//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv Administrator
// Entwickler: m.frey
// Erstellt:   2009-09-16
// Name:       u_AdminTools
// Typ:        Unit
// Zweck:      Datenbankoperationen von Register "Tools"
//-----------------------------------------------------------------------------
// das soll rein, wass die Buttons auf der Seite Tools machen

//----------------------------------------------------------------------------}

unit u_AdminTools;

//-----------------------------------------------------------------------------
{###############################} INTERFACE {###############################}
//-----------------------------------------------------------------------------

uses
  Windows, SysUtils, StrUtils, Classes, Forms,
  MyAccess,
  gnugettext,
  u_ShLowUtils, u_ShDbUtils, u_ShHighUtils,
  u_dm_mainform;

const
   gsversion = '3.4.3.0';

//-----------------------------------------------------------------------------
// Ermglich es hier Logging zu machen ohne dass man hier ber den Rest des
// Programms Bescheid wei
procedure DefLogProcedure(Const S:string); far;
type TLogProcedure = procedure(Const S:string);
const LogProcedure:TLogProcedure=DefLogProcedure;

var LogPrefix:string;
procedure LogInfo(Const S:string);
procedure LogInfoBeg(Const S:string);
procedure LogInfoEnd(Const S:string);
procedure LogInfoEinzugAus;
var
giErrCount:Integer;
procedure LogErr(Const S:string);

//-----------------------------------------------------------------------------
function DbXLogPrc(Sql,ErrMsg:string):Boolean;
function DbXLogPrc2(Sql,ErrMsg,SuccesMsg:string):Boolean;
function DbAktVersion:string;

//-----------------------------------------------------------------------------
// Einzelne Aktionen

// .. nur im Implemenationsteil

//-----------------------------------------------------------------------------
// Groe Aktionen
procedure CreateCommentaries;
procedure RepairMySql5;
procedure UpdateForGdocid;
procedure RepairGdocid(repair:Boolean);
procedure RepairGdocid_alt(repair:Boolean);
procedure RepairStatusfields;
procedure RepairCollateClick;
procedure Char2Date;
procedure Char2Decimal;
procedure UpdateTo_3_3;
procedure UpdateTo_3_4_1;
procedure UpdateTo_3_4(out li:integer);
procedure CreateSystemTables;
procedure CreateOrUpdate_Sys;
procedure CreateOrUpdateOneArc(lmqArc: TMyQuery;  slTbl:TStringList);
procedure CreateOrUpdateAllArc;
procedure CreateOrUpdateAll;

//-----------------------------------------------------------------------------
{############################} IMPLEMENTATION {#############################}
//-----------------------------------------------------------------------------

const
   cSqlCreateTableSysConfig =
      'CREATE TABLE sys_config (`con_id` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,' +
      '`Version` VARCHAR(16) NOT NULL,' +
      '`Name1` Varchar(255),' +
      '`Name2` Varchar(255),' +
      '`Adresse1` Varchar(255),' +
      '`Adresse2` Varchar(255),' +
      '`Adresse3` Varchar(255),' +
      '`Tel` Varchar(64),' +
      '`Fax` Varchar(64),' +
      '`eMail` Varchar(255),' +
      '`WEB` Varchar(255),' +
      '`MinVersionViewer` VARCHAR(16),' +
      '`MinVersionManuScan` VARCHAR(16),' +
      '`MinVersionOlViewer` VARCHAR(16),' +
      '`MinVersionImporter` VARCHAR(16),' +
      '`MinVersionHotsearch` VARCHAR(16),' +
      '`MinVersionDBImp` VARCHAR(16),' +
      '`MinVersionExporter` VARCHAR(16),' +
      ' PRIMARY KEY(`con_id`)' +
      ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci '+
      'Comment=' + #39 + 'Systemtabelle mit globalen Konfigurationinformationen' + #39;

   cSqlCreateTableSysDelhistory =
      'CREATE TABLE `sys_delhistory` (' +
      '`DHST_ID` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
      '`ARC_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
      '`DOC_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
      '`GDOC_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
      '`DISP_NAME` VARCHAR(32) NOT NULL,' +
      '`DOC_LOC` VARCHAR(255) NOT NULL,' +
      '`EXT_LOC` VARCHAR(255) NOT NULL,' +
      '`ORI_LOC` VARCHAR(255) NOT NULL,' +
      '`USR_NAME` VARCHAR(32) NOT NULL,' +
      '`USR_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
      '`TStamp` DATETIME NOT NULL DEFAULT ' + #39 + '1900-01-01 00:00:00' + #39 + ',' +
      '`DOC_TXT` LONGTEXT,' +
      '`DOC_STATE` INTEGER UNSIGNED NOT NULL DEFAULT 0,' +
      '`OCR_QF` INTEGER SIGNED NOT NULL DEFAULT 0,' +
      '`DELTStamp` DATETIME NOT NULL DEFAULT ' + #39 + '1900-01-01 00:00:00' + #39 + ',' +
      '`DELUSR_NAME` VARCHAR(32) NOT NULL,' +
      'INDEX `IX_TStamp`(`TStamp`),' +
      'INDEX `IX_USR_NAME`(`USR_NAME`),' +
      'INDEX `IX_DOC_STATE`(`DOC_STATE`),' +
      'FULLTEXT `FTX_DOC_TXT`(`DOC_TXT`)' +
      ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
      'COMMENT = ' + #39 + 'Tabelle fr Vorgesetzte' + #39;

   cSqlCreateTableSysTimerhist =
      'create table sys_timerhist (' +
      'hist_id bigint(32) not null auto_increment, ' +
      'primary key(hist_id), ' +
      'tim_id bigint(32), tim_Ref bigint(32), ' +
      'usr_id_shed bigint(20), ' +
      'optionen bigint(32)) ' +
      'ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci';

   cSqlCreateTableSysTimerxs =
      'create table sys_timerxs (' +
      'timxs_id bigint not null auto_increment, ' +
      'primary key(timxs_id), ' +
      'tim_id bigint, ' +
      'usr_id_work bigint, ' +
      'usr_id_free bigint) ' +
      'ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci';

//-----------------------------------------------------------------------------
procedure DefLogProcedure(Const S:string);
begin
end;

//-----------------------------------------------------------------------------
procedure LogInfo(Const S:string);
begin
   LogProcedure(LogPrefix+'Info: '+S);
end;

procedure LogInfoBeg(Const S:string);
begin
   LogInfo(S);
   LogPrefix:=LogPrefix+'  ';
end;

procedure LogInfoEnd(Const S:string);
begin
   LogInfoEinzugAus;
   LogInfo(S);
end;

procedure LogInfoEinzugAus;
begin
   Delete(LogPrefix,length(LogPrefix)-1,2);
end;

procedure LogErr(Const S:string);
begin
   LogProcedure(LogPrefix+'Fehler: '+S);
   inc(giErrCount);
end;

//-----------------------------------------------------------------------------
function DbXLogPrc(Sql,ErrMsg:string):Boolean;
begin
   Result := True;
   try
      DbX(SQL);
   except
      on e: Exception do
      begin
         LogErr(ErrMsg + ': ' + e.Message);
         Result := False;
      end;
   end;
end;

//-----------------------------------------------------------------------------
function DbXLogPrc2(Sql,ErrMsg,SuccesMsg:string):Boolean;
begin
   Result := True;
   try
      DbX(SQL);
      LogInfo(SuccesMsg);
   except
      on e: Exception do
      begin
         LogErr(ErrMsg + ': ' + e.Message);
         Result := False;
      end;
   end;
end;

//-----------------------------------------------------------------------------
function DbAktVersion:string;
var lmq: TMyQuery;
begin
   Result:='';
   lmq := DbCreateQuery;
   try
      DbDoSql(lmq,'select * from sys_config order by con_id asc');
      if lmq.RecordCount=0 then
         Exit;
      lmq.Last; // letzte Version auslesen...
      Result := lmq.FieldByName('Version').AsString;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
function DbVersionEintragen(Version:string):Boolean;
var lmq: TMyQuery;  i:integer;  lsSql,lsSql1,lsSql2,lsField,lsValue:string;
begin
   lmq := DbCreateQuery;
   try
      DbDoSql(lmq,'select * from sys_config order by con_id desc limit 1');
      if lmq.RecordCount=0 then
         begin
            Result:=DbXLogPrc(
               'Insert into sys_config (Version) Values (' + #39 + Version + #39 + ')',
               'Fehler beim Einfgen der Version '+Version+' in Tabelle sys_config');
         end
      else
         begin
            lsSql1:=''; lsSql2:='';
            for i := 0 + 2  to lmq.FieldCount-1 do // Id- und Version-Spalte ignorieren
            begin
               lsField := lmq.Fields[i].FieldName;
               lsValue := lmq.Fields[i].AsString;
               lsSql1 := lsSql1 + ',' +lsField;
               lsSql2 := lsSql2 + ',' + #39 + lsValue + #39;
            end;

            lsSql := 'insert into sys_config (Version'+lsSql1+') '
                   + 'values ("'+Version+'"'+lsSQL2+')';
            Result:=DbXLogPrc( lsSql,
               'Fehler beim updaten der Tabelle "sys_config"');
         end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Einzelne Aktionen
//-----------------------------------------------------------------------------

// Tabelle systimer anlegen oder updaten
function CreateOrUpdate_sys_config:Boolean;
begin
   if not DbTableExist('sys_config') then
      begin
         Result := DbXLogPrc2(
            cSqlCreateTableSysConfig,
            'Fehler beim Erstellen der Tabelle "sys_config"',
            _('Tabelle "sys_config" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_config" ist schon angelegt.'));
         Result := True;

      end;
end;


//-----------------------------------------------------------------------------
// Tabelle systimer anlegen oder updaten
function CreateOrUpdate_sys_timer:Boolean;
begin
   if not DbTableExist('sys_timer') then
      begin
         Result := DbXLogPrc2(
            'CREATE TABLE `sys_timer` (' +
            cCreateSysTimer +
            'PRIMARY KEY  (`tim_id`),' +
            'KEY `IX_USR_ID` (`usr_id_work`),' +
            'KEY `IX_Timer` (`termin`)' +
            ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Systemtabelle mit Wiedervorlage-Informationen' + #39,
            'Fehler beim Erstellen der Tabelle "sys_timer"',
            _('Tabelle "sys_timer" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_timer" ist schon angelegt.'));
         Result := True;
         try
            if not DbTableColumnExist('sys_timer','tim_ref') then
               DbX('ALTER TABLE sys_timer ' +
                  'ADD COLUMN `tim_ref` BIGINT UNSIGNED NOT NULL DEFAULT 0 AFTER `tim_id`,' +
                  'ADD COLUMN `grp_id` BIGINT UNSIGNED NOT NULL DEFAULT 0 AFTER `doc_titel`');

            if not DbTableColumnExist('sys_timer','Optionen') then
               DbX('ALTER TABLE sys_timer ' +
                  'ADD COLUMN `Optionen` BIGINT UNSIGNED NOT NULL DEFAULT 0 AFTER `erinnerung`');
            DbX('update sys_timer set tim_ref = tim_id where grp_id = 0 and tim_ref = 0'); //m.frey zur Sicherheit falls man das nochmals laufen lsst
         except
            on e: exception do
               begin
                  LogErr(_('Fehler beim ndern der Tabelle')+' "sys_timer": ' + e.Message);
                  Result := False;
               end;
         end;
      end;
end;


//-----------------------------------------------------------------------------
// Tabelle systimer anlegen oder updaten
function CreateOrUpdate_sys_arc:Boolean;
begin
   if not DbTableExist('sys_arc') then
      begin
         Result := DbXLogPrc2(
            'CREATE TABLE `sys_arc` (' +
            '`ARC_ID` bigint(20) unsigned NOT NULL auto_increment,' +
            '`LGR_ID` bigint(20) unsigned default ' + #39 + '0' + #39 + ',' +
            '`ARC_Name` varchar(32) NOT NULL default ' + #39 + #39 + ',' +
            '`ARC_TBLName` varchar(17) NOT NULL default ' + #39 + #39 + ',' +
            '`ARC_Enabled` int(10) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`Arc_BackPic` varchar(255) NOT NULL default ' + #39 + #39 + ',' +
            '`Icon` int(10) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`Type` int(10) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`Options` int unsigned default 0,' +
            '`DefDocname` varchar(32) NOT NULL default ' + #39 + #39 + ',' +
            'PRIMARY KEY  (`ARC_ID`),' +
            'KEY `IX_ARC_NAME` (`ARC_Name`),' +
            'KEY `IX_LGR_ID` (`LGR_ID`),' +
            'KEY `IX_Type` (`Type`)' +
            ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Systemtabelle Archive' + #39,
            'Fehler beim Erstellen der Tabelle "sys_arc"',
            _('Tabelle "sys_arc" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_arc" ist schon angelegt.'));
         Result := True;
         try
            if not DbTableColumnExist('sys_arc','Options') then
            begin
               DbX('alter table sys_arc ADD COLUMN `Options` int unsigned default 0');
               LogInfo(_('Tabelle sys_arc erweitert um Spalte "Options"'));
            end;
         except
            on e: exception do
               begin
                  LogErr(_('Fehler beim ndern der Tabelle')+' sys_arc: ' + e.Message);
                  Result := False;
               end;
         end;
         try
            if not DbTableColumnExist('sys_arc','DefDocname') then
            begin
               DbX('alter table sys_arc ADD COLUMN `DefDocname` varchar(32) NOT NULL default ' + #39 + #39);
               LogInfo(_('Tabelle sys_arc erweitert um Spalte "DefDocname"'));
            end;
         except
            on e: exception do
               begin
                  LogErr(_('Fehler beim ndern der Tabelle')+' sys_arc: ' + e.Message);
                  Result := False;
               end;
         end;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_arcxs:Boolean;
var lsType:string;
begin
   if not DbTableExist('sys_arcxs') then
      begin
         Result := DbXLogPrc2(
            'CREATE TABLE `sys_arcxs` (' +
            '`ARCXS_ID` bigint(20) unsigned NOT NULL auto_increment,' +
            '`ARC_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`USR_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`GRP_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            '`Rights` set(' + #39 + 'list' + #39 +
            ',' + #39 + 'read' + #39 +
            ',' + #39 + 'modify' + #39 +
            ',' + #39 + 'write' + #39 +
            ',' + #39 + 'mail' + #39 +
            ',' + #39 + 'print' + #39 +
            ',' + #39 + 'link' + #39 +
            ',' + #39 + 'rights' + #39 +
            ',' + #39 + 'history' + #39 +
            ',' + #39 + 'move' + #39 +
            ',' + #39 + 'awrite' + #39 +
            ',' + #39 + 'aread' + #39 +
            ',' + #39 + 'amodify' + #39 +
            ',' + #39 + 'apread' + #39 +
            ',' + #39 + 'apwrite' + #39 +
            ',' + #39 + 'workflowbreak' + #39 +
            ',' + #39 + 'hstprotoread' + #39 +
            ',' + #39 + 'suanno' + #39 +
            ',' + #39 + 'docdel' + #39 +
            ',' + #39 + 'export' + #39 +
            ') collate latin1_german1_ci NOT NULL default ' + #39 + #39 + ',' +
            'PRIMARY KEY  (`ARCXS_ID`),' +
            'KEY `IX_ARC_ID` (`ARC_ID`),' +
            'KEY `IX_USR_ID` (`USR_ID`),' +
            'KEY `IX_RIGHTS` (`Rights`),' +
            'KEY `IX_GRP_ID` (`GRP_ID`)' +
            ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Systemtabelle Archivberechtigungen' + #39,
            'Fehler beim Erstellen der Tabelle "sys_arcxs"',
            _('Tabelle "sys_arcxs" angelegt'));
      end
   else
      try
         LogInfo(_('Tabelle "sys_arcxs" ist schon angelegt.'));
         Result := True;
         lsType := DbTableColumnType('sys_arcxs','rights');
         if pos('export', lsType) = 0 then
         begin
            DbX('alter table sys_arcxs change rights rights set(' + #39 + 'list' + #39 + ',' + #39 +
               'read' + #39 + ',' + #39 + 'modify' + #39 + ',' + #39 + 'write' + #39 + ',' + #39 + 'mail' + #39 + ',' + #39 +
               'print' + #39 + ',' + #39 + 'link' + #39 + ',' + #39 + 'rights' + #39 + ',' + #39 + 'history' + #39 + ',' + #39 + 'move' + #39 +
               ',' + #39 + 'awrite' + #39 + ',' + #39 + 'aread' + #39 + ',' + #39 + 'amodify' + #39 + ',' + #39 + 'apwrite' + #39 + ',' + #39 +
               'apread' + #39 + ',' + #39 + 'workflowbreak' + #39 + ',' + #39 + 'hstprotoread' + #39 +
               ',' + #39 + 'suanno' + #39 + ',' + #39 + 'docdel' + #39 + ',' + #39 + 'export' + #39 + ')');
         end;
      except
         on e: exception do
            begin
               LogErr(_('Fehler beim ndern der Tabelle')+' sys_arcxs: ' + e.Message);
               Result := False;
            end;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_doclnk:Boolean;
begin
   if not DbTableExist('sys_doclnk') then
      begin
         Result := DbXLogPrc2(
         'CREATE TABLE `sys_doclnk` (' +
         '`REF_ID` bigint(20) unsigned NOT NULL auto_increment,' +
         '`REF_LNK` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`ARC_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`DOC_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`USR_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`REF_Type` integer NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`REF_NAME` varchar(255) NOT NULL default ' + #39 + #39 + ',' +
         'PRIMARY KEY  (`REF_ID`),' +
         'KEY `IX_ARC_ID` (`ARC_ID`),' +
         'KEY `IX_DOC_ID` (`DOC_ID`),' +
         'KEY `IX_REF_LNK` (`REF_LNK`),' +
         'KEY `IX_REF_TYPE` (`REF_Type`),' +
         'KEY `IX_REF_NAME` (`REF_NAME`)' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'COMMENT=' + #39 + 'Systemtabelle Dokumentenverknpfungen' + #39,
         'Fehler beim Erstellen der Tabelle "sys_doclnk"',
            _('Tabelle "sys_doclnk" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_doclnk" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_docxs:Boolean;
var lsType:string;
begin
   if not DbTableExist('sys_docxs') then
      begin
         Result := DbXLogPrc2(
         'CREATE TABLE `sys_docxs` (' +
         '`DOCXS_ID` bigint(20) unsigned NOT NULL auto_increment,' +
         '`ARC_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`DOC_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`SRC_USR_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' + 
         '`USR_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`GRP_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`Rights` set(' + #39 + 'list' + #39 + ','
         + #39 + 'read' + #39 + ','
         + #39 + 'modify' + #39 + ','
         + #39 + 'write' + #39 + ','
         + #39 + 'mail' + #39 + ','
         + #39 + 'print' + #39 + ','
         + #39 + 'link' + #39 + ','
         + #39 + 'rights' + #39 + ','
         + #39 + 'history' + #39 + ','
         + #39 + 'move' + #39 + ','
         + #39 + 'aread' + #39 + ','
         + #39 + 'amodify' + #39 + ','
         + #39 + 'awrite' + #39 + ','
         + #39 + 'apread' + #39 + ','
         + #39 + 'apwrite' + #39 + ','
         + #39 + 'workflowbreak' + #39 +
         ') character set latin1 NOT NULL default ' + #39 + #39 + ',' +
         'PRIMARY KEY  (`DOCXS_ID`),' +
         'KEY `IX_ARC_ID` (`ARC_ID`),' +
         'KEY `IX_DOC_ID` (`DOC_ID`),' +
         'KEY `IX_USR_ID` (`USR_ID`),' +
         'KEY `IX_GRP_ID` (`GRP_ID`),' +
         'KEY `IX_Rights` (`Rights`)' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'COMMENT=' + #39 + 'Systemtabelle Dokumentenberechtigungen' + #39,
         'Fehler beim Erstellen der Tabelle "sys_docxs"',
            _('Tabelle "sys_docxs" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_docxs" ist schon angelegt.'));
         try
            Result := True;
            lsType := DbTableColumnType('sys_docxs','rights');
            if pos('apread', lsType) = 0 then
            begin
               DbX('ALTER TABLE sys_docxs ' +
                  'CHANGE Rights Rights set(' + #39 + 'list' + #39 + ','
                  + #39 + 'read' + #39 + ','
                  + #39 + 'modify' + #39 + ','
                  + #39 + 'write' + #39 + ','
                  + #39 + 'mail' + #39 + ','
                  + #39 + 'print' + #39 + ','
                  + #39 + 'link' + #39 + ','
                  + #39 + 'rights' + #39 + ','
                  + #39 + 'history' + #39 + ','
                  + #39 + 'move' + #39 + ','
                  + #39 + 'aread' + #39 + ','
                  + #39 + 'amodify' + #39 + ','
                  + #39 + 'awrite' + #39 + ','
                  + #39 + 'apwrite' + #39 + ','
                  + #39 + 'apread' + #39 +
                  ')');
            end;
         except
            on e: exception do
               begin
                  LogErr(_('Fehler beim ndern der Tabelle')+' sys_docxs: ' + e.Message);
                  Result := False;
               end;
         end;

         try
            if not DbTableColumnExist('sys_docxs','SRC_USR_ID') then
               DbX('Alter Table sys_docxs ADD ' +
                  'Column SRC_USR_ID Bigint unsigned not null Default 0 ' +
                  'After DOC_ID');
         except
            on e: exception do
               begin
                  LogErr(_('Fehler beim ndern der Tabelle')+' sys_docxs: ' + e.Message);
                  Result := False;
               end;
         end;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_grp:Boolean;
begin
   if not DbTableExist('sys_grp') then
      begin
         Result := DbXLogPrc2(
         'CREATE TABLE `sys_grp` (' +
         '`GRP_ID` bigint(20) unsigned NOT NULL auto_increment,' +
         '`GRP_NAME` varchar(32) NOT NULL default ' + #39 + #39 + ',' +
         '`Login_Right` int(10) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         'PRIMARY KEY  (`GRP_ID`),' +
         'KEY `IX_GRP_NAME` (`GRP_NAME`)' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 ' +
         'COMMENT=' + #39 + 'Systemtabelle Benutzergruppen' + #39,
         'Fehler beim Erstellen der Tabelle "sys_grp"',
            _('Tabelle "sys_grp" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_grp" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_grpusr:Boolean;
begin
   if not DbTableExist('sys_grpusr') then
      begin
         Result := DbXLogPrc2(
         'CREATE TABLE `sys_grpusr` (' +
         '`MEM_ID` bigint(20) unsigned NOT NULL auto_increment,' +
         '`GRP_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`USR_ID` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         'PRIMARY KEY  (`MEM_ID`),' +
         'KEY `IX_GRP_ID` (`GRP_ID`),' +
         'KEY `IX_USR_ID` (`USR_ID`)' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'COMMENT=' + #39 + 'Systemtabelle Benutzer in Gruppen' + #39,
         'Fehler beim Erstellen der Tabelle "sys_grpusr"',
            _('Tabelle "sys_grpusr" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_grpusr" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_usr:Boolean;
const cFlags =
            '`Flags` set(' + #39 + 'enabled' + #39 + ',' +
                             #39 + 'deleted' + #39 + ',' +
                             #39 + 'from_ad' + #39 +
                         ') NOT NULL default ' + #39 + #39;
begin
   if not DbTableExist('sys_usr') then
      begin
         Result := DbXLogPrc2(
            'CREATE TABLE `sys_usr` (' +
            '`USR_ID` bigint(20) unsigned NOT NULL auto_increment,' +
            '`USR_NAME` varchar(36) NOT NULL default ' + #39 + #39 + ',' +
            '`USR_PASS` varchar(64) NOT NULL default ' + #39 + #39 + ',' +
            '`USR_MAIL` varchar(64) NOT NULL default ' + #39 + #39 + ',' +
            '`SUB_USR` bigint(20) unsigned default ' + #39 + '0' + #39 + ',' +
            (*
            '`Flags` set(' + #39 + 'enabled' + #39 + ',' +
                             #39 + 'deleted' + #39 + ',' +
                             #39 + 'from_ad' + #39 +
                         ') NOT NULL default ' + #39 + #39 + ',' +
            *)
            cFlags + ',' +
            'PRIMARY KEY  (`USR_ID`),' +
            'KEY `IX_USR_NAME` (`USR_NAME`),' +
            'KEY `IX_SUB_USR` (`SUB_USR`)' +
            ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Systemtabelle Benutzer' + #39,
            'Fehler beim Erstellen der Tabelle "sys_usr"',
            _('Tabelle "sys_usr" angelegt'));
         if not Result then
            Exit;
         Result := DbXLogPrc2(
            'INSERT INTO `sys_usr` (`USR_ID`,`USR_NAME`,`SUB_USR`,`Flags`,`USR_PASS`) VALUES ' +
            '(1,' + #39 + 'System' + #39 + ',NULL,' + #39 + #39 + ',' + #39 + #39 + ')',
            'Fehler beim Einfgen in Tabelle "sys_usr"',
            _('In Tabelle "sys_usr" User "system" eingetragen'));
      end
   else
      begin
         Result := DbXLogPrc2(
            'alter table `sys_usr` change sys_usr.flags '+cFlags,
            'Fehler beim ndern der Spalte "Flags" in Tabelle "sys_usr"',
            _('In Tabelle "sys_usr" Spalte "Flags" gendert'));
         LogInfo(_('Tabelle "sys_usr" ist schon angelegt.'));
         //Result := True;
      end;
(*
Zu SUB_USR

Der Baum ergibt sich automatisch aufgrund dem Inhalt in der Tabelle sys_usr.
(Select 3, USR_ID, USR_NAME, SUB_USR from sys_usr where )

Mageblich ist hier das Feld SUB_USR, das zu einem User angibt zu welchem anderen User er gehrt.

Im ganzen Code wird das Feld lediglich nur erzeugt und auf 0 gesetzt. Eine andere Verwendung habe ich nicht gefunden. Da hat wohl einer mal angefangen etwas einzubauen und die Werte im Query-Browser manuell eingetragen. Ich kann mir kaum vorstellen, dass bei einem Kunden da ein Baum zu sehen ist.

*)
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_timerhist:Boolean;
begin
   if not DbTableExist('sys_timerhist') then
      begin
         Result := DbXLogPrc2(
         cSqlCreateTableSysTimerhist,  //sys_timerhist
            'Fehler beim Erstellen der Tabelle "sys_timerhist"',
            _('Tabelle "sys_timerhist" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_timerhist" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_timerxs:Boolean;
begin
   if not DbTableExist('sys_timerxs') then
      begin
         Result := DbXLogPrc2(
         cSqlCreateTableSysTimerxs,
            'Fehler beim Erstellen der Tabelle "sys_timerxs"',
            _('Tabelle "sys_timerxs" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_timerxs" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_gdocid:Boolean;
begin
   if not DbTableExist('sys_gdocid') then
      begin
         Result := DbXLogPrc2(
         'create table sys_gdocid (' +
         '`gdoc_id` bigint unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY' +
         ',`arc_id` bigint unsigned, ' +
         '`doc_id` bigint unsigned, ' +
         'index `arc_doc_id` (`arc_id`,`doc_id`))' +
         ' ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'comment = ' + #39 + 'Globale Docids' + #39,
         'Fehler beim Erstellen der Tabelle "sys_gdocid"',
            _('Tabelle "sys_gdocid" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_gdocid" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_doclock:Boolean;
begin
   if not DbTableExist('sys_doclock') then
      begin
         Result := DbXLogPrc2(
         'create TABLE `sys_doclock` (' +
         'doclock_id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
         ' gdoc_id BIGINT UNSIGNED ,' +
         ' arc_id BIGINT UNSIGNED ,' +
         ' doc_id BIGINT UNSIGNED ,' +
         ' usr_id BIGINT UNSIGNED ' +
         ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'COMMENT = ' + #39 + 'Tabelle zum Ein- und Ausschecken von Dokumenten' + #39,
         'Fehler beim Erstellen der Tabelle "sys_doclock"',
            _('Tabelle "sys_doclock" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_doclock" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_ctlrtimer:Boolean;
begin
   if not DbTableExist('sys_ctlrtimer') then
      begin
         Result := DbXLogPrc2(
         'create TABLE `sys_ctlrtimer` (' +
         ' timctrl_id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
         ' tim_id BIGINT UNSIGNED ,' +
         ' tim_ref BIGINT UNSIGNED ,' +
         ' usr_id_work BIGINT UNSIGNED ,' +
         ' grp_id BIGINT UNSIGNED ,' +
         ' usr_id_shed BIGINT UNSIGNED ,' +
         '`info` varchar(255) collate latin1_german1_ci NOT NULL default ' + #39 + #39 +
         ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'COMMENT = ' + #39 + 'Tabelle fr Kontrolle von Wiedervorlagen' + #39,
         'Fehler beim Erstellen der Tabelle "sys_ctlrtimer"',
            _('Tabelle "sys_ctlrtimer" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_ctlrtimer" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_superior:Boolean;
begin
   if not DbTableExist('sys_superior') then
      begin
         Result := DbXLogPrc2(
         'CREATE TABLE `sys_superior` (' +
         '`SUP_ID` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
         ' sup_usr_id BIGINT UNSIGNED ,' +
         ' inf_usr_id BIGINT UNSIGNED ,' +
         ' options BIGINT UNSIGNED ,' +
         ' status BIGINT UNSIGNED ,' +
         '`info` varchar(255) collate latin1_german1_ci NOT NULL default ' + #39 + #39 +
         ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
         'COMMENT = ' + #39 + 'Tabelle fr Vorgesetzte' + #39,
         'Fehler beim Erstellen der Tabelle "sys_superior"',
            _('Tabelle "sys_superior" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_superior" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_delhistory:Boolean;
begin
   if not DbTableExist('sys_delhistory') then
      begin
         Result := DbXLogPrc2(
         cSqlCreateTableSysDelhistory,
         'Fehler beim Erstellen der Tabelle "sys_delhistory"',
            _('Tabelle "sys_delhistory" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_delhistory" ist schon angelegt.'));
         Result := True;
      end;
end;

//-----------------------------------------------------------------------------
function CreateOrUpdate_sys_symlnk:Boolean;
begin
   if not DbTableExist('sys_symlnk') then
      begin
         Result := DbXLogPrc2(
         'create TABLE `sys_symlnk` (' +
         'gsdoc_id BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
         ' gdoc_id BIGINT UNSIGNED ,' +
         ' arc_id BIGINT UNSIGNED ,' +
         ' doc_id BIGINT UNSIGNED ' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci  ' +
         'COMMENT = ' + #39 + 'Symbolic links Tabelle' + #39,
         'Fehler beim Erstellen der Tabelle "sys_symlnk"',
            _('Tabelle "sys_symlnk" angelegt'));
      end
   else
      begin
         LogInfo(_('Tabelle "sys_symlnk" ist schon angelegt.'));
         Result := True;
      end;
end;


//-----------------------------------------------------------------------------
// Groe Aktionen
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Erzeugt ggf. Tabelle fr Diskussionen/Kommentare
procedure CreateCommentaries;
var sTblName: string;  lmy_Arc: TMyQuery;
begin
   try
      lmy_Arc := DbCreateQuery;
      try
         // Alle Archive raussuchen
         DbExecSql(lmy_Arc,'select * from sys_arc where type = 1');
         LogProcedure(Format('Tabellen fr Kommentare anlegen, sofern ntig. (%d Tabellen)',[lmy_Arc.Recordcount]));
         while not lmy_Arc.eof do // ... und durchgehen
         begin
            // Name der Kommentartabelle
            sTblName := lmy_Arc.FieldByName('Arc_Tblname').asstring;
            if DbTableExist('com_' + sTblName ) then // keine da?
               LogProcedure(Format('Tabelle %s ist schon angelegt.',[sTblName]))
            else
               begin
                  // dann eine erzeugen
                  try
                   LogProcedure('Tabelle '+sTblName+' wird angelegt.');
                   //Diskussionstabelle - kommt noch woanders so vor!
                   DbX(
                     'CREATE TABLE `com_' + sTblName + '` (' +
                     '`COM_ID` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
                     '`DOC_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
                     '`DISP_NAME` VARCHAR(32) NOT NULL,' +
                     '`USR_NAME` VARCHAR(32) NOT NULL,' +
                     '`USR_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
                     '`TStamp` DATETIME NOT NULL DEFAULT ' + #39 + '1900-01-01 00:00:00' + #39 + ',' +
                     //m.frey'`COM_TXT` VARCHAR(65535) NOT NULL,' +
                     '`COM_TXT` VARCHAR(16383) NOT NULL,' + //m.frey 65535 ist zuviel, eine existierende Tabelle hat auch nur 16383
                     //                       '`COM_TXT` LONGTEXT,' +
                     'INDEX `IX_TStamp`(`TStamp`),' +
                     'INDEX `IX_USR_NAME`(`USR_NAME`)' +
                     //                       'FULLTEXT `FTX_DOC_TXT`(`COM_TXT`)' +
                     ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
                     'COMMENT = ' + #39 + 'Kommentartabelle fr Archiv: ' + sTblName + #39);
                  except
                     on e: Exception do
                        LogErr(_('Fehler beim Erzeugen einer Tabelle fr Kommentare:')+' ' + e.Message);
                  end;
               end;
            lmy_Arc.next;
         end;
      finally
         lmy_Arc.Free;
         LogProcedure(_('Tabellen fr Kommentare anlegen Ende.'));
      end;
   except
      on e: Exception do
         LogErr(_('Fehler beim Erzeugen einer Tabelle fr Kommentare:')+' ' + e.Message);
   end;
end;

//-----------------------------------------------------------------------------
procedure RepairMySql5;
var lqSysArc,lqArc: TMyQuery;  sTblName: string;
begin
   lqSysArc := DbCreateQuery;
   try
      lqArc := DbCreateQuery;
      try
         DbExecSql(lqSysArc, 'select * from sys_arc where type = 1 ');
         while not lqSysArc.eof do
         begin
            sTblName := lqSysArc.fieldbyname('Arc_Tblname').asstring;
            DbExecSql(lqArc,'describe  arc_' + sTblName);
            while not lqArc.eof do
            begin
               if pos('add_', lqArc.fieldbyname('Field').AsString) > 0 then
               begin
                  if pos('varchar', lqArc.fieldbyname('Type').AsString) > 0 then
                  begin
                     if lqArc.fieldbyname('Default').IsNull then
                     begin
                        DbX(
                             'alter table arc_' + sTblName
                           + ' alter ' + lqArc.fieldbyname('Field').AsString
                           + ' set default ' + #39 + #39);
                     end;
                  end;
               end;
               lqArc.next;
            end;
            lqSysArc.next;
         end;
         LogProcedure(_('Anpassung an MySQL 5.x durchgefhrt'));
      finally
         lqArc.Free;
      end;
   finally
      lqSysArc.Free;
   end;
end;


//-----------------------------------------------------------------------------
procedure UpdateForGdocid;
var
   //lbcleared: boolean;
   //lssql,
   sTblName: string;
   //li64ngdocid: Int64;
   my_q_Tmp, my_q_Tmp2 : TMyQuery;
begin
   my_q_Tmp := DbCreateQuery;
   try
      my_q_Tmp2 := DbCreateQuery;
      try
         //Alle Archive (nicht Lager) prfen ob gdoc_id schon da ist und ggf fr alle docs anlegen
         DbExecSql(my_q_tmp,'select * from sys_arc where type = 1');
         while not my_q_tmp.eof do
         begin
            sTblName := my_q_tmp.FieldByName('Arc_Tblname').AsString;
            DbExecSQL(my_q_Tmp2,'select * from arc_'+sTblName + ' limit 1');
            try
               //first bit says if gdoc_ijois hard or symbolic link!!!!
               if my_q_Tmp2.FieldDefList.Find('gdoc_id') = nil then
               begin
                    //TODO: insert into history
                  DbX('alter table arc_' + sTblName +
                     ' ADD COLUMN `gdoc_id` bigint UNSIGNED NULL, ADD INDEX `idx_gdoc_id` (`gdoc_id`)');
                  DbX('insert into sys_gdocid (arc_id, doc_id) select ' +
                     my_q_tmp.fieldbyname('arc_id').AsString + ',doc_id from arc_' +
                     sTblName);
                  DbX('update arc_' + sTblName +
                     ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                     my_q_tmp.fieldbyname('arc_id').AsString + ')) set a.gdoc_id = b.gdoc_id ');
               end;
            except
               on e: exception do
               begin
                  LogErr(_('Fehler bei der nderung der Tabelle sys_gdocid: ') + e.Message + #13 + ' sql: ' + LastSql);
               end;
            end;
            my_q_tmp.Next;
         end;
      finally
         my_q_Tmp2.Free;
      end;
   finally
      my_q_Tmp.Free;
   end;
end;




procedure RepairGdocid(repair:Boolean);
var
   tblname : TStringList;
   i, i2 : Integer;
   ind, gdocid, arcid, docid, insertid, maxarc: Int64;
   my_q_Tmp, my_q_Tmp2, my_q_del : TMyQuery;

   procedure deletegdocid(gdocid : Integer);
   begin
      try
         DbExecSql(my_q_del,'delete from sys_gdocid where gdoc_id = ' + IntToStr(gdocid));

      except
         Exit;

      end;
      LogInfo(Format(_('gdocid [%s] wurde gelscht'),[IntToStr(gdocid)]));

   end;

begin
   LogInfoBeg(_('berprfung der sys_gdoc_id:'));
   if repair then
   begin
      if not CreateOrUpdate_sys_gdocid
      then Exit;
   // update each archive table and add gdoc_ids
      UpdateForGdocid;
   end
   else
     LogInfo(_('berprfungsmodus (es wird keine nderung durchgefhrt)'));


   my_q_Tmp := DbCreateQuery;
   my_q_Tmp2 := DbCreateQuery;
   my_q_del := DbCreateQuery;
   try

      // zuerst die sys_gdocid bereinigen

      tblname := TStringList.Create;

      DbExecSql(my_q_tmp,'select max(arc_id) from sys_arc');
      maxarc := my_q_tmp.FieldByName('max(arc_id)').AsInteger;
      for i := 0 to maxarc  do
      begin
         tblname.Add('');
      end;
      DbExecSql(my_q_tmp,'select * from sys_arc where type = 1');
      if my_q_Tmp.RecordCount > 0 then
      begin
         LogInfo(Format(_('Es sind %s Archivtabellen vorhanden'),[IntToStr(my_q_Tmp.RecordCount)]));

         for i := 0 to my_q_Tmp.RecordCount -1 do
         begin
            ind := my_q_tmp.FieldByName('ARC_ID').AsInteger;
            tblname[ind] := my_q_Tmp.FieldByName('ARC_TBLName').AsString;
            my_q_tmp.Next;
         end;
      end;

      for i:= 0 to tblname.Count -1 do
      begin
         if tblname[i] <>'' then
             LogInfo(Format('arc_id = %s  tblname= %s',[inttostr(i),tblname[i]]));
      end;

      LogInfo(_('berprfe sys_gdocid auf Leereintrge...'));
      DbExecSql(my_q_tmp,'select * from sys_gdocid where arc_id  is null or doc_id is null');

      if my_q_Tmp.RecordCount > 0 then
      begin
         LogInfo(Format(_('Es wurden %s Leereintrge gefunden'),[IntToStr(my_q_Tmp.RecordCount)]));
         if repair then
         begin
            try
               DbExecSql(my_q_tmp,'delete from sys_gdocid where arc_id  = NULL or doc_id = Null');
            except
               LogInfo(_('Fehler beim Lschen der Leereintrge'));
               Exit;

            end;
            LogInfo(_('Leereintrge wurden gelscht'));
         end;
      end;

      DbExecSql(my_q_tmp,'select * from sys_gdocid');

      if my_q_Tmp.RecordCount > 0 then
      begin
         LogInfo(_('berprfe die vorhandenen gdocids in der sys_gdocid...'));

         LogInfo(Format(_('Es wurden %s Eintrge in der sys_gdocid gefunden'),[IntToStr(my_q_Tmp.RecordCount)]));

         for i := 0 to my_q_Tmp.RecordCount -1 do
         begin
            gdocid := my_q_Tmp.FieldByName('gdoc_id').AsInteger;
            arcid := my_q_Tmp.FieldByName('arc_id').AsInteger;
            docid := my_q_Tmp.FieldByName('doc_id').AsInteger;

            if tblname[arcid] = '' then
            begin
               LogInfo(Format(_('gdocid [%s] verweist auf leere Tabelle, arc_id = '),[IntToStr(gdocid)]) + IntToStr(arcid));
               if repair then
               begin
                  deletegdocid(gdocid);
               end;
            end
            else
            begin
               DbExecSql(my_q_Tmp2,'select * from arc_' + tblname[arcid] + ' where doc_id = ' + IntToStr(docid));
               if my_q_Tmp2.RecordCount = 0 then
               begin
                  LogInfo(Format(_('Dokument zu [%s] konnte nicht gefunden werden ('),[IntToStr(gdocid)]) + IntToStr(arcid) +'.' + IntToStr(docid)+')');
                  if repair then
                  begin
                     deletegdocid(gdocid);
                  end;
               end
               else
               begin
                  if gdocid <> my_q_Tmp2.FieldByName('gdoc_id').AsInteger then
                  begin
                     LogInfo(Format(_('gdocid [%s] verweist auf ein Dokument mit anderer gdocid ('),[IntToStr(gdocid)])
                     + IntToStr(arcid) +'.' + IntToStr(docid)+'/' + my_q_Tmp2.FieldByName('gdoc_id').AsString +')');
                     if repair then
                     begin
                        deletegdocid(gdocid);
                     end;
                  end;
               end;
            end;
            my_q_Tmp.Next;
            Application.ProcessMessages;
         end;
      end;

      // jetzt die einzelnen arc_ Tabellen
      LogInfo(_('berprfe alle Dokumente...'));

      for i:= 0 to tblname.Count-1 do
      begin
         if tblname[i] <> '' then
         begin
            LogInfo(_('berprfung der arc_') + tblname[i]);
            DbExecSql(my_q_tmp,'select * from arc_' + tblname[i]+' order by doc_id');
            if my_q_Tmp.RecordCount > 0 then
            begin
               for i2 := 0 to my_q_Tmp.RecordCount-1 do
               begin
                  gdocid :=  my_q_Tmp.FieldByName('gdoc_id').AsInteger;
                  docid := my_q_Tmp.FieldByName('doc_id').AsInteger;
                  if gdocid <= 0 then
                  begin
                     LogInfo(Format(_('Das Dokument (%s) hat keine gdoc_id'),[IntToStr(i) +'.' + IntToStr(my_q_Tmp.FieldByName('doc_id').AsInteger)]));

                     if repair then
                     begin
                        DbExecSql(my_q_Tmp2,'Insert into sys_gdocid set arc_id = ' + inttostr(i)+', doc_id = ' + IntToStr(docid));
                        insertid := my_q_Tmp2.InsertId;
                        DbExecSql (my_q_Tmp2,'Update arc_' + tblname[i]+' set gdoc_id='+inttostr(insertid) + ' where doc_id='+ IntToStr(docid));
                        LogInfo(_('Neue gdocid angelegt [')+inttostr(insertid) +']');
                     end;

                  end
                  else
                  begin
                     DbExecSql(my_q_Tmp2,'Select * from sys_gdocid where gdoc_id = ' + IntToStr(gdocid));
                     if my_q_Tmp2.RecordCount = 0 then
                     begin
                        LogInfo(Format(_('Die gdocid [%s] des Dokuments (%s) konnte nicht in der sys_gdocid gefunden werden'),[IntToStr(gdocid),IntToStr(i) +'.' + IntToStr(docid)]));
                        if repair then
                        begin
                           DbExecSql(my_q_Tmp2,'Insert into sys_gdocid set gdoc_id = ' + IntToStr(gdocid)+', arc_id = ' + inttostr(i)+', doc_id = ' + IntToStr(docid));
                           insertid := my_q_Tmp2.InsertId;
                           LogInfo(_('Neue gdocid angelegt [')+inttostr(insertid) +']');

                        end;

                     end
                     else
                     begin
                        if (i <> my_q_Tmp2.FieldByName('Arc_id').AsInteger) or (docid <> my_q_Tmp2.FieldByName('Doc_id').AsInteger) then
                        begin
                           LogInfo( IntToStr(i) +'.' + IntToStr(docid)
                           + Format(_(': die gdocid [%s] in sys_gdocid verweist auf ein anderes Dokument'),[inttostr(gdocid)]));
                           if repair then
                           begin
                              DbExecSql(my_q_Tmp2,'Insert into sys_gdocid set arc_id = ' + inttostr(i)+', doc_id = ' + IntToStr(docid));
                              insertid := my_q_Tmp2.InsertId;
                              DbExecSql (my_q_Tmp2,'Update arc_' + tblname[i]+' set gdoc_id='+inttostr(insertid) + ' where doc_id='+ IntToStr(docid));
                              LogInfo(_('Neue gdocid angelegt [')+inttostr(insertid) +']');
                           end;

                        end;

                     end;

                  end;

                  my_q_Tmp.Next;
                  Application.ProcessMessages;
               end;
            end;

         end;
      end;


   except
      LogInfo(_('Es hat Fehler bei der berprfung der sys_gdocid gegeben.'));

   end;
   LogInfoEnd(_('berprfung der sys_gdocid abgeschlossen.'));


end;





//-----------------------------------------------------------------------------
procedure RepairGdocid_alt(repair:Boolean);
var
   lbcleared: boolean;
   lssql, sTblName, lsArcId, sarcname: string;
   li64ngdocid: Int64;
   my_q_Tmp, my_q_Tmp2, my_q_Tmp3, my_q_Tmp4 : TMyQuery;
begin
// create table gdoc_id
  // LogInfo('Not operating, fixing errors (testing phase)');
  // exit;
   if not CreateOrUpdate_sys_gdocid
   then Exit;
// update each archive table and add gdoc_ids
   UpdateForGdocid;

   my_q_Tmp := DbCreateQuery;
   try
     my_q_Tmp2 := DbCreateQuery;
     try
      my_q_Tmp3 := DbCreateQuery;
      try
        my_q_Tmp4 := DbCreateQuery;
        try
        try
          DbExecSql(my_q_tmp,'select * from sys_arc where type = 1');
           my_q_tmp.first;
          //check for sys_gdocid
          DbExecSql(my_q_tmp2,'select * from sys_gdocid order by arc_id, gdoc_id');
          while not my_q_tmp2.eof do
          begin
          if my_q_tmp.fieldbyname('arc_id').IsNull or
          (my_q_tmp.fieldbyname('arc_id').AsString = '')then
          begin
             my_q_tmp2.next;
             continue;
          end;
             if my_q_tmp.fieldbyname('arc_id').AsString <>
                my_q_tmp2.fieldbyname('arc_id').AsString then
             begin
                my_q_tmp.first;
                sTblName := '';
                //search for arc_tblname
                while not my_q_tmp.eof do
                begin
                   if my_q_tmp.fieldbyname('arc_id').Asinteger =
                      my_q_tmp2.fieldbyname('arc_id').Asinteger then
                      begin

                           sTblName := my_q_tmp.FieldByName('Arc_Tblname').AsString;
                           sArcName := my_q_tmp.FieldByName('Arc_Name').AsString;
                           lsArcId := my_q_tmp.fieldbyname('arc_id').AsString;
                           break;
                      end;
                   my_q_tmp.next;
                end;
             end
             else
             begin

             sTblName := my_q_tmp.FieldByName('Arc_Tblname').AsString;
             sArcName := my_q_tmp.FieldByName('Arc_Name').AsString;
             lsArcId := my_q_tmp.fieldbyname('arc_id').AsString;
             end;
             
                if   sTblName = '' then
                begin
              LogInfo( 'Fehler(manuell korrigieren):'+my_q_tmp2.fieldbyname('gdoc_id').AsString+' hat kein arc_id');
                   my_q_tmp2.next;
                    continue;

                end;
                if my_q_tmp2.fieldbyname('doc_id').isnull then
                begin  
              LogInfo( my_q_tmp2.fieldbyname('gdoc_id').AsString+' hat kein doc_id');

                end;
             //m.frey: hier sieht es so aus, dass wenn in der gdoc-Tabelle was drin ist, aber kein Doc, dass dann das aus der gdoc-Tabelle genullt wird
             //check by gdoc_id
             DbExecSql(my_q_Tmp3,'select * from arc_' + sTblName +
                '  where gdoc_id=' +
                my_q_tmp2.fieldbyname('gdoc_id').AsString+' and ((Optionen and 1) = 0)');
                //2 options, delete or search (and if nothing then delete,1.  implemented)
             if my_q_tmp3.recordcount = 0 then
             begin
             LogInfo('Fehler(manuell korrigieren):'+my_q_tmp2.fieldbyname('gdoc_id').AsString+' hat keine gltige arc.docid.'+
             ' Bitte manuell korrigieren, da es verschoben worden ist oder etc...');

              {  my_q_tmp2.edit;
                my_q_tmp2.fieldbyname('doc_id').clear;
                my_q_tmp2.fieldbyname('arc_id').clear;
                my_q_tmp2.post;    }
             end
             else
             begin
             if my_q_tmp3.recordcount > 1 then
             begin
             LogInfo('Fehler(manuell korrigieren):'+my_q_tmp2.fieldbyname('gdoc_id').AsString+' hat mehrere Eintrge bei Tabelle '+sTblName+
             ' Bitte manuell korrigieren, da es verschoben worden ist oder etc...');



             end
             else if  my_q_tmp3.recordcount = 1 then
             begin
             if  ( my_q_tmp2.fieldbyname('doc_id').asinteger <>
             my_q_tmp3.fieldbyname('doc_id').asinteger ) then
             begin


                   LogInfo('Fehler(manuell reparieren):'+
                   my_q_tmp2.fieldbyname('arc_id').AsString+'.'+my_q_tmp3.fieldbyname('doc_id').AsString+
                   ' hat  gdoc_id '+my_q_tmp2.fieldbyname('gdoc_id').AsString+' wie die gdoc_id '+
                   my_q_tmp3.fieldbyname('doc_id').AsString+', aber letzteres zeigt auf '+
                   my_q_tmp2.fieldbyname('gdoc_id').AsString);



             end;


             end;
             end;

              if  (not my_q_tmp2.fieldbyname('doc_id').isnull) and
              (my_q_tmp2.fieldbyname('gdoc_id').Asinteger <> 0) then
              begin
              DbExecSql(my_q_Tmp3,'select * from arc_' + sTblName +
                '  where doc_id=' +
                my_q_tmp2.fieldbyname('doc_id').AsString+' and ((Optionen and 1) = 0)');
              if my_q_tmp3.recordcount = 0 then
             begin
                 LogInfo('Fehler(manuell korrigieren):'+my_q_tmp2.fieldbyname('gdoc_id').AsString+' hat '+
                 my_q_tmp2.fieldbyname('arc_id').AsString+'.'+my_q_tmp2.fieldbyname('doc_id').AsString+' diese existiert '+
                 'aber nicht mehr');

             end;
             if  my_q_tmp3.fieldbyname('gdoc_id').isnull then
             begin
                 LogInfo('Fehler(wird repariert):'+my_q_tmp2.fieldbyname('arc_id').AsString+'.'+my_q_tmp2.fieldbyname('doc_id').AsString+
                 'wird auf gdoc_id '+my_q_tmp2.fieldbyname('gdoc_id').AsString +' gesetzt.');

                     DbX('update arc_' +sTblName+' set gdoc_id = '+ my_q_tmp2.fieldbyname('gdoc_id').AsString);
              //TODO: set right taskid
              DbX('insert hst_' +sTblName+' (doc_id, usr_id, tstamp, task, task_info) ' + 'Values (' +
              my_q_tmp2.fieldbyname('doc_id').AsString +',1, now(),1,'+#39+'gdoc_id  beim Reparieren auf '+
              my_q_tmp2.fieldbyname('gdoc_id').AsString+' gesetzt.' );

             end;
             if  ( my_q_tmp2.fieldbyname('gdoc_id').asinteger <>
             my_q_tmp3.fieldbyname('gdoc_id').asinteger ) and
             (not my_q_tmp3.fieldbyname('gdoc_id').isnull) then
             begin

                   LogInfo('Fehler(manuell reparieren):'+
                   my_q_tmp2.fieldbyname('arc_id').AsString+'.'+my_q_tmp2.fieldbyname('doc_id').AsString+
                   ' hat andere gdoc_id '+my_q_tmp3.fieldbyname('gdoc_id').AsString+' wie die gdoc_id '+
                   my_q_tmp2.fieldbyname('gdoc_id').AsString+', welche auf es zeigt.');



             end;
             end
             else
             begin
                 LogInfo('FEHLER(manuell reparieren): gdoc_id '+ my_q_tmp2.fieldbyname('gdoc_id').AsString +
                 ' hat keine doc_id aber anscheinend arcid! '+my_q_tmp2.fieldbyname('arc_id').AsString+'.'+
                 my_q_tmp2.fieldbyname('doc_id').AsString);

             end;

             //check by doc_id    
          //check if arc has a entry and gdocid hasnt
             DbExecSQL(my_q_Tmp3,'select *  from arc_' + sTblName + '   limit 1');
             try
                //first bit says if gdoc_id is hard or symbolic link!!!!
                //should not happen but if so then do it...
                if my_q_Tmp3.FieldDefList.Find('gdoc_id') = nil then
                begin
                //TODO: should create history entry
                Loginfo('FEHLER: Tabelle '+sTblName+' arc_id '+lsArcId+' hat keine gdoc_id spalte');
                   DbX('alter table arc_' + sTblName +
                      ' ADD COLUMN `gdoc_id` bigint UNSIGNED NULL, ADD INDEX `idx_gdoc_id` (`gdoc_id`)');
                   DbX('insert into sys_gdocid (arc_id, doc_id) select ' +
                      my_q_tmp.fieldbyname('arc_id').AsString + ',doc_id from arc_' +
                      sTblName);
                   DbX('update arc_' + sTblName +
                      ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                      my_q_tmp.fieldbyname('arc_id').AsString + ')) set a.gdoc_id = b.gdoc_id ');
                end
                else
                begin
                   if (not my_q_tmp2.fieldbyname('doc_id').isnull) and
                   (not my_q_tmp2.fieldbyname('arc_id').isnull) then
                   begin
                      DbExecSql(my_q_Tmp4,'select *  from arc_'+sTblName +
                         ' where doc_id= ' + my_q_tmp2.fieldbyname('doc_id').AsString+' and ((Optionen and 1) = 0)');
                      if my_q_Tmp4.recordcount = 0 then
                      begin
                         //todo: better strategy here
                         // something is really wrong
                         // wont do anything here, someday maybe delete field
                         LogInfo('FEHLER(reparatur manuell): gdoc_id '+ my_q_tmp2.fieldbyname('gdoc_id').AsString+
                         ' zeigt auf '+my_q_tmp2.fieldbyname('arc_id').AsString+'.'+
                         my_q_tmp2.fieldbyname('doc_id').AsString+' aber es gibt keinen '+
                         ' solchen Eintrag in der Tabelle '+ sTblName);

                      end
                      else
                      begin
                         //check for gdoc_id
                         if my_q_Tmp4.fieldbyname('gdoc_id').isnull then
                         begin
                         LogInfo('FEHLER (wird repariert): gdoc_id '+ my_q_tmp2.fieldbyname('gdoc_id').AsString+
                         ' zeigt auf '+ my_q_tmp2.fieldbyname('arc_id').AsString+'.'+
                         my_q_tmp2.fieldbyname('doc_id').AsString+' aber der Eintrag ist '+
                         ' null in der Tabelle '+ sTblName);
                         try
                            my_q_Tmp4.edit;
                            my_q_Tmp4.fieldbyname('gdoc_id').asstring :=
                               my_q_Tmp2.fieldbyname('gdoc_id').asstring;
                            my_q_Tmp4.post;
                         except on e:exception do
                         begin
                               LogInfo('FEHLER beim updaten');
                         end;
                         end;
              DbX('insert hst_' +sTblName+' (doc_id, usr_id, tstamp, task, task_info) ' + 'Values (' +
              my_q_tmp2.fieldbyname('doc_id').AsString +',1, now(),1,'+#39+'gdoc_id  beim Reparieren auf '+
              my_q_tmp2.fieldbyname('gdoc_id').AsString+' gesetzt.' );
                         end
                         else
                         begin
                              if  my_q_Tmp4.recordcount >1 then
                              begin
                                    LogInfo('FEHLER (Repartur manuell): gdoc_id '+
                                    my_q_Tmp2.fieldbyname('gdoc_id').asstring+
                         ' zeigt auf '+my_q_tmp2.fieldbyname('arc_id').asstring+ '.'+
                         my_q_tmp2.fieldbyname('doc_id').AsString+' aber diese gdoc_id ist in der arc Tabelle '+
                         'mehrfach vorhanden.');
                              end
                              else
                              begin
                            if my_q_Tmp4.fieldbyname('gdoc_id').asinteger <>
                               my_q_Tmp2.fieldbyname('gdoc_id').asinteger then
                            begin

                         LogInfo('FEHLER (Repartur manuell): gdoc_id '+ my_q_Tmp2.fieldbyname('gdoc_id').asstring+
                         ' zeigt auf '+my_q_tmp2.fieldbyname('arc_id').AsString+'.'+
                         my_q_tmp2.fieldbyname('doc_id').AsString+' aber der Eintrag zeigt auf gdoc_id '+
                          my_q_Tmp4.fieldbyname('gdoc_id').asstring);
{
                               my_q_Tmp4.edit;
                               my_q_Tmp4.fieldbyname('gdoc_id').asstring :=
                                  my_q_Tmp2.fieldbyname('gdoc_id').asstring;
                               my_q_Tmp4.post;
                               }
                            end;
                            end;
                         end;
                      end;
                   end
                   else
                   begin

                         LogInfo('FEHLER (wird repariert): gdoc_id '+ my_q_tmp2.fieldbyname('gdoc_id').AsString+
                         ' hat doc_id null. ');

                   end;
                end;
             except
                on e: exception
                   do
                begin
                   LogErr(_('Fehler bei der nderung der Tabelle sys_gdocid: ') + e.Message + #13 + ' sql: ' + LastSql);
                end;
             end;
             my_q_tmp2.next;
          end;
          //check arcs for missing entry in sys_gdocid
          my_q_tmp.first;
          while not my_q_tmp.eof do
          begin
             sTblName := my_q_tmp.FieldByName('Arc_Tblname').AsString;
             lsArcId := my_q_tmp.fieldbyname('arc_id').AsString;
             //put new entry in sys_gdocid
             DbX('insert into sys_gdocid (arc_id, doc_id) select ' +
                lsArcId + ',a.doc_id from arc_' +
                sTblName +
                ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                lsArcId + ')) where  (b.gdoc_id is null) and (a.gdoc_id is null) ' +
                ' and ((a.Optionen and 1) = 0)');
             //update entries
     {        DbX('update arc_' +sTblName +
                ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                lsArcId + ')) ' +
                'set a.gdoc_id = b.gdoc_id  where  (not(b.gdoc_id is null)) and  (a.gdoc_id is null) and ((a.Optionen and 1) = 0)');}
          DbExecSql(my_q_tmp2,'select '+
                lsArcId + ' as arc_id,a.doc_id as doc_id, b.gdoc_id as gdoc_id from arc_' +
                sTblName +
                ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                lsArcId + ')) where  (not(b.gdoc_id is null)) and  (a.gdoc_id is null) and ' +
                ' ((a.Optionen and 1) = 0)');
          my_q_tmp2.first;
          while not my_q_tmp2.eof do
          begin
          //should check for existing gdoc_id in the history
          //if existing try to get it back if not create one
          // if history has gdocid
             LogInfo('Fgen der gdocid fr docid '+ my_q_tmp2.fieldbyname('arc_id').AsString +
             '.'+   my_q_tmp2.fieldbyname('doc_id').AsString +' table '+sTblName);
              DbX('update arc_' +sTblName+' set gdoc_id = '+ my_q_tmp2.fieldbyname('gdoc_id').AsString);
              //TODO: set right taskid
              DbX('insert hst_' +sTblName+' (doc_id, usr_id, tstamp, task, task_info) ' + 'Values (' +
              my_q_tmp2.fieldbyname('doc_id').AsString +',1, now(),1,'+#39+'gdoc_id  beim Reparieren auf '+
              my_q_tmp2.fieldbyname('gdoc_id').AsString+' gesetzt.' );

             my_q_tmp2.next;
          end;
             my_q_tmp.next;
          end;
          //update entry of arc_ check for existency

          //todo: finish it
                                                     
          LogInfo('berprufe, ob gdocid in den Arc Tabellen passt:');
          my_q_tmp.first;
          //search for arc_tblname
          // and ((Optionen and 1) = 1) is symbolic link
          while not my_q_tmp.eof do
          begin
          
             sTblName := my_q_tmp.FieldByName('Arc_Tblname').AsString;
             sArcName := my_q_tmp.FieldByName('Arc_Name').AsString;
             lsArcId := my_q_tmp.fieldbyname('arc_id').AsString;
              DbExecSql(my_q_Tmp4,'select a.doc_id as doc_id, a.gdoc_id as gdoc_id,'+
             ' b.gdoc_id as sgdoc_id, b.arc_id as sarc_id, b.doc_id as sdoc_id  from arc_' + sTblName +
                ' as a left join sys_gdocid as b on ' +
                '((a.doc_id = b.doc_id) and (b.arc_id = ' + my_q_tmp.fieldbyname('arc_id').AsString + ')) where (b.gdoc_id is null) ' +
                ' and (not(a.gdoc_id is null)) and ((a.Optionen and 1) = 0)');



             while not my_q_Tmp4.eof do
             begin
             LogInfo('FEHLER(manuell reparieren):'+lsArcId+
                             '.'+my_q_Tmp4.fieldbyname('doc_id').asstring+
                             ' hat gdoc_id '+my_q_Tmp4.fieldbyname('gdoc_id').asstring+
                             ' table '+sTblName+' aber diese wurde nicht in sys_gdocid gefunden!');
               { my_q_Tmp4.Edit;
                my_q_Tmp4.fieldbyname('gdoc_id').Clear;
                my_q_Tmp4.post;    }
                my_q_Tmp4.next;

             end;
          {   DbX('update arc_' + sTblName +
                ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                my_q_tmp.fieldbyname('arc_id').AsString + ')) set a.gdoc_id = b.gdoc_id ');    }

                //check if entry corresponds

                
                DbExecSql(my_q_tmp2,'select * from arc_' + sTblName+
                ' where ((Optionen and 1) = 0) order by doc_id');
                while not my_q_tmp2.eof do
                begin
                   lbcleared := false;

                   //if this is cleared it was deleted by preceding routine
                   if my_q_tmp2.fieldbyname('gdoc_id').isnull then
                   begin
                      lbcleared := true;
                   end
                   else
                   begin
                   //select from sys_gdocid
                      DbExecSql(my_q_Tmp3,'select * from sys_gdocid' +
                         '  where gdoc_id=' + my_q_tmp2.fieldbyname('gdoc_id').AsString);
                   end;
                   if (my_q_tmp3.recordcount = 0) or
                      (lbcleared) then
                   begin
                      //give a new docid
                      //todo: search in history if there is any gdocids
                      if lbcleared  then
                      begin
                       LogInfo('Fehler(wird repariert): '+lsArcId+'.'+
                       my_q_tmp2.fieldbyname('doc_id').AsString+' hat kein gdoc_id! Eine wird vergeben.');
                      end
                       else
                       begin
                       LogInfo('Fehler(wird repariert): '+lsArcId+'.'+
                       my_q_tmp2.fieldbyname('doc_id').AsString+' hat gdoc_id '+
                       my_q_tmp2.fieldbyname('gdoc_id').AsString+', die nicht in der sys_gdocid ist.');


                       end;
                       //if it isn't there now, it wasnt in the sys_gdocid table
                      DbX('insert into sys_gdocid (arc_id, doc_id)' +
                         ' values(' + my_q_tmp.fieldbyname('arc_id').AsString + ',' +
                         my_q_tmp2.fieldbyname('doc_id').AsString + ')');
                      li64ngdocid := LastInsertId;
                      DbX('update arc_' + sTblName +
                         ' set gdoc_id = ' + inttostr(li64ngdocid) + ' where doc_id=' + my_q_tmp2.fieldbyname('doc_id').AsString);
              DbX('insert hst_' +sTblName+' (doc_id, usr_id, tstamp, task, task_info) ' + 'Values (' +
              my_q_tmp2.fieldbyname('doc_id').AsString +',1, now(),1,'+#39+'gdoc_id  beim Reparieren auf '+
              inttostr(li64ngdocid)+' gesetzt.' );

                   end
                   else
                   begin
                      //check for equalness
                      if my_q_tmp2.fieldbyname('gdoc_id').asinteger <>
                         my_q_tmp3.fieldbyname('gdoc_id').asinteger then
                      begin
                           Loginfo('Fehler(manuell reparieren): '+
                           'in arc Tabelle '+ sTblName +' mit '+my_q_tmp.fieldbyname('arc_id').AsString+
                           '.'+my_q_tmp2.fieldbyname('doc_id').asstring+' hat gdoc_id '+
                           my_q_tmp2.fieldbyname('gdoc_id').asstring +' aber in der sys_gdocid verweis gdoc_id '+
                           my_q_tmp3.fieldbyname('gdoc_id').asstring+' auf darauf ');
                         //check for other entries
                         DbExecSql(my_q_Tmp4,'select * from sys_gdocid' +
                            '  where doc_id=' +
                            my_q_tmp2.fieldbyname('doc_id').AsString + ' and ' +
                            'arc_id=' + my_q_tmp.fieldbyname('arc_id').AsString);
                         if my_q_Tmp4.RecordCount > 1 then
                         begin
                              Loginfo('Fehler(manuell reparieren): und darauf verweisen noch mehr Eintrge.');
                         end;
                      end;
                      //check for uniquiness
                      DbExecSql(my_q_Tmp4,'select * from sys_gdocid' +
                         '  where doc_id=' +
                         my_q_tmp2.fieldbyname('doc_id').AsString + ' and ' +
                         'arc_id=' + my_q_tmp.fieldbyname('arc_id').AsString);
                      if my_q_Tmp4.RecordCount > 1 then
                      begin
                         my_q_Tmp4.first;
                         my_q_Tmp4.next;
                         while not my_q_Tmp4.eof do
                         begin
                            Loginfo('Fehler(manuell reparieren): es verweisen mehere Eintrge der sys_gdocid auf'+
                             my_q_tmp.fieldbyname('arc_id').AsString+
                           '.'+my_q_tmp2.fieldbyname('doc_id').asstring+ ' gdoc_id '+
                           my_q_tmp4.fieldbyname('gdoc_id').asstring);

                           { my_q_Tmp4.edit;
                            my_q_tmp4.fieldbyname('doc_id').clear;
                            my_q_tmp4.fieldbyname('arc_id').clear;
                            my_q_Tmp4.post; }
                            my_q_Tmp4.next;
                         end;
                      end;
                   end;
                   my_q_tmp2.next;
                end;
             my_q_tmp.next;
          end;


           except on e: exception do
             begin
                LogErr(_('Fehler bei der nderung der Tabelle sys_gdocid:')+' ' + e.Message + #13 + ' sql: ' + lssql);
             end;
          end;
        finally
           my_q_Tmp4.Free;
        end;
      finally
         my_q_Tmp3.Free;
      end;
     finally
        my_q_Tmp2.Free;
     end;
   finally
      my_q_Tmp.Free;
   end;
   LogInfo( 'berprfung abgeschlossen');
end;

//-----------------------------------------------------------------------------
procedure RepairStatusfields;
var
   lsiarcname: string;
begin
   try
      DbExecSql(dm_mainform.my_q_tmp, 'show tables like ' + #39 + 'sts\_%' + #39);
      while not dm_mainform.my_q_tmp.Eof do
      begin
         lsiarcname := copy(dm_mainform.my_q_tmp.Fields[0].AsString, 5, length(dm_mainform.my_q_tmp.Fields[0].AsString));
         DbExecSql(dm_mainform.my_q_tmp2,
            'select * from sts_' + lsiarcname + ' order by sts_id');
         while not dm_mainform.my_q_tmp2.Eof do
         begin
            if dm_mainform.my_q_tmp2.fieldbyname('sts_zusfeld').AsString = '' then
            begin
               dm_mainform.my_q_tmp2.Next;
               continue;
            end;

            DbExecSql(dm_mainform.my_q_tmp3,
               'select * from cfg_' + lsiarcname + ' where Feld_name = ' + #39 +
               dm_mainform.my_q_tmp2.fieldbyname('sts_zusfeld').AsString + #39);
            if dm_mainform.my_q_tmp3.recordcount > 0 then
            begin
               dm_mainform.my_q_tmp2.Next;
               continue;
            end;

            DbExecSql(dm_mainform.my_q_tmp3, 'select * from cfg_' + lsiarcname + ' order by cfg_id');
            while not dm_mainform.my_q_tmp3.Eof do
            begin
               if dm_mainform.my_q_tmp2.fieldbyname('sts_zusname').Asstring =
                  dm_mainform.my_q_tmp3.fieldbyname('disp_name').Asstring then
               begin
                  dm_mainform.my_q_tmp2.edit;
                  dm_mainform.my_q_tmp2.fieldbyname('sts_zusfeld').AsString := dm_mainform.my_q_tmp3.fieldbyname('Feld_Name').AsString;
                  dm_mainform.my_q_tmp2.fieldbyname('sts_ZusFeldID').AsInteger := dm_mainform.my_q_tmp3.fieldbyname('cfg_id').AsInteger;
                  dm_mainform.my_q_tmp2.fieldbyname('sts_zusName').AsString := dm_mainform.my_q_tmp3.fieldbyname('Disp_Name').AsString;
                  dm_mainform.my_q_tmp2.post;
               end;
               dm_mainform.my_q_tmp3.Next;
            end;
            dm_mainform.my_q_tmp2.Next;
         end;
         dm_mainform.my_q_tmp.Next;
      end;
   except on e: Exception
         do
      begin
      end;
   end;
end;

//-----------------------------------------------------------------------------
procedure RepairCollateClick;
var sTblName:string;
begin
   dm_mainform.my_q_tmp.sql.text := 'Select * from sys_arc where arc_tblname <> ' + #39 + #39;
   dm_mainform.my_q_tmp.execute;
   while not dm_mainform.my_q_tmp.eof do
   begin
      sTblName := dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString;

      dm_mainform.my_q_tmp2.sql.text := 'SHOW FULL COLUMNS FROM cfg_' + sTblName;
      dm_mainform.my_q_tmp2.execute;
      while not dm_mainform.my_q_tmp2.eof do
      begin
         if dm_mainform.my_q_tmp2.fieldbyname('Field').asstring = 'Disp_Name' then
         begin
            if dm_mainform.my_q_tmp2.fieldbyname('Collation').asstring <> 'latin1_german1_ci' then
            begin
               DbX('ALTER TABLE `cfg_' + sTblName + '` CONVERT TO CHARACTER SET latin1 COLLATE latin1_german1_ci');
            end;
            break;
         end;
         dm_mainform.my_q_tmp2.next;
      end;

      if dm_mainform.my_q_tmp.fieldbyname('Type').asinteger = 1 then
      begin
         dm_mainform.my_q_tmp2.sql.text := 'SHOW FULL COLUMNS FROM arc_' + sTblName;
         dm_mainform.my_q_tmp2.execute;
         while not dm_mainform.my_q_tmp2.eof do
         begin
            if dm_mainform.my_q_tmp2.fieldbyname('Field').asstring = 'Disp_Name' then
            begin
               if dm_mainform.my_q_tmp2.fieldbyname('Collation').asstring <> 'latin1_german1_ci' then
               begin
                  DbX('ALTER TABLE `arc_' + sTblName + '` CONVERT TO CHARACTER SET latin1 COLLATE latin1_german1_ci');
               end;
               break;
            end;
            dm_mainform.my_q_tmp2.next;
         end;
         dm_mainform.my_q_tmp2.sql.text := 'SHOW FULL COLUMNS FROM hst_' + sTblName;
         dm_mainform.my_q_tmp2.execute;
         while not dm_mainform.my_q_tmp2.eof do
         begin
            if dm_mainform.my_q_tmp2.fieldbyname('Field').asstring = 'Task_Info' then
            begin
               if dm_mainform.my_q_tmp2.fieldbyname('Collation').asstring <> 'latin1_german1_ci' then
               begin
                  DbX('ALTER TABLE `hst_' + sTblName + '` CONVERT TO CHARACTER SET latin1 COLLATE latin1_german1_ci');
               end;
               break;
            end;
            dm_mainform.my_q_tmp2.next;
         end;
         dm_mainform.my_q_tmp2.sql.text := 'SHOW FULL COLUMNS FROM slw_' + sTblName;
         dm_mainform.my_q_tmp2.execute;
         while not dm_mainform.my_q_tmp2.eof do
         begin
            if dm_mainform.my_q_tmp2.fieldbyname('Field').asstring = 'DOC_SLW' then
            begin
               if dm_mainform.my_q_tmp2.fieldbyname('Collation').asstring <> 'latin1_german1_ci' then
               begin
                  DbX('ALTER TABLE `slw_' + sTblName + '` CONVERT TO CHARACTER SET latin1 COLLATE latin1_german1_ci');
               end;
               break;
            end;
            dm_mainform.my_q_tmp2.next;
         end;
      end;
      dm_mainform.my_q_tmp.next;
   end;
end;

//-----------------------------------------------------------------------------
procedure Char2Date;
var
   lbalreadyt, lbnoerror: boolean;
   sTblName, lsFeldName, sArc : string;
begin
   lbnoerror := true;
   try
      DbExecSql(dm_mainform.my_q_tmp,'select * from sys_arc where Type = 1');
      while not dm_mainform.my_q_tmp.Eof do
      begin
         sTblName := dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString;
         DbExecSql(dm_mainform.my_q_tmp2,'select * from cfg_'+ sTblName);
         while not dm_mainform.my_q_tmp2.Eof do
         begin
            if dm_mainform.my_q_tmp2.FieldByName('typ').AsInteger = 1 then
            begin
               lsFeldName := dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring;
               lbalreadyt := false;
               DbExecSql( dm_mainform.my_q_tmp4,
                  'show columns from  arc_' + sTblName + ' like ' + #39 + lsFeldName + #39);
               while not dm_mainform.my_q_tmp4.Eof do
               begin
                  if lsFeldName = dm_mainform.my_q_tmp4.FieldByName('Field').asstring then
                  begin
                     if (dm_mainform.my_q_tmp4.FieldByName('type').asstring = 'datetime') and
                        (dm_mainform.my_q_tmp4.FieldByName('Default').isnull) then
                     begin
                        lbalreadyt := true;
                        break;
                     end;
                  end;
                  dm_mainform.my_q_tmp4.next;
               end;
               if lbalreadyt then
               begin
                  //delete 0s
                  DbX('update arc_' + sTblName +
                     ' set ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring +
                     '= NULL where ' + lsFeldName + ' like ' + #39 + '0000-00-00%' + #39);
                  dm_mainform.my_q_tmp2.Next;
                  continue;
               end;
               sArc := 'arc_' + sTblName;
               DbX('update ' + sArc + ' set ' + lsFeldName + ' = str_to_date(' + lsFeldName + ',' + #39 + '%d.%m.%Y' + #39 + ')');
               DbX('update ' + sArc + ' set ' + lsFeldName + ' = NULL where ' + lsFeldName + ' like ' + #39 + '0000-00-00%' + #39);
               DbX('alter table ' + sArc + ' modify ' + lsFeldName + ' datetime NULL');
               DbX('update ' + sArc + ' set ' + lsFeldName + ' = NULL where ' + lsFeldName + ' like ' + #39 + '0000-00-00%' + #39);
            end;
            dm_mainform.my_q_tmp2.Next;
         end;
         dm_mainform.my_q_tmp.Next;
      end;
   except on e: exception do
      begin
         lbnoerror := false;
         LogInfo(_('Char2date Error'));
         LogProcedure(_('Fehler:') + e.message);
         LogEvnt('1000    Fehler in Modul:  btn_char2dateClick   ' + e.message);
      end;
   end;

   if lbnoerror then
   begin
      LogInfo(_('Char2date erfolgreich durchgefhrt'));
      LogProcedure(_('Char2date erfolgreich durchgefhrt'));
   end;
end;


procedure Char2Decimal;
var
   lbIsvar,lbIsdec, lbnoerror: boolean;
   iTyp: Integer;
begin
  lbnoerror := true;
  try

        DbExecSql(dm_mainform.my_q_tmp,'select * from sys_arc where arc_tblname <> ' + #39 + #39 + ' ');
        while not dm_mainform.my_q_tmp.Eof do
        begin
           LogInfoBeg(_('Checke ') + dm_mainform.my_q_tmp.fieldbyname('arc_name').AsString );
           DbExecSql(dm_mainform.my_q_tmp2,'select * from cfg_' + dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString +'  where typ = 7 or typ = 8');

           while not dm_mainform.my_q_tmp2.Eof do
           begin

              iTyp:= dm_mainform.my_q_tmp2.FieldByName('typ').AsInteger;
              LogInfo(Format(_('Feld %s vom Typ %d gefunden'),[dm_mainform.my_q_tmp2.FieldByName('Disp_name').asstring,iTyp]));
              if ( iTyp= 7) or (iTyp = 8) then
              begin
                 lbIsvar := false;
                 lbIsdec := False;
                 DbExecSql( dm_mainform.my_q_tmp4, 'show columns from  arc_' + dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString + ' like ' + #39 + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + #39);

                 while not dm_mainform.my_q_tmp4.Eof do
                 begin
                    if dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring = dm_mainform.my_q_tmp4.FieldByName('Field').asstring then
                    begin
                       if Pos('varchar',dm_mainform.my_q_tmp4.FieldByName('type').asstring )>0 then
                       begin
                          lbIsvar := true;
                          LogInfo(_('Spalte ist varchar kodiert'));
                          break;
                       end;
                       if Pos('double',dm_mainform.my_q_tmp4.FieldByName('type').asstring )>0 then
                       begin
                          lbIsdec := true;
                          LogInfo(_('Spalte ist double kodiert'));
                          break;
                       end;
                       if Pos('decimal',dm_mainform.my_q_tmp4.FieldByName('type').asstring )>0 then
                       begin
                          lbIsdec := true;
                          LogInfo(_('Spalte ist decimal kodiert'));
                          break;
                       end;

                    end;
                    dm_mainform.my_q_tmp4.next;
                 end;
                 if lbIsvar then
                 begin
                    //delete 0s
                    DbX('update arc_' + dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString +
                       ' set ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring +
                       '= Replace(' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ','+#39+','+#39+','+#39+'.'+#39+')');

                    LogInfo(_('Dezimaltrennzeichen in . gendert'));
                    //m_q2.Next;
                    //continue;
                 end;

                 DbX('update arc_' + dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString +
                    ' set ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring +
                    ' = 0 where ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ' = '+#39 +#39);

                 LogInfo(_('Leerstellen in 0 gendert'));
                 {
                 m_cmd.SQL.Text := 'update arc_' + m_q.fieldbyname('arc_tblname').AsString +
                    ' set ' + m_q2.FieldByName('Feld_name').asstring +
                    '= NULL where ' + m_q2.FieldByName('Feld_name').asstring + ' like ' + #39 + '0000-00-00%' + #39;
                 m_cmd.Execute;
                 }
                 if not lbIsdec then
                 begin

                   if iTyp = 7 then
                      DbX('alter table arc_' + dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString + ' modify ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ' double')
                   else
                      DbX('alter table arc_' + dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString + ' modify ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ' decimal(15,2)');

                   if iTyp = 7 then
                      LogInfo(_('Spalte in double gendert'))
                   else
                      LogInfo(_('Spalte in decimal(15,2) gendert'));
                 end;

              end;
              dm_mainform.my_q_tmp2.Next;

           end;
           LogInfoEinzugAus;

           dm_mainform.my_q_tmp.Next;
        end;


  except
     on e: Exception do
     begin
        lbnoerror := False;
        ExitCode := 1;
        LogInfo(_('Fehler bei der Verarbeitung mit char2decimal! ') + e.Message);

        exit;
     end;


  end;

  if lbnoerror then
   begin
      LogInfo(_('Char2decimal erfolgreich durchgefhrt'));
      LogProcedure(_('Char2decimal erfolgreich durchgefhrt'));
   end;
end;
//-----------------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////////////////////////////////////////
// Update der Systemtabellen
// cummulatives Update der Sytemtabellen

procedure UpdateTo_3_3;
var
   slTbl: TStringList;  bPreVer32: boolean;
   sTblName, sArcName, sVersion: string;
begin
   slTbl := TStringList.Create;
   try
      try
         dm_mainform.my_con.GetTableNames(slTbl);
         bPreVer32 := slTbl.IndexOf('sys_config') = -1;
         if bPreVer32 then
         begin
            if not CreateOrUpdate_sys_config
            then Exit;

            DbDoSql(dm_mainform.my_qry_Arc,'select * from sys_arc where Type = 1');
            while not dm_mainform.my_qry_Arc.Eof do
            begin
               sTblName := dm_mainform.my_qry_Arc.FieldByName('Arc_TblName').AsString;
               sArcName := dm_mainform.my_qry_Arc.FieldByName('Arc_Name').AsString;
               if slTbl.IndexOf('sts_' + sTblName) = -1 then
               begin
                  DbX('CREATE TABLE sts_' + sTblName + ' (' +
                     '`sts_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,' +
                     '`sts_Name` VARCHAR(32) NOT NULL,' +
                     '`sts_ZusFeld` VARCHAR(36) NOT NULL,' +
                     '`sts_ZusFeldID` BIGINT UNSIGNED NOT NULL,' +
                     '`sts_ZusName` VARCHAR(32) NOT NULL,' +
                     '`sts_Func` SMALLINT UNSIGNED NOT NULL,' +
                     ' PRIMARY KEY(`sts_id`))' +
                     'ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
                     'COMMENT=' + #39 + 'Statusfelder Tabelle fr Archiv' + sArcName + #39);
               end;
               DbX('Update arc_' + sTblName + ' set doc_state = 1 where doc_state = 10 or doc_state = 11');
               dm_mainform.my_qry_Arc.Next;
            end;
            dm_mainform.my_qry_Arc.Close;
            DbVersionEintragen('3.2.0');
         end;
         
         // Update von V 3.2.0 auf V 3.2.1
         sVersion := DbAktVersion;
         if sVersion = '3.2.0' then
         begin
            DbDoSql(dm_mainform.my_qry_Arc,'select * from sys_arc where Type = 1');
            while not dm_mainform.my_qry_Arc.Eof do
            begin
               sTblName := dm_mainform.my_qry_Arc.FieldByName('Arc_TblName').AsString;
               sArcName := dm_mainform.my_qry_Arc.FieldByName('Arc_Name').AsString;
               DbX('ALTER TABLE cfg_' + sTblName + #32 +
                  'ADD COLUMN `Typ` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `Disp_Name`, ' +
                  'ADD COLUMN `Werte` TEXT NOT NULL DEFAULT ' + #39 + #39 + ' AFTER `Typ`, ' +
                  'ADD COLUMN `Mode` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `Werte`');
               dm_mainform.my_qry_Arc.Next;
            end;
            dm_mainform.my_qry_Arc.Close;
            DbVersionEintragen('3.2.1');
         end;

         // Update von V 3.2.1 auf V 3.2.2
         sVersion := DbAktVersion;
         if sVersion = '3.2.1' then
         begin
            DbDoSql(dm_mainform.my_qry_Arc,'select * from sys_arc where Type = 1');
            while not dm_mainform.my_qry_Arc.Eof do
            begin
               sTblName := dm_mainform.my_qry_Arc.FieldByName('Arc_TblName').AsString;
               sArcName := dm_mainform.my_qry_Arc.FieldByName('Arc_Name').AsString;
               DbX('ALTER TABLE cfg_' + sTblName + #32 +
                  'MODIFY COLUMN `Werte` TEXT CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL DEFAULT ' + #39 + #39 + ',' +
                  'ADD COLUMN `Pos` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `Mode`');
               dm_mainform.my_qry_Arc.Next;
            end;
            dm_mainform.my_qry_Arc.Close;
            DbVersionEintragen('3.2.2');
         end;

         // Update von V 3.2.2 auf V 3.3.0
         sVersion := DbAktVersion;
         if sVersion = '3.2.2' then
         begin
            if CreateOrUpdate_sys_timer then
               DbVersionEintragen('3.3.0');
         end;

         // Update von V 3.3.0 auf V 3.3.1
         sVersion := DbAktVersion;
         if sVersion = '3.3.0' then
         begin
            if CreateOrUpdate_sys_arcxs
            and CreateOrUpdate_sys_docxs then
               DbVersionEintragen('3.3.1');
         end;
      except
         on e: exception do
            LogErr(_('Fehler beim Update der Archivtabellen')+': ' + e.Message);
      end;
   finally
      FreeAndNil(slTbl);
   end;

   sVersion := DbAktVersion;
   if sVersion = '3.3.1' then
   begin
      // begin of altering CFG_Table

      DbDoSql(dm_mainform.my_qry_Arc,'select * from sys_arc where Type = 1');
      while not dm_mainform.my_qry_Arc.Eof do
      begin
         sTblName := dm_mainform.my_qry_Arc.FieldByName('Arc_TblName').AsString;
         sArcName := dm_mainform.my_qry_Arc.FieldByName('Arc_Name').AsString;

         DbExecSql(dm_mainform.my_q_tmp, 'select * from cfg_' + sTblName);
         if (dm_mainform.my_q_tmp.FieldDefList.Find('Optionen') = nil) then
         begin
            DbX('ALTER TABLE cfg_' + sTblName + #32 +
               'ADD COLUMN `Optionen` BIGINT UNSIGNED NOT NULL DEFAULT 0 AFTER `Mode`');
         end;
         dm_mainform.my_qry_Arc.Next;
      end;
      dm_mainform.my_qry_Arc.Close;

      CreateOrUpdate_sys_timer;

      DbVersionEintragen('3.3.2');
   end;
   // end of altering CFG_Table

   sVersion := DbAktVersion;
   if sVersion = '3.3.2' then
   begin
      // Update von V 3.3.2 auf V 3.3.2.21
      if CreateOrUpdate_sys_timer then
         DbVersionEintragen('3.3.2.21');
   end;

   ////////////////////////////////////////////////
   // Update von V 3.3.2.21 auf V 3.3.2.22

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.21' then
   begin
      if CreateOrUpdate_sys_docxs
      and CreateOrUpdate_sys_arcxs
      and CreateOrUpdate_sys_timer then
         DbVersionEintragen('3.3.2.22');
      sVersion := DbAktVersion;
   end;

   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //
   // Begin des Datenbank update auf Version 3.3.2.23 NG070713
   // Erweitert wird die Tabelle docxy im das Feld src_usr_id
   // damit fuer die Annos nachgehalten werden kann, wer ein bestimmtes Recht vergeben hat

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.22' then
   begin
      // Update von 3.3.2.22 auf 3.3.2.23
      ////////////////////////////////////////////////////////////////////////////////////////////////////
      // Begin des Datenbankupdate
      //
      if CreateOrUpdate_sys_docxs
      and CreateOrUpdate_sys_timer
      and CreateOrUpdate_sys_arcxs then
         DbVersionEintragen('3.3.2.23');
   end;

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.23' then
   begin
      if CreateOrUpdate_sys_timerhist then
         DbVersionEintragen('3.3.2.24');
   end;

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.24' then
   begin
      if CreateOrUpdate_sys_arcxs then
         DbVersionEintragen('3.3.2.25');
   end;

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.25' then
   begin
      if CreateOrUpdate_sys_timerxs then
         DbVersionEintragen('3.3.2.26');
   end;

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.26' then
   begin
      if CreateOrUpdate_sys_arcxs then
         DbVersionEintragen('3.3.2.27');
   end;

   sVersion := DbAktVersion;
   if sVersion = '3.3.2.27' then
   begin
      DbVersionEintragen('3.3.2.28');
   end;
end;

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
procedure UpdateTo_3_4(out li:integer);
var sVersion, sTblName: string;
   lberror, lbupdate, lbshowwarining: boolean;
   lvhostedv, lsminimum: Tversion;
begin
   li:=0;
   // Update von V 3.2.1 auf V 3.2.2
   lbupdate := false;
   lbshowwarining := false;

   sVersion := DbAktVersion;
   if sVersion>'' then
   begin
      if sVersion = '3.3.2.28' then
      begin
         lbupdate := true;
      end
      else
      begin
         sVersion := DbAktVersion;
         SplitVersionString(sVersion, lvhostedv);
         SplitVersionString('3.3.2.28', lsminimum);
         if compareversions(lvhostedv, lsminimum) then
         begin
            lbupdate := true;
         end
         else
         begin
            lbshowwarining := true;
         end;
      end;
   end;
   //      dm_mainform.my_qry_Arc.Close;
   if lbupdate then
   begin
      lberror := false;
      if not CreateOrUpdate_sys_gdocid
      then lberror := true;

      DbExecSql(dm_mainform.my_q_tmp, 'select * from sys_arc where type = 1');
      while not dm_mainform.my_q_tmp.eof do
      begin
         sTblName := dm_mainform.my_q_tmp.fieldbyname('arc_tblname').AsString;
         DbExecSql(dm_mainform.my_q_Tmp2,'select * from arc_' + sTblName + ' limit 1');
         try
            //first bit says if gdoc_id is hard or symbolic link!!!!
            if dm_mainform.my_q_Tmp2.FieldDefList.Find('gdoc_id') = nil then
            begin
               DbX('alter table arc_' + sTblName +
                  ' ADD COLUMN `gdoc_id` bigint UNSIGNED NULL, ADD INDEX `idx_gdoc_id` (`gdoc_id`)');
               DbX('insert into sys_gdocid (arc_id, doc_id) select ' +
                  dm_mainform.my_q_tmp.fieldbyname('arc_id').AsString + ',doc_id from arc_' +
                  sTblName);
               DbX('update arc_' + sTblName +
                  ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
                  dm_mainform.my_q_tmp.fieldbyname('arc_id').AsString + ')) set a.gdoc_id = b.gdoc_id');
            end;
         except
            on e: exception
               do
            begin
               lberror := true;
               LogErr(_('Fehler bei der nderung der Tabelle')+' sys_gdocid: ' + e.Message + #13 + ' sql: ' + LastSql);
            end;
         end;

         dm_mainform.my_q_tmp.Next;
      end;
      li := li or 64;

      if not CreateOrUpdate_sys_symlnk then
         lberror := true;
      
      try
         DbExecSql(dm_mainform.my_q_tmp, 'select * from sys_arc where type = 1');
         while not dm_mainform.my_q_tmp.eof do
         begin
            sTblName := dm_mainform.my_q_tmp.FieldByName('Arc_Tblname').AsString;
            DbExecSql(dm_mainform.my_q_Tmp2,
               'select *  from arc_' + sTblName + ' limit 1');
            if dm_mainform.my_q_Tmp2.FieldDefList.Find('Optionen') = nil then
            begin
               //first bit says if gdoc_id is hard or symbolic link!!!!
               DbX('ALTER TABLE `arc_' + sTblName +
                  '` ADD COLUMN `Optionen` int unsigned DEFAULT 0;');
            end;
            dm_mainform.my_q_tmp.Next;
         end;

         li := li or 32;

         //check progrs for zusfield

         DbExecSql(dm_mainform.my_q_tmp, 'select * from sys_arc where type = 1');
         while not dm_mainform.my_q_tmp.eof do
         begin
            sTblName := dm_mainform.my_q_tmp.FieldByName('Arc_Tblname').AsString;
            DbExecSql(dm_mainform.my_q_Tmp2,'select *  from cfg_' + sTblName + ' limit 1');
            if dm_mainform.my_q_Tmp2.FieldDefList.Find('chck_prog') = nil then
            begin
               //first bit says if gdoc_id is hard or symbolic link!!!!
               DbX('ALTER TABLE `cfg_' + sTblName +
                  '` ADD COLUMN `chck_prog` varchar(255);');
            end;
            dm_mainform.my_q_tmp.Next;
         end;
      except
         on e: Exception do
         begin
            lberror := true;
            LogErr(_('Fehler beim Erzeugen des')+' chck_prog: ' + e.Message);
         end;
      end;

      if not CreateOrUpdate_sys_arcxs then
         lberror := true;

      if not CreateOrUpdate_sys_arc then
         lberror := true;

      if not CreateOrUpdate_sys_doclock then
         lberror := true;

      if not CreateOrUpdate_sys_arcxs then
         lberror := true;;

      Char2Date;
      
      if not CreateOrUpdate_sys_ctlrtimer then
         lberror := true;

      sVersion := DbAktVersion;
      if sVersion = '3.3.2.28' then
         begin
            DbVersionEintragen('3.4.0.0');
         end
      else
         if pos('3.3.', sVersion) = 1 then
         begin
            DbVersionEintragen('3.4.0.0');
         end;

      sVersion := DbAktVersion;
      if sVersion = '3.4.0.0' then
         DbVersionEintragen('3.4.0.1');

      if lberror then
         begin
            LogInfo(_('Update hatte Fehler bitte berprfen sie gegebenenfalls das Log:') + #10
               + BD.LogPath + '\AdministratorV3.log');
         end
      else
         begin
            LogInfo(_('Update erfolgreich auf Version ' + '3.4.0.1' + ' durchgefhrt.'));
         end;
   end
   else
   begin
      sVersion := DbAktVersion;
      if pos('3.3.', sVersion) = 1 then
      begin
         DbVersionEintragen('3.4.0.1');
      end;
      if lbshowwarining then
         LogInfo(_('Datenbank muss schon auf Version 3.3.2.28 upgedatet worden sein, um das ' + #10 +
            'Update durchfhren zu knnen. Aktuelle Version ist ') + sVersion + '.');
   end;
end;

//-----------------------------------------------------------------------------
procedure UpdateTo_3_4_1;
var sVersion: string;
begin
   if not CreateOrUpdate_sys_superior then
      Exit;

   sVersion := DbAktVersion;
   if sVersion = '3.4.0.1' then
      DbVersionEintragen('3.4.1.0');

   if not CreateOrUpdate_sys_delhistory then Exit;
   
   if CreateOrUpdate_sys_arcxs then Exit;

   sVersion := DbAktVersion;
   if sVersion = '3.4.1.0' then
      DbVersionEintragen('3.4.1.1');

   sVersion := DbAktVersion;
   if sVersion = '3.4.1.1' then
      DbVersionEintragen('3.4.1.2');

   sVersion := DbAktVersion;
   if sVersion = '3.4.1.2' then
      DbVersionEintragen('3.4.1.3');

   CreateOrUpdate_sys_arcxs;

   sVersion := DbAktVersion;
   if sVersion = '3.4.1.3' then
      DbVersionEintragen('3.4.1.4');
      
   LogProcedure(_('Update erfolgreich auf Version ' + '3.4.1.4' + ' durchgefhrt.'));
end;

//-----------------------------------------------------------------------------
procedure CreateSystemTables;
begin
   CreateOrUpdateAll;
end;

//-----------------------------------------------------------------------------
// Systemtabellen erzeugen oder updaten
procedure CreateOrUpdate_Sys;
var sVersion: string;
begin
   LogInfoBeg(_('Alle System-Tabellen erzeugen oder updaten'));

   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_config"');
   if not CreateOrUpdate_sys_config
   then Exit;
   
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_timer"');
   CreateOrUpdate_sys_timer;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_arc"');
   CreateOrUpdate_sys_arc;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_arcxs"');
   CreateOrUpdate_sys_arcxs;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_gdocid"');
   CreateOrUpdate_sys_gdocid;
   //---------------------------------------------------------------------------
   LogInfo(_('Lege gdoc_id falls ntig an'));
   UpdateForGdocid;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_ctlrtimer"');
   CreateOrUpdate_sys_ctlrtimer;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_delhistory"');
   CreateOrUpdate_sys_delhistory;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_doclnk"');
   CreateOrUpdate_sys_doclnk;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_doclock"');
   CreateOrUpdate_sys_doclock;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_docxs"');
   CreateOrUpdate_sys_docxs;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_grp"');
   CreateOrUpdate_sys_grp;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_grpusr"');
   CreateOrUpdate_sys_grpusr;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_superior"');
   CreateOrUpdate_sys_superior;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_symlnk"');
   CreateOrUpdate_sys_symlnk;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_timerhist"');
   CreateOrUpdate_sys_timerhist;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_timerxs"');
   CreateOrUpdate_sys_timerxs;
   //---------------------------------------------------------------------------
   LogInfo(_('Behandle Tabelle')+' "sys_usr"');
   CreateOrUpdate_sys_usr;
   //---------------------------------------------------------------------------

   sVersion := DbAktVersion;
   if sVersion <> gsversion then
      DbVersionEintragen(gsversion);

   LogInfoEnd(_('Ende mit: Alle System-Tabellen erzeugen oder updaten'));
end;

//-----------------------------------------------------------------------------
// Erzeugt oder Updated Tabellen fr ein Archiv
// Parameter
//  - lmqArc ist das Query, das aktuell den Eintrag der sysw_arc hat der dran ist
//  - slTbl ist eine Liste aller Tabellen
procedure CreateOrUpdateOneArc(lmqArc: TMyQuery;  slTbl:TStringList);
var
  lbalreadyt,lbIsvar,lbIsDec: Boolean; 
  sArcId, sArcName, sTblName, sArc, sSts, sCfg, sCom, lsFeldName: string;
  iTyp:Integer;

begin
   sArcId   := lmqArc.FieldByName('Arc_Id').AsString;
   sArcName := lmqArc.FieldByName('Arc_Name').AsString;
   sTblName := lmqArc.FieldByName('Arc_TblName').AsString;
   LogInfoBeg( _('Behandle Archiv')+' "'+sTblName+'" - "'+sArcName+'"');

   //-------------------------
   sArc := 'arc_' + sTblName;
   sCfg := 'cfg_' + sTblName;
   sSts := 'sts_' + sTblName;
   sCom := 'com_' + sTblName;

   if slTbl.IndexOf(sSts) = -1 then
      begin
         DbXLogPrc2('CREATE TABLE sts_' + sTblName + ' (' +
            '`sts_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,' +
            '`sts_Name` VARCHAR(32) NOT NULL,' +
            '`sts_ZusFeld` VARCHAR(36) NOT NULL,' +
            '`sts_ZusFeldID` BIGINT UNSIGNED NOT NULL,' +
            '`sts_ZusName` VARCHAR(32) NOT NULL,' +
            '`sts_Func` SMALLINT UNSIGNED NOT NULL,' +
            ' PRIMARY KEY(`sts_id`))' +
            'ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT=' + #39 + 'Statusfelder Tabelle fr Archiv' + sArcName + #39,
            'Tabelle  "'+sSts+'" angelegt',
            'Fehler beim Anlegen der Tabelle  "'+sSts+'"');
      end
   else
      LogInfo( Format(_('Tabelle  "%s" bereits vorhanden'),[sSts]) );

   //-------------------------
 (*  DbXLogPrc2(
      'Update arc_' + sTblName + ' set doc_state = 1 where doc_state = 10 or doc_state = 11',
      Format(_('Fehler bei Tabelle "%s" doc_state korrigieren, sofern ntig'),['arc_' + sTblName]),
      Format(_('In Tabelle "%s" doc_state korrigiert, sofern ntig'),['arc_' + sTblName]));
 *) // 24.05.2011 b.takacs 3.5.1.3
   //-------------------------
   if DbTableColumnExist(sCfg,'Typ') then
      LogInfo(Format(_('In der Tabelle "%s" existieren die Spalten "Typ", "Werte", "Mode" und "Pos" bereits'),[sCfg]))
   else
      DbXLogPrc2(
         'ALTER TABLE ' + sCfg + #32 +
            'ADD COLUMN `Typ` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `Disp_Name`, ' +
            'ADD COLUMN `Werte` TEXT NOT NULL DEFAULT ' + #39 + #39 + ' AFTER `Typ`, ' +
            'ADD COLUMN `Mode` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `Werte`' +
            'ADD COLUMN `Pos` INTEGER UNSIGNED NOT NULL DEFAULT 0 AFTER `Mode`',
         Format(_('Fehler beim Hinzufgen der Spalten "Typ", "Werte", "Mode" und "Pos" in Tabelle "%s"'),[sCfg]),
         Format(_('In der Tabelle "%s" die Spalten "Typ", "Werte", "Mode" und "Pos" hinzugefgt'),[sCfg]));

   //-------------------------
   DbXLogPrc2(
      'ALTER TABLE ' + sCfg + #32 +
         //'MODIFY COLUMN `Werte` TEXT CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL DEFAULT ' + #39 + #39 + ',' +
         'MODIFY COLUMN `Werte` TEXT CHARACTER SET latin1 COLLATE latin1_german1_ci NOT NULL',
      Format(_('Fehler beim ndern der Werte in Tabelle "%s"'),[sCfg]),
      Format(_('In Tabelle "%s" Spalte Werte gendert, sofern ntig'),[sCfg]));

   //-------------------------
   if DbTableColumnExist(sCfg,'Optionen') then
      LogInfo(Format(_('In der Tabelle "%s" existiert die Spalte "Optionen" bereits'),[sCfg]))
   else
      DbXLogPrc2(
         'ALTER TABLE ' + sCfg + #32 +
              'ADD COLUMN `Optionen` BIGINT UNSIGNED NOT NULL DEFAULT 0 AFTER `Mode`',
         Format(_('Fehler beim Hinzufgen der Spalte "Optionen" in Tabelle "%s"'),[sCfg]),
         Format(_('In Tabelle "%s" Spalte "Optionen" hinzugefgt'),[sCfg]));

   //-------------------------

   if DbTableColumnExist(sArc,'gdoc_id') then
      LogInfo(Format(_('In der Tabelle "%s" existiert die Spalte "gdoc_id" bereits'),[sArc]))
   else
      try
         DbX('alter table ' + sArc +
            ' ADD COLUMN `gdoc_id` bigint UNSIGNED NULL, ADD INDEX `idx_gdoc_id` (`gdoc_id`)');
         DbX('insert into sys_gdocid (arc_id, doc_id) select ' +
            sArcId + ',doc_id from ' + sArcId);
         DbX('update ' + sArc +
            ' as a left join sys_gdocid as b on ((a.doc_id = b.doc_id) and (b.arc_id = ' +
            sArcId + ')) set a.gdoc_id = b.gdoc_id');
      except
         on e: exception do
            begin
               LogErr(_('Fehler beim ndern der Tabelle')+' "'+sArc+'": ' + e.Message);
            end;
      end;

   //-------------------------
   if DbTableColumnExist(sArc,'Optionen') then
      LogInfo(Format(_('In der Tabelle "%s" existiert die Spalte "Optionen" bereits'),[sArc]))
   else
      DbXLogPrc2(
         'ALTER TABLE `' + sArc + '` ADD COLUMN `Optionen` int unsigned DEFAULT 0;',
         Format(_('Fehler beim Hinzufgen der Spalte "Optionen" in Tabelle "%s" '),[sArc]),
         Format(_('In Tabelle "%s" Spalte "Optionen" hinzugefgt'),[sArc]));

   //-------------------------
   if DbTableColumnExist(sArc,'SHA1') then
      LogInfo(Format(_('In der Tabelle "%s" existiert die Spalte "SHA1" bereits'),[sArc]))
   else
      DbXLogPrc2(
         'ALTER TABLE `' + sArc + '` ADD COLUMN `SHA1` varchar(40);',
         Format(_('Fehler beim Hinzufgen der Spalte "SHA1" in Tabelle "%s" '),[sArc]),
         Format(_('In Tabelle "%s" Spalte "SHA1" hinzugefgt'),[sArc]));

   //-------------------------
   if DbTableColumnExist(sCfg,'chck_prog') then
      LogInfo(Format(_('In der Tabelle "%s" existiert die Spalte "chck_prog" bereits'),[sCfg]))
   else
      DbXLogPrc2(
         'ALTER TABLE `' + sCfg + '` ADD COLUMN `chck_prog` varchar(255);',
         Format(_('Fehler beim Hinzufgen der Spalte chck_prog in Tabelle  "%s"'),[sCfg]),
         Format(_('In Tabelle "%s" Spalte chck_prog hinzugefgt'),[sCfg]));

   //-------------------------
   if slTbl.IndexOf(sCom) = -1 then
      begin
         DbXLogPrc2(
            'CREATE TABLE `' + sCom + '` (' +
            '`COM_ID` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,' +
            '`DOC_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
            '`DISP_NAME` VARCHAR(32) NOT NULL,' +
            '`USR_NAME` VARCHAR(32) NOT NULL,' +
            '`USR_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,' +
            '`TStamp` DATETIME NOT NULL DEFAULT ' + #39 + '1900-01-01 00:00:00' + #39 + ',' +
            //m.frey'`COM_TXT` VARCHAR(65535) NOT NULL,' +
            '`COM_TXT` VARCHAR(16383) NOT NULL,' + //m.frey 65535 ist zuviel, eine existierende Tabelle hat auch nur 16383
            //                       '`COM_TXT` LONGTEXT,' +
            'INDEX `IX_TStamp`(`TStamp`),' +
            'INDEX `IX_USR_NAME`(`USR_NAME`)' +
            //                       'FULLTEXT `FTX_DOC_TXT`(`COM_TXT`)' +
            ')  ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ' +
            'COMMENT = ' + #39 + 'Kommentartabelle fr Archiv: ' + sTblName + #39 ,
            Format(_('Fehler beim Anlegen der Tabelle  "%s"'),[sCom]),
            Format(_('Tabelle  "%s" angelegt'),[sCom]));
      end
   else
      LogInfo(Format(_('Tabelle "%s" bereits vorhanden'),[sCom]));

   //-------------------------
   LogInfo(_('Fhre char2date aus'));
   //char2date
   try
      DbExecSql(dm_mainform.my_q_tmp2,'select * from '+ sCfg);
      while not dm_mainform.my_q_tmp2.Eof do
      begin
         if dm_mainform.my_q_tmp2.FieldByName('typ').AsInteger = 1 then
         begin
            lsFeldName := dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring;
            lbalreadyt := false;
            DbExecSql( dm_mainform.my_q_tmp4,
               'show columns from  arc_' + sTblName + ' like ' + #39 + lsFeldName + #39);
            while not dm_mainform.my_q_tmp4.Eof do
            begin
               if lsFeldName = dm_mainform.my_q_tmp4.FieldByName('Field').asstring then
               begin
                  if (dm_mainform.my_q_tmp4.FieldByName('type').asstring = 'datetime') and
                     (dm_mainform.my_q_tmp4.FieldByName('Default').isnull) then
                  begin
                     lbalreadyt := true;
                     break;
                  end;
               end;
               dm_mainform.my_q_tmp4.next;
            end;
            if lbalreadyt then
            begin
               //delete 0s
               DbX('update arc_' + sTblName +
                  ' set ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring +
                  '= NULL where ' + lsFeldName + ' like ' + #39 + '0000-00-00%' + #39);
               dm_mainform.my_q_tmp2.Next;
               continue;
            end;
            sArc := 'arc_' + sTblName;
            DbX('update ' + sArc + ' set ' + lsFeldName + ' = str_to_date(' + lsFeldName + ',' + #39 + '%d.%m.%Y' + #39 + ')');
            DbX('update ' + sArc + ' set ' + lsFeldName + ' = NULL where ' + lsFeldName + ' like ' + #39 + '0000-00-00%' + #39);
            DbX('alter table ' + sArc + ' modify ' + lsFeldName + ' datetime NULL');
            DbX('update ' + sArc + ' set ' + lsFeldName + ' = NULL where ' + lsFeldName + ' like ' + #39 + '0000-00-00%' + #39);
         end;
         dm_mainform.my_q_tmp2.Next;
      end;
      LogInfo(_('Fertig mit char2date der Tabelle')+' "'+sArc+'"');
   except
      on e: exception do
         LogErr(_('Fehler bei char2date der Tabelle')+' "'+sArc+'": ' + e.Message);
   end;

   //-------------------------
   LogInfoBeg(_('Fhre char2decimal aus'));
   try
     DbExecSql(dm_mainform.my_q_tmp2,'select * from ' +sCfg+ ' where typ = 7 or typ = 8');

     while not dm_mainform.my_q_tmp2.Eof do
     begin

        iTyp:= dm_mainform.my_q_tmp2.FieldByName('typ').AsInteger;
        LogInfo(Format(_('Feld %s vom Typ %d gefunden'),[dm_mainform.my_q_tmp2.FieldByName('Disp_name').asstring,iTyp]));
        if ( iTyp= 7) or (iTyp = 8) then
        begin
           lbIsvar := false;
           lbIsdec := False;
           DbExecSql( dm_mainform.my_q_tmp4, 'show columns from  arc_' + sTblName + ' like ' + #39 + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + #39);

           while not dm_mainform.my_q_tmp4.Eof do
           begin
              if dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring = dm_mainform.my_q_tmp4.FieldByName('Field').asstring then
              begin
                 if Pos('varchar',dm_mainform.my_q_tmp4.FieldByName('type').asstring )>0 then
                 begin
                    lbIsvar := true;
                    LogInfo(_('Spalte ist varchar kodiert'));
                    break;
                 end;
                 if Pos('double',dm_mainform.my_q_tmp4.FieldByName('type').asstring )>0 then
                 begin
                    lbIsdec := true;
                    LogInfo(_('Spalte ist double kodiert'));
                    break;
                 end;
                 if Pos('decimal',dm_mainform.my_q_tmp4.FieldByName('type').asstring )>0 then
                 begin
                    lbIsdec := true;
                    LogInfo(_('Spalte ist decimal kodiert'));
                    break;
                 end;

              end;
              dm_mainform.my_q_tmp4.next;
           end;
           if lbIsvar then
           begin
              //delete 0s
              DbX('update arc_' +sTblName +
                 ' set ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring +
                 '= Replace(' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ','+#39+','+#39+','+#39+'.'+#39+')');

              LogInfo(_('Dezimaltrennzeichen in . gendert'));
              //m_q2.Next;
              //continue;
           end;

           DbX('update arc_' +sTblName +
              ' set ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring +
              ' = 0 where ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ' = '+#39 +#39);

           LogInfo(_('Leerstellen in 0 gendert'));
           {
           m_cmd.SQL.Text := 'update arc_' + m_q.fieldbyname('arc_tblname').AsString +
              ' set ' + m_q2.FieldByName('Feld_name').asstring +
              '= NULL where ' + m_q2.FieldByName('Feld_name').asstring + ' like ' + #39 + '0000-00-00%' + #39;
           m_cmd.Execute;
           }
           if not lbIsdec then
           begin

             if iTyp = 7 then
                DbX('alter table arc_' + sTblName + ' modify ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ' double')
             else
                DbX('alter table arc_' + sTblName + ' modify ' + dm_mainform.my_q_tmp2.FieldByName('Feld_name').asstring + ' decimal(15,2)');

             if iTyp = 7 then
                LogInfo(_('Spalte in double gendert'))
             else
                LogInfo(_('Spalte in decimal(15,2) gendert'));
           end;

        end;
        dm_mainform.my_q_tmp2.Next;

     end;
     LogInfoEnd(_('Fertig mit char2decimal der Tabelle')+' "'+sArc+'"');
   except
     on e: exception do
         LogErr(_('Fehler bei char2decimal der Tabelle')+' "'+sArc+'": ' + e.Message);

   end;



   //-------------------------
   LogInfoEinzugAus;
end;

//-----------------------------------------------------------------------------
// Tabellen der Archive erzeugen oder updaten
procedure CreateOrUpdateAllArc;
var lmqArc: TMyQuery;
  slTbl:TStringList; // Liste aller Tabellen
begin
   LogInfoBeg(_('Starte mit: Alle Archiv-Tabellen erzeugen oder updaten'));
   lmqArc := DbCreateQuery;
   slTbl := TStringList.Create;
   try
      my_Con.GetTableNames(slTbl);
      try
         DbDoSql(lmqArc,'select * from sys_arc where Type = 1');
         while not lmqArc.Eof do
         begin
            CreateOrUpdateOneArc(lmqArc, slTbl);
            lmqArc.Next;
         end;
      finally
         lmqArc.Free;
      end;
   finally
      slTbl.Free;
   end;
   LogInfoEnd(_('Ende mit: Alle Archiv-Tabellen erzeugen oder updaten'));
end;

//-----------------------------------------------------------------------------
// Ersetzt das bisherige Create oder Update
procedure CreateOrUpdateAll;
begin
   LogInfoBeg(_('Alle Tabellen erzeugen oder updaten'));

   // Systemtabellen erzeugen oder updaten
   CreateOrUpdate_Sys;

   // Tabellen der Archive erzeugen oder updaten
   CreateOrUpdateAllArc;

   LogInfoEnd(_('Ende mit: Alle Tabellen erzeugen oder updaten'));
end;


//-----------------------------------------------------------------------------
begin
end.

//-----------------------------------------------------------------------------