//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv Administrator
// Entwickler: m.frey
// Erstellt:   2009-09-16
// Name:       u_AdminUtils
// Typ:        Unit
// Zweck:      Datenbankoperationen von Register "Tools"
//-----------------------------------------------------------------------------
// Diverse Hilfsmethode auf hherer Ebene
// Insbesondere ist hier Zugriff auf die DB wegen u_dm_mainform
//----------------------------------------------------------------------------}

unit u_AdminUtils;

//-----------------------------------------------------------------------------
{###############################} INTERFACE {###############################}
//-----------------------------------------------------------------------------

uses
  Windows, SysUtils, StrUtils, Classes,
  MyAccess,
  gnugettext,
  u_ShLowUtils, u_ShDbUtils, u_ShHighUtils,
  u_dm_mainform;

const
  cDbTrue  = '*';
  cDbFalse = '-';

(* //3.5.0.36 [2390]
function DbUserIdI(Name: string):int64;
function DbUserIdS(Name: string):string;
*)
function DbAdUserIdS(Name: string):string;
function DbAddUser(Name, Mail, Pass: string; Enabled, isAd: Boolean):integer;
procedure DbUserUpdateMail(Name, Mail: string; isAd: Boolean);
procedure DbDelUserName(Name:string; NurAd: Boolean);
//procedure DbDelUserNameId(Name:string; UsrID:integer; NurAd: Boolean);

(* //3.5.0.36 [2390]
function DbGroupIdI(Name: string):int64;
function DbGroupIdS(Name: string):string;
*)
function DbAddGroup(Name: string):int64;
procedure DbAddUserToGroup(UserName, GroupName: string);
procedure DbDelUserFromGroup(UserName, GroupName: string);
procedure GetGroupList(List:TStrings);
function CreateGroupList:TStringList;
procedure GetUserList(List:TStrings);
procedure DbGetUserInfo(Names,Mails, Ad:TStrings);
function CreateUserList:TStringList;

// Gibt eine Liste der User einer Gruppe zurck. Fr Free ist Aufrufer verantwortlich
procedure GetGroupUserList(Group:string; Users,Mails,Ad:TStrings);

procedure SetGrpUsrRights(USR_ID, GRP_ID: Integer); //3.5.0.22 [2403]
procedure RemGrpUsrRights(USR_ID, GRP_ID: Integer); //3.5.0.22 [2403]

//-----------------------------------------------------------------------------
{############################} IMPLEMENTATION {#############################}
//-----------------------------------------------------------------------------


(*
//-----------------------------------------------------------------------------
// gibt die Usr_id zurck anhand dem Namen - Rckgabe als int
function DbUserIdI(Name: string):int64;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := 0;
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_usr where Usr_Name = ' +
         #39 + Name + #39 + ' and (FIND_IN_SET("deleted",sys_usr.Flags)=0)';
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('usr_id').AsInteger;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// gibt die Usr_id zurck anhand dem Namen - Rckgabe als String  // Leerstring wenn nicht gefunden
function DbUserIdS(Name: string):string;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_usr where ' +
         '(Usr_Name = ' + #39 + Name + #39 + ') and (FIND_IN_SET("deleted",sys_usr.Flags)=0)';
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('usr_id').AsString;
      end;
   finally
      lmq.Free;
   end;
end;
*)

//-----------------------------------------------------------------------------
// gibt die Usr_id zurck anhand dem Namen - Rckgabe als String - nur wenn AD-User
function DbAdUserIdS(Name: string):string;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_usr where Usr_Name = ' +
         #39 + Name + #39 + ' and (FIND_IN_SET("from_ad",sys_usr.Flags)>0)';
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('usr_id').AsString;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Legt einen User an.
// Rckgabewert ist die usr_id

function DbAddUser( Name, Mail, Pass: string; Enabled, isAd:Boolean):integer;
var lmq: TMyQuery;  lsSql, lsFlags:string;
begin
   lmq := DbCreateQuery;
   try
      Result := 0;
      lsSql := 'select * from sys_usr where ' +
               '(Usr_Name = ' + #39 + Name + #39 + ') ' +
               //'and (sys_usr.Flags <> ' + #39 + 'deleted' + #39 + ')';
               'and (find_in_set("deleted",sys_usr.Flags)=0)';

      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount = 0 then // gibt es den user noch nicht?
         begin
            lsSql := 'select * from sys_usr where ' +
                     '(Usr_Name = '+ #39 +'DEL_' + Name + #39 + ') ' +
                     'and (sys_usr.Flags = ' + #39 + 'deleted' + #39+')';
            if DbDoSql(lmq, lsSql) then
            begin
               if lmq.RecordCount = 0 then // gab es den user auch noch nicht als gelscht?
                  begin
                     lsSql := 'select * from sys_usr where usr_id = 0'; // Leere Menge holen
                     if DbDoSql(lmq, lsSql) then
                        begin
                           lmq.Insert;
                           Result := lmq.InsertId;
                        end
                     else Exit;
                  end
               else // Es gibt den User als gelscht, dann nehmen wir den
                  begin
                     lmq.Edit;
                     Result := lmq.FieldByName('Usr_id').AsInteger;
                  end;

               lsFlags := '';
               if Enabled then
                  lsFlags := 'enabled';
               if isAd then
                  lsFlags := AddWithComma(lsFlags,'from_ad');

               lmq.FieldByName('Usr_Name').AsString := Name;
               lmq.FieldByName('Usr_Mail').AsString := Mail;
               lmq.FieldByName('Sub_Usr' ).AsInteger := 0;
               lmq.FieldByName('Usr_Pass').AsString := Pass;

               lmq.FieldByName('Flags').AsString := lsFlags; //sys_usr.Flags

               //lsOldFlags := lmq.FieldByName('Flags').AsString;

               lmq.Post;

               //lsSql := 'update sys_usr set Flags = (' + #39 +
               //   lsFlags + #39 + ')' + ' where usr_name = "' + Name + '"';
               //DbX(lsSql);
            end
            else
               ErrorMsg('AddUser', _('Fehler beim Zugriff auf Usertabelle'), 2010, True);
         end
         else
         begin
            Result := lmq.FieldByName('Usr_id').AsInteger;
         end;
      end
         else
            ErrorMsg('AddUser', _('Fehler beim Zugriff auf Usertabelle'), 2010, True);
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Updated die Mail und Flag from_ad. User muss schon da sein.
procedure DbUserUpdateMail(Name, Mail: string; isAd: Boolean);
var lmq: TMyQuery;  lsSql, lsFlags:string;
begin
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_usr where Usr_Name = ' +
         #39 + Name + #39 + ' and sys_usr.Flags <> ' + #39 + 'deleted' + #39;
      if DbDoSql(lmq, lsSql) then
         begin
            lsFlags := lmq.FieldByName('Flags').AsString;  //sys_usr.Flags
            if isAd then
               lsFlags := AddWithComma(lsFlags,'from_ad');
            lmq.Edit;
            lmq.FieldByName('Usr_Mail').AsString := Mail;
            lmq.FieldByName('Flags').AsString := lsFlags;
            lmq.Post;
         end
      else
         ErrorMsg('DbUserUpdateMail', _('User existiert nicht'), 2010, True);
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
procedure DbDelUserName(Name:string; NurAd: Boolean);
var lsSqlWhere, lsUsrId: string;
begin
   if NurAd then
      lsUsrId := DbAdUserIdS(Name)
   else
      lsUsrId := DbUserIdS(Name);
   if lsUsrId = '0' then
      Exit;

   lsSqlWhere := ' where (usr_id = ' + lsUsrId + ')';

   DbX('update sys_usr set flags = ' + #39 + 'deleted' + #39 + ', USR_NAME = ' + #39 + //sys_usr.Flags
      'del_' + Name + #39 + lsSqlWhere);
      
   DbX('delete from sys_grpusr'+ lsSqlWhere);

   // [ 1920 ] DEL_User sollten auch aus Gruppen und Wiedervorlagen entfernt werden. 
   DbX('update sys_timer set status = 2 ' +
       'where (usr_id_work = ' + lsUsrId + ') or (usr_id_shed = ' + lsUsrId + ')');
end;

//-----------------------------------------------------------------------------
(* //3.5.0.36 [2390]
// gibt die Grpp_id zurck anhand dem Namen - Rckgabe als int
function DbGroupIdI(Name: string):int64;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := 0;
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_grp where Grp_Name = ' +
         #39 + Name + #39;
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('grp_id').AsInteger;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// gibt die Grpp_id zurck anhand dem Namen - Rckgabe als String
function DbGroupIdS(Name: string):string;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_grp where Grp_Name = ' +
         #39 + Name + #39;
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('grp_id').AsString;
      end;
   finally
      lmq.Free;
   end;
end;
*)

//-----------------------------------------------------------------------------
// Legt eine Gruppe an.
// Rckgabewert ist die grp_id
function DbAddGroup(Name: string):int64;
var lsSql:string;
begin
   Result := 0;
   lsSql := 'Insert into sys_grp (grp_name, Login_right) Values(' + #39 + Name + #39 + ', 1)';
   if DbX(lsSql) then
   begin
      Result := LastInsertId;
   end
   else
      ErrorMsg('DbAddGroup', _('Fehler beim Anlegen einer Gruppe:'), 1006, True);
end;

//-----------------------------------------------------------------------------
procedure DbAddUserToGroup(UserName, GroupName: string);
var lsSql:string;  UsrId, GrpId: string;  iCount: integer;
begin
   UsrId := DbUserIdS(UserName);
   if UsrId = '' then
      begin
         ErrorMsg('DbAddUserToGroup',
            Format(_('Kann Benutzer %s nicht finden'),[UserName]), 4100, True);
         Exit;
      end;

   GrpId := DbGroupIdS(GroupName);
   if GrpId = '' then
      begin
         ErrorMsg('DbAddUserToGroup',
            Format(_('Kann Gruppe %s nicht finden'),[GroupName]), 4101, True);
         Exit;
      end;

   lsSql := 'from sys_grpusr where (grp_id='+GrpId+') and (usr_id='+UsrId+')';
   iCount := DbCountSql(lsSql);
   if iCount>0 // User gehrt schon zur Gruppe
   then Exit;
   try
      DbX('insert into sys_grpusr (grp_id, usr_id) Values (' + GrpId + ', ' + UsrId + ')');
   except
      on e: exception do
         ErrorMsg('DbAddUserToGroup', _('Fehler beim Hinzufgen eines Benutzers in eine Gruppe:')+' ' + e.Message, 1002, True);
   end;
   
   SetGrpUsrRights( StrToInt(UsrID), StrToInt(GrpID) ); //3.5.0.22 [2403]
end;

//-----------------------------------------------------------------------------
procedure DbDelUserFromGroup(UserName, GroupName: string);
var UsrId, GrpId: string; 
begin
   UsrId := DbUserIdS(UserName);
   GrpId := DbGroupIdS(GroupName);

   try
      // ich weiss nicht wer sich diesen mist ausgedacht hat, aber ich bekomme diese query nicht ausgefhrt (mysql.5.1)
      //  f.schneider  v3.5.0.42
      //DbX('delete from sys_grpusr (grp_id, usr_id) Values (' + GrpId + ', ' + UsrId + ')');
      DbX('delete from sys_grpusr where (grp_id=' + GrpId + ' and usr_id='+ UsrId + ')');
   except
      on e: exception do
         ErrorMsg('DbDelUserFromGroup', _('Fehler beim Entfernen eines Benutzers aus einer Gruppe:')+' ' + e.Message, 1002, True);
   end;

   RemGrpUsrRights( StrToInt(UsrID), StrToInt(GrpID) ); //3.5.0.22 [2403]
end;

//-----------------------------------------------------------------------------
// Fllt eine Liste mit allen Gruppen. 
procedure GetGroupList(List:TStrings);
var lmq: TMyQuery;  lsSql:string;
begin
   GgfLogEvntBeg('GetGroupList beg');
   List.Clear;
   lmq := DbCreateQuery;
   try
      lsSql := 'Select * from sys_grp order by Grp_Name';
      if DbDoSql(lmq, lsSql) then
         while not lmq.Eof do
         begin
            List.Add(lmq.FieldByName('Grp_Name').AsString);
            GgfLogEvnt('GetGroupList Add :'+lmq.FieldByName('Grp_Name').AsString);
            lmq.Next;
         end
      else
         ErrorMsg('CreateGroupList', _('Fehler beim Einlesen der Gruppen.'), 2001, True);
   finally
      lmq.Free;
   end;
   GgfLogEvntEnd('GetGroupList end');
end;

//-----------------------------------------------------------------------------
// gibt eine Liste alle Gruppen zurck. Fr Free ist Aufrufer verantwortlich
function CreateGroupList:TStringList;
begin
   Result := TStringList.Create;
   GetGroupList(Result);
end;

//-----------------------------------------------------------------------------
// Fllt eine Liste mit allen Usern.
procedure GetUserList(List:TStrings);
var lmq: TMyQuery;  lsSql:string;
begin
   List.Clear;
   lmq := DbCreateQuery;
   try
      lsSql := 'Select * from sys_usr where sys_usr.Flags <> ' + #39 + 'deleted' + #39 + ' and sys_usr.Flags <> ' + #39 + #39 + ' Order By usr_name';
      if DbDoSql(lmq, lsSql) then
         while not lmq.Eof do
         begin
            List.Add(lmq.FieldByName('Usr_Name').AsString);
            lmq.Next;
         end
      else
         ErrorMsg('GetUserList', _('Fehler beim Einlesen der User.'), 2001, True);
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Fllt eine Liste mit allen Usern.
procedure DbGetUserInfo(Names, Mails, Ad:TStrings);
var lmq: TMyQuery;  lsSql, ls:string;
begin
   Names.Clear; Mails.Clear; Ad.Clear;
   lmq := DbCreateQuery;
   try
      lsSql := 'Select * from sys_usr where flags <> ' + #39 + 'deleted' + #39 + ' and Flags <> ' + #39 + #39 + ' Order By usr_name';
      if DbDoSql(lmq, lsSql) then
         while not lmq.Eof do
         begin
            if Assigned(Names) then
            Names.Add(lmq.FieldByName('Usr_Name').AsString);
            if Assigned(Mails) then
            Mails.Add(lmq.FieldByName('Usr_Mail').AsString);

            if Assigned(Ad) then
            begin
               ls := lmq.FieldByName('Flags').AsString; //sys_usr.Flags
               if Pos('from_ad',ls)<>0 then
                 ls := cDbTrue
               else
                 ls := cDbFalse;
               Ad.Add(ls);
            end;

            lmq.Next;
         end
      else
      begin
         ErrorMsg('DbGetUserInfo', _('Fehler beim Einlesen der User.'), 2001, True);
         LogEvnt('DbGetUserInfo: Fehler beim Einlesen der User. (2001)' + #13 +#10 + lsSql);
      end;

   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// gibt eine Liste alle User zurck. Fr Free ist Aufrufer verantwortlich
function CreateUserList:TStringList;
begin
   Result := TStringList.Create;
   GetUserList(Result);
end;

//-----------------------------------------------------------------------------
// Gibt eine Liste der User einer Gruppe zurck. Fr Free ist Aufrufer verantwortlich
procedure GetGroupUserList(Group:string; Users,Mails,Ad:TStrings);
var lmq: TMyQuery;  ls, lsSql, lsGrpid: string;
begin
   Users.Clear; Mails.Clear; Ad.Clear;
   lmq := DbCreateQuery;
   try
      lsSql := 'Select * from sys_grp where Grp_Name = ' + #39 + Group + #39 + ' Order By Grp_Name';
      if DbDoSql(lmq, lsSql) then
         if not lmq.Eof then
            lsGrpid := lmq.FieldByName('Grp_Id').AsString
         else
         begin
            // Wenn keine Gruppe da dann ist die halt noch nicht angelegt.
            // ErrorMsg('GetGroupUserList', _('Fehler beim Einlesen der Gruppe.'), 2001, True);
            Exit;
         end
      else
      begin
        ErrorMsg('GetGroupUserList', _('Fehler beim Einlesen der Gruppe.'), 4101, True);
        LogEvnt('GetGroupUserList: Fehler beim Einlesen der Gruppe. (4101)' + #13 +#10 + lsSql);
        Exit;
      end;
      // in lsGrpid ist nun die Gruppen-ID
      //[2609]
      lsSql := 'select sys_usr.USR_ID, GRP_ID, USR_NAME, USR_MAIL, Flags ' + //sys_usr.Flags
               'from sys_grpusr ' +
               'join sys_usr using (usr_id) ' +
               'where (grp_id = ' + lsGrpid + ') And sys_usr.usr_name not like ' + #39 +'del_%'+#39;
      if DbDoSql(lmq, lsSql) then
         while not lmq.Eof do
         begin
            Users.Add(lmq.FieldByName('Usr_Name').AsString);
            Mails.Add(lmq.FieldByName('Usr_Mail').AsString);
            if Assigned(Ad) then
            begin
               ls := lmq.FieldByName('Flags').AsString; //sys_usr.Flags
               if Pos('from_ad',ls)<>0 then
                 ls := cDbTrue
               else
                 ls := cDbFalse;
               Ad.Add(ls);
            end;
            lmq.Next;
         end
      else
      begin
         ErrorMsg('GetGroupUserList', _('Fehler beim Einlesen der User.'), 4102, True);
         LogEvnt('GetGroupUserList: Fehler beim Einlesen der User. (4102)' + #13 +#10 + lsSql);
      end;

   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// wird fr die nchsten zwei gebraucht
function TMPSQLSetGrpUsr(SQLCMD: String): boolean;
begin
   try
      result := True;
      dm_mainform.my_q_SetGrpUsr.Active := False;
      dm_mainform.my_q_SetGrpUsr.SQL.Text := SQLCMD;
      dm_mainform.my_q_SetGrpUsr.Active := True;
      dm_mainform.my_q_SetGrpUsr.First;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: GrpSQL    ' + e.message);
         result := False;
      end;
   end;
end;

//-----------------------------------------------------------------------------
//3.5.0.22 [2403]
procedure SetGrpUsrRights(USR_ID, GRP_ID: Integer);
var TmpArcID, TmpDocID, TmpRights, TmpValues: String;
begin
   If TMPSQLSetGrpUsr('Select * from sys_arcxs where usr_ID = 0 and grp_id = ' + IntToStr(grp_id)) then
   begin
      if dm_mainform.my_q_SetGrpUsr.RecordCount <> 0 then
      begin
         while not dm_mainform.my_q_SetGrpUsr.Eof do
         begin
            TmpArcID := IntToStr(dm_mainform.my_q_SetGrpUsr.FieldByName('arc_id').AsInteger);
            TmpRights := dm_mainform.my_q_SetGrpUsr.FieldByName('Rights').AsString;
            TmpValues := TmpValues + '(' + TmpArcID + ',' + IntToStr(Usr_ID) + ',' + IntToStr(Grp_ID) + ',' + #39 + TmpRights + #39 + '),';
            dm_mainform.my_q_SetGrpUsr.Next;
         end;
         try
            DbX('insert into sys_arcxs (arc_id, usr_id, grp_id, rights) Values ' + Copy(TmpValues, 1, Length(TmpValues) - 1));
         except
            on e: exception do
            begin
               ErrorMsg('SetGrpUsrRights', _('Fehler beim Setzen der Archivberechtigungen:')+' ' + e.Message, 1002, True);
               exit;
            end;
         end;
      end;
   end
   else ErrorMsg('SetGrpUsrRights', _('Fehler beim Auslesen der Gruppen'), 2017, True);
   TmpValues := '';
   If TMPSQLSetGrpUsr('Select * from sys_docxs where usr_ID = 0 and grp_id = ' + IntToStr(grp_id)) then
   begin
      while not dm_mainform.my_q_SetGrpUsr.Eof do
      begin
         TmpArcID := IntToStr(dm_mainform.my_q_SetGrpUsr.FieldByName('arc_id').AsInteger);
         TmpDocID := IntToStr(dm_mainform.my_q_SetGrpUsr.FieldByName('doc_id').AsInteger);
         TmpRights := dm_mainform.my_q_SetGrpUsr.FieldByName('Rights').AsString;
         TmpValues := TmpValues + '(' + TmpArcID + ',' + TmpDocID + ',' + IntToStr(Usr_ID) + ',' + IntToStr(Grp_ID) + ',' + #39 + TmpRights + #39 + '),';
         dm_mainform.my_q_SetGrpUsr.Next;
      end;
      try
         if TmpValues <> '' then
         begin
            DbX('insert into sys_docxs (arc_id, doc_id, usr_id, grp_id, rights) Values ' + Copy(TmpValues, 1, Length(TmpValues) - 1));
         end;
      except
         on e: exception do
         begin
            ErrorMsg('SetGrpUsrRights', _('Fehler beim Setzen der Dokumentenberechtigungen:')+' ' + e.Message, 1002, True);
            exit;
         end;
      end;
   end
   else ErrorMsg('SetGrpUsrRights', _('Fehler beim Auslesen der Gruppen'), 2017, True);
   If TMPSQLSetGrpUsr('Select * from sys_arc  where type = 1') then
   begin
      dm_mainform.my_q_SetGrpUsr.first;
      while not dm_mainform.my_q_SetGrpUsr.Eof and (dm_mainform.my_q_SetGrpUsr.recordcount > 0) do
      begin
         //set zusatzfield rights
         try
            dm_mainform.my_q_SetGrpUsr2.SQL.text := 'show tables like "cfgxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring + '"';
            dm_mainform.my_q_SetGrpUsr2.execute;
            if dm_mainform.my_q_SetGrpUsr2.recordcount > 0 then
            begin
               dm_mainform.my_q_SetGrpUsr2.SQL.text := 'select * from cfgxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring +
                  ' where grp_id =' + inttostr(grp_id) + ' group by cfg_id';
               dm_mainform.my_q_SetGrpUsr2.execute;
               while not dm_mainform.my_q_SetGrpUsr2.eof and (dm_mainform.my_q_SetGrpUsr2.recordcount > 0) do
               begin
                  dm_mainform.my_q_SetGrpUsr3.sql.Text := 'insert into  cfgxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring +
                     ' (cfg_id,usr_id,grp_id) values (' + dm_mainform.my_q_SetGrpUsr2.fieldbyname('cfg_id').asstring + ',' +
                     inttostr(USR_ID) + ',' + dm_mainform.my_q_SetGrpUsr2.fieldbyname('grp_id').asstring + ')';
                  dm_mainform.my_q_SetGrpUsr3.execute;

                  dm_mainform.my_q_SetGrpUsr2.next;
               end;
            end;
         except on e: exception do
            begin
            end;
         end;
         //set statusfield rights
         try
            dm_mainform.my_q_SetGrpUsr2.SQL.text := 'show tables like "stsxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring + '"';
            dm_mainform.my_q_SetGrpUsr2.execute;
            if dm_mainform.my_q_SetGrpUsr2.recordcount > 0 then
            begin
               dm_mainform.my_q_SetGrpUsr2.SQL.text := 'select * from stsxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring +
                  ' where grp_id =' + inttostr(grp_id) + ' group by sts_id';
               dm_mainform.my_q_SetGrpUsr2.execute;
               while not dm_mainform.my_q_SetGrpUsr2.eof and (dm_mainform.my_q_SetGrpUsr2.recordcount > 0) do
               begin
                  dm_mainform.my_q_SetGrpUsr3.sql.Text := 'insert into  stsxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring +
                     ' (sts_id,usr_id,grp_id) values (' + dm_mainform.my_q_SetGrpUsr2.fieldbyname('sts_id').asstring + ',' +
                     inttostr(USR_ID) + ',' + dm_mainform.my_q_SetGrpUsr2.fieldbyname('grp_id').asstring + ')';
                  dm_mainform.my_q_SetGrpUsr3.execute;

                  dm_mainform.my_q_SetGrpUsr2.next;
               end;
            end;
         except on e: exception do
            begin
            end;
         end;
         dm_mainform.my_q_SetGrpUsr.Next;
      end;
   end;

   //set wvl
end;

//3.5.0.22 [2403]
procedure RemGrpUsrRights(USR_ID, GRP_ID: Integer);
begin
   try
      DbX('delete from sys_arcxs where usr_id = ' + IntToStr(Usr_ID) + ' and grp_id = ' + IntToStr(Grp_ID));
   except
      on e: exception do
      begin
         ErrorMsg('SetGrpUsrRights', _('Fehler beim Lschen der Archivberechtigungen:')+' ' + e.Message, 1001, True);
         exit;
      end;
   end;
   try
      DbX('delete from sys_docxs where usr_id = ' + IntToStr(Usr_ID) + ' and grp_id = ' + IntToStr(Grp_ID));
   except
      on e: exception do
      begin
         ErrorMsg('SetGrpUsrRights', _('Fehler beim Lschen der Archivberechtigungen:')+' ' + e.Message, 1001, True);
         exit;
      end;
   end;
   If TMPSQLSetGrpUsr('Select * from sys_arc where type = 1') then
   begin
      dm_mainform.my_q_SetGrpUsr.first;
      while not dm_mainform.my_q_SetGrpUsr.Eof and (dm_mainform.my_q_SetGrpUsr.recordcount > 0) do
      begin
         //delete zusatzfield rights
         try
            dm_mainform.my_q_SetGrpUsr2.SQL.text := 'show tables like "cfgxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring + '"';
            dm_mainform.my_q_SetGrpUsr2.execute;
            if dm_mainform.my_q_SetGrpUsr2.recordcount > 0 then
            begin
               dm_mainform.my_q_SetGrpUsr2.SQL.text := 'delete from cfgxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring +
                  ' where usr_id =' + inttostr(usr_id);
               dm_mainform.my_q_SetGrpUsr2.execute;
            end;
         except on e: exception do
            begin
            end;
         end;
         //delete statusfield rights
         try
            dm_mainform.my_q_SetGrpUsr2.SQL.text := 'show tables like "stsxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring + '"';
            dm_mainform.my_q_SetGrpUsr2.execute;
            if dm_mainform.my_q_SetGrpUsr2.recordcount > 0 then
            begin
               dm_mainform.my_q_SetGrpUsr2.SQL.text := 'delete from stsxs_' + dm_mainform.my_q_SetGrpUsr.fieldbyname('arc_tblname').asstring +
                  ' where usr_id =' + inttostr(usr_id);
               dm_mainform.my_q_SetGrpUsr2.execute;
            end;
         except on e: exception do
            begin
            end;
         end;
         dm_mainform.my_q_SetGrpUsr.Next;
      end;
   end;
   //remove wvl
end;

//-----------------------------------------------------------------------------
begin
end.

//-----------------------------------------------------------------------------