unit u_StatusFields;

interface

uses
   gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls,
   u_ShLowUtils;

type
   Tfrm_StsFields = class (TForm)
      lv_Status: TListView;
      edt_StsName: TEdit;
      cbx_ZusLink: TComboBox;
      cbx_ZusVal: TComboBox;
      lbl_StsName: TLabel;
      lbl_ZusLink: TLabel;
      lbl_ZusVal: TLabel;
      btn_New: TButton;
      btn_Change: TButton;
      btn_Delete: TButton;
      btn_Close: TButton;
      procedure btn_NewClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure cbx_ZusLinkChange(Sender: TObject);
      procedure lv_StatusSelectItem(Sender: TObject; Item: TListItem;
         Selected: Boolean);
      procedure btn_DeleteClick(Sender: TObject);
      procedure btn_ChangeClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
      procedure ReadSts;
      procedure ReadZus;
   public
      { Public-Deklarationen }
   end;

var
   frm_StsFields: Tfrm_StsFields;

implementation

{$R *.dfm}
uses u_MainForm, u_dm_mainform;

procedure Tfrm_StsFields.ReadSts;
var li_Item: TListItem;
begin
   edt_StsName.Text := '';
   cbx_ZusLink.ItemIndex := 0;
   cbx_ZusVal.ItemIndex := 0;
   cbx_ZusVal.Enabled := False;
   lv_Status.Clear;
   try
      try
         with dm_MainForm.my_qry_Grp do
         begin
            Close;
            SQL.Text := 'select * from sts_' + GArcTblName + ' order by sts_id';
            Open;
            while not eof do
            begin
               li_Item := lv_Status.Items.Add;
               li_Item.Data := TObject(FieldByName('sts_id').AsInteger);
               li_Item.Caption := FieldByName('sts_Name').AsString;
               li_Item.SubItems.Add(FieldByName('sts_ZusName').AsString);
               case FieldByName('sts_Func').AsInteger of
                  0:
                     li_Item.SubItems.Add(_('Uhrzeit'));
                  1:
                     li_Item.SubItems.Add(_('Datum'));
                  2:
                     li_Item.SubItems.Add(_('Zeitstempel'));
                  3:
                     li_Item.SubItems.Add(_('Benutzername'));
                  4:
                     li_Item.SubItems.Add(_('Benutzer + Zeitstempel'));
                  255:
                     li_Item.SubItems.Add('-');
               else
                  li_Item.SubItems.Add(_('Zeitstempel'));
               end;
               //          lv_Status.Items.AddItem(li_Item, -1);
               next;
            end;
            Close;
         end;
      except
         on e: exception do
            ErrorMsg('ReadSts', _('Fehler beim Erstellen von Listeneintrgen:')+' ' + e.Message, 2000, True);
      end;
   finally

   end;
end;

procedure Tfrm_StsFields.ReadZus;
begin
   cbx_ZusLink.Clear;
   cbx_ZusLink.Items.Add(_('keinem Feld'));
   try
      with dm_MainForm.my_qry_Grp do
      begin
         Close;
         SQL.Text := 'select * from cfg_' + GArcTblName;
         Open;
         while not eof do
         begin
            cbx_ZusLink.Items.AddObject(dm_MainForm.my_qry_Grp.FieldByName('Disp_Name').AsString,
               TObject(dm_MainForm.my_qry_Grp.FieldByName('cfg_id').AsInteger));
            Next;
         end;
         Close;
         cbx_ZusLink.ItemIndex := 0;
      end;
   except
      on e: exception do
         ErrorMsg('ReadZus', _('Fehler beim Einlesen der Zusatzfelder')+': ' + e.Message, 2000, True);
   end;
end;

procedure Tfrm_StsFields.btn_NewClick(Sender: TObject);
var sZusFeld: String;
   iZusLink, iZusFunc: integer;
begin
   try
      iZusLink := 0;     // Keine Verknpfung
      iZusFunc := 255;   // Keine Funktion
      if cbx_ZusLink.ItemIndex > 0 then
      begin
         iZusLink := Integer(cbx_ZusLink.Items.Objects[cbx_ZusLink.ItemIndex]);
         iZusFunc := cbx_ZusVal.ItemIndex;
         with dm_MainForm.my_qry_Grp do
         begin
            Close;
            sql.Text := 'select * from cfg_' + GArcTblName + ' where cfg_id = ' + IntToStr(iZusLink);
            Open;
            sZusFeld := FieldByName('feld_name').AsString;
            Close;
         end;
      end
      else sZusFeld := '-';
      with dm_MainForm.my_Cmd do
      begin
         sql.Text := 'Insert into sts_' + GArcTblName + ' (sts_name, sts_zusfeld, sts_ZusFeldID, sts_ZusName, sts_Func) ' +
            'Values ( :stsname, :stszusfeld, :stszusfeldid, :stszusname, :stsfunc )';
         ParamByName('stsname').AsString := edt_StsName.Text;
         ParamByName('stszusfeld').AsString := sZusFeld;
         ParamByName('stszusfeldid').AsInteger := iZusLink;
         ParamByName('stszusname').AsString := cbx_ZusLink.Text;
         ParamByName('stsfunc').AsInteger := iZusFunc;
         Execute;
      end;
      ReadSts;
   except

   end;
end;

procedure Tfrm_StsFields.FormShow(Sender: TObject);
begin
   ReadSts;
   ReadZus;
end;

procedure Tfrm_StsFields.cbx_ZusLinkChange(Sender: TObject);
begin
   if cbx_ZusLink.ItemIndex = 0 then
      cbx_ZusVal.Enabled := False else cbx_ZusVal.Enabled := True;
end;

procedure Tfrm_StsFields.lv_StatusSelectItem(Sender: TObject;
   Item: TListItem; Selected: Boolean);
begin
   if Selected then
   begin
      with dm_MainForm.my_qry_Grp do
      begin
         Close;
         sql.Text := 'select * from sts_' + GArcTblName + ' where sts_id = ' + IntToStr(Integer(item.Data));
         Open;
         if RecordCount > 0 then
         begin
            edt_StsName.Text := FieldByName('sts_Name').AsString;
            cbx_ZusLink.ItemIndex := cbx_ZusLink.Items.IndexOfObject(TObject(FieldByName('sts_ZusFeldID').AsInteger));
            case FieldByName('sts_func').AsInteger of
               1..254:
               begin
                  cbx_ZusVal.ItemIndex := FieldByName('sts_func').AsInteger;
                  cbx_ZusVal.Enabled := True;
               end;
            else
            begin
               cbx_ZusVal.ItemIndex := 0;
               cbx_ZusVal.Enabled := False;
            end;
            end;
         end;
      end;
   end;
end;

procedure Tfrm_StsFields.btn_DeleteClick(Sender: TObject);
var li_Item: TListItem;
begin
   if lv_Status.SelCount > 0 then
   begin
      li_Item := lv_Status.Selected;
      with dm_MainForm.my_cmd do
      begin
         sql.Text := 'delete from sts_' + GArcTblName + ' where sts_id = :stsID ';
         ParamByName('stsID').AsInteger := Integer(li_Item.Data);
         Execute;
      end;
      ReadSts;
   end;
end;

procedure Tfrm_StsFields.btn_ChangeClick(Sender: TObject);
var li_Item: TListItem;
   sZusFeld: String;
   iZusLink, iZusFunc: integer;
begin
   if lv_Status.SelCount > 0 then
   begin
      try
         iZusLink := 0;     // Keine Verknpfung
         iZusFunc := 255;   // Keine Funktion
         li_Item := lv_Status.Selected;
         if cbx_ZusLink.ItemIndex > 0 then
         begin
            iZusLink := Integer(cbx_ZusLink.Items.Objects[cbx_ZusLink.ItemIndex]);
            iZusFunc := cbx_ZusVal.ItemIndex;
            with dm_MainForm.my_qry_Grp do
            begin
               Close;
               sql.Text := 'select * from cfg_' + GArcTblName + ' where cfg_id = ' + IntToStr(iZusLink);
               Open;
               sZusFeld := FieldByName('feld_name').AsString;
               Close;
            end;
         end
         else sZusFeld := '-';
         with dm_MainForm.my_Cmd do
         begin
            sql.Text := 'Update sts_' + GArcTblName + ' set sts_name = :stsname , sts_zusfeld = :stszusfeld , ' +
               'sts_ZusFeldID = :stszusfeldid , sts_ZusName = :stszusname , sts_Func = :stsfunc ' +
               'where sts_id = :stsid ';
            ParamByName('stsname').AsString := edt_StsName.Text;
            ParamByName('stszusfeld').AsString := sZusFeld;
            ParamByName('stszusfeldid').AsInteger := iZusLink;
            ParamByName('stszusname').AsString := cbx_ZusLink.Text;
            ParamByName('stsfunc').AsInteger := iZusFunc;
            ParamByName('stsid').AsInteger := Integer(li_Item.Data);
            Execute;
         end;
         ReadSts;
      except

      end;
   end;
end;

procedure Tfrm_StsFields.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

end.
