unit u_dm_mainform;

interface

uses
   SysUtils, Classes, DB, MemDS, DBAccess, MyAccess, MyServerControl,
   shellapi, gnugettext,
   u_ShLowUtils, u_ShDbUtils;

type
   Tdm_mainform = class (TDataModule)
    ds_Wvl: TMyDataSource;
      ds_Arc: TDataSource;
      ds_LgrArc: TDataSource;
      ds_MyCtrl: TDataSource;
      ds_Usr: TDataSource;
      ds_usrTree: TDataSource;
      ds_usrsuptree: TMyDataSource;
      my_Cmd: TMyCommand;
      my_Con: TMyConnection;
      my_Ctrl: TMyServerControl;
      my_q_Grp_all: TMyQuery;
      my_q_Grp_selected: TMyQuery;
      my_q_SetGrpUsr2: TMyQuery;
      my_q_SetGrpUsr3: TMyQuery;
      my_q_SetGrpUsr: TMyQuery;
      my_q_grp_all_sz: TMyQuery;
      my_q_grp_selected_sz: TMyQuery;
      my_q_infe: TMyQuery;
      my_q_tmp2: TMyQuery;
      my_q_tmp3: TMyQuery;
      my_q_tmp4: TMyQuery;
      my_q_tmp5: TMyQuery;
      my_q_tmp: TMyQuery;
      my_q_urlauber: TMyQuery;
      my_q_usr_all: TMyQuery;
      my_q_usr_all_sz: TMyQuery;
      my_q_usr_selected: TMyQuery;
      my_q_usr_selected_sz: TMyQuery;
      my_q_usrsuptree: TMyQuery;
      my_q_vertretung: TMyQuery;
      my_q_vertretungava: TMyQuery;
      my_q_vorgeava: TMyQuery;
      my_q_vorgesetzte: TMyQuery;
      my_q_wvl: TMyQuery;
      my_qry_Arc: TMyQuery;
      my_qry_Grp: TMyQuery;
      my_qry_LgrArc: TMyQuery;
      my_qry_Usr: TMyQuery;
      my_qry_UsrTree: TMyQuery;
      procedure my_ConAfterConnect(Sender: TObject);
      procedure my_ConAfterDisconnect(Sender: TObject);
      procedure DataModuleCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      function UsrSelectedSZ(SQLCMD: String): boolean;
      function UsrSQLALLSZ(SQLCMD: String): boolean;
      function GrpSQLALLSZ(SQLCMD: String): boolean;
      function GrpSQLSelectedSZ(SQLCMD: String): boolean;
      function ShellExecute_AndWait(Operation, FileName, Parameter, //#3.5
         Directory: string; Show: word; bWait: boolean): longint; //#3.5
      { Public-Deklarationen }
   end;

var
   dm_mainform: Tdm_mainform;

implementation

uses u_mainform, windows, forms;
{$R *.dfm}


//-----------------------------------------------------------------------------
function Tdm_MainForm.GrpSQLSelectedSZ(SQLCMD: String): boolean;
begin
   try
      result := True;
      dm_mainform.my_q_Grp_selected_sz.Active := False;
      dm_mainform.my_q_Grp_selected_sz.SQL.Text := SQLCMD;
      dm_mainform.my_q_Grp_selected_sz.Active := True;
      dm_mainform.my_q_Grp_selected_sz.First;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: GrpSQLSelectedSZ    ' + e.message);
         result := False;
      end;
   end;
end;

function Tdm_MainForm.GrpSQLALLSZ(SQLCMD: String): boolean;
begin
   try
      result := True;
      dm_mainform.my_q_Grp_all_sz.Active := False;
      dm_mainform.my_q_Grp_all_sz.SQL.Text := SQLCMD;
      dm_mainform.my_q_Grp_all_sz.Active := True;
      dm_mainform.my_q_Grp_all_sz.First;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: GrpSQLALLSZ    ' + e.message);
         result := False;
      end;
   end;
end;

function Tdm_MainForm.UsrSQLALLSZ(SQLCMD: String): boolean;
begin
   try
      result := True;
      dm_mainform.my_q_usr_all_sz.Active := False;
      dm_mainform.my_q_usr_all_sz.SQL.Text := SQLCMD;
      dm_mainform.my_q_usr_all_sz.Active := True;
      dm_mainform.my_q_usr_all_sz.First;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: UsrSQLALLSZ    ' + e.message);
         result := False;
      end;
   end;
end;

function Tdm_MainForm.UsrSelectedSZ(SQLCMD: String): boolean;
begin
   try
      result := True;
      dm_mainform.my_q_usr_selected_sz.Active := False;
      dm_mainform.my_q_usr_selected_sz.SQL.Text := SQLCMD;
      dm_mainform.my_q_usr_selected_sz.Active := True;
      dm_mainform.my_q_usr_selected_sz.First;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: UsrSelectedSZ    ' + e.message);
         result := False;
      end;
   end;
end;


procedure Tdm_mainform.my_ConAfterConnect(Sender: TObject);

var DBName: String;
begin
   if dm_mainform.my_con.Database = '' then
      DBName := ' nicht aktiv '
   else DBName := dm_mainform.my_con.Database;
   frm_MainForm.stb_MainForm.Panels[0].Text := _('Verbunden mit ') +
      dm_mainform.my_con.Server + _(' als ') + dm_mainform.my_con.Username;
   frm_MainForm.stb_MainForm.Panels[0].Width := 6 * Length(frm_MainForm.stb_MainForm.Panels[0].Text);
   frm_MainForm.stb_MainForm.Panels[2].Text := IntToStr(dm_mainform.my_con.ThreadId);
   frm_MainForm.stb_MainForm.Panels[4].Text := DBName;
   frm_MainForm.stb_MainForm.Panels[6].Text := _('nicht vorhanden');
end;

procedure Tdm_mainform.my_ConAfterDisconnect(Sender: TObject);
begin
   frm_MainForm.stb_MainForm.Panels[0].Text := _('Nicht Verbunden!');
end;


{3.6<}
function Tdm_MainForm.ShellExecute_AndWait(Operation, FileName,
   Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
   bOK: boolean;
   Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
   FillChar(Info, SizeOf(Info), Chr(0));
   Info.cbSize := SizeOf(Info);
   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
   Info.lpVerb := PChar(Operation);
   Info.lpFile := PChar(FileName);
   Info.lpParameters := PChar(Parameter);
   Info.lpDirectory := PChar(Directory);
   Info.nShow := Show;
   bOK := boolean(ShellExecuteEx(@Info));
   if bOK then
   begin
      if bWait then
      begin
         while
            WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
            Application.ProcessMessages;
         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      end
      else
         Result := 0;
   end;
   if not bOK then
      Result := -1;
end;
{>3.6}

procedure Tdm_mainform.DataModuleCreate(Sender: TObject);
begin
   u_ShDbUtils.my_Con := Self.my_Con;
   TranslateComponent(self);
end;

end.
