unit u_vmng;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Mask, JvExMask, JvToolEdit, JvCombobox, inifiles, Spin, gnugettext;

type
   Tfrm_vtrmng = class (TForm)
      lbl_start: TLabel;
      lbl_interval: TLabel;
      lbl_End: TLabel;
      lbl_lasttimeactivated: TLabel;
      cbx_lasttimeactivated: TComboBox;
      lbl_kuendigung: TLabel;
      cbx_end: TComboBox;
      cbx_interval: TComboBox;
      cbx_start: TComboBox;
      btn_save: TButton;
      edt_name: TEdit;
      lbl_name: TLabel;
      btn_cancel: TButton;
      btn_open: TButton;
      lbl_archiv: TLabel;
      lbl_Archivvalue: TLabel;
      lbl_arcid: TLabel;
      lbl_arcidvalue: TLabel;
      cbx_kuendingung: TComboBox;
      lbl_versatz: TLabel;
      spe_versatz: TSpinEdit;
      procedure btn_openClick(Sender: TObject);
      procedure btn_saveClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormCreate(Sender: TObject);
   private
      fstrlfeldname: Tstringlist;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_vtrmng: Tfrm_vtrmng;

implementation

uses u_Mainform, u_dm_mainform;
{$R *.dfm}

{3.6<}
function StrToWords(const InputStr: string): TStringList;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////
   ///  30.09.2006 modifiziert by NG.
   ///
   ///  Diese Function zerlegt einen String in einzelne Worte
   ///  bzw Phrasen und listet diese in einer Stringlist auf.
   ///                                                                                                                        //
   ///  Parameter: InputStr        String mit Suchbegriffen
   ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen
   ///
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////

const
   sTrennZeichen = ',';
var
   iCount, iWortStart, iWortEnde: integer;
   bPhrase: boolean;
   sOP, sWort, slStr: string;
begin
   Result := TStringList.Create;
   Result.Clear;
   iWortStart := 0;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   sOP := '';
   // trim the input!
   slStr := trim(InputStr);
   while iCount <= Length(slStr) do
   begin
      if IsDelimiter('"', slStr, iCount) then
      begin
         if not bPhrase then
         begin
            bPhrase := True;
            iWortStart := iCount + 1;
            if IsDelimiter('+-*', slStr, iCount - 1) then
               sOp := slStr[iCount - 1]
            else
               sOp := '';
         end
         else
            bPhrase := False;
      end;
      if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount - 1;
            sWort := Trim(StringReplace(Copy(slStr, iWortStart,
               iWortEnde - iWortStart), '"', '', [rfReplaceAll]));
            if ((Length(trim(sWort)) >= 1) and (not IsDelimiter('+-*', sWort, 1) or
               (Length(trim(sWort)) > 1))) then
               Result.Add(sOP + sWort);
            iWortStart := iWortEnde + 2;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart <= iWortEnde then
      Result.Add(sOP + Trim(StringReplace(Copy(slStr, iWortStart, 1 +
         iWortEnde - iWortStart), '"', '', [rfReplaceAll])));
end;
{>3.6}


procedure Tfrm_vtrmng.btn_openClick(Sender: TObject);
const
   sFileTypes = 'mwl Dateien|*.mwl';
var
   sFileName: string;
   linimwvl: Tinifile;
   liarcid: integer;
begin
   {lbvalue := }PromptForFileName(sFileName, sFileTypes,
      '', 'Datei ffnen...',
      '', False);
   linimwvl := tinifile.create(sFileName);
   if linimwvl.ValueExists('Info', 'archivID') then
      liarcid := linimwvl.ReadInteger('Info', 'archivID', 0)
   else liarcid:=0;
   lbl_Archivvalue.caption := frm_mainform.cbx_ArcName.Items.Strings[frm_mainform.cbx_ArcName.Items.IndexOfObject(TObject(Integer(liarcid)))];
   lbl_arcidvalue.caption := inttostr(liarcid);
   edt_name.text := copy(sFileName, 1, length(sFileName) - 4);
   if liarcid <> GArcID then
   begin
      lbl_archivvalue.caption := 'ngultiges Archiv';
   end;
   if linimwvl.ValueExists('Info', 'Start') then
      cbx_start.itemindex := cbx_start.Items.IndexOf(linimwvl.ReadString('Info', 'Start', ''));
   if cbx_start.itemindex = -1 then
   begin
      cbx_start.text := linimwvl.ReadString('Info', 'Start', '');
   end;
   if linimwvl.ValueExists('Info', 'Interval') then
      cbx_Interval.itemindex := cbx_Interval.Items.IndexOf(linimwvl.ReadString('Info', 'Interval', ''));
   if cbx_Interval.itemindex = -1 then
   begin
      cbx_Interval.text := linimwvl.ReadString('Info', 'Interval', '');
   end;
   if linimwvl.ValueExists('Info', 'End') then
      cbx_End.itemindex := cbx_start.Items.IndexOf(linimwvl.ReadString('Info', 'End', ''));
   if cbx_End.itemindex = -1 then
   begin
      cbx_End.text := linimwvl.ReadString('Info', 'End', '');
   end;
   if linimwvl.ValueExists('Info', 'lasttimeactivated') then
      cbx_lasttimeactivated.itemindex := cbx_start.Items.IndexOf(linimwvl.ReadString('Info', 'lasttimeactivated', ''));
   if cbx_lasttimeactivated.itemindex = -1 then
   begin
      cbx_lasttimeactivated.text := linimwvl.ReadString('Info', 'lasttimeactivated', '');
   end;

   if linimwvl.ValueExists('Info', 'kuendingung') then
      cbx_kuendingung.itemindex := cbx_start.Items.IndexOf(linimwvl.ReadString('Info', 'kuendingung', ''));
   if cbx_kuendingung.itemindex = -1 then
   begin
      cbx_kuendingung.text := linimwvl.ReadString('Info', 'kuendingung', '');
   end;
   if linimwvl.ValueExists('Info', 'versatz') then
   begin
      SPE_VERSATZ.Value := linimwvl.ReadInteger('Info', 'versatz', 0);
   end;


{
     jccbx_users.SetUnCheckedAll;
     if linimwvl.ValueExists('Info', 'users') then
     lsusers    := linimwvl.ReadString('Info', 'users', '');
     lstrlusers:=StrToWords(lsusers);
     for licounter2 := 0 to lstrlusers.count -1 do
     begin
         licounter1:= jccbx_users.Items.IndexOf(lstrlusers.Strings[licounter2]);
         if licounter1 > -1 then
         begin
             jccbx_users.Checked[licounter1]:=true;
         end;
     end;         }
   linimwvl.Free;
end;

procedure Tfrm_vtrmng.btn_saveClick(Sender: TObject);
const
   sFileTypes = 'mwl Dateien|*.mwl';
var
   lbvalue: boolean;
   sFileName: string;
   linimwvl: Tinifile;
   licounter, licounter1: integer;
   lstrl: Tstringlist;
begin
   sFileName := edt_name.text + '.mwl';
   {lbvalue := }PromptForFileName(sFileName, sFileTypes,
      '', 'Datei speichern...',
      '', False);
   if lowercase(ExtractFileExt(sFileName)) <> '.mwl' then
   begin
      ChangeFileExt(sFileName, '.mwl');
   end;
   linimwvl := tinifile.create(sFileName);
   linimwvl.WriteInteger('Info', 'archivID', garcid);
   linimwvl.WriteString('Info', 'start', cbx_start.text);
   linimwvl.WriteString('Info', 'startfeld', fstrlfeldname.strings[cbx_start.itemindex]);
   linimwvl.WriteString('Info', 'interval', cbx_interval.text);
   linimwvl.WriteString('Info', 'intervalfeld', fstrlfeldname.strings[cbx_interval.itemindex]);

   frm_mainform.ArchivSQL('select * from cfg_' + GArcTblName + ' where Feld_name = ' + #39 + fstrlfeldname.strings[cbx_interval.itemindex] + #39 +
      ' order by Pos');
   if dm_mainform.my_qry_Arc.FieldByName('typ').AsInteger <> 5 then
   begin
      dm_mainform.my_qry_Arc.edit;
      dm_mainform.my_qry_Arc.FieldByName('typ').AsInteger := 5;
      dm_mainform.my_qry_Arc.post;
   end;
   linimwvl.WriteString('Info', 'end', cbx_end.text);
   linimwvl.WriteString('Info', 'endfeld', fstrlfeldname.strings[cbx_end.itemindex]);
   linimwvl.WriteString('Info', 'lasttimeactivated', cbx_lasttimeactivated.text);
   linimwvl.WriteString('Info', 'lasttimeactivatedfeld', fstrlfeldname.strings[cbx_lasttimeactivated.itemindex]);
   linimwvl.WriteString('Info', 'kuendingung', cbx_kuendingung.text);
   linimwvl.WriteString('Info', 'kuendingungfeld', fstrlfeldname.strings[cbx_kuendingung.itemindex]);
   linimwvl.WriteString('Info', 'versatz', spe_versatz.Text);
   //    linimwvl.WriteString('Info', 'users',jccbx_users.text);
   linimwvl.Free;

   linimwvl := tinifile.create(ExtractFilePath(sFileName) + 'List.ini');
   lstrl := Tstringlist.create;
   licounter := linimwvl.ReadInteger('Files', 'Counter', 0);
   if licounter <> 0 then
   begin
      linimwvl.ReadSectionValues('Files', lstrl);
      lbvalue := false;
      for licounter1 := 0 to lstrl.Count - 1 do
      begin

         if pos(lowercase(sFileName), lowercase(lstrl.Strings[licounter1])) > 0 then
         begin
            lbvalue := true;
            break;
         end;
      end;
      if lbvalue then
      begin

      end
      else
      begin

         linimwvl.WriteInteger('Files', 'Counter', licounter + 1);
         linimwvl.WriteString('Files', 'Datei' + inttostr(licounter), sFileName);
      end;

   end
   else
   begin

      linimwvl.WriteInteger('Files', 'Counter', licounter + 1);
      linimwvl.WriteString('Files', 'Datei' + inttostr(licounter), sFileName);
   end;

   linimwvl.free;
   close;
end;

procedure Tfrm_vtrmng.FormShow(Sender: TObject);
begin
   fstrlfeldname := Tstringlist.create;
   frm_mainform.ArchivSQL('select * from cfg_' + GArcTblName + ' order by Pos');
   while not dm_mainform.my_qry_Arc.Eof do
   begin
      cbx_start.Items.AddObject(dm_mainform.my_qry_Arc.FieldByName('Disp_Name').AsString,
         TObject(dm_mainform.my_qry_Arc.FieldByName('cfg_id').AsInteger));
      cbx_interval.Items.AddObject(dm_mainform.my_qry_Arc.FieldByName('Disp_Name').AsString,
         TObject(dm_mainform.my_qry_Arc.FieldByName('cfg_id').AsInteger));
      cbx_end.Items.AddObject(dm_mainform.my_qry_Arc.FieldByName('Disp_Name').AsString,
         TObject(dm_mainform.my_qry_Arc.FieldByName('cfg_id').AsInteger));
      cbx_lasttimeactivated.Items.AddObject(dm_mainform.my_qry_Arc.FieldByName('Disp_Name').AsString,
         TObject(dm_mainform.my_qry_Arc.FieldByName('cfg_id').AsInteger));
      cbx_kuendingung.Items.AddObject(dm_mainform.my_qry_Arc.FieldByName('Disp_Name').AsString,
         TObject(dm_mainform.my_qry_Arc.FieldByName('cfg_id').AsInteger));
      fstrlfeldname.add(dm_mainform.my_qry_Arc.FieldByName('Feld_Name').AsString);
      dm_mainform.my_qry_Arc.Next;
   end;

{    for licounter:=0 to  frm_mainform.lv_UsrGrp.Items.Count -1 do
    begin
       jccbx_users.Items.Add( frm_mainform.lv_UsrGrp.Items.Item[licounter].Caption);
    end;}
end;

procedure Tfrm_vtrmng.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   freeandnil(fstrlfeldname);
end;

procedure Tfrm_vtrmng.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

end.
