program AutoScanV3;

//{$APPTYPE CONSOLE}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Aufruf mit Parameter
//  S:\bitfarm-archiv\autoscan.vbs archiv_1 -G:GP_i1220_SW300
//
uses
   SysUtils,
   IniFiles,
   ieview,
   iemview,
   ievect,
   ImageEnIO,
   Printers,
   Registry,
   Controls,
   Messages,
   Dialogs,
   ShellAPI,
   windows, classes, imageenview,
   u_ShBase in '..\Shared\u_ShBase.pas',
   u_ShLowUtils in '..\Shared\u_ShLowUtils.pas',
   u_dm_Main in 'u_dm_Main.pas' {dm_Main: TDataModule};

{$R *.res}



Function  AnsiToConCP(Const AString: String): String;
Var
  lResult: String;
Begin
  SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
  {$ELSE}
  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
  Result := lResult;
End;

Function WriteCmd(strtext: String):STring ;
begin
  strtext:= AnsiToConCP(strtext);
  WriteLN(strtext);
End;




function GetSystemVariable(const Name: String): String;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 06.06.2005 by SV                           ///
   ///                                                       ///
   ///   Liest eine Systemvariable aus                       ///
   ///                                                       ///
   ///   Parameter:  Name          Name der Systemvariable   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Wert der Systemvariable      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   Result := GetEnvironmentVariable(Name);
end;

function GenNewName: String;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 07.06.2005 by SV                           ///
   ///                                                       ///
   ///   Erzeugt einen String mit dem aktuellen Datum und    ///
   ///   der aktuellen Uhrzeit                               ///
   ///                                                       ///
   ///   Parameter:  keine                                   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Datum + Uhrzeit              ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   DateTimeToString(result, 'ddmmyyyyhhnnss', now);
end;


procedure ShowLogo;
begin
   AllocConsole;
   WriteLn('bitfarm Archiv V3 - AutoScan V3');
   WriteLn('(c) 2004 - '+cCurYear+' bitfarm Informationssysteme GmbH [http://www.bitfarm-archiv.de]');
   WriteLn(' ');

end;

procedure WaitForKey;
begin
   Exit;
   WriteLn(' ');
   WriteCMD('Bitte die Enter Taste drcken...');
   ReadLn;
end;


var img: TImageEnMView;
   scan: TIETWainParams;
   //tiff: TIOParamsVals;
   io: TImageEnIO;
   reg: TRegistry;
   sParamType, sProfileName, sTempPath, sTemplate, sFileName, Druckername: String;
   bStacked, useInvers, FiltLeer, bReady, bPageInfo, gbIgnoreTWAINError : Boolean;
   iComp, iCount, liimagecount, liscannedpages, li, button: Integer;
   JobFile: TIniFile;
   lftmp, GFkbleer: double;
   liev: TImageEnView;
   ms: TMemoryStream;

    fMLeft,
    fMRight,
    fMTop,
    fMBottom,
    fSHeight,
    fSWidth,
    fGamma: double;
    ieVPos: TIEVerticalPos;
    ieHPos: TIEHorizontalPos;
    ieSize: TIESize;
    xDocView: TImageEnVect;
    xUseStdPrn, xIdx, iFromPage, iToPage, iPage, status_req, status :Integer;
    i     :Integer;
    bPrintDoc, lbres     :Boolean;
    gIsDocPrinting :Boolean;


function PrintDoc():Boolean;
begin
    Result        := True;
    bPrintDoc     := False;

    try
      if Printer.Printers.Count = 0 then
      begin
        Exit;
      end;

      Printer.PrinterIndex := -1;    // default
      if LowerCase(Druckername) = 'standard' then
         Printer.PrinterIndex := -1
      else
      begin
         for i:= 0 to  Printer.Printers.Count -1  do
         begin
            if LowerCase(Printer.Printers.Strings[i]) = LowerCase(Druckername) then
               Printer.PrinterIndex := i;
         end;
      end;

      // Liefert der Druckertreiber gltige Parameter ?
      if (Printer.PageWidth < 1) or (Printer.PageHeight < 1) then
      begin
         ShowMessage('Der aktuelle Drucker ist nicht mit dem Viewer kompatibel.' +
            #13 + 'Bitte whlen Sie einen anderen Drucker aus oder benutzen' +
            #13 + 'Sie einen anderen Druckertreiber.');

         Exit;
      end;

       try
          ieSize := iesFITTOPAGE;
          ieVPos := ieVPCenter;
          ieHPos := ieHPCenter;

          if (img.ImageCount > 0) then
          begin
             (*
             if (  xDocView.ieBitmap.Height
                 < xDocView.ieBitmap.Width )

             then
                Printer.Orientation := poLandscape
             else
                Printer.Orientation := poPortrait;
               *)
             Printer.BeginDoc;

             try
                for iPage := 0 to img.ImageCount - 1 do
                begin
                   img.MIO.PrintImage(iPage, Printer.Canvas, fMLeft, fMTop,
                      fMRight, fMBottom, ieVPos, ieHPos, ieSize,
                      fSWidth, fSHeight, fGamma);

                   if iPage < (img.ImageCount - 1) then
                      Printer.NewPage;
                end;
             except
					on e: exception do
               begin
                  ShowLogo;
                  WriteCmd('Fehler bei m Drucken:' + e.Message);
               end;
             end;

             Printer.Enddoc;
          end;
       except
          on e: Exception do
          begin
             Printer.Abort;
             Result := False;
          end;
       end; {Try - Except}

    finally


    end;

end; 



begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }
   //  FreeConsole;
   GgfLogEvnt('Autoscan-Log');
   dm_Main := Tdm_Main.Create(nil);
   dm_Main.tico_Main.Icons := dm_Main.il_Std;
   dm_Main.tico_Main.Hint := 'bitfarm Archiv V3 - AutoScan (initalisiere)';
   dm_Main.tico_Main.Active := True;
   try
      GgfLogEvnt('Trap 1');
      img := TImageEnMView.Create(nil);
      img.GridWidth := -1;
      img.DisplayMode := mdGrid;
      img.StoreType := ietNormal;
      img.Style := iemsACD;

      io := TImageEnIO.Create(nil);
      reg := TRegistry.Create;
      scan := img.MIO.TWainParams;
      //tiff := TIOParamsVals.Create(nil);
      if ParamCount < 2 then
      begin
         ShowLogo;
         WriteCMD('Fehler: Nicht gengend Parameter angegeben!');
         WriteLn('Aufrufen mit: AutoScanV3.exe <Template> -G:<Globales Scanprofil>{-P:Druckername}');
         WriteLn('                  oder       <Template> -U:<Benutzer Scanprofil>{-P:Druckername}');
         WriteCmd('Optional kann ein lokal installierter Drucker angegeben werden');
         WriteCmd('bei Druckername mit Leerzeichen bitte den gesamten Ausdruck in ');
         WriteCmd('Anfhrungszeichen setzen ("-P:Drucker 1")');
         WaitForKey;
         ExitCode := 1;  // Zuviele Parameter
         Exit;
      end;
      sTemplate := ParamStr(1);
      sParamType := UpperCase(Copy(ParamStr(2), 1, 3));
      sProfileName := Copy(ParamStr(2), 4, Length(ParamStr(2)) - 3);
      if sParamType = '-G:' then
      begin
         if Assigned(reg) then
            FreeAndNil(reg);
         reg := TRegistry.Create(KEY_READ);
         // Load Global Profile
         reg.RootKey := $80000002;  //HKEY_LOCAL_MACHINE;
      end
      else
      if sParamType = '-U:' then
      begin
         // Load User Profile
         reg.RootKey := $80000001;  //HKEY_CURRENT_USER;
      end
      else
      begin
         ShowLogo;
         WriteLn('Fehler: Unbekannter Parameter (' + sParamType + ') angegeben!');
         WriteLn('Aufrufen mit: AutoScanV3.exe -G:<Globales Scanprofil>{-P:Druckername} -D:<Scan Ordner Pfad>');
         WriteLn('                  oder       -U:<Benutzer Scanprofil>{-P:Druckername} -D:<Scan Ordner Pfad>');
         WaitForKey;
         ExitCode := 2;  // Unbekannter Parameter abgegeben
         Exit;
      end;

		sTempPath := GetEnvironmentVariable('Temp');
      bPageInfo := False;
      if ParamCount >= 3 then
      begin
         for iCount := 3 to ParamCount do
         begin
            if UpperCase(Copy(ParamStr(iCount), 1, 3)) = '-P:' then
            begin
               bPrintDoc := True;
               Druckername := Copy(ParamStr(iCount), 4, Length(ParamStr(iCount)) - 3);
            end;

            if UpperCase(Copy(ParamStr(iCount), 1, 3)) = '-D:' then
            begin
                sTempPath:= Copy(ParamStr(iCount), 4, Length(ParamStr(iCount)) - 3);
            end;
            if LowerCase(Paramstr(iCount)) = 'pageinfo' then
            	bPageInfo := True;
            if LowerCase(Paramstr(iCount)) = '-debug' then
            	BD.LogOn := True;
         end;
      end;

      if sTempPath[Length(sTempPath)] <> '\' then
        sTempPath := sTempPath + '\';
      if not DirectoryExists(sTempPath) then
        CreateDir(sTempPath);

      BD.LogPath := sTempPath;
      GgfLogEvnt('Trap 2');
      ////////////////////////////////////////////////////////////////////////////////////////////////
      //  Scanner Parameter ueberpruefen und fehler ausgeben dessen Exception beim Scannen ausgelst wurde

      try
         with reg do
         begin
            if not KeyExists('\Software\bitfarm\Archiv_V3\Scan\Profiles\' + sProfileName) then
            begin
               ShowLogo;
               WriteLn('Fehler: Angegebenes Profil (' + sProfileName + ') existiert nicht!');
               WaitForKey;
               ExitCode := 3;  // Profil wurde nicht gefunden
               Exit;
            end
            else OpenKey('\Software\bitfarm\Archiv_V3\Scan\Profiles\' + sProfileName, False);
            GgfLogEvnt('Trap 3');
            if ReadBool('ScanByID') then
            	if not scan.SelectSourceByName(Scan.SourceName[ReadInteger('ScanID')]) then
               begin
                  ShowLogo;
                  WriteLn('Fehler: Angegebener Scanner (' + ReadString('ScanName') + ') wurde nicht gefunden!');
                  WaitForKey;
                  ExitCode := 4; // Scannername wurde nicht gefunden
                  exit;

               end;
               //scan.SelectedSource := ReadInteger('ScanID');   //alte Methode
            if ReadBool('ScanByName') then
               if not scan.SelectSourceByName(ReadString('ScanName')) then
               begin
                  ShowLogo;
                  WriteLn('Fehler: Angegebener Scanner (' + ReadString('ScanName') + ') wurde nicht gefunden!');
                  WaitForKey;
                  ExitCode := 4; // Scannername wurde nicht gefunden
                  exit;

               end;
            case ReadInteger('PaperType') of
               00:
                  Scan.StandardSize.CurrentValue := IETW_NONE;
               01:
                  Scan.StandardSize.CurrentValue := IETW_A4LETTER;
               02:
                  Scan.StandardSize.CurrentValue := IETW_B5LETTER;
               03:
                  Scan.StandardSize.CurrentValue := IETW_USLETTER;
               04:
                  Scan.StandardSize.CurrentValue := IETW_USLEGAL;
               05:
                  Scan.StandardSize.CurrentValue := IETW_A5;
               06:
                  Scan.StandardSize.CurrentValue := IETW_B4;
               07:
                  Scan.StandardSize.CurrentValue := IETW_B6;
               08:
                  Scan.StandardSize.CurrentValue := IETW_USLEDGER;
               09:
                  Scan.StandardSize.CurrentValue := IETW_USEXECUTIVE;
               10:
                  Scan.StandardSize.CurrentValue := IETW_A3;
               11:
                  Scan.StandardSize.CurrentValue := IETW_B3;
               12:
                  Scan.StandardSize.CurrentValue := IETW_A6;
               13:
                  Scan.StandardSize.CurrentValue := IETW_C4;
               14:
                  Scan.StandardSize.CurrentValue := IETW_C5;
               15:
                  Scan.StandardSize.CurrentValue := IETW_C6;
               16:
                  Scan.StandardSize.CurrentValue := IETW_4A0;
               17:
                  Scan.StandardSize.CurrentValue := IETW_2A0;
               18:
                  Scan.StandardSize.CurrentValue := IETW_A0;
               19:
                  Scan.StandardSize.CurrentValue := IETW_A1;
               20:
                  Scan.StandardSize.CurrentValue := IETW_A2;
               21:
                  Scan.StandardSize.CurrentValue := IETW_A7;
               22:
                  Scan.StandardSize.CurrentValue := IETW_A8;
               23:
                  Scan.StandardSize.CurrentValue := IETW_A9;
               24:
                  Scan.StandardSize.CurrentValue := IETW_A10;
               25:
                  Scan.StandardSize.CurrentValue := IETW_ISOB0;
               26:
                  Scan.StandardSize.CurrentValue := IETW_ISOB1;
               27:
                  Scan.StandardSize.CurrentValue := IETW_ISOB2;
               28:
                  Scan.StandardSize.CurrentValue := IETW_ISOB5;
               29:
                  Scan.StandardSize.CurrentValue := IETW_ISOB7;
               30:
                  Scan.StandardSize.CurrentValue := IETW_ISOB8;
               31:
                  Scan.StandardSize.CurrentValue := IETW_ISOB9;
               32:
                  Scan.StandardSize.CurrentValue := IETW_ISOB10;
               33:
                  Scan.StandardSize.CurrentValue := IETW_JISB0;
               34:
                  Scan.StandardSize.CurrentValue := IETW_JISB1;
               35:
                  Scan.StandardSize.CurrentValue := IETW_JISB2;
               36:
                  Scan.StandardSize.CurrentValue := IETW_JISB3;
               37:
                  Scan.StandardSize.CurrentValue := IETW_JISB4;
               38:
                  Scan.StandardSize.CurrentValue := IETW_JISB6;
               39:
                  Scan.StandardSize.CurrentValue := IETW_JISB7;
               40:
                  Scan.StandardSize.CurrentValue := IETW_JISB8;
               41:
                  Scan.StandardSize.CurrentValue := IETW_JISB9;
               42:
                  Scan.StandardSize.CurrentValue := IETW_JISB10;
               43:
                  Scan.StandardSize.CurrentValue := IETW_C0;
               44:
                  Scan.StandardSize.CurrentValue := IETW_C1;
               45:
                  Scan.StandardSize.CurrentValue := IETW_C2;
               46:
                  Scan.StandardSize.CurrentValue := IETW_C3;
               47:
                  Scan.StandardSize.CurrentValue := IETW_C7;
               48:
                  Scan.StandardSize.CurrentValue := IETW_C8;
               49:
                  Scan.StandardSize.CurrentValue := IETW_C9;
               50:
                  Scan.StandardSize.CurrentValue := IETW_C10;
               51:
                  Scan.StandardSize.CurrentValue := IETW_USSTATEMENT;
               52:
                  Scan.StandardSize.CurrentValue := IETW_BUSINESSCARD;
            else
               Scan.StandardSize.CurrentValue := IETW_A4LETTER;
            end;
            GgfLogEvnt('Trap 4');
            Scan.BufferedTransfer := True;    // das muss True sein, verdammte Hacke
            case ReadInteger('Transfer') of
               0:
               begin
                  Scan.FileTransfer := True;
                  Scan.CompatibilityMode := False;
               end;
               1:
               begin
                  Scan.FileTransfer := True;
                  Scan.CompatibilityMode := True;
               end;
               2:
               begin
                  Scan.FileTransfer := False;
                  Scan.CompatibilityMode := False;
               end;
               3:
               begin
                  Scan.FileTransfer := False;
                  Scan.CompatibilityMode := True;
               end;
               4:
               begin
                  Scan.FileTransfer := False;
                  Scan.BufferedTransfer := False;
                  Scan.CompatibilityMode := False;
               end;
               5:
               begin
                  Scan.FileTransfer := False;
                  Scan.BufferedTransfer := False;
                  Scan.CompatibilityMode := True;
               end;
            else
            begin
               Scan.FileTransfer := False;
               Scan.BufferedTransfer := True;
               Scan.CompatibilityMode := False;
            end;
            end;

            GgfLogEvnt('Trap 5');
            if ValueExists('Filter') then
            begin
               Case ReadInteger('Filter') of
                  1:
                     Scan.Filter := ietwRed;
                  2:
                     Scan.Filter := ietwGreen;
                  3:
                     Scan.Filter := ietwBlue;
                  4:
                     Scan.Filter := ietwWhite;
                  5:
                     Scan.Filter := ietwCyan;
                  6:
                     Scan.Filter := ietwMagenta;
                  7:
                     Scan.Filter := ietwYellow;
                  8:
                     Scan.Filter := ietwBlack;
               end;
               (*
               case ReadInteger('Filter') of
                  // 0:    Scanner.Filter := ietwNone;
                  1:
                     Scan.Filterenum := ietwfenmRed;
                  2:
                     Scan.Filterenum := ietwfenmGreen;
                  3:
                     Scan.Filterenum := ietwfenmBlue;
               else
                  Scan.Filterenum := ietwfenmNone;
               end;
               *)
            end;
            GgfLogEvnt('Trap 6');
            lftmp := ReadFloat('BrightCur');
            if lftmp <> 0 then
               scan.Brightness.CurrentValue := lftmp;
            lftmp := ReadFloat('ContrastCur');
            if lftmp <> 0 then
               scan.Contrast.CurrentValue := lftmp;

            GgfLogEvnt('Trap 7');
            lftmp := ReadFloat('ThresholdCur');
            if lftmp <> 0 then
               scan.Threshold.CurrentValue := lftmp;
            Scan.Orientation.CurrentValue := ReadInteger('PaperFormat');
            scan.AcquireFrameEnabled := False;
            Scan.AcquireFrameEnabled := ReadBool('Cutted');
            Scan.AcquireFrameTop := ReadFloat('Cut_Top');
            Scan.AcquireFrameLeft := ReadFloat('Cut_Left');
            Scan.AcquireFrameRight := ReadFloat('Cut_Right');
            Scan.AcquireFrameBottom := ReadFloat('Cut_Bottom');
            Scan.FeederEnabled := ReadBool('Opt_ADF');
            Scan.DuplexEnabled := ReadBool('Opt_Duplex');
            bStacked := ReadBool('Opt_Stacked');
            GgfLogEvnt('Trap 8');
            if valueExists('opt_UseInvers') then
            begin
               UseInvers := Readbool('Opt_UseInvers');
            end
            else
	            UseInvers := false;

            if ValueExists('Opt_FiltLeer') then
            begin
               FiltLeer := ReadBool('Opt_FiltLeer');
            end
            else
               FiltLeer := false;
            if ValueExists('Opt_Leerkb') then
            begin
               GFkbleer := ReadFloat('Opt_Leerkb');
            end
            else
               GFkbleer := 0;
            if ValueExists('IgnoreTWAINError') then
            begin
               gbIgnoreTWAINError := ReadBool('IgnoreTWAINError');
            end
            else
               gbIgnoreTWAINError := True;
            (*
            case ReadInteger('ColorMode') of
               0, 1:
                  //tiff.SamplesPerPixel := 1;
               2:
                  //tiff.SamplesPerPixel := 3;
            else
               //tiff.SamplesPerPixel := 1;
            end;*)
            case ReadInteger('ColorMode') of
               0:
                  Scan.PixelType.CurrentValue := 0;
               1:
                  Scan.PixelType.CurrentValue := 1;
               2:
                  Scan.PixelType.CurrentValue := 2;
            else
               Scan.PixelType.CurrentValue := 0;
            end;
            case ReadInteger('BitDepth') of
               0:
                  Scan.BitDepth.CurrentValue := 1;
               1:
                  Scan.BitDepth.CurrentValue := 4;
               2:
                  Scan.BitDepth.CurrentValue := 8;
            else
               Scan.BitDepth.CurrentValue := 1;
            end;
            //tiff.BitsPerSample := Scan.BitDepth.CurrentValue;
            case ReadInteger('DPIX') of
               0:
                  Scan.XResolution.CurrentValue := 50;
               1:
                  Scan.XResolution.CurrentValue := 75;
               2:
                  Scan.XResolution.CurrentValue := 100;
               3:
                  Scan.XResolution.CurrentValue := 150;
               4:
                  Scan.XResolution.CurrentValue := 200;
               5:
                  Scan.XResolution.CurrentValue := 300;
               6:
                  Scan.XResolution.CurrentValue := 400;
               7:
                  Scan.XResolution.CurrentValue := 600;
               8:
                  Scan.XResolution.CurrentValue := 1200;
            else
               Scan.XResolution.CurrentValue := 200;
            end;
            //tiff.DpiX := Trunc(Scan.XResolution.CurrentValue);
            case ReadInteger('DPIY') of
               0:
                  Scan.YResolution.CurrentValue := 50;
               1:
                  Scan.YResolution.CurrentValue := 75;
               2:
                  Scan.YResolution.CurrentValue := 100;
               3:
                  Scan.YResolution.CurrentValue := 150;
               4:
                  Scan.YResolution.CurrentValue := 200;
               5:
                  Scan.YResolution.CurrentValue := 300;
               6:
                  Scan.YResolution.CurrentValue := 400;
               7:
                  Scan.YResolution.CurrentValue := 600;
               8:
                  Scan.YResolution.CurrentValue := 1200;
            else
               Scan.YResolution.CurrentValue := 200;
            end;

            //tiff.DpiY := Trunc(Scan.YResolution.CurrentValue);
            iComp := ReadInteger('Compression');

            CloseKey;
         end;
         GgfLogEvnt('Trap 9');
         dm_Main.tico_Main.Icons := dm_Main.il_Ani;
         dm_Main.tico_Main.Hint := 'bitfarm Archiv V3 - AutoScan (scannen)' + #13 + scan.SourceName[scan.SelectedSource];
         dm_Main.tico_Main.Delay := 100;
         dm_Main.tico_Main.Animated := True;
         Scan.VisibleDialog := false;
         GgfLogEvnt('Trap 10');
         img.MIO.TWainParams.VisibleDialog := false;
         img.MIO.TWainParams.ProgressIndicators := false;

         bReady := False;

         while not bReady do
         begin
           	liimagecount := img.ImageCount;
            img.MIO.TWainParams.LastError := 0;
            img.MIO.TWainParams.LastErrorStr := '';
            GgfLogEvnt('vor Acquire');
         	lbres := img.MIO.Acquire(ieaTwain);  // daten vom Scannner Anfordern
	         GgfLogEvnt('nach Acquire result: ' + BoolToStr(lbres));
            GgfLogEvnt('LastError: ' + Inttostr(img.MIO.TWainParams.LastError));

            if img.MIO.TWainParams.LastError <> 0 then
            begin
               if not gbIgnoreTWAINError then
               begin
                  GgfLogEvnt('nach not gbIgnoreTWAINError');

                  ShowLogo;
                  GgfLogEvnt('nach ShowLogo');

                  WriteLN('Fehler beim Scannen! TWAIN-Errorcode:' + IntToStr(img.MIO.TWainParams.LastError));
                  LogEvnt('Fehler beim Scannen! TWAIN-Errorcode:' + IntToStr(img.MIO.TWainParams.LastError));
                     // bei einem Fehler lschen wir die letzte Seite
                  if (img.MIO.TWainParams.LastError <> 5) and (img.MIO.TWainParams.LastError <> 4) then
                  begin
                     if img.ImageCount > liimagecount then
                        img.DeleteImage(img.ImageCount - 1);
                     GgfLogEvnt('vor MessageDlg');

                     button := MessageDlg('Es hat einen Fehler beim Scannen gegeben (' +IntToStr(img.MIO.TWainParams.LastError) +').' +#13#10+
                                 'Es wurden bisher ' + inttostr(img.ImageCount)+' Seiten gescannt.' +#13#10+
                                 'Wollen sie den Scan fortsetzen und weitere Seiten hinzufgen oder Abbrechen?', mtWarning, [mbYes, mbCancel],0);
                     GgfLogEvnt('nach MessageDlg');

                     if button = mrYes then
                        bReady := False;
                     if button = mrCancel then
                     begin
                        bReady := True;
                        lbres := False;
                     end;
                  end
                  else
                    bReady := True;
               end
               else
                 bReady := True;
            end
            else
            	bReady := True;
         end;

         GgfLogEvnt('vor AcquireClose');

         try
            img.MIO.AcquireClose;
         except
             GgfLogEvnt('Fehler bei AcquireClose');
             
         end;

         GgfLogEvnt('nach AcquireClose');

         if lbres then
			begin

            dm_Main.tico_Main.Animated := False;
            GgfLogEvnt('nach tico_Main.Animated');
         end
         else
         begin
            liscannedpages := img.ImageCount - liimagecount;
            if liscannedpages > 0 then
            begin
               for li := liimagecount to img.ImageCount -1 do
               begin
                  img.DeleteImage(liimagecount);
                  GgfLogEvnt('nach DeleteImage: ' + inttostr(liimagecount));
               end;
            end;
         end;
      except
         on e: exception do
         begin
            GgfLogEvnt('vor ShowLogo (2)');
            ShowLogo;
            WriteLn('Fehler: Es ist ein Fehler beim Scannen aufgetreten(' + e.Message + ')');
            LogEvnt('Fehler: Es ist ein Fehler beim Scannen aufgetreten(' + e.Message + ')');
            WaitForKey;
            Exitcode := 5;  // Unerwarteter Fehler beim Scannen
            Exit;
         end;
      end;
      ///////////////////////////////////////////////////////////////////////////////////
      //
      // Datei speichern und auf Fehler beim Speichern prfen
      //
      try
         GgfLogEvnt('Trap 12 imagecount: ' + IntToStr(img.imagecount));
         if img.imagecount = 0 then
         begin
            GgfLogEvnt('vor ShowLogo (3)');
            ShowLogo;
            WriteLn('Keine Seite gescannt');
            WaitForKey;
            Exitcode := 7;  // Unerwarteter Fehler beim Speichern
            Exit;

         end;

         GgfLogEvnt('vor bPageInfo');
         if bPageInfo then
         begin
            button := MessageDlg('Es wurden ' + inttostr(img.ImageCount)+' Seiten gescannt.' +#13#10+
               'Seiten archivieren oder Abbrechen?', mtInformation, [mbYes, mbCancel],0);
            if button = mrCancel then
            begin
					ExitCode := 9;		//Abbruch durch den Benutzer
               Exit;
            end;
         end;

         GgfLogEvnt('vor tico_Main.Icons');
         dm_Main.tico_Main.Icons := dm_Main.il_Std;
         dm_Main.tico_Main.IconIndex := 0;
         dm_Main.tico_Main.Delay := 800;
         dm_Main.tico_Main.Hint := 'bitfarm Archiv V3 - AutoScan (speichern)' + #13 + scan.SourceName[scan.SelectedSource];
         dm_Main.tico_Main.Animated := True;
         //      if UseInvers then
         GgfLogEvnt('Trap 13');
         for iCount := 0 to img.ImageCount - 1 do
         begin
            case iComp of
               0:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_UNCOMPRESSED;
               1:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_G3FAX2D;
               2:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_G4FAX;
               3:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_JPEG;
               4:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_PACKBITS;
               5:
                  img.MIO.Params[iCount].TIFF_Compression := ioTIFF_LZW;
            else
               img.MIO.Params[iCount].TIFF_Compression :=
                  ioTIFF_UNCOMPRESSED;
            end;
            (*case iComp of
               0:
                  //tiff.tiff_Compression := iotiff_Uncompressed;
               1:
                  //tiff.tiff_Compression := iotiff_G3FAX2D;
               2:
                  //tiff.tiff_Compression := iotiff_G4FAX;
               3:
                  begin
                     //tiff.tiff_Compression := iotiff_JPEG;
                     if  img.MIO.Params[0].SamplesPerPixel = 1 then //Graustufen
                     begin
                        //tiff.BitsPerSample :=8;
                        //tiff.SamplesPerPixel := 3;
                        //tiff.tiff_JPEGColorSpace := ioJPEG_GRAYLEV;

                     end
                     else
                     begin
                        //tiff.BitsPerSample :=8;
                        //tiff.SamplesPerPixel := 3;
                        //tiff.tiff_JPEGColorSpace := ioJPEG_YCbCr;
                     end;
                  end;
               4:
                  //tiff.tiff_Compression := iotiff_PACKBITS;
               5:
                  //tiff.tiff_Compression := iotiff_LZW;
            else
               //tiff.tiff_Compression := iotiff_LZW;
            end;
            *)

         //img.MIO.Params[0].Assign(tiff);

            if img.MIO.TWainParams.PixelType.CurrentValue = 0 then
            begin
               img.MIO.Params[iCount].BitsPerSample := 1;
               img.MIO.Params[iCount].SamplesPerPixel := 1;
            end
            else
            if img.MIO.TWainParams.PixelType.CurrentValue = 1 then
            begin
               img.MIO.Params[iCount].BitsPerSample := img.MIO.TWainParams.BitDepth.CurrentValue;
               img.MIO.Params[iCount].SamplesPerPixel := 1;
            end
            else
            if img.MIO.TWainParams.PixelType.CurrentValue = 2 then
            begin
               img.MIO.Params[iCount].BitsPerSample := 8;
               img.MIO.Params[iCount].SamplesPerPixel := 3;
            end;
         end;

         img.MIO.DuplicateCompressionInfo;
         sleep(200);
         GgfLogEvnt('Trap 14');
         if useInvers then
         begin

            for iCount := 0 to img.ImageCount - 1 do
            begin
               img.SelectedImage := icount;
               img.Proc.Negative;
            end;
         end;
         GgfLogEvnt('Trap 15');
         if Filtleer then
         begin
            img.EnableMultiSelect := true;
            icount := 0;
            while iCount < img.ImageCount do
            begin
               ms := TMemoryStream.Create;

               img.SelectedImage := icount;
               liev := TImageEnView.Create(nil);
               liev.IO.Params.tiff_Compression := img.MIO.Params[iCount].tiff_Compression;
               liev.IEBitmap.AssignImage(img.GetTIEBitmap(img.SelectedImage));

               liev.io.Params.BitsPerSample := img.MIO.Params[iCount].BitsPerSample;
               liev.io.Params.SamplesPerPixel := img.MIO.Params[iCount].SamplesPerPixel;
               case liev.io.Params.BitsPerSample * liev.io.Params.SamplesPerPixel of
                  1:
                     liev.Proc.ConvertToBWOrdered;
                  4:
                     liev.Proc.ConvertToGray;
                  8:
                     liev.Proc.ConvertToGray;
                  24:
                     liev.Proc.ConvertTo24Bit;
               end;

               try
                  liev.IO.SaveToStreamTIFF(ms);
                  //tiffWriteStream(ms,true ,lbit,lioparam , Progress);

               except on e: exception do
                  begin
                  end;
               end;
               if ms.Size < trunc(GFkbleer * 1024) then
               begin
                  //  showmessage('delete page '+inttostr(icount));
                  img.deleteSelectedimages;
               end
               else
               begin
                  icount := icount + 1;
               end;
               if assigned(ms) then
                  freeandnil(ms);
               if assigned(liev) then
                  liev.Destroy;
               //            if assigned(lbit) then freeandnil (lbit);
            end;
         end;

         GgfLogEvnt('Trap 16');
         if not bStacked then
         begin
            if img.imagecount = 0 then
            begin
               ShowLogo;
               WriteLn('Keine Seite gescannt, bzw. nur leere Seiten.');
               WaitForKey;
               Exitcode := 8;  // Unerwarteter Fehler beim Speichern
               Exit;

            end;
            sFileName := GenNewName;

            img.MIO.SaveToFile(sTempPath + sFileName + '.TIF');
            // img.MIO.SaveToFile('c:\'+ sFileName + '.TIF');
            CopyFile(PChar(sTemplate), PChar(sTempPath + sFileName + '.JOB'), False);           //  Deaktiviert fr Geschwindigkeitsmessung

            try
               JobFile := TIniFile.Create(sTempPath + sFileName + '.JOB');
               // Ini.WriteString('Section','Schlssel1','Wert');
               Jobfile.WriteString('Document', 'NumPages', inttostr(img.ImageCount));

            finally
               JobFile.Free;
            end;
            GgfLogEvnt('Trap 17');
         end
         else
         begin
            for iCount := 0 to (img.ImageCount - 1) do
            begin
               sFileName := GenNewName;
               io.AttachedIEBitmap := img.GetTIEBitmap(iCount);
               io.AssignParams(img.MIO.Params[iCount]);
               io.SaveToFile(sTempPath + sFileName + IntToStr(iCount) + '.TIF');

               CopyFile(PChar(sTemplate), PChar(sTempPath + sFileName + IntToStr(iCount) + '.JOB'), False);   // deaktiviert fr Geschwindigkeitsmessung
               try
                  JobFile := TIniFile.Create(sTempPath + sFileName + '.JOB');
                  // Ini.WriteString('Section','Schlssel1','Wert');
                  Jobfile.WriteString('Document', 'NumPages', '1');

               finally
                  JobFile.Free;
               end;

            end;
            GgfLogEvnt('Trap 18');
         end;

         if bPrintDoc then
         begin
            PrintDoc();
         end;
      except
         on e: exception do
         begin
            ShowLogo;
            WriteLn('Fehler: Unerwarteter Fehler beim Speichern (' + e.Message + ')');
            GgfLogEvnt('Fehler: Unerwarteter Fehler beim Speichern (' + e.Message + ')');
            WaitForKey;
            Exitcode := 6;  // Unerwarteter Fehler beim Speichern
            Exit;
         end;
      end;
   finally
      img := nil;
      if Assigned(img) then
         FreeAndNil(img);
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(io) then
         FreeAndNil(io);
      (*if Assigned(tiff) then
         FreeAndNil(tiff);*)
      if Assigned(dm_Main) then
         dm_Main.Free;
      reg.free;
   end;

end.



