program ConvertBigEndian;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  imageenproc,
  ImageEnView,
  IEMView,
  Classes,
  hyieUtils,
  hyiedefs,
  ImageEnIO,
  strutils,
  Windows;

{$R *.res}

var //img: TImageEnMView;
    img2 : TImageEnView;
    sfile : string;
    icount : Integer;

  
function GetVersionInfo: string;
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    result := IntTostr(dwFileVersionMS shr 16);
    result := result + '.' + IntTostr(dwFileVersionMS and $FFFF);
    result := result + '.' + IntTostr(dwFileVersionLS shr 16);
    result := result + '.' + IntTostr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;


begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }
    ExitCode := 0;
  //img := TImageEnMView.Create(nil);
  img2 := TImageEnView.Create(nil);
  //img.MIO.AsyncMode := False;
  //img.MIO.AutoAdjustDPI := True;
  //slFilterList := TStringList.Create;
  WriteLn('bitfarm Archiv ConvertBigEndian (GPL) Version: '+ GetVersionInfo);
  WriteLn('(c) 2013 by bitfarm Informationssysteme GmbH, Siegen');
   try
      WriteLn('Konvertiert BigEndian-codierte Tiffs in LittleEndian-Codierung');
      if FileExists(ParamStr(1)) then
      begin
		  Writeln('Lade Tifdatei...');
        //img.MIO.LoadFromFile(ParamStr(1));

        img2.IO.ParamsFromFile(ParamStr(1));
        //img2.IO.Params.TIFF_ImageCount;

        if img2.IO.Params.TIFF_ByteOrder <> ioBigEndian then
        begin
           Writeln('Keine BigEndian ByteOrder gefunden');
           Exit;
        end;


        if ParamCount = 2 then
        begin
          sfile := ParamStr(2);
          //img.MIO.SaveToFile(ParamStr(2));
        end
        else
           sfile := ParamStr(1) + '.tmp';
          //img.MIO.SaveToFile(ParamStr(1));

          for icount := 0 to img2.IO.Params.TIFF_ImageCount -1 do
          begin
				Writeln('Verarbeite Seite ' + inttostr(icount +1));
          	img2.IO.Params.ImageIndex := icount;
            img2.IO.LoadFromFile(ParamStr(1));
            if icount = 0 then
   				img2.IO.SaveToFileTIFF(sfile)
            else
	            img2.IO.InsertToFileTIFF(sfile);
          end;

          if RightStr(sfile,4) = '.tmp' then
          begin
				DeleteFile(PChar(Paramstr(1)));
          	RenameFile(sfile,ParamStr(1))

          end;

        //WriteLn('Konvertiere...: ' + Paramstr(1) );
      end
      else
      begin
        ExitCode := 1;
        WriteLn('Datei nicht vorhanden: ' + Paramstr(1) );
      end;

   except
      on e: exception do
      begin
        ExitCode := 255;
        WriteLn('Allgemeiner Anwendungsfehler: ' + e.Message);
      end;
   end;

   WriteLn('Done.' );


end.
