program DBImpV3;{$APPTYPE CONSOLE}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
// DBIMPv3

// Author: f.schneider/f.benites/N.Gering/S.Voelke

// Die Schalter sollen auch noch in den Viewer eingebracht werden

// Datumsformat zum Importieren von Dateien  tt.mm.jjjj ohne Uhrzeit     incl Eintrag

// Erzeugt neue Dokumente in der Datenbank und kann diese auf Wiedervorlage legen
// indem eine Jobdatei ausgelesen wird

// Begin der Jobdatei ab der nchsten Zeile
// [Version]
// Version=3.0
// [Archiv]
// Profil=bitfarm
// ame=Lieferantenrechnungen
// Tabelle=27062005090546
// [Document]
// DOCID=
// Titel=Ingram_Rechnung
// Orginal=t:\dokuarch\Lieferantenrechnungen27062005090546\102006\610241527303584.tif
// Kopie=
// Benutzer=n.gering
// Volltext=t:\dokuarch\Lieferantenrechnungen27062005090546\102006\610241527303584.txt
// Status=0
// StatStr=Dokument indiziert und archiviert.
// OCR_QF=-1
// OCR_Typ=OMP
// Schlagworte=S:\bitfarm-archiv\garbage\temp27.swd
// Datum=2006-10-24 15:21:17
// Quelle=t:\dokuarch\Lieferantenrechnungen27062005090546\102006\610241527303584.pdf
// Filter=
// [Referenz]
// Anzahl=0
// [Zusatzfelder]
// Felder=5
// ZusTitel1=Rechnungsnummer
// ZusFeld1=add_17082005094816
// ZusWert1=andindocument=netto
// ZusTitel2=Auftragsnummer
// ZusFeld2=add_17082005094833
// ZusWert2=
// ZusTitel3=Bearbeiter
// ZusFeld3=add_17082005094902
// ZusWert3=
// ZusTitel4=Sachkonto
// ZusFeld4=add_17082005094909
// ZusWert4=
// ZusTitel5=Buchungsdatum
// ZusFeld5=add_17082005094914
// ZusWert5=
// ZusTitel6=Kd-Auftragsnummer
// ZusFeld6=add_07072005101430
// ZusWert6=
// [Tasks]
// Termin=24.10.2006
// Alarm=31.10.2006
// Bearbeiter=n.gering
// Notiz=TestNotiz

//  Remark zum obigen Job:
//  es wird ein neues Dokument in der Datenbank angelegt
//  mit Einer Wiedervorlage
//////////////////////////////////////////////////////////////////////////////////////////////////////
//  Modifikationen am Programm

uses
   u_dm_Main in 'u_dm_Main.pas' {dm_DBImp: TDataModule},
   u_Functions in 'u_Functions.pas',
   u_ShBase in '..\Shared\u_ShBase.pas',
   SysUtils,
   Windows,
   IniFiles,
   Classes,
   StrUtils,
   u_ShLowUtils;

{$R *.res}

var
   con, job: TIniFile;
   sVtxFile, sSlwFile, tglistsec: TStrings;
   iFieldCount, iField, iDocID, iSvnID, iGblDocID, iArcID, iUsrIDWork, iUsrIDShed,
   iRefCount: integer;
   sUser, sPass, sGArcName, sGTblName, sDocID, sDocTitel, sDocOrg,
   sDocKopie, sDocUsr, sDocVTX, sDocState, sDocStateText, sDocOCR,
   sDocSLW, sDocDate, sDocQuelle, sSQLCMD, sProfil, sTermin, sAlarm,
   sWorker, sNotiz, sIWvlID, sgVersion, sSha1, sDefDocname: string;
   sSvnLink, sSvnVersion, sSvnRevision, sSvnDatum, sSvnInfo, sDateformat, lcid: string;
   sMsg1, sMsg2, sMsg3, sMsg4, sMsg5, sMsg6, sMsg7, sMsg8, sMsg9, sMsg10 : string;
   gigdocid: int64;
   aZusFeld, aZusWert, aDocRef: array of string;
   iwvlid, giTimerOptionen, ioldStatus , iNewStatus
   //  Otionen Steuerfeld fur eine WVL, AFEM und EFAM = 1 oder 0
   : integer;
   bNewStatusIsAbsolute : Boolean;
   AFEM,              // 'Alle fuer einen Modus' in der Wiedervorlage fuer eine Gruppe
   bIsWorkflow, boldStatus: boolean;
   formatSettings : TFormatSettings;
////////////////////////////////////////////////////////////////////////////////////////

function RightStr
   (Const Str: String; Size: Word): String;
begin
   if Size > Length(Str) then
      Size := Length(Str);
   RightStr := Copy(Str, Length(Str) - Size + 1, Size)
end;

function MidStr
   (Const Str: String; From, Size: Word): String;
begin
   MidStr := Copy(Str, From, Size)
end;

function LeftStr
   (Const Str: String; Size: Word): String;
begin
   LeftStr := Copy(Str, 1, Size)
end;

Function AnsiToConCP(Const AString: String): String;
Var
   lResult: String;
Begin
   SetLength(lResult, Length(AString));
    {$IFDEF WIN32}
   CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
    {$ELSE}
   AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
    {$ENDIF}
   Result := lResult;
End;

Function WriteCmd(strtext: String): STring;
begin
   strtext := AnsiToConCP(strtext);
   WriteLN(strtext);
End;

// from http://www.delphipraxis.net/topic27196_splitfunktion.html

function Split(const fText: string; const fSep: char; fTrim: boolean = False;
   fQuotes: boolean = False): TStringList;
var
   vI: integer;
   vBuffer: string;
   vOn: boolean;
begin
   Result := TStringList.Create;
   vBuffer := '';
   vOn := True;
   for vI := 1 to Length(fText) do
   begin
      if (fQuotes and (fText[vI] = fSep) and vOn) or
         (not (fQuotes) and (fText[vI] = fSep)) then
      begin
         if fTrim then
            vBuffer := Trim(vBuffer);
         if vBuffer = '' then
            vBuffer := fSep; // !!! sonst luft z.B. split(',**',',') auf einen Hammer...
         if vBuffer[1] = fSep then
            vBuffer := Copy(vBuffer, 2, Length(vBuffer));
         Result.Add(vBuffer);
         vBuffer := '';
      end;
      if fQuotes then
      begin
         if fText[vI] = '"' then
         begin
            vOn := not (vOn);
            Continue;
         end;
         if (fText[vI] <> fSep) or ((fText[vI] = fSep) and (vOn = False)) then
            vBuffer := vBuffer + fText[vI];
      end
      else
      if fText[vI] <> fSep then
         vBuffer := vBuffer + fText[vI];
   end;
   if vBuffer <> '' then
   begin
      if fTrim then
         vBuffer := Trim(vBuffer);
      Result.Add(vBuffer);
   end;
end;

function ParserSemiColonusebackspace(InputStr: string): string;
begin
   Result := StringReplace(InputStr, ';', '', [rfReplaceAll]);
   //be sure of no \'
   Result := StringReplace(Result, '\' + #39 + '', '' + #39 + '', [rfReplaceAll]);
   // change ' to \' for mysql
   Result := StringReplace(Result, '' + #39 + '', '\' + #39, [rfReplaceAll]);
end;

function ParserMySQLString(InputStr: string): string;
begin
   // 3.5.0.5  fr Zusatzfeldwerte kann Semikolon bergeben werden, der Rest wird geparst
   // von ParserSemiColonusebackspace bernommen
   //be sure of no \'
   Result := StringReplace(InputStr, '\' + #39 + '', '' + #39 + '', [rfReplaceAll]);
   // change ' to \' for mysql
   Result := StringReplace(Result, '' + #39 + '', '\' + #39, [rfReplaceAll]);
end;

procedure Get_OldStatus;
// wir holen uns den in Bearbeitung-Status bei schon vorhandenen Dokumenten
var
   iCount: integer;
   sIArcID, sIDocID, sGArcName, sGTblName, soldStatus: string;
begin
   iCount := Pos('.', sDocID);
   sIArcID := copy(sDocID, 1, iCount - 1);
   sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
   iArcID := StrToInt(sIArcID);
   iDocID := StrToInt(sIDocID);

   try
      with dm_DBImp.my_q_Tmp do
      begin
         SQL.Text := 'Select * from sys_arc where arc_id = ' + sIArcID;
         Open;
         First;
         sGArcName := FieldByName('Arc_Name').AsString;
         sGTblName := FieldByName('Arc_TBLName').AsString;

         SQL.Text := 'Select * from arc_' + sGTblName + ' where doc_id = ' + sIDocID;
         Open;
         First;
         soldStatus := FieldByName('DOC_STATE').AsString;
         ioldStatus := strtoint(soldstatus);

         //uns interessiert nur der In Bearbeitung-Status, da andere Stati durchaus
         //whrend eines UpdateSQL gesetzt werden knnen (unabhngig zur Wiedervorlage)
         if ioldStatus and 1 = 1 then
         begin
            boldStatus := True;
         end
         else
         begin
            boldStatus := False;
         end;
      end;
   except
   	on e: exception do
      begin
      	WriteCmd('Fehler bei Get_OldStatus: ' + e.Message);
      end;
   end;
end;

function trim_vtx_for_mysql(vtx: WideString):string;
var
   max_allowed : Int64;
begin
   try
      dm_DBImp.my_q_tmp4.SQL.Text := 'SHOW VARIABLES LIKE ' + #39 +'max_allowed_packet' + #39;
      dm_DBImp.my_q_tmp4.Execute;
      max_allowed:= dm_DBImp.my_q_tmp4.FieldByName('value').asInteger;
   except
      WriteCmd(' Konnte max_alloed_packet nicht ermitteln. Setzte Volltext auf Standardgre');
      max_allowed := 1048576;
   end;

   if length(vtx) > max_allowed then
      vtx := LeftStr(vtx,max_allowed - 1);
   Result:= vtx;
end;

procedure WriteHistory;
var
   sDate, sIDocID: string;
begin
   if iDocID <> 0 then
   begin
     DateTimeToString(sDate, 'yyyy-mm-dd hh:nn:ss', Now);
     sIDocID := IntToStr(iDocID);
     sSQLCmd := 'Insert into hst_' + sGTblName +
        ' (doc_id, usr_id, tstamp, task, task_info) Values (' + sIDocID +
        ', 1, ' + #39 + sDate + #39 + ', 0, ' + #39 + ParseSemicolonUseBackslash(sDocStateText) + #39 + ')';
     dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
     try
        dm_DBImp.my_Cmd.Execute;
     except
        on e: exception  do
        begin
           WriteCMD('Fehler: beim Schreiben in der History-Tabelle! ' + e.Message);
        end;
     end;
   end
   else
   begin
      WriteCMD('Fehler: WriteHistory - Es kann kein Eintrag fr Docid 0 erzeugt werden!');
   end;
end;

procedure SetAddFieldsByState;
var
   xormask, setmask, deletemask, iCount, iFunc : Integer;
   svalue : string;
begin
   if not bNewStatusIsAbsolute then
   	Exit;
	xormask := ioldStatus xor iNewStatus;

   if xormask > 0 then
   begin
       setmask := xormask and iNewStatus;
       deletemask := xormask and ioldStatus;

       if setmask > 0 then
       begin
       	dm_DBImp.my_q_tmp6.SQL.Text := 'select * from sts_' + sGTblName + ' order by sts_id';
         dm_DBImp.my_q_tmp6.Execute;
         if dm_DBImp.my_q_tmp6.RecordCount = 0 then	// da will jemand einen Status setzen in einem Archiv wo es keine Statusbuttons gibt?
         	Exit;													// warum? egal, einfach raus hier....

         for iCount := 1 to  dm_DBImp.my_q_tmp6.RecordCount do
         begin
            svalue := '';
         	if (setmask and ( 1 shl iCount)) > 0 then
            begin
               iFunc := dm_DBImp.my_q_tmp6.FieldByName('sts_Func').AsInteger;
               case iFunc of
                  0:
                     sValue := TimeToStr(Time);
                  1:
                     sValue := DateToStr(Date);
                  2:
                     sValue := DateTimeToStr(now);
                  3:
                     sValue := sDocUsr;
                  4:
                     sValue := sDocUsr + #32 + DateTimeToStr(now);
               else
                  sValue := '';
               end;

               if sValue <> '' then
               begin
                  try
                     dm_DBImp.my_cmd2.SQL.Text := 'Update arc_' + sGTblName + ' Set ' +
                        dm_DBImp.my_q_tmp6.FieldByName('sts_ZusFeld').AsString +' = ' + #39 + svalue + #39 +
                        ' where doc_id = ' + inttostr(iDocID);;
                     dm_DBImp.my_cmd2.Execute;
                  except
                  	on e: Exception do
                     begin
                     	WriteCmd('Fehler beim Setzen der statusabhngigen Zusatzfelder' + e.Message);
                     end;
                  end
               end;
            end;
            dm_DBImp.my_q_tmp6.Next;
         end;
       end;

       if deletemask > 0 then
       begin
       	dm_DBImp.my_q_tmp6.SQL.Text := 'select * from sts_' + sGTblName + ' order by sts_id';
         dm_DBImp.my_q_tmp6.Execute;
         if dm_DBImp.my_q_tmp6.RecordCount = 0 then	// da will jemand einen Status setzen in einem Archiv wo es keine Statusbuttons gibt?
         	Exit;													// warum? egal, einfach raus hier....

         for iCount := 1 to  dm_DBImp.my_q_tmp6.RecordCount do
         begin
         	if (deletemask and ( 1 shl iCount)) > 0 then
            begin
               iFunc := dm_DBImp.my_q_tmp6.FieldByName('sts_Func').AsInteger;
					if iFunc <> 255 then
               begin
                  try
                     dm_DBImp.my_cmd2.SQL.Text := 'Update arc_' + sGTblName + ' Set ' +
                        dm_DBImp.my_q_tmp6.FieldByName('sts_ZusFeld').AsString +' = ' + #39 + #39 +
                        ' where doc_id = ' + inttostr(iDocID);;
                     dm_DBImp.my_cmd2.Execute;
                  except
                  	on e: Exception do
                     begin
                     	WriteCmd('Fehler beim Leeren der statusabhngigen Zusatzfelder' + e.Message);
                     end;
                  end
               end;
            end;
            dm_DBImp.my_q_tmp6.Next;
         end;
       end;

   end;

end;

function StrToWords7(const InputStr: string): TStringList;
const
   sTrennZeichen = ';';
var
   iCount, iWortStart, iWortEnde: integer;  bPhrase: boolean;
   sWort, slStr: string;
begin
   Result := TStringList.Create;
   Result.Clear;
   iWortStart := 1;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   // trim the input!
   slStr := trim(InputStr);
   while iCount <= Length(slStr) do
   begin
      if IsDelimiter(sTrennZeichen, slStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            sWort := Trim(Copy(slStr, iWortStart, iWortEnde - iWortStart));
            if (Length(sWort) >= 1) then
               Result.Add(sWort);
            iWortStart := iWortEnde + 1;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart <= iWortEnde then
   begin
      sWort := Trim(Copy(slStr, iWortStart, maxint));
      Result.Add(sWort);
   end;
end;


function DeleteLink(iArcid, iDocid: integer; link : string): Boolean;
var
   slLink : TStringList;
   iCount : Integer;
   sArcid, sDocid : string;
begin
	sArcid := inttostr(iArcid);
   sDocid := inttostr(iDocid);
   slLink := StrToWords7(link);
   for iCount := 0 to slLink.Count -1 do
   begin
   	dm_DBImp.my_q_tmp5.SQL.Text := 'Delete from sys_doclnk where arc_id = ' + sArcid + ' and doc_id = ' + sDocid +
      											' and ref_name = ' + #39 + slLink[iCount] + #39;
      dm_DBImp.my_q_tmp5.Execute;
   end;
end;

function InsertLink(iArcid, iDocid: integer; link : string): Boolean;
var
   slLink : TStringList;
   iCount, iInsertID : Integer;
   sArcid, sDocid : string;
begin
   sArcid := inttostr(iArcid);
   sDocid := inttostr(iDocid);
   link := Copy(link, 2, length(link) -2);
   slLink := StrToWords7(link);
   for iCount := 0 to slLink.Count -1 do
   begin
      dm_DBImp.my_q_tmp5.SQL.Text := 'Select * from sys_doclnk where arc_id = ' + sArcid + ' and doc_id = ' + sDocid +
      											' and ref_name =' +#39+ slLink[iCount] + #39;
      dm_DBImp.my_q_tmp5.Execute;
      if dm_DBImp.my_q_tmp5.RecordCount > 0 then
      	continue;

   	dm_DBImp.my_q_tmp5.SQL.Text := 'Insert into sys_doclnk set ref_name =' +#39+ slLink[iCount] +#39+ ', arc_id = ' +
      											sArcid + ', doc_id = ' + sDocid;
      dm_DBImp.my_q_tmp5.Execute;
      iInsertID := dm_DBImp.my_q_tmp5.InsertId;
      dm_DBImp.my_q_tmp5.SQL.Text := 'Update sys_doclnk set ref_lnk = ' + inttostr(iInsertID) + ' where ref_id = ' +
      											 inttostr(iInsertID);
      dm_DBImp.my_q_tmp5.Execute;
      sDocStateText := sMsg9 + slLink[iCount] + sMsg10;
      WriteHistory;
   end;
end;


function CreateLinkByAddfield(addfield, link : string): Boolean;
var
   iCount: integer;
   sIArcID, sIDocID, svalue, lsjunk: string;
   igdocid: int64;
begin
   result := false;
   if sDocID <> '' then   // wenn wir ber UpdateSQL kommen haben wir sDocID, bei InsertSQL haben wir
   begin
      iCount := Pos('.', sDocID);
      sIArcID := copy(sDocID, 1, iCount - 1);
      sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
      iArcID := StrToInt(sIArcID);
      iDocID := StrToInt(sIDocID);
   end;
   try
      if iDocID > 0 then
      begin
         dm_DBImp.my_q_tmp5.SQL.Text := 'Select * from arc_' + sGTblName + ' where doc_id = ' + inttostr(iDocID);
         dm_DBImp.my_q_tmp5.Execute;
         if dm_DBImp.my_q_tmp5.RecordCount > 0 then
         begin
            if (dm_DBImp.my_q_tmp5.FieldByName(addfield).AsString <> '') and (dm_DBImp.my_q_tmp5.FieldByName(addfield).AsString <> Copy(link, 2, length(link) -2)) then
               DeleteLink(iArcID, iDocID, dm_DBImp.my_q_tmp5.FieldByName(addfield).AsString);
         end;
      end;

      InsertLink(iArcID, iDocID, link);
	except
   	on e: Exception do
      begin
      	WriteCmd('Fehler beim Erzeugen einer Zusatzfeldverknpfung' + e.Message);

      end;
   end;
end;



// Neue Wiedervorlage Aufgabe einfgen
procedure InsertTask;
var
   iCount, licounter, iGrpID, iInsID: integer;
   sIArcID, sIDocID, lsWorker, sBearbeiterText, sName, sTime: string;
   bIsGrp: boolean;
   ltsworkers: TStringList;
   lscripts: TIniFile;
begin
   if ((iArcID = -1) or (iDocID = -1)) then
   begin
      iCount := Pos('.', sDocID);
      sIArcID := copy(sDocID, 1, iCount - 1);
      sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
      iArcID := StrToInt(sIArcID);
      iDocID := StrToInt(sIDocID);
   end;

   // Erzeugung einer Gruppen Wiedervorlage nach dem Szenario EFAM (Einer fuer Alle)
   // ist der Name eine Gruppe oder ein Benutzer

   if sDocTitel = '' then
   begin
     if lcid = '1031' then
       sDocTitel := 'Dokument'
     else
        sDocTitel := 'Document'; 
   end;

   sTime := TimeToStr(Time);
   sTermin := sTermin + ' ' + sTime;
   sAlarm := sAlarm + ' '  + sTime;

   sDocStateText := '';
   iInsID := 0;
   with dm_DBImp.my_q_Tmp do
   begin
      // Archiv des Dokumentes suchen....
      Close;
      SQL.Text := 'Select * from sys_arc where arc_id = ' + IntToStr(iArcID);
      Open;
      First;
      if RecordCount > 0 then
      begin
         sGArcName := FieldByName('Arc_Name').AsString;
         sGTblName := FieldByName('Arc_TBLName').AsString;
      end
      else
      begin
         WriteCMD('Fehler: Die ArcID:=' + IntToStr(iArcID) +
            'referenziert ein Archiv das nicht existiert. sdocid ' +
            sDocID + 'idocid:=' + IntToStr(idocid));
         ExitCode := 7; // Archiv nicht gefunden;
         exit;
      end;
      Close;
      // Vergebenden Benutzer suchen....
      SQL.Text := 'Select * from sys_usr where usr_name = ' + #39 + sDocUsr + #39;
      try
         Open;
         First;
      except
      	on e: exception do
         begin
         	WriteCmd('Fehler bei InserTask: ' + e.Message);
         end;
      end;

      if RecordCount > 0 then
      begin
         iUsrIDShed := FieldByName('usr_id').AsInteger;
      end
      else
      begin
         WriteCMD('Fehler: Der vergebende Benutzer ' + sDocUsr +
            ' wurde nicht gefunden und durch System ersetzt.');
         if fileexists(extractfilepath(ParamStr(0)) + '\scripts.ini') then
         begin
            try
               lscripts := TIniFile.Create(extractfilepath(ParamStr(0)) + '\scripts.ini');

               SQL.Text := 'Select * from sys_usr where usr_name = ' + #39 +
                  lscripts.ReadString('Scripts', 'admin', 'system') + #39;
               try
                  Open;
               except on e: exception do
                  begin
                     WriteCMD('Fehler bei der Abfrage von "admin": ' + e.message);
                  end;
               end;
               First;
            finally
               if Assigned(lscripts) then
                  FreeAndNil(lscripts);
               iUsrIDShed := FieldByName('usr_id').AsInteger;
            end;
         end
         else
         begin
            iUsrIDShed := 1;
         end;
         ExitCode := 6; // User nicht gefunden;
         //      exit;
      end;
      Close;

      // als Trennzeichen fr Bearbeiterlisten nehmen wir das Semikolon
      ltsworkers := TStringList.Create;
      ltsworkers := Split(sWorker, ';', True, False);

      if ltsworkers.Count > 0 then
      begin
         WriteCMD('Wiedervorlage bergeben: Die Liste der Benutzer war:');
         WriteCMD(ltsworkers.Text);
      end;

      for licounter := 0 to ltsworkers.Count - 1 do
      begin

         if copy(ltsworkers[licounter], 1, 1) = '#' then
         begin
            bIsGrp := True;
            // EFAM:= TRUE;  // mul
            AFEM := False;
            lsWorker := copy(ltsworkers[licounter], 2, Length(ltsworkers[licounter]) - 1);
            // Achtug ggf mssend die Timeroptionen erstmal ausgelesen werden
            // so long set the first bit to 0 and not substract -1 ( -1 could be more efficient (since not 1 = -1 )
            // but this is clearer and should be
            // by optimizing also transformed to -1.)
            // Optionen := bigint(20) UNSIGNED!
            giTimerOptionen := giTimerOptionen and (not 1); //  (2^0)
         end
         else
         if copy(ltsworkers[licounter], 1, 1) = '' then
         begin
            bIsGrp := True;
            // EFAM:= False;
            AFEM := True;
            lsWorker := copy(ltsworkers[licounter], 2, Length(ltsworkers[licounter]) - 1);
            // Hier muss der Eintrag rein um die JE WVL zu kennzeichnen
            giTimerOptionen := giTimerOptionen or 1;
         end
         else
         begin
            lsWorker := copy(ltsworkers[licounter], 1, Length(ltsworkers[licounter]));
            bIsGrp := False;
         end;

         if bIsGrp then // Wenn es sich um eine Gruppewiedervorlage handelt , dann
         begin
            //WriteCMD('Das Dokument wird der Gruppe ' + lsWorker +
            //  ' auf Wiedervorlage gelegt');
            SQL.Text := 'Select * from sys_grp where grp_name = ' +
               #39 + lsWorker + #39 + ' and grp_name not like  ' + #39 + 'DEL_%' + #39;
            try
               Open;
            except
              on e: exception do
              begin
     		        	WriteCmd('Fehler bei InsertTask: ' + e.Message);              
              end;
            end;
            First;
            if RecordCount > 0 then
            begin
               iGrpID := FieldByName('grp_id').AsInteger;
               Close;
               SQL.Text :=
                  'Select * from sys_grpusr left join sys_usr using (usr_id) where grp_id = '
                  + IntToStr(iGrpID) + ' and usr_name not like  ' +
                  #39 + 'DEL_%' + #39;
               try
                  Open;
               except
                  on e: exception do
                  begin
                     WriteCmd('Fehler bei InsertTask: ' + e.Message);
                  end;
               end;
               First;
               //todo check if count  > 0 !!!
               if RecordCount > 0 then
               begin
                  //wenigstens eine WVL wird gesetzt, daher
                  bIsWorkflow := True;
                  WriteCMD('Das Dokument wird der Gruppe ' + lsWorker +
                     ' auf Wiedervorlage gelegt');
                  if sBearbeiterText <> '' then
                  begin
                     sBearbeiterText := sBearbeiterText + ',';
                  end;
                  sBearbeiterText := sBearbeiterText + sMsg8 + lsWorker + '(';
                  iUsrIDWork := FieldByName('usr_id').AsInteger;
                  sName := FieldByName('usr_name').AsString;
                  WriteCMD('Gruppen-Wvl fr Benutzer ' + sName + ' angelegt');


                  dm_DBImp.my_Cmd.SQL.Text :=
                     'Insert into sys_timer (grp_id, arc_id, doc_id, doc_titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                     + 'Values (:grpid, :arcid, :docid, :titel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
                  dm_DBImp.my_Cmd.ParamByName('grpid').AsInteger := iGrpID;
                  dm_DBImp.my_Cmd.ParamByName('arcid').AsInteger := iArcID;
                  dm_DBImp.my_Cmd.ParamByName('docid').AsInteger := iDocID;
                  dm_DBImp.my_Cmd.ParamByName('titel').AsString := sDocTitel;
                  dm_DBImp.my_Cmd.ParamByName('uwork').AsInteger := iUsrIDWork;
                  dm_DBImp.my_Cmd.ParamByName('ushed').AsInteger := iUsrIDShed;
                  dm_DBImp.my_Cmd.ParamByName('termin').AsDateTime := StrToDateTime(sTermin);
                  dm_DBImp.my_Cmd.ParamByName('alarm').AsDateTime := StrToDateTime(sAlarm);
                  dm_DBImp.my_Cmd.ParamByName('optionen').AsInteger := giTimerOptionen;

                  dm_DBImp.my_Cmd.ParamByName('info').AsString := sNotiz;
                  try
                     dm_DBImp.my_Cmd.Execute;
                  except
                    on e: exception do
                    begin
                       WriteCmd('Fehler bei InsertTask: ' + e.Message);
                    end;
                  end;
                  iInsID := dm_DBImp.my_Cmd.InsertId;
                  dm_DBImp.my_Cmd.SQL.Text :=
                     'Update sys_timer set tim_ref = ' + IntToStr(iInsID) +
                     ' where tim_id = ' + IntToStr(iInsID);
                  try
                     dm_DBImp.my_Cmd.Execute;
                  except
                    on e: exception do
                    begin
                       WriteCmd('Fehler bei InsertTask: ' + e.Message);
                    end;
                  end;
                  // this was the first, so now do with the next ppl
                  sBearbeiterText := sBearbeiterText + ' ' + FieldByName('usr_name').AsString;
                  Next;
                  while not EOF do
                  begin
                     iUsrIDWork := FieldByName('usr_id').AsInteger;
                     sName := FieldByName('usr_name').AsString;
                     WriteCMD('Gruppen-Wvl fr Benutzer ' + sName + ' angelegt');

                     dm_DBImp.my_Cmd.SQL.Text :=
                        'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                        + 'Values (:timref, :grpid, :arcid, :docid, :titel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
                     dm_DBImp.my_Cmd.ParamByName('timref').AsInteger := iInsID;
                     dm_DBImp.my_Cmd.ParamByName('grpid').AsInteger := iGrpID;
                     dm_DBImp.my_Cmd.ParamByName('arcid').AsInteger := iArcID;
                     dm_DBImp.my_Cmd.ParamByName('docid').AsInteger := iDocID;
                     dm_DBImp.my_Cmd.ParamByName('titel').AsString := sDocTitel;
                     dm_DBImp.my_Cmd.ParamByName('uwork').AsInteger := iUsrIDWork;
                     dm_DBImp.my_Cmd.ParamByName('ushed').AsInteger := iUsrIDShed;
                     dm_DBImp.my_Cmd.ParamByName('termin').AsDateTime :=
                        StrToDateTime(sTermin);
                     dm_DBImp.my_Cmd.ParamByName('alarm').AsDateTime :=
                        StrToDateTime(sAlarm);
                     dm_DBImp.my_Cmd.ParamByName('optionen').AsInteger := giTimerOptionen;
                     dm_DBImp.my_Cmd.ParamByName('info').AsString := sNotiz;
                     try
                        dm_DBImp.my_Cmd.Execute;

                     except
                        on e: exception do
                        begin
                           WriteCMD('Fehler beim Anlegen einer WV fr die Gruppe ' + lsWorker);
                           WriteCMD(e.Message);
                        end;
                     end;
                     sBearbeiterText := sBearbeiterText + ' ' + FieldByName('usr_name').AsString;
                     Next;
                  end;
               end
               else
               begin
                  WriteCMD('Fehler: Leere Gruppe ausgewhlt: ' + lsWorker + ' (' +
                     IntToStr(licounter + 1) + ' von ' + IntToStr(ltsworkers.Count) + ')');
                  ExitCode := 6;    // User nicht gefunden;
                  continue;
               end;
            end
            else
            begin
               WriteCMD('Fehler: Die Benutzergruppe ' + lsWorker +
                  ' wurde nicht gefunden. (' +
                  IntToStr(licounter + 1) + ' von ' + IntToStr(ltsworkers.Count) + ')');
               ExitCode := 6;    // User nicht gefunden;
               continue;
            end;
            sBearbeiterText := sBearbeiterText + ') ';
            IWvlID := iInsID;
            Close;
         end
         else
         begin       // Einzelbenutzer
            SQL.Text := 'Select * from sys_usr where usr_name = ' +
               #39 + lsWorker + #39 + ' and  usr_name not like  ' + #39 + 'DEL_%' + #39;
            try
               Open;
            except
                on e: exception do
                begin
                   WriteCmd('Fehler bei InsertTask: ' + e.Message);
                end;
            end;
            First;
            if RecordCount > 0 then
            begin
               if FieldByName('usr_id').AsString <> '' then
               begin
                  iUsrIDWork := FieldByName('usr_id').AsInteger;
               end;
            end
            else
            begin
               WriteCMD('Fehler: Der Bearbeiter - ' + lsWorker +
                  ' wurde nicht gefunden. (' +
                  IntToStr(licounter + 1) + ' von ' + IntToStr(ltsworkers.Count) + ')');
               ExitCode := 6; // User nicht gefunden;
               //exit;
               continue;
            end;
            //wenigstens eine WVL wird gesetzt, daher
            bIsWorkflow := True;

            WriteCMD('Wvl wird fr Benutzer ' + lsWorker + ' angelegt');
            // Optionen for one single user not needed!
            dm_DBImp.my_Cmd.SQL.Text :=
               'Insert into sys_timer (grp_id, arc_id, doc_id, doc_titel, usr_id_work, usr_id_shed, termin, erinnerung, info, optionen) '
               + 'Values (0, :arcid, :docid, :titel, :uwork, :ushed, :termin, :alarm, :info, :optionen)';
            dm_DBImp.my_Cmd.ParamByName('arcid').AsInteger := iArcID;
            dm_DBImp.my_Cmd.ParamByName('docid').AsInteger := iDocID;
            dm_DBImp.my_Cmd.ParamByName('titel').AsString := sDocTitel;
            dm_DBImp.my_Cmd.ParamByName('uwork').AsInteger := iUsrIDWork;
            dm_DBImp.my_Cmd.ParamByName('ushed').AsInteger := iUsrIDShed;
            dm_DBImp.my_Cmd.ParamByName('termin').AsDateTime := StrToDateTime(sTermin);
            dm_DBImp.my_Cmd.ParamByName('alarm').AsDateTime := StrToDateTime(sAlarm);
            dm_DBImp.my_Cmd.ParamByName('info').AsString := sNotiz;
            dm_DBImp.my_Cmd.ParamByName('optionen').AsInteger := giTimerOptionen;
            try
               dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                 WriteCmd('Fehler bei InsertTask: ' + e.Message);
              end;
            end;

            // hier muss die Time ID abgefragt werden
            iInsID := dm_DBImp.my_Cmd.InsertId;
            dm_DBImp.my_Cmd.SQL.Text :=
               'Update sys_timer set tim_ref = ' + IntToStr(iInsID) +
               ' where tim_id = ' + IntToStr(iInsID);
            try
               dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                 WriteCmd('Fehler bei InsertTask: ' + e.Message);
              end;
            end;

            if sBearbeiterText <> '' then
            begin
               sBearbeiterText := sBearbeiterText + ',';
            end;
            sBearbeiterText := sBearbeiterText + ' ' + lsWorker;

         end;
         Close;
      end;
   end;
   //just be sure sidocid was set!
   //no bearbeiter set no wvl so dont set in worked it!
   if sIDocID = '' then
   begin
      //exit;
   end;
   sIArcID := IntToStr(iArcID);
   sIDocID := IntToStr(iDocID);

   if bIsWorkflow then
   begin
      dm_DBImp.my_q_Tmp.SQL.Text :=
         'update arc_' + sGTblName + ' set doc_state = (doc_state | 1) where' +
         ' doc_id = ' + sIDocID;
      dm_DBImp.my_q_Tmp.Execute;

      sDocStateText := sMsg1;
      WriteHistory;
      sDocStateText := sMsg2;
      WriteHistory;
      sDocStateText := sMsg3 + sBearbeiterText;
      WriteHistory;
      sDocStateText := sMsg4 + sTermin + sMsg5;
      WriteHistory;
      IWvlID := iInsID;
   end
   else
      //  ToDO : Eine Behandlung fr ExitCode 12 in Archivierung und Workflow.vbs
      //ExitCode:=12;  // Es konnte keine Wiedervorlage angelegt werden (User,Gruppen und Konfiguration berprfen)

   begin    //Status zurcksetzen
      if boldStatus then
      begin
         dm_DBImp.my_q_Tmp.SQL.Text :=
            'update arc_' + sGTblName + ' set doc_state = (doc_state | 1) where' +
            ' doc_id = ' + sIDocID;
         dm_DBImp.my_q_Tmp.Execute;
      end
      else
      begin
         dm_DBImp.my_q_Tmp.SQL.Text :=
            'update arc_' + sGTblName + ' set doc_state = (doc_state | 1) ^ 1  where' +
            ' doc_id = ' + sIDocID;
         dm_DBImp.my_q_Tmp.Execute;
      end;
   end;

end;

procedure WriteRef;
var
   iCount, iRefID: integer;
begin
   for iCount := 1 to iRefCount do
   begin
      // entry does exists?
      dm_DBImp.my_q_Tmp.sql.Text :=
         'select * from sys_doclnk where arc_id = ' + IntToStr(iArcID) +
         ' and doc_id = ' + IntToStr(iDocID) + ' and ref_Name = ' +
         #39 + aDocRef[iCount] + #39 + ' order by ref_lnk desc';
      try
         dm_DBImp.my_q_Tmp.Execute;
      except
        on e: exception do
        begin
           WriteCmd('Fehler bei WriteRef: ' + e.Message);
        end;
      end;

      if dm_DBImp.my_q_Tmp.RecordCount > 0 then
      begin
         continue;
      end;
      with dm_DBImp.my_q_Tmp do
      begin
         //      SQL.Text := 'Select * from sys_doclnk where Ref_Type = 1 and Ref_ID = Ref_LNK and Ref_Name = ' + #39 + aDocRef[iCount] + #39;
         SQL.Text := 'Select * from sys_doclnk where Ref_ID = Ref_LNK and Ref_Name = ' +
            #39 + ParseSemicolonUseBackslash(aDocRef[iCount]) + #39;

         try
            Open;
         except
            on e: exception do
            begin
               WriteCmd('Fehler bei WriteRef: ' + e.Message);
            end;
         end;
         First;
         if RecordCount = 0 then
         begin
            try
               Insert;
            except
                on e: exception do
                begin
                   WriteCmd('Fehler bei WriteRef: ' + e.Message);
                end;
            end;
            FieldByName('Ref_Type').AsInteger := 1;
            FieldByName('Arc_ID').AsInteger := iArcID;
            FieldByName('Doc_ID').AsInteger := iDocID;
            FieldByName('Usr_ID').AsInteger := 1;
            FieldByName('Ref_Name').AsString := aDocRef[iCount];
            try
               Post;
            except
                on e: exception do
                begin
                   WriteCmd('Fehler bei WriteRef: ' + e.Message);
                end;
            end;
            iRefID := FieldByName('Ref_ID').AsInteger;
            edit;
            FieldByName('Ref_Lnk').AsInteger := iRefID;
            try
               Post;
            except
                on e: exception do
                begin
                   WriteCmd('Fehler bei WriteRef: ' + e.Message);
                end;
            end;

            if length(aDocRef[iCount]) > 50 then
            begin
               sDocStateText := sMsg9 + LeftStr(aDocRef[iCount], 50) + '...' + sMsg10;
            end
            else
               sDocStateText := sMsg9 + aDocRef[iCount] + sMsg10;
         end
         else
         begin
            iRefID := FieldByName('Ref_id').AsInteger;
            try
               Insert;
               FieldByName('Ref_Type').AsInteger := 1;
               FieldByName('Ref_Lnk').AsInteger := iRefID;
               FieldByName('Arc_ID').AsInteger := iArcID;
               FieldByName('Doc_ID').AsInteger := iDocID;
               FieldByName('Usr_ID').AsInteger := 1;
               FieldByName('Ref_Name').AsString := aDocRef[iCount];
               Post;
            except
                on e: exception do
                begin
                   WriteCmd('Fehler bei WriteRef: ' + e.Message);
                end;
            end;

            if length(aDocRef[iCount]) > 50 then
            begin
               sDocStateText := sMsg6 + LeftStr(aDocRef[iCount], 50) + '...' + sMsg7;
            end
            else
               sDocStateText := sMsg6 + aDocRef[iCount] + sMsg7;
         end;
         WriteHistory;
      end;
   end;
end;

//insert job data into mysql database
function InsertSQL: boolean;
var
   iCount, litmp, lit: integer;
   bnulldate: boolean;
   lfloat: Double;
   lsjunk, svalue: string;
   vtx : WideString;
begin
   result := false;
   ioldStatus := 0;
   boldStatus := False;
   bNewStatusIsAbsolute := False;
   try
      //get arc table name
      with dm_DBImp.my_q_Tmp do
      begin
         SQL.Text := 'Select * from sys_arc where arc_TblName = ' + #39 + sGTblName + #39;
         Open;
         First;
         iArcID := FieldByName('Arc_ID').AsInteger;
         sDefDocname := FieldByName('DefDocname').AsString;
      end;

      //start mysql query
      sSQLCMD := 'Insert into arc_' + sGTblName + ' (';
      lsjunk := '';
      if sDocTitel <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'Disp_Name';
         lsjunk := ',';
      end;
      if sDocOrg <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'Doc_Loc';
         lsjunk := ',';
      end;
      if sDocKopie <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'Ext_Loc';
         lsjunk := ',';
      end;
      if sDocQuelle <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'Ori_Loc';
         lsjunk := ',';
      end;
      if sDocUsr <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'usr_Name';
         lsjunk := ',';
      end;
      if sDocDate <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'TStamp';
         lsjunk := ',';
      end
      else
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'TStamp';
         lsjunk := ',';
      end;
      if sDocVtx <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'Doc_Txt';
         lsjunk := ',';
      end;
      if sDocState <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'doc_State ';
         lsjunk := ',';
      end;
      if sDocOCR <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'OCR_QF';
         lsjunk := ',';
      end;
      if sSha1 <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + 'SHA1';
         lsjunk := ',';
      end;

      if iFieldCount > 0 then
      begin
         //check if default NULL is valid to datefield
         dm_DBImp.my_q_Tmp.SQL.Text := 'describe arc_' + sGTblName;
         dm_DBImp.my_q_Tmp.Execute;
         dm_DBImp.my_q_Tmp.First;
         bnulldate := True;
         while not dm_DBImp.my_q_Tmp.EOF do
         begin
            try
               if pos('add_', dm_DBImp.my_q_Tmp.FieldByName('Field').AsString) > 0 then
               begin
                  if (not dm_DBImp.my_q_Tmp.FieldByName('Default').isnull) and
                     (dm_DBImp.my_q_Tmp.FieldByName('Type').AsString = 'datetime') then
                  begin
                     bnulldate := False;
                     break;
                  end;
               end;
            except
               on e: exception do
               begin
                  WriteCmd('Fehler bei InsertSQL: ' + e.Message);
               end;
            end;
            dm_DBImp.my_q_Tmp.Next;
         end;
         for iCount := 1 to iFieldCount do
         begin
            if trim(aZusWert[iCount]) <> '' then
            begin
               sSQLCMD := sSQLCMD + ', ' + aZusFeld[iCount];
               with dm_DBImp.my_q_Tmp do
               begin
                  SQL.Text := 'Select * from cfg_' + sGTblName + ' where Feld_Name = ' +
                     #39 + ParseSemicolonUseBackslash(aZusFeld[iCount]) + #39;

                  try
                     Open;
                     First;
                  except
                     on e: exception do
                     begin
                        WriteCmd('Fehler bei InsertSQL: ' + e.Message);
                     end;
                  end;
                  //set datefield as database allow
                  if FieldByName('Typ').AsInteger = 1 then
                  begin
                     if aZusWert[iCount] <> '' then
                     begin
                        if not bnulldate then
                        begin
                           try
                              dm_DBImp.my_q_Tmp.SQL.Text :=
                                 'select str_to_date(' + #39 + aZusWert[iCount] +
                                 #39 + ',' + #39 + sDateformat + #39 + ') as a';
                              dm_DBImp.my_q_Tmp.Execute;
                              if dm_DBImp.my_q_Tmp.FieldByName('a').IsNull then
                              begin
                                 aZusWert[iCount] := '0000-00-00';

                              end
                              else
                              begin
                                 aZusWert[iCount] :=
                                    'str_to_date(' + #39 + aZusWert[iCount] + #39 +
                                    ',' + #39 + sDateformat + #39 + ')';
                              end;
                           except
                              on e: Exception do
                              begin
                                 aZusWert[iCount] := '0000-00-00';
                              end;
                           end;
                        end
                        else
                        begin
                           aZusWert[iCount] :=
                              'str_to_date(' + #39 + aZusWert[iCount] + #39 +
                              ',' + #39 + sDateformat + #39 + ')';
                        end;
                     end
                     else
                     begin
                        if bnulldate then
                        begin
                           aZusWert[iCount] := 'NULL';
                        end
                        else
                        begin
                           aZusWert[iCount] := '0000-00-00';
                        end;
                     end;
                  end
                  else
                  begin
                     //for number we check for , and 2 last number if so convert to .
                     if ((FieldByName('Typ').AsInteger = 6) or
                        (FieldByName('Typ').AsInteger = 7) or
                        (FieldByName('Typ').AsInteger = 8)) then
                     begin
                        svalue := ParseSemicolonUseBackslash(aZusWert[iCount]);
                        if Pos(',',svalue) > 0 then
                        begin
                           if (TryStrToInt(svalue, lit)) or (TryStrToFloat(svalue, lfloat)) then
                           begin
                              svalue:= StringReplace(svalue,',','.', [rfReplaceAll]);

                           end;
                        end;
                        aZusWert[iCount] := #39 + ParseSemicolonUseBackslash(svalue) + #39;
                     end
                     else
                     begin
                        aZusWert[iCount] := #39 + ParserMySQLString(aZusWert[iCount]) + #39;
                     end;
                  end;
               end;
            end;
         end;
      end;

      lsjunk := ' ';
      sSQLCMD := sSQLCMD + ') Values (';

      if sDocTitel <> '' then
      begin
        if (sDocTitel = 'Dokument') And (sDefDocname<>'') then
          sSQLCMD := sSQLCMD + lsjunk + #39 + sDefDocname + #39
        else
          sSQLCMD := sSQLCMD + lsjunk + #39 + StringReplace(sDocTitel,#39,'\'+#39,[rfReplaceAll]) + #39; //08.07.2011 b.takacs 3.5.1.1
        lsjunk := ',';
      end;
      if sDocOrg <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + #39 + sDocOrg + #39;
         lsjunk := ',';
      end;
      if sDocKopie <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + #39 + sDocKopie + #39;
         lsjunk := ',';
      end;
      if sDocQuelle <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + #39 + sDocQuelle + #39;
         lsjunk := ',';
      end;
      if sDocUsr <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + #39 + sDocUsr + #39;
         lsjunk := ',';
      end;
      if sDocDate <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + #39 + sDocDate + #39;
         lsjunk := ',';
      end
      else
      begin
      	sSQLCMD := sSQLCMD + lsjunk + ' now() ';
         lsjunk := ',';
      end;
      if sDocVtx <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + ':doctxt';
         lsjunk := ',';
      end;
      if sDocState <> '' then
      begin
         if Pos('+', sDocState) = 1 then
         begin  // Bits setzten: ([alterWert] or [zuSetztendeBits])
            sSQLCMD := sSQLCMD + lsjunk + ' (doc_state | ' +
               Copy(sDocState, 2, Length(sDocState)) + ')';
               TryStrToInt(Copy(sDocState, 2, Length(sDocState)), iNewStatus);
         end
         else
         if Pos('-', sDocState) = 1 then
         begin // Bits lschen: ([AlterWert] or [zuLschendeBits]) xor [zuLschendeBits]
            sSQLCMD := sSQLCMD + lsjunk + ' (doc_state | ' +
               Copy(sDocState, 2, Length(sDocState)) + ') ^ ' +
               Copy(sDocState, 2, Length(sDocState));
               TryStrToInt(Copy(sDocState, 2, Length(sDocState)), iNewStatus);
         end
         else
         if Pos('#', sDocState) = 1 then
         begin // Bits ersetzen:
            sSQLCMD := sSQLCMD + lsjunk + ' ' + Copy(sDocState, 2, Length(sDocState));
            TryStrToInt(Copy(sDocState, 2, Length(sDocState)), iNewStatus);
            bNewStatusIsAbsolute := True;
         end
         else
         begin
            try
               iNewStatus := strtoint(sDocState);
               sSQLCMD := sSQLCMD + lsjunk + ' ' + sDocState;
               bNewStatusIsAbsolute := True;
            except
               on e: Exception do
               begin
                  sSQLCMD := sSQLCMD + lsjunk + ' 0';

               end;
            end;
         end;
         lsjunk := ',';
      end;

      if sDocOCR <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + sDocOCR;
         lsjunk := ',';
      end;
      if sSha1 <> '' then
      begin
         sSQLCMD := sSQLCMD + lsjunk + #39 + sSha1+ #39;
         lsjunk := ',';
      end;
      if iFieldCount > 0 then
         for iCount := 1 to iFieldCount do
         begin

            if trim(aZusWert[iCount]) <> '' then
            begin
               sSQLCMD := sSQLCMD + ', ' + aZusWert[iCount];
		 //          sSQLCMD := sSQLCMD + ', ' + StringReplace(aZusWert[iCount],#39,#39+'/',[rfReplaceAll]); //08.07.2011 b.takacs 3.5.1.1
            	//CreateLinkByAddfield(aZusFeld[iCount], aZusWert[iCount]);
            end;
         end;
      sSQLCMD := sSQLCMD + ')';
      dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
      //only now is the query ready to set the parameter doctxt if sDoctxt isnt empty
      if sDocVtx <> '' then
      begin
         vtx :=trim_vtx_for_mysql(sVtxFile.Text);
         dm_DBImp.my_Cmd.ParamByName('doctxt').AsString := vtx;
      end;
      try
         dm_DBImp.my_Cmd.Prepare;
         dm_DBImp.my_Cmd.Execute;
      except on e: exception do
         begin
            WriteCMD('Fehler: Beim Einfgen in die Archiv tabelle! ' + e.Message);
            WriteCMD('Fehler: SQL-Command! ' + dm_DBImp.my_Cmd.SQL.Text);
         end;
      end;
      iDocID := dm_DBImp.my_Cmd.InsertId;

      for iCount := 1 to iFieldCount do
      begin
         if trim(aZusWert[iCount]) <> '' then
         begin
            with dm_DBImp.my_q_Tmp do
            begin
               SQL.Text := 'Select * from cfg_' + sGTblName + ' where Feld_Name = ' +
                  #39 + ParseSemicolonUseBackslash(aZusFeld[iCount]) + #39;
               try
                  Open;
                  First;
               except
                  on e: exception do
                  begin
                     WriteCmd('Fehler bei InsertSQL: ' + e.Message);
                  end;
               end;
               //set datefield as database allow
					if (FieldByName('optionen').AsInteger and 2) = 2 then
               	CreateLinkByAddfield(aZusFeld[iCount], aZusWert[iCount]);
            end;
         end;
      end;


      if sSlwFile.Count > 0 then
      begin
         sSQLCMD := 'Insert into slw_' + sGTblName + ' (doc_id, doc_slw) Values ';
         for iCount := 0 to (sSlwFile.Count - 1) do
            sSQLCMD := SSQLCMD + '(' + IntToStr(iDocID) + ', ' + #39 +
               ParseSemicolonUseBackslash(sSlwFile.Strings[iCount]) + #39 + '),';
         sSQLCMD := Copy(sSQLCMD, 1, Length(sSQLCMD) - 1);
         dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
         try
            dm_DBImp.my_Cmd.Execute;
         except on e: exception do
            begin
               WriteCMD('Fehler: Beim Einfgen in die Schlagwort-Tabelle! ' + e.Message);
            end;
         end;
      end;
      dm_DBImp.my_q_Tmp.SQL.Text := 'show tables like ' + #39 + 'sys_gdocid' + #39;
      try
         dm_DBImp.my_q_Tmp.Execute;
      except on e: exception do
         begin
            WriteCmd('Fehler bei InsertSQL: ' + e.Message);
         end;
      end;
      if dm_DBImp.my_q_Tmp.RecordCount > 0 then
      begin

         //update entry into sys_gdocid if already got one from importer or manuscan
         if gigdocid = 0 then
         begin
            dm_DBImp.my_Cmd.SQL.Text :=
               'insert into sys_gdocid (arc_id, doc_id) values ' + '(' +
               #39 + IntToStr(iArcID) + #39 + ',' + #39 + IntToStr(iDocID) + #39 + ')';
            try
               dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                 WriteCmd('Fehler bei InsertSQL: ' + e.Message);
              end;
            end;
            iGblDocID := dm_DBImp.my_Cmd.InsertId;
         end
         else
         begin
            dm_DBImp.my_Cmd.SQL.Text :=
               'update sys_gdocid set arc_id= ' + IntToStr(iArcID) + ', doc_id=' + IntToStr(iDocID) +
               ' where gdoc_id=' + IntToStr(gigdocid);
            try
               dm_DBImp.my_Cmd.Execute;
            except
              on e: exception do
              begin
                 WriteCmd('Fehler bei InsertSQL: ' + e.Message);
              end;
            end;
            iGblDocID := gigdocid;
         end;
         dm_DBImp.my_Cmd.SQL.Text :=
            'update arc_' + sGTblName + ' set gdoc_id = ' + IntToStr(iGblDocID) +
            ' where doc_id =' + IntToStr(iDocID);
         try
            dm_DBImp.my_Cmd.Execute;
         except
         	on e: exception do
            begin
               WriteCmd('Fehler bei InsertSQL: ' + e.Message);
            end;
         end;
      end;

      if lcid = '1031' then
         sDocStateText := 'Dokument wurde archiviert.'
      else
        sDocStateText := 'Dokument was archived.';
      WriteHistory;

      if iRefCount > 0 then
         WriteRef;
      if sTermin <> '' then
         InsertTask;

      SetAddFieldsByState;

      result := true;
   except on e: exception do
      begin
         WriteCMD('Error in Insertsql ' + e.message);
         WriteCMD('SQL befehl ' + dm_DBImp.my_Cmd.SQL.Text);
         result := false;
      end;
   end;
end;

function ConnectDB: boolean;
begin
   // Auslesen der Connection
   con := TIniFile.Create(sProfil);
   Result := True;
   try
      try
         with con do
         begin
            sUser := ReadString('Connection', 'User', '');
            sPass := ReadString('Connection', 'Pass', '');
            with dm_DBImp.my_Con do
            begin
               Username := Decrypt(sUser, GlobalKey);
               Password := Decrypt(sPass, GlobalKey);
               Server := ReadString('Connection', 'Server', '');
               Port := ReadInteger('Connection', 'Port', 3306);
               Database := ReadString('Connection', 'DB', '');
               WriteCMD('Connection to Server ' + Server + ' with DB ' + Database);
               Connect; // Anmelden an der Datenbank
               if not Connected then // Wenn keine Verbindung dann Tool verlassen
               begin
                  ExitCode := 2;  //keine Connection zur Datenbank mglich
                  WriteCMD('Fehler: Keine Verbindung zur Datenbank!');
                  Result := False;
                  exit;
               end;
            end;
         end;
      except
         on e: Exception do
         begin
            ExitCode := 4;   // Fehler beim Auslesen der .CON Datei
            WriteCMD('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
            Result := False;
            exit;
         end;
      end;
   finally
      if Assigned(con) then
         FreeAndNil(con);
   end;
end;


//change values in the sql database
function UpdateSQL: boolean;
var
   iCount, litmp, lit: integer;
   lfloat: Double;
   lcur : Currency;
   sIArcID, sIDocID, svalue, lsjunk: string;
   bnulldate: boolean;
   igdocid: int64;
   vtx: WideString;

begin
   result := false;
   iCount := Pos('.', sDocID);
   sIArcID := copy(sDocID, 1, iCount - 1);
   sIDocID := copy(sDocID, iCount + 1, Length(sDocID) - iCount);
   iArcID := StrToInt(sIArcID);
   iDocID := StrToInt(sIDocID);

   //Get_OldStatus

   if iDocID <> 0 then
   begin
		try
			with dm_DBImp.my_q_Tmp do
         begin
            SQL.Text := 'Select * from sys_arc where arc_id = ' + sIArcID;
            Open;
            First;
            sGArcName := FieldByName('Arc_Name').AsString;
            sGTblName := FieldByName('Arc_TBLName').AsString;
            sDefDocname := FieldByName('DefDocname').AsString;
            // Time_id des Dokumentes holen

            SQL.Text := 'Select * from sys_timer where arc_id = ' +
              sIArcID + ' and doc_id = ' + sIDocID;
            Open;
            First;
            sIWvlID := FieldByName('tim_ref').AsString;

            if sIWvlID <> '' then
              	iWvlID := StrToInt(sIWvlID)
            else
              	iWvlID := 0;

            Close;

            igdocid := 0;
            SQL.Text := 'Select * from arc_' + sGTblName + ' where doc_id = ' + sIDocID;
            Open;
            First;
            igdocid := FieldByName('gdoc_id').asinteger;
            ioldStatus := FieldByName('Doc_State').asinteger;
         end;

         sSQLCMD := 'Update arc_' + sGTblName + ' Set ';
         if sDocTitel <> '' then
         begin
            if (sDocTitel = 'Dokument') And (sDefDocname<>'') then
              sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + sDefDocname + #39 + ','
            else
            //  sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + sDocTitel + #39 + ',';
                 sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + StringReplace(sDocTitel,#39,'\'+#39,[rfReplaceAll]) + #39 + ','; //08.07.2011 b.takacs 3.5.1.1
         end;
         //        sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + sDocTitel + #39 + ',';
         if sDocOrg <> '' then
           sSQLCMD := sSQLCMD + 'Doc_Loc = ' + #39 + sDocOrg + #39 + ',';
         if sDocKopie <> '' then
           sSQLCMD := sSQLCMD + 'Ext_Loc = ' + #39 + sDocKopie + #39 + ',';
         if sDocQuelle <> '' then
           sSQLCMD := sSQLCMD + 'Ori_Loc = ' + #39 + sDocQuelle + #39 + ',';
         if sDocUsr <> '' then
           sSQLCMD := sSQLCMD + 'usr_Name = ' + #39 + sDocUsr + #39 + ',';
         if sDocDate <> '' then
           sSQLCMD := sSQLCMD + 'TStamp = ' + #39 + sDocDate + #39 + ',';
         if sSha1 <> '' then
           sSQLCMD := sSQLCMD + 'SHA1 = ' + #39 + sSha1 + #39 + ',';
         if sDocVtx <> '' then
         begin
           sSQLCMD := sSQLCMD + 'Doc_Txt = :doctxt,';
         end;
         if sDocOCR <> '' then
           sSQLCMD := sSQLCMD + 'OCR_QF = ' + sDocOCR + ',';
         if sDocState <> '' then
         begin
           if Pos('+', sDocState) = 1 then
           begin  // Bits setzten: ([alterWert] or [zuSetztendeBits])
              sSQLCMD := sSQLCMD + 'Doc_State = (doc_state | ' +
                 Copy(sDocState, 2, Length(sDocState)) + '),';
                 TryStrToInt(Copy(sDocState, 2, Length(sDocState)), iNewStatus);
           end
           else
           if Pos('-', sDocState) = 1 then
           begin // Bits lschen: ([AlterWert] or [zuLschendeBits]) xor [zuLschendeBits]
              sSQLCMD := sSQLCMD + 'Doc_State = (doc_state | ' +
                 Copy(sDocState, 2, Length(sDocState)) + ') ^ ' +
                 Copy(sDocState, 2, Length(sDocState)) + ',';
                 TryStrToInt(Copy(sDocState, 2, Length(sDocState)), iNewStatus);
           end
           else
           if Pos('#', sDocState) = 1 then
           begin // Bits ersetzen:
              sSQLCMD := sSQLCMD + 'Doc_State = ' + Copy(sDocState, 2, Length(sDocState)) + ',';
              TryStrToInt(Copy(sDocState, 2, Length(sDocState)), iNewStatus);
              bNewStatusIsAbsolute := True;
           end
           else
           begin
              try
                 iNewStatus := strtoint(sDocState);
                 if iNewStatus <> 0 then
                 begin
                    sSQLCMD := sSQLCMD + 'Doc_State = ' + sDocState + ',';
                    bNewStatusIsAbsolute := True;
                 end;
              except
                on e: Exception do
                begin
                   WriteCmd('Fehler bei UpdateSQL: ' + e.Message);
                end;
              end;
           end;
         end;
         if iFieldCount > 0 then
         begin
           //check if default NULL is valid to datefield
           dm_DBImp.my_q_Tmp.SQL.Text := 'describe arc_' + sGTblName;
           dm_DBImp.my_q_Tmp.Execute;
           dm_DBImp.my_q_Tmp.First;
           bnulldate := True;
           while not dm_DBImp.my_q_Tmp.EOF do
           begin
              if pos('add_', dm_DBImp.my_q_Tmp.FieldByName('Field').AsString) > 0 then
              begin
                 if (not dm_DBImp.my_q_Tmp.FieldByName('Default').isnull) and
                    (dm_DBImp.my_q_Tmp.FieldByName('Type').AsString = 'datetime') then
                 begin
                    bnulldate := False;
                    break;
                 end;
              end;
              dm_DBImp.my_q_Tmp.Next;
           end;
           for iCount := 1 to iFieldCount do
           begin
              if trim(aZusWert[iCount]) <> '' then
              begin
                 with dm_DBImp.my_q_Tmp do
                 begin
                    SQL.Text := 'Select * from cfg_' + sGTblName + ' where Feld_Name = ' +
                       #39 + aZusFeld[iCount] + #39;
                    Open;
                    First;
                    if FieldByName('Typ').AsInteger = 1 then
                    begin
                       if (aZusWert[iCount] <> '') and (aZusWert[iCount] <> '#delete#') then
                       begin
                          if not bnulldate then
                          begin
                             try
                                dm_DBImp.my_q_Tmp.SQL.Text :=
                                   'select str_to_date(' + #39 + aZusWert[iCount] +
                                   #39 + ',' + #39 + sDateformat + #39 + ') as a';
                                dm_DBImp.my_q_Tmp.Execute;
                                if dm_DBImp.my_q_Tmp.FieldByName('a').IsNull then
                                begin
                                   aZusWert[iCount] := '0000-00-00';
                                end
                                else
                                begin
                                   aZusWert[iCount] :=
                                      'str_to_date(' + #39 + aZusWert[iCount] +
                                      #39 + ',' + #39 + sDateformat + #39 + ')';
                                end;
                             except
                                on e: Exception do
                                begin
                                   aZusWert[iCount] := '0000-00-00';
                                end;
                             end;
                          end
                          else
                          begin
                             aZusWert[iCount] :=
                                'str_to_date(' + #39 + aZusWert[iCount] + #39 +
                                ',' + #39 + sDateformat + #39 + ')';
                          end;
                       end
                       else
                       begin
                          if bnulldate then
                          begin
                             aZusWert[iCount] := 'NULL';
                          end
                          else
                          begin
                             aZusWert[iCount] := '0000-00-00';
                          end;
                       end;
                    end
                    else
                    begin
                       if ((FieldByName('Typ').AsInteger = 6) or
                          (FieldByName('Typ').AsInteger = 7) or
                          (FieldByName('Typ').AsInteger = 8)) then
                       begin
                          svalue := ParseSemicolonUseBackslash(aZusWert[iCount]);
                          if Pos(',',svalue) > 0 then
                          begin
                              if (TryStrToInt(svalue, lit)) or (TryStrToFloat(svalue, lfloat)) then
                              begin
                                 svalue:= StringReplace(svalue,',','.', [rfReplaceAll]);

                              end;
                          end;

                          if aZusWert[iCount] = '#delete#' then
                            aZusWert[iCount] := #39 + #39
                          else
                             aZusWert[iCount] := #39 + ParseSemicolonUseBackslash(svalue) + #39;
                       end
                       else
                       begin
                          if aZusWert[iCount] = '#delete#' then
                            aZusWert[iCount] := #39 + #39
                          else
                            aZusWert[iCount] := #39 + ParserMySQLString(aZusWert[iCount]) + #39;
                       end;
                    end;
                    if (FieldByName('optionen').AsInteger and 2) = 2 then
                        CreateLinkByAddfield(aZusFeld[iCount],aZusWert[iCount]);
                 end;
                 sSQLCMD := sSQLCMD + aZusFeld[iCount] + ' = ' + aZusWert[iCount] + ',';
              end;
           end;
         end;

         sSQLCMD := Copy(sSQLCMD, 1, Length(sSQLCMD) - 1) + ' where doc_id = ' + sIDocID;
         dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
         if sDocVtx <> '' then
         begin
           vtx :=trim_vtx_for_mysql(sVtxFile.Text);
           dm_DBImp.my_Cmd.ParamByName('doctxt').AsString := vtx;
         end;

         dm_DBImp.my_Cmd.Execute;

         if sSlwFile.Count > 0 then
         begin
           sSQLCMD := 'Insert into slw_' + sGTblName + ' (doc_id, doc_slw) Values ';
           for iCount := 0 to (sSlwFile.Count - 1) do
              sSQLCMD := SSQLCMD + '(' + IntToStr(iDocID) + ', ' + #39 +
                 ParseSemicolonUseBackslash(sSlwFile.Strings[iCount]) + #39 + '),';
           sSQLCMD := Copy(sSQLCMD, 1, Length(sSQLCMD) - 1);
           dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
           dm_DBImp.my_Cmd.Execute;
         end;

         if lcid = '1031' then
            sDocStateText := 'Dokument wurde berarbeitet.'
         else
            sDocStateText := 'Document was revised.';

         WriteHistory;

         sSQLCMD := '';
         lsjunk := '';
         if sDocTitel <> '' then
         begin
           if ((sDocTitel = 'Dokument') or (sDocTitel = 'Document')) And (sDefDocname<>'') then
              sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + sDefDocname + #39
           else
              sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + StringReplace(sDocTitel,#39,'\'+#39,[rfReplaceAll]) + #39; //08.07.2011 b.takacs 3.5.1.1
           lsjunk := ',';
         end;
           //sSQLCMD := sSQLCMD + 'Disp_Name = ' + #39 + sDocTitel + #39 + ',';
         if sDocOrg <> '' then
         begin
           sSQLCMD := sSQLCMD + lsjunk + 'Doc_Loc = ' + #39 + sDocOrg + #39;
           lsjunk := ',';
         end;
         if sDocKopie <> '' then
         begin
           sSQLCMD := sSQLCMD + lsjunk + 'Ext_Loc = ' + #39 + sDocKopie + #39;
           lsjunk := ',';
         end;
         if sDocQuelle <> '' then
         begin
           sSQLCMD := sSQLCMD + lsjunk + 'Ori_Loc = ' + #39 + sDocQuelle + #39;
           lsjunk := ',';
         end;
         if sDocUsr <> '' then
         begin
           sSQLCMD := sSQLCMD + lsjunk + 'usr_Name = ' + #39 + sDocUsr + #39;
           lsjunk := ',';
         end;

         if sDocDate <> '' then
         begin
           sSQLCMD := sSQLCMD + lsjunk + 'TStamp = ' + #39 + sDocDate + #39;
           lsjunk := ',';
         end;

         if sDocVtx <> '' then
         begin
           sSQLCMD := sSQLCMD + lsjunk + 'Doc_Txt = :doctxt';
           lsjunk := ',';
         end;

         if sSQLCMD <> '' then
         begin
           dm_DBImp.my_Cmd.SQL.Text := 'update arc_' +
              sGTblName + ' set ' +
              sSQLCMD +   ' where doc_id = ' + sIDocID;

           if sDocVtx <> '' then
           begin
              dm_DBImp.my_Cmd.ParamByName('doctxt').AsString := vtx;
           end;

           dm_DBImp.my_Cmd.execute;
         end;

         if iRefCount > 0 then
           	WriteRef;

         SetAddFieldsByState;

         result := true;
      except on e: exception do
        begin
           WriteCMD('Error in Updatesql ' + e.message);
           result := false;
        end;
      end;
   end
   else
   begin
      WriteCMD('Fehler: Es kann kein Dokument mit Docid 0 aktualisiert werden.');
   end;

end;







function FileAccessable(FileName: string): boolean;
   //////////////////////////////////////////////////////////////////
   ///  15.05.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Prft, ob auf eine Datei lesend zugegriffen werden kann    ///
   ///  oder nicht.                                               ///
   ///                                                            ///
   ///  Parameter: FileName    String mit Pfad und Dateiname      ///
   ///                                                            ///
   ///  Ausgabe:   True       bei Erfolg                          ///
   ///             False      bei Fehlschlag                      ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iFile: integer;
begin
   iFile := -1;
   try
      iFile := FileOpen(FileName, fmOpenRead);
      if iFile > 0 then
         Result := True
      else
         Result := False;
   finally
      FileClose(iFile);
   end;
end;


//svn

Function InsertSVN: boolean;
begin
   result := False;
   try
      dm_DBImp.my_q_Tmp.SQL.Text := 'SHOW TABLEs  LIKE  ' + #39 + 'sys_svn' + #39;
      dm_DBImp.my_q_Tmp.Execute;
      if dm_DBImp.my_q_Tmp.RecordCount <> 0 then
      begin
         sSQLCMD := 'Insert into sys_svn (ARC_ID, DOC_ID, GDOC_ID, SVN_LINK, SVN_VERSION, SVN_REVISION, SVN_DATE, SVN_INFO) ' +
            ' Values (' + #39 + inttostr(iArcID) + #39 + ', ' +
            #39 + inttostr(iDocID) + #39 + ', ' +
            #39 + inttostr(gigdocid) + #39 + ', ' +
            #39 + sSvnLink + #39 + ', ' +
            #39 + sSvnVersion + #39 + ', ' +
            #39 + sSvnRevision + #39 + ', ' +
            #39 + sSvnDatum + #39 + ', ' +
            #39 + sSvnInfo + #39 + ')';

         dm_DBImp.my_Cmd.SQL.Text := sSQLCMD;
         dm_DBImp.my_Cmd.Execute;
         iSvnID := dm_DBImp.my_Cmd.InsertId;

      end;

      result := true;
   except on e: exception do
      begin
         WriteCMD('Error in InsertSVN ' + e.message);
         result := false;
      end;
   end;
end;

function GetVersionInfo: string;
var
   VerInfoSize: DWord;
   VerInfo: Pointer;
   VerValueSize: DWord;
   VerValue: PVSFixedFileInfo;
   Dummy: DWord;
begin
   VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
   GetMem(VerInfo, VerInfoSize);
   GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
   VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
   with VerValue^ do
   begin
      Result := IntToStr(dwFileVersionMS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
      Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
   end;
   FreeMem(VerInfo, VerInfoSize);
end;


// Start of MAIN
begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }
   // Prfen ob alle Parameter angegeben wurden.
   iArcID := -1;
   iDocID := -1;
   bIsWorkflow := False;   //sobald eine WVL angelegt werden kann auf True setzen
   WriteCMD('bitfarm Archiv V3 -  Datenbank Import Tool');
   WriteCMD('(c) 2004 - '+cCurYear+' bitfarm Informationssysteme GmbH');
   if ParamCount <> 1 then
   begin
      ExitCode := 1; //  Nicht genuegend Parameter angegeben
      WriteCMD('Version: ' + GetVersionInfo);
      WriteCMD('Fehler: Nicht genuegend Parameter angegeben!');
      WriteCMD('        Aufrufen mit: dbimpv3 <job-datei>');
      exit;
   end;

   // Initalisieren der Objekte
   if not FileExists(ParamStr(1)) then
   begin
      ExitCode := 5;   //  Kann Jobdatei nicht finden
      WriteCMD('Fehler: Kann Jobdatei <' + ParamStr(1) + '> nicht finden.');
      exit;
   end;
   if not FileAccessable(ParamStr(1)) then
   begin
      exit;
   end;

   sDateformat := '%d.%m.%Y';
   GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, formatSettings);
   if LowerCase(formatSettings.ShortDateFormat) = 'dd.mm.yyyy' then
      sDateformat := '%d.%m.%Y';
   if LowerCase(formatSettings.ShortDateFormat) = 'm/d/yyyy' then
      sDateformat := '%m/%d/%Y';
   if LowerCase(formatSettings.ShortDateFormat) = 'mm/dd/yyyy' then
      sDateformat := '%m/%d/%Y';
   if LowerCase(formatSettings.ShortDateFormat) = 'dd/mm/yyyy' then
      sDateformat := '%d/%m/%Y';
   if LowerCase(formatSettings.ShortDateFormat) = 'd/m/yyyy' then
      sDateformat := '%d/%m/%Y';
   WriteCmd('DateFormat:'+LowerCase(formatSettings.ShortDateFormat));

   lcid := inttostr(SysLocale.DefaultLCID);
   WriteCmd('LanguageID:' + lcid);
   if lcid = '1031' then
   begin
      sMsg1 := 'Workflow: Dokument wurde in Bearbeitung gesetzt.';
      sMsg2 := 'Workflow: Wiedervorlage angelegt:';
      sMsg3 := '  Bearbeiter:';
      sMsg4 := '  Termin: ';
      sMsg5 := ' Wiedervorlage-Status: offen';
      sMsg6 := 'Dokument mit [';
      sMsg7 := '] automatisch verknpft';
      sMsg8 := ' Gruppe:';
      sMsg9 := 'Verknpfung [';
      sMsg10 := '] automatisch angelegt';
   end
   else
   begin
      sMsg1 := 'Workflow: Document was set in editing.';
      sMsg2 := 'Workflow: Created resubmission';
      sMsg3 := '  Editor:';
      sMsg4 := '  Date: ';
      sMsg5 := ' Resubmission status: open';
      sMsg6 := 'Document linked with [';
      sMsg7 := '] automatically';
      sMsg8 := ' Group:';
      sMsg9 := 'Link [';
      sMsg10 := '] created';
   end;


   job := TIniFile.Create(ParamStr(1));
   sVtxFile := TStringList.Create;
   sSlwFile := TStringList.Create;
   dm_DBImp := Tdm_DBImp.Create(nil);
   // Try-Finally Try-Except starten
   try
      try
         // Auslesen der JOB Datei
         tglistsec := TStringList.Create;
         job.readsections(tglistsec);

         with job do
         begin
            // Auf Version 3.0 berprfen
            sgVersion := ReadString('Version', 'Version', '');
            if Copy(sgVersion, 1, 1) <> '3' then
            begin
               ExitCode := 3;  // Falsche Version der JOB Datei
               WriteCMD('Fehler: Falsche Version der JOB Datei!');
               exit;
            end;
            sProfil := ExtractFilePath(ParamStr(0)) +
               ReadString('Archiv', 'Profil', '') + '.con';
            sGArcName := ReadString('Archiv', 'Name', '');
            sGTblName := ReadString('Archiv', 'Tabelle', '');
            sDocID := ReadString('Document', 'DocID', '');
            gigdocid := Readinteger('Document', 'gdoc_id', 0);
            sDocTitel := ReadString('Document', 'Titel', '');
            sDocOrg := StringReplace(ReadString('Document', 'Orginal', ''),
               '\', '\\', [rfReplaceAll]);
            sDocKopie := StringReplace(ReadString('Document', 'Kopie', ''),
               '\', '\\', [rfReplaceAll]);
            if ValueExists('Document', 'Quelle') then
               sDocQuelle := StringReplace(ReadString('Document', 'Quelle', ''),
                  '\', '\\', [rfReplaceAll])
            else
               sDocQuelle := '';
            sDocUsr := ReadString('Document', 'Benutzer', '');
            sDocVTX := ReadString('Document', 'Volltext', '');
            sDocState := ReadString('Document', 'Status', '0');
            sDocStateText := ReadString('Document', 'StatStr', '');
            sDocOCR := ReadString('Document', 'OCR_QF', '0');
            sDocSLW := ReadString('Document', 'Schlagworte', '');
            sDocDate := ReadString('Document', 'Datum', '');
            //svn
            sSvnLink := ReadString('SVN', 'SVN_Link', '');
            sSvnVersion := ReadString('SVN', 'SVN_Version', '');
            sSvnRevision := ReadString('SVN', 'SVN_Revision', '');
            sSvnDatum := ReadString('SVN', 'SVN_Datum', '');
            sSvnInfo := ReadString('SVN', 'SVN_Info', '');

            sSha1 := ReadString('Hash', 'SHA1', '');

            sTermin := ReadString('Tasks', 'Termin', '');
            sAlarm := ReadString('Tasks', 'Alarm', '');
            sWorker := ReadString('Tasks', 'Bearbeiter', '');
            sNotiz := ReadString('Tasks', 'Notiz', '');
            giTimerOptionen := ReadInteger('Tasks', 'TimerOptionen', 0);
            // Zusatz Felder einlesen...
            iFieldCount := ReadInteger('Zusatzfelder', 'Felder', 0);
            if iFieldCount > 0 then
            begin
               SetLength(aZusFeld, iFieldCount + 1);
               SetLength(aZusWert, iFieldCount + 1);
               for iField := 1 to iFieldCount do
               begin
                  aZusFeld[iField] :=
                     ReadString('Zusatzfelder', 'ZusFeld' + IntToStr(iField), '');
                  aZusWert[iField] :=
                     ReadString('Zusatzfelder', 'ZusWert' + IntToStr(iField), '');
               end;
            end;
            // Referenzen einlesen
            iRefCount := ReadInteger('Referenz', 'Anzahl', 0);
            if iRefCount > 0 then
            begin
               SetLength(aDocRef, iRefCount + 1);
               for iField := 1 to iRefCount do
                  aDocRef[iField] := ReadString('Referenz', 'Referenz' + IntToStr(iField), '');
            end;

            // keine Text oder SLW Datei ? dann mit leerem Inhalt weiter
            if sDocVtx <> '' then
            begin
               if FileAccessable(sDocVtx) then
                  sVtxFile.LoadFromFile(sDocVtx)
               else
                  sVtxFile.Text := '';
            end;

            if sDocSLW <> '' then
            begin
               if FileAccessable(sDocSLW) then
                  sSlwFile.LoadFromFile(sDocSLW)
               else
                  sSlwFile.Text := '';
            end;
            sVtxFile.Text := StringReplace(sVtxFile.Text, '\', '\\', [rfReplaceAll]);
            sSlwFile.Text := StringReplace(sSlwFile.Text, '\', '\\', [rfReplaceAll]);

            // hier noch parsen und auf die lngen einzelner variabeln achten

            sDocTitel := LeftStr(sDocTitel, 255);
            if iFieldCount > 0 then
            begin
               for iField := 1 to iFieldCount do
               begin
                  aZusWert[iField] := Trim(ParseAddfields(aZusWert[iField]));
                  aZusWert[iField] := LeftStr(aZusWert[iField], 255);
               end;
            end;

            if iRefCount > 0 then
            begin
               for iField := 1 to iRefCount do
               begin
                  aDocRef[iField] := Trim(ParseAddfields(aDocRef[iField]));
                  aDocRef[iField] := LeftStr(aDocRef[iField], 255)
               end;
            end;

            if (Length(sDocOrg) > 255) Or (Length(sDocKopie) > 255) Or (Length(sDocQuelle) > 255) then
            begin
               //
               ExitCode := 11; //Fehler: Pfadlnge berschritten
               WriteCMD('Fehler: Pfadlnge berschritten (255)');
               exit;
            end;

            // wenn wir schon eine gdocid ausgelesen haben, dann sollten wir diese
            // auch behalten
            iGblDocID := gigdocid;


            // Datenbank Import
            if not ConnectDB then
               exit;
            // when is docid set before insertsql?
            if ((sTermin <> '') and (sDocID <> '')) then
            begin
               Get_OldStatus();
               InsertTask();
            end
            else
            if sDocID <> '' then
            begin
               if not UpdateSQL then
               begin
                  ExitCode := 8; //Update der Datenbank fehlgeschlagen
                  WriteCMD('Fehler: Update der Datenbank fehlgeschlagen');
               end;
            end
            else
            begin
               if not InsertSQL then
               begin
                  ExitCode := 9; //Es konnte kein neuer Eintrag erzeugt werden
                  WriteCMD('Fehler: Es konnte kein neuer Eintrag erzeugt werden');
               end;
            end;

            //svn
            if sSvnRevision <> '' then
            begin
               if not InsertSVN then
               begin
                  ExitCode := 10; //Es konnte kein SVN-Eintrag erzeugt werden
                  WriteCMD('Fehler: Es konnte kein SVN-Eintrag erzeugt werden');
               end;
            end;

            WriteCMD('DocID:' + IntToStr(iArcID) + '.' + IntToStr(idocid));
            WriteCMD('WfID:' + IntToStr(iWvlID));
            WriteCMD('gdoc_id:' + IntToStr(iGblDocID));

            if idocid > 0 then
            begin
               job.WriteString('Document', 'DocID', IntToStr(iArcID) + '.' + IntToStr(idocid));
               job.WriteString('Document', 'gdoc_id', IntToStr(iGblDocID));
               job.UpdateFile;
               sVtxFile.Clear;
               WriteCMD('Das Dokument wurde erfolgreich archiviert.');
            end
            else
            begin
               WriteCMD('Bei der Archivierung in die Datenbank trat ein Fehler auf.');
               ExitCode := 8;  //Update der Datenbank fehlgeschlagen
            end;
         end;
      except
         on e: Exception do
         begin
            ExitCode := 255;
            WriteCMD('Fehler: Folgender Fehler ist aufgetreten: ' + e.Message);
         end;
      end;
   finally
      dm_DBImp.my_Con.Disconnect;
      if Assigned(job) then
         FreeAndNil(job);
      if Assigned(sVtxFile) then
         FreeAndNil(sVtxFile);
      if Assigned(sSlwFile) then
         FreeAndNil(sSlwFile);
      if Assigned(dm_DBImp) then
         dm_DBImp.Free;
   end;
end.
