unit u_Functions;

interface

uses
   Windows, SysUtils;

function EnCrypt(InputStr, HexKeyStr: string): string;
function DeCrypt(HexInputStr, HexKeyStr: string): string;
function SetSystemVariable(const Name, Wert: string): boolean;
function GetSystemVariable(const Name: string): string;

implementation

function EnCrypt(InputStr, HexKeyStr: string): string;
   //////////////////////////////////////////////////////////////////
   ///  10.04.2005 Erstellt EnCrypt by SV.                        ///
   ///                                                            ///
   ///  Diese Funktion erzeugt aus dem InputStr einen mit         ///
   ///  HexKeyStr verschlsselten HexString (einfaches XOR)       ///
   ///                                                            ///
   ///  Format: String aus Hexadezimalzahlen                      ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCntIStr, iCntKStr: integer;
begin
   iCntIStr := 1;
   iCntKStr := 1;
   Result := '';
   while iCntIStr < (Length(InputStr) + 1) do
   begin
      Result := Result + IntToHex((Ord(InputStr[iCntIStr]) xor
         StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))), 2);
      Inc(iCntIStr, 1);
      Inc(iCntKStr, 2);
   end;
end;

function DeCrypt(HexInputStr, HexKeyStr: string): string;
   //////////////////////////////////////////////////////////////////
   ///  10.04.2005 Erstellt DeCrypt by SV.                        ///
   ///                                                            ///
   ///  Diese Funktion erzeugt aus dem HexInputStr einen mit      ///
   ///  HexKeyStr entschlsselten String (einfaches XOR)          ///
   ///                                                            ///
   ///  Format: Entschlsselter String                            ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCntIStr, iCntKStr: integer;
begin
   iCntIStr := 1;
   iCntKStr := 1;
   Result := '';
   while iCntIStr < (Length(HexInputStr) + 1) do
   begin
      Result := Result + chr((StrToInt('$' + copy(HexInputStr, iCntIStr, 2)) xor
         StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))));
      Inc(iCntIStr, 2);
      Inc(iCntKStr, 2);
   end;
end;

function SetSystemVariable(const Name, Wert: string): boolean;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 06.06.2005 by SV                           ///
   ///                                                       ///
   ///   Setzt eine Systemvariable auf einen neuen Wert      ///
   ///                                                       ///
   ///   Parameter:  Name          Name der Systemvariable   ///
   ///               Wert          Wert der Systemvariable   ///
   ///                                                       ///
   ///   Rckgabe:   True          bei Erfolg                ///
   ///               False         bei Fehlschlag            ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   Result := SetEnvironmentVariable(PChar(Name), PChar(Wert));
end;

function GetSystemVariable(const Name: string): string;
   /////////////////////////////////////////////////////////////
   ///   Erstellt 06.06.2005 by SV                           ///
   ///                                                       ///
   ///   Liest eine Systemvariable aus                       ///
   ///                                                       ///
   ///   Parameter:  Name          Name der Systemvariable   ///
   ///                                                       ///
   ///   Rckgabe:   String mit Wert der Systemvariable      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   SetLength(Result, 255);
   SetLength(Result, GetEnvironmentVariable(PChar(Name), PChar(Result), 255));
end;

end.
