unit u_Info;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, jpeg, ExtCtrls, ShellAPI;

function GetVersionInfo: string;

type
  Tfrm_Info = class(TForm)
    img_Logo: TImage;
    lbl_Info1: TLabel;
    lbl_Info2: TLabel;
    lbl_Info3: TLabel;
    lbl_Info4: TLabel;
    lbl_Info5: TLabel;
    lbl_Info8: TLabel;
    btn_ShowLiz: TButton;
    lbl_URL: TLabel;
    lbl_Info6: TLabel;
    procedure btn_CloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btn_ShowLizClick(Sender: TObject);
    procedure lbl_URLClick(Sender: TObject);
    procedure lbl_URLMouseEnter(Sender: TObject);
    procedure lbl_URLMouseLeave(Sender: TObject);
    procedure lbl_Info6Click(Sender: TObject);
    procedure lbl_Info6MouseEnter(Sender: TObject);
    procedure lbl_Info6MouseLeave(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frm_Info: Tfrm_Info;

implementation

uses u_Rights;

{$R *.dfm}

function GetVersionInfo: string;
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    result := IntTostr(dwFileVersionMS shr 16);
    result := result + '.' + IntTostr(dwFileVersionMS and $FFFF);
    result := result + '.' + IntTostr(dwFileVersionLS shr 16);
    result := result + '.' + IntTostr(dwFileVersionLS and $FFFF);
  end;
  FreeMem(VerInfo, VerInfoSize);
end;


procedure Tfrm_Info.btn_CloseClick(Sender: TObject);

begin
  frm_Info.Destroy;
end;

procedure Tfrm_Info.FormClose(Sender: TObject; var Action: TCloseAction);
var alpha : Integer;
begin
  {
  for alpha := 255 downto 0 do
  begin
    frm_Info.AlphaBlendValue := alpha;
    Application.ProcessMessages;
    //sleep(1);
  end;
  }
  frm_Info.Release;
end;

procedure Tfrm_Info.FormShow(Sender: TObject);
begin
  lbl_Info1.Caption := 'bitfarm Archiv V3 Dokument Cutter ' + GetVersionInfo + ' (GPL)';
end;

procedure Tfrm_Info.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_escape then frm_Info.Close;
end;

procedure Tfrm_Info.btn_ShowLizClick(Sender: TObject);
begin
  Application.CreateForm(Tfrm_Rights, frm_Rights);
  frm_Rights.ShowModal;
  frm_Rights.Release;
end;

procedure Tfrm_Info.lbl_URLClick(Sender: TObject);
begin
  ShellExecute(0, Nil, PChar('http://www.bitfarm-archiv.com'), Pchar(''), Pchar(''), SW_NORMAL);
end;

procedure Tfrm_Info.lbl_URLMouseEnter(Sender: TObject);
begin
  lbl_URL.Font.Color := clSkyBlue;
end;

procedure Tfrm_Info.lbl_URLMouseLeave(Sender: TObject);
begin
  lbl_URL.Font.Color := clBlue;
end;

procedure Tfrm_Info.lbl_Info6Click(Sender: TObject);
begin
   ShellExecute(0, Nil, PChar('http://sourceforge.net/projects/bitfarm-archiv/support'), Pchar(''), Pchar(''), SW_NORMAL);
end;

procedure Tfrm_Info.lbl_Info6MouseEnter(Sender: TObject);
begin
    lbl_Info6.Font.Color := clSkyBlue;
end;

procedure Tfrm_Info.lbl_Info6MouseLeave(Sender: TObject);
begin
    lbl_Info6.Font.Color := clBlue;
end;

end.
