unit u_Main;

interface

uses
  gnugettext,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, StdCtrls, ieview, imageenview, Menus, ImgList,
  IniFiles, XPMan, ExtCtrls, JvExExtCtrls, JvExtComponent, JvFooter, u_ShBase, u_ShLowUtils;

function GetStringFromResource(Name: String): String;

type
  Tfrm_DocCut = class(TForm)
    mnu_Main: TMainMenu;
    mnu_File: TMenuItem;
    mnu_Edit: TMenuItem;
    mnu_Help: TMenuItem;
    mnu_Info: TMenuItem;
    mnu_LoadCUT: TMenuItem;
    mnu_N1: TMenuItem;
    mnu_End: TMenuItem;
    mnu_CreCUT: TMenuItem;
    mnu_DelCut: TMenuItem;
    mnu_RenCUT: TMenuItem;
    img_Doc: TImageEnView;
    img_Cut: TImageEnView;
    lbl_DocTemplate: TLabel;
    lbl_CutPreView: TLabel;
    lb_CutList: TListBox;
    edt_CutName: TEdit;
    tlb_Tools: TToolBar;
    tbtn_CutSave: TToolButton;
    tbtn_CutRen: TToolButton;
    tbtn_CutDel: TToolButton;
    tbtn_Zoom100: TToolButton;
    ToolButton5: TToolButton;
    tbtn_BestFit: TToolButton;
    stb_Main: TStatusBar;
    mnu_DocLoad: TMenuItem;
    Label1: TLabel;
    il_Main: TImageList;
    mnu_NewCut: TMenuItem;
    XPMan: TXPManifest;
    tbtn_CutRot: TToolButton;
    ToolBar1: TToolBar;
    tbtn_DocView100: TToolButton;
    btn_DocViewFit: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    procedure tbtn_CutSaveClick(Sender: TObject);
    procedure img_DocSelectionChange(Sender: TObject);
    procedure mnu_DocLoadClick(Sender: TObject);
    procedure lb_CutListClick(Sender: TObject);
    procedure tbtn_BestFitClick(Sender: TObject);
    procedure tbtn_Zoom100Click(Sender: TObject);
    procedure mnu_LoadCUTClick(Sender: TObject);
    procedure mnu_NewCutClick(Sender: TObject);
    procedure tbtn_CutRenClick(Sender: TObject);
    procedure tbtn_CutDelClick(Sender: TObject);
    procedure mnu_CreCUTClick(Sender: TObject);
    procedure mnu_RenCUTClick(Sender: TObject);
    procedure mnu_DelCutClick(Sender: TObject);
    procedure mnu_EndClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnu_InfoClick(Sender: TObject);
    procedure tbtn_CutRotClick(Sender: TObject);
    procedure tbtn_DocView100Click(Sender: TObject);
    procedure btn_DocViewFitClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure LoadCutFile;
  end;

var
  frm_DocCut: Tfrm_DocCut;
  sGCutFile: String;
  iGRotCount: Integer;

implementation

uses u_Info;

{$R *.dfm}
function GetStringFromResource(Name: String): String;
//////////////////////////////////////////////////////////////////
///  02.05.2005 Erstellt by SV.                                ///
///                                                            ///
///  Diese Funktion liest die Kompilierte Resource in 'Name'   ///
///  aus und liefert ihren Inhalt als Delphi String            ///
///                                                            ///
///  Ausgabe: String                                           ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
  with TResourceStream.Create(HInstance, Name, RT_RCDATA) do
  try
    SetLength(Result, Size);
    Read(Result[1], Size);
  finally
    Free;
  end;
end;

procedure Tfrm_DocCut.LoadCutFile;
var ini: TIniFile;
begin
  ini := TIniFile.Create(sGCutFile);
  Try
    try
      lb_CutList.Clear;
      ini.ReadSections(lb_CutList.Items);
    except
      on e: exception do
      	ShowMessage(_('Fehler beim Einlesen der Sektionen in ') + sGCutFile + ': ' + e.Message);
    end;
  finally
    if Assigned(ini) then FreeAndNil(ini);
  end;
end;

procedure Tfrm_DocCut.tbtn_CutSaveClick(Sender: TObject);
var
  ini: TIniFile;
  cutname:string;
  bSaved: Boolean;
begin
  if sGCutFile = '' then
  begin
    ShowMessage(_('Sie mssen erst eine Schnittliste laden oder neu erstellen!') + #13 +_('Men [Datei] -> [Neue Schnittliste] oder [Schnittliste laden]'));
    exit;
  end;

  if not img_Doc.Selected then Exit;
  
  cutname:=edt_CutName.Text;
  if edt_CutName.Text = '' then
  begin
    cutname :=  'Cut_' + IntToStr(lb_CutList.Count);
    if not InputQuery(_('Neue Schnittmarke anlegen...'),_('Bitte geben Sie einen Namen fr die neue Schnittmarke ein:'),cutname) then Exit;
    if cutname = '' then Exit;
  end;


  edt_CutName.Text := cutname;
  if lb_CutList.Items.IndexOf(edt_CutName.Text) = -1 then lb_CutList.Items.Insert(lb_CutList.ItemIndex, edt_CutName.Text);
  ini := TIniFile.Create(sGCutFile);
  Try
    try
      ini.WriteInteger(edt_CutName.Text, 'Left', img_Doc.SelX1);
      ini.WriteInteger(edt_CutName.Text, 'Top', img_Doc.SelY1);
      ini.WriteInteger(edt_CutName.Text, 'Width', img_Doc.SelX2 - img_Doc.SelX1);
      ini.WriteInteger(edt_CutName.Text, 'Height', img_Doc.SelY2 - img_Doc.SelY1);
      ini.WriteInteger(edt_CutName.Text, 'Rotation', iGRotCount);
      bSaved:=True;
    except
      on e: exception do
      begin
        ShowMessage(_('Fehler beim Schreiben in ') + sGCutFile + ': ' + e.Message);
        bSaved:=False;
      end;

    end;
  finally
    if Assigned(ini) then FreeAndNil(ini);
  end;
  if       bSaved then
  begin
    stb_Main.Panels[14].Text := Format(_('Ausschnitt %s gespeichert.'),[edt_CutName.Text]);
    //edt_CutName.Text := '';
  end;

end;

procedure Tfrm_DocCut.img_DocSelectionChange(Sender: TObject);
begin
  if img_Doc.Selected then
  begin
    stb_Main.Panels[2].Text := IntToStr(img_Doc.SelX1);
    stb_Main.Panels[4].Text := IntToStr(img_Doc.SelY1);
    stb_Main.Panels[6].Text := IntToStr(img_Doc.SelX2 - img_Doc.SelX1);
    stb_Main.Panels[8].Text := IntToStr(img_Doc.SelY2 - img_Doc.SelY1);
    img_Doc.Proc.SelCopyToClip;
    img_Cut.Proc.SelPasteFromClip;
    iGRotCount := 0;
  end
  else
  begin
    stb_Main.Panels[2].Text := '';
    stb_Main.Panels[4].Text := '';
    stb_Main.Panels[6].Text := '';
    stb_Main.Panels[8].Text := '';
    img_Cut.Clear;
    img_Cut.Blank;
    edt_CutName.Text:='';
  end;

end;

procedure Tfrm_DocCut.mnu_DocLoadClick(Sender: TObject);
var sFileName, sFilter: String;
begin
  sFilter := _('TIFF Dateien (*.tif)|*.TIF;*.TIFF|') +
             _('JPEG Dateien (*.jpg)|*.jpg;*.jpeg|') +
             _('PNG Dateien (*.png)|*.png|') +
             _('Alle Bild Formate|*.tif;*.tiff;*.jpeg;*.jpg;*.png;*.gif;*.bmp;*.jp2|') +
             _('Alle Dateien (*.*)|*.*');

  if PromptForFileName(sFileName, sFilter, 'TIF', _('Bitte whlen Sie ein Bild als Vorlage aus...'), '', False) then
  begin
    img_Doc.IO.LoadFromFile(sFileName);

    btn_DocViewFitClick(self);
    img_DocSelectionChange(Self);
    lbl_DocTemplate.Caption:=_('Dokumentenvorlage:')+' '+ ExtractFileName(sFileName);
    stb_Main.Panels[10].Text := inttostr(img_Doc.DpiX);
    stb_Main.Panels[12].Text := inttostr(img_Doc.DpiY);
    //todo: Anzeige aktualisieren Vorschau
  end;
end;

procedure Tfrm_DocCut.lb_CutListClick(Sender: TObject);
var iCount, x1, x2, y1, y2, iRot: Integer;
    ini: TIniFile;
begin
  For iCount := 0 to lb_CutList.Count - 1 do
  begin
    if lb_CutList.Selected[iCount] then
    begin
      edt_CutName.Text := lb_CutList.Items.Strings[iCount];
      ini := TIniFile.Create(sGCutFile);
      Try
        try
          X1 := ini.ReadInteger(edt_CutName.Text, 'Left', 0);
          Y1 := ini.ReadInteger(edt_CutName.Text, 'Top', 0);
          X2 := X1 + ini.ReadInteger(edt_CutName.Text, 'Width', 0);
          Y2 := Y1 + ini.ReadInteger(edt_CutName.Text, 'Height', 0);
          iRot := ini.ReadInteger(edt_CutName.Text, 'Rotation', 0);
          img_Doc.Select(x1, y1, x2, y2);
          img_Doc.OnSelectionChange(self);
          img_Cut.Proc.Rotate(90 * iRot);
        except
          on e: exception do ShowMessage(_('Fehler beim Lesen aus ') + sGCutFile + ': ' + e.Message);
        end;
      finally
        if Assigned(ini) then FreeAndNil(ini);
        stb_Main.Panels[14].Text:=_('Schnittmarke:')+' ' + edt_CutName.Text;
      end;

      break;
    end;
  end;
end;

procedure Tfrm_DocCut.tbtn_BestFitClick(Sender: TObject);
begin
  if tbtn_Zoom100.Down then
  begin
    tbtn_Zoom100.Down := False;
    tbtn_BestFit.Down := True;
    img_Cut.AutoFit := True;
    img_Cut.AutoStretch := True;
    img_Cut.AutoShrink := True;
  end else tbtn_BestFit.Down := True;
  img_Cut.Fit;
end;

procedure Tfrm_DocCut.tbtn_Zoom100Click(Sender: TObject);
begin
  if tbtn_BestFit.Down then
  begin
    tbtn_Zoom100.Down := True;
    tbtn_BestFit.Down := False;
    img_Cut.AutoFit := False;
    img_Cut.AutoStretch := False;
    img_Cut.AutoShrink := False;
    img_Cut.Zoom := 100;
  end else tbtn_Zoom100.Down := True;
end;

procedure Tfrm_DocCut.mnu_LoadCUTClick(Sender: TObject);
begin
  if PromptForFileName(sGCutFile, _('Schnittlisten (*.CUT)|*.CUT'), 'CUT', _('Schnittliste laden...'), '', False) then
  begin
    LoadCutFile;
    stb_Main.Panels[14].Text := Format(_('Neue Schnittliste [%s] eingelesen.'),[ExtractFileName(sGCutFile)]);
    img_Cut.Clear;
    img_Cut.Blank;
    img_Doc.DeSelect;
  end;
end;

procedure Tfrm_DocCut.mnu_NewCutClick(Sender: TObject);
begin
  if PromptForFileName(sGCutFile, _('Schnittlisten (*.CUT)|*.CUT'), 'CUT', _('Neue Schnittliste erstellen...'), '', True) then
  begin
    stb_Main.Panels[14].Text := Format(_('Neue Schnittliste [%s] erstellt.'),[ExtractFileName(sGCutFile)]);
    edt_CutName.Text := '';
    img_Cut.Clear;
    img_Cut.Blank;
    img_Doc.DeSelect;
    lb_CutList.Clear;
  end;

end;

procedure Tfrm_DocCut.tbtn_CutRenClick(Sender: TObject);
var ini: TIniFile;
    sNewName, sOldName, sTempName: String;
    bRenamed:Boolean;
begin
  if (sGCutFile = '') or (edt_CutName.Text = '') then exit;
  sTempName := edt_CutName.Text;
  sOldName := edt_CutName.Text;

  if not InputQuery(_('Schnittmarke umbenennen'), _('Bitte geben Sie eine neue Bezeichnung fr die Schnittmarke ein:'), sTempName) then Exit;
  if sTempName = '' then Exit;
  sNewName:= STempName;

  ini := TIniFile.Create(sGCutFile);
  Try
    try
      if not ini.SectionExists(sOldName) then Exit;
      if not ini.SectionExists(sNewName) then
      begin
        ini.WriteInteger(sNewName, 'Top', ini.ReadInteger(sOldName, 'Top', 0));
        ini.WriteInteger(sNewName, 'Left', ini.ReadInteger(sOldName, 'Left', 0));
        ini.WriteInteger(sNewName, 'Width', ini.ReadInteger(sOldName, 'Width', 0));
        ini.WriteInteger(sNewName, 'Height', ini.ReadInteger(sOldName, 'Height', 0));
        ini.EraseSection(sOldName);
        lb_CutList.Clear;
        ini.ReadSections(lb_CutList.Items);
        bRenamed:=True;
      end
      else
      begin
       ShowMessage(_('Es existiert bereits eine Schnittmarke mit dieser Bezeichnung!'));
       bRenamed:=False
       end;
    except
      on e: exception do ShowMessage(_('Fehler beim Lschen einer Section in ') + sGCutFile + ': ' + e.Message);
    end;
  finally
    if Assigned(ini) then FreeAndNil(ini);

  end;
  if bRenamed then
  begin
    stb_Main.Panels[14].Text :=Format(_('Ausschnitt %s in %s umbenannt.'),[sOldName,sNewName]);
    edt_CutName.Text := sNewName;
  end;

end;

procedure Tfrm_DocCut.tbtn_CutDelClick(Sender: TObject);
var ini: TIniFile;
begin
  if (sGCutFile = '') or (edt_CutName.Text = '') then exit;
  ini := TIniFile.Create(sGCutFile);
  Try
    try
      if not ini.SectionExists(edt_CutName.Text) then Exit;
      ini.EraseSection(edt_CutName.Text);
      lb_CutList.Clear;
      ini.ReadSections(lb_CutList.Items);
    except
      on e: exception do ShowMessage(_('Fehler beim Lschen einer Section in ') + sGCutFile + ': ' + e.Message);
    end;
  finally
    if Assigned(ini) then FreeAndNil(ini);
  end;
  stb_Main.Panels[14].Text := Format(_('Ausschnitt %s entfernt.'),[ edt_CutName.Text]);
  edt_CutName.Text := '';
  img_Cut.Clear;
  img_Cut.Blank;
  img_Doc.DeSelect;
end;

procedure Tfrm_DocCut.mnu_CreCUTClick(Sender: TObject);
begin
  tbtn_CutSaveClick(self);  
end;

procedure Tfrm_DocCut.mnu_RenCUTClick(Sender: TObject);
begin
  tbtn_CutRenClick(self);
end;

procedure Tfrm_DocCut.mnu_DelCutClick(Sender: TObject);
begin
  tbtn_CutDelClick(self);
end;

procedure Tfrm_DocCut.mnu_EndClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure Tfrm_DocCut.FormCreate(Sender: TObject);
var
   icount, iPos: integer;
   lsPar, lsParL, lsParCom, lsParVal, lsLanguage, lsLangPath, lsArcId: string;
begin
  sGCutFile := '';

	for icount := 0 to paramcount do
   begin
      lsPar := ParamStr(icount);
      lsParL := lowercase(lsPar);
      iPos := Pos(':',lsParL);
      if iPos = 0 then
         iPos := maxint-1;
      lsParCom := Copy(lsParL,1,iPos-1); // das vor dem Doppelpunkt (oder alles wenn keiner)
      lsParVal := Copy(lsParL,iPos+1,maxint); // das vor nach Doppelpunkt (oder nix wenn keiner)

      if lsParCom = '-lang' then   //z.B. "-lang:en"
         begin lsLanguage := lsParVal; Continue; end;
      if lsParCom = '-langpath' then   //z.B. "-lang:en"
         begin lsLangPath := lsParVal; Continue; end;

   end;

   GnugettextTextdomain('DocCutV3', lsLangPath, lsLanguage);


  TranslateComponent(self);
end;

procedure Tfrm_DocCut.mnu_InfoClick(Sender: TObject);
begin
  Application.CreateForm(Tfrm_Info, frm_Info);
  frm_Info.ShowModal;
  frm_Info.Release;
end;

procedure Tfrm_DocCut.tbtn_CutRotClick(Sender: TObject);
begin
  img_Cut.Proc.Rotate(90);
  inc(iGRotCount);
end;


procedure Tfrm_DocCut.tbtn_DocView100Click(Sender: TObject);
begin

    if btn_DocViewFit.Down then
    begin
      tbtn_DocView100.Down := True;
      btn_DocViewFit.Down := False;
      img_Doc.AutoFit := False;
      img_Doc.AutoStretch := False;
      img_Doc.AutoShrink := False;
      img_Doc.Zoom := 100;
    end else  tbtn_DocView100.Down := True;
end;

procedure Tfrm_DocCut.btn_DocViewFitClick(Sender: TObject);
begin
    if tbtn_DocView100.Down then
  begin
    tbtn_DocView100.Down := False;
    btn_DocViewFit.Down := True;
    img_Doc.AutoFit := True;
    img_Doc.AutoStretch := True;
    img_Doc.AutoShrink := True;
  end else btn_DocViewFit.Down := True;
  img_Doc.Fit;
    
end;

procedure Tfrm_DocCut.ToolButton3Click(Sender: TObject);
var z: Double;
begin
  z:=  img_Doc.Zoom ;
  if z < 100 then
  begin
    img_Doc.AutoFit := False;
    img_Doc.AutoStretch := False;
    img_Doc.AutoShrink := False;
    z := z +7;
    img_Doc.Zoom := z;
  end;
end;

procedure Tfrm_DocCut.ToolButton4Click(Sender: TObject);
var z: Double;
begin
  z:=  img_Doc.Zoom ;
  if z > 10 then
  begin
    img_Doc.AutoFit := False;
    img_Doc.AutoStretch := False;
    img_Doc.AutoShrink := False;
    z := z -7;
    img_Doc.Zoom := z;
  end;
end;



end.


