program FilterV3;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  Igel0703081313 Der Parameter zur Qualitaetsbestimmung wurde nicht beruecksitigt
//  Igel0703081123 Erweiterung um die Funktion zum Comprimieren von JPEG Bildern

//
{$APPTYPE CONSOLE}

uses
  SysUtils, imageenproc, ImageEnView, Classes,Windows, hyieUtils, hyiedefs, ImageEnIO, strutils;

{$R *.res}

var img: TImageEnView;
    slFilterList: TStrings;
    iFlt, iPos, iPage, iFirst, iLast: Integer;
    sCmd, sPrm, sFirst, sLast,sSavename: String;
    gdbg:boolean;
    rfResample:TResampleFilter;

Function  AnsiToConCP(Const AString: String): String;
Var
  lResult: String;
Begin
  SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
  {$ELSE}
  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
  Result := lResult;
End;

Function WriteCmd(strtext: String):STring ;
  begin
  strtext:= AnsiToConCP(strtext);
  WriteLN(strtext);
End;


procedure FltRed;
begin
  if img.IEBitmap.PixelFormat = ie1g then exit;
  img.IEBitmap.AssignImage(img.Proc.GetRGBChannel(2));
  img.Update;
end;

procedure FltGreen;
begin
  if img.IEBitmap.PixelFormat = ie1g then exit;
  img.IEBitmap.AssignImage(img.Proc.GetRGBChannel(1));
  img.Update;
end;

procedure FltBlue;
begin
  if img.IEBitmap.PixelFormat = ie1g then exit;
  img.IEBitmap.AssignImage(img.Proc.GetRGBChannel(0));
  img.Update;
end;

procedure FltRot(Rot: String);
begin
  img.Proc.Rotate(StrToInt(Rot), True, ierFast, -1);
end;

procedure FltPix(Pix: String);
begin
  img.Proc.RemoveIsolatedPixels(0, StrToInt(Pix));
end;

procedure FltContr(Contr: String);
begin
  img.Proc.Contrast(StrToInt(Contr));
end;

procedure FltBright(Bright: String);
begin
  img.Proc.IntensityRGBall(StrToInt(Bright), StrToInt(Bright), StrToInt(Bright));
end;

procedure FltSkew(skew: String);
begin
  if skew = 'auto' then
     img.Proc.Rotate(img.Proc.SkewDetection(0, 45, 0.1, True), True, ierFast, -1)
  else
     img.Proc.Rotate(img.Proc.SkewDetectionFine(0, 0.1, StrToInt(skew), True), false, ierFast, -1);
end;

procedure FltRes(Res: String; rfResample: TResampleFilter);
begin
  img.ChangeResolution(StrToInt(Res), rfFastLinear);
end;


procedure setfilter(filter:String);
begin
  filter:=LowerCase(filter);
  if filter = 'none' then rfResample:= rfNone;
  if filter = 'triangle' then rfResample:= rfTriangle;
  if filter = 'hermite' then rfResample:= rfHermite;
  if filter = 'bell' then rfResample:= rfBell;
  if filter = 'bspline' then rfResample:= rfBSpline;
  if filter = 'lanczos3' then rfResample:= rfLanczos3;
  if filter = 'mitchell' then rfResample:= rfMitchell;
  if filter = 'nearest' then rfResample:= rfNearest;
  if filter = 'linear' then rfResample:= rfLinear;
  if filter = 'fastlinear' then rfResample:= rfFastLinear;
  if filter = 'bilinear' then rfResample:= rfBilinear;
  if filter = 'bicubic' then rfResample:= rfBicubic;
  if filter = 'projectbw' then rfResample:= rfProjectBW;
  if filter = 'projectwn' then rfResample:= rfProjectWB;

end;


procedure FltBW(BW: String);
begin
  //img.Proc.ConvertToGray;
  img.Proc.ConvertToBWThreshold(StrToInt(BW));
  img.IEBitmap.PixelFormat := ie1g;
  img.IO.Params.SamplesPerPixel := 1;
  img.IO.Params.BitsPerSample := 1;
  img.IO.Params.TIFF_Compression := ioTIFF_G4FAX;
end;

procedure FltGray;
begin
  img.Proc.ConvertToGray;
  img.IO.Params.SamplesPerPixel := 1;
  img.IO.Params.BitsPerSample := 8;
  img.IO.Params.TIFF_Compression := ioTIFF_LZW;
end;

procedure FltDither;
begin
  img.Proc.ConvertToGray;
  img.Proc.ConvertToBW_FloydSteinberg;
end;

procedure FltWhite;
begin
  img.Proc.WhiteBalance_AutoWhite;
end;

procedure FltJPEG(Comp: String);
begin
  writeCMD ('JPEG Kompressionsrate = '+Comp);
  img.IEBitmap.PixelFormat := ie24RGB;
  img.IO.Params.SamplesPerPixel := 3;
  img.IO.Params.BitsPerSample := 8;
  img.IO.Params.TIFF_Compression := ioTIFF_JPEG;
  img.IO.Params.TIFF_JPEGQuality := StrToInt(Comp);
  img.IO.Params.JPEG_Quality := StrToInt(Comp);
end;

procedure FltLZW;
begin
  img.IEBitmap.PixelFormat := ie24RGB;
  img.IO.Params.SamplesPerPixel := 3;
  img.IO.Params.BitsPerSample := 8;
  img.IO.Params.TIFF_Compression := ioTIFF_LZW;
end;

procedure FltAutoComp(Comp: String);
var iCol: Integer;
    iPer: Double;
    rgb: TRGB;
begin
  if gdbg then
  begin
    WriteLn('calc number of colors '+Comp+'.');
  end;

  iCol := img.Proc.CalcImageNumColors;
  if gdbg then
  begin
    WriteLn('ncolrs '+inttostr(iCol));
  end;
  case iCol of
    1..2:     begin
                img.IEBitmap.PixelFormat := ie1g;
                img.IO.Params.SamplesPerPixel := 1;
                img.IO.Params.BitsPerSample := 1;
                img.IO.Params.TIFF_Compression := ioTIFF_G4FAX;
              end;
    3..16:    begin
                img.IEBitmap.PixelFormat := ie8p;
                img.IO.Params.SamplesPerPixel := 1;
                img.IO.Params.BitsPerSample := 4;
                img.IO.Params.TIFF_Compression := ioTIFF_LZW;
              end;
  else
    begin
      iPer := img.Proc.GetDominantColor(rgb);

      if gdbg then
      begin
        WriteLn('iPer '+floattostr(iPer));
      end;
    end;
    if iPer < 25 then
    begin
      img.IEBitmap.PixelFormat := ie24RGB;
      img.IO.Params.SamplesPerPixel := 3;
      img.IO.Params.BitsPerSample := 8;
      img.IO.Params.TIFF_JPEGQuality := StrToInt(Comp);
      img.IO.Params.TIFF_Compression := ioTIFF_JPEG;
    end
    else
    begin
      if iCol <= 256 then
      begin
        img.IEBitmap.PixelFormat := ie8p;
        img.IO.Params.SamplesPerPixel := 1;
        img.IO.Params.BitsPerSample := 8;
        img.IO.Params.TIFF_Compression := ioTIFF_LZW;
      end
      else
      begin
        img.IEBitmap.PixelFormat := ie24RGB;
        img.IO.Params.SamplesPerPixel := 3;
        img.IO.Params.BitsPerSample := 8;
        img.IO.Params.TIFF_Compression := ioTIFF_LZW;
      end;
    end;
  end;
end;

begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }
  ExitCode := 0;
  img := TImageEnView.Create(nil);
  img.IO.AsyncMode := False;
  img.IO.AutoAdjustDPI := True;
  slFilterList := TStringList.Create;
  rfResample:=rfFastLinear;
  WriteLn('bitfarm Archiv FilterV3');
  WriteLn('(c) 2011 bitfarm Informationssysteme GmbH, Siegen');
  try
    if (ParamCount < 3) or (Paramcount > 4) then
    begin
      WriteCMD('Nicht gengend Parameter: filterv3 <inputbild> <filterdatei> <outputbild>{-debug}');
      WriteLN;
      WriteLN ('Die Filterdatei ist zeilenweise aufzubauen.');
      WriteLN ('');
      WriteLN ('Filter1');
      WriteLN ('Filter2');
      WriteLN ('');
      WriteLN ('Der JPG Kompressionsfilter wird wie folgt angesteuert.');
      WriteLN ('Die Dateiendung der Quelldatei muss vom Typ .jpg sein ');
      WriteLN ('der Parameter in der Filterdatei lautet ');
      WriteCMD ('COMPJPEG={JPEG Kompressionsrate}');
      WriteLN ('');
      WriteCMD ('Die JPEG Kompressionsrate wird als eine ganze Zahl im Bereich von 1  bis 99 angegeben');
      WriteLN ('');

      {          if sCmd = 'RED' then FltRed;
          if sCmd = 'GREEN' then FltGreen;
          if sCmd = 'BLUE' then FltBlue;
          if sCmd = 'ROT' then FltRot(sPrm);
          if sCmd = 'REMPIX' then FltPix(sPrm);
          if sCmd = 'CONTR' then FltContr(sPrm);
          if sCmd = 'BRIGHT' then FltBright(sPrm);
          if sCmd = 'SKEW' then FltSkew(sPrm);
          if sCmd = 'RES' then FltRes(sPrm);
          if sCmd = 'BW' then FltBW(sPrm);
          if sCmd = 'GRAY' then FltGray;
          if sCmd = 'DITHER' then FltDither;
          if sCmd = 'WHITE' then FltWhite;
          if sCmd = 'COMPJPEG' then FltJPEG(sPrm);
          if sCmd = 'COMPLZW' then FltLZW;
          if sCmd = 'COMPAUTO' then FltAutoComp(sPrm);}

      exit;
    end;

    if fileexists(Paramstr(3)) then
    begin
        SysUtils.DeleteFile(Paramstr(3));
    end;



    try
      WriteLn('Untersuche zu filterndes Bild...');
      if FileExists(ParamStr(1)) then img.IO.ParamsFromFile(ParamStr(1))
      else ExitCode := 1;
      if lowercase(rightstr(ParamStr(1),4))<>'.jpg' then
      begin
        WriteCMD('Bild enthlt ' + IntToStr(img.IO.Params.TIFF_ImageCount) + ' Seite(n).');
      end
      else
      begin
        WriteLn ('JPEG Datei erkannt ');
      end ;
      if paramcount = 4 then
      begin
          gdbg:=true;
      end
      else
      begin
      gdbg:=false;
      end;
      WriteLn('Fertig. Lade Filterliste...');
      if FileExists(ParamStr(2)) then slFilterList.LoadFromFile(ParamStr(2))
      else ExitCode := 2;

      iFirst:= 0;
      iLast:= img.IO.Params.TIFF_ImageCount - 1;



      // einzelseiten separieren
      For iFlt := 0 to (slFilterList.Count - 1) do
      begin
        if gdbg then
        begin
          WriteLn(inttostr(iFlt)+':>> '+slFilterList.Strings[iFlt]);
        end;
          iPos := POS('=', slFilterList.Strings[iFlt]);
          if iPos = 0 then iPos := Length(slFilterList.Strings[iFlt]) + 1
          else sPrm := Copy(slFilterList.Strings[iFlt], iPos + 1, Length(slFilterList.Strings[iFlt]));
          sCmd := UpperCase(Copy(slFilterList.Strings[iFlt], 1, iPos - 1));
          if sCMD = 'SAVEPAGE' then
          begin
             if Pos('-',sPrm) <> 0 then
             begin
              sFirst:=Copy(sPrm,1,Pos('-',sPrm)-1);
              sLast:=Copy(sPrm,Pos('-',sPrm)+1,Length(sPrm) -Pos('-',sPrm));
              iFirst:=strtoint( sFirst);
              iLast:=strtoint(sLast);
              dec(iFirst);
              dec(iLast);

              if iLast > img.IO.Params.TIFF_ImageCount - 1 then
                iLast := img.IO.Params.TIFF_ImageCount - 1;

             end
             else
             begin
               iFirst:=strtoint(sPrm);
               dec(iFirst);
               if iFirst > img.IO.Params.TIFF_ImageCount - 1 then
                  iFirst:= img.IO.Params.TIFF_ImageCount - 1;

               iLast:=iFirst;
             end;
          end;
      end;


      if lowercase(rightstr(ParamStr(1),4))<>'.jpg' then
      begin
         if ExitCode <> 0 then exit;
         WriteLn('Fertig. Beginne mit filtern...');

         For iPage := iFirst to iLast do
         begin
           WriteLn('Filtere Seite ' + IntToStr(iPage + 1));
           img.IO.Params.TIFF_ImageIndex := iPage;
           if gdbg then
           begin
             WriteLn('loading file ' + ParamStr(1));
           end;
           img.IO.LoadFromFile(ParamStr(1));
           if gdbg then
           begin
             WriteLn('loaded  file');
           end;
           For iFlt := 0 to (slFilterList.Count - 1) do
           begin
           if gdbg then
           begin
             WriteLn(inttostr(iFlt)+':>> '+slFilterList.Strings[iFlt]);
           end;
             iPos := POS('=', slFilterList.Strings[iFlt]);
             if iPos = 0 then iPos := Length(slFilterList.Strings[iFlt]) + 1
             else sPrm := Copy(slFilterList.Strings[iFlt], iPos + 1, Length(slFilterList.Strings[iFlt]));
             sCmd := UpperCase(Copy(slFilterList.Strings[iFlt], 1, iPos - 1));

             if sCMD = 'RESAMPLE' then setfilter(sPrm);

             if sCmd = 'RED' then FltRed;
             if sCmd = 'GREEN' then FltGreen;
             if sCmd = 'BLUE' then FltBlue;
             if sCmd = 'ROT' then FltRot(sPrm);
             if sCmd = 'REMPIX' then FltPix(sPrm);
             if sCmd = 'CONTR' then FltContr(sPrm);
             if sCmd = 'BRIGHT' then FltBright(sPrm);
             if sCmd = 'SKEW' then FltSkew(sPrm);
             if sCmd = 'RES' then FltRes(sPrm,rfResample);
             if sCmd = 'BW' then FltBW(sPrm);
             if sCmd = 'GRAY' then FltGray;
             if sCmd = 'DITHER' then FltDither;
             if sCmd = 'WHITE' then FltWhite;
             if sCmd = 'COMPJPEG' then FltJPEG(sPrm);
             if sCmd = 'COMPLZW' then FltLZW;
             if sCmd = 'COMPAUTO' then FltAutoComp(sPrm);
           end;

           if lowercase(rightstr(ParamStr(3),4))='.jpg' then
           begin
             sSavename:= ExtractFilePath(ParamStr(3)) + Copy(ExtractFileName(ParamStr(3)),1,Length(ExtractFileName(ParamStr(3)))-4);
             sSavename:=sSavename +'-'+ IntToStr(iPage) + '.jpg'
           end
           else
             sSavename:= ParamStr(3);

           if FileExists(sSavename) then
           begin
             if gdbg then
             begin
               WriteLn('adding to file');
             end;
               if img.IO.Params.FileType = ioTIFF then img.IO.InsertToFileTIFF(sSavename)
               else img.IO.SaveToFile(sSavename);
           end
           else
           begin
             if gdbg then
             begin
               WriteLn('saving to file');
             end;
              img.IO.SaveToFile(sSavename);
           end;
         end;

      end
      else if lowercase(rightstr(ParamStr(1),4))='.jpg' then
      begin
                
        if gdbg then
        begin
          WriteLn('loading  file');
        end;
        img.IO.LoadFromFile(ParamStr(1));
               
         if gdbg then
        begin
          WriteLn('loaded  file');
        end;
         For iFlt := 0 to (slFilterList.Count - 1) do
        begin
          iPos := POS('=', slFilterList.Strings[iFlt]);
          if iPos = 0 then iPos := Length(slFilterList.Strings[iFlt]) + 1
          else sPrm := Copy(slFilterList.Strings[iFlt], iPos + 1, Length(slFilterList.Strings[iFlt]));
          sCmd := UpperCase(Copy(slFilterList.Strings[iFlt], 1, iPos - 1));

          if sCMD = 'RESAMPLE' then setfilter(sPrm);

          if sCmd = 'RED' then FltRed;
          if sCmd = 'GREEN' then FltGreen;
          if sCmd = 'BLUE' then FltBlue;
          if sCmd = 'ROT' then FltRot(sPrm);
          if sCmd = 'REMPIX' then FltPix(sPrm);
          if sCmd = 'CONTR' then FltContr(sPrm);
          if sCmd = 'BRIGHT' then FltBright(sPrm);
          if sCmd = 'SKEW' then FltSkew(sPrm);
          if sCmd = 'RES' then FltRes(sPrm,rfResample);
          if sCmd = 'BW' then FltBW(sPrm);
          if sCmd = 'GRAY' then FltGray;
          if sCmd = 'DITHER' then FltDither;
          if sCmd = 'WHITE' then FltWhite;
          if sCmd = 'COMPJPEG' then FltJPEG(sPrm);
          if sCmd = 'COMPLZW' then FltLZW;
          if sCmd = 'COMPAUTO' then FltAutoComp(sPrm);
        end;

        img.IEBitmap.PixelFormat := ie24RGB;
        img.IO.Params.SamplesPerPixel := 3;
        img.IO.Params.BitsPerSample := 8;
        // img.IO.Params.TIFF_Compression := ioTIFF_JPEG;

        //img.IO.Params.TIFF_JPEGQuality := StrToInt(sPrm);
        //img.IO.Params.JPEG_Quality := StrToInt(sPrm); // Igel070308 Der Parameter zur Qualitaetsbestimmung wurde nicht beruecksitigt
        img.IO.SaveToFile(ParamStr(3))
      end;

      WriteLn('Gefilterte Datei wurde als ' + ParamStr(3) + ' gespeichert.');
    except
      on e: exception do
      begin
        ExitCode := 255;
        WriteLn('Allgemeiner Anwendungsfehler: ' + e.Message);
      end;
    end;
  finally
    if Assigned(img) then FreeAndNil(img);
    if Assigned(slFilterList) then FreeAndNil(slFilterList);
  end;
end.
