//////////////////////////////////////////////////
//  bitfarm-Archiv Login Unit

unit u_Login;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, IniFiles, Registry, ShellAPI, Buttons,
   RxGIF, //#3.5
   ComCtrls, JvExComCtrls, JvProgressBar, JvDBProgressBar, gnugettext,
   SSPIValidatePasswordW,
   u_ShBase, u_ShLowUtils;

//todo for opensource save unencrypted!! hide this function
function lXOR_encryption(const InStr, KeyStr: string): string;
function deldir(dir: string): Boolean;

type
   Tfrm_Login = class (TForm)
      img_Logo1: TImage;
      img_Logo2: TImage;
      lbl_User: TLabel;
      lbl_Pass: TLabel;
      lbl_Profil: TLabel;
      cbx_Profil: TComboBox;
      edt_User: TEdit;
      edt_Pass: TEdit;
      lbl_Version: TLabel;
      btn_Login: TButton;
      btn_Exit: TButton;
      shp_Rand: TShape;
      lbl_URL: TLabel;
      cbx_login_optionen: TComboBox;
      play_mod_login: TBitBtn;
      JvGradientProgressBar1: TJvGradientProgressBar;
      procedure btn_ExitClick(Sender: TObject);
      procedure shp_RandMouseMove(Sender: TObject; Shift: TShiftState; X,
         Y: Integer);
      procedure shp_RandMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
      procedure FormShow(Sender: TObject);
      procedure btn_LoginClick(Sender: TObject);
      procedure lbl_URLClick(Sender: TObject);
      procedure lbl_URLMouseEnter(Sender: TObject);
      procedure lbl_URLMouseLeave(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      function XOR_encryption(const InStr: string): string;
      procedure play_mod_loginClick(Sender: TObject);
      procedure tbi_OptionenClick(Sender: TObject);
   private
      { Private-Deklarationen }
      fsdomain: string;
   public
      { Public-Deklarationen }
      fnotpasswordneeded: boolean;
      procedure InitLogin;
      function CheckLogin: boolean;
   end;

var
   frm_Login: Tfrm_Login;
   iGX, iGY: Integer;
   bgSavePass, bShowOpt: Bool;
   sGArcPath, sGclientprogram, sGCopyPath, sGClntSpool: string;


implementation

uses u_MainForm, u_dm_DB, u_Info;

{$R *.dfm}


function deldir(dir: string): Boolean;
var
   fos: TSHFileOpStruct;
begin
   ZeroMemory(@fos, SizeOf(fos));
   with fos do
   begin
      wFunc := FO_DELETE;
      fFlags := FOF_SILENT or FOF_NOCONFIRMATION;
      pFrom := PChar(dir + #0);
   end;
   Result := (0 = ShFileOperation(fos));
end;


procedure Tfrm_Login.InitLogin;
var reg: TRegistry;
   sFiles: TStrings;
   sFileName, slpass, slappdata: string;
   iCount: Integer;
   ini: TIniFile;
begin
   reg := TRegistry.Create;
   sFiles := TStringList.Create;
   slappdata := '';
   try
      try
         FindAllFiles(sFiles, ExtractFilePath(ParamStr(0)), '*.con', false);
         for iCount := 0 to (sFiles.Count - 1) do
         begin
            sFileName := ExtractFileName(sFiles[iCount]);
            sFiles[iCount] := copy(sFileName, 1, (Length(sFileName) - 4));
         end;
         cbx_Profil.Items := sFiles;
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
            if ValueExists('User') then
               edt_User.Text := ReadString('User') else edt_User.Text := '';
            if ValueExists('SavePass') then
               bgSavePass := ReadBool('SavePass') else bgSavePass := true;
            if (bgSavePass) then
            begin
               if ValueExists('Pass') then
                  edt_Pass.Text := ReadString('Pass') else edt_Pass.Text := '';
            end
            else
            begin
               edt_Pass.Text := '';
            end;
            if ValueExists('Conn') then
            begin
               if cbx_Profil.Items.IndexOf(ReadString('Conn')) <> -1 then
                  cbx_Profil.ItemIndex := cbx_Profil.Items.IndexOf(ReadString('Conn'))
               else cbx_Profil.ItemIndex := 0;
            end;
            if ValueExists('mylogin') then
            begin
               slappdata := ReadString('mylogin');
            end;
            CloseKey;
         end;

         if gbdebug then
            LogEvnt('slappadata:' + slappdata);

         if (slappdata <> '') and (GetSystemVariable('APPDATA') = '') then
         begin
            ini := TIniFile.Create(Pchar(slappdata));
         end
         else
         begin
            ini := TIniFile.Create(Pchar(GetSystemVariable('APPDATA') + '\bitfarm-archiv' + '\mylogin.ini'));
         end;

         // read from ini
         if ini.ValueExists('User', 'UserName') then
         begin
            slpass := ini.ReadString('User', 'UserName', '');
            if slpass <> '' then
               edt_User.Text := slpass;
         end;
         if ini.ValueExists('User', 'SavePass') then
         begin
            bgSavePass := ini.ReadBool('User', 'SavePass', true);
         end
         else
         begin
            bgSavePass := true;
         end;

         if (ini.ValueExists('User', 'Password') and bgSavePass) then
         begin
            slpass := ini.ReadString('User', 'Password', '');
            if slpass <> '' then
               // edt_Pass.Text :=XOR_encryption(slpass);
               //I prefer mine encription but we want standize.
               edt_Pass.Text := Decrypt(slpass, Globalkey);
         end;
      except
         on e: Exception do
            ErrorMsg('LoginMod', 'Fehler beim Auslesen der Profile: ' + e.Message, 2001, True);
      end;
   finally
      if Assigned(ini) then
         FreeAndNil(ini);
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(sFiles) then
         FreeAndNil(sFiles);
   end;
end;

function Tfrm_Login.CheckLogin: boolean;
var ini: TIniFile;
begin
   JvGradientProgressBar1.Position := 10;
   sGProfil := cbx_Profil.Text;
   sGConnection := ExtractFilePath(ParamStr(0)) + sGProfil + '.con';
   ini := TIniFile.Create(sGConnection);
   try
      try
         with ini do
         begin
            dm_DB.my_Con.Disconnect;
            dm_DB.my_con.Server := ReadString('Connection', 'Server', '');
            dm_DB.my_con.Port := ReadInteger('Connection', 'Port', 3306);
            dm_DB.my_con.Database := ReadString('Connection', 'DB', '');
            fsdomain := ReadString('Connection', 'Domain', '');
            dm_DB.my_con.Username := Decrypt(ReadString('Connection', 'User', ' '), GlobalKey);
            dm_DB.my_con.Password := Decrypt(ReadString('Connection', 'Pass', ' '), GlobalKey);
            sGArcPath := ReadString('Scripts', 'Archivverzeichnis', '');
            sGclientprogram := ReadString('Scripts', 'clientprogramm', '');
            sGCopyPath := ReadString('Scripts', 'archivkopie', sGArcPath);
            sGClntSpool := ReadString('Scripts', 'uncclientspooler', '');
            dm_DB.my_con.Connect;
         end;
      except
         on e: exception do
            LogEvnt('2003    Fehler beim Auslesen der Connection: ' + e.Message);
      end;
      result := dm_DB.my_con.Connected;
      JvGradientProgressBar1.Position := 50;
      if not Result then
      begin
         SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
         SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck

         BfShowMessage(_('Fehler!') + #13 + _('Es konnte keine Verbindung mit dem Archiv') + #13 +
            _('Server hergestellt werden. Whlen Sie ein anderes Profil') + #13 +
            _('oder wenden Sie sich an Ihren Administrator.'));

         JvGradientProgressBar1.Position := 0;
         SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
         SetWindowLong(Handle, GWL_HWNDPARENT, 0);   // Die Login Form soll immer im Vordergrund bleiben
      end;

   finally
      if Assigned(ini) then
         FreeAndNil(ini);
   end;
end;

procedure Tfrm_Login.btn_ExitClick(Sender: TObject);
begin
   frm_Login.Close;
end;

procedure Tfrm_Login.shp_RandMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: Integer);
begin
   if Shift = [ssRight] then
   begin
      frm_Login.Left := frm_Login.Left - iGX + x;
      frm_Login.Top := frm_Login.Top - iGY + y;
   end;
end;

procedure Tfrm_Login.shp_RandMouseDown(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: Integer);
begin
   if Shift = [ssLeft] then
   begin
      iGX := x;
      iGY := y;
   end;
end;

procedure Tfrm_Login.FormShow(Sender: TObject);
var
   P: TPoint;
begin
   P.X := Width div 2;
   P.Y := Height div 2;
   //P.X := 165;
   //P.Y := 70;

   P := ClientToScreen(P);
   // dont move the mouse cursor!
   // SetCursorPos(P.X, P.Y);
   cbx_login_optionen.ItemIndex := 0;
   InitLogin;

   lbl_Version.Caption := 'Version: ' + GetVersionInfo;
end;

procedure Tfrm_Login.btn_LoginClick(Sender: TObject);
var
   reg: TRegistry;
   ini: TIniFile;
   lbLoginOk: boolean; // alles fr Anmeldung in Ordnung (Passwort und so ...)
   lsPassDb, lsPassInput: string;
begin
   lbLoginOk := false;
   if CheckLogin then
   begin
      if frm_Main.TmpSQL('select * from sys_usr where Usr_Name = ' + #34 + edt_User.text + #34) then
      begin
         JvGradientProgressBar1.Position := 75;
         with dm_DB.my_q_Tmp do
         begin
            lsPassDb := FieldByName('usr_pass').AsString; // das Passwort in der bitfarm-Datenbank
            if RecordCount <> 0 then
            begin
               lsPassInput := Encrypt(edt_Pass.Text, GlobalKey); // das eingegebene Passwort verschlsselt
               if ((fnotpasswordneeded) or (lsPassInput = lsPassDb)) then
               begin

                  JvGradientProgressBar1.Position := 100;
                  frm_Login.ModalResult := mrOK;
                  iGUsrID := FieldByName('usr_id').AsInteger;
                  sGUsrName := FieldByName('usr_name').AsString;
                  reg := TRegistry.Create;

                  try
                     try
                        reg.RootKey := HKEY_CURRENT_USER;
                        reg.OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
                        reg.WriteString('User', edt_User.Text);
                        reg.WriteString('Conn', cbx_Profil.Text);
                        reg.WriteString('WindowsUser', GetSystemVariable('%USERNAME%'));
                        reg.CloseKey;
                     except
                        on e: exception do
                           ErrorMsg('btn_LoginClick', 'Fehler beim speichern des Users in der Registrierung: ' + e.Message, 2004, True);
                     end;

                  finally
                     if Assigned(reg) then
                        FreeAndNil(reg);
                     if Assigned(ini) then
                        FreeAndNil(ini);
                  end;
               end
               else
               begin
                  ///////////////////////////////////////////////////////////////////////////////////////////////
                  // Das Anmeldefenster wird nicht mehr in den Vordergrung gezwungen
                  // Dadurch kann die Fehlermeldung zur Fehlerhaften Passworteingabe im Vordergrund angezeigt werden
                  SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
                  SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck


                  //application.NormalizeTopMosts;
                  BfShowMessage(_('Benutzer oder Passwort stimmen nicht berein!'));


                  //////////////////////////////////////////////////////////////////////////////////////////////////////////
                  SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
                  SetWindowLong(Handle, GWL_HWNDPARENT, 0);   // Die Login Form soll immer im Vordergrund bleiben
                  //     mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
                  //     mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
               end;
            end
            else
            begin

               SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
               SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck

               //application.normalizeTopMosts;
               BfShowMessage(_('Benutzer oder Passwort stimmen nicht berein!'));


               SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
               SetWindowLong(Handle, GWL_HWNDPARENT, 0);   // Die Login Form soll immer im Vordergrund bleiben
               //         mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
               //         mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
            end;
         end;
      end
      else
      Begin
         SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
         SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck

         ErrorMsg('btn_LoginClick', 'Fehler beim Auslesen eines Benutzers', 2005, True);
         SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
         SetWindowLong(Handle, GWL_HWNDPARENT, 0);   // Die Login Form soll immer im Vordergrund bleiben
      end;
   end
   else
   begin
      InitLogin;
   end;
   outputdebugstring(pchar('closing my_q_tmp'));
   dm_DB.my_q_Tmp.Close;
   outputdebugstring(pchar('closed my_q_tmp'));
end;

procedure Tfrm_Login.lbl_URLClick(Sender: TObject);
begin
   ShellExecute(0, nil, PChar('http://www.bitfarm-archiv.de'), Pchar(''), Pchar(''), SW_NORMAL);
end;

procedure Tfrm_Login.lbl_URLMouseEnter(Sender: TObject);
begin
   lbl_Url.Font.Color := clSkyBlue;
end;

procedure Tfrm_Login.lbl_URLMouseLeave(Sender: TObject);
begin
   lbl_URL.Font.Color := clBlue;
end;

procedure Tfrm_Login.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
   SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
   SetWindowLong(Handle, GWL_HWNDPARENT, 0);   // Die Login Form soll immer im Vordergrund bleiben
   //  mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
   //  mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
end;


function Tfrm_Login.XOR_encryption(const InStr: string): string;
begin

   result := lxor_encryption(InStr, 'bitfarmIT-archiv;bitfarm-gmbh');
end;

// from
//http://delphi.blue-aura.co.uk/forum/archive/index.php/t-171.html
function lXOR_encryption(const InStr, KeyStr: string): string;
var C1, C2: integer;
   OutStr: string;
   Ch1, Ch2: byte;
begin

   //First initialise the counters to zero
   C1 := 0;
   C2 := 0;

   //initialise the returning string to an empty string
   OutStr := '';

   //We want to loop for as many characters in the Input String
   while (C1 < Length(InStr)) do
   begin

      //first of all, increment the both counters
      inc(C1);
      inc(C2);

      //if the second counter is greater than the length of the
      //Key String, then set ot back to 1
      if (C2 > Length(KeyStr)) then
         C2 := 1;

      //get the byte value of the character at the current position
      //of the Input String
      Ch1 := Ord(InStr[C1]);

      //get the byte value of the character at the current position
      //of the Key String. To ensure we do not get any NULL
      //characters during encryption, we add 128 to this value
      Ch2 := Ord(KeyStr[C2]) + 128;

      //Add the XOR'd value of the current Input String position
      //and the current Key String position to the end of the
      //returning string
      OutStr := OutStr + Chr(Ch1 xor Ch2);
   end;

   //return the encrypted/decrypted string
   Result := OutStr;
end;


procedure Tfrm_Login.play_mod_loginClick(Sender: TObject);
(*var
   Reg: TRegistry;
   ini: TIniFile;
   lbresult: boolean;*)
begin
{case   cbx_login_optionen.ItemIndex of
// formdata reset
     0:
       begin
          try
             Reg:=TRegistry.Create;
             Reg.RootKey:=HKEY_CURRENT_USER;
             Reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\', True);
             Reg.deletekey('Formdata');
              if  (directoryexists(ng_sTreflistDesignPAth)) then
  begin
  try
            lbresult:= deldir(  ng_sTreflistDesignPAth);
             except on e:Exception do
             logevnt('Could not delete bfa_hit dir :'+e.message);
             end;
             end;

          finally
                 if Assigned(reg) then
                 FreeAndNil(reg);
          end;
       end;
//dont save password
     1:
       begin  
          try
             Reg:=TRegistry.Create;
             Reg.RootKey:=HKEY_CURRENT_USER;
             bgSavePass:=false;
             reg.DeleteValue('password');
             Reg.deletekey('Formdata');
             ini :=TIniFile.Create(Pchar(GetSystemVariable('APPDATA')+ '\bitfarm-archiv'+'\mylogin.ini'));
             ini.WriteString('User','Profil',cbx_profil.Text);
             ini.WriteBool('User','SavePass',bgSavePass);
             ini.WriteString('User', 'Password','') ;
             ini.UpdateFile;
          finally
                 if Assigned(reg) then
                 FreeAndNil(reg);
              if Assigned(ini) then FreeAndNil(ini);
          end;
       end;
// save password
     2:
       begin
            bgSavePass:=true;
       end;
     //end of case of
end; }
end;

procedure Tfrm_Login.tbi_OptionenClick(Sender: TObject);
begin
   bShowOpt := not bShowOpt;

   if bshowOpt then
   begin
      frm_login.Height := 210;
      cbx_login_optionen.visible := true;
      play_mod_login.visible := true;
   end
   else
   begin
      frm_login.Height := 177;
      cbx_login_optionen.visible := false;
      play_mod_login.visible := false;
   end;
   SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE);
end;

end.
