unit u_Optionen;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, Menus, StdCtrls, ComCtrls, ExtCtrls, Buttons, Registry, IniFiles,
   gnugettext,
   u_ShLowUtils;

type
   Tfrm_Opt = class (TForm)
      pctr_Scan: TPageControl;
      tbs_Opt: TTabSheet;
      btn_Ok: TButton;
      btn_Cancel: TButton;
      btn_Save: TButton;
      grbx_StandardOpt: TGroupBox;
      lbl_StdLgr: TLabel;
      lbl_StdArc: TLabel;
      cbx_StdLgr: TComboBox;
      cbx_StdArc: TComboBox;
      chbx_ManVtx: TCheckBox;
      chbx_ManOcrVtx: TCheckBox;
      chbx_ACol: TCheckBox;
      chbx_AHigh: TCheckBox;
      chbx_SavLastLgrArc: TCheckBox;
      cbx_showpnlinput: TCheckBox;
      cbx_showdoc: TCheckBox;
      cbx_cpclipbrdgdocid: TCheckBox;
      procedure cbx_StdLgrChange(Sender: TObject);
      procedure btn_SaveClick(Sender: TObject);
      procedure btn_OkClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure chbx_SavLastLgrArcClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      procedure InitOpt;
      function LoadOptReg: boolean;
      function SaveOptReg: boolean;
      function CheckOptReg: boolean;
   end;

var
   frm_Opt: Tfrm_Opt;

implementation

uses u_dm_Main, u_MainForm;

{$R *.dfm}

procedure Tfrm_Opt.InitOpt;
begin
   LoadOptReg;
end;

function Tfrm_Opt.LoadOptReg: boolean;
var reg: TRegistry;
begin
   result := True;
   cbx_StdLgr.Items := frm_Main.cbx_Lgr.Items;
   cbx_StdLgr.ItemIndex := 0;
   cbx_StdArc.Items := frm_Main.cbx_Arc.Items;
   cbx_StdArc.ItemIndex := 0;
   reg := TRegistry.Create;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Importer\Options', True);
            cbx_StdLgr.ItemIndex := cbx_StdLgr.Items.IndexOfObject(TObject(ReadInteger('StdLgr')));
            if cbx_StdLgr.ItemIndex = -1 then
               cbx_StdLgr.ItemIndex := 0;
            cbx_StdArc.ItemIndex := cbx_StdArc.Items.IndexOfObject(TObject(ReadInteger('StdArc')));
            if cbx_StdArc.ItemIndex = -1 then
               cbx_StdArc.ItemIndex := 0;
            chbx_ManVtx.Checked := ReadBool('ManVtx');
            chbx_ManOcrVtx.Checked := ReadBool('ManOcrVtx');
            chbx_ACol.Checked := ReadBool('Color');
            chbx_AHigh.Checked := ReadBool('HighRes');

            //3.5.0.7 cbx_showdoc.Checked := ReadBool('ShowDocViewer');
            cbx_showdoc.Checked := RegReadBool(Reg, 'ShowDocViewer', False);    //3.5.0.7

            if ValueExists('cpclipbrdgdocid') then
               cbx_cpclipbrdgdocid.Checked := ReadBool('cpclipbrdgdocid');
            cbx_showpnlinput.Checked := ReadBool('Maskinputpanel');

            if valueexists('SavLastLgrArc') then
            begin
               chbx_SavLastLgrArc.Checked := ReadBool('SavLastLgrArc');
               chbx_SavLastLgrArc.OnClick(self);
            end;
         except
            result := False;
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

function Tfrm_Opt.SaveOptReg: boolean;
var reg: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Importer\Options', True);
            if not chbx_SavLastLgrArc.Checked then
            begin
               WriteInteger('StdLgr', Integer(cbx_StdLgr.Items.Objects[cbx_StdLgr.ItemIndex]));
               WriteInteger('StdArc', Integer(cbx_StdArc.Items.Objects[cbx_StdArc.ItemIndex]));
            end;
            WriteBool('ManVtx', chbx_ManVtx.Checked);
            WriteBool('ManOcrVtx', chbx_ManOcrVtx.Checked);
            WriteBool('Color', chbx_ACol.Checked);
            WriteBool('HighRes', chbx_AHigh.Checked);
            WriteBool('ShowDocViewer', cbx_showdoc.Checked);
            WriteBool('cpclipbrdgdocid', cbx_cpclipbrdgdocid.Checked);
            WriteBool('Maskinputpanel', cbx_showpnlinput.Checked);
            WriteBool('SavLastLgrArc', chbx_SavLastLgrArc.Checked);

         except
            result := False;
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

function Tfrm_Opt.CheckOptReg: boolean;
var reg: TRegistry;
begin
   result := True;
   reg := TRegistry.Create;
   with reg do
   begin
      try
         try
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Importer\Options', True);
            if ValueExists('StdLgr') then
               if GetDataType('StdLgr') = rdString then
                  DeleteValue('StdLgr');
            if ValueExists('StdArc') then
               if GetDataType('StdArc') = rdString then
                  DeleteValue('StdArc');
            if not ValueExists('StdLgr') then
               WriteInteger('StdLgr', 0);
            if not ValueExists('StdArc') then
               WriteInteger('StdArc', 0);
            if not ValueExists('ManVtx') then
               WriteBool('ManVtx', False);
            if not ValueExists('ManOcrVtx') then
               WriteBool('ManOcrVtx', True);
            if not ValueExists('Color') then
               WriteBool('Color', False);
            if not ValueExists('HighRes') then
               WriteBool('HighRes', False);
            if not ValueExists('Maskinputpanel') then
               WriteBool('Maskinputpanel', False);
            if not ValueExists('SavLastLgrArc') then
               WriteBool('SavLastLgrArc', True);
         except
            result := False;
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_Opt.cbx_StdLgrChange(Sender: TObject);
begin
   frm_Main.cbx_Lgr.ItemIndex := cbx_StdLgr.ItemIndex;
   frm_Main.cbx_LgrChange(self);
   cbx_StdArc.Items := frm_Main.cbx_Arc.Items;
end;

procedure Tfrm_Opt.btn_SaveClick(Sender: TObject);
begin
   SaveOptReg;
end;

procedure Tfrm_Opt.btn_OkClick(Sender: TObject);
begin
   SaveOptReg;
end;

procedure Tfrm_Opt.FormShow(Sender: TObject);
begin
   InitOpt;
end;

procedure Tfrm_Opt.chbx_SavLastLgrArcClick(Sender: TObject);
begin
   lbl_StdLgr.Enabled := not chbx_SavLastLgrArc.Checked;
   lbl_StdArc.Enabled := not chbx_SavLastLgrArc.Checked;
   cbx_StdLgr.Enabled := not chbx_SavLastLgrArc.Checked;
   cbx_StdArc.Enabled := not chbx_SavLastLgrArc.Checked;
end;

procedure Tfrm_Opt.FormCreate(Sender: TObject);
begin

   TranslateComponent(self);
end;

end.
