unit u_dm_Main;

interface

uses
   SysUtils, Classes, Menus, gnugettext, XPMan, ImgList, Controls, Graphics, JvImageList,
   shellapi,
   u_ShFrameZusFldMulti, u_ShBase, u_ShLowUtils, JvComboBox;

type
   Tdm_Main = class (TDataModule)
      xp_Man: TXPManifest;
      il_LgrArc: TImageList;
      jil_Scroll: TJvImageList;
      im_list16: TImageList;
      ImageList1: TImageList;
      procedure mnu_LgrArcClick(Sender: TObject);
      procedure mnu_InfoClick(Sender: TObject);
      procedure mnu_OptClick(Sender: TObject);
      procedure mnu_EndClick(Sender: TObject);
      procedure mnu_stdzusatzClick(Sender: TObject);
      procedure stdzusatz(Sender: TObject);
      procedure DataModuleCreate(Sender: TObject);
   private
      function FormatHTMLClipboardHeader(HTMLText: string): string;
      { Private-Deklarationen }
   public
     function ShellExecute_AndWait(Operation, FileName,
		   Parameter, Directory: string; Show: word; bWait: boolean): longint;
      procedure cplinktoclbrd(const str, htmlStr: string);
      function StrToWords2(const InputStr: string): TStringList;
			function GetRegestryZusFeldData	(lslZusFeld,lslZusFeldWert:TStringList):Boolean;
      { Public-Deklarationen }
   end;

var
   dm_Main: Tdm_Main;

implementation

uses u_MainForm, u_Optionen, windows, clipbrd, forms,
   registry, JvStaticText, StdCtrls, JvToolEdit, JvSpin, Spin,
  u_ShDlgAddFields;

{$R *.dfm}

function Tdm_Main.GetRegestryZusFeldData(lslZusFeld,lslZusFeldWert:TstringList):Boolean;
var
  reg:  TRegistry;
  slZusfields: TStringList;
  i: Integer;
begin
      slZusfields:= TStringList.Create;
      reg := TRegistry.Create;
      try
         try
             with reg do
             begin
                RootKey := HKEY_CURRENT_USER;
                OpenKey('Software\bitfarm\Archiv_V3\Importtools\' + sGProfil + '\' + inttostr(iGArcID), True);
                GetValueNames(slZusfields);
                for i:= 0 to slZusfields.Count -1 do
                begin
                  lslZusfeld.Add(slZusfields[i]);
                  lslZusFeldWert.Add(ReadString(slZusfields[i]));

                end;



             end;

         except
             on e: exception do
             begin
                ErrorMsg('ReadReg', 'Fehler beim laden der Optionen: ' + e.Message,
                   2000, True);
             end;
         end;
      finally
          begin
           reg.CloseKey;
           if Assigned(reg) then
              freeandnil(reg);
          end;
      end;
end;

procedure Tdm_Main.mnu_LgrArcClick(Sender: TObject);
begin
   //frm_Main.sbtn_TExitClick(self);
end;

procedure Tdm_Main.mnu_InfoClick(Sender: TObject);
begin
   frm_Main.ShowPrgInfo;
end;

procedure Tdm_Main.mnu_OptClick(Sender: TObject);
begin
   frm_Opt.ShowModal;
   frm_Main.LoadOptReg;
end;

procedure Tdm_Main.mnu_EndClick(Sender: TObject);
begin
   frm_Main.Close;
end;


function Tdm_Main.StrToWords2(const InputStr: string): TStringList;
   //////////////////////////////////////////////////////////////////
   ///  30.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function zerlegt einen String in einzelne Worte     ///
   ///  bzw Phrasen und listet diese in einer Stringlist auf.     ///
   ///                                                            ///
   ///  Parameter: InputStr        String mit Suchbegriffen       ///
   ///                                                            ///
   ///  Ausgabe: StringList mit einzelnen Worten und Phrasen      ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
const
   sTrennZeichen = ' .,!?';
var
   iCount, iWortStart, iWortEnde: integer;
   bPhrase: boolean;
   sWort: string;
begin
   Result := TStringList.Create;
   Result.Clear;

   if trim(inputstr) = '' then
      exit;
   iWortStart := 0;
   iWortEnde := 0;
   iCount := 0;
   bPhrase := False;
   while iCount <= Length(InputStr) do
   begin
      if IsDelimiter('"', InputStr, iCount) then
      begin
         if not bPhrase then
         begin
            bPhrase := True;
            iWortStart := iCount + 1;
            //if IsDelimiter('+-*', InputStr, iCount - 1) then inc(iCount, 1);
         end
         else
            bPhrase := False;
      end;
      if IsDelimiter(sTrennZeichen, InputStr, iCount) and not bPhrase then
      begin
         if iWortStart <= iWortEnde then
         begin
            iWortEnde := iCount;
            sWort := Trim(StringReplace(Copy(InputStr, iWortStart,
               iWortEnde - iWortStart), '"', '', [rfReplaceAll]));
            if swort <> '' then
            begin
               if (Ord(sWort[1]) = $2B) or (Ord(sWort[1]) = $2D) then
                  sWort := Copy(sWort, 2, Length(sWort));
               Result.Add(sWort);
            end;
            //ShowMessage(sWort);
            iWortStart := iWortEnde + 1;
         end;
      end;
      iWortEnde := iCount;
      Inc(iCount);
   end;
   if iWortStart < iWortEnde then
      Result.Add(Trim(StringReplace(Copy(InputStr, iWortStart, 1 +
         iWortEnde - iWortStart), '"', '', [rfReplaceAll])));
end;

//from http://www.swissdelphicenter.ch/torry/printcode.php?id=1391
function Tdm_Main.FormatHTMLClipboardHeader(HTMLText: string): string;
const
   CrLf = #13#10;
begin
   Result := 'Version:0.9' + CrLf;
   Result := Result + 'StartHTML:-1' + CrLf;
   Result := Result + 'EndHTML:-1' + CrLf;
   Result := Result + 'StartFragment:000081' + CrLf;
   Result := Result + 'EndFragment:' + CrLf;
   Result := Result + HTMLText + CrLf;
   Result := StringReplace(Result, '', Format('%.6d', [Length(Result)]), []);
end;

//The second parameter is optional and is put into the clipboard as CF_HTML.
//Function can be used standalone or in conjunction with the VCL clipboard so long as
//you use the USEVCLCLIPBOARD conditional define
//($define USEVCLCLIPBOARD}
//(and clipboard.open, clipboard.close).
//Code from http://www.lorriman.com
procedure Tdm_Main.cplinktoclbrd(const str: string; const htmlStr: string);
var
   gMem: HGLOBAL;
   lp: PChar;
   Strings: array[0..1] of string;
   Formats: array[0..1] of UINT;
   i: Integer;
begin
   //gMem := 0;
  {$IFNDEF USEVCLCLIPBOARD}
   Win32Check(OpenClipBoard(0));
  {$ENDIF}
   try
      //most descriptive first as per api docs
      Strings[0] := FormatHTMLClipboardHeader(htmlStr);
      Strings[1] := str;
      Formats[0] := RegisterClipboardFormat('HTML Format');
      Formats[1] := CF_TEXT;
    {$IFNDEF USEVCLCLIPBOARD}
      Win32Check(EmptyClipBoard);
    {$ENDIF}
      for i := 0 to High(Strings) do
      begin
         if Strings[i] = '' then
            Continue;
         //an extra "1" for the null terminator
         gMem := GlobalAlloc(GMEM_DDESHARE + GMEM_MOVEABLE, Length(Strings[i]) + 1);
         {Succeeded, now read the stream contents into the memory the pointer points at}
         try
            Win32Check(gmem <> 0);
            lp := GlobalLock(gMem);
            Win32Check(lp <> nil);
            CopyMemory(lp, PChar(Strings[i]), Length(Strings[i]) + 1);
         finally
            GlobalUnlock(gMem);
         end;
         Win32Check(gmem <> 0);
         SetClipboardData(Formats[i], gMEm);
         Win32Check(gmem <> 0);
         //gmem := 0;
      end;
   finally
    {$IFNDEF USEVCLCLIPBOARD}
      Win32Check(CloseClipBoard);
    {$ENDIF}
   end;
end;

procedure Tdm_Main.mnu_stdzusatzClick(Sender: TObject);
begin
   stdzusatz(self);
end;




procedure Tdm_Main.stdzusatz(Sender: TObject);
var
   reg: TRegistry;
   jvstcomp: tjvstatictext;
   sFeld, sName, sWert: string;
   comp, comp1: Tcomponent;
   liCount1: integer;
   lbwrote: boolean;
   lslZusFeld, lslZusFeldWert: Tstringlist;
begin
   lslZusFeld:= TStringList.Create;
   lslZusFeldWert:= TStringList.Create;

   bCheckFields:= false; //10.03.2011 b.takacs 3.5.0.13
   Application.CreateForm(Tfrm_zuspflicht, frm_zuspflicht);
   frm_zuspflicht.fsDestIarcname := sIArcName;
   frm_zuspflicht.fsSrcIarcname := sIArcName;
   frm_zuspflicht.iGUsrID := iGUsrID;
//   frm_zuspflicht.gbHasCFGXS := gbHasCFGXS;
   frm_zuspflicht.igNewArcid := iGArcID;

   frm_zuspflicht.bMove := False;
   frm_zuspflicht.bPflichtfelder := False;
   frm_zuspflicht.Caption := _('Standardwerte-Zusatzfelder');
   GetRegestryZusFeldData(lslZusFeld,lslZusFeldWert);

   frm_zuspflicht.slZusFeld.AddStrings(lslZusFeld);
   frm_zuspflicht.slZusFeldWert.AddStrings(lslZusFeldWert);

   frm_zuspflicht.fiZusFcount := frm_zuspflicht.CreZusFields;
   lbwrote := false;


   frm_zuspflicht.ShowModal;
   if frm_zuspflicht.ModalResult <> mrOk then
   begin
 	 		bCheckFields:= true; //10.03.2011 b.takacs 3.5.0.13
      exit;
   end;
   if (not frm_zuspflicht.ChkZusfield(False)) and (bCheckFields) then
   begin
      if 0 <> (frm_zuspflicht.ftorpflichtfeld - frm_zuspflicht.fkeypflichtfeld) then
      begin
         ErrorMsg('MoveDoc',
            'Fehler beim Verschieben eines Dokumentes: frm_zusplicht.ChkZusfield = FALSE',
            2023, True);
    	 		bCheckFields:= true; //10.03.2011 b.takacs 3.5.0.13
          Exit;
      end;
   end
   else
   begin
 	 		bCheckFields:= true; //10.03.2011 b.takacs 3.5.0.13
   end;

   if frm_zuspflicht.ModalResult <> mrOk then
   begin
      exit;
   end;

   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Importtools\' + sGProfil + '\' + inttostr(iGArcID), True);
            for liCount1 := 0 to (frm_zuspflicht.fiZusFcount - 1) do
            begin
{3.6<}
               jvstcomp := tjvstatictext(frm_zuspflicht.sbx_ZusFeld.FindComponent(
                  'zlbl_Tmp' + IntToStr(liCount1)));

               sFeld := jvstcomp.Hint;
               sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);

               sWert := '';
               comp := FindComponentRekursivFrame(frm_zuspflicht.sbx_ZusFeld, 'zedt_Tmp' +
                  IntToStr(liCount1));

               if comp is TJvCheckedComboBox then
               begin
                  if TjvcheckedComboBox(Comp).Color <> cColorNoRightInit then
	                  sWert := TJvCheckedComboBox(comp).Text;
               end;
               if comp is TEdit then
               begin
                  if TEdit(Comp).Color <> cColorNoRightInit then
	                  sWert := TEdit(comp).Text;
               end;
               if comp is TJvDateEdit then
               begin
                  if TJvDateEdit(Comp).Color <> cColorNoRightInit then
                  	swert := TJvDateEdit(comp).Text;
               end;
               if comp is TComboBox then
               begin
                  if TComboBox(Comp).Color <> cColorNoRightInit then
	                  sWert := TComboBox(comp).Text;
               end;
               if comp is TJvSpinEdit then
               begin
                  if TJvSpinEdit(comp).Color <> cColorNoRightInit then
	                  sWert := TJvSpinEdit(comp).Text;
               end;
               if comp is TSpinEdit then
               begin
                  comp1 := FindComponentRekursivFrame(frm_zuspflicht.sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(liCount1));
                  if comp1 <> nil then
                  begin
                     if TSpinEdit(comp).Color <> cColorNoRightInit then
	                     sWert := TSpinEdit(comp).Text + ';' + Tcombobox(comp1).text;
                  end;
               end;

					//if sWert = '0' then sWert := '';
               //if sWert = '0,00' then sWert := '';
               //if sWert = '0,0000000000' then sWert := '';
               if sWert = '  .  .    ' then sWert := '';
               if sWert = '01.01.1900' then sWert := '';
               if sWert = '0T' then sWert := '';
               if sWert = '0M' then sWert := '';
               if sWert = '0J' then sWert := '';

               sWert := ParseAddfields(sWert);

               if swert <> '' then
               begin
                  writestring(sFeld, sWert);
                  lbwrote := true;
               end
               else
               begin
                  DeleteValue(sFeld);
                  lbwrote := true;
               end;
            end;
         end;
				 frm_Main.dbtv_MainClick(Sender); //10.03.2011 b.takacs 3.5.0.13
      except
         on e: exception do
         begin
            ErrorMsg('ReadReg', 'Fehler beim laden der Optionen: ' + e.Message,
               2000, True);
         end;
      end;
   finally
      begin
         reg.CloseKey;
         if Assigned(reg) then
            freeandnil(reg);
      end;
   end;
   if lbwrote then
   begin
      frm_Main.cbx_ArcChange(frm_Main.cbx_Arc);
   end;
   if Assigned(lslZusFeldWert) then
    FreeAndNil(lslZusFeldWert);
   if Assigned(lslZusFeld) then
    FreeAndNil(lslZusFeld);   
end;

function Tdm_Main.ShellExecute_AndWait(Operation, FileName,
   Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
   bOK: boolean;
   Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
   FillChar(Info, SizeOf(Info), Chr(0));
   Info.cbSize := SizeOf(Info);
   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
   Info.lpVerb := PChar(Operation);
   Info.lpFile := PChar(FileName);
   Info.lpParameters := PChar(Parameter);
   Info.lpDirectory := PChar(Directory);
   Info.nShow := Show;
   bOK := boolean(ShellExecuteEx(@Info));
   if bOK then
   begin
      if bWait then
      begin
         while
            WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
            Application.ProcessMessages;
         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      end
      else
         Result := 0;
   end;
   if not bOK then
      Result := -1;
end;
{>3.6}




procedure Tdm_Main.DataModuleCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

end.
