unit u_Info;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, jpeg, ExtCtrls, ShellAPI, gnugettext,
   u_ShLowUtils;

function GetVersionInfo: string;

type
   Tfrm_Info = class (TForm)
      img_Logo: TImage;
      lbl_Info1: TLabel;
      lbl_Info2: TLabel;
      lbl_Info3: TLabel;
      lbl_Info4: TLabel;
      lbl_Info5: TLabel;
      lbl_Info8: TLabel;
      btn_GPL: TButton;
      Label1: TLabel;
      lbl1: TLabel;
      lbl_Info6: TLabel;
      procedure btn_CloseClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormShow(Sender: TObject);
      procedure FormKeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure btn_GPLClick(Sender: TObject);
      procedure lbl1Click(Sender: TObject);
      procedure lbl1MouseEnter(Sender: TObject);
      procedure lbl1MouseLeave(Sender: TObject);
      procedure FormCreate(Sender: TObject);
    procedure lbl_Info6Click(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_Info: Tfrm_Info;

implementation

uses u_Rights;

{$R *.dfm}

function GetVersionInfo: string;
var
   VerInfoSize: DWord;
   VerInfo: Pointer;
   VerValueSize: DWord;
   VerValue: PVSFixedFileInfo;
   Dummy: DWord;
begin
   VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
   GetMem(VerInfo, VerInfoSize);
   GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
   VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
   with VerValue^ do
   begin
      result := IntTostr(dwFileVersionMS shr 16);
      result := result + '.' + IntTostr(dwFileVersionMS and $FFFF);
      result := result + '.' + IntTostr(dwFileVersionLS shr 16);
      result := result + '.' + IntTostr(dwFileVersionLS and $FFFF);
   end;
   FreeMem(VerInfo, VerInfoSize);
end;


procedure Tfrm_Info.btn_CloseClick(Sender: TObject);

begin
   frm_Info.Destroy;
end;

procedure Tfrm_Info.FormClose(Sender: TObject; var Action: TCloseAction);
//var alpha : byte;
begin
{
  for alpha := 255 downto 0 do
  begin
    frm_Info.AlphaBlendValue := alpha;
    sleep(10);
  end;
  frm_Info.Release;
}
end;

procedure Tfrm_Info.FormShow(Sender: TObject);
begin
   lbl_Info1.Caption := 'bitfarm Archiv V3 ManuScan - Version ' + GetVersionInfo + ' (GPL)';
end;

procedure Tfrm_Info.FormKeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if key = vk_escape then
      frm_Info.Close;
end;

procedure Tfrm_Info.btn_GPLClick(Sender: TObject);
begin
   Application.CreateForm(Tfrm_Rights, frm_Rights);
   frm_Rights.ShowModal;
   frm_Rights.Release;
end;

procedure Tfrm_Info.lbl1Click(Sender: TObject);
begin
   ShellExecute(0, Nil, PChar('http://www.bitfarm-archiv.com'), Pchar(''), Pchar(''), SW_NORMAL);
end;

procedure Tfrm_Info.lbl1MouseEnter(Sender: TObject);
begin
   lbl1.Font.Color := clSkyBlue;
end;

procedure Tfrm_Info.lbl1MouseLeave(Sender: TObject);
begin
   lbl1.Font.Color := clBlue;
end;

procedure Tfrm_Info.FormCreate(Sender: TObject);
begin

   TranslateComponent(self);
end;

procedure Tfrm_Info.lbl_Info6Click(Sender: TObject);
begin

   ShellExecute(0, nil, PChar('http://sourceforge.net/projects/bitfarm-archiv/support'), PChar(''),
      PChar(''), SW_NORMAL);
end;


end.
