{******************************************************************

                       JEDI-VCL Demo

 Copyright (C) 2002 Project JEDI

 Original author:

 Contributor(s):

 You may retrieve the latest version of this file at the JEDI-JVCL
 home page, located at http://jvcl.sourceforge.net

 The contents of this file are used with permission, subject to
 the Mozilla Public License Version 1.1 (the "License"); you may
 not use this file except in compliance with the License. You may
 obtain a copy of the License at
 http://www.mozilla.org/MPL/MPL-1_1Final.html

 Software distributed under the License is distributed on an
 "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 implied. See the License for the specific language governing
 rights and limitations under the License.

******************************************************************}

unit u_Mailform;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   JclMapi, JvMail, ExtCtrls, ComCtrls, StdCtrls, JvComponent, JvDialogs,
   JvComponentBase, gnugettext,
   u_ShLowUtils;

type
   Tfrm_MailForm = class (TForm)
      ClientTypeGroupBox: TGroupBox;
      AutomaticRadioBtn: TRadioButton;
      MapiRadioBtn: TRadioButton;
      DirectRadioBtn: TRadioButton;
      ClientsListView: TListView;
      ClientLabel: TLabel;
      ToEdit: TEdit;
      Label1: TLabel;
      SubjectEdit: TEdit;
      Label2: TLabel;
      BodyEdit: TRichEdit;
      SendBtn: TButton;
      Label3: TLabel;
      AttachmentMemo: TMemo;
      Label4: TLabel;
      AttachBtn: TButton;
      JvOpenDialog1: TJvOpenDialog;
      CcEdit: TEdit;
      Label5: TLabel;
      DownloadBtn: TButton;
      DownloadsListView: TListView;
      mm_attachmenttiffs: TMemo;
      procedure FormCreate(Sender: TObject);
      procedure ClientsListViewSelectItem(Sender: TObject; Item: TListItem;
         Selected: boolean);
      procedure AutomaticRadioBtnClick(Sender: TObject);
      procedure ClientsListViewCustomDrawItem(Sender: TCustomListView;
         Item: TListItem; State: TCustomDrawState; var DefaultDraw: boolean);
      procedure SendBtnClick(Sender: TObject);
      procedure AttachBtnClick(Sender: TObject);
      procedure DownloadBtnClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure JvMail1Error(Sender: TJvMail; ErrorCode: cardinal);
   private
      fbsendasonepdf: boolean;
      procedure BuildClientList;
      procedure UpdateClientName;

      function CreateMailComponent: boolean; //04.10.2011 b.takacs 3.5.1.45
   public
	    JvMail1: TJvMail; //04.10.2011 b.takacs 3.5.1.45
         
      property sendasonepdf: boolean Read fbsendasonepdf Write fbsendasonepdf default false;
   end;

var
   frm_MailForm: Tfrm_MailForm;

implementation

uses u_Main, comobj, Variants, registry;

{$R *.DFM}

//
//  Name:
//  Parameters:
//  Description:
//  Return value:
// []  04.10.2011 b.takacs 3.5.1.45
//------------------------------------------------------------------------------
function Tfrm_MailForm.CreateMailComponent: boolean;
	procedure CreateMailComp;
  begin
    if JvMail1 = nil then
    begin
      JvMail1:= TJvMail.Create(Self);
      JvMail1.LogonOptions:= [loLogonUI,loNewSession];
      JvMail1.ReadOptions:= [roFifo,roPeek];
      JvMail1.LongMsgId:= True;
      JvMail1.OnError:= JvMail1Error;
    end;
    BuildClientList;      //06.10.2011 b.takacs 3.5.1.45
    UpdateClientName;  //06.10.2011 b.takacs 3.5.1.45
  end;

var
	reg: TRegistry;
begin
	try
      reg:= TRegistry.Create;
      try
         try
            reg.RootKey := HKEY_LOCAL_MACHINE;
            reg.OpenKey('SOFTWARE\Clients',false);
            if reg.KeyExists('Mail') then
            begin
               CreateMailComp;
               result:= true;
            end
            else
               result:= false;
         except
            result:= false;
            LogEvnt('Fehler beim Lesen von HKLM\SOFTWARE\Clients');
         end;
      finally
      	reg.Free;
      end;
      // if the first not works use this to send email !!!
      if result = false then         //28.10.2011 b.takacs 3.5.1.53
      begin
      	reg:= TRegistry.Create;
         try
            try
               reg.RootKey := HKEY_CURRENT_USER;
               reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen',false);
               if reg.ValueExists('SendMail') then
               begin
                  if reg.ReadBool('SendMail') then
                  begin
                     CreateMailComp;
                     result:= true;
                  end
            	end;
            except
               LogEvnt('Fehler beim Lesen von HKCU\..\Viewer\Optionen');
            end;
         finally
            reg.Free;
         end;
      end;
   except
      JVMail1:= nil; //06.10.2011 b.takacs 3.5.1.45
      result := false;
   end;
end;
//
procedure Tfrm_MailForm.BuildClientList;
var
   I: integer;
begin
   GgfLogEvnt('frm_MailForm.BuildClientList');
   gbhasoutlookasstd := false;
   try
      if JVMail1 <> nil then      //06.10.2011 b.takacs 3.5.1.45
      begin
         ClientsListView.Items.BeginUpdate;
         ClientsListView.Items.Clear;
         ClientsListView.BringToFront;
         with JvMail1.SimpleMAPI do
         begin
            for I := 0 to ClientCount - 1 do
            begin
               with ClientsListView.Items.Add do
               begin
                  Caption := Clients[I].RegKeyName;
                  Data := Pointer(Clients[I].Valid);
                  SubItems.Add(Clients[I].ClientName);
                  SubItems.Add(Clients[I].ClientPath);
               end;
            end;
            if ClientsListView.items.count > 0 then
            begin
               if ((SelectedClientIndex < 0) or
                  (SelectedClientIndex > ClientsListView.items.count)) then
               begin
                  SelectedClientIndex := 0;
               end;
               ClientsListView.Items[SelectedClientIndex].Selected := True;
               AutomaticRadioBtn.Enabled := AnyClientInstalled;
               MapiRadioBtn.Enabled := SimpleMapiInstalled;
               DirectRadioBtn.Enabled := ClientCount > 0;
               i:= 0;
               while (i<=ClientsListView.items.count-1) and (not gbhasoutlookasstd) do     //11.02.2011 b.takacs 3.5.0.158
               begin
                 if ClientsListView.items[i].caption = 'Microsoft Outlook' then
                 begin
                    gbhasoutlookasstd := true;
                 end;
                 inc(i);
               end;
            end;
         end;
      	ClientsListView.Items.EndUpdate;
      end;
   except
      on e: Exception do
      begin
         LogEvnt('frm_MailForm.BuildClientList ' + e.Message);
      end;
   end;
end;

procedure Tfrm_MailForm.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

procedure Tfrm_MailForm.ClientsListViewSelectItem(Sender: TObject;
   Item: TListItem; Selected: boolean);
begin
	if JVMail1 <> nil then   //06.10.2011 b.takacs 3.5.1.45
  begin
   if Selected then
   begin
      JvMail1.SimpleMAPI.SelectedClientIndex := Item.Index;
      UpdateClientName;
   end;
  end;
end;

procedure Tfrm_MailForm.UpdateClientName;
begin
   GgfLogEvnt('frm_MailForm.UpdateClientName');
   if JvMail1 <> nil then  //06.10.2011 b.takacs 3.5.1.45
	   ClientLabel.Caption := JvMail1.SimpleMAPI.CurrentClientName;
   // ClientsListView.BringToFront;
end;

procedure Tfrm_MailForm.AutomaticRadioBtnClick(Sender: TObject);
begin
	if JvMail1 <> nil then       //06.10.2011 b.takacs 3.5.1.45
  begin
   with JvMail1.SimpleMAPI do
   begin
      if AutomaticRadioBtn.Checked then
         ClientConnectKind := ctAutomatic;
      if MapiRadioBtn.Checked then
         ClientConnectKind := ctMapi;
      if DirectRadioBtn.Checked then
         ClientConnectKind := ctDirect;
   end;
   UpdateClientName;
  end;
end;

procedure Tfrm_MailForm.ClientsListViewCustomDrawItem(Sender: TCustomListView;
   Item: TListItem; State: TCustomDrawState; var DefaultDraw: boolean);
begin
   if not boolean(Item.Data) then
      Sender.Canvas.Font.Color := clInactiveCaption;
end;

procedure Tfrm_MailForm.SendBtnClick(Sender: TObject);
const olMailItem = 0;
   olTo = 1;
   olCC = 2;
   olBCC = 3;

var Outlook: OLEVariant;
   MailItem,
   objOutlookRecip            // Outlook.Recipient
   : Variant;
   count: integer;
begin
   GgfLogEvntBeg('SendBtnClick beg'); //3.5.0.75
   try
      if not CreateMailComponent then //04.10.2011 b.takacs  3.5.1.45
      begin
        ShowMessage(_('E-Mail-Versand nicht mglich!'));
        Exit;
      end;


      if AttachmentMemo.Lines.Count = 0 then
      begin
         BfShowMessage(_('Es wurde kein Dokument zum E-Mail-Versand ausgewhlt.\n' +
           'Um diese Funktion ordnungsgem zu benutzen, muss mindestens\n' +
           'ein Dokument zum E-Mail-Versand ausgewhlt worden sein.'));
         exit;
      end;
 LogEvnt('DBG mail 3 - 1');
      JvMail1.Clear;
 LogEvnt('DBG mail 3 - 2');
      if sGEmailAdr = '' then
         sGEmailAdr := '@';
 LogEvnt('DBG mail 3 - 3');
      ToEdit.Text := sGEmailAdr;
 LogEvnt('DBG mail 3 - 4');
      SubjectEdit.Text := sGEmailBet;
 LogEvnt('DBG mail 3 - 5');
      JvMail1.Recipient.AddRecipient(ToEdit.Text);
 LogEvnt('DBG mail 3 - 6');
      if CcEdit.Text <> '' then
         JvMail1.CarbonCopy.AddRecipient(CcEdit.Text);
 LogEvnt('DBG mail 3 - 7');
      JvMail1.Subject := SubjectEdit.Text;
 LogEvnt('DBG mail 3 - 8');
      JvMail1.Body.Text := BodyEdit.Text;
 LogEvnt('DBG mail 3 - 9');

      try
 LogEvnt('DBG mail 3 - 10');
         JvMail1.Attachment.Assign(AttachmentMemo.Lines);
 LogEvnt('DBG mail 3 - 11');

      except on e: exception
            do
         begin
            logevnt('Error on frm_MailForm.SendBtnClick ' + e.Message);
         end;
      end;
      //  JvMail1.LogOn;

 LogEvnt('DBG mail 3 - 12');
      if gbhasoutlookasstd and gbOleoutlook then
      begin
 LogEvnt('DBG mail 3 - 13');
         try
            GgfLogEvnt('SendBtnClick: try GetActiveOleObject'); //3.5.0.75
            Outlook := GetActiveOleObject('Outlook.Application');
         except
            GgfLogEvnt('SendBtnClick: CreateOleObject'); //3.5.0.75
            Outlook := CreateOleObject('Outlook.Application');
         end;
         GgfLogEvnt('SendBtnClick: Outlook.CreateItem'); //3.5.0.75
         MailItem := Outlook.CreateItem(olMailItem);
 LogEvnt('DBG mail 3 - 14');

         //   MailItem.Recipients.Add('delphi.guide@about.com') ;
         try
            objOutlookRecip := MailItem.Recipients.Add(ToEdit.Text);
            objOutlookRecip.Type := olTo;
         except on e: exception do
            begin
            end;
         end;
 LogEvnt('DBG mail 3 - 15');
         if CcEdit.Text <> '' then
         begin
            objOutlookRecip := MailItem.Recipients.Add(CcEdit.Text);
            objOutlookRecip.Type := olCC;
         end;
 LogEvnt('DBG mail 3 - 16');
         MailItem.Subject := SubjectEdit.text;
 LogEvnt('DBG mail 3 - 17');
         //   mailitem.
         //set signature if needed
         MailItem.getinspector;
 LogEvnt('DBG mail 3 - 18');


         MailItem.HTMLBody := BodyEdit.Text + MailItem.HTMLBody;
 LogEvnt('DBG mail 3 - 19');
         count := 0;
 LogEvnt('DBG mail 3 - 20');
         while count < AttachmentMemo.Lines.Count do
         begin MailItem.Attachments.Add(AttachmentMemo.Lines.Strings[count]);

            inc(count);
         end;
         GgfLogEvnt('SendBtnClick: MailItem.display'); //3.5.0.75
         try
 LogEvnt('DBG mail 3 - 21');
            MailItem.display;
 LogEvnt('DBG mail 3 - 22');
         finally
            Outlook := Unassigned;
            objOutlookRecip := Unassigned;
            gbsendthisemailnow := False;
            GgfLogEvnt('SendBtnClick: end(1)'); //3.5.0.75
         end;
      end
      else
      begin
         GgfLogEvnt('SendBtnClick: JvMail1.SendMail vor'); //3.5.0.75
         try
	         JvMail1.SendMail(true); // aufruf des Email Client
         except
           ShowMessage(_('E-Mail-Versand nicht mglich!'));
	        Exit;
         end;
         GgfLogEvnt('SendBtnClick: JvMail1.SendMail nach'); //3.5.0.75
      end;
 LogEvnt('DBG mail 3 - 23');
      //  JvMail1.LogOff;

   finally
 LogEvnt('DBG mail 3 - 24');
      AttachmentMemo.Clear;
 LogEvnt('DBG mail 3 - 25');
      mm_attachmenttiffs.Clear;
 LogEvnt('DBG mail 3 - 26');
      frm_MailForm.ModalResult := mrOk;
 LogEvnt('DBG mail 3 - 27');
      if DirectoryExists(BD.EnvTemp + '\bfa_send\') then //07.06.2011 b.takacs 3.5.1.19 [3069]
      begin
        if not IsDirectoryEmpty(BD.EnvTemp + '\bfa_send\') then //07.06.2011 b.takacs 3.5.1.19 [3069]
        begin
          GgfLogEvntEnd('Delete file:  ' + BD.EnvTemp + '\bfa_send\*.*'); //30.05.2011 b.takacs 3.5.1.16
          BfDeleteFile(BD.EnvTemp + '\bfa_send\*.*');
        end;
      end;
 LogEvnt('DBG mail 3 - 28');
 		if assigned(JvMail1) then
      begin
         FreeAndNil(JvMail1);
      end;
      GgfLogEvntEnd('SendBtnClick end(2)'); //3.5.0.75
   end;
end;

procedure Tfrm_MailForm.AttachBtnClick(Sender: TObject);
begin
   JvOpenDialog1.FileName := '';
   if JvOpenDialog1.Execute then
      AttachmentMemo.Lines.AddStrings(JvOpenDialog1.Files);
end;

procedure Tfrm_MailForm.DownloadBtnClick(Sender: TObject);
var
   b: boolean;
begin
	try
    if not CreateMailComponent then //04.10.2011 b.takacs 3.5.1.45
    begin
    	ShowMessage(_('E-Mail-Versand nicht mglich!'));
    	Exit;
    end;

     DownloadsListView.Items.Clear;
     JvMail1.LogonOptions := [JvMail.loNewSession, JvMail.loDownloadMail];
     JvMail1.LogOn;
     try
        b := JvMail1.FindFirstMail;
        while b do
        begin
           JvMail1.ReadOptions := [roFifo, roHeaderOnly, roPeek];
           JvMail1.ReadMail;
           with DownloadsListView.Items.Add do
           begin
              Caption := JvMail1.Subject;
              SubItems.Add(JvMail1.ReadedMail.RecipientName);
              SubItems.Add(DateTimeToStr(JvMail1.ReadedMail.DateReceived));
           end;
           b := JvMail1.FindNextMail;
        end;
     finally
        JvMail1.LogOff;
        JvMail1.Clear;
        DownloadsListView.BringToFront;
     end;
  except
  end;
end;

procedure Tfrm_MailForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if assigned(JvMail1) then
   begin
      FreeAndNil(JvMail1);
   end;
end;

procedure Tfrm_MailForm.JvMail1Error(Sender: TJvMail; ErrorCode: cardinal);
begin
   logevnt('Konnte Nachricht nicht senden. Errorcode' + IntToStr(errorcode));
end;

end.


