unit u_mailform;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, JvDialogs, JvComponentBase, JvMail, StdCtrls, ComCtrls,
   u_ShLowUtils, gnugettext;

type
   Tfrm_MailForm = class (TForm)
      ClientLabel: TLabel;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      Label4: TLabel;
      Label5: TLabel;
      ClientsListView: TListView;
      DownloadsListView: TListView;
      ClientTypeGroupBox: TGroupBox;
      AutomaticRadioBtn: TRadioButton;
      MapiRadioBtn: TRadioButton;
      DirectRadioBtn: TRadioButton;
      ToEdit: TEdit;
      SubjectEdit: TEdit;
      BodyEdit: TRichEdit;
      SendBtn: TButton;
      AttachmentMemo: TMemo;
      AttachBtn: TButton;
      CcEdit: TEdit;
      DownloadBtn: TButton;
      mm_attachmenttiffs: TMemo;
      JvMail1: TJvMail;
      JvOpenDialog1: TJvOpenDialog;
      procedure FormCreate(Sender: TObject);
      procedure SendBtnClick(Sender: TObject);
   private
      fbhasoutlookasstd: boolean;
      procedure AutomaticRadioBtnClick(Sender: TObject);
      procedure BuildClientList;
      procedure UpdateClientName;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_MailForm: Tfrm_MailForm;

implementation

{$R *.dfm}
uses jclmapi, registry, u_Main, comobj;


procedure Tfrm_MailForm.BuildClientList;
var
   I: integer;
begin
   fbhasoutlookasstd := false;
   try
      ClientsListView.Items.BeginUpdate;
      ClientsListView.Items.Clear;
      ClientsListView.BringToFront;
      with JvMail1.SimpleMAPI do
      begin
         for I := 0 to ClientCount - 1 do
         begin
            with ClientsListView.Items.Add do
            begin
               Caption := Clients[I].RegKeyName;
               Data := Pointer(Clients[I].Valid);
               SubItems.Add(Clients[I].ClientName);
               SubItems.Add(Clients[I].ClientPath);
            end;
         end;
         if ClientsListView.items.count > 0 then
         begin
            if ((SelectedClientIndex < 0) or
               (SelectedClientIndex > ClientsListView.items.count)) then
            begin
               SelectedClientIndex := 0;
            end;
            ClientsListView.Items[SelectedClientIndex].Selected := True;
            AutomaticRadioBtn.Enabled := AnyClientInstalled;
            MapiRadioBtn.Enabled := SimpleMapiInstalled;
            DirectRadioBtn.Enabled := ClientCount > 0;
            if ClientsListView.selected.caption = 'Microsoft Outlook' then
            begin
               fbhasoutlookasstd := true;
            end;
         end;
      end;
      ClientsListView.Items.EndUpdate;
   except
      on e: Exception do
      begin
      end;
   end;
end;

procedure Tfrm_MailForm.FormCreate(Sender: TObject);
begin

   TranslateComponent(self);

   try
      BuildClientList;
   except
      on e: Exception do
      begin
      end;
   end;
end;


procedure Tfrm_MailForm.UpdateClientName;
begin

   ClientLabel.Caption := JvMail1.SimpleMAPI.CurrentClientName;
   // ClientsListView.BringToFront;
end;

procedure Tfrm_MailForm.AutomaticRadioBtnClick(Sender: TObject);
begin
   with JvMail1.SimpleMAPI do
   begin
      if AutomaticRadioBtn.Checked then
         ClientConnectKind := ctAutomatic;
      if MapiRadioBtn.Checked then
         ClientConnectKind := ctMapi;
      if DirectRadioBtn.Checked then
         ClientConnectKind := ctDirect;
   end;
   UpdateClientName;
end;

procedure Tfrm_MailForm.SendBtnClick(Sender: TObject);
const olMailItem = 0;
   olTo = 1;
   olCC = 2;
   olBCC = 3;
var Outlook: OLEVariant;
   MailItem,
   objOutlookRecip            // Outlook.Recipient
   : Variant;
   count: integer;
begin
   GgfLogEvntBeg('SendBtnClick beg'); //3.5.0.75
   try
      if AttachmentMemo.Lines.Count = 0 then
      begin
         BfShowMessage(_('Es wurde kein Dokument zum E-Mail-Versand ausgewhlte.\n' +
            'Um diese Funktion ordnungsgem zu benutzen, muss mindestens\n' +
            'ein Dokument zum E-Mail-Versand ausgewhlt worden sein.'));
         exit;
      end;
      JvMail1.Clear;
      ToEdit.Text := '@';
      JvMail1.Recipient.AddRecipient(ToEdit.Text);
      if CcEdit.Text <> '' then
         JvMail1.CarbonCopy.AddRecipient(CcEdit.Text);
      JvMail1.Subject := SubjectEdit.Text;
      JvMail1.Body.Text := BodyEdit.Text;

      try
         JvMail1.Attachment.Assign(AttachmentMemo.Lines);

      except on e: exception
            do
         begin
         end;
      end;
      //  JvMail1.LogOn;

      if fbhasoutlookasstd and gbOleoutlook
      then
      begin
         try
            GgfLogEvnt('SendBtnClick: try GetActiveOleObject'); //3.5.0.75
            Outlook := GetActiveOleObject('Outlook.Application');
         except
            GgfLogEvnt('SendBtnClick: CreateOleObject'); //3.5.0.75
            Outlook := CreateOleObject('Outlook.Application');
         end;
         GgfLogEvnt('SendBtnClick: Outlook.CreateItem'); //3.5.0.75
         MailItem := Outlook.CreateItem(olMailItem);
         //   MailItem.Recipients.Add('delphi.guide@about.com') ;
         try
            objOutlookRecip := MailItem.Recipients.Add(ToEdit.Text);
            objOutlookRecip.Type := olTo;
         except on e: exception do
            begin
            end;
         end;
         if CcEdit.Text <> '' then
         begin
            objOutlookRecip := MailItem.Recipients.Add(CcEdit.Text);
            objOutlookRecip.Type := olCC;
         end;
         MailItem.Subject := SubjectEdit.text;
         //   mailitem.
         //set signature if needed
         MailItem.getinspector;

         MailItem.HTMLBody := BodyEdit.Text + MailItem.HTMLBody;
         count := 0;
         while count < AttachmentMemo.Lines.Count do
         begin MailItem.Attachments.Add(AttachmentMemo.Lines.Strings[count]);
            inc(count);
         end;
         GgfLogEvnt('SendBtnClick: MailItem.display'); //3.5.0.75
         MailItem.display;
         Outlook := Unassigned;
         objOutlookRecip := Unassigned;
         GgfLogEvnt('SendBtnClick: end'); //3.5.0.75
      end
      else
      begin
         GgfLogEvnt('SendBtnClick: JvMail1.SendMail vor'); //3.5.0.75
         JvMail1.SendMail; //(true); // aufruf des Email Client
         GgfLogEvnt('SendBtnClick: JvMail1.SendMail nach'); //3.5.0.75
      end;
      //  JvMail1.LogOff;
      attachmentMemo.Clear;

      mm_attachmenttiffs.Clear;
      frm_MailForm.ModalResult := mrOk;
   finally
      GgfLogEvntEnd('SendBtnClick end'); //3.5.0.75
   end;
end;

end.
