unit U_getmac_iphlpapi;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls;

// die Windows Error msgs
const
   ERROR_NOT_SUPPORTED = $50;

const
   ERROR_INSUFFICIENT_BUFFER = 122;

const
   ERROR_INVALID_PARAMETER = 87;
   WM_NOTIFYICON = WM_USER + 333; // fr den Tray

const
   MAX_INTERFACE_NAME_LEN = $100;   // maximale Lnge Name des Interfaces

const
   MAXLEN_IFDESCR = $100;   // maximale Lnge Beschreibung des Int.

const
   MAXLEN_PHYSADDR = 8;      // maximale Lnge der physischen Adresse

// TCP-States...
const
   MIB_TCP_STATE_CLOSED = 0;

const
   MIB_TCP_STATE_LISTEN = 1;

const
   MIB_TCP_STATE_SYN_SENT = 2;

const
   MIB_TCP_STATE_SYN_RCVD = 3;

const
   MIB_TCP_STATE_ESTAB = 4;

const
   MIB_TCP_STATE_FIN_WAIT1 = 5;

const
   MIB_TCP_STATE_FIN_WAIT2 = 6;

const
   MIB_TCP_STATE_CLOSE_WAIT = 7;

const
   MIB_TCP_STATE_CLOSING = 8;

const
   MIB_TCP_STATE_LAST_ACK = 9;

const
   MIB_TCP_STATE_TIME_WAIT = 10;

const
   MIB_TCP_STATE_DELETE_TCB = 11;

// -----------------------------------TCP Stats ---------------------
type
   TMIB_TCPROW = record
      dwState: longint;        //Status der Verbindung
      dwLocalAddr: array[0..3] of byte;   //Adresse des lokalen computer
      dwLocalPort: array[0..3] of byte;    //Port des lokalen computer
      dwRemoteAddr: array[0..3] of byte;   //Adresse des Remote computer
      dwRemotePort: array[0..3] of byte;   //Port des Remote computer
   end;

type
   TMIB_TCPTABLE = record
      dwNumEntries: longint;    //Anzahl der Eintrge in der Tabelle
      table: array [0..100] of TMIB_TCPROW;   //Feld fr TCP-Verbindungen
   end;

// -----------------------------------UDP Stats ---------------------
type
   TMIB_UDPROW = record
      dwLocalAddr: string; //Adresse des lokalen computer
      dwLocalPort: string; //Port des lokalen computer
   end;

type
   TMIB_UDPTABLE = record
      dwNumEntries: longint;    //Anzahl der Eintrge in der Tabelle
      table: array [0..100] of TMIB_UDPROW;   //Feld fr UDP-Verbindungen
   end;

// Die Struktur eines IFRow-Tables - wird fr jedes Interface erstellt
type
   TMIB_IFROW = record
      wszName: array [0 .. (MAX_INTERFACE_NAME_LEN * 2 - 1)] of byte;
      dwIndex: cardinal;            // index of the interface
      dwType: longint;   // type of interface
      dwMtu: longint;   // max transmission unit
      dwSpeed: longint;   // speed of the interface
      dwPhysAddrLen: longint;// length of physical address
      bPhysAddr: array [0 .. (MAXLEN_PHYSADDR - 1)] of
      byte;// physical address of adapter
      dwAdminStatus: longint;// administrative status
      dwOperStatus: longint;// operational status
      dwLastChange: longint;// last time operational status changed
      dwInOctets: longint;// octets received
      dwInUcastPkts: longint;// unicast packets received
      dwInNUcastPkts: longint;// non-unicast packets received
      dwInDiscards: longint;// received packets discarded
      dwInErrors: longint;// erroneous packets received
      dwInUnknownProtos: longint;// unknown protocol packets received
      dwOutOctets: longint;// octets sent
      dwOutUcastPkts: longint;// unicast packets sent
      dwOutNUcastPkts: longint;// non-unicast packets sent
      dwOutDiscards: longint;// outgoing packets discarded
      dwOutErrors: longint;// erroneous packets sent
      dwOutQLen: longint;// output queue length
      dwDescrLen: longint;// length of bDescr member
      bDescr: array[0 .. (MAXLEN_IFDESCR - 1)] of char;// interface description
   end;
// Struktur des IfTables
type
   TifTable = record
      nRows: longint;   // Anzahl Interfaces
      ifRow: array[1..20] of TMIB_IFROW;
      // mehr als 20 sollten es aber nicht sein!
   end;

type
   TGetmac = class (TObject)
      ListBox1: TListBox;
      Label1: TLabel;
   private
      { Private-Deklarationen }
      ia: array of integer;
   public
      cCode: word;
      sllist: TStringList;
      pIfTable: ^TifTable;    // ein Pointer auf eine Interfacetabelle
      L: record               // L ist ein Record fr das Auslesen der Werte
         cbRequired: longint;  // wird gebraucht, um die bentigte Buffer-Gre zu ermitteln
         nStructSize: longint;
         tmp: string;
      end;
      constructor Create;
      function MacAdresse(var Addr): string;
      function getfirstmac: string;
      { Public-Deklarationen }
   end;

// Einbinden der Funktion aus iphlpapi, um empfangene und gesendete Bytes und die Interfaces-Stats zu holen
function GetIfTable(pIfRowTable: Pointer; var pdwSize: longint;
   bOrder: longint): longint; stdcall;
function GetIfTable; external 'iphlpapi.dll' Name 'GetIfTable';

implementation

constructor TGetmac.Create;
var
   i, counter: integer;
begin
   inherited;
   pIfTable := nil;
   ZeroMemory(@L, sizeof(L));
   // schauen, wie gross die Tabelle ist..
   cCode := GetIfTable(pIfTable, L.cbRequired, 1);
   if (L.cbRequired <= 0) or (L.cbRequired > sizeof(TifTable)) then
      exit;
   // Mem allokieren und IP-Table empfangen...
   GetMem(pIfTable, L.cbRequired);
   ZeroMemory(pIfTable, L.cbrequired);
   cCode := GetIfTable(pIfTable, L.cbRequired, 1);

   if cCode <> ERROR_SUCCESS then
   begin
      ShowMessage('Fehler beim Funktionsaufruf');
      exit;
   end;
   counter := 0;
   sllist := TStringList.Create;
   for i := 1 to pIfTable^.nRows do
   begin
      if Pos('loopback', lowercase(StrPas(@pIfTable^.ifRow[i].bDescr))) > 0 then
      begin
         continue;
      end;
      if Pos('virtual', lowercase(StrPas(@pIfTable^.ifRow[i].bDescr))) > 0 then
      begin
         continue;
      end;
      setlength(ia, i);
      ia[counter] := i;
      counter := counter + 1;
      sllist.Add(StrPas(@pIfTable^.ifRow[i].bDescr));
   end;
end;

function TGetmac.MacAdresse(var Addr): string;
var
   daten: array[0..6] of byte absolute Addr;
begin
   Result := Format('%2.2x-%2.2x-%2.2x-%2.2x-%2.2x-%2.2x',
      [Daten[0], daten[1], Daten[2], Daten[3], Daten[4], Daten[5]]);
end;

function TGetmac.getfirstmac: string;
   // Die Windwos Error Messages...

const
   ERROR_NOT_SUPPORTED = $50;
const
   ERROR_INSUFFICIENT_BUFFER = 122;
const
   ERROR_INVALID_PARAMETER = 87;

begin
   pIfTable := nil;
   ZeroMemory(@L, sizeof(L));
   // schauen, wie gross die Tabelle ist..
   cCode := GetIfTable(pIfTable, L.cbRequired, 1);

   if (L.cbRequired <= 0) or (L.cbRequired > sizeof(TifTable)) then
      exit;

   // Mem allokieren und IP-Table empfangen...
   GetMem(pIfTable, L.cbRequired);
   ZeroMemory(pIfTable, L.cbrequired);
   cCode := GetIfTable(pIfTable, L.cbRequired, 1);

   if cCode <> ERROR_SUCCESS then
   begin
      ShowMessage('Fehler beim Funktionsaufruf');
      exit;
   end;
   L.tmp := MacAdresse(pifTable^.ifRow[ia[0]].bPhysAddr);
   Result := L.tmp;
     {L.tmp := Format ('phys Add.: %s', [L.tmp]);
     Memo1.Lines.Add(L.tmp);
     Memo1.Lines.Add('Index: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwIndex));
     Memo1.Lines.Add('Typ: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwType));
     Memo1.Lines.Add('Mtu: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwMtu));
     Memo1.Lines.Add('Speed: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwSpeed));
     Memo1.Lines.Add('AdminStatus: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwAdminStatus));
     Memo1.Lines.Add('OperStatus: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwOperStatus));
     Memo1.Lines.Add('LastChange: ' + inttostr(pIfTable^.ifRow[ia[listbox1.itemindex]].dwLastChange));
     Memo1.Lines.add(''); }
   freemem(piftable, sizeof(piftable));
end;

end.
