// Unit Vectors
(**************************************************

- Enthlt: TVector2f

**************************************************)

unit Vectors;

interface

type
   // 2D Vektor
   TVector2f = record
      X, Y: extended;
   end;

// Zwei extendeds in einen TVector2f umwandeln
function To_v2f(X, Y: extended): TVector2f;
// Zwei Vektoren addieren
function v2f_Add(V1, V2: TVector2f): TVector2f;
// Einen Vektor von einem anderen subtrahieren
function v2f_Sub(V1, V2: TVector2f): TVector2f;
// Einen Vektor skalieren
function v2f_Scale(V: TVector2f; Scalar: extended): TVector2f;
// Ermittelt die Lnge eines Vektors
function v2f_Length(V: TVector2f): extended;
// Normalisiert einen Vektor (sodass v2f_length = 1)
function v2f_Normalize(V: TVector2f): TVector2f;
// Ermittelt ds Skalarprodukt
function v2f_DotProduct(V1, V2: TVector2f): extended;

implementation

function To_v2f(X, Y: extended): TVector2f;
begin
   Result.X := X;
   Result.Y := Y;
end;

function v2f_Add(V1, V2: TVector2f): TVector2f;
begin
   Result.X := V1.X + V2.X;
   Result.Y := V1.Y + V2.Y;
end;

function v2f_Sub(V1, V2: TVector2f): TVector2f;
begin
   Result.X := V1.X - V2.X;
   Result.Y := V1.Y - V2.Y;
end;

function v2f_Scale(V: TVector2f; Scalar: extended): TVector2f;
begin
   Result.X := V.X * Scalar;
   Result.Y := V.Y * Scalar;
end;

function v2f_Length(V: TVector2f): extended;
begin
   Result := sqrt(V.X * V.X + V.Y * V.Y);
end;

function v2f_Normalize(V: TVector2f): TVector2f;
var
   L: extended;
begin
   L := v2f_Length(V);

   if L = 0 then
      L := 1;

   Result := v2f_Scale(V, 1 / L);
end;

function v2f_DotProduct(V1, V2: TVector2f): extended;
begin
   Result := V1.X * V2.X + V1.Y * V2.Y;
end;

end.
