//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv
// Entwickler: m.frey
// Erstellt:   2009-10-07
// Name:       u_ShBase
// Typ:        Unit
// Zweck:      Grundlegenede Definitionen fr alle Module
//-----------------------------------------------------------------------------
// die uses-Liste ist klein zu halten und es drfen nur low-level verwendet werden.
// eher nur consts und types, wenig procedures und functions
//
//----------------------------------------------------------------------------}

unit u_ShBase;

{###############################} INTERFACE {###############################}

{$WRITEABLECONST ON}

uses
  Windows, SysUtils, Math, SvcMgr, Graphics,
  //MyAccess,
  Nb30, gnugettext,
  u_getmac_iphlpapi;

type
  TArcDocId = record
     ArcId: int64;
     DocId: int64;
  end;
  TUsrId = int64;

var
  //	gclLime,
//   gclRed,
//   gclTeal,
//   gclFree,
//   gclWork,
//   gclDone,
//   gclUrgent,
//   gclFree_Selected,
//   gclWork_Selected,
//	gclDone_Selected,
//   gclUrgent_Selected,
//   gclRot,
//   gclBraun,
//   gclYellow
//   : TColor;


   	//Standardfarben
   gclLime 	: TColor = clLime;
   gclRed 	: TColor = clRed;
   gclTeal 	: TColor = clTeal;
   gclFree 	: TColor = clwhite;
   gclWork 	: TColor = $0065ffff;//clyellow;
   gclDone 	: TColor = $0005EF11;
   gclUrgent: TColor = clRed;
   gclFree_Selected 	: TColor = $00bdbdbd;
   gclWork_Selected 	: TColor = $0000a3e1;
	gclDone_Selected 	: TColor = $00009100;
   gclUrgent_Selected: TColor = $000000b7;
   gclRot 	: TColor = $002828FF; 	// ~ rot
   gclBraun : TColor = $003A3A70; 	// ~ braun
   gclYellow: TColor = $00FFFF;	// ~ gelb
   gclOlive : TColor = clOlive;
   gclNone  : TColor = clNone;

const
	cCurYear = '2014';

const 
  cDateTimeUndefined = NaN; // Um bei Parametern angeben zu knnen, dass undefiniert

const
	GlobalKey = 'b17fa300900b421333de672c41a0d';

const
  	globalDelimiter = ',';

const
  Zoll = 0.03937007874015748031496062992126;

const
  //Optionen fr Zusatzfeld
  cZusatzFeldOptEingabepflicht = 1;
  cZusatzFeldOptVerknuepfung   = 2;
  cZusatzFeldOptNamensfeld     = 4;

  cBackSlash = char (92);

  //Optionen fr Archiv
  cArchivOptNamePflicht = 1;  // "Titelpflicht"
  cArchivOptNameArchiv  = 2;  // "Dokname aus Archiv"
  //
  cColorPflichtfeld = $00CAE4FF;
  cColorHellgruen   = $00E1FFE6; // Hellgrn - fr genderte Felder
  cColorHellblau    = $00F1FFC6; // fr genderte und gesuchte Felder
  cColorNoRightInit = $00E0E0E0;
  cColorNoRight     = $00E0E0E1; //c0e1ff  //00a3d4ff   //adb4de  //hellrotbraun //No right 1
  cColorNoRightChg  = $00adb4ff; //c0e1ff  //00a3d4ff   //adb4de  //hellrotbraun //No right 2
  cColorNoRightStat = $008489a9; //c0e1ff  //00a3d4ff   //8489a9  //rotbraun  //No right fr Status
  cColorWhite       = $00FFFFFF;
  cColorRed         = $000000FF;
  //
  cDocNameDefault = 'Dokument';

  //3.5.0.92
  cEmptyDateString = '  .  .    ';

  //3.5.0.121 f.schneider  Konstanten und Typen aus u_ViewBase integriert, um diese auch den
  //anderen Anwendungen zur Verfgung zu stellen
const
  sfVoransicht = 1;
  sfVolltext   = 2;
  sfDocLink    = 3;
  sfHistory    = 4;
  sfRechte     = 5;
  sfNix        = 6;
  sfCommentary = 7;

const
  // Angemeldet als: = 0
  cStatusPanelUser   = 1;
  // Server:         = 2
  cStatusPanelServer = 3;
  cStatusPanelDoc    = 5;
  cStatusPanelInfo   = 7;

  cStatusPanelDocIdTrennzeichen = '/';

  //
const
  vctpNormal = 0;		//ViewerConnectionType Normal (Default 3.5)
  vctpSocket = 1;   //ViewerConnectionType Socket (Client Server Connection)
  sctpSSL 	 = 0;   //SocketType SSL (only at vctpSocket)
  sctpNoSSL  = 1;   //SocketType NoSSL (only at vctpSocket)
  annoPub = 0;      // Public Annotation
  annoPriv = 1;     // Private Annotation
  respOk = 0;       // Socket response OK
  respError = 1;    // Socket response Error


//
resourcestring

  strReqAnmeldung			  = 'reqAnmeldung';
  strReqDoc					  = 'reqDoc';
  strReqVoransicht        = 'reqVoransicht';
  strReqIEV               = 'reqIev';
  strReqIevCheck          = 'reqIevCheck';
  strReqSendIev           = 'reqSendIev';
  strReqSendVoransicht    = 'reqSendVoransicht';
  strReqSendOri           = 'reqSendOri';
  strRespAuth             = 'respAuth';
  strReqOri               = 'reqOri';
  strIEVPublic            = 'public';
  strIEVPrivate           = 'private';
  strReqIevDelete         = 'reqIevDelete';
  strReqQueuecount        = 'reqQueuecount';
  strReqDuplicateDoc      = 'reqDuplicateDoc';
  strReqResetOriginal     = 'reqResetOriginal';
  strReqMoveDoc  			  = 'reqMoveDoc';
  strRespSendReady        = 'respSendReady';
  strRespSendComplete     = 'respSendComplete';
  strRespOK               = 'respOK';
  strRespError            = 'respError';
  strReqFinished          = 'finished';
  strXMLEndTag						= '</bfreq>';



type
     //annotationsdata
   TAnnoData = record
      version: string[50];
      Ersteller: string[100];
      Datum: string[255];
      Veraenderer: string[255];
   end;
   PAnnoData = ^TAnnoData;

  // ein Typ zur Speicherung von Anzeigezustnden
  TDocViewSave = record
                   Doc: TArcDocId; // Das Dokument
                   Page: integer; // Die Seite
                 end;
  TDocViewSaves = array [0..5] of TDocViewSave;

	// Callback-Funktionen fr frm_Voransicht
  TOnObjectOver = procedure(annodata : PAnnoData) of object;
  TOnDblClick = procedure(Sender : TObject) of object;

  //3.5.0.23
type // Record mit Rechtevariablen fr Archiv- und Dokumentenrechte
   TRData = record
      list,
      print,
      read,
      link,
      modify,
      import,
      write,
      history,
      mail,
      move,
      aread,
      awrite,
      amodify,
      apwrite,
      apread,
      hstprotoread,
      suanno,
      docdel,
      docexport,
      revsave: boolean;
   end;



function ArcDocId(ArcId, DocId: int64): TArcDocId;

{############################} IMPLEMENTATION {#############################}

//-----------------------------------------------------------------------------
function ArcDocId(ArcId, DocId: int64): TArcDocId;
begin
  Result.ArcId := ArcId;
  Result.DocId := DocId;
end;


//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

initialization

finalization

end.

