//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv Administrator
// Entwickler: Frey
// Erstellt:   2009-10-29
// Name:       
// Typ:        Unit
// Zweck:      Utilities fr Zusatzfelder
//-----------------------------------------------------------------------------
{
Prefixe fr Komponenten:
- 'lfb' - Der Button um ein Editfeld anzuzeigen

//----------------------------------------------------------------------------}

unit u_ShFrameZusFldMulti;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, JvExForms, JvScrollBox, StrUtils, ImgList,

   TBXDkPanels, MyAccess, gnugettext,
   JvStaticText, JvToolEdit, JvCombobox, JvSpin,
   u_ShLowUtils, u_ShDbUtils, u_ShBase;



const
   cZusFldTyp0Universalfeld       = 0;
   cZusFldTyp1Datumsfeld          = 1;
   cZusFldTyp2Auswahlfeld         = 2;
   cZusFldTyp3MehrfachAuswahlfeld = 3;
   cZusFldTyp4Obsolet             = 4;
   cZusFldTyp5Intervalfeld        = 5;
   cZusFldTyp6Ganzzahl            = 6;
   cZusFldTyp7Fliesskomma         = 7;
   cZusFldTyp8Waehrung            = 8;


type
  TFrameZusFldMulti = class(TFrame)
    il_ZusFldMulti: TImageList;
  private
    { Private-Deklarationen }
    procedure EditKeyPress(Sender: TObject; var Key: Char);
    procedure ZusFeldMehrfachCreateEdit(Sender: TObject);
    procedure EditZusfieldCheckedExit(Sender: TObject);
    procedure EditZusfieldCheckedKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  public
    ComboBox: TJvCheckedComboBox;
    Button: TTBXButton;
    Edit: TEdit;
    procedure Clear;
    procedure FillJvCheckedComboBox(sAdd, sIArcName:string);
    procedure FreeComboAndButton;
  end;


function CreateTJvCheckedComboBox(Container: TWinControl;
                                  Index,
                                  iTop, 
                                  Left,
                                  Width    : integer;
                                  Feldname,
                                  sAdd,
                                  sIArcName:string;
                                  OnChange :TNotifyEvent;
                                  Mode     :integer      ): TFrameZusFldMulti;


function FindComponentRekursivFrame(Container: TComponent; const AName: string): TComponent;
//[2351]
procedure ComboBoxAddOneKomma(Combo:TComboBox; const Werte:string);


var DebugJvCheckedComboBox: TJvCheckedComboBox;

implementation

{$R *.dfm}
//-----------------------------------------------------------------------------
function FindComponentRekursivFrame(Container: TComponent; const AName: string): TComponent;
var
  I: Integer;
begin
	try
 //  GgfLogevnt('FindComponentRekursivFrame begin');

    if (AName <> '') and (Container <> nil) then
      for I := 0 to Container.ComponentCount - 1 do
      begin
        Result := Container.Components[I];
        if SameText(Result.Name, AName) then Exit;
        if Result is TFrame then
           begin
              Result :=  FindComponentRekursivFrame(Result, AName);
              if Assigned(Result) then
                 Exit;
           end;
      end;
    Result := nil;
 //  GgfLogevnt('FindComponentRekursivFrame end');
  except
   GgfLogevnt('FindComponentRekursivFrame Exception');
  end;
end;

//-----------------------------------------------------------------------------
//[2351]
procedure ComboBoxAddOneKomma(Combo:TComboBox; const Werte:string);
var sTmp:string;  lstlw: TStringList;  licount2: integer;
begin
   lstlw := StrToWords7(Werte);
   try
      for licount2 := 0 to lstlw.Count - 1 do
      begin
         sTmp := lstlw.Strings[licount2];
         AddListWhenNot(Combo.Items, sTmp);
      end;
   finally
      FreeAndNil(lstlw);
   end;
end;

//-----------------------------------------------------------------------------

function CreateTJvCheckedComboBox (Container: TWinControl;
                                   Index,
                                   iTop,
                                   Left,
                                   Width    : integer;
                                   Feldname,
                                   sAdd,
                                   sIArcName:string;
                                   OnChange :TNotifyEvent;
                                   Mode     :integer     ): TFrameZusFldMulti;
var
	lcomp: TComponent;
  ZusFldFrame: TFrameZusFldMulti;
begin
	 lcomp:= FindComponentRekursivFrame(Container, 'zedt_Tmp_Frame' + IntToStr(Index));
   if lcomp <> nil then
   begin
     ZusFldFrame:= (lcomp as TFrameZusFldMulti);
		 Result:= ZusFldFrame;
   end
   else
	   Result:=TFrameZusFldMulti.Create(Container);
   Result.Name := 'zedt_Tmp_Frame' + IntToStr(Index);
   Result.Left := Left;
   if iTop = -1 then
	   Result.Top := 21 + (38 * Index)
   else
	   Result.Top := 21 + (38 * Index) - iTop;
   Result.Height := 1 + 21 + 1 + 2 + 10;
   Result.Width := Width;
   Result.Anchors := [akLeft, akTop, akright];
   Result.AutoScroll := False;
   Result.Parent := Container;

   Result.ComboBox := TJvCheckedComboBox.Create(Result);
   Result.ComboBox.Name := 'zedt_Tmp' + IntToStr(Index);
   //Result.ComboBox.Caption := ''; // geht nicht versteckt
   Result.ComboBox.Perform(WM_SETTEXT, 0, Integer(PChar('')) );
   Result.ComboBox.Hint := _('Auswahlmaske fr das Feld') + ' ' + #34 + Feldname + #34;
   Result.ComboBox.ShowHint := True;
   Result.ComboBox.Left := 0;
   Result.ComboBox.Top := 1;
   Result.ComboBox.Height := 21;
   Result.ComboBox.Width := Result.Width - 23;
   Result.ComboBox.Anchors := [akLeft, akTop, akRight];
   Result.ComboBox.TabStop := true;


   //  02.06.2010  Vers. 3.5.0.80  [2450]  r.sch.
   //  ich glaube, der Author dieser Prozedur hat einfach vergessen,
   //  die beiden folgenden Zeilen korrekt anzupassen!
   //
   //Result.ComboBox.OnChange := EnableSaveOnChange;
   //Result.ComboBox.Tag := FieldByName('Mode').AsInteger;

   Result.ComboBox.OnChange := OnChange;
   Result.ComboBox.Tag := Mode;
   Result.ComboBox.Sorted := true;
   Result.ComboBox.DropDownLines := 30;

   Result.ComboBox.Parent := Result;
   Result.ComboBox.Delimiter := Char(globalDelimiter);

	 lcomp:= FindComponentRekursivFrame(Result, 'lfbzedt_Tmp' + IntToStr(Index));
   if lcomp = nil then
   begin
	   Result.Button := TTBXButton.Create(Result);
     Result.Button.Name := 'lfbzedt_Tmp' + IntToStr(Index);
  	 Result.Button.Left := Result.Width - 21;
   	 Result.Button.Top := 0;
   	 Result.Button.Width := 21;
   	 Result.Button.Height := 21;
   	 Result.Button.Anchors := [aktop, akright];
   	 Result.Button.Caption := '';
   	 Result.Button.Images := Result.il_ZusFldMulti;
   	 Result.Button.ImageIndex := 0;
   	 Result.Button.OnClick := Result.ZusFeldMehrfachCreateEdit;
   	 Result.Button.Parent := Result;
   	 Result.Button.TabStop := false;
   end;

   Result.FillJvCheckedComboBox(sAdd, sIArcName);
end;


//-----------------------------------------------------------------------------

procedure TFrameZusFldMulti.FillJvCheckedComboBox;
var lstlw: TStringList;
   procedure WertAuswerten(Werte:string);
   var i: integer;  sTmp: string;
   begin
      // v3.5.0.89 f.schneider Test
      lstlw := StrToWords6 (Werte);
      //lstlw := StrToWords7 ('"",' + Werte);
      try
         for i := 0 to lstlw.Count - 1 do
         begin
            sTmp := lstlw.Strings[i];
            if (ComboBox.Items.IndexOf(lstlw.Strings[i]) = -1) and  //noch nicht drin?
               (lstlw.Strings[i] <> '') then
            begin
               ComboBox.Items.Add(lstlw.Strings[i]);
            end;
         end;
      finally
         FreeAndNil(lstlw);
      end;
   end;
var lmq: TMyQuery;  lsWerte, lsTable:string; //3.5.0.35 [2387]
begin
   GgfLogevnt('FillJvCheckedComboBox');
   lmq := DbCreateQuery;
   try

      // Zuerst ein Leerwert zur Suche
      ComboBox.Items.Add('""');
      (**)                                                                                 
      LastSQL := 'select Werte from cfg_' + sIArcName + ' where Feld_Name = ' + AddQuote(sAdd) ;
      DbExecSql(lmq,LastSQL);

      while not lmq.EOF do
      begin
         lsWerte := lmq.FieldByName('Werte').AsString;
         WertAuswerten(lsWerte);
         lmq.Next;
      end;

      lsTable := 'arc_' + sIArcName; //3.5.0.35 [2387]
      if DbTableExist(lsTable) then //3.5.0.35 [2387]
      begin
         LastSQL := 'select distinct ' + sAdd + ' from ' + lsTable + ' where ' + sAdd + ' <> ' + #34 + #34; //3.5.0.35 [2387]
         DbExecSql(lmq,LastSQL);

         while not lmq.EOF do
         begin
            lsWerte := lmq.FieldByName(sAdd).AsString;
            WertAuswerten(lsWerte);
            lmq.Next;
         end;
      end;
   finally
      lmq.Free;
   end;
   if ComboBox.DropDownLines > ComboBox.Items.Count then
      ComboBox.DropDownLines := ComboBox.Items.Count;
end;


//-----------------------------------------------------------------------------
procedure TFrameZusFldMulti.EditZusfieldCheckedExit;
//var Btn: TTBXButton; ls:string;
begin
   GgfLogevnt('EditZusfieldCheckedExit');
   (*
   ls := 'lfb' + copy(Edit.name, 6, length(Edit.name));
   Btn := TTBXButton(FindComponentRekursivFrame(Container, ls));
   Btn.Visible := true;
   Edit.visible := false; // warum false und nicht Free? Der wird doch wieder neu erzeugt
   //freeandnil(lfedt);
   *)
   Button.Visible := true;
   Edit.Visible := false;
   ComboBox.Width := Width - 23;
end;

//-----------------------------------------------------------------------------
// Beim Klicke auf den Button mit dem grnen Kreuz
procedure TFrameZusFldMulti.ZusFeldMehrfachCreateEdit;
var ls: string;   Btn: TTBXButton;
begin
   GgfLogevnt('ZusFeldMehrfachCreateEdit');
   Btn := TTBXButton(Sender);
   Btn.Visible := false;

   if Edit = nil then
   begin
      Edit := Tedit.Create(Self);
      Edit.OnKeyDown := EditZusfieldCheckedKeyDown;
      Edit.OnExit := EditZusfieldCheckedExit;
      Edit.Parent := Self;
      ls := '';
   end
   else
   begin
      ls := Edit.Text;
   end;
   Edit.Name      := 'ed' + Btn.name;
   Edit.Top       := 1;
   Edit.Text      := ls;
   Edit.OnKeyPress:= EditKeyPress;

   ComboBox.Width := Width *2 div 3;
   Edit.Left   := ComboBox.Width;
   Edit.Width  := Width - ComboBox.Width;

   Edit.Visible:= true;
   Edit.SetFocus;
end;

//-----------------------------------------------------------------------------
procedure TFrameZusFldMulti.Clear;
begin
   if DebugJvCheckedComboBox = nil then
      DebugJvCheckedComboBox := ComboBox;
   if not Assigned(ComboBox) then
   begin
      Exit;
   ComboBox.Items.Clear;
   ComboBox.Text:='';
end;
end;

//-----------------------------------------------------------------------------
// Hier werden etliche Zeichen verboten
procedure TFrameZusFldMulti.EditKeyPress(Sender: TObject; var Key: Char);
begin
   // if not (key in ['0'..'9',#13,#8, '.' , ',' ]) then key := #0;

   if Key in [
      '!', // Trenner
      //'"', // Anfhrungszeichen, reserviert als Quote und auch SQL //3.5.0.46 [2414]
      //  '%', // wegen SQL mit like //3.5.0.71 wieder dazu
      #24, // Apostroph, wegen SQL
      #39, // Apostroph, wegen SQL
      '(', // wegen SQL
      ')', // wegen SQL
      '\', // wegen SQL
      '*', // vielleicht mal Platzhalter
      ',', // Trenner
      '?', // vielleicht mal Platzhalter
      '`', // wegen SQL
      '{', // wegen - rein vorsichtshalber
      '|', // wegen - rein vorsichtshalber
      '}', // wegen - rein vorsichtshalber
      #160 // geschtztes Leerzeichen
      ] then
         Key := #0;
end;

//-----------------------------------------------------------------------------
procedure TFrameZusFldMulti.EditZusfieldCheckedKeyDown;
var
   li, licounter, licounter2, liNeu: integer;
   lai: array of integer;
begin
   GgfLogevnt('EditZusfieldCheckedKeyDown');
   if key = VK_Return then // Enter gedrckt
   begin
      licounter := ComboBox.Items.IndexOf(Edit.Text);
      if licounter = -1 then
      begin
         setlength(lai, ComboBox.CheckedCount);  // Speicher fr die Markierung reservieren
         licounter2 := 0;
         for licounter := 0 to ComboBox.Items.Count -1 do
         begin
            if ComboBox.Checked[licounter] then
            begin
               lai[licounter2] := licounter;
               inc(licounter2);
            end;
         end;
         ComboBox.SetUnCheckedAll();
         li := ComboBox.Items.Add(Trim(Edit.Text));
         ComboBox.Checked[li] := true;
         if length(lai) > 0 then    // m.frey: braucht man das?
         begin
            for licounter := 0 to length(lai)-1 do
            begin
               liNeu := lai[licounter];
               //[ 2275 ] Manuscan: Einfgen zustzlicher Werte in Mehrfachauswahlfelder verschiebt die schon vorhandene Auswahl
               if liNeu>=li // wenn hinter dem eingefgten dann ist das nun eines weiter.
               then inc(liNeu);
               //
               ComboBox.Checked[liNeu] := true;
            end;
         end;
      end
      else
      begin
         ComboBox.Checked[licounter] := true;
      end;
      Edit.visible := false;

      Button.Visible := true;
      //     freeandnil(lfedt);
   end;
   if (ComboBox.DropDownLines < ComboBox.Items.Count)
   and (ComboBox.Items.Count < 30) then
      ComboBox.DropDownLines := ComboBox.Items.Count;
end;

//-----------------------------------------------------------------------------

procedure TFrameZusFldMulti.FreeComboAndButton;  //3.5.0.11
begin
   FreeAndNil(ComboBox);
   FreeAndNil(Button);
end;


//-----------------------------------------------------------------------------
begin end.
//-----------------------------------------------------------------------------
