//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv
// Entwickler: m.frey
// Erstellt:   2009-10-14
// Name:       u_ShHighUtils
// Typ:        Unit
// Zweck:      Diverse Routinen
//-----------------------------------------------------------------------------
// Regeln fr die uses-Liste:
// - Datenbankzugriffe sind erlaubt
// - ebenfalls erlaubt sind alle Standard-VCL-Units
// - nicht erlaubt andere Units mit Formularen
//----------------------------------------------------------------------------}

unit u_ShHighUtils;

{###############################} INTERFACE {###############################}

{$WRITEABLECONST ON}


uses
  Windows, SysUtils, Classes, Dialogs, Menus, ShlObj, Activex, StrUtils, Math, DB,
  Forms, // SvcMgr muss vor Forms kommen
  Spin, StdCtrls, ExtCtrls, ShellApi, psIBTreeView, TBX, TB2Item,
   JvComponentBase, JvBalloonHint, JvExMask, JvToolEdit, JvExStdCtrls, JvCombobox,
   JvListComb, JvExControls, JvComponent, JvSimIndicator, JvDragDrop,
   JvExComCtrls, JvAnimate, JvExExtCtrls,
   JvExtComponent, JvOfficeColorButton, JvColorTrackbar, JvFullColorSpaces,
   JvFullColorCtrls, JvProgressBar, JvStaticText, JvSpeedButton, JvgCheckBox,
   JvExForms, JvScrollBox, JvSpin, //JvDBSpinEdit,
   MyAccess, gnugettext, IniFiles, Graphics, u_ShDefs, u_ShRecTab,
   u_ShBase, u_ShLowUtils, u_ShDbUtils, u_ShFrameZusFldMulti;
{>3.6}

type
   Tversion = record
      Major: integer;
      Minor: integer;
      compile: integer;
      revision: integer;
   end;

var
  LastLsAdd : String;     // speichert die letzte Liste der Addfields fr  DbCreateTempTable

procedure SplitVersionString(const fsversion: String; var fversion: Tversion);
function compareversions(var fversion, fversion1: Tversion): boolean;
function PruefeProgrammversion(sModul:string):Boolean;
procedure ZusatzfelderAuftrennen(const Inhalt:string; var sl:TStringlist);
function PruefeObVerknuepfungAnlegen(sIArcName, sZusatzFeld:string):Boolean;
const
   // die Felder von Tabelle "sys_timer" zum Erzeugen
   cCreateSysTimer =
          '`tim_id` bigint(20) unsigned NOT NULL auto_increment,' +
         '`tim_ref` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`arc_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`doc_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`doc_titel` varchar(32) collate latin1_german1_ci NOT NULL default ' + #39 + #39 + ',' +
         '`grp_id` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`usr_id_work` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`usr_id_shed` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`status` int(10) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`termin` datetime NOT NULL default ' + #39 + '1900-01-01 00:00:00' + #39 + ',' +
         '`erinnerung` datetime NOT NULL default ' + #39 + '1900-01-01 00:00:00' + #39 + ',' +
         '`Optionen` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         '`info` varchar(255) collate latin1_german1_ci NOT NULL default ' + #39 + #39 + ',';



procedure ClearAdditionalFields(Container: TComponent);

// gibt eine Liste aller UserIds in einem String kommagetrennt zurck, fr die
// ein angegeber User Vertretung ist

function  DbUserIdI(Name: string):int64;
function  DbUserIdS(Name: string):string;
function  DbGroupIdI(Name: string):int64;
function  DbGroupIdS(Name: string):string;
procedure DbGetLinks(const Strings:TStrings; const sSub : string);
procedure DbCreateTempTable(sTblname: string; const Addfields:TStringList = nil);

function ShellExecute_AndWait(Operation, FileName, Parameter, Directory: string;
   Show: word; bWait: boolean): longint;
procedure ReadCbxArc(ArcCbx: TJvCombobox; UsrID, LgrID: Integer);
procedure ReadCbxLgr(LgrCbx: TJvComboBox; dbtv : TpsDBTreeView);
function NewHistoryID(Funktion: integer; Text: string;
   farc_id, fdoc_id: int64; userid: Integer): boolean;


{############################} IMPLEMENTATION {#############################}


//-----------------------------------------------------------------------------
procedure SplitVersionString(const fsversion: String; var fversion: Tversion);
var
   li, li1: integer;
begin
   li1 := posex('.', fsversion);
   trystrtoint(copy(fsversion, 1, li1 - 1), fversion.major);
   li := li1;
   li1 := posex('.', fsversion, li + 1);
   trystrtoint(copy(fsversion, li + 1, li1 - li - 1), fversion.minor);
   li := li1;
   li1 := posex('.', fsversion, li + 1);
   trystrtoint(copy(fsversion, li + 1, li1 - li - 1), fversion.compile);
   li := li1;
   trystrtoint(copy(fsversion, li + 1, length(fsversion) - li), fversion.revision);
end;

//-----------------------------------------------------------------------------
//compare if fversion is bigger than version1
function compareversions(var fversion, fversion1: Tversion): boolean;
begin
   Result := true;
   if fversion.major < fversion1.major then
   begin
      Result := false;
   end
   else
   begin
      if (fversion.minor < fversion1.minor) and (fversion.major = fversion1.major) then
      begin
         Result := false;
      end
      else
      begin
         if (fversion.compile < fversion1.compile) and ((fversion.minor = fversion1.minor) and (fversion.major = fversion1.major)) then
         begin
            Result := false;
         end
         else
         begin
            if (fversion.revision < fversion1.revision) and (fversion.compile = fversion1.compile) and ((fversion.minor = fversion1.minor) and (fversion.major = fversion1.major)) then
            begin
               Result := false;
            end
            else
            begin
            end;
         end;
      end;
   end;
end;

//-----------------------------------------------------------------------------
// Hiermit soll ein Programm sich selber prfen ob die Version neu genug
// fr den Stand in der DB ist.
function PruefeProgrammversion(sModul:string):Boolean;
var lmq: TMyQuery;  sColumn,sMinVersion,sExeVersion,sErr:string;  Field:TField;
   vMinVersion, vExeVersion: Tversion;
begin
   Result:=true;

   sExeVersion := GetVersionInfo;

   lmq := DbCreateQuery;
   try
      LastSQL := 'select * from sys_config order by con_id desc limit 1'; // Leere Menge holen
      DbExecSql(lmq,LastSQL);
      sColumn := 'MinVersion'+sModul;
      Field := lmq.FindField(sColumn);
      // Prfen ob berhautp das Feld angelegt ist, wenn nicht dann ists auch ok
      if not Assigned(Field) then
         Exit;
      sMinVersion := Field.AsString;
   finally
      lmq.Free;
   end;
   splitversionstring(sMinVersion, vMinVersion);
   splitversionstring(sExeVersion, vExeVersion);
   Result := compareversions(vExeVersion,vMinVersion);
   if not Result then
   begin
      sErr := _('Die von Ihnen verwendete Version "%s" von "%s" ist mit der bitfarm-Datenbank nicht kompatibel. Bitte kontaktieren Sie Ihren Administrator.');
      sErr := Format( sErr, [sExeVersion,BD.ExeFile]);
      (*
      if sModul='DBImp'
      then
         WindowsEreignisanzeige(BD.ExeFile, sErr);
      else
      *)
      BfMessageDlg( sErr, mtError, [mbOk], 0);
   end;
end;

//-----------------------------------------------------------------------------
// trennt Inhalte eines Zusatzfeldes anhand komma auf und fgt diese der Liste hinzu.
// Die Liste wird zu Beginn NICHT gelscht

procedure ZusatzfelderAuftrennen(const Inhalt:string; var sl:TStringlist);
var
  i:integer;
  slTmp:TStringlist;
  ls:string;
begin
   slTmp := StrToWords7(Inhalt);
   try
      for i := 0 to slTmp.Count-1 do
      begin
         ls := slTmp[i];
         ls := ParseSemicolonWithoutBackslash(ls);
         sl.Add(ls);
      end;
   finally
      slTmp.Free;
   end;
end;

//-----------------------------------------------------------------------------
// Prft ob fr ein Zusatzfeld eine Verknpfung angelegt werden muss
// Parameter:
// - sIArcName z.B. '15092005160837'
// - sZusatzFeld z.B. 'add_15092005160955'
function PruefeObVerknuepfungAnlegen(sIArcName, sZusatzFeld:string):Boolean;
var liOptionen: integer;  my_q_tmp: TMyQuery;
begin
   my_q_tmp := DbCreateQuery;
   try
      //Tabelle mit den Zusatzfelder holen
      DbExecSql(my_q_tmp, 'select Optionen from cfg_'+sIArcName+' where Feld_Name="'+sZusatzFeld+'"');
      liOptionen := my_q_tmp.FieldByName('Optionen').AsInteger;
      Result := (liOptionen and cZusatzFeldOptVerknuepfung) <> 0;
   finally
      my_q_tmp.Free;
   end;
end;

//-----------------------------------------------------------------------------

procedure ClearAdditionalFields(Container: TComponent);
var
   iCount: Integer;
   Comp: TComponent;
begin
   DebugJvCheckedComboBox := nil;
   if Container.ComponentCount = 0 then
      Exit;
   GgfLogEvnt('ClearAdditionalFields Count='+IntToStr(Container.ComponentCount) );
   for iCount := 0 to (Container.ComponentCount - 1) do
   begin
      Comp := Container.Components[iCount];
      if Comp is TEdit then
         TEdit(Comp).Text := '';
      if Comp is TComboBox then
         begin

            // je nachdem welchen Wert TComboBox(Comp).Style hat funktionieren verschiedene Methoden
            TComboBox(Comp).ItemIndex := -1;
            TComboBox(Comp).ItemIndex := TComboBox(Comp).Items.Count - 1; //3.5.0.22
            TComboBox(Comp).Text := ''; //3.5.0.22

            // f.schneider: nur zur Doku : hier wurde es griechisch
            //TComboBox(Comp).Font.Name := 'Symbol';
            //TComboBox(Comp).Items.Clear; // na das doch sicher gar nicht //3.5.0.22
         end;
      if Comp is TJvDateEdit then
         TJvDateEdit(Comp).Text := '';
      if Comp is TSpinEdit then
         TSpinEdit(Comp).text := '';
      if Comp is TjvSpinEdit then
         //TSpinEdit(Comp).text := ''; //3.5.0.22
         TjvSpinEdit(Comp).text := ''; //3.5.0.22
      if Comp is TjvcheckedComboBox then
      begin
         TjvcheckedComboBox(Comp).SetUnCheckedAll;
         TjvcheckedComboBox(Comp).Tag := TjvcheckedComboBox(Comp).Tag and (not 4);
      end;

      if Comp is TFrameZusFldMulti then
         TFrameZusFldMulti(Comp).Clear;
   end;
end;


//-----------------------------------------------------------------------------
//3.5.0.36 [2390]
//-----------------------------------------------------------------------------
// gibt die Usr_id zurck anhand dem Namen - Rckgabe als int
function DbUserIdI(Name: string):int64;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := 0;
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_usr where Usr_Name = ' +
         #39 + Name + #39 + ' and (FIND_IN_SET("deleted",sys_usr.Flags)=0)';
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('usr_id').AsInteger;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// gibt die Usr_id zurck anhand dem Namen - Rckgabe als String  // Leerstring wenn nicht gefunden
function DbUserIdS(Name: string):string;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_usr where ' +
         '(Usr_Name = ' + #39 + Name + #39 + ') and (FIND_IN_SET("deleted",sys_usr.Flags)=0)';
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('usr_id').AsString;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// gibt die Grpp_id zurck anhand dem Namen - Rckgabe als int
function DbGroupIdI(Name: string):int64;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := 0;
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_grp where Grp_Name = ' +
         #39 + Name + #39;
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('grp_id').AsInteger;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
// gibt die Grpp_id zurck anhand dem Namen - Rckgabe als String
function DbGroupIdS(Name: string):string;
var lmq: TMyQuery;  lsSql:string;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from sys_grp where Grp_Name = ' +
         #39 + Name + #39;
      if DbDoSql(lmq, lsSql) then
      begin
         if lmq.RecordCount > 0 then
            Result := lmq.FieldByName('grp_id').AsString;
      end;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
//[2497]
procedure DbGetLinks(const Strings:TStrings; const sSub : string);
var lmq: TMyQuery;  lsSql:string;  Field:TField;
begin
    GgfLogevntBeg('DbGetLinks beg');
   Strings.Clear;
   lmq := DbCreateQuery;
   try
      if sSub = '' then
	      lsSql := 'select distinct ref_name from sys_doclnk order by ref_name'
      else
			lsSql := 'select distinct ref_name from sys_doclnk where ref_name like '+#39+sSub+'%'+ #39 +' order by ref_name';
      if DbDoSql(lmq, lsSql) then
      begin
         Field := lmq.FieldByName('ref_name');
         while not lmq.eof do
         begin
            Strings.Add(Field.AsString);
            lmq.next;
         end;
      end;
   finally
      lmq.Free;
      GgfLogevntEnd('DbGetLinks end Count='+IntToStr(Strings.Count));
   end;
end;

procedure DbCreateTempTable(sTblname: string; const Addfields:TStringList = nil);
var
  lsadd : string;
  licounter : Integer;
  lmc: TMyCommand;
  bTruncate : Boolean;
begin
  lsadd := '';
  bTruncate := False;

  lmc := DbCreateCommand;
  try
    with lmc do
    begin
      if Addfields = nil then
      begin
        bTruncate := True
      end
      else
      begin
        if Addfields.Count > 0 then
        begin

            for licounter := 0 to Addfields.Count - 1 do
            begin
              lsadd := lsadd + ',`' + Addfields.Strings[licounter] + '` VARCHAR(255) NOT NULL default ' + #39 + #39;
            end;
            if lsadd = LastLsAdd then
               bTruncate := True;

        end;
      end;

      if bTruncate then
      begin
        if DbTableExist('tmp_' + sTblname) then
        begin
          SQL.Text := 'Truncate tmp_' + sTblname;
          Execute;
          Exit;
        end;
      end;
      try
        SQL.Text := 'drop table if exists tmp_' + sTblname;
        Execute;

        SQL.Text := 'CREATE   TABLE `tmp_' + sTblname + '` (' +
              '`ARC_ID` BIGINT UNSIGNED NOT NULL,' +
              '`ArcName` VARCHAR(32) NOT NULL,' +
              '`TblName` VARCHAR(14) NOT NULL,' +
              '`DOC_ID` BIGINT UNSIGNED NOT NULL,' +
              '`DISP_NAME` VARCHAR(255) NOT NULL,' +
              '`DOC_LOC` VARCHAR(255) NOT NULL,' +
              '`EXT_LOC` VARCHAR(255) NOT NULL,' +
              '`ORI_LOC` VARCHAR(255) NOT NULL,' +
              '`USR_NAME` VARCHAR(40) NOT NULL,' +
              '`USR_ID` BIGINT UNSIGNED NOT NULL,' +
              '`TStamp` DATETIME NOT NULL,' +
              '`DOC_TXT` LONGTEXT,' +
              '`DOC_STATE` INTEGER UNSIGNED NOT NULL,' +
              '`OCR_QF` INTEGER SIGNED NOT NULL DEFAULT 0,' +
              '`GDOC_ID` BIGINT UNSIGNED NOT NULL DEFAULT 0,'+
              '`OPTIONEN` BIGINT UNSIGNED,' +
              '`SHA1` varchar(40)' +
              lsadd +
              ', primary key (`ARC_ID`,`DOC_ID`))';

        Execute;
        LastLsAdd := lsadd;
      except
        on e: Exception do
        begin
          LogEvnt('Fehler beim Erstellen einer temporren Tabelle');
          LastLsAdd := '';
        end;

      end;

    end;
  finally
    lmc.Free;

  end;

end;


function ShellExecute_AndWait(Operation, FileName,
   Parameter, Directory: string; Show: word; bWait: boolean): longint;
var
   bOK: boolean;
   Info: TShellExecuteInfo;
{
  ****** Parameters ******
  Operation:

  edit  Launches an editor and opens the document for editing.
  explore Explores the folder specified by lpFile.
  find Initiates a search starting from the specified directory.
  open Opens the file, folder specified by the lpFile parameter.
  print Prints the document file specified by lpFile.
  properties Displays the file or folder's properties.

  FileName:

  Specifies the name of the file or object on which
  ShellExecuteEx will perform the action specified by the lpVerb parameter.

  Parameter:

  String that contains the application parameters.
  The parameters must be separated by spaces.

  Directory:

  specifies the name of the working directory.
  If this member is not specified, the current directory is used as the working directory.

  Show:

  Flags that specify how an application is to be shown when it is opened.
  It can be one of the SW_ values

  bWait:

  If true, the function waits for the process to terminate
}
begin
   FillChar(Info, SizeOf(Info), Chr(0));
   Info.cbSize := SizeOf(Info);
   Info.fMask := SEE_MASK_NOCLOSEPROCESS;
   Info.lpVerb := PChar(Operation);
   Info.lpFile := PChar(FileName);
   Info.lpParameters := PChar(Parameter);
   Info.lpDirectory := PChar(Directory);
   Info.nShow := Show;
   bOK := boolean(ShellExecuteEx(@Info));
   if bOK then
   begin
      if bWait then
      begin
         while
            WaitForSingleObject(Info.hProcess, 100) = WAIT_TIMEOUT do
         begin
         	Application.ProcessMessages;
            Sleep(2);
         end;

         bOK := GetExitCodeProcess(Info.hProcess, DWORD(Result));
      end
      else
         Result := 0;
   end;
   if not bOK then
      Result := -1;
end;


procedure ReadCbxLgr(LgrCbx: TJvComboBox; dbtv : TpsDBTreeView);
var
  slTemp : TStringList;
  iCount : Integer;
begin
   GgfLogEvnt('ReadCbxLgr');
   slTemp := TStringList.Create;
   LgrCbx.Items.Clear;
   //wir holen uns die Lager aus dem Treeview, weil da sind sie so, wie der User drauf zugreifen kann
   iCount := 0;
   while iCount <= dbtv.Items.Count - 1 do
   begin
      if (dbtv.Items.Item[iCount].ImageIndex = 2) or
         (dbtv.Items.Item[iCount].ImageIndex = 0) then
      begin
         slTemp.AddObject(dbtv.Items.Item[iCount].Text,
               TObject(Integer(dbtv.Items.Item[iCount].Data)));
      end;
      inc(iCount);
   end;

   LgrCbx.Items := slTemp;
   If Assigned(slTemp) then
     FreeAndNil(slTemp);
   LgrCbx.ItemIndex := 0;

end;


procedure ReadCbxArc(ArcCbx: TJvCombobox; UsrID, LgrID: Integer);
var
  slTemp : TStringList;
  lmq: TMyQuery;
begin
   GgfLogEvntBeg ('ReadCbxArc Begin');
   // f.schneider v3.5.1.62  lokale Stringlist erzeugen, dann der Combobox zuweisen
   slTemp := TStringList.Create;
   ArcCbx.Items.Clear;
   slTemp.AddObject(_('alle Archive'), TObject(0));
   lmq := DbCreateQuery;
   if DbDoSkySQL(lmq,
      'Select Sql_No_cache sys_arc.Arc_ID, Arc_Name from sys_arc left join sys_arcxs using(arc_id) where usr_id = '
      + IntToStr(UsrID) + ' and lgr_id = ' + IntToStr(LgrID) +
      ' and Type = 1 group by sys_arc.arc_id order by arc_name') then
   begin
      try
         with lmq do
            while not EOF do
            begin
               if slTemp.IndexOfObject(TObject(FieldByName('Arc_ID').AsInteger)) = -1 then
                  slTemp.AddObject(FieldByName('arc_name').AsString,
                     TObject(FieldByName('Arc_ID').AsInteger));
               Next;
            end;
      except
         on e: Exception do
            ErrorMsg('ReadCbxArc', _('Fehler beim Auslesen der Archive:') +
               e.Message, 2001, True);
      end;
   end
   else
      ErrorMsg('ReadCbxArc', _('Fehler bei Select Sql_No_cache Anweisung!'), 2002, True);
   lmq.Free;
   ArcCbx.Items := slTemp;
   If Assigned(slTemp) then
     FreeAndNil(slTemp);

   ArcCbx.ItemIndex := 0;

   GgfLogEvntEnd ('ReadCbxArc End');
end;

function NewHistoryID(Funktion: integer; Text: string;
   farc_id, fdoc_id: int64; userid: Integer): boolean;
var
   sTStamp, lsIArcName: string;
   lmq: TMyQuery;
   lmc : TMyCommand;
begin
   GgfLogEvnt('NewHistoryID ' + IntToStr(farc_id) + '.' + IntToStr(fdoc_id) + Text);
   Result := True;
   //DateTimeToString(sTStamp, 'yyyy-mm-dd hh:nn:ss', Now);
   // get the time from server! as the desired format!
   lmq := DbCreateQuery;
   lmq.SQL.Text := 'select date_format(now(),"%Y-%m-%d %T") as date';
   lmq.Execute;

   sTStamp := lmq.FieldByName('date').AsString;
   //  sTStamp:= StringReplace(sTStamp,'.','-',[rfReplaceAll]);
   Text := StringReplace(Text, '\', '\\', [rfReplaceAll]);
   // Maskierung der Backslashes
   lmc := DbCreateCommand;
   try
      with lmc do
      begin
         lmq.SQL.Text := 'select * from sys_arc where arc_id= ' + IntToStr(farc_id);
         lmq.Execute;
         try
            lsIArcName := lmq.FieldByName('arc_TblName').AsString;
			except
            BfShowMessage(
               _('Der Archiv-Lager konnte nicht ermittelt werden. History-Eintrag wurde abgebrochen.'));
            exit;
         end;

         if lsIArcName = '' then
         begin
            BfShowMessage(
               _('Der Archiv-Lager konnte nicht ermittelt werden. History-Eintrag wurde abgebrochen.'));
            exit;
         end;
         SQL.Text := 'Insert into hst_' + lsIArcName +
            ' (doc_id, usr_id, tstamp, task, task_info) ' + 'Values (' +
            IntToStr(fdoc_id) + ',' + IntToStr(userid) + ',' + #39 +
            sTStamp + #39 + ',' + IntToStr(Funktion) + ',' + #39 +
            Trim(StringReplace(Text, #39, '\' + #39, [rfReplaceAll])) + #39 + ')';
         Execute;
      end;
   except
      on e: Exception do
      begin
         Result := False;
         ErrorMsg('NewHistory', _('Fehler beim Erstellen eines History Eintrages:') +
            e.Message, 2016, True);
      end;
   end;
   if Assigned(lmq) then
   	FreeAndNil(lmq);
   If Assigned(lmc) then
   	FreeAndNil(lmc);
end;

//-----------------------------------------------------------------------------

initialization

finalization

end.




