unit u_ShStamps;
///////////////////////////////////////////////////////////////////////////////////////////////////
//
interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, ComCtrls, StdCtrls, Registry, gnugettext, u_ShVoransicht,
   u_ShLowUtils, {u_ShDocument,} ExtCtrls, Buttons, ImgList;

type
   Tfrm_Stamps = class (TForm)
      lv_Stamps: TListView;
      Memo1: TMemo;
      PanelButton: TPanel;
      btn_Cancel: TBitBtn;
      btn_Ok: TBitBtn;
    il_Stamps: TImageList;
      procedure btn_OkClick(Sender: TObject);
      procedure lv_StampsDblClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   protected
      procedure CreateParams(var Params: TCreateParams); override;
      { Private-Deklarationen }
   public
      fVoransicht : Tfrm_Voransicht;
      { Public-Deklarationen }
      function ListStamps: boolean;
   end;

   procedure CreateTfrm_Stamps(Owner:TWinControl; Voransicht: Tfrm_Voransicht);


implementation

{$R *.dfm}

uses
   	StrUtils;


//-----------------------------------------------------------------------------
//3.5.0.40 [2336]
procedure CreateTfrm_Stamps(Owner:TWinControl; Voransicht: Tfrm_Voransicht);
var frm_Stamps: Tfrm_Stamps;
begin
   frm_Stamps := Tfrm_Stamps.Create(Owner);
   try
      frm_stamps.fVoransicht := Voransicht;
      frm_Stamps.ShowModal;
   finally
      frm_Stamps.Free;
   end;
end;

procedure Tfrm_Stamps.CreateParams(var Params: TCreateParams);
var h1,h2:THandle;
begin
   inherited;

end;


function Tfrm_Stamps.ListStamps: boolean;
var
   reg: TRegistry;
   slStampKeys: TStrings;
   iCount: integer;
   lItem: TListItem;
begin
   GgfLogevntBeg('Tfrm_Stamps.ListStamps beg');
   Result := True;
   reg := TRegistry.Create;
   slStampKeys := TStringList.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
            GetKeyNames(slStampKeys);
            CloseKey;
            lv_Stamps.Clear;
            for iCount := 0 to (slStampKeys.Count - 1) do
            begin
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  slStampKeys.Strings[iCount], True);
               lItem := lv_Stamps.Items.Add;
               if ValueExists('StampName') then
                  lItem.Caption := ReadString('StampName')
               else
                  lItem.Caption := 'unbekannter Stempel';
               lItem.SubItems.Add(slStampKeys.Strings[iCount]);
               if ValueExists('StampTyp') then
               begin
                  if ReadBool('StampTyp') then
                     lItem.ImageIndex := 1
                  else
                     lItem.ImageIndex := 0;
               end
               else
                  lItem.ImageIndex := 3;
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_Stamps.ListStamps', _('Fehler beim Lesen der Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(slStampKeys) then
         FreeAndNil(slStampKeys);
   end;
   GgfLogevntEnd('Tfrm_Stamps.ListStamps end');
end;


procedure Tfrm_Stamps.btn_OkClick(Sender: TObject);
begin
   if lv_Stamps.SelCount > 0 then
   begin
      fVoransicht.LoadStamp(lv_Stamps.Selected.SubItems.Strings[0]);
      ModalResult := mrOk;   //3.5.0.40 [2336]
      fVoransicht.fphistorymessage := _('Stempel') +' '+ lv_Stamps.Selected.Caption;
   end
   else
   	ModalResult := mrCancel;
end;

procedure Tfrm_Stamps.lv_StampsDblClick(Sender: TObject);
begin
   btn_OkClick(self);
end;

procedure Tfrm_Stamps.FormShow(Sender: TObject);
begin
   GgfLogevntBeg('Tfrm_Stamps.FormShow beg');
   ListStamps;
   GgfLogevntEnd('Tfrm_Stamps.FormShow end');
end;


procedure Tfrm_Stamps.FormCreate(Sender: TObject);
begin
   GgfLogevntBeg('Tfrm_Stamps.FormCreate beg');
   TranslateComponent(self, 'Viewerv3');
   GgfLogevntEnd('Tfrm_Stamps.FormCreate end');
end;

end.
