unit u_ShVoransicht;

interface

uses
   GnuGetText, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Registry, ExtCtrls, Buttons, ComCtrls, MyAccess, ieview, imageenview, ievect,
   Imageenproc, imageenio, TB2Dock, TBX, TBXExtItems, u_ShBase, {u_ShDocument,}
   u_ShLowUtils, u_ShDbUtils, u_ShHighUtils;

type
   Tfrm_Voransicht = class (TFrame)
      img_DocView: TImageEnVect;
      Label1: TLabel;
      procedure img_DocViewDblClick(Sender: TObject);
      procedure img_DocViewMouseWheel(Sender: TObject; Shift: TShiftState;
         WheelDelta: integer; MousePos: TPoint; var Handled: boolean);

      procedure img_DocViewImageChange(Sender: TObject);
      procedure img_DocViewViewChange(Sender: TObject; Change: integer);
      procedure img_DocViewMouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);
      procedure img_DocViewMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure img_DocViewMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure img_DocViewNewObject(Sender: TObject; hobj: integer);
      procedure img_DocViewObjectOver(Sender: TObject; hobj: integer);
      procedure img_DocViewDeactivateTextEdit(Sender: TObject);
      procedure img_DocViewActivateTextEdit(Sender: TObject);
      procedure img_DocViewMouseLeave(Sender: TObject);
      procedure img_DocViewMouseEnter(Sender: TObject);
      procedure img_DocViewObjectMoveResize(Sender: TObject; hobj,
         Grip: Integer; var OffsetX, OffsetY: Integer);

    procedure img_DocViewKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure img_DocViewUserSelectObject(Sender: TObject; hobj: Integer);
    function getlongestline(fstl: TStrings): string;
    procedure textanObjektpassen(fstl: TStrings);
    procedure ObjektAnTextAnpassen(hobj: Integer);
	 procedure ClearHistory;
    procedure img_DocViewUserDeselectObject(Sender: TObject;
      hobj: Integer);
    procedure img_DocViewSelectObject(Sender: TObject);

   private
      fsaveenabled: boolean;
      fobjdel: boolean;
      fobjposition: array of Tpoint;
      fobjdimension: array of Tpoint;
      fStartPos : TPoint;
      fObjectMoved : Boolean;
      fObjWidth, fObjHeight : Integer;
      function CheckAnnoRights: Boolean;
      { Private-Deklarationen }
   public
      gbAnnoNotSaved, gbAnnoNotAccessible: boolean;
      bGDelObj, fdoubleklicked: boolean;
      fzooming: boolean;

		fPrivAnnoID: Integer; // save the id from requested user priv anno
      fsavingobjs: boolean;
      fphistorymessage: string;
      fHistoryDeleted, fHistoryNew, fNoteVTX, fNoteSLW : TStringList;
      fOldtext : string;
      fbmouseinim, fNoteslwrecord, fNotevtxrecord,
      fTextAnnoCreated, fNewTextObject, fAnnosRotated: boolean;

      fTblName : string;
      fUserName : string;
      fUserId, fArcid, fDocid : Integer;
      fGdocid : Int64;
      fDocLoc, fExtLoc, fArcPath, fCopyPath, fDispName : string;
      fAnnoType : Byte;
      fSaveBtN : TObject;
      fPubAnnoBTN : TObject;
      fPrivAnnoBTN : TObject;
      fCbx_Zoom : TObject;
      fRights : TRData;
      fChangeZoomtextNotView: Boolean;
      fLastControl : TWinControl;
      fAutozoom : Boolean;
      fEndPolylineOnMouseUp : Boolean;
      fParentHandle : THandle;
      fOnObjectOver : procedure(annodata: PAnnoData) of object;
      fOnDblClick : procedure of object;
      fOnMouseLeave : procedure of object;

      fAfterSaveObjects : procedure of object;
      fOnNewObject : procedure of object;
      fOnObjectMoveResize : procedure of object;
      fOnMouseUpSelection : procedure of object;
      constructor Create(AOwner: TComponent); override;
      procedure updateobjects;
      procedure saveObjects(fsetinteracts, fsetintervtback: boolean; ignorerights: Boolean = False);
      procedure createannodata(fidx: integer);
      procedure saveannodata(fidx: integer);
      function ReadObjVals(ObjType, Idx: integer): boolean;
      function CheckObjVals: boolean;
      function LoadStamp(StampKey: string): boolean;
      procedure AnnoDelete(Sender: TObject);
      procedure SaveAnno(IEVFileName: string; Page: integer; annotype: Byte; ievUser:Integer);  // Obj kann Viewer oder docEditor sein //27.01.2011 f.schneider 3.5.0.134
		procedure DeleteAnno(IEVFileName: string; Page: integer; annotype: Byte; ievUser:Integer);
      function ObjKindToStr (hobj: integer): string;
      procedure RotateImage(degree : Integer);
      procedure SelectNextAnno;
      procedure SelectPrevAnno;
      procedure EditSelectedAnno;
		procedure EscOnTextEdit;
      { Public-Deklarationen }
   end;

implementation

uses
  StrUtils,
  Vectors,
  collision,
  hyiedefs;

{$R *.dfm}

var
   md_mouseX1, md_mouseY1: integer;


function ObjTypeToStr (ObjType: integer): string;
  begin
    case ObjType of
       0: Result := 'Line';
       1: Result := 'Box';
       2: Result := 'Ellipse';
       3: Result := 'Arc';
       4: Result := 'Bitmap';
       5: Result := 'Text';
       6: Result := 'Ruler';
       7: Result := 'Polyline';
       8: Result := 'Angle';
       9: Result := 'Note';
      10: Result := 'LineLabel';
      11: Result := 'HiLite';
      12: Result := 'Poligon';
      13: Result := 'FreeHand';
      14: Result := 'Arrow';
      15: Result := 'Text';
      16: Result := 'Freihand';
      17: Result := 'Freihand1';
      18: Result := 'Freihand2';
      19: Result := 'Freihand3';
      20: Result := 'Freihand4';
      21: Result := 'Text1';
      22: Result := 'Text2';
      23: Result := 'Text3';
      24: Result := 'Text4';
      25: Result := 'Note1';
      26: Result := 'Note2';
      27: Result := 'Note3';
      28: Result := 'Note4';
      29: Result := 'HiLite1';
      30: Result := 'HiLite2';
      31: Result := 'HiLite3';
      32: Result := 'HiLite4';
      33: Result := 'Buchungsstempel';
    end;
  end;

function Tfrm_Voransicht.ObjKindToStr(hobj: integer): string;
begin
   case img_DocView.ObjKind[hobj] of
      iekBOX:
      begin
         Result := _('Box');
      end;
      iekLINE:
      begin
         Result := _('Pfeil');
      end;

      iekPOLYLINE:
      begin
         Result := _('Linie');
      end;

      iekELLIPSE:
      begin
         Result := _('Ellipse');
      end;

      iekARC, iekANGLE:
      begin
         Result := _('Winkel');
      end;

      iekRULER:
      begin
         Result := _('Lineal');
      end;
      iekBITMAP:
      begin
         Result := _('Bild');
      end;
      iekTEXT:
      begin
         Result := _('Text');
      end;
      iekMEMO:
      begin
         Result := _('Text');
      end;
      iekLINELABEL:
      begin
         Result := _('Label');
      end;
   end;

end;



constructor Tfrm_Voransicht.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   fHistoryDeleted := TStringList.Create();
   fHistoryNew := TStringList.Create();
   fNoteVTX := TStringList.Create();
   fNoteSLW := TStringList.Create();

   fSaveBtN := nil;
   fPubAnnoBTN := nil;
   fPrivAnnoBTN := nil;
   fCbx_Zoom := nil;
   fLastControl := nil;
   fOnObjectOver := nil;
   img_DocView.MouseInteract := [miScroll];
end;



function Tfrm_Voransicht.ReadObjVals(ObjType, Idx: integer): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   //    ssTmp: TIEVSoftShadow;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   sRegKeyName: string;
begin
   Result := True;
   CheckObjVals;
   reg := TRegistry.Create;

   sRegKeyName := ObjTypeToStr (ObjType);

   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKeyName, True);
            with img_Docview do
            begin
               // ObjTransparency[idx]:=120; // Transparenz setzen
               if ValueExists('ObjArcEndingAngle') then
                  ObjArcEndingAngle[idx] := ReadFloat('ObjArcEndingAngle')
               else
                  ObjArcEndingAngle[idx] := 90;
               if ValueExists('ObjArcStartingAngle') then
                  ObjArcStartingAngle[idx] := ReadFloat('ObjArcStartingAngle')
               else
                  ObjArcStartingAngle[idx] := 0;
               if ValueExists('ObjBeginShape') then
                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp))
               else
                  shTmp := iesNONE;
               ObjBeginShape[Idx] := shTmp;
               if ValueExists('ObjBitmapBorder') then
                  ObjBitmapBorder[idx] := ReadBool('ObjBitmapBorder')
               else
                  ObjBitmapBorder[idx] := False;
               if ValueExists('ObjBoxHighLight') then
                  ObjBoxHighLight[idx] := ReadBool('ObjBoxHighLight')
               else
                  ObjBoxHighLight[idx] := False;
               if ValueExists('ObjBrushColor') then
                  ObjBrushColor[idx] := ReadInteger('ObjBrushColor')
               else
                  ObjBrushColor[idx] := clYellow;
               if ValueExists('ObjBrushStyle') then
                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
               else
               begin
                  if (ObjType > 15) and (ObjType < 21) then
                  begin
                     bsTmp := bsClear;
                  end
                  else
                  begin
                     bsTmp := bsSolid;
                  end;
               end;

               ObjBrushStyle[idx] := bsTmp;
               if ValueExists('ObjEndShape') then
                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp))
               else
                  shTmp := iesNONE;
               ObjEndShape[Idx] := shTmp;
               if ValueExists('ObjFontAngle') then
                  ObjFontAngle[idx] := ReadFloat('ObjFontAngle')
               else
                  ObjFontAngle[idx] := 0;
               if ValueExists('ObjFontHeight') then
                  ObjFontHeight[idx] := ReadInteger('ObjFontHeight')
               else
                  ObjFontHeight[idx] := 72;

               if img_DocView.DpiX < 300 then //17.03.2011 b.takacs 3.5.0.167
               begin
                  if ObjFontHeight[idx] = 72 then
                  begin
                    ObjFontHeight[idx]:= round((img_DocView.DpiX*72)/300);
                  end;
               end;

               ObjFontLocked[idx] := False;

               if ValueExists('ObjFontName') then
                  ObjFontName[idx] := ReadString('ObjFontName')
               else
                  ObjFontName[idx] := 'Arial';
               if ValueExists('ObjFontStyles') then
                  ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp))
               else
                  fsTmp := [];
               ObjFontStyles[idx] := fsTmp;
               if ValueExists('ObjLabelBrushColor') then
                  ObjLabelBrushColor[idx] := ReadInteger('ObjLabelBrushColor')
               else
                  ObjLabelBrushColor[idx] := clGreen;
               if ValueExists('ObjLabelBrushStyle') then
                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp))
               else
                  bsTmp := bsSolid;
               ObjLabelBrushStyle[idx] := bsTmp;
               //f.schneider  v3.5.0.174
               if ValueExists('ObjMemoCharsBrushStyle') then
                  ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
               else
                  bsTmp := bsClear;
//               ObjMemoCharsBrushStyle[idx] := bsTmp;
               ObjMemoCharsBrushStyle[idx] := bsSolid;     //  3.5.3.61   wir probieren mal Solid, dann bleibt wenigstens die Farbe bestehen, wenn man die Fonteigenschaft eines Teils des Textes bearbeitet
               if ValueExists('ObjLabelPosition') then
                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp))
               else
                  lpTmp := ielBegin;
               ObjLabelPosition[idx] := lpTmp;
               if ValueExists('ObjMemoBorderColor') then
                  ObjMemoBorderColor[idx] := ReadInteger('ObjMemoBorderColor')
               else
                  ObjMemoBorderColor[idx] := clBlack;
               if ValueExists('ObjMemoBorderStyle') then
                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
               else
                  psTmp := psSolid;
               ObjMemoBorderStyle[idx] := psTmp;
               if ValueExists('ObjMemoFixedHeight') then
                  ObjMemoFixedHeight[idx] := ReadInteger('ObjMemoFixedHeight')
               else
                  ObjMemoFixedHeight[idx] := 0;
               if ValueExists('ObjMemoLineSpace') then
                  ObjMemoLineSpace[idx] := ReadInteger('ObjMemoLineSpace')
               else
                  ObjMemoLineSpace[idx] := 0;
               if ValueExists('ObjName') then
                  ObjName[idx] := ReadString('ObjName')
               else
                  ObjName[idx] := _('Neues Objekt')+' '+ IntToStr(idx);
               if ValueExists('ObjPenColor') then
                  ObjPenColor[idx] := ReadInteger('ObjPenColor')
               else
                  ObjPenColor[idx] := clBlack;
               if ValueExists('ObjPenStyle') then
                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp))
               else
                  psTmp := psSolid;
               ObjPenStyle[idx] := psTmp;
               if ValueExists('ObjPenWidth') then
                  ObjPenWidth[idx] := ReadInteger('ObjPenWidth')
               else
                  ObjPenWidth[idx] := 1;
               if ValueExists('ObjPolylineClosed') then
                  ObjPolylineClosed[idx] := ReadBool('ObjPolylineClosed')
               else
                  ObjPolylineClosed[idx] := False;
               if ValueExists('ObjRulerType') then
                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp))
               else
                  rtTmp := iertRULER;
               ObjRulerType[idx] := rtTmp;
               if ValueExists('ObjRulerUnit') then
                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp))
               else
                  ruTmp := ieuPIXELS;
               ObjRulerUnit[idx] := ruTmp;
               if ValueExists('ObjShapeHeight') then
                  ObjShapeHeight[idx] := ReadInteger('ObjShapeHeight')
               else
                  ObjShapeHeight[idx] := 0;
               if ValueExists('ObjShapeWidth') then
                  ObjShapeWidth[idx] := ReadInteger('ObjShapeWidth')
               else
                  ObjShapeWidth[idx] := 0;

               if ValueExists('ObjStyle') then
                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp))
               else
                  osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
               ObjStyle[idx] := osTmp;
               if ValueExists('ObjTextAlign') then
                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp))
               else
                  taTmp := iejLeft;
               ObjTextAlign[idx] := taTmp;

					case ObjType of
               	15, 16, 22, 23, 24, 5, 9, 10, 11, 20:
							ObjTextAutoSize[idx] := True;  // jetzt immer an, das automatische Anpassen der text und memo annos
               end;

               if ValueExists('ObjTextCurveCharRot') then
                  ObjTextCurveCharRot[idx] := ReadFloat('ObjTextCurveCharRot')
               else
                  ObjTextCurveCharRot[idx] := 0;
               if ValueExists('ObjText') then
                  ObjText[idx] := ReadString('ObjText')
               else
                  ObjText[idx] := '';
               if ValueExists('ObjTransparency') then
                  ObjTransparency[idx] := ReadInteger('ObjTransparency')
               else
                  ObjTransparency[idx] := 255;

               if ValueExists('Objwidth') then
                  Objwidth[idx] := ReadInteger('Objwidth');
               if ValueExists('objheight') then
                  Objheight[idx] := ReadInteger('objheight');

               // f.schneider   v3.5.0.164
               // Neue Notiz gibts nicht mehr, da ImageEn 3.1.2 das Markieren nicht mehr untersttzt
               If ObjName[idx] = _('Neue Notiz')+' ' then
                  ObjName[idx] := '';
               if Pos(_('Neuer Text'), ObjName[idx]) > 0 then
                  ObjName[idx] := '';

            end;

            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEdit.ReadObjVals', _('Fehler bei Laden aus der Registrierung: ') +
               e.Message, 2029, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_Voransicht.CheckObjVals: boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   //    ssTmp: TIEVSoftShadow;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   licounter: integer;
   lszus: string;
begin
   GgfLogEvnt('CheckObjVals');
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            // Linie definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Line', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Linie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlue);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Box definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Box', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBoxHighLight') then
               WriteBool('ObjBoxHighLight', False);
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neues Rechteck'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // HiLite definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite' + lszus, True);
               end;
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', clYellow);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', cllime);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', clred);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', clblue);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', $000080FF);
                  end;
               end;
               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjBoxHighLight') then
                  WriteBool('ObjBoxHighLight', True);
               if not ValueExists('ObjBrushColor') then
                  WriteInteger('ObjBrushColor', clYellow);
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjName') then
                  WriteString('ObjName', _('Neues Rechteck'));
               if not ValueExists('ObjPenColor') then
                  WriteInteger('ObjPenColor', clYellow);
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);
               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 400);
               CloseKey;
            end;
            // Elipse definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Ellipse', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBoxHighLight') then
               WriteBool('ObjBoxHighLight', False);
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Ellipse'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clGreen);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Winkel definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Arc', True);
            if not ValueExists('ObjArcEndingAngle') then
               WriteFloat('ObjArcEndingAngle', 90);
            if not ValueExists('ObjArcStartingAngle') then
               WriteFloat('ObjArcStartingAngle', 90);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neuer Winkel'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Text definieren
            shTmp := iesNONE;
            psTmp := psClear;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;

            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Text', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Text' + lszus, True);
               end;
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 72);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clBlack);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 72);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clred);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 72);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clgreen);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 96);
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clBlack);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjText') then
                        WriteString('ObjText', '');
                     // it will read hex!!! so 72 in dec= 114!
                     if not ValueExists('ObjFontHeight') then
                        WriteInteger('ObjFontHeight', 36); //3.5.0.72
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clRed); //3.5.0.72
                  end;
               end;

               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjBrushColor') then
                  WriteInteger('ObjBrushColor', clWhite);
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjFontAngle') then
                  WriteFloat('ObjFontAngle', 0);
//               if not ValueExists('ObjFontLocked') then
//                  WriteBool('ObjFontLocked', False);
               if not ValueExists('ObjFontName') then
                  WriteString('ObjFontName', 'Arial');
               if not ValueExists('ObjFontStyles') then
                  WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               if not ValueExists('ObjName') then
                  WriteString('ObjName', '');
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjMemoBorderColor') then
                  WriteInteger('ObjMemoBorderColor', clNone);
               if not ValueExists('ObjAutoIncreaseLine') then
                  WriteInteger('ObjAutoIncreaseLine', clNone);
               if not ValueExists('ObjAutoIncreaseHeight') then
                  WriteInteger('ObjAutoIncreaseHeight', clNone);
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);

               if not ValueExists('ObjLabelBrushStyle') then
                  WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjMemoBorderStyle') then
                  WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               //         if not ValueExists('ObjSoftShadow') then WriteBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp));
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 200);
               if not ValueExists('ObjTextAlign') then
                  WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
//               if not ValueExists('ObjTextAutoSize') then
//                  WriteBool('ObjTextAutoSize', False);
               if not ValueExists('ObjTextCurveCharRot') then
                  WriteFloat('ObjTextCurveCharRot', 0);
               if not ValueExists('Showtextform') then
                  WriteBool('Showtextform', false);
               CloseKey;
            end;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Stempel', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 72);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'Arial');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', '');
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', '');
            CloseKey;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Buchungsstempel', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clWhite);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 72);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'Arial');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Buchungsstempel'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));

            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', '');
            CloseKey;
            // Notiz definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Note', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Note' + lszus, True);
               end;
               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', clYellow);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', cllime);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', clred);
                     if not ValueExists('ObjPenColor') then
		                  WriteInteger('ObjPenColor', clWhite);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', clblue);
                     if not ValueExists('ObjPenColor') then
		                  WriteInteger('ObjPenColor', clWhite);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjBrushColor') then
                        WriteInteger('ObjBrushColor', $000080FF);
                  end;
               end;
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjFontAngle') then
                  WriteFloat('ObjFontAngle', 0);
               if not ValueExists('ObjFontHeight') then
                  WriteInteger('ObjFontHeight', 72);
               if not ValueExists('ObjFontName') then
                  WriteString('ObjFontName', 'Arial');
               if not ValueExists('ObjFontStyles') then
                  WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
               if not ValueExists('ObjMemoBorderColor') then
                  WriteInteger('ObjMemoBorderColor', clBlack);
               if not ValueExists('ObjAutoIncreaseLine') then
                  WriteInteger('ObjAutoIncreaseLine', clNone);
               if not ValueExists('ObjAutoIncreaseHeight') then
                  WriteInteger('ObjAutoIncreaseHeight', clNone);
               if not ValueExists('ObjMemoBorderStyle') then
                  WriteBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjMemoFixedHeight') then
                  WriteInteger('ObjMemoFixedHeight', 0);
               if not ValueExists('ObjMemoLineSpace') then
                  WriteInteger('ObjMemoLineSpace', 0);
               if not ValueExists('ObjName') then
                  WriteString('ObjName', '');
               if not ValueExists('ObjPenColor') then
                  WriteInteger('ObjPenColor', clBlack);
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 400);
               if not ValueExists('ObjTextAlign') then
                  WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
               if not ValueExists('ObjTextCurveCharRot') then
                  WriteFloat('ObjTextCurveCharRot', 0);
               if not ValueExists('ObjText') then
                  WriteString('ObjText', '');
               CloseKey;
            end;
            // Poligon definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Poligon', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clSkyBlue);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue PolyLinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlue);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjPolylineClosed') then
            begin
               WriteBool('ObjPolylineClosed', True);
            end;
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // Polyline definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Polyline', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue PolyLinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlue);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjPolylineClosed') then
               WriteBool('ObjPolylineClosed', False);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            // LineLabel definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\LineLabel', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clInfoBk);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 72);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'Arial');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjLabelBrushColor') then
               WriteInteger('ObjLabelBrushColor', clInfoBK);
            if not ValueExists('ObjLabelBrushStyle') then
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjLabelPosition') then
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Notiz'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 1);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 0);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 0);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', 'Neuer Aufkleber');
            CloseKey;
            // Messlinie definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertQUOTECENTER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Ruler', True);
            shTmp := iesOUTARROW;
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clInfoBk);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 8);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'MS Sans Serif');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjLabelBrushColor') then
               WriteInteger('ObjLabelBrushColor', clInfoBK);
            if not ValueExists('ObjLabelBrushStyle') then
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjLabelPosition') then
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Messlinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 1);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 30);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 30);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', _('Neue Messlinie'));
            if not ValueExists('ObjRulerType') then
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            if not ValueExists('ObjRulerUnit') then
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            CloseKey;
            // Winkelmessen definieren
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Angle', True);
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clInfoBk);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjFontAngle') then
               WriteFloat('ObjFontAngle', 0);
            if not ValueExists('ObjFontHeight') then
               WriteInteger('ObjFontHeight', 8);
            if not ValueExists('ObjFontName') then
               WriteString('ObjFontName', 'MS Sans Serif');
            if not ValueExists('ObjFontStyles') then
               WriteBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp));
            if not ValueExists('ObjLabelBrushColor') then
               WriteInteger('ObjLabelBrushColor', clInfoBK);
            if not ValueExists('ObjLabelBrushStyle') then
               WriteBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjLabelPosition') then
               WriteBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neue Messlinie'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 1);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 30);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 30);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            if not ValueExists('ObjTextAlign') then
               WriteBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp));
            if not ValueExists('ObjTextCurveCharRot') then
               WriteFloat('ObjTextCurveCharRot', 0);
            if not ValueExists('ObjText') then
               WriteString('ObjText', _('Neue Messlinie'));
            if not ValueExists('ObjRulerType') then
               WriteBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp));
            if not ValueExists('ObjRulerUnit') then
               WriteBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp));
            CloseKey;
            // Pfeil definieren
            shTmp := iesOUTARROW;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsSolid;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Arrow', True);
            if not ValueExists('ObjEndShape') then
               WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
            shTmp := iesNONE;
            if not ValueExists('ObjBeginShape') then
               WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
            if not ValueExists('ObjBrushColor') then
               WriteInteger('ObjBrushColor', clNavy);
            if not ValueExists('ObjBrushStyle') then
               WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
            if not ValueExists('ObjName') then
               WriteString('ObjName', _('Neuer Pfeil'));
            if not ValueExists('ObjPenColor') then
               WriteInteger('ObjPenColor', clBlack);
            if not ValueExists('ObjPenStyle') then
               WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
            if not ValueExists('ObjPenWidth') then
               WriteInteger('ObjPenWidth', 2);
            if not ValueExists('ObjShapeHeight') then
               WriteInteger('ObjShapeHeight', 30);
            if not ValueExists('ObjShapeWidth') then
               WriteInteger('ObjShapeWidth', 30);
            if not ValueExists('ObjStyle') then
               WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
            if not ValueExists('ObjTransparency') then
               WriteInteger('ObjTransparency', 255);
            if not ValueExists('Objwidth') then
               WriteInteger('Objwidth', 400);
            if not ValueExists('objheight') then
               WriteInteger('objheight', 400);
            CloseKey;
            //Freihand
            shTmp := iesNONE;
            psTmp := psSolid;
            osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
            bsTmp := bsClear;
            fsTmp := [];
            taTmp := iejLeft;
            rtTmp := iertRULER;
            ruTmp := ieuPIXELS;
            lpTmp := ielBegin;
            for licounter := 0 to 4 do
            begin
               if licounter = 0 then
               begin
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand', True);
               end
               else
               begin
                  lszus := inttostr(licounter);
                  OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Freihand' + lszus, True);
               end;
               case licounter of
                  0:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clBlack);
                  end;
                  1:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clGreen);
                  end;
                  2:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clred);
                  end;
                  3:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', clblue);
                  end;
                  4:
                  begin
                     if not ValueExists('ObjPenColor') then
                        WriteInteger('ObjPenColor', $000080FF);
                  end;
               end;
               if not ValueExists('ObjBrushStyle') then
                  WriteBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp));
               if not ValueExists('ObjBeginShape') then
                  WriteBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjEndShape') then
                  WriteBinaryData('ObjEndShape', shTmp, SizeOf(shTmp));
               if not ValueExists('ObjName') then
                  WriteString('ObjName', _('Neue PolyLinie'));
               if not ValueExists('ObjPenStyle') then
                  WriteBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp));
               if not ValueExists('ObjPenWidth') then
                  WriteInteger('ObjPenWidth', 2);
               if not ValueExists('ObjPolylineClosed') then
                  WriteBool('ObjPolylineClosed', False);
               if not ValueExists('ObjShapeHeight') then
                  WriteInteger('ObjShapeHeight', 0);
               if not ValueExists('ObjShapeWidth') then
                  WriteInteger('ObjShapeWidth', 0);
               if not ValueExists('ObjStyle') then
                  WriteBinaryData('ObjStyle', osTmp, SizeOf(osTmp));
               if not ValueExists('ObjTransparency') then
                  WriteInteger('ObjTransparency', 255);
               if not ValueExists('Objwidth') then
                  WriteInteger('Objwidth', 400);
               if not ValueExists('objheight') then
                  WriteInteger('objheight', 400);
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEdit.CheckObjVals',
               'Fehler beim berprfen der Registrierung: ' + e.Message, 2031, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;



function Tfrm_Voransicht.LoadStamp(StampKey: string): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   bmpTmp: TImageEnView;
   mesTmp: TIEUnits;
   sStampText, sDate, sTime, sFileName, lszusname, lszusnr, splittext, ls: string;
   iSWidth, iSHeight, liposzus, liposzus1,
   liposzus2, lizus: integer;
   lbfin: Boolean;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   bFitToText, bFixedSize : Boolean;
   memo2: TStringList;
   liDeckkraft : Integer;
   dtNow : TDateTime;
   MySettings: Tformatsettings;
   lmq : TMyQuery;
begin

   Result := True;
   lbfin := false;
   lizus := 0;
   reg := TRegistry.Create;
   DateTimeToString(sDate, 'dd.mm.yyyy', Now);
   DateTimeToString(sTime, 'hh:nn:ss', Now);

   ls := GetCurrentLanguage;
   if Copy(ls,0,2) ='en' then
   begin
      dtNow := Now();
      GetLocaleFormatSettings(GetUserDefaultLCID, MySettings);
      MySettings.ShortDateFormat := 'MM.dd.yyyy';
      MySettings.DateSeparator := '/';
   	sDate := FormatDateTime('MM/dd/yyyy', dtNow, MySettings);
   end;

   bmpTmp := TImageEnView.Create(nil);
   memo2 := TStringList.Create();

   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
            with img_DocView do
            begin
               if ValueExists('StampName') then
                  ObjName[-1] := 'Stempel: ' + ReadString('StampName')
               else
                  ObjName[-1] := _('Neuer Stempel');
               if ValueExists('StampTyp') then
               begin
                  if not ReadBool('StampTyp') then
                  begin
                     // Text Stempel
                     ObjKind[-1] := iekTEXT;
                     ObjKind[-1] := iekMEMO;

                     // f.schneider
                     // so jetzt mal alles neu und nur was wir wirklich brauchen
                     // um abwrtskompatibel zu sein wird beim fehlen in der registry von
                     // ObjMemoCharsBrushStyle dieser Wert von ObjBrushStyle genommen
                     // und gespeichert, danach ist der Wert angelegt

                     if ValueExists('StampText') then
                     begin
                        //memo2.add(ReadString('StampText'));
                        //memo1.Lines.Text := ReadString('StampText');
                        sStampText := ReadString('StampText');
                     end
                     else
                     begin
                        //memo2.add('');
                        //memo1.Lines.Text := '';
                        sStampText := _('(kein Text)');
                     end;

                     if ValueExists('FontColor') then
                        ObjPenColor[-1] := ReadInteger('FontColor')
                     else
                        ObjPenColor[-1] := 0;

                     if ValueExists('FontName') then
                        ObjFontName[-1] := ReadString('FontName')
                     else
                        ObjFontName[-1] := 'Arial';

                     if ValueExists('FontStyle') then
                     begin
                        ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                        ObjFontStyles[-1] := fsTmp;
                     end
                     else
                        ObjFontStyles[-1] := [];

                     if ValueExists('FontSize') then
                        ObjFontHeight[-1] := ReadInteger('FontSize')
                     else
                        ObjFontHeight[-1] := 72;

                     if ValueExists('StampHeight') then
                        iSHeight := ReadInteger('StampHeight')
                     else
                        iSHeight := 30;
                     if ValueExists('StampWidth') then
                        iSWidth := ReadInteger('StampWidth')
                     else
                        iSWidth := 40;
                    
                     if ValueExists('ObjBrushColor') then
                        ObjBrushColor[-1] := ReadInteger('ObjBrushColor')
                     else
                        ObjBrushColor[-1] := clYellow;

                     if ValueExists('ObjBrushStyle') then
                        ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
                     else
                        bsTmp := bsSolid;
                     ObjBrushStyle[-1] := bsTmp;

                     if ValueExists('ObjMemoBorderStyle') then
                        ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
                     else
                        psTmp := psClear;
                     ObjMemoBorderStyle[-1] := psTmp;


                     if ValueExists('ObjMemoBorderColor') then
                        ObjMemoBorderColor[-1] := ReadInteger('ObjMemoBorderColor')
                     else
                        ObjMemoBorderColor[-1] := clBlack;

                     if ValueExists('ObjTransparency') then
                        liDeckkraft := ReadInteger('ObjTransparency')
                     else
                        liDeckkraft := 255;

                     if liDeckkraft < 51 then  // f.schneider 3.5.0.133  Kein Stempel mehr unter 20% Deckkraft
                     begin
                         liDeckkraft := 255;
                         WriteInteger    ('ObjTransparency',    liDeckkraft);
                     end;
                     ObjTransparency[-1] := liDeckkraft;


                     if ValueExists('ObjMemoCharsBrushStyle') then
                        ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
                     else
                        bsTmp := bsClear;
                     ObjMemoCharsBrushStyle[-1] := bsTmp;

                     if ValueExists('StampFitToText') then
                       	bFitToText := ReadBool('StampFitToText')
                     else
                       	bFitToText := True;
                     if ValueExists('StampFixedSize') then
                     	bFixedSize := ReadBool('StampFixedSize')
                     else
                       	bFixedSize := True;

                     ObjFontLocked[-1] := False;	// die Schrift sollte vernderbar sein, bei einem Textstempel

                     liposzus := 0;
                     while not lbfin do
                     begin
                        liposzus2 := posex('%F', sStampText, liposzus + 1);
                        if liposzus2 > 0 then
                        begin
                           if (liposzus > liposzus2) then
                              break;
                           liposzus1 := liposzus2;
                           while (copy(sStamptext, liposzus1, 1) <> ' ')
                              and (length(sStamptext) >= liposzus1) do
                           begin
                              liposzus1 := liposzus1 + 1;
                           end;
                           lszusnr := copy(sStamptext, liposzus2 + 2, liposzus1 - liposzus2 - 2);
                           try
                              lizus := StrToInt(lszusnr);
                           except
                              on e: Exception do
                              begin
                                 lizus := -1;
                              end;
                           end;
                           if lizus > -1 then
                           begin
                              lmq := DbCreateQuery;
                              DbExecSql(lmq, 'select * from cfg_' + fTblName + ' where cfg_id = ' + IntToStr(lizus));
                              if lmq.RecordCount > 0 then
                              begin
                                  lszusname := lmq.FieldByName('Feld_Name').AsString;
                                  DbExecSql(lmq, 'select '+lszusname+' from arc_' + fTblName + ' where gdoc_id = ' + IntToStr(fGdocid));
                                  if lmq.RecordCount > 0 then
                                     sStampText := StringReplace(sStampText, '%F' + lszusnr,
                                       lmq.FieldByName(lszusname).AsString, [rfReplaceAll,rfIgnoreCase]);
                              end;

                           end;
                        end;

                        liposzus := liposzus2 + 1;
                        if (length(sStampText) < liposzus) or (liposzus2 = 0) then
                        begin
                           lbfin := true;
                        end;
                     end;
                     sStampText := StringReplace(sStampText, '%D', sDate, [rfReplaceAll,rfIgnoreCase]);
                     sStampText := StringReplace(sStampText, '%Z', sTime, [rfReplaceAll,rfIgnoreCase]);
                     sStampText := StringReplace(sStampText, '%U', fUserName, [rfReplaceAll,rfIgnoreCase]);
                     sStampText := StringReplace(sStampText, '\n\r', #13#10, [rfReplaceAll,rfIgnoreCase]);

                     if not bFitToText then
                     begin
                       mesTmp := MUnit;
                       MUnit := ieuMILLIMETERS;
                       ObjWidth[-1] := Round(iSWidth / MeasureCoefX);
                       ObjHeight[-1] := Round(iSHeight / MeasureCoefY);
                       MUnit := mesTmp;
                     end;

                     splittext := sStampText;
                     while Pos(#13#10,splittext) > 0 do
                     begin
                        memo2.Add(LeftStr(splittext,Pos(#13#10,splittext)));
                        splittext := RightStr(splittext,Length(splittext) - Pos(#13#10,splittext)-1);
                     end;
                     if splittext <> '' then
                       memo2.Add(splittext);

                     ObjStyle[-1] := [ievsSelectable, ievsMoveable, ievsVisible];
                     if not bFixedSize then
                     	ObjStyle[-1] := ObjStyle[-1] + [ievsSizeable];
                     MouseInteractVT := [miPutmemo];

                     if bFitToText then
                        textanObjektpassen(memo2)
                     else
                        ObjText[-1] := sStampText;
                  end
                  else
                  begin
                     // Bild Stempel
                     ObjKind[-1] := iekBITMAP;
                     if ValueExists('StampFile') then
                        sFileName := ReadString('StampFile')
                     else
                     begin
								BfShowMessage(_('Der Bildstempel konnte nicht geladen werden. Keine Bilddatei angegeben'));
                        exit;
                     end;

                     if FileExists(sFileName) then
                     begin
                        SetObjBitmapFromFile(-1, sFileName);
                     end
                     else
                     begin
								BfShowMessage(_('Der Bildstempel konnte nicht geladen werden. Bilddatei nicht gefunden'));
                        exit;
                     end;
                     if ValueExists('StampHeight') then
                        iSHeight := ReadInteger('StampHeight')
                     else
                        iSHeight := 30;
                     if ValueExists('StampWidth') then
                        iSWidth := ReadInteger('StampWidth')
                     else
                        iSWidth := 40;
                     if ValueExists('ObjTransparency') then
                        liDeckkraft := ReadInteger('ObjTransparency')
                     else
                        liDeckkraft := 255;

                     if liDeckkraft < 51 then  // f.schneider 3.5.0.133  Kein Stempel mehr unter 20% Deckkraft
                     begin
                         liDeckkraft := 255;
                         WriteInteger    ('ObjTransparency',    liDeckkraft);
                     end;
                     if ValueExists('StampFixedSize') then
                     	bFixedSize := ReadBool('StampFixedSize')
                     else
                       	bFixedSize := True;
                     ObjTransparency[-1] := liDeckkraft;

                     EnableAlphaChannel := True;
                     ObjBrushColor[-1] := 16777215;
                     mesTmp := MUnit;
                     MUnit := ieuMILLIMETERS;
                     ObjWidth[-1] := Round(iSWidth / MeasureCoefX);
                     ObjHeight[-1] := Round(iSHeight / MeasureCoefY);
                     MUnit := mesTmp;
                     ObjBitmapBorder[-1] := False;

                     ObjStyle[-1] := [ievsSelectable, ievsMoveable, ievsVisible];
                     if not bFixedSize then
                     	ObjStyle[-1] := ObjStyle[-1] + [ievsSizeable];
                     MouseInteractVT := [miPutBitmap];
                  end;
               end
               else
                  exit;
            end;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('LoadStamp', _('Fehler beim Lesen der Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      reg.CloseKey;
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(bmpTmp) then
         FreeAndNil(bmpTmp);
   end;
end;

procedure Tfrm_Voransicht.ClearHistory;
begin
   fHistoryNew.Clear;
   fHistoryDeleted.Clear;
   fNoteSLW.Clear;
   fNoteVTX.Clear;
end;
procedure Tfrm_Voransicht.ObjektAnTextAnpassen(hobj: Integer);
var
   lilen, linelength, inewlen, inewheight, ioldwidth: integer;
   lslongestline: string;
   fstl : TStringList;
begin
   fstl := StrToWordsLF(img_DocView.ObjText[hobj]);
   lilen := length(fstl.Text);

   lslongestline := getlongestline(fstl);
   if lslongestline = '' then
   begin
      img_DocView.ObjText[hobj] := '';
      exit;
   end;

   linelength := img_DocView.GetCanvas.TextWidth(lslongestline);
   inewlen := trunc((linelength * img_DocView.ObjFontHeight[hobj] / 11) + (img_DocView.ObjFontHeight[hobj] / 2));
   inewheight := (fstl.Count *  (trunc(abs(img_DocView.ObjFontHeight[hobj]) * 3 / 2.5))) +2;
   ioldwidth := img_DocView.ObjWidth[hobj];
   if inewlen < img_DocView.ObjWidth[hobj] then
   begin
   	img_DocView.ObjWidth[hobj] := inewlen;
      if inewheight < img_DocView.ObjHeight[hobj] then
         img_DocView.ObjHeight[hobj] := inewheight;
      // Position anpassen, je nachdem ob rechtsbndig oder zentriert
      if img_DocView.ObjTextAlign[hobj] = iejRight then
      	img_DocView.ObjLeft[hobj] := img_DocView.ObjLeft[hobj] + (ioldwidth - inewlen);
      if img_DocView.ObjTextAlign[hobj] = iejCenter then
      	img_DocView.ObjLeft[hobj] := img_DocView.ObjLeft[hobj] + trunc((ioldwidth - inewlen) / 2);
   end;
   FreeAndNil(fstl);
end;



procedure Tfrm_Voransicht.RotateImage(degree : Integer);
var
   idx, hobj, ileft, itop, iwidth, iheight, imgwidth, imgheight :Integer;
begin
   img_DocView.Proc.Rotate(degree);
   img_DocView.Update;
   if degree <> 180 then
	begin
      // tausche Bildhhe und Breite
      imgwidth := img_DocView.IO.Params.Width;
      imgheight := img_DocView.IO.Params.Height;
      img_DocView.IO.Params.Width := imgheight;
      img_DocView.IO.Params.Height := imgwidth;
   end;

   for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
   	hobj := img_DocView.GetObjFromIndex(idx);
      ileft:= img_DocView.ObjLeft[hobj];
      itop := img_DocView.ObjTop[hobj];
      iwidth:= img_DocView.ObjWidth[hobj];
      iheight := img_DocView.ObjHeight[hobj];

      if degree = 90 then
      begin
      	img_DocView.ObjLeft[hobj] := itop;
         img_DocView.ObjTop[hobj] :=  img_DocView.io.params.height - ileft;
      end
      else if degree = -90 then
      begin
      	img_DocView.ObjLeft[hobj] := img_DocView.io.params.width - itop;
         img_DocView.ObjTop[hobj] :=  ileft;
      end
      else if degree = 180 then
      begin
      	img_DocView.ObjLeft[hobj] := img_DocView.io.params.width - ileft;
         img_DocView.ObjTop[hobj] :=  img_DocView.io.params.height - itop;
      end;

      // prfen ob wir den Bildrand verlassen
      if img_DocView.ObjTop[hobj] + iheight > img_DocView.io.params.height then
         img_DocView.ObjTop[hobj] :=  img_DocView.ObjTop[hobj] - (img_DocView.ObjTop[hobj] + iheight -img_DocView.io.params.height);
      if img_DocView.ObjLeft[hobj] + iwidth > img_DocView.io.params.width then
         img_DocView.ObjLeft[hobj] :=  img_DocView.ObjLeft[hobj] - (img_DocView.ObjLeft[hobj] + iwidth -img_DocView.io.params.width);
      if img_DocView.ObjLeft[hobj] < 0 then
         img_DocView.ObjLeft[hobj] := 0;
      if img_DocView.ObjTop[hobj] < 0 then
         img_DocView.ObjTop[hobj] := 0;

   end;
   fAnnosRotated := True;  // damit diese unabhngig von den Rechten auch gedreht werden drfen
   gbAnnoNotSaved := True;
end;

procedure Tfrm_Voransicht.img_DocViewDblClick(Sender: TObject);
begin
   try
      if fsavingobjs then
      begin
         fdoubleklicked := true;
      end
      else
      begin
         if ((fRights.modify) or (fRights.awrite)) and (not img_DocView.IsEmpty) then
         begin
            if img_docview.MouseInteractVt = [miPutPolyLine] then
               begin
                  img_DocView.CancelInteracts;
				      img_DocView.DeSelect;
				      img_DocView.UnSelAllObjects;
                  img_docview.MouseInteractVt := [];
				      img_docview.BitmapResampleFilter := rfLinear;
                  createannodata(img_DocView.ObjHeapCount -1);
                  if fAnnoType = 0 then
	                  fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),[ObjKindToStr(img_DocView.ObjTextEditMode),inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
                  gbAnnoNotSaved := True;

                  img_docview.MouseInteractVt := [miPutPolyLine];

                  Abort;   // ganz wichtig! sonst wird hiernach TImageEnVect.MouseDown ausgefhrt und
                  			// das nue Polygon beginnt genau dort wo das alte aufhren sollte
               end
            else
            if img_docview.MouseInteractVt = [miObjectSelect] then
            begin
              if not gbAnnoNotAccessible then
              begin
                 gbAnnoNotSaved := True;
                 EditSelectedAnno;
                 img_DocView.SetFocus;
              end;
              Exit;
            end
            else
            begin
                if Assigned(fOnDblClick) then
	                fOnDblClick;
                Abort;
            end;
         end;
         if not fRights.modify then
            ShowMessage(_('Hinweis') + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
      end;
   finally

   end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseWheel(Sender: TObject;
   Shift: TShiftState; WheelDelta: integer; MousePos: TPoint; var Handled: boolean);

begin
   if not fbmouseinim then
   	Abort;

   if img_DocView.ObjTextEditMode = -1 then
   begin
      img_DocView.ZoomAt(mousepos.x, mousepos.y, 0, False);
   end
   else
   	Abort;

end;


procedure Tfrm_Voransicht.img_DocViewImageChange(Sender: TObject);
begin
   fChangeZoomtextNotView := True;
   if Assigned(fCbx_Zoom) then
	   (fCbx_Zoom as TTBXComboBoxItem).Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
   fChangeZoomtextNotView := False;
   with img_DocView do
      if (VertScrollBar.IsScrollBarVisible or HorzScrollBar.IsScrollBarVisible) and
         (MouseInteract = []) then
         MouseInteract := [miScroll];
   
end;

procedure Tfrm_Voransicht.img_DocViewViewChange(Sender: TObject; Change: integer);
begin
   if Change = 1 then
   begin
      fChangeZoomtextNotView := True;
      if img_DocView.Zoom < 10.0 then
          img_DocView.Zoom := 10.0;
      if Assigned(fCbx_Zoom) then
	      (fCbx_Zoom as TTBXComboBoxItem).Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
      fChangeZoomtextNotView := False;
   end
   else
   begin
      if img_DocView.isempty and (not fAutozoom) then
      begin
         img_DocView.Zoom := 0.1;
         fChangeZoomtextNotView := true;
         if Assigned(fCbx_Zoom) then
	         (fCbx_Zoom as TTBXComboBoxItem).Text := '';
         fChangeZoomtextNotView := false;
      end;
   end;
   if img_DocView.isempty then
   	img_DocView.BackgroundStyle := iebsSolid
   else
   	img_DocView.BackgroundStyle := iebsCropShadow;
end;

procedure Tfrm_Voransicht.img_DocViewMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: integer);
var lscontrolname: string;
   lbwvlhasfocus: boolean;
   hdl: Cardinal;
begin

end;

procedure Tfrm_Voransicht.img_DocViewMouseDown(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
   idx :Integer;
begin
  GgfLogEvnt('img_DocViewMouseDown');

   if button = MbMiddle then
   begin
      md_mouseX1 := X;
      md_mousey1 := Y;
   end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
   idx, hobj, colobj, i, j: Integer;
   lbhcol: Boolean;  A, B: TPolygon; MTD: TVector2f;
begin
	GgfLogEvnt('img_DocViewMouseUp');
   // on realease button just select if the middle mouse was pressed
   if button = MbMiddle then
   begin
      img_docview.select(md_mouseX1, md_mousey1, x, y);
      img_docview.ZoomSelection(True);
   end;

 	if (img_docview.MouseInteractVt = [miPutPolyLine]) and
      fEndPolylineOnMouseUp then
   begin
      img_docview.cancelinteracts;
      createannodata(img_DocView.ObjHeapCount -1);
      img_docview.BitmapResampleFilter := rfLinear;
      if fAnnoType = 0 then
      	fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),[ObjKindToStr(img_DocView.ObjHeapCount -1),inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
      gbAnnoNotSaved := True;
   end;

   if fObjectMoved and (img_DocView.ObjectsCount > 1) then
   begin
      hobj :=  img_DocView.SelObjects[0];
      B := nil;
     	A := nil;
      if (img_DocView.ObjKind[hobj] <> iekLINE) and
         (img_DocView.ObjBrushStyle[hobj] <> bsClear) and
         (not fRights.AModify)
      then
      begin
         try
            A := TPolygon.Create;
            with A do
            begin
               position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
               AddVertex(to_v2f(0, 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
               AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
            end;
            i := 0;
            j := 0;
            while i < img_DocView.ObjectsCount do
            begin
            	colobj := img_DocView.GetObjFromIndex(i);
               if colobj = hobj then
               begin
                  i := i + 1;
                  continue;
               end;
               B := TPolygon.Create;
               with B do
               begin
                  position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
                  AddVertex(to_v2f(0, 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
                  AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
               end;
               i := i + 1;
               if PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) then
               begin
                  lbhcol := true;

                  while PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) do
                  begin
                     if (MTD.x = 0) and (MTD.y = 0) then
                     begin
                        MTD.x := -1;
                        MTD.y := -1;
                     end
                     else
                     begin
                        MTD := v2f_Scale(MTD, (1.05));
                     end;
                     a.position := v2f_add(a.position, MTD);
                  end;

                  img_DocView.ObjLeft[hobj] := trunc(a.position.x);
                  img_DocView.ObjTop[hobj] := trunc(a.position.y);

                  if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.IO.Params.Width then
                     img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) - img_DocView.ObjWidth[hobj];
                  if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.IO.Params.Height then
                     img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) - img_DocView.ObjHeight[hobj];

                  if img_DocView.ObjLeft[hobj] < 0 then // mit Rand kollidiert ;-)
                     img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) + Trunc(b.Vertices[2].X);

                  if img_DocView.ObjTop[hobj] < 0 then
                     img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) + Trunc(b.Vertices[2].Y);

                  A := nil;
                  A := TPolygon.Create;
                  with A do
                  begin
                     position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
                     AddVertex(to_v2f(0, 0));
                     AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
                     AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
                     AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
                  end;
               end;
               if lbhcol then
               begin
                  i := 0;
                  j := j + 1;
                  if j > 50 then
                  begin
                     break;
                  end;
                  lbhcol := false;
               end;
               if assigned(b) then
                  FreeAndNil(b);
            end;
            if lbhcol or ((img_DocView.ObjLeft[hobj] < 0) or (img_DocView.ObjTop[hobj] < 0) or
            (img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.IO.Params.Width) or
            (img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.IO.Params.Height))then
            begin
               img_DocView.ObjLeft[hobj] := fStartPos.X;
               img_DocView.ObjTop[hobj] := fStartPos.Y;
               img_DocView.ObjWidth[hobj] := fObjWidth;
	            img_DocView.ObjHeight[hobj] := fObjHeight;
               // BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
               exit;
            end;
         finally
            begin
               if assigned(A) then
                  FreeAndNil(A);
               if assigned(B) then
                  FreeAndNil(B);
            end;
         end;
      end;
      fStartPos.X := img_DocView.ObjLeft[hobj];
	   fStartPos.y := img_DocView.ObjTop[hobj];
      fObjWidth := img_DocView.ObjWidth[hobj];
      fObjHeight := img_DocView.ObjHeight[hobj];
   end;
   fObjectMoved := False;

   if (img_DocView.MouseInteract = [miSelect]) and
      (img_DocView.selected) and
      (img_DocView.SelectionAbsWidth > 0) and
      (img_DocView.SelectionAbsHeight > 0) and (button = Mbleft) then
   begin
      if Assigned(fOnMouseUpSelection) then
         fOnMouseUpSelection;
   end;

	for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
      hobj := img_DocView.GetObjFromIndex(idx);
		if img_docview.ObjUserData[hobj] <> nil then
      begin
         if (fUserName <> PAnnoData(img_docview.ObjUserData[hobj])^.ersteller) and ((not fRights.AModify) and (not fRights.apwrite)) then
         begin
            img_DocView.UnSelObject(hobj);
         end;
      end;
   end;

end;

procedure Tfrm_Voransicht.img_DocViewNewObject(Sender: TObject; hobj: integer);
var
   A, B: TPolygon;
   i, colobj: integer;
   MTD: TVector2f;
   lbinter, loopbreak: boolean;

begin
   GgfLogEvntBeg ('Tfrm_Voransicht.img_DocViewNewObject Begin');
   fTextAnnoCreated := False;	//zurcksetzen bei jeder neuen Anno
   if Assigned(fOnNewObject) then
      fOnNewObject;

   fobjdel := False;
   img_DocView.ObjEditOnNewText := True;

   try
      loopbreak := false;
      a := nil;
      b := nil;

      if ievsSizeable in img_DocView.ObjStyle[hobj] then
      begin
         if img_DocView.ObjWidth[hobj] < 70 then
            img_DocView.ObjWidth[hobj] := 70;
         if img_DocView.ObjHeight[hobj] < 70 then
	      	img_DocView.ObjHeight[hobj] := 70;
      end;

      if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.IO.Bitmap.Width then
      	img_DocView.ObjWidth[hobj] :=  img_DocView.IO.Bitmap.Width - img_DocView.ObjLeft[hobj] -1;
      if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.IO.Bitmap.Height then
         img_DocView.ObjHeight[hobj] :=  img_DocView.IO.Bitmap.Height - img_DocView.ObjTop[hobj] -1;

      if ((img_DocView.ObjBrushStyle[hobj] <> bsClear) and
      	(img_DocView.ObjKind[hobj] <> iekLine)) or
         ((img_DocView.ObjKind[hobj] = iekBOX) and
         (img_DocView.ObjBoxHighLight[hobj])) then
      begin
         if not fRights.AModify then
         begin
            A := TPolygon.Create;
            with A do
            begin
               position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
               AddVertex(to_v2f(0, 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
               AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
            end;
            i := 0;
            loopbreak := False;
            while i < img_DocView.ObjectsCount do
            begin
            	colobj := img_DocView.GetObjFromIndex(i);
               if colobj = hobj then
               begin
                  i := i + 1;
                  continue;
               end;
               B := TPolygon.Create;
               with B do
               begin
                  position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
                  AddVertex(to_v2f(0, 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
                  AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
               end;
               i := i + 1;
               lbinter := False;
               loopbreak := False;
               if PolyPolyIntersect(a, b, MTD) then
               begin
                  img_docview.DeSelect;
                  img_docview.cancelinteracts;
                  img_docview.RemoveObject(hobj);
                  fobjdel := True;

                  //      img_DocView.MouseInteractVt := [];
                  BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
                  img_docview.UnSelAllObjects;
                  img_docview.ObjEditOnNewText := false;
                  if assigned(a) then
                     FreeAndNil(a);
                  if assigned(b) then
                     FreeAndNil(b);
                  Abort;
               end;

               if loopbreak then
               begin
                  img_DocView.RemoveObject(hobj);
                  break;
               end;
               if lbinter then
               begin
                  img_DocView.ObjTop[hobj] := round(a.position.y);
                  img_DocView.ObjLeft[hobj] := round(a.position.x);
               end;

               if assigned(b) then
                  FreeAndNil(b);
            end;
         end;
         if not loopbreak then
         begin
            createannodata(hobj);
            img_DocView.ObjEditOnNewText := true;
         end
         else
         begin
            ShowMessage(_('Die Notiz konnte nicht auf eine freie Stelle platziert werden.'));
            exit;
         end;
      end
      else
      begin
         createannodata(hobj);
         if (img_DocView.ObjKind[hobj] in [iekBITMAP, iekMEMO]) then
            img_DocView.ObjStyle[hobj] := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
         if img_DocView.ObjKind[hobj] <> iekBITMAP then
	         img_DocView.ObjEditOnNewText := true;
      end;

      // History von Text, Memo wird bei OnDeactivateText geschrieben, von Polyline bei OnMouseUP 
      if (img_DocView.objkind[hobj] <> iekMemo) and
         (img_DocView.objkind[hobj] <> iekTEXT) and
         (img_DocView.objkind[hobj] <> iekPOLYLINE) then    // f.schneider   v3.5.1.62
      begin
         if fAnnoType = 0 then
	         fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),[ObjKindToStr(img_DocView.ObjTextEditMode),inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
         gbAnnoNotSaved:= true;
      end
      else
      begin
         gbAnnoNotSaved:= true; //10.06.2011 b.takacs 3.5.1.21 [3082]
      end;

      if (img_DocView.ObjKind[hobj] in [iekText, iekMEMO]) then
			fNewTextObject := True;

      img_DocView.ObjGraphicRender := False;
      img_DocView.EnableAlphaChannel := False;

   finally
      begin
         GgfLogEvntEnd ('Tfrm_Voransicht.img_DocViewNewObject End via finally');

         if assigned(a) then
            FreeAndNil(a);
         if assigned(b) then
            FreeAndNil(b);

      end;
   end;
end;

procedure Tfrm_Voransicht.AnnoDelete(Sender: TObject);
var
   idx, licount, iSel: integer;
   bContinue : Boolean;   // nicht das einer meint, ich htte hier Bldsinn programmiert
									// die Funktion hat tatschlich das Continue nicht richt ausgefhrt
                           // und jede Anno gelscht, auch wenn sie das nicht sollte, balint ist mein Zeuge
begin
   licount := 0;
   while  licount < img_docview.SelObjectsCount do
   begin
      bContinue := False;
      idx := img_docview.SelObjects[licount];

      if (not fRights.AModify) then
      begin
         if img_docview.ObjUserDataLength[idx] > 0 then
         begin
            if (fUserName <> PAnnoData(img_docview.ObjUserData[idx])^.ersteller) then
            begin
               bContinue := True;
            end;
         end
         else
         if (img_docview.ObjUserDataLength[idx] = 0) then
         begin
            bContinue := True;
         end;
      end;
      if not bContinue then
      begin
         bGDelObj := True;
         if fAnnoType = 0 then
            if img_DocView.ObjText[idx] = '' then
               fHistoryDeleted.Add(Format(_('Anmerkung (%s) auf Seite %s wurde entfernt.'),[ObjKindToStr(idx),inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]))
            else
               fHistoryDeleted.Add(Format(_('Anmerkung mit Text "%s" auf Seite %s wurde entfernt'),[img_DocView.ObjText[idx],inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
         img_DocView.ObjLeft[idx] := 0;
         img_DocView.ObjTop[idx] := 0;
         img_DocView.ObjWidth[idx] := 0;
         img_DocView.ObjHeight[idx] := 0;
         img_DocView.RemoveObject(idx);
      end;
      Inc(licount);
   end;

   if bGDelObj then
   begin
      SelectNextAnno;
      if Assigned(fSaveBtN) then
      begin
         if fSaveBtN is TBitBtn then
            (fSaveBtN as TBitBtn).Enabled := True;
         if fSaveBtN is TTBXItem then
            (fSaveBtN as TTBXItem).Enabled := True;
      end;
      fTextAnnoCreated := False;
   end;

end;


procedure Tfrm_Voransicht.img_DocViewObjectOver(Sender: TObject; hobj: integer);
var
   mydata: PAnnoData;

begin
   mydata := img_DocView.ObjUserData[hobj];
   if Assigned(fOnObjectOver) then
      fOnObjectOver(mydata);

end;

procedure Tfrm_Voransicht.img_DocViewDeactivateTextEdit(Sender: TObject);
var
   liarcid, lidocid, hobj, i, j, colobj: integer;
   lssql, lsarcname, lsVtx, lstext: string;
      lbhcol: Boolean;  A, B: TPolygon; MTD: TVector2f;
begin
   lidocid := 0;
   liarcid := 0;
   hobj := img_DocView.ObjTextEditMode;

   lstext := trim(ParseSQLString(img_DocView.ObjText[hobj]));

   if (img_DocView.ObjKind[hobj] in [iekText,iekMEMO]) and
   	(img_DocView.ObjBrushStyle[hobj] = bsClear) then
    	ObjektAnTextAnpassen(hobj);

   if fAnnoType = 0 then //09.05.2011 b.takacs 3.5.1.10
   begin
   	if (lstext <> '') and (lstext <> fOldtext) then
      begin
         if lstext <> '' then
         begin
            if fNewTextObject then
               fHistoryNew.Add(Format(_('neue Anmerkung "%s" auf Seite %s'),[lstext,inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]))
            else
               if fOldtext = '' then
                  fHistoryNew.Add(Format(_('leere Anmerkung gendert nach "%s" auf Seite %s'),[lstext,inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]))
               else
                  fHistoryNew.Add(Format(_('Anmerkung "%s" gendert nach "%s" auf Seite %s'),[ fOldtext, lstext, inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));

           if fNoteslwrecord then  //09.05.2011 b.takacs 3.5.1.10
           begin
              fNoteSLW.Add(lstext);
           end;
           if fNotevtxrecord then  //09.05.2011 b.takacs 3.5.1.10
           begin
              fNoteVTX.Add(lstext);
           end;
         end
         else
            fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),[ObjKindToStr(hobj),inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
      end
      else
      	if lstext <> '' then		// lstext = fOldtext  (bei Stempeln der Fall)
			begin
            if ((img_DocView.ObjKind[hobj] in [iekText,iekMEMO]) and
			   	(img_DocView.ObjBrushStyle[hobj] = bsClear)) then
               fHistoryNew.Add(Format(_('neue Anmerkung "%s" auf Seite %s'),[lstext,inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]))
         end
			else
      	if fOldtext = '' then
         begin
            if fNewTextObject then
               if not ((img_DocView.ObjKind[hobj] in [iekText,iekMEMO]) and
                  (img_DocView.ObjBrushStyle[hobj] = bsClear)) then
                  fHistoryNew.Add(Format( _('Neue Anmerkungen (%s) auf Seite %s'),[ObjKindToStr(hobj),inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
         end
         else
            fHistoryNew.Add(Format(_('Text von Anmerkung "%s" geleert auf Seite %s'),[fOldtext, inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1)]));
   end;


   hobj :=  img_DocView.SelObjects[0];
   B := nil;
   A := nil;
   if (img_DocView.ObjKind[hobj] <> iekLINE) and
      (img_DocView.ObjBrushStyle[hobj] <> bsClear) and
      (not fRights.AModify) and (img_DocView.ObjectsCount > 1)
   then
   begin
      try
         A := TPolygon.Create;
         with A do
         begin
            position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
            AddVertex(to_v2f(0, 0));
            AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
            AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
            AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
         end;
         i := 0;
         j := 0;
         while i < img_DocView.ObjectsCount do
         begin
            colobj := img_DocView.GetObjFromIndex(i);
            if colobj = hobj then
            begin
               i := i + 1;
               continue;
            end;
            B := TPolygon.Create;
            with B do
            begin
               position := to_v2f(img_DocView.ObjLeft[colobj], img_DocView.ObjTop[colobj]);
               AddVertex(to_v2f(0, 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[colobj], 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[colobj], img_DocView.ObjHeight[colobj]));
               AddVertex(to_v2f(0, img_DocView.ObjHeight[colobj]));
            end;
            i := i + 1;
            if PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) then
            begin
               lbhcol := true;

               while PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) do
               begin
                  if (MTD.x = 0) and (MTD.y = 0) then
                  begin
                     MTD.x := -1;
                     MTD.y := -1;
                  end
                  else
                  begin
                     MTD := v2f_Scale(MTD, (1.05));
                  end;
                  a.position := v2f_add(a.position, MTD);
               end;

               img_DocView.ObjLeft[hobj] := trunc(a.position.x);
               img_DocView.ObjTop[hobj] := trunc(a.position.y);

               if img_DocView.ObjLeft[hobj] < 0 then // mit Rand kollidiert ;-)
                  img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) + Trunc(b.Vertices[2].X);

               if img_DocView.ObjTop[hobj] < 0 then
                  img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) + Trunc(b.Vertices[2].Y);

               if img_DocView.ObjLeft[hobj] + img_DocView.ObjWidth[hobj] > img_DocView.IO.Params.Width then
                  img_DocView.ObjLeft[hobj] := Trunc(b.Position.X) - img_DocView.ObjWidth[hobj];

               if img_DocView.ObjTop[hobj] + img_DocView.ObjHeight[hobj] > img_DocView.IO.Params.Height then
                  img_DocView.ObjTop[hobj] := Trunc(b.Position.Y) - img_DocView.ObjHeight[hobj];

               A := nil;
               A := TPolygon.Create;
               with A do
               begin
                  position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
                  AddVertex(to_v2f(0, 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
                  AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
               end;
            end;
            if lbhcol then
            begin
               i := 0;
               j := j + 1;
               if j > 50 then
               begin
                  break;
               end;
               lbhcol := false;
            end;
            if assigned(b) then
               FreeAndNil(b);
         end;
         if lbhcol then
         begin
            img_DocView.ObjLeft[hobj] := fStartPos.X;
            img_DocView.ObjTop[hobj] := fStartPos.Y;
            img_DocView.ObjWidth[hobj] := fObjWidth;
            img_DocView.ObjHeight[hobj] := fObjHeight;

            // BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
            exit;
         end;
      finally
         begin
            if assigned(A) then
               FreeAndNil(A);
            if assigned(B) then
               FreeAndNil(B);
         end;
      end;
   end;

   fOldtext := '';
   gbAnnoNotSaved := True;
   fdoubleklicked := false;
   fNewTextObject := False;
   fTextAnnoCreated := True;
   img_DocView.update;
end;

procedure Tfrm_Voransicht.img_DocViewActivateTextEdit(Sender: TObject);
var
   lbmod: boolean;
begin
   if img_DocView.ObjTextEditMode < 0 then
   begin
      img_DocView.CancelInteracts;
      exit;
   end;
   lbmod := false;
   if img_DocView.ObjUserDataLength[img_DocView.ObjTextEditMode] > 0 then
   begin
      if (fUserName = PAnnoData(img_DocView.ObjUserData[img_DocView.ObjTextEditMode])^.ersteller) or (fRights.AModify) or (fRights.apwrite) then
      begin
         lbmod := true;
      end;
   end;
   if lbmod then
   begin
      gbAnnoNotSaved:= true;
      fOldtext := img_DocView.ObjText[img_DocView.ObjTextEditMode];
      fStartPos.X := img_DocView.ObjLeft[img_DocView.ObjTextEditMode];
	   fStartPos.y := img_DocView.ObjTop[img_DocView.ObjTextEditMode];
      fObjWidth := img_DocView.ObjWidth[img_DocView.ObjTextEditMode];
      fObjHeight := img_DocView.ObjHeight[img_DocView.ObjTextEditMode];
   end
   else
   begin
      img_DocView.CancelInteracts;
   end;

end;


procedure Tfrm_Voransicht.img_DocViewUserSelectObject(Sender: TObject; hobj: Integer);
begin
   outputdebugstring('img_DocViewUserSelectObject');
   gbAnnoNotAccessible := False;
   fStartPos.X := img_DocView.ObjLeft[hobj];
   fStartPos.y := img_DocView.ObjTop[hobj];
   fObjWidth := img_DocView.ObjWidth[hobj];
   fObjHeight := img_DocView.ObjHeight[hobj];
   img_DocView.SetObjFrontOf(hobj, -1);

   if img_docview.ObjUserData[hobj] <> nil then
   begin
      if (fUserName <> PAnnoData(img_docview.ObjUserData[hobj])^.ersteller) and ((not fRights.AModify) and (not fRights.apwrite)) then
      begin
         img_DocView.UnSelAllObjects;
         gbAnnoNotAccessible := True;
      end;
   end;
   fTextAnnoCreated := False;
end;



procedure Tfrm_Voransicht.SelectNextAnno;
var
	idx, hobj, iselect, iself : integer;
	hobjids : TStringList;
begin
	hobjids := TStringList.Create;
   iselect := -1;
   for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
   	hobj := img_DocView.GetObjFromIndex(idx);
      if img_DocView.IsSelObject(hobj) then
      	iselect := hobj;
      if img_docview.ObjUserData[hobj] <> nil then
	      if (fUserName = PAnnoData(img_docview.ObjUserData[hobj])^.ersteller) or (fRights.AModify) then
         begin
	         hobjids.add(IntToStr(hobj));
         end;
   end;
   if iselect = -1 then
   	idx := 0
   else
   	idx := hobjids.IndexOf(IntToStr(iselect));
   if (idx <> -1) and (hobjids.count > 0) then
   begin
      if idx < hobjids.count -1 then
      	inc(idx)
      else
      	idx := 0;
      img_DocView.Deselect;
      img_DocView.UnSelAllObjects;
      img_DocView.AddSelObject(StrToInt(hobjids[idx]));
   end;
   img_DocView.SetFocus;
end;


procedure Tfrm_Voransicht.SelectPrevAnno;
var
	idx, hobj, iselect, iself : integer;
	hobjids : TStringList;
begin
	hobjids := TStringList.Create;
   iselect := -1;
   for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
   	hobj := img_DocView.GetObjFromIndex(idx);
      if img_DocView.IsSelObject(hobj) then
      	iselect := hobj;
      if img_docview.ObjUserData[hobj] <> nil then
	      if (fUserName = PAnnoData(img_docview.ObjUserData[hobj])^.ersteller) or (fRights.AModify) then
         begin
	         hobjids.add(IntToStr(hobj));
         end;
   end;
   if iselect = -1 then
   	idx := 0
   else
   	idx := hobjids.IndexOf(IntToStr(iselect));
   if (idx <> -1) and (hobjids.count > 0) then
   begin
      if idx > 0 then
      	dec(idx)
      else
      	idx := hobjids.count -1;
      img_DocView.Deselect;
      img_DocView.UnSelAllObjects;
      img_DocView.AddSelObject(StrToInt(hobjids[idx]));
   end;
   img_DocView.SetFocus;
end;



procedure Tfrm_Voransicht.EditSelectedAnno;
var
	idx, hobj, iselect : integer;
begin
   for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
      hobj := img_DocView.GetObjFromIndex(idx);
      if img_DocView.IsSelObject(hobj) then
      begin
			img_DocView.ObjTextEditMode := hobj;
         Break;
      end;
   end;
end;

procedure Tfrm_Voransicht.EscOnTextEdit;
var
	idx, hobj, iselect : integer;
begin
	if img_DocView.ObjTextEditMode > -1 then
   	img_DocView.CancelInteracts;
end;


procedure Tfrm_Voransicht.img_DocViewKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   GgfLogEvnt('u_Voransicht img_DocViewKeyUp Begin Key(word): ' + IntToStr(Key));
   case key of
      vk_delete:	AnnoDelete(self);
      vk_return: EditSelectedAnno;
   	vk_tab : SelectNextAnno;
      vk_escape : EscOnTextEdit;
   end;
end;

procedure Tfrm_Voransicht.createannodata(fidx: integer);
var
   mydata: PAnnoData;
   lstmp: string;
begin
   getmem(mydata, sizeof(TAnnoData));

   mydata^.Ersteller := fUserName;
   mydata^.Veraenderer := '';
   DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
   mydata^.Datum := lstmp;
   mydata^.version := '0.1';
   img_docview.ObjUserDataLength[fidx] := sizeof(TAnnoData);
   img_docview.ObjUserData[fidx] := mydata;
end;

procedure Tfrm_Voransicht.saveannodata(fidx: integer);
var
   mydata: PAnnoData;
   lstmp: string;
   liudl: integer;
begin
   liudl := img_docview.ObjUserDataLength[fidx];
   if liudl = 0 then
   begin
      createannodata(fidx);
   end
   else
   begin
      mydata := img_docview.ObjUserData[fidx];
      mydata^.Veraenderer := mydata^.Veraenderer + ',' + fUserName;
      DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
      mydata^.Datum := lstmp;
   end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseLeave(Sender: TObject);
var
   lwcparent: twincontrol;
   lhforw: HWND;
begin
   if img_DocView.ObjTextEditMode <> -1 then   // tatschlich wird beim stellen einer Anno in TextEditMode MouseLeave aufgerufen
   	Exit;                                    // wir mssen hier wieder raus, damit fLastControl nicht wieder den Focus erhlt (Trefferliste)

   fbmouseinim := false;
   try
      if Assigned(fOnMouseLeave) then
			fOnMouseLeave;

      img_DocView.Cursor := 0;
   except on e: exception do
      begin
      end;
   end;
end;

procedure Tfrm_Voransicht.saveObjects(fsetinteracts, fsetintervtback: boolean; ignorerights: Boolean = False);
var
   sIEVFile, sDocPath, sExtFile, sTmpPath, lsIArcName, lssql, vtx, sCheckoutUser: string;
   liarcno, liCount, hobj: integer;
   liRecNo, ievUser, iCheckoutuser: integer;
   ievType: Byte;

begin
   if fsavingobjs then
   	Exit;

   if img_DocView.IsEmpty then
   	Exit;

   GgfLogEvntBeg ('Tfrm_Voransicht.saveObjects Begin');
   try
      fsavingobjs := true;
      img_DocView.CancelInteracts;
      img_DocView.DeSelect;
      img_DocView.UnSelAllObjects;

      if (img_DocView.MouseInteractVt <> [miObjectSelect]) and
         (img_DocView.MouseInteractVt <> []) and fsetintervtback then
         img_DocView.MouseInteractVt := [];

      liCount := 0;     // Leere Textannos lschen
      while liCount < img_DocView.ObjectsCount do
      begin
      	hobj := img_DocView.GetObjFromIndex(liCount);
         if (img_DocView.ObjKind[hobj] in [iekText,iekMEMO]) and
            (img_DocView.ObjBrushStyle[hobj] = bsClear) and
            (img_DocView.ObjText[hobj] = '') then
            img_DocView.RemoveObject(hobj)
         else
         	inc(liCount);
		end;

      if CheckAnnoRights or ignorerights or fAnnosRotated then
      begin
         sDocPath := fDocLoc;
         sExtFile := fExtLoc;

         if sExtFile <> '' then
           sDocPath := sExtFile;

         sTmpPath := StringReplace(sDocPath, fArcPath, fCopyPath, [rfReplaceAll,rfIgnoreCase]);

           if fAnnoType = 0 then
           begin
              sIEVFile := ChangeFileExt(sTmpPath, '') +
                 IntToStr(img_DocView.io.Params.TIFF_ImageIndex) + '.IEV';
              ievType := annoPub;
              ievUser := fUserID;
              if Assigned(fPubAnnoBTN) then
                 (fPubAnnoBTN as TTBXItem).ImageIndex := 125;
           end
           else
           if fAnnoType = 1 then
           begin
              sIEVFile :=
                 ChangeFileExt(sTmpPath, '') +
                 IntToStr(img_DocView.io.Params.TIFF_ImageIndex) + 'P' +
                 IntToStr(fPrivAnnoID) + '.IEV';
              ievType := annoPriv;
              ievUser := fPrivAnnoID;
              if Assigned(fPrivAnnoBTN) then
                  (fPrivAnnoBTN as TTBXItem).ImageIndex := 119;
           end
           else
           begin
              sIEVFile := ChangeFileExt(sTmpPath, '') +
                 IntToStr(img_DocView.IO.Params.TIFF_ImageIndex) + '.IEV';
              ievType := annoPub;
              ievUser := fUserID;
              if Assigned(fPubAnnoBTN) then
                 (fPubAnnoBTN as TTBXItem).ImageIndex := 125;
           end;
           try
              if not DirectoryExists(ExtractFilePath(sTmpPath)) then
                 ForceDirectories(ExtractFilePath(sTmpPath));

              if (img_DocView.ObjectsCount > 0) then
                  SaveAnno(sIEVFile,img_DocView.io.Params.TIFF_ImageIndex,ievType,ievUser)
              else
              begin
                 if bGDelObj then
                 begin
                     DeleteAnno(sIEVFile,img_DocView.IO.Params.TIFF_ImageIndex,ievType, ievUser);
                     if Assigned(fPubAnnoBTN) then
                        if (fPubAnnoBTN as TTBXItem).Checked then
                           (fPubAnnoBTN as TTBXItem).ImageIndex := 110;
                     if Assigned(fPrivAnnoBTN) then
                        if (fPrivAnnoBTN as TTBXItem).Checked  then
                            (fPrivAnnoBTN as TTBXItem).ImageIndex := 109;
                     fphistorymessage := '';
                     if fAnnoType = 0 then
	                     NewHistoryID(9, Format(_('Alle Anmerkungen auf Seite %s wurden gelscht'),[inttostr(img_DocView.IO.Params.TIFF_ImageIndex +1)]), fArcid, fDocid, fUserId);
                     bGDelObj := False;
                 end;
              end;
           except
              on e: Exception do
              begin
                 LogEvnt('9000 - 6   Allgemeiner Anwendungsfehler in Voransicht beim Speichern:    '
                    + e.Message);
              end;
           end;

         if fHistoryNew.Count > 0 then
         begin
            for liCount := 0 to fHistoryNew.Count -1 do
            begin
               NewHistoryID(9, fHistoryNew[liCount], fArcid, fDocid, fUserId);
            end;
         end;
         if fHistoryDeleted.Count > 0 then
         begin
            for liCount := 0 to fHistoryDeleted.Count -1 do
            begin
               NewHistoryID(9, fHistoryDeleted[liCount], fArcid, fDocid, fUserId);
            end;
         end;

         if fNoteVTX.Count > 0 then
         begin
            for liCount := 0 to fNoteVTX.Count -1 do
            begin
               vtx := DbTableColumnGetString('select doc_txt from arc_'+ fTblName+' where doc_id = ' + IntToStr(fDocID));
               vtx := vtx + #13 + #13 + _('Anmerkungstexte eingefgt am:') + ' ' + DateTimeToStr(now) + #13 +
               '--------------------------------------------------------------------------------------------------------------------'
               + #13 + fNoteVTX[liCount];
               try
                  DbXParam('update arc_'+ fTblName+' set doc_txt = :VTX where doc_id = '
                     + IntToStr(fDocID), 'VTX', vtx);
                  NewHistoryID(12, '[' + fNoteVTX[liCount] + '] ' + _('zum Volltext hinzugefgt.'), fArcid, fDocid, fUserId);
               except
                  on e: Exception do
                   LogEvnt('Fehler beim Hinzufgen der Anmerkung zum Volltext' + e.Message);
               end;
            end;
         end;

         if fNoteSLW.Count > 0 then
         begin
            for liCount := 0 to fNoteSLW.Count -1 do
            begin
                if DbXLog('Insert into slw_' + fTblName + ' (doc_id, doc_slw) Values (' +
                    IntToStr(fDocID) + ', ' + #39 + fNoteSLW[liCount] + #39 + ')',
                    _('Fehler beim Hinzufgen eines Schlagwortes: ') + fNoteSLW[liCount]) then
                  NewHistoryID(12, '[' + fNoteSLW[liCount] + '] ' + _('zu den Schlagworten hinzugefgt.'), fArcid, fDocid, fUserId);
            end;
         end;

         ClearHistory;
      end
      else
      begin
      	BfShowMessage(_('Hinweis!') + #13 + _('Sie drfen auf diesem Dokument keine Anmerkungen speichern'));
      end;

      if fsetinteracts then
      begin
         if (img_DocView.MouseInteractVt <> [miObjectSelect]) and
            (img_DocView.MouseInteractVt <> []) then
             img_DocView.MouseInteractVt := [];
         img_DocView.MouseInteract := [miScroll];
      end;
      bGDelObj := False;
      gbAnnoNotSaved:= false; //10.06.2011 b.takacs 3.5.1.21 [3082]
      if Assigned(fAfterSaveObjects) then
      	fAfterSaveObjects;
   finally
      fTextAnnoCreated := False;
      fAnnosRotated := false;
      fsavingobjs := false;
      GgfLogEvntEnd ('Tfrm_Voransicht.saveObjects End via finally');
   end;
end;

function Tfrm_Voransicht.CheckAnnoRights: Boolean;
begin
	Result := False;
   if fAnnoType = 0 then
   begin
      if not fRights.awrite then
			Result := False
      else
      	Result := True;
   end;

   if fAnnoType = 1 then
   begin
      if fUserID <> fPrivAnnoID then
      begin
          if not fRights.apwrite then
             Result := False
          else
            Result := True;
      end
      else  // eigenen Layer darf man immer
         Result := True;
   end;
end;


//
//  Name: SaveAnno
//  Parameters:
//  Description:
//  Return value:
// []  f.schneider 27.01.2011 3.5.0.134
//------------------------------------------------------------------------------
procedure Tfrm_Voransicht.SaveAnno(IEVFileName: string; Page: integer; annotype: Byte; ievUser:Integer);  // Obj kann Viewer oder docEditor sein
var
    ievstream : TMemoryStream;

    xml : string;
begin
	try
      try
        img_DocView.SaveToFileIEV(IEVFileName);
        GgfLogEvnt('Anno gespeichert:' + IEVFileName);
      except
        GgfLogEvnt('Fehler beim Speichern: ' + IEVFileName);
      end;
   finally
   end;
end;

procedure Tfrm_Voransicht.DeleteAnno(IEVFileName: string; Page: integer; annotype: Byte; ievUser:Integer);
var xmlStr, xml2 : string;
begin
   if FileExists(IEVFileName) then
   begin
      KillFile(IEVFileName);
   end;

end;


procedure Tfrm_Voransicht.img_DocViewMouseEnter(Sender: TObject);
begin
   if img_DocView.MouseInteractVt <> [] then
   begin
      if img_DocView.MouseInteractVt = [miObjectSelect] then
	      img_DocView.Cursor := 1780
      else
         img_DocView.Cursor := 1785;
   end;
   fbmouseinim := true;
   outputdebugstring(PChar('img_DocViewMouseEnter:' + inttostr(GetForegroundWindow)));
end;


procedure Tfrm_Voransicht.updateobjects;
var
	i, liobjcount: integer;
begin
   liobjcount := img_docview.objectscount;
   setlength(fobjposition, liobjcount);
   setlength(fobjdimension, liobjcount);

   i := 0;
   while i < liobjcount do
   begin
      fobjposition[i].X := img_DocView.ObjLeft[i];
      fobjposition[i].Y := img_DocView.ObjTop[i];
      fobjdimension[i].X := img_DocView.Objwidth[i];
      fobjdimension[i].Y := img_DocView.Objheight[i];
      inc(i);
   end;
end;


function Tfrm_Voransicht.getlongestline(fstl: TStrings): string;
var
   lii, lil, lilinel, lftextwidth: integer;
begin
   if fstl.Count = 0 then
   begin
      Result := '';
      exit;
   end;
   lilinel := 0;
   lftextwidth := 0;
   for lii := 0 to fstl.Count - 1 do
   begin
      lil := length(fstl.Strings[lii]);
      if lftextwidth < lil then
      begin
         lftextwidth := lil;
         lilinel := lii;
      end;
   end;
   Result := fstl.Strings[lilinel];
end;


procedure Tfrm_Voransicht.textanObjektpassen(fstl: TStrings);
var
   lileng, lilinelength: integer;
   lslongestline: string;
begin
   lileng := length(fstl.Text);


   lslongestline := getlongestline(fstl);
   if lslongestline = '' then
   begin
      img_DocView.ObjText[-1] := '';
      exit;
   end;

   lilinelength := img_DocView.GetCanvas.TextWidth(lslongestline);

   img_DocView.ObjWidth[-1] :=
      trunc(lilinelength * img_DocView.ObjFontHeight[-1] / 11);
   img_DocView.ObjHeight[-1] := fstl.Count *
      (trunc(abs(img_DocView.ObjFontHeight[-1]) * 3 / 2.5));

   img_DocView.ObjText[-1] := Copy(fstl.Text, 1, length(fstl.Text) -1);
end;



procedure Tfrm_Voransicht.img_DocViewObjectMoveResize(Sender: TObject; hobj, Grip: Integer; var OffsetX, OffsetY: Integer);
var
   mydata: PAnnoData;
   i, j, liudl: integer;
   lbhcol: Boolean;  A, B: TPolygon; MTD: TVector2f;
begin
   lbhcol := false;
   if Assigned(fOnObjectMoveResize) then
      fOnObjectMoveResize;
   try
      fObjectMoved := True;

      fobjdel := False;
      img_DocView.ObjEditOnNewText := false;
      mydata := img_DocView.ObjUserData[hobj];
      liudl := img_DocView.ObjUserDataLength[hobj];
      gbAnnoNotSaved := True;
      img_DocView.ObjGraphicRender := False;
      img_DocView.EnableAlphaChannel := False;
      if length(fobjposition) <= hobj then
         setlength(fobjposition, hobj + 1);

      fobjposition[hobj].X := img_DocView.ObjLeft[hobj];
      fobjposition[hobj].y := img_DocView.ObjTop[hobj];
   except on e: exception do
      begin
         logevnt('Error in   frm_Voransicht.img_DocViewObjectMoveResize ' + e.message);
      end;
   end;

end;

// setzt die durchsichtigen Annos nach vorne
procedure Tfrm_Voransicht.img_DocViewUserDeselectObject(Sender: TObject;
  hobj: Integer);
begin
	outputdebugstring('img_DocViewUserDeselectObject');
	if img_DocView.ObjBrushStyle[hobj] <> bsClear then
   	img_DocView.SetObjBackTo(hobj,-1);
end;

// setzt die durchsichtigen Annos nach vorne
procedure Tfrm_Voransicht.img_DocViewSelectObject(Sender: TObject);
var
   hobj, idx: integer;
begin
   outputdebugstring('img_DocViewSelectObject');
   for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
   	hobj := img_DocView.GetObjFromIndex(idx);
      if (img_DocView.ObjBrushStyle[hobj] = bsClear) or
      	(img_DocView.ObjKind[hobj] = iekLine) then
   		img_DocView.SetObjFrontOf(hobj,-1);
   end;
end;

end.

