//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
//  splitter.exe
//
//  Autor: n.gering
//
//  copyright 2006 bitfarm Informationssysteme GmbH
//
//
//
//  Korrektur: img_Conv wieder frei geben (sonst bleiben die Temp-Dateien stehen)
//  23.10.07 Falko Schneider
//  neue Option - a  append  (endlich! war doch garnicht so schwer  :-)
//  09.03.09 Falko Schneider

program SplitterV3;

{$APPTYPE CONSOLE}

uses

  SysUtils,
  imageenview,
  imageEnIO,
  //imageenProc,
  iemView,
  //ieVect,
  hyiedefs,
  hyieutils,
  Classes;

{$R *.res}

var
    img_Merge, img_Split: TImageEnView;
    img_Conv:TimageEnMview;
    tmp : TMemoryStream;
    lttags : TIETIFFHandler;
    //img_vect:TImageEnVect;
    //img_io:TimageEnIo;
    istrCount,iCount, iPCount,
    insertingPage,
    iLayer: Integer;
    i: Integer;
    sTmpPath,
    nu_File_name, strIndex,strparam  :string;


 
function FileAccessable(FileName: string): boolean;
//////////////////////////////////////////////////////////////////
///  15.05.2005 Erstellt by NG.                                ///
///                                                            ///
///  Prft, ob auf eine Datei lesend zugegriffen werden kann    ///
///  oder nicht.                                               ///
///                                                            ///
///  Parameter: FileName    String mit Pfad und Dateiname      ///
///                                                            ///
///  Ausgabe:   True       bei Erfolg                          ///
///             False      bei Fehlschlag                      ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var iFile: Integer;
begin
  iFile := -1;
  try
    iFile := FileOpen(FileName, fmOpenRead);
    if iFile > 0 then result := True else result := False;
  finally
    FileClose(iFile);
  end;
end;


    {

function GetFileInfo(
  var aInternalName, aFileVersion: String; FileName: AnsiString
): Boolean;
var
  VersionInfoSize, VerInfoSize, GetInfoSizeJunk: Longword;
  VersionInfo, Translation, InfoPointer: Pointer;
  VersionValue: AnsiString;
begin
  Result := False;
  //VerInfoSize := GetFileVersionInfoSize(PChar(FileName), GetInfoSizeJunk);
  if VerInfoSize > 0 then
  begin
    GetMem(VersionInfo, VerInfoSize);
    try
      GetFileVersionInfo(PChar(FileName), 0, VerInfoSize, VersionInfo);
      VerQueryValue(
        VersionInfo, '\\VarFileInfo\\Translation', Translation, VerInfoSize
      );
      VersionValue :=
        '\\StringFileInfo\\' + IntToHex(LoWord(LongInt(Translation^)), 4) +
        IntToHex(HiWord(LongInt(Translation^)), 4) + '\\';
      VersionInfoSize := 0;

      VerQueryValue(
        VersionInfo, PChar(VersionValue + 'InternalName'), InfoPointer,
        VersionInfoSize
      );
      aInternalName := AnsiString(PChar(InfoPointer));

      VerQueryValue(
        VersionInfo, PChar(VersionValue + 'FileVersion'), InfoPointer,
        VersionInfoSize
      );
      aFileVersion := AnsiString(PChar(InfoPointer));


    finally
      FreeMem(VersionInfo);
    end;
    aInternalName := Trim(aInternalName);
    aFileVersion := Trim(aFileVersion);
    Result := (aInternalName <> '') and (aFileVersion <> '');
  end;
end;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
begin
  WriteLn('bitfarm Archiv V3 - Tiff Splitter und Merge Tool');
  WriteLn('(c) 2009 bitfarm Informationssysteme GmbH');
  WriteLn(' ');
  //WriteLN('splitter.exe -h  ==> hilfe');
  for i:= 1 to paramcount  DO
    strparam:= strparam + ' ' + Paramstr(i);
  writeln ('uebergebene Parameter = '+strparam);



  if (ParamCount = 0) or (Paramstr(1)='-h') then
  begin
    ExitCode := 1;
    WriteLn('usage: ');
    WriteLn('-h Hilfe');
    WriteLn('Seiten einer TIF Datei vereinzeln');
    WriteLn('-s {Quelledatei.tif}');
    WriteLN('   vereinzelt die Seiten einer Tiff-Datei, und legt die einzelnen');
    WriteLN('   Seiten im Verzeichnis der Quelldatei ab. {{Quelle}_page_n}');
    WriteLN(' ');
    WriteLN('-m {Datei1.tif} {Datei2.tif}');
    WriteLN('zwei TIF Dateien zusammenfassen (merge) Datei2.tif und Datei1.tif zu Datei1.tif ,');
    WriteLN('wobei Datei2.tif am Anfang eingefgt werden ');
    WriteLN('(Datei1.tif = Datei2.tif + Datei1.tif)');
    WriteLN('-a {Datei1.tif} {Datei2.tif}');
    WriteLN('zwei Tif Dateien zusammenfassen (append) wobei an Datei1.tif die Datei2.tif');
    WriteLN('angehangen wird');
    WriteLN('(Datei1.tif = Datei1.tif + Datei2.tif)');

    ExitCode:=255;
    exit;
  end;

  ///////////////////////////////////////////////////////////////////////////////////////////////////////////
  //
  // Auf Splitter anforderung prfen   und Schalter -s in der Comandozeile zum aufteilen von Dateien geben
  //

  try

  if lowercase(paramstr(1)) = '-s' then
  begin
    ////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Wenn keine Datei angegeben die gesplittet werden kann dan Abbruch
    //
    if paramstr(2)='' then
    begin
      WriteLn('..keine Quelldatei vom Typ TIF angegeben die vereinzelt werden kann.');
      ExitCode:=1;
     exit;
    end;
    // Objekte initalisieren.
    img_Split := TImageEnView.Create(nil);
    // img_io:=TImageEnIO.create(nil);
    // Hauptschleife starten.
    try
        //    try
        img_Split.IO.LoadFromFile(ParamStr(2));
        // Lade die zu vereinzelnde Tiffdatei

        //img_Split.IO.LoadFromFileTIFF('C:\Dokumente und Einstellungen\s.voelke\Desktop\Splitter\temp0.tif');


          // errechne die Anzahl der Seiten der Tiff Bildergruppe
          iPCount := img_Split.IO.Params.ImageCount;  // Anzahl der Seiten ermitteln
          // Hilfs Meldung an der Konsole ueber die Anzahl der zu exportierenden Seiten
          Writeln ('Anzahl der zu vereinzelnden Seiten = '+ inttostr(iPCount));
          for iCount := 0 to ipcount-1  do
          begin
            // Imageen interner Bildzaehler auf icount setzen
            img_Split.IO.Params.ImageCount := iCount;
            //writeln(ParamStr(1)+'_'+inttostr(icount));
            //         ExtractTIFFImageFile( input_multipage.tif , page0.tif, 0 );	//  extract first page
            //         ExtractTIFFImageFile( 'C:\Dokumente und Einstellungen\s.voelke\Desktop\Splitter\temp0.tif' , 'page+'inttostr(icount), icount );	//  extract first page
            //istrCount := length(paramstr(2));
            // Neuen Dateiname erzeugen der aus dem Originaldateinamen und einer Vereinzelungsspezifischen Kennung
            // besteht. {originaldateiname}_pageXXX.tif
            if icount < 10 then strIndex := '00' +  inttostr(icount);
            if ((icount > 9) AND (icount < 100 )) then strIndex := '0' +  inttostr(icount);
            if icount >99 then strIndex :=  inttostr(icount);
            nu_File_name:= ChangeFileExt(paramstr(2), '') +'_page'+strIndex+ '.tif';
            // hilfsmeldung an der Konsole zur Angane der aktuellen exportierten Datei.
            writeln('.._page'+inttostr(icount)+ '.tif');
            // Extrahiere die aktuelle Seite der Imageen direkt als TIFF Datei in die Zielfatei.
            ExtractTIFFImageFile( paramstr(2) , nu_File_name, icount);
            ExitCode:=0;
          end;

       finally
      if Assigned(img_Split) then FreeAndNil(img_Split);
    end;
  end;
  if lowercase(paramstr(1)) = '-m' then
  begin
    if (paramstr(2)='') and (paramstr(3)='') then
    begin
      WriteLn ('Fehler: ..keine TIFF Dateien angegeben die zusammengefgt werden sollen');
      ExitCode:=1;
      exit;
    end;
    img_Merge := TImageEnView.Create(nil);
    img_Conv := TImageEnMView.Create(nil);
//    img_vect:=TImageEnVect.create(nil);

    if FileAccessable(paramstr(3))then
    begin;
      if FileAccessable(paramstr(2))then
      begin
         // lade die erste Datei
 { 
//        img_conv.SetImage(img_conv.AppendImage,img_merge.Bitmap);
         sleep(150);



         insertTiffimageFile(paramstr(2),paramstr(3),paramstr(2),img_Merge.IO.params.ImageCount );
}

        {
         img_conv.MIO.LoadFromFile(paramstr(3));
         insertingpage:= img_conv.MIO.Params[0].ImageCount; // zaehle die Anzahl der Seiten der  1rsten Datei
         img_conv.MIO.Params[0].ImageIndex:=  insertingpage; // setze den index den Seiten ersten Datei auf die letzte Seite
         img_conv.MIO.LoadFromFile(paramstr(2)) ; // lade die 2-te Datei
         img_conv.MIO.SaveToFile(paramstr(2)); //  Speichere die zusammegefgten Datei unter dem agegebenen Dateinamen.
          }

         // insert the TIFF
        //tags.InsertTIFFFile( OpenImageEnDialog1.FileName, insertingPage );
        // update
        // ChangesPage;

        // zweite Methode

         lttags := TIETIFFHandler.Create;
         img_Merge.IO.LoadFromFile(paramstr(3));
         lttags.ReadFile(paramstr(2));
         for i:=0 to  img_Merge.IO.Params.ImageCount-1 do
         begin
         img_Merge.IO.Params.ImageIndex:=  img_Merge.IO.Params.ImageCount-1-i;
         img_Merge.IO.LoadFromFile(paramstr(3));
         tmp := TMemoryStream.Create;


         img_Merge.IO.SaveToStreamTIFF(tmp);
         tmp.Seek(0, 0);

         lttags.InsertTIFFStream(tmp, 0);
         tmp.Free;
         end;      
         lttags.WriteFile(paramstr(2));
        ExitCode:=0;
        end else WriteLn('Fehler: auf die Datei (Param2) kann nicht zugegriffen werden.'+#10+#13);
    end else WriteLn('Fehler: auf die Datei (Param3) kann nicht zugegriffen werden.'+#10+#13);
   end;

  if lowercase(paramstr(1)) = '-a' then
  begin
    if (paramstr(2)='') and (paramstr(3)='') then
    begin
      WriteLn ('Fehler: ..keine TIFF Dateien angegeben die zusammengefgt werden sollen');
      ExitCode:=1;
      exit;
    end;
    img_Merge := TImageEnView.Create(nil);
    img_Conv := TImageEnMView.Create(nil);
//    img_vect:=TImageEnVect.create(nil);

    if FileAccessable(paramstr(3))then
    begin;
      if FileAccessable(paramstr(2))then
      begin
 {       img_Merge.IO.LoadFromFile(paramstr(2));  // lade die erste Datei

//        img_conv.SetImage(img_conv.AppendImage,img_merge.Bitmap);
         sleep(150);



         insertTiffimageFile(paramstr(2),paramstr(3),paramstr(2),img_Merge.IO.params.ImageCount );
}
        {
         img_conv.MIO.LoadFromFile(paramstr(2));
         insertingpage:= img_conv.MIO.Params[0].ImageCount; // zaehle die Anzahl der Seiten der  1rsten Datei
         img_conv.MIO.Params[0].ImageIndex:=  insertingpage; // setze den index den Seiten ersten Datei auf die letzte Seite
         img_conv.MIO.LoadFromFile(paramstr(3)) ; // lade die 2-te Datei
         img_conv.MIO.SaveToFile(paramstr(2)); //  Speichere die zusammegefgten Datei unter dem agegebenen Dateinamen.
         // insert the TIFF
        //tags.InsertTIFFFile( OpenImageEnDialog1.FileName, insertingPage );
        // update
        // ChangesPage;}

        lttags := TIETIFFHandler.Create;
         img_Merge.IO.LoadFromFile(paramstr(3));
         lttags.ReadFile(paramstr(2));
         for i:=0 to  img_Merge.IO.Params.ImageCount-1 do
         begin
         img_Merge.IO.Params.ImageIndex:= i;
         img_Merge.IO.LoadFromFile(paramstr(3));
         tmp := TMemoryStream.Create;


         img_Merge.IO.SaveToStreamTIFF(tmp);
         tmp.Seek(0, 0);
         //lttags.ReadFile(paramstr(3));
         lttags.InsertTIFFStream(tmp, lttags.GetPagesCount);
         tmp.Free;

         end;
         lttags.WriteFile(paramstr(2));






        ExitCode:=0;
      end else WriteLn('Fehler: auf die Datei (Param2) kann nicht zugegriffen werden.'+#10+#13);
    end else WriteLn('Fehler: auf die Datei (Param3) kann nicht zugegriffen werden.'+#10+#13);
   end;

finally

  if Assigned(img_Split) then FreeAndNil(img_Split);
  if Assigned(img_Merge) then FreeAndNil(img_Merge);
  if Assigned(img_Conv) then FreeAndNil(img_Conv);

end;

end.




