unit U_commentary;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Grids, DBGrids, CRGrid, ExtCtrls,
   gnugettext,
   u_ShBase, u_ShLowUtils, u_dm_db;

type
   Tfra_commentary = class (TFrame)
      dbgrd_commentary: TCRDBGrid;
    btn_AddCommentary: TButton;
      lbl_komm: TLabel;
      pnl_input: TPanel;
      memo_comm: TMemo;
    btn_ModifyCommentary: TButton;
    btn_DeleteCommentary: TButton;
      procedure btn_AddCommentaryClick(Sender: TObject);
      procedure dbgrd_commentaryCellClick(Column: TColumn);
      procedure btn_ModifyCommentaryClick(Sender: TObject);
      procedure btn_DeleteCommentaryClick(Sender: TObject);
      procedure dbgrd_commentaryDrawColumnCell(Sender: TObject;
         const Rect: TRect; DataCol: Integer; Column: TColumn;
         State: TGridDrawState);
    procedure memo_commChange(Sender: TObject);
   protected
      DocRight:TRData;
   public
      procedure InitCommentary(ArcName: string; docid: int64; ADocRight:TRData);
      function Count:integer;
   end;

implementation

uses u_mainform, db, u_dm_ViewerMain;

{$R *.dfm}
(* GPL
//-----------------------------------------------------------------------------
procedure Tfra_commentary.btn_AddCommentaryClick(Sender: TObject);
var lsText: string;
begin
   lsText := trim(memo_comm.lines.text);
   if lsText  <> '' then
   begin
      dm_db.my_cmd.SQL.Text := 'insert into com_' + sIarcName + ' (doc_id,usr_id, usr_name,tstamp,com_txt) values(' +
         inttostr(iGdocid) + ',' + inttostr(igUsrid) + ',' + #34 + sGusrname + #34 + ',now(),:kom_txt)';
      dm_DB.my_cmd.ParamByName('kom_txt').AsMemo := ParserSemiColonWithoutspace(lsText);
      try
         dm_db.my_cmd.execute;
      except on e: exception do
         begin
            logevnt('Error on fra_commentary.btn_AddCommentaryClick ' + e.message);
         end;
      end;
      dm_db.my_q_comm.Refresh;
      dm_MainForm2.updatecolumnbuttonTBX(frm_mainform.tbi_DocDiscussion, _('Diskussion'), dm_MainForm2.img_buttonstr, 4);
      // Selektierten Eintrag auf den letzten setzen
      dbgrd_commentary.DataSource.DataSet.Last;
      dbgrd_commentaryCellClick(nil);
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfra_commentary.dbgrd_commentaryCellClick(Column: TColumn);
var lUsrId: TUsrId; lSelber: Boolean;
begin
   memo_comm.lines.text := dm_db.my_q_comm.fieldbyname('com_txt').AsString;

   if dm_db.my_q_comm.recordcount = 0 then
      lUsrId := -1
   else
      lUsrId := dm_db.my_q_comm.fieldbyname('usr_id').AsInteger;

   lSelber := lUsrId = iGUsrID;

   btn_ModifyCommentary.Enabled := lSelber and (DocRight.AModify);
   btn_DeleteCommentary.Enabled := lSelber and (DocRight.AModify);;
   btn_AddCommentary   .Enabled := (memo_comm.lines.Count > 0)
                                    and (DocRight.awrite);;
end;

//-----------------------------------------------------------------------------
procedure Tfra_commentary.memo_commChange(Sender: TObject);
begin
   btn_AddCommentary   .Enabled := (memo_comm.lines.Count > 0)
                                    and (DocRight.awrite);;
end;

//-----------------------------------------------------------------------------
procedure Tfra_commentary.btn_ModifyCommentaryClick(Sender: TObject);
begin
   if dm_db.my_q_comm.RecordCount > 0 then
   begin
      dm_db.my_cmd.SQL.Text := 'update com_' + sIarcName + ' set com_txt = :kom_txt' +
         ' where com_id = ' + inttostr(dm_db.my_q_comm.fieldbyname('com_id').AsInteger);
      dm_DB.my_cmd.ParamByName('kom_txt').AsMemo := ParserSemiColonWithoutspace(trim(memo_comm.Lines.Text));
      try
         dm_db.my_cmd.execute;
      except on e: exception do
         begin
            logevnt('Error on fra_commentary.btn_AddCommentaryClick ' + e.message);
         end;
      end;
      dm_db.my_q_comm.Refresh;
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfra_commentary.btn_DeleteCommentaryClick(Sender: TObject);
begin
   if dm_db.my_q_comm.RecordCount > 0 then
   begin
      dm_db.my_cmd.SQL.Text := 'delete from  com_' + sIarcName +
         ' where com_id = ' + inttostr(dm_db.my_q_comm.fieldbyname('com_id').AsInteger);
      try
         dm_db.my_cmd.execute;
      except on e: exception do
         begin
            logevnt('Error on fra_commentary.btn_AddCommentaryClick ' + e.message);
         end;
      end;
      dm_db.my_q_comm.Refresh;
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfra_commentary.dbgrd_commentaryDrawColumnCell(Sender: TObject;
   const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
   s, t, s1: string;
   i, w: integer;
begin
   if column.Field.DataType = ftMemo then
   begin
      with
         TDBGrid(Sender).Canvas do
      begin
         w := Rect.Right - Rect.Left - Textwidth('...');
         s := Column.field.asstring;
         for i := 1 to length(s) do
         begin
            t := copy(s, 1, i);
            if (textwidth(t) > w) then
            begin
               s1 := '...';
               break;
            end;
         end;
         t := copy(s, 1, i - 1);
         fillrect(rect);

         textrect(rect, rect.Left + 1, rect.top + 2, t + s1);
      end;
   end
   else
   begin
      TDBGrid(Sender).DefaultDrawColumnCell(rect, datacol, column, state);
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfra_commentary.InitCommentary(ArcName: string; docid: int64; ADocRight:TRData);
var lsSql: string;
begin
   GgfLogevnt('ShowDocCommentary');

   DocRight := ADocRight;

   memo_comm.text := ''; //3.5.0.23

   if (sIarcname = '') or (iGdocid < 1) then
      Exit;

   if DocRight.aread then
   begin
      lsSql := 'select * from com_' + ArcName + ' where doc_id=' + inttostr(docid);
   end
   else
   begin
      lsSql := 'select * from com_' + ArcName + ' where 1=0';
   end;
   dm_db.my_q_comm.sql.text := lsSql;
   dm_db.my_q_comm.execute;
   dbgrd_commentary.Columns.items[0].Width := 80;
   dbgrd_commentaryCellClick(nil); //3.5.0.23
end;

//-----------------------------------------------------------------------------
function Tfra_commentary.Count:integer;
begin
   Result := dbgrd_commentary.DataSource.DataSet.RecordCount;
end;

//-----------------------------------------------------------------------------
*)
end.
