unit U_drawsat;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, ExtCtrls, u_DocEditor, Vectors, Collision;

type
   Tfsat = class (TForm)
      Image1: TImage;
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      m: array of TPOlygon;
      MTD: TVector2f;
      procedure DrawPolygon(A: TPolygon);
      procedure DrawCircle(C: TCircle);
      procedure DrawScene;
   end;

var
   fsat: Tfsat;

implementation

{$R *.dfm}
procedure Tfsat.DrawPolygon(A: TPolygon);
var
   i, l: integer;
begin
   for i := 0 to A.Count - 1 do
   begin
      l := i + 1;
      if l > (A.Count - 1) then
         l := 0;
      with Image1.Canvas do
      begin
         MoveTo(round(A.vertices_abs[l].x), round(A.vertices_abs[l].y));
         LineTo(round(A.vertices_abs[i].x), round(A.vertices_abs[i].y));
      end;
   end;
end;

procedure Tfsat.DrawCircle(C: TCircle);
begin
   with Image1.Canvas do
   begin
      Ellipse(round(C.position.x - C.radius), round(C.position.y - C.radius),
         round(C.position.x + C.radius), round(C.position.y + C.radius));
   end;
end;

procedure Tfsat.DrawScene;
var
   acolor, bcolor, ccolor: TColor;
   i, j: integer;
begin
   image1.Picture.Bitmap := nil;
   image1.Canvas.Pen.color := clblack;
   for i := 0 to length(m) - 1 do
   begin
      for j := 0 to length(m) - 1 do
      begin
         if i = j then
         begin
            continue;
         end;
         if PolyPolyIntersect(m[j], m[i], MTD) then
            image1.Canvas.Pen.color := clred;
      end;
   end;
   for i := 0 to length(m) - 1 do
   begin
      DrawPolygon(m[i]);
   end;
end;

procedure Tfsat.FormCreate(Sender: TObject);
var i, hobj: integer;
begin
   image1.Width := frm_DocEdit.img_DocEdit.IO.Params.Width;
   image1.Height := frm_DocEdit.img_DocEdit.IO.Params.height;
   for hobj := 0 to frm_DocEdit.img_DocEdit.ObjectsCount - 1 do
   begin
      i := length(m);
      setlength(m, i + 1);
      m[i] := TPolygon.Create;
      m[i].position := to_v2f(frm_DocEdit.img_DocEdit.Objleft[hobj], frm_DocEdit.img_DocEdit.Objtop[hobj]);
      frm_DocEdit.img_DocEdit.ObjID[hobj] := 4 + i;
      with m[i] do
      begin
         AddVertex(to_v2f(0, 0));
         AddVertex(to_v2f(frm_DocEdit.img_DocEdit.ObjWidth[hobj], 0));
         AddVertex(to_v2f(frm_DocEdit.img_DocEdit.ObjWidth[hobj], frm_DocEdit.img_DocEdit.ObjHeight[hobj]));
         AddVertex(to_v2f(0, frm_DocEdit.img_DocEdit.ObjHeight[hobj]));
      end;
   end;
   DrawScene;
end;

end.
