unit U_threadedannoscheck;

interface

uses
   Classes,
   u_ShLowUtils;

type
   TTannoscheck = class (TThread)
   private
      fsDocFile: string;
      { Private declarations }
   protected
      procedure Execute; override;
   public
      constructor Create(fsuspended: boolean);
      property psdocfile: string Read fsDocFile Write fsDocFile;
   end;

implementation

{ TTannoscheck }
uses u_mainform, u_ShVoransicht, SysUtils, Windows, Forms,
   {} u_dm_ViewerMain,
   u_dm_db, menus, gnugettext;


var
  gThreadCSAnnos : RTL_CRITICAL_SECTION;


constructor TTannoscheck.Create(fsuspended: boolean);
begin
   inherited Create(fsuspended);
end;


(* m.frey: bei langen Dokumente, z.B. 500 Seiten ist die Methode recht langsam
wegen die vielen Fileexists. Als Ersatz wird erst die Dateiliste geladen und
dann dort drin gesucht.
*)
procedure TTannoscheck.Execute; //3.5.0.23
var
   licounter, licounter2, iXTbi, iYTbi, liobjcount, iXTlb, iYTlb: integer;
   lblesbarpubanno: boolean;
   sIEVFiletmp, lsusers, lsprivtmp, lspubtmp, lstmp,
   lspubannopages, sChk4pIev, lsDocName, lsDocPath, lsDocMask, lsDocBase,
   lsUser1, lsUserId, ls, lsDiscussion: string;
   iPos: Tpoint;
   slFiles: TStringList;
   function FileExistsFast(s:string):Boolean;
   begin
      Result := slFiles.IndexOf(s) >= 0;
   end;
begin
   GgfLogEvntBeg('TTannoscheck.Execute; beg');
	try
      inherited;

      lblesbarpubanno := false;
      liobjcount := 0;

      lsDocName := ChangeFileExt(fsDocFile, ''); // z.B. '\\sv03\Daten-RS\testarchiv20042006100810\112009\05\91151422343607'
      lsDocName := StringReplace(lsDocName, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

      lsDocPath := ExtractFilePath(lsDocName);
      lsDocBase := ExtractFileName(lsDocName);
      lsdocMask := lsdocMask+'*.IEV';
      slFiles := ReadDir( lsDocPath, lsDocMask, false);
      slFiles.Sorted := true;

      try
         with frm_MainForm do
         begin
          //private
            if dm_db.my_q_ngtmp.active then
            begin
               for licounter2 := 0 to fra_Voransicht.img_DocView.io.params.ImageCount - 1 do
               begin
                  for licounter := 0 to dm_db.my_q_ngtmp.RecordCount - 1 do
                  begin
                     lsUserId := dm_db.my_q_ngtmp.FieldByName('src_usr_id').AsString;
                     ls := lsDocBase + IntToStr(licounter2) + 'P' + lsUserId + '.IEV';
                     if FileExistsFast(ls) then
                     begin
                        sChk4pIev := lsDocPath + ls;
                        // Icon 119
                        fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
                        GgfLogEvnt('LoadFromFileIEV T2');
                        if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
                        begin
                         liobjcount := fra_Voransicht.img_DocView.ObjectsCount + liobjcount;
                         lsUser1 := dm_db.my_q_ngtmp.FieldByName('usr_name').AsString;
                         if lsUsers = '' then
                            lsUsers := lsUser1
                         else
                            lsUsers := lsusers + ', ' + lsUser1;
                         dm_MainForm2.pum_PrivAnno.Items.Add(
                            newItem(lsUser1, //name
                            0,    //shortcut
                            False,//checked
                            True, // enabled
                            dm_MainForm2.pum_PrivAnnoClick, //onclick
                            0,    //heplcontext
                            'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
                            ));
                         dm_MainForm2.pum_PrivAnno.Items[
                            dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
                            dm_db.my_q_ngtmp.FieldByName('src_usr_id').AsInteger;
                        end;
                     end;
                  end;
                  ls := lsDocBase + IntToStr(licounter2) + 'P' + IntToStr(igUsrId) + '.IEV';
                  if FileExistsFast(ls) then
                  begin
                     sChk4pIev := lsDocPath + ls;
                     // Icon 119
                     fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
                     GgfLogEvnt('LoadFromFileIEV T1');
                     if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
                     begin
                        liobjcount := fra_Voransicht.img_DocView.ObjectsCount + liobjcount;
                        if lsUsers = '' then
                         	lsUsers := sGUsrName
                        else
                        begin
                           if pos(sGUsrName, lsusers) = 0 then
                           begin
                            lsUsers := lsusers + ', ' +
                               sGUsrName;
                           end;
                        end;
                        if dm_MainForm2.pum_PrivAnno.Items.Find(sGUsrName) = nil then
                        begin
                         dm_MainForm2.pum_PrivAnno.Items.Add(
                            newItem(sGUsrName, //name
                            0,    //shortcut
                            False,//checked
                            True, // enabled
                            dm_MainForm2.pum_PrivAnnoClick, //onclick
                            0,    //heplcontext
                            'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
                            ));
                         dm_MainForm2.pum_PrivAnno.Items[
                            dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
                            igUsrId;
                        end;
                     end;
                     if terminated then
                     begin
                     	exit;
                     end;
                  end;
               end;
               if terminated then
               begin
               	exit;
               end;
               if lsusers = '' then
               begin
                  tbx_privNote.ImageIndex := 109;
                  // Icon 109
               end
               else
               begin
                  //   fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
                  tbx_privNote.ImageIndex := 119;
                  tbx_privNote.Hint := Format(
                  _('Zu diesem Dokument existiert eine persnliche Notiz von %s'),
                  [lsusers]);
               end;
               fra_Voransicht.img_DocView.RemoveAllObjects;
               frm_MainForm.fra_Volltext.clearobjslist;
            end
            else
            begin
             LogEvnt('error with my_q_ngtmp in ShowVoransicht, searching for priv anno');
            end;
            //public
            if terminated then
            begin
             	exit;
            end;
            for licounter2 := 0 to fra_Voransicht.img_DocView.io.params.ImageCount - 1 do
            begin
               //for licounter := 0 to 2 do
               begin
                  ls := lsDocBase + IntToStr(licounter2) + '.IEV';
                  if FileExistsFast(ls) then
                  begin
                     sIEVFiletmp := lsDocPath + ls;
                     if lspubannopages = '' then
                     begin
                      	lspubannopages := IntToStr(licounter2 + 1);
                     end
                     else
                     begin
                      	lspubannopages := lspubannopages + ',' + IntToStr(licounter2 + 1);
                     end;
                     lblesbarpubanno := True;
                     //break;
                  end;
                  if terminated then
                  begin
                   	exit;
                  end;
                //m.frey: bei 500 Seiten sind das 30Sekunden //sleep(20);
               end;
            end;
            if (lspubannopages <> '') or (lsusers <> '') or (lsDiscussion <> '') then //3.5.0.23
            begin
               if tbx_privNote.Visible and (lspubannopages <> '') and
                (lsusers <> '') and tbx_pubNote.Visible then
               begin
                iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbi_vshowanno).BoundsRect.Left;
                iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbi_vshowanno).BoundsRect.Top;
               end
               else
               if tbx_privNote.Visible and (lsusers <> '') then
               begin
                iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbx_privNote).BoundsRect.Left;
                iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbx_privNote).BoundsRect.Top;
               end
               else
               if tbx_pubNote.Visible then
               begin
                iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbx_pubNote).BoundsRect.Left;
                iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbx_pubNote).BoundsRect.Top;
               end
               else
               begin
                iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbi_vshowanno).BoundsRect.Left;
                iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                   frm_MainForm.tbi_vshowanno).BoundsRect.Top;
               end;
               if lsusers <> '' then
               begin
                  if liobjcount = 1 then
                  begin
                   lsprivtmp := Format(
                      _('Zu diesem Dokument existiert eine persnliche Notiz von %s'),
                      [lsusers]);
                  end
                  else
                  begin
                   lsprivtmp := Format(
                      _('Zu diesem Dokument existieren %d persnliche Notizen von %s'),
                      [liobjcount,lsusers]);
                  end;
                  lstmp := lsprivtmp;
               end;
               if lspubannopages <> '' then
               begin
                  tbx_pubNote.ImageIndex := 125;
                  lspubtmp := _('Zu diesem Dokument existieren ffentliche Notizen auf Seite(n)') + ': ' + lspubannopages;
                  lstmp := lspubtmp;
                  tbx_pubNote.Hint := lspubtmp;
               end;
               if (lspubannopages <> '') and (lsusers <> '') then
               begin
                	lstmp := lspubtmp + #13 + lsprivtmp;
               end;

               if lsDiscussion <> '' then
               begin
                	lstmp := lspubtmp + #13 + lsDiscussion;
               end;

               iXTlb := frm_MainForm.tlb_Zoom2.Left;
               iYTlb := frm_MainForm.tlb_Zoom2.Top;

               iPos.X := frm_MainForm.tlb_Zoom2.CurrentDock.Left + iXTlb + iXTbi + 15;
               iPos.Y := frm_MainForm.tlb_Zoom2.CurrentDock.Top + iYTlb + iYTbi + 15;
               dm_MainForm2.fiPos := iPos;
               dm_MainForm2.fsmsghinttop := _('Notiz');
               dm_MainForm2.fsmsghint := lstmp;
               dm_MainForm2.fblesbarpubanno := lblesbarpubanno;

               if (igDocID <> iGLastDocAnnos) or
                  (igArcID <> iGLastArcAnnos) then
               begin
                   EnterCriticalSection(gThreadCSAnnos);
                   try
                      dm_MainForm2.tim_annosshow.enabled := true;
                      iGLastDocAnnos :=  igDocID;
                      iGLastArcAnnos := igArcID;
                   finally
                      LeaveCriticalSection(gThreadCSAnnos);
                   end;
               end;
            end;
            if lspubannopages = '' then
            begin
             tbx_pubnote.Hint := _('Zeige ffentlliche Anmerkungen an');
             tbx_pubNote.ImageIndex := 110;
            end;

            if terminated then
            begin
             exit;
            end;
            if lblesbarpubanno and not ShowNoAnno then
             tbi_VShowAnno.Checked := True;
            if tbi_VShowAnno.Checked then
            begin
             tbx_privNote.Visible := True;
             tbx_pubNote.Visible := True;
             // tbx_UserNote.Visible:=false;
            end
            else
            begin
             tbx_privNote.Visible := False;
             tbx_pubNote.Visible := False;
             //tbx_UserNote.Visible:=true;
            end;
         end;
      finally
	      slFiles.Free;
      end;
      frm_MainForm.ZustaendeAnnotationBearbeitenSetzen; //m.frey

      if not dm_MainForm2.tim_annosshow.enabled then
      begin
         //frm_MainForm.SeiteSetzen;
         dm_MainForm2.tim_SelPage.Enabled := true;
         GgfLogEvnt('dm_MainForm2.tim_SelPage.Enabled := true;');
      end;
	finally
     GgfLogEvntEnd('TTannoscheck.Execute; end');
  	end;
end;

//-----------------------------------------------------------------------------

initialization
   InitializeCriticalSection(gThreadCSAnnos); //17.08.2010 b.takacs

finalization
   DeleteCriticalSection(gThreadCSAnnos); //17.08.2010 b.takacs


end.
