unit u_AddDocTimer;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, Buttons, TBXStatusBars, StdCtrls, ComCtrls, MFEdit, DateUtils,
   JvExStdCtrls, JvCombobox, JvListComb, Mask, JvExMask, JvToolEdit, gnugettext,
   DB, MemDS, DBAccess, MyAccess,
   u_ShLowUtils, u_ShDbUtils, u_ShHighUtils;

type
   Tfrm_AddDocTime = class (TForm)
      dtp_DocTime: TMFDateTimeEdit;
      lbl_Datum: TLabel;
      memo_Info: TMemo;
      lbl_Notiz: TLabel;
      stb_AddDocTime: TTBXStatusBar;
      sbtn_OK: TSpeedButton;
      sbtn_Cancel: TSpeedButton;
      dtp_Alarm: TMFDateTimeEdit;
      Label2: TLabel;
      JvCCB_je: TJvCheckedComboBox;
      JvCCB_efa: TJvCheckedComboBox;
      StaticText2: TLabel;
      StaticText3: TLabel;
      StaticText4: TLabel;
      StaticText5: TLabel;
      StaticText6: TLabel;
      JvCCB_eb: TJvCheckedComboBox;
      jchb_opttim: TJvCheckedComboBox;
      st_wvlopt: TLabel;
      procedure sbtn_OKClick(Sender: TObject);
      procedure sbtn_CancelClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure dtp_DocTimeChange(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
      gSLitems_eb: TStringList;
      gSLitems_je: TStringList;
      gSLitems_efa: TStringList;
   public
      { Public-Deklarationen }
      procedure InitAddDocTimer;
      function CheckRights:Boolean;
   end;

var
   frm_AddDocTime: Tfrm_AddDocTime;

   // get the usr_ids maybe not necessary...
   gSLitems_eb: TStringList;
   gSLitems_je: TStringList;
   gSLitems_efa: TStringList;

implementation

{$R *.dfm}

uses u_dm_DB, u_MainForm, {} u_dm_ViewerMain, u_Login, Registry;

procedure Tfrm_AddDocTime.InitAddDocTimer;
var
   iCount: integer;
begin
   dtp_DocTime.DateTime := StartOfTheDay(now);
   dtp_Alarm.DateTime := IncDay(dtp_DocTime.DateTime, 7);
   // Benutzer auslesen
   frm_MainForm.TmpSQL('select usr_id, usr_Name  from sys_usr where (usr_name not like  '
      +
      #39 + 'DEL\_%' + #39 + ') and (usr_name not like ' + #39 + 'system' +
      #39 + ') order by usr_name');
   //  statictext1.Caption:=inttostr (dm_DB.my_q_Tmp.RecordCount);

   jvccb_je.Items.Clear;
   jvccb_efa.Items.Clear;

   jvccb_eb.Items.Clear;

   gSLitems_eb := TStringList.Create;
   gSLitems_je := TStringList.Create;
   gSLitems_efa := TStringList.Create;
   for iCount := 0 to (dm_DB.my_q_Tmp.RecordCount - 1) do
   begin
      jvccb_eb.Items.Add(dm_DB.my_q_Tmp.FieldByName('usr_name').AsString);
      gSLitems_eb.Add(dm_DB.my_q_Tmp.FieldByName('usr_id').AsString);
      dm_DB.my_q_Tmp.Next;
   end;
   dm_DB.my_q_Tmp.Close;

   // Gruppen auslesen
   frm_MainForm.TmpSQL(
      'select grp_id, grp_Name,  grp_name from sys_grp' +
      ' order by grp_name');
   //statictext1.Caption:=inttostr (dm_DB.my_q_Tmp.RecordCount); // schreibt die Anzahl der Gruppen
   for iCount := 0 to (dm_DB.my_q_Tmp.RecordCount - 1) do
   begin
      jvccb_je.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      gSLitems_je.Add(dm_DB.my_q_Tmp.FieldByName('grp_id').AsString);
      jvccb_efa.Items.Add(dm_DB.my_q_Tmp.FieldByName('grp_name').AsString);
      gSLitems_efa.Add(dm_DB.my_q_Tmp.FieldByName('grp_id').AsString);
      dm_DB.my_q_Tmp.Next;
   end;
   dm_DB.my_q_Tmp.Close;

end;

procedure Tfrm_AddDocTime.sbtn_OKClick(Sender: TObject);
var
   sDatum, sAlarm, lsDocStateText, lsjunc, lsidw: string;
   listatus, licounter,
   liInsID, litimeroptionen: integer;
   lbnotsomeonechecked: boolean;
begin
   //skywalker added      chbx_gbd. it is invisible till param(1) = 0704161322
   DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(dtp_DocTime.DateTime));
   DateTimeToString(sAlarm, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(dtp_Alarm.DateTime));
   lbnotsomeonechecked := True;
   lsDocStateText := '';
   lsjunc := '';
   if iGArcRecNo <> dm_db.my_q_arc.RecNo then
   begin
      dm_db.my_q_Arc.GotoBookmark(
         Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
   end;

   litimeroptionen := 0;
   for licounter := 0 to jchb_opttim.Items.Count - 1 do
   begin
      // Nach Erledigung zurck 2
      // Erinnerungsmail senden 4
      // Einzelmodusinbearbeitung 8 
      {Kein Einzelmodus in Bearbeitung}

      if jchb_opttim.IsChecked(licounter) then
      begin
         litimeroptionen := litimeroptionen or (1 shl (licounter + 1));
      end;
      //             label2.Caption:= label2.Caption+' '+JvCheckedComboBox1.Items.Strings[licounter];
   end;
   for licounter := 0 to jvccb_je.Items.Count - 1 do
   begin
      if jvccb_je.IsChecked(licounter) then
      begin
         lbnotsomeonechecked := False;
         frm_MainForm.TmpSQL(
            'Select * from sys_grpusr left join sys_usr using (usr_id) where grp_id = ' +
            gSLitems_je.Strings[licounter] + ' and usr_name not like  ' +
            #39 + 'DEL\_%' + #39);

         if dm_DB.my_q_Tmp.RecordCount > 0 then
         begin
            dm_DB.my_Cmd.SQL.Text :=
               'Insert into sys_timer (grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
               + 'Values (:grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
            dm_DB.my_Cmd.ParamByName('grpid').AsString :=
               gSLitems_efa.Strings[licounter];
            dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
            dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
            dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
               dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
            dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
               dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
            dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
            dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

            dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := dtp_Alarm.DateTime;
            dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen or 1;

            dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
            dm_DB.my_Cmd.Execute;
            liInsID := dm_DB.my_Cmd.InsertId;
            dm_DB.my_Cmd.SQL.Text :=
               'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
               ' where tim_id = ' + IntToStr(liInsID);
            dm_DB.my_Cmd.Execute;
            lsDocStateText :=
               lsDocStateText + lsjunc + dm_DB.my_q_Tmp.FieldByName('usr_name').AsString;
            lsjunc := ', ';

            dm_DB.my_q_Tmp.Next;
            while not dm_DB.my_q_Tmp.EOF do
            begin
               dm_DB.my_Cmd.SQL.Text :=
                  'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                  +
                  'Values (:timref, :grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
               dm_DB.my_Cmd.ParamByName('timref').AsInteger := liInsID;
               dm_DB.my_Cmd.ParamByName('grpid').AsString :=
                  gSLitems_je.Strings[licounter];
               dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
               dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
               dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                  dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
               dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                  dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
               dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
               dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

               dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := dtp_Alarm.DateTime;
               dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen or 1;

               dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
               dm_DB.my_Cmd.Execute;
               lsDocStateText :=
                  lsDocStateText + lsjunc + dm_DB.my_q_Tmp.FieldByName('usr_name').AsString;


               dm_DB.my_q_Tmp.Next;
            end;
         end;
      end;


      if jvccb_efa.IsChecked(licounter) then
      begin
         lbnotsomeonechecked := False;
         //               susr:= sUsr+'#'+jvccb_efa.items.Strings[i] +' ';
         frm_MainForm.TmpSQL(
            'Select * from sys_grpusr left join sys_usr using (usr_id) where grp_id = ' +
            gSLitems_efa.Strings[licounter] + ' and usr_name not like  ' +
            #39 + 'DEL\_%' + #39);

         try
            if dm_DB.my_q_Tmp.RecordCount > 0 then
            begin
               dm_DB.my_Cmd.SQL.Text :=
                  'Insert into sys_timer (grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                  +
                  'Values (:grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
               dm_DB.my_Cmd.ParamByName('grpid').AsString :=
                  gSLitems_efa.Strings[licounter];
               dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
               dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
               dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                  dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
               dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                  dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
               dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
               dm_DB.my_Cmd.ParamByName('termin').AsDateTime :=
                  dtp_DocTime.DateTime;

               dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := dtp_Alarm.DateTime;
               dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

               dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
               dm_DB.my_Cmd.Execute;
               liInsID :=
                  dm_DB.my_Cmd.InsertId;
               dm_DB.my_Cmd.SQL.Text :=
                  'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
                  ' where tim_id = ' + IntToStr(liInsID);
               dm_DB.my_Cmd.Execute;
               if lsDocStateText = '' then
                  lsDocStateText :=
                     lsDocStateText + lsjunc + dm_DB.my_q_Tmp.FieldByName('usr_name').AsString;
               lsjunc := ', ';


               dm_DB.my_q_Tmp.Next;
               while not dm_DB.my_q_Tmp.EOF do
               begin
                  dm_DB.my_Cmd.SQL.Text :=
                     'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) ' + 'Values (:timref, :grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';
                  dm_DB.my_Cmd.ParamByName('timref').AsInteger := liInsID;
                  dm_DB.my_Cmd.ParamByName('grpid').AsString :=
                     gSLitems_efa.Strings[licounter];
                  dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
                  dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
                  dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                     dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                  dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                     dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                  dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
                  dm_DB.my_Cmd.ParamByName('termin').AsDateTime :=
                     dtp_DocTime.DateTime;

                  dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := dtp_Alarm.DateTime;
                  dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

                  dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                  dm_DB.my_Cmd.Execute;

                  lsDocStateText :=
                     lsDocStateText + lsjunc + dm_DB.my_q_Tmp.FieldByName('usr_name').AsString;

                  dm_DB.my_q_Tmp.Next;
               end;
            end;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_AddDocTime.sbtn_OKClick',
                  _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben: ') +
                  e.Message, 2023, True);
            end;
         end;
      end;
   end;
   for licounter := 0 to jvccb_eb.Items.Count - 1 do
   begin
      if jvccb_eb.IsChecked(licounter) then
      begin
         lbnotsomeonechecked := False;
         try
            //               susr:= sUsr+jvccb_eb.items.Strings[licounter] +' ';
            lsidw := gSLitems_eb.Strings[licounter];

            if lsidw = '' then
            begin
               lsidw := gSLitems_eb.Strings[licounter];
            end;
            dm_DB.my_Cmd.SQL.Text :=
               'Insert into sys_timer ( arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, info, optionen) '
               + 'Values ( :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :info, :optionen)';
            dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
            dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
            dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
               dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
            dm_DB.my_Cmd.ParamByName('uwork').AsString :=
               lsidw;
            dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
            dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

            dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := dtp_Alarm.DateTime;

            dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

            dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
            dm_DB.my_Cmd.Execute;
            liInsID := dm_DB.my_Cmd.InsertId;
            dm_DB.my_Cmd.SQL.Text :=
               'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
               ' where tim_id = ' + IntToStr(liInsID);
            dm_DB.my_Cmd.Execute;

            lsDocStateText := lsDocStateText + lsjunc + jvccb_eb.Items.Strings[gSLitems_eb.IndexOf(lsidw)];
            lsjunc := ', ';
         except
            on e: Exception do
            begin
               ErrorMsg('frm_AddDocTime.sbtn_OKClick',
                  _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben: ') +
                  e.Message, 2023, True);
            end;
         end;
      end;
   end;

   //own wvl
   if lbnotsomeonechecked then
   begin
      lsidw := inttostr(iGUsrID);

      if lsidw = '' then
      begin
         lsidw := inttostr(iGUsrID);
      end;
      try
         //               susr:= sUsr+jvccb_eb.items.Strings[licounter] +' ';
         dm_DB.my_Cmd.SQL.Text :=
            'Insert into sys_timer ( arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, info, optionen) '
            + 'Values ( :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :info, :optionen)';
         dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iGArcID;
         dm_DB.my_Cmd.ParamByName('docid').AsInteger := iGDocID;
         dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
            dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
         dm_DB.my_Cmd.ParamByName('uwork').AsString := lsidw;
         dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
         dm_DB.my_Cmd.ParamByName('termin').AsDateTime := dtp_DocTime.DateTime;

         dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := dtp_Alarm.DateTime;
         dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

         dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
         dm_DB.my_Cmd.Execute;
         liInsID := dm_DB.my_Cmd.InsertId;
         dm_DB.my_Cmd.SQL.Text :=
            'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
            ' where tim_id = ' + IntToStr(liInsID);
         dm_DB.my_Cmd.Execute;
         lsDocStateText := lsDocStateText + lsjunc + jvccb_eb.Items.Strings[gSLitems_eb.IndexOf(lsidw)];
         lsjunc := ', ';


      except
         on e: Exception do
         begin
            ErrorMsg('frm_AddDocTime.sbtn_OKClick',
               _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben: ') +
               e.Message, 2023, True);
         end;
      end;
   end;

   frm_AddDocTime.ModalResult := mrOk;
   if iGArcRecNo <> dm_db.my_q_arc.RecNo then
   begin
      dm_db.my_q_Arc.GotoBookmark(
         Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
   end;

   frm_MainForm.NewHistory(17, _('Dokument auf Wiedervorlage/Aufgaben gelegt. Bearbeiter:'+' ') +
      lsDocStateText + ' Termin: ' + DateToStr(StartOfTheDay(dtp_DocTime.DateTime)));

   frm_MainForm.TmpSQL('select doc_state from arc_' + sIArcName +
      ' where doc_id = ' + IntToStr(iGDocID));
   listatus := dm_DB.my_q_Tmp.FieldByName('doc_state').AsInteger or 1;
   dm_DB.my_cmd.sql.Text := 'update arc_' + sIArcName + ' set doc_state = ' +
      IntToStr(listatus) + ' where doc_id = ' + IntToStr(iGDocID);
   dm_DB.my_cmd.Execute;


   dm_db.my_q_arc.refreshrecord;

   frm_MainForm.dbgrd_trefferliste.Show;
   // better refreshing of wvl!
   frm_MainForm.tci_inuse.Color := cllime;
   try
      if dm_DB.my_q_time.active then
         dm_DB.my_q_time.Refresh;
   except;
   end;
   frm_MainForm.dbgrd_wvl.hide;
   frm_MainForm.dbgrd_wvl.Show;
end;

procedure Tfrm_AddDocTime.sbtn_CancelClick(Sender: TObject);
begin
   frm_AddDocTime.ModalResult := mrCancel;
end;

{procedure Tfrm_AddDocTime.cbx_Usr_WorkChange(Sender: TObject);
begin
  if cbx_Usr_Work.ItemIndex = -1 then cbx_Usr_Work.ItemIndex := 0;
end;}

procedure Tfrm_AddDocTime.FormShow(Sender: TObject);
var reg: TRegistry;
begin
   reg := TRegistry.Create;
   try
      with reg do
      begin
         try
            RootKey := HKEY_CURRENT_USER;
            // Einlesen der Options-Einstellungen
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            if ValueExists('ReturntoSender') then
               jchb_opttim.Checked[0] := ReadBool('ReturntoSender');
            if ValueExists('Erinnerungsmail') then
               jchb_opttim.Checked[1] := ReadBool('Erinnerungsmail');
{        if ValueExists('Einzelmodusinbearbeitung') then
            jchb_opttim.Checked[2]:=   ReadBool('Einzelmodusinbearbeitung');}
         except
            on e: Exception do
            begin
               ErrorMsg('Tfrm_AddDocTime.FormShow', _('Fehler beim Einlesen der Registrierung: ') +
                  e.Message, 2029, True);
            end;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
   InitAddDocTimer;
end;

procedure Tfrm_AddDocTime.dtp_DocTimeChange(Sender: TObject);
begin
   dtp_Alarm.DateTime := IncDay(dtp_DocTime.DateTime, 7);
end;

procedure Tfrm_AddDocTime.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

//-----------------------------------------------------------------------------
function Tfrm_AddDocTime.CheckRights:Boolean;
var
  lsSql, lsTxt, lsName, lsValue, lsUserList, lsGrpList: string;
  liUser: integer;
  lUsrId,lGrpId: int64;  lbUserOk: Boolean;
  procedure Grp(Combo: TJvCheckedComboBox);
  var liGrp: integer;
  begin
   for liGrp := 0 to Combo.Items.Count - 1 do
   begin
      if Combo.IsChecked(liGrp) then
      begin
         try
            lsName := Combo.Items[liGrp];
            lGrpId := DbGroupIdI(lsName);
            lsSql := 'from sys_arcxs ' +
                     'where (arc_id = '+IntToStr(iGArcID)+') ' +
                     'and (grp_id = '+IntToStr(liGrp)+') ' +
                     'and (find_in_set("list",Rights)>0)';

            if DbCountSql(lsSql)=0 then
                  lsGrpList := lsGrpList+', '+lsName;
         finally
         end;
      end;
   end;
  end;
begin
   Result := true;
   for liUser := 0 to jvccb_eb.Items.Count - 1 do
   begin
      if jvccb_eb.IsChecked(liUser) then
      begin
         try
            lsName := jvccb_eb.Items[liUser];
            lUsrId := DbUserIdI(lsName);
            lsSql := 'from sys_arcxs ' +
                     'where (arc_id = '+IntToStr(iGArcID)+') ' +
                     'and (usr_id = '+IntToStr(lUsrId)+') ' +
                     'and (find_in_set("list",Rights)>0)';

            if DbCountSql(lsSql)=0 then
                  lsUserList := lsUserList+', '+lsName;
         finally
         end;
      end;
   end;
   Grp(JvCCB_je);
   Grp(JvCCB_efa);


   if lsUserList > '' then
      begin
         Delete(lsUserList,1,2); // vorne ', ' weg
         lsUserList := _('Folgende Benutzer haben nicht das Recht das Dokument zu sehen'
                       + ': ' + lsUserList);
         Result := false;
      end;
   if lsGrpList > '' then
      begin
         Delete(lsGrpList,1,2); // vorne ', ' weg
         lsGrpList := _('Folgende Gruppen haben nicht das Recht das Dokument zu sehen'
                      + ': ' + lsGrpList);
         Result := false;
      end;

   lsTxt := ConcatDelim(lsUserList,'<nl>',lsGrpList);
   if lsTxt > '' then
      begin
         BfMessageDlg(lsTxt , mtError, [mbOK], 0);
         Result := false;
      end;
end;

//-----------------------------------------------------------------------------
end.
