unit u_BrowseForPath;

interface

uses
   ShlObj, ActiveX, Windows;

type
   TFolderBrowser = class
   private
      // Luckie
      // alles private gemacht, geht niemanden was an da nachtrglicher Zugriff
      // sinnlos
      FHandle: THandle;
      FCaption: string;
      FShowFiles: boolean;
      FNewFolder: boolean;
      FInitFolder: string;
      FSelected: string;
   public
      // im Konstruktor gleich alles initialisieren (ist geschmackssache)
      constructor Create(Handle: THandle; const Caption: string;
         const InitFolder: string = ''; ShowFiles: boolean = False;
         NewFolder: boolean = False);
      function Execute: boolean;
      property SelFolder: string Read FSelected;
   end;

implementation

function FolderCallBack(theHandle: HWND; uMsg: UINT; lParam: lParam;
   lpData: lParam): lresult; stdcall;
begin
   //Dialog wurde initialisiert
   if uMsg = BFFM_INITIALIZED then
      //Ordner auswhlen
      SendMessage(theHandle, BFFM_SETSELECTION, Ord(True), lpData);
   Result := 0; //von Luckie hinzugefgt, hatte ich vergessen (oops)
end;

constructor TFolderBrowser.Create(Handle: THandle; const Caption: string;
   const InitFolder: string = ''; ShowFiles: boolean = False; NewFolder: boolean = False);
begin
   FHandle := Handle;
   FCaption := Caption;
   FInitFolder := InitFolder;
   FShowFiles := ShowFiles;
   FNewFolder := NewFolder;
end;

//Original:        Tino in den Delphi-Forum FAQs
//Modifiziert von: Christian "Peter Lustig" Stelzmann
// Luckie: Bug ("neuer Ordner" wird immer angezeigt) gefixed

function TFolderBrowser.Execute: boolean;

   procedure FreeItemIDList(var aPIdL: pItemIDList);
   var
      ppMalloc: iMalloc;
   begin
      SHGetMalloc(ppMalloc);
      ppMalloc.Free(aPIdL);
      aPIdL := nil;
      ppMalloc := nil;
   end;

const
   BIF_NEWDIALOGSTYLE = $40;
   BIF_NONEWFOLDERBUTTON = $200;

var
   BrowseInfo: TBrowseInfo;
   pidlResult: PItemIDList;
   DisplayName, Path: array[0..MAX_PATH + 1] of char;
begin
   // BrowseInfo mit Werten fllen
   FillChar(BrowseInfo, SizeOf(BrowseInfo), 0);
   CoInitialize(nil);
   with BrowseInfo do
   begin
      hwndOwner := 0;
      pszDisplayName := @DisplayName;
      lpszTitle := PChar(Fcaption);

      //Callback-Funktion zur Auswahl des Startverzeichnisses verwenden und ...
      lpfn := @FolderCallBack;
      //... das entsprechende Verzeichnis als lParam verwenden.
      lParam := integer(PChar(FinitFolder));


      // Luckie - BIF_USENEWUI sorgt dafr dass besagter Button immer angezeigt wird,
      //          egal, ob BIF_BROWSEINCLUDEFILES gesetzt wird oder nicht, daher rausgenommen
      if FShowFiles then
         ulFlags := ulFlags or BIF_BROWSEINCLUDEFILES;


      //Button zum Erstellen neuer Ordner anzeigen?
      // Luckie - ergnzt / gendert
      // PL - nochmals gendert
      if FNewFolder then
         ulFlags := ulFlags or BIF_NEWDIALOGSTYLE
      else
         ulFlags := ulFlags or BIF_NONEWFOLDERBUTTON;
   end;


   // Dialog aufrufen
   try
      pidlResult := SHBrowseForFolder(BrowseInfo);
   except
      Result := False;
      Exit;
   end;


   // Prfen ob ein Verzeichnis ausgewhlt wurde
   if pidlResult <> nil then
   begin
      SHGetPathFromIDList(pidlResult, Path);
      FSelected := Path;
      FreeItemIDList(pidlResult);


      Result := True;
   end
   else
      Result := False;
end;

end.
