unit u_DocEditor;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Placemnt, u_BrowseForPath, Registry, ieview, imageenview,
   ievect, ImageEnIO, ImageEnProc, TB2Item, TBX, TB2Dock, TB2Toolbar, TBXStatusBars,
   TB2ExtItems, TBXExtItems, ietextc, Math, ExtCtrls, gnugettext, StrUtils,
   u_ShBase, u_ShLowUtils, u_ShDm, u_HighUtils, u_ShVoransicht, u_ShHighUtils;

type

   TDOCOBJ = record
      doc_id: int64;
      arc_id: int64;
      symgsdocid: int64;
      gdocid: int64;
      disp_name: string;
      doc_loc: string;
      ext_loc: string;
      sIArcName: string;
      rights: TRData;
   end;

type
   Tfrm_DocEdit = class (TForm)
      fms_DocEdit: TFormStorage;
      stb_DocEdit: TTBXStatusBar;
      dock_DocEdit_Top: TTBXDock;
      dock_DocEdit_Right: TTBXDock;
      dock_DocEdit_Left: TTBXDock;
      dock_DocEdit_Bottom: TTBXDock;
      tlb_Menu: TTBXToolbar;
      tbsi_Help: TTBXSubmenuItem;
      tbsi_Extra: TTBXSubmenuItem;
      tbsi_Ansicht: TTBXSubmenuItem;
      tbsi_Datei: TTBXSubmenuItem;
      tbi_CloseEdit: TTBXItem;
      tbi_SaveLoc: TTBXItem;
      tbsep_Menu_1: TTBXSeparatorItem;
      tbi_SaveDoc: TTBXItem;
      tbsi_Symbols: TTBXSubmenuItem;
      tbsi_VisSpezial: TTBXSubmenuItem;
      tbi_Opt: TTBXItem;
      tbi_Info: TTBXItem;
      tbi_VisReDraw: TTBXItem;
      tbi_VisDefault: TTBXItem;
      tbsep_Menu_2: TTBXSeparatorItem;
      tbi_VisLoad: TTBXItem;
      tbi_VisSave: TTBXItem;
      tbi_SymScan: TTBXItem;
      tbi_SymEdit: TTBXItem;
      tbi_SymTools: TTBXItem;
      tbi_SymNav: TTBXItem;
      tlb_Tools: TTBXToolbar;
      tbsi_TZoom: TTBXSubmenuItem;
      tbsep_Tools_3: TTBXSeparatorItem;
      tbsi_TDeSpeckle: TTBXSubmenuItem;
      tbi_TRemBorder: TTBXItem;
      tbi_TDeSkew: TTBXItem;
      tbi_TTurnRight: TTBXItem;
      tbi_TFlip: TTBXItem;
      tbi_TTurnLeft: TTBXItem;
      tbsep_Tools_2: TTBXSeparatorItem;
      tbi_TScan: TTBXItem;
      tbi_TAnno: TTBXItem;
      tbsep_Tools_1: TTBXSeparatorItem;
      tbi_TLocSave: TTBXItem;
      tbi_TDocSave: TTBXItem;
      tbi_DSpAsk: TTBXItem;
      tbi_DSp4P: TTBXItem;
      tbi_DSp3P: TTBXItem;
      tbi_DSp2P: TTBXItem;
      tbi_DSp1P: TTBXItem;
      tbi_ZoomOff: TTBXItem;
      tbi_ZoomSelect: TTBXItem;
      tbi_ZoomHeight: TTBXItem;
      tbi_ZoomWidth: TTBXItem;
      tbi_ZoomPage: TTBXItem;
      tbi_Zoom100: TTBXItem;
      tlb_EditTools: TTBXToolbar;
      tbi_EAnDel: TTBXItem;
      tbi_EAnnoInfo: TTBXItem;
      tbi_ObjProp: TTBXItem;
      tbsep_Edit_1: TTBXSeparatorItem;
      tbi_EToBack: TTBXItem;
      tbi_EToFront: TTBXItem;
      tbi_EMeasureAng: TTBXItem;
      tbi_EMeasureLen: TTBXItem;
      tbi_EImage: TTBXItem;
      tbi_EPointer: TTBXItem;
      tbi_EBox: TTBXItem;
      tbi_EElipse: TTBXItem;
      tbi_EPoligon: TTBXItem;
      tbi_EPolyLine: TTBXItem;
      tbi_ELabel: TTBXItem;
      tbi_EStamp: TTBXItem;
      tbi_ENotes: TTBXItem;
      tbi_EHiLite: TTBXItem;
      tbi_ESelect: TTBXItem;
      tlb_Scan: TTBXToolbar;
      tlb_Nav: TTBXToolbar;
      tblbl_NPage: TTBXLabelItem;
      tbsep_Nav_2: TTBXSeparatorItem;
      tbi_NLast: TTBXItem;
      tbi_NNext: TTBXItem;
      tbi_NPrev: TTBXItem;
      tbi_NFirst: TTBXItem;
      tbsep_Nav_1: TTBXSeparatorItem;
      tbedt_NPage: TTBXEditItem;
      tbi_SPageApp: TTBXItem;
      tbi_SPageIns: TTBXItem;
      tbi_SPage: TTBXItem;
      tbsep_Scan_1: TTBXSeparatorItem;
      tbi_SScanner: TTBXItem;
      TBSeparatorItem1: TTBSeparatorItem;
      TBXItem1: TTBXItem;
      tbsi_topenLayer: TTBXItem;
      tbsi_tPrivatLayer: TTBXItem;
      tbx_UsrNote: TTBXItem;
      Button1: TButton;
      TBControlItem1: TTBControlItem;
      tbi_EText: TTBXItem;
      TBXToolbar1: TTBXToolbar;
      tbl_veraenderer: TTBXLabelItem;
      tbl_datum: TTBXLabelItem;
      tbl_ersteller: TTBXLabelItem;
      tbl_erstellercap: TTBXLabelItem;
      tbl_datumcap: TTBXLabelItem;
      tbl_veraenderercap: TTBXLabelItem;
      TBSeparatorItem2: TTBSeparatorItem;
      TBSeparatorItem3: TTBSeparatorItem;
      tbi_ENotesg: TTBXItem;
      tbi_ENotesr: TTBXItem;
      tim_bringtofront: TTimer;
      tbi_freihand: TTBXItem;
      tbsi_marker: TTBXSubmenuItem;
      tbi_marker5: TTBXItem;
      tbi_marker4: TTBXItem;
      tbi_marker3: TTBXItem;
      tbi_marker2: TTBXItem;
      tbi_marker1: TTBXItem;
      tbsi_notizen: TTBXSubmenuItem;
      tbi_notiz5: TTBXItem;
      tbi_notiz4: TTBXItem;
      tbi_notiz3: TTBXItem;
      tbi_notiz2: TTBXItem;
      tbi_notiz1: TTBXItem;
      tbsi_text: TTBXSubmenuItem;
      tbi_text5: TTBXItem;
      tbi_text4: TTBXItem;
      tbi_text3: TTBXItem;
      tbi_text2: TTBXItem;
      tbi_text1: TTBXItem;
      tbsi_stifte: TTBXSubmenuItem;
      tbi_stifte5: TTBXItem;
      tbi_stifte4: TTBXItem;
      tbi_stifte3: TTBXItem;
      tbi_stifte2: TTBXItem;
      tbi_stifte1: TTBXItem;
    tlb_FavStempel: TTBXToolbar;
    tbx_fav1: TTBXItem;
    tbx_fav2: TTBXItem;
    tbx_fav3: TTBXItem;
    tbx_fav4: TTBXItem;
    tbx_fav5: TTBXItem;
    pnl_DocEditor: TPanel;
    tbxtm_normalmouse: TTBXItem;
    lbl_usrAnno: TLabel;
    cbx_TZoom: TTBXComboBoxItem;
      procedure FormShow(Sender: TObject);
      procedure cbx_TZoomChange(Sender: TObject);
      procedure KeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure ShowAnnoData(annodata: PAnnoData);
      procedure FormResize(Sender: TObject);
      procedure edt_NPageKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure tbi_TDocSaveClick(Sender: TObject);
      procedure tbi_TLocSaveClick(Sender: TObject);
      procedure tbi_TAnnoClick(Sender: TObject);
      procedure tbi_TScanClick(Sender: TObject);
      procedure tbi_TTurnLeftClick(Sender: TObject);
      procedure tbi_TFlipClick(Sender: TObject);
      procedure tbi_TTurnRightClick(Sender: TObject);
      procedure tbi_TDeSkewClick(Sender: TObject);
      procedure tbi_TRemBorderClick(Sender: TObject);
      procedure tbsi_TDeSpeckleClick(Sender: TObject);
      procedure tbsi_TZoomClick(Sender: TObject);
      procedure tbi_DSp1PClick(Sender: TObject);
      procedure tbi_DSp2PClick(Sender: TObject);
      procedure tbi_DSp3PClick(Sender: TObject);
      procedure tbi_DSp4PClick(Sender: TObject);
      procedure tbi_DSpAskClick(Sender: TObject);
      procedure tbi_Zoom100Click(Sender: TObject);
      procedure tbi_ZoomPageClick(Sender: TObject);
      procedure tbi_ZoomWidthClick(Sender: TObject);
      procedure tbi_ZoomHeightClick(Sender: TObject);
      procedure tbi_ZoomSelectClick(Sender: TObject);
      procedure tbi_ESelectClick(Sender: TObject);
      procedure tbi_EHiLiteClick(Sender: TObject);
      procedure tbi_ENotesClick(Sender: TObject);
      procedure tbi_EStampClick(Sender: TObject);
      procedure tbi_ELabelClick(Sender: TObject);
      procedure tbi_EPolyLineClick(Sender: TObject);
      procedure tbi_EPoligonClick(Sender: TObject);
      procedure tbi_EElipseClick(Sender: TObject);
      procedure tbi_EBoxClick(Sender: TObject);
      procedure tbi_EPointerClick(Sender: TObject);
      procedure tbi_EImageClick(Sender: TObject);
      procedure tbi_EMeasureLenClick(Sender: TObject);
      procedure tbi_EMeasureAngClick(Sender: TObject);
      procedure tbi_EToFrontClick(Sender: TObject);
      procedure tbi_EToBackClick(Sender: TObject);
      procedure tbi_ObjPropClick(Sender: TObject);
      procedure tbi_EAnnoInfoClick(Sender: TObject);
      procedure tbi_EAnDelClick(Sender: TObject);
      procedure tbi_NFirstClick(Sender: TObject);
      procedure tbi_NPrevClick(Sender: TObject);
      procedure tbi_NNextClick(Sender: TObject);
      procedure tbi_NLastClick(Sender: TObject);
      procedure tbi_SaveDocClick(Sender: TObject);
      procedure tbi_SaveLocClick(Sender: TObject);
      procedure tbi_CloseEditClick(Sender: TObject);
      procedure tbi_VisSaveClick(Sender: TObject);
      procedure tbi_VisLoadClick(Sender: TObject);
      procedure tbi_VisDefaultClick(Sender: TObject);
      procedure tbi_SymNavClick(Sender: TObject);
      procedure tbi_SymToolsClick(Sender: TObject);
      procedure tbi_SymEditClick(Sender: TObject);
      procedure tbi_OptClick(Sender: TObject);
      procedure tbi_InfoClick(Sender: TObject);
      procedure tbsi_tPrivatLayerClick(Sender: TObject);
      procedure TBXItem1Click(Sender: TObject);
      procedure tbsi_topenLayerClick(Sender: TObject);
      procedure tbx_UsrNoteClick(Sender: TObject);
      procedure Button1Click(Sender: TObject);
      procedure tbi_ETextClick(Sender: TObject);
      procedure tbi_ENotesrClick(Sender: TObject);
      procedure tbi_ENotesgClick(Sender: TObject);
      procedure Specialkeys(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure tim_bringtofrontTimer(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure tbi_EPolyLineFreeClick(Sender: TObject);
      procedure tbi_marker1Click(Sender: TObject);
      procedure tbi_notiz1Click(Sender: TObject);
      procedure tbsi_textClick(Sender: TObject);
      procedure tbi_stifte1click(Sender: TObject);
      procedure tbi_text1Click(Sender: TObject);
      procedure tbsi_markerClick(Sender: TObject);
      procedure tbsi_notizenClick(Sender: TObject);
      procedure tbsi_stifteClick(Sender: TObject);
      procedure tbedt_NPageChange(Sender: TObject; const Text: String);
    procedure tbx_favClick(Sender: TObject);
    procedure tbxtm_normalmouseClick(Sender: TObject);
   private
      { Private-Deklarationen }
      fobjposition: array of Tpoint;
      fbshowingdoc: boolean;
      fbLoadDoc : Boolean;
   protected
      procedure CreateParams(var Params: TCreateParams); override;
   public
      { Public-Deklarationen }
      fra_DocEditor : Tfrm_Voransicht;
      fwassettofront: boolean;
      fiRights: integer;
      fbdocchanged: boolean;
      fbshowformtext: boolean;
      fstlobjchanged: TStringList;
      fstlobjtext: TStringList;
      fstlobjdel: TStringList;
      fstlobjcreated: TStringList;
      Doc_obj: TDOCOBJ;
      fKeyHandled : Boolean;
      procedure UncheckFav;
      procedure ShowOpt;
      procedure CalcZoom;
      procedure ShowPage;
      function InitEdit: boolean;
      function LoadDoc(Page: integer): boolean;
      function ChangePage(Mode: integer): boolean;
      procedure uncheckallgraphictools;
      procedure loadfavstampvalues(fktag: integer; favtext: string);
   end;

var
   frm_DocEdit: Tfrm_DocEdit;
   bGDelObj: boolean; // Zeigt an das ein Objekt gelscht wurde

implementation

{$R *.dfm}

uses u_dm_DocEditor, u_dm_DB, {} u_dm_ViewerMain, u_DeSpeckle,
   u_ObjectOpt, u_ObjInfo, u_DocEditOpt, u_ShStamps, u_Info, u_ShowLayer,
   u_UsRLayerRights, Vectors, Collision, hyieutils,
   u_MainForm, hyiedefs, u_askForSave;

procedure Tfrm_DocEdit.ShowOpt;
begin
   GgfLogEvnt('doc ShowOpt');
   Application.CreateForm(Tfrm_DocEditOpt, frm_DocEditOpt);
   frm_DocEditOpt.ShowModal;
   frm_DocEditOpt.Release;
end;

function Tfrm_DocEdit.InitEdit: boolean;
var
   reg: TRegistry;
begin
   GgfLogEvnt('doc InitEdit');
   reg := TRegistry.Create;
   Result := True;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('\Software\bitfarm\Archiv_V3\Viewer\FormData', True);
            if not KeyExists('DefEdit') then
            begin
               CreateKey('DefEdit');
               fms_DocEdit.IniFileName := '\Software\bitfarm\Archiv_V3\viewer\FormData';
               fms_DocEdit.IniSection := 'DefEdit';
               fms_DocEdit.SaveFormPlacement;
               fms_DocEdit.Active := True;
               fms_DocEdit.Active := False;
               fms_DocEdit.IniSection := 'DocEditor';

            end;
            CloseKey;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            if ValueExists('DE_RenderEng') then
               fra_DocEditor.img_DocView.ObjGraphicRender := ReadBool('DE_RenderEng')
            else
               fra_DocEditor.img_DocView.ObjGraphicRender := False;
            if ValueExists('DE_Antialias') then
               fra_DocEditor.img_DocView.ObjAntialias := ReadBool('DE_Antialias')
            else
               fra_DocEditor.img_DocView.ObjAntialias := False;

            if ValueExists('MouseRadDirection') then
            begin
               fra_DocEditor.img_DocView.MouseWheelParams.InvertDirection :=
                  ReadBool('MouseRadDirection');
            end;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('InitViewer', 'Fehler beim Erstellen der Standart Werte: ' +
               e.Message, 2028, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         reg.Free;
   end;
   tbi_TRemBorder.Tag := 0;
   tbi_VisLoadClick(self);
end;

procedure Tfrm_DocEdit.CalcZoom;
begin
   GgfLogEvnt('doc CalcZoom');
   cbx_TZoom.Text := FloatToStrF(fra_DocEditor.img_DocView.Zoom, ffFixed, 7, 2) + ' %';
end;

procedure Tfrm_DocEdit.ShowPage;
var
  sFileTyp: string;
begin
   GgfLogEvnt('frm_DocEdit ShowPage');

    sFileTyp:= StringReplace(ExtractFileExt(fra_DocEditor.img_DocView.IO.Params.FileName),'.','',[rfReplaceAll]);
    if sFileTyp = 'tif' then
    begin
      tbedt_NPage.Text := IntToStr(fra_DocEditor.img_DocView.IO.Params.TIFF_ImageIndex + 1);
		tblbl_NPage.Caption := '  ' + _('Seite')+' ' + tbedt_NPage.Text + ' / ' +
      	IntToStr(fra_DocEditor.img_DocView.IO.Params.TIFF_ImageCount);
    end
    else
    begin
      tbedt_NPage.Text := IntToStr(fra_DocEditor.img_DocView.IO.Params.ImageIndex + 1);
      tblbl_NPage.Caption := '  ' + _('Seite')+' ' + tbedt_NPage.Text + ' / ' +
									           IntToStr(fra_DocEditor.img_DocView.IO.Params.ImageCount);
    end;
end;

function Tfrm_DocEdit.ChangePage(Mode: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  02.06.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function wechelt die angezeigte Seite eines Doku-   ///
   ///  mentes.                                                   ///
   ///                                                            ///
   ///  Mode:  1:  Nchste Seite                                  ///
   ///         2:  Vorherige Seite                                ///
   ///         3:  Erste Seite                                    ///
   ///         4:  Letzte Seite                                   ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iPage: integer;
   lmmy: TModalresult;
begin
   GgfLogEvnt('doc ChangePage');
   Result := True;

   if fbdocchanged then
   begin
      application.createform(Tfrm_AskForSave, frm_AskForSave);
      frm_AskForSave.Label1.caption := _('Dokument wurde verndert.') + #13 +
         _('Mchten Sie die vorgenommenen nderungen speichern?');
      frm_AskForSave.showmodal;
      lmmy := frm_AskForSave.ModalResult;
      frm_AskForSave.Release;
      if lmmy = mrYes then
      begin
         tbi_TDocSaveClick(self);
      end;
      fbdocchanged := false;
   end;
   iPage := fra_DocEditor.img_DocView.IO.Params.TIFF_ImageIndex;
   fra_DocEditor.img_DocView.IO.Params.ImagingAnnot.CopyFromTImageEnVect(fra_DocEditor.img_DocView);
   case Mode of
      1:
         Inc(iPage);
      2:
         Dec(iPage);
      3:
         iPage := 0;
      4:
         iPage := (fra_DocEditor.img_DocView.IO.Params.TIFF_ImageCount - 1);
   end;
   if (iPage >= 0) and (iPage < fra_DocEditor.img_DocView.IO.Params.TIFF_ImageCount) then
      LoadDoc(iPage)
   else
      Result := False;
   ShowPage;
end;

procedure Tfrm_DocEdit.FormShow(Sender: TObject);
begin
   GgfLogEvnt('doc FormShow');
   fbshowingdoc := true;
   fbdocchanged := False;

   self.Caption := _('Dokumenteneditor')+ ' - ' + Doc_obj.disp_name;
   tbi_TDocSave.Enabled := False;
   // mouse dependent zoom position
   frm_DocEdit.fra_DocEditor.img_DocView.MouseWheelParams.ZoomPosition := iemwMouse;
   if not fra_DocEditor.CheckObjVals then
      frm_DocEdit.Close;
   InitEdit;

   fstlobjtext := TStringList.Create;
   LoadDoc(frm_Mainform.fra_Voransicht.img_DocView.IO.Params.TIFF_ImageIndex);

   CreZusPum(dm_DocEdit.pum_ImpZus, dm_DocEdit.pum_ImpZusClick, 'pum_ImpZus', False);
   fbshowingdoc := false;
   self.SetFocus;
   fstlobjchanged := TStringList.Create;
   fstlobjdel := TStringList.Create;
   fstlobjcreated := TStringList.Create;

   SetWindowPos(frm_DocEdit.Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
   SetWindowPos(frm_DocEdit.Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);

   u_HighUtils.LoadFavStampbuttons( tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5);
end;

//    Load Document und seine IEV
function Tfrm_DocEdit.LoadDoc(Page: integer): boolean;
var
   sIEVFile, sDocFile, sTmpFile, sTmpID, sTmpSQL: string;
   srcUID, licount: integer;
begin
	try
      fbLoadDoc := True;
      GgfLogEvnt('doc LoadDoc');
      Result := True;
      fra_DocEditor.img_DocView.IO.AutoAdjustDPI := True;
      SRCUID := 0;

      with fra_DocEditor.img_DocView do
      begin
         sTmpID := IntToStr(iGUsrID);
         sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = '
            + IntToStr(Doc_obj.arc_id) + ' and doc_id = ' + IntToStr(Doc_obj.doc_id) +
            ' and usr_id = ' + sTmpID + ' and src_usr_id = ' + IntToStr(SRCUID);

         if frm_MainForm.TmpSQL(sTmpSQL) then
         begin
            if dm_DB.my_q_Tmp.RecordCount = 0 then
            begin
               sTmpSQL :=
                  'select cast(rights as signed) as recht, grp_id from sys_arcxs where arc_id = ' +
                  IntToStr(Doc_obj.arc_id) + '  and usr_id = ' + sTmpID;

               if not frm_MainForm.TmpSQL(sTmpSQL) then
               begin
                  ErrorMsg('ReadObjRights',
                     _('Fehler beim Auslesen der Objekt-Berechtigungen'), 2019, True);
                  exit;
               end;
            end;
         end;

         if dm_DB.my_q_Tmp.RecordCount > 0 then
         begin
            fiRights := 0;
            dm_DB.my_q_Tmp.first;
            while not dm_DB.my_q_Tmp.eof do
            begin
               fiRights := fiRights or dm_DB.my_q_Tmp.FieldByName('recht').AsInteger;
               dm_DB.my_q_Tmp.next;
            end;
         end;
         //change it!
         try
            if ObjectsCount > 0 then
               RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;

            sDocFile := Doc_obj.doc_loc;
            sTmpFile := Doc_obj.ext_loc;
            if FileExists(sTmpFile) then
               sDocFile := sTmpFile;
            IO.Params.TIFF_ImageIndex := Page;
            IO.LoadFromFile(sDocFile);

            if (tbsi_tPrivatLayer.Checked or tbx_UsrNote.Checked) then
            begin
               sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(Page) +
                  'P' + IntToStr(iGUsrID) + '.IEV';
               sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);
               // aktiviere den Save Button und die Menueschaltflche SPEICHERN ( der Annotation modiifikationen)
               //        tbi_TDocSave.Enabled := True;
               tbi_SaveDoc.Enabled := True;
               if lbl_usrAnno.Caption <> '___' then
               begin
                  //  rights  lesen (16384) und nicht schreiben
                  if (((fiRights and 16384) = 16384) and not ((fiRights and 8192) = 8192)) then
                  begin
                     sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(Page) +
                        'P' + lbl_usrAnno.Caption + '.IEV';
                     //            tbi_TDocSave.Enabled := False;
                     tbi_SaveDoc.Enabled := False;
                  end;

                  //  rights  Write schreiben modifizieren
                  if (((fiRights and 8192) = 8192)) then
                  begin
                     sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(Page) +
                        'P' + lbl_usrAnno.Caption + '.IEV';
                     tbi_TDocSave.Enabled := True;
                     tbi_SaveDoc.Enabled := True;
                  end;
               end;
            end; // wo?
            if tbsi_topenLayer.Checked then
            begin
               sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(Page) + '.IEV';
            end;
            //else tbsi_sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(Page) + '.IEV';
            sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

            if IO.Params.ImagingAnnot.ObjectsCount > 0 then
               IO.Params.ImagingAnnot.CopyToTImageEnVect(fra_DocEditor.img_DocView);
            if FileExists(sIEVFile) then
            begin
               LoadFromFileIEV(sIEVFile);
               GgfLogEvnt('LoadFromFileIEV V1');
            end;
            bGDelObj := False;
            setlength(fobjposition, objectscount);
            for licount := 0 to objectscount - 1 do
            begin
               if (objkind[licount] = iekText) or (objkind[licount] = iekMEMO) then
               begin
                  fstlobjtext.Add(objtext[licount]);
               end
               else
               begin
                  fstlobjtext.Add('');
               end;

               fobjposition[licount].X := fra_DocEditor.img_DocView.ObjLeft[licount];
               fobjposition[licount].y := fra_DocEditor.img_DocView.ObjTop[licount];
            end;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_DocEdit.LoadDoc', 'Fehler beim Laden eines Dokumentes: ' +
                  e.Message, 2038, True);
            end;
         end;
      end;
      if fra_DocEditor.img_DocView.proc.CalcImageNumColors > 2 then
      begin
         tbsi_TDeSpeckle.Enabled := falsE;
      end
      else
      begin
         tbsi_TDeSpeckle.Enabled := true;
      end;

      if fra_DocEditor.img_DocView.proc.CalcImageNumColors > 2 then
      begin
         tbsi_TDeSpeckle.Enabled := falsE;
      end
      else
      begin
         tbsi_TDeSpeckle.Enabled := true;
      end;

      ShowPage;
      Self.BringToFront;
     Application.ProcessMessages;
   finally
  		fbLoadDoc := False;
   end;

end;

procedure Tfrm_DocEdit.Specialkeys(Sender: TObject; var Key: word; Shift: TShiftState);
begin
   OutputDebugString('Specialkeys');
   case Key of
   	VK_F7:
      begin
         fKeyHandled := True;
			tbxtm_normalmouseClick(Self);
      end;
      VK_F8:
      begin
         fKeyHandled := True;
         tbi_ESelectClick(Self);
      end;
   end;
end;



procedure Tfrm_DocEdit.cbx_TZoomChange(Sender: TObject);
var
   fpZoom: single;
   iPos: integer;
   sZoom: string;
begin
   GgfLogEvnt('doc cbx_TZoomChange');
   iPos := Pos('%', cbx_TZoom.Text);
   if iPos = -1 then
   begin
      cbx_TZoom.Text := cbx_TZoom.Text + ' %';
      iPos := Pos('%', cbx_TZoom.Text);
   end;

   if iPos < 2 then
      exit;

   sZoom := copy(cbx_TZoom.Text, 0, iPos - 2);
	sZoom := StringReplace(sZoom, ',', gFormatSettings.DecimalSeparator,[rfReplaceAll]);

   if TryStrToFloat(sZoom, fpZoom, gFormatSettings) then
   begin
      try
         fra_DocEditor.img_DocView.Zoom := fpZoom;
      except
         on e: Exception do
         begin
            logevnt('Fehler bei zoomen');
         end;
      end;
   end;
end;

procedure Tfrm_DocEdit.FormResize(Sender: TObject);
begin
   GgfLogEvnt('doc FormResize');
   tbsi_TZoomClick(self);
end;

procedure Tfrm_DocEdit.edt_NPageKeyUp(Sender: TObject; var Key: word;
   Shift: TShiftState);
var
   iPage: integer;
begin
   GgfLogEvnt('doc edt_NPageKeyUp');
   case key of
      vk_Return:
      begin
         if TryStrToInt(tbedt_NPage.Text, iPage) then
            if (iPage > 0) and (iPage <= fra_DocEditor.img_DocView.IO.Params.TIFF_ImageCount) then
               LoadDoc(iPage - 1);
         ShowPage;
      end;
   end;
end;

procedure Tfrm_DocEdit.FormClose(Sender: TObject; var Action: TCloseAction);
var lmmy: TModalresult;
   licounter: integer;
   lbfound: boolean;
begin
   GgfLogEvnt('doc FormClose');
   fra_DocEditor.img_DocView.UnSelAllObjects;
   fra_DocEditor.img_DocView.MouseInteractVt := [];
   stb_DocEdit.SimpleText := '';
   tbi_ESelect.Checked := False;
   tbi_VisSaveClick(self);
   if fbdocchanged or tbi_TDocSave.enabled then
   begin
      GgfLogEvnt('doc FormClose Tfrm_AskForSave');
      application.createform(Tfrm_AskForSave, frm_AskForSave);
      frm_AskForSave.Label1.caption := _('Dokument wurde verndert.') + #13 +
         _('Mchten Sie die vorgenommenen nderungen speichern?');
      frm_AskForSave.showmodal;
      lmmy := frm_AskForSave.ModalResult;
      frm_AskForSave.Release;
      if lmmy = mrYes then
      begin
         tbi_TDocSaveClick(self);
      end;
      fbdocchanged := False;
      tbi_TDocSave.Enabled := False;
   end
   else
   begin
     if fra_DocEditor.gbAnnoNotSaved then
         tbi_TDocSaveClick(self);
   end;

   if assigned(fstlobjchanged) then
      freeandnil(fstlobjchanged);
   if assigned(fstlobjdel) then
      freeandnil(fstlobjdel);
   if assigned(fstlobjcreated) then
      freeandnil(fstlobjcreated);
   if assigned(fstlobjtext) then
      freeandnil(fstlobjtext);

   GgfLogEvnt('frm_DocEdit FormClose');
   if frm_mainform.flastdoc_edit = self then
   begin
      frm_mainform.flastdoc_edit := nil;
   end;
   lbfound := false;
   for licounter := 0 to length(frm_mainform.farrayofdoceid) - 1 do
   begin
      if frm_mainform.farrayofdoceid[licounter] = self then
      begin
         lbfound := true;
         break;
      end;
   end;

   if lbfound then
   begin
      while licounter < length(frm_mainform.farrayofdoceid) - 1 do
      begin
         frm_mainform.farrayofdoceid[licounter] := frm_mainform.farrayofdoceid[licounter + 1];
         inc(licounter);
      end;
      setlength(frm_mainform.farrayofdoceid, length(frm_mainform.farrayofdoceid) - 1);
   end;
   self.release;
end;

// Vektor layer speichern
procedure Tfrm_DocEdit.tbi_TDocSaveClick(Sender: TObject);
var
   sIEVFile, sDocPath, sTmpPath, lstmp, lssql, lsslw: string;
   licount, liudl, licounter, liArcid: integer;
   mydata: PAnnoData;
   lbfound, lbvoransicht, lbextlocupdate: boolean;
   lmmy: TModalresult;
begin
   GgfLogEvnt('doc tbi_TDocSaveClick');
   if Doc_obj.rights.modify or Doc_obj.rights.Write then
   begin
      lbfound := false;
      lbextlocupdate := false;
      lmmy := mrYes;
      if (iGdocid = doc_obj.doc_id) and (iGarcid = doc_obj.arc_id) and
         (frm_mainform.btn_SaveDoc.enabled or frm_MainForm.fra_Voransicht.gbAnnoNotSaved or frm_MainForm.fra_Voransicht.bGDelObj)
      then
      begin
         lbfound := true;
      end;
      for licounter := 0 to length(frm_mainform.farrayofdoceid) - 1 do
      begin
         if (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).Doc_obj.doc_id = doc_obj.doc_id)
            and (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).Doc_obj.arc_id = doc_obj.arc_id)
            and (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]) <> self)
            and (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).tbi_TDocSave.enabled)
         then
         begin
            lbfound := true;
            break;
         end;
      end;
      if lbfound then
      begin
         application.createform(Tfrm_AskForSave, frm_AskForSave);
            frm_AskForSave.Label1.caption := _('Editor: Das Dokument ist auch im Viewer geffnet') + #13+
              _('und wurde dort auch gendert. Soll der Editor die Voransicht im Viewer berschreiben?');
         frm_AskForSave.showmodal;
         lmmy := frm_AskForSave.ModalResult;
         frm_AskForSave.Release;
      end;
      if lmmy <> mrYes then
      begin
      	frm_MainForm.fra_Voransicht.saveobjects(False,False);  // wenn der Editor nicht berschreiben soll,
         exit;                                                  // so soll wenigstens die Voransicht gespeichert werden.
      end;
      lbvoransicht := frm_mainform.btn_SaveDoc.enabled;
      if lbvoransicht then
      begin
         frm_mainform.tbi_VSaveDocClick(self);
         //wait till all is loaded before saing it
         if thr_voransicht <> nil then
         begin
            thr_voransicht.waitfor;
            FreeAndNil(thr_voransicht);
         end;
      end;
      fra_DocEditor.img_DocView.CancelInteracts;
      with fra_DocEditor.img_DocView do
      begin
         sDocPath := Doc_obj.doc_loc;
         sTmpPath := StringReplace(sDocPath, sGArcPath, sGCopyPath, []);
         if Doc_obj.ext_loc <> '' then
         begin
            sTmpPath := Doc_obj.ext_loc;
         end;

         if tbsi_tPrivatLayer.Checked then
         begin
            sIEVFile := ChangeFileExt(sTmpPath, '') +
               IntToStr(IO.Params.TIFF_ImageIndex) + 'P' + IntToStr(iGUsrID) + '.IEV';
         end
         else
            sIEVFile := ChangeFileExt(sTmpPath, '') + IntToStr(IO.Params.TIFF_ImageIndex) + '.IEV';
         sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

         try
            if not DirectoryExists(ExtractFilePath(sTmpPath)) then
               ForceDirectories(ExtractFilePath(sTmpPath));
            if ((ObjectsCount > 0) or bGDelObj) then
            begin
               for licount := 0 to fstlobjchanged.Count - 1 do
               begin
                  mydata := fra_DocEditor.img_DocView.ObjUserData[StrToInt(fstlobjchanged.strings[licount])];
                  liudl := fra_DocEditor.img_DocView.ObjUserDataLength[StrToInt(fstlobjchanged.strings[licount])];
                  if (liudl > 0) and (mydata <> nil) then
                  begin
                     if mydata^.Veraenderer <> '' then
                     begin
                        mydata^.Veraenderer := mydata^.Veraenderer + ',' + sGUsrName;
                     end
                     else
                     begin
                        mydata^.Veraenderer := sGUsrName;
                     end;
                     DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
                     mydata^.datum := lstmp;
                  end;
               end;
               for licount := 0 to fstlobjdel.Count - 1 do
               begin
                  frm_Mainform.NewHistory(23, 'Annotation mit dem folgenden Text gelscht:' +
                     fstlobjtext.strings[strtoint(fstlobjdel.strings[licount])] + ' auf Seite ' +
                     inttostr(fra_DocEditor.img_DocView.IO.Params.TIFF_ImageIndex + 1));
               end;
               for licount := 0 to fstlobjtext.count - 1 do
               begin
                  if (objkind[licount] = iekText) or (objkind[licount] = iekMEMO) then
                  begin
                     if (objtext[licount] <> fstlobjtext.strings[licount]) and
                        (fstlobjdel.IndexOf(inttostr(licount)) = -1) then
                     begin
                        if (fstlobjcreated.IndexOf(inttostr(licount)) = -1) then
                        begin
                           frm_Mainform.NewHistory(23, 'nderung an einer Annotation - alter Text:' +
                              fstlobjtext.strings[licount] + '; neuer Text:' + objtext[licount] +
                              ' ' + _('auf Seite') + ' ' + inttostr(fra_DocEditor.img_DocView.IO.Params.TIFF_ImageIndex + 1));
                        end
                        else
                        begin
                           frm_Mainform.NewHistory(23, _('Neue Annotation mit dem folgenden Text:') +
                              objtext[licount] + ' ' + _('auf Seite') + ' ' +
                              inttostr(fra_DocEditor.img_DocView.IO.Params.TIFF_ImageIndex + 1));
                        end;
                        // take it into slw
                        with dm_DB.my_cmd do
                        begin
                           lsslw := trim(ParseSemicolonUseBackslash(objtext[licount]));
                           SQL.Text := 'Insert into slw_' + doc_obj.sIArcName + ' (doc_id, doc_slw) Values (' +
                              IntToStr(Doc_obj.doc_id) + ', ' + #39 +
                              lsslw + #39 + ')';
                           lssql := SQL.Text;
                           try
                              Execute;
                           except
                              on e: Exception do
                              begin
                                 LogEvnt(IntToStr(2025) + '    ' + 'Fehler in Modul: ' + 'frm_DocEdit.tbi_TDocSaveClick' +
                                    '    ' + 'Fehler beim Hinzufgen eines Schlagwortes: ' +
                                    e.Message + ' . sqltext: ' + lssql + ' slw: ' +
                                    objtext[licount]);
                                 exit;
                              end;
                           end;

                           frm_Mainform.NewHistory(12, _('Neues Schlagwort') + ' [' +
                              lsslw + '] ' + _('hinzugefgt') + '.');
                           if True then
                           begin

                              dm_DB.my_q_tmp.SQL.Text := 'select arc_id,doc_id, arc_tblname from sys_gdocid left join sys_Arc ' +
                                 'using(arc_id) where gdoc_id = ' + inttostr(giglobalgdocid);

                              try
                                 dm_DB.my_q_tmp.Execute;
                              except on e: exception do
                                 begin
                                 end;
                              end;

                              SQL.Text := 'Insert into slw_' + dm_DB.my_q_tmp.FieldByName('arc_tblname').AsString +
                                 ' (doc_id, doc_slw) Values (' +
                                 IntToStr(dm_DB.my_q_tmp.FieldByName('doc_id').asinteger) + ', ' + #39 +
                                 lsslw + #39 + ')';
                              lssql := SQL.Text;
                              try
                                 Execute;
                              except
                                 on e: Exception do
                                 begin
                                    ErrorMsg('frm_voransicht.NewSlw', _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                                       e.Message + ' . sqltext: ' + lssql + ' slw: ' +
                                       lsslw, 2025, True);
                                    exit;
                                 end;
                              end;
                              NewHistoryID(12, _('Neues Schlagwort') + ' [' +
                                 lsslw + '] ' + _('hinzugefgt') + '.', Self.Doc_obj.arc_id,
                                 Self.Doc_obj.doc_id, iGUsrID);
                           end;
                        end;
                     end;
                  end;
               end;
               if fra_DocEditor.img_DocView.ObjectsCount = 0 then
               begin
                  killfile(sIEVFile);
               end
               else
               begin
                  SaveToFileIEV(sIEVFile);
               end;
            end;

            if fra_DocEditor.img_DocView.ObjectsCount = 0 then
            begin
               killfile(sIEVFile);
            end;
            if FileExists(sTmpPath) then
            begin
               IoSaveGraphic(IO,sTmpPath);
               if Doc_obj.ext_loc = '' then
               begin
                  dm_DB.my_cmd.SQL.Text :=
                     'Update arc_' + doc_obj.sIArcName + ' set ext_loc = :TmpPath ' +
                     'where doc_id = :DocID';
                  dm_DB.my_cmd.ParamByName('TmpPath').AsString := sTmpPath;
                  dm_DB.my_cmd.ParamByName('DocID').AsInteger := Doc_obj.doc_id;
                  dm_DB.my_cmd.Execute;
                  lbextlocupdate := true;
                  Doc_obj.ext_loc := sTmpPath;
               end;
            end
            else
            begin
               CopyFile(PChar(sDocPath), PChar(sTmpPath), False);

               IoSaveGraphic(IO,sTmpPath);

               dm_DB.my_cmd.SQL.Text :=
                  'Update arc_' + doc_obj.sIArcName + ' set ext_loc = :TmpPath ' +
                  'where doc_id = :DocID';
               dm_DB.my_cmd.ParamByName('TmpPath').AsString := sTmpPath;
               dm_DB.my_cmd.ParamByName('DocID').AsInteger := Doc_obj.doc_id;
               dm_DB.my_cmd.Execute;
               lbextlocupdate := true;
            end;
         except
            on e: Exception do
            begin
               LogEvnt('9000    Allgemeiner Anwendungsfehler:    ' + e.Message);
               stb_DocEdit.SimpleText :=
                  'Fehler beim Speichern der Dokumentennderung. Bitte Berechtigungen prfen.';
            end;
         end;
      end;
      if lbextlocupdate then
      begin
         dm_DB.my_q_tmp.SQL.Text := 'select arc_id,doc_id, arc_tblname from sys_gdocid left join sys_Arc ' +
            'using(arc_id) where gdoc_id = ' + inttostr(Doc_obj.gdocid);

         try
            dm_DB.my_q_tmp.Execute;
         except on e: exception do
            begin
            end;
         end;

         dm_DB.my_cmd.SQL.Text := 'Update arc_' + dm_DB.my_q_tmp.FieldByName('arc_tblname').AsString +
            ' set ext_loc = :TmpPath ' +
            'where doc_id = :DocID';
         dm_DB.my_cmd.ParamByName('TmpPath').AsString := sTmpPath;
         dm_DB.my_cmd.ParamByName('DocID').AsInteger := dm_DB.my_q_tmp.FieldByName('doc_id').asinteger;
         lssql := dm_DB.my_cmd.SQL.Text;
         try
            dm_DB.my_cmd.Execute;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_voransicht.saveobjects', _('Fehler beim update der ext_loc: ') +
                  e.Message + ' . sqltext: ' + lssql, 2025, True);
               exit;
            end;
         end;

      end;
      fbdocchanged := False;
      tbi_TDocSave.Enabled := False;
      frm_Mainform.NewHistory(9, _('nderung am Dokument gespeichert.'));
      dm_db.my_q_Arc.RefreshRecord;
      
      if (Self.Doc_obj.doc_id = iGDocID) and (Self.Doc_obj.arc_id = iGArcID)   // wird das selbe Dokument angezeigt im Viewer, so wird dieses berschrieben
      	and (fra_DocEditor.img_DocView.IO.Params.ImageIndex = frm_MainForm.fra_Voransicht.img_DocView.IO.Params.ImageIndex) then
      begin
      	frm_MainForm.fra_Voransicht.gbAnnoNotSaved := False;
         NewHistoryID(13, _('DocEditor berschreibt Voransicht'), Self.Doc_obj.arc_id,
                                 Self.Doc_obj.doc_id, iGUsrID);
      	frm_mainform.tmb_VoransichtImageSelect(nil, frm_mainform.fra_Voransicht.img_DocView.IO.Params.TIFF_ImageIndex);

      end;

      for licounter := 0 to length(frm_mainform.farrayofdoceid) - 1 do
      begin
         if (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).Doc_obj.doc_id = doc_obj.doc_id)
            and (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).Doc_obj.arc_id = doc_obj.arc_id)
            and (Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]) <> self) then
         begin
            Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).Doc_obj.ext_loc := sTmpPath;
            Tfrm_DocEdit(frm_mainform.farrayofdoceid[licounter]).ChangePage(0);
         end;
      end;
   end
   else
      BfShowMessage(_('Hinweis!') + #13 + _('Sie drfen dieses Dokument nicht speichern.'));
end;

procedure Tfrm_DocEdit.tbi_TLocSaveClick(Sender: TObject);
var
   sPathName, sDocFile, sTmpFile: string;
   Folder: TFolderBrowser;
begin
   GgfLogEvnt('doc tbi_TLocSaveClick');
   if Doc_obj.rights.Write then
   begin
      Folder := TFolderBrowser.Create(Application.Handle,
         _('Bitte Verzeichnis auswhlen'), '', False, True);
      try
         if Folder.Execute then
            sPathName := Folder.SelFolder
         else
            exit;
      finally
         if assigned(Folder) then
            FreeAndNil(Folder);
      end;
      sDocFile := Doc_obj.doc_loc;
      sTmpFile := Doc_obj.ext_loc;
      if FileExists(sTmpFile) then
         sDocFile := sTmpFile;
      if CopyFile(PChar(sDocFile), PChar(sPathName + '\' + ExtractFileName(sDocFile)),
         False) then
         frm_Mainform.NewHistory(15, _('Dokument wurde in lokalem Verzeichnis') + ' [' +
            sPathName + '] ' + _('gespeichert') + '.');
   end;
end;

procedure Tfrm_DocEdit.tbi_TAnnoClick(Sender: TObject);
begin
   GgfLogEvnt('doc tbi_TAnnoClick');
   if tlb_EditTools.Visible then
   begin
      tbi_TAnno.Checked := False;
      tlb_EditTools.Visible := False;
   end
   else
   begin
      tbi_TAnno.Checked := True;
      tlb_EditTools.Visible := True;
   end;
   tbsi_TZoomClick(self);
end;

procedure Tfrm_DocEdit.tbi_TScanClick(Sender: TObject);
begin
   GgfLogEvnt('doc tbi_TScanClick');
   if tlb_Scan.Visible then
   begin
      tbi_TScan.Checked := False;
      tlb_Scan.Visible := False;
   end
   else
   begin
      tbi_TScan.Checked := True;
      tlb_Scan.Visible := True;
   end;
   tbsi_TZoomClick(self);
end;

procedure Tfrm_DocEdit.tbi_TTurnLeftClick(Sender: TObject);
begin
   GgfLogEvnt('doc tbi_TTurnLeftClick');
   fra_DocEditor.img_DocView.Proc.Rotate(90, True);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_TFlipClick(Sender: TObject);
begin
   GgfLogEvnt('doc tbi_TFlipClick');
   fra_DocEditor.img_DocView.Proc.Rotate(180, True);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_TTurnRightClick(Sender: TObject);
begin
   GgfLogEvnt('doc tbi_TTurnRightClick');
   fra_DocEditor.img_DocView.Proc.Rotate(-90, True);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_TDeSkewClick(Sender: TObject);
begin
   GgfLogEvnt('doc tbi_TDeSkewClick');
   with fra_DocEditor.img_DocView.Proc do
      Rotate(SkewDetection(0, 45, 0.1, True), True, ierFast, -1);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_TRemBorderClick(Sender: TObject);
begin
   if tbi_TRemBorder.Tag <= 2 then
   begin
      fra_DocEditor.img_DocView.Proc.AutoCrop(10, CreateRGB(255, 255, 255));
      fra_DocEditor.img_DocView.Proc.AutoCrop(10, CreateRGB(0, 0, 0));
      tbsi_TZoomClick(self);
      tbi_TRemBorder.Tag := tbi_TRemBorder.Tag + 1;
   end;
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbsi_TDeSpeckleClick(Sender: TObject);
var
   iRemPixel: integer;
begin
   with fra_DocEditor.img_DocView.Proc do
   begin
      case tbsi_TDeSpeckle.ImageIndex of
         36:
            RemoveIsolatedPixels(0, 1);
         37:
            RemoveIsolatedPixels(0, 2);
         38:
            RemoveIsolatedPixels(0, 3);
         39:
            RemoveIsolatedPixels(0, 4);
      end;
      if tbsi_TDeSpeckle.ImageIndex = 35 then
      begin
         Application.CreateForm(Tfrm_DeSpeckle, frm_DeSpeckle);
         frm_DeSpeckle.ShowModal;
         iRemPixel := frm_DeSpeckle.Tag;
         frm_DeSpeckle.Release;
         case iRemPixel of
            0:
               RemoveIsolatedPixels(0, 1);
            1:
               RemoveIsolatedPixels(0, 2);
            2:
               RemoveIsolatedPixels(0, 3);
            3:
               RemoveIsolatedPixels(0, 4);
         end;
      end;
   end;
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbsi_TZoomClick(Sender: TObject);
begin
   case tbsi_TZoom.ImageIndex of
      21:
         tbi_ZoomWidthClick(self);
      22:
         tbi_ZoomPageClick(self);
      23:
         tbi_Zoom100Click(self);
      24:
         tbi_ZoomHeightClick(self);
      25:
         tbi_ZoomSelectClick(self);
   end;
   cbx_TZoom.Text := FloatToStrF(fra_DocEditor.img_DocView.Zoom, ffFixed, 15, 2) + ' %';

end;

procedure Tfrm_DocEdit.tbi_DSp1PClick(Sender: TObject);
begin
   tbsi_TDeSpeckle.ImageIndex := 36;
   tbsi_TDeSpeckleClick(self);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_DSp2PClick(Sender: TObject);
begin
   tbsi_TDeSpeckle.ImageIndex := 37;
   tbsi_TDeSpeckleClick(self);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_DSp3PClick(Sender: TObject);
begin
   tbsi_TDeSpeckle.ImageIndex := 38;
   tbsi_TDeSpeckleClick(self);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_DSp4PClick(Sender: TObject);
begin
   tbsi_TDeSpeckle.ImageIndex := 39;
   tbsi_TDeSpeckleClick(self);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_DSpAskClick(Sender: TObject);
begin
   tbsi_TDeSpeckle.ImageIndex := 35;
   tbsi_TDeSpeckleClick(self);
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_Zoom100Click(Sender: TObject);
begin
   with frm_DocEdit do
   begin
      tbsi_TZoom.ImageIndex := 23;
      fra_DocEditor.img_DocView.Zoom := 100;
   end;
end;

procedure Tfrm_DocEdit.tbi_ZoomPageClick(Sender: TObject);
begin
   with frm_DocEdit do
   begin
      tbsi_TZoom.ImageIndex := 22;
      fra_DocEditor.img_DocView.Fit;
   end;
end;

procedure Tfrm_DocEdit.tbi_ZoomWidthClick(Sender: TObject);
begin
   with frm_DocEdit do
   begin
      tbsi_TZoom.ImageIndex := 21;
      fra_DocEditor.img_DocView.FitToWidth;
   end;
end;

procedure Tfrm_DocEdit.tbi_ZoomHeightClick(Sender: TObject);
begin
   with frm_DocEdit do
   begin
      tbsi_TZoom.ImageIndex := 24;
      fra_DocEditor.img_DocView.FitToHeight;
   end;
end;

procedure Tfrm_DocEdit.tbi_ZoomSelectClick(Sender: TObject);
begin
   with frm_DocEdit do
   begin
      tbsi_TZoom.ImageIndex := 25;
      fra_DocEditor.img_DocView.MouseInteract := [miSelectZoom];
   end;
end;

procedure Tfrm_DocEdit.tbi_EHiLiteClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   fra_DocEditor.ReadObjVals(11, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutBox];
   tbi_EStamp.Checked := False;
   tbi_ELabel.Checked := False;
   tbi_EPolyLine.Checked := False;
   tbi_EPoligon.Checked := False;
   tbi_EElipse.Checked := False;
   tbi_EBox.Checked := False;
   tbi_EPointer.Checked := False;
   tbi_EImage.Checked := False;
   tbi_EMeasureLen.Checked := False;
   tbi_EMeasureAng.Checked := False;
   tbi_ESelect.Checked := False;
   tbi_ENotes.Checked := False;
   tbi_ENotesg.Checked := False;
   tbi_ENotesr.Checked := False;
   tbi_EText.Checked := False;
   tbi_freihand.checked := false;

   tbi_EHiLite.Checked := True;
   UncheckFav;
end;

procedure Tfrm_DocEdit.tbi_ENotesClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   fra_DocEditor.ReadObjVals(9, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutMemo];
   uncheckallgraphictools;
   tbi_ENotes.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EStampClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;

   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   tbi_EStamp.checked := true;

   CreateTfrm_Stamps(Self, fra_DocEditor);
end;

procedure Tfrm_DocEdit.tbi_ELabelClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   tbi_ELabel.Checked := True;
   fra_DocEditor.ReadObjVals(10, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutLineLabel];
end;

procedure Tfrm_DocEdit.tbi_EPolyLineClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   tbi_EPolyLine.Checked := True;
   fra_DocEditor.ReadObjVals(7, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutPolyLine];
end;

procedure Tfrm_DocEdit.tbi_EPoligonClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage('Sie drfen keine Annotationen an dieses Dokument anbringen.');
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.ReadObjVals(12, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutPolyLine];
   tbi_EPoligon.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EElipseClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.ReadObjVals(2, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutEllipse];

   tbi_EElipse.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EBoxClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.ReadObjVals(1, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutBox];

   tbi_EBox.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EPointerClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.ReadObjVals(14, -1);

   fra_DocEditor.img_DocView.MouseInteractVt := [miPutLine];
   tbi_EPointer.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EImageClick(Sender: TObject);
var
   bmpTmp: TImageEnView;
   sFileName: string;
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   bmpTmp := TImageEnView.Create(nil);
   try
      try
         if PromptForFileName(sFileName) then
         begin
            if not FileExists(sFileName) then
               exit;
            bmpTmp.IO.LoadFromFile(sFileName);
            with fra_DocEditor.img_DocView do
            begin
               ObjKind[-1] := iekBITMAP;
               //dopnt use assing, it will override, so it will creat a new instance
               //override bitmap but not the points of created objects.
               ObjBitmap[-1] := bmpTmp.IEBitmap;
               ObjWidth[-1] := ObjBitmap[-1].Width;
               ObjHeight[-1] := ObjBitmap[-1].Height;
               ObjBitmapBorder[-1] := False;
               bmpTMP.IO.Params.GIF_FlagTranspColor := True;
               bmpTMP.IO.Params.GIF_TranspColor := CreateRGB(255, 255, 255);
               MouseInteractVT := [miPutBitmap];
            end;
         end
         else
            exit;
      except
         on e: Exception do
            ErrorMsg('frm_DocEdit.tbtn_EImage', _('Fehler beim Einfgen eines Bildes:') +
               e.Message, 2040, True);
      end;
   finally
      if Assigned(bmpTmp) then
         FreeAndNil(bmpTmp);
   end;
end;

procedure Tfrm_DocEdit.tbi_EMeasureLenClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;

   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.ReadObjVals(6, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutRuler];

   tbi_EMeasureLen.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EMeasureAngClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.ReadObjVals(8, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutAngle];

   tbi_EMeasureAng.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_EToFrontClick(Sender: TObject);
var
   iCount, idx: integer;
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   for iCount := 0 to (fra_DocEditor.img_DocView.SelObjectsCount - 1) do
   begin
      idx := fra_DocEditor.img_DocView.SelObjects[iCount];
      fra_DocEditor.img_DocView.SetObjFrontOf(idx, -1);
   end;
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_EToBackClick(Sender: TObject);
var
   iCOunt, idx: integer;
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   for iCount := 0 to (fra_DocEditor.img_DocView.SelObjectsCount - 1) do
   begin
      idx := fra_DocEditor.img_DocView.SelObjects[iCount];
      fra_DocEditor.img_DocView.SetObjBackTo(idx, -1);
   end;
   tbi_TDocSave.Enabled := True;
   fbdocchanged := true;
end;

procedure Tfrm_DocEdit.tbi_ObjPropClick(Sender: TObject);
begin
   if fra_DocEditor.img_DocView.SelObjectsCount = 0 then
      exit;
   Application.CreateForm(Tfrm_ObjectOpt, frm_ObjectOpt);
   frm_ObjectOpt.fdoceditparent := self;
   frm_ObjectOpt.ShowModal;
   frm_ObjectOpt.Release;

end;

procedure Tfrm_DocEdit.tbi_EAnnoInfoClick(Sender: TObject);
begin
   if (fra_DocEditor.img_DocView.SelObjectsCount > 0) then
   begin
      Application.CreateForm(Tfrm_AnnoInfo, frm_AnnoInfo);
      frm_AnnoInfo.ShowModal;
      frm_AnnoInfo.Release;
   end;
end;

procedure Tfrm_DocEdit.tbi_EAnDelClick(Sender: TObject);
var
   idx, licount: integer;
begin
	fra_DocEditor.AnnoDelete(self);
end;

procedure Tfrm_DocEdit.tbi_NFirstClick(Sender: TObject);
begin
   ChangePage(3);
end;

procedure Tfrm_DocEdit.tbi_NPrevClick(Sender: TObject);
begin
   ChangePage(2);
end;

procedure Tfrm_DocEdit.tbi_NNextClick(Sender: TObject);
begin
   ChangePage(1);
end;

procedure Tfrm_DocEdit.tbi_NLastClick(Sender: TObject);
begin
   ChangePage(4);
end;

procedure Tfrm_DocEdit.tbi_SaveDocClick(Sender: TObject);
begin
   tbi_TDocSaveClick(self);
end;

procedure Tfrm_DocEdit.tbi_SaveLocClick(Sender: TObject);
begin
   tbi_TLocSaveClick(self);
end;

procedure Tfrm_DocEdit.tbi_CloseEditClick(Sender: TObject);
begin
   frm_DocEdit.Close;
end;

procedure Tfrm_DocEdit.tbi_VisSaveClick(Sender: TObject);
begin
   GgfLogEvnt('doc FormClose');
   fms_DocEdit.SaveFormPlacement;
   fms_DocEdit.Active := True;
   fms_DocEdit.Active := False;
end;

procedure Tfrm_DocEdit.tbi_VisLoadClick(Sender: TObject);
begin
   fms_DocEdit.Active := False;
   fms_DocEdit.RestoreFormPlacement;
   fms_DocEdit.Active := True;
   fms_DocEdit.Active := False;
end;

procedure Tfrm_DocEdit.tbi_VisDefaultClick(Sender: TObject);
begin
   fms_DocEdit.IniSection := 'DefEdit';
   fms_DocEdit.Active := False;
   fms_DocEdit.RestoreFormPlacement;
   fms_DocEdit.Active := True;
   fms_DocEdit.Active := False;
   fms_DocEdit.IniSection := 'DocEditor';
end;

procedure Tfrm_DocEdit.tbi_SymNavClick(Sender: TObject);
begin
   tlb_Nav.Visible := tbi_SymNav.Checked;
end;

procedure Tfrm_DocEdit.tbi_SymToolsClick(Sender: TObject);
begin
   tlb_Tools.Visible := tbi_SymTools.Checked;
end;

procedure Tfrm_DocEdit.tbi_SymEditClick(Sender: TObject);
begin
   tlb_EditTools.Visible := tbi_SymEdit.Checked;
   tbi_TAnno.Checked := tbi_SymEdit.Checked;
end;

procedure Tfrm_DocEdit.tbi_OptClick(Sender: TObject);
begin
   ShowOpt;
end;

procedure Tfrm_DocEdit.tbi_InfoClick(Sender: TObject);
begin
   with Tfrm_Info.Create(Self) do
   begin
      ShowModal;
      Free;
   end;
end;

procedure Tfrm_DocEdit.tbsi_tPrivatLayerClick(Sender: TObject);
var lmmy: TModalresult;
begin
   if fbdocchanged then
   begin
      application.createform(Tfrm_AskForSave, frm_AskForSave);
      frm_AskForSave.Label1.caption := _('Dokument wurde verndert.') + #13 +
         _('Mchten Sie die vorgenommenen nderungen speichern?');
      frm_AskForSave.showmodal;
      lmmy := frm_AskForSave.ModalResult;
      frm_AskForSave.Release;
      if lmmy = mrYes then
      begin
         tbsi_tPrivatLayer.Checked := False; // private Layer ausschalten
         tbi_TDocSaveClick(self);
         tbsi_tPrivatLayer.Checked := true; // private Layer einschalten
      end;
      fbdocchanged := False;
      tbi_TDocSave.Enabled := False;
   end;
   tbsi_topenLayer.Checked := False; // public Layer ausschalten
   ChangePage(0);
end;

procedure Tfrm_DocEdit.TBXItem1Click(Sender: TObject);
begin
   frm_ShowLayer.showmodal;
   ChangePage(0);
end;

procedure Tfrm_DocEdit.tbsi_topenLayerClick(Sender: TObject);
var lmmy: TModalresult;
begin
   if fbdocchanged then
   begin
      application.createform(Tfrm_AskForSave, frm_AskForSave);
      frm_AskForSave.Label1.caption := _('Dokument wurde verndert.') + #13 +
         _('Mchten Sie die vorgenommenen nderungen speichern?');
      frm_AskForSave.showmodal;
      lmmy := frm_AskForSave.ModalResult;
      frm_AskForSave.Release;
      if lmmy = mrYes then
      begin
         tbsi_topenLayer.Checked := False; // public Layer ausschalten
         tbi_TDocSaveClick(self);
         tbsi_topenLayer.Checked := true; // public Layer einschalten
      end;
      fbdocchanged := False;
      tbi_TDocSave.Enabled := False;
   end;
   tbsi_tPrivatLayer.Checked := False; // privat Layer ausschalten
   ChangePage(0);
end;

procedure Tfrm_DocEdit.tbx_UsrNoteClick(Sender: TObject);
var lmmy: TModalresult;
begin
   tbsi_tPrivatLayer.Checked := True;  // privat Layer einschalten
   tbsi_tOpenLayer.Checked := False; // puplic Layer ausschalten

   if fbdocchanged then
   begin
      application.createform(Tfrm_AskForSave, frm_AskForSave);
      frm_AskForSave.Label1.caption := _('Dokument wurde verndert.') + #13 +
         _('Mchten Sie die vorgenommenen nderungen speichern?');
      frm_AskForSave.showmodal;
      lmmy := frm_AskForSave.ModalResult;
      frm_AskForSave.Release;
      if lmmy = mrYes then
      begin
         tbi_TDocSaveClick(self);
      end;
      fbdocchanged := False;
      tbi_TDocSave.Enabled := False;
   end;
   frm_ShowLayer.showmodal;
   ChangePage(0);
end;

procedure Tfrm_DocEdit.Button1Click(Sender: TObject);
begin
   // must update table so target and src user are abvailable
   frm_UsrLayerRights.Doc_obj := self.Doc_obj;
   frm_UsrLayerRights.showmodal;
end;

procedure Tfrm_DocEdit.tbi_ETextClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   fra_DocEditor.ReadObjVals(15, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutmemo];
   uncheckallgraphictools;

   tbi_EText.Checked := True;
end;

procedure Tfrm_DocEdit.tbi_ENotesrClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   fra_DocEditor.ReadObjVals(9, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutMemo];
   uncheckallgraphictools;

   tbi_ENotesr.Checked := True;
   fra_DocEditor.img_DocView.ObjBrushColor[-1] := clred;
end;

procedure Tfrm_DocEdit.tbi_ENotesgClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   fra_DocEditor.ReadObjVals(9, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutMemo];
   uncheckallgraphictools;

   tbi_ENotesg.Checked := True;
   fra_DocEditor.img_DocView.ObjBrushColor[-1] := cllime;
end;


procedure Tfrm_DocEdit.KeyUp(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('doc img_DocEditKeyUp Begin Key(word): ' + IntToStr(Key));
   OutputDebugString('KeyUp');
   if fKeyHandled then
   begin
      fKeyHandled := False;
      Abort;
   end;
   case key of
      vk_delete:
         fra_DocEditor.AnnoDelete(self);

      vk_up, vk_prior:
      	tbi_NPrevClick(Sender);

      vk_down, vk_next:
      	tbi_NNextClick(Sender);

      vk_home:
      	tbi_NFirstClick(Sender);

      vk_end:
      	tbi_NLastClick(Sender);

      VK_F7:
      begin
			tbxtm_normalmouseClick(Self);
      end;
      VK_F8:
      begin
           tbi_ESelectClick(Self);
      end;
      VK_TAB:
      	if (Shift = [ssShift]) then
            Self.fra_DocEditor.SelectPrevAnno
         else
	      	Self.fra_DocEditor.SelectNextAnno;
      vk_return:
      	fra_DocEditor.EditSelectedAnno;
   end;
   if ssCtrl in Shift then
   begin
      case Key of
         $41, $61:
         begin
            Self.fra_DocEditor.img_DocView.SelAllObjects;
         end;
         Ord('S'):
            tbi_TDocSaveClick(self);
      end;
   end;
   GgfLogEvnt('doc img_DocEditKeyUp End');
end;


procedure Tfrm_DocEdit.CreateParams(var Params: TCreateParams);
begin
   inherited;
   Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
end;


procedure Tfrm_DocEdit.tim_bringtofrontTimer(Sender: TObject);
begin
   //     bringtofront;
   if fbshowingdoc then
      exit;
   fra_DocEditor.img_DocView.SetFocus;
   tim_bringtofront.enabled := false;
end;

procedure Tfrm_DocEdit.FormActivate(Sender: TObject);
begin
   bringtofront;
   gbdoceditformshowed := true;
end;

procedure Tfrm_DocEdit.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
   fwassettofront := false;
   fbshowingdoc := false;
      // wir erzeugen die Ansicht aus u_ShVoransicht, dann sind wenigsten die ganzen Funktionen (OnEvents) die gleichen
   fra_DocEditor := Tfrm_Voransicht.Create(pnl_DocEditor);
   fra_DocEditor.Visible := True;
   fra_DocEditor.Parent  := pnl_DocEditor;
   fra_DocEditor.Align := alClient;
   fra_DocEditor.fParentHandle := frm_DocEdit.Handle;
   fra_DocEditor.img_DocView.ObjBoxInnerSelectable := True;
   fra_DocEditor.img_DocView.MaxSelectionDistance := 30;
   fra_DocEditor.img_DocView.MaxMovingDistance := 30;
   fra_DocEditor.img_DocView.AllowOutOfBitmapMoving  := False;
   fra_DocEditor.img_DocView.AllowOutOfBitmapPolylines := False;
   fra_DocEditor.img_DocView.PopupMenu := dm_DocEdit.pum_Tools;
   fra_DocEditor.img_DocView.OnKeyUp := KeyUp;
   fra_DocEditor.img_DocView.Visible := True;
   fra_DocEditor.fNoteslwrecord := gbNoteslwrecord;
   fra_DocEditor.fNotevtxrecord := gbNotevtxrecord;
   fra_DocEditor.fSaveBtN := frm_DocEdit.tbi_TDocSave;
   fra_DocEditor.fPubAnnoBTN := frm_DocEdit.tbsi_topenLayer;
   fra_DocEditor.fPrivAnnoBTN := frm_DocEdit.tbsi_tPrivatLayer;
   fra_DocEditor.fCbx_Zoom := frm_DocEdit.cbx_TZoom;
   fra_DocEditor.fOnObjectOver := ShowAnnoData;
   fra_DocEditor.img_DocView.OnTextKeyDown := SpecialKeys;
   fra_DocEditor.fUserID:= iGUsrId;
   fra_DocEditor.fUserName := sGUsrName;
   fra_DocEditor.fArcPath := sGArcPath;
   fra_DocEditor.fCopyPath := sGCopyPath;

   dm_DocEdit.bh_DocEditor_Main.UseBalloonAsApplicationHint := False;
end;

procedure Tfrm_DocEdit.ShowAnnoData(annodata: PAnnoData);
var
   lipos1: integer;
   lsv, lsTmp: string;
begin
   //OutputDebugString('ShowAnnoData');
   try
      if annodata <> nil then
      begin
         if annodata = Pointer($FFFFFFFF) then
            exit;

         lsv := annodata.version;
         if ((lsv[1] <> '0') or (lsv[3] <> '1')) then
            exit;

         tbl_ersteller.Caption := annodata.Ersteller;
         tbl_datum.Caption := annodata.Datum;

         if annodata.Veraenderer <> '' then
         begin
            if 0 = Pos(',', ReverseString(annodata.Veraenderer)) then
            begin
               lipos1 := 0;
            end
            else
            begin
               lipos1 := length(annodata.Veraenderer) - Pos(',',
                  ReverseString(annodata.Veraenderer)) + 2;
            end;
				tbl_veraenderer.Caption := copy(annodata.Veraenderer, lipos1, length(annodata.Veraenderer));
         end;
      end
      else
      begin
         tbl_ersteller.Caption := '';
         tbl_datum.Caption := '';
         tbl_veraenderer.Caption := '';
      end;
   except
      on e: Exception do
      begin
      end;
   end;
end;



procedure Tfrm_DocEdit.tbi_EPolyLineFreeClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage('Sie drfen keine Annotationen an dieses Dokument anbringen.');
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   fra_DocEditor.img_DocView.BitmapResampleFilter := rfNone;
   fra_DocEditor.ReadObjVals(16, -1);
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutPolyLine];
   tbi_ESelect.Checked := False;
   tbi_EHiLite.Checked := False;
   tbi_ENotes.Checked := False;
   tbi_ENotesg.Checked := False;
   tbi_ENotesr.Checked := False;
   tbi_EStamp.Checked := False;
   tbi_ELabel.Checked := False;
   tbi_EPoligon.Checked := False;
   tbi_EElipse.Checked := False;
   tbi_EBox.Checked := False;
   tbi_EPointer.Checked := False;
   tbi_EImage.Checked := False;
   tbi_EMeasureLen.Checked := False;
   tbi_EMeasureAng.Checked := False;
   tbi_EText.Checked := False;
   tbi_EPolyLine.Checked := False;
   tbsi_marker.Checked := false;
   tbsi_notizen.checked := false;
   tbsi_text.checked := false;
   tbsi_stifte.checked := false;

   tbi_freihand.checked := true;
   
   UncheckFav;
end;

procedure Tfrm_DocEdit.tbi_marker1Click(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;

   tbsi_marker.checked := true;
   case Tcomponent(sender).Tag of
      0:
      begin
         fra_DocEditor.ReadObjVals(11, -1);
         tbsi_marker.ImageIndex := 7;
      end;
      1:
      begin
         fra_DocEditor.ReadObjVals(29, -1);
         tbsi_marker.ImageIndex := 28;
      end;
      2:
      begin
         fra_DocEditor.ReadObjVals(30, -1);
         tbsi_marker.ImageIndex := 30;
      end;
      3:
      begin
         fra_DocEditor.ReadObjVals(31, -1);
         tbsi_marker.ImageIndex := 27;
      end;
      4:
      begin
         fra_DocEditor.ReadObjVals(32, -1);
         tbsi_marker.ImageIndex := 29;
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(11, -1);
      tbsi_marker.ImageIndex := 7;
   end;
   end;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutBox];
end;

procedure Tfrm_DocEdit.tbi_notiz1Click(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   //
   uncheckallgraphictools;

   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   tbsi_notizen.checked := true;

   case Tcomponent(sender).Tag of
      0:
      begin
         fra_DocEditor.ReadObjVals(9, -1);
         tbsi_notizen.ImageIndex := 5;
      end;
      1:
      begin
         fra_DocEditor.ReadObjVals(25, -1);
         tbsi_notizen.ImageIndex := 10;
      end;
      2:
      begin
         fra_DocEditor.ReadObjVals(26, -1);
         tbsi_notizen.ImageIndex := 11;
      end;
      3:
      begin
         fra_DocEditor.ReadObjVals(27, -1);
         tbsi_notizen.ImageIndex := 9;
      end;
      4:
      begin
         fra_DocEditor.ReadObjVals(28, -1);
         tbsi_notizen.ImageIndex := 20;
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(9, -1);
      tbsi_notizen.ImageIndex := 5;
   end;
   end;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutmemo];
end;

procedure Tfrm_DocEdit.tbsi_textClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   //
   uncheckallgraphictools;
   tbsi_text.Checked := true;
   case tbsi_text.ImageIndex of
      15:
      begin
         fra_DocEditor.ReadObjVals(15, -1);
      end;
      16:
      begin
         fra_DocEditor.ReadObjVals(21, -1);
      end;
      22:
      begin
         fra_DocEditor.ReadObjVals(22, -1);
      end;
      23:
      begin
         fra_DocEditor.ReadObjVals(23, -1);
      end;
      5:
      begin
         fra_DocEditor.ReadObjVals(24, -1);
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(15, -1);
   end;
   end;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutmemo];
end;

procedure Tfrm_DocEdit.tbi_stifte1click(Sender: TObject);
begin
   //

   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   tbsi_stifte.checked := true;
   case Tcomponent(sender).Tag of
      0:
      begin
         fra_DocEditor.ReadObjVals(16, -1);
         tbsi_stifte.ImageIndex := 13;
      end;
      1:
      begin
         fra_DocEditor.ReadObjVals(17, -1);
         tbsi_stifte.ImageIndex := 19;
      end;
      2:
      begin
         fra_DocEditor.ReadObjVals(18, -1);
         tbsi_stifte.ImageIndex := 17;
      end;
      3:
      begin
         fra_DocEditor.ReadObjVals(19, -1);
         tbsi_stifte.ImageIndex := 18;
      end;
      4:
      begin
         fra_DocEditor.ReadObjVals(20, -1);
         tbsi_stifte.ImageIndex := 21;
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(16, -1);
      tbsi_stifte.ImageIndex := 13;
   end;
   end;
   fra_DocEditor.img_DocView.BitmapResampleFilter := rfNone;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutPolyLine];
end;

procedure Tfrm_DocEdit.uncheckallgraphictools;
begin
   tbi_EHiLite.Checked := False;
   tbi_ENotes.Checked := False;
   tbi_EStamp.Checked := False;
   tbi_ELabel.Checked := False;
   tbi_EPolyLine.Checked := False;
   tbi_EPoligon.Checked := False;
   tbi_EElipse.Checked := False;
   tbi_EBox.Checked := False;
   tbi_EPointer.Checked := False;
   tbi_EImage.Checked := False;
   tbi_EMeasureLen.Checked := False;
   tbi_EMeasureAng.Checked := False;
   tbi_ESelect.Checked := False;
   tbi_ENotes.Checked := False;
   tbi_ENotesg.Checked := False;
   tbi_ENotesr.Checked := False;
   tbi_freihand.checked := false;

   tbi_EText.Checked := false;
   tbsi_notizen.Checked := false;
   tbsi_marker.Checked := false;
   tbsi_text.Checked := false;
   tbsi_stifte.Checked := false;
   tbi_ESelect.Checked := false;
   tbxtm_normalmouse.Checked := false;

   UncheckFav;
end;

procedure Tfrm_DocEdit.UncheckFav;
begin
   tbx_fav1.Checked := false;
   tbx_fav2.Checked := false;
   tbx_fav3.Checked := false;
   tbx_fav4.Checked := false;
   tbx_fav5.Checked := false;
end;

procedure Tfrm_DocEdit.tbi_text1Click(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   if not (tbsi_topenLayer.Checked or tbsi_tPrivatLayer.Checked) then
   begin
      exit;
   end;
   tbsi_text.Checked := true;
   case Tcomponent(sender).Tag of
      0:
      begin
         fra_DocEditor.ReadObjVals(15, -1);
         tbsi_text.ImageIndex := 15;
      end;
      1:
      begin
         fra_DocEditor.ReadObjVals(21, -1);
         tbsi_text.ImageIndex := 16;
      end;
      2:
      begin
         fra_DocEditor.ReadObjVals(22, -1);
         tbsi_text.ImageIndex := 22;
      end;
      3:
      begin
         fra_DocEditor.ReadObjVals(23, -1);
         tbsi_text.ImageIndex := 23;
      end;
      4:
      begin
         fra_DocEditor.ReadObjVals(24, -1);
         tbsi_text.ImageIndex := 24;
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(15, -1);
      tbsi_text.ImageIndex := 5;
   end;
   end;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutmemo];
end;

procedure Tfrm_DocEdit.tbsi_markerClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   tbsi_marker.checked := true;

   case tbsi_marker.ImageIndex of
      7:
      begin
         fra_DocEditor.ReadObjVals(11, -1);
      end;
      28:
      begin
         fra_DocEditor.ReadObjVals(29, -1);
      end;
      30:
      begin
         fra_DocEditor.ReadObjVals(30, -1);
      end;
      27:
      begin
         fra_DocEditor.ReadObjVals(31, -1);
      end;
      29:
      begin
         fra_DocEditor.ReadObjVals(32, -1);
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(11, -1);
   end;
   end;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutBox];
end;

procedure Tfrm_DocEdit.tbsi_notizenClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   //
   uncheckallgraphictools;
   tbsi_notizen.checked := true;

   case tbsi_notizen.imageindex of
      5:
      begin
         fra_DocEditor.ReadObjVals(9, -1);
      end;
      10:
      begin
         fra_DocEditor.ReadObjVals(25, -1);
      end;
      11:
      begin
         fra_DocEditor.ReadObjVals(26, -1);
      end;
      9:
      begin
         fra_DocEditor.ReadObjVals(27, -1);
      end;
      20:
      begin
         fra_DocEditor.ReadObjVals(28, -1);
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(9, -1);
   end;
   end;

   fra_DocEditor.img_DocView.MouseInteractVt := [miPutmemo];
end;

procedure Tfrm_DocEdit.tbsi_stifteClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   uncheckallgraphictools;
   tbsi_stifte.Checked := true;
   case tbsi_stifte.ImageIndex of
      13:
      begin
         fra_DocEditor.ReadObjVals(16, -1);
      end;
      19:
      begin
         fra_DocEditor.ReadObjVals(17, -1);
      end;
      17:
      begin
         fra_DocEditor.ReadObjVals(18, -1);
      end;
      18:
      begin
         fra_DocEditor.ReadObjVals(19, -1);
      end;
      21:
      begin
         fra_DocEditor.ReadObjVals(20, -1);
      end;
   else
   begin
      fra_DocEditor.ReadObjVals(16, -1);
   end;
   end;
   fra_DocEditor.img_DocView.BitmapResampleFilter := rfNone;
   fra_DocEditor.img_DocView.MouseInteractVt := [miPutPolyLine];
end;

procedure Tfrm_DocEdit.tbedt_NPageChange(Sender: TObject;
   const Text: String);
var iPage: integer;
   lmmy: TModalresult;
begin
	if fbLoadDoc then
  		Exit;

   try
      iPage := strtoint(Text) - 1;
   except on e: Exception do
      begin
         exit;
      end;
   end;
   with frm_DocEdit.fra_DocEditor.img_DocView do
   begin
      if iPage < 0 then
      begin
         iPage := IO.Params.Tiff_ImageCount - 1;
      end;
      if iPage > (IO.Params.Tiff_ImageCount - 1) then
      begin
         iPage := 0;
      end;
      if fbdocchanged then
      begin
         application.createform(Tfrm_AskForSave, frm_AskForSave);
         frm_AskForSave.Label1.caption := _('Dokument wurde verndert.') + #13 +
            _('Mchten Sie die vorgenommenen nderungen speichern?');
         frm_AskForSave.showmodal;
         lmmy := frm_AskForSave.ModalResult;
         frm_AskForSave.Release;
         if lmmy = mrYes then
         begin
            tbi_TDocSaveClick(self);
         end;
         fbdocchanged := false;
      end;
      IO.Params.ImageIndex := iPage;
      changepage(0);
      ShowPage
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_DocEdit.tbx_favClick(Sender: TObject);
var tbx_fav:TTBXItem;
begin
   GgfLogevnt('tbx_favClick');
   if not (Sender is TTBXItem) then
      Exit; // nur zur Sicherheit
   tbx_fav := TTBXItem(Sender);
   //uncheckallgraphictools;
   uncheckallgraphictools;

   if Doc_obj.rights.awrite and (tbsi_topenLayer.checked or tbsi_tPrivatLayer.Checked) then
   begin
      loadfavstampvalues(tbx_fav.tag, tbx_fav.Hint);
      tbx_fav.Checked := true;
      //tbi_normalmouse.checked := false;
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_DocEdit.loadfavstampvalues(fktag: integer; favtext: string);
var
   iSHeight, iSWidth, liposzus, liposzus1, lizus: integer;
   mesTmp: TIEUnits;
   reg: TRegistry;
   lsfilename: string;
   ltim: TIEMouseInteractVt;
   sStampText, sDate, sTime, lszusname, lszusnr: string;
   fsTmp: TFontStyles;
begin
   GgfLogevnt('loadfavstampvalues');
   iSHeight := 0;
   iSWidth := 0;
   uncheckallgraphictools;

   fra_DocEditor.LoadStamp(gasfavstemp[fktag])
end;


//-----------------------------------------------------------------------------
procedure Tfrm_DocEdit.tbxtm_normalmouseClick(Sender: TObject);
begin
   uncheckallgraphictools;
   tbxtm_normalmouse.checked := true;
   tbi_ESelect.checked := False;
   stb_DocEdit.SimpleText := _('Verschieben und Zoomen');
   fra_DocEditor.img_DocView.DeSelect;
   fra_DocEditor.img_DocView.MouseInteractVt := [];
   fra_DocEditor.img_DocView.MouseInteract := [miscroll];
	fra_DocEditor.img_DocView.Cursor := 0;
   if fra_DocEditor.gbAnnoNotSaved then
	   fra_DocEditor.saveobjects(False, True);
   Abort;
end;

procedure Tfrm_DocEdit.tbi_ESelectClick(Sender: TObject);
begin
   if not Doc_obj.rights.awrite then
   begin
      BfShowMessage(_('Sie drfen keine Annotationen an dieses Dokument anbringen.'));
      exit;
   end;
   fra_DocEditor.img_DocView.MouseInteractVt := [miObjectSelect];
   stb_DocEdit.SimpleText := _('Anmerkungen Editieren');
   uncheckallgraphictools;
   tbi_ESelect.Checked := True;
   tbxtm_normalmouse.Checked := False;
   fra_DocEditor.img_DocView.Cursor := 1780;
end;



end.



