unit u_DocTime;

interface

{3.6<}
uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, DateUtils, TB2Item, TBX, Grids, DBGrids, CRGrid, StdCtrls,
   TB2Dock, TB2Toolbar, TBXStatusBars, ComCtrls, MFEdit, DB, Buttons,
   JvExStdCtrls, JvCombobox, JvListComb, Placemnt, ExtCtrls,
   u_ShLowUtils;
{>3.6}

type
   Tfrm_DocTime = class (TForm)
      memo_Info: TMemo;
      dtp_Timer: TMFDateTimeEdit;
      stb_DocTime: TTBXStatusBar;
      dock_DocTime_Top: TTBXDock;
      tlb_DocTime: TTBXToolbar;
      lbl_Notiz: TLabel;
      lbl_Datum: TLabel;
      dbgrd_Timers: TCRDBGrid;
      tbi_PrevKW: TTBXItem;
      tbi_DelTimer: TTBXItem;
      tbi_SaveEdit: TTBXItem;
      tbi_ShowDoc: TTBXItem;
      tbsep_1: TTBXSeparatorItem;
      tbsep_2: TTBXSeparatorItem;
      tbi_NextKW: TTBXItem;
      dtp_DocTime: TMFDateTimeEdit;
      tbci_DocTime: TTBControlItem;
      tbsep_3: TTBXSeparatorItem;
      tbi_ShowKW: TTBXItem;
      lbl_Bearbeiter: TLabel;
      cbx_Status: TComboBox;
      lbl_Status: TLabel;
      tbsep_4: TTBXSeparatorItem;
      tbi_MATask: TTBXItem;
      tbi_MyTask: TTBXItem;
      tbsep_6: TTBXSeparatorItem;
      tbi_DelDone: TTBXItem;
      tbi_ShowDone: TTBXItem;
      tbi_ShowWork: TTBXItem;
      tbi_ShowOpen: TTBXItem;
      tbsep_5: TTBXSeparatorItem;
      sbtn_OK: TSpeedButton;
      sbtn_Cancel: TSpeedButton;
      tbi_SetState_Done: TTBXItem;
      tbi_SetState_Work: TTBXItem;
      tbi_SetState_Open: TTBXItem;
      tbsep_7: TTBXSeparatorItem;
      cbx_Usr_Work: TJvImageComboBox;
      Panel1: TPanel;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      Label4: TLabel;
      procedure dbgrd_TimersCellClick(Column: TColumn);
      procedure tbi_PrevKWClick(Sender: TObject);
      procedure tbi_NextKWClick(Sender: TObject);
      procedure dtp_DocTimeChange(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure tbi_ShowKWClick(Sender: TObject);
      procedure tbi_DelTimerClick(Sender: TObject);
      procedure tbi_SaveEditClick(Sender: TObject);
      procedure tbi_ShowDocClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure tbi_MyTaskClick(Sender: TObject);
      procedure tbi_MATaskClick(Sender: TObject);
      procedure dbgrd_TimersDrawColumnCell(Sender: TObject; const Rect: TRect;
         DataCol: integer; Column: TColumn; State: TGridDrawState);
      procedure cbx_Usr_WorkChange(Sender: TObject);
      procedure cbx_StatusChange(Sender: TObject);
      procedure tbi_ShowOpenClick(Sender: TObject);
      procedure tbi_ShowWorkClick(Sender: TObject);
      procedure tbi_ShowDoneClick(Sender: TObject);
      procedure tbi_DelDoneClick(Sender: TObject);
      procedure sbtn_OKClick(Sender: TObject);
      procedure sbtn_CancelClick(Sender: TObject);
      procedure tbi_SetState_OpenClick(Sender: TObject);
      procedure tbi_SetState_WorkClick(Sender: TObject);
      procedure tbi_SetState_DoneClick(Sender: TObject);

      procedure Button1Click(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure FormClick(Sender: TObject);
      procedure lbl_StatusClick(Sender: TObject);


   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      function TimeSQL(SQLCMD: string): boolean;
      procedure ShowDocsKW(Year, KW: integer);
      procedure ShowDocsDate(Datum: TDateTime);
      procedure ShowMATasks;
      procedure FillControls(Showstati: bool);
      procedure InitDocTime;
      procedure SwitchControls(Func: integer);
      procedure ReadCbxUsr;
      procedure CancelStatus;
      procedure ShowMAOpen;
      procedure ShowMAWork;
      procedure ShowMADone;
   end;

var
   frm_DocTime: Tfrm_DocTime;
// tor02open ist eine Torlogik zur Steuerung der Voransicht augrund der Wiedervorlage NG

implementation

{$R *.dfm}

uses u_dm_ViewerMain, u_dm_DB, u_MainForm, u_form1;

function Tfrm_DocTime.TimeSQL(SQLCMD: string): boolean;
begin
   /////////////////////////////////////////////////////////////////////////////////////////////////////////

   // Anzeige des SQL Command

   /////////////////////////////////////////////////////////////////////////////////////////////////////////
   // ShowMessage(SQLCMD);
   try
      with dm_db.my_q_Time do
      begin
         Close;
         SQL.Text := SQLCMD;
         Open;
         First;
         Result := True;
         // if frm_DocTime.Showing then dbgrd_Timers.AdjustColumns;
      end;
   except
      on e: Exception do
      begin
         LogEvnt('1000    Fehler in Modul: TimeSQL    ' + e.message);
         Result := False;
      end;
   end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////
// initialisiere den Wiedevorlage Anzeigebereich


procedure Tfrm_DocTime.InitDocTime;
var
   dtNow: TDateTime;
begin
   // ReadCbxUsr;
   dtNow := Now;
   iGYear := YearOf(dtNow);
   //showmessage ('u_doctime: '+inttostr(igyear));
   iGKW := WeekOf(dtNow);
   //  showmessage ('u_doctime: '+inttostr(igkw));
   dtp_DocTime.Date := dtNow;
   dtp_Timer.Date := dtNow;
   ShowDocsKW(iGYear, iGKW);
   if frm_DocTime.Tag = 1 then
      tbi_ShowDocClick(self);
end;

procedure Tfrm_DocTime.CancelStatus;
var
   sTblName, sFileName: string;
   slWFEnd: TStringList;
begin
   slWFEnd := TStringList.Create;
   DateTimeToString(sFileName, 'ddmmyyyyhhnnsszzz', now);
   if frm_MainForm.TmpSQL('select * from sys_arc where arc_id = ' +
      IntToStr(iGTimArcID)) then
   begin
      if dm_DB.my_q_Tmp.RecordCount > 0 then
      begin
         sTblName := dm_DB.my_q_Tmp.FieldByName('arc_tblname').AsString;
         dm_DB.my_q_Tmp.Close;
      end
      else
         sTblName := '';
   end;
   if sTblName <> '' then
   begin
      with dm_DB.my_cmd do
      begin
         SQL.Text := 'Update arc_' + sTblName +
            ' set doc_state = (doc_state | 1) ^ 1 where doc_id = ' + IntToStr(iGTimDocID);
         try
            try
               Execute;
               slWFEnd.Add(IntToStr(iGTimArcID) + '.' + IntToStr(iGTimDocID));
               slWFEnd.SaveToFile(sGClntSpool + sFileName + '.WFEND');
            except
               on e: Exception do
                  ErrorMsg('CancelStatus', 'Fehler beim ndern des Dokumentenstatus: ' +
                     e.Message, 1006, True);
            end;
         finally
            if Assigned(slWFEnd) then
               FreeAndNil(slWFEnd);
         end;
      end;
   end;
end;

procedure Tfrm_DocTime.ReadCbxUsr;
// var AddItem: TJvImageItem;
begin
{
  cbx_Usr_Work.Items.Clear;
  // Benutzer auslesen...
  if frm_MainForm.TmpSQL('select * from sys_usr where flags = 1 order by usr_name') then
  begin
    try
      with dm_DB.my_q_Tmp do
      begin
        while not Eof do
        begin
          AddItem := cbx_Usr_Work.Items.Add;
          AddItem.Text := FieldByName('usr_name').AsString;
          AddItem.LinkedObject := TObject(FieldByName('usr_ID').AsInteger);
          AddItem.ImageIndex := 8;
          Next;
        end;
        dm_DB.my_q_Tmp.Close;
      end;
    except
      on e: exception do ErrorMsg('ReadCbxUsr', 'Fehler beim Auslesen aller Benutzer: ' + e.Message, 2015, True);
    end;
  end else ErrorMsg('ReadCbxUsr', 'Fehler bei Select Anweisung!', 2002, True);
  // Gruppen auslesen...
  if frm_MainForm.TmpSQL('select * from sys_grp order by grp_name') then
  begin
    try
      with dm_DB.my_q_Tmp do
      begin
        while not Eof do
        begin
          AddItem := cbx_Usr_Work.Items.Add;
          AddItem.Text := FieldByName('grp_name').AsString;
          AddItem.LinkedObject := TObject(FieldByName('grp_ID').AsInteger);
          AddItem.ImageIndex := 9;
          Next;
        end;
        dm_DB.my_q_Tmp.Close;
      end;
    except
      on e: exception do ErrorMsg('ReadCbxUsr', 'Fehler beim Auslesen aller Benutzer: ' + e.Message, 2015, True);
    end;
  end else ErrorMsg('ReadCbxUsr', 'Fehler bei Select Anweisung!', 2002, True);
  }
end;


////////////////////////////////////////////////////////////////////////////////////////////////////////
// uebertragen

procedure Tfrm_DocTime.SwitchControls(Func: integer);
var
   colTmp: TColumn;
begin
   if func = 1 then
   begin
      tbi_MyTask.Checked := True;
      tbi_MATask.Checked := False;
      tbi_PrevKW.Enabled := True;
      tbi_NextKW.Enabled := True;
      tbi_ShowKW.Enabled := True;
      dtp_DocTime.Enabled := True;
      tbi_ShowOpen.Enabled := False;
      tbi_ShowWork.Enabled := False;
      tbi_ShowDone.Enabled := False;
      tbi_DelDone.Enabled := False;
      with dbgrd_Timers do
      begin
         Columns.Clear;
         colTmp := Columns.Add;
         colTmp.Width := 21;
         colTmp.Title.Caption := 'Typ';
         colTmp := Columns.Add;
         colTmp.FieldName := 'termin';
         colTmp.Title.Caption := 'Termin';
         colTmp := Columns.Add;
         colTmp.FieldName := 'arc_name';
         colTmp.Title.Caption := 'Archiv';
         colTmp := Columns.Add;
         colTmp.FieldName := 'doc_titel';
         colTmp.Title.Caption := 'Dokument';
         colTmp := Columns.Add;
         colTmp.FieldName := 'info';
         colTmp.Title.Caption := 'Notiz';
      end;
   end;
   if func = 2 then
   begin
      tbi_MyTask.Checked := False;
      tbi_MATask.Checked := True;
      tbi_PrevKW.Enabled := False;
      tbi_NextKW.Enabled := False;
      tbi_ShowKW.Enabled := False;
      dtp_DocTime.Enabled := False;
      tbi_ShowOpen.Enabled := True;
      tbi_ShowWork.Enabled := True;
      tbi_ShowDone.Enabled := True;
      tbi_DelDone.Enabled := True;
      with dbgrd_Timers do
      begin
         Columns.Clear;
         colTmp := Columns.Add;
         colTmp.Width := 21;
         colTmp.Title.Caption := 'Typ';
         colTmp := Columns.Add;
         colTmp.FieldName := 'erinnerung';
         colTmp.Title.Caption := 'Erinnerung';
         colTmp := Columns.Add;
         colTmp.FieldName := 'termin';
         colTmp.Title.Caption := 'Termin';
         colTmp := Columns.Add;
         colTmp.FieldName := 'status';
         colTmp.Title.Caption := 'Status';
         colTmp := Columns.Add;
         colTmp.FieldName := 'arc_name';
         colTmp.Title.Caption := 'Archiv';
         colTmp := Columns.Add;
         colTmp.FieldName := 'doc_titel';
         colTmp.Title.Caption := 'Dokument';
         colTmp := Columns.Add;
         colTmp.FieldName := 'usr_name';
         colTmp.Title.Caption := 'Bearbeiter';
         colTmp := Columns.Add;
         colTmp.FieldName := 'info                      _';
         colTmp.Title.Caption := 'Notiz';
      end;
   end;
end;

// END Uebertragen
//////////////////////////////////////////////////////////////////////////////////////  ////////////////
//  Wiedervorlage
//  fr die aktuelle Kalenderwoche anzeigen
//  ShowDocsKW

/////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.ShowDocsKW(Year, KW: integer);
var
   dtFirstDayOfKW, dtStart, dtEnd: TDateTime;
   sStart, sEnd
   // ,debugstr01
   : string;
begin
   tor02open := True;
   dtFirstDayOfKW := EncodeDateWeek(Year, KW, 1);
   dtStart := StartOfTheWeek(dtFirstDayOfKW);
   dtEnd := EndOfTheWeek(dtFirstDayOfKW);
   DateTimeToString(sStart, 'yyyy-mm-dd hh:nn:ss', dtStart);
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', dtEnd);
   /////////////


   if TimeSQL(
      'Select tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, info, optionen, status, usr_id_work from sys_timer ' + 'left join sys_arc using(arc_id) where usr_id_work = ' + IntToStr(iGUsrID) + ' and status <> 2 and ' + '((Termin between ' + #39 + sStart + #39 + ' and ' + #39 + sEnd + #39 + ') or ' + ' (Termin < ' + #39 + sStart + #39 + ')) ' + 'order by termin') then
      FillControls(False);
   frm_DocTime.Caption := 'Dokumente auf Wiedervorlage [KW ' +
      IntToStr(KW) + ':  ' + DateToStr(dtStart) + ' - ' + DateToStr(dtEnd) + ']';
   iGTaskCount := dm_DB.my_q_Time.RecordCount;
   ///////////////////////////////////////////////////////////////////
   // Debug Anzeige der auf Wiedervorlage liegenden Dokumente
   //showmessage ('igTaskCount : '+inttostr(igtaskcount));
end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Berechnung und Anzeige der Titel Zeile "Dokumente auf Wiedervortlage und KW mit Datum


////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.ShowDocsDate(Datum: TDateTime);
var
   sStart, sEnd: string;
begin
   iGKW := WeekOf(Datum);
   iGYear := YearOf(Datum);
   DateTimeToString(sStart, 'yyyy-mm-dd', StartOfTheDay(Datum));
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', EndOfTheDay(Datum));
   if TimeSQL(
      'Select tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, info, optionen, status, usr_id_work from sys_timer ' + 'left join sys_arc using(arc_id) where usr_id_work = ' + IntToStr(iGUsrID) + ' and status <> 2 ' + 'and Termin between ' + #39 + sStart + #39 + ' and ' + #39 + sEnd + #39 + ' order by termin') then
      FillControls(False);
   frm_DocTime.Caption := 'Dokumente auf Wiedervorlage [KW ' +
      IntToStr(iGKW) + ':  ' + DateToStr(Datum) + ']';
end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Berechnung und Anzeige der Titel Zeile "Dokumente Liste aller vergebenen Auftraege


////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.ShowMATasks;
begin
   if TimeSQL(
      'Select tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' + 'erinnerung, info, optionen, status, usr_id_work from sys_timer ' + 'left join sys_arc using(arc_id) ' + 'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' + 'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' + 'where (usr_id_work = ' + IntToStr(iGUsrID) + ' or usr_id_shed = ' + IntToStr(iGUsrID) + ') ' + 'group by tim_ref order by termin') then
      FillControls(False);
   frm_DocTime.Caption := 'Dokumente auf Wiedervorlage [Liste aller vergebenen Auftrge]';
end;

procedure Tfrm_DocTime.ShowMAOpen;
begin
   if TimeSQL(
      'Select tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' + 'erinnerung, info, optionen, status, usr_id_work from sys_timer ' + 'left join sys_arc using(arc_id) ' + 'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' + 'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' + 'where (usr_id_work = ' + IntToStr(iGUsrID) + ' or usr_id_shed = ' + IntToStr(iGUsrID) + ')  and status = 0 ' + 'group by tim_ref order by termin') then
      FillControls(False);
   frm_DocTime.Caption := 'Dokumente auf Wiedervorlage [Liste aller vergebenen Auftrge]';
end;

procedure Tfrm_DocTime.ShowMAWork;
begin
   if TimeSQL(
      'Select tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' + 'erinnerung, info, optionen, status, usr_id_work from sys_timer ' + 'left join sys_arc using(arc_id) ' + 'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' + 'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' + 'where (usr_id_work = ' + IntToStr(iGUsrID) + ' or usr_id_shed = ' + IntToStr(iGUsrID) + ')  and status = 1 ' + 'group by tim_ref order by termin') then
      FillControls(False);
   frm_DocTime.Caption := 'Dokumente auf Wiedervorlage [Liste aller vergebenen Auftrge]';
end;

procedure Tfrm_DocTime.ShowMADone;
begin
   //  if TimeSQL('Select tim_id, grp_id, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, sys_usr.usr_name, erinnerung, info, status, usr_id_work from sys_timer ' +
   //             'left join sys_arc using(arc_id) left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
   //             'where (usr_id_work = ' + IntToStr(iGUsrID) + ' or usr_id_shed = ' + IntToStr(iGUsrID) + ') and status = 2 order by termin') then FillControls;
   if TimeSQL(
      'Select tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' + 'erinnerung, info, optionen, status, usr_id_work from sys_timer ' + 'left join sys_arc using(arc_id) ' + 'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' + 'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' + 'where (usr_id_work = ' + IntToStr(iGUsrID) + ' or usr_id_shed = ' + IntToStr(iGUsrID) + ')  and status = 2 ' + 'group by tim_ref order by termin') then
      FillControls(False);
   frm_DocTime.Caption := 'Dokumente auf Wiedervorlage [Liste aller vergebenen Auftrge]';
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////


//  FILL Controls bedient die Stati des Workflow und fllt die DB Grid der wIedervorlage aus

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.FillControls(showstati: bool);
var
   iCount, iTmpID: integer;

   // zu diesem zeitpunkt ist die Wvlliste bereits gelscht
begin
   with dm_DB.my_q_Time do
   begin
      if RecordCount > 0 then
         // Recordcount beinhaltet die Anzahl der Datnsaetze in der Wiedervorlageliste

      begin
         dtp_Timer.Enabled := True;
         memo_Info.Enabled := True;
         dtp_Timer.DateTime := FieldByName('termin').AsDateTime;
         memo_Info.Text := FieldByName('Info').AsString;
         iGTimRec := dm_DB.my_q_Time.FieldByName('tim_ref').AsInteger;
         iGTimArcID := dm_DB.my_q_Time.FieldByName('arc_ID').AsInteger;
         iGTimDocID := dm_DB.my_q_Time.FieldByName('doc_ID').AsInteger;
         iTmpID := dm_DB.my_q_Time.FieldByName('grp_id').AsInteger;
         // zu diesem zeitpunkt ist die Wvlliste bereits gelscht
         if iTmpID > 0 then
         begin
            for iCount := 0 to (cbx_Usr_Work.Items.Count - 1) do
               if cbx_Usr_Work.Items.Items[iCount].ImageIndex = 9 then
                  if cbx_Usr_Work.Items.Items[iCount].LinkedObject = TObject(iTmpID) then
                  begin
                     cbx_Usr_Work.ItemIndex := iCount;
                     break;
                  end;
         end
         else
         begin
            iTmpID := dm_DB.my_q_Time.FieldByName('usr_id_work').AsInteger;
            for iCount := 0 to (cbx_Usr_Work.Items.Count - 1) do
               if cbx_Usr_Work.Items.Items[iCount].ImageIndex = 8 then
                  if cbx_Usr_Work.Items.Items[iCount].LinkedObject = TObject(iTmpID) then
                  begin
                     cbx_Usr_Work.ItemIndex := iCount;
                     break;
                  end;
         end;

         ///////////////////////////////////////////////////////////////////////////////

         // Hier werden die Bearbeitungsstati der Dokumnte gesetzt

         ///////////////////////////////////////////////////////////////////////////////


         // lese den Status des dokumentes aus der Datenbank

         cbx_Status.ItemIndex := FieldByName('status').AsInteger;
         // setze die Leuchtanzeigen der drei Stati open, done, work auf false (nicht bettigt)
         tbi_SetState_Open.Checked := False;
         tbi_SetState_Work.Checked := False;
         tbi_SetState_Done.Checked := False;
         // setze die Leutchanzeige des in der Datenbank gespeicherten Status
         case cbx_Status.ItemIndex of
            0:
               tbi_SetState_Open.Checked := True;
            1:
               tbi_SetState_Work.Checked := True;
            2:
               tbi_SetState_Done.Checked := True;
         end;
      end
      else
      begin
         dtp_Timer.Enabled := False;
         memo_Info.Enabled := False;
      end;
   end;
end;

procedure Tfrm_DocTime.dbgrd_TimersCellClick(Column: TColumn);
//var iStatus: Integer;
////////////////////////////////////////////////////////////////////////////////////////////////////////
// Dokument im Wiedervorlagefenster anklicken  CellCLICK once
// zeigt das Tiff der Seite des Dokumentes im Vorschaufenster an
// NG
////////////////////////////////////////////////////////////////////////////////////////////////////////
begin
   /////////////////////////////////////////////////////////////////////////////////////////////////////

   // bAlive Lebenszaehler

   // Die Ausfhrung der Funktionen Kombination FillControls in verbindung mit Show Dock CLick
   // zeigt das aktuelle Dokument im Vorgucker Fenster an
   // wird diese Funktionenkombination angefordert wenn bereit eine anfrage aktiv ist
   // stoeren sich die MYSQL Abfragen

   // Der lebenszaehler der Abfrage verhindert diese Abfragekollision in Forma eines Tores
   // Lebenszaehler bAlive = false , dann ist gerade keine Abfrage aktiv
   // und eine neue Abfrage darf gestellt werden
   // Ist die Funktionenkombination Fill-Show aktiv findet keine aktivierung der
   // Angeforderten Klickfunktionalitt statt.

   // NG 060809
   ////////////////////////////////////////////////////////////////////////////////////////////////////
   if bAlive = False then
   begin
      bAlive := True;
      FillControls(False);
      tbi_ShowDocClick(self);
      bAlive := False;
   end;
   ///////////////////////////////////////////////////////////////////////////////////////////////////////////

  {

  try
    if dm_DB.my_q_Arc.RecordCount > 0 then
    begin
      iStatus := dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger;


      case istatus of
        1:
        begin
          tbi_setState_open.checked:=false;
          tbi_setState_work.Checked:=true;
          tbi_setstate_done.Checked:=false;
        end;
        0:
        begin
          tbi_setState_open.checked:=true;
          tbi_setState_work.Checked:=false;
          tbi_setstate_done.Checked:=false;
        end;
      end;
    end;

  finally

  }


   //sleep(500);
end;

procedure Tfrm_DocTime.tbi_PrevKWClick(Sender: TObject);
var
   dtEnd: TDateTime;
begin
   Dec(iGKW);
   if iGKW < 1 then
   begin
      Dec(iGYear);
      dtEnd := EndOfAYear(iGYear);
      iGKW := WeekOfTheYear(dtEnd);
   end;
   ShowDocsKW(iGYear, iGKW);
end;

procedure Tfrm_DocTime.tbi_NextKWClick(Sender: TObject);
var
   dtStart: TDateTime;
begin
   Inc(iGKW);
   if iGKW > 52 then
   begin
      Inc(iGYear);
      dtStart := StartOfAYear(iGYear);
      iGKW := WeekOfTheYear(dtStart);
   end;
   ShowDocsKW(iGYear, iGKW);
end;

procedure Tfrm_DocTime.dtp_DocTimeChange(Sender: TObject);
begin
   ShowDocsDate(dtp_DocTime.Date);
end;

procedure Tfrm_DocTime.FormShow(Sender: TObject);
begin
   // NG
   InitDocTime;  // Igel061114 deaktiviert beider Igelfehlersuche
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Wiedervorlage Anzeige der Daten der Wiedervorlage fr eine Kalenderwochen (jetztKW)


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_ShowKWClick(Sender: TObject);
begin
   iGYear := YearOf(dtp_DocTime.DateTime);
   iGKW := WeekOf(dtp_DocTime.DateTime);
   ShowDocsKW(iGYear, iGKW);
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Dokument aus der Wiedervorlage entfernen


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_DelTimerClick(Sender: TObject);
var
   iTmpArcID, iTmpDocID: integer;
begin
   with dm_DB.my_q_Time do
   begin
      if (RecordCount > 0) and (FieldByName('status').AsInteger = 2) then
      begin
         Sql.Text := 'delete from sys_timer where tim_ref = ' +
            IntToStr(iGTimRec) + ' or tim_id = ' + IntToStr(iGTimRec);
         try
            Execute;
         except
            on e: Exception do
               ErrorMsg('tbi_DelTimer',
                  'Fehler beim Entfernen eines Dokumentes aus der Wiedervorlage: ' +
                  e.Message, 1001, True);
         end;
         iTmpArcID := iGArcID;
         iTmpDocID := iGDocID;
         iGArcID := iGTimArcID;
         iGDocID := iGTimDocID;
         frm_MainForm.NewHistory(19, 'Aus Wiedervorlage entfernt. Bearbeiter: ' +
            cbx_Usr_Work.Text + ' Termin: ' + DateToStr(StartOfTheDay(dtp_Timer.DateTime)) +
            ' Status: ' + cbx_Status.Text);
         iGArcID := iTmpArcID;
         iGDocID := iTmpDocID;
         if tbi_MyTask.Checked then
            ShowDocsKW(iGYear, iGKW);
         if tbi_MATask.Checked then
            ShowMATasks;
      end
      else
         ShowMessage('Sie knnen nur Dokumente mit dem Status [Fertig] aus der Wiedervorlage entfernen.');
   end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Aenderungen, die in der Wiedervorlageliste am Datensystz vorgenommen worden sind speichern


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_SaveEditClick(Sender: TObject);
var
   sDatum: string;
   iTmpArcID, iTmpDocID, iStat: integer;
   bUpdate: boolean;
begin
   DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(dtp_Timer.DateTime));
   bUpdate := False;
   with dm_DB.my_cmd do
   begin
      // wenn mehr als Null elemente fuer die Wiedervorlage vorgemerkt sind
      if dm_DB.my_q_Time.RecordCount > 0 then
         // Recordcount enthaelt die Anzahl der Wiedervorlagen
      begin
         iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
         // den Status der WVL aus DB lesen
         // Status 0 = offen, 1 = in Bearbeitung , 2 = fertig
         dm_DB.my_q_Time.RefreshRecord;
         if iStat <> dm_DB.my_q_Time.FieldByName('status').AsInteger then
         begin
            ShowMessage('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.'
               + #13 + 'Bitte berprfen Sie den neuen Status!' + #13 +
               #13 + 'Es erfolgte keine nderung an der Wiedervorlage.');
            FillControls(False);
            exit;
         end;
         // auf Benutzer oder Gruppen Update prfen...
         if dm_DB.my_q_Time.FieldByName('grp_id').AsInteger = 0 then
         begin
            // auf anderen Benutzer oder Gruppe prfen...
            if cbx_Usr_Work.Items.Items[cbx_Usr_Work.ItemIndex].ImageIndex = 8 then
            begin
               Sql.Text := 'Update sys_timer set Termin = ' + #39 + sDatum +
                  #39 + ', info = ' + #39 + memo_Info.Text + #39 +
                  ', usr_id_work = ' +
                  IntToStr(integer(cbx_Usr_Work.Items.Objects[cbx_Usr_Work.ItemIndex])) +
                  ', status = ' + IntToStr(cbx_Status.ItemIndex) +
                  ' where tim_ref = ' + IntToStr(iGTimRec);
               Execute;
               bUpdate := True;
            end
            else
            begin
               // Benutzer -> Gruppe geht nicht!
               ShowMessage('Eine fr einen Benutzer geplante Wiedervorlage, kann' +
                  #13 + 'nicht einer Gruppe zugeteilt werden.');
            end;
         end
         else
         begin
            // Gruppen Update - Gruppen Wiedervorlage an einen Benutzer geben
            if cbx_Usr_Work.Items.Items[cbx_Usr_Work.ItemIndex].ImageIndex = 8 then
            begin
               Sql.Text := 'delete sys_timer where tim_ref = ' + IntToStr(iGTimRec) +
                  ' and usr_id_work <> ' +
                  IntToStr(integer(cbx_Usr_Work.Items.Objects[cbx_Usr_Work.ItemIndex]));
               Execute;
               Sql.Text := 'Update sys_timer set Termin = ' + #39 + sDatum +
                  #39 + ', info = ' + #39 + memo_Info.Text + #39 +
                  ', usr_id_work = ' +
                  IntToStr(integer(cbx_Usr_Work.Items.Objects[cbx_Usr_Work.ItemIndex])) +
                  ', status = ' + IntToStr(cbx_Status.ItemIndex) +
                  ', grp_id = 0 ' + 'where tim_ref = ' + IntToStr(iGTimRec);
               Execute;
               bUpdate := True;
            end
            else
            begin
               // Gruppen Update - Wenn Gruppe unverndert, dann Attribute Updaten
               if dm_DB.my_q_Time.FieldByName('grp_id').AsInteger =
                  integer(cbx_Usr_Work.Items.Objects[cbx_Usr_Work.ItemIndex]) then
               begin
                  Sql.Text := 'Update sys_timer set Termin = ' + #39 +
                     sDatum + #39 + ', info = ' + #39 + memo_Info.Text +
                     #39 + ', status = ' + IntToStr(cbx_Status.ItemIndex) +
                     'where tim_ref = ' + IntToStr(iGTimRec);
                  Execute;
                  bUpdate := True;
               end
               else
               begin
                  // Gruppen Wiedervorlage an andere Gruppe vergeben geht nicht!
                  ShowMessage('Eine fr eine Gruppe geplante Wiedervorlage, kann' +
                     #13 + 'nicht einer anderen Gruppe zugeteilt werden.');
               end;
            end;
         end;
         // nur Updaten wenn auch wirklich ein SQL Update erfolgt ist
         if bUpdate then
         begin
            //tbi_ShowDocClick(self);
            if cbx_Status.ItemIndex = 2 then
               CancelStatus;
            iTmpArcID := iGArcID;
            iTmpDocID := iGDocID;
            iGArcID := iGTimArcID;
            iGDocID := iGTimDocID;
            frm_MainForm.NewHistory(18, 'Wiedervorlage gendert. Bearbeiter: ' +
               cbx_Usr_Work.Text + ' Termin: ' +
               DateToStr(StartOfTheDay(dtp_Timer.DateTime)) + ' Status: ' + cbx_Status.Text);
            iGArcID := iTmpArcID;
            iGDocID := iTmpDocID;
            if tbi_MyTask.Checked then
               ShowDocsKW(iGYear, iGKW);
            if tbi_MATask.Checked then
               ShowMATasks;
         end;
      end;
   end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// S H O W D O C C L I C K
// Dokument der Wiedervorlage Liste anzeigen das mit einem Einfachen linksklick ausgewaehlt wurde
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_ShowDocClick(Sender: TObject);
begin
   with dm_DB.my_q_Time do
   begin
      if RecordCount > 0 then
      begin
         frm_MainForm.stb_Main.Panels[4].Caption :=
            FieldByName('arc_id').AsString + '.' + FieldByName('doc_id').AsString;
         //       /DEbug IGEL
         //     Sleep(2000);
         frm_MainForm.GoToDocID;
      end;
   end;
end;

procedure Tfrm_DocTime.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   frm_DocTime.Release;
   //frm_MainForm.tbi_VDocTimer.Checked := False;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//    Wiedervorlage
//    Anzeige Eigene Aufgaben


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_MyTaskClick(Sender: TObject);
begin
   SwitchControls(1);
   ShowDocsKW(iGYear, iGKW);
end;

procedure Tfrm_DocTime.tbi_MATaskClick(Sender: TObject);
begin
   SwitchControls(2);
   ShowMATasks;
end;

procedure Tfrm_DocTime.dbgrd_TimersDrawColumnCell(Sender: TObject;
   const Rect: TRect; DataCol: integer; Column: TColumn; State: TGridDrawState);
begin
  {
  //try // IGEL NOG

    if tor02open then

    begin
      //BEGIN IGEL BUG hunting
      // showmessage ( 'Tor 2 ist offen');
      //END IGEL BUG HUNTing
      if ngAliveMainform then  // wenn die Mainform erstellt worden ist
      begin
        tor02open:=false;
        // showmessage('die frm_mainform.fra_Voransicht.img_DocView sollte jetzt eigentlich existieren und angezeigt werden');
        FillControls(false);
        tbi_ShowDocClick(self);
      end;    // if ngAliveMainform
    end;  //if tor02open
  //finally;
  //tor02open := true
 // end; // try

  //
  // end of igel060815
  }

   if state = [] then
   begin
      if dm_DB.my_q_Time.FieldList.IndexOf('status') <> -1 then
      begin
         ///////////////////////////////////////////////////////////////////////////////////////////////////////

         // Wiedervorlage  Farben der Datenreihen


         ///////////////////////////////////////////////////////////////////////////////////////////////////////
         case dm_DB.my_q_Time.FieldByName('status').AsInteger of
            //  Column.Field.AsInteger of
            0:
               TDBGrid(Sender).canvas.brush.color := $00E1E1FF; // Weiss-Rot
            1:
               TDBGrid(Sender).canvas.brush.color := $00E1FCFF; // Weiss-Gelb
            2:
               TDBGrid(Sender).canvas.brush.color := $00E1FFE6; // Weiss-Grn
         else
            TDBGrid(Sender).canvas.brush.color := clWhite;
         end;
         if dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime <= StartOfTheDay(Date) then
         begin
            case dm_DB.my_q_Time.FieldByName('status').AsInteger of
               //  Column.Field.AsInteger of
               0:
                  TDBGrid(Sender).canvas.brush.color := clRed; // Rot
               1:
                  TDBGrid(Sender).canvas.brush.color := clYellow; // Gelb
            end;
         end;
         if column.Index = 0 then
         begin
            if dm_DB.my_q_Time.FieldByName('grp_id').AsInteger <> 0 then
            begin
               dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, 16, rect.Top, 9, True);
            end
            else
            begin
               dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, 16, rect.Top, 8, True);
            end;
         end;
      end;
   end;


   ////////////////////////////////////////////////////////////////////////////////////////////////////////////

   // Markierung der Reihe durch einfachen Linksklick


   ////////////////////////////////////////////////////////////////////////////////////////////////////////////
   if state = [gdSelected] then
   begin
      TDBGrid(Sender).canvas.brush.color := clSkyBlue;  // $00ffe3e1; // Weiss-Blau
   end;
   TDBGrid(Sender).DefaultDrawColumnCell(rect, datacol, column, state);


   if (column.Index = 0) and (dm_DB.my_q_Time.RecordCount > 0) then
   begin
      if dm_DB.my_q_Time.FieldByName('grp_id').AsInteger <> 0 then
         dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, 16, rect.Top, 9, True)
      else
         dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, 16, rect.Top, 8, True);
   end;
end;

procedure Tfrm_DocTime.cbx_Usr_WorkChange(Sender: TObject);
begin
   //  if cbx_Usr_Work.Items.IndexOf(cbx_Usr_Work.Text) = -1 then cbx_Usr_Work.ItemIndex := 0;
end;

procedure Tfrm_DocTime.cbx_StatusChange(Sender: TObject);
begin
   if cbx_Status.Items.IndexOf(cbx_Status.Text) = -1 then
      cbx_Status.ItemIndex := 0;
end;

procedure Tfrm_DocTime.tbi_ShowOpenClick(Sender: TObject);
begin
   ShowMAOpen;
end;

procedure Tfrm_DocTime.tbi_ShowWorkClick(Sender: TObject);
begin
   ShowMAWork;
end;

procedure Tfrm_DocTime.tbi_ShowDoneClick(Sender: TObject);
begin
   ShowMADone;
end;

procedure Tfrm_DocTime.tbi_DelDoneClick(Sender: TObject);
begin
   with dm_DB.my_cmd do
   begin
      SQL.Text :=
         'delete from sys_timer where status = 2 and (usr_id_work = :uid or usr_id_shed = :uid)';
      ParamByName('uid').AsInteger := iGUsrID;
      try
         Execute;
      except
         on e: Exception do
            ErrorMsg('tbi_DelDone',
               'Fehler beim Entfernen fertiger Eintrge aus der Wiedervorlage: ' +
               e.Message, 1001, True);
      end;
   end;
   ShowMATasks;
end;

procedure Tfrm_DocTime.sbtn_OKClick(Sender: TObject);
begin
   tbi_SaveEditClick(self);
end;

procedure Tfrm_DocTime.sbtn_CancelClick(Sender: TObject);
begin
   FillControls(False);
end;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Wiedervorlage status des Dokumentes: OFFEN


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_SetState_OpenClick(Sender: TObject);
{
 var iStatus: Integer;

begin
  try
    if dm_DB.my_q_Arc.RecordCount > 0 then
    begin
      iStatus := dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger;

      iStatus := 0;
      tbi_setState_open.checked:=true;
      tbi_setState_work.Checked:=false;
      tbi_setstate_done.Checked:=false;
      dm_DB.my_q_Arc.Edit;
      dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger := iStatus;
      dm_DB.my_q_Arc.Post;
      //frm_MainForm.ReadStatus;
      if (iStatus and 1) = 1 then frm_MainForm.NewHistory(22, 'Dokumentenstatus gendert [in Bearbeitung]')
      else begin
      frm_MainForm.NewHistory(22, 'Dokumentenstatus gendert [aus Bearbeitung]');
      end;
    end else
    begin
     // if tci_InUse.Color = clYellow then tci_InUse.Color := clGreen else tci_InUse.Color := clYellow;
    end;
  finally
  end;
end;

}

var
   iTmpDocID, iTmpArcID, iStat, iStatNew: integer;
   sTmpTblName: string;
begin
   if dm_DB.my_q_Time.RecordCount > 0 then
   begin
      iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      dm_DB.my_q_Time.RefreshRecord;
      iStatNew := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      if iStat <> iStatNew then
      begin
         ShowMessage('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.'
            + #13 + 'Bitte berprfen Sie den neuen Status!' + #13 + #13 +
            'Es erfolgte keine nderung an der Wiedervorlage.');
         FillControls(False);
         exit;
      end;
      with dm_DB.my_cmd do
      begin
         Sql.Text := 'Update sys_timer set status = 0 where tim_ref = ' +
            IntToStr(iGTimRec);
         Execute;
      end;
      //tbi_ShowDocClick(self);
      //if cbx_Status.ItemIndex = 2 then CancelStatus;
      iTmpArcID := iGArcID;
      iTmpDocID := iGDocID;
      iGArcID := iGTimArcID;
      iGDocID := iGTimDocID;
      frm_MainForm.TmpSQL('select * from sys_arc where arc_ID = ' + IntToStr(iGArcID));
      if dm_DB.my_q_Tmp.RecordCount <> 0 then
      begin
         sTmpTblName := sIArcName;
         sIArcName := dm_DB.my_q_Tmp.FieldByName('arc_tblName').AsString;
         frm_MainForm.NewHistory(18, 'Wiedervorlage gendert. Status: offen');
         dm_DB.my_q_Tmp.Close;
         sIArcName := sTmpTblName;
      end;
      iGArcID := iTmpArcID;
      iGDocID := iTmpDocID;
      if tbi_MyTask.Checked then
         ShowDocsKW(iGYear, iGKW);
      if tbi_MATask.Checked then
         ShowMATasks;
   end;
end;

//////////////////////////////////////////////////////////////////////////////////////
// End of Offen


//////////////////////////////////////////////////////////////////////////////////////
// Wiedervorlage Status des Dokumentes : in Bearbeitung

// Status aenderung eines Zur Wiedervorlage aufgefhrten Dokumentes
// Statuszweisung : IN BEARBEITUNG
// Ausgelst durch betaetigung der Schaltflche Status inbearbeitung in der
// Form u_DocTime

//////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_SetState_WorkClick(Sender: TObject);
{ Ueberarbeitung NG stabilisierung der Auswahlliste in der Wiedervorlage

 var iStatus: Integer;

begin
  try
    if dm_DB.my_q_Arc.RecordCount > 0 then
    begin
      iStatus := dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger;

      iStatus := 1;
      tbi_setState_open.checked:=false;
      tbi_setState_work.Checked:=true;
      tbi_setstate_done.Checked:=false;
      dm_DB.my_q_Arc.Edit;
      dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger := iStatus;
      dm_DB.my_q_Arc.Post;
      //frm_MainForm.ReadStatus;
      if (iStatus and 1) = 1 then frm_MainForm.NewHistory(18, 'Dokumentenstatus gendert [in Bearbeitung]')
      else begin
      frm_MainForm.NewHistory(18, 'Dokumentenstatus gendert [aus Bearbeitung]');
      end;
    end else
    begin
     // if tci_InUse.Color = clYellow then tci_InUse.Color := clGreen else tci_InUse.Color := clYellow;
    end;
  finally
  end;
end;
 }

var
   iTmpDocID, iTmpArcID, iStat, iStatNew: integer;
   sTmpTblName: string;
begin
   if dm_DB.my_q_Time.RecordCount > 0 then
   begin
      // dm_DB.my_q_Time.RecordCount = Anzahl der in der Wiedervorlageliste
      // dargestellten Zeilen
      iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      dm_DB.my_q_Time.RefreshRecord;
      iStatNew := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      if iStat <> iStatNew then
      begin
         ShowMessage('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.'
            + #13 + 'Bitte berprfen Sie den neuen Status!' + #13 + #13 +
            'Es erfolgte keine nderung an der Wiedervorlage.');
         FillControls(False);
         exit;
      end;
      with dm_DB.my_cmd do
      begin
         Sql.Text := 'Update sys_timer set status = 1 where tim_ref = ' +
            IntToStr(iGTimRec);
         Execute;
      end;
      //tbi_ShowDocClick(self);
      //if cbx_Status.ItemIndex = 2 then CancelStatus;
      ///////////////////////////////////////////////////////////////////////////////////////

      // DOC ID aufbereiten


      ///////////////////////////////////////////////////////////////////////////////////////
      iTmpArcID := iGArcID;
      iTmpDocID := iGDocID;
      iGArcID := iGTimArcID;
      iGDocID := iGTimDocID;

      frm_MainForm.TmpSQL('select * from sys_arc where arc_ID = ' + IntToStr(iGArcID));
      if dm_DB.my_q_Tmp.RecordCount <> 0 then
      begin
         sTmpTblName := sIArcName;
         sIArcName := dm_DB.my_q_Tmp.FieldByName('arc_tblName').AsString;
         frm_MainForm.NewHistory(18, 'Wiedervorlage gendert. Status: in Bearbeitung');
         dm_DB.my_q_Tmp.Close;
         sIArcName := sTmpTblName;
      end;
      iGArcID := iTmpArcID;
      iGDocID := iTmpDocID;

      if tbi_MyTask.Checked then
         ShowDocsKW(iGYear, iGKW);
      if tbi_MATask.Checked then
         ShowMATasks;
   end;
end;


/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Wiedervorlage Status erledigt


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_DocTime.tbi_SetState_DoneClick(Sender: TObject);
var
   iTmpDocID, iTmpArcID, iStat, iStatNew: integer;
   sTmpTblName: string;
begin
   if dm_DB.my_q_Time.RecordCount > 0 then
   begin
      iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      dm_DB.my_q_Time.RefreshRecord;
      iStatNew := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      ///////////////////////////////////////////////////////////////////
      // zeige inhalt on istat

      if iStat <> iStatNew then
      begin
         ShowMessage('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.'
            + #13 + 'Bitte berprfen Sie den neuen Status!' + #13 + #13 +
            'Es erfolgte keine nderung an der Wiedervorlage.');
         FillControls(False);
         exit;
      end;
      with dm_DB.my_cmd do
      begin
         Sql.Text := 'Update sys_timer set status = 2 where tim_ref = ' +
            IntToStr(iGTimRec);
         Execute;
      end;
      //igel 060815c
      //    tbi_ShowDocClick(self);
      CancelStatus;
      iTmpArcID := iGArcID;
      iTmpDocID := iGDocID;
      iGArcID := iGTimArcID;
      iGDocID := iGTimDocID;
      frm_MainForm.TmpSQL('select * from sys_arc where arc_ID = ' + IntToStr(iGArcID));
      if dm_DB.my_q_Tmp.RecordCount <> 0 then
      begin
         sTmpTblName := sIArcName;
         sIArcName := dm_DB.my_q_Tmp.FieldByName('arc_tblName').AsString;
         frm_MainForm.NewHistory(18, 'Wiedervorlage gendert. Status: fertig');
         dm_DB.my_q_Tmp.Close;
         sIArcName := sTmpTblName;
      end;
      iGArcID := iTmpArcID;
      iGDocID := iTmpDocID;
      if tbi_MyTask.Checked then
         ShowDocsKW(iGYear, iGKW);
      if tbi_MATask.Checked then
         ShowMATasks;
   end;
end;


procedure Tfrm_DocTime.Button1Click(Sender: TObject);
begin
   InitDocTime;
end;

procedure Tfrm_DocTime.FormCreate(Sender: TObject);
begin
   bAlive := False;
   tbi_ShowDocClick(self);
end;


procedure Tfrm_DocTime.FormActivate(Sender: TObject);
begin
   //////////////////////////////////////////////////////////////////////////////

   // NG 060814
   // fllen der Voransicht

   ////////////////////////////////////////////////////////////////////////////////

   // wird in der fra_Voransicht kein Dokument angezeigt,
   // ...und die wiedervorlageliste ist geffnet dann uebernimmt die Wiedervorlageliste
   // die Anzeige des ersten in der Liste verfgbaren Dikumentes

   if frm_MainForm <> nil then
   begin
      if frm_MainForm.fra_Voransicht.img_DocView.IsEmpty then
      begin
         tbi_ShowDocClick(self);
      end;
   end;
end;

procedure Tfrm_DocTime.FormClick(Sender: TObject);
begin
   tbi_ShowDocClick(self);
end;

procedure Tfrm_DocTime.lbl_StatusClick(Sender: TObject);
begin
   tbi_ShowWork.Enabled := True;
end;


end.
