//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv Viewer
// Entwickler: Frey
// Erstellt:   2009-10-12           
// Name:       u_ViewUtils
// Typ:        Unit
// Zweck:      Fr Viewer high-level Definitionen
//-----------------------------------------------------------------------------
// Diverse Hilfroutinen um u_MainForm zu entlasten
// Datenbank darf verwendet werden
// hier darf man so mllig proggen wie auch im Rest des Programms :-(
//----------------------------------------------------------------------------}

unit u_HighUtils;

{###############################} INTERFACE {###############################}

uses
  Windows, Types, StrUtils, Classes, SysUtils, Dialogs, ActiveX, Registry, ComCtrls,
  StdCtrls,
  MyAccess, imageenio, ActiveDs_TLB, adshlp, gnugettext,
  TBX,
  u_ShBase, u_ShLowUtils, u_ShDbUtils, u_ViewBase;

var debugedit:TEdit;

function ArcNameAnhandArcId(const ArcId:int64):string;
function GDocIdAnhandArcDocId(const ArcId, DocId: int64):int64;
function GetDocIdString(Delimiter:Char; const ArcId, DocId: int64):string;

procedure VerknuepfenAnhandZusatzfelder(const ArcDocId:TArcDocId; const Zusatzfeld, OldValue, NewValue:string);
function DateinameAnhandZusatzfelder(const ArcDocId:TArcDocId; const sIArcName:string; const my_q_Arc:TMyQuery):string;
procedure IoSaveGraphic(IO: TImageEnIO; sTmpPath:string);

function GetSha1FromFile(const filename: string):string;
function GetAdUsername(Owner: TComponent): string;

procedure LoadFavStampbuttons(tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5: TTBXItem);

procedure GetChilds(StartNode: TTreeNode; ChildList: TStringList);

procedure DbSetDate(Arcname, TmpField, NewValue: string; iGDOCID: int64);

//3.5.0.53 [2304]
procedure DocViewSavesSave(const DocViewSaves: TDocViewSaves);
procedure DocViewSavesLoad(var DocViewSaves: TDocViewSaves);
function StringFromRData(RData:TRData):string;

{############################} IMPLEMENTATION {#############################}

uses u_MainForm, u_dm_DB, {} u_dm_ViewerMain;


//-----------------------------------------------------------------------------
function ArcNameAnhandArcId(const ArcId:int64):string;
var lmq: TMyQuery;
begin
   Result := '';
   lmq := DbCreateQuery;
   try
      // Prfen ob die Tabelle da ist.
      LastSQL:='SELECT ARC_TBLName FROM sys_arc where ARC_ID = ' + IntToStr(ArcId);
      DbExecSql(lmq,LastSQL);
      if lmq.recordcount > 0 then
         Result:=lmq.fields[0].AsString;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
function GDocIdAnhandArcDocId(const ArcId, DocId: int64):int64;
var lsArcTblname: string;  lmq: TMyQuery;
begin
   Result := -1;
   lsArcTblname := ArcNameAnhandArcId(ArcId);
   lmq := DbCreateQuery;
   try
      // Prfen ob die Tabelle da ist.
      LastSQL := 'SELECT gdoc_id FROM sys_gdocid ' +
                 'where (arc_id = ' + IntToStr(ArcId)+') ' +
                 'and (doc_id = ' + IntToStr(DocId)+')';
      DbExecSql(lmq,LastSQL);
      if lmq.recordcount > 0 then
         Result:=lmq.fields[0].AsInteger;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
//3.5.0.60
function GetDocIdString(Delimiter:Char; const ArcId, DocId: int64):string;
var liGDocId:int64;  sID: string;
begin
   liGDocId := GDocIdAnhandArcDocId(iGArcID,iGDocID);
   if liGDocId > 0 then
   begin
      sID := IntToStr(liGDocId);
      Result := 'gdocid' + Delimiter + sID;
   end
   else
   begin 
      sID := IntToStr(iGArcID) + '.' + IntToStr(iGDocID);
      Result := 'docid'+ Delimiter + sID;
   end;
end;

//-----------------------------------------------------------------------------
(*
ArcDocId: das Dokument um das es geht
Zusatzfeld: um welches Zusatzfeld es geht ("add_...")
OldValue: alter Inhalt
NewValue: neuer Inhalt

Hinweise:
statt "like" bei ref_name nehme ich "="
*)
procedure VerknuepfenAnhandZusatzfelder(const ArcDocId:TArcDocId; const Zusatzfeld, OldValue, NewValue:string);
var
  liOptionen, li, liRefLnk:integer;
  lsFeldname, lsZusatzfeldInhalt, lsArcName,
  lsVerknName:string;
  my_q_tmp, my_q_arc, my_q_doclnk:TMyQuery;
  slOldValues, slNewValues:TStringlist;

  //lokale procedure damit es bersichtlicher wird
  procedure Eintragen(lsVerknName:string);
  var lbSchonDa:Boolean; li:integer;
  begin
     //Prfen ob es die Verknpfung fr das Dokument schon gibt
     li := DbCountSql(
        'from sys_doclnk where arc_id = '+IntToStr(ArcDocId.ArcId)+' and '
        +'doc_id = '+IntToStr(ArcDocId.DocId)+' and ' +'ref_name = "'+lsVerknName+'"');
     if li > 0 then
        Exit; // Das Dokument ist schon drin, drfte eigentlich nicht passieren

     //Prfen ob es die Verknpfung berhaupt schon gibt
     DbExecSql(my_q_doclnk,
        'select ref_id, ref_lnk, ref_name from sys_doclnk where ref_name = ' +
        #39 + lsVerknName + #39 + ' and ref_id = ref_lnk');
     lbSchonDa := my_q_doclnk.RecordCount > 0;
     if lbSchonDa then
        liRefLnk := my_q_doclnk.FieldByName('ref_lnk').AsInteger
     else
        liRefLnk := 0;

     // Einen Eintrag anlegen
     // - einfach mal anlegen ohne ref_lnk, ref_id ist auto
     my_q_doclnk.SQL.Text :=
        'Insert into sys_doclnk (arc_id, doc_id, usr_id, ref_name, ref_lnk) '
        +'Values (:arc_id, :doc_id, :usr_id, :ref_name, :ref_lnk )';
     my_q_doclnk.ParamByName('arc_id'  ).AsInteger := ArcDocId.ArcId;
     my_q_doclnk.ParamByName('doc_id'  ).AsInteger := ArcDocId.DocId;
     my_q_doclnk.ParamByName('usr_id'  ).AsInteger := iGUsrID;
     my_q_doclnk.ParamByName('ref_name').AsString  := lsVerknName;
     my_q_doclnk.ParamByName('ref_lnk' ).AsInteger := liRefLnk;
     my_q_doclnk.Execute;
     //li:=my_q_doclnk.InsertId;
     if not lbSchonDa then
     begin
        // - Eintrag gleich wieder holen, weil ref_id ist dann der ref_lnk
        DbExecSql(my_q_doclnk,
           'select * from sys_doclnk where arc_id=:arc_id and doc_id=:doc_id and ref_name=:ref_name');
        if my_q_doclnk.RecordCount = 0 then
          Exit;  // da sollte noch ne Fehlerbehandlung rein
        liRefLnk := my_q_doclnk.FieldByName('ref_id').AsInteger;
        // und bei neuem Eintrag die liRefLnk setzen
        my_q_doclnk.Edit;
        my_q_doclnk.FieldByName('ref_lnk').AsInteger := liRefLnk;
        my_q_doclnk.Post;
     end;
     frm_MainForm.NewHistory(10, _('Dokument mit Referenz')+' '+ lsVerknName +' '+_('verknpft'));
  end;

  procedure Austragen(lsVerknName:string);
  var ls:string;
  begin
     ls:='delete from sys_doclnk where arc_id = '+IntToStr(ArcDocId.ArcId)+' and '
        +'doc_id = '+IntToStr(ArcDocId.DocId)+' and ' +'ref_name = "'+lsVerknName+'"';
     DbExecSql(my_q_doclnk, ls);
     frm_MainForm.NewHistory(10, 'Dokument aus Referenz ' + lsVerknName + ' entfernt');
  end;

  procedure Trimmen(sl:TStringList);
  var li:integer;
  begin
     for li := 0 to slNewValues.Count-1 do
     begin
        slNewValues[li] := trim(ParseSemicolonWithoutBackslash(slNewValues[li]))
     end;
  end;

begin
   // Der Inhalt in den Zusatzfeldern kann mehrere durch Komme getrennte Werte enthalten
   // - aufspalten
   slOldValues := StrToWords7(OldValue);
   slNewValues := StrToWords7(NewValue);
   Trimmen(slOldValues);
   Trimmen(slNewValues);

   try
    // - alte und neue Werte vergleichen
    StrlistsVergleichen(slOldValues, slNewValues);

    my_q_tmp := DbCreateQuery;
    try
     my_q_arc := DbCreateQuery;
     try
      my_q_doclnk := DbCreateQuery;
      try
         DbExecSql(my_q_tmp,
            'select * from sys_arc where arc_id=' + IntToStr(ArcDocId.ArcID));
         if my_q_tmp.RecordCount = 0
         then Exit;
         lsArcName := my_q_tmp.FieldByName('ARC_TBLName').AsString; //z.B. '31072008173538'

         //Tabelle mit den Zusatzfelder holen
         DbExecSql(my_q_tmp, 'select * from cfg_'+lsArcName+' where Feld_Name="'+Zusatzfeld+'"');
         //DbDoSql(my_q_tmp, 'select * from cfg_'+lsArcName+' where Feld_Name="'+Zusatzfeld+'"');
         while not my_q_tmp.eof do // alle (d.h. genaugenommen nur eines) Zusatzfelder durchgehen
         begin
            liOptionen := my_q_tmp.FieldByName('Optionen').AsInteger;
            if (liOptionen and cZusatzFeldOptVerknuepfung)<>0 // nur wenn Option, dann verknpfen
            then
               begin
                  // Feldnamen in der arc-Tabelle holen z.B. add_10072006143438
                  lsFeldname:=my_q_tmp.FieldByName('Feld_Name').AsString;

                  //Archiv-Haupttabelle laden und davon das eine Dokument
                  DbExecSql(my_q_arc, 'select * from arc_'+lsArcName+' where doc_id='+ IntToStr(ArcDocId.DocID));
                  lsZusatzfeldInhalt:=my_q_Arc.FieldByName(lsFeldname).AsString;

                  // Alle alten Verknpfungen eintragen
                  for li := 0 to slOldValues.Count-1 do
                  begin
                     lsVerknName:=slOldValues[li];
                     Austragen(lsVerknName);
                  end;

                  // Alle neuen Verknpfungen eintragen
                  for li := 0 to slNewValues.Count-1 do
                  begin
                     lsVerknName:=slNewValues[li];
                     Eintragen(lsVerknName);
                  end;
               end;
            my_q_tmp.Next;
         end;

         //lsZusatzfeldInhalt:=my_q_tmp.FieldByName(lsFeldname).AsString;

         //frm_MainForm.fra_DocLink.CreLink(lsZusatzfeldInhalt)
      finally
         my_q_doclnk.Free;
      end;
     finally
        my_q_arc.Free;
     end;
    finally
       my_q_tmp.Free;
    end;

   finally
      slOldValues.Free; slNewValues.Free;
   end;
end;


//-----------------------------------------------------------------------------
// fr vtiger [2155] Zusatzfeld-Option Name fr Dokument
// sIArcName und my_q_Arc wird auch bergeben weil er schon da ist und man ihn erst ermitteln msste.

function DateinameAnhandZusatzfelder(const ArcDocId:TArcDocId; const sIArcName:string; const my_q_Arc:TMyQuery):string;
var liOptionen:integer; lsFeldname, lsZusatzfeldInhalt, lsSql:string;
begin
   result:='';

   DbExecSql(dm_DB.my_q_Tmp,'select * from cfg_' + sIarcname);
   while not dm_DB.my_q_Tmp.eof do
   begin
      liOptionen := dm_DB.my_q_Tmp.FieldByName('Optionen').AsInteger;
      if (liOptionen and cZusatzFeldOptNamensfeld)<>0
      then
         begin
            lsFeldname:=dm_DB.my_q_Tmp.FieldByName('Feld_Name').AsString;

            if dm_DB.my_q_Tmp.FieldDefList.Find(lsFeldname) <> nil then  //3.5.0.29
               lsZusatzfeldInhalt := my_q_Arc.FieldByName(lsFeldname).AsString
            else
               begin
                  lsSql := 'select '+lsFeldname+' from arc_'+sIArcName+' where doc_id='+IntToStr(ArcDocId.DocId);
                  lsZusatzfeldInhalt := DbTableColumnValue(lsSql);
               end;

            lsZusatzfeldInhalt := ConvertStringToFileName(lsZusatzfeldInhalt); //3.5.0.22

            if lsZusatzfeldInhalt<>'' then
               begin
                 if result>'' then
                    result := result+'_';
               end;
               result := result+lsZusatzfeldInhalt;
         end;
      dm_DB.my_q_Tmp.Next;
   end;
end;

//-----------------------------------------------------------------------------
procedure IoSaveGraphic(IO: TImageEnIO; sTmpPath:string);
begin
   //ioTiff is buggy, this delete the first page for some docs.
   if IO.Params.FileType = ioTIFF then
      IO.ReplaceFileTIFF(sTmpPath)
   else
      IO.SaveToFile(sTmpPath);
end;

//-----------------------------------------------------------------------------
// Holt von einer Datei eine Prfsumme dazu
function GetSha1FromFile(const filename: string):string;
var lsPfad, lsExe, lsCom, lsOutput: string;  p: integer;  res: DWord;  //lst1: TStringList;
begin
   GgfLogEvnt('GetSha1FromFile filename='+ filename);
   Result := '';
   lsPfad := BD.ExeDir + 'Viewer-files\OpenSSL\bin\';
   lsExe  := lsPfad + 'openssl.exe';

   GgfLogEvnt('GetSha1FromFile lsExe='+ lsExe);
   if not FileExists(lsExe) then
      Exit;
      
   //OpenSSL aufrufen um die Prfsumme zu bekommen
   lsCom := lsExe+' dgst -sha1 '+ filename;
   res := RunWaitAndCaptureOutput(lsCom, lsOutput, 0);
   if res <> 0 then
      Exit;
   // Beginn des Schlssels suchen
   p := Pos('=', lsOutput);
   //if lsOutput[p]=' ' then
      inc(p,2); // "= " berspringen
   Result := copy(lsOutput, p, 40);
   (*
   lst1 := TStringList.Create;
   try
      lst1.LoadFromFile(lsoutput);
   finally
      lst1.Free;
   end;
   *)
end;

//-----------------------------------------------------------------------------
function CheckSha1(const ArcDocId:TArcDocId; const my_q_Arc:TMyQuery):string;
var lmq: TMyQuery;  lsSql: string;
begin
   lmq := DbCreateQuery;
   try
      lsSql := 'select * from'; 
      DbExecSql(lmq,LastSQL);
      Result:=lmq.fields[0].AsString;
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
function GetAdUsername(Owner: TComponent): string;
var
   lADSystemInfo: TADSystemInfo;
   l_aUser: IADsUser;
begin
   Result := '';
   try
      lADSystemInfo := TADSystemInfo.Create(Owner);
      if lADSystemInfo <> nil then
      begin
         if SUCCEEDED(ADsGetObject('LDAP://' + lADSystemInfo.UserName,
            IADsUser, l_aUser)) then
         begin
            Result := l_aUser.Get('sAMAccountName');
            {      l_aUser._Release;
                  lADSystemInfo.Free;}
         end;
      end;
   except
      on e: Exception do
      begin
         LogEvnt('4201  ' + _('Fehler in GetAdUsername:') + ' ' + ' ' + e.Message);
      end;
   end;
end;

//-----------------------------------------------------------------------------
procedure LoadFavStampbuttons(tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5: TTBXItem);
var
   reg: TRegistry;  lsStampName: string;
   slStampKeys: TStringList;
   iCount, lifav: integer;
begin
   reg := TRegistry.Create;
   try
      with reg do
      begin
         slStampKeys := TStringList.Create;
         try
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
            GetKeyNames(slStampKeys);
            CloseKey;
            setlength(gasfavstemp, slStampKeys.Count);
            //Items im Hauptformular
            tbx_fav1.Enabled := False;
            tbx_fav1.visible := False;
            tbx_fav1.Tag := 0;
            tbx_fav2.Enabled := False;
            tbx_fav2.visible := False;
            tbx_fav2.Tag := 0;
            tbx_fav3.Enabled := False;
            tbx_fav3.visible := False;
            tbx_fav3.Tag := 0;
            tbx_fav4.Enabled := False;
            tbx_fav4.visible := False;
            tbx_fav4.Tag := 0;
            tbx_fav5.Enabled := False;
            tbx_fav5.visible := False;
            tbx_fav5.Tag := 0;

            for iCount := 0 to (slStampKeys.Count - 1) do
            begin
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  slStampKeys.Strings[iCount], True);

               if ValueExists('favnr') then
               begin
                  lifav := readinteger('favnr');
                  lsStampName := readstring('StampName');
                  case lifav of
                     1:
                     begin
                        tbx_fav1.Enabled := True;
                        tbx_fav1.visible := True;
                        tbx_fav1.hint := lsStampName;
                        tbx_fav1.Tag := icount;
                     end;
                     2:
                     begin
                        tbx_fav2.Enabled := True;
                        tbx_fav2.visible := True;
                        tbx_fav2.hint := lsStampName;
                        tbx_fav2.Tag := icount;
                     end;
                     3:
                     begin
                        tbx_fav3.Enabled := True;
                        tbx_fav3.visible := True;
                        tbx_fav3.hint := lsStampName;
                        tbx_fav3.Tag := icount;
                     end;
                     4:
                     begin
                        tbx_fav4.Enabled := True;
                        tbx_fav4.visible := True;
                        tbx_fav4.hint := lsStampName;
                        tbx_fav4.Tag := icount;
                     end;
                     5:
                     begin
                        tbx_fav5.Enabled := True;
                        tbx_fav5.visible := True;
                        tbx_fav5.hint := lsStampName;
                        tbx_fav5.Tag := icount;
                     end;
                  end;
                  gasfavstemp[icount] := slStampKeys.Strings[iCount];
               end;
               CloseKey;
            end;
         finally
            slStampKeys.Free;
         end;
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('LoadFavStampbuttons', _('Fehler beim Lesen des Registrierung:') +
            e.Message, 2200, True);
      end;
   end;
end
;
//-----------------------------------------------------------------------------
procedure GetChilds(StartNode: TTreeNode; ChildList: TStringList);
//////////////////////////////////////////////////////////////////
///  03.05.2005 Erstellt by SV.                                ///
///                                                            ///
///  Diese Procedur wertet alle Unterknoten von StartNode aus  ///
///  Und liefert das Ergebnis an eine Stringliste              ///
///                                                            ///
///  Ausgabe: 'ArcName'.Object(ArcID) in ChildList             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   SubNode: TTreeNode;
begin
   SubNode := StartNode.GetFirstChild;
   while Assigned(SubNode) do
   begin
      GetChilds(SubNode, ChildList);
      if SubNode.ImageIndex = 1 then
         ChildList.AddObject(SubNode.Text, TObject(SubNode.Data));
      SubNode := SubNode.getNextSibling;
   end;
end;

//-----------------------------------------------------------------------------
// 
procedure DbSetDate(Arcname, TmpField, NewValue: string; iGDOCID: int64);
//3.5.0.25 var lsSql: string;
var lmq: TMyQuery;
begin
   (* so war das mal.
   lsSql := 'update arc_' + Arcname +
         ' set '+sTmpField+' = '+#39+NewValue+#39 +
         ' where (doc_id='+IntToStr(iGDOCID)+')';
   DbXLog( lsSql,
         _('SaveZusFields TEdit Fehler beim ndern des Inhaltes:')
            + '%e%' + ' mysqltext:' + lsSql);
   *)
   lmq := DbCreateQuery;
   try
      LastSQL := 'select '+TmpField+' from arc_' + Arcname +
                 ' where (doc_id='+IntToStr(iGDOCID)+')';
      DbExecSql(lmq,LastSQL);
      if (NewValue = cEmptyDateString) or (NewValue = '  /  /    ') then
      	NewValue := '';
      lmq.Edit; //#02 Edit;
      lmq.FieldByName(TmpField).AsString := NewValue;
      lmq.Post; //#02
   finally
      lmq.Free;
   end;
end;

//-----------------------------------------------------------------------------
//3.5.0.53 [2304]
procedure DocViewSavesSave(const DocViewSaves: TDocViewSaves);
var i: integer;  Reg: TRegistry;  State: TDocViewSave;  sKey: string;
begin
   reg := TRegistry.Create;
   try
      try
         with Reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\DocView', True);
            for i := Low(DocViewSaves) to High(DocViewSaves) do
            begin
               State := DocViewSaves[i];
               sKey := IntToStr(i);
               Reg.WriteInteger(sKey+'_ArcId',State.Doc.ArcId);
               Reg.WriteInteger(sKey+'_DocId',State.Doc.DocId);
               Reg.WriteInteger(sKey+'_Page',State.Page);
            end;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('DocViewSavesSave',
               _('Fehler beim Schreiben in die Registrierung:') + e.Message, 2200, True);
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


//-----------------------------------------------------------------------------
//3.5.0.53 [2304]
procedure DocViewSavesLoad(var DocViewSaves: TDocViewSaves);
var i: integer;  Reg: TRegistry;  State: TDocViewSave;  sKey: string;
begin
   reg := TRegistry.Create;
   try
      try
         with Reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\DocView', True);
            for i := Low(DocViewSaves) to High(DocViewSaves) do
            begin
               sKey := IntToStr(i);
               State.Doc.ArcId := RegReadInteger(Reg, sKey+'_ArcId',0);
               State.Doc.DocId := RegReadInteger(Reg, sKey+'_DocId',0);
               State.Page      := RegReadInteger(Reg, sKey+'_Page' ,0);
               DocViewSaves[i] := State;
            end;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('DocViewSavesSave',
               _('Fehler beim Schreiben in die Registrierung:') + e.Message, 2200, True);
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

//-----------------------------------------------------------------------------
function StringFromRData(RData:TRData):string;
   procedure one(f:Boolean; Name:string);
   begin
      if f then
         Result := Result + uppercase(Name)+','
      else
         Result := Result + lowercase(Name)+',';
   end;
begin
   Result := '';
   with RData do begin
   One(list        ,'list');
   One(print       ,'print');
   One(Read        ,'Read');
   One(link        ,'link');
   One(modify      ,'modify');
   One(import      ,'import');
   One(Write       ,'Write');
   One(history     ,'history');
   One(mail        ,'mail');
   One(move        ,'move');
   One(aread       ,'aread');
   One(awrite      ,'awrite');
   One(AModify     ,'AModify');
   One(apwrite     ,'apwrite');
   One(apread      ,'apread');
   One(hstprotoread,'hstprotoread');
   One(suanno      ,'suanno');
   One(docdel      ,'docdel');
   One(docexport   ,'docexport');
   end;
end;


//-----------------------------------------------------------------------------
begin end.
//-----------------------------------------------------------------------------