unit u_HistDetail;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, Buttons, StdCtrls, gnugettext,
   u_ShLowUtils;

type
   Tfrm_HistDetail = class (TForm)
      memo_Task: TMemo;
      sbtn_Prev: TSpeedButton;
      sbtn_Next: TSpeedButton;
      lbl_HistIDTxt: TLabel;
      lbl_UsrTxt: TLabel;
      lbl_HistID: TLabel;
      lbl_Usr: TLabel;
      lbl_DatumTxt: TLabel;
      lbl_Datum: TLabel;
      btn_Close: TButton;
      procedure sbtn_PrevClick(Sender: TObject);
      procedure sbtn_NextClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      function ReadHist: boolean;
   end;

var
   frm_HistDetail: Tfrm_HistDetail;

implementation

{$R *.dfm}

uses u_dm_DB, u_MainForm;

function Tfrm_HistDetail.ReadHist: boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///             Fehler werden nun auch Abgefangen              ///
   ///                                                            ///
   ///  Diese Funktion liest den aktuellen History Record aus der  ///
   ///  Tabelle hst_XXXXXXXXX und Zeigt die Werte an.             ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
begin
   Result := True;
   try
      with dm_DB.my_q_Hst do
      begin
         lbl_HistID.Caption := FieldByName('hst_id').AsString;
         lbl_Datum.Caption := DateTimeToStr(FieldByName('tstamp').AsDateTime);
         lbl_Usr.Caption := FieldByName('usr_name').AsString;
         memo_Task.Text := FieldByName('task_info').AsString;
      end;
   except
      on e: Exception do
      begin
         Result := False;
         ErrorMsg('frm_HistDetail.ReadHist',
            _('Fehler beim auslesen eines History Records: ') +
            e.Message, 2035, True);
      end;
   end;
end;

procedure Tfrm_HistDetail.sbtn_PrevClick(Sender: TObject);
begin
   with dm_DB.my_q_Hst do
      Prior;
   ReadHist;
end;

procedure Tfrm_HistDetail.sbtn_NextClick(Sender: TObject);
begin
   with dm_DB.my_q_Hst do
      Next;
   ReadHist;
end;

procedure Tfrm_HistDetail.FormShow(Sender: TObject);
begin
   ReadHist;
end;

procedure Tfrm_HistDetail.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
