{  Copyright (C) 2009 bitfarm Informationssysteme GmbH

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; version 2 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
along with this program (see COPYING or gpl-2.0.txt); if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
}
unit u_Info;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, jpeg, ExtCtrls, ShellAPI;

function GetVersionInfo: string;

type
   Tfrm_Info = class (TForm)
      img_Logo: TImage;
      lbl_Info1: TLabel;
      lbl_Info2: TLabel;
      lbl_Info3: TLabel;
      lbl_Info4: TLabel;
      lbl_Info5: TLabel;
      lbl_Info8: TLabel;
      Button1: TButton;
      lbl_URL: TLabel;
      lbl_Info6: TLabel;
      procedure btn_CloseClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormShow(Sender: TObject);
      procedure FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure Button1Click(Sender: TObject);
      procedure lbl_URLClick(Sender: TObject);
      procedure lbl_URLMouseEnter(Sender: TObject);
      procedure lbl_URLMouseLeave(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure lbl_Info6Click(Sender: TObject);
   private
      procedure CreateParams(var Params: TCreateParams); override;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_Info: Tfrm_Info;

implementation

uses u_Rights, gnugettext;

{$R *.dfm}

function GetVersionInfo: string;
var
   VerInfoSize: DWord;
   VerInfo: Pointer;
   VerValueSize: DWord;
   VerValue: PVSFixedFileInfo;
   Dummy: DWord;
begin
   VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
   GetMem(VerInfo, VerInfoSize);
   GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo);
   VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
   with VerValue^ do
   begin
      Result := IntToStr(dwFileVersionMS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
      Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
   end;
   FreeMem(VerInfo, VerInfoSize);
end;


procedure Tfrm_Info.btn_CloseClick(Sender: TObject);

begin
   frm_Info.Destroy;
end;

procedure Tfrm_Info.FormClose(Sender: TObject; var Action: TCloseAction);
//var alpha : byte;
begin
   //  for alpha := 255 downto 0 do
   //  begin
   //    frm_Info.AlphaBlendValue := alpha;
   //    sleep(10);
   //  end;
   //  frm_Info.Release;
end;

procedure Tfrm_Info.FormShow(Sender: TObject);
begin
   lbl_Info1.Caption := 'bitfarm Archiv V3 Viewer - Version ' + GetVersionInfo + ' (GPL)';
end;

procedure Tfrm_Info.FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
begin
   if key = vk_escape then
      frm_Info.Close;
end;

procedure Tfrm_Info.Button1Click(Sender: TObject);
begin
   Application.CreateForm(Tfrm_Rights, frm_Rights);
   frm_Rights.ShowModal;
   frm_Rights.Release;
end;

procedure Tfrm_Info.lbl_URLClick(Sender: TObject);
begin
   ShellExecute(0, nil, PChar('http://www.bitfarm-archiv.com'), PChar(''),
      PChar(''), SW_NORMAL);
end;

procedure Tfrm_Info.lbl_URLMouseEnter(Sender: TObject);
begin
   lbl_URL.Font.Color := clSkyBlue;
end;

procedure Tfrm_Info.lbl_URLMouseLeave(Sender: TObject);
begin
   lbl_URL.Font.Color := clBlue;
end;

procedure Tfrm_Info.CreateParams(var Params: TCreateParams);
begin
   inherited;
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
end;

procedure Tfrm_Info.FormCreate(Sender: TObject);
begin
   TranslateComponent(self);
end;

procedure Tfrm_Info.lbl_Info6Click(Sender: TObject);
begin

   ShellExecute(0, nil, PChar('http://sourceforge.net/projects/bitfarm-archiv/support'), PChar(''),
      PChar(''), SW_NORMAL);
end;

end.
