unit u_Info;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, jpeg, ExtCtrls, ShellAPI, gnugettext,
   u_ShLowUtils;

function GetVersionInfo: string; //#3.5

type
   Tfrm_Info = class (TForm)
      img_Logo: TImage;
      lbl_Info1: TLabel;
      lbl_Info2: TLabel;
      lbl_Info3: TLabel;
      lbl_Info4: TLabel;
      lbl_Info5: TLabel;
      lbl_Info6: TLabel;
      lbl_Info8: TLabel;
      lbl_Info7: TLabel;
      Button1: TButton;
      lbl_URL: TLabel;
      procedure btn_CloseClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormShow(Sender: TObject);
      procedure FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure Button1Click(Sender: TObject);
      procedure lbl_URLClick(Sender: TObject);
      procedure lbl_URLMouseEnter(Sender: TObject);
      procedure lbl_URLMouseLeave(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   protected
      procedure CreateParams(var Params: TCreateParams); override;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_Info: Tfrm_Info;

implementation

uses u_Rights;

{$R *.dfm}

{3.6<}
function GetVersionInfo: string;
var
   VerInfoSize: DWord;
   VerInfo: Pointer;
   VerValueSize: DWord;
   VerValue: PVSFixedFileInfo;
   Dummy: DWord;
begin
   VerInfoSize := GetFileVersionInfoSize(PChar(BD.ExeFile), Dummy);
   GetMem(VerInfo, VerInfoSize);
   GetFileVersionInfo(PChar(BD.ExeFile), 0, VerInfoSize, VerInfo);
   VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
   with VerValue^ do
   begin
      Result := IntToStr(dwFileVersionMS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionMS and $FFFF);
      Result := Result + '.' + IntToStr(dwFileVersionLS shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionLS and $FFFF);
   end;
   FreeMem(VerInfo, VerInfoSize);
end;
{>3.6}


procedure Tfrm_Info.btn_CloseClick(Sender: TObject);

begin
   frm_Info.Destroy;
end;

procedure Tfrm_Info.FormClose(Sender: TObject; var Action: TCloseAction);
//var alpha : byte;
begin
   //  for alpha := 255 downto 0 do
   //  begin
   //    frm_Info.AlphaBlendValue := alpha;
   //    sleep(10);
   //  end;
   //  frm_Info.Release;
end;

procedure Tfrm_Info.FormShow(Sender: TObject);
begin
   lbl_Info1.Caption := 'bitfarm Archiv V3 Viewer - Version ' + GetVersionInfo;
end;

procedure Tfrm_Info.FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
begin
   if key = vk_escape then
      frm_Info.Close;
end;

procedure Tfrm_Info.Button1Click(Sender: TObject);
begin
   Application.CreateForm(Tfrm_Rights, frm_Rights);
   frm_Rights.ShowModal;
   frm_Rights.Release;
end;

procedure Tfrm_Info.lbl_URLClick(Sender: TObject);
begin
   ShellExecute(0, nil, PChar('http://www.bitfarm-archiv.de'), PChar(''),
      PChar(''), SW_NORMAL);
end;

procedure Tfrm_Info.lbl_URLMouseEnter(Sender: TObject);
begin
   lbl_URL.Font.Color := clSkyBlue;
end;

procedure Tfrm_Info.lbl_URLMouseLeave(Sender: TObject);
begin
   lbl_URL.Font.Color := clBlue;
end;

procedure Tfrm_Info.CreateParams(var Params: TCreateParams);
begin
   inherited;
   (*
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
   *)
end;

procedure Tfrm_Info.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
