//////////////////////////////////////////////////
//  bitfarm-Archiv Login Unit
//  Copyright  1998-2005 Core Lab. All right reserved.
//////////////////////////////////////////////////
//  Igel Featurers

// Igel0612111423 Bug Focus des Loginfensters auch fr Fatalen Anmeldefehler loslassen
// Igel0611300942 Feature Steuerung des Login Fensters in den Vordergrund
//  // Igel0611101431 Timer fr REgistrierungsnag abschalten waerend das Login Fenster gezeigt wird
//  // Igel0611101431 Timer fr REgistrierungsnag einschalten wenn das Login Fenster geschlossen wird
//  // NG Igel0611101415 Feature u_login Das Anmeldefenster bleibt nun on sho immer im Vordergrund
unit u_Login;

interface


{3.6<}
uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, IniFiles, Registry, ShellAPI, Buttons,
   RxGIF, //#3.5
   ComCtrls, JvExComCtrls, JvProgressBar, JvDBProgressBar, gnugettext, jpeg,
   SSPIValidatePasswordW,
   u_ShBase, u_ShLowUtils;
{>3.6}

procedure FindAllFiles(var FileList: TStrings; RootFolder: string;
   Mask: string = '*.*'; Recurse: boolean = True);
//todo for opensource save unencrypted!! hide this function
function lXOR_encryption(const InStr, KeyStr: string): string;
function deldir(dir: string): boolean;

type
   Tfrm_Login = class (TForm)
      img_Logo1: TImage;
      img_Logo2: TImage;
      lbl_User: TLabel;
      lbl_Pass: TLabel;
      lbl_Profil: TLabel;
      cbx_Profil: TComboBox;
      edt_User: TEdit;
      edt_Pass: TEdit;
      lbl_Version: TLabel;
      btn_Login: TButton;
      btn_Exit: TButton;
      shp_Rand: TShape;
      lbl_URL: TLabel;
      cbx_login_optionen: TComboBox;
      play_mod_login: TBitBtn;
      tbi_Optionen: TButton;
      JvGradientProgressBar1: TJvGradientProgressBar;
    img_gpl: TImage;
      procedure btn_ExitClick(Sender: TObject);
      procedure shp_RandMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
      procedure shp_RandMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure FormShow(Sender: TObject);
      procedure btn_LoginClick(Sender: TObject);
      procedure lbl_URLClick(Sender: TObject);
      procedure lbl_URLMouseEnter(Sender: TObject);
      procedure lbl_URLMouseLeave(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormCreate(Sender: TObject);
      function XOR_encryption(const InStr: string): string;
      procedure btn_login_optionenClick(Sender: TObject);
      procedure play_mod_loginClick(Sender: TObject);
      procedure tbi_OptionenClick(Sender: TObject);
   private
      { Private-Deklarationen }
      fbConSavePass: boolean;
      bgSavePass: boolean; //3.5.0.24
      fsdomain: string;
   public
      { Public-Deklarationen }
      fnoshowwindow: boolean;
      fnotpasswordneeded: boolean;
      procedure InitLogin;
      function CheckLogin: boolean;
      procedure SetzeHoehe;
   end;

var
   frm_Login: Tfrm_Login;
   iGX, iGY: integer;
   //3.5.0.24 bgSavePass,
   bShowOpt: Bool;


implementation

uses u_MainForm, u_dm_DB, u_Info, {} u_dm_ViewerMain, u_login_optionen;

{$R *.dfm}


function deldir(dir: string): boolean;
var
   fos: TSHFileOpStruct;
begin
   ZeroMemory(@fos, SizeOf(fos));
   with fos do
   begin
      wFunc := FO_DELETE;
      fFlags := FOF_SILENT or FOF_NOCONFIRMATION;
      pFrom := PChar(dir + #0);
   end;
   Result := (0 = ShFileOperation(fos));
end;

procedure FindAllFiles(var FileList: TStrings; RootFolder: string;
   Mask: string = '*.*'; Recurse: boolean = True);
var
   SR: TSearchRec;
begin
   IncludeTrailingPathDelimiter(RootFolder);

   if Recurse then
      if FindFirst(RootFolder + '*.*', faAnyFile, SR) = 0 then
         try
            repeat
               if SR.Attr and faDirectory = faDirectory then
                  // --> ein Verzeichnis wurde gefunden
                  //   der Verzeichnisname steht in SR.Name
                  //   der vollstndige Verzeichnisname (inkl. darberliegender Pfade) ist
                  //       RootFolder + SR.Name
                  if (SR.Name <> '.') and (SR.Name <> '..') then
                     FindAllFiles(FileList, RootFolder + SR.Name, Mask, Recurse);
            until FindNext(SR) <> 0;
         finally
            FindClose(SR);
         end;
   if FindFirst(RootFolder + Mask, faAnyFile, SR) = 0 then
      try
         repeat
            if SR.Attr and faDirectory <> faDirectory then
            begin
               // --> eine Datei wurde gefunden
               //   der Dateiname steht in SR.Name
               //   der vollstndige Dateiname (inkl. Pfadangabe) ist
               //       RootFolder + SR.Name
               FileList.Add(RootFolder + SR.Name);
            end;
         until FindNext(SR) <> 0;
      finally
         FindClose(SR);
      end;
end;

procedure Tfrm_Login.InitLogin;
var
   reg: TRegistry;
   sFiles: TStrings;
   sFileName, slpass, lsprofil: string;
   iCount: integer;
   ini: TIniFile;
begin
   reg := TRegistry.Create;
   sFiles := TStringList.Create;
   try
      try
         ini := TIniFile.Create(BD.ExeDir + 'scripts.ini');
         if ini.ValueExists('Scripts', 'Profil') then
            lsprofil := ini.ReadString('Scripts', 'Profil', '');
         ini.Free;
         FindAllFiles(sFiles, BD.ExeDir, '*.con', False);
         for iCount := 0 to (sFiles.Count - 1) do
         begin
            sFileName := ExtractFileName(sFiles[iCount]);
            sFiles[iCount] := copy(sFileName, 1, (Length(sFileName) - 4));
         end;
         cbx_Profil.Items := sFiles;
         cbx_Profil.Text := lsprofil;
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
            if ValueExists('User') then
               edt_User.Text := ReadString('User')
            else
               edt_User.Text := '';

            img_gpl.Visible := true;

            bgSavePass := RegReadBool(Reg, 'SavePass', True); //3.5.0.24
            
            if bgSavePass then
            begin
               if ValueExists('Pass') then
                  edt_Pass.Text := ReadString('Pass')
               else
                  edt_Pass.Text := '';
            end
            else
            begin
               edt_Pass.Text := '';
            end;
            if ValueExists('Conn') then
            begin
               if cbx_Profil.Items.IndexOf(ReadString('Conn')) <> -1 then
                  cbx_Profil.ItemIndex := cbx_Profil.Items.IndexOf(ReadString('Conn'))
               else
                  cbx_Profil.ItemIndex := 0;
            end;
            CloseKey;
         end;

         // Ab hier mylogin.ini //3.5.0.24
         ini := TIniFile.Create(BD.MyLoginIniName); //m.frey

         if ini.ValueExists('User', 'UserName') then
         begin
            slpass := ini.ReadString('User', 'UserName', '');
            if slpass <> '' then
               edt_User.Text := slpass;
         end;

         bgSavePass := ini.ReadBool('User', 'SavePass', True);

         if (ini.ValueExists('User', 'Password') and bgSavePass) then
         begin
            slpass := ini.ReadString('User', 'Password', '');
            if slpass <> '' then
               edt_Pass.Text := Decrypt(slpass, Globalkey);
         end;
      except
         on e: Exception do
            ErrorMsg('LoginMod', _('Fehler beim Auslesen der Profile: ') +
               e.Message, 2001, True);
      end;
   finally
      if Assigned(ini) then
         FreeAndNil(ini);
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(sFiles) then
         FreeAndNil(sFiles);
   end;
end;

function Tfrm_Login.CheckLogin: boolean;
var
   ini: TIniFile;
   lsTmp, lsUser: string;
begin
   JvGradientProgressBar1.Position := 10;
   sGConnection := BD.ExeDir + cbx_Profil.Text + '.con';
   ini := TIniFile.Create(sGConnection);
   try
      try
         with ini do
         begin
            dm_DB.my_Con.Disconnect;
            dm_DB.my_con.Server           := ReadString('Connection', 'Server', '');
            dm_DB.my_con.Port             := ReadInteger('Connection', 'Port', 3306);
            dm_DB.my_con.Database         := ReadString('Connection', 'DB', '');
            fsdomain                      := ReadString('Connection', 'Domain', '');
            lsUser                        := Decrypt(ReadString('Connection', 'User', ' '), GlobalKey);
            dm_DB.my_con.Username         := lsUser;
            dm_DB.my_con.Password         :=
               Decrypt(ReadString('Connection', 'Pass', ' '), GlobalKey);
            sGArcPath                     := ReadString('Scripts', 'Archivverzeichnis', '');
            sGclientprogram               := ReadString('Scripts', 'clientprogramm', '');
            sGCopyPath                    := ReadString('Scripts', 'archivkopie', sGArcPath);
            sGClntSpool                   := ReadString('Scripts', 'uncclientspooler', '');
            dm_MainForm2.smtp_Eng.Host     := ReadString('Scripts', 'smtpserver', '');
            dm_MainForm2.fsbuchungsprogramm:=
               ini.ReadString('scripts', 'buchungsprogramm', '');
            fbConSavePass                 := Readbool('Options', 'savepass', true);
            sGSha1ErrorMsg                := ReadString('Options', 'Sha1ErrorMsg', '');
            giRegKeyArchived              := ReadInteger('Options', 'RegKeyArchived', 0);
            dm_MainForm2.fssvn_repository  := ReadString('scripts', 'svn_repository', '');
            if ValueExists('scripts', 'fnd_ext') then
            begin
               frm_MainForm.fnd_ext :=
                  ini.ReadString('scripts', 'fnd_ext', '');
            end;
            if dm_MainForm2.smtp_Eng.Host = '' then
            begin
               frm_MainForm.tbi_VerknuepfungVersenden.Enabled := False;
               //             frm_MainForm.tbi_VerknuepfungVersenden.Visible:=false;
            end;
            dm_DB.my_con.Connect;
         end;
      except
         on e: Exception do
            LogEvnt('2003    Fehler beim Auslesen der Connection: ' + e.Message);
      end;
      Result := dm_DB.my_con.Connected;
      JvGradientProgressBar1.Position := 50;
      if not Result then
      begin
         SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height,
            SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
         SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck

         ShowMessage(_('Fehler!') +
            #13 + _('Es ist konnte keine Verbindung mit dem Archiv') +
            #13 + _('Server hergestellt werden. Whlen Sie ein anderes Profil') +
            #13 + _('oder wenden Sie sich an Ihren Administrator.'));

         JvGradientProgressBar1.Position := 0;
         SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height,
            SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
         SetWindowLong(Handle, GWL_HWNDPARENT, 0);
         // Die Login Form soll immer im Vordergrund bleiben
      end;

      lsTmp := ini.ReadString('Options', 'LogDir', '');
      if lsTmp <> '' then
         begin
            BD.LogPath := lsTmp;
            BD.LogUser := edt_User.Text;
         end
      else
         begin
            BD.LogPath := BD.EnvTemp;
            BD.LogUser := ''; // wenn kein LogPath in con-datei, dann auch kein User
         end;
      gbWithSvnInfo := ini.Readbool('Options', 'SvnInfo', false);
      logevnt('Viewer at login version:' + GetVersionInfo);
      logevnt('gbWithSvnInfo:' + BS(gbWithSvnInfo) );
   finally
      if Assigned(ini) then
         FreeAndNil(ini);
   end;
end;

procedure Tfrm_Login.btn_ExitClick(Sender: TObject);
begin
   frm_Login.Close;
end;

procedure Tfrm_Login.shp_RandMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: integer);
begin
   if Shift = [ssRight] then
   begin
      frm_Login.Left := frm_Login.Left - iGX + x;
      frm_Login.Top := frm_Login.Top - iGY + y;
   end;
end;

procedure Tfrm_Login.shp_RandMouseDown(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: integer);
begin
   if Shift = [ssLeft] then
   begin
      iGX := x;
      iGY := y;
   end;
end;

procedure Tfrm_Login.FormShow(Sender: TObject);
var
   P: TPoint;
begin
   P.X := Width div 2;
   P.Y := Height div 2;
   //P.X := 165;
   //P.Y := 70;

   P := ClientToScreen(P);
   // dont move the mouse cursor!
   // SetCursorPos(P.X, P.Y);
   cbx_login_optionen.ItemIndex := 0;
   InitLogin;

   lbl_Version.Caption := 'Version: ' + GetVersionInfo;
   dm_MainForm2.tim_nag.Enabled := False;
   // Igel0611101430 Timer fr REgistrierungsnag abschalten waerend das Login Fenster gezeigt wird
end;

procedure Tfrm_Login.btn_LoginClick(Sender: TObject);
var
   reg: TRegistry;
   ini: TIniFile;
   lbLoginOk: boolean; // alles fr Anmeldung in Ordnung (Passwort und so ...)
   lsPassDb, lsPassInput: string;
begin
   lbLoginOk := false;
   if CheckLogin then
   begin
      if frm_MainForm.TmpSQL('select * from sys_usr where Usr_Name = ' +
         #34 + edt_User.Text + #34) then
      begin
         JvGradientProgressBar1.Position := 75;
         with dm_DB.my_q_Tmp do
         begin
            lsPassDb := FieldByName('usr_pass').AsString; // das Passwort in der bitfarm-Datenbank
            if RecordCount <> 0 then
            begin
               lsPassInput := Encrypt(edt_Pass.Text, GlobalKey); // das eingegebene Passwort verschlsselt
               if ((fnotpasswordneeded) or (lsPassInput = lsPassDb))
                  and (lsPassDb <> '')
               then
               begin
                  lbLoginOk := true;
               end
               else
               begin
                  if lsPassDb = '' then
                  begin
                     //try to login with ldap
                     try
                        if (edt_Pass.Text = '') // Passwort muss bei AD angegegben werden
                        then
                           lbLoginOk := false // SSPLogonUser liefert bei leerem PW true!
                        else lbLoginOk := SSPLogonUser(fsdomain, edt_User.Text, edt_Pass.Text);
                     except
                        lbLoginOk := false;
                     end;
                  end;
               end;
               // nun ist klar ob alles fr Anmeldung in Ordnung (Passwort und so ...) ist
               if lbLoginOk then
               begin
                  JvGradientProgressBar1.Position := 100;
                  frm_Login.ModalResult := mrOk;
                  iGUsrID := FieldByName('usr_id').AsInteger;
                  sGUsrName := FieldByName('usr_name').AsString;
                  sGUsrEMail := FieldByName('usr_Mail').AsString;
                  reg := TRegistry.Create;
                  ini := TIniFile.Create(BD.MyLoginIniName); //m.frey
                  try
                     try
                        reg.RootKey := HKEY_CURRENT_USER;
                        reg.OpenKey('\Software\bitfarm\Archiv_V3\Viewer\Login', True);
                        reg.WriteString('User', edt_User.Text);
                        reg.WriteString('WindowsUser', BD.EnvUsername);
                        reg.WriteString('mylogin', BD.MyLoginIniName); //m.frey

                        reg.WriteString('Conn', cbx_Profil.Text);
                        reg.WriteString('Confile', BD.ExeDir + cbx_Profil.Text);
                        reg.CloseKey;
                     except
                        on e: Exception do
                           ErrorMsg('btn_LoginClick',
                              _('Fehler beim speichern des Users in der Registrierung: ') +
                              e.Message, 2004, True);
                     end;
                     ini.WriteString('User', 'Profil', cbx_profil.Text);
                     ini.WriteString('User', 'UserName', edt_User.Text);
                     ini.WriteBool('User', 'SavePass', bgSavePass);
                     if bgSavePass and fbConSavePass then
                     begin
                        ini.WriteString('User', 'Password', Encrypt(edt_Pass.Text, GlobalKey));
                     end
                     else
                     begin
                        ini.WriteString('User', 'Password', '');
                     end;
                     ini.UpdateFile;
                  finally
                     if Assigned(reg) then
                        FreeAndNil(reg);
                     if Assigned(ini) then
                        FreeAndNil(ini);
                  end;
               end
               else
               begin
                  ///////////////////////////////////////////////////////////////////////////////////////////////
                  // Igel0611300942 Feature Steuerung des Login Fensters in den Vordergrund
                  // Das Anmeldefenster wird nicht mehr in den Vordergrung gezwungen
                  // Dadurch kann die Fehlermeldung zur Fehlerhaften Passworteingabe im Vordergrund angezeigt werden
                  SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top,
                     Width, Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
                  SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle);     // und zurck

                  //application.NormalizeTopMosts;
                  ShowMessage(_('Benutzer oder Passwort stimmen nicht berein!'));

                  //////////////////////////////////////////////////////////////////////////////////////////////////////////
                  // Igel0611300942 das Anmeldefenster wird wieder in den Vordergrund gezwungen
                  SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height,
                     SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
                  SetWindowLong(Handle, GWL_HWNDPARENT, 0);
                  // Die Login Form soll immer im Vordergrund bleiben
                  //     mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
                  //     mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
               end;
            end
            else
            begin
               SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height,
                  SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
               SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck

               //application.normalizeTopMosts;
               ShowMessage(_('Benutzer oder Passwort stimmen nicht berein!'));

               SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height,
                  SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
               SetWindowLong(Handle, GWL_HWNDPARENT, 0);
               // Die Login Form soll immer im Vordergrund bleiben
               //         mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
               //         mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
            end;
         end;
      end
      else
      begin
         SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height,
            SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
         SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck
         // Igel0612111423 Focus des Loginfensters auch fr Fatalen Anmeldefehler loslassen
         ErrorMsg('btn_LoginClick', _('Fehler beim Auslesen eines Benutzers'),
            2005, True);
         SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height,
            SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
         SetWindowLong(Handle, GWL_HWNDPARENT, 0);
         // Die Login Form soll immer im Vordergrund bleiben
      end;
   end
   else
   begin
      InitLogin;
   end;
   dm_DB.my_q_Tmp.Close;
end;

procedure Tfrm_Login.lbl_URLClick(Sender: TObject);
begin
   ShellExecute(0, nil, PChar('http://www.bitfarm-archiv.de'), PChar(''),
      PChar(''), SW_NORMAL);
end;

procedure Tfrm_Login.lbl_URLMouseEnter(Sender: TObject);
begin
   lbl_Url.Font.Color := clSkyBlue;
end;

procedure Tfrm_Login.lbl_URLMouseLeave(Sender: TObject);
begin
   lbl_URL.Font.Color := clBlue;
end;

procedure Tfrm_Login.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   dm_MainForm2.tim_nag.Enabled := True;
   // Igel0611101430 Feature u_Login Timer fr REgistrierungsnag einschalten wenn das Login Fenster geschlossen wird
end;

procedure Tfrm_Login.FormCreate(Sender: TObject);
begin
   SetzeHoehe;
   TranslateComponent(self, 'Viewerv3');
   SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height,
      SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
   SetWindowLong(Handle, GWL_HWNDPARENT, 0);
   // Die Login Form soll immer im Vordergrund bleiben
   fnoshowwindow := False;
   fnotpasswordneeded := False;
   fbConSavePass := true;
   //  mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);
   //  mouse_event(MOUSEEVENTF_ABSOLUTE or MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
end;

procedure Tfrm_Login.tbi_OptionenClick(Sender: TObject);
begin
   bShowOpt := not bShowOpt;
   SetzeHoehe;
   SetWindowPos(Handle, HWND_TOPMOST, Left, Top, Width, Height, SWP_NOACTIVATE or SWP_NOMOVE);
end;

procedure Tfrm_Login.SetzeHoehe;
begin
   if bshowOpt then
   begin
      frm_login.Clientheight := cbx_login_optionen.Top + cbx_login_optionen.Height+8;
      cbx_login_optionen.Visible := True;
      play_mod_login.Visible := True;
   end
   else
   begin
      frm_login.Clientheight := cbx_login_optionen.Top-2;
      cbx_login_optionen.Visible := False;
      play_mod_login.Visible := False;
   end;
end;



function Tfrm_Login.XOR_encryption(const InStr: string): string;
begin
   Result := lxor_encryption(InStr, 'bitfarmIT-archiv;bitfarm-gmbh');
end;

// from
//http://delphi.blue-aura.co.uk/forum/archive/index.php/t-171.html
function lXOR_encryption(const InStr, KeyStr: string): string;
var
   C1, C2: integer;
   OutStr: string;
   Ch1, Ch2: byte;
begin
   //First initialise the counters to zero
   C1 := 0;
   C2 := 0;

   //initialise the returning string to an empty string
   OutStr := '';

   //We want to loop for as many characters in the Input String
   while (C1 < Length(InStr)) do
   begin
      //first of all, increment the both counters
      Inc(C1);
      Inc(C2);

      //if the second counter is greater than the length of the
      //Key String, then set ot back to 1
      if (C2 > Length(KeyStr)) then
         C2 := 1;

      //get the byte value of the character at the current position
      //of the Input String
      Ch1 := Ord(InStr[C1]);

      //get the byte value of the character at the current position
      //of the Key String. To ensure we do not get any NULL
      //characters during encryption, we add 128 to this value
      Ch2 := Ord(KeyStr[C2]) + 128;

      //Add the XOR'd value of the current Input String position
      //and the current Key String position to the end of the
      //returning string
      OutStr := OutStr + Chr(Ch1 xor Ch2);
   end;

   //return the encrypted/decrypted string
   Result := OutStr;
end;


procedure Tfrm_Login.btn_login_optionenClick(Sender: TObject);
begin
{      SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width,Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);  // und zurck
      SetWindowLong(Handle, GWL_HWNDPARENT, Application.Handle); // und zurck
}
   Application.CreateForm(Tfrm_Login_Optionen, frm_Login_Optionen);
   frm_Login_Optionen.ShowModal;
   //  frm_Info.Release;
     { SetWindowPos(Handle, HWND_TOPMOST, Left,Top, Width,Height, SWP_NOACTIVATE or SWP_NOMOVE or SWP_NOSIZE);
      SetWindowLong(Handle, GWL_HWNDPARENT, 0);   // Die Login Form soll immer im Vordergrund bleiben
      }
end;

procedure Tfrm_Login.play_mod_loginClick(Sender: TObject);
var
   Reg: TRegistry;
   ini: TIniFile;
begin
   case cbx_login_optionen.ItemIndex of
      // formdata reset
      2:
      begin
         try
            Reg := TRegistry.Create;
            Reg.RootKey := HKEY_CURRENT_USER;
            Reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\', True);
            Reg.deletekey('Formdata');

            if (directoryexists(ng_sTreflistDesignPAth)) then
            begin
               try
                  {lbresult := }deldir(ng_sTreflistDesignPAth);
               except
                  on e: Exception do
                     logevnt('Could not delete bfa_hit dir :' + e.message);
               end;
            end;

         finally
            if Assigned(reg) then
               FreeAndNil(reg);
         end;
      end;
      //dont save password
      0:
      begin
         try
            Reg := TRegistry.Create;
            Reg.RootKey := HKEY_CURRENT_USER;
            bgSavePass := False;
            reg.DeleteValue('password');
            Reg.deletekey('Formdata');
            ini := TIniFile.Create(BD.MyLoginIniName); //m.frey
            ini.WriteString('User', 'Profil', cbx_profil.Text);
            ini.WriteBool('User', 'SavePass', bgSavePass);
            ini.WriteString('User', 'Password', '');
            ini.UpdateFile;
         finally
            if Assigned(reg) then
               FreeAndNil(reg);
            if Assigned(ini) then
               FreeAndNil(ini);
         end;
      end;
      // save password
      1:
      begin
         bgSavePass := True;
      end;
      //end of case of
   end;
end;

end.
