unit u_MrgDocs;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, Buttons, TBXStatusBars, ieview, iemview, ComCtrls, StrUtils,
   StdCtrls, gnugettext, u_ShHighUtils, u_ShLowUtils;

type
   Tfrm_MrgDocs = class (TForm)
      img_Mrg: TImageEnMView;
      stb_MrgDocs: TTBXStatusBar;
      sbtn_OK: TSpeedButton;
      sbtn_Cancel: TSpeedButton;
      // Editable filename by revisionssicher files
      Edit1: TEdit;
      StaticText1: TStaticText;
      cbx_Lager: TComboBox;
      cbx_Archiv: TComboBox;
      sbtn_order: TSpeedButton;
      procedure img_MrgMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
      procedure img_MrgEndDrag(Sender, Target: TObject; X, Y: integer);
      procedure img_MrgDragOver(Sender, Source: TObject; X, Y: integer;
         State: TDragState; var Accept: boolean);
      procedure img_MrgDragDrop(Sender, Source: TObject; X, Y: integer);
      procedure sbtn_OKClick(Sender: TObject);
      procedure sbtn_CancelClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure ReadCbxLgr(Sender: TObject);
      procedure ReadCbxArc(Sender: TObject);
      procedure sbtn_orderClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure FormCreate(Sender: TObject);
   private
      revsicher: integer;
      fsDocName: string;
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      fbinit: boolean;
      flstmylist: TStringlist;

      procedure SaveMerge (ArchivID: Integer);
      procedure LoadDocs;
      procedure ShowFileAccessError;
   end;

var
   frm_MrgDocs: Tfrm_MrgDocs;
   // save how many pages a doc has for saving the annotations
   annopages,
   // which pages have actually an annotation?
   annoindex: array of integer;
   // save the file name of existing annotations
   sAnnoFileName: array of string;
// save the annotations in one timagenevect per page
//  Annotations:array of TImageEnVect;

(*
  ==============================================================================
*)
implementation
(*
  ==============================================================================
*)

uses
  u_MainForm,
  u_dm_DB,
  u_mrgdocs_reorder,
  u_ShSql, u_ShDlgAddFields;

{$R *.dfm}

const
  gLocalLog = False;

procedure Tfrm_MrgDocs.ShowFileAccessError;
begin
   BfShowMessage(_('Es ist ein Fehler beim ffnen eines Dokumentes aufgetreten.') +
      #13 + _('Vermutlich fehlt Ihnen die Berechtigung um das Doku-') +
      #13 + _('ment zu ffnen.') + #13 + #13 +
      _('Bitte wenden Sie sich an Ihren Administrator.'));
   frm_MrgDocs.ModalResult := mrCancel;
end;

// was tut das?
procedure Tfrm_MrgDocs.img_MrgMouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: integer);
begin
   if ssLeft in Shift then
   begin
      img_Mrg.MouseInteract := [];
      img_Mrg.IEBeginDrag(True, -1);
   end;
end;

procedure Tfrm_MrgDocs.img_MrgEndDrag(Sender, Target: TObject; X, Y: integer);
begin
   img_Mrg.IEEndDrag;
   img_Mrg.MouseInteract := [mmiSelect];
end;

// bahnhof?

procedure Tfrm_MrgDocs.img_MrgDragOver(Sender, Source: TObject;
   X, Y: integer; State: TDragState; var Accept: boolean);
begin
   if Source is TImageEnMView then
      Accept := True;
end;

// was genau ndert das?
procedure Tfrm_MrgDocs.img_MrgDragDrop(Sender, Source: TObject; X, Y: integer);
var
   iCount, idx, im: integer;
begin
   im := img_Mrg.InsertingPoint(X, Y);
   for iCount := 0 to (img_Mrg.MultiSelectedImagesCount - 1) do
   begin
      idx := img_Mrg.MultiSelectedImages[0];
      img_Mrg.MoveImage(idx, im);
      Inc(im);
   end;
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Dateien zusammenfassen
procedure Tfrm_MrgDocs.LoadDocs;
var
   sPDocFile, sCDocFile, sPExtFile, sCExtFile, sDocName: string;
   counter, idx, page: integer;

begin
   // initialize
   frm_MrgDocs.revsicher := 0;
   setlength(sAnnoFileName, 0);
   setlength(annoindex, 0);
   with frm_MainForm.dbgrd_Trefferliste do
   begin
      setlength(annopages, SelectedRows.Count);
      with dm_DB.my_q_Arc do
      begin
         // Eltern Dokument finden und laden

         GotoBookmark(Pointer(flstmylist.Strings[0]));
         sPDocFile := FieldByName('doc_loc').AsString;
         sPExtFile := FieldByName('ext_loc').AsString;
         sDocName := FieldByName('disp_name').AsString;

         if FileExists(sPExtFile) then
            sPDocFile := sPExtFile;
         if not FileAccessable(sPDocFile) then
         begin
            ShowFileAccessError;
            exit;
         end;
         // skywalker20070612 set the thumbnail dimension, this should be elsewhere,
         // or be dynamic, but later
         img_Mrg.ThumbWidth := 250;
         img_Mrg.ThumbHeight := 320;
         img_Mrg.MIO.LoadFromFile(sPDocFile);
         // store the pages and indexes for the annotations!
         idx := 0;
         annopages[0] := img_Mrg.ImageCount;
         if Pos(sGArcPath, ExtractFilePath(FieldByName('doc_loc').AsString)) = 1 then
            frm_MrgDocs.revsicher := frm_MrgDocs.revsicher or 1
         else
            frm_MrgDocs.revsicher := frm_MrgDocs.revsicher or 2;
         // go to the others selectedrows and load the items
         for page := 0 to annopages[0] - 1 do
         begin
            setlength(sAnnoFileName, length(sAnnoFileName) + 1);
            setlength(annoindex, length(sAnnoFileName));
            sAnnoFileName[length(sAnnoFileName) - 1] :=
               ChangeFileExt(sPDocFile, '') + IntToStr(page) + '.IEV';

            if FileExists(sAnnoFileName[length(sAnnoFileName) - 1]) then
            begin
               // save the future page numebr of this annotation
               annoindex[length(sAnnoFileName) - 1] := page + idx;

               //             Annotations[length(Annotations)-1]:= TImageEnVect.Create(nil);
               //            Annotations[length(Annotations)-1].IO.params.ImagingAnnot.CopyToTImageEnVect(Annotations[length(Annotations)-1]);
               //            Annotations[length(Annotations)-1].LoadFromFileIEV(sAnnoFileName);
            end
            else
            begin
               sAnnoFileName[length(sAnnoFileName) - 1] := '';
            end;
         end;
         for counter := 1 to SelectedRows.Count - 1 do
         begin
            // skywalker20070612 Kind Dokument finden und laden
            GotoBookmark(Pointer(flstmylist.Strings[counter]));
            sCDocFile := FieldByName('doc_loc').AsString;
            sCExtFile := FieldByName('ext_loc').AsString;

            if FileExists(sCExtFile) then
               sCDocFile := sCExtFile;

            if not FileAccessable(sCDocFile) then
            begin
               ShowFileAccessError;
               exit;
            end;

            // store the status: revisionssicher or not for later
            if Pos(sGArcPath, ExtractFilePath(FieldByName('doc_loc').AsString)) =
               1 then  // revisionssicher
               frm_MrgDocs.revsicher := frm_MrgDocs.revsicher or 1
            else
               // nicht revisionssicher
               frm_MrgDocs.revsicher := frm_MrgDocs.revsicher or 2;
            // save the length
            idx := img_Mrg.ImageCount;
            img_Mrg.MIO.LoadFromFile(sCDocFile);
            annopages[counter] := img_Mrg.ImageCount - idx;
            for page := 0 to annopages[counter] - 1 do
            begin
               setlength(sAnnoFileName, length(sAnnoFileName) + 1);
               setlength(annoindex, length(sAnnoFileName));
               sAnnoFileName[length(sAnnoFileName) - 1] :=
                  ChangeFileExt(sCDocFile, '') + IntToStr(page) + '.IEV';
               if FileExists(sAnnoFileName[length(sAnnoFileName) - 1]) then
               begin
                  // save the future page numebr of this annotation
                  annoindex[length(sAnnoFileName) - 1] := page + idx;

                  //             Annotations[length(Annotations)-1]:= TImageEnVect.Create(nil);
                  //            Annotations[length(Annotations)-1].IO.params.ImagingAnnot.CopyToTImageEnVect(Annotations[length(Annotations)-1]);
                  //            Annotations[length(Annotations)-1].LoadFromFileIEV(sAnnoFileName);
               end
               else
               begin
                  sAnnoFileName[length(sAnnoFileName) - 1] := '';
               end;
            end;
         end;


         // skywalker20070612 set the window in a proper size
         if (img_Mrg.ImageCount >= 8) then
         begin
            if ((img_Mrg.ThumbWidth * 4) + 60 > 1100) then
               frm_MrgDocs.Width := 1100
            else
               frm_MrgDocs.Width := (img_Mrg.ThumbWidth * 4) + 60;
            if (img_Mrg.ThumbHeight * ((img_Mrg.ImageCount div 4) + 1) + 30 > 800) then
               frm_MrgDocs.Height := 800
            else
               frm_MrgDocs.Height :=
                  img_Mrg.ThumbHeight * ((img_Mrg.ImageCount div 4) + 1) + 30;

         end
         else
         begin
            if (img_Mrg.ImageCount > 4) then
               frm_MrgDocs.Width := integer(img_Mrg.ThumbWidth * 4 + 60)
            else
               frm_MrgDocs.Width := integer(img_Mrg.ThumbWidth * img_Mrg.ImageCount + 60);

            frm_MrgDocs.Height :=
               integer(img_Mrg.ThumbHeight * ((img_Mrg.ImageCount div 4) + 1) + 50);
         end;
         for counter := 0 to img_Mrg.ImageCount - 1 do
         begin
            img_Mrg.ImageTopText[counter].Caption := 'Seite ' + IntToStr(counter + 1);
         end;
         if frm_MrgDocs.Width < 880 then
         begin
            frm_MrgDocs.Width := 880;
         end;
      end;
   end;
   // allow only revsecure merge or only not revsecure not mixed!!!
   // this is already secured by u_dm_mainform.pas but anyway
   if frm_MrgDocs.revsicher <> 3 then
   begin
      {
           if     frm_MrgDocs.revsicher = 2  then
           begin
                Edit1.visible:=false;
                StaticText1.visible:=false;
           end;
           if     frm_MrgDocs.revsicher = 1  then
           begin  }
      // set the name (dispname) of the first selected document!
      sDocName := sfirstselecteditem;
      fsDocName := sDocName;
      //                DateTimeToString(sFileName, 'ddmmyyyyhhnnss', now);
      //                sFileName := sFileName + IntToStr(Random(999)) +ExtractFileExt(sPDocFile);
      Edit1.Text := sDocName;
      //   end;
   end;
end;

// skywalker20070612 changed the whole document for
// merging and saving more than 2 documents and
// actualizing the changes after saving! (refreshrecord)

(*  Zweck:
      Mehrere Dokumente zusammenfhren und speichern.
    Eingabe:
      'ArchivID': Ist die ID des Archivs, in dem der Vorgang stattfindet.
    Achtung!
      Die Archiv-ID ist in dieser Unit als gobale Variable 'iGArcID' zugnglich.
      Um die Abhngigkeit von globalen Variablen zu verringern, wird der
      Parameter 'ArchivID' eingefhrt und konsequent genutzt.
      Der Name ist so gewhlt, um die Variable besser mit der Suchfunktion
      zu finden.
    Delikatesse:
      'ArcID' und 'DocID' werden oft als 'Int64' deklariert.
      Die 'iGArcID' ist jedoch als 'Integer' deklariert, und viele Prozeduren,
      die die Archiv-ID im Parameter stehen haben, entsprechen dem.
      So auch diese Procedure.
*)
(*
procedure Tfrm_MrgDocs.SaveMerge (ArchivID: Integer);

var
   sDocFile, sExtFile: array of string;
   iDocID: array of integer;
   lNewDocID, counter, counterSave, nb, iTmpRec, iCount, otmpiGDocID, linewarcid: integer;
   slQMetaField, slQMetaName, slVtx: TStrings;
   sQMetaField, slwtrevsicher, srevsicherNewFileName, srevsicherNewAnnoFileName,
   sFileName, sDocDispName, slDocsNames, lssql: string;

   xGDoc: clSysGDocIDRec;

begin
   // initialize
   slVtx := TStringList.Create;
   slQMetaField := TStringList.Create;
   slQMetaName := TStringList.Create;
   sQMetaField := '';
   try
     nb := frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count;

     setlength (SDocFile, nb);
     setlength (sExtFile, nb);
     setlength (iDocID,   nb);

      // Eltern Dokument finden und verndert abspeichern
      dm_DB.my_q_Arc.GotoBookmark (Pointer(flstmylist.Strings[0]));

      sDocFile [0] := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
      sExtFile [0] := StringReplace(sDocFile[0], sGArcPath, sGCopyPath, []);
      iDocID   [0] := dm_DB.my_q_Arc.FieldByName('DOC_ID').Value;
      slVTX.Add      (dm_DB.my_q_Arc.FieldByName('doc_txt').AsString);
      slDocsNames := #34 + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + #34;
      iTmpRec := dm_DB.my_q_Arc.RecNo;
      sDocDispName := dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
      // check for revsicher file name
      // todo saving after the change in the database
      //      could be a problem if the is some error...
      // can be later fixed if needed
      if frm_MrgDocs.revsicher = 1 then
      begin
         // we hope this is
         DateTimeToString(sFileName, 'ddmmyyyyhhnnss', now);
         sFileName := sFileName + IntToStr(Random(999)) + ExtractFileExt(sDocFile[0]);
         srevsicherNewFileName :=
            extractfilepath(StringReplace(sDocFile[0], sGArcPath, sGCopyPath, [])) +
            sFileName;
         while FileExists(srevsicherNewFileName) do
         begin
            sFileName :=
               sFileName + IntToStr(Random(999)) + ExtractFileExt(sDocFile[0]);
            srevsicherNewFileName :=
               extractfilepath(StringReplace(sDocFile[0], sGArcPath, sGCopyPath, [])) +
               sFileName;
         end;
         sDocDispName := Edit1.Text;
      end;
      // if not revsicher save the images now and
      if frm_MrgDocs.revsicher = 2 then
      begin
         try
            begin
               if not DirectoryExists(ExtractFilePath(sExtFile[0])) then
                  CreateDir(ExtractFilePath(sExtFile[0]));
               if FileExists(sExtFile[0]) then
                  // Wenn schon eine Datei existiert bearbeite diese
               begin
                  img_Mrg.MIO.SaveToFile(sExtFile[0]);
               end
               else // Wenn Datei nicht existiert kopiere Sie zuerst und ndere Sie dann.
               begin
                  img_Mrg.MIO.SaveToFile(sExtFile[0]);
                  dm_DB.my_q_Arc.Edit;
                  dm_DB.my_q_Arc.FieldByName('ext_loc').AsString := sExtFile[0];
                  dm_DB.my_q_Arc.Post;
               end;
               sDocDispName := Edit1.Text;
            end;
         except
            on e: Exception do
            begin
               LogEvnt('9000    Allgemeiner Anwendungsfehler:    ' + e.Message);
               frm_mainform.setpanelinfo(
                  _('Fehler beim Speichern der Dokumentennderung. Bitte Berechtigungen prfen.'));
               exit;
            end;
         end;
      end;
      for counter := 1 to frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count - 1 do
      begin
         // Kind Dokument finden und lschen
         dm_DB.my_q_Arc.GotoBookmark(Pointer(flstmylist.Strings[counter]));
         sDocFile [counter] := dm_DB.my_q_Arc.FieldByName ('doc_loc').AsString;
         sExtFile [counter] := dm_DB.my_q_Arc.FieldByName ('ext_loc').AsString;
         iDocID   [counter] := dm_DB.my_q_Arc.FieldByName ('DOC_ID' ).Value;
         slVTX.Add            (dm_DB.my_q_Arc.FieldByName ('doc_txt').AsString);
         if counter <> frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count - 1 then
         begin
            slDocsNames := slDocsNames + ', ' + #34 + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + #34;
         end
         else
         begin
            slDocsNames := slDocsNames + ' ' + _('und') + ' ' + #34 + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + #34;
         end;

         if frm_MrgDocs.revsicher = 2 then
         begin
           //  GDocID's fr zu lschende arc_Eintrge ebenfalls lschen
           //  31.05.2010  Vers. 3.5.0.79  [2516]  r.sch.
           //
           xGDoc := u_ShSql.sysGDocIDTab.getGDocID (ArchivID,
                                                    dm_DB.my_q_Arc.FieldByName ('doc_id').AsInteger);

           if xGDoc <> nil then
           begin
             //  Das Dokument hat eine GDocID
             //
             u_ShSql.sysGDocIDTab.deleteGDocID (xGDoc.GDocID);
           end;

           // delete db entry
           dm_DB.my_q_Arc.Delete;  //  lscht den aktiven Datensatz und mach den nchsten zum aktiven
           // delete files
           if FileExists(sExtFile[counter]) then
              DeleteFile(sExtFile[counter]);
           if FileExists(sDocFile[counter]) then
              DeleteFile(sDocFile[counter]);
         end;
      end;

      // prepare for copy first doc into a new entry!
      if frm_MrgDocs.revsicher = 1 then
      begin
         // Quellzusatzfelder ermitteln
         // Zusatzfelder definitionen stehen in der Tabelle cfg_


         if frm_MainForm.TmpSQL('Select Sql_No_cache * from cfg_' + sIArcName) then
         begin
            with dm_DB.my_q_Tmp do
            begin
               slQMetaField.Clear;
               slQMetaName.Clear;
               while not EOF do
               begin
                  slQMetaField.Add(FieldByName('Feld_Name').AsString);
                  slQMetaName.Add(FieldByName('Disp_Name').AsString);
                  Next;
               end;
               dm_DB.my_q_Tmp.Close;
            end;
         end
         else
         begin
            Close;
            ErrorMsg('MergeDoc',
               _('Fehler beim Verbinden revisionsicherer Dokumente: Auslesen der Quell-MetaFelder.'),
               2023, True);
            Exit;
         end;
         // format for sql query
         for iCount := 0 to slQMetaName.Count - 1 do
         begin
            sQMetaField := sQMetaField + slQMetaField.Strings[iCount] + ', ';
         end;

         // Get an ID for the new Doc


         // Copy informations of the first doc.
         // This Information will be overwritten later!
         // Get lNewDocID, use idocid[0] as example!
         // be careful with locs (this time we dont copy the ext_loc!)
         //
         //  Nur noch mal ins Deutsche bersetzt:
         //  Die Information des 1. Dokuments wird dupliziert.
         //  Dabei entsteht eine neue DocID.
         //  Grund:
         //  Das alte Dokument ist revisionssicher und
         //  darf nicht gelscht werden.
         //  Fr das Neue Dokument wird eine GDocID bentigt.
         //
         dm_DB.my_cmd.SQL.Text := 'Insert into arc_' + sIArcName + ' (' +
            sQMetaField +
            'disp_name, doc_loc,  ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf) ' +
            'Select Sql_No_cache ' + sQMetaField +
            'disp_name, doc_loc,  ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf from arc_'
            + sIArcName + ' where doc_id = ' + IntToStr(iDocID[0]);

         if gLocalLog then
           GgfLogEvnt ('Tfrm_MrgDocs.SaveMerge' +#13+#10
                      + dm_DB.my_cmd.SQL.Text);

         try
           dm_DB.my_cmd.Execute;

           lNewDocID := dm_DB.my_cmd.InsertID;  // get the new doc_id

         except
           on e: Exception do
           begin
             ErrorMsg('MergeDoc',
                 _('Fehler beim Verbinden revisionsicherer Dokumente: ') +
                 e.Message, 2023, True);
             Exit;
           end;
         end;

         xGDoc := u_ShSql.sysGDocIDTab.newGDocID (ArchivID, lNewDocID);

         //  neue GDocID in der Arc-Tabelle sichern
         //  31.05.2010  Vers. 3.5.0.79  [2516]  r.sch.
         //  f.schneider: bitte keine sql abfragen mit zeilenumbrchen
         dm_DB.my_cmd.SQL.Text := 'Update arc_' + sIArcName + ' set'
          +' gdoc_id = ' + IntToStr (xGDoc.GDocID)
          +' where doc_id = ' + IntToStr (xGDoc. DocID);

         if gLocalLog then
           GgfLogEvnt ('Tfrm_MrgDocs.SaveMerge' +#13+#10
                      + dm_DB.my_cmd.SQL.Text);

         try
           dm_DB.my_cmd.Execute;
         except
           on e: Exception do
           begin
             ErrorMsg('MergeDoc',
                 _('Fehler beim Verbinden revisionsicherer Dokumente: ') +
                 e.Message, 2023, True);
             Exit;
           end;
         end;
      end;

      // Archivtabellen berarbeiten...
      with dm_DB.my_cmd do
      begin
         // Child Dokument aus dem Archiv lschen - 17.08.2005 Funktion deaktiviert da berflssig (sv)
      {
      SQL.Text := 'delete from arc_' + sIArcName + ' where doc_id = ' + IntToStr(iCDocID);
      try
        Execute;
      except
        ErrorMsg('MergeDoc', 'Fehler beim lschen des alten Dokumentes.', 1000, True);
      end;
      }
         counterSave := 0;
         for counter := 0 to nb - 1 do
         begin
            counterSave := counter;
            // this code can be optimized in the future
            //  lNewDocID:= iDocID[0];
            // then the second condition can be fussioned with the first... but be careful when fussioning
            // did that for better debugging

            // revsicher docs!
            if frm_MrgDocs.revsicher = 1 then
            begin
               // set right doc name
               SQL.Text := 'Update arc_' + sIArcName + ' set disp_name = ' +
                  #39 + sDocDispName + #39 + ' where doc_id = ' + IntToStr(lNewDocID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Neubenennen.'),
                     1000, True);
               end;
               // Volltexte zusammenfhren
               SQL.Text := 'Update arc_' + sIArcName + ' set doc_txt = :vtx '
                   + ' where doc_id = ' + IntToStr(iDocID[0]);
               ParamByName('vtx').AsString := slVTX.Text;
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Zeilen.'),
                     1000, True);
               end;

               try
                  slVTX.SaveToFile(ChangeFileExt(srevsicherNewFileName, '') + '.txt');
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Speichern der Zeilen.'),
                     1000, True);
               end;
               // schlgwrt we do in one go! to avoid duplicates!
               // connect the idocid[counter] with or
               if ((counter > 0) and (counter < nb - 2)) then
                  slwtrevsicher := slwtrevsicher + ' or ';

               slwtrevsicher := slwtrevsicher + '  doc_id = ' + IntToStr(iDocID[counter]);

               // Verknpfungen des Child Dokumentes dem Parent Dokument zuordnen
               // by resicher you must copy them and put with the new id.
               SQL.Text := 'Insert into sys_doclnk (doc_id, arc_id, usr_id, ref_type, ref_name, ref_lnk) ' +
                  'Select  Sql_No_cache distinct ' + IntToStr(lNewDocID) +
                  ' as doc_id, arc_id, usr_id, ref_type, ref_name, ref_lnk ' +
                  ' from sys_doclnk where doc_id = ' + IntToStr(iDocID[counter]) +
                  ' and arc_id = ' + IntToStr(ArchivID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Verknpfungen.'),
                     1000, True);
               end;
               // History des Child Dokumentes dem Parent Dokument zuordnen
               // Copy History of all and  assign to the lNewDocID
               SQL.Text := 'insert into hst_' + sIArcName +
                  ' (doc_id, usr_id, TStamp, task, task_info) ' +
                  'Select  Sql_No_cache distinct ' + IntToStr(lNewDocID) +
                  ' as doc_id, usr_id, TStamp, task,' + ' task_info from hst_' +
                  sIArcName + ' where doc_id = ' + IntToStr(iDocID[counter]);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Schlagworte.'),
                     1000, True);
               end;
               // copy annotations to the new file
               // go from the first to the last   sAnnoFileName entry
               for  icount := 0 to length(sAnnoFileName) - 1 do
                  if sAnnoFileName[icount] <> '' then
                  begin
                     //    CopyFile (source,target, overwrite)
                     srevsicherNewAnnoFileName :=
                        ChangeFileExt(srevsicherNewFileName, '') +
                        IntToStr(annoindex[icount]) + '.IEV';
                     CopyFile(PChar(sAnnoFileName[icount]), PChar(
                        srevsicherNewAnnoFileName), False);
                     // delete file
                     // KillFile(sAnnoFileName[icount]);
                  end;
                 {
                 // if there is any annotation set ext_loc so
                if length(sAnnoFileName) <> 0 then
                begin
                     SQL.Text := " update
                     }
               // private rights will be not saved to the new document!
            end;
            // not revsicher docs!
            if frm_MrgDocs.revsicher = 2 then
            begin
              xGDoc := u_ShSql.sysGDocIDTab.getGDocID (ArchivID, iDocID[0]);

              if xGDoc = nil then
              begin
                //  Das Dokument hat noch keine GDocID
                //
                xGDoc := u_ShSql.sysGDocIDTab.newGDocID (ArchivID, iDocID[0]);
              end;

               //neubennen
               SQL.Text := 'Update arc_' + sIArcName + ' set'
                 + ' disp_name  = ' + #39 + sDocDispName + #39 +','
                 + ' gdoc_id    = '   + IntToStr (xGDoc.GDocID)  //  31.05.2010  Vers. 3.5.0.79  [2516]  r.sch.
                 + ' where doc_id = '   + IntToStr (iDocID[0]   );

               if gLocalLog then
                 GgfLogEvnt ('Tfrm_MrgDocs.SaveMerge' +#13+#10
                            + SQL.Text);

               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Neubenennen.'),
                     1000, True);
               end;
               // Volltexte zusammenfhren
               SQL.Text := 'Update arc_' + sIArcName + ' set doc_txt = :vtx ' 
                   + ' where doc_id = ' + IntToStr(iDocID[0]);
               ParamByName('vtx').AsString := slVTX.Text;
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Zeilen.'),
                     1000, True);
               end;
               try
                  slVTX.SaveToFile(ChangeFileExt(sExtFile[0], '') + '.txt');
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Speichern der Zeilen.'),
                     1000, True);
               end;
               // Schlagworte des Child Dokumentes dem Parent Dokument zuordnen
               SQL.Text := 'Update slw_' + sIArcName + ' set doc_ID = ' +
                  IntToStr(IDocID[0]) + ' where doc_id = ' + IntToStr(iDocID[counter]);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Schlagworte.'),
                     1000, True);
               end;
               // Verknpfungen des Child Dokumentes dem Parent Dokument zuordnen
               SQL.Text := 'Update sys_doclnk set doc_ID = ' +
                  IntToStr(IDocID[0]) + ' where doc_id = ' + IntToStr(iDocID[counter]) +
                  ' and arc_id = ' + IntToStr(ArchivID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Verknpfungen.'),
                     1000, True);
               end;
               // Berechtigunge des Child Dokumentes lschen
               SQL.Text := 'delete from sys_docxs where doc_id = ' +
                  IntToStr(iDocID[counter]) + ' and arc_id = ' + IntToStr(ArchivID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim lschen der alter Berechtigung.'),
                     1000, True);
               end;

               // History des Child Dokumentes dem Parent Dokument zuordnen
               SQL.Text := 'Update hst_' + sIArcName + ' set doc_ID = ' +
                  IntToStr(IDocID[0]) + ' where doc_id = ' + IntToStr(iDocID[counter]);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Schlagworte.'),
                     1000, True);
               end;
               // copy annotations to the new file
               // go from the first to the last   sAnnoFileName entry
               for  icount := 0 to length(sAnnoFileName) - 1 do
                  if sAnnoFileName[icount] <> '' then
                  begin
                     //    CopyFile (source,target, overwrite)
                     CopyFile(PChar(sAnnoFileName[icount]), PChar(
                        ChangeFileExt(sExtFile[0], '') + IntToStr(annoindex[icount]) +
                        '.IEV'), False);
                     // todo delete file
                     // KillFile(sAnnoFileName[icount]);
                  end;
            end;
         end;

         // do revsicher slwt and avoid duplicates
         // save also file and update ext_loc
         if frm_MrgDocs.revsicher = 1 then
         begin
            iGDocID := lNewDocID;
            // Schlagworte des Dokumentes aus Quelltabelle in Zieltabelle kopieren
            SQL.Text := 'Insert into slw_' + sIArcName + ' (doc_id, doc_slw) ' +
               // the distinct avoid doubles!
               'Select Sql_No_cache distinct ' + IntToStr(lNewDocID) +
               ' as doc_id, doc_slw from slw_' + sIArcName + ' where doc_id = ' +
               IntToStr(iDocID[counterSave]);
            try
               Execute;
            except
               on e: Exception do
               begin
                  ErrorMsg('MergeDoc',
                     _('Fehler beim Neuerzeugen der Schlagwoerter eines Dokumentes: ') +
                     e.Message, 2023, True);
                  Exit;
               end;
            end;
            // todo this could be a problem if  sGCopyPath is not set!!!
            try
               begin
                  if not DirectoryExists(extractFilePath(srevsicherNewFileName)) then
                     CreateDir(ExtractFilePath(extractFilePath(srevsicherNewFileName)));
                  if FileExists(srevsicherNewFileName) then
                     // Wenn schon eine Datei existiert bearbeite diese
                  begin
                     img_Mrg.MIO.SaveToFile(srevsicherNewFileName);
                  end
                  else // Wenn Datei nicht existiert kopiere Sie zuerst und ndere Sie dann.
                  begin
                     img_Mrg.MIO.SaveToFile(srevsicherNewFileName);
                     // Set the right filename (path) in the database
                     // use quote so the string is taken as it is
                     SQL.Text :=
                        'Update arc_' + sIArcName + ' set doc_loc = ' + #39 +
                        stringreplace(srevsicherNewFileName, '\', '\\', [rfReplaceAll]) +
                        #39 + ' where doc_id = ' + IntToStr(lNewDocID);
                          {
                      with dm_DB.my_q_Arc do
                      begin
                       FieldByName('doc_loc').AsString := srevsicherNewFileName;
                      end;
                      }
                     try
                        Execute;
                     except
                        ErrorMsg('MergeDoc',
                           _('Fehler beim Zusammenfhren der Zeilen.'),
                           1000, True);
                     end;
                  end;
               end;
            except
               on e: Exception do
               begin
                  LogEvnt('9000    Allgemeiner Anwendungsfehler:    ' + e.Message);
                  frm_mainform.setpanelinfo(
                     _('Fehler beim Speichern der Dokumentennderung. Bitte Berechtigungen prfen.'));
                  exit;
               end;
            end;
         end;

         if frm_MrgDocs.revsicher = 2 then
         begin
            iGDocID := IDocID[0];
         end;
      end;
      //        iGDocID:=
      // todo need to now if 22 is the right function
      frm_MainForm.NewHistory(22, _('Dokumente') + ' ' + slDocsNames +
         ' ' + _('wurden zu Dokument') + ' ' + #34 + sDocDispName + #34 + ' ' + _('verbunden.'));
      //       iGDocID:=otmpiGDocID;
      //skywalker0706110941
      // update the entries so it shows the volltext right after the merge and not after something else.


      // select the new entry for revisionssicher
      if trim(ParseSemicolonUseBackslash(fsDocName)) <>
         trim(ParseSemicolonUseBackslash(sDocDispName)) then
      begin
         with dm_DB.my_cmd do
         begin
            // todo schlagwrter are being insert, but what if someone want to remove the old one?
            SQL.Text :=
               'Insert into slw_' + sIarcname +
               ' (doc_id, doc_slw) Values (' + IntToStr(lNewDocID) +
               ', ' + #39 + trim(ParseSemicolonUseBackslash(sDocDispName)) + #39 + ')';
            lssql := SQL.Text;
            try
               Execute;
            except
               on e: Exception do
               begin
                  Logevnt('SaveMerge Fehler beim Hinzufgen eines Schlagwortes: '
                     + e.Message + ' mysqltext: ' + lssql);
               end;
            end;
         end;
      end;
      if ((frm_Mainform.cbx_Archiv.Items.IndexOfObject(TObject(ArchivID)) <>
         cbx_archiv.ItemIndex) or (frm_Mainform.cbx_Lager.Items.IndexOfObject(
         TObject(igLgrid)) <> cbx_Lager.ItemIndex)) then
      begin
         linewarcid := integer(cbx_Archiv.Items.Objects[cbx_archiv.ItemIndex]);
         frm_mainform.queryarc('Select * from arc_' + sIarcname + ' where doc_id = ' + inttostr(iGDocID));
         frm_Mainform.MoveDoc(ArchivID, linewarcid, iGDocID, lNewDocID);
         frm_mainform.HandleParam(IntToStr(linewarcid) + '.' + IntToStr(lNewDocID));
         frm_mainform.handledoc; // 04

      end
      else
      begin
         dm_DB.my_q_Arc.Refresh;

         dm_DB.my_q_Arc.RecNo := iTmpRec;
         if frm_MrgDocs.revsicher = 1 then
         begin
            // reset search
            frm_MainForm.btn_ResFieldsClick(TObject(frm_MainForm.dbgrd_Trefferliste));
            // get the new entries
            frm_MainForm.bitbtn1Click(TObject(frm_MainForm.dbgrd_Trefferliste));

            // wait till search is finished!
            // maybe this is not needed!
            while dm_DB.thr_Arc.Count > 1 do
            begin
               sleep(20);
            end;

            counter := 1;
            frm_MainForm.TmpSQL(dm_DB.my_q_Arc.sql.Text);
            //choose the right entry in the list;
            with frm_MainForm.dbgrd_Trefferliste.DataSource.DataSet do
            begin
               while counter <= dm_DB.my_q_Arc.RecordCount do
               begin
                  frm_MainForm.dbgrd_Trefferliste.SelectedIndex := counter;
                  //               frm_MainForm.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
                  if FieldByName('doc_id').Value = lNewDocID then
                  begin
                     break;
                  end;
                  Next;
                  counter := counter + 1;
               end;
            end;
         end;

         if frm_MrgDocs.revsicher = 2 then
         begin
         end;
      end;
   finally

      if Assigned(slVTX) then
         FreeAndNil(slVTX);
   end;
end;  //  Tfrm_MrgDocs.SaveMerge
*)

procedure Tfrm_MrgDocs.SaveMerge (ArchivID: Integer);

var
   sDocFile, sExtFile: array of string;
   iDocID: array of integer;
   lNewDocID, counter, counterSave, nb, iTmpRec, iCount, otmpiGDocID, linewarcid, rc: integer;
   slQMetaField, slQMetaName, slVtx: TStrings;
   sQMetaField, slwtrevsicher, srevsicherNewFileName, srevsicherNewAnnoFileName,
   sFileName, sDocDispName, slDocsNames, lssql, xml: string;
   xGDoc: clSysGDocIDRec;
   slZMetaField, slZMetaName,slZMetaFieldValues, slZMetaFieldType: TStringList;
   lbhaszusfield : Boolean;
//   SaveMergeReq : TRequesthandler;
begin
   // initialize
   slVtx := TStringList.Create;
   slQMetaField := TStringList.Create;
   slQMetaName := TStringList.Create;
   sQMetaField := '';

   try
      nb := frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count;

      setlength (SDocFile, nb);
      setlength (sExtFile, nb);
      setlength (iDocID,   nb);

      // Eltern Dokument finden und verndert abspeichern
      dm_DB.my_q_Arc.GotoBookmark (Pointer(flstmylist.Strings[0]));

      sDocFile [0] := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
      sExtFile [0] := StringReplace(sDocFile[0], sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);
      iDocID   [0] := dm_DB.my_q_Arc.FieldByName('DOC_ID').Value;
      slVTX.Add      (dm_DB.my_q_Arc.FieldByName('doc_txt').AsString);
      slDocsNames := #34 + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + #34;
      iTmpRec := dm_DB.my_q_Arc.RecNo;
      sDocDispName := dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
      // check for revsicher file name
      // todo saving after the change in the database
      //      could be a problem if the is some error...
      // can be later fixed if needed
      if frm_MrgDocs.revsicher = 1 then
      begin
         // we hope this is
         DateTimeToString(sFileName, 'ddmmyyyyhhnnss', now);
         sFileName := sFileName + IntToStr(Random(999)) + ExtractFileExt(sDocFile[0]);
         srevsicherNewFileName :=
            extractfilepath(StringReplace(sDocFile[0], sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase])) +
            sFileName;
         while FileExists(srevsicherNewFileName) do
         begin
            sFileName :=
               sFileName + IntToStr(Random(999)) + ExtractFileExt(sDocFile[0]);
            srevsicherNewFileName :=
               extractfilepath(StringReplace(sDocFile[0], sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase])) +
               sFileName;
         end;
         sDocDispName := Edit1.Text;
      end;
      // if not revsicher save the images now and
      if frm_MrgDocs.revsicher = 2 then
      begin
         try
//            if Viewer.ConnectionType = vctpNormal then
//            begin
               begin
                  if not DirectoryExists(ExtractFilePath(sExtFile[0])) then
                     ForceDirectories(ExtractFilePath(sExtFile[0]));
                  if FileExists(sExtFile[0]) then
                     // Wenn schon eine Datei existiert bearbeite diese
                  begin
                     img_Mrg.MIO.SaveToFile(sExtFile[0]);
                  end
                  else // Wenn Datei nicht existiert kopiere Sie zuerst und ndere Sie dann.
                  begin
                     img_Mrg.MIO.SaveToFile(sExtFile[0]);
                     dm_DB.my_q_Arc.Edit;
                     dm_DB.my_q_Arc.FieldByName('ext_loc').AsString := sExtFile[0];
                     dm_DB.my_q_Arc.Post;
                  end;
                  sDocDispName := Edit1.Text;
               end;
//         	end
//            else
//            begin
//               Viewer.FStreamTIF.Clear;
//               img_Mrg.MIO.SaveToStreamTIFF(Viewer.FStreamTIF);
//               Viewer.FStreamTIF.Position:= 0;
//               xml := '';
//               SaveMergeReq := TRequesthandler.Create;
//               SaveMergeReq.Clear;
//               SaveMergeReq.reqType:= strReqSendVoransicht;
//               SaveMergeReq.gdocId:= dm_DB.my_q_Arc.FieldByName('gdocid').AsInteger;
//               SaveMergeReq.user:= Viewer.UserID;
//               SaveMergeReq.dataLen := Viewer.FStreamTIF.Size;
//               xml := SaveMergeReq.createXMLString;
//               if Viewer.FStreamTIF.Size > 0 then
//               begin
//                  rc := Viewer.Document.SendWithStream(xml, Viewer.FStreamTIF);
//                  if rc = respError then
//                  begin
//                     ShowMessage('Fehler beim Speichern der leeren Seite');
//                     Viewer.Document.EndSaveProcess;
//                  end;
//               end;
//               FreeAndNil(SaveMergeReq);
//            end;

         except
            on e: Exception do
            begin
               LogEvnt('9000 - 4   Allgemeiner Anwendungsfehler:    ' + e.Message);
               frm_mainform.setpanelinfo(
                  _('Fehler beim Speichern der Dokumentennderung. Bitte Berechtigungen prfen.'));
               exit;
            end;
         end;
      end;
      for counter := 1 to frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count - 1 do
      begin
         // Kind Dokument finden und lschen
         dm_DB.my_q_Arc.GotoBookmark(Pointer(flstmylist.Strings[counter]));
         sDocFile [counter] := dm_DB.my_q_Arc.FieldByName ('doc_loc').AsString;
         sExtFile [counter] := dm_DB.my_q_Arc.FieldByName ('ext_loc').AsString;
         iDocID   [counter] := dm_DB.my_q_Arc.FieldByName ('DOC_ID' ).Value;
         slVTX.Add            (dm_DB.my_q_Arc.FieldByName ('doc_txt').AsString);
         if counter <> frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count - 1 then
         begin
            slDocsNames := slDocsNames + ', ' + #34 + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + #34;
         end
         else
         begin
            slDocsNames := slDocsNames + ' ' + _('und') + ' ' + #34 + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + #34;
         end;

         if frm_MrgDocs.revsicher = 2 then
         begin
           //  GDocID's fr zu lschende arc_Eintrge ebenfalls lschen
           //  31.05.2010  Vers. 3.5.0.79  [2516]  r.sch.
           //
           xGDoc := u_ShSql.sysGDocIDTab.getGDocID (ArchivID,
                                                    dm_DB.my_q_Arc.FieldByName ('doc_id').AsInteger);

           if xGDoc <> nil then
           begin
             //  Das Dokument hat eine GDocID
             //
             u_ShSql.sysGDocIDTab.deleteGDocID (xGDoc.GDocID);
           end;

           // delete db entry
           dm_DB.my_q_Arc.Delete;  //  lscht den aktiven Datensatz und mach den nchsten zum aktiven
           // delete files

//         	if Viewer.ConnectionType = vctpNormal then
//				begin
              if FileExists(sExtFile[counter]) then
                 DeleteFile(sExtFile[counter]);
              if FileExists(sDocFile[counter]) then
                 DeleteFile(sDocFile[counter]);
//            end;

         end;

      end;

      // prepare for copy first doc into a new entry!
      if frm_MrgDocs.revsicher = 1 then
      begin
         // Quellzusatzfelder ermitteln
         // Zusatzfelder definitionen stehen in der Tabelle cfg_

         if frm_MainForm.TmpSQL('Select Sql_No_cache * from cfg_' + sIArcName) then
         begin
            with dm_DB.my_q_Tmp do
            begin
               slQMetaField.Clear;
               slQMetaName.Clear;
               while not EOF do
               begin
                  slQMetaField.Add(FieldByName('Feld_Name').AsString);
                  slQMetaName.Add(FieldByName('Disp_Name').AsString);
                  Next;
               end;
               dm_DB.my_q_Tmp.Close;
            end;
         end
         else
         begin
            Close;
            ErrorMsg('MergeDoc',
               _('Fehler beim Verbinden revisionsicherer Dokumente: Auslesen der Quell-MetaFelder.'),
               2023, True);
            Exit;
         end;
         // format for sql query
         for iCount := 0 to slQMetaName.Count - 1 do
         begin
            sQMetaField := sQMetaField + slQMetaField.Strings[iCount] + ', ';
         end;

         // Get an ID for the new Doc

         // Copy informations of the first doc.
         // This Information will be overwritten later!
         // Get lNewDocID, use idocid[0] as example!
         // be careful with locs (this time we dont copy the ext_loc!)
         //
         //  Nur noch mal ins Deutsche bersetzt:
         //  Die Information des 1. Dokuments wird dupliziert.
         //  Dabei entsteht eine neue DocID.
         //  Grund:
         //  Das alte Dokument ist revisionssicher und
         //  darf nicht gelscht werden.
         //  Fr das Neue Dokument wird eine GDocID bentigt.
         //
         dm_DB.my_cmd.SQL.Text := 'Insert into arc_' + sIArcName + ' (' +
            sQMetaField +
            'disp_name, doc_loc,  ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf) ' +
            'Select Sql_No_cache ' + sQMetaField +
            'disp_name, doc_loc,  ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf from arc_'
            + sIArcName + ' where doc_id = ' + IntToStr(iDocID[0]);

         try
           dm_DB.my_cmd.Execute;

           lNewDocID := dm_DB.my_cmd.InsertID;  // get the new doc_id

         except
           on e: Exception do
           begin
             ErrorMsg('MergeDoc',
                 _('Fehler beim Verbinden revisionsicherer Dokumente: ') +
                 e.Message, 2023, True);
             Exit;
           end;
         end;

         xGDoc := u_ShSql.sysGDocIDTab.newGDocID (ArchivID, lNewDocID);

         //  neue GDocID in der Arc-Tabelle sichern
         //  31.05.2010  Vers. 3.5.0.79  [2516]  r.sch.
         //  f.schneider: bitte keine sql abfragen mit zeilenumbrchen
         dm_DB.my_cmd.SQL.Text := 'Update arc_' + sIArcName + ' set'
          +' gdoc_id = ' + IntToStr (xGDoc.GDocID)
          +' where doc_id = ' + IntToStr(xGDoc. DocID);

         try
           dm_DB.my_cmd.Execute;
         except
           on e: Exception do
           begin
             ErrorMsg('MergeDoc',
                 _('Fehler beim Verbinden revisionsicherer Dokumente: ') +
                 e.Message, 2023, True);
             Exit;
           end;
         end;

         dm_DB.my_cmd.SQL.Text :=
            'Update arc_' + sIArcName + ' set doc_loc = ' + #39 +
            stringreplace(srevsicherNewFileName, '\', '\\', [rfReplaceAll,rfIgnoreCase]) +
            #39 + ' where doc_id = ' + IntToStr(xGDoc. DocID);

         try
            dm_DB.my_cmd.Execute;
         except
            ErrorMsg('MergeDoc', _('Fehler beim Setzen von Doc_Loc.'),
               1000, True);
         end;
      end;

      // Archivtabellen berarbeiten...
      with dm_DB.my_cmd do
      begin
         // Child Dokument aus dem Archiv lschen - 17.08.2005 Funktion deaktiviert da berflssig (sv)
         counterSave := 0;
         for counter := 0 to nb - 1 do
         begin
            counterSave := counter;
            // this code can be optimized in the future
            //  lNewDocID:= iDocID[0];
            // then the second condition can be fussioned with the first... but be careful when fussioning
            // did that for better debugging

            // revsicher docs!
            if frm_MrgDocs.revsicher = 1 then
            begin
               // set right doc name
               SQL.Text := 'Update arc_' + sIArcName + ' set disp_name = ' +
                  #39 + sDocDispName + #39 + ' where doc_id = ' + IntToStr(lNewDocID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Neubenennen.'),
                     1000, True);
               end;
               // Volltexte zusammenfhren
               SQL.Text := 'Update arc_' + sIArcName + ' set doc_txt = :vtx ' 
                   + ' where doc_id = ' + IntToStr(iDocID[0]);
               ParamByName('vtx').AsString := slVTX.Text;
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Zeilen.'),
                     1000, True);
               end;

               // die zustzliche txt-datei speichern wir nur im share-mode
//               if Viewer.ConnectionType = vctpNormal then
//               begin
                  try
                     slVTX.SaveToFile(ChangeFileExt(srevsicherNewFileName, '') + '.txt');
                  except
                     ErrorMsg('MergeDoc', _('Fehler beim Speichern der Zeilen.'),
                        1000, True);
                  end;
//               end;

               // schlagwort we do in one go! to avoid duplicates!
               // connect the idocid[counter] with or
               if ((counter > 0) and (counter < nb - 2)) then
                  slwtrevsicher := slwtrevsicher + ' or ';

               slwtrevsicher := slwtrevsicher + '  doc_id = ' + IntToStr(iDocID[counter]);

               // Verknpfungen des Child Dokumentes dem Parent Dokument zuordnen
               // by resicher you must copy them and put with the new id.
               SQL.Text := 'Insert into sys_doclnk (doc_id, arc_id, usr_id, ref_type, ref_name, ref_lnk) ' +
                  'Select  Sql_No_cache distinct ' + IntToStr(lNewDocID) +
                  ' as doc_id, arc_id, usr_id, ref_type, ref_name, ref_lnk ' +
                  ' from sys_doclnk where doc_id = ' + IntToStr(iDocID[counter]) +
                  ' and arc_id = ' + IntToStr(ArchivID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Verknpfungen.'),
                     1000, True);
               end;

               // History des Child Dokumentes dem Parent Dokument zuordnen
               // Copy History of all and  assign to the lNewDocID
               SQL.Text := 'insert into hst_' + sIArcName +
                  ' (doc_id, usr_id, TStamp, task, task_info) ' +
                  'Select  Sql_No_cache distinct ' + IntToStr(lNewDocID) +
                  ' as doc_id, usr_id, TStamp, task,' + ' task_info from hst_' +
                  sIArcName + ' where doc_id = ' + IntToStr(iDocID[counter]);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Schlagworte.'),
                     1000, True);
               end;
            end;
            // not revsicher docs!
            if frm_MrgDocs.revsicher = 2 then
            begin
              xGDoc := u_ShSql.sysGDocIDTab.getGDocID (ArchivID, iDocID[0]);

              if xGDoc = nil then
              begin
                //  Das Dokument hat noch keine GDocID
                //
                xGDoc := u_ShSql.sysGDocIDTab.newGDocID (ArchivID, iDocID[0]);
              end;

               //neubennen
               SQL.Text := 'Update arc_' + sIArcName + ' set'
                 + ' disp_name  = ' + #39 + sDocDispName + #39 +','
                 + ' gdoc_id    = '   + IntToStr (xGDoc.GDocID)  //  31.05.2010  Vers. 3.5.0.79  [2516]  r.sch.
                 + ' where doc_id = '   + IntToStr (iDocID[0]   );

               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Neubenennen.'),
                     1000, True);
               end;
               // Volltexte zusammenfhren
               SQL.Text := 'Update arc_' + sIArcName + ' set doc_txt = :vtx ' 
                   + ' where doc_id = ' + IntToStr(iDocID[0]);
               ParamByName('vtx').AsString := slVTX.Text;
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Zeilen.'),
                     1000, True);
               end;

               // die zustzliche txt-datei speichern wir nur im share-mode
//               if Viewer.ConnectionType = vctpNormal then
//               begin
	               try
                     slVTX.SaveToFile(ChangeFileExt(sExtFile[0], '') + '.txt');
                  except
                     ErrorMsg('MergeDoc', _('Fehler beim Speichern der Zeilen.'),
                        1000, True);
                  end;
//               end;

               // Schlagworte des Child Dokumentes dem Parent Dokument zuordnen
               SQL.Text := 'Update slw_' + sIArcName + ' set doc_ID = ' +
                  IntToStr(IDocID[0]) + ' where doc_id = ' + IntToStr(iDocID[counter]);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Schlagworte.'),
                     1000, True);
               end;
               // Verknpfungen des Child Dokumentes dem Parent Dokument zuordnen
               SQL.Text := 'Update sys_doclnk set doc_ID = ' +
                  IntToStr(IDocID[0]) + ' where doc_id = ' + IntToStr(iDocID[counter]) +
                  ' and arc_id = ' + IntToStr(ArchivID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Verknpfungen.'),
                     1000, True);
               end;
               // Berechtigunge des Child Dokumentes lschen
               SQL.Text := 'delete from sys_docxs where doc_id = ' +
                  IntToStr(iDocID[counter]) + ' and arc_id = ' + IntToStr(ArchivID);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim lschen der alter Berechtigung.'),
                     1000, True);
               end;

               // History des Child Dokumentes dem Parent Dokument zuordnen
               SQL.Text := 'Update hst_' + sIArcName + ' set doc_ID = ' +
                  IntToStr(IDocID[0]) + ' where doc_id = ' + IntToStr(iDocID[counter]);
               try
                  Execute;
               except
                  ErrorMsg('MergeDoc', _('Fehler beim Zusammenfhren der Schlagworte.'),
                     1000, True);
               end;
            end;
         end;


         // do revsicher slwt and avoid duplicates
         // save also file and update ext_loc
         if frm_MrgDocs.revsicher = 1 then
         begin
            iGDocID := lNewDocID;
            // Schlagworte des Dokumentes aus Quelltabelle in Zieltabelle kopieren
            SQL.Text := 'Insert into slw_' + sIArcName + ' (doc_id, doc_slw) ' +
               // the distinct avoid doubles!
               'Select Sql_No_cache distinct ' + IntToStr(lNewDocID) +
               ' as doc_id, doc_slw from slw_' + sIArcName + ' where doc_id = ' +
               IntToStr(iDocID[counterSave]);
            try
               Execute;
            except
               on e: Exception do
               begin
                  ErrorMsg('MergeDoc',
                     _('Fehler beim Neuerzeugen der Schlagwoerter eines Dokumentes: ') +
                     e.Message, 2023, True);
                  Exit;
               end;
            end;
            // todo this could be a problem if  sGCopyPath is not set!!!
            try
               begin
//               	if Viewer.ConnectionType = vctpNormal then
//                  begin
                     if not DirectoryExists(extractFilePath(srevsicherNewFileName)) then
                        ForceDirectories(ExtractFilePath(extractFilePath(srevsicherNewFileName)));
                     if FileExists(srevsicherNewFileName) then
                        // Wenn schon eine Datei existiert bearbeite diese
                     begin
                        img_Mrg.MIO.SaveToFile(srevsicherNewFileName);
                     end
                     else // Wenn Datei nicht existiert kopiere Sie zuerst und ndere Sie dann.
                     begin
                        img_Mrg.MIO.SaveToFile(srevsicherNewFileName);
                        // Set the right filename (path) in the database
                        // use quote so the string is taken as it is

                     end;
//                  end
//                  else
//                  begin
//                     Viewer.FStreamTIF.Clear;
//                     img_Mrg.MIO.SaveToStreamTIFF(Viewer.FStreamTIF);
//                     Viewer.FStreamTIF.Position:= 0;
//                     if Viewer.FStreamTIF.Size > 0 then
//                     begin
//                     	xml := '';
//                        SaveMergeReq := TRequesthandler.Create;
//                        SaveMergeReq.Clear;
//                        SaveMergeReq.reqType:= strReqSendVoransicht;
//                        SaveMergeReq.gdocId:= xGDoc.GDocID;
//                        SaveMergeReq.user:= Viewer.UserID;
//                        SaveMergeReq.dataLen := Viewer.FStreamTIF.Size;
//                        xml := SaveMergeReq.createXMLString;
//                        rc := Viewer.Document.SendWithStream(xml, Viewer.FStreamTIF);
//                        if rc = respError then
//                        begin
//                           ShowMessage('Fehler beim Speichern der leeren Seite');
//                           Viewer.Document.EndSaveProcess;
//                        end;
//                        FreeAndNil(SaveMergeReq);
//                     end;
//                  end;
               end;
            except
               on e: Exception do
               begin
                  LogEvnt('9000 - 5   Allgemeiner Anwendungsfehler:    ' + e.Message);
                  frm_mainform.setpanelinfo(
                     _('Fehler beim Speichern der Dokumentennderung. Bitte Berechtigungen prfen.'));
                  exit;
               end;
            end;
         end;

         if frm_MrgDocs.revsicher = 2 then
         begin
            iGDocID := IDocID[0];
         end;

         // Annotations

         if frm_MrgDocs.revsicher = 1 then
         begin
//         	if Viewer.ConnectionType = vctpNormal then
//            begin
               for  icount := 0 to length(sAnnoFileName) - 1 do
                  if sAnnoFileName[icount] <> '' then
                  begin
                     //    CopyFile (source,target, overwrite)
                     srevsicherNewAnnoFileName :=
                        ChangeFileExt(srevsicherNewFileName, '') +
                        IntToStr(icount) + '.IEV';
                     CopyFile(PChar(sAnnoFileName[icount]), PChar(
                        srevsicherNewAnnoFileName), False);
                     // delete file
                     // KillFile(sAnnoFileName[icount]);
                  end;

//            end
//            else
//            begin
//               for  icount := 0 to length(AnnoStreams) - 1 do
//                  if AnnoStreams[icount] <> nil then
//                  begin
//                     if AnnoStreams[icount].Size > 0 then
//                     begin
//                     	xml := '';
//                        SaveMergeReq := TRequesthandler.Create;
//                        SaveMergeReq.Clear;
//								SaveMergeReq.reqType:= strReqSendIev;
//                        SaveMergeReq.page:= icount;
//                        SaveMergeReq.ievType :=  strIEVPublic;
//                        SaveMergeReq.ievUser := Viewer.UserID;
//                        SaveMergeReq.gdocId:= xGDoc.GDocID;
//                        SaveMergeReq.user:= Viewer.UserID;
//                        AnnoStreams[icount].Position := 0;
//                        SaveMergeReq.dataLen :=  AnnoStreams[icount].Size;
//                        xml := SaveMergeReq.createXMLString;
//                        Viewer.Document.SendWithStream(xml, AnnoStreams[icount]);
//                        FreeAndNil(SaveMergeReq);
//                     end;
//                  end;
//
//            end;


         end;
         if frm_MrgDocs.revsicher = 2 then
         begin
         		// copy annotations to the new file
//               if Viewer.ConnectionType = vctpNormal then
//               begin

               	// go from the first to the last   sAnnoFileName entry
                  for  icount := 0 to length(sAnnoFileName) - 1 do
                     if sAnnoFileName[icount] <> '' then
                     begin
                        //    CopyFile (source,target, overwrite)
                        CopyFile(PChar(sAnnoFileName[icount]), PChar(
                           ChangeFileExt(sExtFile[0], '') + IntToStr(icount) + '.IEV'), False);
                        // todo delete file
                        // KillFile(sAnnoFileName[icount]);
                     end;
//              	end
//              	else
//              	begin
//              		for  icount := 0 to length(AnnoStreams) - 1 do
//                     if AnnoStreams[icount] <> nil then
//                     begin
//                        if AnnoStreams[icount].Size > 0 then
//                        begin
//                           xml := '';
//                           SaveMergeReq := TRequesthandler.Create;
//                           SaveMergeReq.Clear;
//                           SaveMergeReq.reqType:= strReqSendIev;
//                           SaveMergeReq.page:= icount;
//                           SaveMergeReq.ievType :=  strIEVPublic;
//                           SaveMergeReq.ievUser := Viewer.UserID;
//                           SaveMergeReq.gdocId:= xGDoc.GDocID;
//                           SaveMergeReq.user:= Viewer.UserID;
//                           AnnoStreams[icount].Position := 0;
//                           SaveMergeReq.dataLen :=  AnnoStreams[icount].Size;
//                           xml := SaveMergeReq.createXMLString;
//                           Viewer.Document.SendWithStream(xml, AnnoStreams[icount]);
//                           FreeAndNil(SaveMergeReq);
//                        end;
//                  	end;
//              	end;
         end;
      end;


      NewHistoryID(22, _('Dokumente') + ' ' + slDocsNames +
         ' ' + _('wurden zu Dokument') + ' ' + #34 + sDocDispName + #34 + ' ' + _('verbunden.'), iGArcID, iGDocID, iGUsrID);

      // select the new entry for revisionssicher
      if trim(ParseSemicolonUseBackslash(fsDocName)) <>
         trim(ParseSemicolonUseBackslash(sDocDispName)) then
      begin
         with dm_DB.my_cmd do
         begin
            // todo schlagwrter are being insert, but what if someone want to remove the old one?
            //showmessage('Insert into slw_' + sIArcName + ' (doc_id, doc_slw) Values (' + IntToStr(iGDocID) + ', ' + #39 + TEdit(Comp).Text + #39 + ')');
            SQL.Text := 'Insert into slw_' + sIarcname +
               ' (doc_id, doc_slw) Values (' + IntToStr(lNewDocID) +
               ', ' + #39 + trim(ParseSemicolonUseBackslash(sDocDispName)) + #39 + ')';
            lssql := SQL.Text;
            try
               Execute;
            except
               on e: Exception do
               begin
                  Logevnt('SaveMerge Fehler beim Hinzufgen eines Schlagwortes: '
                     + e.Message + ' mysqltext: ' + lssql);
               end;
            end;
         end;
      end;
      if ((frm_Mainform.cbx_Archiv.Items.IndexOfObject(TObject(ArchivID)) <>
         cbx_archiv.ItemIndex) or (frm_Mainform.cbx_Lager.Items.IndexOfObject(
         TObject(igLgrid)) <> cbx_Lager.ItemIndex)) then
      begin
			linewarcid := integer(cbx_Archiv.Items.Objects[cbx_archiv.ItemIndex]);

         slZMetaField      := TStringList.Create;
         slZMetaFieldValues:= TStringList.Create;
         slZMetaName       := TStringList.Create;
         slZMetaFieldType  := TStringList.Create;

         GgfLogEvnt('SaveMerge - Select Sql_No_cache * from cfg_' + GSysArc[linewarcid].TblName);
         if frm_MainForm.TmpSQL('Select Sql_No_cache * from cfg_' + GSysArc[linewarcid].TblName) then
         begin
            with dm_DB.my_q_Tmp do
            begin
               slZMetaField.Clear;
               slZMetaFieldValues.Clear;
               slZMetaName.Clear;
               slZMetaFieldType.Clear;
               while not EOF do
               begin
                  slZMetaField.Add(FieldByName('Feld_Name').AsString);
                  slZMetaName.Add(FieldByName('Disp_Name').AsString);
                  slZMetaFieldValues.Add('');
                  slZMetaFieldType.Add(FieldByName('Typ').AsString);
                  Next;
               end;
               dm_DB.my_q_Tmp.Close;
            end;
         end
         else
         begin
            dm_DB.my_q_Tmp.Close;
            LogEvnt('SaveMerge - Fehler beim Verschieben eines Dokumentes: Auslesen der Ziel-MetaFelder');
            ShowMessage(_('Fehler beim Verschieben eines Dokumentes: Auslesen der Ziel-MetaFelder'));
            Exit;
         end;

         LogEvnt('dbtv_LgrArcDragDrop - Create Tfrm_zuspflicht begin');
         Application.CreateForm(Tfrm_zuspflicht, frm_zuspflicht);
         frm_zuspflicht.fsDestIarcname := GSysArc[linewarcid].TblName;
         frm_zuspflicht.fsSrcIarcname := GSysArc[ArchivID].TblName;
         frm_zuspflicht.igdocid := iDocID[0];
         frm_zuspflicht.iGUsrID := iGUsrID;

         frm_zuspflicht.bMove := True;
         frm_zuspflicht.bPflichtfelder := True;
         dm_DB.bgCancelfrmZuspflicht:= false; //06.05.1979	b.takacs 3.5.1.9

         frm_zuspflicht.lbl_doctitel.caption := dm_db.my_q_arc.fieldbyname('disp_name').asstring;
         frm_zuspflicht.lbl_docid.caption := dm_db.my_q_arc.fieldbyname('doc_id').asstring;

         frm_zuspflicht.fiZusFcount := frm_zuspflicht.CreZusFields;
         if frm_zuspflicht.fTorpflichtfeld <> 0 then
         begin
            lbhaszusfield := true;
         end
         else
         begin
            lbhaszusfield := false;
         end;
         LogEvnt('dbtv_LgrArcDragDrop - Create Tfrm_zuspflicht end');

         if lbhaszusfield then
         begin
            frm_zuspflicht.ShowModal;
            if frm_zuspflicht.ModalResult <> mrOk then
            begin
               exit;
            end;

            if not frm_zuspflicht.ChkZusfield(false) then
            begin
               if 0 <> (frm_zuspflicht.ftorpflichtfeld - frm_zuspflicht.fkeypflichtfeld) then
               begin
                  LogEvnt('dbtv_LgrArcDragDrop - Fehler beim Verschieben eines Dokumentes: frm_zusplicht.ChkZusfield = FALSE');
                  showmessage(_('Fehler beim Verschieben eines Dokumentes: frm_zusplicht.ChkZusfield = FALSE'));
                  Exit;
               end;
            end;
         end;

         frm_mainform.queryarc('Select * from arc_' + sIarcname + ' where doc_id = ' + inttostr(iGDocID));
         frm_Mainform.MoveDoc(ArchivID, linewarcid, iGDocID, lNewDocID, slZMetaField,slZMetaName,slZMetaFieldValues, slZMetaFieldType,lbhaszusfield);
         frm_mainform.HandleParam(IntToStr(linewarcid) + '.' + IntToStr(lNewDocID));

      end
      else
      begin
         dm_DB.my_q_Arc.Refresh;

         dm_DB.my_q_Arc.RecNo := iTmpRec;
         if frm_MrgDocs.revsicher = 1 then
         begin
            // reset search
            frm_MainForm.btn_ResFieldsClick(TObject(frm_MainForm.dbgrd_Trefferliste));
            // get the new entries
            frm_MainForm.bitbtn1Click(TObject(frm_MainForm.dbgrd_Trefferliste));

            counter := 1;
            frm_MainForm.TmpSQL(dm_DB.my_q_Arc.sql.Text);
            //choose the right entry in the list;
            frm_MainForm.dbgrd_Trefferliste.SelectedRows.Clear;
            with frm_MainForm.dbgrd_Trefferliste.DataSource.DataSet do
            begin
               while counter <= dm_DB.my_q_Arc.RecordCount do
               begin
                  frm_MainForm.dbgrd_Trefferliste.SelectedIndex := counter;
                  //               frm_MainForm.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
                  if FieldByName('doc_id').Value = lNewDocID then
                  begin
                     frm_MainForm.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
                     break;
                  end;
                  Next;
                  counter := counter + 1;
               end;
            end;
         end;

         if frm_MrgDocs.revsicher = 2 then
         begin
         end;
      end;
   finally
   	gbDocMove := False;
      if Assigned(slVTX) then
         FreeAndNil(slVTX);
      if Assigned(slZMetaName) then
        FreeAndNil(slZMetaName);
      if Assigned(slZMetaField) then
        FreeAndNil(slZMetaField);
      if Assigned(slZMetaFieldValues) then
        FreeAndNil(slZMetaFieldValues);
      if Assigned(slZMetaFieldType) then
        FreeAndNil(slZMetaFieldType);
   end;
end;  //  Tfrm_MrgDocs.SaveMerge




procedure Tfrm_MrgDocs.sbtn_OKClick (Sender: TObject);
begin
   SaveMerge (iGArcID);
   frm_MrgDocs.Close;
end;

procedure Tfrm_MrgDocs.sbtn_CancelClick(Sender: TObject);
begin
   frm_MrgDocs.Close;
end;

procedure Tfrm_MrgDocs.FormShow(Sender: TObject);
var li: integer;
begin
   fbinit := True;
   ReadCbxLgr(self);
   flstmylist := Tstringlist.Create;

   with frm_MainForm.dbgrd_Trefferliste do
   begin
      setlength(annopages, SelectedRows.Count);
      for li := 0 to SelectedRows.Count - 1 do
      begin
         flstmylist.Add(SelectedRows.Items[li]);
      end;
   end;
   LoadDocs;
   fbinit := False;
end;

procedure Tfrm_MrgDocs.ReadCbxLgr(Sender: TObject);
begin
   if fbinit then
   begin
      if frm_Mainform.TmpSQL(
         'Select Sql_No_cache arc_id, arc_Name from sys_arc where type = 0 order by arc_name')
      then
      begin
         try
            cbx_Lager.Items.Clear;
            with dm_DB.my_q_Tmp do
               while not EOF do
               begin
                  cbx_Lager.Items.AddObject(FieldByName('arc_name').AsString,
                     TObject(FieldByName('Arc_ID').AsInteger));
                  Next;
               end;
         except
            on e: Exception do
               ErrorMsg('ReadCbxLgr', _('Fehler beim Auslesen der LagerOrte: ') +
                  e.Message, 2001, True);
         end;
      end
      else
         ErrorMsg('ReadCbxLgr', _('Fehler bei Select Sql_No_cache Anweisung!'),
            2002,
            True);
      dm_DB.my_q_Tmp.Close;
      cbx_Lager.ItemIndex := frm_Mainform.cbx_Lager.ItemIndex;
   end
   else
   begin
   end;
   ReadCbxArc(self);
end;

procedure Tfrm_MrgDocs.ReadCbxArc(Sender: TObject);
begin
   if frm_Mainform.TmpSQL(
      'Select Sql_No_cache sys_arc.Arc_ID, Arc_Name from sys_arc left join sys_arcxs using(arc_id) where usr_id = '
      + IntToStr(iGUsrID) + ' and lgr_id = ' +
      IntToStr(integer(cbx_Lager.Items.Objects[cbx_Lager.ItemIndex])) +
      ' and Type = 1 group by sys_arc.arc_id order by arc_name') then
   begin
      try
         cbx_Archiv.Items.Clear;
         cbx_Archiv.AddItem(_('alle Archive'), TObject(0));
         with dm_DB.my_q_Tmp do
            while not EOF do
            begin
               if cbx_Archiv.Items.IndexOfObject(TObject(FieldByName('Arc_ID').AsInteger)) =
                  -1 then
                  cbx_Archiv.Items.AddObject(FieldByName('arc_name').AsString,
                     TObject(FieldByName('Arc_ID').AsInteger));
               Next;
            end;
      except
         on e: Exception do
            ErrorMsg('ReadCbxArc', _('Fehler beim Auslesen der LagerOrte: ') +
               e.Message, 2001, True);
      end;
   end
   else
      ErrorMsg('ReadCbxArc', _('Fehler bei Select Sql_No_cache Anweisung!'),
         2002,
         True);
   dm_DB.my_q_Tmp.Close;

   if fbinit then
   begin
      cbx_Archiv.ItemIndex := frm_Mainform.cbx_Archiv.ItemIndex;
   end
   else
   begin
      cbx_archiv.ItemIndex := 0;
   end;
end;

procedure Tfrm_MrgDocs.sbtn_orderClick(Sender: TObject);
var li: integer;
begin
   Application.CreateForm(Tfrm_mrgdocreorder, frm_mrgdocreorder);
   frm_mrgdocreorder.ShowModal;

   if assigned(flstmylist) then
   begin
      flstmylist.Clear;
   end
   else
   begin
      flstmylist := Tstringlist.Create;
   end;
   for li := 0 to frm_mrgdocreorder.ListView1.Items.Count - 1 do
   begin
      flstmylist.Add(frm_mrgdocreorder.ListView1.Items.Item[li].SubItems[2]);
   end;
   frm_mrgdocreorder.Release;
   img_Mrg.Clear;
   LoadDocs;
end;

procedure Tfrm_MrgDocs.FormClose(Sender: TObject;
   var Action: TCloseAction);
begin
   if assigned(flstmylist) then
   begin
      flstmylist.Free;
   end
end;

procedure Tfrm_MrgDocs.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
