unit u_ObjectOpt;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, ievect, imageEnView, u_DocEditor, gnugettext,
   JvExStdCtrls, JvCombobox, JvListComb,
   u_ShLowUtils;

type
   Tfrm_ObjectOpt = class (TForm)
      grbx_Color: TGroupBox;
      lbl_CBackground: TLabel;
      lbl_CBorder: TLabel;
      lbl_CLabel: TLabel;
      lbl_CNoteBorder: TLabel;
      clbx_CBackground: TColorBox;
      clbx_CBorder: TColorBox;
      clbx_CLabel: TColorBox;
      clbx_CNoteBorder: TColorBox;
      grbx_Brush: TGroupBox;
      grbx_Algem: TGroupBox;
      lbl_BBackground: TLabel;
      lbl_BBorder: TLabel;
      lbl_BLabel: TLabel;
      lbl_BNoteBorder: TLabel;
      btn_Cancel: TButton;
      grbx_Shape: TGroupBox;
      rbtn_SSNo: TRadioButton;
      rbtn_SSOut: TRadioButton;
      rbtn_SSIn: TRadioButton;
      rbtn_SENo: TRadioButton;
      rbtn_SEOut: TRadioButton;
      rbtn_SEIn: TRadioButton;
      pnl_SShape: TPanel;
      lbl_SShapeStart: TLabel;
      lbl_SShapeEnd: TLabel;
      lbl_SSHeight: TLabel;
      edt_SSHeight: TEdit;
      lbl_SSWidth: TLabel;
      edt_SSWidth: TEdit;
      grbx_Text: TGroupBox;
      lbl_TFont: TLabel;
      chbx_TFontLocked: TCheckBox;
      edt_TFont: TEdit;
      lbl_TFontAngle: TLabel;
      edt_TFontAngle: TEdit;
      lbl_TFontSize: TLabel;
      edt_TFontSize: TEdit;
      sbtn_TFont: TSpeedButton;
      lbl_TLabelPos: TLabel;
      cbx_TLabelPos: TComboBox;
      lbl_TAlign: TLabel;
      cbx_TAlign: TComboBox;
      chbx_TObjAutoSize: TCheckBox;
      memo_TObjText: TMemo;
      lbl_AObjName: TLabel;
      edt_AObjName: TEdit;
      lbl_APenWidth: TLabel;
      edt_APenWidth: TEdit;
      lbl_ARulerTyp: TLabel;
      lbl_ARulerMeasure: TLabel;
      cbx_ARulerTyp: TComboBox;
      cbx_ARulerMes: TComboBox;
      chbx_AOpenPoly: TCheckBox;
      chbx_AIsHiLite: TCheckBox;
      chbx_ASizeable: TCheckBox;
      chbx_AVisible: TCheckBox;
      chbx_AMoveable: TCheckBox;
      chbx_ASelectable: TCheckBox;
      lbl_ATransp: TLabel;
      edt_ATransp: TEdit;
      lbl_TGrad: TLabel;
      lbl_APixel: TLabel;
      btn_Save: TButton;
      btn_OK: TButton;
      btn_PrevObj: TButton;
      btn_NextObj: TButton;
      dlg_Schrift: TFontDialog;
      lbl_AObjLeft: TLabel;
      edt_AObjLeft: TEdit;
      edt_AObjTop: TEdit;
      edt_AObjHeight: TEdit;
      lbl_AObjHeight: TLabel;
      lbl_AObjTop: TLabel;
      edt_AObjWidth: TEdit;
      lbl_AObjWidth: TLabel;
      cbx_BBackground: TJvImageComboBox;
      cbx_BBorder: TJvImageComboBox;
      cbx_BLabel: TJvImageComboBox;
      cbx_BNoteBorder: TJvImageComboBox;
      procedure FormShow(Sender: TObject);
      procedure btn_PrevObjClick(Sender: TObject);
      procedure btn_NextObjClick(Sender: TObject);
      procedure btn_OKClick(Sender: TObject);
      procedure btn_SaveClick(Sender: TObject);
      procedure sbtn_TFontClick(Sender: TObject);
      procedure cbx_ARulerTypChange(Sender: TObject);
      procedure cbx_ARulerMesChange(Sender: TObject);
      procedure cbx_TLabelPosChange(Sender: TObject);
      procedure cbx_TAlignChange(Sender: TObject);
      procedure edt_SSHeightChange(Sender: TObject);
      procedure edt_SSWidthChange(Sender: TObject);
      procedure edt_APenWidthChange(Sender: TObject);
      procedure edt_ATranspChange(Sender: TObject);
      procedure edt_AObjLeftChange(Sender: TObject);
      procedure edt_AObjTopChange(Sender: TObject);
      procedure edt_AObjWidthChange(Sender: TObject);
      procedure edt_AObjHeightChange(Sender: TObject);
      procedure edt_TFontAngleChange(Sender: TObject);
      procedure edt_TFontSizeChange(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure memo_TObjTextKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
   private
      { Private-Deklarationen }
      iGSelObjIdx: integer;
   protected
      procedure CreateParams(var Params: TCreateParams); override;
   public
      { Public-Deklarationen }
      fdoceditparent: Tfrm_DocEdit;
      function LoadObjVal(idx: integer): boolean;
      function SaveObjVal(idx: integer): boolean;
   end;

var
   frm_ObjectOpt: Tfrm_ObjectOpt;


implementation

{$R *.dfm}

uses u_Dm_DocEditor, u_MainForm;

function Tfrm_ObjectOpt.LoadObjVal(idx: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  08.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function ld die Objecteigenschaften des selektier- ///
   ///  ten Objektes [idx] in den Objekteigenschften Editor.      ///
   ///                                                            ///
   ///  Parameter: idx           Selektiertes Objekt [idx]        ///
   ///             -1            Objekt zurck                    ///
   ///             -2            Objekt vor                       ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iObjCount, iHobj: integer;
begin
   Result := True;
   try
      iObjCount := frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount;
      // Anzahl der selektierten Objekte feststellen
      if idx = -1 then
         idx := iGSelObjIdx - 1; // Vorheriges selektiertes Objekt
      if idx = -2 then
         idx := iGSelObjIdx + 1; // Nchstes selektiertes Objekt
      if (idx > (iObjCount - 1)) or (idx < 0) then
         idx := idx mod iObjCount; // Prfung auf Plausibilitt und Korrektur
      if (idx < 0) then
      begin
         idx := idx + iObjCount; // turn -1 in 12
      end;
      if iObjcount = 1 then
      begin
         btn_PrevObj.Enabled := False;
         btn_NextObj.Enabled := False;
      end
      else
      begin
         btn_PrevObj.Enabled := True;
         btn_NextObj.Enabled := True;
      end;
      iGSelObjIdx := idx; // Globale Variable mit aktuellem Objektindex fllen
      iHobj := frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[idx];
      // Handel von selektiertem Objekt [idx] ermitteln
      frm_ObjectOpt.Caption := 'Objekteigenschaften bearbeiten - Objekt[' +
         IntToStr(iHobj) + ']';

      case frm_DocEdit.fra_DocEditor.img_DocView.ObjKind[ihobj] of
         iekBOX:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := True;
            clbx_CBorder.Visible := True;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := True;
            cbx_BBorder.Visible := True;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := True;
            chbx_AIsHiLite.Visible := True;
         end;
         iekLINE:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := True;
            clbx_CBorder.Visible := True;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := True;
            cbx_BBorder.Visible := True;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := False;
            grbx_Text.Visible := False;
            chbx_AIsHiLite.Visible := False;
            cbx_ARulerTyp.Visible := False;
         end;

         iekPOLYLINE:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := True;
            clbx_CBorder.Visible := True;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := True;
            cbx_BBorder.Visible := True;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := True;
            grbx_Text.Visible := False;
            chbx_AIsHiLite.Visible := False;
         end;

         iekELLIPSE:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := True;
            clbx_CBorder.Visible := True;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := True;
            cbx_BBorder.Visible := True;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := True;
            grbx_Text.Visible := False;
            chbx_AIsHiLite.Visible := False;
         end;

         iekARC, iekRULER, iekANGLE:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := False;
            clbx_CBorder.Visible := False;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := True;
            cbx_BBorder.Visible := True;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := True;
            grbx_Text.Visible := True;
            chbx_AIsHiLite.Visible := True;
         end;

         iekBITMAP:
         begin
            lbl_CBackground.Visible := False;
            clbx_CBackground.Visible := False;
            lbl_CBorder.Visible := False;
            clbx_CBorder.Visible := False;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := False;
            cbx_BBackground.Visible := False;
            lbl_BBorder.Visible := False;
            cbx_BBorder.Visible := False;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := True;
            grbx_Text.Visible := True;
            chbx_AIsHiLite.Visible := True;
         end;
         iekTEXT, iekMEMO:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := False;
            clbx_CBorder.Visible := False;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := True;
            clbx_CNoteBorder.Visible := True;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := False;
            cbx_BBorder.Visible := False;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := True;
            cbx_BNoteBorder.Visible := True;
            grbx_Brush.Visible := True;
            grbx_Text.Visible := True;
            chbx_AIsHiLite.Visible := True;
         end;
         iekLINELABEL:
         begin
            lbl_CBackground.Visible := True;
            clbx_CBackground.Visible := True;
            lbl_CBorder.Visible := True;
            clbx_CBorder.Visible := True;
            lbl_CLabel.Visible := False;
            clbx_CLabel.Visible := False;
            lbl_CNoteBorder.Visible := False;
            clbx_CNoteBorder.Visible := False;
            lbl_BBackground.Visible := True;
            cbx_BBackground.Visible := True;
            lbl_BBorder.Visible := True;
            cbx_BBorder.Visible := True;
            lbl_BLabel.Visible := False;
            cbx_BLabel.Visible := False;
            lbl_BNoteBorder.Visible := False;
            cbx_BNoteBorder.Visible := False;
            grbx_Brush.Visible := True;
            grbx_Text.Visible := True;
            chbx_AIsHiLite.Visible := True;
         end;
      end;

      with frm_DocEdit.fra_DocEditor.img_DocView do
      begin
         clbx_CBackground.Selected := ObjBrushColor[iHobj];
         clbx_CBorder.Selected := ObjPenColor[iHobj];
         clbx_CLabel.Selected := ObjLabelBrushColor[iHobj];
         clbx_CNoteBorder.Selected := ObjMemoBorderColor[iHobj];
         case ObjBrushStyle[iHobj] of
            bsSolid:
               cbx_BBackground.ItemIndex := 7;
            bsClear:
               cbx_BBackground.ItemIndex := 0;
            bsHorizontal:
               cbx_BBackground.ItemIndex := 4;
            bsVertical:
               cbx_BBackground.ItemIndex := 3;
            bsFDiagonal:
               cbx_BBackground.ItemIndex := 1;
            bsBDiagonal:
               cbx_BBackground.ItemIndex := 2;
            bsCross:
               cbx_BBackground.ItemIndex := 5;
            bsDiagCross:
               cbx_BBackground.ItemIndex := 6;
         end;
         case ObjLabelBrushStyle[iHobj] of
            bsSolid:
               cbx_BLabel.ItemIndex := 7;
            bsClear:
               cbx_BLabel.ItemIndex := 0;
            bsHorizontal:
               cbx_BLabel.ItemIndex := 4;
            bsVertical:
               cbx_BLabel.ItemIndex := 3;
            bsFDiagonal:
               cbx_BLabel.ItemIndex := 1;
            bsBDiagonal:
               cbx_BLabel.ItemIndex := 2;
            bsCross:
               cbx_BLabel.ItemIndex := 5;
            bsDiagCross:
               cbx_BLabel.ItemIndex := 6;
         end;
         case ObjPenStyle[iHobj] of
            psSolid:
               cbx_BBorder.ItemIndex := 0;
            psDash:
               cbx_BBorder.ItemIndex := 2;
            psDot:
               cbx_BBorder.ItemIndex := 5;
            psDashDot:
               cbx_BBorder.ItemIndex := 3;
            psDashDotDot:
               cbx_BBorder.ItemIndex := 4;
            psClear:
               cbx_BBorder.ItemIndex := 1;
         end;
         case ObjMemoBorderStyle[iHobj] of
            psSolid:
               cbx_BNoteBorder.ItemIndex := 0;
            psDash:
               cbx_BNoteBorder.ItemIndex := 2;
            psDot:
               cbx_BNoteBorder.ItemIndex := 5;
            psDashDot:
               cbx_BNoteBorder.ItemIndex := 3;
            psDashDotDot:
               cbx_BNoteBorder.ItemIndex := 4;
            psClear:
               cbx_BNoteBorder.ItemIndex := 1;
         end;
         case ObjBeginShape[iHobj] of
            iesNONE:
               rbtn_SSNo.Checked := True;
            iesINARROW:
               rbtn_SSIn.Checked := True;
            iesOUTARROW:
               rbtn_SSOut.Checked := True;
         end;
         case ObjEndShape[iHobj] of
            iesNONE:
               rbtn_SENo.Checked := True;
            iesINARROW:
               rbtn_SEIn.Checked := True;
            iesOUTARROW:
               rbtn_SEOut.Checked := True;
         end;
         edt_SSHeight.Text := IntToStr(ObjShapeHeight[iHobj]);
         edt_SSWidth.Text := IntToStr(ObjShapeWidth[iHobj]);
         edt_AObjName.Text := ObjName[iHobj];
         edt_APenWidth.Text := IntToStr(ObjPenWidth[iHobj]);
         case ObjRulerType[iHobj] of
            iertRULER:
               cbx_ARulerTyp.ItemIndex := 0;
            iertQUOTEBEGIN:
               cbx_ARulerTyp.ItemIndex := 1;
            iertQUOTECENTER:
               cbx_ARulerTyp.ItemIndex := 2;
            iertQUOTEEND:
               cbx_ARulerTyp.ItemIndex := 3;
         end;
         case ObjRulerUnit[iHobj] of
            ieuPIXELS:
               cbx_ARulerMes.ItemIndex := 0;
            ieuINCHES:
               cbx_ARulerMes.ItemIndex := 1;
            ieuKM:
               cbx_ARulerMes.ItemIndex := 5;
            ieuMETERS:
               cbx_ARulerMes.ItemIndex := 4;
            ieuCENTIMETERS:
               cbx_ARulerMes.ItemIndex := 3;
            ieuMILLIMETERS:
               cbx_ARulerMes.ItemIndex := 2;
            ieuMICRONS:
               cbx_ARulerMes.ItemIndex := 6;
            ieuNANOMETERS:
               cbx_ARulerMes.ItemIndex := 7;
         end;
         edt_ATransp.Text := IntToStr(ObjTransparency[iHobj]);
         // Object Transparency aus der TR des Objektes in Text uebertragen
         chbx_AOpenPoly.Checked := not ObjPolylineClosed[iHobj];
         chbx_AIsHiLite.Checked := ObjBoxHighlight[iHobj];
         chbx_ASelectable.Checked := ievsSelectable in ObjStyle[iHobj];
         chbx_AMoveable.Checked := ievsMoveable in ObjStyle[iHobj];
         chbx_ASizeable.Checked := ievsSizeable in ObjStyle[iHobj];
         chbx_AVisible.Checked := ievsVisible in ObjStyle[iHobj];
         edt_AObjTop.Text := IntToStr(ObjTop[iHobj]);
         edt_AObjLeft.Text := IntToStr(ObjLeft[iHobj]);
         edt_AObjWidth.Text := IntToStr(ObjWidth[iHobj]);
         edt_AObjHeight.Text := IntToStr(ObjHeight[iHobj]);
         edt_TFont.Text := ObjFontName[iHobj];
         dlg_Schrift.Font.Name := ObjFontName[iHobj];
         dlg_Schrift.Font.Color := ObjPenColor[iHobj];
         dlg_Schrift.Font.Size := ObjFontHeight[iHobj];
         dlg_Schrift.Font.Style := ObjFontStyles[iHobj];
         edt_TFontSize.Text := IntToStr(ObjFontHeight[iHobj]);
         edt_TFontAngle.Text := FloatToStr(ObjFontAngle[iHobj]);
         case ObjLabelPosition[iHobj] of
            ielBegin:
               cbx_TLabelPos.ItemIndex := 0;
            ielEnd:
               cbx_TLabelPos.ItemIndex := 1;
         end;
         case ObjTextAlign[iHobj] of
            iejLeft:
               cbx_TAlign.ItemIndex := 0;
            iejRight:
               cbx_TAlign.ItemIndex := 1;
            iejCenter:
               cbx_TAlign.ItemIndex := 2;
            iejJustify:
               cbx_TAlign.ItemIndex := 3;
         end;
         memo_TObjText.Text := ObjText[iHobj];
         chbx_TObjAutoSize.Checked := ObjTextAutoSize[iHobj];
         chbx_TFontLocked.Checked := ObjFontLocked[iHobj];
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('frm_ObjectOpt.LoadObjVal', _('Fehler beim Laden von Objecteigenschaften'),
            2200, True);
         Result := False;
      end;
   end;
end;

function Tfrm_ObjectOpt.SaveObjVal(idx: integer): boolean;
   //////////////////////////////////////////////////////////////////
   ///  08.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function ndert die Objecteigenschaften des selekt- ///
   ///  ierten Objektes [idx] nach den Objekteigenschften Editor. ///
   ///                                                            ///
   ///  Parameter: idx           Selektiertes Objekt [idx]        ///
   ///                                                            ///
   ///  Rckgabe:  True bei Erfolg                                ///
   ///             False bei Fehlschlag                           ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iObjCount, iHobj: integer;
begin
   fdoceditparent.fbdocchanged := True;
   fdoceditparent.tbi_TDocSave.Enabled := True;
   Result := True;
   try
      iObjCount := frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount;
      // Anzahl der selektierten Objekte feststellen
      if (idx > (iObjCount - 1)) or (idx < 0) then
         exit; // Prfung auf Plausibilitt
      if iObjcount = 1 then
      begin
         btn_PrevObj.Enabled := False;
         btn_NextObj.Enabled := False;
      end
      else
      begin
         btn_PrevObj.Enabled := True;
         btn_NextObj.Enabled := True;
      end;
      iHobj := frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[idx];
      // Handel von selektiertem Objekt [idx] ermitteln
      with frm_DocEdit.fra_DocEditor.img_DocView do
      begin
         ObjBrushColor[iHobj] := clbx_CBackground.Selected;
         case frm_DocEdit.fra_DocEditor.img_DocView.ObjKind[ihobj] of
            iekNONE, iekLINE,
            iekBOX:
            begin
               ObjPenColor[iHobj] := clbx_CBorder.selected;
            end;
            iekELLIPSE, iekARC, iekRULER, iekPOLYLINE, iekANGLE:
            begin
               ObjPenColor[iHobj] := clbx_CBorder.selected;
            end;
            iekBITMAP:
            begin
               ObjPenColor[iHobj] := dlg_Schrift.Font.color;
            end;
            iekTEXT, iekMEMO:
            begin
               ObjPenColor[iHobj] := dlg_Schrift.Font.color;
            end;
            iekLINELABEL:
            begin
               ObjPenColor[iHobj] := clbx_CBorder.selected;
            end;
         end;

         ObjLabelBrushColor[iHobj] := clbx_CLabel.Selected;
         ObjMemoBorderColor[iHobj] := clbx_CNoteBorder.Selected;
         case cbx_BBackground.ItemIndex of
            0:
               ObjBrushStyle[iHobj] := bsClear;
            1:
               ObjBrushStyle[iHobj] := bsFDiagonal;
            2:
               ObjBrushStyle[iHobj] := bsBDiagonal;
            3:
               ObjBrushStyle[iHobj] := bsVertical;
            4:
               ObjBrushStyle[iHobj] := bsHorizontal;
            5:
               ObjBrushStyle[iHobj] := bsCross;
            6:
               ObjBrushStyle[iHobj] := bsDiagCross;
            7:
               ObjBrushStyle[iHobj] := bsSolid;
         end;
         case cbx_BLabel.ItemIndex of
            0:
               ObjLabelBrushStyle[iHobj] := bsClear;
            1:
               ObjLabelBrushStyle[iHobj] := bsFDiagonal;
            2:
               ObjLabelBrushStyle[iHobj] := bsBDiagonal;
            3:
               ObjLabelBrushStyle[iHobj] := bsVertical;
            4:
               ObjLabelBrushStyle[iHobj] := bsHorizontal;
            5:
               ObjLabelBrushStyle[iHobj] := bsCross;
            6:
               ObjLabelBrushStyle[iHobj] := bsDiagCross;
            7:
               ObjLabelBrushStyle[iHobj] := bsSolid;
         end;
         case cbx_BBorder.ItemIndex of
            0:
               ObjPenStyle[iHobj] := psSolid;
            1:
               ObjPenStyle[iHobj] := psClear;
            2:
               ObjPenStyle[iHobj] := psDash;
            3:
               ObjPenStyle[iHobj] := psDashDot;
            4:
               ObjPenStyle[iHobj] := psDashDotDot;
            5:
               ObjPenStyle[iHobj] := psDot;
         end;
         case cbx_BNoteBorder.ItemIndex of
            0:
               ObjMemoBorderStyle[iHobj] := psSolid;
            1:
               ObjMemoBorderStyle[iHobj] := psClear;
            2:
               ObjMemoBorderStyle[iHobj] := psDash;
            3:
               ObjMemoBorderStyle[iHobj] := psDashDot;
            4:
               ObjMemoBorderStyle[iHobj] := psDashDotDot;
            5:
               ObjMemoBorderStyle[iHobj] := psDot;
         end;
         if rbtn_SSNo.Checked then
            ObjBeginShape[iHobj] := iesNONE;
         if rbtn_SSIn.Checked then
            ObjBeginShape[iHobj] := iesINARROW;
         if rbtn_SSOut.Checked then
            ObjBeginShape[iHobj] := iesOUTARROW;
         if rbtn_SENo.Checked then
            ObjEndShape[iHobj] := iesNONE;
         if rbtn_SEIn.Checked then
            ObjEndShape[iHobj] := iesINARROW;
         if rbtn_SEOut.Checked then
            ObjEndShape[iHobj] := iesOUTARROW;
         ObjShapeHeight[iHobj] := StrToInt(edt_SSHeight.Text);
         ObjShapeWidth[iHobj] := StrToInt(edt_SSWidth.Text);
         ObjName[iHobj] := edt_AObjName.Text;
         ObjPenWidth[iHobj] := StrToInt(edt_APenWidth.Text);
         case cbx_ARulerTyp.ItemIndex of
            0:
               ObjRulerType[iHobj] := iertRULER;
            1:
               ObjRulerType[iHobj] := iertQUOTEBEGIN;
            2:
               ObjRulerType[iHobj] := iertQUOTECENTER;
            3:
               ObjRulerType[iHobj] := iertQUOTEEND;
         end;
         case cbx_ARulerMes.ItemIndex of
            0:
               ObjRulerUnit[iHobj] := ieuPIXELS;
            1:
               ObjRulerUnit[iHobj] := ieuINCHES;
            2:
               ObjRulerUnit[iHobj] := ieuMILLIMETERS;
            3:
               ObjRulerUnit[iHobj] := ieuCENTIMETERS;
            4:
               ObjRulerUnit[iHobj] := ieuMETERS;
            5:
               ObjRulerUnit[iHobj] := ieuKM;
            6:
               ObjRulerUnit[iHobj] := ieuMICRONS;
            7:
               ObjRulerUnit[iHobj] := ieuNANOMETERS;
         end;
         ObjTransparency[iHobj] := StrToInt(edt_ATransp.Text);
         // Hier gibts die Tranparenz
         ObjPolylineClosed[iHobj] := not chbx_AOpenPoly.Checked;
         ObjBoxHighlight[iHobj] := chbx_AIsHiLite.Checked;
         ObjStyle[iHobj] := [];
         if chbx_ASelectable.Checked then
            ObjStyle[iHobj] := ObjStyle[iHobj] + [ievsSelectable];
         if chbx_AMoveable.Checked then
            ObjStyle[iHobj] := ObjStyle[iHobj] + [ievsMoveable];
         if chbx_ASizeable.Checked then
            ObjStyle[iHobj] := ObjStyle[iHobj] + [ievsSizeable];
         if chbx_AVisible.Checked then
            ObjStyle[iHobj] := ObjStyle[iHobj] + [ievsVisible];
         ObjTop[iHobj] := StrToInt(edt_AObjTop.Text);
         ObjLeft[iHobj] := StrToInt(edt_AObjLeft.Text);
         ObjWidth[iHobj] := StrToInt(edt_AObjWidth.Text);
         ObjHeight[iHobj] := StrToInt(edt_AObjHeight.Text);
         ObjFontName[iHobj] := edt_TFont.Text;
         ObjFontName[iHobj] := dlg_Schrift.Font.Name;
         //ObjPenColor[iHobj] := dlg_Schrift.Font.Color;
         ObjFontHeight[iHobj] := dlg_Schrift.Font.Size;
         ObjFontStyles[iHobj] := dlg_Schrift.Font.Style;
         ObjFontHeight[iHobj] := StrToInt(edt_TFontSize.Text);
         ObjFontAngle[iHobj] := StrToFloat(edt_TFontAngle.Text);
         case cbx_TLabelPos.ItemIndex of
            0:
               ObjLabelPosition[iHobj] := ielBegin;
            1:
               ObjLabelPosition[iHobj] := ielEnd;
         end;
         case cbx_TAlign.ItemIndex of
            0:
               ObjTextAlign[iHobj] := iejLeft;
            1:
               ObjTextAlign[iHobj] := iejRight;
            2:
               ObjTextAlign[iHobj] := iejCenter;
            3:
               ObjTextAlign[iHobj] := iejJustify;
         end;
         ObjText[iHobj] := memo_TObjText.Text;
         ObjTextAutoSize[iHobj] := chbx_TObjAutoSize.Checked;
         ObjFontLocked[iHobj] := chbx_TFontLocked.Checked;
         AddSelObject(iHobj);
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('frm_ObjectOpt.SaveObjVal',
            _('Fehler beim Speichern von Objecteigenschaften'),
            2200, True);
         Result := False;
      end;
   end;
end;

procedure Tfrm_ObjectOpt.FormShow(Sender: TObject);
begin
   LoadObjVal(0);
   visible := true;
end;

procedure Tfrm_ObjectOpt.btn_PrevObjClick(Sender: TObject);
begin
   LoadObjVal(-1);
end;

procedure Tfrm_ObjectOpt.btn_NextObjClick(Sender: TObject);
begin
   LoadObjVal(-2);
end;

procedure Tfrm_ObjectOpt.btn_OKClick(Sender: TObject);
begin
   SaveObjVal(iGSelObjIdx);
end;

procedure Tfrm_ObjectOpt.btn_SaveClick(Sender: TObject);
begin
   SaveObjVal(iGSelObjIdx);
   LoadObjVal(frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount - 1);
end;

procedure Tfrm_ObjectOpt.sbtn_TFontClick(Sender: TObject);
begin
   if dlg_Schrift.Execute then
   begin
      edt_TFont.Text := dlg_Schrift.Font.Name;
      edt_TFontSize.Text := IntToStr(dlg_Schrift.Font.Size);
   end;
end;

procedure Tfrm_ObjectOpt.cbx_ARulerTypChange(Sender: TObject);
begin
   if cbx_ARulerTyp.ItemIndex = -1 then
      cbx_ARulerTyp.ItemIndex := 0;
end;

procedure Tfrm_ObjectOpt.cbx_ARulerMesChange(Sender: TObject);
begin
   if cbx_ARulerMes.ItemIndex = -1 then
      cbx_ARulerMes.ItemIndex := 0;
end;

procedure Tfrm_ObjectOpt.cbx_TLabelPosChange(Sender: TObject);
begin
   if cbx_TLabelPos.ItemIndex = -1 then
      cbx_TLabelPos.ItemIndex := 0;
end;

procedure Tfrm_ObjectOpt.cbx_TAlignChange(Sender: TObject);
begin
   if cbx_TAlign.ItemIndex = -1 then
      cbx_TAlign.ItemIndex := 0;
end;

procedure Tfrm_ObjectOpt.edt_SSHeightChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_SSHeight.Text, iValue) then
      edt_SSHeight.Text := IntToStr(edt_SSHeight.Tag)
   else
   begin
      if iValue < 0 then
         iValue := 0;
      edt_SSHeight.Tag := iValue;
   end;
end;

procedure Tfrm_ObjectOpt.edt_SSWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_SSWidth.Text, iValue) then
      edt_SSWidth.Text := IntToStr(edt_SSWidth.Tag)
   else
   begin
      if iValue < 0 then
         iValue := 0;
      edt_SSWidth.Tag := iValue;
   end;
end;

procedure Tfrm_ObjectOpt.edt_APenWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_APenWidth.Text, iValue) then
      edt_APenWidth.Text := IntToStr(edt_APenWidth.Tag)
   else
   begin
      if iValue < 1 then
         iValue := 1;
      edt_APenWidth.Tag := iValue;
   end;
end;

procedure Tfrm_ObjectOpt.edt_ATranspChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_ATransp.Text, iValue) then
      edt_ATransp.Text := IntToStr(edt_ATransp.Tag)
   else
   begin
      if iValue > 255 then
         iValue := 255;
      if iValue < 0 then
         iValue := 0;
      edt_ATransp.Tag := iValue;
      edt_ATransp.Text := IntToStr(iValue);
   end;
end;

procedure Tfrm_ObjectOpt.edt_AObjLeftChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_AObjLeft.Text, iValue) then
      edt_AObjLeft.Text := IntToStr(edt_AObjLeft.Tag)
   else
      edt_AObjLeft.Tag := iValue;
end;

procedure Tfrm_ObjectOpt.edt_AObjTopChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_AObjTop.Text, iValue) then
      edt_AObjTop.Text := IntToStr(edt_AObjTop.Tag)
   else
      edt_AObjTop.Tag := iValue;
end;

procedure Tfrm_ObjectOpt.edt_AObjWidthChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_AObjWidth.Text, iValue) then
      edt_AObjWidth.Text := IntToStr(edt_AObjWidth.Tag)
   else
      edt_AObjWidth.Tag := iValue;
end;

procedure Tfrm_ObjectOpt.edt_AObjHeightChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_AObjHeight.Text, iValue) then
      edt_AObjHeight.Text := IntToStr(edt_AObjHeight.Tag)
   else
      edt_AObjHeight.Tag := iValue;
end;

procedure Tfrm_ObjectOpt.edt_TFontAngleChange(Sender: TObject);
var
   fValue: double;
begin
   if not TryStrToFloat(edt_TFontAngle.Text, fValue) then
      edt_TFontAngle.Text := '0'
   else
   begin
      if (fValue < -359) and (fValue > 359) then
      begin
         fValue := 0;
         edt_TFontAngle.Text := '0';
      end;
   end;
end;

procedure Tfrm_ObjectOpt.edt_TFontSizeChange(Sender: TObject);
var
   iValue: integer;
begin
   if not TryStrToInt(edt_TFontSize.Text, iValue) then
      edt_TFontSize.Text := IntToStr(edt_TFontSize.Tag)
   else
   begin
      if iValue < 0 then
         iValue := 0;
      edt_TFontSize.Tag := iValue;
      dlg_Schrift.Font.Size := iValue;
   end;
end;

procedure Tfrm_ObjectOpt.CreateParams(var Params: TCreateParams);
begin
   // so that mainform doesnt throw frm_docedit to background
   inherited;
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
end;

procedure Tfrm_ObjectOpt.memo_TObjTextKeyDown(Sender: TObject;
   var Key: Word; Shift: TShiftState);
begin
   if (Key = Ord('A')) and (ssCtrl in Shift) then
   begin
      TMemo(Sender).SelectAll;
      Key := 0;
   end;
end;

procedure Tfrm_ObjectOpt.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
   // manuelle Behandlung der TColorBox
   TranslateStrings(clbx_CBackground.Items, 'Delphi7');
   TranslateStrings(clbx_CBorder.Items, 'Delphi7');
   TranslateStrings(clbx_CLabel.Items, 'Delphi7');
   TranslateStrings(clbx_CNoteBorder.Items, 'Delphi7');
end;

end.
