unit u_OptHiLite;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, Registry;

type
   Tfrm_HiLiteOpt = class (TForm)
      lbl_BorderCol: TLabel;
      clbx_BorderCol: TColorBox;
      clbx_BrushCol: TColorBox;
      lbl_BrushCol: TLabel;
      btn_Cancel: TButton;
      chbx_SaveDefault: TCheckBox;
      btn_Save: TButton;
      procedure btn_SaveClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
   private
      { Private-Deklarationen }
      procedure LoadValues;
   public
      { Public-Deklarationen }
   end;

var
   frm_HiLiteOpt: Tfrm_HiLiteOpt;

implementation

{$R *.dfm}
uses u_MainForm;

procedure Tfrm_HiLiteOpt.LoadValues;
var reg: TRegistry;
begin
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite', True);
            if ValueExists('BorderCol') then
               clbx_BorderCol.Selected := ReadInteger('BorderCol') else WriteInteger('BorderCol', clYellow);
            if ValueExists('BrushCol') then
               clbx_BrushCol.Selected := ReadInteger('BrushCol') else WriteInteger('BrushCol', clYellow);
            CloseKey;
         end;
      except
         on e: Exception do
            ErrorMsg('frm_HiLiteOpt.LoadValues', 'Fehler bei Laden aus der Registrierung: ' + e.Message, 2029, True);
      end;
   finally
      If Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

procedure Tfrm_HiLiteOpt.btn_SaveClick(Sender: TObject);
var reg: TRegistry;
begin
   if chbx_SaveDefault.Checked then
   begin
      reg := TRegistry.Create;
      try
         try
            with reg do
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\HiLite', True);
               WriteInteger('BorderCol', clbx_BorderCol.Selected);
               WriteInteger('BrushCol', clbx_BrushCol.Selected);
               CloseKey;
            end;
         except
            on e: Exception do
               ErrorMsg('frm_HiLiteOpt.btn_SaveClick', 'Fehler bei Schreiben in die Registrierung: ' + e.Message, 2030, True);
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_HiLiteOpt.FormShow(Sender: TObject);
begin
   LoadValues;
end;

end.
