unit u_OptNote;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Mask, MFEdit, ExtCtrls, Registry;

type
   Tfrm_OptNote = class (TForm)
      lbl_BorderCol: TLabel;
      lbl_BrushCol: TLabel;
      clbx_BrushCol: TColorBox;
      clbx_BorderCol: TColorBox;
      chbx_SaveDefault: TCheckBox;
      btn_Save: TButton;
      btn_Cancel: TButton;
      dlg_Font: TFontDialog;
      bedt_Font: TMFButtonEdit;
      lbl_TextCol: TLabel;
      procedure bedt_FontButtonClick(Sender: TObject);
      procedure btn_SaveClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
   private
      { Private-Deklarationen }
      procedure LoadValues;
   public
      { Public-Deklarationen }
   end;

var
   frm_OptNote: Tfrm_OptNote;

implementation

{$R *.dfm}
uses u_MainForm;

procedure Tfrm_OptNote.LoadValues;
var reg: TRegistry;
begin
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Notes', True);
            if ValueExists('BorderCol') then
               clbx_BorderCol.Selected := ReadInteger('BorderCol') else WriteInteger('BorderCol', clBlack);
            if ValueExists('BrushCol') then
               clbx_BrushCol.Selected := ReadInteger('BrushCol') else WriteInteger('BrushCol', clYellow);
            if ValueExists('FontName') then
               dlg_Font.Font.Name := ReadString('FontName') else WriteString('FontName', 'Arial');
            if ValueExists('FontCol') then
               dlg_Font.Font.Color := ReadInteger('FontCol') else WriteInteger('FontCol', clBlack);
            if ValueExists('FontSize') then
               dlg_Font.Font.Size := ReadInteger('FontSize') else WriteInteger('FontSize', 12);

            if ValueExists('FontBold') then
            begin
               if ReadBool('FontBold') then
                  dlg_Font.Font.Style := dlg_Font.Font.Style + [fsBold]
               else dlg_Font.Font.Style := dlg_Font.Font.Style - [fsBold];
            end
            else WriteBool('FontBold', False);

            if ValueExists('FontItalic') then
            begin
               if ReadBool('FontItalic') then
                  dlg_Font.Font.Style := dlg_Font.Font.Style + [fsItalic]
               else dlg_Font.Font.Style := dlg_Font.Font.Style - [fsItalic];
            end
            else WriteBool('FontItalic', False);

            if ValueExists('FontUndl') then
            begin
               if ReadBool('FontUndl') then
                  dlg_Font.Font.Style := dlg_Font.Font.Style + [fsUnderline]
               else dlg_Font.Font.Style := dlg_Font.Font.Style - [fsUnderline];
            end
            else WriteBool('FontUndl', False);

            if ValueExists('FontStrO') then
            begin
               if ReadBool('FontStrO') then
                  dlg_Font.Font.Style := dlg_Font.Font.Style + [fsStrikeOut]
               else dlg_Font.Font.Style := dlg_Font.Font.Style - [fsStrikeOut];
            end
            else WriteBool('FontStrO', False);
            CloseKey;
            bedt_Font.Text := dlg_Font.Font.Name;
         end;
      except
         on e: Exception do
            ErrorMsg('frm_OptNote.LoadValues', 'Fehler bei Laden aus der Registrierung: ' + e.Message, 2029, True);
      end;
   finally
      If Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure Tfrm_OptNote.bedt_FontButtonClick(Sender: TObject);
begin
   if dlg_Font.Execute then
      bedt_Font.Text := dlg_Font.Font.Name;
end;

procedure Tfrm_OptNote.btn_SaveClick(Sender: TObject);
var reg: TRegistry;
begin
   if chbx_SaveDefault.Checked then
   begin
      reg := TRegistry.Create;
      try
         try
            with reg do
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\Notes', True);
               WriteInteger('BorderCol', clbx_BorderCol.Selected);
               WriteInteger('BrushCol', clbx_BrushCol.Selected);
               WriteString('FontName', dlg_Font.Font.Name);
               WriteInteger('FontCol', dlg_Font.Font.Color);
               WriteInteger('FontSize', dlg_Font.Font.Size);
               if fsBold in dlg_Font.Font.Style then
                  WriteBool('FontBold', True) else WriteBool('FontBold', False);
               if fsItalic in dlg_Font.Font.Style then
                  WriteBool('FontItalic', True) else WriteBool('FontItalic', False);
               if fsUnderline in dlg_Font.Font.Style then
                  WriteBool('FontUndl', True) else WriteBool('FontUndl', False);
               if fsStrikeOut in dlg_Font.Font.Style then
                  WriteBool('FontStrO', True) else WriteBool('FontStrO', False);
               CloseKey;
            end;
         except
            on e: Exception do
               ErrorMsg('frm_OptNote.btn_SaveClick', 'Fehler bei Speichern in die Registrierung: ' + e.Message, 2030, True);
         end;
      finally
         If Assigned(reg) then
            FreeAndNil(reg);
      end;
   end;
end;

procedure Tfrm_OptNote.FormShow(Sender: TObject);
begin
   LoadValues;
end;

end.
