unit u_PrintPreview;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Mask, MFEdit, ExtCtrls, Buttons, TB2Dock, Printers,
   TB2ToolWindow, TBX, TBXDkPanels, ieview, imageenview, Registry, ievect,
   ImageEnIO, gnugettext,
   u_ShLowUtils, ImgList;

type
   Tfrm_PrintPreview = class (TForm)
      grbx_Border: TGroupBox;
      tbx_Back: TTBXToolWindow;
      grbx_Pos: TGroupBox;
      grbx_PreView: TGroupBox;
      nedt_BTop: TMFNumEdit;
      nedt_BBottom: TMFNumEdit;
      nedt_BLeft: TMFNumEdit;
      nedt_BRight: TMFNumEdit;
      lbl_BTop: TTBXLabel;
      lbl_BBottom: TTBXLabel;
      lbl_BLeft: TTBXLabel;
      lbl_BRight: TTBXLabel;
      tbtn_PTL: TTBXButton;
      tbtn_PTM: TTBXButton;
      tbtn_PTR: TTBXButton;
      tbtn_PML: TTBXButton;
      tbtn_PMM: TTBXButton;
      tbtn_PMR: TTBXButton;
      tbtn_PBL: TTBXButton;
      tbtn_PBM: TTBXButton;
      tbtn_PBR: TTBXButton;
      btn_Cancel: TTBXButton;
      btn_Print: TTBXButton;
      grbx_Size: TGroupBox;
      cbx_Size: TComboBox;
      lbl_SWidth: TTBXLabel;
      nedt_SWidth: TMFNumEdit;
      nedt_SHeight: TMFNumEdit;
      lbl_SHeight: TTBXLabel;
      grbx_Opt: TGroupBox;
      btn_PrinterDlg: TTBXButton;
      nedt_OGamma: TMFNumEdit;
      lbl_OGamma: TTBXLabel;
      chbx_OAnno: TTBXCheckBox;
      grbx_Page: TGroupBox;
      rbtn_PgAll: TTBXRadioButton;
      rbtn_PgSel: TTBXRadioButton;
      lbl_PgStart: TTBXLabel;
      nedt_PgStart: TMFNumEdit;
      lbl_PgEnd: TTBXLabel;
      nedt_PgEnd: TMFNumEdit;
      chbx_SAutoRot: TTBXCheckBox;
      img_PreView: TImageEnVect;
    il_Main: TImageList;
      procedure btn_PrintClick(Sender: TObject);
      procedure btn_PrinterDlgClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure cbx_SizeChange(Sender: TObject);
      procedure nedt_BBottomChange(Sender: TObject);
      procedure tbtn_PTLClick(Sender: TObject);
      procedure chbx_OAnnoChange(Sender: TObject);
      procedure FormCreate(Sender: TObject);
    procedure EnableVonBis(Sender: TObject);
   private
      { Private-Deklarationen }
      function CheckReg: boolean;
      function WriteReg: boolean;
      function ReadReg: boolean;
      procedure InitDlg;
      procedure DrawPreview;
   public
      { Public-Deklarationen }
   end;

var
   frm_PrintPreview: Tfrm_PrintPreview;

implementation

{$R *.dfm}

uses {} u_dm_ViewerMain, u_MainForm, u_ShVoransicht;

function Tfrm_PrintPreview.CheckReg: boolean;
var reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('software\bitfarm\archiv_v3\Viewer\Optionen\Printing', True);
            if not ValueExists('BorTop') then
               WriteFloat('BorTop', 0.00);
            if not ValueExists('BorBottom') then
               WriteFloat('BorBottom', 0.00);
            if not ValueExists('BorLeft') then
               WriteFloat('BorLeft', 0.00);
            if not ValueExists('BorRight') then
               WriteFloat('BorRight', 0.00);
            if not ValueExists('Position') then
               WriteInteger('Position', 16);
            if not ValueExists('Size') then
               WriteInteger('Size', 1);
            if not ValueExists('SWidth') then
               WriteFloat('SWidth', 0.00);
            if not ValueExists('SHeight') then
               WriteFloat('SHeight', 0.00);
            if not ValueExists('SAutoRot') then
               WriteBool('SAutoRot', False);
            if not ValueExists('PgAll') then
               WriteBool('PgAll', True);
            if not ValueExists('PgSel') then
               WriteBool('PgSel', False);
            if not ValueExists('OGamma') then
               WriteFloat('OGamma', 1);
            if not ValueExists('OAnno') then
               WriteBool('OAnno', False);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('PrintPreview.CheckReg',
               _('Fehler beim berprfen der Registrierungswerte: ') +
               e.Message, 2031, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_PrintPreview.WriteReg: boolean;
var
   reg: TRegistry;
   iVal: integer;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('software\bitfarm\archiv_v3\Viewer\Optionen\Printing', True);
            WriteFloat('BorTop', nedt_BTop.Value);
            WriteFloat('BorBottom', nedt_BBottom.Value);
            WriteFloat('BorLeft', nedt_BLeft.Value);
            WriteFloat('BorRight', nedt_BRight.Value);
            iVal := 0;
            if tbtn_PTL.Checked then
               iVal := 1;
            if tbtn_PTM.Checked then
               iVal := 2;
            if tbtn_PTR.Checked then
               iVal := 4;
            if tbtn_PML.Checked then
               iVal := 8;
            if tbtn_PMM.Checked then
               iVal := 16;
            if tbtn_PMR.Checked then
               iVal := 32;
            if tbtn_PBL.Checked then
               iVal := 64;
            if tbtn_PBM.Checked then
               iVal := 128;
            if tbtn_PBR.Checked then
               iVal := 256;
            WriteInteger('Position', iVal);
            WriteInteger('Size', cbx_Size.ItemIndex);
            WriteFloat('SWidth', nedt_SWidth.Value);
            WriteFloat('SHeight', nedt_SHeight.Value);
            WriteBool('SAutoRot', chbx_SAutoRot.Checked);
            WriteBool('PgAll', rbtn_PgAll.Checked);
            WriteBool('PgSel', rbtn_PgSel.Checked);
            WriteFloat('OGamma', nedt_OGamma.Value);
            WriteBool('OAnno', chbx_OAnno.Checked);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('PrintPreview.CheckReg',
               _('Fehler beim Sichern der Registrierungswerte: ') +
               e.Message, 2030, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_PrintPreview.ReadReg: boolean;
var reg: TRegistry;
begin
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('software\bitfarm\archiv_v3\Viewer\Optionen\Printing', True);
            if ValueExists('BorTop') then
               nedt_BTop.Value := ReadFloat('BorTop');
            if ValueExists('BorBottom') then
               nedt_BBottom.Value := ReadFloat('BorBottom');
            if ValueExists('BorLeft') then
               nedt_BLeft.Value := ReadFloat('BorLeft');
            if ValueExists('BorRight') then
               nedt_BRight.Value := ReadFloat('BorRight');
            if ValueExists('Position') then
            begin
               case ReadInteger('Position') of
                  1:
                     tbtn_PTL.Checked := True;
                  2:
                     tbtn_PTM.Checked := True;
                  4:
                     tbtn_PTR.Checked := True;
                  8:
                     tbtn_PML.Checked := True;
                  16:
                     tbtn_PMM.Checked := True;
                  32:
                     tbtn_PMR.Checked := True;
                  64:
                     tbtn_PBL.Checked := True;
                  128:
                     tbtn_PBM.Checked := True;
                  256:
                     tbtn_PBR.Checked := True;
               else
                  tbtn_PMM.Checked := True;
               end;
            end;
            if ValueExists('Size') then
               cbx_Size.ItemIndex := ReadInteger('Size');
            if ValueExists('SWidth') then
               nedt_SWidth.Value := ReadFloat('SWidth');
            if ValueExists('SHeight') then
               nedt_SHeight.Value := ReadFloat('SHeight');
            if ValueExists('SAutoRot') then
               chbx_SAutoRot.Checked := ReadBool('SAutoRot');
            if ValueExists('PgAll') then
               rbtn_PgAll.Checked := ReadBool('PgAll');
            if ValueExists('PgSel') then
               rbtn_PgSel.Checked := ReadBool('PgSel');
            if ValueExists('OGamma') then
               nedt_OGamma.Value := ReadFloat('OGamma');
            if ValueExists('OAnno') then
               chbx_OAnno.Checked := ReadBool('OAnno');
            chbx_OAnnoChange(self);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('PrintPreview.CheckReg', _('Fehler beim Lesen der Registrierungswerte: ') +
               e.Message, 2029, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

procedure Tfrm_PrintPreview.InitDlg;
var fXCoef, fYCoef, fHeight, fWidth: Double;
   PrnName, Dummy: Array[0..255] of Char;
   iDummy: Cardinal;
begin
   frm_MainForm.fra_Voransicht.img_DocView.MUnit := ieuMILLIMETERS; //3.5.0.62 []

   fXCoef := frm_MainForm.fra_Voransicht.img_DocView.MeasureCoefX;
   fYCoef := frm_MainForm.fra_Voransicht.img_DocView.MeasureCoefY;
   fHeight := frm_MainForm.fra_Voransicht.img_DocView.IEBitmap.Height;
   fWidth := frm_MainForm.fra_Voransicht.img_DocView.IEBitmap.Width;
   CheckReg;
   ReadReg;
   EnableVonBis(Self);
   if nedt_OGamma.Value < 0.1 then
      nedt_OGamma.Value:=0.1;

   nedt_BTop.MaxValue := (fHeight * fYCoef) / 2;
   nedt_BBottom.MaxValue := nedt_BTop.MaxValue;
   nedt_BLeft.MaxValue := (fWidth * fXCoef) / 2;
   nedt_BRight.MaxValue := nedt_BLeft.MaxValue;
   nedt_SWidth.MaxValue := fWidth * fXCoef;
   nedt_SHeight.MaxValue := fHeight * fYCoef;
   nedt_SWidth.Value := nedt_SWidth.MaxValue;
   nedt_SHeight.Value := nedt_SHeight.MaxValue;
   Printer.GetPrinter(PrnName, dummy, dummy, idummy);
   Caption := _('Druck-Vorschau')+ ' - ' + PrnName;
   DrawPreView;
end;

procedure Tfrm_PrintPreview.DrawPreview;
var VPos: TIEVerticalPos;
   HPos: TIEHorizontalPos;
   SSize: TIESize;
   fBLeft, fBTop, fBRight, fBBottom, fWidth, fHeight{,
    fXCoef, fYCoef}: Double;
Const Zoll = 0.03937007874015748031496062992126;
begin
   //  fXCoef := frm_Main.fra_Voransicht.img_Voransicht.MeasureCoefX;
   //  fYCoef := frm_Main.fra_Voransicht.img_Voransicht.MeasureCoefY;
   case cbx_Size.ItemIndex of
      0:
         SSize := iesNORMAL;
      1:
         SSize := iesFITTOPAGE;
      2:
         SSize := iesFITTOPAGESTRETCH;
      3:
         SSize := iesSPECIFIEDSIZE;
   else
      SSize := iesFITTOPAGE;
   end;
   if tbtn_PTL.Checked then
   begin
      VPos := ievpTOP;
      HPos := iehpLEFT;
   end
   else
   if tbtn_PTM.Checked then
   begin
      VPos := ievpTOP;
      HPos := iehpCENTER;
   end
   else
   if tbtn_PTR.Checked then
   begin
      VPos := ievpTOP;
      HPos := iehpRIGHT;
   end
   else
   if tbtn_PML.Checked then
   begin
      VPos := ievpCENTER;
      HPos := iehpLEFT;
   end
   else
   if tbtn_PMM.Checked then
   begin
      VPos := ievpCENTER;
      HPos := iehpCENTER;
   end
   else
   if tbtn_PMR.Checked then
   begin
      VPos := ievpCENTER;
      HPos := iehpRIGHT;
   end
   else
   if tbtn_PBL.Checked then
   begin
      VPos := ievpBOTTOM;
      HPos := iehpLEFT;
   end
   else
   if tbtn_PBM.Checked then
   begin
      VPos := ievpBOTTOM;
      HPos := iehpCENTER;
   end
   else
   if tbtn_PBR.Checked then
   begin
      VPos := ievpBOTTOM;
      HPos := iehpRIGHT;
   end;

   if nedt_BLeft.Value <> 0.00 then
      fBLeft := (nedt_BLeft.Value * Zoll) else fBLeft := 0;
   if nedt_BTop.Value <> 0.00 then
      fBTop := (nedt_BTop.Value * Zoll) else fBTop := 0;
   if nedt_BRight.Value <> 0.00 then
      fBRight := (nedt_BRight.Value * Zoll) else fBRight := 0;
   if nedt_BBottom.Value <> 0.00 then
      fBBottom := (nedt_BBottom.Value * Zoll) else fBBottom := 0;
   if nedt_SWidth.Value <> 0.00 then
      fWidth := (nedt_SWidth.Value * Zoll) else fWidth := 0;
   if nedt_SHeight.Value <> 0.00 then
      fHeight := (nedt_SHeight.Value * Zoll) else fHeight := 0;

   frm_MainForm.fra_Voransicht.img_DocView.IO.PreviewPrintImage(
      img_Preview.Bitmap, 260, 360, Printer,
      fBLeft, fBTop, fBRight, fBBottom, VPos, HPos, SSize,
      fWidth, fHeight, nedt_OGamma.Value);
   img_Preview.Update;
end;

procedure Tfrm_PrintPreview.btn_PrintClick(Sender: TObject);
begin
   WriteReg;
end;

procedure Tfrm_PrintPreview.btn_PrinterDlgClick(Sender: TObject);
var PrnName, dummy: Array[0..255] of char;
   iDummy: Cardinal;
begin
   if dm_MainForm2.pDlg_Drucken.Execute then
   begin
      DrawPreView;
      Printer.GetPrinter(PrnName, dummy, dummy, idummy);
      frm_PrintPreview.Caption := 'Druck-Vorschau - ' + PrnName;
   end;
end;

procedure Tfrm_PrintPreview.FormShow(Sender: TObject);
begin
   InitDlg;
   DrawPreView;
end;

procedure Tfrm_PrintPreview.cbx_SizeChange(Sender: TObject);
begin
   if cbx_Size.ItemIndex = 3 then
   begin
      lbl_SWidth.Enabled := True;
      lbl_SHeight.Enabled := True;
      nedt_SWidth.Enabled := True;
      nedt_SHeight.Enabled := True;
   end
   else
   begin
      lbl_SWidth.Enabled := False;
      lbl_SHeight.Enabled := False;
      nedt_SWidth.Enabled := False;
      nedt_SHeight.Enabled := False;
   end;
   DrawPreView;
end;

procedure Tfrm_PrintPreview.nedt_BBottomChange(Sender: TObject);
begin
   DrawPreView;
end;

procedure Tfrm_PrintPreview.tbtn_PTLClick(Sender: TObject);
begin
   DrawPreView;
end;

procedure Tfrm_PrintPreview.chbx_OAnnoChange(Sender: TObject);
begin
   img_PreView.RemoveAllObjects;
   frm_MainForm.fra_Volltext.clearobjslist;
   if chbx_OAnno.Checked then
      frm_MainForm.fra_Voransicht.img_DocView.CopyAllObjectsTo(img_PreView);
end;

procedure Tfrm_PrintPreview.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;
procedure Tfrm_PrintPreview.EnableVonBis(Sender: TObject);
begin
  if rbtn_PgAll.Checked = True then
  begin
     nedt_PgStart.Enabled:=False;
     nedt_PgEnd.Enabled:=False;
     lbl_PgStart.Enabled:=False;
     lbl_PgEnd.Enabled:=False;
  end
  else
  begin
     nedt_PgStart.Enabled:=True;
     nedt_PgEnd.Enabled:=True;
     lbl_PgStart.Enabled:=True;
     lbl_PgEnd.Enabled:=True;

  end;
end;

end.
