/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen

unit u_Rechte;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, Buttons, ExtCtrls, gnugettext,
   u_ShLowUtils;

type
   Tfrm_Rechte = class (TFrame)
      lbl_RInfo: TLabel;
      lv_RSObj: TListView;
      lbl_Spez: TLabel;
      pnl_AddRem: TPanel;
      lv_RRObj: TListView;
      sbtn_RAdd: TSpeedButton;
      sbtn_RRem: TSpeedButton;
      pnl_Info: TPanel;
      pnl_Sec: TPanel;
      pnl_Rechte: TPanel;
      pnl_ofRights: TPanel;
      chbx_RAprRead: TCheckBox;
      chbx_RApuWrite: TCheckBox;
      chbx_RAprWrite: TCheckBox;
      chbx_RApuRead: TCheckBox;
      chbx_RHistory: TCheckBox;
      chbx_RLink: TCheckBox;
      chbx_RPrint: TCheckBox;
      chbx_RRights: TCheckBox;
      chbx_RMove: TCheckBox;
      chbx_RMail: TCheckBox;
      chbx_RWrite: TCheckBox;
      chbx_RChange: TCheckBox;
      chbx_RRead: TCheckBox;
      chbx_RList: TCheckBox;
      btn_Save: TButton;
      Panel1: TPanel;
      BitBtn1: TBitBtn;
      procedure sbtn_RAddClick(Sender: TObject);
      procedure sbtn_RRemClick(Sender: TObject);
      procedure lv_RRObjClick(Sender: TObject);
      procedure btn_SaveClick(Sender: TObject);
      procedure chbx_RListClick(Sender: TObject);

      procedure chbx_RApuWriteClick(Sender: TObject);
      procedure chbx_RAprReadClick(Sender: TObject);
      procedure chbx_RAprWriteClick(Sender: TObject);
      procedure chbx_RApuReadClick(Sender: TObject);
      procedure BitBtn1Click(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      procedure ChangeRights;
      procedure ChangeAnnoRights;
      procedure AddObj;
      procedure RemObj;
      procedure ReadDocRights;
      procedure ReadObjRights(Owner: Bool);
   end;

implementation

uses u_MainForm, u_dm_DB;

{$R *.dfm}

procedure Tfrm_Rechte.ChangeRights;
var
   iRights, iTmpType: integer;
   sTmpID, sTmpName: string;
begin
   iRights := 0;
   if chbx_RList.Checked then
      iRights := iRights + 1;
   if chbx_RRead.Checked then
      iRights := iRights + 2;
   if chbx_RChange.Checked then
      iRights := iRights + 4;
   if chbx_RWrite.Checked then
      iRights := iRights + 8;
   if chbx_RMail.Checked then
      iRights := iRights + 16;
   if chbx_RPrint.Checked then
      iRights := iRights + 32;
   if chbx_RLink.Checked then
      iRights := iRights + 64;
   if chbx_RRights.Checked then
      iRights := iRights + 128;
   if chbx_RHistory.Checked then
      iRights := iRights + 256;
   if chbx_RMove.Checked then
      iRights := iRights + 512;
   //  if chbx_RApuRead.Checked  then iRights := iRights + 2048; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
   if chbx_RApuRead.Checked then
      iRights := iRights + 1024;
   //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
   //if chbx_RApuModify.checked then iRights:= iRights + 4096; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
   if chbx_RApuWrite.Checked then
      iRights := iRights + 2048;
   //if chbx_RApuread.Checked then iRights := iRights + 4096;
   if chbx_RAprRead.Checked then
      iRights := iRights + 8192;
   if chbx_RApuWrite.Checked then
      iRights := iRights + 16384;

   try
      with lv_RRObj.Selected do
      begin
         sTmpID := SubItems.Strings[0];
         iTmpType := ImageIndex;
         sTmpName := Caption;
      end;

      with dm_DB.my_cmd do
      begin
         if iTmpType = 8 then
            Sql.Text := 'Update sys_docxs set rights = ' + IntToStr(iRights) +
               ' where usr_id = ' + sTmpID + ' and doc_id = ' +
               IntToStr(iGDocID) + ' and arc_id = ' + IntToStr(iGArcID) + ' and grp_id = 0';
         if iTmpType = 9 then
            Sql.Text := 'Update sys_docxs set rights = ' + IntToStr(iRights) +
               ' where doc_id = ' + IntToStr(iGDocID) + ' and arc_id = ' +
               IntToStr(iGArcID) + ' and grp_id = ' + sTmpID;
         Execute;
         frm_MainForm.NewHistory(1, _('Dokumentenrechte fr Benutzer / Gruppe') + ' ' +
            sTmpName + ' ' + _('gendert') + '. (' + IntToStr(iRights) + ')');
      end;
   except
      on e: Exception do
         ErrorMsg('ChangeRights', _('Fehler beim ndern eines Dokumentenrechtes: ') +
            e.Message, 2017, True);
   end;
   ReadObjRights(False);
end;

procedure Tfrm_Rechte.ChangeAnnoRights;
var
   iRights, iTmpType: integer;
   sTmpID, sTmpName, sTmpSQL: string;
begin
   with lv_RRObj.Selected do
   begin
      sTmpID := SubItems.Strings[0];
      iTmpType := ImageIndex;
      sTmpName := Caption;
   end;
   sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = ' +
      IntToStr(iGArcID) + ' and doc_id = ' + IntToStr(iGDocID) +
      ' and grp_id = 0 and usr_id = ' + sTmpID;
   if frm_MainForm.TmpSQL(sTmpSQL) then
      if dm_DB.my_q_Tmp.RecordCount = 0 then
      begin
         sTmpSQL := 'select cast(rights as signed) as recht from sys_arcxs where arc_id = '
            + IntToStr(iGArcID) + '  and grp_id = 0 and usr_id = ' + sTmpID;
         if not frm_MainForm.TmpSQL(sTmpSQL) then
         begin
            ErrorMsg('ReadObjRights',
               _('Fehler beim Auslesen der Objekt-Berechtigungen'),
               2019, True);
            exit;
         end;
      end;
   iRights := dm_DB.my_q_Tmp.FieldByName('recht').AsInteger;
  {
  if chbx_RList.Checked     then iRights := iRights + 1;
  if chbx_RRead.Checked     then iRights := iRights + 2;
  if chbx_RChange.Checked   then iRights := iRights + 4;
  if chbx_RWrite.Checked    then iRights := iRights + 8;
  if chbx_RMail.Checked     then iRights := iRights + 16;
  if chbx_RPrint.Checked    then iRights := iRights + 32;
  if chbx_RLink.Checked     then iRights := iRights + 64;
  if chbx_RRights.Checked   then iRights := iRights + 128;
  if chbx_RHistory.Checked  then iRights := iRights + 256;
  if chbx_RMove.Checked     then iRights := iRights + 512;
  }

   //  if chbx_RApuRead.Checked  then iRights := iRights + 2048; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
   if chbx_RApuRead.Checked then
      iRights := iRights or 1024
   else
   begin
      irights := iRights and (not 1024);
      //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
   end;
   //if chbx_RApuModify.checked then iRights:= iRights + 4096; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
   if chbx_RApuWrite.Checked then
      iRights := iRights or 2048
   else
      irights := iRights and (not 2048);
   //if chbx_RApuread.Checked then iRights := iRights + 4096 else iRights xor 1024;
   if chbx_RAprRead.Checked then
      iRights := iRights or 8192
   else
      irights := iRights and (not 8192);
   if chbx_RAprWrite.Checked then
      iRights := iRights or 16384
   else
      irights := iRights and (not 16384);

   try

      with dm_DB.my_cmd do
      begin
         if iTmpType = 8 then
         begin
            Sql.Text := 'Update sys_docxs set rights = ' + IntToStr(iRights) +
               ' where usr_id = ' + sTmpID + ' and doc_id = ' +
               IntToStr(iGDocID) + ' and arc_id = ' + IntToStr(iGArcID) +
               ' and grp_id = 0';
         end;
         if iTmpType = 9 then
         begin
            Sql.Text := 'Update sys_docxs set rights = ' + IntToStr(iRights) +
               ' where doc_id = ' + IntToStr(iGDocID) + ' and arc_id = ' +
               IntToStr(iGArcID) + ' and grp_id = ' + sTmpID;
         end;
         Execute;
         frm_MainForm.NewHistory(1, _('Dokumentenrechte fr Benutzer / Gruppe') + ' ' +
            sTmpName + ' ' + _('gendert') + '. (' + IntToStr(iRights) + ')');
      end;
   except
      on e: Exception do
         ErrorMsg('ChangeRights', _('Fehler beim ndern eines Dokumentenrechtes: ') +
            e.Message, 2017, True);
   end;
   ReadObjRights(False);
end;

procedure Tfrm_Rechte.AddObj;
var
   iTmpType, iRights: integer;
   sTmpID, sTmpName, sTmpSQL: string;
begin
   try
      with lv_RSObj.Selected do
      begin
         sTmpID := SubItems.Strings[0];
         iTmpType := ImageIndex;
         sTmpName := Caption;
      end;

      if iTmpType = 8 then
      begin
         sTmpSQL := 'select cast(rights as signed) as recht from sys_arcxs where arc_id = '
            + IntToStr(iGArcID) + '  and usr_id = ' + sTmpID;
      end;

      if iTmpType = 9 then
      begin
         sTmpSQL := 'select cast(rights as signed) as recht from sys_arcxs where arc_id = '
            + IntToStr(iGArcID) + ' and grp_id = ' + sTmpID;
      end;
      if frm_MainForm.TmpSQL(sTmpSQL) then
         iRights := dm_DB.my_q_Tmp.FieldByName('recht').AsInteger
      else
         iRights := 0;
      with dm_DB.my_cmd do
      begin
         if iTmpType = 8 then
         begin
            SQL.Text :=
               'Insert into sys_docxs (arc_id, doc_id, usr_id, rights, grp_id) values ' +
               '(' + IntToStr(iGArcID) + ',' + IntToStr(iGDocID) +
               ',' + sTmpID + ',' + IntToStr(iRights) + ',0)';
            Execute;
         end;

         if iTmpType = 9 then
         begin
            SQL.Text :=
               'Insert into sys_docxs (arc_id, doc_id, usr_id, rights, grp_id) ' +
               'select ' + IntToStr(iGArcID) + ' as arc_id, ' +
               IntToStr(iGDocID) + ' as doc_id, ' + 'usr_id, ' +
               IntToStr(iRights) + ' as rights, grp_id from sys_grpusr where grp_id = '
               + sTmpID;
            Execute;
            SQL.Text :=
               'Insert into sys_docxs (arc_id, doc_id, usr_id, rights, grp_id) values ' +
               '(' + IntToStr(iGArcID) + ',' + IntToStr(iGDocID) +
               ',0,' + IntToStr(iRights) + ',' + sTmpID + ')';
            Execute;
         end;
         frm_MainForm.NewHistory(2, _('Benutzer / Gruppe') + ' ' + sTmpName +
            ' ' + _('dem Dokument hinzugefgt'));
      end;
   except
      on e: Exception do
         ErrorMsg('AddObj',
            _('Fehler beim Hinzufgen eines Benutzers zu einem Dokument: ') +
            e.Message,
            2018, True);
   end;
   ReadDocRights;
end;

procedure Tfrm_Rechte.RemObj;
var
   iTmpType: integer;
   sTmpID, sTmpName: string;
begin
   try
      with lv_RRObj.Selected do
      begin
         sTmpID := SubItems.Strings[0];
         iTmpType := ImageIndex;
         sTmpName := Caption;
      end;

      with dm_DB.my_cmd do
      begin
         if iTmpType = 8 then
            SQL.Text := 'delete from sys_docxs where arc_id = ' +
               IntToStr(iGArcID) + ' and doc_id = ' + IntToStr(iGDocID) +
               ' and usr_id = ' + sTmpID + ' and grp_id = 0';
         if iTmpType = 9 then
            SQL.Text := 'delete from sys_docxs where arc_id = ' +
               IntToStr(iGArcID) + ' and doc_id = ' + IntToStr(iGDocID) +
               ' and grp_id = ' + sTmpID;
         Execute;
         frm_MainForm.NewHistory(3, _('Benutzer / Gruppe') + ' ' + sTmpName +
            ' ' + _('aus Dokument entfernt'));
      end;
   except
      on e: Exception do
         ErrorMsg('RemObj',
            _('Fehler beim Entfernen eines Benutzers aus einem Dokument: ') +
            e.Message,
            2019, True);
   end;
   ReadDocRights;
end;

procedure Tfrm_Rechte.ReadDocRights;
begin
   if frm_MainForm.TmpSQL(
      'select sys_usr.usr_id, usr_Name from sys_usr left join sys_docxs using(usr_id) where arc_id = '
      + IntToStr(iGArcID) + ' and doc_id = ' + IntToStr(iGDocID) +
      ' and grp_id = 0 Group by sys_usr.usr_id') then
   begin
      lv_RRObj.Items.Clear;
      with dm_DB.my_q_Tmp do
         while not EOF do
         begin
            with lv_RRObj.Items.Add do
            begin
               Caption := FieldByName('usr_name').AsString;
               ImageIndex := 8;
               SubItems.Add(FieldByName('usr_id').AsString);
            end;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
   end
   else
      ErrorMsg('ReadDocRights', _('Fehler beim Auslesen der Benutzer'),
         2013, True);

   if frm_MainForm.TmpSQL(
      'select sys_grp.grp_id, grp_Name from sys_grp left join sys_docxs Using(grp_id) where Arc_ID = '
      + IntToStr(iGArcID) + ' and Usr_ID = 0 and doc_id = ' + IntToStr(iGDocID) +
      ' group by sys_grp.grp_id') then
   begin
      with dm_DB.my_q_Tmp do
         while not EOF do
         begin
            with lv_RRObj.Items.Add do
            begin
               Caption := FieldByName('grp_name').AsString;
               ImageIndex := 9;
               SubItems.Add(FieldByName('grp_id').AsString);
            end;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
   end
   else
      ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'),
         2013, True);

   if frm_MainForm.TmpSQL(
      'select sys_usr.usr_id, usr_Name from sys_usr left join sys_docxs on sys_usr.usr_id = sys_docxs.usr_id '
      + 'and Grp_ID = 0 and Arc_ID = ' + IntToStr(iGArcID) + ' and doc_id = ' +
      IntToStr(iGDocID) + ' where grp_ID is null and usr_name not like  ' +
      #39 + 'DEL\_%' + #39) then
   begin
      lv_RSObj.Items.Clear;
      with dm_DB.my_q_Tmp do
         while not EOF do
         begin
            with lv_RSObj.Items.Add do
            begin
               Caption := FieldByName('usr_name').AsString;
               ImageIndex := 8;
               SubItems.Add(FieldByName('usr_id').AsString);
            end;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
   end
   else
      ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'),
         2013, True);

   if frm_MainForm.TmpSQL(
      'select sys_grp.grp_id, grp_Name from sys_grp left join sys_docxs on sys_grp.grp_id = sys_docxs.grp_id '
      + 'and Arc_ID = ' + IntToStr(iGArcID) + ' and Usr_ID = 0 and doc_id = ' +
      IntToStr(iGDocID) + ' where sys_docxs.Grp_ID is NULL') then
   begin
      with dm_DB.my_q_Tmp do
         while not EOF do
         begin
            with lv_RSObj.Items.Add do
            begin
               Caption := FieldByName('grp_name').AsString;
               ImageIndex := 9;
               SubItems.Add(FieldByName('grp_id').AsString);
            end;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
   end
   else
      ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'),
         2013, True);
   if lv_RRObj.Items.Count > 0 then
      lv_RRObj.Items[0].Selected := True;

   ReadObjRights(True);
end;

//iskywalker20070618 check if the function was called by   ReadDocRights


procedure Tfrm_Rechte.ReadObjRights(Owner: Bool);
var
   iTmpType, iRights, iuRights: integer;
   sTmpID, sTmpSQL: string;
begin
   if not Owner then
   begin
      if lv_RRObj.SelCount = 0 then
         exit;
      with lv_RRObj.Selected do
      begin
         sTmpID := SubItems.Strings[0];
         iTmpType := ImageIndex;
      end;
   end
   else
   begin
      sTmpID := IntToStr(iGUsrID);
      iTmpType := 8;
   end;

   // check users permission first

   sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = ' +
      IntToStr(iGArcID) + ' and doc_id = ' + IntToStr(iGDocID) +
      ' and grp_id = 0 and usr_id = ' + IntToStr(iGUsrID);

   if frm_MainForm.TmpSQL(sTmpSQL) then
   begin
      // the user has permissions but to what?
      if dm_DB.my_q_Tmp.RecordCount <> 0 then
      begin
         //[Hinweis] u_Rechte.pas(474): Auf 'iuRights' zugewiesener Wert wird niemals benutzt
         //[Warnung] u_Rechte.pas(475): Variable 'iRights' ist mglicherweise nicht initialisiert worden
         // msste hier nicht statt iuRights richtigerweise iRights stehen?

         iuRights := dm_DB.my_q_Tmp.FieldByName('recht').AsInteger; //prfen!!!
         // aber egal, das Fenster wird eh nicht mehr benutzt
         if (((iRights and 1) = 1) and ((iRights and 2) = 2) and   //prfen!!!
            ((iRights and 4) = 4) and ((iRights and 4) = 4) and
            ((iRights and 128) <> 128)) then
         begin
            // needed permissions existent allow to change!
            btn_save.Visible := True;
            panel1.Enabled := True;
         end
         else
         begin
            // just show
            // todo refine this better
            btn_save.Visible := False;
            panel1.Enabled := False;
         end;
      end;

      if iTmpType = 8 then
      begin
         sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = '
            + IntToStr(iGArcID) + '  and grp_id = 0 and usr_id = ' + sTmpID;
      end;
      if iTmpType = 9 then
      begin
         sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = '
            + IntToStr(iGArcID) + '  and usr_id = 0 and grp_id = ' + sTmpID;
      end;
      if not frm_MainForm.TmpSQL(sTmpSQL) then
      begin
         ErrorMsg('ReadObjRights',
            _('Fehler beim Auslesen der Objekt-Berechtigungen'),
            2019, True);
         exit;
      end;
      iRights := dm_DB.my_q_Tmp.FieldByName('recht').AsInteger;
      dm_DB.my_q_Tmp.Close;
      if (iRights and 1) = 1 then
         chbx_RList.Checked := True
      else
         chbx_RList.Checked := False;
      if (iRights and 2) = 2 then
         chbx_RRead.Checked := True
      else
         chbx_RRead.Checked := False;
      if (iRights and 4) = 4 then
         chbx_RChange.Checked := True
      else
         chbx_RChange.Checked := False;
      if (iRights and 8) = 8 then
         chbx_RWrite.Checked := True
      else
         chbx_RWrite.Checked := False;
      if (iRights and 16) = 16 then
         chbx_RMail.Checked := True
      else
         chbx_RMail.Checked := False;
      if (iRights and 32) = 32 then
         chbx_RPrint.Checked := True
      else
         chbx_RPrint.Checked := False;
      if (iRights and 64) = 64 then
         chbx_RLink.Checked := True
      else
         chbx_RLink.Checked := False;
      if (iRights and 128) = 128 then
      begin
         chbx_RRights.Checked := True;
         // the viewer user has rights to change
         //                btn_save.Visible:= true;
         //                bitbtn1.Visible:= false;
         //                panel1.Enabled:=true;
      end
      else
      begin
         chbx_RRights.Checked := False;

         // the viewer user has rights to change
         // btn_save.Visible:= false;
         //                bitbtn1.Visible:= true;
         //              panel1.Enabled:=false;
      end;
      if (iRights and 256) = 256 then
         chbx_RHistory.Checked := True
      else
         chbx_RHistory.Checked := False;
      if (iRights and 512) = 512 then
         chbx_RMove.Checked := True
      else
         chbx_RMove.Checked := False;
      //if (iRights and 2048) = 2048 then chbx_RApuRead.Checked := true else  chbx_RApuRead.Checked := false;
      if (iRights and 1024) = 1024 then
         chbx_RApuRead.Checked := True
      else
         chbx_RApuRead.Checked := False;
      if (iRights and 8192) = 8192 then
         chbx_RAprRead.Checked := True
      else
         chbx_RAprRead.Checked := False;
      if (iRights and 16384) = 16384 then
         chbx_RAprRead.Checked := True
      else
         chbx_RAprRead.Checked := False;

      {

          //  if chbx_RApuRead.Checked  then iRights := iRights + 2048; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
        if chbx_RApuRead.Checked then iRights := iRights + 1024;    //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
        //if chbx_RApuModify.checked then iRights:= iRights + 4096; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
        if chbx_RApuWrite.Checked then iRights := iRights + 2048;
        //if chbx_RApuread.Checked then iRights := iRights + 4096;
        if chbx_RAprRead.Checked then iRights := iRights + 8192;
        if chbx_RApuWrite.Checked then iRights := iRights + 16384;

       }

          {
           if chbx_RApuRead.Checked  then iRights := iRights + 2048; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
        if chbx_RApuWrite.Checked then iRights := iRights + 1024; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
        //if chbx_RApuModify.checked then iRights:= iRights + 4096; //   igel0702221244 Erweiterung der Rechte den Zugriff auf Anmerkungen
        }

   end
   else
      ErrorMsg('ReadObjRights', _('Fehler beim Auslesen der Objekt-Berechtigungen'),
         2019, True);
end;

procedure Tfrm_Rechte.sbtn_RAddClick(Sender: TObject);
begin
   if lv_RSObj.SelCount = 0 then
      exit;
   AddObj;
end;

procedure Tfrm_Rechte.sbtn_RRemClick(Sender: TObject);
begin
   if lv_RRObj.SelCount = 0 then
      exit;
   RemObj;
end;

procedure Tfrm_Rechte.lv_RRObjClick(Sender: TObject);
begin
   ReadObjRights(False);
end;

procedure Tfrm_Rechte.btn_SaveClick(Sender: TObject);
begin
   if lv_RRObj.SelCount = 0 then
      exit;
   ChangeRights;
   btn_Save.Enabled := False;
end;

procedure Tfrm_Rechte.chbx_RListClick(Sender: TObject);
begin
   btn_Save.Enabled := True;
end;

procedure Tfrm_Rechte.chbx_RApuWriteClick(Sender: TObject);
begin
   btn_Save.Enabled := True;
end;

procedure Tfrm_Rechte.chbx_RAprReadClick(Sender: TObject);
begin
   btn_Save.Enabled := True;
end;

procedure Tfrm_Rechte.chbx_RAprWriteClick(Sender: TObject);
begin
   btn_Save.Enabled := True;
end;

procedure Tfrm_Rechte.chbx_RApuReadClick(Sender: TObject);
begin
   btn_Save.Enabled := True;
end;

procedure Tfrm_Rechte.BitBtn1Click(Sender: TObject);
begin
   ChangeAnnoRights;
end;

end.
