unit u_SendMailLnk;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, IniFiles, Buttons, gnugettext,
   u_ShLowUtils, u_HighUtils;

type
   Tfrm_SendMailLnk = class (TForm)
      lv_UsrMail: TListView;
      btn_SendMail: TButton;
      edt_EMail: TEdit;
      btn_Close: TButton;
      lbl_eMail: TLabel;
      memo_MsgText: TMemo;
      lbl_Adressen: TLabel;
      lbl_MsgText: TLabel;
      bbtn_Send: TBitBtn;
      BBtnEnd: TBitBtn;
      procedure btn_SendMailClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure bbtn_SendClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      function ReadUser: boolean;
   end;

var
   frm_SendMailLnk: Tfrm_SendMailLnk;

implementation

uses u_MainForm, u_dm_DB, {} u_dm_ViewerMain;

{$R *.dfm}


function Tfrm_SendMailLnk.ReadUser: boolean;
begin
   Result := True;
   with frm_MainForm do
   begin
      lv_UsrMail.Items.Clear;

      if TmpSQL('select usr_name, usr_mail from sys_usr where Usr_name not like ' +
         #39 + 'DEL\_%' + #39 + 'order by usr_Name') then

         with dm_DB.my_q_Tmp do
         begin
            while not EOF do
            begin
               try
                  with lv_UsrMail.Items.Add do
                  begin
                     ImageIndex := 40;
                     Caption := FieldByName('Usr_Name').AsString;
                     SubItems.Text := FieldByName('usr_mail').AsString;
                  end;
                  Next;
               except
                  on e: Exception do
                  begin
                     Result := False;
                     ErrorMsg('frm_SendMailLnk.ReadUser',
                        _('Fehler beim Einlesen eines Benutzers: ') +
                        e.Message, 2005, True);
                  end;
               end;
            end;
         end
      else
      begin
         Result := False;
         ErrorMsg('frm_SendMailLnk.ReadUser', _('Fehler beim Einlesen der Benutzer.'),
            2015, True);
      end;
   end;
end;


procedure Tfrm_SendMailLnk.btn_SendMailClick(Sender: TObject);
var
   x: integer;
   sMsg, sID: string;
begin
   with dm_MainForm2 do
   begin
      if rGDocRight.mail then
      begin
         try
            //      smtp_Eng.Host := sGSmtpHost;
            mail_msg.ToList.Clear;
            mail_msg.CcList.Clear;
            mail_msg.BccList.Clear;
            mail_msg.AttachList.Clear;
            mail_Msg.SetFrom(sGUsrName, sGUsrEMail);
            for x := 0 to (lv_UsrMail.Items.Count - 1) do
            begin
               if lv_UsrMail.Items[x].Selected then
                  mail_Msg.ToList.Add(lv_UsrMail.Items[x].Caption,
                     Trim(lv_UsrMail.Items[x].SubItems.Text));
            end;
            if edt_eMail.Text <> '' then
               mail_Msg.ToList.Add(edt_eMail.Text, edt_eMail.Text);
            sID := IntToStr(iGArcID) + '.' + IntToStr(iGDocID);
            sMsg := '<META HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=iso-8859-1">' +
               '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">' +
               '<HTML><HEAD>' +
               '<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">' +
               '<META content="bitfarm Archiv V3" name=GENERATOR>' +
               '<STYLE></STYLE>' + '</HEAD>' + '<BODY bgColor=#ffffff>' +
               '<DIV><FONT face=Arial size=2>' +
               _('Klicken Sie auf den nachstehenden Link, um das Dokument im bitfarm-Archiv Viewer zu ffnen:') + ' '
               + '<A href="docid:' + sID +
               '">Zum Dokument</a></FONT>&nbsp;<BR><BR></DIV>' +
               // + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + ' DOCID: ' + sID + '.</a></FONT>&nbsp;<BR><BR></DIV>' +
               '<DIV><STRONG><FONT face=Arial size=2>' + _('Kurzmitteilung:') + '</STRONG><BR>' +
               memo_MsgText.Text + '</FONT><BR><BR></DIV>' +
               '<DIV><STRONG><FONT face=Arial><EM>bitfarm-<FONT color=#ff6600 >Archiv</FONT></STRONG> Dokumentenmanagement</EM></FONT><BR>'
               + '</BODY></HTML>';
            mail_msg.SetTextPlain(' Arc_id.Doc_id =  ' + sID + #13 +
               #13 + 'Kurzmitteillung:' + #13 + memo_MsgText.Text);
            mail_msg.SetTextHTML(sMsg);
            mail_Msg.Subject := 'bitfarm-Archiv Dokument ';
            // + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + ' DOCID: ' + sID + ' wurde an Sie weitergeleitet.';
            mail_Msg.RebuildBody;
            smtp_Eng.Quit;
            if not smtp_Eng.Connect then
            begin
               BfShowMessage(_('Konnte mit SMTP Server')+' ' + dm_MainForm2.smtp_Eng.Host +
                  ' ' + _('nicht verbinden.'));
            end;
            if not smtp_Eng.SendMessage then
            begin
               BfShowMessage(_('Link konnte nicht gesendet werden!'));
            end;
            smtp_Eng.Quit;
            frm_MainForm.setpanelinfo(
               _('Das Dokument wurde als Link versendet.'));
            frm_MainForm.NewHistory(14, _('Dokument wurde als E-Mail an' + _(' ' +
               mail_msg.ToList.AllAddresses + ' ') + 'als Link versendet.'));

         except
            on e: Exception do
            begin
               logevnt('Konnte mail link nicht versenden error :' + e.Message);
               ShowMessage(
                  _('Die Link konnte leider nicht als Mail wegen eines schweren Fehlers versendet werden.'));
            end;
         end;
      end
      else
      begin
         ShowMessage(_('Sie haben nicht die Berechtigung einen Link auf dieses Dokument per E-Mail zu versenden.'));
         frm_MainForm.setpanelinfo(
            _('Es wurde kein Link auf dieses Dokument versendet.'));
      end;
   end;
end;

procedure Tfrm_SendMailLnk.FormShow(Sender: TObject);
begin
   ReadUser;
end;

// 3.5.0.60
procedure Tfrm_SendMailLnk.bbtn_SendClick(Sender: TObject);
var
   x: integer;
   sMsg, sID, lsText: string;
begin
   GgfLogevnt('bbtn_SendClick');
   with dm_MainForm2 do
   begin
      if rGDocRight.mail then
      begin
        try
         //    smtp_Eng.Host := sGSmtpHost;
         mail_msg.ToList.Clear;
         mail_msg.CcList.Clear;
         mail_msg.BccList.Clear;
         mail_msg.AttachList.Clear;
         mail_Msg.SetFrom(sGUsrName, sGUsrEMail);
         for x := 0 to (lv_UsrMail.Items.Count - 1) do
         begin
            if lv_UsrMail.Items[x].Selected then
               mail_Msg.ToList.Add(lv_UsrMail.Items[x].Caption,
                  Trim(lv_UsrMail.Items[x].SubItems.Text));
         end;
         if edt_eMail.Text <> '' then
            mail_Msg.ToList.Add(edt_eMail.Text, edt_eMail.Text);

         //sID := IntToStr(iGArcID) + '.' + IntToStr(iGDocID);
         sID := GetDocIdString(':', iGArcID,iGDocID);

         sMsg := '<META HTTP-EQUIV="Content-Type" CONTENT="text/html;charset=iso-8859-1">' +
            '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">' +
            '<HTML><HEAD>' +
            '<META http-equiv=Content-Type content="text/html; charset=iso-8859-1">' +
            '<META content="bitfarm Archiv V3" name=GENERATOR>' +
            '<STYLE></STYLE>' + '</HEAD>' + '<BODY bgColor=#ffffff>' +
            '<DIV><FONT face=Arial size=2>' +
            _('Klicken Sie auf den nachstehenden Link, um das Dokument im bitfarm-Archiv Viewer zu ffnen:') + ' '
            //+ '<A href="docid:' + sID +
            + '<A href="' + sID +
            '">'+_('Zum Dokument')+'</a></FONT>&nbsp;<BR><BR></DIV>' +
            // + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + ' DOCID: ' + sID + '.</a></FONT>&nbsp;<BR><BR></DIV>' +
            '<DIV><STRONG><FONT face=Arial size=2>' + _('Kurzmitteilung:') + '</STRONG><BR>' +
            memo_MsgText.Text + '</FONT><BR><BR></DIV>' +
            '<DIV><STRONG><FONT face=Arial><EM>bitfarm-<FONT color=#ff6600 >Archiv</FONT></STRONG> '+
            _('Dokumentenmanagement')+'</EM></FONT><BR>'
            + '</BODY></HTML>';

         //lsText := ' Arc_id.Doc_id =  ' + sID + #13 + #13 + 'Kurzmitteillung:' + #13 + memo_MsgText.Text
         lsText := sID + #13 + #13 + _('Kurzmitteilung:') + #13 + memo_MsgText.Text; //3.5.0.60
         mail_msg.SetTextPlain(lsText);

         mail_msg.SetTextHTML(sMsg);
         mail_Msg.Subject := _('bitfarm-Archiv Dokument');
         // + dm_DB.my_q_Arc.FieldByName('disp_name').AsString + ' DOCID: ' + sID + ' wurde an Sie weitergeleitet.';
         mail_Msg.RebuildBody;
         smtp_Eng.Quit;
         GgfLogevnt('smtp_Eng.Quit');

           try
               if not smtp_Eng.Connect then
               begin
                  ShowMessage(_('Konnte nicht mit SMTP Server verbinden:') + dm_MainForm2.smtp_Eng.Host +#13+_('Der Link konnte nicht gesendet werden!') );
                  logevnt('Konnte mit SMTP Server ' + dm_MainForm2.smtp_Eng.Host +
                     ' nicht verbinden.');
               end
               else
               begin
                 if not smtp_Eng.SendMessage then
                 begin
                    ShowMessage(_('Der Link konnte nicht gesendet werden!'));
                    logevnt(_('Der Link konnte nicht gesendet werden!'));
                 end
                 else //3.5.0.45 [2192]
                 begin
                    frm_mainform.setpanelinfo(
                       _('Das Dokument wurde als Link versendet.'));
                    frm_MainForm.NewHistory(14, _('Dokument wurde als E-Mail an') + ' ' +
                       mail_msg.ToList.AllAddresses + ' ' + _('als Link versendet.'));
                 end;
               end;
           except
                on e: Exception do
                begin
                  BfShowMessage(_('Konnte nicht mit SMTP Server verbinden:') + dm_MainForm2.smtp_Eng.Host );
                  logevnt('Konnte mit SMTP Server ' + dm_MainForm2.smtp_Eng.Host +
                     ' nicht verbinden.'+ e.Message);
                end;
           end;
        except
            on e: Exception do
            begin
               logevnt('Der Link konnte wegen eines Fehlers leider nicht versandt werden :' + e.Message);
               BfShowMessage(_('Der Link konnte wegen eines Fehlers leider nicht versandt werden.'));
            end;
        end;

      end
      else
      begin
         BfShowMessage(_('Sie haben nicht die Berechtigung einen Link auf dieses Dokument per E-Mail zu versenden.'));
         frm_mainform.setpanelinfo(_('Es wurde kein Link auf dieses Dokument versendet.'));
      end;
   end;
   GgfLogevnt('bbtn_SendClick - Ende');
end;

procedure Tfrm_SendMailLnk.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
