unit u_SlwEdit;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, gnugettext,
   u_ShLowUtils;

type
   Tfrm_SlwEdit = class (TForm)
      lb_Slw: TListBox;
      edt_SlwEdit: TEdit;
      lbl_SlwEdit: TLabel;
      btn_NewSlw: TButton;
      btn_EdtSlw: TButton;
      btn_DelSlw: TButton;
      btn_Close: TButton;
      ButtonLeereLoeschen: TButton;
      Btn_doublesdel: TButton;
      procedure FormShow(Sender: TObject);
      procedure lb_SlwClick(Sender: TObject);
      procedure btn_NewSlwClick(Sender: TObject);
      procedure btn_EdtSlwClick(Sender: TObject);
      procedure btn_DelSlwClick(Sender: TObject);
      procedure btn_CloseClick(Sender: TObject);
      procedure btn_NewSlwKeyPress(Sender: TObject; var Key: char);
      procedure ButtonLeereLoeschenClick(Sender: TObject);
      procedure Btn_doublesdelClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      function ReadSlw: boolean;
      function NewSlw: boolean;
      function EditSlw: boolean;
      function DelSlw: boolean;
   end;

var
   frm_SlwEdit: Tfrm_SlwEdit;

implementation

uses u_MainForm, u_dm_DB;

{$R *.dfm}

function Tfrm_SlwEdit.ReadSlw: boolean;
   /////////////////////////////////////////////////////////////
   ///  23.05.2005  Erstellt (SV)                            ///
   ///                                                       ///
   ///  Diese Function liest die Schlagworte von einem Doku- ///
   ///  ment aus der Tabelle slw_xxxxxxx und listet Sie in   ///
   ///  einem Listenfeld auf                                 ///
   ///                                                       ///
   ///  Ausgabe: True bei Erfolg                             ///
   ///           False bei Fehlschlag                        ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
begin
   Result := True;
   with frm_MainForm do
   begin
      if TmpSQL('select * from slw_' + sIArcName + ' where doc_id = ' +
         IntToStr(iGDocID)) then
      begin
         try
            lb_Slw.Items.Clear;
            with dm_DB.my_q_Tmp do
            begin
               while not EOF do
               begin
                  lb_Slw.Items.AddObject(FieldByName('doc_slw').AsString,
                     TObject(FieldByName('slw_id').AsInteger));
                  Next;
               end;
               Close;
            end;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_SlwEdit.ReadSlw', _('Fehler beim Auslesen der Schlagworte: ') +
                  e.Message, 2024, True);
            end;
         end;
      end
      else
      begin
         Result := False;
         ErrorMsg('frm_SlwEdit.ReadSlw', _('Fehler beim Auslesen der Schlagworte'),
            2024, True);
      end;
   end;
end;

function Tfrm_SlwEdit.EditSlw: boolean;
   /////////////////////////////////////////////////////////////
   ///  23.05.2005  Erstellt (SV)                            ///
   ///                                                       ///
   ///  Diese Function Editiert ein Selektiertes Schlagwort  ///
   ///  und ndert es in der Tabelle slw_xxxxxxxxx.          ///
   ///                                                       ///
   ///  Ausgabe: True bei Erfolg                             ///
   ///           False bei Fehlschlag oder Abbruch           ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   sSlw, lssql: string;
   iTmpID: integer;
begin
   Result := True;
   if lb_Slw.Selected[lb_Slw.ItemIndex] then
   begin
      sSlw := lb_Slw.Items.Strings[lb_Slw.ItemIndex];
      iTmpID := integer(lb_Slw.Items.Objects[lb_Slw.ItemIndex]);
   end
   else
   begin
      Result := False;
      Exit;
   end;
   if InputQuery(_('Schlagwort bearbeiten...'),
      _('Hier knnen Sie das aktuelle Schlagwort verndern:'),
      sSlw) then
   begin
      with dm_DB.my_cmd do
      begin
         SQL.Text := 'Update slw_' + sIArcName + ' set doc_slw = ' +
            #39 + sSlw + #39 + ' where slw_id = ' + IntToStr(iTmpID);
         lssql := SQL.Text;
         try
            Execute;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_SlwEdit.EditSlw', _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                  e.Message + ' . sqltext: ' + lssql + ' slw: ' + sSlw, 2025, True);
            end;
         end;
      end;
   end
   else
      Result := False;
   if Result then
      frm_MainForm.NewHistory(7, _('Schlagwort gendert'));
end;

function Tfrm_SlwEdit.NewSlw: boolean;
   /////////////////////////////////////////////////////////////
   ///  23.05.2005  Erstellt (SV)                            ///
   ///                                                       ///
   ///  Diese Function Erzeugt ein neues Schlagwort in der   ///
   ///  Tabelle slw_xxxxxxxxx.                               ///
   ///                                                       ///
   ///  Ausgabe: True bei Erfolg                             ///
   ///           False bei Fehlschlag oder Abbruch           ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   sSlw, lssql: string;
begin
   Result := True;
   sSlw := edt_SlwEdit.Text;
   if InputQuery(_('Neues Schlagwort hinzufgen...'),
      _('Bitte geben Sie ein neues Schlagwort ein:'),
      sSlw) then
   begin
      with dm_DB.my_cmd do
      begin
         SQL.Text := 'Insert into slw_' + sIArcName + ' (doc_id, doc_slw) Values (' + IntToStr(iGDocID) +
            ', ' + #34 + trim(ParseSemicolonWithoutBackslash(sSlw)) + #34 + ')';
         lssql := SQL.Text;
         try
            Execute;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_SlwEdit.NewSlw', _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                  e.Message + ' . sqltext: ' + lssql + ' slw: ' + sSlw, 2025, True);
            end;
         end;
      end;
   end
   else
      Result := False;
   if Result then
      frm_MainForm.NewHistory(12, _('Neues Schlagwort') + ' [' + sSlw + '] ' + _('hinzugefgt.'));
end;

function Tfrm_SlwEdit.DelSlw: boolean;
   /////////////////////////////////////////////////////////////
   ///  23.05.2005  Erstellt (SV)                            ///
   ///                                                       ///
   ///  Diese Function lscht ein Schlagwort aus der Tabelle ///
   ///  slw_xxxxxxxxx                                        ///
   ///                                                       ///
   ///  Ausgabe: True bei Erfolg                             ///
   ///           False bei Fehlschlag oder Abbruch           ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   sSlw: string;
   iTmpID: integer;
begin
   Result := True;
   if lb_Slw.Selected[lb_Slw.ItemIndex] then
   begin
      sSlw := lb_Slw.Items.Strings[lb_Slw.ItemIndex];
      iTmpID := integer(lb_Slw.Items.Objects[lb_Slw.ItemIndex]);
   end
   else
   begin
      Result := False;
      Exit;
   end;
   if MessageDlg(_('Mchten Sie wirklich das Schlagwort') + ' [' + sSlw +
      '] ' + _('lschen?'), mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      with dm_DB.my_cmd do
      begin
         SQL.Text := 'delete from slw_' + sIArcName + ' where slw_id = ' + IntToStr(iTmpID);
         try
            Execute;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_SlwEdit.DelSlw', _('Fehler beim Entfernen eines Schlagwortes: ') +
                  e.Message, 2027, True);
            end;
         end;
      end;
   end
   else
      Result := False;
   if Result then
      frm_MainForm.NewHistory(13, _('Schlagwort') + ' [' + sSlw + '] ' + _('entfernt.'));
end;

procedure Tfrm_SlwEdit.lb_SlwClick(Sender: TObject);
begin
   if (lb_Slw.ItemIndex < 0) or (lb_Slw.ItemIndex >= lb_Slw.Count) then
      exit;
   if lb_Slw.Selected[lb_Slw.ItemIndex] then
   begin
      edt_SlwEdit.Text := lb_Slw.Items.Strings[lb_Slw.ItemIndex];
   end;
end;

procedure Tfrm_SlwEdit.FormShow(Sender: TObject);
begin
   ReadSlw;
end;

procedure Tfrm_SlwEdit.btn_NewSlwClick(Sender: TObject);
begin
   if (lb_Slw.Items.IndexOf(edt_SLWEdit.Text) = -1) then
   begin
      if NewSlw then
         ReadSlw;
   end
   else
   begin
      BfShowMessage(_('Das von Ihnen eingegebene Schlagwort existiert bereits.') +
         #10 + #10 + _('Das Wort braucht nicht zur Schlagwortliste hinzugefgt werden.'));
   end;
end;

procedure Tfrm_SlwEdit.btn_EdtSlwClick(Sender: TObject);
begin
   if edt_SLWEdit.Text <> '' then
   begin
      if (lb_Slw.Items.IndexOf(edt_SLWEdit.Text) <> -1) then
      begin
         //lb_Slw.Items.Strings[lb_Slw.ItemIndex]
         if EditSlw then
            ReadSlw;
      end
      else
      begin
         BfShowMessage(_('Das von Ihnen eingegebene Wort existiert nicht.') +
            #10 + _('Bitte whlen Sie ein Schlagwort aus der Liste.`'));
         exit;
      end;
   end
   else
   begin
      BfShowMessage(_('Bitte whlen Sie ein Schlagwort zum Bearbeiten aus der Liste.'));
      exit;
   end;
end;

procedure Tfrm_SlwEdit.btn_DelSlwClick(Sender: TObject);
//begin
//  if DelSlw then ReadSlw;
//end;      

begin
   if edt_SLWEdit.Text <> '' then
   begin
      if (lb_Slw.Items.IndexOf(lowercase(edt_SLWEdit.Text)) <> -1) then
      begin
         //lb_Slw.Items.Strings[lb_Slw.ItemIndex]
         if DelSlw then
            ReadSlw;
         ;
      end
      else
      begin
         BfShowMessage(_('Das von Ihnen eingegebene Wort existiert nicht in der Schlagwortliste.')
            + #10 + _('Bitte whlen Sie ein Schlagwort aus der Liste,') +
            #10 + _('welches gelscht werden soll.'));
         exit;
      end;
   end
   else
   begin
      BfShowMessage(_('Bitte whlen Sie ein Schlagwort aus der Liste,') +
         #10 + _('welches gelscht werden soll.'));
   end;
end;


procedure Tfrm_SlwEdit.btn_CloseClick(Sender: TObject);
begin
   frm_SlwEdit.ModalResult := mrOk;
end;

procedure Tfrm_SlwEdit.btn_NewSlwKeyPress(Sender: TObject; var Key: char);
begin
   MessageDlg(Key + ' has been pressed', mtInformation, [mbOK], 0);
end;

procedure Tfrm_SlwEdit.ButtonLeereLoeschenClick(Sender: TObject);
//var licount: integer;
begin
   {
   while ( licount < lb_SLW.Count) do
   begin
       if lb_slw.Items.Strings[licount] = '' then
       begin
          lb_slw.Items.Delete(licount);
       end
       else
           licount:=licount+1;
   end;
   }
   with dm_DB.my_cmd do
   begin
      SQL.Text := 'delete from slw_' + sIArcName + ' where doc_id = ' +
         IntToStr(iGDocID) + ' and trim(doc_slw) = ' + #39 + #39;
      Execute;
   end;
   frm_MainForm.NewHistory(12, _('Leere Schlagworte gelscht.'));
   ReadSlw;
end;

procedure Tfrm_SlwEdit.Btn_doublesdelClick(Sender: TObject);
var
   lbamy: array of boolean;
   licount: integer;
   lstrl: TStringList;
begin
   with dm_DB.my_q_tmp do
   begin
      SQL.Text := 'select distinct doc_slw from slw_' + sIArcName +
         ' where doc_id = ' + IntToStr(iGDocID);
      Execute;
      First;
   end;
   if dm_DB.my_q_tmp.RecordCount > 0 then
   begin
      setlength(lbamy, dm_DB.my_q_tmp.RecordCount);
      lstrl := TStringList.Create;
      licount := 0;
      while not dm_DB.my_q_tmp.EOF do
      begin
         lbamy[licount] := False;
         lstrl.Add(dm_DB.my_q_tmp.FieldByName('doc_slw').AsString);
         dm_DB.my_q_tmp.Next;
      end;

      with dm_DB.my_q_tmpcrestatus1 do
      begin
         SQL.Text := 'select * from slw_' + sIArcName + ' where doc_id = ' +
            IntToStr(iGDocID);
         Execute;
      end;

      lstrl.CaseSensitive := False;
      dm_DB.my_q_tmpcrestatus1.First;
      while not dm_DB.my_q_tmpcrestatus1.EOF do
      begin
         for  licount := 0 to lstrl.Count - 1 do
         begin
            if dm_DB.my_q_tmpcrestatus1.FieldByName('doc_slw').AsString =
               lstrl.Strings[licount] then
            begin
               if lbamy[licount] then
               begin
                  with dm_DB.my_cmd do
                  begin
                     SQL.Text := 'delete from slw_' + sIArcName + ' where doc_id = ' +
                        IntToStr(iGDocID) + ' and slw_id = ' + #39 +
                        dm_DB.my_q_tmpcrestatus1.FieldByName('slw_id').AsString + #39;
                     Execute;
                  end;
               end
               else
               begin
                  lbamy[licount] := True;
                  break;
               end;
            end;
         end;
         dm_DB.my_q_tmpcrestatus1.Next;
      end;
   end;
   frm_MainForm.NewHistory(12, _('Dublettenschlagworte gelscht.'));
   ReadSlw;
   setlength(lbamy, 0);
end;


procedure Tfrm_SlwEdit.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
