unit u_Stamps;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, ComCtrls, StdCtrls, Registry, ieVect, ImageEnView, ImageEnProc,
   ieview, hyieutils, gnugettext,
   u_ShLowUtils, ExtCtrls, Buttons;

type
   Tfrm_Stamps = class (TForm)
      lv_Stamps: TListView;
      Memo1: TMemo;
      PanelButton: TPanel;
      btn_Cancel: TBitBtn;
      btn_Ok: TBitBtn;
      procedure btn_OkClick(Sender: TObject);
      procedure lv_StampsDblClick(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure FormCreate(Sender: TObject);
   protected
      procedure CreateParams(var Params: TCreateParams); override;
      { Private-Deklarationen }
   public
      iev_myvect: TImageEnVect;
      tmp_iev_myvect: TImageEnVect;
      { Public-Deklarationen }

      function ListStamps: boolean;
   end;
   function LoadStamp(StampKey: string; iev_myvect:TImageEnVect): boolean;
   procedure CreateTfrm_Stamps(Owner:TWinControl; Aiev_myvect:TImageEnVect);
  
//var frm_Stamps: Tfrm_Stamps;


implementation

{$R *.dfm}

uses u_dm_DocEditor, u_DocEditor, u_MainForm, u_DocEditOpt,
   u_de_Eingabetext, u_dm_DB, StrUtils;


//-----------------------------------------------------------------------------
//3.5.0.40 [2336]
procedure CreateTfrm_Stamps(Owner:TWinControl; Aiev_myvect:TImageEnVect);
var frm_Stamps: Tfrm_Stamps;
begin
   (** )
   Application.CreateForm(Tfrm_Stamps, frm_Stamps);
   frm_stamps.iev_myvect := Aiev_myvect;
   frm_Stamps.ShowModal;
   frm_Stamps.Release;
   (**)
   frm_Stamps := Tfrm_Stamps.Create(Owner);
   try
      frm_stamps.tmp_iev_myvect := Aiev_myvect;
      frm_Stamps.ShowModal;
   finally
      frm_Stamps.Free;
   end;
   (**)
end;

procedure Tfrm_Stamps.CreateParams(var Params: TCreateParams);
var h1,h2:THandle;
begin
   inherited;
   //3.5.0.40 [2336]
   (** )
   GgfLogevnt('Tfrm_Stamps.CreateParams A');
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   GgfLogevnt('Tfrm_Stamps.CreateParams B');

   h1 := TWinControl(Owner).Handle;
   h2 := GetDesktopWindow;

   Params.WndParent := GetDesktopWindow;
   GgfLogevnt('Tfrm_Stamps.CreateParams C');
   (**)
end;

//-----------------------------------------------------------------------------
// lade Stempel und setze den Spempel an die richtige Stelle
function LoadStamp(StampKey: string; iev_myvect:TImageEnVect): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   bmpTmp: TImageEnView;
   mesTmp: TIEUnits;
   sStampText, sDate, sTime, sFileName, lszusname, lszusnr, splittext: string;
   iSWidth, iSHeight, liposzus, liposzus1,
   liposzus2, lizus: integer;
   lbfin: Boolean;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   //    ssTmp: TIEVSoftShadow;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   bFitToText : Boolean;
   memo2: TStringList;
   liDeckkraft : Integer;
begin
   Result := True;
   lbfin := false;
   lizus := 0;
   reg := TRegistry.Create;
   DateTimeToString(sDate, 'dd.mm.yyyy', Now);
   DateTimeToString(sTime, 'hh:nn:ss', Now);
   bmpTmp := TImageEnView.Create(nil);
   memo2 := TStringList.Create();

   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            if not KeyExists('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey) then
               exit;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + StampKey, True);
            with iev_myvect do
            begin
               if ValueExists('StampName') then
                  ObjName[-1] := 'Stempel: ' + ReadString('StampName')
               else
                  ObjName[-1] := _('Neuer Stempel');
               if ValueExists('StampTyp') then
               begin
                  if not ReadBool('StampTyp') then
                  begin
                     // Text Stempel
                     ObjKind[-1] := iekTEXT;
                     ObjKind[-1] := iekMEMO;

                     (*
                     if ValueExists('StampText') then
                     begin
                        memo1.Lines.Text := ReadString('StampText');
                        sStampText := ReadString('StampText');
                     end
                     else
                     begin
                        memo1.Lines.Text := '';
                        sStampText := _('(kein Text)');
                     end;
                     if ValueExists('FontColor') then
                        ObjPenColor[-1] := ReadInteger('FontColor')
                     else
                        ObjPenColor[-1] := 0;
                     if ValueExists('FontName') then
                        ObjFontName[-1] := ReadString('FontName')
                     else
                        ObjFontName[-1] := 'Arial';
                     if ValueExists('FontStyle') then
                     begin
                        ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                        ObjFontStyles[-1] := fsTmp;
                     end
                     else
                        ObjFontStyles[-1] := [];
                     if ValueExists('FontSize') then
                        ObjFontHeight[-1] := ReadInteger('FontSize')
                     else
                        ObjFontHeight[-1] := 72;
                     if ValueExists('ObjLabelBrushColor') then
                        ObjBrushColor[-1] := ReadInteger('ObjBrushColor');
                     if ValueExists('ObjArcEndingAngle') then
                        ObjArcEndingAngle[-1] := ReadFloat('ObjArcEndingAngle')
                     else
                        ObjArcEndingAngle[-1] := 90;
                     if ValueExists('ObjArcStartingAngle') then
                        ObjArcStartingAngle[-1] := ReadFloat('ObjArcStartingAngle')
                     else
                        ObjArcStartingAngle[-1] := 0;
                     if ValueExists('ObjBeginShape') then
                        ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp))
                     else
                        shTmp := iesNONE;
                     ObjBeginShape[-1] := shTmp;
                     if ValueExists('ObjBitmapBorder') then
                        ObjBitmapBorder[-1] := ReadBool('ObjBitmapBorder')
                     else
                        ObjBitmapBorder[-1] := False;
                     if ValueExists('ObjBoxHighLight') then
                        ObjBoxHighLight[-1] := ReadBool('ObjBoxHighLight')
                     else
                        ObjBoxHighLight[-1] := False;
                     if ValueExists('ObjBrushColor') then
                        ObjBrushColor[-1] := ReadInteger('ObjBrushColor')
                     else
                        ObjBrushColor[-1] := clYellow;
                     if ValueExists('ObjBrushStyle') then
                        ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
                     else
                        bsTmp := bsSolid;
                     ObjBrushStyle[-1] := bsTmp;
                     if ValueExists('ObjEndShape') then
                        ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp))
                     else
                        shTmp := iesNONE;
                     ObjEndShape[-1] := shTmp;
                     if ValueExists('ObjFontAngle') then
                        ObjFontAngle[-1] := ReadFloat('ObjFontAngle')
                     else
                        ObjFontAngle[-1] := 0;
                     if ValueExists('ObjFontHeight') then
                        ObjFontHeight[-1] := ReadInteger('ObjFontHeight')
                     else
                        ObjFontHeight[-1] := 12;
                     if ValueExists('ObjFontLocked') then
                        ObjFontLocked[-1] := ReadBool('ObjFontLocked')
                     else
                        ObjFontLocked[-1] := False;
                     if ValueExists('ObjFontName') then
                        ObjFontName[-1] := ReadString('ObjFontName')
                     else
                        ObjFontName[-1] := 'Arial';
                     if ValueExists('ObjFontStyles') then
                        ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp))
                     else
                        fsTmp := [];
                     ObjFontStyles[-1] := fsTmp;
                     if ValueExists('ObjLabelBrushColor') then
                        ObjLabelBrushColor[-1] := ReadInteger('ObjLabelBrushColor')
                     else
                        ObjLabelBrushColor[-1] := clGreen;
                     if ValueExists('ObjLabelBrushStyle') then
                        ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp))
                     else
                        bsTmp := bsSolid;
                     ObjLabelBrushStyle[-1] := bsTmp;
                     if ValueExists('ObjLabelPosition') then
                        ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp))
                     else
                        lpTmp := ielBegin;
                     ObjLabelPosition[-1] := lpTmp;
                     if ValueExists('ObjMemoBorderColor') then
                        ObjMemoBorderColor[-1] := ReadInteger('ObjMemoBorderColor')
                     else
                        ObjMemoBorderColor[-1] := clRed;
                     if ValueExists('ObjMemoBorderStyle') then
                        ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
                     else
                        psTmp := psSolid;
                     ObjMemoBorderStyle[-1] := psTmp;
                     if ValueExists('ObjMemoFixedHeight') then
                        ObjMemoFixedHeight[-1] := ReadInteger('ObjMemoFixedHeight')
                     else
                        ObjMemoFixedHeight[-1] := 0;
                     if ValueExists('ObjMemoLineSpace') then
                        ObjMemoLineSpace[-1] := ReadInteger('ObjMemoLineSpace')
                     else
                        ObjMemoLineSpace[-1] := 0;
                     if ValueExists('ObjName') then
                        ObjName[-1] := ReadString('ObjName')
                     else
                        ObjName[-1] := _('Neues Objekt') + ' ' + IntToStr(-1);
                     if ValueExists('ObjPenColor') then
                        ObjPenColor[-1] := ReadInteger('ObjPenColor')
                     else
                        ObjPenColor[-1] := clBlack;
                     if ValueExists('ObjPenStyle') then
                        ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp))
                     else
                        psTmp := psSolid;
                     ObjPenStyle[-1] := psTmp;
                     if ValueExists('ObjPenWidth') then
                        ObjPenWidth[-1] := ReadInteger('ObjPenWidth')
                     else
                        ObjPenWidth[-1] := 1;
                     if ValueExists('ObjPolylineClosed') then
                        ObjPolylineClosed[-1] := ReadBool('ObjPolylineClosed')
                     else
                        ObjPolylineClosed[-1] := False;
                     if ValueExists('ObjRulerType') then
                        ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp))
                     else
                        rtTmp := iertRULER;
                     ObjRulerType[-1] := rtTmp;
                     if ValueExists('ObjRulerUnit') then
                        ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp))
                     else
                        ruTmp := ieuPIXELS;
                     ObjRulerUnit[-1] := ruTmp;
                     if ValueExists('ObjShapeHeight') then
                        ObjShapeHeight[-1] := ReadInteger('ObjShapeHeight')
                     else
                        ObjShapeHeight[-1] := 0;
                     if ValueExists('ObjShapeWidth') then
                        ObjShapeWidth[-1] := ReadInteger('ObjShapeWidth')
                     else
                        ObjShapeWidth[-1] := 0;
                     //           if ValueExists('ObjSoftShadow') then ReadBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp)) else ssTmp.Enabled := False;
                     //          ObjSoftShadow[-1].Enabled := ssTmp.Enabled;
                     //          ObjSoftShadow[-1].Radius := ssTmp.Radius;
                     //          ObjSoftShadow[-1].OffsetX := ssTmp.OffsetX;
                     //          ObjSoftShadow[-1].OffsetY := ssTmp.OffsetY;
                     if ValueExists('ObjStyle') then
                        ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp))
                     else
                        osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
                     ObjStyle[-1] := osTmp;
                     if ValueExists('ObjTextAlign') then
                        ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp))
                     else
                        taTmp := iejLeft;
                     ObjTextAlign[-1] := taTmp;
                     if ValueExists('ObjTextAutoSize') then
                        ObjTextAutoSize[-1] := ReadBool('ObjTextAutoSize')
                     else
                        ObjTextAutoSize[-1] := False;
                     if ValueExists('ObjTextCurveCharRot') then
                        ObjTextCurveCharRot[-1] := ReadFloat('ObjTextCurveCharRot')
                     else
                        ObjTextCurveCharRot[-1] := 0;
                     if ValueExists('ObjText') then
                        ObjText[-1] := ReadString('ObjText')
                     else
                        ObjText[-1] := _('Neuer Text') + ' ' + IntToStr(-1);
                     if ValueExists('ObjTransparency') then
                        ObjTransparency[-1] := ReadInteger('ObjTransparency')
                     else
                        ObjTransparency[-1] := 255;
                     // liposzus := pos('%F', sStamptext);
                     *)
                     // f.schneider
                     // so jetzt mal alles neu und nur was wir wirklich brauchen
                     // um abwrtskompatibel zu sein wird beim fehlen in der registry von
                     // ObjMemoCharsBrushStyle dieser Wert von ObjBrushStyle genommen
                     // und gespeichert, danach ist der Wert angelegt


                     if ValueExists('StampText') then
                     begin
                        //memo2.add(ReadString('StampText'));
                        //memo1.Lines.Text := ReadString('StampText');
                        sStampText := ReadString('StampText');
                     end
                     else
                     begin
                        //memo2.add('');
                        //memo1.Lines.Text := '';
                        sStampText := _('(kein Text)');
                     end;

                     if ValueExists('FontColor') then
                        ObjPenColor[-1] := ReadInteger('FontColor')
                     else
                        ObjPenColor[-1] := 0;

                     if ValueExists('FontName') then
                        ObjFontName[-1] := ReadString('FontName')
                     else
                        ObjFontName[-1] := 'Arial';

                     if ValueExists('FontStyle') then
                     begin
                        ReadBinaryData('FontStyle', fsTmp, SizeOf(fsTmp));
                        ObjFontStyles[-1] := fsTmp;
                     end
                     else
                        ObjFontStyles[-1] := [];

                     if ValueExists('FontSize') then
                        ObjFontHeight[-1] := ReadInteger('FontSize')
                     else
                        ObjFontHeight[-1] := 72;

                     if ValueExists('StampHeight') then
                        iSHeight := ReadInteger('StampHeight')
                     else
                        iSHeight := 30;
                     if ValueExists('StampWidth') then
                        iSWidth := ReadInteger('StampWidth')
                     else
                        iSWidth := 40;
                    
                     if ValueExists('ObjBrushColor') then
                        ObjBrushColor[-1] := ReadInteger('ObjBrushColor')
                     else
                        ObjBrushColor[-1] := clYellow;

                     if ValueExists('ObjBrushStyle') then
                        ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
                     else
                        bsTmp := bsSolid;
                     ObjBrushStyle[-1] := bsTmp;

                     if ValueExists('ObjMemoBorderStyle') then
                        ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
                     else
                        psTmp := psClear;
                     ObjMemoBorderStyle[-1] := psTmp;


                     if ValueExists('ObjMemoBorderColor') then
                        ObjMemoBorderColor[-1] := ReadInteger('ObjMemoBorderColor')
                     else
                        ObjMemoBorderColor[-1] := clBlack;

                     if ValueExists('ObjTransparency') then
                        liDeckkraft := ReadInteger('ObjTransparency')
                     else
                        liDeckkraft := 255;

                     if liDeckkraft < 51 then  // f.schneider 3.5.0.133  Kein Stempel mehr unter 20% Deckkraft
                     begin
                         liDeckkraft := 255;
                         WriteInteger    ('ObjTransparency',    liDeckkraft);
                     end;
                     ObjTransparency[-1] := liDeckkraft;


                     if ValueExists('ObjMemoCharsBrushStyle') then
                        ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
                     else
                        bsTmp := bsClear;
                     ObjMemoCharsBrushStyle[-1] := bsTmp;

                     if ValueExists('StampFitToText') then
                      bFitToText := ReadBool('StampFitToText')
                     else
                       bFitToText := True;

                     liposzus := 0;
                     while not lbfin do
                     begin
                        liposzus2 := posex('%F', sStampText, liposzus + 1);
                        if liposzus2 > 0 then
                        begin
                           dm_db.my_q_tmp.sql.Text := 'select * from cfg_' + sIarcname;
                           dm_db.my_q_tmp.Execute;

                           if (liposzus > liposzus2) then
                           begin
                              break;
                           end;
                           liposzus1 := liposzus2;
                           while (copy(sStamptext, liposzus1, 1) <> ' ')
                              and (length(sStamptext) >= liposzus1) do
                           begin
                              liposzus1 := liposzus1 + 1;
                           end;
                           lszusnr := copy(sStamptext, liposzus2 + 2, liposzus1 - liposzus2 - 2);
                           try
                              lizus := StrToInt(lszusnr);
                           except
                              on e: Exception do
                              begin
                                 lizus := -1;
                              end;
                           end;
                           if lizus > -1 then
                           begin
                              dm_db.my_q_tmp.First;
                              while (dm_db.my_q_tmp.FieldByName('cfg_id').AsInteger <> lizus) and
                                 (not dm_db.my_q_tmp.EOF) do
                              begin
                                 dm_db.my_q_tmp.Next;
                              end;
                              lszusname := dm_db.my_q_tmp.FieldByName('Feld_Name').AsString;
                              if iGArcRecNo <> dm_db.my_q_arc.RecNo then
                              begin
                                 dm_db.my_q_Arc.GotoBookmark(
                                    Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
                              end;
                              if dm_db.my_q_Arc.FieldDefList.Find(lszusname) <> nil then
                              begin
                                 sStampText :=
                                    StringReplace(sStampText, '%F' + lszusnr,
                                    dm_db.my_q_arc.FieldByName(lszusname).AsString, [rfReplaceAll]);
                              end;
                           end;
                        end;

                        liposzus := liposzus2 + 1;
                        if (length(sStampText) < liposzus) or
                           (liposzus2 = 0) then
                        begin
                           lbfin := true;
                        end;
                     end;
                     sStampText := StringReplace(sStampText, '%D', sDate, [rfReplaceAll]);
                     sStampText := StringReplace(sStampText, '%Z', sTime, [rfReplaceAll]);
                     sStampText := StringReplace(sStampText, '%U', sGUsrName, [rfReplaceAll]);
                     sStampText := StringReplace(sStampText, '\n\r', #13#10, [rfReplaceAll]);

                     if not bFitToText then
                     begin
                       mesTmp := MUnit;
                       MUnit := ieuMILLIMETERS;
                       ObjWidth[-1] := Round(iSWidth / MeasureCoefX);
                       ObjHeight[-1] := Round(iSHeight / MeasureCoefY);
                       MUnit := mesTmp;
                     end;

                     splittext := sStampText;
                     while Pos(#13#10,splittext) > 0 do
                     begin
                        memo2.Add(LeftStr(splittext,Pos(#13#10,splittext)));
                        splittext := RightStr(splittext,Length(splittext) - Pos(#13#10,splittext)-1);
                     end;
                     if splittext <> '' then
                       memo2.Add(splittext);

                     MouseInteractVT := [miPutmemo];

                     if not assigned(frm_textanno) then
                     begin
                        Application.CreateForm(Tfrm_textanno, frm_textanno);
                     end;
                     frm_textanno.iev_myvect := iev_myvect;
                     if bFitToText then
                        frm_textanno.textanObjektpassen(memo2)
                     else
                        iev_myvect.ObjText[-1] := sStampText;
                     //3.5.0.40 [2336]
                     {
                     }
                  end
                  else
                  begin
                     // Bild Stempel
                     // Mit der
                     iev_myvect.ObjKind[-1] := iekBITMAP;
                     if ValueExists('StampFile') then
                        sFileName := ReadString('StampFile')
                     else
                        exit;
                     if FileExists(sFileName) then
                     begin
                        iev_myvect.SetObjBitmapFromFile(-1, sFileName);
                        // bmpTmp.set SetObjBitmapFromFile
                        //bmpTmp.IO.LoadFromFile(sFileName)
                     end
                     else
                        exit;
                     if ValueExists('StampHeight') then
                        iSHeight := ReadInteger('StampHeight')
                     else
                        iSHeight := 30;
                     if ValueExists('StampWidth') then
                        iSWidth := ReadInteger('StampWidth')
                     else
                        iSWidth := 40;

                     //               iev_myvect.ObjGraphicRender:=true;

                     if ValueExists('ObjTransparency') then
                        liDeckkraft := ReadInteger('ObjTransparency')
                     else
                        liDeckkraft := 255;

                     if liDeckkraft < 51 then  // f.schneider 3.5.0.133  Kein Stempel mehr unter 20% Deckkraft
                     begin
                         liDeckkraft := 255;
                         WriteInteger    ('ObjTransparency',    liDeckkraft);
                     end;
                     iev_myvect.ObjTransparency[-1] := liDeckkraft;

                     iev_myvect.EnableAlphaChannel := True;
                     iev_myvect.ObjBrushColor[-1] := 16777215;
                     mesTmp := MUnit;
                     MUnit := ieuMILLIMETERS;
                     ObjWidth[-1] := Round(iSWidth / MeasureCoefX);
                     ObjHeight[-1] := Round(iSHeight / MeasureCoefY);
                     MUnit := mesTmp;
                     ObjBitmapBorder[-1] := False;
                     // ObjBitmap[-1].AssignImage(bmpTmp.IEBitmap);
                     //     ObjBitmap[-1].AssignImage(ImageEnVect1.ObjBitmap[-1]);
                     //objBitmap[-1].a
                     //               iev_myvect.ObjStyle[-1]:=[ievsSizeable];
                     MouseInteractVT := [miPutBitmap];
                  end;
               end
               else
                  exit; // Stempel Typ unbekannt - verlassen!
            end;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_Stamps.LoadStamp', _('Fehler beim Lesen der Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      reg.CloseKey;
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(bmpTmp) then
         FreeAndNil(bmpTmp);
   end;
end;

function Tfrm_Stamps.ListStamps: boolean;
var
   reg: TRegistry;
   slStampKeys: TStrings;
   iCount: integer;
   lItem: TListItem;
begin
   GgfLogevntBeg('Tfrm_Stamps.ListStamps beg');
   Result := True;
   reg := TRegistry.Create;
   slStampKeys := TStringList.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
            GetKeyNames(slStampKeys);
            CloseKey;
            lv_Stamps.Clear;
            for iCount := 0 to (slStampKeys.Count - 1) do
            begin
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  slStampKeys.Strings[iCount], True);
               lItem := lv_Stamps.Items.Add;
               if ValueExists('StampName') then
                  lItem.Caption := ReadString('StampName')
               else
                  lItem.Caption := 'unbekannter Stempel';
               lItem.SubItems.Add(slStampKeys.Strings[iCount]);
               if ValueExists('StampTyp') then
               begin
                  if ReadBool('StampTyp') then
                     lItem.ImageIndex := 1
                  else
                     lItem.ImageIndex := 0;
               end
               else
                  lItem.ImageIndex := 3;
               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_Stamps.ListStamps', _('Fehler beim Lesen der Registrierung: ') +
               e.Message, 2200, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(slStampKeys) then
         FreeAndNil(slStampKeys);
   end;
   GgfLogevntEnd('Tfrm_Stamps.ListStamps end');
end;


procedure Tfrm_Stamps.btn_OkClick(Sender: TObject);
begin
   if lv_Stamps.SelCount > 0 then
      LoadStamp(lv_Stamps.Selected.SubItems.Strings[0], tmp_iev_myvect);
   ModalResult := mrOk;   //3.5.0.40 [2336]
   //frm_docEditOPt.edt_APenWidth.Tag := 110;
end;

procedure Tfrm_Stamps.lv_StampsDblClick(Sender: TObject);
begin
   btn_OkClick(self);
end;

procedure Tfrm_Stamps.FormShow(Sender: TObject);
begin
   GgfLogevntBeg('Tfrm_Stamps.FormShow beg');
   ListStamps;
   GgfLogevntEnd('Tfrm_Stamps.FormShow end');
end;


procedure Tfrm_Stamps.FormCreate(Sender: TObject);
begin
   GgfLogevntBeg('Tfrm_Stamps.FormCreate beg');
   TranslateComponent(self, 'Viewerv3');
   GgfLogevntEnd('Tfrm_Stamps.FormCreate end');
end;

end.
