unit u_UsRLayerRights;

//   skywalker20070619 save the rights right (create entry and xor and not the bits rights)
//   skywalker20070618 u_USRRights sql condition grp_ID is null and put away so
//   todo change sys_docxs so it supports target_id or owner_id (so i can set the users to see my annotation, and not
//   to see annotations of the document at all.)

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, u_DocEditor, gnugettext,
   u_ShLowUtils;

type
   Tfrm_UsrLayerRights = class (TForm)
      lv_UsrGrp: TListView;
      chbx_RAprWrite: TCheckBox;
      chbx_RAprRead: TCheckBox;
      Button1: TButton;
      Button2: TButton;
      //close button
      Button3: TButton;
      cbx_prannowvl: TCheckBox;
      procedure chbx_RAprWriteClick(Sender: TObject);
      procedure Button1Click(Sender: TObject);
      procedure FormShow(Sender: TObject);
      procedure Button2Click(Sender: TObject);
      procedure chbx_RAprReadClick(Sender: TObject);
      // show the user rights
      procedure lv_UsrGrpCustomDrawItem(Sender: TCustomListView;
         Item: TListItem; State: TCustomDrawState; var DefaultDraw: boolean);
      // check the checkbox respectively when user is selected
      procedure lv_UsrGrpSelectItem(Sender: TObject; Item: TListItem;
         Selected: boolean);
      // close form on close button (better than waiting for close on save)
      procedure frm_usrlayerrightsclose(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      // procedure FormShow(Sender: TObject);
   protected
      procedure CreateParams(var Params: TCreateParams); override;
   public
      { Public-Deklarationen }
      Doc_obj: TDOCOBJ;
      procedure ReadObjRights;
      procedure ReadDocRights;
      procedure SetDoCRights;
   end;

var
   frm_UsrLayerRights: Tfrm_UsrLayerRights;
   // save the rights of the users so they can be shown
   ingrights: array of integer;

implementation

uses u_MainForm, u_dm_DB, u_dm_DocEditor;


{$R *.dfm}

//change the color of the item if the user has rights in sys_docxs
procedure Tfrm_UsrLayerRights.lv_UsrGrpCustomDrawItem(Sender: TCustomListView;
   Item: TListItem; State: TCustomDrawState; var DefaultDraw: boolean);
begin
   with Sender.Canvas.brush do
   begin
      if (length(ingrights) > Item.index) then
      begin
         case ingrights[Item.index] of
            //  0:font.color:=clgreen;
            //1:font.color:=clred;
            0:
               color := clwhite;
         else
            color := clgray;
            //      0: Color := clGreen;
         end;
      end;
   end;
end;


procedure Tfrm_UsrLayerRights.chbx_RAprReadClick(Sender: TObject);
begin
   if not chbx_RAprRead.Checked then
      chbx_RAprWrite.Checked := False;
end;

procedure Tfrm_UsrLayerRights.chbx_RAprWriteClick(Sender: TObject);
begin
   if chbx_RAprWrite.Checked then
      chbx_RAprRead.Checked := True;
end;


procedure Tfrm_UsrLayerRights.ReadObjRights;

var
   iTmpType{, iRights}: integer;
   sTmpID, sTmpSQL: string;
begin
   if lv_UsrGrp.SelCount = 0 then
      exit;
   with lv_UsrGrp.Selected do
   begin
      sTmpID := SubItems.Strings[0];
      iTmpType := ImageIndex;
   end;

   if iTmpType = 8 then
      sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = ' +
         IntToStr(doc_obj.arc_id) + ' and doc_id = ' + IntToStr(doc_obj.doc_id) +
         ' and grp_id = 0 and usr_id = ' + sTmpID + ' and src_usr_id =' + IntToStr(iGUsrID);

   if iTmpType = 9 then
      sTmpSQL := 'select cast(rights as signed) as recht from sys_docxs where arc_id = ' +
         IntToStr(doc_obj.arc_id) + ' and doc_id = ' + IntToStr(doc_obj.doc_id) +
         ' and usr_id = 0 and grp_id = ' + sTmpID + ' and src_usr_id =' + IntToStr(iGUsrID);

   if frm_MainForm.TmpSQL(sTmpSQL) then
   begin
      dm_DB.my_q_Tmp.Close;
   {
    if (iRights and 1) = 1 then chbx_RList.Checked := true else chbx_RList.Checked := false;
    if (iRights and 2) = 2 then chbx_RRead.Checked := true else chbx_RRead.Checked := false;
    if (iRights and 4) = 4 then chbx_RChange.Checked := true else chbx_RChange.Checked := false;
    if (iRights and 8) = 8 then chbx_RWrite.Checked := true else chbx_RWrite.Checked := false;
    if (iRights and 16) = 16 then chbx_RMail.Checked := true else chbx_RMail.Checked := false;
    if (iRights and 32) = 32 then chbx_RPrint.Checked := True else chbx_RPrint.Checked := false;
    if (iRights and 64) = 64 then chbx_RLink.Checked := true else chbx_RLink.Checked := false;
    if (iRights and 128) = 128 then chbx_RRights.Checked := true else chbx_RRights.Checked := false;
    if (iRights and 256) = 256 then chbx_RHistory.Checked := true else chbx_RHistory.Checked := false;
    if (iRights and 512) = 512 then chbx_RMove.Checked := true else chbx_RMove.Checked := false;
    //if (iRights and 2048) = 2048 then chbx_RApuRead.Checked := true else  chbx_RApuRead.Checked := false;
    if (iRights and 1024) = 1024 then chbx_RApuRead.Checked := true else chbx_RApuRead.Checked:= False;
   }
   end
   else
      ErrorMsg('ReadObjRights', _('Fehler beim Auslesen der Objekt-Berechtigungen'),
         2019, True);
end;

procedure Tfrm_UsrLayerRights.Button1Click(Sender: TObject);
begin
   ReadDocRights;
end;


procedure Tfrm_UsrLayerRights.ReadDocRights;
var
   iRights: integer;

begin
{
  if frm_MainForm.TmpSQL('select sys_usr.usr_id, usr_Name from sys_usr left join sys_docxs using(usr_id) where arc_id = ' + IntToStr(iGArcID) +
                         ' and doc_id = ' + IntToStr(iGDocID) + ' and grp_id = 0 Group by sys_usr.usr_id') then
  begin
    lv_UsrGrp.Items.Clear;
    with dm_DB.my_q_Tmp do
      while not Eof do
      begin
        with lv_UsrGrp.Items.Add do
        begin
          Caption := FieldByName('usr_name').AsString;
          ImageIndex := 8;
          SubItems.Add(FieldByName('usr_id').AsString);
          SubItems.Add('Read');
        end;
        Next;
      end;
      dm_DB.my_q_Tmp.Close
  end else ErrorMsg('ReadDocRights', 'Fehler beim Auslesen der Benutzer', 2013, True);

  if frm_MainForm.TmpSQL('select sys_grp.grp_id, grp_Name from sys_grp left join sys_docxs Using(grp_id) where Arc_ID = ' + IntToStr(iGArcID) +
                         ' and Usr_ID = 0 and doc_id = ' + IntToStr(iGDocID) + ' group by sys_grp.grp_id') then
  begin
    with dm_DB.my_q_Tmp do
      while not Eof do
      begin
        with lv_UsrGrp.Items.Add do
        begin
          Caption := FieldByName('grp_name').AsString;
          ImageIndex := 9;
          SubItems.Add(FieldByName('grp_id').AsString);
          SubItems.Add('Read');
        end;
        Next;
      end;
      dm_DB.my_q_Tmp.Close
  end else ErrorMsg('ReadArcRights', 'Fehler beim Auslesen der Benutzer', 2013, True);

 }
   // reset the rights
   setlength(ingrights, 0);

   //skywalker20070618 sql condition grp_ID is null and put away so
   // u_rechte added users can be selected
   // select the rights for this document which the usr src_usr_id gave to the users
   if frm_MainForm.TmpSQL(
      'select sys_usr.usr_id, usr_Name,  cast(rights as signed) as recht from sys_usr left join sys_docxs '
      + ' on ( sys_usr.usr_id = sys_docxs.usr_id ' + ' and Grp_ID = 0 and Arc_ID = ' +
      IntToStr(doc_obj.arc_id) + ' and doc_id = ' + IntToStr(doc_obj.doc_id) +
      ' and src_usr_id=' + IntToStr(iGUsrID) + ') where  usr_name not like  ' +
      #39 + 'DEL\_%' + #39 + ' order by usr_name') then
      //if    frm_MainForm.TmpSQL('select sys_usr.usr_id, usr_Name from sys_usr where  usr_name not like  '+#39+'DEL\_%'+#39) then
   begin
      lv_UsrGrp.Items.Clear;
      with dm_DB.my_q_Tmp do
         while not EOF do
         begin
            with lv_UsrGrp.Items.Add do
            begin
               Caption := FieldByName('usr_name').AsString;
               SubItems.Add(FieldByName('usr_id').AsString);
               iRights := 0;
               ImageIndex := 8;
               setlength(ingrights, length(ingrights) + 1);

      {    dm_db.my_q_tmp1.SQL.text:=' select   cast(rights as signed) as recht from sys_docxs where usr_id='+
                                      FieldByName('usr_id').AsString+' and   Grp_ID = 0 and Arc_ID = ' + IntToStr(iGArcID) +
                                      ' and doc_id = ' + IntToStr(iGDocID) +' and src_usr_id ='+inttostr(iGUsrID);
          dm_db.my_q_tmp1.execute;}
               // if the user has rights in sys_docsxs save them
               if not FieldByName('recht').IsNull then
               begin
                  iRights := FieldByName('recht').AsInteger;
               end;
               ingrights[length(ingrights) - 1] := iRights;
               SubItems.Add(IntToStr(iRights));
            end;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
   end
   else
      ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'),
         2013, True);

   // select the rights for this document which the usr src_usr_id gave to the groups
   if frm_MainForm.TmpSQL(
      'select sys_grp.grp_id, grp_Name, cast(rights as signed) as recht from sys_grp left join sys_docxs on (sys_grp.grp_id = sys_docxs.grp_id ' + 'and Arc_ID = ' +
      IntToStr(doc_obj.arc_id) + ' and Usr_ID = 0 and doc_id = ' + IntToStr(doc_obj.doc_id) +
      ' and src_usr_id=' + IntToStr(iGUsrID) + ' ) order by grp_name') then
      // if    frm_MainForm.TmpSQL('select sys_grp.grp_id, grp_Name  from sys_grp ') then
   begin
      with dm_DB.my_q_Tmp do
         while not EOF do
         begin
            with lv_UsrGrp.Items.Add do
            begin
               Caption := FieldByName('grp_name').AsString;
               SubItems.Add(FieldByName('grp_id').AsString);
               iRights := 0;
               ImageIndex := 9;
               setlength(ingrights, length(ingrights) + 1);
     {     dm_db.my_q_tmp1.SQL.text:=' select   cast(rights as signed) as recht from sys_docxs where grp_id='+
                                      FieldByName('grp_id').AsString+' and   usr_ID = 0 and Arc_ID = ' + IntToStr(iGArcID) +
                                      ' and doc_id = ' + IntToStr(iGDocID) +' and src_usr_id ='+inttostr(iGUsrID);
          dm_db.my_q_tmp1.execute;}

               // if the user has rights in sys_docsxs save them
               if not FieldByName('recht').IsNull then
               begin
                  iRights := FieldByName('recht').AsInteger;
               end;
               ingrights[length(ingrights) - 1] := iRights;
               SubItems.Add(IntToStr(iRights));
            end;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
   end
   else
      ErrorMsg('ReadArcRights', _('Fehler beim Auslesen der Benutzer'),
         2013, True);
   if lv_UsrGrp.Items.Count > 0 then
      lv_UsrGrp.Items[0].Selected := True;


   ReadObjRights;
end;


procedure Tfrm_UsrLayerRights.FormShow(Sender: TObject);
begin
   ReadDocRights;
end;


procedure Tfrm_UsrLayerRights.setDocRights;
begin
   // Moin moin
end;


// save button
procedure Tfrm_UsrLayerRights.Button2Click(Sender: TObject);

var
   iRights, iTmpType, usrexists, liInsID, litarcid, litdocid: integer;
   sTmpID, sTmpName, sTmpSQL, lsarcname: string;

begin
   //iskywalker20070619 we hope the user exists
   usrexists := 1;
   try
      with lv_UsrGrp.Selected do
      begin
         sTmpID := SubItems.Strings[0];
         iTmpType := ImageIndex;
         sTmpName := Caption;
      end;
      sTmpSQL := 'select cast(rights as signed) as recht, docxs_id from sys_docxs where arc_id = '
         + IntToStr(doc_obj.arc_id) + ' and doc_id = ' + IntToStr(doc_obj.doc_id) +
         ' and grp_id = 0 and usr_id = ' + sTmpID + ' and src_usr_id = ' +
         IntToStr(iGUSRID);
      if frm_MainForm.TmpSQL(sTmpSQL) then
      begin
         if dm_DB.my_q_Tmp.RecordCount = 0 then
         begin
            // the user doesnt exists read the sys_arc (directory) rights
            usrexists := 0;
            if iTmpType = 8 then
            begin
               sTmpSQL := 'select cast(rights as signed) as recht from sys_arcxs where arc_id = '
                  + IntToStr(doc_obj.arc_id) + '  and usr_id = ' + sTmpID;
            end;
            if iTmpType = 9 then
            begin
               sTmpSQL :=
                  'select cast(rights as signed) as recht from sys_arcxs where arc_id = ' +
                  IntToStr(doc_obj.arc_id) + ' and grp_id = ' + sTmpID;
            end;
            if not frm_MainForm.TmpSQL(sTmpSQL) then
            begin
               ErrorMsg('ReadObjRights', _('Fehler beim Auslesen der Objekt-Berechtigungen'),
                  2019, True);
               exit;
            end;
         end;
      end;
      iRights := dm_DB.my_q_Tmp.FieldByName('recht').AsInteger;
      // Checkboxen bennen
      // Fehler: Die rechte (schreiben und Kesen haben die falsche Zuornung erhalten)
      // Schreiben der privat Annotation = 8192
      // Lesen der Annotation = 16384
      if chbx_RAprWrite.Checked then
         // if chbx_RAprRead.Checked then
      begin
         // put the bit on!
         iRights := (iRights or 8192); // hier soll es das recht zum lesen geben NG
      end
      else
      begin
         // reverse all bits of 8192 and "and" with rights
         // lets call this function g with 2 arguments the rights and the number to be negated,
         // so g(101, 1) is 100, a single -1 would cause 100 to be 11 where g(100,1) is 100
         // e.g. 101 and 110, 100 and 110
         iRights := (iRights and (not 8192));
      end;


      if chbx_RAprRead.Checked then
         // if chbx_RAprWrite.Checked then
      begin
         iRights := (iRights or 16384);
         // hier solls das Redcht zum Schreiben respektive Aender geben NG
      end
      else
      begin
         iRights := (iRights and (not 16384));
         // user exists then just update the value right
      end;

      if (usrexists = 1) then
      begin
         with dm_DB.my_cmd do
         begin
            // itmpType 8  ist ein USER
            // ItmpType 9  ist eine Gruppe

            if iTmpType = 8 then
            begin
               if cbx_prannowvl.checked then
               begin
                  lsarcname := doc_obj.sIArcName;
                  dm_DB.my_Cmd.SQL.Text :=
                     'Insert into sys_timer ( arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                     + 'Values ( :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';

                  dm_DB.my_Cmd.ParamByName('arcid').AsInteger := doc_obj.arc_id;
                  dm_DB.my_Cmd.ParamByName('docid').AsInteger := doc_obj.doc_id;
                  dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                     dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                  dm_DB.my_Cmd.ParamByName('uwork').AsString := sTmpID;
                  dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
                  dm_DB.my_Cmd.ParamByName('termin').AsDateTime := now;

                  dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := now + 7;
                  dm_DB.my_Cmd.ParamByName('optionen').AsInteger := 0;

                  dm_DB.my_Cmd.ParamByName('info').AsString :=
                     _('Neue private Annotation fr Sie von ') + sGUsrName;
                  dm_DB.my_Cmd.Execute;
                  liInsID := dm_DB.my_Cmd.InsertId;
                  dm_DB.my_Cmd.SQL.Text :=
                     'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
                     ' where tim_id = ' + IntToStr(liInsID);
                  dm_DB.my_Cmd.Execute;

                  dm_docedit.my_q_doctmp.sql.text := 'select * from sys_arc where arc_id=' + inttostr(doc_obj.arc_id);
                  dm_docedit.my_q_doctmp.execute;
                  dm_DB.my_Cmd.SQL.Text :=
                     'Update arc_' + lsarcname + ' set doc_State = (doc_state or 1)' +
                     ' where doc_id = ' + IntToStr(doc_obj.doc_id);
                  dm_DB.my_Cmd.Execute;
               end;

               Sql.Text := {'Update sys_docxs set rights = ' + IntToStr(iRights) +
                                           ' where usr_id = ' + sTmpID + ' and doc_id = ' + IntToStr(iGDocID) +
                                           ' and arc_id = ' + IntToStr(iGArcID) + ' and grp_id = 0';}
                  ' Update sys_docxs set rights = ' + IntToStr(iRights) +
                  ' where docxs_id = ' + dm_DB.my_q_Tmp.FieldByName('docxs_id').AsString;
            end
            else
               //          if iTmpType = 9 then
            begin
               Sql.Text :={ 'Update sys_docxs set rights = ' + IntToStr(iRights) +
                                           ' where doc_id = ' + IntToStr(iGDocID) + ' and arc_id = ' + IntToStr(iGArcID) +
                                           ' and grp_id = ' + sTmpID;}
                  ' Update sys_docxs set rights = ' + IntToStr(iRights) +
                  ' where docxs_id = ' + dm_DB.my_q_Tmp.FieldByName('docxs_id').AsString;
            end;
            Execute;
            // initiierenden benutzer schreiben

            litarcid := igarcid;
            litdocid := igdocid;
            igarcid := doc_obj.arc_id;
            igdocid := doc_obj.doc_id;
            sIarcname := '';
            frm_MainForm.NewHistory(1, _('Dokumentenrechte fr Benutzer / Gruppe') + ' ' +
               sTmpName + ' ' + _('gendert') + '. (' + IntToStr(iRights) + ')');
            igarcid := litarcid;
            igdocid := litdocid;
         end;
      end
      else
         // the user doesnt exist, create an entry
      begin
         with dm_DB.my_cmd do
         begin
            if iTmpType = 8 then
            begin
               if cbx_prannowvl.checked then
               begin
                  lsarcname := doc_obj.sIArcName;
                  dm_DB.my_Cmd.SQL.Text :=
                     'Insert into sys_timer ( arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                     + 'Values ( :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :alarm, :optionen, :info)';

                  dm_DB.my_Cmd.ParamByName('arcid').AsInteger := doc_obj.arc_id;
                  dm_DB.my_Cmd.ParamByName('docid').AsInteger := doc_obj.doc_id;
                  dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                     dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                  dm_DB.my_Cmd.ParamByName('uwork').AsString := sTmpID;
                  dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
                  dm_DB.my_Cmd.ParamByName('termin').AsDateTime := now;

                  dm_DB.my_Cmd.ParamByName('alarm').AsDateTime := now + 7;
                  dm_DB.my_Cmd.ParamByName('optionen').AsInteger := 0;

                  dm_DB.my_Cmd.ParamByName('info').AsString :=
                     _('Neue private Annotation fr Sie von ') + sGUsrName;
                  dm_DB.my_Cmd.Execute;
                  liInsID := dm_DB.my_Cmd.InsertId;
                  dm_DB.my_Cmd.SQL.Text :=
                     'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
                     ' where tim_id = ' + IntToStr(liInsID);
                  dm_DB.my_Cmd.Execute;


                  dm_docedit.my_q_doctmp.sql.text := 'select * from sys_arc where arc_id=' + inttostr(doc_obj.arc_id);
                  dm_docedit.my_q_doctmp.execute;
                  dm_DB.my_Cmd.SQL.Text :=
                     'Update arc_' + lsarcname + ' set doc_State = (doc_state or 1)' +
                     ' where doc_id = ' + IntToStr(doc_obj.doc_id);
                  dm_DB.my_Cmd.Execute;
               end;
               Sql.Text :=
                  'insert into sys_docxs (usr_id,rights,doc_id,arc_id,grp_id,src_usr_id) Values '
                  + '(' + sTmpID + ',' + IntToStr(iRights) + ',' +
                  IntToStr(doc_obj.doc_id) + ',' + IntToStr(doc_obj.arc_id) + ', 0, ' +
                  IntToStr(igUsrID) + ')';
            end
            else
               //          if iTmpType = 9 then
            begin
               Sql.Text :=
                  'insert into sys_docxs (rights,doc_id,arc_id,grp_id,src_usr_id) Values ' +
                  '(' + IntToStr(iRights) + ',' + IntToStr(doc_obj.doc_id) +
                  ',' + IntToStr(doc_obj.arc_id) + ',' + sTmpID + ',' + IntToStr(igUsrID) + ')';
            end;
            dm_DB.my_Cmd.Execute;
            // initiierenden benutzer schreiben

            litarcid := igarcid;
            litdocid := igdocid;
            igarcid := doc_obj.arc_id;
            igdocid := doc_obj.doc_id;
            sIarcname := '';
            frm_MainForm.NewHistory(1, _('Dokumentenrechte fr Benutzer / Gruppe') + ' ' +
               sTmpName + ' ' + _('gendert') + '. (' + IntToStr(iRights) + ')');
            igarcid := litarcid;
            igdocid := litdocid;
         end;
      end;
   except
      // on e: exception do ErrorMsg('ChangeRights', 'Fehler beim ndern eines Dokumentenrechtes: ' + e.Message, 2017, True);
   end;
   //  ReadObjRights; // never USed
   frm_usrlayerrightsclose(sender);
end;


// set the boxes respectly to the rights of the user
procedure Tfrm_UsrLayerRights.lv_UsrGrpSelectItem(Sender: TObject;
   Item: TListItem; Selected: boolean);
begin
   if (length(ingrights) > Item.index) then
   begin
      if (ingrights[item.index] and 8192) = 8192 then
         chbx_RAprRead.Checked := True
      else
         chbx_RAprRead.Checked := False;


      if (ingrights[item.index] and 16384) = 16384 then
         chbx_RAprWrite.Checked := True
      else
         chbx_RAprWrite.Checked := False;
   end;
end;


// close form
procedure Tfrm_UsrLayerRights.frm_usrlayerrightsclose(Sender: TObject);
begin
   // reset the rights
   // not really needed but should be done for big rights lists
   // todo: should be also tested for bufferoverflow... (if used before ReadDocRights)
   setlength(ingrights, 0);
   frm_UsrLayerRights.Close;
end;

procedure Tfrm_UsrLayerRights.CreateParams(var Params: TCreateParams);
begin
   inherited;
   Params.ExStyle := Params.ExStyle; // or WS_EX_APPWINDOW;
   Params.WndParent := GetDesktopWindow;
end;

procedure Tfrm_UsrLayerRights.FormCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.
