unit u_Volltext;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, ExtCtrls, Menus, StrUtils, gnugettext,
   u_ShLowUtils;

type
   Tfrm_Volltext = class (TFrame)
      redt_Volltext: TRichEdit;
      pnl_Optionen: TPanel;
      chbx_MarkHits: TCheckBox;
      btn_showpos: TButton;
      fd_Suche: TFindDialog;
      procedure chbx_MarkHitsClick(Sender: TObject);
      procedure redt_VolltextKeyUp(Sender: TObject; var Key: word;
         Shift: TShiftState);

      procedure fd_SucheFind(Sender: TObject);
   private
      fslocrhits: Tstringlist;
      fmarking:boolean;          // schranke um in markhits rein zu kommen
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      fstext: string;
      procedure removeocrhits;
      procedure clearobjslist;
      procedure MarkHits(REControl: TRichEdit; InputStr: string);
      property marking:boolean read fmarking default False;  //default value fr fmarking
   end;

implementation

uses {} u_dm_ViewerMain, u_dm_db, shellapi, ievect, hyieutils, u_MainForm;

{$R *.dfm}

procedure Tfrm_Volltext.clearobjslist;
begin
   if not assigned(fslocrhits) then
      exit;
   fslocrhits.clear;
end;

procedure Tfrm_Volltext.removeocrhits;
var li: integer;
begin
   if not assigned(fslocrhits) then
      exit;
   if fslocrhits.count > 0 then
   begin
      for li := 0 to fslocrhits.count - 1 do
      begin
         frm_mainform.fra_Voransicht.img_DocView.RemoveObject(strtoint(fslocrhits.Strings[li]));
      end;
      fslocrhits.clear;
   end;
end;

procedure Tfrm_Volltext.MarkHits(REControl: TRichEdit; InputStr: string);
var
   //  StrList1: TStringlist;
   StrList: TStrings;
   iStrCount, iStrPos, iWortLen, iTxtLen, iclIndex, listarter, i,
   lifirstsel: integer;
   sWort, lstext: string;
   AColor: array[0..9] of TColor;
begin
// diese funktion kann auch von timer tim_markpages aufgerufen werden.
// der timer kann wiederum von mysql.execute aufgerufen werden (processmessages)
// deswegen fmarking schranke
if fmarking then
exit;
try
fmarking:=true;
   StrList := StrToWords2(InputStr + #32); //TStringList.Create;
   //  StrList1:= TStringlist.create;
   //nothing to find
   if strlist.count = 0 then
      exit;
   AColor[0] := clRed;
   AColor[1] := clLime;
   AColor[2] := clBlue;
   AColor[3] := clFuchsia;
   AColor[4] := clMaroon;
   AColor[5] := clGreen;
   AColor[6] := clNavy;
   AColor[7] := clPurple;
   AColor[8] := clTeal;
   AColor[9] := clOlive;
   try
      iclIndex := 0;
      if dm_DB.my_q_Arc.recordcount = 0 then
      begin
         exit;
      end;
      if (dm_db.my_q_Arc.FieldDefList.Find('doc_txt') <> nil) then
      begin
         lstext := fstext;

      end
      else
      begin
         lstext := REControl.text;
      end;

      REControl.SelStart := 0;
      REControl.SelLength := length(lstext);
      REControl.SelAttributes.Color := 0;
      REControl.SelAttributes.Style := [];
      //    StrList.AddStrings(StrToWords(InputStr));
      iTxtLen := Length(lstext);
      listarter := 0;
      frm_mainform.tmb_Voransicht.Deselect;
      frm_mainform.tmb_Voransicht.MultiSelecting := True;
      frm_mainform.tmb_Voransicht.SelectionColor := clgreen;
      lifirstsel := -1;
      for iStrCount := 0 to StrList.Count - 1 do
      begin
         iStrPos := 1;
         sWort := StrList.Strings[iStrCount];
         if trim(swort) = '' then
         begin
            continue;
         end;
         if length(sWort) > 1 then
         begin
            case Ord(sWort[1]) of
               $2B, $2D, $2F:
               begin
                  swort := copy(swort, 2, length(swort));
               end;
            end;
         end;

         while iStrPos < iTxtLen do
         begin
            dm_db.my_q_tmp_ldmv.SQL.Text :=
               'Select  locate(' + #39 + sWort + #39 + ', doc_txt,' +
               IntToStr(iStrPos) + ') as pos from arc_' + sIarcname +
               ' as arc where  doc_id=' + IntToStr(igdocid);
            dm_db.my_q_Tmp_ldmv.Execute;
            iStrPos := dm_db.my_q_Tmp_ldmv.FieldByName('pos').AsInteger - 1;
            if iStrPos = -1 then
               break;
            iWortLen := Length(sWort);
            //            iStrPos := ReControl.FindText(sWort, iStrPos, iTxtLen, []);
            //PosEx(sWort, UpperCase(REControl.Text), iStrPos);

            REControl.SelStart := iStrPos;
            REControl.SelLength := iWortLen;
            REControl.SelAttributes.Color := AColor[iclIndex mod 10];
            REControl.SelAttributes.Style := [fsBold];
            if length(GaiPagesbytes) > 2 then
            begin
               for i := listarter to length(GaiPagesbytes) - 2 do
               begin
                  if (iStrPos > GaiPagesbytes[i] - 1) and
                     (iStrPos < GaiPagesbytes[i + 1] + 1) then
                  begin
                     //    iem.ima
                     listarter := i + 1;
                     frm_mainform.tmb_Voransicht.SelectedImage := i;
                     if frm_mainform.tmb_Voransicht.MultiSelectedImagesCount = 1 then
                     begin
                        lifirstsel := i;
                     end;
                     break;
                  end;
               end;
            end;
            dm_db.my_q_Tmp_ldmv.Next;
            iStrPos := iStrPos + iWortLen + 1;
         end;
         Inc(iclIndex);
      end;
      if lifirstsel > -1 then
      begin
         frm_mainform.tmb_Voransicht.CenterSelected;
         setlength(GaiPagesSelectedtmb, frm_mainform.tmb_Voransicht.MultiSelectedImagesCount);
         for iStrCount := 0 to frm_mainform.tmb_Voransicht.MultiSelectedImagesCount - 1 do
         begin
            GaiPagesSelectedtmb[iStrCount] :=
               frm_mainform.tmb_Voransicht.MultiSelectedImages[iStrCount];
         end;
         //         frm_mainform.tmb_Voransicht.setfocus;
      end;

     {   for i := 0 to length(GaiPagesbytes) -2 do
        begin
        StrList1.Clear;
    StrList1.add(copy(lstext,GaiPagesbytes[i],GaiPagesbytes[i+1]-GaiPagesbytes[i]));
      StrList1.SaveToFile('f:\tmp\textfiles\mytext'+inttostr(i)+'.txt');
    end;   }
   finally
      if Assigned(StrList) then
         FreeAndNil(StrList);
   end;
   finally
   fmarking:=false;
   end;
end;

procedure Tfrm_Volltext.chbx_MarkHitsClick(Sender: TObject);
begin
   if chbx_MarkHits.Checked then
      MarkHits(redt_Volltext, frm_MainForm.memo_Vtx.Text);
end;

procedure Tfrm_Volltext.redt_VolltextKeyUp(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   // Nix Machen
   if ssctrl in shift then
   begin
      if key = 70 then  // Strg+F
      begin
         fd_suche.Position := Point(redt_Volltext.Left + redt_Volltext.Width, redt_Volltext.Top);
         fd_suche.Execute;
      end;
   end;
end;


procedure Tfrm_Volltext.fd_SucheFind(Sender: TObject);
var
   FoundAt: LongInt;
   StartPos, ToEnd: Integer;
begin
   with redt_Volltext do
   begin
      { Suche hinter aktueller Markierung beginnen (falls vorhanden), }
      { andernfalls am Textanfang starten. }
      if SelLength <> 0 then

         StartPos := SelStart + SelLength
      else

         StartPos := 0;

      { ToEnd ist die Lnge von StartPos bis zum Textende im RTF-Eingabefeld }

      ToEnd := Length(Text) - StartPos;

      FoundAt := FindText(fd_Suche.FindText, StartPos, ToEnd, []);
      if FoundAt <> -1 then
      begin
         SetFocus;
         SelStart := FoundAt;
         SelLength := Length(fd_Suche.FindText);

         Perform(EM_SCROLLCARET, 0, 0);
      end;
   end;
end;

end.
