unit u_dm_DB;

interface

uses
   Forms, SysUtils, Classes, DB, DBAccess, MyAccess, MemDS, DASQLMonitor,
   MySQLMonitor, MyServerControl, JvComponent, JvThread, VirtualTable,
   JvComponentBase, MyDacMonitor, ExtCtrls, U_threadedannoscheck, gnugettext,
   u_ShLowUtils, u_ShDbUtils;

type
   Tdm_DB = class (TDataModule)
      my_con: TMyConnection;
      my_q_Arc: TMyQuery;
      my_cmd: TMyCommand;
      ds_Arc: TDataSource;
      my_q_LgrArc: TMyQuery;
      ds_LgrArc: TDataSource;
      my_q_Lnk: TMyQuery;
      ds_Lnk: TDataSource;
      my_q_Tmp: TMyQuery;
      my_q_Hst: TMyQuery;
      ds_Hst: TDataSource;
      my_conArc: TMyConnection;
      my_Ctrl: TMyServerControl;
      my_q_Time: TMyQuery;
      ds_Time: TDataSource;
      my_cmdarc: TMyCommand;
      thr_Arc: TJvThread;
      ds_Usr: TDataSource;
      my_q_usr: TMyQuery;
      my_q_ngtmp: TMyQuery;
      MySQLMonitor1: TMySQLMonitor;
      MyCmdNog01: TMyCommand;
      MyQNog01: TMyQuery;
      my_q_tmp_CreStatus: TMyQuery;
      my_q_datetime: TMyQuery;
      my_con_wvl_timer: TMyConnection;
      my_q_wvl_timer: TMyQuery;
      tim_searcharc: TTimer;
      tim_ansicht: TTimer;
      my_q_tmpcrestatus1: TMyQuery;
      my_q_tmp_ldmv: TMyQuery;
      my_q_comm: TMyQuery;
      my_ds_comm: TMyDataSource;
      my_q_vertretungava: TMyQuery;
      my_q_vertretung: TMyQuery;
      my_q_urlauber: TMyQuery;
    my_q_CreZusFields: TMyQuery;
    my_q_tmp_2: TMyQuery;
    my_q_tmp_Arc: TMyQuery;
    my_q_CreZusTmp: TMyQuery;
    my_q_FillZusAuswahlFeld: TMyQuery;
    my_q_sysarc: TMyQuery;
    my_q_GetArcDocUsrRights: TMyQuery;
    my_q_Move: TMyQuery;
    my_q_DocMove: TMyQuery;
    my_q_tmp_slw: TMyQuery;
    my_q_DocidIn: TMyQuery;
    my_q_DocShowTmp: TMyQuery;
    my_q_GetGDocID: TMyQuery;
      procedure my_q_ArcAfterOpen(DataSet: TDataSet);
      procedure my_conBeforeDisconnect(Sender: TObject);
      procedure MySQLMonitor1SQL(Sender: TObject; Text: string; Flag: TDATraceFlag);
      procedure tim_searcharcTimer(Sender: TObject);
      procedure tim_ansichtTimer(Sender: TObject);
      procedure DataModuleCreate(Sender: TObject);
   private
      procedure exitloadmainview;
      { Private-Deklarationen }
   public
      floadingmainview: boolean;
      fbtimansicht: boolean;
      tannoscheck: TTannoscheck;
      bgCancelfrmZuspflicht: boolean;    //06.05.2011 b.takacs 3.5.1.9
      procedure loadmainviewdoc(firstpage: boolean);
      function GetGDocIDByArcIDandDocID(ArcID, DocID: integer):integer;
      { Public-Deklarationen }
   end;

var
   dm_DB: Tdm_DB;
   Gicounter, giansichtlistcounter: integer;

implementation

uses u_MainForm, Windows, ImageEnView, iemview,
   hyiedefs, ImageEnIO, ImageEnProc, ievect, {} u_dm_ViewerMain,
   Menus, Dialogs, Inifiles, MemData, Graphics;

{$R *.dfm}

procedure Tdm_DB.my_q_ArcAfterOpen(DataSet: TDataSet);
begin
   dm_DB.tim_searcharc.Enabled := False;
   frm_MainForm.pnl_SrcTime.ParentBackground := True;
   frm_MainForm.pnl_SrcTime.Color := frm_MainForm.pnl_SuchOpt.Color;
end;



procedure Tdm_DB.my_conBeforeDisconnect(Sender: TObject);
begin
   ds_Arc.Enabled := False;
end;

procedure Tdm_DB.MySQLMonitor1SQL(Sender: TObject; Text: string; Flag: TDATraceFlag);
begin
   if gbmysqldebug and (Sender <> nil) then
   begin
      if Sender is TComponent then
      begin
         LogEvnt('Mysql: Sender: ' + Sender.classname + ' ' + Tcomponent(Sender).Name + ' ' + #13 + #10 + Text);
      end
      else
      begin
         LogEvnt('Mysql: Sender: ' + Sender.classname + ' ' + #13 + #10 + Text);
      end;
   end;
end;

procedure Tdm_DB.tim_searcharcTimer(Sender: TObject);
begin
   frm_Mainform.pnl_SrcTime.ParentBackground := False;
   frm_Mainform.pnl_SrcTime.Color :=
      $00000000 + 256 * trunc(91 * (sin(PI * Gicounter / 16))) + 255 + trunc(256 * 91);
   Gicounter := Gicounter + 1;

end;

procedure Tdm_DB.tim_ansichtTimer(Sender: TObject);
begin
   if fbtimansicht then
      exit;
   fbtimansicht := True;
   try
      if giansichtlistcounter <> gtsl_ansicht.Count - 1 then
      begin
         giansichtlistcounter := gtsl_ansicht.Count - 1;
         loadmainviewdoc(gbfirstpage);
      end
      else
      begin
         gcsListAnsicht.Acquire;
         tim_ansicht.Enabled := False;
         gtsl_ansicht.Clear;
         giansichtlistcounter := -1;
         gcsListAnsicht.Leave;
      end;
   finally
	   fbtimansicht := False;
   end;
end;

procedure Tdm_DB.loadmainviewdoc(firstpage: boolean);
var
   sIEVFile, sDocFile, sExtFile, sChk4pIev, lsUsers, lsjobfile, lsjobfile1, lspages,
   lstmp, lspubannopages, lsdocfile: string;
   licounter, liindex, liPageIndex: integer;
   lblesbar, lblesbaranno, lbfloaded, lbjobloaded: bool;
   linijob: TInifile;
   lstrpages: TStringList;
   lbvorvi: boolean;
begin
   GgfLogEvntBeg('loadmainviewdoc beg firstpage:'+BS(firstpage));
   linijob := nil;
   lbjobloaded := low(lbjobloaded);

   if dm_db.my_q_arc.RecordCount = 0 then
      exit;
   try
      floadingmainview := true;
      gbansichtlesen := True;
      lblesbar := False;
      lblesbaranno := False;

      while (frm_mainform.fra_voransicht.img_DocView.lockpaintcount <> 0) do
      begin
         frm_mainform.fra_voransicht.img_DocView.UnLockPaint;
      end;

      if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0 then
      begin
         liindex := 0;
         frm_mainform.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := true;
      end
      else
      begin
         liindex := frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1;
      end;

      if ((PRecBookmark(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[liindex]).order <>
         dm_db.my_q_Arc.recno) and
         (not frm_mainform.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected)) then
      begin
         dm_db.my_q_Arc.GotoBookmark(
            Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[liindex]));
      end;

      with frm_Mainform do
      begin
         with fra_Voransicht.img_DocView do
         begin
            if fra_Nix.Visible then
               fra_Nix.Visible := False;

            if dm_DB.my_q_Arc.RecordCount = 0 then
            begin
               exitloadmainview;
               floadingmainview := false;
               exit;
            end;
            bGImageDisp := False; // Neues Bild wurde noch nicht geladen
            //blank already calls clear
            lbvorvi := fra_Voransicht.visible;
            fra_Voransicht.visible := true;
            fra_Voransicht.img_DocView.Visible := true;
            //if they are not set to 0 then the view will be updated, and set to .1 %...
            frm_mainform.fra_voransicht.img_docview.viewx := 0;
            frm_mainform.fra_voransicht.img_docview.viewy := 0;
            Blank;
            if ObjectsCount > 0 then
               RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;
            fra_Voransicht.visible := lbvorvi;
            fra_Voransicht.img_DocView.Visible := False;
            //    if ZoomFilter = rfFastLinear then ZoomFilter := rfNone;
            sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sgextfilename := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
            sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
            lsdocfile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            frm_mainform.fra_Volltext.fstext := dm_DB.my_q_Arc.FieldByName('doc_txt').AsString;

            if not FileAccessable(sDocFile) then
            begin
               dm_DB.my_q_Arc.RefreshRecord;
               sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
               sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
               sleep(50);
            end
            else
            begin
               lblesbar := True;
               if (sExtFile <> '') then
               begin
                  if FileExists(sExtFile) then
                  begin
                     sDocFile := sExtFile;
                  end
                  else
                  begin
                     sgextfilename := '';
                  end;
               end
               else
                  sgextfilename := '';
            end;
            if ((not FileAccessable(sDocFile)) and (not lblesbar)) then
            begin
               dm_DB.my_q_Arc.RefreshRecord;
               sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
               sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
               sleep(50);
            end
            else
            begin
               lblesbar := True;
               if FileExists(sExtFile) then
               begin
                  sDocFile := sExtFile;
               end;
            end;
            dm_MainForm2.pum_PrivAnno.Items.Clear;

            if (not lblesbar) then
            begin
               for licounter := 0 to 2 do
               begin
                  if FileExists(sExtFile) then
                  begin
                     sDocFile := sExtFile;
                  end;
                  if not FileAccessable(sDocFile) then
                  begin
                     // wait for caching?
                     sleep(70);
                  end
                  else
                  begin
                     lblesbar := True;
                     break;
                  end;
               end;

               if licounter = 2 then
               begin
                  if sExtFile = sDocFile then
                  begin
                     sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
                     sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
                  end;
               end;
            end;
            fra_Voransicht.img_DocView.LockPaint;
            if sDocFile = '' then
            begin
               frm_mainform.setpanelinfo(
                  _('Die Datei kann nicht gelesen werden, bitte versuchen sie es erneut.'));
               dm_MainForm2.gsstatustext := '';
               Clear;
               Blank;
               if ObjectsCount > 0 then
                  RemoveAllObjects;
               frm_MainForm.fra_Volltext.clearobjslist;
               bGImageDisp := True;
               //        outputdebugstring(PChar('Could not open file ' + sDocFile));
               LogEvnt('Could not open file ' + sDocFile);

               fra_Voransicht.img_DocView.unLockPaint;
               if thr_voransicht <> nil then
               begin
                  thr_voransicht.Terminate;
                  thr_voransicht.waitfor;
                  FreeAndNil(thr_voransicht);
               end;
               frm_MainForm.tmb_Voransicht.Clear;
               exitloadmainview;
               floadingmainview := false;

               fra_Voransicht.img_DocView.zoomfilter := rfFastLinear;
               fra_Voransicht.img_DocView.Visible := True;
               dm_db.tim_ansicht.Enabled := False;
               exit;
            end;
            if ((not FileAccessable(sDocFile)) and (not lblesbar)) then
            begin
               frm_mainform.setpanelinfo(
                  _('Die Datei kann nicht gelesen werden, bitte versuchen sie es erneut.'));
               dm_MainForm2.gsstatustext := '';
               Clear;
               Blank;
               if ObjectsCount > 0 then
                  RemoveAllObjects;
               bGImageDisp := True;
               //        outputdebugstring(PChar('Could not open file ' + sDocFile));
               LogEvnt('Could not open file ' + sDocFile);

               fra_Voransicht.img_DocView.unLockPaint;
               if thr_voransicht <> nil then
               begin
                  thr_voransicht.Terminate;
                  thr_voransicht.waitfor;
                  FreeAndNil(thr_voransicht);
               end;
               frm_MainForm.tmb_Voransicht.Clear;
               exitloadmainview;

               fra_Voransicht.img_DocView.zoomfilter := rfFastLinear;
               fra_Voransicht.img_DocView.Visible := True;
               floadingmainview := false;
               exit;
            end;

            if FirstPage then
               IO.Params.TIFF_ImageIndex := 0
            else
               if giGoToPage > 0 then
                  IO.Params.TIFF_ImageIndex := giGoToPage;
            liPageIndex := IO.Params.TIFF_ImageIndex;
            if giGoToPage > 0 then
                  begin liPageIndex := giGoToPage; end;

            sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(liPageIndex) + '.IEV';
            sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

            dm_MainForm2.fsIEVFile := sIEVFile;
            GgfLogEvnt('dm_MainForm2.fsIEVFile: '+ sIEVFile);

            // Erzeuge den Privat Annotation Namen anhand des angemeldeten Users
            // should check for priv anno from others which give the right to read
            sChk4pIev := ChangeFileExt(sDocFile, '') + IntToStr(liPageIndex) +
               'P' + IntToStr(igUsrId) + '.IEV';
            try
               fra_Voransicht.img_DocView.RemoveAllObjects;
               frm_MainForm.fra_Volltext.clearobjslist;
            except
               on e: Exception do
               begin
               end;
            end;

            frm_Mainform.fra_Voransicht.img_DocView.Visible := False;

            lbfloaded := False;
            licounter := 0;
            while not lbfloaded do
            begin
               try
                  //          outputdebugstring(PChar(sdocfile));
                  IO.LoadFromFile(sDocFile);
                  lbfloaded := True;
               except
                  on e: Exception do
                  begin
                     lbfloaded := False;
                     licounter := licounter + 1;
                     if licounter > 10 then
                     begin
                        break;
                     end;
                     sleep(30);
                  end;
               end;
            end;

            if not floadingmainview then
            begin
               exitloadmainview;
               exit;
            end;

            fra_Voransicht.fTblName := sIArcName;
            fra_Voransicht.fGdocid := dm_DB.my_q_Arc.FieldByName('gdoc_id').AsInteger;
            fra_Voransicht.fDocLoc := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         	fra_Voransicht.fExtLoc := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
            fra_Voransicht.fDocid := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
            if dm_DB.my_q_Arc.FieldDefList.Find('arc_id') <> nil then
	            fra_Voransicht.fArcid := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger
            else
            	fra_Voransicht.fArcid := iGArcID;

            if thr_voransicht <> nil then
            begin
               try
                  thr_voransicht.terminate;
                  // wait for terminate, it should just take the moment of a
                  try
                     thr_voransicht.waitfor;
                  except on e: exception do
                     begin
                     end;
                  end;
               finally
                  begin
                     FreeAndNil(thr_voransicht);
                  end;
               end;
            end;
            setlength(GaiPagesSelectedtmb, 0);
            frm_mainform.tmb_Voransicht.clear;

            if FirstPage then
               IO.Params.TIFF_ImageIndex := 0
            else
               if giGoToPage > 0 then
                  IO.Params.TIFF_ImageIndex := giGoToPage;
            for licounter := 0 to 2 do
            begin
               if (Fileexists(sChk4pIev)) then
               begin
                  lblesbaranno := True;
                  break;
               end;
               sleep(20);
            end;
            if lblesbaranno then
            begin
               fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
               fra_Voransicht.updateobjects;

               if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
               begin
                  lsUsers := sGUsrName;
                  //liobjcount := fra_Voransicht.img_DocView.ObjectsCount;

                  dm_MainForm2.pum_PrivAnno.Items.Add(
                     newItem(sGUsrName, //name
                     0,    //shortcut
                     False,//checked
                     True, // enabled
                     dm_MainForm2.pum_PrivAnnoClick, //onclick
                     0,    //heplcontext
                     'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
                     ));
                  dm_MainForm2.pum_PrivAnno.Items[
                     dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
                     iGUSRID;
               end;
            end;
            my_q_ngtmp.sql.Text :=
               ' select b.usr_id, src_usr_id, usr_name from sys_docxs   as b left join' +
               ' sys_usr as a on(a.usr_id=b.src_usr_id) where b.usr_id = ' +
               IntToStr(igUsrId) + ' and  doc_id= ' + IntToStr(igdocid) +
               ' and arc_id=' + IntToStr(igarcid) + ' and  (find_in_set(' +
               #39 + 'apread' + #39 + ',rights))';
            my_q_ngtmp.Execute;
            //    Outputdebugstring(pchar('lesbar '+booltostr(lblesbar)));
            if lblesbar then
            begin
               userights(rgDocRight);
               lspubannopages := '';
               if tannoscheck <> nil then
               begin
                  tannoscheck.Terminate;
                  tannoscheck.WaitFor;
               end;

               tannoscheck := TTannoscheck.Create(true);
               tannoscheck.psdocfile := sdocfile;
               tannoscheck.Resume;
               // is alerady done in changedoc
               //      tbsi_VZoomClick(self);
               ChangeDocPage(3);    // Erneuert nur die Seitenanzeige
               if not floadingmainview then
               begin
                  exitloadmainview;
                  exit;
               end;
               gbansichtlesen := False;

               fra_Voransicht.img_DocView.zoomfilter := rfFastLinear;
               fra_Voransicht.img_DocView.Visible := True;
               bGImageDisp := True; // Neues Bild wurde geladen
               // Miniatur Ansicht einschalten
               if frm_mainform.dpnl_Thumbs.Visible then
               begin
                  frm_mainform.loadthumbs(0, true);
               end;
            end
            else
            begin
               frm_mainform.setpanelinfo(_('Die Datei kann nicht gelesen werden.'));
               dm_MainForm2.gsstatustext := '';
               Clear;
               Blank;
               if ObjectsCount > 0 then
                  RemoveAllObjects;
               frm_MainForm.fra_Volltext.clearobjslist;
               bGImageDisp := True;
            end;
         end;
         try
            fra_Voransicht.img_DocView.unLockPaint;
         except
            on e: Exception do
            begin
            end;
         end;
         frm_Mainform.fra_Voransicht.img_DocView.zoomfilter := rfFastlinear;
         frm_Mainform.fra_Voransicht.img_DocView.Visible := True;
      end;
      if frm_Mainform.fra_voransicht.img_DocView.proc.CalcImageNumColors > 2 then
      begin
         frm_Mainform.tbsi_VDeSpecklea.Enabled := falsE;
         frm_Mainform.tbsi_VDeSpeckle.Enabled := falsE;
         dm_MainForm2.mnu_TDeSpeckle.Enabled := false;
      end
      else
      begin
         frm_Mainform.tbsi_VDeSpecklea.Enabled := true;
         frm_Mainform.tbsi_VDeSpeckle.Enabled := true;
         dm_MainForm2.mnu_TDeSpeckle.Enabled := true;
      end;
      gbansichtlesen := False;
      dm_DB.tim_searcharc.Enabled := False;
      frm_Mainform.pnl_SrcTime.Caption := '';
//      dm_MainForm2.tim_voransicht.Enabled := true;

      if not floadingmainview then
      begin
         exitloadmainview;
         exit;
      end;
      lsjobfile := ChangeFileExt(sDocFile, '.job');
      lsjobfile1 := ChangeFileExt(lsdocfile, '.job');

      for licounter := 0 to 2 do
      begin
         if (Fileexists(lsjobfile)) then
         begin
            lbjobloaded := True;
            break;
         end
         else

         if (Fileexists(lsjobfile1)) then
         begin
            lsjobfile := lsjobfile1;
            lbjobloaded := True;
            break;
         end;
         sleep(20);
      end;

      if not floadingmainview then
      begin
         exitloadmainview;
         exit;
      end;
      if lbjobloaded then
      begin
         try
            try
               setlength(GaiPagesbytes, 0);
               linijob := Tinifile.Create(lsjobfile);
               if linijob.ValueExists('Document', 'Pages') then
               begin
                  lspages := linijob.ReadString('Document', 'Pages', '');
                  if trim(lspages) = '' then
                  begin
                     setlength(GaiPagesbytes, 2);
                     GaiPagesbytes[0] := 0;
                     lstrpages := TStringList.Create;
                  end
                  else
                  begin
                     lstrpages := strtowords(lspages);
                     setlength(GaiPagesbytes, lstrpages.Count + 2);
                     GaiPagesbytes[0] := 0;
                     for licounter := 0 to lstrpages.Count - 1 do
                     begin
                        lstmp := StringReplace(lstrpages.Strings[licounter], ',',
                           '', [rfReplaceAll]);
                        if lstmp <> '' then
                        begin
                           GaiPagesbytes[licounter + 1] := StrToInt(lstmp);
                        end;
                     end;
                  end;
                  if dm_db.my_q_Arc.active then
                  begin
                     GaiPagesbytes[lstrpages.Count + 1] :=
                        length(dm_db.my_q_Arc.FieldByName('doc_txt').AsString);
                  end;
               end;
            except
               on e: Exception do
               begin
               end;
            end;
         finally
            begin
               floadingmainview := false;
               linijob.Free;
            end;
         end;
      end;
   finally
      begin
         floadingmainview := false;
         frm_mainform.pnl_docTime.Caption := '';
         dm_MainForm2.tim_docload.Enabled := False;
         frm_mainform.pnl_docTime.ParentBackground := True;
         frm_mainform.pnl_docTime.Color := frm_mainform.pnl_SuchOpt.Color;
      end;
   end;
   GgfLogEvntEnd('loadmainviewdoc end firstpage:'+BS(firstpage));
end;

function Tdm_DB.GetGDocIDByArcIDandDocID(ArcID, DocID: integer):integer;
var
	gdoc_id: integer;
begin
	with my_q_GetGDocID do
  begin
    SQL.Clear;
    SQL.Text:= 'SELECT * FROM sys_gdocid s where doc_ID=' + IntToStr(DocID) + ' and arc_ID=' + IntToStr(ArcID) + ';';
    Open;
    First;
    gdoc_id:= FieldByName('gdoc_id').AsInteger;
    Close;
  end;
  result:= gdoc_id;
end;


procedure Tdm_DB.DataModuleCreate(Sender: TObject);
begin
   u_ShDbUtils.my_Con := Self.my_Con;
   TranslateComponent(self, 'Viewerv3');
   floadingmainview := false;
   MySQLMonitor1.Active := BD.LogOn;
end;

procedure Tdm_db.exitloadmainview;
begin
   gbansichtlesen := False;
   frm_mainform.pnl_docTime.Caption := '';
   dm_MainForm2.tim_docload.Enabled := False;
   frm_mainform.pnl_docTime.ParentBackground := True;
   frm_mainform.pnl_docTime.Color := frm_mainform.pnl_SuchOpt.Color;
end;

end.
