unit u_dm_DocEditor;

interface

uses
   Forms, SysUtils, Classes, Menus, ImgList, Controls, Registry, ieview,
   imageenview, ievect, ImageEnIO, ImageEnProc, StdCtrls, Dialogs, DB,
   MemDS, DBAccess, MyAccess, gnugettext,
   u_ShLowUtils, u_ShFrameZusFldMulti, JvComponentBase, JvBalloonHint;

type
   Tdm_DocEdit = class (TDataModule)
      il_DocEdit: TImageList;
      pum_Tools: TPopupMenu;
      mnu_ObjProperty: TMenuItem;
      mnu_AnnoInfo: TMenuItem;
      il_BrushStyle: TImageList;
      il_PenStyle: TImageList;
      il_Stamps: TImageList;
      pum_ImpSlw: TMenuItem;
      pum_ImpZus: TMenuItem;
      pum_TextToVtx: TMenuItem;
      BenutzerLayervonBenutzereditieren1: TMenuItem;
      pum_UsrRechtLayer: TMenuItem;
      my_q_doc: TMyQuery;
      my_q_doctmp: TMyQuery;
    bh_DocEditor_Main: TJvBalloonHint;
      procedure pum_ToolsPopup(Sender: TObject);
      procedure mnu_ObjPropertyClick(Sender: TObject);
      procedure mnu_AnnoInfoClick(Sender: TObject);
      procedure pum_ImpZusClick(Sender: TObject);
      procedure pum_ImpSlwClick(Sender: TObject);
      procedure pum_TextToVtxClick(Sender: TObject);
      procedure BenutzerLayervonBenutzereditieren1Click(Sender: TObject);
      procedure pum_UsrRechtLayerClick(Sender: TObject);
      procedure DataModuleCreate(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
      function TextToSlw: boolean;
      function TextToVtx: boolean;
   end;

var
   dm_DocEdit: Tdm_DocEdit;

implementation

{$R *.dfm}

uses Windows, {} u_dm_ViewerMain, u_DocEditor, u_MainForm, u_dm_DB, u_DlgWords,
   u_ShowLayer, u_UsRLayerRights;

procedure Tdm_DocEdit.pum_ToolsPopup(Sender: TObject);
begin
   //    outputdebugstring(pchar('editmoe '+booltostr(frm_DocEdit.fra_DocEditor.img_DocView.IsEditMode)));
   //if in editmode dont show popup
   if frm_DocEdit.fra_DocEditor.img_DocView.IsEditMode then
   begin
   end
   else
   begin
      case frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount of
         0:
         begin
            mnu_ObjProperty.Enabled := False;
            mnu_AnnoInfo.Enabled := False;
            pum_ImpSlw.Enabled := False;
            pum_ImpZus.Enabled := False;
            pum_TextToVtx.Enabled := False;
         end;
         1:
         begin
            mnu_ObjProperty.Enabled := True;
            mnu_AnnoInfo.Enabled := True;
            if (frm_DocEdit.fra_DocEditor.img_DocView.ObjKind[frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[0]] = iekmemo) or
               (frm_DocEdit.fra_DocEditor.img_DocView.ObjKind[frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[0]] = iektext) then
            begin
               pum_ImpSlw.Enabled := True;
               pum_ImpZus.Enabled := True;
               pum_TextToVtx.Enabled := True;
            end
            else
            begin
               pum_ImpSlw.Enabled := False;
               pum_ImpZus.Enabled := False;
               pum_TextToVtx.Enabled := False;
            end;
         end;
      else
      begin
         mnu_ObjProperty.Enabled := True;
         mnu_AnnoInfo.Enabled := True;
         pum_ImpSlw.Enabled := False;
         pum_ImpZus.Enabled := False;
         pum_TextToVtx.Enabled := False;
      end;
      end;
   end;
end;

procedure Tdm_DocEdit.mnu_ObjPropertyClick(Sender: TObject);
begin
   frm_DocEdit.fra_DocEditor.img_DocView.CancelInteracts;
   frm_DocEdit.tbi_ObjPropClick(Self);
end;

procedure Tdm_DocEdit.mnu_AnnoInfoClick(Sender: TObject);
begin
   frm_DocEdit.fra_DocEditor.img_DocView.CancelInteracts;
   frm_DocEdit.tbi_EAnnoInfoClick(self);
end;

procedure Tdm_DocEdit.pum_ImpZusClick(Sender: TObject);
var
   iCount: integer;
   TmpEdt: TEdit;
   sText: string;
begin
   if not rGDocRight.modify then
      exit;
   frm_DocEdit.fra_DocEditor.img_DocView.CancelInteracts;
   with Sender as TMenuItem do
   begin
      for iCount := 0 to frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount - 1 do
         sText := sText + Trim(frm_DocEdit.fra_DocEditor.img_DocView.ObjText[
            frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[iCount]]);
      TmpEdt := TEdit(FindComponentRekursivFrame(frm_MainForm.sbx_ZusFeld, 'zedt_Tmp' +
         Copy(Hint, 9, Length(Hint)))); //#3.5
      TmpEdt.Text := sText;
   end;
end;

procedure Tdm_DocEdit.pum_ImpSlwClick(Sender: TObject);
var
   iCount: integer;
   sText, sSLW: string;
   slWords: TStrings;
   //mrForm: TModalResult;
begin
   if not rGDocRight.modify then
      exit;
   frm_DocEdit.fra_DocEditor.img_DocView.CancelInteracts;
   for iCount := 0 to frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount - 1 do
      sText := sText + Trim(frm_DocEdit.fra_DocEditor.img_DocView.ObjText[
         frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[iCount]]) + ' ';
   if sText <> '' then
      slWords := StrToWords(sText)
   else
      exit;
   try
      if slWords.Count > 5 then
      begin
         // Routine zur Abfrage wie gespeichert werden soll
         Application.CreateForm(Tfrm_DlgWords, frm_DlgWords);
         frm_DlgWords.ShowModal;
         //mrForm := frm_DlgWords.ModalResult;
         frm_DlgWords.Release;
         if frm_DlgWords.ModalResult = mrCancel then
            Exit;
         if frm_DlgWords.ModalResult = mrNo then
         begin
            TextToVTX;
            exit;
         end;
      end;
      for iCount := 0 to (slWords.Count - 1) do
      begin
         sSLW := sSLW + '(' + IntToStr(iGDocID) + ', ' + #39 +
            trim(ParseSemicolonWithoutBackslash(slWords.Strings[iCount])) + #39 + '),';
      end;
      sSLW := Copy(sSLW, 1, Length(sSLW) - 1);
      with dm_DB.my_cmd do
      begin
         SQL.Text := 'Insert into slw_' + sIArcName +
            ' (doc_id, doc_slw) Values ' + sSLW;
         try
            Execute;
         except
            on e: Exception do
            begin
               ErrorMsg('pum_ImpSLWClick',
                  _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                  e.Message, 2025,
                  True);
            end;
         end;
      end;
   finally
      if Assigned(slWords) then
         FreeAndNil(slWords);
   end;
end;

function Tdm_DocEdit.TextToSlw: boolean;
   ////////////////////////////////////////////////////////////////////////////////////////////////////////
   // wird von nirgendwo aufgerufen
var
   iCount: integer;
   sText, sSLW: string;
begin
   Result := False;
   if not rGDocRight.modify then
      exit;
   frm_DocEdit.fra_DocEditor.img_DocView.CancelInteracts;
   for iCount := 0 to frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount - 1 do
   begin
      sText :=
         Trim(frm_DocEdit.fra_DocEditor.img_DocView.ObjText[
         frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[iCount]]);
      if sText <> '' then
         sSLW := sSLW + '(' + IntToStr(iGDocID) + ', ' + #39 + trim(ParseSemicolonWithoutBackslash(sText)) + #39 +
            '),';
   end;
   sSLW := Copy(sSLW, 0, Length(sSLW) - 1);

   with dm_DB.my_cmd do
   begin
      Result := True;
      SQL.Text := 'Insert into slw_' + sIArcName +
         ' (doc_id, doc_slw) Values ' + sSLW;
      try
         Execute;
      except
         on e: Exception do
         begin
            ErrorMsg('pum_ImpSLWClick',
               _('Fehler beim Hinzufgen eines Schlagwortes: ') +
               e.Message, 2025,
               True);
            Result := False;
         end;
      end;
   end;
end;

function Tdm_DocEdit.TextToVtx: boolean;
   ////////////////////////////////////////////////////////////////////////////////////////////////////////
   //    konvertieren von Text zu VTX  mit dem Ergebnis : boolean
var
   iCount: integer;
   sText, sVTX: string;
begin
   Result := False;
   if not rGDocRight.modify then
      exit;


   frm_DocEdit.fra_DocEditor.img_DocView.CancelInteracts;
   for iCount := 0 to frm_DocEdit.fra_DocEditor.img_DocView.SelObjectsCount - 1 do
      sText := sText + Trim(frm_DocEdit.fra_DocEditor.img_DocView.ObjText[
         frm_DocEdit.fra_DocEditor.img_DocView.SelObjects[iCount]]) + ' ';
   if sText = '' then
      exit;
   my_q_doc.SQL.Text := 'select doc_txt from arc_' + frm_DocEdit.Doc_obj.sIArcName + ' where doc_id=' +
      inttostr(frm_DocEdit.Doc_obj.doc_id);
   try
      my_q_doc.Execute;
   except on e: exception do
      begin
      end;
   end;
   sVtx := my_q_doc.FieldByName('doc_txt').AsString;
   Result := True;
   with dm_DB.my_cmd do
   begin
      SQL.Text := 'Update arc_' + sIArcName + ' set doc_txt = :VTX where doc_id = ' +
         IntToStr(iGDocID);
      ParamByName('VTX').AsString :=
         sVTX + #13 + #13 + 'Anmerkungstexte eingefgt am: ' +
         DateTimeToStr(now) + #13 +
         '--------------------------------------------------------------------------------------------------------------------'
         + #13 + #13 + sText;
      try
         Execute;
      except
         on e: Exception do
         begin
            ErrorMsg('TextToVtx',
               _('Fehler beim Update eines Dokumenten Volltextes: ') +
               e.Message,
               1006, True);
            Result := False;
         end;
      end;
   end;
end;

procedure Tdm_DocEdit.pum_TextToVtxClick(Sender: TObject);
begin
   TextToVtx;
end;

procedure Tdm_DocEdit.BenutzerLayervonBenutzereditieren1Click(Sender: TObject);
begin
   frm_ShowLayer.showmodal;
   frm_DocEdit.LoadDoc(0);
end;

procedure Tdm_DocEdit.pum_UsrRechtLayerClick(Sender: TObject);
begin
   // must update table so target and src user are abvailable
   frm_UsrLayerRights.doc_obj := frm_mainform.flastdoc_edit.doc_obj;
   frm_UsrLayerRights.ShowModal;
end;

procedure Tdm_DocEdit.DataModuleCreate(Sender: TObject);
begin
   TranslateComponent(self, 'Viewerv3');
end;

end.



