unit u_mrgdocs_reorder;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ComCtrls, gnugettext;

type
   Tfrm_mrgdocreorder = class (TForm)
      ListView1: TListView;
      btn_close: TButton;
      procedure FormCreate(Sender: TObject);
      procedure ListView1DragDrop(Sender, Source: TObject; X, Y: Integer);
      procedure ListView1DragOver(Sender, Source: TObject; X, Y: Integer;
         State: TDragState; var Accept: Boolean);
      procedure btn_closeClick(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

var
   frm_mrgdocreorder: Tfrm_mrgdocreorder;

implementation

uses u_mainform, u_dm_db, u_MrgDocs;

{$R *.dfm}

procedure Tfrm_mrgdocreorder.FormCreate(Sender: TObject);
var li: integer;
   llistitem: tlistitem;
begin
   TranslateComponent(self, 'Viewerv3');
   for li := 0 to frm_MrgDocs.flstmylist.Count - 1 do
   begin
      dm_DB.my_q_Arc.GotoBookmark(Pointer(frm_MrgDocs.flstmylist.strings[li]));
      llistitem := ListView1.items.Add;
      llistitem.caption := (dm_DB.my_q_Arc.FieldByName('disp_name').AsString);

      if dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil then
      begin
         ListView1.Items.Item[ListView1.Items.Count - 1].SubItems.add(dm_DB.my_q_Arc.FieldByName('arc_id').AsString);
      end
      else
      begin
         ListView1.Items.Item[ListView1.Items.Count - 1].SubItems.add(inttostr(iGarcid));
      end;
      ListView1.Items.Item[ListView1.Items.Count - 1].SubItems.add(dm_DB.my_q_Arc.FieldByName('doc_id').AsString);
      ListView1.Items.Item[ListView1.Items.Count - 1].SubItems.add(dm_DB.my_q_Arc.Bookmark);
   end;
end;

procedure Tfrm_mrgdocreorder.ListView1DragDrop(Sender, Source: TObject; X,
   Y: Integer);
var
   currentItem, nextItem, dragItem, dropItem: TListItem;
begin
   if Sender = Source then
   begin
      with TListView(Sender) do
      begin
         dropItem := GetItemAt(X, Y);
         currentItem := Selected;
         while currentItem <> nil do
         begin
            nextItem := GetNextItem(currentItem, SdAll, [IsSelected]);
            if Assigned(dropItem) then
               dragItem := Items.Insert(dropItem.Index)
            else
               dragItem := Items.Add;
            dragItem.Assign(currentItem);
            currentItem.Free;
            currentItem := nextItem;
         end;
      end;
   end;
end;

procedure Tfrm_mrgdocreorder.ListView1DragOver(Sender, Source: TObject; X,
   Y: Integer; State: TDragState; var Accept: Boolean);
begin
   Accept := Sender = ListView1;
end;

procedure Tfrm_mrgdocreorder.btn_closeClick(Sender: TObject);
begin
   frm_mrgdocreorder.close;
end;

end.
