unit u_threadedansicht;

interface

uses
   Classes;

type
   TTdocview = class (TThread)
   private
      { Private declarations }
   protected
      procedure Execute; override;
   public
      firstpage: boolean;
   end;

implementation

uses Windows, SysUtils, u_MainForm, u_dm_DB, ImageEnView, iemview,
   hyiedefs, ImageEnIO, ImageEnProc, ievect, {} u_dm_ViewerMain,
   Menus, Dialogs,
   gnugettext,
   u_ShLowUtils;

{ TMyThread }


procedure TTdocview.Execute;
var
   sIEVFile, sDocFile, sExtFile, sChk4pIev, lsUsers: string;
   iXTbi, iYTbi, iXTlb, iYTlb, licounter, liobjcount: integer;
   iPos: tPoint;
   lblesbar, lblesbaranno, lblesbarpubanno, lbfloaded: bool;
begin
   liobjcount := 0;
   lblesbar := False;
   lblesbaranno := False;
   lblesbarpubanno := False;
   gbansichtlesen := True;
   with frm_Mainform do
   begin
      with fra_Voransicht.img_DocView do
      begin
         if fra_Nix.Visible then
            fra_Nix.Visible := False;

         if dm_DB.my_q_Arc.RecordCount = 0 then
         begin
            gbansichtlesen := False;
            exit;
         end;
         bGImageDisp := False; // Neues Bild wurde noch nicht geladen
         fra_Voransicht.img_DocView.Visible := False;
         Clear;
         Blank;
         if ObjectsCount > 0 then
            RemoveAllObjects;
         frm_MainForm.fra_Volltext.clearobjslist;
         //    if ZoomFilter = rfFastLinear then ZoomFilter := rfNone;
         sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
         sgextfilename := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
         //    OUTPUTDEBUGSTRING(pchar('showvoransicht 0'+sDocFile+' '+sExtFile));
         if not FileAccessable(sDocFile) then
            // Wenn Datei nicht existiert, Datensatz aktualisieren und 100ms warten
         begin
            //      lblesbar := True;
            dm_DB.my_q_Arc.RefreshRecord;
            sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
            sgextfilename := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
            sleep(50);
         end
         else
         begin
            lblesbar := True;
         end;
         //    OUTPUTDEBUGSTRING(pchar('showvoransicht 1'+sDocFile+' '+sExtFile));
         if ((not FileAccessable(sDocFile)) and (not lblesbar)) then
            // Wenn Datei immer noch nicht existiert, Datensatz aktualisieren und 100ms warten
         begin
            dm_DB.my_q_Arc.RefreshRecord;
            sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
            sgextfilename := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
            sleep(50);
         end
         else
         begin
            lblesbar := True;
         end;
         dm_MainForm2.pum_PrivAnno.Items.Clear;
         OUTPUTDEBUGSTRING(PChar('showvoransicht 2' + sDocFile + ' ' + sExtFile));

         //too many threads make the fileaccess failt for some reason
         // todo research why!
         //    sleep(50);
         if (not lblesbar) then
         begin
            for licounter := 0 to 2 do
            begin
               if FileExists(sExtFile) then
               begin
                  sDocFile := sExtFile;
               end;
               if not FileAccessable(sDocFile) then
               begin
                  // wait for caching?
                  sleep(70);
               end
               else
               begin
                  lblesbar := True;
                  break;
               end;
            end;

            if licounter = 2 then
            begin
               if sExtFile = sDocFile then
               begin
                  sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
               end;
            end;
         end;
         fra_Voransicht.img_DocView.LockPaint;
         if sDocFile = '' then
         begin
            setpanelinfo(
               _('Die Datei kann nicht gelesen werden, bitte versuchen sie es erneut.'));
            Clear;
            Blank;
            if ObjectsCount > 0 then
               RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;
            bGImageDisp := True;
            //        outputdebugstring(PChar('Could not open file ' + sDocFile));
            LogEvnt('Could not open file ' + sDocFile);

            fra_Voransicht.img_DocView.unLockPaint;

            gbansichtlesen := False;
            fra_Voransicht.img_DocView.Visible := True;
            exit;
         end;
         if ((not FileAccessable(sDocFile)) and (not lblesbar)) then
         begin
            setpanelinfo(
               _('Die Datei kann nicht gelesen werden, bitte versuchen sie es erneut.'));
            Clear;
            Blank;
            if ObjectsCount > 0 then
               RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;
            bGImageDisp := True;
            //        outputdebugstring(PChar('Could not open file ' + sDocFile));
            LogEvnt('Could not open file ' + sDocFile);

            fra_Voransicht.img_DocView.unLockPaint;
            gbansichtlesen := False;
            fra_Voransicht.img_DocView.Visible := True;
            exit;
         end;
         sIEVFile := ChangeFileExt(sDocFile, '') +
            IntToStr(IO.Params.TIFF_ImageIndex) + '.IEV';
         sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

         // Erzeuge den Privat Annotation namen des angemeldeten Users
         // should check for priv anno from others which give the right to read
         sChk4pIev := ChangeFileExt(sDocFile, '') + IntToStr(IO.Params.TIFF_ImageIndex) +
            'P' + IntToStr(igUsrId) + '.IEV';
         try
            fra_Voransicht.img_DocView.RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;

         except
            on e: Exception do
            begin
            end;
         end;

         //      outputdebugstring(PChar('Trying to opening file ' + sDocFile));
         frm_Mainform.fra_Voransicht.img_DocView.Visible := False;
         //      LogEvnt('Trying to opening file '+sDocFile);
         lbfloaded := False;
         licounter := 0;
         while not lbfloaded do
         begin
            try
               //          outputdebugstring(PChar(sdocfile));
               IO.LoadFromFile(sDocFile);
               lbfloaded := True;
            except
               on e: Exception do
               begin
                  lbfloaded := False;
                  licounter := licounter + 1;
                  if licounter > 10 then
                  begin
                     break;
                  end;
                  sleep(30);
               end;
            end;
         end;
//         dm_MainForm2.tim_Thumb.Enabled := True;
         if frm_mainform.dpnl_Thumbs.Visible then
         begin
            frm_mainform.loadthumbs(0, true);
         end;
         //      LogEvnt('Opened file ');
         if FirstPage then
            IO.Params.TIFF_ImageIndex := 0;
         for licounter := 0 to 2 do
         begin
            if (Fileexists(sChk4pIev)) then
            begin
               lblesbaranno := True;
               break;
            end;
            sleep(20);
         end;
         if lblesbaranno then
         begin
            fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
            GgfLogEvnt('LoadFromFileIEV 3');
            if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
            begin
               lsUsers := sGUsrName;
               liobjcount := fra_Voransicht.img_DocView.ObjectsCount;

               dm_MainForm2.pum_PrivAnno.Items.Add(
                  newItem(sGUsrName, //name
                  0,    //shortcut
                  False,//checked
                  True, // enabled
                  dm_MainForm2.pum_PrivAnnoClick, //onclick
                  0,    //heplcontext
                  'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
                  ));
               dm_MainForm2.pum_PrivAnno.Items[
                  dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
                  iGUSRID;
            end;
         end;
         if TMPSQL(' select b.usr_id, src_usr_id, usr_name from sys_docxs   as b left join'
            + ' sys_usr as a on(a.usr_id=b.src_usr_id) where b.usr_id = ' +
            IntToStr(igUsrId) + ' and  doc_id= ' + IntToStr(igdocid) +
            ' and arc_id=' + IntToStr(igarcid) + ' and  (find_in_set(' +
            #39 + 'apread' + #39 + ',rights))') then
         begin
            for licounter := 0 to dm_db.my_q_Tmp.RecordCount - 1 do
            begin
               sChk4pIev := ChangeFileExt(sDocFile, '') + '0P' +
                  dm_db.my_q_Tmp.FieldByName('src_usr_id').AsString + '.IEV';
               if Fileexists(sChk4pIev) then
               begin
                  // Icon 119
                  fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
                  GgfLogEvnt('LoadFromFileIEV 2');
                  if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
                  begin
                     liobjcount := fra_Voransicht.img_DocView.ObjectsCount + liobjcount;
                     if lsUsers = '' then
                        lsUsers := dm_db.my_q_Tmp.FieldByName('usr_name').AsString
                     else
                        lsUsers := lsusers + ', ' +
                           dm_db.my_q_Tmp.FieldByName('usr_name').AsString;
                     dm_MainForm2.pum_PrivAnno.Items.Add(
                        newItem(dm_db.my_q_Tmp.FieldByName('usr_name').AsString, //name
                        0,    //shortcut
                        False,//checked
                        True, // enabled
                        dm_MainForm2.pum_PrivAnnoClick, //onclick
                        0,    //heplcontext
                        'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
                        ));
                     dm_MainForm2.pum_PrivAnno.Items[
                        dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
                        dm_db.my_q_Tmp.FieldByName('src_usr_id').AsInteger;
                  end;
               end;
            end;
            if lsusers = '' then
            begin
               tbx_privNote.ImageIndex := 109;
               // Icon 109
            end
            else
            begin
               //   fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
               if tbx_privNote.Visible then
               begin
                  iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                     frm_MainForm.tbx_privNote).BoundsRect.Left;
                  iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                     frm_MainForm.tbx_privNote).BoundsRect.Top;

               end
               else
               begin
                  iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                     frm_MainForm.tbi_vshowanno).BoundsRect.Left;
                  iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                     frm_MainForm.tbi_vshowanno).BoundsRect.Top;
               end;
               iXTlb := frm_MainForm.tlb_Zoom2.Left;
               iYTlb := frm_MainForm.tlb_Zoom2.Top;

               iPos.X := frm_MainForm.tlb_Zoom2.CurrentDock.Left + iXTlb + iXTbi + 15;
               iPos.Y := frm_MainForm.tlb_Zoom2.CurrentDock.Top + iYTlb + iYTbi + 15;
               bh_PrivAnnoExist.ActivateHintPos(frm_MainForm, iPos,
                  'Notiz',
                  'Zu diesem Dokument existiert ' + IntToStr(liobjcount) +
                  ' persnliche Notiz von ' + lsusers);
               tbx_privNote.ImageIndex := 119;
               tbx_privNote.Hint :=
                  'Zu diesem Dokument existiert eine persnliche Notiz von ' + lsusers;
            end;
            fra_Voransicht.img_DocView.RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;
         end
         else
         begin
            LogEvnt('error with TMPSQL in   ShowVoransicht, searching for priv anno');
         end;
         //    Outputdebugstring(pchar('lesbar '+booltostr(lblesbar)));
         if lblesbar then
         begin
            ////////////////////////////////////////////////////////////////////////////////////////////////
            // Wenn eine IEV Datei mit Annotation existiert wird die Schaltflaeche Annotation automatisch aktiviert
            // und ebenfalls die Annotation automatisch angezeigt
            // if FileExists(sIEVFile) then tbi_VShowAnno.Checked := true;
            ////////////////////////////////////////////////////////////////////////////////////////////////

            // willentliche Enscheidung des U die annotation nicht anzuzeigen trotzdem Annos vorhanden
            // sind, z.B. beim Drucken ohne Annotation

            userights(rgDocRight);
            for licounter := 0 to 2 do
            begin
               if (Fileexists(sIEVFile)) then
               begin
                  lblesbarpubanno := True;
                  break;
               end;
               sleep(20);
            end;
            if lblesbarpubanno and not ShowNoAnno then
               tbi_VShowAnno.Checked := True;
            if tbi_VShowAnno.Checked then
            begin
               tbx_privNote.Visible := True;
               tbx_pubNote.Visible := True;
               // tbx_UserNote.Visible:=false;
            end
            else
            begin
               tbx_privNote.Visible := False;
               tbx_pubNote.Visible := False;
               //tbx_UserNote.Visible:=true;
            end;

            if tbi_VShowAnno.Checked then
            begin
               if lblesbarpubanno and lblesbar then
                  begin
                     LoadFromFileIEV(sIEVFile);
                     GgfLogEvnt('LoadFromFileIEV 1');
                  end
               else
               if ObjectsCount > 0 then
                  RemoveAllObjects;
               frm_MainForm.fra_Volltext.clearobjslist;
               if IO.Params.ImagingAnnot.ObjectsCount > 0 then
                  IO.Params.ImagingAnnot.CopyToTImageEnVect(fra_Voransicht.img_DocView);
            end;
            // is alerady done in changedoc
            //      tbsi_VZoomClick(self);
            ChangeDocPage(3);    // Erneuert nur die Seitenanzeige
            gbansichtlesen := False;
            fra_Voransicht.img_DocView.Visible := True;
            bGImageDisp := True; // Neues Bild wurde geladen
            ///////////////////////////////////////////////////////////////////////////////////////////////
            // Miniatur Ansicht einschalten

//            if tbi_VisThumbs.Checked then
//               dm_MainForm2.tim_Thumb.Enabled := True;
            if frm_mainform.dpnl_Thumbs.Visible then
            begin
               frm_mainform.loadthumbs(0, true);
            end;
         end
         else
         begin
            setpanelinfo(_('Die Datei kann nicht gelesen werden.'));
            Clear;
            Blank;
            if ObjectsCount > 0 then
               RemoveAllObjects;
            frm_MainForm.fra_Volltext.clearobjslist;
            bGImageDisp := True;
         end;
      end;
      try
         fra_Voransicht.img_DocView.unLockPaint;
         fra_Voransicht.img_DocView.Visible := True;
         dm_MainForm2.tim_docload.Enabled := False;
         frm_MainForm.pnl_docTime.ParentBackground := True;
         //shp_SuchInfo.Brush.Color := $0000007f;
         frm_MainForm.pnl_docTime.Color := frm_MainForm.pnl_SuchOpt.Color;
         frm_MainForm.pnl_docTime.Caption := '';
      except
         on e: Exception do
         begin
         end;
      end;
      frm_Mainform.fra_Voransicht.img_DocView.Visible := True;
      frm_MainForm.ZustaendeAnnotationBearbeitenSetzen; //m.frey
   end;
   gbansichtlesen := False;
end;

end.
