unit u_threadedvoransicht;

interface

uses
   Classes,
   u_ShLowUtils;

type
   TTvoransicht = class (TThread)
   private
      { Private declarations }

      fpipage: integer;
      fpitotalpages: integer;
      filoadedpages: integer;
      fpbcontinuetoload: boolean;
      fpbgotdocname: boolean;
   protected
      procedure Execute; override;
   public
      constructor create(fsuspended: boolean);
      property pipage: integer Read fpipage Write fpipage;
      property pitotalpages: integer Read fpitotalpages Write fpitotalpages;
      property piloadedpages: integer Read filoadedpages Write filoadedpages;
      property pbcontinuetoload: boolean Read fpbcontinuetoload Write fpbcontinuetoload;
      property pbgotdocname: boolean Read fpbgotdocname Write fpbgotdocname;
   end;

implementation

uses Windows, SysUtils, u_MainForm, u_dm_DB, ImageEnView, iemview,
   hyiedefs, ImageEnIO, ImageEnProc, ievect, Forms, {} u_dm_ViewerMain;

   var
     gThreadCS : RTL_CRITICAL_SECTION;

{ TMyThread }

constructor TTvoransicht.create(fsuspended: boolean);
begin
   fpbgotdocname := false;
   inherited create(fsuspended);
end;

procedure TTvoransicht.Execute;
var
   sDocFile, sExtFile: string;
   lMVec: TImageEnView;
   iout, licount, istarter: integer;
   lbfloaded, lbmarkhits: boolean;
begin
(*13.10.2010   iout := 0;
   //clear miniansicht
   try
      fpbgotdocname := false;
      sGdocfilenameloadedbythread := '';
      sGExtfilenameloadedbythread := '';
      lmvec := nil;
      istarter := 0;
      lbmarkhits := true;
      frm_MainForm.tmb_Voransicht.MIO.Aborting := True;
      while (((frm_MainForm.tmb_Voransicht.LockPaintCount > 0) or gbansichtlesen) and
            not terminated) do
      begin
         sleep(10);
      end;
      try

         if terminated then
            exit;
         if pbcontinuetoload then
         begin
            //load the next page not the actual!
            istarter := pipage;
         end
         else
         begin
            while (frm_MainForm.tmb_Voransicht.LockPaintCount <> 0) do
            begin
               sleep(10);
            end;
            try
               EnterCriticalSection(gThreadCS);
               frm_MainForm.tmb_Voransicht.LockPaint;

               frm_MainForm.tmb_Voransicht.Deselect;
               frm_MainForm.tmb_Voransicht.Clear;
               frm_MainForm.tmb_Voransicht.unLockPaint;
            finally

               LeaveCriticalSection(gThreadCS);
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
      // set doc titles
(*      if ((dm_DB.my_q_Arc.sql.Text = '') or ((rGDOCRight.Read = False))) then
      begin
         exit;
      end;
      while ((dm_db.my_q_Arc.FieldDefList.Find('doc_loc') = nil) or
            (dm_db.my_q_Arc.Executing)) and (not terminated) do
      begin
         sleep(50);
      end;
      if terminated then
      begin
         exit;
      end;     *)
(*13.10.2010      sDocFile := sGdocfilename;
      sExtFile := sGextfilename;
      sGdocfilenameloadedbythread := sDocFile;
      sGExtfilenameloadedbythread := sExtFile;
      fpbgotdocname := true;

      if FileExists(sExtFile) then
         sDocFile := sExtFile;


      // is file accescible?   
      lbfloaded := False;
      licount := 0;
  (*    while ((not lbfloaded) and (licount < 20)) do
      begin
         if FileAccessable(sDocFile) then
         begin
            lbfloaded := True;
            Break;
         end;
         licount := licount + 1;
         sleep(10);
      end;
      if lbfloaded then
      begin     *)
         // set a nice filter
(*13.10.2010         frm_MainForm.tmb_Voransicht.ThumbnailDisplayFilter := rfFastLinear;
         // create a dummy MView Object for loading
         lmvec := TImageEnView.Create(nil);
         // set load on demand so it will show incrementally
         { if not FileExists(sDocFile) then
          begin
             exit;
          end;
          }
         // set the filter for the miniansicht
         frm_MainForm.tmb_Voransicht.ThumbnailDisplayFilter := rfFastLinear;
         // show now all frames from the file
         while (not bGImageDisp) and (not terminated) do
         begin
            sleep(10);
            application.processmessages;
         end;
         if terminated then
         begin
            exit;
         end;
         try
            lmvec.io.LoadFromFile(sDocFile);
         except on e: exception do
            begin
            end;
         end;
         iout := istarter;
         pitotalpages := lmvec.IO.params.ImageCount;
         if lmvec.IO.params.ImageCount = 0 then
            pitotalpages := 1;
         if iout = pitotalpages then
         begin
            lbmarkhits := false;
         end;
         while ((iout < pitotalpages)
               //check for files ahead
            ) do
         begin
            // stop if terminate request was set
            if (terminated) then
            begin
               break;
            end;
            // set the frame
            lmvec.io.params.imageindex := iout;
            try
               lmvec.io.LoadFromFile(sDocFile);

            except on e: exception do
               begin
               end;
            end;
            //               OutPutDebugString(Pchar(booltostr(terminated)));
            // lock the paint for loading just the one frame!
            if lmvec.Bitmap.Width = 0 then
            begin
               iout := iout + 1;
               continue;
            end;
            try
               frm_MainForm.tmb_Voransicht.LockPaint;
               frm_MainForm.tmb_Voransicht.InsertImageEx(iout);
               frm_MainForm.tmb_Voransicht.SetImage(iout, lmvec.Bitmap);
               pipage := iout;
               frm_MainForm.tmb_Voransicht.unLockPaint;

            except
               on e: Exception do
               begin
                  logevnt('Error on Voransicht ' + e.Message);
               end;
            end;
            iout := iout + 1;
            piloadedpages := iout;
         end;
   //   end;
      piloadedpages := iout;
(*      if lbmarkhits then
      begin
         dm_MainForm2.tim_markpages.enabled := true;
      end;    *)
(*13.10.2010   finally
      begin
         if Assigned(lmvec) then
         begin
            FreeAndNil(lmvec);
         end;
      end;
   end;  *)
end;

//-----------------------------------------------------------------------------

initialization
   InitializeCriticalSection(gThreadCS); //17.08.2010 b.takacs

finalization
   DeleteCriticalSection(gThreadCS); //17.08.2010 b.takacs

end.

