//-----------------------------------------------------------------------------
// Projekt:    Bitfarm-Archiv Viewer
// Entwickler: m.frey
// Erstellt:   2010
// Name:       u_NewDocLink
// Typ:        Unit
// Zweck:      Eingabe fr Name einer neuen Verknpfung
//-----------------------------------------------------------------------------
//
//----------------------------------------------------------------------------}

unit u_NewDocLink;

{###############################} INTERFACE {###############################}

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls,
   u_ShHighUtils,
   gnugettext;


function GetNewDocLinkName(Owner:TComponent; bDocLinkList:Boolean; out Name:string):Boolean;

type
   Tfrm_NewDocLink = class (TForm)
      lbl_Hinweis_1: TLabel;
      btn_Ok: TButton;
      btn_Cancel: TButton;
      cbbName: TComboBox;
      procedure FormCreate(Sender: TObject);
    procedure cbbNameChange(Sender: TObject);
    procedure cbbNameSelect(Sender: TObject);
   private
      { Private-Deklarationen }
   public
      { Public-Deklarationen }
   end;

{############################} IMPLEMENTATION {#############################}

uses u_dm_DB, u_MainForm;

{$R *.dfm}

//-----------------------------------------------------------------------------
function GetNewDocLinkName(Owner:TComponent; bDocLinkList:Boolean; out Name:string):Boolean;
var frm_NewDocLink: Tfrm_NewDocLink;   mr: integer;
begin
   frm_NewDocLink := Tfrm_NewDocLink.Create(Owner);
   try
      if igLinkChars = 0 then
         DbGetLinks(frm_NewDocLink.cbbName.Items,'')
      else
         frm_NewDocLink.cbbName.Items.Clear;
      frm_NewDocLink.cbbName.AutoComplete := bDocLinkList;

      if frm_Mainform.lbl_choosenlink.Caption <> '' then
         frm_NewDocLink.cbbName.Text := frm_Mainform.lbl_choosenlink.Caption;


      mr := frm_NewDocLink.ShowModal;
      Result := mr = mrOk;
      if Result then
         Name := frm_NewDocLink.cbbName.Text;
   finally
      frm_NewDocLink.Free;
   end;
end;


//-----------------------------------------------------------------------------
procedure Tfrm_NewDocLink.FormCreate(Sender: TObject);
begin
   TranslateComponent(Self, 'ViewerV3');
end;

procedure Tfrm_NewDocLink.cbbNameChange(Sender: TObject);
begin
	if length(Trim(cbbName.Text)) < igLinkChars then
      cbbName.Items.Clear
   else
   begin
      //cbb_SearchDocLink.Items.Clear;
      frm_Mainform.ReadCbxDocLinks(cbbName, Trim(cbbName.Text));
   end;
   cbbName.SelStart := Length(cbbName.Text);

end;

procedure Tfrm_NewDocLink.cbbNameSelect(Sender: TObject);
begin
	OutputDebugString('cbbNameSelect');
end;

end.
//-----------------------------------------------------------------------------

