unit u_Voransicht;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, Registry, ExtCtrls, Buttons, ComCtrls, ieview, imageenview, ievect,
   Imageenproc, imageenio, TB2Dock, TBX, gnugettext,
   u_ShLowUtils, u_HighUtils, u_ViewBase;

type
   Tfrm_Voransicht = class (TFrame)
      img_DocView: TImageEnVect;
      Label1: TLabel;
      tim_doubleclick: TTimer;
      procedure img_DocViewDblClick(Sender: TObject);
      procedure img_DocViewMouseWheel(Sender: TObject; Shift: TShiftState;
         WheelDelta: integer; MousePos: TPoint; var Handled: boolean);
      procedure img_DocViewProgress(Sender: TObject; per: integer);
      procedure img_DocViewImageChange(Sender: TObject);
      procedure img_DocViewViewChange(Sender: TObject; Change: integer);
      procedure img_DocViewMouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);
      procedure img_DocViewMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure img_DocViewMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure img_DocViewNewObject(Sender: TObject; hobj: integer);
      procedure img_DocViewObjectOver(Sender: TObject; hobj: integer);
      procedure img_DocViewDeactivateTextEdit(Sender: TObject);
      procedure img_DocViewActivateTextEdit(Sender: TObject);
      procedure img_DocViewMouseLeave(Sender: TObject);
      procedure FrameResize(Sender: TObject);
      procedure tim_doubleclickTimer(Sender: TObject);
      procedure img_DocViewMouseEnter(Sender: TObject);
      procedure img_DocViewTextKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure img_DocViewObjectMoveResize(Sender: TObject; hobj,
         Grip: Integer; var OffsetX, OffsetY: Integer);
        procedure img_DocViewSelectObject(Sender: TObject);
    procedure img_DocViewUserDeselectObject(Sender: TObject;
      hobj: Integer);
    procedure img_DocViewKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure img_DocViewUserSelectObject(Sender: TObject; hobj: Integer);

   private
      fsaveenabled: boolean;
      fobjdel: boolean;
      fobjposition: array of Tpoint;
      fobjdimension: array of Tpoint;
      { Private-Deklarationen }
   public
      fdoubleklicked: boolean;
      fzooming: boolean;
      fmysavedcontrol: TwinControl;
      fsavingobjs: boolean;
      fphistorymessage: string;
      fsinfo: string;
      fbshowformtext: boolean;
      fbmouseinim: boolean;
      procedure updateobjects;
      procedure saveobjects(fsetinteracts, fsetintervtback: boolean);
      procedure createannodata(fidx: integer);
      procedure saveannodata(fidx: integer);
      function ReadObjVals(ObjType, Idx: integer): boolean;
      procedure AnDelClick(Sender: TObject);
      { Public-Deklarationen }
   end;

implementation

uses u_MainForm, {} u_dm_ViewerMain, u_dm_DB, StrUtils, Vectors, collision,
   u_DocEditor, hyiedefs;

{$R *.dfm}

var
   md_mouseX1, md_mouseY1: integer;


function ObjTypeToStr (ObjType: integer): string;
  begin
    case ObjType of
       0: Result := 'Line';
       1: Result := 'Box';
       2: Result := 'Ellipse';
       3: Result := 'Arc';
       4: Result := 'Bitmap';
       5: Result := 'Text';
       6: Result := 'Ruler';
       7: Result := 'Polyline';
       8: Result := 'Angle';
       9: Result := 'Note';
      10: Result := 'LineLabel';
      11: Result := 'HiLite';
      12: Result := 'Poligon';
      13: Result := 'FreeHand';
      14: Result := 'Arrow';
      15: Result := 'Text';
      16: Result := 'Freihand';
      17: Result := 'Freihand1';
      18: Result := 'Freihand2';
      19: Result := 'Freihand3';
      20: Result := 'Freihand4';
      21: Result := 'Text1';
      22: Result := 'Text2';
      23: Result := 'Text3';
      24: Result := 'Text4';
      25: Result := 'Note1';
      26: Result := 'Note2';
      27: Result := 'Note3';
      28: Result := 'Note4';
      29: Result := 'HiLite1';
      30: Result := 'HiLite2';
      31: Result := 'HiLite3';
      32: Result := 'HiLite4';
      33: Result := 'Buchungsstempel';
    end;
  end;


function Tfrm_Voransicht.ReadObjVals(ObjType, Idx: integer): boolean;
var
   reg: TRegistry;
   fsTmp: TFontStyles;
   shTmp: TIEShape;
   bsTmp: TBrushStyle;
   lpTmp: TIELabelPos;
   psTmp: TPenStyle;
   rtTmp: TIEVRulerType;
   ruTmp: TIEUnits;
   //    ssTmp: TIEVSoftShadow;
   osTmp: TIEVStyle;
   taTmp: TIEAlignment;
   sRegKeyName: string;
begin
   Result := True;
   frm_DocEdit.CheckObjVals;
   reg := TRegistry.Create;

   sRegKeyName := ObjTypeToStr (ObjType);

   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Annotation\' + sRegKeyName, True);
            with img_Docview do
            begin

               // ObjTransparency[idx]:=120; // Transparenz setzen
               if ValueExists('ObjArcEndingAngle') then
                  ObjArcEndingAngle[idx] := ReadFloat('ObjArcEndingAngle')
               else
                  ObjArcEndingAngle[idx] := 90;
               if ValueExists('ObjArcStartingAngle') then
                  ObjArcStartingAngle[idx] := ReadFloat('ObjArcStartingAngle')
               else
                  ObjArcStartingAngle[idx] := 0;
               if ValueExists('ObjBeginShape') then
                  ReadBinaryData('ObjBeginShape', shTmp, SizeOf(shTmp))
               else
                  shTmp := iesNONE;
               ObjBeginShape[Idx] := shTmp;
               if ValueExists('ObjBitmapBorder') then
                  ObjBitmapBorder[idx] := ReadBool('ObjBitmapBorder')
               else
                  ObjBitmapBorder[idx] := False;
               if ValueExists('ObjBoxHighLight') then
                  ObjBoxHighLight[idx] := ReadBool('ObjBoxHighLight')
               else
                  ObjBoxHighLight[idx] := False;
               if ValueExists('ObjBrushColor') then
                  ObjBrushColor[idx] := ReadInteger('ObjBrushColor')
               else
                  ObjBrushColor[idx] := clYellow;
               if ValueExists('ObjBrushStyle') then
                  ReadBinaryData('ObjBrushStyle', bsTmp, SizeOf(bsTmp))
               else
               begin
                  if (ObjType > 15) and (ObjType < 21) then
                  begin
                     bsTmp := bsClear;
                  end
                  else
                  begin
                     bsTmp := bsSolid;
                  end;
               end;

               ObjBrushStyle[idx] := bsTmp;
               if ValueExists('ObjEndShape') then
                  ReadBinaryData('ObjEndShape', shTmp, SizeOf(shTmp))
               else
                  shTmp := iesNONE;
               ObjEndShape[Idx] := shTmp;
               if ValueExists('ObjFontAngle') then
                  ObjFontAngle[idx] := ReadFloat('ObjFontAngle')
               else
                  ObjFontAngle[idx] := 0;
               if ValueExists('ObjFontHeight') then
                  ObjFontHeight[idx] := ReadInteger('ObjFontHeight')
               else
                  ObjFontHeight[idx] := 72;

               if img_DocView.DpiX < 300 then //17.03.2011 b.takacs 3.5.0.167
               begin
                  if ObjFontHeight[idx] = 72 then
                  begin
                    ObjFontHeight[idx]:= round((img_DocView.DpiX*72)/300);
                  end;
               end;

               if ValueExists('ObjFontLocked') then
                  ObjFontLocked[idx] := ReadBool('ObjFontLocked')
               else
                  ObjFontLocked[idx] := False;
               if ValueExists('ObjFontName') then
                  ObjFontName[idx] := ReadString('ObjFontName')
               else
                  ObjFontName[idx] := 'Arial';
               if ValueExists('ObjFontStyles') then
                  ReadBinaryData('ObjFontStyles', fsTmp, SizeOf(fsTmp))
               else
                  fsTmp := [];
               ObjFontStyles[idx] := fsTmp;
               if ValueExists('ObjLabelBrushColor') then
                  ObjLabelBrushColor[idx] := ReadInteger('ObjLabelBrushColor')
               else
                  ObjLabelBrushColor[idx] := clGreen;
               if ValueExists('ObjLabelBrushStyle') then
                  ReadBinaryData('ObjLabelBrushStyle', bsTmp, SizeOf(bsTmp))
               else
                  bsTmp := bsSolid;
               ObjLabelBrushStyle[idx] := bsTmp;
               //f.schneider  v3.5.0.174
               if ValueExists('ObjMemoCharsBrushStyle') then
                  ReadBinaryData('ObjMemoCharsBrushStyle', bsTmp, SizeOf(bsTmp))
               else
                  bsTmp := bsClear;
               ObjMemoCharsBrushStyle[idx] := bsTmp;
               if ValueExists('ObjLabelPosition') then
                  ReadBinaryData('ObjLabelPosition', lpTmp, SizeOf(lpTmp))
               else
                  lpTmp := ielBegin;
               ObjLabelPosition[idx] := lpTmp;
               if ValueExists('ObjMemoBorderColor') then
                  ObjMemoBorderColor[idx] := ReadInteger('ObjMemoBorderColor')
               else
                  ObjMemoBorderColor[idx] := clBlack;
               if ValueExists('ObjMemoBorderStyle') then
                  ReadBinaryData('ObjMemoBorderStyle', psTmp, SizeOf(psTmp))
               else
                  psTmp := psSolid;
               ObjMemoBorderStyle[idx] := psTmp;
               if ValueExists('ObjMemoFixedHeight') then
                  ObjMemoFixedHeight[idx] := ReadInteger('ObjMemoFixedHeight')
               else
                  ObjMemoFixedHeight[idx] := 0;
               if ValueExists('ObjMemoLineSpace') then
                  ObjMemoLineSpace[idx] := ReadInteger('ObjMemoLineSpace')
               else
                  ObjMemoLineSpace[idx] := 0;
               if ValueExists('ObjName') then
                  ObjName[idx] := ReadString('ObjName')
               else
                  ObjName[idx] := 'Neues Objekt '+ IntToStr(idx);
               if ValueExists('ObjPenColor') then
                  ObjPenColor[idx] := ReadInteger('ObjPenColor')
               else
                  ObjPenColor[idx] := clBlack;
               if ValueExists('ObjPenStyle') then
                  ReadBinaryData('ObjPenStyle', psTmp, SizeOf(psTmp))
               else
                  psTmp := psSolid;
               ObjPenStyle[idx] := psTmp;
               if ValueExists('ObjPenWidth') then
                  ObjPenWidth[idx] := ReadInteger('ObjPenWidth')
               else
                  ObjPenWidth[idx] := 1;
               if ValueExists('ObjPolylineClosed') then
                  ObjPolylineClosed[idx] := ReadBool('ObjPolylineClosed')
               else
                  ObjPolylineClosed[idx] := False;
               if ValueExists('ObjRulerType') then
                  ReadBinaryData('ObjRulerType', rtTmp, SizeOf(rtTmp))
               else
                  rtTmp := iertRULER;
               ObjRulerType[idx] := rtTmp;
               if ValueExists('ObjRulerUnit') then
                  ReadBinaryData('ObjRulerUnit', ruTmp, SizeOf(ruTmp))
               else
                  ruTmp := ieuPIXELS;
               ObjRulerUnit[idx] := ruTmp;
               if ValueExists('ObjShapeHeight') then
                  ObjShapeHeight[idx] := ReadInteger('ObjShapeHeight')
               else
                  ObjShapeHeight[idx] := 0;
               if ValueExists('ObjShapeWidth') then
                  ObjShapeWidth[idx] := ReadInteger('ObjShapeWidth')
               else
                  ObjShapeWidth[idx] := 0;
               //           if ValueExists('ObjSoftShadow') then ReadBinaryData('ObjSoftShadow', ssTmp, SizeOf(ssTmp)) else ssTmp.Enabled := False;
               //          ObjSoftShadow[idx].Enabled := ssTmp.Enabled;
               //          ObjSoftShadow[idx].Radius := ssTmp.Radius;
               //          ObjSoftShadow[idx].OffsetX := ssTmp.OffsetX;
               //          ObjSoftShadow[idx].OffsetY := ssTmp.OffsetY;
               if ValueExists('ObjStyle') then
                  ReadBinaryData('ObjStyle', osTmp, SizeOf(osTmp))
               else
                  osTmp := [ievsSelectable, ievsMoveable, ievsSizeable, ievsVisible];
               ObjStyle[idx] := osTmp;
               if ValueExists('ObjTextAlign') then
                  ReadBinaryData('ObjTextAlign', taTmp, SizeOf(taTmp))
               else
                  taTmp := iejLeft;
               ObjTextAlign[idx] := taTmp;
               if ValueExists('ObjTextAutoSize') then
                  ObjTextAutoSize[idx] := ReadBool('ObjTextAutoSize')
               else
                  ObjTextAutoSize[idx] := False;
               if ValueExists('ObjTextCurveCharRot') then
                  ObjTextCurveCharRot[idx] := ReadFloat('ObjTextCurveCharRot')
               else
                  ObjTextCurveCharRot[idx] := 0;
               if ValueExists('ObjText') then
                  ObjText[idx] := ReadString('ObjText')
               else
                  ObjText[idx] := '';
               if ValueExists('ObjTransparency') then
                  ObjTransparency[idx] := ReadInteger('ObjTransparency')
               else
                  ObjTransparency[idx] := 255;

               if ValueExists('Objwidth') then
                  Objwidth[idx] := ReadInteger('Objwidth');
               if ValueExists('objheight') then
                  Objheight[idx] := ReadInteger('objheight');
               if ValueExists('Showtextform') then
                  fbshowformtext := ReadBool('Showtextform')
               else
                  fbshowformtext := false;

               // f.schneider   v3.5.0.164
               // Neue Notiz gibts nicht mehr, da ImageEn 3.1.2 das Markieren nicht mehr untersttzt
               If ObjName[idx] = 'Neue Notiz ' then
                  ObjName[idx] := '';
               If ObjText[idx] = 'Neue Notiz ' then
                  ObjText[idx] := '';
               if LeftStr(ObjName[idx],10) = 'Neuer Text' then
                  ObjName[idx] := '';
               if LeftStr(ObjText[idx],10) = 'Neuer Text' then
                  ObjText[idx] := '';
            end;

            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('frm_DocEdit.ReadObjVals', _('Fehler bei Laden aus der Registrierung: ') +
               e.Message, 2029, True);
            Result := False;
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure Tfrm_Voransicht.img_DocViewDblClick(Sender: TObject);
begin
   try //3.5.0.72
      //3.5.0.72 frm_MainForm.tbi_normalmouseClick(Self);//3.5.0.44 [2161]

      if fsavingobjs then
      begin
         fdoubleklicked := true;
      end
      else
      begin
         if (rGDocRight.modify) and (not img_DocView.IsEmpty) then
         begin
            if img_docview.MouseInteractVt = [miPutPolyLine] then
               begin
                  img_DocView.CancelInteracts;
				      img_DocView.DeSelect;
				      img_DocView.UnSelAllObjects;
                  img_docview.MouseInteractVt := [];
				      img_docview.BitmapResampleFilter := rfLinear;
                  frm_MainForm.fgchangedvoransicht := true;
                  frm_MainForm.fgchangedvoransichttif := true;
                  gbAnnoNotSaved := True;
                  createannodata(img_DocView.ObjHeapCount -1);

                  img_docview.MouseInteractVt := [miPutPolyLine];

                  Abort;   // ganz wichtig! sonst wird hiernach TImageEnVect.MouseDown ausgefhrt und
                  			// das nue Polygon beginnt genau dort wo das alte aufhren sollte
               end
            else
            if img_docview.MouseInteractVt = [miObjectSelect] then
            begin
              ///
              if not gbAnnoNotAccessible then
              begin
                 frm_MainForm.btn_SaveDoc.Enabled := True;
              	  GHasNotBeenSavedAfterModify := True;
              end;

              Exit;
            end
            else
            begin
                frm_MainForm.tbi_VEditClick(self);
                Abort;
            end;
         end;
         if not rGDocRight.modify then
            BfShowMessage('Hinweis' + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
      end;
   finally //3.5.0.72
      // Hier am schlu weil sonst ist miPutPolyLine nicht mehr aktiv
      //frm_MainForm.tbi_normalmouseClick(Self);//3.5.0.44 [2161] //3.5.0.72
   end; //3.5.0.72
end;

procedure Tfrm_Voransicht.img_DocViewMouseWheel(Sender: TObject;
   Shift: TShiftState; WheelDelta: integer; MousePos: TPoint; var Handled: boolean);
var
   li: integer;
   
begin
   //m.frey 09-12-17 bug gemeldet von Heino mit Zoomen mit Rausrad wenn gerade neue Notiz draufgemacht wurde
   if not ( miscroll in img_DocView.MouseInteract) then
      Exit;

   li := img_docview.ObjTextEditMode;
   if li = 0 then
   begin
      img_DOCView.ZoomAt(mousepos.x, mousepos.y, 0, False);
   end;

end;

procedure Tfrm_Voransicht.img_DocViewProgress(Sender: TObject; per: integer);
begin
   //  if (per mod 10) = 0 then
   //  begin
   //    pgb_LoadDoc.Position := per;
   (*if (Sender is TImageEnProc) or
      (Sender is TImageEnIO) then
      Application.ProcessMessages;*)
   //  end;
   //  If per = 100 then pgb_LoadDoc.Position := 0;
end;

procedure Tfrm_Voransicht.img_DocViewImageChange(Sender: TObject);
begin
   gbchangezoomtextnotview := True;
   frm_MainForm.cbx_VZoom.Text := FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
   gbchangezoomtextnotview := False;
   with img_DocView do
      if (VertScrollBar.IsScrollBarVisible or HorzScrollBar.IsScrollBarVisible) and
         (MouseInteract = []) then
         MouseInteract := [miScroll];
   
end;

procedure Tfrm_Voransicht.img_DocViewViewChange(Sender: TObject; Change: integer);
begin
   if Change = 1 then
   begin
      gbchangezoomtextnotview := True;
      frm_MainForm.cbx_VZoom.Text :=
         FloatToStrF(img_DocView.Zoom, ffFixed, 7, 2) + ' %';
      gbchangezoomtextnotview := False;
   end
   else
   begin
      if img_DocView.isempty and (not (frm_mainform.tbsi_VZoom.ImageIndex = 41)) then
      begin
         img_DocView.Zoom := 0.1;
         gbchangezoomtextnotview := true;
         frm_MainForm.cbx_VZoom.Text := '';
         gbchangezoomtextnotview := false;
      end;
   end;
   // we need it so the text gets actually actualized when zooming
   frm_MainForm.uncheckallgraphictools;
{  if (img_DocView.Bitmap.Width > img_DocView.Width) or (img_DocView.Bitmap.Height > img_DocView.Height) then
  img_DocView.MouseInteract := img_DocView.MouseInteract + [miScroll];}
end;

procedure Tfrm_Voransicht.img_DocViewMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: integer);
var lscontrolname: string;
   lbwvlhasfocus: boolean;
begin
   //     MousePositionVoransicht.x:=X;
   //     MousePositionVoransicht.y:=Y;
   if not gbdoceditformshowed then
   begin
      if fmysavedcontrol <> nil then
      begin
         fmysavedcontrol.setfocus;
      end;
      exit;
   end;

   if assigned(frm_mainform.ActiveControl) then
   begin
      lscontrolname := frm_mainform.ActiveControl.name;
   end
   else
   begin
      lscontrolname := '';
   end;
   if frm_MainForm.tbi_VLupe.Checked and img_DocView.Visible and
      (frm_mainform.Handle = GetForegroundWindow) and (not img_DocView.Focused) and
      ((lscontrolname = 'dbgrd_Trefferliste') or (lscontrolname = 'dbgrd_Wvl')) then
   begin
      try
         if (fmysavedcontrol <> nil) then
            //    outputdebugstring(pchar('entering '+fmysavedcontrol.name));
            if (frm_mainform.ActiveControl <> nil) and
               (frm_mainform.ActiveControl.name <> 'img_DocView')
            then
               fmysavedcontrol := frm_mainform.ActiveControl;
         lbwvlhasfocus := wvlhasfocus;
         img_DocView.SetFocus;
         wvlhasfocus := lbwvlhasfocus;

         frm_mainform.wvlshowbuttons(lbwvlhasfocus);
      except
          on e: exception do
         begin
           LogEvnt('Fehler bei img_DocViewMouseMove:' + e.Message);
         end;
      end;
   end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseDown(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
   if button = MbMiddle then
   begin
      // showmessage ('mittleren Knopf gedrckt');
      //img_docView.MouseInteractVT := [miObjectSelect];
  {
      img_docview.SelX1:= 40;
      img_docview.SelX2:= 40;
      img_docview.Sely1:= 200;
      img_docview.Sely2:= 200;
   }

      md_mouseX1 := X;
      md_mousey1 := Y;
   end;
   // in the doubleclick mousedown is called
   if assigned(frm_docedit)
   //  and    gbeditdoc
   then
   begin
      try
         if assigned(frm_mainform.flastdoc_edit)
         then
         begin
            if not frm_mainform.flastdoc_edit.fwassettofront then
            begin
               frm_mainform.flastdoc_edit.BringToFront;
               frm_mainform.flastdoc_edit.fwassettofront := true;
            end;
         end;
      except on e: exception do
         begin
         end;
      end;
      //      gbeditdoc :=false;
   end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
   idx :Integer;
begin
   // on realease button just select if the middle mouse was pressed
   if button = MbMiddle then
   begin
      img_docview.select(md_mouseX1, md_mousey1, x, y);
      img_docview.ZoomSelection(True);
   end;

   if (img_docview.MouseInteractVt = [miPutPolyLine]) and
      frm_mainform.tbsi_stifte.Checked then
   begin
      img_docview.cancelinteracts;
      gbAnnoNotSaved := True;
      createannodata(img_DocView.ObjHeapCount -1);
      //img_docview.finalizepolyline;
      img_docview.BitmapResampleFilter := rfLinear;
   end;

	for idx := 0 to img_DocView.ObjectsCount -1 do
   begin
		if img_docview.ObjUserData[idx] <> nil then
      begin
         if (sGUsrName <> PAnnoData(img_docview.ObjUserData[idx])^.ersteller) and (not rGDocRight.AModify) then
         begin
            img_DocView.UnSelObject(idx);
         end;

      end;
   end;

end;

procedure Tfrm_Voransicht.img_DocViewNewObject(Sender: TObject; hobj: integer);
var
   A, B: TPolygon;
   i: integer;
   MTD: TVector2f;
   lbinter, loopbreak: boolean;

begin
   GgfLogEvntBeg ('Tfrm_Voransicht.img_DocViewNewObject Begin');

   frm_mainform.fra_Volltext.removeocrhits;
   fobjdel := False;
   img_DocView.ObjEditOnNewText := false;

   try
      loopbreak := false;
      a := nil;
      b := nil;
      if (img_DocView.ObjBrushStyle[hobj] <> bsClear) or
         ((img_DocView.ObjKind[hobj] = iekBOX) and
         (img_DocView.ObjBoxHighLight[hobj])) then
      begin
         if not rgdocRight.suanno then
         begin
            A := TPolygon.Create;
            with A do
            begin
               position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
               AddVertex(to_v2f(0, 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
               AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
            end;
            i := 0;
            loopbreak := False;
            while i < img_DocView.ObjectsCount do
            begin
               if i = hobj then
               begin
                  i := i + 1;
                  continue;
               end;
               B := TPolygon.Create;
               with B do
               begin
                  position := to_v2f(img_DocView.ObjLeft[i], img_DocView.ObjTop[i]);
                  AddVertex(to_v2f(0, 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[i], 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[i], img_DocView.ObjHeight[i]));
                  AddVertex(to_v2f(0, img_DocView.ObjHeight[i]));
               end;
               i := i + 1;
               lbinter := False;
               loopbreak := False;
               if PolyPolyIntersect(a, b, MTD) then
               begin
                  img_docview.DeSelect;
                  img_docview.cancelinteracts;
                  img_docview.RemoveObject(hobj);
                  fobjdel := True;
                  img_docview.UnSelAllObjects;
                  img_docview.ObjEditOnNewText := false;
                  //      img_DocView.MouseInteractVt := [];
                  BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
                  exit;
               end;

               if loopbreak then
               begin
                  img_DocView.RemoveObject(hobj);
                  break;
               end;
               if lbinter then
               begin
                  img_DocView.ObjTop[hobj] := round(a.position.y);
                  img_DocView.ObjLeft[hobj] := round(a.position.x);
               end;

               if assigned(b) then
                  FreeAndNil(b);
            end;
         end;
         if not loopbreak then
         begin
            createannodata(hobj);
            gbAnnoNotSaved := True;
            img_DocView.ObjEditOnNewText := true;

         end
         else
         begin
            BfShowMessage(_('Die Notiz konnte nicht auf eine freie Stelle platziert werden.'));
            exit;
         end;
      end
      else
      begin
         createannodata(hobj);
         gbAnnoNotSaved := True;
         img_DocView.ObjEditOnNewText := true;
      end;
      //if text or memo ondeactivate will be called, save there.
      if (img_DocView.objkind[hobj] <> iekMemo) and
         (img_DocView.objkind[hobj] <> iekTEXT) and
         (img_DocView.objkind[hobj] <> iekPOLYLINE) then    // f.schneider   v3.5.1.62
      begin
         frm_mainform.fgchangedvoransicht := true;
         saveobjects(false, false);
      end
      else
      begin
         //       img_docview.ObjTextAutoSize[hobj]:=true;
{       if (img_DocView.MouseInteractVt<> [miObjectSelect]) and (img_DocView.MouseInteractVt<> []) then
      img_DocView.MouseInteractVt:=[];

      img_DocView.MouseInteract:=[miScroll];}
         //GHasNotBeenSavedAfterModify := true;

         frm_mainform.fgchangedvoransicht := true;
      end;

      img_DocView.ObjGraphicRender := False;
      img_DocView.EnableAlphaChannel := False;

   finally
      begin
         GgfLogEvntEnd ('Tfrm_Voransicht.img_DocViewNewObject End via finally');

         if assigned(a) then
            FreeAndNil(a);
         if assigned(b) then
            FreeAndNil(b);

      end;
   end;
end;

procedure Tfrm_Voransicht.AnDelClick(Sender: TObject);
var
   idx, licount, iSel: integer;
   bContinue : Boolean;   // nicht das einer meint, ich htte hier Bldsinn programmiert
									// die Funktion hat tatschlich das Continue nicht richt ausgefhrt
                           // und jede Anno gelscht, auch wenn sie das nicht sollte, balint ist mein Zeuge
begin
   licount := 0;
   while  licount < img_docview.SelObjectsCount do
   begin
      bContinue := False;
      idx := img_docview.SelObjects[licount];

      if (not rGDocRight.AModify) then
      begin
         if img_docview.ObjUserDataLength[idx] > 0 then
         begin
            if (sGUsrName <> PAnnoData(img_docview.ObjUserData[idx])^.ersteller) then
            begin
               bContinue := True;
            end;
         end
         else
         if (img_docview.ObjUserDataLength[idx] = 0) then
         begin
            bContinue := True;
         end;
      end;
      if not bContinue then
      begin
         bGDelObj := True;

         if  img_docview.ObjText[idx] = '' then
            frm_MainForm.NewHistory(13, _('Annotation wurde entfernt.'))
         else
            frm_MainForm.NewHistory(13, Format(_('Annotation mit Text %s wurde entfernt'),[img_docview.ObjText[idx]]));
         img_docview.RemoveObject(idx);
         frm_mainform.btn_SaveDoc.Enabled := True;
         frm_mainform.fgchangedvoransicht := true;
         GHasNotBeenSavedAfterModify := True;

      end;
      Inc(licount);
   end;
end;


procedure Tfrm_Voransicht.img_DocViewObjectOver(Sender: TObject; hobj: integer);
var
   mydata: PAnnoData;
   lipos1: integer;
   lsv, lsTmp: string;
begin
   mydata := img_DocView.ObjUserData[hobj];
   try
      if mydata <> nil then
      begin
         if mydata = Pointer($FFFFFFFF) then
            exit;

         lsv := mydata.version;
         if ((lsv[1] <> '0') or (lsv[3] <> '1')) then
            exit;
         lsTmp := frm_Mainform.GetStatusText(cStatusPanelInfo);
         if pos(_('; zuletzt gendert am:'), lsTmp) = 0 then //3.5.0.25
         begin
            fsinfo := lsTmp; //3.5.0.25 frm_MAinform.GetStatusText(cStatusPanelInfo);
         end;
         frm_MainForm.setpanelinfo(
            _('Autor:') + mydata.Ersteller + _('; zuletzt gendert am:') + mydata.Datum);
         if mydata.Veraenderer <> '' then
         begin
            if 0 = Pos(',', ReverseString(mydata.Veraenderer)) then
            begin
               lipos1 := 0;
            end
            else
            begin
               lipos1 := length(mydata.Veraenderer) - Pos(',',
                  ReverseString(mydata.Veraenderer)) + 2;
            end;
            frm_MainForm.setpanelinfo(
               frm_MAinform.GetStatusText(cStatusPanelInfo)
               + _('; zuletzt verndert von:') + //3.5.0.25
               copy(mydata.Veraenderer, lipos1, length(mydata.Veraenderer)));
            frm_MAinform.SetStatusHint(cStatusPanelInfo, //3.5.0.25
               copy(mydata.Veraenderer, 0, length(mydata.Veraenderer)) );
         end;
         //3.5.0.25
      end
      else
      begin
         if fsinfo <> '' then
            frm_MainForm.setpanelinfo(fsinfo);
      end;
   except
      on e: Exception do
      begin
      end;
   end;
end;

procedure Tfrm_Voransicht.img_DocViewDeactivateTextEdit(Sender: TObject);
var
   liobj, liarcid, lidocid: integer;
   lssql, lsarcname, lsVtx, lstext, lsadd: string;
begin
   lidocid := 0;
   liarcid := 0;
   liobj := img_DocView.ObjTextEditMode;
   (*
   try
      img_DocView.LockPaint;
      if not (gbArcHandling or dm_MainForm2.tim_Blank.Enabled) then
         saveobjects(False, false);
      if gbArcHandling then
      begin
         saveobjects(False, true);
      end;
   finally
      img_DocView.UnLockPaint;
   end; *)
   fsaveenabled := frm_mainform.btn_SaveDoc.Enabled;
   lsarcname := gshardlarcname;

   liarcid := iGArcID;
   lidocid := iGDocID;
   iGArcID := gihardlarcid;
   iGDocID := gihardldocid;

   frm_mainform.NewHistory(23, _('Neue Annotation mit folgendem Text:') +
      img_DocView.ObjText[liobj] + ' ' + _('auf Seite') + ' ' +
      inttostr(img_DocView.IO.Params.TIFF_ImageIndex + 1));

   frm_mainform.btn_SaveDoc.Enabled := fsaveenabled;
   img_DocView.Update;

   if gbNoteslwrecord then
   begin
      if frm_mainform.fbisktstamp then
      begin
         lsadd := 'KT:';
         frm_mainform.fbisktstamp := false;
      end
      else
      begin
         lsadd := '';
      end;
      lstext := lsadd + trim(ParseSemicolonUseBackslash(img_DocView.ObjText[img_DocView.ObjTextEditMode]));

      with dm_DB.my_cmd do
      begin
         SQL.Text := 'Insert into slw_' + sIArcName + ' (doc_id, doc_slw) Values (' +
            IntToStr(iGDocID) + ', ' + #39 +
            lstext + #39 + ')';
         lssql := SQL.Text;
         try
            Execute;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_voransicht.NewSlw', _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                  e.Message + ' . sqltext: ' + lssql + ' slw: ' +
                  lstext, 2025, True);

               iGArcID := liarcid;
               iGDocID := lidocid;
               exit;
            end;
         end;


         dm_DB.my_q_tmp.SQL.Text := 'select arc_id,doc_id, arc_tblname from sys_gdocid left join sys_Arc ' +
            'using(arc_id) where gdoc_id = ' + inttostr(giglobalgdocid);

         try
            dm_DB.my_q_tmp.Execute;
         except on e: exception do
            begin
            end;
         end;

         SQL.Text := 'Insert into slw_' + dm_DB.my_q_tmp.FieldByName('arc_tblname').AsString +
            ' (doc_id, doc_slw) Values (' +
            IntToStr(dm_DB.my_q_tmp.FieldByName('doc_id').asinteger) + ', ' + #39 +
            lstext + #39 + ')';
         lssql := SQL.Text;
         try
            Execute;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_voransicht.NewSlw', _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                  e.Message + ' . sqltext: ' + lssql + ' slw: ' +
                  lstext, 2025, True);
               exit;
            end;
         end;
         frm_mainform.NewHistoryID(12, _('Neues Schlagwort') + ' [' +
            lstext + '] ' + _('hinzugefgt') + '.', dm_DB.my_q_tmp.FieldByName('arc_id').asinteger,
            dm_DB.my_q_tmp.FieldByName('doc_id').asinteger);
      end;

   end;
   if gbNotevtxrecord then
   begin
      dm_DB.my_q_tmp.SQL.Text := 'select doc_txt from arc_' + sIArcName + ' where doc_id=' +
         inttostr(iGDocID);
      try
         dm_DB.my_q_tmp.Execute;
      except on e: exception do
         begin
         end;
      end;
      lsVtx := dm_DB.my_q_tmp.FieldByName('doc_txt').AsString;
      with dm_DB.my_cmd do
      begin
         SQL.Text := 'Update arc_' + sIArcName + ' set doc_txt = :VTX where doc_id = ' +
            IntToStr(iGDocID);
         ParamByName('VTX').AsString :=
            lsVTX + #13 + #13 + _('Anmerkungstexte eingefgt am:') + ' ' +
            DateTimeToStr(now) + #13 +
            '--------------------------------------------------------------------------------------------------------------------'
            + #13 + #13 + Trim(img_DocView.ObjText[liobj]);
         lssql := SQL.Text;
         try
            Execute;
         except
            on e: Exception do
            begin
               ErrorMsg('frm_voransicht.VtX', _('Fehler beim Hinzufgen eines Schlagwortes: ') +
                  e.Message + ' . sqltext: ' + lssql + ' slw: ' +
                  img_DocView.ObjText[liobj], 2025, True);

               iGArcID := liarcid;
               iGDocID := lidocid;
               exit;
            end;
         end;
      end;
      frm_MainForm.NewHistory(12, '[' +
         img_DocView.ObjText[liobj] + '] ' + _('zum Volltext hinzugefgt.'));
   end;

   iGArcID := liarcid;
   iGDocID := lidocid;

   if fdoubleklicked then
   begin
      fdoubleklicked := false;
      //tim_doubleclick.enabled := true;
   end;
   img_DocView.update;
end;

procedure Tfrm_Voransicht.img_DocViewActivateTextEdit(Sender: TObject);
var
   lbmod: boolean;
begin
//////////////////// 14.06.2011 b.takacs 3.5.1.22 -->

   if img_DocView.ObjTextEditMode < 0 then
   begin
      img_DocView.CancelInteracts;
      exit;
   end;
   lbmod := false;
   if img_DocView.ObjUserDataLength[img_DocView.ObjTextEditMode] > 0 then
   begin
      if (SGUsrname = PAnnoData(img_DocView.ObjUserData[img_DocView.ObjTextEditMode])^.ersteller) or (rGDocRight.AModify) then
      begin
         lbmod := true;
      end;
   end;
   if lbmod then
   begin


      frm_mainform.fgchangedvoransicht:= true;
      //frm_MainForm.btn_SaveDoc.Enabled := True;
 	//05.07.2011 b.takacs 3.5.1.26 [3107]     img_DocView.PopupMenu := nil;

   end
   else
   begin
      img_DocView.CancelInteracts;
   end;
	//////////////////// 14.06.2011 b.takacs 3.5.1.22 <--

end;


procedure Tfrm_Voransicht.img_DocViewSelectObject(Sender: TObject);
begin
   outputdebugstring('img_DocViewSelectObject');
end;

procedure Tfrm_Voransicht.img_DocViewUserDeselectObject(Sender: TObject; hobj: Integer);
begin
   outputdebugstring('img_DocViewUserDeselectObject');
end;

procedure Tfrm_Voransicht.img_DocViewUserSelectObject(Sender: TObject; hobj: Integer);
begin
   outputdebugstring('img_DocViewUserSelectObject');
   gbAnnoNotAccessible := False;
   if img_docview.ObjUserData[hobj] <> nil then
   begin
      if (sGUsrName <> PAnnoData(img_docview.ObjUserData[hobj])^.ersteller) and (not rGDocRight.AModify) then
      begin
         img_DocView.UnSelAllObjects;
         gbAnnoNotAccessible := True;
      end;
   end;
end;



procedure Tfrm_Voransicht.createannodata(fidx: integer);
var

   mydata: PAnnoData;
   lstmp: string;
begin
   getmem(mydata, sizeof(TAnnoData));

   mydata^.Ersteller := sGUsrName;
   mydata^.Veraenderer := '';
   DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
   mydata^.Datum := lstmp;
   mydata^.version := '0.1';
   img_docview.ObjUserDataLength[fidx] := sizeof(TAnnoData);
   img_docview.ObjUserData[fidx] := mydata;
end;

procedure Tfrm_Voransicht.saveannodata(fidx: integer);
var
   mydata: PAnnoData;
   lstmp: string;
   liudl: integer;
begin
   liudl := img_docview.ObjUserDataLength[fidx];
   if liudl = 0 then
   begin
      createannodata(fidx);
   end
   else
   begin
      mydata := img_docview.ObjUserData[fidx];
      mydata^.Veraenderer := mydata^.Veraenderer + ',' + sGUsrName;
      DateTimeToString(lstmp, 'dd.mm.yyyy hh:nn:ss', now);
      mydata^.Datum := lstmp;
   end;
end;

procedure Tfrm_Voransicht.img_DocViewMouseLeave(Sender: TObject);
var
   lwcparent: twincontrol;
   lhforw: HWND;
begin
   fbmouseinim := false;
   try
      if fsinfo <> '' then
         frm_MainForm.setpanelinfo(fsinfo);

      if (fmysavedcontrol <> nil) and (img_DocView.ObjTextEditMode < 0) then
      begin
         if fmysavedcontrol.visible and fmysavedcontrol.enabled
         then
         begin
            lwcparent := fmysavedcontrol.Parent;
            if lwcparent <> nil then
            begin
               while lwcparent.Parent <> nil do
               begin
                  lwcparent := lwcparent.Parent;
               end;
               lhforw := GetForegroundWindow;
               if lhforw = lwcparent.Handle then
               begin
                  fmysavedcontrol.SetFocus;
               end;
            end;
         end;
      end;
      img_DocView.Cursor := 0;
   except on e: exception do
      begin
      end;
   end;
end;

procedure Tfrm_Voransicht.saveObjects(fsetinteracts, fsetintervtback: boolean);
var
   sIEVFile, sDocPath, sExtFile, sTmpPath, lsIArcName, lssql: string;
   liarcno, liarcid, lidocid: integer;
   liRecNo: integer;
begin
   GgfLogEvntBeg ('Tfrm_Voransicht.saveObjects Begin');

   if fsavingobjs then
   	Exit;

   if dm_DB.my_q_Arc.Recordcount = 0 then
   	Exit;   

   lidocid := 0;
   liarcid := 0;
   try
      fsavingobjs := true;
      img_DocView.DeSelect;
      img_DocView.UnSelAllObjects;
      if sIArcName = '' then
      begin
         if frm_mainform.TMPSQL('select * from sys_arc where arc_id= ' +
            IntToStr(iGArcID)) then
         begin
            sIarcName := dm_db.my_q_tmp.FieldByName('arc_TblName').AsString;
            sGarcName := dm_db.my_q_tmp.FieldByName('arc_name').AsString;
         end
         else
         begin
            logevnt(
               _('Der Archiv-Lagerort konnte nicht ermittelt werden. Voransicht-speichern'));
            sIArcName := lsIArcName;
            exit;
         end;
      end;
      lsIArcName := sIArcName;
      if (img_DocView.MouseInteractVt <> [miObjectSelect]) and
         (img_DocView.MouseInteractVt <> []) and fsetintervtback then
         img_DocView.MouseInteractVt := [];
      // dont repaint maybe it is causing problems when textediting and zooming
      //  img_docview.repaint;

      if (rGDocRight.modify or rGDocRight.Write) and (frm_mainform.fgchangedvoransicht or gbAnnoNotSaved) then
      begin
         try
            sDocPath := sgdocfilename;
            sExtFile := sgextfilename;

            if sExtFile <> '' then
            begin
              sDocPath := sExtFile;
              sTmpPath := StringReplace(sDocPath, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);
            end
            else
            begin
               sTmpPath := StringReplace(sDocPath, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);
               if not DirectoryExists(ExtractFilePath(sTmpPath)) then
                 	CreateDir(ExtractFilePath(sTmpPath));
               try
                 	CopyFile(PChar(sDocPath), PChar(sTmpPath), False);
               except
                  on e: Exception do
                     LogEvnt(_('Fehler beim Umkopieren nach Ext_Loc: ') + sTmpPath);
               end;

               if bMultiArcQuery then
               begin
                  sIArcName := '';
               end;
               if sIArcName = '' then
               begin
                  if frm_mainform.TMPSQL('select * from sys_arc where arc_id= ' +
                     IntToStr(iGArcID)) then
                  begin
                     sIarcName := dm_db.my_q_tmp.FieldByName('arc_TblName').AsString;
                     sGarcName := dm_db.my_q_tmp.FieldByName('arc_name').AsString;
                  end
                  else
                  begin
                     logevnt(
                        _('Der Archiv-Lagerort konnte nicht ermittelt werden. Voransicht-speichern'));
                     sIArcName := lsIArcName;
                     exit;
                  end;
               end;

               dm_DB.my_cmd.SQL.Text :=
                  'Update arc_' + sIArcName + ' set ext_loc = :TmpPath ' +
                  'where doc_id = :DocID';
               dm_DB.my_cmd.ParamByName('TmpPath').AsString := sTmpPath;
               dm_DB.my_cmd.ParamByName('DocID').AsInteger := iGDocID;
               dm_DB.my_cmd.execute;

               dm_DB.my_q_tmp.SQL.Text := 'select arc_id, doc_id, arc_tblname from sys_gdocid left join sys_Arc ' +
                  'using(arc_id) where gdoc_id = ' + inttostr(giglobalgdocid);

               try
                  dm_DB.my_q_tmp.Execute;
               except on e: exception do
                  begin
                  end;
               end;

               dm_DB.my_cmd.SQL.Text := 'Update arc_' + dm_DB.my_q_tmp.FieldByName('arc_tblname').AsString +
                  ' set ext_loc = :TmpPath ' +
                  'where doc_id = :DocID';
               dm_DB.my_cmd.ParamByName('TmpPath').AsString := sTmpPath;
               dm_DB.my_cmd.ParamByName('DocID').AsInteger := dm_DB.my_q_tmp.FieldByName('doc_id').asinteger;
               lssql := dm_DB.my_cmd.SQL.Text;
               try
                  dm_DB.my_cmd.Execute;
               except
                  on e: Exception do
                  begin
                     ErrorMsg('frm_voransicht.saveobjects', _('Fehler beim update der ext_loc: ') +
                        e.Message + ' . sqltext: ' + lssql, 2025, True);
                     exit;
                  end;
               end;

               sgextfilename := sTmpPath;
            end;
            if frm_Mainform.tbx_pubNote.Checked = True then
            begin
               sIEVFile :=
                  ChangeFileExt(sTmpPath, '') +
                  IntToStr(img_DocView.IO.Params.TIFF_ImageIndex) + '.IEV';
            end
            else
            if frm_Mainform.tbx_privNote.Checked = True then
            begin
               sIEVFile :=
                  ChangeFileExt(sTmpPath, '') +
                  IntToStr(img_DocView.IO.Params.TIFF_ImageIndex) + 'P' +
                  IntToStr(iGPrivAnnoID) + '.IEV';
            end
            else
            begin
               sIEVFile := ChangeFileExt(sTmpPath, '') +
                  IntToStr(img_DocView.IO.Params.TIFF_ImageIndex) + '.IEV';
            end;
            try
               if not DirectoryExists(ExtractFilePath(sTmpPath)) then
                  CreateDir(ExtractFilePath(sTmpPath));
               // what does the next line do?
               if (img_DocView.ObjectsCount > 0) then
                  img_DocView.SaveToFileIEV(sIEVFile)
               else
               begin
                  DeleteFile(sIEVFile);
                  if frm_Mainform.tbx_pubNote.Checked = True then
                     frm_Mainform.tbx_pubNote.ImageIndex := 110;
                  if frm_Mainform.tbx_privNote.Checked = True then
                      frm_Mainform.tbx_privNote.ImageIndex := 109;
               end;

               liRecNo := dm_db.my_q_arc.recno;
               dm_db.my_q_arc.recno := iGArcRecNo;

               try
                  dm_db.my_q_Arc.RefreshRecord;
               except on e: exception
                     do
                  begin
                  end;
               end;
               dm_db.my_q_arc.recno := liRecNo;

               if FileExists(sTmpPath) then
               begin
                  if frm_mainform.fgchangedvoransichttif then
                  begin
                     //ioTiff is buggy, this delete the first page for some docs.
                     (*
                     if img_DocView.IO.Params.FileType = ioTIFF then
                     begin
                        //            fra_Voransicht.img_DocView.IO.SaveToFile(sTmpPath);
                        img_DocView.IO.ReplaceFileTIFF(sTmpPath);
                     end
                     else
                        img_DocView.IO.SaveToFile(sTmpPath);
                     *)
                     IoSaveGraphic(img_DocView.IO,sTmpPath);
                  end;
                  dm_db.my_q_Arc.RefreshRecord;
               end
               else
               begin
                  // file doesnt exists so copy it!
                  CopyFile(PChar(sDocPath), PChar(sTmpPath), False);
                  if frm_mainform.fgchangedvoransichttif then
                  begin
                     try
                        (*
                        if img_DocView.IO.Params.FileType = ioTIFF then
                        begin
                           img_DocView.IO.ReplaceFileTIFF(sTmpPath);
                        end
                        else
                           img_DocView.IO.SaveToFile(sTmpPath);
                        *)
                        IoSaveGraphic(img_DocView.IO,sTmpPath);
                     except on e: exception do
                        begin
                           logevnt('error saving save ' + e.message);
                        end;
                     end;
                  end;
               end;
               // update the entries

               if bMultiArcQuery then
               begin
                  sIArcName := '';
               end;
               if sIArcName = '' then
               begin
                  if frm_mainform.TMPSQL('select * from sys_arc where arc_id= ' +
                     IntToStr(iGArcID)) then
                  begin
                     sIarcName := dm_db.my_q_tmp.FieldByName('arc_TblName').AsString;
                     sGarcName := dm_db.my_q_tmp.FieldByName('arc_name').AsString;
                  end
                  else
                  begin
                     logevnt(
                        _('Der Archiv-Lagerort konnte nicht ermittelt werden. Voransicht-speichern'));
                     sIArcName := lsIArcName;
                     exit;
                  end;
               end;
              if sExtFile = '' then
              begin
               dm_DB.my_cmd.SQL.Text :=
                  'Update arc_' + sIArcName + ' set ext_loc = :TmpPath ' +
                  'where doc_id = :DocID';
               dm_DB.my_cmd.ParamByName('TmpPath').AsString := sTmpPath;
               dm_DB.my_cmd.ParamByName('DocID').AsInteger := iGDocID;
               dm_DB.my_cmd.Execute;
              end;

               sgextfilename := sTmpPath;
               dm_db.my_q_Arc.RefreshRecord;
               if bMultiArcQuery then
               begin
                  liarcno := dm_DB.my_q_Arc.RecNo;
                  dm_DB.my_q_Arc.RecNo := iGArcRecNo;
                  dm_DB.my_q_Arc.Edit;
                  dm_DB.my_q_Arc.FieldByName('ext_loc').AsString := sTmpPath;
                  dm_DB.my_q_Arc.Post;
                  dm_DB.my_q_Arc.RecNo := liarcno;
               end;
               dm_DB.my_q_Arc.Refreshrecord;
            except
               on e: Exception do
               begin
                  LogEvnt('9000    Allgemeiner Anwendungsfehler in voransicht beim speichern:    '
                     + e.Message);
                  sIArcName := lsIArcName;
               end;
            end;

            liarcid := iGArcID;
            lidocid := iGDocID;
            iGArcID := gihardlarcid;
            iGDocID := gihardldocid;

            if fphistorymessage <> '' then
            begin
               frm_MainForm.NewHistory(9, fphistorymessage + ' ' + _('am Dokument gespeichert.'));
            end;
            dm_db.my_q_Arc.RefreshRecord;

            iGArcID := liarcid;
            iGDocID := lidocid;

         finally
            begin
               frm_mainform.fgchangedvoransicht := false;
               frm_mainform.fgchangedvoransichttif := false;
            end;
         end;
      end
      else
      begin
         if (frm_mainform.fgchangedvoransicht) then
            BfShowMessage(_('Hinweis!') + #13 + _('Sie drfen dieses Dokument nicht speichern'));
      end;

      if fsetinteracts then
      begin
         if (img_DocView.MouseInteractVt <> [miObjectSelect]) and
            (img_DocView.MouseInteractVt <> []) then
             img_DocView.MouseInteractVt := [];
         img_DocView.MouseInteract := [miScroll];
      end;
      sIArcName := lsIArcName;
   finally
      fsavingobjs := false;
      gbAnnoNotSaved:= false;
      GgfLogEvntEnd ('Tfrm_Voransicht.saveObjects End via finally');
   end;
end;

procedure Tfrm_Voransicht.FrameResize(Sender: TObject);
begin
   frm_mainform.cbx_VZoom.text := frm_mainform.cbx_VZoom.text;
end;

procedure Tfrm_Voransicht.tim_doubleclickTimer(Sender: TObject);
begin
   tim_doubleclick.enabled := false;
   img_DocViewDblClick(self);
end;


procedure Tfrm_Voransicht.img_DocViewMouseEnter(Sender: TObject);
begin
   if img_DocView.MouseInteractVt <> [] then
   begin
      img_DocView.Cursor := 1785;
   end;
   fbmouseinim := true;
   fmysavedcontrol := nil;
end;

procedure Tfrm_Voransicht.img_DocViewTextKeyDown(Sender: TObject;
   var Key: Word; Shift: TShiftState);
begin
   //
end;

procedure Tfrm_Voransicht.img_DocViewObjectMoveResize(Sender: TObject;
   hobj, Grip: Integer; var OffsetX, OffsetY: Integer);
var
   mydata: PAnnoData;
   A, B: TPolygon;
   i, j, liudl: integer;
   MTD: TVector2f;
   lbhcol: Boolean;
begin
   lbhcol := false;
   try
      frm_mainform.fra_Volltext.removeocrhits;
      fobjdel := False;
      img_DocView.ObjEditOnNewText := false;
      B := nil;
      A := nil;
      if (img_DocView.ObjKind[hobj] <> iekLINE) and
         (img_DocView.ObjBrushStyle[hobj] <> bsClear) and
         (not rgdocRight.suanno) and (img_DocView.ObjectsCount > 1)
      then
      begin
         try
            A := TPolygon.Create;
            with A do
            begin
               position := to_v2f(img_DocView.ObjLeft[hobj], img_DocView.ObjTop[hobj]);
               AddVertex(to_v2f(0, 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], 0));
               AddVertex(to_v2f(img_DocView.ObjWidth[hobj], img_DocView.ObjHeight[hobj]));
               AddVertex(to_v2f(0, img_DocView.ObjHeight[hobj]));
            end;
            i := 0;
            j := 0;
            while i < img_DocView.ObjectsCount do
            begin
               if i = hobj then
               begin
                  i := i + 1;
                  continue;
               end;
               B := TPolygon.Create;
               with B do
               begin
                  position := to_v2f(img_DocView.ObjLeft[i], img_DocView.ObjTop[i]);
                  AddVertex(to_v2f(0, 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[i], 0));
                  AddVertex(to_v2f(img_DocView.ObjWidth[i], img_DocView.ObjHeight[i]));
                  AddVertex(to_v2f(0, img_DocView.ObjHeight[i]));
               end;
               i := i + 1;
               if PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) then
               begin
                  lbhcol := true;
                  while PolyPolyIntersect(a, b, MTD) and ((MTD.x <> 0) or (MTD.y <> 0)) do
                  begin
                     if (MTD.x = 0) and (MTD.y = 0) then
                     begin
                        MTD.x := -1;
                        MTD.y := -1;
                     end
                     else
                     begin
                        MTD := v2f_Scale(MTD, (1.05));
                     end;
                     a.position := v2f_add(a.position, MTD);
                  end;

                  img_DocView.ObjLeft[hobj] := trunc(a.position.x);
                  //  img_docedit.ObjLeft[hobj] ;// - (offsetX + 10 * sign(offsetX));
                  img_DocView.ObjTop[hobj] := trunc(a.position.y);
                  if (MTD.x = 0) and (MTD.y = 0) then
                  begin
                     lbhcol := false;
                  end;

                  img_DocView.MouseInteractVt := [miObjectSelect];
               end;
               if lbhcol then
               begin
                  i := 0;
                  j := j + 1;
                  if j > 50 then
                  begin
                     break;
                  end;
                  lbhcol := false;
               end;
               if assigned(b) then
                  FreeAndNil(b);
            end;
            if lbhcol then
            begin
               img_DocView.ObjLeft[hobj] := fobjposition[hobj].X;
               img_DocView.ObjTop[hobj] := fobjposition[hobj].Y;

               BfShowMessage(_('Platzieren Sie bitte die Notiz auf eine freie Stelle!'));
               exit;
            end;
         finally
            begin
               if assigned(a) then
                  FreeAndNil(a);
               if assigned(b) then
                  FreeAndNil(b);
            end;
         end;
      end;
      mydata := img_DocView.ObjUserData[hobj];
      liudl := img_DocView.ObjUserDataLength[hobj];
      if ((liudl > 0) and (mydata <> nil) and (mydata^.ersteller <> '')) then
      begin
      end;
      //if text or memo ondeactivate will be called, save there.

      //save it directly is not possible...
      //todo: find a way around
      //  saveobjects(false, false);
      frm_mainform.btn_SaveDoc.enabled := true;
      GHasNotBeenSavedAfterModify := true;

      frm_mainform.fgchangedvoransicht := true;

      img_DocView.ObjGraphicRender := False;
      img_DocView.EnableAlphaChannel := False;
      if length(fobjposition) <= hobj then
      begin
         setlength(fobjposition, hobj + 1);
      end;
      fobjposition[hobj].X := img_DocView.ObjLeft[hobj];
      fobjposition[hobj].y := img_DocView.ObjTop[hobj];
   except on e: exception do
      begin
         logevnt('Error in   frm_Voransicht.img_DocViewObjectMoveResize ' + e.message);
      end;
   end;

end;

procedure Tfrm_Voransicht.updateobjects;
var
	i, liobjcount: integer;
begin
   liobjcount := img_docview.objectscount;
   setlength(fobjposition, liobjcount);
   setlength(fobjdimension, liobjcount);

   i := 0;
   while i < liobjcount do
   begin
      fobjposition[i].X := img_DocView.ObjLeft[i];
      fobjposition[i].Y := img_DocView.ObjTop[i];
      fobjdimension[i].X := img_DocView.Objwidth[i];
      fobjdimension[i].Y := img_DocView.Objheight[i];
      inc(i);
   end;
end;

procedure Tfrm_Voransicht.img_DocViewKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
   GgfLogEvnt('u_Voransicht img_DocViewKeyUp Begin Key(word): ' + IntToStr(Key));
   case key of
      vk_delete:	AnDelClick(self);
   end;
end;

end.

