program createnewjobfile;

{$APPTYPE CONSOLE}


uses
  u_Functions in 'u_Functions.pas',
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  strUtils,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule},
  u_ShBase in '..\Shared\u_ShBase.pas',
  U_getmac_iphlpapi in '..\Shared\u_getmac_iphlpapi.pas';

{$R *.res}

Var
 con: TIniFile;
 sProfil, sUser, sPass, strArcid, strDocid, strPfad, strProfil: String;
 tblname,  arcname,  strvolltext, stromp,strdatum: String;
 strsvn_info,strstatus,strstatstr : String;
 strparam, queue,sFilename: string;
 modus: string;
 lstTmp, lstArcid, lstDocid, lstFilelist:TStringList;
 bDeleteList: Boolean;

 mydatum:TDatetime;
 i,j, pos1, pos2: Integer;

 zusfeld_name:Tstringlist;
 zusdisp_name:Tstringlist;
 zusfeld_wert:Tstringlist;
 strLink:TStringlist;

Function  AnsiToConCP(Const AString: String): String;
Var
  lResult: String;
Begin
  SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
  CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
  {$ELSE}
  AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
  Result := lResult;
End;

Function WriteCmd(strtext: String):STring ;
  begin
  strtext:= AnsiToConCP(strtext);
  WriteLN(strtext);
End;


function ConnectDB: boolean;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := ReadString('Connection', 'User', '');
          sPass := ReadString('Connection', 'Pass', '');
          with dm_sep.my_Con do
          begin
            Username := Decrypt(sUser, GlobalKey);
            Password := Decrypt(sPass, GlobalKey);
            Server   := ReadString('Connection', 'Server', '');
            Port     := ReadInteger('Connection', 'Port', 3306);
            Database := ReadString('Connection', 'DB', '');
            WriteLn('Connection to Server ' + Server + ' with DB ' + Database);
            Connect; // Anmelden an der Datenbank
            if not Connected then // Wenn keine Verbindung dann Tool verlassen
            begin
              ExitCode := 2;
              WriteLn('Fehler: Keine Verbindung zur Datenbank!');
              Result := False;
              exit;
            end;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteLn('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;


function WriteJobFile: Boolean;
var ini: TIniFile;
    iCount,   litimeroptionen: Integer;
    sWert: String;
    //comp: TComponent;
begin


  try
    if FileExists(strPfad + '.job') then
            DeleteFile(PChar(strPfad + '.job'));
    ini := TIniFile.Create(strPfad + '.job');
    // ini := TIniFile.Create('c:\' + sGDocName + '.JOB');

    try
      with ini do
      begin
        WriteString('Version', 'Version', '3.0');
        WriteString('Archiv', 'Profil', strProfil);
        WriteString('Archiv', 'Name', arcname);
        WriteString('Archiv', 'Tabelle', tblname);
        WriteString('Document', 'DOCID', strArcid + '.' + strDocid);
        if dm_sep.my_q.FieldDefList.Find('gdoc_id')<> NIL then
        begin
           WriteString('Document', 'gdoc_id', dm_sep.my_q.fieldbyname('gdoc_id').asstring);
        end ;
        WriteString('Document', 'Titel', dm_sep.my_q.fieldbyname('DISP_Name').asstring);
        WriteString('Document', 'Orginal', dm_sep.my_q.fieldbyname('DOC_LOC').asstring);
        WriteString('Document', 'Kopie', dm_sep.my_q.fieldbyname('EXT_LOC').asstring);
        WriteString('Document', 'Quelle', dm_sep.my_q.fieldbyname('ORI_LOC').asstring);
        WriteString('Document', 'Benutzer', dm_sep.my_q.fieldbyname('USR_NAME').asstring);
        WriteString('Document', 'Volltext', strvolltext);
        if strstatus = '' then
          WriteString('Document', 'Status', dm_sep.my_q.fieldbyname('DOC_STATE').asstring)
        else
           WriteString('Document', 'Status', strstatus);

        WriteString('Document', 'StatStr', strstatstr);
        WriteString('Document', 'OCR_QF', dm_sep.my_q.fieldbyname('OCR_QF').asstring);
        WriteString('Document', 'OCR_Typ', stromp);
        WriteString('Document', 'Schlagworte', '');
        //strdatum:=  dm_sep.my_q.fieldbyname('TStamp').asstring;
        mydatum:= dm_sep.my_q.fieldbyname('TStamp').asDateTime;
        strdatum:=FormatDateTime('yyyy-mm-dd hh:mm:ss',mydatum);
        WriteString('Document', 'Datum',strdatum );
        sWert := '';
//        if chbx_ACol.Checked then sWert := sWert + 'Color';
//        if chbx_AHigh.Checked then sWert := sWert + 'Highres';
        WriteString('Document', 'Filter', '');
        {
        if Trim(edt_iRef.Text) <> '' then
        begin
          WriteString('Referenz', 'Anzahl', '1');
          WriteString('Referenz', 'Referenz1', Trim(edt_iRef.Text));
        end else WriteString('Referenz', 'Anzahl', '0');
        }


             {
        if Length(Trim(jedt_Ref.Text)) <> 0 then
        begin
          WriteString('Referenz', 'Anzahl', '1');
          WriteString('Referenz', 'Referenz1', jedt_Ref.Text);
        end else WriteString('Referenz', 'Anzahl', '0');


        if cb_Referenz.Items.Count <>0 then
        begin
           WriteString('Referenz', 'Anzahl', inttostr(cb_Referenz.Items.Count) );
           for jCount := 0 to cb_Referenz.Items.Count-1 do
           begin
              WriteString('Referenz', 'Referenz'+inttostr(jCount+1), cb_Referenz.Items[jcount]);
           end;
        end  else WriteString('Referenz', 'Anzahl', '0');
        }

        WriteString('Document','Pages','');

        WriteString('Referenz', 'Anzahl', IntToStr(strLink.Count));

        //WriteString('Referenz', 'Referenz' + IntToStr(strLink.Count)  , IntToStr(zusfeld_name.Count));

         for iCount := 0  to strLink.Count -1 do

          begin

          WriteString('Referenz', 'Referenz' + IntToStr(iCount + 1), strLink[iCount]);

        end;


        {
        if sUsr <> '' then
        begin
             WriteString('Tasks', 'Termin', DateToStr (date));
             WriteString('Tasks', 'Alarm', DateToStr (jde_erinnerung.Date));



             //WriteString('Tasks', 'Bearbeiter', sBearbeiter);
             //Uebernahme aus der Mehrfachauswahl
             WriteString('Tasks', 'Bearbeiter', sUsr);
        end
        else
        begin
             WriteString('Tasks', 'Termin', '');
             WriteString('Tasks', 'Alarm', '');



             //WriteString('Tasks', 'Bearbeiter', sBearbeiter);
             //Uebernahme aus der Mehrfachauswahl
             WriteString('Tasks', 'Bearbeiter', sUsr);

        end;
        //
        // Zeilenweise Ausgabe der benutzer
        {
        for icount := 0 to lb_usr.Count do
        begin

        end ;
        }


         WriteString('SVN', 'SVN_Link', '');
         WriteString('SVN', 'SVN_Version', '');
         WriteString('SVN', 'SVN_Revision', '');
         WriteString('SVN', 'SVN_Datum', '');
         WriteString('SVN', 'SVN_Info', strsvn_info);

         WriteString('Tasks', 'Termin', '');
         WriteString('Tasks', 'Alarm', '');
         WriteString('Tasks', 'Bearbeiter', '');


        {
        if (edt_info.text = '') then
        begin
             WriteString('Tasks', 'Notiz', cbx_Arc.Text);
        end
        else
        begin
             WriteString('Tasks', 'Notiz', trim (edt_info.text));
        end;
         }

         WriteString('Tasks', 'Notiz', '');

         WriteString('Zusatzfelder', 'Felder' , IntToStr(zusfeld_name.Count));

         for iCount := 0  to zusfeld_name.Count -1 do

          begin

          WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(iCount + 1), zusdisp_name[iCount]);
          WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(iCount + 1), zusfeld_name[iCount]);
          WriteString('Zusatzfelder', 'ZusWert' + IntToStr(iCount + 1), zusfeld_wert[iCount]);
        end;
      end;
    except
      //on e: exception do ErrorMsg('btn_CreJob', 'Fehler beim Erstellen der Vorlagen Datei: ' + e.Message, 2023, True);
    end;
  finally


    if Assigned(ini) then
    begin
         ini.UpdateFile;
         FreeAndNil(ini);
    end;
  end;
end;





begin
  { TODO -oUser -cConsole Main : Hier Code einfgen }

  WriteLn('bitfarm Archiv V3  -  Datenbank createnewjobfile Tool');
  WriteLn('(c) 2004-2010 bitfarm Informationssysteme GmbH');

  for i := 1 to paramcount do
     strparam:= strparam + Paramstr(i) + ' ';

  WriteCmd('bergebene Parameter:'+strparam);

  if (ParamCount < 2) OR (paramstr(1)='-h') then
  begin
    ExitCode := 1;



    WriteLN('createnewjobfile: Tool zur Erstellung einer Job-Datei mit den');
    WriteLN('aktuellen Inhalten aus der Datenbank');
    WriteLN('Parameter: createnewjobfile <Profil><Arc_ID><Doc_ID><Pfad>{Bezeichner}');
    WriteLN('     oder  createnewjobfile <Profil><-f:Datei|-rs|-nrs>{-del}');

    WriteLN('-h  diese Hilfe');
    WriteLN('Profil: Name des Profils');
    WriteLN('Arc_ID: Eindeutige ArchivID');
    WriteLN('Doc_ID: Eindeutige Doc_ID');
    WriteCMD('Pfad: Basis-Pfad der neuen Job-Datei (Endung .job wird angehngt)');
    WriteCMD('Bezeichner: Es besteht die Mglichkeit verschiedene Werte in der ');
    WriteLN('Job-Datei per Parameter setzen zu lassen. Dazu gibt man mit Minuszeichen');
    WriteLN('den Bezeichner an und nach einem : den Wert.');
    WriteCMD('Untersttzt werden derzeit folgende Bezeichner:');

    WriteCMD('-OCR_Typ: (OMP/OCR/MAN/TXT)(OMP ist default)');
    WriteCMD('-SVN_Info: Infozeile fr das SVN-Log');
    WriteCMD('-Status:   Integerwert zum setzen der Statusbutton');
    WriteCMD('-StatStr:  Eintrag fr die History');
    WriteCMD('oder:');
    WriteCMD('-f:Datei  Textdatei mit einer Liste von Dokumenten '+#39+'Docid:<docid>'+#39);
    WriteCmd('die Jobdateien werden mit gleichen Basisnamen im Dokumentenpfad gespeichert');
    WriteCMD('-rs       Das komplette revisionsichere Verzeichnis wird aktualisiert');
    WriteCMD('-nrs      Das komplette nichtrevisionsichere Verzeichnis wird aktualisiert');
    WriteCmd('-del      Die Textdatei wird nach Verarbeitung gelscht');
     if paramstr(1)<>'-h' then
    begin


        WriteLn('Fehler: Nicht genuegend Parameter angegeben!');
        WriteLn('Aufrufen mit: createnewjobfile <Profil><Arc_ID><Doc_ID><Pfad>{Bezeichner}');
    end;
    exit;
  end;

  modus:='standard';
  strProfil:= Paramstr(1);
  strArcid:=Paramstr(2);
  if paramcount >= 3 then
    strDocid:=Paramstr(3);
  if paramcount >= 4 then
    strPfad:=Paramstr(4);

  if leftstr(strArcid,3) = '-f:' then
  begin
    modus:='filelist';
    sFilename:=rightstr(strArcid,Length(strarcid)-3);
  end;

  if LeftStr(strArcid,3) = '-rs' then
    modus:='rs';
  if LeftStr(strArcid,4) = '-nrs' then
    modus:='nrs';

  if LeftStr(strDocid,4) = '-del' then
    bDeleteList:= True;

  stromp:='OMP';
  strsvn_info:='';
  strstatus:='';
  strstatstr:='';

  if paramCount > 4 then
  begin
    for i:=5 to ParamCount do
    begin

      if Pos('-ocr_typ:', LowerCase(Paramstr(i))) > 0 then
        stromp:=Copy(paramstr(i),10,Length(paramstr(i))-9);

      if Pos('-svn_info:', LowerCase(Paramstr(i))) > 0 then
        strsvn_info:=Copy(paramstr(i),11,Length(paramstr(i))-10);

      if Pos('-status:', LowerCase(Paramstr(i))) > 0 then
        strstatus:=Copy(paramstr(i),9,Length(paramstr(i))-8);

      if Pos('-statstr:', LowerCase(Paramstr(i))) > 0 then
        strstatstr:=Copy(paramstr(i),10,Length(paramstr(i))-9);
    end;
  end;

  // Initalisieren der Objekte

  sProfil:=ExtractFilePath(Paramstr(0))+Paramstr(1)+'.con';
  queue:=  ExtractFilePath(Paramstr(0))+'queue\';
  if not FileExists(sProfil) then
  begin
    ExitCode := 5;
    WriteCmd('Fehler: Kann condatei <' + ParamStr(2) + '> nicht finden.');
    exit;
  end;

  try

   dm_sep:=tdm_sep.Create(nil);
   connectDB;
  except
    on e:exception do
    begin
      WriteCmd('Fehler bei der Verbindung zur Datenbank' + e.Message);
      ExitCode:=1;
      Exit;

    end;
  end;

  //je nach modus schleife aufbauen

  lstArcid:=TstringList.create;
  lstDocid:=TStringList.Create;
  lstFilelist:=TStringList.Create;
  lstTmp:=TStringList.Create;
   if modus = 'standard' then
   begin

      lstArcid.Add(strArcid);
      lstDocid.Add(strDocid);

   end;

   if modus = 'filelist' then
   begin
       lstTmp.LoadFromFile(sFilename);
       for i:=0 to lstTmp.Count-1 do
       begin
          if Pos('docid:',LowerCase(lstTmp.Strings[i]))> 0 then
          begin
             pos1:=0;
             pos2:=0;
             pos1:=Pos('.',lstTmp.Strings[i]);
             pos2:= Length( lstTmp.Strings[i]);
             lstArcid.Add(Copy(lstTmp.Strings[i],7,pos1-7));
             lstDocid.Add(Copy(lstTmp.Strings[i],pos1+1,pos2-pos1));

          end;
       end;
   end;

    if modus = 'rs' then
    begin
       WriteCmd('Wird momentan nicht untersttzt');
       ExitCode:=2;
       Exit;
    end;

    if modus = 'nrs' then
    begin
       WriteCmd('Wird momentan nicht untersttzt');
       ExitCode:=2;
       Exit;
    end;

   // hier die schleife

   zusfeld_name:=Tstringlist.Create;
   zusdisp_name:=Tstringlist.Create;
   zusfeld_wert:=Tstringlist.Create;
   strLink:=TStringlist.Create;

  if lstArcid.Count > 0 then
  begin
    for j:= 0 to  lstArcid.Count -1 do
    begin

      strArcid:=lstArcid.Strings[j];
      strDocid:=lstDocid.Strings[j];

      try
        dm_sep.my_q.SQL.text:='select * from sys_arc where arc_id ='+strArcid;
        dm_sep.my_q.Execute;
        while not dm_sep.my_q.Eof do
        begin
               tblname:= dm_sep.my_q.fieldbyname('Arc_TBLName').asstring;
               writeCmd(' Arc_TBLName :'+dm_sep.my_q.fieldbyname('Arc_TBLName').asstring);
               arcname:= dm_sep.my_q.fieldbyname('Arc_Name').asstring;
               writeCmd(' Arc_Name :'+dm_sep.my_q.fieldbyname('Arc_Name').asstring);

               dm_sep.my_q.Next;
        end;
      except
        WriteCmd('Fehler(1) bei Dokument '+strArcid+'.'+strDocid);
        Continue;
      end;

      try
        dm_sep.my_q.SQL.text:='select * from cfg_'+ tblname ;
        dm_sep.my_q.Execute;
        while not dm_sep.my_q.Eof do
        begin
               zusfeld_name.Add( dm_sep.my_q.fieldbyname('Feld_Name').asstring);
               writeCmd(' Feld_Name :'+dm_sep.my_q.fieldbyname('Feld_name').asstring);
               zusdisp_name.Add( dm_sep.my_q.fieldbyname('Disp_Name').asstring);
               writeCmd(' Disp_Name :'+dm_sep.my_q.fieldbyname('Disp_Name').asstring);

               dm_sep.my_q.Next;
        end;
      except
        WriteCmd('Fehler(2) bei Dokument '+strArcid+'.'+strDocid);
        Continue;
      end;

      try
        dm_sep.my_q.SQL.text:='select DISTINCT(REF_NAME) from sys_doclnk Where Arc_id =' + strArcid + ' And Doc_ID=' + strDocid;
        dm_sep.my_q.Execute;

        while not dm_sep.my_q.Eof do
        begin
        strLink.Add( dm_sep.my_q.fieldbyname('REF_NAME').asstring);
               writeCmd(' Referenz :'+dm_sep.my_q.fieldbyname('REF_NAME').asstring);
               dm_sep.my_q.Next;
        end;
      except
        WriteCmd('Fehler(3) bei Dokument '+strArcid+'.'+strDocid);
        Continue;
      end;

      try
        dm_sep.my_q.SQL.text:='select * from arc_'+ tblname +' Where Doc_ID=' + strDocid;
        dm_sep.my_q.Execute;

        for i:=0 to zusfeld_name.count-1  DO
        begin
        zusfeld_wert.Add( dm_sep.my_q.fieldbyname(zusfeld_name[i]).asstring);
               writeCmd(' Zusfeld_Wert :'+dm_sep.my_q.fieldbyname(zusfeld_name[i]).asstring);

        end;
      except
        WriteCmd('Fehler(4) bei Dokument '+strArcid+'.'+strDocid);
        Continue;
      end;

      try
        //strvolltext:=extractfilepath(dm_sep.my_q.fieldbyname('DOC_LOC').asstring) +extractfilename(dm_sep.my_q.fieldbyname('DOC_LOC').asstring )+ '.txt';
        strvolltext:=changefileext(dm_sep.my_q.fieldbyname('DOC_LOC').asstring , '.txt');

        if modus = 'filelist' then
          strPfad:=changefileext(dm_sep.my_q.fieldbyname('DOC_LOC').asstring , '');
        if NOT(fileexists(strvolltext)) then
        begin
         strvolltext:='';
        end;
      except
        WriteCmd('Fehler(4) bei Dokument '+strArcid+'.'+strDocid);
        Continue;
      end;

      WriteJobFile;

      zusfeld_name.Clear;
      zusdisp_name.Clear;
      zusfeld_wert.Clear;
      strLink.Clear;

    end;
  end;

  if Assigned(zusfeld_name) then
        FreeAndNil(zusfeld_name);
  if Assigned(zusdisp_name) then
        FreeAndNil(zusdisp_name);
  if Assigned(zusfeld_wert) then
        FreeAndNil(zusfeld_wert);
  if Assigned(strLink) then
        FreeAndNil(strLink);

  if bDeleteList and (FileExists(sFilename)) then
    DeleteFile(PChar(sFilename));

  WriteCmd('Done...');
  
end.




