unit u_Functions;

interface

uses
  Windows, SysUtils;

function EnCrypt(InputStr, HexKeyStr: String): String;
function DeCrypt(HexInputStr, HexKeyStr: String): String;
function SetSystemVariable(const Name, Wert: String): boolean;
function GetSystemVariable(const Name: String): String;

implementation

function EnCrypt(InputStr, HexKeyStr: String): String;
//////////////////////////////////////////////////////////////////
///  10.04.2005 Erstellt EnCrypt by SV.                        ///
///                                                            ///
///  Diese Funktion erzeugt aus dem InputStr einen mit         ///
///  HexKeyStr verschlsselten HexString (einfaches XOR)       ///
///                                                            ///
///  Format: String aus Hexadezimalzahlen                      ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var iCntIStr, iCntKStr: integer;
begin
  iCntIStr := 1;
  iCntKStr := 1;
  result := '';
  while iCntIStr < (Length(InputStr) + 1) do
  begin
    result := result + IntToHex((ord(InputStr[iCntIStr]) xor StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))), 2);
    inc(iCntIStr, 1);
    inc(iCntKStr, 2);
  end;
end;

function DeCrypt(HexInputStr, HexKeyStr: String): String;
//////////////////////////////////////////////////////////////////
///  10.04.2005 Erstellt DeCrypt by SV.                        ///
///                                                            ///
///  Diese Funktion erzeugt aus dem HexInputStr einen mit      ///
///  HexKeyStr entschlsselten String (einfaches XOR)          ///
///                                                            ///
///  Format: Entschlsselter String                            ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var iCntIStr, iCntKStr: integer;
begin
  iCntIStr := 1;
  iCntKStr := 1;
  result := '';
  while iCntIStr < (Length(HexInputStr) + 1) do
  begin
    result := result + chr((StrToInt('$' + copy(HexInputStr, iCntIStr, 2)) xor StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1), 2))));
    inc(iCntIStr, 2);
    inc(iCntKStr, 2);
  end;
end;

function SetSystemVariable(const Name, Wert: String): boolean;
/////////////////////////////////////////////////////////////
///   Erstellt 06.06.2005 by SV                           ///
///                                                       ///
///   Setzt eine Systemvariable auf einen neuen Wert      ///
///                                                       ///
///   Parameter:  Name          Name der Systemvariable   ///
///               Wert          Wert der Systemvariable   ///
///                                                       ///
///   Rckgabe:   True          bei Erfolg                ///
///               False         bei Fehlschlag            ///
///                                                       ///
/////////////////////////////////////////////////////////////
begin
  result := SetEnvironmentVariable(PChar(Name), PChar(Wert));
end;

function GetSystemVariable(const Name: String): String;
/////////////////////////////////////////////////////////////
///   Erstellt 06.06.2005 by SV                           ///
///                                                       ///
///   Liest eine Systemvariable aus                       ///
///                                                       ///
///   Parameter:  Name          Name der Systemvariable   ///
///                                                       ///
///   Rckgabe:   String mit Wert der Systemvariable      ///
///                                                       ///
/////////////////////////////////////////////////////////////
begin
  SetLength(Result, 255);
  SetLength(Result, GetEnvironmentVariable(PChar(Name), PChar(Result), 255));
end;

end.
