program createnewtemplate;

{$APPTYPE CONSOLE}


uses
  u_Functions in 'u_Functions.pas',
  SysUtils,
  IniFiles,
  Classes,
  Windows,
  u_dm_sep in 'u_dm_sep.pas' {dm_sep: TDataModule},
  u_ShBase in '..\Shared\u_ShBase.pas';

{$R *.res}

Var
   con: TIniFile;
   sProfil, sUser, sPass, strArcid, strPfad, strProfil: String;

   strparam, queue, ext: string;
   i, j: Integer;

   zusfeld_name, tblname, arcname, arcid, lstdoppelte, lstexisting: Tstringlist;
   zusdisp_name: Tstringlist;
   all, ispath: Boolean;

Function AnsiToConCP(Const AString: String): String;
Var
   lResult: String;
Begin
   SetLength(lResult, Length(AString));
  {$IFDEF WIN32}
   CharToOEM(PChar(AString), PChar(lResult)); {32Bit}
  {$ELSE}
   AnsiToOEM(PChar(@AString[1]), PChar(@lResult[1])); {16Bit}
  {$ENDIF}
   Result := lResult;
End;

Function WriteCmd(strtext: String): STring;
begin
   strtext := AnsiToConCP(strtext);
   WriteLN(strtext);
End;

function RightStr
   (Const Str: String; Size: Word): String;
begin
   if Size > Length(Str) then
      Size := Length(Str);
   RightStr := Copy(Str, Length(Str) - Size + 1, Size)
end;

function MidStr
   (Const Str: String; From, Size: Word): String;
begin
   MidStr := Copy(Str, From, Size)
end;

function LeftStr
   (Const Str: String; Size: Word): String;
begin
   LeftStr := Copy(Str, 1, Size)
end;

function ConnectDB: boolean;
begin
   // Auslesen der Connection
   con := TIniFile.Create(sProfil);
   Result := True;
   try
      try
         with con do
         begin
            sUser := ReadString('Connection', 'User', '');
            sPass := ReadString('Connection', 'Pass', '');
            with dm_sep.my_Con do
            begin
               Username := Decrypt(sUser, GlobalKey);
               Password := Decrypt(sPass, GlobalKey);
               Server := ReadString('Connection', 'Server', '');
               Port := ReadInteger('Connection', 'Port', 3306);
               Database := ReadString('Connection', 'DB', '');
               WriteLn('Connection to Server ' + Server + ' with DB ' + Database);
               Connect; // Anmelden an der Datenbank
               if not Connected then // Wenn keine Verbindung dann Tool verlassen
               begin
                  ExitCode := 2;
                  WriteLn('Fehler: Keine Verbindung zur Datenbank!');
                  Result := False;
                  exit;
               end;
            end;
         end;
      except
         on e: Exception do
         begin
            ExitCode := 4;
            WriteLn('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
            Result := False;
            exit;
         end;
      end;
   finally
      if Assigned(con) then
         FreeAndNil(con);
   end;
end;


function WriteJobFile: Boolean;
var ini: TIniFile;
   z, l, iCount: Integer;
   sWert, filename: String;
   //comp: TComponent;
begin
   z := 0;

   if ispath = False then
   begin
      filename := strPfad;

   end
   else
   begin

      for l := 0 to arcname.Count - 1 do
      begin
         if arcname[i] = arcname[l] then
            z := z + 1

      end;

      if z = 1 then
         filename := strPfad + arcname[i]
      else
      begin
         filename := strPfad + arcname[i] + '__' + arcid[i];
         lstdoppelte.Add(extractfilename(filename));
      end;
      // ini:= TIniFile.Create('c:\' + sGDocName + '.JOB');

      if fileexists(filename + ext) then
      begin
         filename := filename + '(2)';
         lstexisting.add(extractfilename(filename) + ext);

      end;

   end;

   filename := filename + ext;

   ini := TIniFile.Create(filename);

   try
      try
         with ini do
         begin
            WriteString('Version', 'Version', '3.0');
            WriteString('Archiv', 'Profil', strProfil);
            WriteString('Archiv', 'Name', arcname[i]);
            WriteString('Archiv', 'Tabelle', tblname[i]);
            WriteString('Document', 'DOCID', '');
            WriteString('Document', 'Titel', '');
            WriteString('Document', 'Orginal', '');
            WriteString('Document', 'Kopie', '');
            WriteString('Document', 'Quelle', '');
            WriteString('Document', 'Benutzer', '');
            WriteString('Document', 'Volltext', '');
            WriteString('Document', 'Status', '');
            WriteString('Document', 'StatStr', '');
            WriteString('Document', 'OCR_QF', '');
            WriteString('Document', 'OCR_Typ', '');
            WriteString('Document', 'Pages', '');
            WriteString('Document', 'gdoc_id', '');
            //        if chbx_ManVtx.Checked and chbx_OCRVtx.Checked then WriteString('Document', 'OCR_Typ', 'TXT');
            //        if not chbx_ManVtx.Checked and chbx_OCRVtx.Checked then WriteString('Document', 'OCR_Typ', '');
            //        if chbx_ManVtx.Checked and not chbx_OCRVtx.Checked then WriteString('Document', 'OCR_Typ', 'MAN');
            //        if not chbx_ManVtx.Checked and not chbx_OCRVtx.Checked then WriteString('Document', 'OCR_Typ', '');
            //        if chbx_OCRVtx.Checked then WriteString('Document', 'OCR_Typ', 'OMP') else WriteString('Document', 'OCR_Typ', 'TXT');
            WriteString('Document', 'Schlagworte', '');
            WriteString('Document', 'Datum', '');
            sWert := '';
            //        if chbx_ACol.Checked then sWert := sWert + 'Color';
            //        if chbx_AHigh.Checked then sWert := sWert + 'Highres';
            WriteString('Document', 'Filter', '');

            WriteString('Referenz', 'Anzahl', '0');


            WriteString('Tasks', 'Termin', '');
            WriteString('Tasks', 'Alarm', '');
            WriteString('Tasks', 'Bearbeiter', '');


            WriteString('Tasks', 'Notiz', '');


            // first bit is reserved to je or efa!

            WriteString('Zusatzfelder', 'Felder', IntToStr(zusfeld_name.Count));

            for iCount := 0 to zusfeld_name.Count - 1 do

            begin

               WriteString('Zusatzfelder', 'ZusTitel' + IntToStr(iCount + 1), zusdisp_name[iCount]);
               WriteString('Zusatzfelder', 'ZusFeld' + IntToStr(iCount + 1), zusfeld_name[iCount]);
               WriteString('Zusatzfelder', 'ZusWert' + IntToStr(iCount + 1), '');
            end;
         end;
      except
         //on e: exception do ErrorMsg('btn_CreJob', 'Fehler beim Erstellen der Vorlagen Datei: ' + e.Message, 2023, True);
      end;
   finally

      if Assigned(ini) then
      begin
         ini.UpdateFile;
         FreeAndNil(ini);
      end;

      WriteCMD(extractfilename(filename) + ' wurde erstellt');

   end;
end;


begin
   { TODO -oUser -cConsole Main : Hier Code einfgen }

   WriteLn('bitfarm Archiv V3  -  Datenbank createnewtemplate Tool');
   WriteLn('(c) 2004-2009 bitfarm Informationssysteme GmbH');

   for I := 1 to paramcount do
      strparam := strparam + Paramstr(i) + ' ';

   WriteCmd('bergebene Parameter:' + strparam);

   if (ParamCount < 3) OR (paramstr(1) = '-h') then
   begin
      ExitCode := 1;
      if paramstr(1) = '-h' then
      begin

         WriteLN('createnewtemplate: Tool zur Erstellung eines leeren Templates');
         WriteLN('Parameter: createnewtemplate <Profil><Arc_ID><Pfad>{-job}');
         WriteLN('Modus: -h  diese Hilfe');
         WriteLN('Profil: Name des Profils');
         WriteLN('Arc_ID: Eindeutige ArchivID oder all');

         WriteLN('Pfad: Verzeichnis fr die Templates');
         WriteLN('-job: (optional) Dateien erhalten die Endung .job, ansonsten .tpl')

      end
      else
      begin
         WriteLn('Fehler: Nicht genuegend Parameter angegeben!');
         WriteLn('Aufrufen mit:createnewtemplate <Profil><Arc_ID><Pfad>{-job}');
      end;
      exit;
   end;

   all := False;
   ext := '.tpl';
   strProfil := Paramstr(1);
   strArcid := Paramstr(2);
   strPfad := Paramstr(3);

   if rightstr(strPfad, 1) = '\' then
      ispath := True;


   if paramstr(2) = 'all' then
      all := True;
   if paramcount = 4 then
      ext := '.job';

   // Initalisieren der Objekte

   sProfil := ExtractFilePath(Paramstr(0)) + Paramstr(1) + '.con';
   queue := ExtractFilePath(Paramstr(0)) + 'queue\';
   if not FileExists(sProfil) then
   begin
      ExitCode := 5;
      WriteCmd('Fehler: Kann condatei <' + ParamStr(1) + '> nicht finden.');
      exit;
   end;

   dm_sep := tdm_sep.Create(nil);
   connectDB;

   if all = False then
   begin
      dm_sep.my_q.SQL.text := 'select * from sys_arc where arc_id =' + Paramstr(2);
      dm_sep.my_q.Execute;
   end
   else
   begin
      dm_sep.my_q.SQL.text := 'select * from sys_arc where Arc_TBLName <>' + #39 + #39;
      dm_sep.my_q.Execute;

   end;


   tblname := tstringlist.Create;
   arcid := tstringlist.Create;
   arcname := tstringlist.Create;
   lstdoppelte := tstringlist.Create;
   lstexisting := tstringlist.Create;
   j := 0;

   while not dm_sep.my_q.Eof do
   begin
      tblname.Add(dm_sep.my_q.fieldbyname('Arc_TBLName').asstring);
      arcid.add(dm_sep.my_q.fieldbyname('ARC_ID').asstring);
      //writeCmd(' tbl :'+dm_sep.my_q.fieldbyname('Arc_TBLName').asstring);
      arcname.add(dm_sep.my_q.fieldbyname('Arc_Name').asstring);
      //writeCmd(' Arc_Name :'+dm_sep.my_q.fieldbyname('Arc_Name').asstring);
      dm_sep.my_q.Next;
      j := j + 1
   end;

   zusfeld_name := Tstringlist.Create;
   zusdisp_name := Tstringlist.Create;

   WriteLN('Es wurden ' + inttostr(j) + ' Archive gefunden:');
   WriteLN('');

   for i := 0 to j - 1 do
   begin
      zusfeld_name.Clear;
      zusdisp_name.Clear;

      dm_sep.my_q.SQL.text := 'select * from cfg_' + tblname[i];
      dm_sep.my_q.Execute;
      while not dm_sep.my_q.Eof do
      begin
         zusfeld_name.Add(dm_sep.my_q.fieldbyname('Feld_Name').asstring);
         //writeCmd(' Feld_Name :'+dm_sep.my_q.fieldbyname('Feld_name').asstring);
         zusdisp_name.Add(dm_sep.my_q.fieldbyname('Disp_Name').asstring);
         //writeCmd(' Disp_Name :'+dm_sep.my_q.fieldbyname('Disp_Name').asstring);

         dm_sep.my_q.Next;
      end;


      WriteJobFile;

   end;

   if lstdoppelte.Count > 0 then
   begin
      WriteLN('');
      WriteLN('Es waren einige Archive mit nicht eindeutigen Namen vorhanden');
      WriteLN('Diese haben deshalb das Suffix __ArcID erhalten');
      lstdoppelte.Sort;
      for i := 0 to lstdoppelte.count - 1 do
         writeCMD(lstdoppelte[i]);

   end;
   if lstexisting.Count > 0 then
   begin
      WriteLN('');
      WriteLN('Es waren einige Templates schon vorhanden');
      WriteLN('Das neue Template wurde als Kopie (2) gespeichert');
      lstdoppelte.Sort;
      for i := 0 to lstexisting.count - 1 do
         writeCMD(lstexisting[i]);

   end;

end.
