program instuppath;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  inifiles,
  Classes,
  u_dm_main in 'u_dm_main.pas' {dm_main: TDataModule};

var
  GsProfil, GSsendername,sDb, sOldPath: string;

  function DeCrypt(HexInputStr, HexKeyStr: string): string;
    //////////////////////////////////////////////////////////////////
    ///  10.04.2005 Erstellt DeCrypt by SV.                        ///
    ///                                                            ///
    ///  Diese Funktion erzeugt aus dem HexInputStr einen mit      ///
    ///  HexKeyStr entschlsselten String (einfaches XOR)          ///
    ///                                                            ///
    ///  Format: Entschlsselter String                            ///
    ///                                                            ///
    //////////////////////////////////////////////////////////////////
  var
    iCntIStr, iCntKStr: integer;
  begin
    iCntIStr := 1;
    iCntKStr := 1;
    Result   := '';
    while iCntIStr < (Length(HexInputStr) + 1) do
    begin
      try
        Result := Result + chr(
          (StrToInt('$' + copy(HexInputStr, iCntIStr, 2)) xor
          StrToInt('$' + copy(HexKeyStr, iCntKStr mod (Length(HexKeyStr) + 1),
          2))));
      except
        on e: Exception do
        begin
          //        LogEvnt('9002    Fehler in Modul: DeCrypt    ' + e.Message);
          Result := '';
          exit;
        end;
      end;
      Inc(iCntIStr, 2);
      Inc(iCntKStr, 2);
    end;
  end;
    
  function ConnectDB(sProfil: string): boolean;
  var
    con: Tinifile;
    sUser, sPass: string;
  begin
    // Auslesen der Connection
    con    := TIniFile.Create(sProfil);
    Result := True;
    try
      try
        with con do
        begin
          sUser := 'sa';
          sPass := 'sa';
          dm_main.my_Con.Username := sUser;
          dm_main.my_Con.Password := sPass;
          dm_main.my_Con.Server := ReadString('Connection', 'Server', '');
          dm_main.my_Con.Port := ReadInteger('Connection', 'Port', 3306);
          dm_main.my_Con.Database := ReadString('Connection', 'DB', '');
          WriteLn('Connection to Server ' + dm_main.my_Con.Server +
            ' with DB ' + dm_main.my_Con.Database);
          sDb:= dm_main.my_Con.Database;
          dm_main.my_Con.Connect; // Anmelden an der Datenbank
          if not dm_main.my_Con.Connected then
            // Wenn keine Verbindung dann Tool verlassen
          begin
            ExitCode := 2;
            WriteLn('Fehler: Keine Verbindung zur Datenbank!');
            Result := False;
            exit;
          end;
        end;
      except
        on e: Exception do
        begin
          ExitCode := 4;
          WriteLn('Fehler: Beim Auslesen der .CON Datei! ' + e.Message);
          Result := False;
          exit;
        end;
      end;
    finally
      if Assigned(con) then
        FreeAndNil(con);
    end;
  end;

  procedure createglobalids;
  begin
    with dm_main do
    begin
    // use index like in:
    //http://dev.mysql.com/doc/refman/5.0/en/multiple-column-indexes.html
    my_q.SQL.text:='select * from sys_arc where type = 1';
    my_q.Execute;
    while not my_q.eof do
    begin
      // my_c.sql.text:='update '+sDB+'.arc_'+my_q.fieldbyname('arc_tblname').AsString
      // +' set doc_loc = replace(doc_loc,"\\\\VMWARE-XP\\","\\\\'+dm_main.my_Con.Server+'\\")';
       my_c.sql.text:='update arc_'+my_q.fieldbyname('arc_tblname').AsString
       +' set doc_loc = replace(doc_loc,"\\\\'+sOldPath+'\\","\\\\'+dm_main.my_Con.Server+'\\")';

       my_c.execute;
       my_c.sql.text:='update arc_'+my_q.fieldbyname('arc_tblname').AsString
       +' set ext_loc = replace(ext_loc,"\\\\'+sOldPath+'\\","\\\\'+dm_main.my_Con.Server+'\\")';

       my_c.execute;
       my_c.sql.text:='update arc_'+my_q.fieldbyname('arc_tblname').AsString
       +' set ori_loc = replace(ori_loc,"\\\\'+sOldPath+'\\","\\\\'+dm_main.my_Con.Server+'\\")';

       my_c.execute;

       my_q.next;
    end;

    end;


  end;
begin

  WriteLn('bitfarm Archiv V3  -  Datenbank Dateipfad-Aktualisierung');
  WriteLn('(c) 2004-2011 bitfarm Informationssysteme GmbH');
  if ParamCount < 1 then
  begin
    ExitCode := 1;
    WriteLn('Fehler: Nicht genuegend Parameter angegeben!');
    WriteLn('        Aufrufen mit: instuppath <con-datei>{oldpath');
    exit;
  end;
  // check for profil
  if not FileExists(ParamStr(1)) then
  begin
    ExitCode := 5;
    WriteLn('Fehler: Kann Condatei <' + ParamStr(1) + '> nicht finden.');
    exit;
  end;
 { if not FileAccessable(ParamStr(1)) then
  begin
    exit;
  end;}
  GsProfil := ParamStr(1);
  if ParamCount  = 2 then
    sOldPath := ParamStr(2)
  else
    sOldPath := 'VMWARE-XP';

  dm_main   := tdm_main.Create(nil);
  ExitCode := 0;
  ConnectDB(GsProfil);
  if (Exitcode > 0) then
  begin
    exit;
  end;
  createglobalids;
  { TODO -oUser -cConsole Main : Hier Code einfgen }
end.
