

{  Copyright (C) 2014 bitfarm Informationssysteme GmbH

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; version 2 of the License.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
along with this program (see COPYING or gpl-2.0.txt); if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
}
unit u_MainForm;


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// 3.4.4.x  GPL
//
//////////////////////////////////////////////////////////////////////////////////////////////////////////////

interface

uses
   FastMM4, gnugettext, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, ExtCtrls, Menus, Grids, CRGrid, DBCtrls, Mask, Buttons,
   //Jv
   JvComponentBase, JvBalloonHint, JvExMask, JvToolEdit, JvExStdCtrls, JvCombobox,
   JvListComb, JvExControls, JvComponent, JvSimIndicator, JvDragDrop,
   JvExComCtrls, JvAnimate, JvExExtCtrls,
   JvExtComponent, JvOfficeColorButton, JvColorTrackbar, JvFullColorSpaces,
   JvFullColorCtrls, JvProgressBar, JvStaticText, JvSpeedButton, JvgCheckBox,
   JvExForms, JvScrollBox, JvSpin, JclSysInfo,

   TB2Item, TB2Dock, TB2Toolbar, TB2ExtItems,
   TB2ToolWindow,
   TBX, TBXDkPanels, TBXStatusBars,
   TBXToolPals, TBXExtItems,
      //
   RxGIF, //#3.5
   TimerLst, Placemnt, AppEvnts,
   psIBTreeView, MFEdit, DBGrids, Printers, registry,
   fldbrows, USingleInst, ImageEnView, iemview,
   hyiedefs, ImageEnIO, ImageEnProc, ShellAPI,
   ComCtrls, nb30, DateUtils, IniFiles, MD5,
   StrUtils, hyieutils, ievect, ieview,
   DBAccess, jpeg, ToolEdit, FMTBcd,

   IdBaseComponent, IdComponent, IdRawBase, IdRawClient, IdIcmpClient,
   RxGrdCpt, Gauges, FileCtrl, shlobj, Activex,
   Xdom_4_1, typinfo, VirtualTrees,
   JCLDebug,
   clipbrd, Richedit, SyncObjs, TIFLZW, XPMan,
   Spin, DB,
   ActnList,
   u_ShBase, u_ShLowUtils, u_ShDm, u_ShDbUtils, u_ShHighUtils,
   u_ShFrameZusFldMulti,
   u_ViewBase, u_HighUtils,
   u_LeerFrame, u_threadedansicht,
   //u_Rechte,
   u_Volltext, u_ShVoransicht, u_DocLink, u_DocEditor,
   u_History, u_threadedvoransicht,
   u_dm_ViewerMain, ImgList;


function CreZusPum(ParentMenu: TMenuItem; OnClickFunction: TNotifyEvent;
   BaseName: string; fsavezus: boolean): boolean;
procedure LogWvl(LogMsg: string);


//-----------------------------------------------------------------------------

type
   TFPStrWords = function(const InputStr: string): TStringList;

const
   WM_HOTKEY_WVL_MESSAGE = WM_APP + 0;
   WM_HOTKEY_RECONNECT = WM_APP + 1; //3.5.0.39 [2393]

type
   THandleArray = array of HWND;

type
   Tplugin = record
      name: string;
      parameters: string;
      command: string;
   end;

   Tmydatefunction = function(const AValue: TDateTime): TDateTime;

type // Record mit Archivinformationen
   TAData = record
      ArcID: integer;    // Archiv ID
      ArcName: string[32]; // Bezeichnung des Archives
      TblName: string[14]; // Interner Referenzname fr Archivtabelle
   end;

type // Record mit Archivinformationen
   TArcData = record
      ArcID: integer;    // Archiv ID
      LgrID: integer;    // Archiv ID
      ArcName: string[32]; // Bezeichnung des Archives
      TblName: string[14]; // Interner Referenzname fr Archivtabelle
      ArcEnabled : integer;
      typ : Integer;
      ArcBackpic :string;
      Options : Integer;
      DefDocname : string;
   end;

type // Record mit Archivinformationen
   TZData = record
      ArcID: integer;    // Archiv ID
      ArcName: string[32]; // Bezeichnung des Archives
      Dispname: string[32]; // Bezeichnung des Archives
      Feldname: string[36]; // Bezeichnung des Archives
      TblName: string[14]; // Interner Referenzname fr Archivtabelle
   end;

type
   Tfrm_MainForm = class (TForm)
      pnl_SuchOpt: TPanel;
      pnl_Trefferliste: TPanel;
      dbgrd_Trefferliste: TCRDBGrid;
      dbnav_Trefferliste: TDBNavigator;
      pnl_TListOpt: TPanel;
      pnl_Voransicht: TPanel;
      pctr_Suchoptionen: TPageControl;
      tbs_StdSuche: TTabSheet;
      tbs_Volltext: TTabSheet;
      tbs_ZusFeld: TTabSheet;
      lbl_SSLw: TLabel;
      lbl_SUsr: TLabel;
      chbx_SDatum: TCheckBox;
      dtp_SVon: TMFDateTimeEdit;
      dtp_SBis: TMFDateTimeEdit;
      chbx_SOnlyUsed: TCheckBox;
      lbl_SBis: TLabel;
      cbx_MaxTreffer: TComboBox;
      lbl_MaxTreffer: TLabel;
      pnl_SrcTime: TPanel;
      btn_StartSrc: TBitBtn;
      btn_ResFields: TBitBtn;
      sbx_ZusFeld_old: TScrollBox; // Eingabe/Ausgabe maske der Zusatzfelder
      cbx_SUsr: TComboBox;
      appevnt: TApplicationEvents;
      memo_Vtx: TMemo;
      dbtv_LgrArc: TpsDBTreeView;
      edt_SSlw: TEdit;
      fms_MainForm: TFormStorage;
      tmb_Voransicht: TImageEnMView;
      pgb_TmbLoad: TProgressBar;
      chbx_VTXSLW: TCheckBox;
      dock_MainForm_Top: TTBXDock;
      tlb_ViewerCtrl: TTBXToolbar;
      tbi_VisThumbs: TTBXItem;
      tbi_VisLgrArc: TTBXItem;
      tbsep_Vis1: TTBXSeparatorItem;
      tbsi_VMail: TTBXSubmenuItem;
    tbi_VorJederMailFragen: TTBXItem;
    tbi_AlsTifPdfVersenden: TTBXItem;
    tbi_VerknuepfungVersenden: TTBXItem;
      tbi_VDeSkew: TTBXItem;
      tbi_VRemBorder: TTBXItem;
      tbi_VEdit: TTBXItem;
      tbsi_VDeSpeckle: TTBXSubmenuItem;
      tbi_DSpAsk: TTBXItem;
      tbi_DSp4P: TTBXItem;
      tbi_DSp3P: TTBXItem;
      tbi_DSp2P: TTBXItem;
      tbi_DSp1P: TTBXItem;
      tbi_VOCR: TTBXItem;
      tbsep_Vis2: TTBXSeparatorItem;
      tbi_VTurnRight: TTBXItem;
      tbi_VFlip: TTBXItem;
      tbi_VTurnLeft: TTBXItem;
      tbsep_Vis3: TTBXSeparatorItem;
      tbi_VDocLinks: TTBXItem;
      tbi_VLinkDoc: TTBXItem;
      tbi_VNewLink: TTBXItem;
      tbi_VSlwEdit: TTBXItem;
      tbsep_Vis4: TTBXSeparatorItem;
      tbi_VPrev: TTBXItem;
      lbl_VSeite: TTBXLabelItem;
      tlb_Favoriten: TTBXToolbar;
      tbi_Fav5: TTBXItem;
      tbi_Fav4: TTBXItem;
      tbi_Fav3: TTBXItem;
      tbi_Fav2: TTBXItem;
      tbi_Fav1: TTBXItem;
      tlb_MainMenu: TTBXToolbar;
      mnu_Datei: TTBXSubmenuItem;
      mnu_ReLogin: TTBXItem;
      mnu_NewPass: TTBXItem;
      mnu_Line2: TTBXSeparatorItem;
      mnu_Ende: TTBXItem;
      mnu_Ansicht: TTBXSubmenuItem;
      mnu_VisLgrArc: TTBXItem;
      mnu_VisThumbs: TTBXItem;
      mnu_Symbolleisten: TTBXSubmenuItem;
      mnu_VisTlbStd: TTBXItem;
      mnu_VisTlbFav: TTBXItem;
      mnu_VisTlbLgr: TTBXItem;
      mnu_VisTlbArc: TTBXItem;
      mnu_VisSpez: TTBXSubmenuItem;
      mnu_VisSave: TTBXItem;
      mnu_VisLoad: TTBXItem;
      mnu_Line1: TTBXSeparatorItem;
      mnu_VisReset: TTBXItem;
      mnu_VisReDraw: TTBXItem;
      mnu_Line3: TTBXSeparatorItem;
      mnu_Opt: TTBXItem;
      mnu_Help: TTBXSubmenuItem;
      mnu_Info: TTBXItem;
      tlb_Lager: TTBXToolbar;
      lbl_LagerTitel: TTBXLabelItem;
      tbsep_LgrArc1: TTBXSeparatorItem;
      lbl_ArchivTitel: TTBXLabelItem;
      tbsep_LgrArc2: TTBXSeparatorItem;
      tbi_Reset: TTBXItem;
      tbi_Suchen: TTBXItem;
      tlb_Zoom2: TTBXToolbar;
      lbl_ZoomTitel: TTBXLabelItem;
      cbx_VZoom: TTBXComboBoxItem;
      tbsi_VZoom: TTBXSubmenuItem;
      tbi_VLupe: TTBXItem;
      tbi_ZoomOff: TTBXItem;
      tbi_ZoomSelect: TTBXItem;
      tbi_ZoomHeight: TTBXItem;
      tbi_ZoomWidth: TTBXItem;
      tbi_ZoomPage: TTBXItem;
      tbi_Zoom100: TTBXItem;
      dock_MainForm_Left: TTBXDock;
      dpnl_LgrArc: TTBXDockablePanel;
      dpnl_Suchen: TTBXDockablePanel;
      dock_MainForm_Bottom: TTBXDock;
      cbx_Archiv: TJvComboBox;
      tbci_Archiv: TTBControlItem;
      cbx_Lager: TJvComboBox;
      tbci_Lager: TTBControlItem;
      stb_Main: TTBXStatusBar;
      dpnl_Thumbs: TTBXDockablePanel;
      dock_MainForm_Right: TTBXDock;
      tbw_DocTitel: TTBXToolWindow;
      pnl_DocTitel: TPanel;
      pnl_Suchen: TPanel;
      tbi_VDocTimer: TTBXItem;
      sbtn_QuickAddSlw: TSpeedButton;
      tbsi_VPrint: TTBXSubmenuItem;
      tbi_VPrintPre: TTBXItem;
      tbi_VPrintAsk: TTBXItem;
      tbi_VPrintStd: TTBXItem;
      tlb_Status: TTBXToolbar;
      lbl_Status: TTBXLabelItem;
      tci_InUse: TTBXColorItem;
      tbsep_Sts1: TTBXSeparatorItem;
      tbi_VShowAnno: TTBXItem;
      tbi_VMakeRev: TTBXItem;
      img_Revision: TImage;
      chbx_SRefSea: TCheckBox;
      edt_SRefSea: TEdit;
      sbtn_SAddRef: TSpeedButton;
      tci_OriFile: TTBXColorItem;
      tci_DocLink: TTBXColorItem;
    tbi_OriginaldateiVersenden: TTBXItem;
      tbi_VShowBrief: TTBXItem; //#3.5
      SaveDialog1: TSaveDialog;
      cbx_Status: TComboBox;
      memo_Info: TMemo;
      btn_SaveDoc: TBitBtn;
      dbgrd_Wvl: TCRDBGrid;
      dock_wvldown: TTBXMultiDock;  // Wiedervorlage
      dock_wvlup: TTBXMultiDock;    // wiedervorlage
      dpnl_Wvlg: TTBXDockablePanel;
      MFDateTimeEdit1: TMFDateTimeEdit;
      TBXToolWindow1: TTBXToolWindow;
      dtp_TimerNG: TMFDateTimeEdit;
      tbsi_localspeichern: TTBXSubmenuItem;
      tbi_VLokalSave: TTBXItem;
    tbi_VlocalSaveOri: TTBXItem;
    tbi_VlocalSavePdf: TTBXItem;
      Splitter1: TSplitter;
      tbi_VlocalSaveTif: TTBXItem;
      DateEdit1: TDateEdit; //#3.5
    tlb_WvlState: TTBXToolbar;
      TBX_ciFertig: TTBXColorItem;
      TBX_ciInArbeit: TTBXColorItem;
      TBX_ciOffen: TTBXColorItem;
    tbi_HinzufuegenDesDokumentesAlsAttachment: TTBXItem;
    tbi_HinzufuegenDerOriginaldatei: TTBXItem;
    tbi_GesammelteDokumenteVersenden: TTBXItem;
      TBXItem34: TTBXItem;
      GB_Kalender: TGroupBox;
      dtp_DocTimeNG: TMFDateTimeEdit;
      TBXToolbar1: TTBXToolbar;
      TBXItem4: TTBXItem;
      TBXSeparatorItem1: TTBXSeparatorItem;
      KW: TTBXItem;
      TBXSeparatorItem2: TTBXSeparatorItem;
      TBXItem5: TTBXItem;
      Panel3: TPanel;
      Button3: TButton;
      bitbtn1: TBitBtn;
      TBXItem2: TTBXItem;
      tbx_pubNote: TTBXItem;
      tbx_privNote: TTBXItem;
      tbx_UserNote: TTBXItem;
      TBXItem8: TTBXItem;
      TBXItem9: TTBXItem;
      TBXToolbar6: TTBXToolbar;
      TBControlItem8: TTBControlItem;
      lbl_numFiles: TLabel;
      TBControlItem9: TTBControlItem;
      Gauge1: TGauge;
      TBControlItem15: TTBControlItem;
      Image2: TImage;
      TrackBar2: TTrackBar;
      TBXItem35: TTBXItem;
      TBXItem36: TTBXItem;
      TBXItem37: TTBXItem;
      Button1: TButton;
      TBControlItem7: TTBControlItem;
      Button2: TButton;
      TBControlItem10: TTBControlItem;
      Button4: TButton;
      TBControlItem12: TTBControlItem;
      tbi_VInvert: TTBXItem;
      StaticText1: tlabel;
      lbl_ChoosenLink: tlabel;
      img_link: TImage;
      TBXToolbar8: TTBXToolbar;
      DeleteDocument: TTBXItem;
      StaticText2: tlabel;
      bh_privAnno: TJvBalloonHint;
      listofpriv: TTBXEditItem;
      bh_PrivAnnoExist: TJvBalloonHint;
      tbi_VSaveDoc: TTBXItem;
      TBSeparatorItem1: TTBSeparatorItem;
      tbi_CopyDocToExt: TTBXItem;
      tbi_DelDone: TTBXItem;
      tbi_ShowDone: TTBXItem;
      tbi_ShowOpen: TTBXItem;
      tbi_ShowWork: TTBXItem;
      tbi_EStamp: TTBXItem;
      tbxt_stempel: TTBXToolbar;
      tbx_fav1: TTBXItem;
      tbx_fav2: TTBXItem;
      tbx_fav3: TTBXItem;
      tbx_fav4: TTBXItem;
      tbx_fav5: TTBXItem;
      TBSeparatorItem2: TTBSeparatorItem;
      tbx_hiim: TTBXItem;
      tbx_noteim: TTBXItem;
      tbx_lineim: TTBXItem;
      tbx_Textim: TTBXItem;
      tbx_wfcancel: TTBXColorItem;
      tbxs_lesezeichen: TTBXSubmenuItem;
      tbx_srcsave: TTBXItem;
    TBXMultiDock1: TTBXMultiDock;
      dpnl_manfav: TTBXDockablePanel;
      vst_favfile: TVirtualStringTree;
      tv_lese: TTreeView;
      pum_favtree: TPopupMenu;
    pumOrdnerHinzufuegen: TMenuItem;
      img_newlink: TImage;
      tbs_doctools: TTBXSubmenuItem;
      tbi_VInverta: TTBXItem;
      tbi_VRemBordera: TTBXItem;
      tbi_VDeSkewa: TTBXItem;
      tbsi_VDeSpecklea: TTBXItem;
      tbi_VTurnRighta: TTBXItem;
      tbi_VTurnLefta: TTBXItem;
      tbi_VFlipa: TTBXItem;
      tbx_noteimgreen: TTBXItem;
      tbx_noteimred: TTBXItem;
      tbx_noteimyellow: TTBXItem;
      tbi_createemptypage: TTBXItem;
      ApplicationEvents1: TApplicationEvents;
      pnl_doctime: TPanel;
      tbi_savepdfsasonefile: TTBXItem;
      tbi_savetifsasonefile: TTBXItem;
      JvgCb_date: TJvgCheckBox;
      sbx_ZusFeld: TJvScrollBox;
      JvgCb_user: TJvgCheckBox;
      JvgCb_slw: TJvgCheckBox;
      tbx_favwvl: TTBXToolbar;
      tbx_wvlfavbear0: TTBXItem;
      tbx_wvlfavbear1: TTBXItem;
      tbx_wvlfavbear2: TTBXItem;
      tbx_wvlfavbear3: TTBXItem;
      tbx_wvlfavbear4: TTBXItem;
      tbx_wvlfavbear5: TTBXItem;
      tbx_wvlfavbear6: TTBXItem;
      tbx_wvlfavbear7: TTBXItem;
      tbx_wvlfavbear8: TTBXItem;
      tbx_wvlfavbear9: TTBXItem;
      timer_autoscroll: TTimer;
      TBX_DelWvl: TTBXToolbar;

      tbi_docdup: TTBXItem;
      tbx_zuspflichtdebug: TTBXItem;
      tbi_mnustempel: TTBXItem;
      tbx_mnuocr: TTBXItem;
      tbx_mnurestore: TTBXItem;
      tbi_wvldoc: TTBXItem;
      tbi_showdocedit: TTBXItem;
      sbti_export: TTBSubmenuItem;
      tbi_expcsv: TTBXItem;
      tbi_expxls: TTBXItem;
      tbi_expods: TTBXItem;
      tbi_manuscan: TTBXItem;
      tbi_history: TTBXItem;
    btn_WvlSpeichern: TBitBtn;
      TBXLabelItem1: TTBXLabelItem;
      tbxse_page: TTBXEditItem;
      tbi_Vnext: TTBXItem;
      tbi_normalmouse: TTBXItem;
      TBXSeparatorItem3: TTBXSeparatorItem;
      tbi_freihand: TTBXItem;
      tbi_objauswahl: TTBXItem;
      tbxs_text: TTBXSubmenuItem;
      tbi_textfirst: TTBXItem;
      tbi_textsecond: TTBXItem;
      tbsi_stifte: TTBXSubmenuItem;
      tbsi_notizen: TTBXSubmenuItem;
      tbsi_highlight: TTBXSubmenuItem;
      tbi_textfourth: TTBXItem;
      tbi_textthird: TTBXItem;
      tbi_highlightfourth: TTBXItem;
      tbi_highlightthird: TTBXItem;
      tbi_highlightsecond: TTBXItem;
      tbi_highlightfirst: TTBXItem;
      tbi_stiftfourth: TTBXItem;
      tbi_stiftthird: TTBXItem;
      tbi_stiftsecond: TTBXItem;
      tbi_stiftfirst: TTBXItem;
      tbi_stiftfifth: TTBXItem;
      tbi_highlightfifth: TTBXItem;
      tbx_noteimorange: TTBXItem;
      tbx_noteimblue: TTBXItem;
      tbi_textfith: TTBXItem;
      tbsi_graphik: TTBXSubmenuItem;
      tbi_grphikoptionen: TTBXItem;
      btn_back: TBitBtn;
      btn_forward: TBitBtn;
      TBSeparatorItem3: TTBSeparatorItem;
      tbi_configuration: TTBXItem;
      tbi_stextprog: TTBXItem;
      TBControlItem2: TTBControlItem;
      cbx_rts: TTBXCheckBox;
    tbi_GesammelteDokumenteAlsEinPdfVersenden: TTBXItem;

      tbxt_werkzeuge: TTBXToolbar;
      tbx_tlbocr: TTBXItem;
      tbi_docedit: TTBXItem;
      tbi_tblmanuscan: TTBXItem;
      tbi_tblrestore: TTBXItem;
      tbi_tblemptypage: TTBXItem;
      tbxt_export: TTBXToolbar;
      tbi_tblexpcsv: TTBXItem;
      tbi_tblexpods: TTBXItem;
      tbi_tblexpxls: TTBXItem;
      tbi_filterwvl: TTBXItem;
    btn_WvlWeiterleiten: TBitBtn;
      cbx_Usr_WorkNG: TJvImageComboBox;
      lbl_wvl_work_name: TLabel;
      img_wvlwork: TImage;
      tbx_delcollted: TTBXItem;
      tbx_stempeldiag: TTBXItem;
      tbbt_search: TTBXButton;
      tbxb_reset: TTBXButton;
      tbi_deldoc: TTBXItem;
      tbxi_abwesenheit: TTBXItem;
      TBXDockColumnButton: TTBXDock;
      tlb_DocRechts: TTBXToolbar;
      tbi_DocVoransicht: TTBXItem;
      tbi_DocVolltext: TTBXItem;
      tbi_DocLink: TTBXItem;
      tbi_DocHistory: TTBXItem;
      aclMain: TActionList;
      acOcr: TAction;
    TBXSeparatorItem5: TTBXSeparatorItem;
    TBXSeparatorItem6: TTBXSeparatorItem;
    tbi_GemerktesDokument0: TTBXItem;
    tbi_GemerktesDokument1: TTBXItem;
    tbi_GemerktesDokument2: TTBXItem;
    tbi_GemerktesDokument3: TTBXItem;
    tbi_GemerktesDokument4: TTBXItem;
    tbi_GemerktesDokument5: TTBXItem;
    TBXSeparatorItem7: TTBXSeparatorItem;
    tbi_DokumentMerken1: TTBXItem;
    tbi_DokumentMerken2: TTBXItem;
    tbi_DokumentMerken3: TTBXItem;
    tbi_DokumentMerken4: TTBXItem;
    tbi_DokumentMerken5: TTBXItem;
    pumOrdnerLoeschen: TMenuItem;
    tlb_DocTime: TTBXToolbar;
    tbi_MyTask: TTBXItem;
    tbi_MATask: TTBXItem;
    tbi_SaveEdit: TTBXItem;
    tbi_ShowDoc: TTBXItem;
    tbi_DelTimer: TTBXItem;
    tbi_SetState_Open: TTBXItem;
    tbi_SetState_Work: TTBXItem;
    tbi_SetState_Done: TTBXItem;
    tbi_ShowKW: TTBXItem;
    tbi_PrevKW: TTBXItem;
    tbi_NextKW: TTBXItem;
    tbix_showallwvl: TTBXItem;
    tbi_nuDate: TTBXItem;
    TBX_FiltOffen: TTBXColorItem;
    TBX_FiltArb: TTBXColorItem;
    TBX_FiltFertig: TTBXColorItem;
    tbxtm_delbfahit: TTBXItem;
    tbxtm_AnnoDelete: TTBXItem;
      procedure mnu_VisLgrArcClick(Sender: TObject);
      procedure mnu_VisThumbsClick(Sender: TObject);
      procedure sbtn_RemThumbClick(Sender: TObject);
      procedure tbi_DocVoransichtClick(Sender: TObject);
      procedure tbi_DocVolltextClick(Sender: TObject);
      procedure tbi_DocLinkClick(Sender: TObject);
      procedure tbi_Doc_HistoryClick(Sender: TObject);

      procedure mnu_InfoClick(Sender: TObject);
      procedure chbx_SDatumClick(Sender: TObject);
      procedure appevntException(Sender: TObject; E: Exception);
      procedure FormShow(Sender: TObject);
      procedure vst_favfileGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
         Column: TColumnIndex; TextType: TVSTTextType; var CellText: WideString);
      procedure vst_favfileDblClick(Sender: TObject);
      procedure dbtv_LgrArcClick(Sender: TObject);
      procedure dbtv_LgrArcDragOver(Sender, Source: TObject; X, Y: integer;
         State: TDragState; var Accept: boolean);
      procedure dbtv_LgrArcDragDrop(Sender, Source: TObject; X, Y: integer);
		procedure FillMetaFieldValues(var slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType: TStringList);
		procedure FillMetaFieldValuesPflicht(var slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType: TStringList);

      procedure mnu_VisTlbStdClick(Sender: TObject);
      procedure mnu_VisTlbFavClick(Sender: TObject);
      procedure mnu_VisTlbLgrClick(Sender: TObject);
      procedure mnu_VisTlbArcClick(Sender: TObject);
      procedure mnu_VisSaveClick(Sender: TObject);
      procedure mnu_VisLoadClick(Sender: TObject);
      procedure mnu_VisReDrawClick(Sender: TObject);
      procedure mnu_ReLoginClick(Sender: TObject);
      procedure dbgrd_TrefferlisteKeyUp(Sender: TObject; var Key: word;
         Shift: TShiftState);
      procedure FormResize(Sender: TObject);
      procedure btn_ResFieldsClick(Sender: TObject);
      function LoadTrefferlisteFromFile(ArcName: string): Boolean;
      procedure dbnav_TrefferlisteClick(Sender: TObject; Button: TNavigateBtn);
      procedure mnu_NewPassClick(Sender: TObject);
      procedure btn_StartSrcClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);


      procedure mnu_EndeClick(Sender: TObject);
      procedure mnu_VisResetClick(Sender: TObject);
      procedure mnu_OptClick(Sender: TObject);

      procedure FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure btn_SaveDocClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure cbx_VZoomKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure dbgrd_TrefferlisteDblClick(Sender: TObject);
      procedure dbgrd_TrefferlisteMouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);
      procedure dbgrd_TrefferlisteMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure dbtv_LgrArcKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure tbtn_VOCRClick(Sender: TObject);
      procedure shp_DocLnkInfoMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure tmb_VoransichtProgress(Sender: TObject; per: integer);
      procedure tmb_VoransichtImageSelect(Sender: TObject; idx: integer);
      procedure dtp_SBisChange(Sender: TObject);
      procedure tbi_Fav1Click(Sender: TObject);
      procedure tbi_Fav2Click(Sender: TObject);
      procedure tbi_Fav3Click(Sender: TObject);
      procedure tbi_Fav4Click(Sender: TObject);
      procedure tbi_Fav5Click(Sender: TObject);
      procedure tbi_VisLgrArcClick(Sender: TObject);
      procedure tbi_VisThumbsClick(Sender: TObject);
      procedure tbi_VSaveDocClick(Sender: TObject);
      procedure tbi_VLokalSaveClick(Sender: TObject);
      procedure Do_VLokalSave;
      procedure tbsi_VMailClick(Sender: TObject);
      procedure tbi_VerknuepfungVersendenClick(Sender: TObject);
      procedure tbi_AlsTifPdfVersendenClick(Sender: TObject);
      procedure tbi_VorJederMailFragenClick(Sender: TObject);
      procedure tbi_VEditClick(Sender: TObject);
      procedure tbi_VRemBorderClick(Sender: TObject);
      procedure tbi_VDeSkewClick(Sender: TObject);
      procedure tbsi_VDeSpeckleClick(Sender: TObject);
      procedure tbi_DSp1PClick(Sender: TObject);
      procedure tbi_DSp2PClick(Sender: TObject);
      procedure tbi_DSp3PClick(Sender: TObject);
      procedure tbi_DSp4PClick(Sender: TObject);
      procedure tbi_DSpAskClick(Sender: TObject);
      procedure tbi_VTurnLeftClick(Sender: TObject);
      procedure tbi_VTurnRightClick(Sender: TObject);
      procedure tbi_VFlipClick(Sender: TObject);
      procedure Drehen(Grad:integer);
      procedure tbi_VSlwEditClick(Sender: TObject);
      procedure tbi_VNewLinkClick(Sender: TObject);
      procedure tbi_VLinkDocClick(Sender: TObject);
      procedure tbi_VPrevClick(Sender: TObject);
      procedure tbi_VNextClick(Sender: TObject);
      procedure cbx_VZoomChange(Sender: TObject; const Text: string);
      procedure tbsi_VZoomClick(Sender: TObject);
      procedure tbi_Zoom100Click(Sender: TObject);
      procedure tbi_ZoomPageClick(Sender: TObject);
      procedure tbi_ZoomWidthClick(Sender: TObject);
      procedure tbi_ZoomHeightClick(Sender: TObject);
      procedure tbi_ZoomSelectClick(Sender: TObject);
      procedure tbi_ZoomOffClick(Sender: TObject);
      procedure tbi_VLupeClick(Sender: TObject);
      procedure tbi_SuchenClick(Sender: TObject);
      procedure tbi_ResetClick(Sender: TObject);
      procedure cbx_LagerChange(Sender: TObject);
      procedure cbx_ArchivChange(Sender: TObject);
      procedure dpnl_LgrArcCloseQuery(Sender: TObject; var CanClose: boolean);
      procedure dpnl_ThumbsCloseQuery(Sender: TObject; var CanClose: boolean);
      procedure tbi_VDocLinksClick(Sender: TObject);
      procedure tbi_VDocTimerClick(Sender: TObject);
      procedure dbgrd_TrefferlisteDrawColumnCell(Sender: TObject;
         const Rect: TRect; DataCol: integer; Column: TColumn; State: TGridDrawState);
      procedure sbtn_QuickAddSlwClick(Sender: TObject);
      procedure tbsi_VPrintClick(Sender: TObject);
      procedure tbi_VPrintStdClick(Sender: TObject);
      procedure tbi_VPrintAskClick(Sender: TObject);
      procedure tbi_VPrintPreClick(Sender: TObject);
      procedure tci_InUseClick(Sender: TObject);
      procedure tbi_VShowAnnoClick(Sender: TObject);
      procedure tbi_VMakeRevClick(Sender: TObject);
      procedure tbi_VOCRClick(Sender: TObject);
      procedure dbtv_LgrArcCollapsed(Sender: TObject; Node: TTreeNode);
      procedure dbtv_LgrArcExpanded(Sender: TObject; Node: TTreeNode);
      procedure chbx_SRefSeaClick(Sender: TObject);

      procedure sbtn_SAddRefClick(Sender: TObject);
      procedure edt_SRefSeaChange(Sender: TObject);
      procedure tci_OriFileClick(Sender: TObject);
      procedure tci_DocLinkClick(Sender: TObject);
      procedure tbi_OriginaldateiVersendenClick(Sender: TObject);
      procedure tbi_VShowBriefClick(Sender: TObject);
      procedure TBXItem1Click(Sender: TObject);
      procedure FormActivate(Sender: TObject);
      procedure FormPaint(Sender: TObject);
      procedure KWClick(Sender: TObject);
      procedure tbi_ShowDocClick(Sender: TObject);
      procedure dbgrd_TimersCellClick(Column: TColumn);
      procedure dbgrd_TimersDrawColumnCell(Sender: TObject; const Rect: TRect;
         DataCol: integer; Column: TColumn; State: TGridDrawState);
      procedure tbi_ShowKWClick(Sender: TObject);
      procedure dtp_TimerNGChange(Sender: TObject);
      procedure tbi_MyTaskClick(Sender: TObject);
      procedure tbi_MATaskClick(Sender: TObject);
      procedure fra_DocLinkbtn_LnkCreClick(Sender: TObject);
      procedure dbgrd_WvlCellClick(Column: TColumn); // wiedervorlage
      procedure TBXItem4Click(Sender: TObject);
      procedure TBXItem5Click(Sender: TObject);
      procedure dtp_DocTimeNGChange(Sender: TObject);
      procedure btnOffenClick(Sender: TObject);
      procedure delAufgClick(Sender: TObject);
      procedure btnBearbeitungClick(Sender: TObject);
      procedure btnFertigClick(Sender: TObject);
      procedure ownaufClick(Sender: TObject);
      procedure dbgrd_WvlDblClick(Sender: TObject);
      procedure tbi_DelTimerClick(Sender: TObject);
      procedure tbi_SaveEditClick(Sender: TObject);
      procedure tbi_SetState_OpenClick(Sender: TObject);
      procedure tbi_SetState_WorkClick(Sender: TObject);
      procedure tbi_SetState_DoneClick(Sender: TObject);
      procedure dbgrd_WvlStartDock(Sender: TObject; var DragObject: TDragDockObject);
      procedure dbgrd_WvlDrawColumnCell(Sender: TObject; const Rect: TRect;
         DataCol: integer; Column: TColumn; State: TGridDrawState);
      procedure TBX_FiltOffenClick(Sender: TObject);
      procedure TBX_FiltArbClick(Sender: TObject);
      procedure TBX_FiltFertigClick(Sender: TObject);
      procedure tbi_nuDateClick(Sender: TObject);
      procedure TSH_OffenMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure TSH_BearbeitungMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure TSH_fertigMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure tbi_VlocalSavePdfClick(Sender: TObject);
      procedure tbi_VlocalSaveOriClick(Sender: TObject);
      procedure tbi_DelDoneClick(Sender: TObject);
      procedure tbi_ShowOpenClick(Sender: TObject);
      procedure tbi_ShowWorkClick(Sender: TObject);
      procedure tbi_ShowDoneClick(Sender: TObject);
      procedure fra_DocLinkbtn_ShowLnkClick(Sender: TObject);
      procedure fra_DocLinkbtn_LnkRenClick(Sender: TObject);
      procedure fra_DocLinkbtn_LnkImpClick(Sender: TObject);
      procedure fra_DocLinkbtn_LnkDelClick(Sender: TObject);
      procedure fra_DocLinkdbgrd_LinksCellClick(Column: TColumn);
      procedure tbi_VlocalSaveTifClick(Sender: TObject);
      procedure memo_InfoDblClick(Sender: TObject);

      procedure MFDateTimeEdit1Change(Sender: TObject);
      procedure MFDateTimeEdit1Click(Sender: TObject);

      procedure tbi_HinzufuegenDesDokumentesAlsAttachmentClick(Sender: TObject);
      procedure tbi_HinzufuegenDerOriginaldateiClick(Sender: TObject);
      procedure tbi_GesammelteDokumenteVersendenClick(Sender: TObject);
      procedure TBXItem34Click(Sender: TObject);
      procedure Button1Click(Sender: TObject);
      procedure Button2Click(Sender: TObject);
      procedure bitbtn1Click(Sender: TObject);
      procedure Button3Click(Sender: TObject);
      procedure memo_VtxKeyPress(Sender: TObject; var Key: char);
      procedure edt_SSlwKeyPress(Sender: TObject; var Key: char);

      procedure dbgrd_TrefferlisteColumnMoved(Sender: TObject;
         FromIndex, ToIndex: integer);
      procedure dbgrd_TrefferlisteAfterColResize(Sender: TObject);
      procedure dbgrd_WVLAfterColResize(Sender: TObject);
      procedure dbgrd_WvlColumnMoved(Sender: TObject; FromIndex,
      	ToIndex: Integer);
      procedure SpeedButtonExportErstellenClick(Sender: TObject);
      procedure tbi_VInvertClick(Sender: TObject);
      procedure TsqlClick(Sender: TObject);
      procedure btn_SDKWClick(Sender: TObject);
      procedure tbx_privNoteClick(Sender: TObject);
      procedure tbx_pubNoteClick(Sender: TObject);
      procedure cbx_SUsrKeyPress(Sender: TObject; var Key: char);
      procedure dtp_SBisKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure dtp_SVonKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure edt_SRefSeaKeyDown(Sender: TObject; var Key: word;
         Shift: TShiftState);
      procedure FormDestroy(Sender: TObject);
      procedure dbgrd_TrefferlisteTitleClick(Column: TColumn);
      procedure TBXItem36Click(Sender: TObject);
      procedure TBXItem37Click(Sender: TObject);
      procedure TBXItem38Click(Sender: TObject);
      procedure TBXItem35Click(Sender: TObject);
      procedure DeletedocumentClick(Sender: TObject);
      procedure dbtv_LgrArcAdvancedCustomDrawItem(Sender: TCustomTreeView;
         Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
         var PaintImages, DefaultDraw: boolean);
      procedure tlb_Zoom2MouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);
      procedure Button4Click(Sender: TObject);
      procedure dbgrd_WvlExit(Sender: TObject);
      procedure tbi_CopyDocToExtClick(Sender: TObject);
      procedure cbx_MaxTrefferChange(Sender: TObject);
      procedure tbi_EStampClick(Sender: TObject);
      procedure tbx_favClick(Sender: TObject);
      procedure tbx_lineimClick(Sender: TObject);
      procedure tbx_noteimClick(Sender: TObject);
      procedure tbx_hiimClick(Sender: TObject);
      procedure tbx_TextimClick(Sender: TObject);
      procedure tbx_wfcancelClick(Sender: TObject);
      procedure tbx_srcsaveClick(Sender: TObject);
      procedure tbx_lesemanClick(Sender: TObject);

      procedure vst_favfileGetImageIndex(Sender: TBaseVirtualTree;
         Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
         var Ghosted: boolean; var ImageIndex: integer);
      procedure vst_favfileEditing(Sender: TBaseVirtualTree; Node: PVirtualNode;
         Column: TColumnIndex; var Allowed: boolean);
      procedure vst_favfileNewText(Sender: TBaseVirtualTree; Node: PVirtualNode;
         Column: TColumnIndex; NewText: WideString);
      procedure vst_favfileDragOver(Sender: TBaseVirtualTree;
         Source: TObject; Shift: TShiftState; State: TDragState; Pt: TPoint;
         Mode: TDropMode; var Effect: integer; var Accept: boolean);
      procedure vst_favfileMouseMove(Sender: TObject; Shift: TShiftState;
         X, Y: integer);

      procedure vst_favfileMouseUp(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: integer);
      procedure pumOrdnerHinzufuegenClick(Sender: TObject);
      procedure img_linkClick(Sender: TObject);
      procedure tbi_wvldocClick(Sender: TObject);
      procedure dbtv_LgrArcStartDrag(Sender: TObject; var DragObject: TDragObject);
      procedure dbtv_LgrArcEndDrag(Sender, Target: TObject; X, Y: integer);
      procedure vst_favfileKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure dbgrd_TrefferlisteMouseWheel(Sender: TObject; Shift: TShiftState;
         WheelDelta: integer; MousePos: TPoint; var Handled: boolean);
      procedure tbx_noteimgreenClick(Sender: TObject);
      procedure tbx_noteimyellowClick(Sender: TObject);
      procedure tbx_noteimredClick(Sender: TObject);
      procedure tbi_createemptypageClick(Sender: TObject);
      procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: boolean);
      procedure tbi_savepdfsasonefileClick(Sender: TObject);
      procedure tbi_savetifsasonefileClick(Sender: TObject);
      procedure timer_autoscrollTimer(Sender: TObject);
      procedure tmb_VoransichtKeyDown(Sender: TObject; var Key: word;
         Shift: TShiftState);
      procedure tbx_wvlfavbear0Click(Sender: TObject);
      procedure tbx_wvlfavdelbearClick(Sender: TObject);
      procedure tbi_docdupClick(Sender: TObject);
      procedure tbx_zuspflichtdebugClick(Sender: TObject);
      procedure tbxi_symlinkClick(Sender: TObject);


      procedure tbi_expcsvClick(Sender: TObject);
      procedure tbi_expxlsClick(Sender: TObject);
      procedure tbi_expodsClick(Sender: TObject);
      procedure tbi_manuscanClick(Sender: TObject);
      procedure tbi_historyClick(Sender: TObject);
      procedure tbi_hideposvtxClick(Sender: TObject);
      procedure tbxse_pageChange(Sender: TObject; const Text: String);
      procedure tv_leseDblClick(Sender: TObject);
      procedure tv_leseDragOver(Sender, Source: TObject; X, Y: Integer;
         State: TDragState; var Accept: Boolean);
      procedure tv_leseEditing(Sender: TObject; Node: TTreeNode;
         var AllowEdit: Boolean);
      procedure tv_leseMouseMove(Sender: TObject; Shift: TShiftState; X,
         Y: Integer);
      procedure tv_leseDragDrop(Sender, Source: TObject; X, Y: Integer);
      procedure tbi_normalmouseClick(Sender: TObject);
      procedure tbi_freihandClick(Sender: TObject);
      procedure tv_leseKeyUp(Sender: TObject; var Key: Word;
         Shift: TShiftState);
      procedure tbi_objauswahlClick(Sender: TObject);
      procedure tbi_textfirstClick(Sender: TObject);
      procedure tbi_textsecondClick(Sender: TObject);
      procedure tbi_grphikoptionenClick(Sender: TObject);
      procedure btn_backClick(Sender: TObject);
      procedure btn_forwardClick(Sender: TObject);
      procedure tbi_stiftsecondClick(Sender: TObject);
      procedure tbi_stiftthirdClick(Sender: TObject);
      procedure tbi_stiftfourthClick(Sender: TObject);
      procedure tbi_stiftfifthClick(Sender: TObject);
      procedure tbi_highlightsecondClick(Sender: TObject);
      procedure tbi_highlightthirdClick(Sender: TObject);
      procedure tbi_highlightfourthClick(Sender: TObject);
      procedure tbi_highlightfifthClick(Sender: TObject);
      procedure tbi_textthirdClick(Sender: TObject);
      procedure tbi_textfourthClick(Sender: TObject);
      procedure tbi_textfithClick(Sender: TObject);
      procedure tbx_noteimblueClick(Sender: TObject);
      procedure tbx_noteimorangeClick(Sender: TObject);
      procedure tbsi_localspeichernClick(Sender: TObject);
      procedure tbi_configurationClick(Sender: TObject);
      procedure tbsi_stifteClick(Sender: TObject);
      procedure tbxs_textClick(Sender: TObject);
      procedure tbsi_notizenClick(Sender: TObject);
      procedure dpnl_manfavClose(Sender: TObject);
      procedure tv_leseMouseDown(Sender: TObject; Button: TMouseButton;
         Shift: TShiftState; X, Y: Integer);
      procedure tv_leseEdited(Sender: TObject; Node: TTreeNode;
         var S: String);

      function CreZusPum(ParentMenu: TMenuItem; OnClickFunction: TNotifyEvent;
         BaseName: string; fsavezus: boolean): boolean;
      procedure tbsi_highlightClick(Sender: TObject);
      procedure tbi_GesammelteDokumenteAlsEinPdfVersendenClick(Sender: TObject);
      procedure tmb_VoransichtMouseEnter(Sender: TObject);
      procedure tmb_VoransichtMouseLeave(Sender: TObject);
      procedure tbi_filterwvlClick(Sender: TObject);
      procedure dbgrd_WvlKeyDown(Sender: TObject; var Key: Word;
         Shift: TShiftState);

      procedure btn_WvlWeiterleitenClick(Sender: TObject);
      procedure tbxse_pageAcceptText(Sender: TObject; var NewText: String;
         var Accept: Boolean);
      procedure tbx_delcolltedClick(Sender: TObject);
      procedure tbx_stempeldiagClick(Sender: TObject);
      procedure tbbt_searchClick(Sender: TObject);
      procedure tbxb_resetClick(Sender: TObject);
      procedure tbi_deldocClick(Sender: TObject);
      procedure dpnl_WvlgResize(Sender: TObject);
      procedure tbix_showallwvlClick(Sender: TObject);
     
    procedure tbi_GemerktesDokumentClick(Sender: TObject);
    procedure tbi_DokumentMerkenClick(Sender: TObject);
    procedure tmb_VoransichtDrawProgress(Sender: TObject; per,
      idx: Integer);
    procedure pumOrdnerLoeschenClick(Sender: TObject);
    procedure tbxs_lesezeichenPopup(Sender: TTBCustomItem;
      FromLink: Boolean);
    procedure Ed_advuser_edtKeyPress(Sender: TObject; var Key: Char);
    procedure pum_favtreePopup(Sender: TObject);
    procedure dbgrd_TrefferlisteStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure dbgrd_TrefferlisteEndDrag(Sender, Target: TObject; X,
      Y: Integer);
      procedure ImgHomeEndClick(ipage: integer);
    procedure tbxtm_delbfahitClick(Sender: TObject);
    procedure tbxtm_AnnoDeleteClick(Sender: TObject);
    procedure dbgrd_TrefferlisteCellClick(Column: TColumn);
    procedure dbgrd_TrefferlisteColExit(Sender: TObject);
   private
      { Private-Deklarationen }
      FBM1: Tbookmark;
      FBM2: Tbookmark;
      fiframe: integer;
      fbloadinarc: boolean;
      fbmouseinthumb: boolean;
      fbfailcauselock: boolean;
      fbsaving: boolean;
      fbedtingtv_levenode: boolean;
      ftnlastbacknode: TTreenode;
      ffirststart: boolean;
      floginexit: TModalResult;
      freset: boolean;
      fselectingthumb: boolean;
      fbscroll_down: boolean;
      fpvnhistofav: TTreenode;
      fpvnlokalefav: TTreenode;
      ftci_InUseonceclicked: boolean;
      fcmdzusfieldsearch: string;
      fcmdzusvaluesearch: string;
      ZusFldFrame: TFrameZusFldMulti;
      fstdir: string;
      fbturned: boolean;
      lfpmystrtowords: TFPStrWords;
      lfpmystrtowords1: TFPStrWords;
      fbopeningeditor: boolean;
      fDragging : boolean;

      procedure BtnEnableSave(Sender: TObject);
      procedure OnStsClick(Sender: TObject);
      procedure ReadStatus;

      procedure LoadBriefPapier(FileName: string);
      procedure MergeLayers(iLayer0, iLayer1: integer);
      procedure askforsave;
      procedure searchforzusfields;
      procedure getzusfieldsarc(fname: string; ChildList, ChildzusList: TStringList);
      function SuchZus: boolean;
      function activateimg_docview: boolean;
      function activatethumbs: boolean;
      function Shiftgedr: Boolean;
      function Strggedr: Boolean;
      procedure Markieren(Sender: TObject);
      procedure Markieren2(Sender: TObject);
      procedure convertdelv2wlt;
      function  areAddFieldsValid (): Boolean;
      procedure onExitComboBox (Sender: TObject); 
      procedure OnAddfieldDropDown(Sender: TObject);
		procedure OnAddfieldCloseUp(Sender: TObject);
   public
      fnd_ext: string;
      flanguage: string;
      fdatestringempty: string;
      flastdoc_edit: Tfrm_DocEdit;
      farrayofdoceid: array of Tfrm_DocEdit;
      faplugins: array of Tplugin;
      fav_nr: integer;
      CF_RTF: word;
      fbAufrufUeberDocId: boolean;
      fshowwvldoc: boolean;
      fbisktstamp: boolean;
      fdocinusrwvl: boolean;
      fidropnode: integer;
      fslsearchcolumnsadds: Tstringlist;
      fgchangedvoransicht: boolean;
      fgchangedvoransichttif: boolean;
      fbshowwvlbutton: boolean;
      property reset: boolean Read freset Write freset;
      property BM1: TBookmark read FBM1 Write FBM1;
      property BM2: TBookmark read FBM2 Write FBM2;
      procedure DelStatus;
      procedure CreStatus; 
      procedure Loadbfaandsearch;
      procedure loadfavdelwvlhints;
      procedure loadfavwvlhints;
      procedure fillSearchWithNode(fDomNode: TDomNode; bAddSearch:Boolean);

      procedure searchWithNode(fDomNode: TDomNode);
      procedure UpdateTreeView(const Doc: TdomDocument; fmytviewX: TTreeview; fbAppendfirst: boolean);
      procedure logtoMemo(msg: string);
      procedure EnableSaveOnChange(Sender: TObject);
      procedure MehrfachRestoreScrollbar(Sender: TObject);
      procedure MehrfachGetScrollbar(Sender: TObject);
      procedure MehrfachRestoreAndUnset(Sender: TObject);
      procedure sbx_ZusFeldCanResize(Sender: TObject; var NewWidth,
			  NewHeight: Integer; var Resize: Boolean);
		procedure sbx_ZusFeldVerticalScroll(Sender: TObject);           
      procedure EnableSaveOnKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure ZusFlsTyp0EditKeyPress(Sender: TObject; var Key: Char); //3.5.0.22

      procedure nDelay(ATime: dword); 
      { Public-Deklarationen }
      procedure EnableSaveBtn;
      procedure GoToDocID;
      procedure ShowFrame(frame: integer);
      procedure ShowLgrArc;
      procedure ShowThumbs;
      procedure ReadCbxUsr;
      procedure ReadLgrArcTree;
      procedure ReadSysArc;
      procedure InitViewer;
      procedure ShowVoransicht(FirstPage: boolean);
      procedure ShowVoransichtNorefresh;
      procedure ShowVolltext;
      procedure ShowDocLink;
      procedure ShowHistory;
      procedure GetArcUsrRights;
      procedure GetDocUsrRights(fbuserights: boolean);
      procedure UseRights(RightData: TRData);
      procedure HandleDoc;
      procedure ChangeDocPage(Func: integer);
      procedure ChangeDocPagenorefresh(Func: integer);
      procedure ActivateLinkDoc(Active: boolean);
      function CreZusFields(isVerschlagwortungsHilfe: boolean): integer;
      function DelZusFields2(fbrdbgrd: boolean): integer;
      function ClearZusFields: boolean;
      function ClearZusFieldsNotsearched: boolean;
      procedure FillZusFields;
      procedure SaveZusFields;
      function ZusFieldsChanged: Boolean;
      procedure ResetTrefferliste;
      procedure ResetAnzeige;
      procedure ResetStatus(bKeepSearched: Boolean = False);
      procedure resetSuchFelder;
      procedure SetControls(Active: boolean); //3.5.0.22
      procedure ExportArc;
      procedure LoadThumbs(fipage: integer; fbreset: boolean);
      procedure ReadFndFile(FileName: string);
      procedure CheckScreenRes;
      procedure ShowDocsKW(Year, KW: integer);
      function TimeSQL(SQLCMD: string): boolean;
      procedure FillControls(Showstati: bool);
      procedure InitDocTime;
      procedure ReadCbxUsrNG;
      procedure ShowDocsDate(Datum: TDateTime);
      procedure SwitchControls(Func: integer);
      procedure ShowMAOpen;
      procedure ShowMAWork;
      procedure ShowMADone;
      procedure ShowMATasks;
      procedure CancelStatus;
      procedure RefreshStatus;
      procedure MergeAnnotation;
      procedure CreateStandardColumnsTRefferliste;
      procedure wvlshowbuttons(fshow: boolean);
      procedure resetmyqarc;
      function CheckBookmark: boolean;
      function ReadReg: boolean;
      function CheckReg: boolean;
      function ReadFav(Favorit: integer; fsetfocus: boolean): boolean;
      function ArcSQL(SQLCMD: string): boolean;
      function LgrArcSQL(SQLCMD: string): boolean;
      function TmpSysArcSQL(SQLCMD: string): boolean;
      function LnkSQL(SQLCMD: string): boolean;
      function TmpSQL(SQLCMD: string): boolean;
      function TmpSQL_2(SQLCMD: string): boolean;
      function HistSQL(SQLCMD: string): boolean;
      function TmpMoveSQL(SQLCMD: string): boolean;
      function DocShowTmpSQL(SQLCMD: string): boolean;
      function MakeArcQuery(tblname:String): string;
      function SuchArc: boolean;
      function QueryArc(QueryString: string): boolean;
      function NewHistory(Funktion: integer; Text: string): boolean;
      function PrintDoc(ShowPrintDlg, ShowPageDlg: boolean): boolean;
      function MoveDoc(var SrcArcID, DesArcID, SrcDocID, NewDocID: integer; slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType: TStringList; lbhaszusfield: boolean ): boolean;
      function ShutDownApp(fic: integer): boolean;
      procedure DisableAllTimer;
      function SaveLgrArcStat: boolean;
      function LoadLgrArcStat: boolean;
		function LoadStdArc: Boolean;
      function Loadtv_leseStat: boolean;
      function Savetv_leseStat: boolean;
      function CheckTasks: boolean;
      function GetIEV(sDoc, sCop: string): string;
      function ColorBetween(C1, C2: TColor; blend: real): TColor;
      function ColorsBetween(colors: array of TColor; blend: real): TColor;
      function ngFilesInDir(sNGPath: string): integer;
      function ExitentFilesInDir(fsPath: string): integer;
      function DelLnk: boolean;
      function Savefavtree: boolean;
      procedure loadfavstampvalues(fktag: integer; favtext: string);
      procedure addToXmlFile(filename: string; fbaskforname: boolean);
      procedure HandleParam(const Param: string);
      procedure uncheckallgraphictools;
      procedure setpanelinfo(fmyinfo: String);
      procedure SetStatusText(Panel:integer; AText: String);
      function GetStatusText(Panel:integer): String;
      procedure SetStatusHint(Panel:integer; AText: String);
      procedure DoSearchonEnter(Sender: TObject; var Key: word; Shift: TShiftState);
      procedure ZustaendeAnnotationBearbeitenSetzen;
      procedure EnableGraphicTools(Ausgeblendet : Boolean);
      procedure ShowAnnoData(annodata: PAnnoData);
      procedure OpenDocEditor;
      procedure ResetPanelInfo;
      procedure AfterSaveObjects;
      procedure AfterEdit;
      procedure SeiteSetzen;
      procedure ColumnMoved;
      procedure WVLColumnMoved;
      function OperationLock: boolean;

   protected
      procedure WMDROPFILES(var Msg: TWMDropFiles); message WM_DROPFILES;
      procedure LBWindowProc(var Message: TMessage);
      procedure WndProc(var Msg: TMessage); override;
      procedure CreateParams(var Params: TCreateParams); override;

      procedure ButtonsRechtsClick(Sender: TObject); //m.frey
      procedure dbtv_LgrArcSet (bAddSearch: Boolean;
                                isClick   : Boolean); //3.5.0.58 [2328]
      function GetVolltext:string; //[2487]
   public
      fra_Nix       : Tfrm_Nix;
      fra_DocLink   : Tfrm_DocLink;
      fra_History   : Tfrm_History;
      fra_Volltext  : Tfrm_Volltext;
      fra_Voransicht: Tfrm_Voransicht;
   end;

type
   PTreeData = ^TTreeData;

   TTreeData = record
      Caption: string;
      Column1: string;
      domnode: TDomNode;
      nr: integer;
      index: integer;
   end;

   TVirtualFile = record
      ArcID: integer;
      Name: string;
      PVNode: PVirtualNode;
      domnode: TDOMnode;
      lbglobal: boolean;
   end;

   TWheelDBGrid = class (TCRDBGrid)
   public
      property OnMouseWheel;
   end;

var
   frm_MainForm: Tfrm_MainForm;

   // Globale Variablen
   // iGArcID            : aktuelle Archiv ID
   // iGLArcID           : letzte Archiv ID (damit hufige DB Anfragen verhindert werden!)
   // iGLgrID            : aktuelle Lager ID
   // iGDocID            : aktuelle Dokumenten ID
   // iGUsrID            : aktuelle Benutzer ID
   // iGRefID            : aktuelle Referenz ID
   // iGZusFCount        : Anzahl der zustzlichen Felder eines Archives
   // iGArcRecNo         : Nummer des letzten Archiv Records
   // iGBorderRem        : Anzahl der Rand-Entfernungs Aufrufe fr ein Dokument
   // iGMagLayer         : Nummer der Lupen-Layers
   // iGUseStdPrn        : Index des Standard Dokumentendruckers
   // iGRArcID           : Arc ID des zum Verknpfen gemerkten Dokumentes
   // iGRDocID           : Doc ID des zum Verknpfen gemerkten Dokumentes
   // iGBriefLayer       : Layer mit dem Briefpapier
   // iGTaskCount        : Anzahl der aktuellen Dokumente in der Wiedervorlage
   // sGArcName          : Bezeichnung des aktuellen Archives
   // sGUsrName          : Name des aktuellen Benutzers
   // sGLgrName          : Bezeichnung des aktuellen Lagerortes
   // sIArcName          : Tabellenname des aktuellen Archives ??? Bentigt ??? m.frey: ja
   // sGRefName          : aktuelle Referenz-Bezeichnung
   // sGTmpName          : Tabellenname der Temporren Benutzer-Tabelle
   // sGUsrEMail         : eMail Adresse des aktuellen Users
   // sGConnection       : Pfad und Dateiname auf .Con Datei
   // sGMaxHits          : String mit der Anzahl der maximalen Treffer
   // sGCopyPath         : Pfad auf das nderungsarchiv-Rootverzeichnis
   // sGArcPath          : Pfad auf das Archiv-Rootverzeichnis
   // sGClntSpool        : Pfad auf das Clientspooler Verzeichnis
   // sGBriefPapier      : Pfad und Datei mit den Briefpapier des Archives
   // sGSha1ErrorMsg     : Meldungstext wenn Prfsumme eines Dokumentes nicht stimmt
   // bGImageDisp        : Bit ob ein Bild angezeigt wird
   // bMultiArcQuery     : Bit ob mehrere Quellen in der Trefferliste sind
   // bAutoPreview       : Bit ob automatisch immer zur Voransicht gewechselt werden soll
   // bFillZusFields     : Bit ob Zusatzfelder gefllt werden.
   // bGAddAsterix       : Bit ob * vor jedes Wort gesetzt wird
   // bGAppAsterix       : Bit ob * nach jedem Word gesetzt wird
   // bGVTXSLW           : Bit ob mit dem Volltext auch in den Schlagworten gesucht werden soll
   // bGLstDocInUse      : Bit ob nur Dokumente in Benutzung angezeigt werden
   // bAutoDispNew       : Bit ob Automatisch die neusten 50 Dokumente angezeigt werden sollen
   // bParamHandled      : Bit ob die Startparameter schon bearbeitet wurden
   // bExportPDF         : Bit ob fr den Export, PDF-Dateien erstellt werden
   // bUseIntMail        : Bit ob fr das Senden von Dokumenten Links der Interne Mailer (true) oder Mapi (false) verwendet wird
   // rGArcRight         : Record mit den Rechten auf das aktuelle Archiv
   // rGDocRight         : Record mit den Rechten auf das aktuelle Dokument
   // GArcSList          : Array mit Archivinfo Records (Suche)

   privAnnoCnt: integer = 0;

   //  08.07.2010  Vers. 3.5.0.86  [2648]  r.sch.
   globalEventLock: boolean;  //  Verhindert die Unterbrechung eines Vorgangs
                              //  durch eine Event,
                              //  wie z.B. MouseClick oder KeyPressed

   tsh_fertigcolor, tsh_bearbeitungcolor, tsh_offencolor, iWvlID, iWvlIDNG,
   // ID fr wiedervorlage referenz
   iGArcID, iGLArcID, iGLgrID, iGDocID, iGUsrID, iGGrpID, iGRefID,
   iGRecNo,     // aktuelles RecordSet in der Trefferliste (wird zur Selektion bentigt)
   iGRefLNK, // save the link_ref
   iGRefIDNG, iGLastDocid, igLastArcid,
   iGPrivAnnoID,// save the id from requested user priv anno
   iGZusFCount, iGArcRecNo, iGBorderRem, iGBriefLayer, iGMagLayer,
   iGUseStdPrn, iGRArcID, iGRDocID, iGTaskCount, posx, numfiles,
   // gtmpiStatus (global tmp iStatus) saves the temporary doc_state till it is saved in tbn_SaveDoc. it should be set when the document ist read
   gtmpiStatus,
   // gotmpiStatus, (global original tmp iStatus) saves the original status, check for changes
   gotmpiStatus, gmodiStatus, // check if status really changed!
   gmodsearchiStatus, gmodnegiStatus,
   //    loadingfromwclcellclick flag for reloading wvl so it dont stay marked!
   loadingfromwclcellclick, igwvlrow, iGRefRemDocID,
   // save ids for creating ref with another existing ref
   iGRefRemArcID, iGmaxhits, iGdocidtmp, iGarcidtmp, lidebuglevel,
   ComingFromFav, //Boolean to indicat where the Question com from NG0611271350
   givirstualfiles, giactivedoclock, iGLastArcAnnos, iGLastDocAnnos,
   giRegKeyArchived, iGdbtvIdx, igZusFieldPos
      : integer;
   giLeftCol : Integer = 1;
   gi64docrev, gi64docver,
   giglobalgdocid, //global doc_id
   gidoclock
   : int64;


   sGArcName, sGUsrName, sGLgrName, sIArcName, sGRefName, sGTmpName,
   sGdocfilename, sGextfilename, sGdocfilenameloadedbythread, sGExtfilenameloadedbythread,
   sGUsrEMail, sGConnection, sGMaxHits,
   sGCopyPath, sGArcPath, sGclientprogram, sGClntSpool, sGBriefPapier,
   sGSha1ErrorMsg, fsinfo,
    ng_lastArc, ng_lastdoc, ng_EmailAdr, ng_EmailBet,
   ResultlistDesignPath, ZusNGFieldName, 
   ngtimeserver,
   lastloadedArcName, WhoisMyServer,
   // Name des in my_con angewaehlten bitfarm Archiv Servers
   sGRArcName, Gsorderby, Gsmy_q_arc, GsWindowsVersion, gstbxpubannotmp,
   sIglobalArcName, sGbh_MainText,
   gshardlarcname, GsIArcName, sGEmailAdr, sGEmailBet: string;

   dazuversenden, // Boolean aufgrund 
   FirstTimeWVL, // Boolean ist true wenn viewer das erstemal nach der Installation gestartet wird
   optbybut, ngdoctimer,
   //wenn true dann ist die Funktion Option aus dem Programm heraus ber diesch aschaltflche angefordert worden
   tifbysave, //wenn true dann ist das Speichern vn btn save fr Tiffdatei angefordert worden
   oribysave, //wenn true dann ist das Speichern von btn Save fr Originaldatei angefordert worden
   pdfbysave, //wenn true dann ist das Speichern vom btn Save fr PDF Datei angefordert worden
   ngrstime, showNoAnno,
   // willentliche enscheidung des U die annotation nicht anzuzeigen trotzdem Annos vorhanden
   HPTorOpen,       // ist true wenn die HandleParam Routine angesteuert werden darf.
   TimeSQLTor,      // ist true wenn die Time SQLroutine angesteurt werden darf.
   ngAliveMainform, // ist true wenn die Main form auf dem Bidlschirm erstellt wurde
   gbStarted2, // ist true wenn ein bestimmter Punkt bei der Initialisierung erreicht wurde
   dpnl_firsttime, ngdocClickOpen, handleparamaktiv, wvldebug,
   FndRbnu, isCompOs,
   // true wenn ein brauchbares OS GEfunden wurde
   hithasfocus, comingFromCreZusPum, GHasNotBeenSavedAfterModify,
   // Ist True wenn ein Dokument gedreht, invertiert, oder anderweitig veraendert wurde
   GotInputfromMenue,
   // ist true wenn daten aus dem pum des Volltext in ein zusatzfeld uebertragen wurden
   nog_hasbeensent, 
   wvlhasfocus,
   datezusfield, // iskywalker20070612 for correction on the sql request
   createnewlink, // did or didnt cancel on    frm_MainForm.fra_DocLink.CreLink
   gbeditdoc, gbwvlcellclick,// dont wvlexit if wvlcellclick
   gbshowresults, gbsearched, Gbwfcancel, gbfirstpage, gbarclick,
   gbshutdownapp, gbchangezoomtextnotview, gbAppStarted, gbprintingdoc,
   gballasonefile, gbbegindragtrefferliste, gbzdvc, gbwvldockin,
   gbsendthisemailnow, bAlive,
   // bAlive ist eine Torlogik die beim anwahlen von wvlzeilen die Schritkette sichert NG
   tor02open,
   gbLgrArcSet, gbDocMove, gbArchivChange, gbSaveDoc, fbtimcheck,
   gbhasdoclock,
   gbhasgdocid,
   gbAnnoNotAccessible,
   gblastclickedlager,
   gbsearchcheckedcombobox,
   bgisverlauffav,
   gbchangevaluespinpage,
   gbdoceditformshowed,
   gbdontsetpage,
   gbcfgxs,
   gbsearching,
   gbsendasonepdf,
   gbkleiner3400,
   gbhasctrlwvl,
   gbhasoutlookasstd,
   gbcmdzussearch,
   gbmysqldebug,
   gbRefSearchbyFavorite,
   gbholyday,
   gbIsWin64,
   gbSavLgrArc,
   gbViewerShutdown,
   gbTrefferlisteFiltered, gbStartSrcClick,
   gbColumnMoved, gbAddfieldDropDown, gbGetZusfieldPos, gbChangeInCombobox,
   gbFillZusfields		 //blockt OnChange-Methoden der Zusatzfelder bei programmatischen nderung (FillZusfields, ClearZusfields, etc.)


   : boolean;

   bGImageDisp, bMultiArcQuery, bAutoPreview, bFillZusFields, bGLstDocInUse,
   bGAddAsterix, bGAppAsterix, bGVTXSLW, bAutoDispNew, bParamHandled,
   bExportPDF, Nog_EAnDel, gbArcHandling, bUseIntMail,
   WvlCellClickopen, tomtom, TrefferListeAlreadyLoaded,
   // Wenn die Trefferliste im db Grid bereits geladen ist soll die Liste nicht mehr veraendert werden
   istrefferliste, Gbadvusrsrc, gbansichtlesen, Gbcrproridoc,
   gbsettingdone, gbNoteslwrecord, gbNotevtxrecord,
   gbOleoutlook, gbchangepagebyenter, gBvolltextkeywordspdf: boolean;
   rGArcRight, rGDocRight: TRData;

   Subject, Mailtext, FromName, FromAdress, ToName, ToAdress,
   AttachedFileName, DisplayFileName,
   sfirstselecteditem, ssomeselecteditem, stempselecteditem,gsstandarddir: string;

   gfWindowsVersion: double;
   ShowDialog: boolean;

   lbl_zuf, gaspreferedtifname: array of string;
   iGBriefLayers: array[0..2] of integer;
   gai_sts_rights: array of boolean;
   gai_cfg_rights: array of boolean;

   listOfPrivAnnos: boolean = False;

   // variables need for saving state correctly and save history
   // they are bound with gtmpiState and gotmpistate
   // could be done a class but with only one instance it is a stile aspect only
   // what should be done when cleaning the code is something like: gtmpstatus[][3] string

   gtmphistory, gtmphinttag, gtmphhsvalue, gasfavstemp: array of string;
   iGTim_id: array of integer;
   GaiPagesbytes: array of integer;
   GaiPagesSelectedtmb: array of integer;
   GSelection : array of Integer;
   GArcSList: array of TAData;
   GZusSList: array of TZData;
   GSysArc: array of TArcData;
   tGStart: TTime;
   iGKW, iGKWYear, iGYear, iGTimRef, iGTimRec, iGTimID, iGTimArcID, iGTimDocID: integer;

   debugstr01, sZusTextOG1, sZusTextUG1: string;

   // needed for zoom on the mouse point
   MousePositionVoransicht: Tpoint;
   MousePositionvts_fav: Tpoint;
   MousePositiontv_lese: Tpoint;
   bh_MainPos : TPoint;
   
   expopath: string; 
   tsl_export, gtsl_ansicht, gtsl_markedids: TStringList;
   gFormatSettings : TFormatSettings;

   // temp variables, will be modified or deleted in future versions
   thr_voransicht: TTVoransicht;
   thr_docview: TTdocview;
   GTrOldLBWindowProc: TWndMethod;
   gcsListAnsicht: TCriticalSection;
   gpvnvirstualfiles: array of TVirtualFile;
   gbBlockVoransicht : Boolean; // um die Voransicht zu blockieren z.B. beim Verschieben von Docs (vtiger 2182)
   gVorigesDocViewSave:TDocViewSave; // das vorherige Doc
   gDocViewSaves : TDocViewSaves; // um die Ansicht von Dokumenten zu speichern
   giGoToPage : integer;



//-----------------------------------------------------------------------------
implementation
//-----------------------------------------------------------------------------


uses u_dm_DB, u_Info, u_Login, u_NewPass, u_DeSpeckle,
   u_SlwEdit, u_Optionen, u_dm_DocEditor, u_DelDoc,
   u_SendMailLnk, u_AskSendMail, u_dm_Skins,
   u_WaitInfo, u_PrintPreview, u_AddDocTimer, u_WvlEdit,
   u_EditInfo, u_DocEditAsk, u_askSendMailType, u_MailForm, u_TechInf,
   u_askForSave, u_ShStamps, Math, imageen,
   U_getmac_iphlpapi, ComObj, u_openoffice,
   u_DocEditOpt,
   u_ShDefs, u_ShSql, u_ShCompUtils, u_ShDlgAddFields,
   u_wvlwlt;

{$R *.dfm}

const
  gLocalLog = False;
  gcnrs  = $008489a9; //c0e1ff  //00a3d4ff   //8489a9


var
   dc: HDC;
   GaugePanelCanvas: TCanvas;

//-----------------------------------------------------------------------------
function GetNumScrollLines: integer;
begin
   SystemParametersInfo(SPI_GETWHEELSCROLLLINES, 0, @Result, 0);
end;

//-----------------------------------------------------------------------------
function FindAllWindows(const WindowCaption: string): THandleArray;
type
   PParam = ^TParam;
   TParam = record
      WindowCaption: string;
      Res: THandleArray;
   end;
var
   Rec: TParam;
   function _EnumProc(_hWnd: HWND; _LParam: LPARAM): longbool; stdcall;
   var
      cTitle: array[0..1023] of char;
   begin
      with PParam(_LParam)^ do
      begin
         GetWindowText(_hWnd, cTitle, SizeOf(cTitle));
         if (CompareText(cTitle, WindowCaption) = 0) then
         begin
            SetLength(Res, Length(Res) + 1);
            Res[Length(Res) - 1] := _hWnd;
         end;
         Result := True;
      end;
   end;
begin
   Rec.WindowCaption := WindowCaption;
   SetLength(Rec.Res, 0);
   EnumWindows(@_EnumProc, integer(@Rec));
   Result := Rec.Res;
end;

//-----------------------------------------------------------------------------
function SwapOps(InputStr: string): string;
begin
   Result := StringReplace(InputStr, ' and ', ' dna ', [rfReplaceAll]);
   Result := StringReplace(Result, ' or ', ' ro ', [rfReplaceAll]);
   Result := StringReplace(Result, ' dna ', ' or ', [rfReplaceAll]);
   Result := StringReplace(Result, ' ro ', ' and ', [rfReplaceAll]);
end;

//-----------------------------------------------------------------------------
procedure GetChilds(StartNode: TTreeNode; ChildList: TStringList);
//////////////////////////////////////////////////////////////////
///  03.05.2005 Erstellt by SV.                                ///
///                                                            ///
///  Diese Procedur wertet alle Unterknoten von StartNode aus  ///
///  Und liefert das Ergebnis an eine Stringliste              ///
///                                                            ///
///  Ausgabe: 'ArcName'.Object(ArcID) in ChildList             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   SubNode: TTreeNode;
begin
   SubNode := StartNode.GetFirstChild;
   while Assigned(SubNode) do
   begin
      GetChilds(SubNode, ChildList);
      if SubNode.ImageIndex = 1 then
         ChildList.AddObject(SubNode.Text, TObject(SubNode.Data));
      SubNode := SubNode.getNextSibling;
   end;
end;

//-----------------------------------------------------------------------------
function ChkJok(InputStr, Joker: string; AppJok, AddJok: boolean): string;
   //////////////////////////////////////////////////////////////////
   ///  30.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function berprft einen Eingangsstring auf Platz-  ///
   ///  halterzeichen und ersetzt und ergnzt diese bei Bedarf    ///
   ///                                                            ///
   ///  Parameter: InputStr        String mit Suchbegriffen       ///
   ///             Joker           String mit Platzhalter         ///
   ///             AddJok          Ergnzt alle Suchbegriffe      ///
   ///             AppJok          automatisch um Platzhalter     ///
   ///                                                            ///
   ///  Ausgabe: SQL-Teil einer Where Klausel als String          ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
begin
   Result := InputStr;
   if AddJok and (InputStr[1] <> '*') then
      Result := Joker + Result;
   if AppJok and (InputStr[Length(InputStr)] <> '*') then
      Result := Result + Joker;
   if (InputStr[1] = '*') then
      Result[1] := Joker[1];
   if (InputStr[Length(InputStr)] = '*') then
      Result[Length(Result)] := Joker[1];
end;

//-----------------------------------------------------------------------------
function CreZusPum(ParentMenu: TMenuItem; OnClickFunction: TNotifyEvent;
   BaseName: string; fsavezus: boolean): boolean;
   //////////////////////////////////////////////////////////////////
   ///  12.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Erzeugt fr ParentMenu ein neues Untermen                ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschl                               ///
   ///  Create Zusatzfelder
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount: integer;
   TmpLbl: TJvStaticText; 
   TmpMnu: TMenuItem;
begin
   frm_mainform.sbx_ZusFEld.Autoscroll := False;
   Result := True;
   ParentMenu.Clear;

   for iCount := 0 to (frm_MainForm.sbx_ZusFeld.ComponentCount - 1) do
   begin
      if frm_MainForm.sbx_ZusFeld.Components[iCount] is TJvStaticText then
      begin
         try
            TmpLbl := TJvStaticText(frm_MainForm.sbx_ZusFeld.Components[iCount]);
            TmpMnu := newItem(Copy(TmpLbl.Caption, 0, Length(TmpLbl.Caption) - 1),
               0, False, True, OnClickFunction, 0, BaseName + IntToStr(iCount));
            ParentMenu.Add(TmpMnu);
            TmpMnu.Hint := TmpLbl.Name;
            TmpMnu.ImageIndex := 63;
         except
            on e: Exception do
            begin
               ErrorMsg('CreZusPum', _('Fehler beim Erstellen eines Untermens:') +
                  e.Message, 2000, True);
               Result := False;
               if Assigned(TmpLbl) then
                  FreeAndNil(TmpLbl);
               if Assigned(TmpMnu) then
                  FreeAndNil(TmpMnu);
            end;
         end;
      end;
   end;
   comingFromCreZusPum := True;
   if fsavezus then
      frm_mainform.SaveZusFields;

   frm_mainform.sbx_ZusFeld.Autoscroll := True;
end;

//-----------------------------------------------------------------------------
function SemSubQuery(Feld: string; Worte: TStringList; AddJok, AppJok: boolean;
   Mode: byte): string;
   //////////////////////////////////////////////////////////////////
   ///  31.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function erstellt eine Semantische Sub-Query fr    ///
   ///  das Feld [Feld] mit den Worten aus [Worte]                ///
   ///                                                            ///
   ///  Parameter: Feld            String mit FeldName            ///
   ///             Worte           StringListe mit Worten         ///
   ///             AddJok          Ergnzt alle Suchbegriffe      ///
   ///             AppJok          automatisch um Platzhalter     ///
   ///             Mode            Stellt den Suchmodus ein       ///
   ///                                                            ///
   ///  Ausgabe: SQL-SubQuery mit Semantischer Abfrage            ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount: integer;
   sOpWort, sWort: string;
begin
   Result := 'Match (' + Feld + ') Against (' + #39;
   for iCount := 0 to Worte.Count - 1 do
   begin
      sOpWort := Worte[iCount];
      if IsDelimiter('+-', sOpWort, 1) and (Mode = 0) then
      begin
         sWort := Copy(sOpWort, 2, Length(sOpWort));
         if Length(sWort) > 2 then
            Result := Result + sOpWort[1] + ChkJok(sWort, '*', AppJok, False) + ' ';
      end
      else
      if IsDelimiter('+-', sOpWort, 1) and (Mode = 1) then
      begin
         sWort := Copy(sOpWort, 2, Length(sOpWort));
         if Length(sWort) > 2 then
            Result := Result + ChkJok(sWort, '*', AppJok, False) + ' ';
      end
      else
      begin
         sWort := sOpWort;
         if Length(sWort) > 2 then
            Result := Result + ChkJok(sWort, '*', AppJok, False) + ' ';
      end;
   end;
   Result := Result + #39 + ' IN BOOLEAN MODE)';
end;

//-----------------------------------------------------------------------------
function MakeRefQuery(InputStr, Field: string; AddJok, AppJok: boolean): string;
   //////////////////////////////////////////////////////////////////
   ///  30.08.2005 Erstellt by SV.                                ///
   ///  31.08.2005 Gendert durch SV aufgeteilt in Unterfunktionen///
   ///                                                            ///
   ///  Diese Function erstellt aus einem String eine SQL-Such-   ///
   ///  Anfrage. Auf Wunsch werden die Suchbegriffe automatsch um ///
   ///  Jokerzeichen erweitert.                                   ///
   ///                                                            ///
   ///  Parameter: InputStr        String mit Suchbegriffen       ///
   ///             Fields          StringListe mit Feldnamen      ///
   ///             AddJok          Ergnzt alle Suchbegriffe      ///
   ///             AppJok          automatisch um Platzhalter     ///
   ///                                                            ///
   ///  Ausgabe: SQL-Teil einer Where Klausel als String          ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount: integer;
   slWords, slAnd, slOr, slNot : TStringList;

   sOpWort: string;
begin
   Result := '';
   slWords := StrToWords(InputStr); // slWords mit Wrtern fllen
   slAnd := TStringList.Create;
   slOr := TStringList.Create;
   slNot := TStringList.Create;
   try
      for iCount := 0 to slWords.Count - 1 do
      begin
         sOpWort := slWords[iCount];
         if length(sOpWort) > 1 then
         begin
            case Ord(sOpWort[1]) of
               $2B:
                  slAnd.Add(Copy(sOpWort, 2, length(sOpWort)));
               $2D:
                  slNot.Add(Copy(sOpWort, 2, length(sOpWort)));
            else
               slOr.Add(sOpWort);
            end;
         end
         else
         begin
            slOr.Add(sOpWort);
         end;
      end;
      ///////////////////////////////////////////////////////////////////////////////
      // ...Und Teilquery Starten

      if slAnd.Count > 0 then
         // mehr als 2 Worte sollen per ver'und'ung gesucht werden
      begin
         for iCount := 0 to slAnd.Count - 1 do
         begin
            Result := Result +
               'doc_id in (Select Sql_No_cache distinct doc_id from :bitfarmslwtbl where ' +
               field + ' like ' + #39 + ChkJok(slAnd[iCount], '%', AppJok, AddJok) +
               #39 + ')';
            // Und-Teilquery - Feldstart Klammer
            if iCount <> (slAnd.Count - 1) then
               Result := Result + ' and '
            else
               Result := Result + ' '; // Und-Teilquery - Feldend Klammer
         end;
      end;
      //////////////////////////////////////////////////////////////////////////////////
      // Teilquery nicht Starten

      if slNot.Count > 0 then
      begin
         if Result <> '' then
            Result := Result + ' and ';
         for iCount := 0 to slNot.Count - 1 do
         begin
            Result := Result +
               'doc_id not in (Select Sql_No_cache distinct doc_id from :bitfarmslwtbl where '
               +
               field + ' like ' + #39 + ChkJok(slNot[iCount], '%', AppJok, AddJok) +
               #39 + ')';
            // Nicht-Teilquery - Feldstart Klammer
            if iCount <> (slNot.Count - 1) then
               Result := Result + ' and '
            else
               Result := Result + ' '; // Nicht-Teilquery - Feldend Klammer
         end;
      end;
      ///////////////////////////////////////////////////////////////////////////////////
      // Oder Teilquery Starten
      if slOr.Count > 0 then
      begin
         if Result <> '' then
            Result := Result + ' or ';
         for iCount := 0 to slOr.Count - 1 do
         begin
            Result := Result +
               'doc_id in (Select Sql_No_cache distinct doc_id from :bitfarmslwtbl where ' +
               field + ' like ' + #39 + ChkJok(slOr[iCount], '%', AppJok, AddJok) + #39 + ')';
            if iCount <> (slOr.Count - 1) then
               Result := Result + ' or '
            else
               Result := Result + ' '; // Oder-Teilquery - Feldend Klammer
         end;
      end;

   finally
      if Assigned(slWords) then
         FreeAndNil(slWords);
      if Assigned(slAnd) then
         FreeAndNil(slAnd);
      if Assigned(slNot) then
         FreeAndNil(slNot);
      if Assigned(slOr) then
         FreeAndNil(slOr);
   end;
end;

//-----------------------------------------------------------------------------
function MakeRefQuery2(InputStr : string; AddJok, AppJok: boolean; tblname: string): string;
// neue Version von MakRefQuery, da die nested-select query ( doc_id in (select *from slw_ ...)
// bei groen datenbanktabellen unendlich langsam ist.
// jetzt wird erst nach den schlagworten gesucht und dann die doc_ids als liste der
// anweisung bergeben (doc_id in (liste))

var
   iCount, i: integer;
   slWords, slAnd, slOr, slNot, slAndDocids, slTmpDocids, slOrDocids, slNotDocids   : TStringList;
   sOpWort, tmpsql, resultstr: string;
begin
   Result := ''; // Sicherheitshalber das Result initalisieren;
   slWords := StrToWords4(InputStr); // slWords mit Wrtern fllen
   slAnd := TStringList.Create;
   slOr := TStringList.Create;
   slNot := TStringList.Create;
   slAndDocids := TStringList.Create;
   slTmpDocids := TStringList.Create;
   slOrDocids := TStringList.Create;
   slNotDocids := TStringList.Create;

   try
   	if not DBTableExist('slw_' + tblname) then
      begin
          Result := 'doc_id in (0)';
          Exit;
      end;

      for iCount := 0 to slWords.Count - 1 do
      begin
         if (LeftStr(slWords[iCount],1) = '"') and (RightStr(slWords[iCount],1) = '"') then
         	slWords[iCount] := Copy(slWords[iCount], 2, Length(slWords[iCount]) -2);
         sOpWort := slWords[iCount];
         if length(sOpWort) > 1 then
         begin
            case Ord(sOpWort[1]) of
               $2B:	//  +
                  slAnd.Add(Copy(sOpWort, 2, length(sOpWort)));
               $2D:	//  -
                  slNot.Add(Copy(sOpWort, 2, length(sOpWort)));
               $2F:  //  /
               	slOr.Add(copy(sOpWort, 2, Length(sOpWort)));
            else
               slAnd.Add(sOpWort);
            end;
         end
         else
         begin
            slAnd.Add(sOpWort);
         end;
      end;

      if slAnd.Count > 0 then
      begin
         for iCount := 0 to slAnd.Count - 1 do
         begin
            if slAndDocids.Count > 0 then
            begin
               slTmpDocids.Text := slAndDocids.Text;
               slAndDocids.Clear;
            end;

            dm_DB.my_q_tmp_slw.SQL.Text := 'Select distinct(doc_id) from slw_' + tblname +
            	' where '+'(doc_slw like '+ #39 + ChkJok(slAnd[iCount], '%', AppJok, AddJok) + #39 + ')';
            dm_DB.my_q_tmp_slw.Execute;
            if dm_DB.my_q_tmp_slw.RecordCount > 0 then
            begin
               for i:= 0 to  dm_DB.my_q_tmp_slw.RecordCount - 1 do
               begin
                  if slTmpDocids.IndexOf(dm_DB.my_q_tmp_slw.fieldbyName('doc_id').asstring) = -1 then
   						slTmpDocids.Add(dm_DB.my_q_tmp_slw.fieldbyName('doc_id').asstring)
                  else
                     slAndDocids.Add(dm_DB.my_q_tmp_slw.fieldbyName('doc_id').asstring);
                  dm_DB.my_q_tmp_slw.Next;
               end;
            end;
         end;
         if (slAndDocids.Count = 0) and (slAnd.Count = 1) then  // wenn wir nur nach einem Wort gesucht haben
            slAndDocids.Text := slTmpDocids.Text;               // mssen wir den Inhalt der slTmpDocids nehmen
      end;

      if slOr.Count > 0 then
      begin
         for iCount := 0 to slOr.Count - 1 do
         begin
            dm_DB.my_q_tmp_slw.SQL.Text := 'Select distinct(doc_id) from slw_' + tblname +
            	' where '+'(doc_slw like '+ #39 + ChkJok(slOr[iCount], '%', AppJok, AddJok) + #39 + ')';
            dm_DB.my_q_tmp_slw.Execute;
            if dm_DB.my_q_tmp_slw.RecordCount > 0 then
            begin
               for i:= 0 to  dm_DB.my_q_tmp_slw.RecordCount - 1 do
               begin
						slOrDocids.Add(dm_DB.my_q_tmp_slw.fieldbyName('doc_id').asstring);
                  dm_DB.my_q_tmp_slw.Next;
               end;
            end;
         end;
      end;

      if slNot.Count > 0 then
      begin
         for iCount := 0 to slNot.Count - 1 do
         begin
            dm_DB.my_q_tmp_slw.SQL.Text := 'Select distinct(doc_id) from slw_' + tblname +
            ' where '+'(doc_slw like '+ #39 + ChkJok(slNot[iCount], '%', AppJok, AddJok) + #39 + ')';
            dm_DB.my_q_tmp_slw.Execute;
            if dm_DB.my_q_tmp_slw.RecordCount > 0 then
            begin
               for i:= 0 to  dm_DB.my_q_tmp_slw.RecordCount - 1 do
               begin
						slNotDocids.Add(dm_DB.my_q_tmp_slw.fieldbyName('doc_id').asstring);
                  dm_DB.my_q_tmp_slw.Next;
               end;
            end;
          end;
      end;

      if (slAndDocids.Count > 0) or (slOrDocids.Count > 0) then
      begin
      	for i:= 0 to slAndDocids.Count -1 do
         begin
         	if slNotDocids.IndexOf(slAndDocids[i]) = -1 then
            begin
            	if resultstr <>'' then
                  resultstr := resultstr +',';
                resultstr := resultstr + slAndDocids[i];
            end;
         end;
         for i:= 0 to slOrDocids.Count -1 do
         begin
         	if (slNotDocids.IndexOf(slOrDocids[i]) = -1) and (slAndDocids.IndexOf(slOrDocids[i]) = -1) then
            begin
            	if resultstr <>'' then
                  resultstr := resultstr +',';
                resultstr := resultstr + slOrDocids[i];
            end;
         end;
      end;

      if resultstr <> '' then
         Result := 'doc_id in (' + resultstr + ')'
      else
         Result := 'doc_id in (0)';
   finally
      if Assigned(slWords) then
         FreeAndNil(slWords);
      if Assigned(slAnd) then
         FreeAndNil(slAnd);
      if Assigned(slNot) then
         FreeAndNil(slNot);
      if Assigned(slNotDocids) then
         FreeAndNil(slNotDocids);
      if Assigned(slOr) then
         FreeAndNil(slOr);
   end;
end;


function MakeDocidInQuery(slqstr : string): string;
var
   i : Integer;
   resultstr : string;
begin
   GgfLogEvnt('MakeDocidInQuery: ' + slqstr);
   Result := '';
   if (slqstr <> '') then
   begin
      try
         try
            dm_DB.my_q_DocidIn.SQL.Text := slqstr;
            dm_DB.my_q_DocidIn.Execute;
            if dm_DB.my_q_DocidIn.RecordCount > 0 then
            begin
               for i:= 0 to  dm_DB.my_q_DocidIn.RecordCount - 1 do
               begin
                  if resultstr <>'' then
                     resultstr := resultstr +',';
                  resultstr := resultstr + dm_DB.my_q_DocidIn.fieldbyName('doc_id').asstring;
                  dm_DB.my_q_DocidIn.Next;
               end;
            end;
            if resultstr <> '' then
               Result := 'doc_id in (' + resultstr + ')'
            else
               Result := 'doc_id in (0)';
         except
            Result := '';
         end;
      finally
         dm_DB.my_q_DocidIn.Close;
      end;
   end;
end;


function MakeKomplexQueryMehrfachauswahl(InputStr: string; Fields: TStrings): string;
var slWords: TStringlist;  Field, Word: String;  i: integer;
begin
   Result := '';
   Field := Fields[0];
   if LeftStr(InputStr,1) = ';' then
      InputStr := Copy(InputStr,2,Length(InputStr) -1);
   slWords := StrToWords7(InputStr);
   try
      for i := 0 to slWords.Count - 1 do
      begin
         Word := slWords[i];
         if Result > '' then
            Result := Result + ' and ';     // f.schneider 3.5.0.164  [2674]

         if     (slWords.Count = 1   )
            and (  Word        = '""')
         then
           Result := Result + ' ' + Field + ' = '''' '  //  01.07.2010  Vers. 3.5.0.86  [2643]  r.sch.
         else
         begin    // f.schneider 3.5.0.164  [2674]
           Word   := StringReplace (Word, '"', '\"', [rfReplaceAll]);
           Word := '%' + Word + '%';
           Result := Result + ' ' + Field + ' like '#34 + Word + #34' ';
         end;
      end;

   finally
      FreeAndNil(slWords);
   end;
end;


function SqlSubQuery (Feld  : string;
                      Worte : TStringList;
                      FldTyp: eAddFieldType;
                      AddJok,
                      AppJok: boolean;
                      Mode  : byte;
                      junction : string = ' and ' ): string;

   //////////////////////////////////////////////////////////////////
   ///  31.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Function erstellt eine Standard SQL Sub-Query fr   ///
   ///  das Feld [Feld] mit den Worten aus [Worte]                ///
   ///                                                            ///
   ///  Parameter: Feld            String mit FeldName            ///
   ///             Worte           StringListe mit Worten         ///
   ///             AddJok          Ergnzt alle Suchbegriffe      ///
   ///             AppJok          automatisch um Platzhalter     ///
   ///             Mode            Stellt den Suchmodus ein       ///
	///				 junction	     Werden mehrere Wrter          ///
   ///                             verundet oder verodert         ///
   ///  Ausgabe: SQL-SubQuery mit Standard SQL Abfrage            ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////

var
   iCount: integer;
   sOpWort, sWort, sOp, tmpfeld, tmpsWort1: string;
begin
   Result := '';

   if (Worte.Count=1) and (Worte[0]='""') then //3.5.0.46 [2414]
      sOp := ' like '
   else
   begin
       case Mode of
          0, 2:
             if FldTyp in [zfld06_GanzZahl,       //  02.07.2010  Vers. 3.5.0.86  [2644]  r.sch.
                           zfld07_FliessKomma,
                           zfld08_Waehrung   ]
             then
               sOp := ' = '
             else
               sOp := ' like ';
          1:
             sOp := ' not like ';
          3:
             sOP := ' between ';
          4:
             sOp := ' = ';
       else
          sOp := ' like ';
       end;
   end;

   // 3.5.0.89 f.schneider   Jetzt wirds dreckig: bevor nicht geklrt wird, wie mit Suchwrtern (mehrere)
   // aus Zusatzfeldern(universal) umgegangen wird, wird hier einfach unabhngig von der definierten
   // Suchmethode ein % vorne angefgt. Die Und-Suche findet dann auch die passenden Treffer
   if  (Worte.Count > 1) And (FldTyp in [zfld00_Universal]) then
   begin
     AddJok := True;
   end;

   for iCount := 0 to Worte.Count - 1 do
   begin
      sOpWort := Worte[iCount];

      if         (IsDelimiter('+-', sOpWort, 1))
         and not (FldTyp in [zfld06_GanzZahl,       //  02.07.2010  Vers. 3.5.0.86  [2644]  r.sch.
                             zfld07_FliessKomma,
                             zfld08_Waehrung   ])
      then
         sWort := Copy(sOpWort, 2, Length(sOpWort))
      else
         sWort := sOpWort;

      if Length(sWort) > 0 then // if Length(sWort) > 2 then
      begin
         if sOP = ' between ' then
         begin
            if datezusfield = True then
            begin
               if gbzdvc then
               begin
                  tmpfeld := 'str_to_date(' + Feld + ',' + #39 + '%d.%m.%Y' + #39 + ')';
               end
               else
               begin
                  tmpfeld := Feld;
               end;
            end
            else
               tmpfeld := Feld;
            if iCount <> (Worte.Count - 1) then
            begin
               Result := Result + Feld + sOp + #39
            end
            else
            begin
               if datezusfield = True then
               begin
                  sZusTextOG1 :=
                     ansileftstr(sZustextOG1, length(sZustextOG1)) + '%';

                  if gbzdvc then
                  begin
                     sWort := stringreplace(sWort, '%', '', [rfReplaceall]);
                     sWort :=
                        'str_to_date(' + #39 + sWort + #39 + ',' + #39 +
                        '%d.%m.%Y' + #39 + ')';
                     tmpsWort1 :=
                        stringreplace(sZustextOG1, '%', '', [rfReplaceall]);
                     tmpsWort1 :=
                        stringreplace(tmpsWort1, '"', #39, [rfReplaceall]);
                     tmpsWort1 :=
                        'str_to_date(' + #39 + tmpsWort1 + #39 + ',' + #39 + '%d.%m.%Y' + #39 + ')';
                     Result :=
                        Result + tmpfeld + sOp + sWort + ' and ' + tmpsWort1;
                  end
                  else
                  begin
                     sWort := stringreplace(sWort, '%', '', [rfReplaceall]);
                     sWort :=
                        'str_to_date(' + #39 + sWort + #39 + ',' + #39 +
                        '%Y-%m-%d' + #39 + ')';
                     tmpsWort1 :=
                        stringreplace(sZustextOG1, '%', '', [rfReplaceall]);
                     tmpsWort1 :=
                        stringreplace(tmpsWort1, '"', #39, [rfReplaceall]);
                     tmpsWort1 :=
                        'str_to_date(' + #39 + tmpsWort1 + #39 + ',' + #39 + '%Y-%m-%d' + #39 + ')';
                     Result :=
                        Result + tmpfeld + sOp + sWort + ' and ' + tmpsWort1;
                  end;
               end
               else
               begin
                  tmpsWort1 :=
                     stringreplace(sZustextOG1, '"', #39, [rfReplaceall]);

                  Result :=
                     Result + tmpfeld + sOp + sWort +
                     ' and ' + tmpsWort1;
               end;
            end;
         end

         else
         if iCount <> (Worte.Count - 1) then
         begin
            if (sWort[1] = '"') and (sWort[length(sWort)] = '"') then
            begin
               // 3.5.0.89 f.schneider  Bei Phrasen kann man ruhig mit % einfassen
               // im Volltext findet er wenigstens so etwas, fr zusatzfelder ist es egal
               if datezusfield = True then
               	Result := Result + Feld + ' is NULL '
               else
                  Result := Result + Feld + sOp + #39 +
                     ChkJok(StringReplace(sWort, '"', '', [rfReplaceAll]), '%',
                     AppJok, AddJok) + #39;
            end
            else
            begin
               Result := Result + Feld + sOp + #39 +
                  ChkJok(StringReplace(sWort, '"', '', [rfReplaceAll]), '%',
                  AppJok, AddJok) + #39;
            end;
            // 3.5.0.89 f.schneider  Wie denn jetzt ? Die Suche soll doch generell eine
            //                       Und-Suche sein bei mehreren Suchwrtern
            if (sOp = ' not like ') or (sOp = ' like ') then
            begin
               Result := Result + junction;
            end
            else
            begin
               Result := Result + ' or ';
            end;
         end
         else
         begin
            if (sWort[1] = '"') and (sWort[length(sWort)] = '"') then
            begin
               // 3.5.0.89 f.schneider  Bei Phrasen kann man ruhig mit % einfassen
               // im Volltext findet er wenigstens so etwas, fr zusatzfelder ist es egal
               if datezusfield = True then
               	Result := Result + Feld + ' is NULL '
               else
                  Result := Result + Feld + sOp + #39 +
                     ChkJok(StringReplace(sWort, '"', '', [rfReplaceAll]), '%',
                     AppJok, AddJok) + #39;
            end
            else
            begin
               Result := Result + Feld + sOp + #39 +
                  ChkJok(sWort, '%', AppJok, AddJok) + #39;
            end;
         end;
      end
      else
      begin
         //allow search after empty strings
         Result := Result + Feld + sOp + #39 + #39;
      end;
   end;
end;

//-----------------------------------------------------------------------------
function MakeKomplexQuery (InputStr: string;
                           Fields  : TStrings;
                           FldTyp  : eAddFieldType;
                           AddJok,
                           AppJok,
                           Sep     : boolean): string;

   //////////////////////////////////////////////////////////////////
   //   MakeKomplexquery
   ///  30.08.2005 Erstellt by SV.                                ///
   ///  31.08.2005 Gendert durch SV aufgeteilt in Unterfunktionen///
   ///                                                            ///
   ///  Diese Function erstellt aus einem String eine SQL-Such-   ///
   ///  Anfrage. Auf Wunsch werden die Suchbegriffe automatsch um ///
   ///  Jokerzeichen erweitert.                                   ///
   ///                                                            ///
   ///  Parameter: InputStr        String mit Suchbegriffen       ///
   ///             Fields          StringListe mit Feldnamen      ///
   ///             AddJok          Ergnzt alle Suchbegriffe      /// (vorne) //todo
   ///             AppJok          automatisch um Platzhalter     /// (hinten)
   ///                                                            ///
   ///  Ausgabe: SQL-Teil einer Where Klausel als String          ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////

var
   iCount, iFCount, iMode: integer;
   // imode for sql combobox query with - = - and not - like -
   slWords, slAnd, slOr, slNot  : TStringList;
   sOpWort: string;
   cSemFlag: byte;

begin
   // if exact search dont use like
   iMode := 0;
   Result := ''; // Sicherheitshalber das Result initalisieren;
   // for exact search dont divide words   (use the  = )
   if (((not AddJok) and (not AppJok)) and (not Sep)) then
   begin
   	// haben wir bei einer exakten Suche ein % im Suchstring
      // dann escapen wir das
      if Pos('%',InputStr) > 0 then
      	InputStr := StringReplace(InputStr,'%','\%',[rfReplaceAll]);

      slWords := TStringList.Create;
      slWords.add(InputStr);
      //use like not =
      iMode := 0;
   end
   else
   begin
      slWords := frm_mainform.lfpmystrtowords(InputStr);
   end;

   slAnd := TStringList.Create;
   slOr := TStringList.Create;
   slNot := TStringList.Create;

   //////////////////////////////////////////////////////////////////////////////////////////////////
   // Prfen: Wenn nur ein Feld per Semantik gesucht werden soll, den Suchoperator nicht entfernen!

   try
      if (Fields.Count = 1) and (integer(Fields.Objects[0]) = 1) then
         cSemFlag := 0
      else
         cSemFlag := 1;

      if (sZustextUG1 <> '') and (sZustextOG1 <> '') and (sZustextUG1 <> sZustextOG1) then
      begin
         if Result <> '' then
            Result := Result + ' or ';
         slAnd.Add(sZustextUG1);

         Result := Result + '('; // between -Teilquery - Start Anfhrungszeichen
         for iFCount := 0 to Fields.Count - 1 do
         begin
            Result := Result + '('; // between-Teilquery - Feldstart Klammer

            if integer(Fields.Objects[iFCount]) = 0 then
               Result := Result + SqlSubQuery(Fields[iFCount], slAnd,
                  FldTyp, AddJok, AppJok, 3, ' and ');

            if integer(Fields.Objects[iFCount]) = 1 then
               Result := Result + SemSubQuery(Fields[iFCount], slAnd,  
                  AddJok, AppJok, cSemFlag);

            if iFCount <> (Fields.Count - 1) then
               Result := Result + ') or '
            else
               Result := Result + ')';
         end;
         Result := Result + ')'; // between -Teilquery - End Klammer
      end
      else if (((sZustextUG1 = '') and (sZustextOG1 <> '')) and (sZustextOG1 <> '1899-12-30')) then
      begin
         if Result <> '' then
            Result := Result + ' or ';
         Result := Result + '(' + Fields[0] + ' <= ' + 'str_to_date(' + #39 + sZustextOG1 + #39 + ',' + #39 + '%Y-%m-%d' + #39 + '))';
      end
      else
      begin
         for iCount := 0 to slWords.Count - 1 do
         begin
            sOpWort := slWords[iCount];

            if  gbsearchcheckedcombobox and (iCount <> 0) then
            begin
               sOpWort := '+' + Trim(StringReplace(sOpWort, '"', '', [rfReplaceAll]))
            end;

            if sOpWort[length(sopwort)] = ',' then
            begin
               sOpWort := copy(sOpWort, 1, length(sopwort) - 1);
            end;

            if         (length (sOpWort) > 1)
               and not (FldTyp in [zfld01_Datum,
                                   zfld06_GanzZahl,     //  02.07.2010  Vers. 3.5.0.86  [2644]  r.sch.
                                   zfld07_FliessKomma,
                                   zfld08_Waehrung   ])
            then begin
               case Ord(sOpWort[1]) of
                  $2B: //  +
                     slAnd.Add(copy(sOpWort, 2, Length(sOpWort)));
                  $2D: //  -
                     slNot.Add(copy(sOpWort, 2, Length(sOpWort)));
                  $2F:  //  /
                     slOr.Add(copy(sOpWort, 2, Length(sOpWort)));
               else
                  slAnd.Add(sOpWort);   //3.5.0.84
               end;
            end
            else
            begin
               // f.schneider  auch hier soll eine UND-Suche durchgefhrt werden   3.5.0.84
               slAnd.Add(sOpWort);
            end;
         end;


         if slAnd.Count > 1 then
            // mehr als 2 Worte sollen per 'ver 'und' ung'  gesucht werden
         begin
            Result := Result + '('; // Und-Teilquery - Start Klammer
            for iFCount := 0 to Fields.Count - 1 do
            begin
               Result := Result + '('; // Und-Teilquery - Feldstart Klammer

               if integer(Fields.Objects[iFCount]) = 0 then
                  Result := Result + SqlSubQuery(Fields[iFCount], slAnd, FldTyp,
                                                 AddJok, AppJok, iMode, ' and ');

               if integer(Fields.Objects[iFCount]) = 1 then
                  Result := Result + SemSubQuery (Fields[iFCount], slAnd,
                                                  AddJok, AppJok, cSemFlag);

               if iFCount <> (Fields.Count - 1) then
                  Result := Result + ') and '
               else
                  Result := Result + ')';
            end;
            Result := Result + ')';
         end
         else
         if slAnd.Count = 1 then // nur ein Wort soll per und gesucht werden!
         begin
            Result := Result + '(';
            for iFCount := 0 to Fields.Count - 1 do
            begin
               Result := Result + '(';

               if integer(Fields.Objects[iFCount]) = 0 then
                  Result := Result + SqlSubQuery(Fields[iFCount], slAnd, FldTyp,
                                                 AddJok, AppJok, 0, ' and ');

               if integer(Fields.Objects[iFCount]) = 1 then
                  Result := Result + SemSubQuery(Fields[iFCount], slAnd,
                                                 AddJok, AppJok, cSemFlag);

               if iFCount <> (Fields.Count - 1) then
               begin
                  Result := Result + ') or  ';
               end
               else
                  Result := Result + ')';
            end;
            Result := Result + ')';
         end;

         // Nicht Teilquery Starten
         if slNot.Count > 1 then
         begin
            if Result <> '' then
               Result := Result + ' and ';
            Result := Result + '(';
            for iFCount := 0 to Fields.Count - 1 do
            begin
               //result := result + '(';
               if integer(Fields.Objects[iFCount]) = 0 then
                  Result := Result + ' (' + SqlSubQuery(Fields[iFCount],
                                                        slNot, FldTyp, AddJok, AppJok, 1, ' and ');

               if integer(Fields.Objects[iFCount]) = 1 then
                  Result := Result + ' (' + SemSubQuery(Fields[iFCount],
                                                        slNot, AddJok, AppJok, 1);

               if iFCount <> (Fields.Count - 1) then
                  Result := Result + ') and '
               else
                  Result := Result + ')';
            end;
            Result := Result + ')';
         end
         else
         if slNot.Count = 1 then // nur ein Wort soll per nicht gesucht werden!
         begin
            if Result <> '' then
               Result := Result + ' and '
            else
            begin
               Result := Result;
            end;
            Result := Result + '('; // Nicht-Teilquery - Start Klammer
            for iFCount := 0 to Fields.Count - 1 do
            begin
               //result := result + '('; // Nicht-Teilquery - Feldstart Klammer
               if integer(Fields.Objects[iFCount]) = 0 then
                  Result := Result + ' (' + SqlSubQuery(Fields[iFCount],
                                                        slNot, FldTyp, AddJok, AppJok, 1, ' and ');

               if integer(Fields.Objects[iFCount]) = 1 then
                  Result := Result + ' not (' + SemSubQuery(Fields[iFCount],
                                                            slNot, AddJok, AppJok, 1);

               if iFCount <> (Fields.Count - 1) then
               begin
                  Result := Result + ') and  ';
               end
               else
                  Result := Result + ')'; // Nicht-Teilquery - Feldend Klammer
            end;
            Result := Result + ')'; // Nicht-Teilquery - End Klammer
         end;

         // Oder Teilquery Starten
         if slOr.Count > 0 then
         begin
            if Result <> '' then
               Result := Result + ' or ';   // hallo ? hier sind wir in der Oder-Suche !   v3.5.0.84
                                            // also kommt hier ein or hin ! sowie ein geplenkentes '!' !
            Result := Result + '('; // Oder-Teilquery - Start Klammer
            for iFCount := 0 to Fields.Count - 1 do
            begin
               Result := Result + '('; // Oder-Teilquery - Feldstart Klammer

               //   Einsprungpunkt fr die Suche nach einem Datumsfeld bei den Zusatzfeldern
               if integer(Fields.Objects[iFCount]) = 0 then
                  Result := Result + SqlSubQuery(Fields[iFCount], slor, FldTyp,
                     										AddJok, AppJok, iMode, ' or ');
               if integer(Fields.Objects[iFCount]) = 1 then
                  Result := Result + SemSubQuery(Fields[iFCount], slOr,
                    			 								AddJok, AppJok, cSemFlag);
               if iFCount <> (Fields.Count - 1) then
                  Result := Result + ') or '
               else
                  Result := Result + ')';
               // Oder-Teilquery - Feldend Klammer
            end;
            Result := Result + ')'; // Oder-Teilquery - End Klammer
            //    result := '(' + result + ' and ' + SwapOps(result) + ')';
         end;
         end;
   finally
      if Assigned(slWords) then
         FreeAndNil(slWords);
      if Assigned(slAnd) then
         FreeAndNil(slAnd);
      if Assigned(slNot) then
         FreeAndNil(slNot);
      if Assigned(slOr) then
         FreeAndNil(slOr);
   end;
end;

function MakeKomplexVTXQuery(InputStr: string; UseSem, AddJok, AppJok: boolean; tblname: string): string;
   //////////////////////////////////////////////////////////////////
   ///  30.08.2005 Erstellt by SV.                                ///
   ///  31.08.2005 Gendert durch SV aufgeteilt in Unterfunktionen///
   ///                                                            ///
   ///  Diese Function erstellt aus einem String eine SQL-Such-   ///
   ///  Anfrage. Auf Wunsch werden die Suchbegriffe automatsch um ///
   ///  Jokerzeichen erweitert.                                   ///
   ///                                                            ///
   ///  Parameter: InputStr        String mit Suchbegriffen       ///
   ///             Fields          StringListe mit Feldnamen      ///
   ///             AddJok          Ergnzt alle Suchbegriffe      ///
   ///             AppJok          automatisch um Platzhalter     ///
   ///                                                            ///
   ///  Ausgabe: SQL-Teil einer Where Klausel als String          ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount: integer;
   slWords, slAnd, slOr, slNot, slAndsem, slOrsem, slNotsem: TStringList;
   sOpWort, sOpwortsem, lszusop, slwquery: string;
   lwsmy: Twordandsemlist;
begin
   Result := '';
   lszusop := '"';
   if InputStr = '' then
      exit;

   lwsmy := StrToWords3(InputStr); // slWords mit Wrtern fllen
   slWords := lwsmy.words;
   slAnd := TStringList.Create;
   slOr := TStringList.Create;
   slNot := TStringList.Create;
   slAndsem := TStringList.Create;
   slOrsem := TStringList.Create;
   slNotsem := TStringList.Create;

   try
      if slWords.Count = 0 then
         exit;
      for iCount := 0 to slWords.Count - 1 do
      begin
         sOpWort := slWords[iCount];
         sOpWortsem := lwsmy.sems[iCount];
         if length(sOpWort) > 1 then
         begin
            case Ord(sOpWort[1]) of
               $2B:  //  +
               begin
                  slAnd.Add(copy(sOpWort, 2, Length(sOpWort)));
                  slAndsem.Add(copy(sOpWort, 2, Length(sOpWortsem)));
               end;
               $2D:  //  -
               begin
                  slNot.Add(copy(sOpWort, 2, Length(sOpWort)));
                  slNotsem.Add(copy(sOpWort, 2, Length(sOpWortsem)));
               end;
               $2F:  //  /
               begin
                  slOr.Add(copy(sOpWort, 2, Length(sOpWort)));
                  slOrsem.Add(copy(sOpWort, 2, Length(sOpWortsem)));
               end;
            else
            begin
               slAND.Add(sOpWort);
               slAndsem.Add(sOpWortsem);
            end;
            end;
         end
         else
         begin
            slAND.Add(sOpWort);
            slAndsem.Add(sOpWortsem);
         end;
      end;

      // Und Teilquery Starten
      if slAnd.Count > 0 then // mehr als 2 Worte sollen per 'und' gesucht werden
      begin
         Result := Result + '('; // Und-Teilquery - Start Klammern
         for iCount := 0 to slAnd.Count - 1 do
         begin
            if icount <> 0 then
            begin
               Result := Result + ' and ';
            end;
            Result := Result + '(';
            // Volltext
            if UseSem and (slAndsem[iCount] = 'y') then     //v3.5.2.28
            begin
               if (slAndsem[iCount] = 'y') then
               begin
                  lszusop := '"';
               end
               else
               begin
                  lszusop := '"';
               end;
               Result := Result + 'Match (doc_txt) Against (' + #39 +
                  '+' + ChkJok(lszusop + slAnd[iCount] + lszusop, '*',
                  (AppJok and (not (slAndsem[iCount] = 'y')))
                  , False) + #39 + ' in boolean mode)';
            end
            else
               Result := Result + 'doc_txt like ' + #39 +
                  ChkJok(slAnd[iCount], '%', AppJok, AddJok) + #39;

            // sollten wir ein Leerzeichen haben, in unserem Suchwort, dann mssen wir es in " packen fr die Schlagwortsuche
            if Pos(' ', slAnd[iCount]) > 0 then
               slwquery := MakeRefQuery2(#34+ slAnd[iCount] +#34,AppJok, AddJok, tblname)
            else
	            slwquery := MakeRefQuery2(slAnd[iCount],AppJok, AddJok, tblname);
            if slwquery <> '' then
            begin
               Result := Result + ' or ' + slwquery;
            end;

            // Und-Teilquery - Feldstart Klammer
            Result := Result + ')';
            if iCount = (slAnd.Count - 1) then
               Result := Result + ')'; // Und-Teilquery - Feldend Klammer
         end;
      end;

      // Nicht Teilquery Starten
      if slNot.Count > 0 then
      begin
         if Result <> '' then
            Result := Result + ' and ';
         Result := Result + '( not ('; // Nicht-Teilquery - Start Klammern
         for iCount := 0 to slNot.Count - 1 do
         begin
            if icount <> 0 then
            begin
               Result := Result + ' or ';  // f.schneider  v3.5.1.63  Bug in der Not Suche
            end;                           // bei mehreren Begriffen wurde verundet, dabei kommt ggf
            Result := Result + '(';        // kein Ergebnis heraus, welches durch not ausgeschlossen werden sollte
            // Volltext                    // d.h. not war ohne Einfluss aufs Ergebnis
            if UseSem and (slNOtsem[iCount] = 'y') then   //v3.5.2.28
            begin
               //" should be in and * out
               //use " only if " was used in the vtx
               if (slNOtsem[iCount] = 'y') then
               begin
                  lszusop := '"';
               end
               else
               begin
                  lszusop := '"';
               end;
               Result := Result + 'Match (doc_txt) Against (' + #39 +
                  '+' + ChkJok(lszusop + slNot[iCount] + lszusop, '*',
                  (AppJok and (not (slNOtsem[iCount] = 'y')))
                  , False) + #39 + ' in boolean mode)';
            end
            else
               Result := Result + 'doc_txt like ' + #39 +
                  ChkJok(slNot[iCount], '%', AppJok, AddJok) + #39;

            // sollten wir ein Leerzeichen haben, in unserem Suchwort, dann mssen wir es in " packen fr die Schlagwortsuche
            if Pos(' ', slNot[iCount]) > 0 then
               slwquery := MakeRefQuery2(#34+ slNot[iCount] +#34,AppJok, AddJok, tblname)
            else
	            slwquery := MakeRefQuery2(slNot[iCount],AppJok, AddJok, tblname);

            if slwquery <> '' then
               Result := Result + ' or ' + slwquery;

            // Nicht-Teilquery - Feldstart Klammer
            Result := Result + ')';
            if iCount = (slNot.Count - 1) then
               Result := Result + '))'; // Und-Teilquery - Feldend Klammer
         end;
      end;

      // Oder Teilquery Starten
      if slOr.Count > 0 then
      begin
         if Result <> '' then
            Result := Result + ' or ';
         Result := Result + '('; // Und-Teilquery - Start Klammern
         for iCount := 0 to slOr.Count - 1 do
         begin
            if icount <> 0 then
            begin
               Result := Result + ' or ';
            end;
            // Volltext
            if UseSem and (slOrsem[iCount] = 'y') then  //v3.5.2.28
            begin
               if (slOrsem[iCount] = 'y') then
               begin
                  lszusop := '"';
               end
               else
               begin
                  lszusop := '"';
               end;
               Result := Result + 'Match (doc_txt) Against (' + #39 +
                  '+' + ChkJok(lszusop + slOr[iCount] + lszusop, '*',
                  (AppJok and (not (slOrsem[iCount] = 'y')))
                  , False) + #39 + ' in boolean mode)';
            end
            else
               Result := Result + 'doc_txt like ' + #39 +
                  ChkJok(slOr[iCount], '%', AppJok, AddJok) + #39;

            // sollten wir ein Leerzeichen haben, in unserem Suchwort, dann mssen wir es in " packen fr die Schlagwortsuche
            if Pos(' ', slOr[iCount]) > 0 then
               slwquery := MakeRefQuery2(#34+ slOr[iCount] +#34,AppJok, AddJok, tblname)
            else
	            slwquery := MakeRefQuery2(slOr[iCount],AppJok, AddJok, tblname);
            if slwquery <> '' then
               Result := Result + ' or ' + slwquery;

            // Und-Teilquery - Feldstart Klammer
            if iCount = (slOr.Count - 1) then
               Result := Result + ')'; // Oder-Teilquery - Feldend Klammer
         end;
      end;
   finally
      if Assigned(slWords) then
         FreeAndNil(slWords);
      if Assigned(slAnd) then
         FreeAndNil(slAnd);
      if Assigned(slNot) then
         FreeAndNil(slNot);
      if Assigned(slOr) then
         FreeAndNil(slOr);
      if Assigned(slAndsem) then
         FreeAndNil(slAndsem);
      if Assigned(slNotsem) then
         FreeAndNil(slNotsem);
      if Assigned(slOrsem) then
         FreeAndNil(slOrsem);
   end;
end;

function MyDummyNow(const AValue: TDateTime): TDateTime;
begin
   result := AValue;
end;


procedure Tfrm_MainForm.Loadbfaandsearch;
var
   liposstr: integer;
   lsmyq: string;
begin
   liposstr := 0;
   with frm_mainform do
   begin

      if ((trefferlistealreadyloaded = False) and
         (FileExists(ResultlistDesignPath + '\' + sIArcName + '.bfa') or
         (FileExists(BD.ExeDir + 'bfa_hit' + '\' +
         sIArcName + '.bfa')))) then
      begin
         if liposstr <> 0 then
         begin
            lsmyq := copy(dm_db.my_q_arc.sql.Text, 0, liposstr - 1);
         end
         else
         begin
            lsmyq := dm_db.my_q_arc.sql.Text;
         end;
        trefferlistealreadyloaded := True;
      end
      else
      begin
         dm_DB.tim_searcharc.Enabled := False;
      end;
      gbshowresults := True;
   end;
end;


procedure Tfrm_MainForm.CheckScreenRes;
var
   iXEnd, iYEnd, iXStart, iYStart, iCF, iCM, iCL: integer;
   sValue: string;
   reg: TRegistry;
begin
   GgfLogEvnt('CheckScreenRes');
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\FormData\MainForm', True);
            sValue := ReadString('NormPos');
            iCF := PosEx(',', sValue, 1);
            iCM := PosEx(',', sValue, iCF + 1);
            iCL := PosEx(',', sValue, iCM + 1);
            if TryStrToInt(copy(sValue, 1, iCF - 1), iXStart) and
               TryStrToInt(copy(sValue, iCF + 1, (iCM - 1) - iCF), iYStart) and
               TryStrToInt(copy(sValue, iCM + 1, (iCL - 1) - iCM), iXEnd) and
               TryStrToInt(copy(sValue, iCL + 1, Length(sValue) - iCL), iYEnd) then
            begin
               if (Screen.Width < iXEnd) or (Screen.Height < iYEnd) or
                  (Screen.Width < iXStart) or (Screen.Height < iYStart) then
                  DeleteValue('NormPos');
               if StrToInt(ReadString('PixelsPerInch')) <>
                  Screen.PixelsPerInch then
                  DeleteValue('PixelsPerInch');
            end;
            CloseKey;
         end;
      except
         on e: Exception do
            LogEvnt('9003    ' + _('Fehler') + ' in Modul: CheckScreenRes    ' + e.Message);
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;


procedure tfrm_mainform.loadbriefpapier(Filename: string);
///////////////////////////////////////////////////////////
var
   lipage, livpage: integer;
   lsf: string;
   lbtim: boolean;
begin
   GgfLogEvnt('loadbriefpapier');
//   lbtim := dm_MainForm2.tim_voransicht.enabled;
//   dm_MainForm2.tim_voransicht.enabled := false;
   frm_MainForm.fra_voransicht.img_docview.CancelInteracts;

   lipage := frm_MainForm.tmb_Voransicht.SelectedImage;
   lsf := frm_mainform.fra_Voransicht.img_DocView.io.Params.FileName;
   try
      with fra_Voransicht.img_DocView do
      begin
         livpage := IO.Params.TIFF_ImageIndex;
         igBriefLayers[0] := fra_Voransicht.img_DocView.LayersAdd;
         IO.Params.TIFF_ImageIndex := 0;
         layersCurrent := igbrieflayers[0];
         io.LoadFromFile(Filename);
         layers[igbriefLayers[0]].PosX := 0;
         layers[igbriefLayers[0]].Posy := 0;
         layers[igbriefLayers[0]].Width := layers[0].Bitmap.Width;
         layers[igbriefLayers[0]].Height := layers[0].Bitmap.Height;
         layers[igbriefLayers[0]].Operation := ielAND;

         iGBriefLayer := 0;
         fra_Voransicht.img_DocView.update;
         Layerscurrent := 0;
      end;
   finally
      begin
         frm_mainform.fra_Voransicht.img_DocView.io.Params.FileName := lsf;
//         dm_MainForm2.tim_voransicht.enabled := lbtim;
      end;
   end;
end;

procedure Tfrm_MainForm.MergeLayers(iLayer0, iLayer1: integer);
//////////////////////////////////////////////////////////////////
///  18.04.2006 Erstellt by SV                                 ///
///                                                            ///
///  Fhrt Briefpapier und Dokument zum Druck zusammen
///  Merge Layers, mergelayers
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   iX, iY: integer;
   proc: TImageEnProc;
begin
   GgfLogEvnt('MergeLayers');
   proc := TImageEnProc.Create(nil);
   try
      with fra_Voransicht.img_DocView do
      begin
         if (Layers[iLayer0].Bitmap.PixelFormat <> ie1g) or
            (Layers[iLayer1].Bitmap.PixelFormat <> ie1g) then
            LayersMerge(iLayer0, iLayer1, False)
         else
         begin
            if (Layers[iLayer1].Bitmap.Width <> Layers[iLayer0].Bitmap.Width) or
               (Layers[iLayer1].Bitmap.Height <> Layers[iLayer0].Bitmap.Height) then
            begin
               proc.AttachedIEBitmap := Layers[iLayer1].Bitmap;
               proc.Resample(Layers[iLayer0].Bitmap.Width,
                  Layers[iLayer0].Bitmap.Height, rfNone);
            end;
            for iY := 0 to Layers[iLayer1].Bitmap.Height - 1 do
               for iX := 0 to Layers[iLayer1].Bitmap.Width - 1 do
                  Layers[iLayer0].Bitmap.Pixels_ie1g[iX, iY] :=
                     (Layers[iLayer0].Bitmap.Pixels_ie1g[iX, iY] and
                     Layers[iLayer1].Bitmap.Pixels_ie1g[iX, iY]);
         end;
      end;
   finally
      if Assigned(proc) then
         FreeAndNil(proc);
   end;
end;

procedure Tfrm_MainForm.ResetAnzeige;
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                 ///
///                                                            ///
///  Setzt die Steuerelemente auf den Ausgangszustand zurck   ///
///  Reset der Steuerelemenete mit ziel Ausgangszustand        ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   iCount: integer;
   ColItem: TTBXColorItem;
begin
   GgfLogEvntBeg ('ResetAnzeige Begin');

   if thr_voransicht <> nil then
      thr_voransicht.Terminate;
   setpanelinfo('');
   Self.SetStatusText(cStatusPanelDoc, ''); //3.5.0.25

	fsinfo := '';
   dm_MainForm2.gsstatustext := '';

   if gbAppStarted then   // wegen Server2008 und mslogon -Problem
   begin
      fra_Voransicht.img_DocView.LayersClear;
      fra_Voransicht.img_DocView.Clear;
      fra_Voransicht.img_DocView.Blank;
      if fra_Voransicht.img_DocView.ObjectsCount > 0 then
         fra_Voransicht.img_DocView.RemoveAllObjects;
      fra_Voransicht.img_DocView.DeSelect;
   end;

   fra_Volltext.redt_Volltext.Clear;
   fra_Volltext.redt_Volltext.Font.Color:= clBlack;

   // Wenn Zusatzfelder existieren werden die Inhalte der Anzeige hier gelscht.
   // Anzeige der Zusatzfelder zurcksetzen und Inhalte loeschen

   if sbx_ZusFeld.ComponentCount > 0 then
      ClearZusFields;

   ResetStatus;

   for iCount := 5 to tlb_Status.Items.Count - 1 do
   begin
      ColItem := TTBXColorItem(tlb_Status.Items.Items[iCount]);
      ColItem.Color := clTeal;

      if gai_sts_rights[(ColItem.tag shr 8) - 1] then
      begin
         ColItem.FontSettings.Color := clnone;
      end
      else
      begin
         ColItem.FontSettings.Color := gcnrs;
      end;
   end;

   if not gbArcHandling and not gbwvlcellclick then
   begin
      resetmyqarc;
   end;

   dm_DB.my_q_Hst.Close;
   chbx_VTXSLW.Checked := bGVTXSLW;
   pnl_SrcTime.ParentBackground := True;
   pnl_SrcTime.Color := pnl_SuchOpt.Color;
   tci_DocLink.Color := clOlive;
   tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [1]');

   tci_InUse.FontSettings.Color := clnone;
   tci_InUse.FontSettings.Bold := tsFalse;
   // setze die Standard Colorierung  ( nicht in arbeit)
   tci_OriFile.Color := clTeal;

   if thr_voransicht <> nil then
   begin
      thr_voransicht.waitfor;
      FreeAndNil(thr_voransicht);
   end;
   try
      frm_MainForm.tmb_Voransicht.LockPaint;
      frm_MainForm.tmb_Voransicht.Deselect;
      frm_MainForm.tmb_Voransicht.Clear;
      frm_MainForm.tmb_Voransicht.unLockPaint;
   except
   	on e: exception do
      begin
         logevnt('Error 9001 ResetAnzeige ' + e.message);
      end;
   end;
   tbx_pubNote.ImageIndex := 110;
   tbx_pubNote.hint := '';
   tbx_privNote.ImageIndex := 109;
   tbx_privNote.hint := '';
   bh_PrivAnnoExist.CancelHint;
   lbl_VSeite.Caption := 'von 0 ';
   dm_MainForm2.il_Standard.GetIcon(84, img_Revision.Picture.Icon);
   tbi_wvldoc.enabled := false;
   dm_db.floadingmainview := false;

   GgfLogEvntEnd ('ResetAnzeige End');
end;

procedure Tfrm_MainForm.ResetStatus(bKeepSearched: Boolean = False);
var
   iCount: integer;
   ColItem: TTBXColorItem;
begin
	tci_DocLink.Color := gclOlive;
   tci_InUse.Color := gclteal;
   tci_OriFile.Color := gclTeal;
   tci_InUse.FontSettings.Color := gclNone;
   tci_InUse.FontSettings.Bold := tsFalse;
   if bKeepSearched then
   begin
      if (gmodsearchiStatus and 1) = 1 then
         tci_InUse.Color := gclLime
      else
         tci_InUse.Color := gclTeal;
   end
   else
	   tci_InUse.Color := gclTeal;

   for iCount := 5 to tlb_Status.Items.Count - 1 do
   begin
      ColItem := TTBXColorItem(tlb_Status.Items.Items[iCount]);

      if bKeepSearched then
      begin
         if (gmodsearchiStatus and (1 shl (iCount -4))) > 0 then
            ColItem.Color := gclLime
         else
         	ColItem.Color := gclTeal;
      end
      else
         ColItem.Color := gclTeal;

      if gai_sts_rights[(ColItem.tag shr 8) - 1] then
      begin
         ColItem.FontSettings.Color := gclNone;
      end
      else
      begin
         ColItem.FontSettings.Color := cColorNoRightStat;
      end;
   end;
end;


procedure Tfrm_MainForm.resetSuchFelder;
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                 ///
///                                                            ///
///  Setzt und die leert die Suchfelder                            ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   iCount: integer;
begin
   GgfLogEvntBeg ('resetSuchFelder Begin');

   if iGmaxhits = -2 then
   begin
      //undeifined...
   end
   else
   if iGmaxhits = -1 then
   begin
      sGMaxHits := '';
      cbx_MaxTreffer.Text := 'alle';
      iGmaxhits := -1;
   end
   else
   begin
      sGMaxHits := 'limit ' + inttostr(iGMaxHits);
      cbx_MaxTreffer.Text := IntToStr(iGmaxhits);
   end;
   edt_SSlw.Text := '';
   cbx_SUsr.ItemIndex := -1; //3.5.0.22 erst mal auf undefiniert setzen sonst klappt das folgende nicht immer
   cbx_SUsr.ItemIndex := 0;
   chbx_SDatum.Checked := False;
   chbx_SOnlyUsed.Checked := bGLstDocInUse;
   chbx_VTXSLW.Checked := bGVTXSLW;
   dtp_SVon.Date := Date;
   dtp_sBis.Date := Date;
   memo_Vtx.Clear;
   if tlb_Status.Items.Count > 5 then
   begin
      for iCount := 5 to (tlb_Status.Items.Count - 1) do
      begin
         TTBXColorItem(tlb_Status.Items.Items[iCount]).Color := clTeal;
         TTBXColorItem(tlb_Status.Items.Items[iCount]).FontSettings.Bold := tsFalse;
      end;
   end;
   tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [2]');

   // Referenz suchen bzw editieren
   edt_SRefSea.Text := '';
   GHasNotBeenSavedAfterModify := False;
   fgchangedvoransicht := False;
   fgchangedvoransichttif := false;
   chbx_SRefSea.Checked := False;
   chbx_SRefSea.OnClick(self);

   GgfLogEvntEnd ('resetSuchFelder End');
end;


// Hier werden etliche Zeichen verboten
procedure Tfrm_MainForm.ZusFlsTyp0EditKeyPress(Sender: TObject; var Key: Char); //3.5.0.22
begin
   // if not (key in ['0'..'9',#13,#8, '.' , ',' ]) then key := #0;
   if Key in [
      '!', // Trenner
      //'"', // Anfhrungszeichen, reserviert als Quote und auch SQL //3.5.0.46 [2414]
      //  '%', // wegen SQL mit like //3.5.0.71 wieder dazu
      #24, // Apostroph, wegen SQL
      '(', // wegen SQL
      ')', // wegen SQL
      '*', // vielleicht mal Platzhalter
      // ',', // Trenner //3.5.0.31 wegen Thomas, Herr Pi(e)tsch?
      '?', // vielleicht mal Platzhalter
      '`', // wegen SQL
      '{', // wegen - rein vorsichtshalber
      '|', // wegen - rein vorsichtshalber
      '}', // wegen - rein vorsichtshalber
      #160 // geschtztes Leerzeichen
      ] then
         Key := #0;
end;


function Tfrm_MainForm.areAddFieldsValid (): Boolean;

var
  xArchiv  : clArchiv;           //  26.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
  xAddField: clAddField;         //  26.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
  xSize    : Integer;
  xIdx     : Integer;
  xStrIdx  : Integer;
  xBox     : TComboBox;
  xObj     : TObject;

begin
  Result := True;
  xSize  := sbx_ZusFeld.ComponentCount;

  for xIdx := 0 to xSize -1 do
  begin
    xObj := sbx_ZusFeld.Components [xIdx];

    if xObj is TComboBox then
    begin
      xBox      := xObj as TComboBox;
      xArchiv   := clArchiv.getInstance;
      xAddField :=  xArchiv.AddFieldTab.findComp (xBox.Name);

      if xAddField <> nil then
      begin
        //  30.06.2010  Vers. 3.5.0.86  [2638]  r.sch.

        xStrIdx := xAddField.ChoiceList.IndexOf (xBox.Text);

        if     (xStrIdx   >= 0                )
           or  (xBox.Text  = xAddField.ContOld)
           or  (xBox.Text  = ''               )
           and (xBox.Text <> '""'             )
        then begin
          //  Speicherbarer Inhalt
          //  Farbe nicht ndern
        end
        else
        begin
          //  Inhalt kann nicht gespeichert werden
          //  Farbe anpassen
          xStrIdx := xBox.Items.IndexOf (xBox.Text);

          if xStrIdx >= 0 then
          begin
            if xAddField.isCatchWord then
            begin
              xBox.Color := cColorHellgruen;   //  VerschlagwortungsHilfe
            end
            else
            begin
              xBox.Color := cColorHellblau;    //  nach diesen Werten darf nur gesucht werden
              Result     := false;
            end;
          end
          else
          begin
              xBox.Color := cColorRed;        //  ungltige Werte
              Result     := false;
          end;
        end;
      end;
    end;
  end;
end;


procedure Tfrm_MainForm.EnableSaveOnKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
var
   ls: string;
   li: integer;
   lbr: boolean;
begin
   GgfLogEvntBeg ('EnableSaveOnKeyUp Begin');

   if Key = vk_TAB then
   	 exit;

   if Sender is TEdit then
   begin
      with Sender as TEdit do
      begin
         if Modified then
         begin
            if gbcfgxs then
            begin
               ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1, length(TEdit(sender).name) - length('zedt_Tmp'));
               ls := ZiffernRechts(TEdit(sender).name);
               try
                  li := strtoint(ls);
               except on e: exception do
                  begin
                  end;
               end;
               lbr := gai_cfg_rights[li];
            end
            else
            begin
               lbr := true;
            end;

            if lbr and (dm_db.my_q_arc.recordcount > 0) then
            begin
               Color := cColorHellgruen;
               if rGDocRight.modify then //18.04.2011 b.takacs 3.5.0.178
               begin
                 tbi_VSaveDoc.Enabled := True;
                 btn_SaveDoc.Enabled := True;
               end;
            end
            else
            begin
               if lbr then
               begin
                  Color := cColorHellgruen;
               end
               else
               begin
                  color := cColorHellgruen;
               end;
            end;
         end;
      end;
   end;
   if Sender is TJvDateEdit then
   begin
      with Sender as TJvDateEdit do
      begin
         if Modified then
         begin
            if gbcfgxs then
            begin
               ls := copy(TJvDateEdit(sender).name, length('zedt_Tmp') + 1,
                  length(TJvDateEdit(sender).name) - length('zedt_Tmp'));
               ls := ZiffernRechts(TJvDateEdit(sender).name);
               if not trystrtoint(ls, li) then
               begin
                  ls := copy(TJvDateEdit(sender).name, length('zedt_Tmp_og_') + 1,
                     length(TJvDateEdit(sender).name) - length('zedt_Tmp_og_'));
                  trystrtoint(ls, li);
               end;
               lbr := gai_cfg_rights[li];
            end
            else
            begin
               lbr := true;
            end;
            if lbr and (dm_db.my_q_arc.recordcount > 0) then
            begin
               Color := cColorHellgruen;
               if rGDocRight.modify then //18.04.2011 b.takacs 3.5.0.178
               begin
                 tbi_VSaveDoc.Enabled := True;
                 btn_SaveDoc.Enabled := True;
               end;
            end
            else
            begin
               if lbr then
               begin
                  Color := cColorHellgruen;
               end
               else
               begin
                  color := cColorHellgruen;
               end;
            end;
            Tag := (Tag or 4);
         end;
      end;
   end;
   if Sender is TjvSpinEdit then
   begin
      with Sender as TjvSpinEdit do
      begin
         if Modified then
         begin
            if gbcfgxs then
            begin
               ls := copy(TjvSpinEdit(sender).name, length('zedt_Tmp') + 1,
                  length(TjvSpinEdit(sender).name) - length('zedt_Tmp'));
               ls := ZiffernRechts(TjvSpinEdit(sender).name);
               if not trystrtoint(ls, li) then
               begin
                  ls := copy(TjvSpinEdit(sender).name, length('zedt_Tmp_og_') + 1,
                     length(TjvSpinEdit(sender).name) - length('zedt_Tmp_og_'));
                  trystrtoint(ls, li);
               end;
               lbr := gai_cfg_rights[li];
            end
            else
            begin
               lbr := true;
            end;

            if lbr and (dm_db.my_q_arc.recordcount > 0) then
            begin
               Color := cColorHellgruen;
               if rGDocRight.modify and (Pos('_og',TjvSpinEdit(sender).name)=0) then //18.04.2011 b.takacs 3.5.0.178
               begin
                 tbi_VSaveDoc.Enabled := True;
                 btn_SaveDoc.Enabled := True;
               end;
            end
            else
            begin
               if lbr then
                  Color := cColorHellgruen
               else
                  color := cColorHellgruen;
            end;
            Tag := (Tag or 4);
         end;
      end;
   end;

   if Sender is TComboBox then
   begin
      with Sender as TComboBox do
      begin
         if gbcfgxs then
         begin
            ls := ZiffernRechts(TComboBox(sender).name);
            try
               li := strtoint(ls);
            except on e: exception do
               begin
               end;
            end;
            lbr := gai_cfg_rights[li];
         end
         else
         begin
            lbr := true;
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
         	Tag := (Tag or 4);
            Color := cColorHellgruen;
            if rGDocRight.modify and (pos('_cbx_', TComboBox(sender).name) = 0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
            end;
         end
         else
         begin
            if lbr then
               Color := cColorHellgruen
            else
               color := cColorHellgruen;
         end;
      end;
   end;
   GgfLogEvntEnd ('EnableSaveOnKeyUp End');
end;

procedure Tfrm_MainForm.BtnEnableSave(Sender: TObject);
var
   li: integer;
   ls: string;
   lbr: boolean;
begin
   lbr := true;
   GgfLogEvnt('BtnEnableSave');
   if Sender is TJvDateEdit then
      with Sender as TJvDateEdit do
      begin
         if gbcfgxs then
         begin
            ls := copy(TJvDateEdit(sender).name, length('zedt_Tmp') + 1,
               length(TJvDateEdit(sender).name) - length('zedt_Tmp'));
            if not trystrtoint(ls, li) then
            begin
               ls := copy(TJvDateEdit(sender).name, length('zedt_Tmp_og_') + 1,
                  length(TJvDateEdit(sender).name) - length('zedt_Tmp_og_'));
               trystrtoint(ls, li);
            end;
            lbr := gai_cfg_rights[li];
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            Color := cColorHellgruen;
            if rGDocRight.modify and (Pos('_og', TJvDateEdit(sender).name) = 0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
              GHasNotBeenSavedAfterModify := True;              
            end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;

            end
            else
            begin
               color := cColorNoRight;
            end;
         end;
         Tag := (Tag or 4);
      end;
   if Sender is TJvSpinEdit then
      with Sender as TJvSpinEdit do
      begin
         if gbcfgxs then
         begin
            ls := copy(TJvSpinEdit(sender).name, length('zedt_Tmp') + 1,
               length(TJvSpinEdit(sender).name) - length('zedt_Tmp'));
            if not trystrtoint(ls, li) then
            begin
               ls := copy(TJvSpinEdit(sender).name, length('zedt_Tmp_og_') + 1,
                  length(TJvSpinEdit(sender).name) - length('zedt_Tmp_og_'));
               trystrtoint(ls, li);
            end;
            lbr := gai_cfg_rights[li];
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            Color := cColorHellgruen;
            if rGDocRight.modify and (Pos('_og',TjvSpinEdit(sender).name)=0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
              GHasNotBeenSavedAfterModify := True;
         	end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;

            end
            else
            begin
               color := cColorNoRight;
            end;
         end;
         Tag := (Tag or 4);
      end;
   if Sender is TSpinEdit then
      with Sender as TSpinEdit do
      begin
         if gbcfgxs then
         begin
            ls := copy(TSpinEdit(sender).name, length('zedt_Tmp') + 1,
               length(TSpinEdit(sender).name) - length('zedt_Tmp'));
            if trystrtoint(ls, li) then
            begin
               lbr := gai_cfg_rights[li];
            end;
         end;


         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            Color := cColorHellgruen;
            if rGDocRight.modify and (Pos('_og',TSpinEdit(sender).name)=0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
              GHasNotBeenSavedAfterModify := True;
            end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;

            end
            else
            begin
               color := cColorNoRight;
            end;
         end;
         Tag := (Tag or 4);
      end;
   if Sender is TComboBox then
      with Sender as TComboBox do
      begin
         if gbcfgxs then
         begin
            ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1,
               length(TEdit(sender).name) - length('zedt_Tmp'));
            try
               li := strtoint(ls);
            except on e: exception do
               begin
               end;
            end;
            lbr := gai_cfg_rights[li];
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            Color := cColorHellgruen;
            if rGDocRight.modify and (pos('_cbx_', TComboBox(sender).name) = 0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
              GHasNotBeenSavedAfterModify := True;
            end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;

            end
            else
            begin
               color := cColorNoRight;
            end;
         end;
         Tag := (Tag or 4);
      end;
end;


procedure Tfrm_MainForm.EnableSaveBtn;
begin
   GgfLogEvnt('EnableSaveBtn');

   if (dm_db.my_q_arc.recordcount > 0) then
   begin
     if areAddFieldsValid () then  //  01.07.2010  Vers. 3.5.0.86  [2590]  r.sch.
     begin
       tbi_VSaveDoc.Enabled := True;
       btn_SaveDoc .Enabled := True;
     end
     else
     begin
       tbi_VSaveDoc.Enabled := False;
       btn_SaveDoc .Enabled := False;
     end;
   end;
end;


procedure Tfrm_MainForm.SetControls(Active: boolean); //3.5.0.22
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV
///                                                            ///
///  Schaltflchen aktivieren
///  schaltflchen deaktivieren                                ///
///  Aktiviert / Deaktiviert die Eingabefunktionen             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   bsseinfo: string;
begin
   GgfLogEvntBeg('Tfrm_MainForm.Controls beg');
   dbtv_LgrArc.Enabled := Active;
   pnl_Voransicht.Enabled := Active;
   dpnl_Thumbs.Enabled := Active;
   bitbtn1.Enabled := Active;
   pctr_Suchoptionen.Enabled := Active;
   btn_StartSrc.Enabled := Active;
   if btn_startSrc.Enabled then
      bsseinfo := 'activ';

   pnl_Trefferliste.Enabled := Active;
   GgfLogEvntEnd('Tfrm_MainForm.Controls end');
end;

procedure Tfrm_MainForm.GoToDocID;
/////////////////////////////////////////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                                                    ///
///                                                                                               ///
///  Ruft ein bestimmtes Dokument aus der Datenbank ab                                            ///
///  Die DokID und Die Arc ID sind zuvor im Caption von cStatusPanelDoc gespeichert worden //3.5.0.25
///  m.frey: das ist doch Mist
/////////////////////////////////////////////////////////////////////////////////////////////////////
var liPos:integer;  lsDoc:string;
begin
   GgfLogEvntBeg ('GoToDocID Begin');

   dm_MainForm2.mnu_TGoToArc.Visible := False;
   lsDoc := GetStatusText(cStatusPanelDoc);

   liPos := Pos(cStatusPanelDocIdTrennzeichen,lsDoc);
   if liPos>0 then
   	Delete(lsDoc,liPos,maxint);

   HandleParam(lsDoc); // Zeige das angeklickte Dokument an //3.5.0.25

   GgfLogEvntEnd ('GoToDocID End');
end;


procedure Tfrm_MainForm.FillZusFields;
//////////////////////////////////////////////////////////////////
///  15.05.2005 Erstellt von SV.
//   Zusatz Felder lesenNG                                     ///
///                                                            ///
///  Diese Procedure liest aus den Zusatzlabeln die Namen der  ///
///  Zusatzfelder aus und fuellt die Zusatzedits mit den Werten
///  aus den Zusatzfeldern der Datenbank)                       //
///                                                      ///
//////////////////////////////////////////////////////////////////
var
   sTmpField,
   tmp_EmailAdr: string;
   coltmp: tcolumn;
   iCount,
   licount2,
   lifield, lipos2: integer;
   xComp, xComp01
   : TComponent;
   lswor: Tstringlist;
   tDate: TDateTime;
   lsspin: string;
   JvStaticText:TJvStaticText;

   xS01     : string;
   xI01     : Integer;
   lAddField: clAddField;
   lArchiv  : clArchiv;

begin
   GgfLogEvnt('Tfrm_MainForm.FillZusFields');
   gbFillZusFields := True;
	try
      lArchiv := clArchiv.getInstance;

      if bMultiArcQuery then
         lifield := 4
      else
         lifield := 3;

      // reset betreff
      ng_emailbet := '';
      ng_emailAdr := '';
      for iCount := 0 to (iGZusFCount - 1) do
      begin
         JvStaticText:=sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount)) as
            TJvStaticText;
         with JvStaticText do
            sTmpField := Hint;

         if (dbgrd_trefferliste.Columns.Count <> (iGZusFCount + lifield)) then
         begin
            with dbgrd_TrefferListe do
               // dynamische Tabelle der Trefferliste erzeugen
            begin
               colTmp := Columns.Add;
               coltmp.Width := 58;
               colTmp.FieldName := sTmpField;
               colTmp.Title.Caption := lbl_zuf[icount];
            end;
         end;

         xComp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
         if xComp = nil then
         begin
            continue;
         end;
         if xComp is TEdit then
         begin
           lAddField := lArchiv.AddFieldTab.findComp (TEdit(xComp).Name);

            if (tedit(xComp).Color = cColorHellgruen) or
               (tedit(xComp).Color = cColorNoRight) then
            begin
            end
            else
            begin
               TEdit(xComp).Text :=
                  dm_DB.my_q_Arc.FieldByName(sTmpField).AsString;
               if gai_cfg_rights[iCount] then
               begin
                  tedit(xComp).Color := clwhite;
               end
               else
               begin
                  tedit(xComp).Color := cColorNoRightInit;
               end;
            end;

            tmp_EmailAdr := ' ';

            tmp_EmailAdr := TEdit(xComp).Text;
            if tmp_EmailAdr = '' then
               tmp_EmailAdr := ' ';

            if posex('Absender', tedit(xComp).hint) > 0 then
            begin
               if pos('@', tmp_EmailAdr) > 0 then
               begin
                  if pos('.', tmp_EmailAdr) > 0 then
                  begin
                     ng_EmailAdr := TEdit(xComp).Text;
                     sleep(10);
                  end;
               end;
            end;

            if posex(#34 + _('Betreff') + #34, tedit(xComp).hint) > 0 then
            begin
               ng_EmailBet := TEdit(xComp).Text;
               if ng_emailbet = '' then
                  ng_emailbet := ' ';
            end;

           lAddField.ContOld := TEdit (xComp).Text;
         end;

         //  Hier wird das  Datum erzeugt
         if xComp is TSpinEdit then
         begin
           lAddField := lArchiv.AddFieldTab.findComp (TSpinEdit (xComp).Name);

            xComp01 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' +
               IntToStr(iCount));
            if xComp01 <> nil then
            begin
               if (TSpinEdit(xComp).Color = cColorHellgruen) or
                  (TCombobox(xComp01).Color = cColorHellgruen) or
                  (TSpinEdit(xComp).Color = cColorNoRight) or
                  (TCombobox(xComp01).Color = cColorNoRight) then
               begin
               end
               else
               begin
                  lsspin := dm_DB.my_q_Arc.FieldByName(sTmpField).AsString;
                  if lsspin <> '' then
                  begin
                     try
                        Tspinedit(xComp).Value := strtoint(
                           copy(lsspin, 0, length(lsspin) - 1));
                        TCombobox(xComp01).Text :=
                           copy(lsspin, length(lsspin), 1);
                     except on e: exception do
                        begin
                           Tspinedit(xComp).text := '';
                           TCombobox(xComp01).Text := '';
                        end;
                     end;
                  end
                  else
                  begin
                     Tspinedit(xComp).text := '';
                     TCombobox(xComp01).Text := '';
                  end;
                  if gai_cfg_rights[iCount] then
                  begin
                     Tspinedit(xComp).Color := clwhite;
                     TCombobox(xComp01).Color := clwhite;
                  end
                  else
                  begin
                     Tspinedit(xComp).Color := cColorNoRightInit;
                     TCombobox(xComp01).Color := cColorNoRightInit;
                  end;
               end;
            end
            else
            begin
               if (TSpinEdit(xComp).Color = cColorHellgruen) or
                  (TSpinEdit(xComp).Color = cColorNoRight) then
               begin
               end
               else
               begin
                  lsspin := dm_DB.my_q_Arc.FieldByName(sTmpField).AsString;
                  if lsspin <> '' then
                  begin
                     try
                        Tspinedit(xComp).Value := strtoint(lsspin);
                     except on e: exception do
                        begin
                           Tspinedit(xComp).text := '';
                        end;
                     end;
                  end
                  else
                  begin
                     Tspinedit(xComp).text := '';
                  end;
                  if gai_cfg_rights[iCount] then
                  begin
                     Tspinedit(xComp).Color := clwhite;
                  end
                  else
                  begin
                     Tspinedit(xComp).Color := cColorNoRightInit;
                  end;
               end;
            end;

            lAddField.ContOld := TSpinEdit (xComp).Text;
         end;

         if xComp is TJvDateEdit then
         begin
           lAddField := lArchiv.AddFieldTab.findComp (TJvDateEdit (xComp).Name);

            if (TJvDateEdit(xComp).Color = cColorHellgruen) or
               (TJvDateEdit(xComp).Color = cColorNoRight) then
            begin
            end
            else
            begin
               if TryStrToDateTime(dm_DB.my_q_Arc.FieldByName(
                  sTmpField).AsString, tDate) then
               begin
                  TJvDateEdit(xComp).Text := DateToStr(tDate); 
                  TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                     IntToStr(iCount))).Text :=
                     TJvDateEdit(xComp).Text;
               end
               else
               begin
                  TJvDateEdit(xComp).Text := '';
                  TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                     IntToStr(iCount))).Text :=
                     TJvDateEdit(xComp).Text;
               end;
               // set clwhite for reset!
               if gai_cfg_rights[iCount] then
               begin
                  TJvDateEdit(xComp).Color := clwhite;
               end
               else
               begin
                  TJvDateEdit(xComp).Color := cColorNoRightInit;
               end;
               TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                  IntToStr(iCount))).color := TJvDateEdit(xComp).color;
            end;

            lAddField.ContOld := TJvDateEdit (xComp).Text;
         end;

         if xComp is TJvSpinEdit then
         begin
           lAddField := lArchiv.AddFieldTab.findComp (TJvSpinEdit (xComp).Name);

            if (TJvSpinEdit(xComp).Color = cColorHellgruen) or
               (TJvSpinEdit(xComp).Color = cColorNoRight) then
            begin
            end
            else
            begin
               TJvSpinEdit(xComp).Text := dm_DB.my_q_Arc.FieldByName(
                  sTmpField).AsString;
               TJvSpinEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                  IntToStr(iCount))).Text :=
                  TJvSpinEdit(xComp).Text;

               if gai_cfg_rights[iCount] then
               begin
                  TJvSpinEdit(xComp).Color := clwhite;
               end
               else
               begin
                  TJvSpinEdit(xComp).Color := cColorNoRightInit;
               end;
            end;

            lAddField.ContOld := TJvSpinEdit (xComp).Text;
         end;

         //  Wenn die Componente einer Combobox entspricht dann gehts hier weiter
         if xComp is TComboBox then
         begin
           lAddField := lArchiv.AddFieldTab.findComp (TComboBox (xComp).Name);

            if   (TComboBox(xComp).Color = cColorHellgruen)
              or (TComboBox(xComp).Color = cColorHellblau )  //  01.07.2010  Vers. 3.5.0.86  [2638]  r.sch.
              or (TComboBox(xComp).Color = cColorNoRight         )
            then begin
            end
            else
            begin
              xS01 := dm_DB.my_q_Arc.FieldByName (sTmpField).AsString;
              xI01 := TComboBox(xComp).Items.Indexof (xS01);

              TComboBox(xComp).Text := xS01;

              if xI01 >= 0 then
                TComboBox(xComp).ItemIndex := xI01;

               // set clwhite for reset!
               if gai_cfg_rights[iCount] then
               begin
                  TComboBox(xComp).Color := clwhite;
               end
               else
               begin
                  TComboBox(xComp).Color := cColorNoRightInit;
               end;
            end;

            lAddField.ContOld := TComboBox (xComp).Text;
         end;

         if xComp is TjvCheckedComboBox then
         begin
           lAddField := lArchiv.AddFieldTab.findComp (TjvCheckedComboBox (xComp).Name);

            if (TjvCheckedComboBox(xComp).noFocusColor = cColorHellgruen) or
               (TjvCheckedComboBox(xComp).noFocusColor = cColorNoRight) then
            begin
            end
            else
            begin
               lswor := lfpmystrtowords1(dm_DB.my_q_Arc.FieldByName(sTmpField).AsString);
               TjvCheckedComboBox(xComp).SetUnCheckedAll();
               for licount2 := 0 to lswor.Count - 1 do
               begin
                  lipos2 := TjvCheckedComboBox(xComp).Items.IndexOf(lswor.Strings[licount2]);
                  if (lipos2 > -1) and (lswor.Strings[licount2] <> '') then
                     TjvCheckedComboBox(xComp).Checked[lipos2] := true;
               end;
               freeandnil(lswor);

               // set clwhite for reset!
               if gai_cfg_rights[iCount] then
               begin
                  TjvCheckedComboBox(xComp).noFocusColor := clwhite;
               end
               else
               begin
                  TjvCheckedComboBox(xComp).noFocusColor := cColorNoRightInit;
               end;
            end;

            lAddField.ContOld := TjvCheckedComboBox (xComp).Text;
         end;
      end;
   finally
       gbFillZusFields := False;
   end;

end;

procedure Tfrm_MainForm.SaveZusFields;
//////////////////////////////////////////////////////////////////
///  15.05.2005                                                ///
// Zusatz Felder Speichern                                     ///
///  Diese Procedure liest aus den Zusatzlabeln die Namen der  ///
///  Zusatzfelder aus und fllt die Zusatzfelder in der Archiv ///
///  Tabelle mit den Werten aus den Zusatzedits.               ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   sTmpField, stmpfield1, lsOldValue, lsNewValue, sTmpCaption: string;
   iCount, iSelected, litmpdocid, litmparcid, licount2, litag, liOptionen: integer;
   xComp, xComp01, xComp02, comp3: TComponent;
   sdate, lsvon, lsarcname, lssql, lsinput, lsinput1, lsinput2,
   lsarcidtmp, lsdocidtmp,lsCheckPrg: string; 
   teditmod, tdatemod, tcombomod, lbchecked,
   lbhasrights: boolean;

   lstlw: Tstringlist;
   ArcDocId:TArcDocId;

   // Gemeinsamer code drin
   function SaveZusFieldsMain1:Boolean; //true wenn fehler - und ein continue erfolgen muss
   begin
      Result:=true;
      with dbgrd_Trefferliste.DataSource.DataSet do
      begin
         GotoBookMark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iSelected]));
         if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
            lsarcidtmp := dm_DB.my_q_Arc.FieldByName('arc_id').Asstring
         else
            lsarcidtmp := inttostr(igarcid);

            lsdocidtmp := dm_DB.my_q_Arc.FieldByName('doc_id').asstring;

         dm_db.my_q_tmp.SQL.Text := 'select * from sys_doclock where ' +
            ' arc_id=' + lsarcidtmp + ' and doc_id=' + lsdocidtmp;
         try
            dm_db.my_q_tmp.Execute;
         except on e: exception do
            LogEvnt('9004c    Fehler in Modul: SaveZusFields    ' + e.Message);
         end;
         if dm_db.my_q_tmp.RecordCount <> 0 then
         begin
            if dm_db.my_q_tmp.fieldbyname('usr_id').asinteger <> iGusrid then
            begin
               fbfailcauselock := true;
               Exit;
            end;
         end;
         lsOldValue := dm_DB.my_q_Arc.FieldByName(sTmpField).AsString;
      end;
      Result:=false;
   end;

var
  JvStaticText: TComponent;
  lsDbValue   : string; //3.5.0.18
  xBox        : TjvCheckedComboBox;
  xMulti      : TFrameZusFldMulti;
  xArcTab     : clArcAddTab;
  xI          : integer;

begin
   GgfLogEvntBeg ('SaveZusFields Begin');

   teditmod := False;
   tdatemod := False;
   tcombomod := False;
   lbhasrights := true;
   if dbgrd_Trefferliste.SelectedRows.Count = 0 then
      dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;

   //todo macht das schlankere und effizienter!!!
   for iCount := 0 to (iGZusFCount - 1) do // Alle Zusatzfelder behandeln
   begin
      // save the name of the component!

      if gai_cfg_rights[iCount] = false then
      begin
         lbhasrights := false;
         continue;
      end;
      xComp01 := sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      stmpfield1 := Copy(TJvStaticText(xComp01).Caption, 1,
         length(TJvStaticText(xComp01).Caption) - 1);
      JvStaticText:=sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      with JvStaticText as
         // TLabel do
         TJvStaticText do
      begin
         sTmpField := Hint;
         sTmpCaption := Caption;
         xComp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      end;

      if xComp is TEdit then
      begin
         if (TEdit(xComp).Modified = True) or (comingfromCrezusPum = True) then
            // hier ist der Casus Knaktus die TEDIT(xComp) hat kein MOdified
         begin
            for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
            begin
               with dbgrd_Trefferliste.DataSource.DataSet do
               begin
                  begin
                     if SaveZusFieldsMain1 then Continue;
                     
                     TMPSQL('select * from cfg_' + sIArcName + ' where Feld_name = ' +
                        #39 + sTmpField + #39);

                     lbchecked := True;
                     lsCheckPrg:=dm_db.my_q_tmp.FieldByName('chck_prog').AsString;
                     if (dm_db.my_q_tmp.RecordCount <> 0) and
                        (dm_db.my_q_tmp.FieldDefList.Find('chck_prog') <> nil) then
                     begin
                        if (dm_db.my_q_tmp.FieldByName('chck_prog').AsString <> null) and
                           (lsCheckPrg <> '') then
                        begin
                           lbchecked :=
                              (dm_MainForm2.ShellExecute_AndWait('', extractfilename(lsCheckPrg),
                              TEdit(xComp).Text, extractfilepath(lsCheckPrg), SW_HIDE, True) = 0);
                        end;
                     end;
                     while not lbchecked do
                     begin
                        if InputQuery(_('Eingabeberprfung'),
                           _('Die Eingabe wurde zurckgewiesen, bitte geben Sie eine gltige Eingabe ein.'),
                           lsinput) then
                        begin
                           TEdit(xComp).Text := lsinput;
                           lbchecked :=
                              (dm_MainForm2.ShellExecute_AndWait('', extractfilename(lsCheckPrg),
                              lsinput, extractfilepath(lsCheckPrg), SW_HIDE, True) = 0);
                        end;
                     end;

                     lsNewValue:=TEdit(xComp).Text;
                     if lsOldValue <> lsNewValue then
                     begin
                        Edit; //#02 Edit;
                        dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := lsNewValue;
                        Post; //#02

                           litmpdocid := iGDOCID;
                           litmparcid := iGARCID;
                           iGDOCID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                           // maybe take bMultiArcQuery ???
                           if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                           begin
                              iGARCID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                              TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(IGARCID));
                              lsarcname := dm_db.my_q_tmp.FieldByName('arc_tblname').AsString;
                           end
                           else
                           begin
                              lsarcname := sIArcName;
                           end;

                           lsSql := 'update arc_' + lsarcname +
                                 ' set '+sTmpField+' = '+#39+lsNewValue+#39 +
                                 ' where (doc_id='+IntToStr(iGDOCID)+')';
                           DbXLog( lsSql,
                                 _('SaveZusFields TEdit Fehler beim ndern des Inhaltes:')
                                    + '%e%' + ' mysqltext:' + lsSql);

                        if lsNewValue <> '' then //#01
                        begin //#01
                           // todo schlagwrter are being insert, but what if someone want to remove the old one?
                           DbXLog(
                                 'Insert into slw_' + lsarcname +
                                 ' (doc_id, doc_slw) Values (' + IntToStr(iGDocID) +
                                 ', ' + #39 + trim(ParseSemicolonUseBackslash(lsNewValue)) + #39 + ')',
                                 _('SaveZusFields TEdit Fehler beim Hinzufgen eines Schlagwortes:')
                                    + '%e%' + ' mysqltext:' + lssql);

                           // reset status and color
                           if lsOldValue = '' then
                              lsvon := ''
                           else
                              lsvon := ' ' + _('von') + ' ';
                           NewHistory(9, _('Zusatzfeld') + ' ' + stmpfield1 + ' ' + _('wurde') +
                              lsvon + lsOldValue + ' ' + _('nach') + ' ' + lsNewValue + ' ' + _('gendert.'));
                           iGDOCID := litmpdocid;
                           iGARCID := litmparcid;
                        end;

                        ArcDocId.ArcId:=StrToInt(lsarcidtmp);
                        ArcDocId.DocId:=StrToInt(lsdocidtmp);
                        VerknuepfenAnhandZusatzfelder(ArcDocId,sTmpField,lsOldValue,lsNewValue);
                     end;
                  end;
               end;
            end;
            TEdit(xComp).Modified := False;
            TEdit(xComp).Color := clwhite;
            comingfromCrezusPum := False;
         end;
      end;

      if xComp is TJvDateEdit then
      begin
         // and 4 means it was modified
         if (TJvDateEdit(xComp).Tag and 4) = 4 then
         begin
            for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
            begin
               with dbgrd_Trefferliste.DataSource.DataSet do
               begin
                  begin
                     if SaveZusFieldsMain1 then Continue;
                     
                     lsNewValue := TJvDateEdit(xComp).Text;
                     if lsOldValue <> lsNewValue then
                     begin
                        Edit;
                        if pos(fdatestringempty, lsNewValue) > 0 then
                        begin
                           dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := '';
                        end
                        else
                        begin
                           dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := lsNewValue;
                        end;
                        Post;

                        litmpdocid := iGDOCID;
                        litmparcid := iGARCID;
                        iGDOCID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                        begin
                           iGARCID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(IGARCID));
                           lsarcname := dm_db.my_q_tmp.FieldByName('arc_tblname').AsString;
                        end
                        else
                        begin
                           lsarcname := sIArcName;
                        end;
                           DbSetDate(lsarcname, sTmpField, lsNewValue, iGDOCID);

                        if lsOldValue = '' then
                           lsvon := ''
                        else
                           lsvon := ' ' + _('von') + ' ';
                        
                        //todo: check if needed
                        // todo schlagwrter are being insert, but what if someone want to remove the old one?
                        DbXLog(
                           'Insert into slw_' + lsarcname +
                           ' (doc_id, doc_slw) Values (' + IntToStr(iGDocID) +
                           ', ' + #39 + trim(ParseSemicolonUseBackslash(lsNewValue)) + #39 + ')',
                           _('SaveZusFields TJvDateEdit  Fehler beim Hinzufgen eines Schlagwortes:')
                                 + '%e%' + ' mysqltext:' + lssql);
                              
                        NewHistory(9, _('Zusatzfeld') + ' ' + stmpfield1 + ' ' + _('wurde') +
                           lsvon + lsOldValue + ' ' + _('nach') + ' ' + lsNewValue + ' ' + _('gendert.'));
                        iGDOCID := litmpdocid;
                        iGARCID := litmparcid;
                        //#01 Post;
                        ArcDocId.ArcId:=StrToInt(lsarcidtmp);
                        ArcDocId.DocId:=StrToInt(lsdocidtmp);
                        VerknuepfenAnhandZusatzfelder(ArcDocId,sTmpField,lsOldValue,lsNewValue);
                     end;
                  end;
               end;
            end;
            // if saved put the color as white and set modified:=false
            TJvDateEdit(xComp).Modified := False;
            TJvDateEdit(xComp).Tag := TJvDateEdit(xComp).Tag and (not 4);
            TJvDateEdit(xComp).Color := clwhite;
         end;
      end;
      /////////////////////////////////////////////////////
      // and 4 means it was modified
      if (xComp is TComboBox) or (xComp is TjvCheckedComboBox) then
      begin
         //??? save when
         if (xComp is TComboBox) then
         begin
            litag := TComboBox(xComp).Tag;
            lsinput := TComboBox(xComp).Text;
         end
         else
         begin
           xBox    := TjvCheckedComboBox (xComp);  //  01.07.2010  Vers. 3.5.0.86  [2643]  r.sch.
           xI      := xBox.Items.IndexOf ('""');

           if xI >= 0 then
             xBox.Checked [xI] := false;

           litag   := xBox.Tag;
           lsinput := xBox.Text;
         end;
         if (litag and 4) = 4 then
         begin
            tCOMBOmod := True;
            for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
            begin
               with dbgrd_Trefferliste.DataSource.DataSet do
               begin
                  begin
                     if SaveZusFieldsMain1 then Continue;

                     lsNewValue := lsinput;
                     if lsOldValue <> lsNewValue then
                     begin
                        Edit;
                        dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := lsNewValue;
                        Post;

                        litmpdocid := iGDOCID;
                        litmparcid := iGARCID;
                        iGDOCID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                        begin
                           iGARCID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(IGARCID));
                           lsarcname := dm_db.my_q_tmp.FieldByName('arc_tblname').AsString;
                        end
                        else
                        begin
                           lsarcname := sIArcName;
                        end;

                        if lsNewValue <> '' then //#01
                        begin
                           // todo schlagwrter are being insert, but what if someone want to remove the old one?
                           DbXLog(
                              'Insert into slw_' + lsarcname +
                              ' (doc_id, doc_slw) Values (' + IntToStr(iGDocID) +
                              ', ' + #39 + trim(ParseSemicolonUseBackslash(lsinput)) + #39 + ')',
                              _('SaveZusFields  Fehler TComboBox beim Hinzufgen eines Schlagwortes:')
                                    + '%e%' + ' mysqltext:' + lssql);
                                 
                           if lsOldValue = '' then
                              lsvon := ''
                           else
                              lsvon := ' ' + _('von') + ' ';
                           NewHistory(9, _('Zusatzfeld') + ' ' + stmpfield1 + ' ' + _('wurde') +
                              lsvon + lsOldValue + ' ' + _('nach') + ' ' + lsinput + ' ' + _('gendert.'));
                           iGDOCID := litmpdocid;
                           iGARCID := litmparcid;
                        end;
                        //#01 Post;
                        ArcDocId.ArcId:=StrToInt(lsarcidtmp);
                        ArcDocId.DocId:=StrToInt(lsdocidtmp);
                        VerknuepfenAnhandZusatzfelder(ArcDocId,sTmpField,lsOldValue,lsNewValue);
                     end;
                  end;
               end;
            end;
            if (xComp is TjvCheckedComboBox) then
            begin
	            xMulti := TFrameZusFldMulti (TjvCheckedComboBox (xComp).Parent);
               xMulti.FillJvCheckedComboBox (sTmpField, sIArcName);
               TjvCheckedComboBox (xComp).Tag          := TjvCheckedComboBox(xComp).Tag and (not 4);
               TjvCheckedComboBox (xComp).noFocusColor := clwhite;
            end
            else
            begin
               // if saved put the color as white
               TComboBox(xComp).Tag := TComboBox(xComp).Tag and (not 4);
               TComboBox(xComp).Color := clwhite;
            end;
         end;
      end;
      if xComp is TSpinEdit then
      begin
         //??? save when
         xComp02 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
         if (xComp02 <> nil) then
         begin
            if (((TSpinEdit(xComp).Tag and 4) = 4) or
               ((TComboBox(xComp02).Tag and 4) = 4))
            then
            begin
               lsinput1 := TSpinEdit(xComp).Text;
               lsinput2 := TComboBox(xComp02).Text;
               if (lsinput1 = '') or
                  (lsinput2 = '') then
               begin
                  continue;
               end;
               lsinput := lsinput1 + lsinput2;
               tCOMBOmod := True;

               for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
               begin
                  with dbgrd_Trefferliste.DataSource.DataSet do
                  begin
                     if SaveZusFieldsMain1 then Continue;
                     
                     lsNewValue := lsinput;
                     if lsOldValue <> lsNewValue then
                     begin
                        Edit;
                        dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := lsNewValue;
                        Post;

                        litmpdocid := iGDOCID;
                        litmparcid := iGARCID;
                        iGDOCID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                        begin
                           iGARCID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(IGARCID));
                           lsarcname := dm_db.my_q_tmp.FieldByName('arc_tblname').AsString;
                        end
                        else
                        begin
                           lsarcname := sIArcName;
                        end;

                        lsSql := 'update arc_' + lsarcname +
                              ' set '+sTmpField+' = '+#39+lsNewValue+#39 +
                              ' where (doc_id='+IntToStr(iGDOCID)+')';
                        DbXLog( lsSql,
                              _('SaveZusFields TEdit Fehler beim ndern des Inhaltes:')
                                 + '%e%' + ' mysqltext:' + lsSql);

                        if lsNewValue <> '' then //#01
                        begin
                           if lsOldValue = '' then
                              lsvon := ''
                           else
                              lsvon := ' ' + _('von') + ' ';
                           NewHistory(9, _('Zusatzfeld') + ' ' + stmpfield1 + ' ' + _('wurde') +
                              lsvon + lsOldValue + ' ' + _('nach') + ' ' + lsNewValue + ' ' + _('gendert.'));
                           iGDOCID := litmpdocid;
                           iGARCID := litmparcid;
                        end;
                        ArcDocId.ArcId:=StrToInt(lsarcidtmp);
                        ArcDocId.DocId:=StrToInt(lsdocidtmp);
                        VerknuepfenAnhandZusatzfelder(ArcDocId,sTmpField,lsOldValue,lsNewValue);
                     end;
                  end;
               end;
               // if saved put the color as white
               TSpinEdit(xComp).Tag := TSpinEdit(xComp).Tag and (not 4);
               TSpinEdit(xComp).Color := clwhite;
               TComboBox(xComp02).Tag := TComboBox(xComp02).Tag and (not 4);
               TComboBox(xComp02).Color := clwhite;
            end;
         end
         else
         begin
            if ((TSpinEdit(xComp).Tag and 4) = 4) then
            begin
               lsinput1 := TSpinEdit(xComp).Text;
               if (lsinput1 = '') then
               begin
                  continue;
               end;
               lsinput := lsinput1;
               tCOMBOmod := True;

               for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
               begin
                  with dbgrd_Trefferliste.DataSource.DataSet do
                  begin
                     if SaveZusFieldsMain1 then Continue;
                     
                     lsNewValue := lsinput;
                     if lsOldValue <> lsNewValue then
                     begin
                        Edit;
                        dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := lsNewValue;
                        Post;

                        litmpdocid := iGDOCID;
                        litmparcid := iGARCID;
                        iGDOCID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                        begin
                           iGARCID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(IGARCID));
                           lsarcname := dm_db.my_q_tmp.FieldByName('arc_tblname').AsString;
                        end
                        else
                        begin
                           lsarcname := sIArcName;
                        end;
                        lsDbValue := StringReplace(lsNewValue, ',', '.', [rfReplaceAll]); //3.5.0.18
                        lsSql := 'update arc_' + lsarcname +
                              ' set '+sTmpField+' = '+#39+lsDbValue+#39 + //3.5.0.18
                              ' where (doc_id='+IntToStr(iGDOCID)+')';
                        DbXLog( lsSql,
                              _('SaveZusFields TEdit Fehler beim ndern des Inhaltes:')
                                 + '%e%' + ' mysqltext:' + lsSql);

                        if lsNewValue <> '' then //#01
                        begin
                           // no ExecSqlCommELog(dm_DB.my_cmd, ...
                           if lsOldValue = '' then
                              lsvon := ''
                           else
                              lsvon := ' ' + _('von') + ' ';
                           NewHistory(9, _('Zusatzfeld') + ' ' + stmpfield1 + ' ' + _('wurde') +
                              lsvon + lsOldValue + ' ' + _('nach') + ' ' + lsNewValue + ' ' + _('gendert.'));
                           iGDOCID := litmpdocid;
                           iGARCID := litmparcid;
                        end;
                        //#01 Post;
                        ArcDocId.ArcId:=StrToInt(lsarcidtmp);
                        ArcDocId.DocId:=StrToInt(lsdocidtmp);
                        VerknuepfenAnhandZusatzfelder(ArcDocId,sTmpField,lsOldValue,lsNewValue);
                     end;
                  end;
               end;
               // if saved put the color as white
               TSpinEdit(xComp).Tag := TSpinEdit(xComp).Tag and (not 4);
               TSpinEdit(xComp).Color := clwhite;
            end;
         end;
      end;

      if xComp is TjvSpinEdit then
      begin 
         if ((TjvSpinEdit(xComp).Tag and 4) = 4) then
         begin
            lsinput1 := TjvSpinEdit(xComp).Text;
            if (lsinput1 = '') then
            begin
               continue;
            end;
            lsinput := lsinput1;
            tCOMBOmod := True;

            for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
            begin
               with dbgrd_Trefferliste.DataSource.DataSet do
               begin
                  begin
                     if SaveZusFieldsMain1 then Continue;
                     
                     lsNewValue := lsinput;
                     if lsOldValue <> lsNewValue then
                     begin
                        Edit;
                        dm_DB.my_q_Arc.FieldByName(sTmpField).AsString := lsNewValue;
                        Post;

                        litmpdocid := iGDOCID;
                        litmparcid := iGARCID;
                        iGDOCID := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                        if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                        begin
                           iGARCID := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                           TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(IGARCID));
                           lsarcname := dm_db.my_q_tmp.FieldByName('arc_tblname').AsString;
                        end
                        else
                        begin
                           lsarcname := sIArcName;
                        end;
                        lsDbValue := StringReplace(lsNewValue, ',', '.', [rfReplaceAll]); //3.5.0.18
                        lsSql := 'update arc_' + lsarcname +
                              ' set '+sTmpField+' = '+#39+lsDbValue+#39 + //3.5.0.18
                              ' where (doc_id='+IntToStr(iGDOCID)+')';
                        DbXLog( lsSql,
                              _('SaveZusFields TEdit Fehler beim ndern des Inhaltes:')
                                 + '%e%' + ' mysqltext:' + lsSql);

                        if lsNewValue <> '' then //#01
                        begin
                           if lsOldValue = '' then
                              lsvon := ''
                           else
                              lsvon := ' ' + _('von') + ' ';
                           NewHistory(9, _('Zusatzfeld') + ' ' + stmpfield1 + ' ' + _('wurde') +
                              lsvon + lsOldValue + ' ' + _('nach') + ' ' + lsNewValue + ' ' + _('gendert.'));
                           iGDOCID := litmpdocid;
                           iGARCID := litmparcid;
                        end;
                        ArcDocId.ArcId:=StrToInt(lsarcidtmp);
                        ArcDocId.DocId:=StrToInt(lsdocidtmp);
                        VerknuepfenAnhandZusatzfelder(ArcDocId,sTmpField,lsOldValue,lsNewValue);
                     end;
                  end;
               end;
            end;
            TjvSpinEdit(xComp).Tag := TjvSpinEdit(xComp).Tag and (not 4);
            TjvSpinEdit(xComp).Color := clwhite;
         end;
      end;
   end;

   GgfLogEvntEnd ('SaveZusFields End');
end;


procedure Tfrm_MainForm.CreateParams(var Params: TCreateParams);
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                 ///
///                                                            ///
///  bergibt Parameter an die Windows Message Que             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   GgfLogEvnt('Tfrm_MainForm.CreateParams');
   inherited;
   StrCopy(Params.WinClassName, 'bitfarm.Viewer.V3');
   SingleInst.CreateParams(Params);
end;

procedure Tfrm_MainForm.WndProc(var Msg: TMessage);
//////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                 ///
///                                                            ///
///  bergibt die Windows Messages                              ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
	try
   if not SingleInst.HandleMessages(Msg) then
      inherited;
  except
  end;
end;

procedure Tfrm_MainForm.ResetTrefferliste;
//////////////////////////////////////////////////////////////////
///  30.06.2005 Erstellt by SV.                                ///
///                                                            ///
///  Schliesst die Datenmenge der Trefferliste und lscht so   ///
///  den Inhalt. Setzt die DocID auf 0 und lscht die Voran-   ///
///  sicht.                                                    ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   GgfLogEvnt('ResetTrefferliste');

   dm_DB.my_q_Arc.Close;
   dm_DB.my_q_Hst.Close;
   dm_DB.my_q_Lnk.Close;

   dm_MainForm2.tim_Blank.Enabled := True;
   sleep(30);
   fra_Volltext.redt_Volltext.Clear;
   iGDocID := -3;
   SetStatusText(cStatusPanelDoc, IntToStr(iGArcID) + '.0'); //3.5.0.25

end;

procedure Tfrm_MainForm.HandleParam(const Param: string);
//////////////////////////////////////////////////////////////////
///  08.06.2005 Erstellt by SV.                                ///
///                                                            ///
///  Auswertung des Strings in [Param] nach einer Externen     ///
///  DocID. Wenn eine gefunden wird, ffnen der Entsprechenden ///
///  Datenbank und Anzeige des Dokumentes.                     ///
///                                                            ///
///  Parameter:   Param   String mit Parameterinhalt           ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   sPStr: string;
   iLgr, iArc, iSlw, iVtx, iRef, iTmpArcID, iTmpDocID, licount, liinterchange,
   liwvl, liclose, ligdoc, ligdocid, ligmanuscan, ligsearchzusfield,
   litmp, iprint, liwvlrecno: integer;
   lmystrl: TStringList;
   lbParamHandled_old, lbparamhandled: boolean;
   lsTmp,lsParamUp: string;
begin
   liinterchange := 0;
   lsParamUp := UpperCase(Param);

   GgfLogEvntBeg ('HandleParam Begin mit Param = "' + Param + '"');

   try
   sPStr := '';
   lbparamhandled := false;
   GgfLogEvnt('A:handleparamaktiv=' + BS(handleparamaktiv));
   if handleparamaktiv = False then
   begin
      GgfLogEvnt('HandleParam0 ' + Param);

      WhoisMyServer := dm_DB.my_con.Server;
      handleparamaktiv := True;  GgfLogEvnt('handleparamaktiv:=true A');

      try
       try

          lbParamHandled_old := bParamHandled;
          bParamHandled := False;
          ///////////////////////////////////////////////////////
          //  Hier startet die Parameter Routiene              //
          ///////////////////////////////////////////////////////
          //resetSuchFelder;
          iLgr  := Pos('-L:', lsParamUp);
          iArc  := Pos('-A:', lsParamUp);
          iSlw  := Pos('-S:', lsParamUp);
          iVtx  := Pos('-V:', lsParamUp);
          iprint:= Pos('-P:', lsParamUp);
          iRef  := Pos('-R:', lsParamUp);  //3.5.0.84
          liinterchange := Pos('-I:', lsParamUp);
          if liinterchange = 0 then
          begin
             Application.BringToFront;
             frm_mainform.BringToFront;
          end;
          liwvl            := Pos('-W:', lsParamUp);
          liclose          := Pos('-C:', lsParamUp);
          ligdoc           := Pos('-G:', lsParamUp);
          ligmanuscan      := Pos('-M:', lsParamUp);
          ligsearchzusfield:= Pos('-ZUS:', lsParamUp);
          if (LowerCase(copy(Param, 1, 7)) = 'gdocid:') then
          begin
             sPStr := Copy(Param, 8, Length(param));
             ligdoc := 1;
          end;
          if ligdoc = 1 then
          begin
             lbparamhandled := true;
             fbAufrufUeberDocId := True; //m.frey 3.5.0.14
             gbhasgdocid := DbTableExist('sys_gdocid'); //m.frey 3.5.0.14
             if gbhasgdocid and (not gbkleiner3400) then
             begin
                lsTmp := copy(lsParamUp, 4, length(param)); // 4 ist doch Quatsch
                if TryStrToInt(lsTmp, ligdocid) or (sPStr <> '') then
                begin
                   if sPstr <> '' then
                   begin
                      TryStrToInt(sPStr, ligdocid);
                   end;
                   if TmpSql('Select Sql_No_cache * from sys_gdocid where gdoc_id = ' +
                      inttostr(ligdocid)) then
                   begin
                      if dm_db.my_q_tmp.RecordCount > 0 then
                      begin
                         if dm_db.my_q_tmp.fieldbyname('arc_id').IsNull then
                         begin
                            dm_MainForm2.tim_docload.Enabled := true;
                            frm_MainForm.pnl_docTime.Color := clred;
                            pnl_doctime.Caption := 'Laden';
                            while dm_db.my_q_tmp.fieldbyname('arc_id').IsNull do
                            begin
                               if not TmpSql('Select Sql_No_cache * from sys_gdocid where gdoc_id = ' +
                                  inttostr(ligdocid)) then
                               begin
                                  HPTorOpen := True;
                                  // vor dem Exit wird die Routine als ausfhrbar markiert
                                  handleparamaktiv := False;
                                  dbgrd_wvl.Enabled := True;

                                  GgfLogEvntEnd ('HandleParam End via Exit #2');
                                  exit;
                               end;
                            end;

                            pnl_docTime.Caption := '';
                            dm_MainForm2.tim_docload.Enabled := False;
                            pnl_docTime.ParentBackground := True;
                            pnl_docTime.Color := pnl_SuchOpt.Color;
                         end;
                         iTmpArcID := dm_db.my_q_tmp.fieldbyname('arc_id').AsInteger;
                         iTmpDocID := dm_db.my_q_tmp.fieldbyname('doc_id').AsInteger;
                         if (iTmpArcID = 0) and (iTmpDocID = 0) then
                         begin
                            BfShowMessage(_('Dokument noch nicht archiviert (fehlende Eintrge in der globale Tabelle).'));
                            GgfLogEvntEnd ('HandleParam End via Exit #3');
                            exit;
                         end;
                         dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iTmpArcID), []);
                         dbtv_LgrArcSet (False, False);  //  r.sch.  10.06.2010

                         if dbtv_LgrArc.Selected = nil then
                         begin
                            HPTorOpen := True;
                            // vor dem Exit wird die Routine als ausfhrbar markiert
                            handleparamaktiv := False;
                            dbgrd_wvl.Enabled := True;

                            GgfLogEvntEnd ('HandleParam End via Exit #4');
                            exit;
                         end;
                         SetLength(GArcSList, 1);
                         GArcSList[0].ArcID := iGArcID;
                         GArcSList[0].ArcName := sGArcName;
                         GArcSList[0].TblName := sIArcName;
                         iGArcRecNo := -1;

                         DelStatus;

                         if sIArcName <> '' then
                         begin
                            logwvl('3201, WVL vor CreStatus ');
                            CreStatus; 
                            iGZusFCount := CreZusFields(false);
                         end;

                         bMultiArcQuery := False;
                         GetArcUsrRights;

                         if rGarcright.list or gbwvlcellclick then
                         begin
                            QueryArc('Select  * from arc_' + GArcSList[0].TblName +
                               ' as arc where doc_id = ' + IntToStr(iTmpDocID));
                            gbsearched := True;
                         end;

                         bGImageDisp := True;
                         dbgrd_Trefferliste.SetFocus;
                         bParamHandled := True;
                         HPTorOpen := True;
                         bParamHandled := lbParamHandled_old;

                         GgfLogEvntEnd ('HandleParam End via Exit #5');
                         exit;
                      end;
                   end;
                end;
             end;
             bParamHandled := lbParamHandled_old;
          end;
          if ligmanuscan = 1 then
          begin
             lbparamhandled := true;
             tbi_manuscanClick(self);
          end;
          if iprint = 1 then
          begin
             lbparamhandled := true;
             tbi_VPrintStdClick(self);
          end;

          if liinterchange = 1 then
          begin
             lbparamhandled := true;
             dm_MainForm2.senduserpermessage(Copy(Param, liinterchange + 3, Length(Param)));
             bParamHandled := lbParamHandled_old;
          end;
          if liwvl = 1 then
          begin
             lbparamhandled := true;
             if not tbi_vdocTimer.Checked then
             begin
                tbi_vdocTimer.Checked := True;
                tbi_VDocTimerClick(self);
             end;
             if Length(param) > length('-W:') then
             begin
                liwvlrecno := dbgrd_wvl.DataSource.DataSet.recno;
                dbgrd_wvl.DataSource.DataSet.refresh;
                if dbgrd_wvl.DataSource.DataSet.recordcount < liwvlrecno then
                begin
                   dbgrd_wvl.DataSource.DataSet.recno := dbgrd_wvl.DataSource.DataSet.recordcount - 1;
                end
                else
                begin
                   dbgrd_wvl.DataSource.DataSet.recno := liwvlrecno;
                end;
                dm_MainForm2.tim_changewvl.enabled := true;
             end;
             bParamHandled := lbParamHandled_old;
          end;
          if liclose = 1 then
          begin
             lbparamhandled := true;
             frm_mainform.Close;
          end;
          if ligsearchzusfield = 1 then
          begin
             lbparamhandled := true;
             litmp := posex(':', param, 6);
             fcmdzusfieldsearch := copy(Param, 6, litmp - 6);
             fcmdzusvaluesearch := copy(Param, litmp + 1, length(param));
             searchforzusfields;
          end;

          GgfLogEvnt('HandleParam1 ' + inttostr(iLgr));
          if iLgr = 1 then
          begin
             lbparamhandled := true;

             // Parameter -L fuer Lagerort auswerten 060816
             cbx_Lager.ItemIndex := -1;
             cbx_Lager.Text := Copy(Param, iLgr + 3, Length(Param));

             GgfLogEvnt('HandleParam2 ' + inttostr(cbx_Lager.Items.IndexOf(cbx_Lager.Text)));
             if cbx_Lager.Items.IndexOf(cbx_Lager.Text) <> -1 then
             begin
                cbx_Lager.ItemIndex := cbx_Lager.Items.IndexOf(cbx_Lager.Text);
                logwvl('3061, WVL vor cbx_LagerChange');
                cbx_LagerChange(self);
                logwvl('3088, WVL nach cbx_LagerChange');
                dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(
                   integer(cbx_Lager.Items.Objects[cbx_Lager.ItemIndex])), []);
             end;
          end;
          if iArc = 1 then
          begin
             lbparamhandled := true;
             cbx_Archiv.ItemIndex := -1;
             // Parameter -A fuer Archiv auswerten NG060816
             cbx_Archiv.Text := Copy(Param, iArc + 3, Length(Param));
             if cbx_Archiv.Items.IndexOf(cbx_Archiv.Text) <> -1 then
             begin
                cbx_Archiv.ItemIndex := cbx_Archiv.Items.IndexOf(cbx_Archiv.Text);
                logwvl('3096, WVL vor cbx_ArchivChange');
                cbx_ArchivChange(self);
                logwvl('3098, WVL nach cbx_ArchivChange');
                dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(
                   integer(cbx_Archiv.Items.Objects[cbx_Archiv.ItemIndex])), []);
             end
             else
             begin
                // SQL Abfrage nach Dokument ID
                logwvl('3103, WVL vor TMPSQL');
                if TmpSql('Select Sql_No_cache lgr_id from sys_Arc where arc_name = '
                   + #39 + cbx_Archiv.Text + #39) then
                begin
                   logwvl('3106, WVL nach TMPSQL erfolgreich');
                   dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(
                      dm_DB.my_q_Tmp.FieldByName('lgr_id').AsInteger), []);
                end;
                dm_DB.my_q_Tmp.Close;
                logwvl('3110, WVL nach dm_DB.my_w_tmp geschlossen vor del Status');

                DelStatus;

                logwvl('3114, WVL nach dm_DB.my_w_tmp geschlossen nach del Status');
                if sIArcName <> '' then
                begin
                   logwvl('3117, WVL nach dm_DB.my_w_tmp geschlossen vor  CreStatus');
                   CreStatus; 
                   logwvl('3119, WVL nach dm_DB.my_w_tmp geschlossen nach CreStatus');
                   iGZusFCount := CreZusFields(false);
                end;
             end;
          end;
          if iSlw = 1 then
          begin
             lbparamhandled := true;
             edt_SSlw.Text := Copy(Param, iSlw + 3, Length(Param));
             memo_Vtx.Text := '';
          end;
          if iVtx = 1 then
          begin
             lbparamhandled := true;
             edt_SSlw.Text := '';
             lmystrl := StrToWords(Copy(Param, iVtx + 3, Length(Param)));

             memo_Vtx.Text := '';
             for licount := 0 to lmystrl.Count - 1 do
             begin
                memo_Vtx.Text := memo_Vtx.Text + ' +' + lmystrl.Strings[licount];
             end;
             lmystrl.Destroy;
          end;
          if iRef = 1 then
          begin
            lbparamhandled := true;
            edt_SRefSea.Text := Copy(Param, iRef + 3, Length(Param));
            memo_Vtx.Text := '';
          end;

          if lsParamUp = '-GO' then
          begin
             lbparamhandled := true;
             bParamHandled := True;
             btn_StartSrcClick(self);
          end;
          if UpperCase(ExtractFileExt(Param)) = '.FND' then
          begin
             lbparamhandled := true;
             Fndrbnu := True;
             ReadFNDFile(Param);
          end;
          if (frm_MainForm.fnd_ext <> '.FND') and (frm_MainForm.fnd_ext <> '') and
             (UpperCase(ExtractFileExt(Param)) = UpperCase(frm_MainForm.fnd_ext)) then
          begin
             lbparamhandled := true;
             Fndrbnu := True;
             ReadFNDFile(Param);
          end;

          if not lbparamhandled then
          begin
             fbAufrufUeberDocId := True; //m.frey 3.5.0.2
             GgfLogEvnt('Tfrm_MainForm.HandleParam - fbAufrufUeberDocId := True;');

             ///////////////////////////////////////////////////////
             //  Hier startet die DocID Routine                  //
             ///////////////////////////////////////////////////////

             ///////////////////////////////////////////////////////////////////////////////////////
             // Behandlung der FND datei
             // wenn die Abarbeitung eines Durchlaufes dieser Routine noch nicht
             // abgeschlossen ist, und die Routine in diesem Zeitraum ein weiteres mal aufgerufen wird,
             // erfolgt hier ein Exit der Routine.
             if not HPTorOpen then
             begin
                handleparamaktiv := False;
                dbgrd_wvl.Enabled := True;

                GgfLogEvntEnd ('HandleParam End via Exit #6');
                exit;
             end;

             HPTorOpen := False;
             Fndrbnu := False;

             if (LowerCase(copy(Param, 1, 6)) = 'docid:') then
                sPStr := Copy(Param, 7, Length(param))
             else
                sPstr := Param;
             if (copy(sPStr, Length(sPStr), Length(sPStr)) = '/') then
                sPStr := copy(Param, 7, (Length(sPStr) - 1));
             if not TryStrToInt(Copy(sPStr, 1, Pos('.', sPStr) - 1), iTmpArcID) then
             begin
                HPTorOpen := True;
                // vor dem Exit wird die Routine als ausfhrbar markiert
                handleparamaktiv := False;
                dbgrd_wvl.Enabled := True;

                GgfLogEvntEnd ('HandleParam End via Exit #7');
                exit;
             end;
             if not TryStrToInt(Copy(sPStr, Pos('.', sPStr) + 1, Length(sPStr)),
                iTmpDocID) then
             begin
                HPTorOpen := True;
                // vor dem Exit wird die Routine als ausfhrbar markiert
                handleparamaktiv := False;
                dbgrd_wvl.Enabled := True;

                GgfLogEvntEnd ('HandleParam End via Exit #8');
                exit;
             end;

             dm_db.tim_ansicht.Enabled := false;
             dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iTmpArcID), []);
             gblastclickedlager := false;

             if gbwvlcellclick then
             begin
                iGArcID := iTmpArcID;
                TMPSQL('select * from sys_arc where arc_id = ' + IntToStr(iGArcID));
                sGArcName := dm_db.my_q_Tmp.FieldByName('arc_name').AsString;
                sIArcName := dm_db.my_q_Tmp.FieldByName('arc_tblname').AsString;
                fshowwvldoc := True;
                dbtv_LgrArcSet (False, False);  //  r.sch.  10.06.2010
             end
             else
             begin
                dbtv_LgrArcSet (False, False);  //  r.sch.  10.06.2010
                if dbtv_LgrArc.Selected = nil then
                begin
                   HPTorOpen := True;
                   // vor dem Exit wird die Routine als ausfhrbar markiert
                   handleparamaktiv := False;
                   dbgrd_wvl.Enabled := True;

                   GgfLogEvntEnd ('HandleParam End via Exit #9');
                   exit;
                end;
             end;
             SetLength(GArcSList, 1);
             GArcSList[0].ArcID := iGArcID;
             GArcSList[0].ArcName := sGArcName;
             GArcSList[0].TblName := sIArcName;
             iGArcRecNo := -1;
             if dbtv_LgrArc.Selected = nil then
             begin
                cbx_Archiv.ItemIndex := -1;
                DelStatus;

                if sIArcName <> '' then
                begin
                   logwvl('3201, WVL vor CreStatus ');
                   CreStatus; 
                   iGZusFCount := CreZusFields(false);
                end;
                bMultiArcQuery := False;
                GetArcUsrRights;
             end;

             if rGarcright.list or gbwvlcellclick then
             begin
                dm_DB.tim_ansicht.enabled := false;
                QueryArc('Select  * from arc_' + GArcSList[0].TblName +
                   ' as arc where doc_id = ' + IntToStr(iTmpDocID));
                gbsearched := True;
                GetDocUsrRights(False);
//                dm_DB.tim_ansicht.enabled := True;
                HandleDoc;
             end;

             bGImageDisp := True;
             if dbgrd_Trefferliste.visible and not wvlhasfocus then
             begin
                dbgrd_Trefferliste.SetFocus;
             end;

             bParamHandled := True;
             HPTorOpen := True;

          end;
       except
          dbgrd_wvl.Enabled := True;
          HPTorOpen := True;
       end;
      finally
         handleparamaktiv := False; //3.5.0.56 [2419]
      end;
      handleparamaktiv := False;
      bParamHandled := True;
      dbgrd_wvl.Enabled := True;
   end;
   handleparamaktiv := False;
   dbgrd_wvl.Enabled := True;

   if liinterchange = 0 then
   begin
      application.bringtofront;
      frm_mainform.BringToFront;
      dm_MainForm2.ForceForegroundWindow(application.handle);
   end;
   finally
     GgfLogEvntEnd ('HandleParam End handleparamaktiv=' + BS(handleparamaktiv));
   end;
end;

function Tfrm_MainForm.SaveLgrArcStat: boolean;
   //////////////////////////////////////////////////////////////////
   ///  06.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion sichert den optischen Aufbau des Lager    ///
   ///  und Archiv Baumes in der Registrierung.                   ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount, iID: integer;
   reg: TRegistry;
begin
   GgfLogEvnt('SaveLgrArcStat');
   Result := True;
   reg := TRegistry.Create;
   try
      try
         reg.RootKey := HKEY_CURRENT_USER;
         reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\LgrArcTree', True);
         for iCount := 0 to dbtv_LgrArc.Items.Count - 1 do
         begin
            iID := integer(dbtv_LgrArc.Items.Item[iCount].Data);
            reg.WriteBool(IntToStr(iID), dbtv_LgrArc.Items.Item[iCount].Expanded);
         end;
         reg.CloseKey;
      except
         on e: Exception do
         begin
            Result := False;
            ErrorMsg('SaveLgrArcStat', _('Fehler beim Speichern des Treestatus:') +
               e.Message, 2038, True);
         end;
      end;
   finally
      FreeAndNil(reg);
   end;
end;

function Tfrm_MainForm.LoadLgrArcStat: boolean;
   //////////////////////////////////////////////////////////////////
   ///  06.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion liest den optischen Aufbau des Lager und   ///
   ///  Archiv Baumes aus der Registrierung.                      ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
   //  Einlesen der Tree Knoten aus den Lager und aRCHiVEN

var
   iCount, iID: integer;
   sStdLgr, sStdArc : string;
   reg: TRegistry;
   stack: TStringList;

begin
   GgfLogEvntBeg ('LoadLgrArcStat Begin');
   stack := TStringList.Create;
   Result := True;
   sStdLgr := '';
   sStdArc := '';
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\LgrArcTree', True);
            dbtv_lgrarc.Enabled := False;
            // Treeview aktualisierung ausschalten damit der Baum nicht flackert

            iCount := 0;
            while iCount <= dbtv_LgrArc.Items.Count - 1 do
            begin
               if (dbtv_LgrArc.Items.Item[iCount].ImageIndex = 2) or
                  (dbtv_LgrArc.Items.Item[iCount].ImageIndex = 0) then
               begin
                  if (not dbtv_LgrArc.Items.Item[iCount].HasChildren) then
                  begin
                  	dbtv_LgrArc.Items.Item[iCount].delete;
                     if iCount > 0 then
                      Dec(iCount);
                  end
                  else
                  	inc(iCount);
               end
               else
               	inc(iCount);
            end;

            if gbSavLgrArc then
            begin

               iCount := 0;
               for icount := 0 to dbtv_LgrArc.Items.Count - 1 do
               begin
                  iID := integer(dbtv_LgrArc.Items.Item[iCount].Data);
                  // check first if value exists
                  if ValueExists(IntToStr(iID)) then
                  begin
                     // Korrektur des zuckenden Treestatus
                     if ReadBool(IntToStr(iID)) then
                        dbtv_LgrArc.Items.Item[iCount].Expand(False)
                     else
                        dbtv_LgrArc.Items.Item[iCount].Collapse(False);
                  end;
               end;

               CloseKey;
               // Treeview einschalten, damit der Baum auch wieder sichtbat wird

               dbtv_lgrarc.Enabled := True;
               dbtv_LgrArc.Select(dbtv_LgrArc.TopItem);
            end
            else
            begin
               dbtv_LgrArc.FullCollapse;
               dbtv_lgrarc.Enabled := True;
               dbtv_LgrArc.Select(dbtv_LgrArc.TopItem);
               dbtv_LgrArc.Selected.Expand(false);
               cbx_Lager.ItemIndex := cbx_Lager.Items.IndexOf(dbtv_LgrArc.TopItem.text);
                cbx_LagerChange(self);
            end;
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            Result := False;
            dbtv_LgrArc.FullCollapse;
            GgfLogEvnt ('LoadLgrArcStat Exception ' + e.Message);
               JclLastExceptStackListToStrings(stack, False, True, True, False);
               //stack.Delimiter := #13;
               LogEvnt(stack.Text);
               FreeAndNil(stack);
            gbArchivChange := False;
            //ErrorMsg('SaveLgrArcStat', 'Fehler beim Laden des Treestatus:' + e.Message, 2038, True);
         end;
      end;
   finally
      FreeAndNil    (reg);
      GgfLogEvntEnd ('LoadLgrArcStat End');
      dbtv_LgrArc.OnAdvancedCustomDrawItem := dbtv_LgrArcAdvancedCustomDrawItem;
      dbtv_LgrArc.OnCollapsed := dbtv_LgrArcCollapsed;
      dbtv_LgrArc.OnExpanded := dbtv_LgrArcExpanded;
      dbtv_LgrArc.Enabled := True;
      dbtv_LgrArc.Visible := True;
   end;
end;

function Tfrm_MainForm.LoadStdArc: Boolean;
var
	reg: TRegistry;
   sStdLgr, sStdArc : string;
   liArcid, iStdLgrInd : integer;
begin
   iStdLgrInd := 0;
   sStdLgr := '';
   sStdArc := '';
   GgfLogEvntBeg ('LoadStdArc Begin');
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;

            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);

            if ValueExists('StdArcID') and gbSavLgrArc then    // neue Methode
            begin
               liArcid := strtoint(ReadString('StdArcID'));
               if liArcid > 0 then
               begin
                  dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(liArcid), []);
                  if dbtv_LgrArc.Selected = nil then    // nicht gefunden
                  begin
                     dbtv_LgrArc.Select(dbtv_LgrArc.Items.GetFirstNode, []);
                     cbx_Lager.ItemIndex :=
                        cbx_Lager.Items.IndexOf(dbtv_LgrArc.TopItem.text);
                  end;
                  //dbtv_LgrArcSet (false, true);
               end
               else
               begin
                     dbtv_LgrArc.Select(dbtv_LgrArc.Items.GetFirstNode, []);
                     cbx_Lager.ItemIndex :=
                        cbx_Lager.Items.IndexOf(dbtv_LgrArc.TopItem.text);
               end;
               dbtv_LgrArcSet (false, true);

            end
            else
            begin
               if ValueExists('StdLgr') then
                 sStdLgr := ReadString('StdLgr');

               if ValueExists('StdLgrInd') then
                 iStdLgrInd := strtoint(ReadString('StdLgrInd'));

               if (sStdLgr <> '') or (iStdLgrInd > 0) then
               begin
                  if iStdLgrInd > 0 then
                  begin
                     cbx_Lager.ItemIndex := iStdLgrInd;
                  end
                  else if (sStdLgr <> '') then
                  begin
                     cbx_Lager.ItemIndex :=
                        cbx_Lager.Items.IndexOf(sStdLgr);
                  end;
                  if cbx_Lager.ItemIndex = -1 then   // wenn ein unbrauchbarer Wert in der Registry steht
                  begin                              // nehmen wir den obersten Eintrag (root)
                     dbtv_LgrArc.Select(dbtv_LgrArc.Items.GetFirstNode, []);
                     cbx_Lager.ItemIndex :=
                        cbx_Lager.Items.IndexOf(dbtv_LgrArc.TopItem.text);
                  end;

                  cbx_LagerChange(self);
               end
               else
               begin
                  //first time viewer starting (hopefully)

                  cbx_Lager.ItemIndex :=
                     cbx_Lager.Items.IndexOf(dbtv_LgrArc.TopItem.text);
                  cbx_LagerChange(self);
               end;
               if ValueExists('StdArc') then
                 sStdArc  := ReadString('StdArc');

               if  sStdArc <> '' then
               begin
                  cbx_Archiv.ItemIndex :=
                     cbx_Archiv.Items.IndexOf(sStdArc);
                  if cbx_Archiv.ItemIndex = -1 then
                     cbx_Archiv.ItemIndex := 0;
                  Trefferlistealreadyloaded := false;
                  if cbx_Archiv.ItemIndex <> -1 then
                     cbx_ArchivChange(self);
               end;

               if iGArcID > 0 then
                  dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGArcID), [])
               else
                  dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGLgrID), []);

               CloseKey;
            end;
         end;
      except
         on e: Exception do
         begin
            LogEvnt(_('Fehler bei LoadStdArc'));
         end;
      end;
   finally
   	FreeAndNil    (reg);
      GgfLogEvntEnd ('LoadStdArc End');
   end;
end;





///////////////////////////////////////////////////////////////////////////////////////
// Wiedervorlage aktivieren
// Taskabhaengige Aktivierung der Wiedervorlage liste
// Reaktivierung
//////////////////////////////////////////////////////////////////////////////////////

function Tfrm_MainForm.CheckTasks: boolean;
var
   dtStart, dtEnd: TDateTime;
   sStart, sEnd: string;
begin
   GgfLogEvnt('CheckTasks');
   dtStart := StartOfTheWeek(Date);
   dtEnd := EndOfTheWeek(Date);
   DateTimeToString(sStart, 'yyyy-mm-dd hh:nn:ss', dtStart);
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', dtEnd);
   if TmpSQL(
      'Select  tim_id, tim_ref,erinnerung, termin, sys_arc.arc_id, arc_name, arc_tblname, doc_id, doc_titel, info, status, usr_id_work, usr_id_shed from sys_timer ' + 'left join sys_arc using(arc_id) where usr_id_work = ' + IntToStr(iGUsrID) + ' and status <> 2 and ' + '((Termin between ' + #39 + sStart + #39 + ' and ' + #39 + sEnd + #39 + ') or status <> 2)') then
   begin
      if dm_DB.my_q_Tmp.RecordCount > 0 then
      begin
         Result := True;

      end
      else
         Result := False;
   end
   else
      Result := False;
   dm_DB.my_q_Tmp.Close;
end;

function Tfrm_MainForm.CheckBookmark: boolean;
   //////////////////////////////////////////////////////////////////
   ///  12.08.2005 Erstellt by SV                                 ///
   ///                                                            ///
   ///  Setzt die Steuerelemente auf den Ausgangszustand zurck
   ///  Reset der Steuelemente in Zustand NULL                    ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
begin
   GgfLogEvnt('CheckBookmark');
   Result := True;
   try
      if dbgrd_Trefferliste.SelectedRows.Count = 0 then
         dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
   except
      on e: Exception do
      begin
         ErrorMsg('frm_MainForm.CheckBookmark',
            _('Fehler beim Selectieren des aktuellen Datensatzes:') + e.Message,
            2037,
            True);
         Result := False;
      end;
   end;
end;


function Tfrm_MainForm.ReadReg: boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///  Registry lesen                                            ///
   ///  Diese Funktion liest die Standardeinstellungen des Ben-   ///
   ///  utzers aus und setzt die Entsprechenden Funktionen        ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///  In Anlehnung an die datensicherung                        ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
   icount, litmp: integer;
   lbresetwvl: boolean;
   lstmp: string;

   // Neue functions, kann die vielen if ersetzen
   function CheckReadBool(const Name: string): Boolean;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadBool(Name)
      else
         Result := False;
   end;
   function CheckReadInteger(const Name: string): Integer;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadInteger(Name)
      else
         Result := 0;
   end;
   function CheckReadIntegerDef(const Name: string; Def: integer): Integer;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadInteger(Name)
      else
         Result := Def;
   end;
   function CheckReadString(const Name: string): string;
   begin
      if reg.ValueExists(Name) then
         Result := reg.ReadString(Name)
      else
         Result := '';
   end;

begin
   GgfLogEvnt('ReadReg');
   Result := True;
   DocViewSavesLoad(gDocViewSaves);
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);

            if ValueExists('Synctime') then
            begin
               if readbool('Synctime') = True then
               begin
                  if ValueExists('bfaTimeServer') then
                  begin
                     ngtimeserver := readstring('bfaTimeServer');
                     {err := }ShellExecute(0, 'open', PChar(
                        BD.EnvSystemRoot + '\system32\cmd.exe'),
                        PChar('/c net time ' + ngtimeserver + '/set /yes'),
                        nil, SW_hide);
                  end;
               end;
            end;
            if ValueExists('AZoom') then
            begin
               case ReadInteger('AZoom') of
                  0:
                     tbsi_VZoom.ImageIndex := 23;
                  1:
                     tbsi_VZoom.ImageIndex := 22;
                  2:
                     tbsi_VZoom.ImageIndex := 21;
                  3:
                     tbsi_VZoom.ImageIndex := 25;
                  4:
                     tbsi_VZoom.ImageIndex := 41;
               end;
            end;
            if ValueExists('StdMail') then
            begin
               case ReadInteger('StdMail') of
                  0:
                     tbsi_VMail.ImageIndex := 16;
                  1:
                     tbsi_VMail.ImageIndex := 15;
                  2:
                     tbsi_VMail.ImageIndex := 30;
               end;
            end;
            if ValueExists('StdDesp') then
            begin
               case ReadInteger('StdDesp') of
                  0:
                     tbsi_VDeSpeckle.ImageIndex := 36;
                  1:
                     tbsi_VDeSpeckle.ImageIndex := 37;
                  2:
                     tbsi_VDeSpeckle.ImageIndex := 38;
                  3:
                     tbsi_VDeSpeckle.ImageIndex := 39;
                  4:
                     tbsi_VDeSpeckle.ImageIndex := 35;
               end;
            end;

				dm_Themes.skinSw.Theme := CheckReadString('Theme');
            bGLstDocInUse := CheckReadBool('ListDocInUse');
            bFillZusFields := CheckReadBool('FillZusFields');
            bAutoPreview := CheckReadBool('AutoPreView');
            bGAddAsterix := CheckReadBool('AddAsterix');
            bGAppAsterix := CheckReadBool('AppAsterix');
            bGVTXSLW := CheckReadBool('VtxSlw');
            frm_Mainform.fra_Voransicht.img_DocView.MouseWheelParams.InvertDirection :=
               CheckReadBool('MouseRadDirection');
            bAutoDispNew := CheckReadBool('AutoDispNew');
            gbNoteslwrecord := CheckReadBool('Noteslwrecord');
            gbNotevtxrecord := CheckReadBool('Notevtxrecord');
            fra_Voransicht.fNoteslwrecord := gbNoteslwrecord;
			   fra_Voransicht.fNotevtxrecord := gbNotevtxrecord;
            bExportPDF := CheckReadBool('ExportPDF');
            gBvolltextkeywordspdf := CheckReadBool('volltextkeywordspdf');

            tifbysave := not bExportPDF;
            GbCrproridoc := CheckReadBool('Crproridoc');
            gbOleoutlook := CheckReadBool('Oleoutlook');
            gbchangepagebyenter := CheckReadBool('Changepagebyenter');
            fra_doclink.fbShowlinkcount := CheckReadBool('Showlinkcount');

            gsstandarddir := trim(CheckReadString('standardlgrsave'));
            gbSavLgrArc := CheckReadBool('SavLastArcLgr');

            if gbchangepagebyenter then
            	tbxse_page.OnChange := nil
            else
               frm_mainform.tbxse_page.OnChange := frm_mainform.tbxse_pageChange;

            bUseIntMail := CheckReadBool('UseIntMail');
            dm_MainForm2.bh_Main.UseBalloonAsApplicationHint := CheckReadBool('BalloonHints');

            //Wiedervorlage   CheckTask Wiedervorlage timer
            //Timer intervall fuer Wiedervorlage lesen
            dm_MainForm2.tim_ChkTasks.Interval := CheckReadInteger('ChkTasksInterval') * 60000;
            dm_MainForm2.tim_ChkTasks.Enabled := CheckReadBool('ChkTasksTimer');
            if ValueExists('Hits') then
            begin
               lstmp := ReadString('Hits');
               if (cbx_MaxTreffer.Items.IndexOf(lstmp) <> -1) and ('alle' <> lstmp) then
               begin
                  try
                     litmp := StrToInt(lstmp);
                  except
                     on e: Exception do
                     begin
                        litmp := 50;
                     end;
                  end;
                  sGmaxhits := 'Limit ' + IntToStr(litmp);
                  iGmaxhits := litmp;
                  cbx_MaxTreffer.Text := IntToStr(litmp);
               end
               else
               begin
                  if 'alle' = lstmp then
                  begin
                     iGmaxhits := -1;
                  end
                  else
                  begin
                     iGmaxhits := -2;
                  end;
                  sGMaxHits := '';
                  cbx_MaxTreffer.Text := lstmp;
               end;
            end
            else
            begin
               iGmaxhits := 50;
               sGMaxHits := ' limit 50';
            end;
            if ValueExists('DocTimer') then
               if ReadBool('DocTimer') then
               begin
                  ngdoctimer := True;
                  if CheckTasks and not optbybut and not FirstTimeWvl then
                  begin
                     tbi_VDocTimer.Checked := True;
                     dpnl_wvlg.Visible := True;
                  end;
               end
               else
               begin
                  ngdoctimer := False;
               end;

            if CheckReadBool('showallwvlbutton') then
            begin
               fbshowwvlbutton := true;
               tbix_showallwvl.visible := true;
               TBX_DelWvl.left := tlb_DocTime.left + tlb_DocTime.width + 5;
            end
            else
            begin
               fbshowwvlbutton := false;
            end;


            lfpmystrtowords := StrToWords4;
            lfpmystrtowords1 := StrToWords7; //m.frey Mehrfachauswahl

            if ValueExists('UseStdPrn') then
               iGUseStdPrn := ReadInteger('UseStdPrn');
            CloseKey;
            // load info of the old wvl
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\wvl', True);
            lbresetwvl := False;
            if ValueExists('iGTaskCount') then
            begin
               iGTaskCount := ReadInteger('iGTaskCount');
               setlength(iGtim_id, iGTaskCount);
               for icount := 0 to iGTaskCount - 1 do
               begin
                  if ValueExists('tim_id' + IntToStr(icount)) then
                     iGtim_id[icount] := ReadInteger('tim_id' + IntToStr(icount))
                  else
                  begin
                     LogEvnt('Wiedervorlage in der Windows-Registry Korrupt! Reset angeordnet.');
                     lbresetwvl := True;
                  end;
               end;
            end;
            CloseKey;
            if lbresetwvl then
            begin
               iGTaskCount := 0;
               setlength(iGtim_id, iGTaskCount);
               reg.DeleteKey('Software\bitfarm\Archiv_V3\Viewer\wvl');
            end;
            chbx_VtxSlw.Checked := bGVTXSLW;
            chbx_SOnlyUsed.Checked := bGLstDocInUse;
         end;
      except
         on e: Exception do
         begin
            Result := False;
            ErrorMsg('frm_MainForm.ReadReg',
               _('Fehler beim Auslesen der Standardwerte:') + e.Message, 2036, True);
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_MainForm.CheckReg: boolean;
   //////////////////////////////////////////////////////////////////
   ///  14.07.2005 Erstellt by SV.                                ///
   ///  061108 Dokumentationerweiterung NG
   ///  Registry auslesen
   ///                                                            ///
   ///  Diese Funktion liest die Standardeinstellungen des Ben-   ///
   ///  utzers aus und setzt die Entsprechenden Funktionen        ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
   list: integer;
   lstmp: string;
   slMoveFile: TStrings;
   sKS, spk: string;
   ini: tinifile;
   lbregkeynarchived: boolean;
   lsBraFilename, lsExeEintrag: string;
begin
   GgfLogEvnt('CheckReg');
   Result := True;
   reg := TRegistry.Create;
   list := 0;
   lbregkeynarchived := false;
   try
      with reg do
      begin
         RootKey := HKEY_LOCAL_MACHINE;
         OpenKey('\SOFTWARE\Microsoft\Windows NT\CurrentVersion\', True);
         if ValueExists('CurrentVersion') then
         begin
            GsWindowsVersion := ReadString('CurrentVersion');
            TryStrToFloat(GsWindowsVersion, gfWindowsVersion);
         end;

         closekey;
      end;
   except
      on e: Exception do
      begin
         logevnt('Could read windows version');
      end;
   end;
   try
      try
         with reg do
         begin
            CloseKey;
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            WriteString('ViewerFilePath', BD.ExeDir);
            if not ValueExists('AZoom') then
               WriteInteger('AZoom', 2);
            if not ValueExists('StdMail') then
               WriteInteger('StdMail', 2);
            if not ValueExists('StdDesp') then
               WriteInteger('StdDesp', 4);
            if not ValueExists('ListDocInUse') then
               WriteBool('ListDocInUse', False);
            if not ValueExists('FillZusFields') then
               WriteBool('FillZusFields', True);
            if not ValueExists('Hits') then
               WriteString('Hits', '50');
            if not ValueExists('AutoPreView') then
               WriteBool('AutoPreView', True);
            if not ValueExists('AddAsterix') then
               WriteBool('AddAsterix', True);
            if not ValueExists('AppAsterix') then
               WriteBool('AppAsterix', True);
            if not ValueExists('VtxSlw') then
               WriteBool('VtxSlw', True);
            if not ValueExists('DocTimer') then
               WriteBool('DocTimer', False); 
            if not ValueExists('AutoDispNew') then
               WriteBool('AutoDispNew', False);
            if not ValueExists('Crproridoc') then
               WriteBool('Crproridoc', False);
            if not ValueExists('UseStdPrn') then
               WriteInteger('UseStdPrn', -1);
            if not ValueExists('ExportPDF') then
               WriteBool('ExportPDF', True);
            if not ValueExists('volltextkeywordspdf') then
               WriteBool('volltextkeywordspdf', False);
            if not ValueExists('UseIntMail') then
               WriteBool('UseIntMail', True);
            if not ValueExists('BalloonHints') then
               WriteBool('BalloonHints', False);
            if not ValueExists('ChkTasksTimer') then
            begin
               WriteBool('ChkTasksTimer', True);
               FirstTimeWVL := True;
            end
            else
               FirstTimeWVL := False;
            if not ValueExists('ChkTasksInterval') then
               WriteInteger('ChkTasksInterval', 5);

            if not ValueExists('Noteslwrecord') then //3.5.0.22
               WriteBool('Noteslwrecord', True);
            if not ValueExists('Notevtxrecord') then //3.5.0.22
               WriteBool('Notevtxrecord', True);

            CloseKey;

            rootkey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\FormData\DocEditor', True);

            if not ValueExists('tbsi_TZoom_ImageIndex') then
               WriteString('tbsi_TZoom_ImageIndex', '22');
            closeKey;
         end;
      except
         on e: Exception do
         begin
            Result := False;
            ErrorMsg('frm_MainForm.CheckReg',
               'Fehler beim berprfen der Standardwerte:' + e.Message, 2036,
               True);
         end;
      end;
   finally
      reg.CloseKey;
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

function Tfrm_MainForm.ReadFav(Favorit: integer; fsetfocus: boolean): boolean;
   //////////////////////////////////////////////////////////////////
   ///  30.05.2005 Erstellt by SV.                                ///
   ///  Favoriten                                                          ///
   ///  Diese Funktion liest die Einstellungen des Favoriten in   ///
   ///  [Favorit] aus und setzt die entsprechenden Such-Parameter ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   reg: TRegistry;
   sFav, sLgr, sArc: string;
begin
   GgfLogEvnt('ReadFav');
   ComingFromFav := Favorit;

   if not fsetfocus then
   begin
      btn_ResFieldsClick(self);
   end;

   Result := True;
   sFav := IntToStr(Favorit);
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Favoriten', True);
            if not fsetfocus then
            begin
               if ValueExists('FavLgr' + sFav) then
               begin
                  sLgr :=  ReadString('FavLgr' + sFav);
                  if cbx_Lager.Items.IndexOf(sLgr) > -1 then
                  begin
                     cbx_Lager.ItemIndex :=  cbx_Lager.Items.IndexOf(sLgr);
                     cbx_LagerChange(self);
                  end
                  else
                  	Exit;   // nicht da ? dann weg hier

               end;
               if ValueExists('FavArc' + sFav) then
               begin
                  sArc := ReadString('FavArc' + sFav);
                  if cbx_Archiv.Items.IndexOf(sArc) > -1 then
                  begin
                  	cbx_Archiv.ItemIndex := cbx_Archiv.Items.IndexOf(sArc);
                     cbx_ArchivChange(self);
                     if iGArcID = 0 then
                        dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGLgrID), [])
                     else
	                     dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGArcID), []);
                  end
                  else
                     Exit;   // nicht da ? dann weg hier

               end;
            end;
            if ValueExists('FavSrc' + sFav) then
            begin
               pctr_Suchoptionen.Enabled := True;
               case ReadInteger('FavSrc' + sFav) of
                  0:
                  begin
                     pctr_Suchoptionen.ActivePage := tbs_StdSuche;
                     edt_SSlw.SetFocus;
                     edt_SSlw.SelectAll;
                  end;
                  1:
                  begin
                     pctr_Suchoptionen.ActivePage := tbs_Volltext;
                     memo_VTX.SetFocus;
                     memo_VTX.SelectAll;
                  end;
                  2:
                  begin
                     pctr_Suchoptionen.ActivePage := tbs_ZusFeld;
                     if sbx_ZusFeld.ComponentCount > 0 then
                     begin
                        with FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp0') as TEdit do
                           SetFocus; 
                     end;
                  end;
               end;
            end;
            if not fsetfocus then
            begin
               if ValueExists('FavUse' + sFav) then
                  chbx_SOnlyUsed.Checked := ReadBool('FavUse' + sFav);
               if iGArcID = 0 then
	               dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGLgrID), [])
               else
	               dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGArcID), []);
            end;
            closekey;
         end;
      except
         on e: Exception do
         begin
            Result := False;
            ErrorMsg('ReadFav', _('Fehler beim Auslesen eines Favoriten:') +
               e.Message, 2034, True);
         end;
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;
end;

procedure Tfrm_MainForm.GetArcUsrRights;
//////////////////////////////////////////////////////////////////
///  02.05.2005 Erstellt GetArcUsrRights by SV.                ///
///  Rechteverwaltung USER                                     ///
///  Diese Procedure liest aus der Tabelle sys_ArcXS die       ///
///  Rechte eines Benutzers auf das aktuelle Archiv aus und    ///
///  setzt die Rechte im Record rGArcRight                     ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   iRights: int64;
begin
   GgfLogEvnt('GetArcUsrRights');
   if iGLArcID = iGArcID then
      exit;
   iGLArcID := iGArcID;

   ClearRights(rGArcRight);

   //use crestatus field
   // cause conflict with sys_doclnk tmp request!
   dm_db.my_q_tmp_CreStatus.sql.Text :=
      'Select bit_or(rights) as rechte from sys_arcxs where arc_id = ' +
      IntToStr(iGArcID) + ' and usr_id = ' + IntToStr(iGUsrID) + ' Group by usr_id';
   dm_db.my_q_tmp_CreStatus.Execute;
   if dm_db.my_q_tmp_CreStatus.RecordCount > 0 then
   begin
      with dm_DB.my_q_Tmp_CreStatus do
         while not EOF do
         begin

            iRights := FieldByName('rechte').AsInteger;
            if (iRights and 1) = 1 then
               rGArcRight.list := True;
            if (iRights and 2) = 2 then
               rGArcRight.Read := True;
            if (iRights and 4) = 4 then
               rGArcRight.modify := True;
            if (iRights and 8) = 8 then
               rGArcRight.Write := True;
            if (iRights and 16) = 16 then
               rGArcRight.mail := True;
            if (iRights and 32) = 32 then
               rGArcRight.print := True;
            if (iRights and 64) = 64 then
               rGArcRight.link := True;
            if (iRights and 128) = 128 then
               rGArcRight.import := True;
            if (iRights and 256) = 256 then
               rGArcRight.history := True;
            if (iRights and 512) = 512 then
               rGArcRight.move := True;
            if (iRights and 1024) = 1024 then
               rGArcRight.aWrite := True;
            if (iRights and 2048) = 2048 then
               rGArcRight.aRead := True;
            if (iRights and 4096) = 4096 then
               rGArcRight.aModify := True;
            if (iRights and 8192) = 8192 then
               rGArcRight.apWrite := True;
            if (iRights and 16384) = 16384 then
               rGArcRight.apRead := True;
            if (iRights and 65536) = 65536 then
               rGArcRight.hstprotoread := True;
            if (iRights and 131072) = 131072 then
               rGArcRight.suanno := True;
            if (iRights and 262144) = 262144 then
               rGArcRight.docdel := True;
            if (iRights and 524288) = 524288 then
               rGArcRight.docexport := True;
            Next;
         end;
      dm_DB.my_q_Tmp.Close;
      UseRights(rGArcRight);
      dm_MainForm2.pum_dbtvOrdnerExp.Enabled := rGArcRight.Write;
      fra_Voransicht.fRights := rGArcRight;
   end;
end;

procedure Tfrm_MainForm.GetDocUsrRights(fbuserights: boolean);
//////////////////////////////////////////////////////////////////
///  02.05.2005 Erstellt GetDocUsrRights by SV.                ///
///  Rechte Userverwaltung
///  Diese Procedure liest aus der Tabelle sys_DocXS die       ///
///  Rechte eines Benutzers auf das aktuelle Dokument aus und  ///
///  setzt die Rechte im Record rGDocRight
///
///                                                            ///
//////////////////////////////////////////////////////////////////

var
   iRights: integer;
begin
   GgfLogEvntBeg('GetDocUsrRights beg');
   try
      ClearRights(rgdocRight);

      if bMultiArcQuery then
         GetArcUsrRights;
      //todo why group by doc_id??
      if TmpSQL('Select Sql_No_cache bit_or(rights) as rechte from sys_docxs where arc_id = '
         + IntToStr(iGArcID) + ' and usr_id = ' + IntToStr(iGUsrID) +
         ' and doc_id = ' + IntToStr(iGDocID) + ' Group by doc_id') then
      begin
         with dm_DB.my_q_Tmp do
         begin
            rGDocRight := rGArcRight;
            if RecordCount = 0 then
            begin
               if TmpSQL('Select Sql_No_cache * from sys_timer where arc_id = ' +
                  IntToStr(iGArcID) + ' and usr_id_work = ' + IntToStr(iGUsrID) +
                  ' and doc_id = ' + IntToStr(iGDocID) + ' and status <> 2') then
               begin
                  if RecordCount <> 0 then
                  begin
                     rGDocRight.list := True;
                     rGDocRight.print := True;
                     rGDocRight.Read := True;
                     rGDocRight.link := True;
                     rGDocRight.modify := True;
                     rGDocRight.import := True;
                     rGDocRight.Write := True;
                     rGDocRight.history := False or rGArcRight.history;
                     rGDocRight.mail := True;
                     rGDocRight.move := False or rGArcRight.move;
                     rgDocRight.Aread := True;
                     rgDocRight.Awrite := True;
                     rgdocRight.AModify := True;
                     rgdocRight.ApRead := True;
                     rgdocRight.ApWrite := True;
                  end;
               end;
               //check for doclock
               gidoclock := 0;
               if gbhasdoclock then
               begin
                  if TmpSQL('select * from sys_doclock where ' +
                     ' arc_id=' + IntToStr(iGArcID) + ' and doc_id=' + IntToStr(iGDocID)) then
                  begin
                     if recordcount > 0 then
                     begin
                        if Fieldbyname('usr_id').asinteger = iGusrid then
                        begin
                           giactivedoclock := 1;
                           rGDocRight.modify := True;
                           rGDocRight.Write := True;
                           rgDocRight.Awrite := True;
                           rgdocRight.AModify := True;
                           rGDocRight.move := True;

                           gidoclock := 0;
                        end
                        else
                        begin
                           if rGDocRight.Write then
                           begin
                              gidoclock := 1;
                           end
                           else
                           begin
                              gidoclock := 2;
                           end;
                           rGDocRight.modify := False;
                           rGDocRight.Write := False;
                           rgDocRight.Awrite := False;
                           rgdocRight.AModify := False;
                           rGDocRight.move := False;
                        end;
                     end
                     else
                     begin
                        giactivedoclock := 0;
                     end;
                  end;
               end;
               if fbuserights then
               begin
                  UseRights(rGDocRight);
               end;

               exit;   //3.5.0.60
               
            end;
            GgfLogEvnt('GetDocUsrRights A');
            // use rights only for annotations!!!
            while not EOF do
            begin
               iRights := FieldByName('rechte').AsInteger;

               if (iRights and 8192) = 8192 then
                  rGDocRight.apwrite := True;
               if (iRights and 16384) = 16384 then
                  rGDocRight.apread := True;

               Next;
            end;
         end;
         dm_DB.my_q_Tmp.Close;
         if fbuserights then
         begin
            UseRights(rGDocRight);
         end;
         fra_Voransicht.fRights := rGDocRight;
      end
      else
         ErrorMsg('GetDocUsrRights', _('Fehler beim Auslesen der Benutzerrechte'), 2008,
            True);
   finally
      GgfLogEvnt('GetDocUsrRights fbuserights='+BS(fbuserights)+' rGDocRight='+StringFromRData(rGDocRight));
      GgfLogEvntEnd('GetDocUsrRights end');
   end;
end;

procedure Tfrm_MainForm.UseRights(RightData: TRData);
//////////////////////////////////////////////////////////////////
///  02.05.2005 Erstellt UserRights by SV.  and Modifies by NG ///
///  Rechteverwaltung
///                                                          ///
///  Diese Procedure liest aus der dem Record RightData die    ///
///  aktuellen Rechte eines Benutzers aus und deaktiviert bzw  ///
///  aktiviert die Viewer Funktionen                           ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   GgfLogEvnt('UseRights');

   // Print [Start]
   tbsi_VPrint.Enabled := RightData.print;

   dm_MainForm2.mnu_TPrint.Enabled := RightData.print;

   // Save [Start]
   // tbi_VSaveDoc.Enabled := RightData.write;
   dm_MainForm2.mnu_TSaveLocal.Enabled := RightData.Write;
   dm_MainForm2.mnu_TCopyToClip.Enabled := RightData.Write;
   dm_MainForm2.mnu_TSave.Enabled := RightData.Write;
   dm_MainForm2.mnu_Dokument_lokal_speichern.Enabled := RightData.Write;
   dm_MainForm2.mnu_DokumentlokalalsPDFspeichern1.Enabled := RightData.Write;
   dm_MainForm2.mnu_TSaveLocal.Enabled := RightData.Write;
   frm_Mainform.tbsi_localspeichern.Enabled := RightData.Write;

   frm_Mainform.tbi_VOCR.Enabled :=  RightData.Write;
   frm_Mainform.tbx_mnuocr.Enabled := RightData.Write;
   frm_MainForm.tbi_createemptypage.Enabled :=  RightData.Write;
   frm_MainForm.tbi_docdup.Enabled :=  RightData.Write;

   frm_MainForm.sbti_export.Enabled := RightData.Write;
   dm_MainForm2.mnu_expsel.Enabled := RightData.Write;
   dm_MainForm2.pum_dbtvOrdnerExp.Enabled := rGArcRight.Write;

   // Email [Start]

   tbsi_VMail.Enabled := RightData.mail;

   tbi_VLokalSave.Enabled := RightData.mail;
   dm_MainForm2.mnu_TMail.Enabled := RightData.mail;
   dm_MainForm2.mnu_AlsTifPdfZumEMailVersandVormerken.Enabled := RightData.mail;
   dm_MainForm2.mnu_OriginalDateiZumEMailVormerken.Enabled := rightData.mail;
   dm_MainForm2.mnu_gesammelteDokumenteversenden1.Enabled := rightData.mail;
   dm_MainForm2.mnu_GesammelteDokumentealseinPDFversenden1.Enabled := rightData.mail;
   tbi_deldoc.Enabled := RightData.docdel;

   // List [Start]
   tbi_DocVoransicht.Enabled := RightData.read;
   tbi_DocVolltext.Enabled := RightData.read;

   dm_MainForm2.mnu_AddDocTimer.Enabled := RightData.read;
   dm_MainForm2.mnu_AddDocTimer.Visible := RightData.read;

   // Dokumenten-Editor
   // tbi_VEdit.Enabled := RightData.modify;
   tbi_Vedit.Enabled := RightData.aWrite or RightData.AModify or RightData.modify;
   // Links [Start]
   tbi_DocLink.Enabled := RightData.link;
   tbi_VNewLink.Enabled := RightData.link;
   tbi_VLinkDoc.Enabled := RightData.link;
   TBXItem36.Enabled := RightData.link;
   tbi_VDocLinks.Enabled := RightData.link;
   dm_MainForm2.mnu_DocLinks.Enabled := RightData.link and (tci_DocLink.Color = clYellow);
   dm_MainForm2.mnu_TNewAutoRef.Enabled := RightData.link;
   dm_MainForm2.mnu_TLinkDoc.Enabled := RightData.link;
   dm_MainForm2.mnu_RefTools.Enabled := RightData.link;
   if gbAppStarted then
   begin
   if ((not RightData.Read) and (not fshowwvldoc)) and
      tbi_DocVoransicht.Checked then
   begin
      ShowFrame(sfNix);

   end
   else
   if tbi_docVoransicht.Checked and not fra_Voransicht.Visible then
      ShowFrame(sfVoransicht);
   if ((not RightData.Read) and (not fshowwvldoc)) and
      tbi_docVolltext.Checked then
   begin
      ShowFrame(sfNix);
   end
   else
   if tbi_docVolltext.Checked and not fra_Volltext.Visible then
      ShowFrame(sfVolltext);

   // History [Start]
   tbi_DocHistory.Enabled := RightData.history;
   if not RightData.history and fra_History.Visible then
      ShowFrame(sfNix)
   else
   if tbi_DocHistory.Checked and not fra_History.Visible then
      ShowFrame(sfDocLink);

   // Links [Start]
   tbi_DocLink.Enabled := RightData.link;
   tbi_VNewLink.Enabled := RightData.link;
   tbi_VLinkDoc.Enabled := RightData.link;
   if (sGRefName <> '') then
   begin
      ActivateLinkDoc(RightData.link);
   end
   else
   begin
      ActivateLinkDoc(False);
   end;
   tbi_VDocLinks.Enabled := RightData.link;
   dm_MainForm2.mnu_DocLinks.Enabled := RightData.link and (tci_DocLink.Color = clYellow);
   dm_MainForm2.mnu_TNewAutoRef.Enabled := RightData.link;
   dm_MainForm2.mnu_TLinkDoc.Enabled := RightData.link;
   if not RightData.link and fra_DocLink.Visible then
      ShowFrame(sfNix)
   else
   if tbi_DocLink.Checked and not fra_DocLink.Visible then
      ShowFrame(sfHistory);

   // Modify Document [Start]
   // tbi_VEdit.Enabled := RightData.modify;
   tbi_Vedit.Enabled := RightData.aWrite or RightData.AModify;

   if not gbprintingdoc then
   begin
      tbi_VShowAnno.Enabled := RightData.aread;
      tbi_VShowAnno.Checked := RightData.aread;
      if tbi_VShowAnno.Checked then
      begin
         tbx_privNote.Visible := True;
         tbx_pubNote.Visible := True;
         // tbx_UserNote.Visible:=false;
      end
      else
      begin
         tbx_privNote.Visible := False;
         tbx_pubNote.Visible := False;
         //tbx_UserNote.Visible:=true;
      end;
   end;
   shownoAnno := not RightData.aread;
   Nog_EAnDel := RightData.awrite;
   end;
   tbi_VInvert.Enabled := RightData.modify;
   tbi_VRemBorder.Enabled := RightData.modify;
   tbi_VDeSkew.Enabled := RightData.modify;
   tbsi_VDeSpeckle.Enabled := RightData.modify;
   tbi_VTurnLeft.Enabled := RightData.modify;
   tbi_VTurnRight.Enabled := RightData.modify;
   tbi_VFlip.Enabled := RightData.modify;
   tbi_VSlwEdit.Enabled := RightData.modify;
   dm_MainForm2.mnu_TEditDoc.Enabled := RightData.modify;
   dm_MainForm2.mnu_TRemBor.Enabled := RightData.modify;
   dm_MainForm2.mnu_TDeSkew.Enabled := RightData.modify;
   dm_MainForm2.mnu_TDeSpeckle.Enabled := RightData.modify;
   dm_MainForm2.mnu_TTurnLeft.Enabled := RightData.modify;
   dm_MainForm2.mnu_TTurnRight.Enabled := RightData.modify;
   dm_MainForm2.mnu_TFlip.Enabled := RightData.modify;
   dm_MainForm2.mnu_TChangeDocName.Enabled := RightData.modify;
   dm_MainForm2.mnu_DocMerge.Enabled := RightData.modify and not bMultiArcQuery;
   // GraficTools, Annotations
   EnableGraphicTools(not RightData.awrite);
   tbi_mnustempel.Enabled :=  RightData.awrite;
end;

procedure Tfrm_MainForm.ReadLgrArcTree;
//////////////////////////////////////////////////////////////////
///  02.05.2005 Erstellt ReadLgrArcTree by SV.                 ///
///                                                            ///
///  Diese Procedure liest alle Lager und Archive aus, auf die ///
///  der aktuelle Benutzers (iGUsrID) Berechtigungen hat       ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   iCount: integer;
begin
   GgfLogEvnt ('ReadLgrArcTree');

   // show only archive which we have  list right!
   dbtv_lgrarc.Enabled := False;
   dbtv_LgrArc.Visible := False;
   if LgrArcSQL('Select Sql_No_cache * FROM sys_arc left join sys_arcxs using(arc_id) where (usr_id = '
      + IntToStr(iGUsrID) + ' or Type = 0) ' +
      'group by sys_arc.Arc_id order by Type, arc_Name, sys_arc.Arc_id') then
   begin
      GgfLogEvnt (LastSQL);

      //insert it so there is no bug with the tree (having a node out of sight)
      dbtv_LgrArc.FullCollapse;
      dbtv_LgrArc.FullExpand;
      dbtv_LgrArc.AutoExpand := False;
      for iCount := 0 to (dbtv_LgrArc.Items.Count - 1) do
      begin
         dbtv_LgrArc.Items.Item[iCount].SelectedIndex :=
            dbtv_LgrArc.Items.Item[iCount].ImageIndex + 2;
      end;
      fbloadinarc := false;
      dbtv_LgrArc.FullCollapse;
      dbtv_LgrArc.Items.GetFirstNode.Expand(false);
      dbtv_LgrArc.Select(dbtv_LgrArc.Items.GetFirstNode, []);
      iGLgrID := Integer(dbtv_LgrArc.Selected.Data);
   end;
end;

procedure Tfrm_MainForm.ReadSysArc;
var
  i: Integer;
  curArcid : Integer;
  maxid : Integer;
begin

  if  TmpSysArcSQL('select max(arc_id) as maxid from sys_arc') then
  begin
    maxid :=  dm_DB.my_q_sysarc.FieldByName('maxid').AsInteger;
  end;

  if maxid > 0 then
  begin
     If TmpSysArcSQL('Select ARC_ID, LGR_ID, ARC_Name, ARC_TBLName, ARC_Enabled, Type, Arc_BackPic, Options, DefDocname from sys_arc') then
     begin
       with dm_DB.my_q_sysarc do
       begin
          if RecordCount > 0 then
          begin
            SetLength(GSysArc, maxid +1);
            First;
            for i:= 0 to RecordCount -1 do
            begin
              curArcid := FieldByName('arc_id').AsInteger;

              GSysArc[curArcid].ArcID := curArcid;
              GSysArc[curArcid].LgrID := FieldByName('lgr_id').AsInteger;
              GSysArc[curArcid].ArcName := FieldByName('arc_name').AsString;
              GSysArc[curArcid].TblName := FieldByName('arc_tblname').AsString;
              GSysArc[curArcid].ArcEnabled := FieldByName('ARC_Enabled').AsInteger ;
              GSysArc[curArcid].typ := FieldByName('Type').AsInteger;
              GSysArc[curArcid].ArcBackpic := FieldByName('Arc_BackPic').AsString;
              GSysArc[curArcid].Options := FieldByName('Options').AsInteger;
              GSysArc[curArcid].DefDocname := FieldByName('DefDocname').AsString;
              Next;
            end;
          end;
       end;
     end;
  end;
end;


procedure Tfrm_MainForm.ShowVoransicht(FirstPage: boolean);
//////////////////////////////////////////////////////////////////
///
///  Voransicht
///  28.04.2005 Erstellt (SV)                                  ///
///  09.05.2005 Erweitert um Hintanzeige (SV)                  ///
///                                                            ///
///  Diese Procedure liest die Tiffdatei des Dokumentes ein    ///
///  und zeigt diese an                                        ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   GgfLogEvnt('ShowVoransicht - begin');
   if gbBlockVoransicht then //wegen vtiger 2182
      begin
         GgfLogEvnt('ShowVoransicht - Ende wegen gbBlockVoransicht');
         Exit; //3.5.0.28
      end;

   if (gtsl_ansicht.IndexOf(IntToStr(dm_db.my_q_arc.RecNo)) > -1) then
      exit;

   gtsl_ansicht.Add(IntToStr(dm_db.my_q_arc.RecNo));
   gbfirstpage := FirstPage;
   gcsListAnsicht.Acquire;
   dm_db.tim_ansicht.Enabled := True;
   gcsListAnsicht.Leave;
   if not bAutoPreview and not frm_MainForm.tbi_docVoransicht.Checked then
   begin
      if frm_MainForm.tbi_DocVolltext.Checked then
         frm_MainForm.tbi_DocVolltextClick(nil);
      if  frm_MainForm.tbi_DocLink.Checked then
         frm_MainForm.tbi_DocLinkClick(nil);
      if frm_MainForm.tbi_DocHistory.Checked then
         frm_MainForm.tbi_Doc_HistoryClick(nil);
   end;
   GgfLogEvnt('ShowVoransicht - end');
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
///  12.08.2005 Erstellt by SV                                                                            ///
///                                                                                                       ///
///  Setzt die Steuerelemente auf den Ausgangszustand zurck
///  zeigt die Volltext information des OCR Dokumentes an.                                            ///
///                                                                                                       ///
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
procedure Tfrm_MainForm.ShowVolltext;
begin
   GgfLogEvnt('ShowVolltext');
   if fra_Nix.Visible then
      fra_Nix.Visible := False;
   fra_Volltext.Visible := True;
   if dm_DB.my_q_Arc.RecordCount = 0 then
      exit;
   dm_DB.my_q_Arc.RefreshRecord;
   with fra_Volltext.redt_Volltext do
   begin
      Lines.Text := dm_DB.my_q_Arc.FieldByName('doc_txt').AsString;
      SelStart := 0; // War ntig um immer an den Anfang des Textes zu springen!!
      Perform(WM_VSCROLL, SB_TOP, 0);
   end;
   fra_Volltext.chbx_MarkHitsClick(self);
   CreZusPum(dm_MainForm2.pum_ImpZus, dm_MainForm2.pum_ImpZusClick, 'pum_ImpZus', False);
end;

////////////////////////////////////////////////////////////////////////////////
//  Dokumentverknuepfungen anzeigen
procedure Tfrm_MainForm.ShowDocLink;
begin
   GgfLogEvnt('ShowDocLink');
   if fra_Nix.Visible then
      fra_Nix.Visible := False;
   if dm_DB.my_q_Arc.RecordCount = 0 then
      exit;
   if fra_DocLink.GetLinks then
      fra_DocLink.GetLinkedDocs;
end;

////////////////////////////////////////////////////////////////////////////////
//  Dokument history anzeigen
procedure Tfrm_MainForm.ShowHistory;
var
   lsarcname: string;
   lidocid: integer;
begin
   GgfLogEvnt('ShowHistory');
   if fra_Nix.Visible then
      fra_Nix.Visible := False;
   if dm_DB.my_q_Arc.RecordCount = 0 then
      exit;

   lsarcname := sIarcname;
   lidocid := iGDocID;

   if HistSQL('Select Sql_No_cache hst_id, tstamp, task_info, usr_name from hst_' +
      lsarcname + ' left join sys_usr Using (usr_id) where doc_id = ' +
      IntToStr(lidocid) + ' order by tstamp desc') then
   begin
      fra_History.dbgrd_History.AdjustColumns;
   end
   else
      ErrorMsg('ShowHistory', _('Fehler bei Abfrage der History.'), 2015, True);
end;


procedure Tfrm_MainForm.dbgrd_TrefferlisteColumnMoved(Sender: TObject;
   FromIndex, ToIndex: integer);
begin
   GgfLogEvnt('dbgrd_TrefferlisteColumnMoved');
   ColumnMoved;
   gbColumnMoved := True;
end;

procedure Tfrm_MainForm.ColumnMoved;
begin
   GgfLogEvnt('ColumnMoved');

   if (GSysArc[igArcid].TblName <> '') and (not bMultiArcQuery) then
   begin
      try
         dbgrd_Trefferliste.Columns.SaveToFile(ResultlistDesignPath + '\' + GSysArc[igArcid].TblName + '.bfa');
      except on e: exception do
         begin
            logevnt('dbgrd_TrefferlisteColumnMoved ' + e.Message);
         end;
      end;
   end;
end;

procedure Tfrm_MainForm.dbgrd_WvlColumnMoved(Sender: TObject; FromIndex,
  ToIndex: Integer);
begin
    WVLColumnMoved;
end;

procedure Tfrm_MainForm.WVLColumnMoved;
begin
	if not gbAppStarted then
   	Exit;
  	try
      if tbi_MyTask.Checked then
         dbgrd_WVL.Columns.SaveToFile(ResultlistDesignPath + '\WVL.bfa');
      if tbi_MATask.Checked then
         dbgrd_WVL.Columns.SaveToFile(ResultlistDesignPath + '\WVLCtrl.bfa');
  	except on e: exception do
      begin
        logevnt('Fehler beim Speichern der WVL-Spalten ' + e.Message);
		end;
   end;
end;


//////////////////////////////////////////////////////////////////////////////////////////////////////
// Viewer init
// Einstellungen aus der Registry lesen
// keywords Registry Einstellungen Registry Einstellung
// FormData Key Redistry formadata Key
procedure Tfrm_MainForm.InitViewer;
var
   reg: TRegistry;
   iCount, lifav, lihnum, licounter, lipamount, iColumns, iCnt: integer;
   slStampKeys: TStrings;
   liini: Tinifile;
   ltbxnew: TTBXITEM;
   Doc: TdomDocument;
   DomNode0: Tdomnode;
   FNodeElement: TDomElement;
   lStream: TFileStream;
   ls, lslese, sFav, lscyg, lspname: string;
   lbfavdir, lbhascygwin, lbfavdironce,
   lbfavretry: boolean;
   lini: Tinifile;
   liitem: Tmenuitem;
   sLokale, SVerlauf, sLokaleLesezeichen, sVerlaufLesezeichen: string;   // Dummystrings fr gettext
begin
   GgfLogEvntBeg ('InitViewer Begin');

   sLokale := _('Lokale ');
   sVerlauf := _('Verlauf-');
   sLokaleLesezeichen := _('Lokale Lesezeichen');
   sVerlaufLesezeichen := _('Verlauf-Lesezeichen');

      with dm_db.my_conArc do
   begin
      if dm_db.my_conArc.Connected then
      begin
         if dm_DB.my_q_sysarc.Active then
            dm_DB.my_q_sysarc.Close;
         if dm_DB.my_q_arc.Active then
            dm_DB.my_q_arc.Close;
         if dm_DB.my_q_usr.Active then
            dm_DB.my_q_usr.Close;
         Close;
         Disconnect;
      end;

      if not Connected then
      begin
         Port := my_Con.Port;
         Server := my_Con.Server;
         Username := my_Con.Username;
         Password := my_Con.Password;
         DataBase := my_Con.Database;
         LoginPrompt := False;
         Options.Compress := True;
         Connect;
      end;
   end;
   
   fra_Voransicht.img_DocView.IO.AutoAdjustDPI := True;
   frm_mainform.tmb_Voransicht.MIO.AutoAdjustDPI := true;
   Application.HintPause := 1000;
   reg := TRegistry.Create;
   try
      with reg do
      begin
         RootKey := HKEY_CURRENT_USER;
         OpenKey('\Software\bitfarm\Archiv_V3\Viewer\FormData', True);
         if not KeyExists('DefMain') then
         begin
            CreateKey('DefMain');
            fms_MainForm.IniFileName :=
               '\Software\bitfarm\Archiv_V3\viewer\FormData';
            fms_MainForm.IniSection := 'DefMain';
            fms_MainForm.SaveFormPlacement;
            fms_MainForm.Active := True;
            fms_MainForm.Active := False;
            fms_MainForm.IniSection := 'MainForm';
         end;

         CloseKey;
      end;
   except
      on e: Exception do
         ErrorMsg('InitViewer', _('Fehler beim Erstellen der Standart Werte:') +
            e.Message, 2028, True);
   end;
   //check for cygwin
   lbhascygwin := false;
   try
      with reg do
      begin
         RootKey := HKEY_LOCAL_MACHINE;

         if OpenKey('\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2', false) then
         begin
            lbhascygwin := true;
            lscyg := readstring('native');
         end;
         CloseKey;
      end;
   except
      on e: Exception do
         ErrorMsg('InitViewer', _('Fehler beim Erstellen der Standart Werte:') +
            e.Message, 2028, True);
   end;
   try
      with reg do
      begin
         RootKey := HKEY_CURRENT_USER;
         if OpenKey('\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2', false) then
         begin
            lbhascygwin := true;
         end;
         CloseKey;
      end;
   except
      on e: Exception do
         ErrorMsg('InitViewer', _('Fehler beim Erstellen der Standart Werte:') +
            e.Message, 2028, True);
   end;
   // not have cygwin create it also (normal case)
   if not lbhascygwin then
   begin
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/local/share', true);
            WriteInteger('Flags', 10);   //binmode active
            WriteString('native', BD.ExeDir + 'Viewer-Files\ocrocmd');
            CloseKey;
         end;
      except
         on e: Exception do
            ErrorMsg('InitViewer', _('Fehler beim Erstellen der Standart Werte:') +
               e.Message, 2028, True);
      end;
   end
   else
   begin
      //check if it is Viewer-Files or tng if tng update
      if lscyg <> (BD.ExeDir + 'Viewer-Files\ocrocmd') then
      begin
         try
            with reg do
            begin
               RootKey := HKEY_CURRENT_USER;
               OpenKey('\SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/local/share', true);
               WriteInteger('Flags', 10);  //binmode active
               WriteString('native', BD.ExeDir + 'Viewer-Files\ocrocmd');
               CloseKey;
            end;
         except
            on e: Exception do
               ErrorMsg('InitViewer', _('Fehler beim Erstellen der Standart Werte:') +
                  e.Message, 2028, True);
         end;
      end;
   end;


   iGLgrID := -1;
   iGArcID := -1;
   iGDocID := -1;
   iGRArcID := -1;
   iGRDocID := -1;
   iGdbtvIdx:= -1;
   gbViewerShutdown := False;
   fra_Voransicht.img_DocView.Blank;
   // get for timerevelant actions the server time
   dm_db.my_q_datetime.SQL.Text :=
      'select date_format(now(),"%d%m%Y%H%i%s") as date';
   dm_db.my_q_datetime.Execute;
   sGTmpName := dm_db.my_q_datetime.FieldByName('date').AsString; //z.B. '15102009101344'
   //  DateTimeToString(sGTmpName, 'ddmmyyyyhhnnss', now);
   sGTmpName := sGTmpName + IntToStr(iGUsrID);   //z.B. '1510200910134470'
   dtp_SVon.DateTime := Date;
   dtp_SBis.Date := Date;

   ReadCbxUsr;

   ReadSysArc;

   ReadLgrArcTree;

   fbloadinarc := false;
   LoadLgrArcStat;

   ReadCbxLgr(cbx_Lager, dbtv_LgrArc);
   ReadCbxArc(cbx_Archiv, iGUsrID, iGLgrID);

	LoadStdArc;

   tv_lese.Items.Clear;
   vst_favfile.Clear;

   if ParamCount = 0 then
      bParamHandled := True;
   DelStatus;

   if (sIArcName <> '') and (not bMultiArcQuery) then
   begin
      CreStatus;
   end
   else
   begin
      if not Trefferlistealreadyloaded then
      begin
         CreateStandardColumnsTRefferliste;
      end;
   end;

   gbStarted2 := true;

   if ParamCount > 0 then
   begin
      for iCount := 1 to ParamCount do
      begin
         ls := inttostr(icount);
         GgfLogEvnt('paramstr ' + ls + ' ' + inttostr(icount));
         if ParamStr(icount) = '-debug' then
         begin
            bParamHandled := True;
         end
         else
         begin
            dm_MainForm2.tim_Blank.Enabled := False;
            GgfLogEvnt('paramstr handleparam');
            HandleParam(ParamStr(iCount));
         end;
      end;
   end;

   GgfLogEvnt('checked ');

   //load stamps
   if fileexists(PChar(BD.ExeDir + 'signs\' + sGUsrName + '.tif')) then
   begin
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' + sGUsrName, True);
            WriteString('StampFile', BD.ExeDir + 'signs\' +
               sGUsrName + '.tif');
            WriteBool('StampTyp', True);
            if not ValueExists('StampName') then
               WriteString('StampName', 'Unterschrift von ' + sGUsrName);
            if not ValueExists('StampHeight') then
               WriteInteger('StampHeight', 30);
            if not ValueExists('StampWidth') then
               WriteInteger('StampWidth', 40);
            if not ValueExists('favnr') then
               WriteInteger('favnr', 1);
            CloseKey;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('initviewer', _('Fehler beim Lesen des Registrierung:') +
               e.Message, 2200, True);
         end;
      end;
   end;

   u_HighUtils.LoadFavStampbuttons( tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5);

   try
      with reg do
      begin
         OpenKey('Software\bitfarm\Archiv_V3\Viewer\Favoriten', True);
         lbfavdironce := false;
         for iCount := 1 to 5 do
         begin
            lbfavdir := False;
            sFav := IntToStr(iCount);
            if ValueExists('FavArc' + sFav) then
            begin
               if readstring('FavArc' + sFav) <> '' then
               begin
                  lbfavdir := True;
                  lbfavdironce := true;
               end;
            end;
            if ValueExists('FavLgr' + sFav) then
            begin
               if readstring('FavArc' + sFav) <> '' then
               begin
                  lbfavdir := True;
                  lbfavdironce := true;
               end;
            end;

            if lbfavdir then
            begin
               TTBXitem(FindComponent('tbi_Fav' + sfav)).Enabled := True;
               TTBXitem(FindComponent('tbi_Fav' + sfav)).visible := True;
            end
            else
            begin
               TTBXitem(FindComponent('tbi_Fav' + sfav)).Enabled := False;
               TTBXitem(FindComponent('tbi_Fav' + sfav)).visible := False;
            end;
         end;
         if lbfavdironce then
         begin
            tlb_Favoriten.visible := true;
         end
         else
         begin
            tlb_Favoriten.visible := false;
         end;
         closekey;
      end;
   except
      on e: Exception do
      begin
         logevnt('Could read dir favs');
      end;
   end;

   //    bParamHandled set it so it will show the trefferliste and
   // it should be anyway set to true.
   bParamHandled := True;
   GgfLogEvnt('loading lese');
   lbfavretry := false;
   lslese := BD.AppdataBitfarmPd + 'Lese.xml';
   if not Fileexists(lslese) then
   begin
      doc := TdomDocument.Create(dm_MainForm2.DomImplementation1);
      FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
      FNodeElement.SetAttribute('name', 'Lokale ');
      doc.AppendChild(FNodeElement);

      try
         lStream := TFileStream.Create(lslese, fmCreate);
         try
            dm_MainForm2.DomToXMLParser_local.WriteToStream(Doc, 'ISO-8859-1', lStream);
         finally
            lStream.Free;
         end;
      except on e: exception do
            logevnt(_('Konnte private Lesezeichen nicht laden. Die Datei wird gelscht und neu angelegt.') + e.message);
      end;
   end;

   try
      dm_MainForm2.XmlToDomParser_local.ParseFile(lslese, True);
   except on e: exception do
      begin
         logevnt(_('Konnte private Lesezeichen nicht laden. Die Datei wird gelscht und neu angelegt.') + e.message);
         lbfavretry := true;
         killfile(lslese);
         doc := TdomDocument.Create(dm_MainForm2.DomImplementation1);
         FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
         FNodeElement.SetAttribute('name', 'Lokale ');
         doc.AppendChild(FNodeElement);
         try
            lStream := TFileStream.Create(lslese, fmCreate);
            try
               dm_MainForm2.DomToXMLParser_local.WriteToStream(Doc, 'ISO-8859-1', lStream);
            finally
               lStream.Free;
            end;
         except on e: exception do
            begin
               logevnt(_('Konnte private Lesezeichen nicht laden. Die Datei wird gelscht und neu angelegt.') + e.message);
            end;
         end;
      end;
   end;
   if lbfavretry then
   begin
      lbfavretry := false;
      try
         dm_MainForm2.XmlToDomParser_local.ParseFile(lslese, True);
      except on e: exception do
         begin
            logevnt(_('Konnte private Lesezeichen nicht laden. Sekundre Manahmen werden ergriffen.') + e.message);
            doc := TdomDocument.Create(dm_MainForm2.DomImplementation1);
            FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
            FNodeElement.SetAttribute('name', 'Lokale ');
            doc.AppendChild(FNodeElement);
            lbfavretry := true;
         end;
      end;
   end;

   if not lbfavretry then
      Doc := (dm_MainForm2.XmlToDomParser_local.DOMImpl.Documents.Item(0) as TdomDocument)
   else
      Doc := Nil;

   GgfLogEvnt('updateing lese');
   updatetreeview(doc, tv_lese, false);
   GgfLogEvnt('lese loaded');

   GgfLogEvnt('loading history');

   lslese := BD.AppdataBitfarmPd + 'History.xml';
   if not Fileexists(lslese) then
   begin
      doc := TdomDocument.Create(dm_MainForm2.Domimp_history);
      FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
      FNodeElement.SetAttribute('name', 'Verlauf-');
      doc.AppendChild(FNodeElement);

      try
         lStream := TFileStream.Create(lslese, fmCreate);
         try
            dm_MainForm2.DomToXMLParser_history.WriteToStream(Doc, 'ISO-8859-1', lStream);
         finally
            lStream.Free;
         end;
      except on e: exception do
            logevnt(_('Konnte privaten Verlauf nicht laden. Die Datei wird gelscht und neu angelegt.'));
      end;
   end;
   lbfavretry := false;

   try
      dm_MainForm2.XmlToDomParser_history.ParseFile(lslese, True);
   except on e: exception do
      begin
         logevnt(_('Konnte privaten Verlauf nicht laden. Die Datei wird gelscht und neu angelegt.'));
         killfile(lslese);
         lbfavretry := true;
         doc := TdomDocument.Create(dm_MainForm2.Domimp_history);
         FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
         FNodeElement.SetAttribute('name', 'Verlauf-');
         doc.AppendChild(FNodeElement);
         try
            lStream := TFileStream.Create(lslese, fmCreate);
            try
               dm_MainForm2.DomToXMLParser_history.WriteToStream(Doc, 'ISO-8859-1', lStream);
            finally
               lStream.Free;
            end;
         except on e: exception do
               logevnt(_('Konnte privaten Verlauf nicht laden. Die Datei wird gelscht und neu angelegt.'));
         end;
      end;
   end;

   if lbfavretry then
   begin
      lbfavretry := false;
      try
         dm_MainForm2.XmlToDomParser_history.ParseFile(lslese, True);
      except on e: exception do
         begin
            logevnt(_('Konnte private Lesezeichen nicht laden. Sekundre Manahmen werden ergriffen.'));

            doc := TdomDocument.Create(dm_MainForm2.Domimp_history);
            FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
            FNodeElement.SetAttribute('name', 'Verlauf-');
            doc.AppendChild(FNodeElement);
            lbfavretry := true;
         end;
      end;
   end;
   if not lbfavretry then
   begin
      Doc := (dm_MainForm2.XmlToDomParser_history.DOMImpl.Documents.Item(0) as TdomDocument);
   end;

   // Hier werden wohl die gelscht, die lter als die ersten 20 sind.
   while doc.ChildNodes.Item(0).ChildNodes.Length > 20 do
   begin
      doc.ChildNodes.Item(0).RemoveChild(doc.ChildNodes.item(0).FindFirstChildElement);
   end;
   icount := 0;
   while icount < 20 do
   begin
      if doc.ChildNodes.item(0).ChildNodes.Item(icount) = nil then
      begin
         break;
      end;
      doc.ChildNodes.item(0).ChildNodes.Item(icount).attributes.GetNamedItem('name_fav').NodeValue := inttostr(icount + 1);
      //  doc.ChildNodes.item(0).ChildNodes.Item(icount);//:=  inttostr(icount+1);//.SetAttribute(,);
      inc(icount);
   end;

   try
      updatetreeview(doc, tv_lese, true);
   except
   	on e: exception do
      begin
         logevnt('init viewer updatetreeview ' + e.message);
      end;
   end;

   GgfLogEvnt('history loaded');

   Loadtv_leseStat;
   dm_MainForm2.fmystrcap := TStringList.Create;
   dm_MainForm2.fmystrhan := TStringList.Create;
   tbsi_localspeichern.Enabled := false;
   tbsi_VMail.Enabled := false;
   tbsi_VPrint.enabled := false;
   //loadplugins
   setlength(gaspreferedtifname, 0);
   if fileexists(PChar(BD.ExeDir + 'Viewer-Files\plugins\plugins.ini')) then
   begin
      dm_MainForm2.mnu_plugins.Clear; //3.5.0.45 [2149]
      lini := tinifile.Create(BD.ExeDir + 'Viewer-Files\plugins\plugins.ini');

      lipamount := lini.ReadInteger('Conf', 'Counter', 0);
      setlength(faplugins, lipamount);
      for licounter := 0 to lipamount - 1 do
      begin
         lspname := lini.ReadString('Names', 'file' + inttostr(licounter), '');
         liitem := newItem(ChangeFileExt(lspname, ''), 0, False, True,
            dm_MainForm2.pum_plugClick, 0, 'pum_Ref');
         liitem.Hint := lspname;
         liitem.Tag := licounter;
         faplugins[licounter].name := lspname;
         faplugins[licounter].parameters := lini.ReadString('Params', 'file' + inttostr(licounter), '');
         dm_MainForm2.mnu_plugins.Add(liitem);
      end;
   end;

   if assigned(slStampKeys) then
      FreeAndNil(slStampKeys);
   if assigned(reg) then
      FreeAndNil(reg);

   if tbi_MyTask.Checked then
   begin
      if FileExists(ResultlistDesignPath + '\WVL.bfa') then
      begin
         dbgrd_Wvl.Columns.Clear;
         iColumns := 6;

         for iCnt := 0 to iColumns do
	         dbgrd_Wvl.Columns.Add;
         try
             dbgrd_Wvl.Columns.LoadFromFile(ResultlistDesignPath + '\WVL.bfa');
         except
           on e: Exception do
            LogEvnt('Fehler beim Auslesen der Datei: \WVL.bfa' + #13 + e.Message);
         end;
      end;
   end;

   if tbi_MATask.Checked then
   begin
      if FileExists(ResultlistDesignPath + '\WVLCtrl.bfa') then
      begin
         dbgrd_Wvl.Columns.Clear;
         iColumns := 7;

         for iCnt := 0 to iColumns do
	         dbgrd_Wvl.Columns.Add;
         try
          	dbgrd_Wvl.Columns.LoadFromFile(ResultlistDesignPath + '\WVLCtrl.bfa');
         except
           on e: Exception do
            LogEvnt('Fehler beim Auslesen der Datei: \WVLCtrl.bfa' + #13 + e.Message);
         end;
      end;
   end;

   GetLocaleFormatSettings(GetUserDefaultLCID, gFormatSettings);
   GgfLogEvntEnd ('InitViewer End');
end;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Datei Find auswerten
// Read find
procedure Tfrm_MainForm.ReadFndFile(FileName: string);
var
   ini: TIniFile;
   iCount, iComp, lidocidcount: integer;
   xComp, xComp01: TComponent;
   tDate: TDateTime;
   lstmp, lsspin: string;
   lldocids: Tstringlist;
begin
   GgfLogEvnt('ReadFndFile');
   try
      if ExtractFilePath(FileName) = '' then
         FileName := BD.ExeDir + FileName;

      if FileExists(FileName) then
         ini := TIniFile.Create(FileName)
      else
         exit;
      with ini do
      begin
         dm_DB.my_q_LgrArc.First;
         while not dm_DB.my_q_LgrArc.EOF do
         begin
            if ReadString('Archiv', 'Tabelle', '-') =
               dm_DB.my_q_LgrArc.FieldByName('Arc_TblName').AsString then
               break;
            dm_DB.my_q_LgrArc.Next;
         end;
         if dm_DB.my_q_LgrArc.EOF then
            exit
         else
         begin
            dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(
               dm_DB.my_q_LgrArc.FieldByName('Arc_ID').AsInteger), []);
            // when loading from file it should be    loadingfromwclcellclick:=0;
            loadingfromwclcellclick := 0;
            dbtv_LgrArcSet (False, False);

            loadingfromwclcellclick := 1;
         end;
         edt_SSLW.Text := ReadString('Suche', 'Schlagworte', '');
         cbx_SUsr.Text := ReadString('Suche', 'Benutzername', _('alle Benutzer'));
         if cbx_SUsr.Text = '' then
            cbx_SUsr.Text := _('alle Benutzer');
         if ReadString('Suche', 'Datum_Von', '') <> '' then
         begin
            chbx_SDatum.Checked := True;
            dtp_SVon.Date := StrToDate(ReadString('Suche', 'Datum_Von', ''));
            if ReadString('Suche', 'Datum_bis', '') <> '' then
               dtp_SBis.Date := StrToDate(ReadString('Suche', 'Datum_bis', ''))
            else
               dtp_SBis.Date := StrToDate(ReadString('Suche', 'Datum_von', ''));
         end
         else
            chbx_SDatum.Checked := False;
         memo_Vtx.Text := ReadString('Suche', 'Volltext', '');
         ////////////////////////////////////////////////////////////////////////////////////////////////////////
         // einlesen der Zusatzfelder
         ////////////////////////////////////////////////////////////////////////////////////////////////////////
         if ReadInteger('Zusatzfelder', 'Felder', 0) > 0 then
         begin
            for iCount := 1 to ReadInteger('Zusatzfelder', 'Felder', 0) do
            begin
               for iComp := 0 to (iGZusFCount - 1) do
               begin
                  if TJvStaticText(sbx_ZusFeld.FindComponent('zlbl_Tmp' +
                     IntToStr(iComp))).Hint = ReadString('Zusatzfelder',
                     'ZusFeld' + IntToStr(iCount), '') then
                  begin
                     xComp :=
                        FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iComp));

                     if xComp is TEdit then
                     begin
                        lstmp :=
                           ReadString('Zusatzfelder', 'ZusWert' +
                           IntToStr(iCount), '');
                        if lstmp <> '' then
                        begin
                           TEdit(xComp).Text := lstmp;
                           if (TEdit(xComp).Color = cColorNoRightInit) or
                              (TEdit(xComp).Color = cColorNoRight) then
                           begin
                              TEdit(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              TEdit(xComp).Color := cColorHellgruen;
                           end;
                           TEdit(xComp).Modified := True;
                        end;
                     end;

                     if xComp is TJvDateEdit then
                     begin
                        if TryStrToDateTime(ReadString('Zusatzfelder',
                           'ZusWert' + IntToStr(iCount), ''), tDate) then
                           lstmp := DateToStr(tDate)
                        else
                           lstmp := '';

                        if lstmp <> '' then
                        begin
                           TJvDateEdit(xComp).Text := lstmp;

                           if (TJvDateEdit(xComp).Color = cColorNoRightInit) or
                              (TJvDateEdit(xComp).Color = cColorNoRight) then
                           begin
                              TJvDateEdit(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              TJvDateEdit(xComp).Color := cColorHellgruen;
                           end;
                           TJvDateEdit(xComp).Modified := True;
                        end;
                     end;
                     if xComp is TComboBox then
                     begin
                        lstmp :=
                           ReadString('Zusatzfelder', 'ZusWert' +
                           IntToStr(iCount), '');
                        if lstmp <> '' then
                        begin
                           TComboBox(xComp).Text := lstmp;
                           if (TComboBox(xComp).Color = cColorNoRightInit) or
                              (TComboBox(xComp).Color = cColorNoRight) then
                           begin
                              TComboBox(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              TComboBox(xComp).Color := cColorHellgruen;
                           end;
                        end;
                     end;
                     if xComp is Tspinedit then
                     begin
                        lsspin := ReadString('Zusatzfelder', 'ZusWert' +
                           IntToStr(iCount), '');

                        xComp01 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iComp));
                        if lsspin <> '' then
                        begin
                           if xComp01 <> nil then
                           begin
                              try
                                 Tspinedit(xComp).Value := strtoint(
                                    copy(lsspin, 0, length(lsspin) - 1));
                                 TCombobox(xComp01).Text :=
                                    copy(lsspin, length(lsspin), 1);
                              except on e: exception do
                                 begin
                                 end;
                              end;
                           end;
                           if (Tspinedit(xComp).Color = cColorNoRightInit) or
                              (Tspinedit(xComp).Color = cColorNoRight) then
                           begin
                              Tspinedit(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              Tspinedit(xComp).Color := cColorHellgruen;
                           end;
                           Tspinedit(xComp).Modified := True;
                           if xComp01 <> nil then
                           begin
                              TCombobox(xComp01).Color := Tspinedit(xComp).Color;
                           end;
                        end
                        else
                        begin
                           Tspinedit(xComp).text := '';
                           if xComp01 <> nil then
                           begin
                              TCombobox(xComp01).Text := '';
                           end;
                        end;
                     end;
                  end;
               end;
            end;
         end;
         chbx_VtxSLw.Checked := ReadBool('Option', 'VtxundSLW', True);
         lidocidcount := ReadInteger('docids', 'DOCSNR', 0);
         if lidocidcount > 0 then
         begin
            lldocids := Tstringlist.create;
            for icount := 1 to lidocidcount do
            begin
               lldocids.Add(inttostr(ReadInteger('docids', 'ARCID' + inttostr(icount), 0)) + '.' +
                  inttostr(ReadInteger('docids', 'DOCID' + inttostr(icount), 0)));
            end;
            dm_MainForm2.searchfordocids(lldocids);
         end
         else
         begin
            btn_StartSrcClick(self);
         end;
      end;

      bParamHandled := True;

   finally
      if Assigned(ini) then
         FreeAndNil(ini);
   end;
end;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Abfangen des Allgemeinen Anwendungsfehlers
procedure Tfrm_MainForm.appevntException(Sender: TObject; E: Exception);
var
   lsname, lsparentname: string;
begin
   if Sender is TComponent then
   begin
      lsname := TComponent(Sender).Name;
   end
   else
   begin
      lsname := '';
   end;
   if Sender is TControl then
   begin
      if TControl(Sender).Parent <> nil then
      begin
         lsparentname := TControl(Sender).Parent.Name;
      end;
   end
   else
   begin
      lsparentname := '';
   end;
   LogEvnt('9000    Allgemeiner Anwendungsfehler:   mit Object ' +
      Sender.ClassName + ' - ' + lsname + '  ' + lsparentname +
      ' ' + _('Fehler') + ' ' + e.Message + #13 + 'Die Anwendung wird beendet.');

   // nett - nur dass lidebuglevel nie ein Wert >1 zugewiesen bekommt
   if BD.LogOn and (lidebuglevel > 1) then
      if MessageDlg(_('Allgemeiner Anwendungsfehler:') + #13 +
         _('Eine fehlerfreie Fortfhrung der Applikation kann nicht mehr gewhrleistet werden.')
         + #13 + _('Es wird empfohlen die Anwendung jetzt zu beenden.') +
         #13 + _('Die Anwendung beenden:'), mtWarning, [mbYes, mbNo], 0) = mrYes then
      begin
         frm_Mainform.Close;
      end;

end;

function Tfrm_MainForm.NewHistory(Funktion: integer; Text: string): boolean;
   /////////////////////////////////////////////////////////////
   ///  09.05.2005  Erstellt (SV)                            ///
   ///  30.05.2005  Erweitert um Maskierung von Backslashs   ///
   ///              im Text.                                 ///
   ///                                                       ///
   ///  Diese Function schreibt ein neues History Ereignis   ///
   ///  in die aktuelle hst_ Tabelle                         ///
   ///                                                       ///
   ///  Parameter: Funktion      Task ID der Funktion        ///
   ///             Text          Beschreibender Text         ///
   ///                                                       ///
   ///  Ausgabe: True bei Erfolg                             ///
   ///           False bei Fehlschlag                        ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////

var
   sTStamp, lsIArcName: string;
   lidocid: integer;
begin
   GgfLogEvnt('NewHistory ' + IntToStr(iGArcID) + '.' + IntToStr(iGDocID) + Text);
   Result := True;

   dm_db.my_q_datetime.SQL.Text :=
      'select date_format(now(),"%Y-%m-%d %T") as date';
   dm_db.my_q_datetime.Execute;

   sTStamp := dm_db.my_q_datetime.FieldByName('date').AsString;
   Text := StringReplace(Text, '\', '\\', [rfReplaceAll]);
   // Maskierung der Backslashes
   try
      with dm_DB.my_cmd do
      begin
         if sIArcName = '' then
         begin
            if TMPSQL('select * from sys_arc where arc_id= ' + IntToStr(iGArcID)) then
            begin
               sIarcName := dm_db.my_q_tmp.FieldByName('arc_TblName').AsString;
               sGarcName := dm_db.my_q_tmp.FieldByName('arc_name').AsString;
            end
            else
            begin
               BfShowMessage(
                  _('Der Archiv-Lager konnte nicht ermittelt werden. History-Eintrag wurde abgebrochen.'));
               exit;
            end;
         end;
         lsIArcName := sIArcName;
         lidocid := iGDocID;

         if lsIArcName = '' then
         begin
            BfShowMessage(
               _('Der Archiv-Lager konnte nicht ermittelt werden. History-Eintrag wurde abgebrochen.'));
            exit;
         end;
         SQL.Text := 'Insert into hst_' + lsIArcName +
            ' (doc_id, usr_id, tstamp, task, task_info) ' + 'Values (' +
            IntToStr(lidocid) + ',' + IntToStr(iGUsrID) + ',' + #39 +
            sTStamp + #39 + ',' + IntToStr(Funktion) + ',' + #39 +
            Trim(StringReplace(Text, #39, '\' + #39, [rfReplaceAll])) + #39 + ')';
         Execute;
      end;
   except
      on e: Exception do
      begin
         Result := False;
         ErrorMsg('NewHistory', _('Fehler beim Erstellen eines History Eintrages:') +
            e.Message, 2016, True);
      end;
   end;
end;


//////////////////////////////////////////////////////////////////////////////////
///                                                                            ///
///  Diese Procedure setzt die Schaltflchen zum Machen von Annotations auf
///  grau, wenn Annotations ausgeblendet sind.
///  Parameter: ---
///                                                                            ///
///  Ausgabe: -
///
///  23.09.2009 Erstellt von m.frey
///                                                                            ///
//////////////////////////////////////////////////////////////////////////////////

procedure Tfrm_MainForm.ZustaendeAnnotationBearbeitenSetzen;
var Ausgeblendet: Boolean;
begin
   // wenn der Hauptschalter, oder die zwei Layerschalter nicht gesetzt sind dann ausblenden
   Ausgeblendet := not tbi_VShowAnno.Checked
   	or ((not tbx_pubNote.Checked) and (not tbx_privNote.Checked));

      // wenn ausblenden, dann Recht prfen
   if not Ausgeblendet then
      Ausgeblendet := not rGDocRight.awrite;

   EnableGraphicTools(Ausgeblendet);
end;


procedure Tfrm_MainForm.EnableGraphicTools(Ausgeblendet : Boolean);
begin

   tbsi_stifte.Enabled := not Ausgeblendet;
   tbi_normalmouse.Enabled := not Ausgeblendet;
   tbi_objauswahl.Enabled := not Ausgeblendet;

   tbx_fav1.Enabled := not Ausgeblendet;
   tbx_fav2.Enabled := not Ausgeblendet;
   tbx_fav3.Enabled := not Ausgeblendet;
   tbx_fav4.Enabled := not Ausgeblendet;
   tbx_fav5.Enabled := not Ausgeblendet;
   tbsi_stifte.Enabled := not Ausgeblendet;
   tbsi_highlight.Enabled := not Ausgeblendet;
   tbsi_notizen.Enabled := not Ausgeblendet;
   tbx_noteimgreen.Enabled := not Ausgeblendet;
   tbx_noteimyellow.Enabled := not Ausgeblendet;
   tbx_noteimred.Enabled := not Ausgeblendet;
   tbx_noteimblue.Enabled := not Ausgeblendet;
   tbx_noteimorange.Enabled := not Ausgeblendet;
   tbx_lineim.Enabled := not Ausgeblendet;
   tbx_stempeldiag.Enabled := not Ausgeblendet;
   tbxs_text.Enabled := not Ausgeblendet;

   tbxtm_AnnoDelete.Enabled := not Ausgeblendet;

   // Alle Objekte deselektieren und .
   if gbAppStarted then   // wegen Server2008 und mslogon -Problem
   begin
      fra_voransicht.img_DocView.CancelInteracts;
      fra_voransicht.img_DocView.UnSelAllObjects;
      if Ausgeblendet then
	      fra_voransicht.img_DocView.MouseInteract := [miscroll];
   end;
end;



//////////////////////////////////////////////////////////////////////////////////
///                                                                            ///
///                                                                            ///
///  Diese Procedure Druckt das aktuelle Dokument aus                          ///
///  Parameter: ShowPrintDlg  Druckerauswahl anzeigen                          ///
///             PrintAnno     Annotations mit ausdrucken                       ///
///                                                                            ///
///  Ausgabe: True bei Erfolg                                                  ///
///           False bei Fehlschlag
///
///  25.7.2006 Modifiziert und Dokumentiert N.Gering
///            der Parameter Domail initiert einen Mailversand                 ///
///                                                                            ///
//////////////////////////////////////////////////////////////////////////////////

function Tfrm_MainForm.PrintDoc(ShowPrintDlg, ShowPageDlg: boolean): boolean;

var
   iOldPage, iPage, iPageSave, iCount, iTmpDocID, iTmpArcID, iCopy, iFromPage, iToPage,
   liDelayZoomTime, lidelaytime, liarcrcno: integer;
   sTmpTblName, sDocFile, sTmpFile: string;
   fMLeft, fMRight, fMTop, fMBottom, fSHeight, fSWidth, fGamma: double;
   ieVPos: TIEVerticalPos;
   ieHPos: TIEHorizontalPos;
   ieSize: TIESize;
   bPrintDoc, bAutoRot, bAnno: boolean;
   reg: TRegistry;
   lbtimervoran, lbtimerthumb, lbtimermarkpag: boolean;
const
   Zoll = 0.03937007874015748031496062992126;
begin
   GgfLogEvntBeg ('PrintDoc Begin');

   if globalEventLock then
     exit;

   globalEventLock := true;

   iPageSave := 0;
   Result := True;
   iTmpDocID := iGDocID;
   iTmpArcID := iGArcID;
   iCopy := 0;
   bPrintDoc := False;
   sTmpTblName := sIArcName;
   gbprintingdoc := True;

   try
      reg := TRegistry.Create;

      if Printer.Printers.Count = 0 then
      begin
        GgfLogEvntEnd ('PrintDoc End via Exit #1');
        Exit;
      end;

      if iGUseStdPrn < Printer.Printers.Count then
         Printer.PrinterIndex := iGUseStdPrn
      else
         Printer.PrinterIndex := -1;
      // Soll die Druckerauswahl angezeigt werden?
      if ShowPrintDlg then
      begin
         dm_MainForm2.pDlg_Drucken.MinPage := 1;
         dm_MainForm2.pDlg_Drucken.MaxPage :=
            fra_Voransicht.img_DocView.IO.Params.TIFF_ImageCount;
         dm_MainForm2.pDlg_Drucken.FromPage := 1;
         dm_MainForm2.pDlg_Drucken.ToPage := dm_MainForm2.pDlg_Drucken.MaxPage;
         if not dm_MainForm2.pDlg_Drucken.Execute then
         begin
            gbprintingdoc := False;
            GgfLogEvntEnd ('PrintDoc End via Exit #2');
            Exit;
         end;
      end;
      // Wenn der Seitendialog angezeigt werden soll, erst das Formular erzeugen
      if ShowPageDlg then
         Application.CreateForm(Tfrm_PrintPreview, frm_PrintPreview)
      else
         bPrintDoc := True;
      // Liefert der Druckertreiber gltige Parameter ?
      if (Printer.PageWidth < 1) or (Printer.PageHeight < 1) then
      begin
         BfShowMessage(_('Der aktuelle Drucker ist nicht mit dem Viewer kompatibel.') +
            #13 + _('Bitte whlen Sie einen anderen Drucker aus oder benutzen') +
            #13 + _('Sie einen anderen Druckertreiber.'));
         gbprintingdoc := False;
         GgfLogEvntEnd ('PrintDoc End via Exit #3');
         Exit;
      end;

      // Alle markierten Dokumente durchgehen
      fra_Voransicht.img_DocView.DelayZoomFilter := false;
      liDelayZoomTime := fra_Voransicht.img_DocView.DelayZoomTime;
      fra_Voransicht.img_DocView.DelayZoomTime := 0;
      fra_Voransicht.img_DocView.zoomfilter := rfBilinear;
      lidelaytime := fra_Voransicht.img_DocView.DelayTimer;
      fra_Voransicht.img_DocView.DelayTimer := 0;
//      lbtimervoran := dm_MainForm2.tim_voransicht.enabled;
//      dm_MainForm2.tim_voransicht.enabled := false;
      lbtimermarkpag := dm_MainForm2.tim_markpages.enabled;
      dm_MainForm2.tim_markpages.enabled := false;
      lbtimerthumb := dm_MainForm2.tim_Thumb.enabled;
      dm_MainForm2.tim_Thumb.enabled := false;
      for iCount := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
      begin
         with dm_DB.my_q_Arc do
         begin
            GotoBookmark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iCount]));
            iGDocID := FieldByName('doc_id').AsInteger;
            //liarcrcno := recno;
            if bMultiArcQuery then
            begin
               iGArcID := FieldByName('arc_id').AsInteger;
               sIArcName := FieldByName('TblName').AsString;
            end;

            //  REchte der Users fuer das Dokument ermitteln
            // die rechte sollten schon frher festgelegt worden sein!
            // gedocusrrigths activiert tbi_VShowAnno was nicht immer erwnscht ist!
            // alternative lsung wre ein printing doc flag zu setzen, wenn es mal nicht mit den rechten funktioniert!
            //alternative angenommen
            GetDocUsrRights(False);
            if rGDocRight.print then
            begin
               with fra_Voransicht.img_DocView do
               begin
                  iOldPage := IO.Params.TIFF_ImageIndex;
                  try
                     ShowVoransichtnorefresh;

                     // Sollen einzelne Seiten Gedruckt werden?
                     // Sollen alle Seiten eines Dokumentes gedruckt werden ?
                     // dann setze iFromPage auf 1 und iToPage auf die Anzahl der Seiten
                     // Dokumentes ( IO.Params.TIFF_ImageCount)

                     if dm_MainForm2.pDlg_Drucken.PrintRange = prAllPages then
                     begin
                        iFromPage := 1;
                        iToPage := IO.Params.TIFF_ImageCount;
                     end
                     else
                     begin
                        iFromPage := dm_MainForm2.pDlg_Drucken.FromPage;
                        iToPage := dm_MainForm2.pDlg_Drucken.ToPage;
                     end;

                     if ShowPageDlg then
                     begin
                        with frm_PrintPreview do
                        begin
                           nedt_PgStart.MaxValue :=
                              IO.Params.TIFF_ImageCount;
                           nedt_PgStart.MinValue := 1;
                           nedt_PgStart.Value := 1;
                           nedt_PgEnd.MaxValue := IO.Params.TIFF_ImageCount;
                           nedt_PgEnd.MinValue := 1;
                           nedt_PgEnd.Value := IO.Params.TIFF_ImageCount;
                           ShowModal;
                           if ModalResult = mrOk then
                           begin
                              bPrintDoc := True;
                              iFromPage := Trunc(nedt_PgStart.Value);
                              iToPage := Trunc(nedt_PgEnd.Value);
                           end
                           else
                           begin
                              bPrintDoc := False;
                              iFromPage := 0;
                              iToPage := 0;
                           end;
                        end;
                     end;

                     if bPrintDoc then
                     begin
                        with reg do
                        begin
                           RootKey := HKEY_CURRENT_USER;
                           OpenKey('software\bitfarm\archiv_v3\Viewer\Optionen\Printing', True);
                           if ValueExists('BorTop') then
                              fMTop := ReadFloat('BorTop') * Zoll
                           else
                              fMTop := 0;
                           if ValueExists('BorBottom') then
                              fMBottom := ReadFloat('BorBottom') * Zoll
                           else
                              fMBottom := 0;
                           if ValueExists('BorLeft') then
                              fMLeft := ReadFloat('BorLeft') * Zoll
                           else
                              fMLeft := 0;
                           if ValueExists('BorRight') then
                              fMRight := ReadFloat('BorRight') * Zoll
                           else
                              fMRight := 0;
                           if ValueExists('Position') then
                           begin
                              case ReadInteger('Position') of
                                 1:
                                 begin
                                    ieVPos := ieVPTop;
                                    ieHPos := ieHPLeft;
                                 end;
                                 2:
                                 begin
                                    ieVPos := ieVPTop;
                                    ieHPos := ieHPCenter;
                                 end;
                                 4:
                                 begin
                                    ieVPos := ieVPTop;
                                    ieHPos := ieHPRight;
                                 end;
                                 8:
                                 begin
                                    ieVPos := ieVPCenter;
                                    ieHPos := ieHPLeft;
                                 end;
                                 16:
                                 begin
                                    ieVPos := ieVPCenter;
                                    ieHPos := ieHPCenter;
                                 end;
                                 32:
                                 begin
                                    ieVPos := ieVPCenter;
                                    ieHPos := ieHPRight;
                                 end;
                                 64:
                                 begin
                                    ieVPos := ieVPBottom;
                                    ieHPos := ieHPLeft;
                                 end;
                                 128:
                                 begin
                                    ieVPos := ieVPBottom;
                                    ieHPos := ieHPCenter;
                                 end;
                                 256:
                                 begin
                                    ieVPos := ieVPBottom;
                                    ieHPos := ieHPRight;
                                 end;
                              else
                              begin
                                 ieVPos := ieVPCenter;
                                 ieHPos := ieHPCenter;
                              end;
                              end;
                           end
                           else
                           begin
                              ieVPos := ieVPCenter;
                              ieHPos := ieHPCenter;
                           end; {If ValueExists('Position')}
                           if ValueExists('Size') then
                           begin
                              case ReadInteger('Size') of
                                 0:
                                    ieSize := iesNORMAL;
                                 1:
                                    ieSize := iesFITTOPAGE;
                                 2:
                                    ieSize := iesFITTOPAGESTRETCH;
                                 3:
                                    ieSize := iesSPECIFIEDSIZE;
                              else
                                 ieSize := iesFITTOPAGE;
                              end;
                           end
                           else
                              ieSize := iesFITTOPAGE;

                           if ValueExists('SWidth') then
                              fSWidth := ReadFloat('SWidth')
                           else
                              fSWidth := 100 * Zoll;
                           if ValueExists('SHeight') then
                              fSHeight := ReadFloat('SHeight')
                           else
                              fSHeight := 100 * Zoll;
                           if ValueExists('SAutoRot') then
                              bAutoRot := ReadBool('SAutoRot')
                           else
                              bAutoRot := True;
                           if ValueExists('OGamma') then
                              fGamma := ReadFloat('OGamma')
                           else
                              fGamma := 1.00;
                           if ValueExists('OAnno') then
                              bAnno := ReadBool('OAnno')
                           else
                              bAnno := False;
                           CloseKey;
                        end;

                        if (iFromPage > 0) and (iToPage > 0) then
                        begin
                           if (ieBitmap.Height < ieBitmap.Width) and
                              bAutoRot then
                              Printer.Orientation := poLandscape
                           else
                              Printer.Orientation := poPortrait;
                           Printer.Title :=
                              dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                           Printer.BeginDoc;

                           try
                              for iPage := (iFromPage - 1) to (iToPage - 1) do
                              begin
                                 iPageSave := iPage;
                                 IO.Params.TIFF_ImageIndex := iPage;
                                 sDocFile :=
                                    dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
                                 sTmpFile := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
                                 if FileExists(sTmpFile) then
                                    sDocFile := sTmpFile;
                                 IO.LoadFromFile(sDocFile);

                                 if tbi_VShowAnno.Checked = True then
                                 begin

                                    RemoveAllObjects; //hasen
                                    frm_MainForm.fra_Volltext.clearobjslist;

                                    if tbx_pubNote.Checked = True then
                                    begin
                                       sTmpFile :=
                                          ChangeFileExt(sDocFile, '') +
                                          IntToStr(iPage) + '.IEV';
                                    end
                                    else
                                    if tbx_privNote.Checked = True then
                                    begin
                                       sTmpFile :=
                                          ChangeFileExt(sDocFile, '') +
                                          IntToStr(iPage) + 'P' +
                                          IntToStr(iGPrivAnnoID) + '.IEV';
                                    end;

                                    // Existiert eine Datei unter dem konstruierten Dateinamen irgenwas0.iev
                                    // convertieren einen Layer zur Farbtiefe von 24BIT
                                    // Lade die Vektorendatei, deren Dateipfad in sTmpFile drinsteht.

                                    sTmpFile := StringReplace(sTmpFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

                                    if FileExists(sTmpFile) then
                                    begin
                                       // erweitere die Farbtiefe auf 24Bit
                                       if (io.Params.BitsPerSample <> 8) and
                                          (io.Params.SamplesPerPixel <> 3) then
                                       begin
                                          io.Params.BitsPerSample := 8;
                                          io.Params.SamplesPerPixel := 3;
                                          Proc.ConvertTo24Bit;
                                       end;

                                       // die Druckroutine funktioniert auch ohne die convertierung in 24Bit Farbtiefe
                                       // lade die Vektoren
                                       LoadFromFileIEV(sTmpFile);
                                       GgfLogEvnt('LoadFromFileIEV M9');
                                       // wandle die Vektoren zu BITMAP und kopiere sie in den Hintergrundlayer
                                       CopyObjectsToBack(False);
                                    end;
                                 end
                                 else
                                 begin
                                    RemoveAllObjects;
                                    frm_MainForm.fra_Volltext.clearobjslist;
                                 end;

                                 if tbi_VShowBrief.Checked then
                                 begin
                                       igbrieflayer := 0;
                                       fra_Voransicht.img_DocView.Layers[iGBriefLayers[0]].Visible := True;
                                       if iGBriefLayers[1] <> -1 then
                                       begin
                                          fra_Voransicht.img_DocView.Layers[iGBriefLayers[1]].Visible := False;
                                       end;
                                    MergeLayers(0, iGBriefLayers[iGBriefLayer]);
                                 end;

                                 IO.PrintImage(Printer.Canvas, fMLeft, fMTop,
                                    fMRight, fMBottom, ieVPos, ieHPos, ieSize,
                                    fSWidth, fSHeight, fGamma);
                                 if iPage < (iToPage - 1) then
                                    Printer.NewPage;

                              end;
                           except on e: exception do
                                 logevnt('errorn on Printdoc file ' + sDocFile + ' Page ' + inttostr(iPageSave) + ' error ' + e.message);
                           end;
                           Printer.Enddoc;
                           IO.Params.TIFF_ImageIndex := iOldPage;
                           dm_DB.loadmainviewdoc(False);
                           NewHistory(8, Format(_('Dokument an Drucker %s gedruckt'), [Printer.Printers.Strings[Printer.PrinterIndex]]));
                        end;
                     end;
                  except
                     on e: Exception do
                     begin
                        Printer.Abort;
                        ErrorMsg('PrintDoc', _('Fehler beim Drucken eines Dokumentes:') +
                           e.Message, 2022, True);
                        gbprintingdoc := False;
                        Result := False;
                     end;
                  end;
               end;
            end
            else
               frm_mainform.setpanelinfo(
                  _('Dieses Dokument drfen Sie nicht ausdrucken.'));
         end;
      end;
   finally
      fra_Voransicht.img_DocView.DelayTimer := lidelaytime;
      fra_Voransicht.img_DocView.DelayZoomFilter := true;
      fra_Voransicht.img_DocView.DelayZoomTime := liDelayZoomTime;
      fra_Voransicht.img_DocView.zoomfilter := rfFastLinear;

//      dm_MainForm2.tim_voransicht.enabled := lbtimervoran;

      dm_MainForm2.tim_markpages.enabled := lbtimermarkpag;

      dm_MainForm2.tim_Thumb.enabled := lbtimerthumb;
      gbprintingdoc := False;
      if Assigned(frm_PrintPreview) then
         frm_PrintPreview.Release;
      if Assigned(reg) then
         FreeAndNil(reg);

      globalEventLock := false;
   end;

   iGDocID := iTmpDocID;
   iGArcID := iTmpArcID;
   gbprintingdoc := False;
   sIArcName := sTmpTblName;
   frm_mainform.setpanelinfo(
      _('Es wurden') + ' ' + IntToStr(iCopy + 1) + ' ' + _('Dokumente von') + ' ' +
      IntToStr(dbgrd_Trefferliste.SelectedRows.Count) + ' ' + _('gedruckt.'));

   GgfLogEvntEnd ('PrintDoc End');
end;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  MakeArcQuery
//  Erzeugt eine Selectanweisung aus den ausgwaehlten Suchoptionen
//  SQL Abfrage Archiv
function Tfrm_MainForm.MakeArcQuery(tblname:String): string;
   /////////////////////////////////////////////////////////////
   ///  03.05.2005   Erstellt (SV)                           ///
   ///  13.05.2005   Erweitert um Schlagworte aus Schlag-    ///
   ///               worttabelle (SV)                        ///
   ///                                                       ///
   ///  Diese Funktion geht alle Eingabefelder durch und     ///
   ///  baut die SQL-Query zusammen.                         ///
   ///                                                       ///
   ///  Format: Fertiger SQL-Query String mit where Klausel  ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   sSQLCMD, sBenCMD, sDatCMD, sDatVon, sDatBis, sSlwCMD,
   sVtxCMD, sZusCMD, sZusOp, sZusText, sZusTextOG, sZusTextUG,
   lsVolltext,
   snOps //obere Grenze fuer die Suche im Datumsrange
   : string;
   bCompModified,
   lbsep: boolean;
   iCount, iStat, niStat, iMode, liitem: integer;
   slFelder: TStringList;
   zLbl: TJvStaticText;
   xComp, xComp01: TComponent;
   lb1, lb2:Boolean;
   xTyp: eAddFieldType;
begin
   GgfLogEvntBeg ('MakeArcQuery beg');
   Result := '';

   try
     lsVolltext := GetVolltext; //[2487]
     iStat := 0;
     iMode := 0;
     sSQLCMD := ''; // Initalisieren des SQL Komandos;
     slFelder := TStringList.Create; // Initalisieren der Felder-Liste

     datezusfield := False;

   	if not assigned(fslsearchcolumnsadds) then
      	fslsearchcolumnsadds := Tstringlist.create
     	else
      	fslsearchcolumnsadds.clear;

   	GgfLogEvnt('Fndrbnu=' + booltostr(Fndrbnu));

     // Zusatz felder auswerten und dem SQL String zufgen
     try
        if sbx_ZusFeld.ComponentCount > 0 then
        begin
           for iCount := 0 to iGZusFCount - 1 do
           begin
              GgfLogEvnt('MakeArcQuery iCount='+IntToStr(iCount));

              datezusfield := false; // 02.04.2012 b.takacs bei manche Auswahlfeld nach Datumsfeld bleibt true, darum falsche SQL Abfrage zusammengebaut
              lbsep := False;
              sZusText := '';
              bCompModified := False;
              gbsearchcheckedcombobox := false;
              sZustextOG1 := '';
              sZustextUG1 := '';
              zLbl := TJvStaticText(sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount)));
              xComp := FindComponentRekursivFrame(sbx_ZusFeld,'zedt_Tmp' + IntToStr(iCount));
              fslsearchcolumnsadds.add(zLbl.Hint);

              if xComp is TEdit then
              begin
                  // check if the color is white for searching! modified is already used for saving:
                  // a1 is changed, search, a2 is changed, save saves only a2!
                  //     bCompModified :=   TEdit(xComp).Modified;
                  // only set the search text if the field was modified
                  if (tedit(xComp).Color = cColorHellgruen) or
                    (Tedit(xComp).Color = cColorNoRight) then
                  begin
                     bCompModified := True;
							sZusText := TEdit(xComp).Text;
                  end
                  else
                  	bCompModified := False;

                  iMode := TEdit(xComp).Tag;
                  TEdit(xComp).Modified := False;
              end
              else
              if xComp is TSpinEdit then
              begin
                 // bCompModified := (TEdit(xComp).Modified or (TEdit(xComp).Text<> '')) ;
                 // check if the color is white for searching! modified is already used for saving:
                 // a1 is changed, search, a2 is changed, save saves only a2!
                 //     bCompModified :=   TEdit(xComp).Modified;
                 // only set the search text if the field was modified
                 xComp01 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
                 if xComp01 <> nil then
                 begin
                     if (// 21.10.2011 b.takacs 3.5.1.51 ((TSpinEdit(xComp).Tag and 4) = 4) or
                       ((TSpinEdit(xComp).Color = cColorHellgruen) or
                       (TSpinEdit(xComp).Color = cColorNoRight))) or
                       (// 21.10.2011 b.takacs 3.5.1.51 ((Tcombobox(xComp01).Tag and 4) = 4) or
                       ((Tcombobox(xComp01).Color = cColorHellgruen) or
                       (Tcombobox(xComp01).Color = cColorNoRight))) then
                     begin
                        bCompModified := True;
                        sZusText := TSpinEdit(xComp).Text + Tcombobox(xComp01).text;
                        if sZusText = '' then  // leere Suche
                        	sZusText := '""';
                     end
                     else
                       	bCompModified := False;

                     TSpinEdit(xComp).Modified := False;
                     iMode := (TSpinEdit(xComp).Tag and 3)
                       or (Tcombobox(xComp01).Tag and 3);
                     // set modified := false so it wont save next save action
                     TSpinEdit(xComp).Tag := TSpinEdit(xComp).Tag and (not 4);
							Tcombobox(xComp01).Tag := Tcombobox(xComp01).Tag and (not 4);
                  	xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));

                     if TJvgCheckBox(xComp01).Checked then
                     begin
                       sZusOp := ' and ';
                     end
                     else
                     begin
                       sZusOp := ' and not';
                     end;
                 end;
              end
              else
              if xComp is TJvDateEdit then
              begin
                  // Datumsfeld auswerten und der Abfrage hinzufgen
                  if gbzdvc then
                  begin
                  	sZusText := '"' + TJvDateEdit(xComp).Text + '"';
                  end
                  else
                  begin
                     if TJvDateEdit(xComp).Text = cEmptyDateString then
                     begin
                       sZusText := '""';
                       sZusTextUG := '';   // bei leerer Datumssuche gibt es keine Bereichssuche
                     end
                     else
                     begin
                       DateTimeToString(sZusText, 'yyyy-mm-dd',
                          StartOfTheDay(TJvDateEdit(xComp).Date));
                     end;
                  end;
                  // zweites Datumsfeld, das die obere Grenze beschreibt lesen
                  datezusfield := True;
                  if gbzdvc then
                  begin
                    sZustextOG := '"' + TJvDateEdit(
                       FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(iCount))).Text + '"';
                  end
                  else
                  begin
                    DateTimeToString(sZustextOG, 'yyyy-mm-dd',
                       StartOfTheDay(TJvDateEdit(
                       FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(iCount))).Date));
                  end;

                  if ((TJvDateEdit(xComp).color = cColorHellgruen) or
                    (TJvDateEdit(xComp).Color = cColorNoRight)) then
                  begin
                    bCompModified := True;
                  end
                  else
                  begin
                    bCompModified := False;
                    sZusText:= ''; //21.10.2011 b.takacs 3.5.1.51
                  end;

                   // bModified ist true, wenn das von ODER das bisFeld ausgefllt wurden  T375 f.schneider
                   bCompModified := bCompModified or (TJvDateEdit(
                       FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(iCount))).Modified);

                  if (sZusText = '""') or (sZusText = cEmptyDateString) then
                  begin
                    sZusText := '""';
                    sZusTextUG := '';
                  end
                  else
                  begin
                    sZusTextUG := sZusText;
                  end;

                  if (sZusTextOG = '""') or (sZusTextOG = cEmptyDateString) then
                    sZusTextOG := '';

                  sZustextOG1 := sZustextOG;
                  sZustextUG1 := sZustextUG;

                  //  normally tag is 4 or 6, if 6 (or 2) then it should check also the first datebox as it is
                  iMode := (TJvDateEdit(xComp).Tag and 3);
                  TJvDateEdit(xComp).Modified := False;
                  TJvDateEdit(xComp).Tag := TJvDateEdit(xComp).Tag and (not 4);
                  xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));

                  if TJvgCheckBox(xComp01).Checked then
                     sZusOp := ' and '
                  else
                     sZusOp := ' and not';
              end
              else
              if xComp is TJvSpinEdit then   // Dynamisches Datumsfeld der Zusatzfeldermaske auswerten
              begin

                 if (((TJvSpinEdit(xComp).Color = cColorHellgruen) or
                   (TJvSpinEdit(xComp).Color = cColorNoRight)))  then
                 begin
                   bCompModified := True;

                   sZusText := TJvSpinEdit(xComp).Text;
                   // zweites Datumsfeld, das die obere Grenze beschreibt lesen
                   datezusfield := false;
                   sZustextOG := TJvSpinEdit(
                      FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(iCount))).Text;

                   sZusTextUG := sZusText;

                   sZusText := StringReplace(sZusText, ',', '.', [rfReplaceAll]);
                   sZustextOG1 := StringReplace(sZustextOG, ',', '.', [rfReplaceAll]);
                   sZustextUG1 := StringReplace(sZustextUG, ',', '.', [rfReplaceAll]);
                   //  normally tag is 4 or 6, if 6 (or 2) then it should check also the first datebox as it is

                   lb1 := (TJvSpinEdit(xComp).Tag and 4) = 4;
                   lb2 := (     (TJvSpinEdit(xComp).color = cColorHellgruen)
                             or (TJvSpinEdit(xComp).Color = cColorNoRight   )    );
                   if lb2 then // Farbe, das ist eindeutig
                   begin
                      bCompModified := True;
                   end
                   else
                      if lb1 then
                      begin
                         bCompModified := (StrToFloat(sZustextOG)<>0)
                                       or (StrToFloat(sZustextUG)<>0);
                      end
                      else
                         bCompModified := False;

                   iMode := 0;

                   TJvSpinEdit(xComp).Modified := False;
                   TJvSpinEdit(xComp).Tag := TJvSpinEdit(xComp).Tag and (not 4);

                   // Anzeige der unteren Grenze und Anzeige der oberen Grtenze
  						  xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));

                    if TJvgCheckBox(xComp01).Checked then
                       sZusOp := ' and '
                    else
                       sZusOp := ' and not';

                 end
                 else
                   bCompModified := False;
              end
              else
              if xComp is TComboBox then
              begin
                  if TComboBox(xComp).Items.IndexOf(TComboBox(xComp).Text) > -1 then
                  begin
                  	sZusText := #34 + TComboBox(xComp).Text + #34;
                  end
                  else
                  begin
                    	sZusText := TComboBox(xComp).Text;
                  end;

                  if (// 21.10.2011 b.takacs 3.5.1.51  ((TComboBox(xComp).Tag and 4) = 4) or
                    ((TComboBox(xComp).color = cColorHellgruen) or
                    (TComboBox(xComp).color = cColorHellblau) or
                    (TComboBox(xComp).Color = cColorNoRight))) then
                    bCompModified := True or bCompModified
                  else
                    	bCompModified := False or bCompModified;

                  if (not bCompModified) then
                   	sZusText:= ''; //21.10.2011 b.takacs 3.5.1.51
                  TComboBox(xComp).Tag := TComboBox(xComp).Tag and (not 4);
                  iMode := (TComboBox(xComp).Tag and 3);
                  lbsep := True;

                  xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));

                  if TJvgCheckBox(xComp01).Checked then
                  begin
                  	sZusOp := ' and ';
                  end
                  else
                  begin
                  	sZusOp := ' and not';
                  end;
              end
              else
              if xComp is TjvCheckedComboBox then
              begin
                  if (((TjvCheckedComboBox(xComp).noFocusColor = cColorHellgruen) or
                    (TjvCheckedComboBox(xComp).noFocusColor = cColorNoRight))) then
                  begin
                     bCompModified := True;
							sZusText := TjvCheckedComboBox(xComp).Text; //21.10.2011 b.takacs 3.5.1.51
						end
                  else
                  begin
                  	bCompModified := False;
                  end;

                  gbsearchcheckedcombobox := true;
                  iMode := (TjvCheckedComboBox(xComp).Tag and 3);

                  TjvCheckedComboBox(xComp).Tag := TjvCheckedComboBox(xComp).Tag and (not 4);
                  lbsep := True;
                  xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));

                  if TJvgCheckBox(xComp01).Checked then
                  	sZusOp := ' and '
                  else
                  	sZusOp := ' and not';
              end;
              GgfLogEvnt('MakeArcQuery iCount='+IntToStr(iCount)+' sZusText='+sZusText +' sZustextOG1='+sZustextOG1 +' bCompModified=' + BoolToStr(bCompModified));

              sZusText := EliminierenVonAnfuehrungszeichen(sZusText); //3.5.0.67 [2445]/[2068] lass ich mal davor
              if (sZusText <> '') or ((sZusText = '') and (sZustextOG1 <> '')) then //b.takacs 11.12.2012 3.5.3.3 T375
              begin
                 if bCompModified or Fndrbnu then
                 begin
                    slFelder.Clear;
                    slFelder.AddObject(zLbl.Hint, TObject(0));

                    xTyp := clArchiv.getInstance.getType (xComp.Name);

                    if xComp is TjvCheckedComboBox then
                    begin
                       sZusCMD :=      // f.schneider 3.5.0.164
                          MakeKomplexQueryMehrfachauswahl(sZusText, slFelder);
                    end
                    else
                    case iMode of
                       //  MakeKomplexQuery Aufruf
                       0:
                          sZusCMD := //exact
                             MakeKomplexQuery (ParseSemicolonUseBackslash (sZusText),
                                               slFelder, xTyp, False, False, lbsep);
                       1:
                          sZusCMD := //Wortende
                             MakeKomplexQuery (ParseSemicolonUseBackslash (sZusText),
                                               slFelder, xTyp, True, False, lbsep);
                       2:
                          sZusCMD := //Wortanfang
                             MakeKomplexQuery (ParseSemicolonUseBackslash (sZusText),
                                               slFelder, xTyp, False, True, lbsep);
                       3:
                          sZusCMD := //wortbestandteil
                             MakeKomplexQuery (ParseSemicolonUseBackslash (sZusText),
                                               slFelder, xTyp, True, True, lbsep);
                    else
                       sZusCMD :=
                          MakeKomplexQuery (ParseSemicolonUseBackslash (sZusText),
                                            slFelder, xTyp, False, True, lbsep);
                    end;

                    xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));

                    if TJvgCheckBox(xComp01).Checked then
                       sZusOp := ' and '
                    else
                       sZusOp := ' and not';
                 end
                 else
                 begin
                    sZusCMD := '';
                    sZusOp := '';
                 end;
              end
              else
              begin
                 sZusCMD := '';
                 sZusOp := '';
              end;
              if sZusCMD <> '' then
              begin
                 if sSQLCMD = '' then
                 begin
                    xComp01 := sbx_ZusFeld.FindComponent('jvcbzedt_Tmp' + IntToStr(iCount));
                    if TJvgCheckBox(xComp01).Checked then
                       sZusOp := ''
                    else
                       sZusOp := ' not ';
                    sSQLCMD := sSQLCMD + '( ' + sZusOp + sZusCMD + ')';
                 end
                 else
                 begin
                    sSQLCMD := sSQLCMD + sZusOp + '( ' + sZusCMD + ')';
                 end;
              end;
           end;
           gbsearchcheckedcombobox := false;

        end;

        if edt_SSLW.Text = '' then
           sSQLCMD := sSQLCMD + ''
        else
        begin
           sSlwCMD := '(' + MakeRefQuery2(ParseSemicolonUseBackslash(edt_SSLW.Text), False, True, tblname) + ')';
           if sSlwCMD <> '()' then
           begin
              if JvgCb_slw.Checked then
              begin
                 snOps := '';
              end
              else
              begin
                 snOps := ' not ';
              end;
              if sSQLCMD = '' then
                 sSQLCMD := sSQLCMD + snOps + sSlwCMD
              else
                 sSQLCMD := sSQLCMD + ' and ' + snOps + sSlwCMD;
           end;
        end;


        // Benutzer auswerten und dem SQL String zufgen
        liitem := cbx_SUsr.Items.IndexOf(cbx_SUsr.Text);
        if (liitem = 0) or (cbx_SUsr.Text = '') then
           sSQLCMD := sSQLCMD + ''
        else
        begin
           sBenCMD := 'usr_name = ' + #39 + ParseSemicolonUseBackslash(cbx_SUsr.Text) + #39;
           if JvgCb_user.Checked then
           begin
              snOps := '';
           end
           else
           begin
              snOps := ' not ';
           end;
           if sSQLCMD = '' then
              sSQLCMD := sSQLCMD + snOps + '(' + sBenCMD + ')'
           else
              sSQLCMD := sSQLCMD + ' and ' + snOps + '(' + sBenCMD + ')';
        end;

        // Datum der Erfassung im DMS auswerten und dem SQL String zufgen
        // ... aus der Standard Suche
        if not chbx_SDatum.Checked then
           sSQLCMD := sSQLCMD + ''
        else
        begin
           DateTimeToString(sDatVon, 'yyyy-mm-dd hh:nn:ss', dtp_SVon.DateTime);
           DateTimeToString(sDatBis, 'yyyy-mm-dd hh:nn:ss', dtp_SBis.DateTime);
           sDatCMD := 'tstamp between ' + #39 + sDatVon + #39 + ' and ' +
              #39 + sDatBis + #39;
           if JvgCb_date.Checked then
           begin
              snOps := '';
           end
           else
           begin
              snOps := ' not ';
           end;
           if sSQLCMD = '' then
              sSQLCMD := sSQLCMD + snOps + sDatCMD
           else
              sSQLCMD := sSQLCMD + ' and ' + snOps + sDatCMD;
        end;

        // Dokumentenstatus auswerten
        if chbx_SOnlyUsed.Checked then
        begin
           if tci_InUse.Color = gclLime then
           begin
              if ((gmodiStatus and 1) = 1) then
              begin
                 iStat := 1;
              end;
           end;

           for iCount := 5 to (tlb_Status.Items.Count - 1) do
           begin
              if TTBXColorItem(tlb_Status.Items.Items[iCount]).Color = gclRed then
              begin
                 break;
              end;
           end;

           if tci_InUse.Color = gclRed then
              niStat := 1

           else
              niStat := 0;
           for iCount := 5 to (tlb_Status.Items.Count - 1) do
           begin
              // for all items which color is lime set a search bit
              // question is why it finds also the documents whith unseted bit
              // answer: it doesnt find!!! maybe it can be changed...
              // WHY XOR!!???
              if TTBXColorItem(tlb_Status.Items.Items[iCount]).Color = gclRed then
              begin
                 niStat := niStat xor (1 shl (iCount - 4));
              end;
           end;
           gmodnegiStatus := gmodnegiStatus or niStat;

           for iCount := 5 to (tlb_Status.Items.Count - 1) do
           begin
              // for all items which color is lime set a search bit
              // question is why it finds also the documents whith unseted bit
              // answer: it doesnt find!!! maybe it can be changed...
              // WHY XOR!!???
              //search only modified fields
              if (((gmodsearchiStatus and (1 shl (iCount - 4))) =
                 (1 shl (iCount - 4))) or (dm_db.my_q_arc.RecordCount = 0)) then
              begin
                 if TTBXColorItem(tlb_Status.Items.Items[iCount]).Color = gclLime then
                    iStat := iStat xor (1 shl (iCount - 4));
              end
              else
              begin
                 iStat := iStat and (not (1 shl (iCount - 4)));
              end;
           end;
           //exact search

           // imply, include search
           if iStat <> 0 then
           begin
              if sSQLCMD = '' then

                 sSQLCMD :=
                    sSQLCMD + '(doc_state & ' + IntToStr(iStat) + ') = ' +
                    IntToStr(iStat)
              else
                 sSQLCMD := sSQLCMD + ' and (doc_state & ' + IntToStr(iStat) +
                    ') = ' + IntToStr(iStat);
           end;

           if niStat <> 0 then
           begin
              if sSQLCMD = '' then
                 sSQLCMD := sSQLCMD + '(doc_state & ' + IntToStr(niStat) +
                    ') = ' + IntToStr(0)
              else
                 sSQLCMD := sSQLCMD + ' and (doc_state & ' + IntToStr(niStat) +
                    ') = ' + IntToStr(0);
           end;
        end;

        // Volltext auswerten und dem SQL String zufgen
        if memo_VTX.Text = '' then
           sSQLCMD := sSQLCMD + ''
        else
        begin
           slFelder.Clear;
           if chbx_VTXSLW.Checked then
              sVtxCMD := MakeKomplexVTXQuery(Trim(ParseSemicolonUseBackslash(lsVolltext)), //[2487]
                 False, bGAddAsterix, bGAppAsterix, tblname)
           else
           begin
              slFelder.AddObject('doc_txt', TObject(0));

              sVtxCMD := MakeKomplexQuery (Trim (ParseSemicolonWithoutBackslash (lsVolltext)), //[2487]
                                                 slFelder,
                                                 zfld04_NichtDefiniert,
                                                 bGAddAsterix,
                                                 bGAppAsterix,
                                                 False);
           end;
           if (sSQLCMD = '') and (sSLWCMD = '') then
              sSQLCMD := sSQLCMD + sVtxCMD
           else
           begin
              if (sVtxCMD <> '') then
                 sSQLCMD := sSQLCMD + ' and ' + sVtxCMD;
           end;
        end;

        // Prfen ob SQL String leer ist und Abfrage anpassen
        if sSQLCMD <> '' then
           // we have already where so if      sSQLCMD use an and!
           // put again where, since delete will be only done through the papierkorb
           Result := ' where  (' + sSQLCMD + ') '
        else
           Result := '';
     finally
        gbsearchcheckedcombobox := false;
     end;
   finally
      GgfLogEvntEnd('MakeArcQuery end');
      if Assigned(slFelder) then
         FreeAndNil(slFelder);
   end;
end;

function Tfrm_MainForm.QueryArc(QueryString: string): boolean;
   /////////////////////////////////////////////////////////////
   ///  03.05.2005   QueryArc by SV.                         ///
   ///                                                       ///
   ///  Diese Funktion gibt die Anfrage an die Datenbank     ///
   ///  und prft auf Erfolg.                                ///
   ///                                                       ///
   ///  Format: Result ist True wenn Abfrage erfolgreich     ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   sTime: string;
   lbwvlhasfocus: boolean;
   iCount : Integer;
begin
   if gbSearching then
   	Exit;
   GgfLogEvntBeg('QueryArc beg');
   gbsearching := true;
   try
      Result := True;
      GgfLogEvnt(QueryString);
       try
          try
             //disable showing it so there is no crash for calculating new rows
             frm_mainform.dbgrd_Trefferliste.visible := false;

              if ArcSQL(QueryString) then
              begin
              	  if not wvlhasfocus then
	                 Application.ProcessMessages; //04.01.2011 b.takacs 3.5.0.137
              end
              else
              begin
                 Result := False;
                 ErrorMsg('QueryArc', _('Fehler beim Suchen') + ' im Archiv', 2007, True);
              end;

          finally
             begin
                frm_mainform.dbgrd_Trefferliste.visible := true;

             end;
          end;
       except
          on e: Exception do
          begin
             frm_mainform.setpanelinfo(_('Fehler bei der Mysqlabfrage. Versuche Sie es bitte erneut.'));
             dm_MainForm2.gsstatustext := '';
             frm_Mainform.pnl_SrcTime.ParentBackground := true;
             frm_Mainform.pnl_SrcTime.Caption := 'Error';
             Result := False;
          end;
      end;

   	try
      	with frm_MainForm do
         begin
            btn_ResFields.Enabled := False;
            tGStart := GetTime - tGStart;
            dm_db.ds_Arc.Enabled := True;
            DateTimeToString(sTime, 'nn:ss:zzz', tGStart);
            GgfLogEvnt('SetControls(True)'); //3.5.0.22
            SetControls(True); //3.5.0.22
            pnl_SrcTime.Caption := sTime;
            bGImageDisp := True;
            if gbAppStarted then
            begin
               if wvlhasfocus then
               begin
                  if dbgrd_WVL.visible and dbgrd_WVL.Enabled then
                  begin
                     dbgrd_WVL.SetFocus;
                  end;
               end
               else
               if dbgrd_Trefferliste.visible and dbgrd_Trefferliste.Enabled then
               begin
                  dbgrd_Trefferliste.SetFocus;

               end;
            end;

            if not dm_db.my_q_Arc.active then
            begin
            	exit;
            end;

            if dm_db.my_q_Arc.RecordCount > 0 then
            begin
               dm_db.my_q_Arc.recno := 1;
               BM1 := dbgrd_Trefferliste.DataSource.DataSet.GetBookmark;
            end
            else
            	BM1 := nil;
               
            BM2 := nil;
            GSelection := nil;

            if fshowwvldoc then
            	fshowwvldoc := False;

            if dm_db.my_q_Arc.RecordCount > 0 then
            begin
               dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
               SetLength(GSelection,1);
               GSelection[0] :=  dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
            end;
         end;
      finally
         begin
         	frm_mainform.btn_ResFields.Enabled := True;
			end;
      end;
   finally
      gbsearching := false;
      GgfLogEvntend('QueryArc end');
   end;
end;

// function Sucharc
function Tfrm_MainForm.SuchArc: boolean;
var
   lsSQL, sSQLCMD, lsadd, lsadd2, lstemp, lstemp1, stemp, sDocidIn {, sSLWCMD, sGroupBy}: string;
   iCount, licounter: integer;
   lbfound: boolean;
begin
   GgfLogEvntBeg('SuchArc beg');
   try
      tGStart := GetTime;
      Result := False;

      if gbcmdzussearch then
      begin
         sSQLCMD := ' where ' + fcmdzusfieldsearch + ' like ' + #39 + '%' + fcmdzusvaluesearch + '%' + #39;
      end
      else
      begin
         sSQLCMD := MakeArcQuery(GArcSList[0].TblName);
      end;

      if not bMultiArcQuery then
      begin
         sSQLCMD := StringReplace(sSQLCMD, ':bitfarmslwtbl', 'slw_' +
            GArcSList[0].TblName, [rfReplaceAll]);

         gbshowresults := False;
         if Gsorderby = '' then
         begin
            Gsorderby := ' order by Tstamp desc ';
         end;

         if LoadTrefferlisteFromFile(GArcSList[0].TblName) then
         begin
            // dbgrid bug fix for sorting loaded files
            for licounter := 0 to dbgrd_TrefferListe.columns.Count - 1 do
            begin
               if dbgrd_Trefferliste.Columns.items[licounter].sortorder <> soNone then
               begin
                  lstemp := dbgrd_Trefferliste.Columns.items[licounter].DisplayName;
                  if dbgrd_Trefferliste.Columns.items[licounter].sortorder = soAsc then
                  begin
                     lstemp1 := ' asc';
                  end
                  else
                  begin
                     lstemp1 := ' desc';
                  end;
               end;
            end;
            if lstemp = '' then
            begin
               lstemp := 'tstamp desc';
            end;
            Gsorderby := ' order by ' + lstemp + lstemp1;
         end;

         // query-optimierung bei where-klausel durch verwendung eines inner select
         if sSQLCMD <> '' then
         begin
            lsSQL := 'Select doc_id from ( select Sql_No_cache * from arc_' + GArcSList[0].TblName +
            ' ' {+ sSLWCMD} + sSQLCMD {+ sGroupBy} + Gsorderby + ') as arc_' + GArcSList[0].TblName +' '+ sGMaxHits;
            sDocidIn := MakeDocidInQuery(lsSQL);
            if  sDocidIn <> '' then
               LsSQL := 'Select * from arc_' + GArcSList[0].TblName +
                        ' where ' +  sDocidIn + Gsorderby

            else  // zur Sicherheit die alte Query, ist zwar langsam, macht aber kein rger mit dem dB-Grid
               lsSQL := 'Select Sql_No_cache * from arc_' + GArcSList[0].TblName +
                  ' as arc' {+ sSLWCMD} + sSQLCMD {+ sGroupBy} + Gsorderby + ' ' + sGMaxHits;

         end
         else
            lsSQL := 'Select Sql_No_cache * from arc_' + GArcSList[0].TblName +
               ' as arc' {+ sSLWCMD} + sSQLCMD {+ sGroupBy} + Gsorderby + ' ' + sGMaxHits;

         QueryArc(lsSQL);

         iGArcID := GArcSList[0].ArcID;
         bMultiArcQuery := False;
         GetArcUsrRights;
      end
      else
      begin
         with dm_DB.my_cmdarc do
         begin
            DbCreateTempTable(sGTmpName,fslsearchcolumnsadds);

            for iCount := 0 to (Length(GArcSList) - 1) do
            begin
               if GArcSList[iCount].ArcName <> '' then
               begin
                  lsadd := '';

                  if fslsearchcolumnsadds.Count > 0 then
                  begin
                     TMPSQL('show tables like ' + #39 + 'cfg_' + GArcSList[iCount].TblName + #39);
                     if dm_db.my_q_tmp.recordcount > 0 then
                     begin
                        TMPSQL('describe arc_' + GArcSList[iCount].TblName);
                     end;
                  end;
                  for licounter := 0 to fslsearchcolumnsadds.Count - 1 do
                  begin
                     if dm_db.my_q_tmp.recordcount = 0 then
                     begin
                        continue;
                     end;
                     dm_db.my_q_tmp.first;
                     lbfound := false;
                     while not dm_db.my_q_tmp.eof do
                     begin
                        //why field name and not disp_name?
                        if dm_db.my_q_tmp.fieldbyname('Field').asstring =
                           fslsearchcolumnsadds.Strings[licounter] then
                        begin
                           lbfound := true;
                           break;
                        end;
                        dm_db.my_q_tmp.next;
                     end;
                     if lbfound then
                     begin
                        lsadd := lsadd + ',' + fslsearchcolumnsadds.Strings[licounter];
                     end;
                  end;

                  sSQLCMD := MakeArcQuery(GArcSList[iCount].TblName);
                  sSQLCMD := StringReplace(sSQLCMD, ':bitfarmslwtbl', 'slw_' +
                     GArcSList[0].TblName, [rfReplaceAll]);

                  SQL.Text := 'Insert into tmp_' + sGTmpName +
                     ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ' +
                     'ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf, `gdoc_id`' + lsadd +
                     ') Select Sql_No_cache '
                     + IntToStr(GArcSList[iCount].ArcID) + ' as Arc_ID,' +
                     #39 + GArcSList[iCount].ArcName + #39 + ' as ArcName,' +
                     #39 + GArcSList[iCount].TblName + #39 + ' as TblName,' +
                     ' arc.doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, arc.usr_id, tstamp, doc_txt, doc_state, ocr_qf, `gdoc_id`' +
                     lsadd + ' from arc_'
                     + GArcSList[iCount].TblName + ' as arc ' {+ sSLWCMD} +
                     sSQLCMD {+ sGroupBy} + ' order by tstamp desc ' + sGMaxHits + '  on duplicate key update ' +
                     ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';

                  SQL.Text := StringReplace(SQL.Text, ':bitfarmslwtbl',
                     'slw_' + GArcSList[iCount].TblName, [rfReplaceAll]);
                  try
                     Execute;
                  except
                     on e: Exception do
                     begin
                        LogEvnt('1003    ' + _('Fehler') + ' in Modul: SuchArc ' + _('Fehler beim Fllen einer Temptabelle:')
                           + e.Message);
                     end;
                  end;
               end;
            end;
         end;

         fslsearchcolumnsadds.clear;
         if Gsorderby = '' then
         begin
            Gsorderby := ' order by tstamp desc ';
         end;

         QueryArc('Select Sql_No_cache * from tmp_' + sGTmpName + Gsorderby +
             ' ' + sGMaxHits);

         bMultiArcQuery := True;
      end;
         if bMultiArcQuery then
            dm_MainForm2.mnu_TGoToArc.Visible := True;
      HandleDoc;
   finally
      GgfLogEvntEnd('SuchArc end');
   end;

end;


function Tfrm_MainForm.CreZusFields(isVerschlagwortungsHilfe: boolean): integer;
   /////////////////////////////////////////////////////////////
   ///  03.05.2005   Erstellt von SV   ZuSATZFELDER          ///
   ///       Zusatz felder erstellen
   ///       create zusatz felder
   ///  Diese Funktion liest aus der Tabelle cfg_[xxxxxx]    ///
   ///  die Zusatzfelder aus und erstellt dynamisch neue     ///
   ///  Label und Edit Komponenten                           ///
   ///                                                       ///
   ///  Ausgabe: Anzahl der erstellten Komponentenstze      ///
   ///           (1x Edit und 1x Label)                      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   edt: array of TEdit;
   lbl: array of TJvStaticText;
   lblbis: array of TJvStaticText;
   cbx: array of TComboBox;
   jccb: array of TjvCheckedComboBox;
   ccb: array of TcheckBox;
   spe: array of TSpinEdit;
   lfbit: array of TTBXButton;
   chx: array of Tcheckbox;
   tbxb: array of TTBXButton;

   dat: array of TJvDateEdit;
   ljvcb: array of TJvgCheckBox;
   lganzzahl: array of TJvSpinEdit;
   ldouble: array of TjvSpinEdit;
   iC, licounter, iTyp, iCntEdt, iCntLFEdt, iCntCbx, iCntLbl, iCntDat, iCntCCbx, litop,
   liscroll, icntccb, licolumntreffer, iCntSpi, licount2,
   iCntbxb, iCntLblbis, iCntganzzahl, iCntdouble, iCntchx, iCnttbxb,
   liLeft, liWidth,
   liprefix, ArcType: integer; // wenn Verschlagwortungshilfe dann ist vorne noch eine Checkbox dran.
   lfont: Tfont;

   sTmpNGField, lsdat1, lsdat2: string; 
   coltmpNG: Tcolumn;
   lbcolumnfound, lblistloaded: boolean;
   lbhasxs: boolean;
   lstlw: Tstringlist;
   TmpMnu: TMenuItem;
   sAdd, sTmp, lsDispName: string;
   lTyp     : eAddFieldType;
   lAddField: clAddField;
   lArchiv  : clArchiv;            
   xFldCont : clArcAddTab;

begin
   GgfLogEvntBeg ('Tfrm_MainForm.CreZusFields Beginn');

   try
      iCntEdt := 0;
      iCntCbx := 0;
      iCntLbl := 0;
      iCntDat := 0;
      iCntSpi := 0;
      iCntCCbx := 0;
      iCntbxb := 0;
      iCntchx := 0;
      iCntLFEdt := 0;
      iCntLblbis := 0;
      iCnttbxb := 0;
      icntccb := 0;
      iCntganzzahl := 0;
      iCntdouble := 0;
      tbxb_reset.Visible := false;
      tbbt_search.Visible := false;

      If sIArcName = '' then
        exit;

      lArchiv := clArchiv.getInstance;
      lArchiv.AddFieldTab.clear;

      with dm_DB.my_q_CreZusFields do
      begin
      	SQL.Text := 'Select * from sys_arc where arc_tblname = ' +#39 + sIArcName +#39;
         Execute;
         ArcType := dm_DB.my_q_CreZusFields.FieldByName('Type').AsInteger;

         if sbx_ZusFeld.ComponentCount > 0 then
            DelZusFields2(not isVerschlagwortungsHilfe);
         if not DbTableExist('cfg_' + sIArcName) then
         	Exit;

         SQL.Text := 'Select * from cfg_' + sIArcName + '  where  typ <> 4  order by pos';
         Open;
         First;
         try
            Result := RecordCount;
            if RecordCount = 0 then
            begin
               Close;
               Exit;
            end;

            Filtered := False;
            SetLength(lbl, RecordCount);
            setlength(lbl_zuf, RecordCount);
            SetLength(ljvcb, RecordCount);

            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            //  Trefferliste um die Zusatzfelder erweitern
            //try to fix not ordering!
            // todo check for svn field version

            if isVerschlagwortungsHilfe then
            begin
               liprefix := 22;
            end
            else
            begin
               liprefix := 0;
               if Trefferlistealreadyloaded = False then
               begin
                  dbgrd_TrefferListe.columns.Clear;

                  lbcolumnfound := false;
                  lblistloaded := false;
                  if FileExists(ResultlistDesignPath + '\' + sIArcName + '.bfa') then
                     // deaktiviert
                  begin
                     dbgrd_TrefferListe.Columns.LoadFromFile(ResultlistDesignPath +
                        '\' + sIArcName + '.bfa');
                     lastloadedArcName :=
                        ResultlistDesignPath + '\' + sIArcName + '.bfa';
                     lblistloaded := true;
                  end
                  else
                  if FileExists(BD.ExeDir + 'bfa_hit' + '\' + sIArcName + '.bfa') then
                  begin
                     dbgrd_TrefferListe.columns.Clear;
                     dbgrd_TrefferListe.Columns.LoadFromFile(BD.ExeDir + 'bfa_hit' +
                        '\' + sIArcName + '.bfa');
                     lastloadedArcName := BD.ExeDir + 'bfa_hit'
                        + '\' + sIArcName + '.bfa';
                     lblistloaded := true;
                  end
                  else
                  begin
                     CreateStandardColumnsTRefferliste;
                  end;
                  if lblistloaded then
                  begin
                     dm_DB.my_q_CreZusFields.First;
                     licolumntreffer := 0;
                     for iC := 0 to (RecordCount - 1) do // Zaehle die Zusatzfelder
                     begin
                        lbcolumnfound := false;
                        for licounter := 0 to (dbgrd_TrefferListe.Columns.Count - 1) do // Zaehle die Zusatzfelder
                        begin
                           if FieldByName('Feld_name').AsString = dbgrd_TrefferListe.Columns.Items[licounter].FieldName then
                           begin
                              lbcolumnfound := true;
                              licolumntreffer := licolumntreffer + 1;
                              break;
                           end;
                        end;
                        if (lbcolumnfound = false)
                        then
                        begin
                           break;
                        end;
                        dm_DB.my_q_CreZusFields.Next;
                     end;
                     if (licolumntreffer <> dbgrd_TrefferListe.Columns.Count - 3) then
                     begin
                        killfile(ResultlistDesignPath +
                           '\' + sIArcName + '.bfa');
                        lbcolumnfound := false;
                     end;
                  end;

                  if (not lbcolumnfound)
                  then
                  begin
                     CreateStandardColumnsTRefferliste;
                     dm_DB.my_q_CreZusFields.First;
                     for iC := 0 to (RecordCount - 1) do // Zaehle die Zusatzfelder
                     begin
                        with dbgrd_TrefferListe do
                           // dynamische Tabelle der Trefferliste erzeugen
                        begin
                           //coltmpNG.Width:=7;  sder
                           coltmpNG := Columns.add;
                           coltmpNG.Width := 70;
                           colTmpNG.Title.Caption := FieldByName('Disp_Name').AsString;
                           colTmpNG.FieldName := FieldByName('Feld_name').AsString;
                           coltmpNG.Alignment := taLeftJustify;
                           coltmpNG.ButtonStyle := cbsAuto;
                           coltmpNG.Color := clWhite;
                           coltmpNG.DropDownRows := 7;
                           coltmpNG.Expanded := False;
                           coltmpNG.ReadOnly := True;
                           coltmpNG.Visible := True;
                        end;
                        dm_DB.my_q_CreZusFields.Next;
                     end;
                     dm_DB.my_q_CreZusFields.First;
                  end;
                  Trefferlistealreadyloaded := True;
               end;
            end;

            // end; // entweder lade die Gridliste aus der Hit Datei oder aus der Datenbank
            litop := 0;
            liscroll := 0;
            dm_DB.my_q_CreZusFields.First;
            sbx_ZusFeld.Update;
            setlength(gai_cfg_rights, recordcount);
            dm_db.my_q_ngtmp.SQL.Text := 'show tables like ' + #39 + 'cfgxs_' + sIarcname + #39;
            dm_db.my_q_ngtmp.execute;
            if dm_db.my_q_ngtmp.RecordCount > 0 then
            begin
               gbcfgxs := true;
               lbhasxs := true;
               dm_db.my_q_ngtmp.SQL.Text := 'select * from cfgxs_' + sIarcname + ' where usr_id = ' + inttostr(iGusrid);
               dm_db.my_q_ngtmp.execute;
            end
            else
            begin
               gbcfgxs := false;
               lbhasxs := false;
            end;
            sbx_ZusFeld.visible := false;

            for iC := 0 to (RecordCount - 1) do // Iteriere ber die Zusatzfelder
            begin
               iTyp      := FieldByName('Typ').AsInteger;
               lAddField := clAddField.Create;

               lArchiv.AddFieldTab.add (lAddField);

               lAddField.CompIdx := iC;

               // lbl[iCntLbl] := TLabel.Create(sbx_ZusFeld);
               lbl[iCntLbl] := TJvStaticText.Create(sbx_ZusFeld);
               lbl[iCntLbl].Name := 'zlbl_Tmp' + IntToStr(iC);
               if (ityp = 1) or
                  (ityp = 6) or
                  (ityp = 7) or
                  (ityp = 8) then
               begin
                  lsdat1 := _('(von)');
                  lsdat2 := _('(bis)');
               end
               else
               if ityp = 5 then
               begin
                  lsdat1 := _('(Einheit)');
                  lsdat2 := _('(Zeitraum)');
               end
               else
               begin
                  lsdat1 := '';
                  lsdat2 := '';
               end;
               lbl[iCntLbl].Caption := FieldByName('Disp_Name').AsString + lsdat1 + ':';
               lbl_zuf[ic] := lbl[iCntLbl].Caption;
               // in diesem Fall reservieren die Labels auch die VariablenNamen
               lbl[iCntLbl].Hint := FieldByName('Feld_Name').AsString;

               lbl[iCntLbl].ParentShowHint := True;
               lbl[iCntLbl].Left := 8;
               lbl[iCntLbl].Top := 8 + (38 * iC);
               if litop + 74 > sbx_ZusFeld.Height then
               begin
                  liscroll := 16;
               end
               else
               begin
                  litop := lbl[iCntLbl].Top;
               end;
               lbl[iCntLbl].Height := 13;

               lfont := canvas.Font;
               canvas.Font := lbl[iCntLbl].Font;
               lbl[iCntLbl].Width := 4 + canvas.TextWidth(lbl[iCntLbl].Caption);
               canvas.Font := lfont;

               lbl[iCntLbl].Tag := FieldByName('typ').AsInteger;
               lbl[iCntlbl].Parent := sbx_ZusFeld;
               ljvcb[iCntLbl] := TJvgCheckBox.Create(sbx_ZusFeld);
               ljvcb[iCntLbl].Name := 'jvcbzedt_Tmp' + IntToStr(iC);
               ljvcb[iCntLbl].Hint :=
                  _('Feld') + ' ' + FieldByName('Disp_Name').AsString +
                  '  ' + _('in der Suche negieren.');
               ljvcb[iCntLbl].FocusControl := sbx_ZusFeld;
               //          ljvcb[iCntLbl].
               ljvcb[iCntLbl].ShowHint := True;
               ljvcb[iCntLbl].Left := sbx_ZusFeld.Width - 20 - liscroll;
               ljvcb[iCntLbl].Top := 21 + (38 * iC);
               ljvcb[iCntLbl].Height := 21;
               ljvcb[iCntLbl].Align := alNone;
               ljvcb[iCntLbl].Width := (10);
               ljvcb[iCntLbl].Anchors := [akTop, akRight];
               ljvcb[iCntLbl].onClick := EnableSaveOnChange;
               ljvcb[iCntLbl].Checked := True;
               // Mode:= exakt, wortende, wortanfang, wortbestandteil
               ljvcb[iCntLbl].Tag := FieldByName('Mode').AsInteger;
               ljvcb[iCntLbl].Transparent := True;
               ljvcb[iCntLbl].Parent := sbx_ZusFeld;


               if lbhasxs then
               begin
                  gai_cfg_rights[iC] := false;
                  dm_db.my_q_ngtmp.first;
                  while not dm_db.my_q_ngtmp.eof do
                  begin
                     if FieldByName('cfg_id').AsInteger = dm_db.my_q_ngtmp.FieldByName('cfg_id').AsInteger then
                     begin
                        gai_cfg_rights[iC] := true;
                     end;
                     dm_db.my_q_ngtmp.next;
                  end;
               end
               else
               begin
                  gai_cfg_rights[iC] := true;
               end;

               lTyp          := eAddFieldType (iTyp);
               lAddField.Typ := lTyp;
               // if iTyp = 0 then

               if lTyp = zfld00_Universal then
               begin
                  // set just the proper length
                  SetLength(edt, iCntEdt + 1);
                  edt[iCntEdt] := TEdit.Create(sbx_ZusFeld);
                  edt[iCntEdt].Name := 'zedt_Tmp' + IntToStr(iC);
                  edt[iCntEdt].Text := '';
                  edt[iCntEdt].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');

                  edt[iCntEdt].ShowHint := false;
                  edt[iCntEdt].Left := 8 + liprefix;
                  edt[iCntEdt].Top := 21 + (38 * iC);
                  edt[iCntEdt].Height := 21;
                  edt[iCntEdt].Width := (sbx_ZusFeld.Width - 45) - liscroll - liprefix;
                  edt[iCntEdt].Anchors := [akLeft, akright, akTop];
                  edt[iCntEdt].OnKeyUp := EnableSaveOnKeyUp;
                  edt[iCntEdt].OnKeyPress := ZusFlsTyp0EditKeyPress; //3.5.0.22
                  // skywalker save if changed!!!
                  edt[iCntEdt].OnChange := EnableSaveOnChange;
                  // edt[iCntEdt].OnEnter := EnableSave;
                  edt[iCntEdt].OnKeyDown := DoSearchOnenter;
                  edt[iCntEdt].Tag := FieldByName('Mode').AsInteger;
                  edt[iCntEdt].Parent := sbx_ZusFeld;
                  if gai_cfg_rights[iC] then
                  begin
                     edt[iCntEdt].color := clwhite;
                  end
                  else
                  begin
                     edt[iCntEdt].color := cColorNoRightInit;
                  end;

                  // Die Komponente erst am Schlu sichtbar machen
                  edt[iCntEdt].Align := alNone;
                  lAddField.FieldName := FieldByName('Feld_Name').AsString;
                  lAddField.CompName := edt [iCntEdt].Name;
                  lAddField.ContOld  := edt [iCntEdt].Text;

                  Inc(iCntEdt, 1);
               end
               else

               if lTyp = zfld01_Datum then
               begin
                  // set just the proper length     (+2 cause there is always 2 date boxes)
                  SetLength(dat, iCntDat + 2);

                  dat[iCntDat] := TJvDateEdit.Create(sbx_ZusFeld);
                  fdatestringempty := dat[iCntDat].text;
                  dat[iCntDat].Name := 'zedt_Tmp' + IntToStr(iC);
                  dat[iCntDat].Clear;
                  dat[iCntDat].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  dat[iCntDat].ShowHint := false;
                  dat[iCntDat].Left := 8 + liprefix;
                  dat[iCntDat].Top := 21 + (38 * iC);
                  dat[iCntDat].Height := 21;
                  dat[iCntDat].Width := dtp_SVon.Width;
                  dat[iCntDat].Anchors := [akLeft, akTop];
                  dat[iCntDat].OnKeyUp := EnableSaveOnKeyUp;
                  dat[iCntDat].OnKeyDown := DoSearchOnenter;
                  dat[iCntDat].OnChange := EnableSaveOnChange;
                  dat[iCntDat].Tag := FieldByName('Mode').AsInteger;
                  dat[iCntDat].Parent := sbx_ZusFeld;

                  if gai_cfg_rights[iC] then
                  begin
                     dat[iCntDat].color := clwhite;
                  end
                  else
                  begin
                     dat[iCntDat].color := cColorNoRightInit;
                  end;

                  lAddField.FieldName := FieldByName('Feld_Name').AsString;
                  lAddField.CompName := dat [iCntDat].Name;
                  lAddField.ContOld  := dat [iCntDat].Text;

                  // Die Komponente erst am Schlu sichtbar machen
                  Inc(iCntDat, 1);

                  dat[iCntDat] := TJvDateEdit.Create(sbx_ZusFeld);
                  dat[iCntDat].Name := 'zedt_Tmp_og_' + IntToStr(iC);
                  dat[iCntDat].Clear;
                  dat[iCntDat].Hint := _('Geben Sie bitte die obere Grenze fr die Datumssuche ein');
                  dat[iCntDat].ShowHint := True;
                  dat[icntdat].Anchors := [akTop, akleft, akright];
                  dat[iCntDat].Top := 21 + (38 * iC);
                  dat[iCntDat].OnKeyUp := EnableSaveOnKeyUp;
                  dat[iCntDat].OnKeyDown := DoSearchOnenter;
                  dat[iCntDat].OnChange := EnableSaveOnChange;
                  dat[iCntDat].Width := dat[iCntDat - 1].Width;
                  dat[iCntDat].Height := 21;
                  dat[iCntDat].Left := sbx_ZusFeld.Width - 39 - dat[iCntDat].Width - liscroll;
                  dat[iCntDat].Anchors := [akright, aktop];
                  dat[iCntDat].Tag := FieldByName('Mode').AsInteger;
                  dat[iCntDat].Parent := sbx_ZusFeld;

                  if gai_cfg_rights[iC] then
                  begin
                     dat[iCntDat].color := clwhite;
                  end
                  else
                  begin
                     dat[iCntDat].color := cColorNoRightInit;
                  end;

                  //bis label:
                  SetLength(lblbis, iCntLblbis + 1);

                  lblbis[iCntLblbis] := TJvStaticText.Create(sbx_ZusFeld);
                  lblbis[iCntLblbis].Name := 'zlblbis_Tmp' + IntToStr(iC);
                  lblbis[iCntLblbis].Caption := lsdat2 + ':';
                  // in diesem Fall reservieren die Labels auch die VariablenNamen
                  lblbis[iCntLblbis].Hint := FieldByName('Feld_Name').AsString;

                  lblbis[iCntLblbis].ParentShowHint := True;
                  lblbis[iCntLblbis].Anchors := [akTop, akright];
                  lblbis[iCntLblbis].Left := sbx_ZusFeld.Width - 39 - dat[iCntDat].Width - liscroll;
                  Inc(iCntDat, 1);
                  lblbis[iCntLblbis].Top := 8 + (38 * iC);
                  lblbis[iCntLblbis].Height := 13;

                  lfont := canvas.Font;
                  canvas.Font := lblbis[iCntLblbis].Font;
                  lblbis[iCntLblbis].Width := 4 + canvas.TextWidth(lblbis[iCntLblbis].Caption);
                  canvas.Font := lfont;
                  lblbis[iCntLblbis].Parent := sbx_ZusFeld;
                  inc(iCntLblbis);
                  //  zur Deaktivierung der dynamischen Erzeugung des Zusatzfeldes Datum hier Begin der Auskommentares
               end
               else

               if lTyp = zfld02_Auswahl then
               begin
                  // set just the proper length
                  SetLength(cbx, iCntCbx + 1);
                  // cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                  cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                  cbx[iCntCbx].Name := 'zedt_Tmp' + IntToStr(iC);
                  cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
                  cbx[iCntCbx].Hint := _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  cbx[iCntCbx].ShowHint  := false;
                  cbx[iCntCbx].Left      := 8 + liprefix;
                  cbx[iCntCbx].Top       := 21 + (38 * iC);
                  cbx[iCntCbx].Height    := 21;
                  cbx[iCntCbx].Width     := (sbx_ZusFeld.Width - 45) - liscroll - liprefix;
                  cbx[iCntCbx].Anchors   := [akLeft, akTop, akRight];
                  cbx[iCntCbx].OnKeyUp   := EnableSaveOnKeyUp;
                  cbx[iCntCbx].OnChange  := EnableSaveOnChange;
                  cbx[iCntCBx].OnKeyDown := DoSearchOnenter;
                  cbx[iCntCBx].OnExit    := onExitComboBox;  //  20.05.2010  Vers. 3.5.0.77  [2264]  r.sch.
                  cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
                  cbx[iCntCbx].Parent := sbx_ZusFeld;
                  cbx[iCntCbx].Clear;
                  cbx[iCntCbx].Items.CommaText := FieldByName('Werte').AsString;
                  cbx[iCntCbx].Items.Add('');

                  if gai_cfg_rights[iC] then
                  begin
                     cbx[iCntCbx].color := clwhite;
                  end
                  else
                  begin
                     cbx[iCntCbx].color := cColorNoRightInit;
                  end;

                  lAddField.FieldName             := FieldByName('Feld_Name').AsString;
                  lAddField.ChoiceList.CommaText := cbx [iCntCbx].Items.CommaText;
                  lAddField.CompName             := cbx [iCntCbx].Name;
                  lAddField.ContOld              := cbx [iCntCbx].Text;

                  //  darf nicht in 'lAddField.ChoiceList' stehen
                  cbx[iCntCbx].Items.Add (_('--- nur suchen mglich ---'));  //  30.06.2010  Vers. 3.5.0.86  [2590]  r.sch.
                  cbx[iCntCbx].Items.Add ('""');                          //  30.06.2010  Vers. 3.5.0.86  [2638]  r.sch.

                  if ArcType <> 0 then     //10.09.2010 b.takacs
                  begin
                    with dm_DB.my_q_FillZusAuswahlFeld do
                      begin
                        SQL.Text := 'Select Sql_No_cache distinct ' + lAddField.FieldName + ' from arc_' + sIArcName + ' order by '+ lAddField.FieldName;
                        Open;
                        First;
                        while not Eof do
                        begin
                          if (FieldByName(lAddField.FieldName).AsString<>'') and (FieldByName(lAddField.FieldName).AsString<>'""') then
                          begin
                             if Pos(FieldByName(lAddField.FieldName).AsString,dm_DB.my_q_CreZusFields.FieldByName('Werte').AsString)=0 then //13.05.2011 b.takacs 3.5.1.11 [3062]
                              cbx[iCntCbx].Items.Add (FieldByName(lAddField.FieldName).AsString);
                          end;
                          Next;
                        end;
                        Close;
                      end;
                  end;
                  Inc(iCntCbx, 1);
               end
               else

               if lTyp = zfld03_MehrfachAuswahl then
               begin
                  lsDispName := FieldByName('Disp_Name').AsString;
                  sAdd := lbl[iCntLbl].Hint;
                  liLeft := 8 + liprefix;
                  liWidth := (sbx_ZusFeld.Width - 45) - liprefix - liscroll;

                  ZusFldFrame := CreateTjvCheckedComboBox(sbx_ZusFeld, iC,
                                    -1, liLeft, liWidth,
                                    lsDispName, sAdd, sIArcName,
                                    EnableSaveOnChange,
                                    FieldByName('Mode').AsInteger);

                  if gai_cfg_rights[iC] then
                     ZusFldFrame.ComboBox.noFocusColor := clwhite
                  else
                     ZusFldFrame.ComboBox.noFocusColor := cColorNoRightInit;

                  SetLength(jccb, iCntCCbx + 1);
                  jccb[iCntCCbx] := ZusFldFrame.ComboBox;
                  jccb[iCntCCbx].OnChange := MehrfachRestoreScrollbar;
                  jccb[iCntCCbx].OnExit := OnAddfieldCloseUp;
                  jccb[iCntCCbx].OnClick := MehrfachGetScrollbar;
                  jccb[iCntCCbx].OnEnter := MehrfachGetScrollbar;

                  lAddField.FieldName := FieldByName('Feld_Name').AsString;
                  lAddField.CompName := jccb [iCntCCbx].Name;
                  lAddField.ContOld  := jccb [iCntCCbx].Text;

                  Inc(iCntCCbx, 1);
                  SetLength(lfbit, iCntbxb + 1);
                  lfbit[iCntbxb] := ZusFldFrame.Button;
                  Inc(iCntbxb, 1);
               end
               else

               if lTyp = zfld05_Intervall then
               begin
                  // set just the proper length
                  SetLength(spe, iCntSpi + 1);
                  // cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                  spe[iCntSpi] := TSpinEdit.Create(sbx_ZusFeld);
                  spe[iCntSpi].Name := 'zedt_Tmp' + IntToStr(iC);
                  spe[iCntSpi].Hint := _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  spe[iCntSpi].ShowHint := false;
                  spe[iCntSpi].Left := 8 + liprefix;
                  spe[iCntSpi].Top := 21 + (38 * iC);
                  spe[iCntSpi].Height := 21;
                  spe[iCntSpi].Width := dtp_SVon.Width - liprefix;
                  spe[iCntSpi].MaxValue := maxint; // m.frey: war 31 gendert wegen Wehrling nicht Monat absolut sondern Laufzeit
                  spe[iCntSpi].MinValue := 0;
                  spe[iCntSpi].Value := 0;
                  spe[iCntSpi].Text := '';
                  spe[iCntSpi].Anchors := [akLeft, akTop];
                  spe[iCntSpi].OnKeyUp := EnableSaveOnKeyUp;
                  spe[iCntSpi].OnChange := EnableSaveOnChange;
                  spe[iCntSpi].OnKeyDown := DoSearchOnenter;
                  spe[iCntSpi].Tag := FieldByName('Mode').AsInteger;
                  spe[iCntSpi].Parent := sbx_ZusFeld;
                  spe[iCntSpi].Clear;

                  if gai_cfg_rights[iC] then
                  begin
                     spe[iCntSpi].color := clwhite;
                  end
                  else
                  begin
                     spe[iCntSpi].color := cColorNoRightInit;
                  end;

                  lAddField.FieldName := FieldByName('Feld_Name').AsString;
                  lAddField.CompName := spe [iCntSpi].Name;
                  lAddField.ContOld  := spe [iCntSpi].Text;

                  Inc(iCntSpi, 1);
                  SetLength(cbx, iCntCbx + 1);

                  cbx[iCntCbx] := TComboBox.Create(sbx_ZusFeld);
                  cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
                  cbx[iCntCbx].Name := 'zedt_Tmp_cbx_' + IntToStr(iC);
                  cbx[iCntCbx].Style := csDropDown; //3.5.0.19 [ 2264 ] Auswahlfelder knnen beliebig manuell ausgefllt werden
                  cbx[iCntCbx].Hint := _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  cbx[iCntCbx].ShowHint := false;
                  cbx[iCntCbx].Left := sbx_ZusFeld.Width - 39 - dtp_SVon.Width - liscroll;
                  cbx[iCntCbx].Top := 21 + (38 * iC);
                  cbx[iCntCbx].Height := 21;
                  cbx[iCntCbx].Width := dtp_SVon.Width - liscroll;
                  cbx[iCntCbx].Anchors := [akTop, akRight];
                  cbx[iCntCbx].OnKeyUp := EnableSaveOnKeyUp;
                  cbx[iCntCbx].OnChange := EnableSaveOnChange;
                  cbx[iCntCBx].OnKeyDown := DoSearchOnenter;
                  cbx[iCntCbx].Tag := FieldByName('Mode').AsInteger;
                  cbx[iCntCbx].Parent := sbx_ZusFeld;
                  cbx[iCntCbx].Clear;
                  cbx[iCntCbx].Items.CommaText := 'T,M,J';
                  cbx[iCntCbx].Items.Add('');

                  if gai_cfg_rights[iC] then
                  begin
                     cbx[iCntCbx].color := clwhite;
                  end
                  else
                  begin
                     cbx[iCntCbx].color := cColorNoRightInit;
                  end;
                  SetLength(lblbis, iCntLblbis + 1);
                  lblbis[iCntLblbis] := TJvStaticText.Create(sbx_ZusFeld);
                  lblbis[iCntLblbis].Name := 'zlblbis_Tmp' + IntToStr(iC);
                  lblbis[iCntLblbis].Caption := lsdat2 + ':';
                  // in diesem Fall reservieren die Labels auch die VariablenNamen
                  lblbis[iCntLblbis].Hint := FieldByName('Feld_Name').AsString;
                  lblbis[iCntLblbis].ParentShowHint := True;
                  lblbis[iCntLblbis].Anchors := [akTop, akright];
                  lblbis[iCntLblbis].Left := sbx_ZusFeld.Width - 39 - cbx[iCntCbx].Width - liscroll;
                  Inc(iCntDat, 1);
                  lblbis[iCntLblbis].Top := 8 + (38 * iC);
                  lblbis[iCntLblbis].Height := 13;
                  lfont := canvas.Font;
                  canvas.Font := lblbis[iCntLblbis].Font;
                  lblbis[iCntLblbis].Width := 4 + canvas.TextWidth(lblbis[iCntLblbis].Caption);
                  canvas.Font := lfont;
                  lblbis[iCntLblbis].Parent := sbx_ZusFeld;
                  inc(iCntLblbis);
                  Inc(iCntCbx, 1);
               end
               else

               if lTyp = zfld06_GanzZahl then
               begin
                  // set just the proper length     (+2 cause there is always 2 date boxes)
                  SetLength(lganzzahl, iCntganzzahl + 2);

                  lganzzahl[iCntganzzahl] := TJvSpinEdit.Create(sbx_ZusFeld);
                  lganzzahl[iCntganzzahl].Name := 'zedt_Tmp' + IntToStr(iC);
                  lganzzahl[iCntganzzahl].Hint := _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  lganzzahl[iCntganzzahl].ShowHint := false;
                  lganzzahl[iCntganzzahl].Left := 8 + liprefix;
                  lganzzahl[iCntganzzahl].Top := 21 + (38 * iC);
                  lganzzahl[iCntganzzahl].Height := 21;
                  lganzzahl[iCntganzzahl].Width := dtp_SVon.Width;
                  lganzzahl[iCntganzzahl].Anchors := [akLeft, akTop];
                  lganzzahl[iCntganzzahl].OnKeyUp := EnableSaveOnKeyUp;
                  lganzzahl[iCntganzzahl].OnKeyDown := DoSearchOnenter;
                  lganzzahl[iCntganzzahl].OnChange := EnableSaveOnChange;
                  lganzzahl[iCntganzzahl].OnClick := BtnEnableSave;
                  lganzzahl[iCntganzzahl].Tag := FieldByName('Mode').AsInteger;
                  lganzzahl[iCntganzzahl].Parent := sbx_ZusFeld;

                  if gai_cfg_rights[iC] then
                  begin
                     lganzzahl[iCntganzzahl].color := clwhite;
                  end
                  else
                  begin
                     lganzzahl[iCntganzzahl].color := cColorNoRightInit;
                  end;

                  lAddField.FieldName := FieldByName('Feld_Name').AsString;
                  lAddField.CompName := lganzzahl [iCntganzzahl].Name;
                  lAddField.ContOld  := lganzzahl [iCntganzzahl].Text;

                  Inc(iCntganzzahl, 1);

                  lganzzahl[iCntganzzahl] := TJvSpinEdit.Create(sbx_ZusFeld);
                  lganzzahl[iCntganzzahl].Name := 'zedt_Tmp_og_' + IntToStr(iC);
                  lganzzahl[iCntganzzahl].Hint :=
                     _('Geben Sie bitte die obere Grenze fr die Datumssuche ein');
                  lganzzahl[iCntganzzahl].ShowHint := True;
                  lganzzahl[iCntganzzahl].Anchors := [akTop, akleft, akright];
                  lganzzahl[iCntganzzahl].Top := 21 + (38 * iC);
                  lganzzahl[iCntganzzahl].OnKeyUp := EnableSaveOnKeyUp;
                  lganzzahl[iCntganzzahl].OnKeyDown := DoSearchOnenter;
                  lganzzahl[iCntganzzahl].OnChange := EnableSaveOnChange;
                  lganzzahl[iCntganzzahl].Width := lganzzahl[iCntganzzahl - 1].Width;
                  lganzzahl[iCntganzzahl].Height := 21;
                  lganzzahl[iCntganzzahl].Left :=
                     sbx_ZusFeld.Width - 39 - lganzzahl[iCntganzzahl].Width - liscroll;
                  lganzzahl[iCntganzzahl].Anchors := [akright, aktop];
                  lganzzahl[iCntganzzahl].OnClick := BtnEnableSave;
                  lganzzahl[iCntganzzahl].Tag := FieldByName('Mode').AsInteger;
                  lganzzahl[iCntganzzahl].Parent := sbx_ZusFeld;

                  if gai_cfg_rights[iC] then
                  begin
                     lganzzahl[iCntganzzahl].color := clwhite;
                  end
                  else
                  begin
                     lganzzahl[iCntganzzahl].color := cColorNoRightInit;
                  end;
                  //bis label:
                  SetLength(lblbis, iCntLblbis + 1);

                  lblbis[iCntLblbis] := TJvStaticText.Create(sbx_ZusFeld);
                  lblbis[iCntLblbis].Name := 'zlblbis_Tmp' + IntToStr(iC);
                  lblbis[iCntLblbis].Caption := lsdat2 + ':';
                  // in diesem Fall reservieren die Labels auch die VariablenNamen
                  lblbis[iCntLblbis].Hint := FieldByName('Feld_Name').AsString;
                  lblbis[iCntLblbis].ParentShowHint := True;
                  lblbis[iCntLblbis].Anchors := [akTop, akright];
                  lblbis[iCntLblbis].Left := sbx_ZusFeld.Width - 39 - lganzzahl[iCntganzzahl].Width - liscroll;
                  Inc(iCntganzzahl, 1);
                  lblbis[iCntLblbis].Top := 8 + (38 * iC);
                  lblbis[iCntLblbis].Height := 13;
                  lfont := canvas.Font;
                  canvas.Font := lblbis[iCntLblbis].Font;
                  lblbis[iCntLblbis].Width := 4 + canvas.TextWidth(lblbis[iCntLblbis].Caption);
                  canvas.Font := lfont;
                  lblbis[iCntLblbis].Parent := sbx_ZusFeld;
                  inc(iCntLblbis);

               end
               else

               if    (lTyp = zfld07_FliessKomma)
                  or (lTyp = zfld08_Waehrung   )
               then
               begin
                  // set just the proper length     (+2 cause there is always 2 date boxes)
                  SetLength(ldouble, iCntdouble + 2);

                  ldouble[iCntdouble] := TjvSpinEdit.Create(sbx_ZusFeld);
                  ldouble[iCntdouble].Name := 'zedt_Tmp' + IntToStr(iC);
                  ldouble[iCntdouble].Hint :=
                     _('Hier knnen Sie im Feld') + ' ' + #34 +
                     FieldByName('Disp_Name').AsString + #34 + ' ' + _('suchen');
                  ldouble[iCntdouble].ShowHint := false;
                  ldouble[iCntdouble].Left := 8 + liprefix;
                  ldouble[iCntdouble].Top := 21 + (38 * iC);
                  ldouble[iCntdouble].Height := 21;
                  ldouble[iCntdouble].Width := dtp_SVon.Width;
                  ldouble[iCntdouble].Anchors := [akLeft, akTop];
                  ldouble[iCntdouble].OnKeyUp := EnableSaveOnKeyUp;
                  ldouble[iCntdouble].OnKeyDown := DoSearchOnenter;
                  ldouble[iCntdouble].OnChange := EnableSaveOnChange;
                  ldouble[iCntdouble].OnClick := BtnEnableSave;
                  ldouble[iCntdouble].Tag := FieldByName('Mode').AsInteger;

                  lAddField.FieldName := FieldByName('Feld_Name').AsString;
                  lAddField.CompName := ldouble [iCntdouble].Name;
                  lAddField.ContOld  := ldouble [iCntdouble].Text;

                  if lTyp = zfld07_FliessKomma then
                  begin
                     ldouble[iCntdouble].Decimal := 10;
                  end
                  else
                  begin
                     ldouble[iCntdouble].Decimal := 2;
                  end;
                  ldouble[iCntdouble].ValueType := vtFloat;
                  ldouble[iCntdouble].Parent := sbx_ZusFeld;
                  if gai_cfg_rights[iC] then
                  begin
                     ldouble[iCntdouble].color := clwhite;
                  end
                  else
                  begin
                     ldouble[iCntdouble].color := cColorNoRightInit;
                  end;

                  Inc(iCntdouble, 1);

                  ldouble[iCntdouble] := TjvSpinEdit.Create(sbx_ZusFeld);
                  ldouble[iCntdouble].Name := 'zedt_Tmp_og_' + IntToStr(iC);
                  ldouble[iCntdouble].Hint :=
                     _('Geben Sie bitte die obere Grenze fr die Datumssuche ein');
                  ldouble[iCntdouble].ShowHint := True;
                  ldouble[iCntdouble].Anchors := [akTop, akleft, akright];
                  ldouble[iCntdouble].Top := 21 + (38 * iC);
                  ldouble[iCntdouble].OnKeyUp := EnableSaveOnKeyUp;
                  ldouble[iCntdouble].OnKeyDown := DoSearchOnenter;
                  ldouble[iCntdouble].OnChange := EnableSaveOnChange;
                  ldouble[iCntdouble].Width := ldouble[iCntdouble - 1].Width;
                  ldouble[iCntdouble].Height := 21;
                  ldouble[iCntdouble].Left :=
                     sbx_ZusFeld.Width - 39 - ldouble[iCntdouble].Width - liscroll;
                  ldouble[iCntdouble].Anchors := [akright, aktop];
                  ldouble[iCntdouble].OnClick := BtnEnableSave;
                  ldouble[iCntdouble].Tag := FieldByName('Mode').AsInteger;

                  if ityp = 7 then
                  begin
                     ldouble[iCntdouble].Decimal := 10;
                  end
                  else
                  begin
                     ldouble[iCntdouble].Decimal := 2;
                  end;
                  ldouble[iCntdouble].ValueType := vtFloat;
                  ldouble[iCntdouble].Parent := sbx_ZusFeld;

                  if gai_cfg_rights[iC] then
                  begin
                     ldouble[iCntdouble].color := clwhite;
                  end
                  else
                  begin
                     ldouble[iCntdouble].color := cColorNoRightInit;
                  end;
                  //bis label:
                  SetLength(lblbis, iCntLblbis + 1);

                  lblbis[iCntLblbis] := TJvStaticText.Create(sbx_ZusFeld);
                  lblbis[iCntLblbis].Name := 'zlblbis_Tmp' + IntToStr(iC);
                  lblbis[iCntLblbis].Caption := lsdat2 + ':';
                  lblbis[iCntLblbis].Hint := FieldByName('Feld_Name').AsString;
                  lblbis[iCntLblbis].ParentShowHint := True;
                  lblbis[iCntLblbis].Anchors := [akTop, akright];
                  lblbis[iCntLblbis].Left := sbx_ZusFeld.Width - 39 - ldouble[iCntdouble].Width - liscroll;

                  Inc(iCntdouble, 1);

                  lblbis[iCntLblbis].Top := 8 + (38 * iC);
                  lblbis[iCntLblbis].Height := 13;

                  lfont := canvas.Font;
                  canvas.Font := lblbis[iCntLblbis].Font;
                  lblbis[iCntLblbis].Width := 4 + canvas.TextWidth(lblbis[iCntLblbis].Caption);
                  canvas.Font := lfont;
                  lblbis[iCntLblbis].Parent := sbx_ZusFeld;
                  inc(iCntLblbis);
                  //  zur Deaktivierung der dynamischen Erzeugung des Zusatzfeldes Datum hier Begin der Auskommentares
               end;
               //        lbl[iCntLbl].Parent := sbx_ZusFeld;
               // Die Komponenten erst am Schlu sichtbar machen
               if isVerschlagwortungsHilfe then
               begin
                  SetLength(chx, iCntchx + 1);
                  chx[iCntchx] := Tcheckbox.Create(sbx_ZusFeld);
                  chx[iCntChx].Name := 'zedt_Tmpchx' + IntToStr(iC);
                  chx[iCntchx].Left := 8;
                  chx[iCntchx].Top := 21 + (38 * iC);
                  chx[iCntchx].Height := 21;
                  chx[iCntchx].Width := (20);
                  chx[iCntchx].Anchors := [akLeft, akTop];
                  chx[iCntchx].Tag := FieldByName('Mode').AsInteger;
                  chx[iCntchx].Caption := '';
                  chx[iCntchx].Parent := sbx_ZusFeld;
                  chx[iCntchx].TabStop := false;
                  inc(iCntchx, 1);

                  SetLength(tbxb, iCnttbxb + 1);
                  tbxb[iCnttbxb] := TTBXButton.Create(sbx_ZusFeld);
                  tbxb[iCnttbxb].Name := 'zedt_Tmptbxb' + IntToStr(iC);

                  tbxb[iCnttbxb].Left := sbx_ZusFeld.Width - 20 - liscroll;  //  22.06.2010  r.sch.
                  tbxb[iCnttbxb].Top := 22 + (38 * iC);
                  tbxb[iCnttbxb].Height := 21;
                  tbxb[iCnttbxb].Width := (15);
                  tbxb[iCnttbxb].Anchors := [akRight, akTop];
                  tbxb[iCnttbxb].Tag := FieldByName('Mode').AsInteger;
                  tbxb[iCnttbxb].Caption := '';
                  tbxb[iCnttbxb].hint := FieldByName('Feld_Name').AsString;
                  tbxb[iCnttbxb].showhint := false;
                  tbxb[iCnttbxb].Onclick := dm_MainForm2.Searchzusfield;
                  tbxb[iCnttbxb].Images := dm_Shared.il_ShScroll; //dm_MainForm2.jil_Scroll;
                  tbxb[iCnttbxb].ImageIndex := 1;
                  tbxb[iCnttbxb].TabStop := false;

                  tbxb[iCnttbxb].Parent := sbx_ZusFeld;

                  inc(iCnttbxb, 1);
               end;
               Inc(iCntLbl, 1);
               dm_DB.my_q_CreZusFields.Next;
            end;

            if gLocalLog then
              GgfLogEvnt (#13+#10+lArchiv.AddFieldTab.List);

            if isVerschlagwortungsHilfe then
            begin
               tbbt_search.visible := true;
               tbxb_reset.visible := true;

               tbbt_search.Top := 21 + (40 * RecordCount);  //  22.06.2010  r.sch.
               tbxb_reset .Top := 21 + (40 * RecordCount);  //  22.06.2010  r.sch.

            end;
            sbx_ZusFeld.Realign;

         except
            on e: Exception do
            begin
               ErrorMsg('CreZusFields',
                  _('Fehler beim dynamischen Erzeugen der Zusatzfelder:') +
                  e.Message + #13 +
                  _('Bitte beenden Sie die Anwendung und starten diese erneut!'),
                  2000,
                  True);
               Result := 0;
               dm_DB.my_q_CreZusFields.Close;
            end;
         end;
      end;

      dm_DB.my_q_CreZusFields.Close;
   finally
      begin
         sbx_ZusFeld.visible := true;
      end;
   end;

   GgfLogEvntEnd ('Tfrm_MainForm.CreZusFields Ende');
end;


//  zusatz felder loeschen
function Tfrm_MainForm.DelZusFields2(fbrdbgrd: boolean): integer;
var
   lcomp: Tcomponent;
begin
   GgfLogEvntBeg ('DelZusFields2 Begin, sbx_ZusFeld.ComponentCount = '
                            + IntToStr (sbx_ZusFeld.ComponentCount));
   Result := 0;

   setlength(gai_cfg_rights, 0);

   if sbx_ZusFeld.ComponentCount = 0 then
   begin
     GgfLogEvntEnd ('DelZusFields2 End via Exit');
     exit;
   end;

   try
      while sbx_ZusFeld.ComponentCount > 0 do
      begin
         lcomp := sbx_ZusFeld.Components[0];
         Freeandnil(lcomp);
         Inc(Result, 1);
      end;
      // if lfedt istn set to nil then it is
      ZusFldFrame := nil;
      if fbrdbgrd then
      begin
         CreateStandardColumnsTRefferliste;
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('DelZusFields2', _('Fehler beim Entfernen der Zusatzfelder:') +
            e.Message, 2006, True);
         Result := 0;
      end;
   end;

   GgfLogEvntEnd ('DelZusFields2 End');
end;

function Tfrm_MainForm.ClearZusFields: boolean; //3.5.0.22
var
   iCount, li: integer;
   lbr: boolean;
   ls: string;
   xComp : TComponent;
   Combo: TComboBox;
   FrameZusFldMulti: TFrameZusFldMulti;
   xIsVerschlagwortungsHilfe: Boolean;

begin
   GgfLogEvntBeg ('ClearZusFields Begin');

   Result                    := False;
   xIsVerschlagwortungsHilfe := tbxb_reset.Visible;

   if xIsVerschlagwortungsHilfe then  //  09.07.2010  r.sch.
   begin
     //  Die Verschlagwortungshilfe ist aktiv!
     //  Da die Komponenten verndert worden sind, mssen sie abgerumt und
     //  neu aufgebaut werden.

     CreZusFields  (not xIsVerschlagwortungsHilfe);  //  soll ja initialisiert werden
     GgfLogEvntEnd ('ClearZusFields End wegen VerschlagwortungsHilfe');
     Exit;
   end;

   if sbx_ZusFeld.ComponentCount = 0 then
   begin
     GgfLogEvntEnd ('ClearZusFields End: Keine Zusatzfelder');
     Exit;
   end;

   gbFillZusfields := True;
	try
      try
         for iCount := 0 to sbx_ZusFeld.ComponentCount - 1 do
         begin
            lbr   := true;
            xComp := sbx_ZusFeld.Components[iCount];  //3.5.0.22

            if xComp is TFrameZusFldMulti then //3.5.0.22
               with xComp as TFrameZusFldMulti do
               begin
                  FrameZusFldMulti := xComp as TFrameZusFldMulti;
                  xComp := FrameZusFldMulti.ComboBox;
               end;

            if xComp is TEdit then
               with xComp as TEdit do
               begin
                  Text := '';
                  if gbcfgxs then
                  begin
                     ls := copy(TEdit(xComp).name, length('zedt_Tmp') + 1,
                        length(TEdit(xComp).name) - length('zedt_Tmp'));
                     try
                        li := strtoint(ls);
                     except on e: exception do
                        begin
                        end;
                     end;
                     lbr := gai_cfg_rights[li];
                  end;
                  if lbr then
                  begin
                     Color := clWhite;
                  end
                  else
                  begin
                     color := cColorNoRightInit;
                  end;
               end;
            if xComp is Tjvspinedit then
               with xComp as Tjvspinedit do
               begin
                  Text := '';
                  if gbcfgxs then
                  begin
                     ls := copy(TEdit(xComp).name, length('zedt_Tmp') + 1,
                        length(TEdit(xComp).name) - length('zedt_Tmp'));
                     if not trystrtoint(ls, li) then
                     begin
                        ls := copy(TJvDateEdit(xComp).name, length('zedt_Tmp_og_') + 1,
                           length(TJvDateEdit(xComp).name) - length('zedt_Tmp_og_'));
                        trystrtoint(ls, li);
                     end;
                     lbr := gai_cfg_rights[li];
                  end;
                  if lbr then
                  begin
                     Color := clWhite;

                  end
                  else
                  begin
                     color := cColorNoRightInit;
                  end;
               end;
            if xComp is TSpinEdit then
               with xComp as TSpinEdit do
               begin
                  Text := '';
                  if gbcfgxs then
                  begin
                     ls := copy(TSpinEdit(xComp).name, length('zedt_Tmp') + 1,
                        length(TSpinEdit(xComp).name) - length('zedt_Tmp'));
                     try
                        li := strtoint(ls);
                     except on e: exception do
                        begin
                        end;
                     end;
                     lbr := gai_cfg_rights[li];
                  end;
                  if lbr then
                  begin
                     Color := clWhite;

                  end
                  else
                  begin
                     color := cColorNoRightInit;
                  end;
                  Tag := (Tag and 3);
               end;
            if xComp is TJvDateEdit then
               with xComp as TJvDateEdit do
               begin
                  Text := '';
                  if gbcfgxs then
                  begin
                     //        if pos
                     ls := copy(TJvDateEdit(xComp).name, length('zedt_Tmp') + 1,
                        length(TJvDateEdit(xComp).name) - length('zedt_Tmp'));
                     if not trystrtoint(ls, li) then
                     begin
                        ls := copy(TJvDateEdit(xComp).name, length('zedt_Tmp_og_') + 1,
                           length(TJvDateEdit(xComp).name) - length('zedt_Tmp_og_'));
                        trystrtoint(ls, li);
                     end;
                     lbr := gai_cfg_rights[li];
                  end;
                  if lbr then
                  begin
                     Color := clWhite;
                  end
                  else
                  begin
                     color := cColorNoRightInit;
                  end;
                  Tag := (Tag and 3);
               end;
            if xComp is TComboBox then
            begin
               Combo := TComboBox(xComp);

               Combo.ItemIndex := indexOf ('', Combo.Items);  //  30.06.2010  Vers. 3.5.0.86  [2636]  r.sch.
            
               with Combo do
               begin
                  if gbcfgxs then
                  begin
                     if pos('_cbx_', Combo.name) > 0 then
                     begin
                        ls := copy(Combo.name, length('zedt_Tmp_cbx_') + 1,
                           length(Combo.name) - length('zedt_Tmp_cbx'));
                     end
                     else
                     begin
                        ls := copy(Combo.name, length('zedt_Tmp') + 1,
                           length(Combo.name) - length('zedt_Tmp'));
                     end;
                     try
                        li := strtoint(ls);
                     except on e: exception do
                        begin
                        end;
                     end;
                     lbr := gai_cfg_rights[li];
                  end;
                  if lbr then
                  begin
                     Color := clWhite;
                  end
                  else
                  begin
                     color := cColorNoRightInit;
                  end;
                  Tag := (Tag and 3);
               end;
            end;
            if xComp is TjvCheckedComboBox then
            begin
               with xComp as TjvCheckedComboBox do
               begin
                  ClearSelection;
                  SetUnCheckedAll;
                  //          TjvCheckedComboBox(xComp01).Clear;
                  if gbcfgxs then
                  begin
                     ls := copy(TjvCheckedComboBox(xComp).name, length('zedt_Tmp') + 1,
                        length(TjvCheckedComboBox(xComp).name) - length('zedt_Tmp'));
                     try
                        li := strtoint(ls);
                     except on e: exception do
                        begin
                        end;
                     end;
                     lbr := gai_cfg_rights[li];
                  end;
                  if lbr then
                  begin
                     noFocusColor := clWhite;

                  end
                  else
                  begin
                     noFocusColor := cColorNoRightInit;
                  end;
                  Modified := False;
                  tag := Tag or 4;
               end;
            end;
            if xComp is TJvgCheckBox then
            begin
               with xComp as TJvgCheckBox do
               begin
                  checked := true;
                  Enabled := True; //[2494]
               end;
            end;
         end;
      except
         on e: Exception do
         begin
            GgfLogEvnt ('ClearZusFields Exception Meldung:' +#13+#10 + e.Message);

            ErrorMsg('ClearZusFields', 'Fehler beim Entfernen der Zusatzfelder:' +
               e.Message, 2006, True);
         end;
      end;
   	Result := True;
   finally
   	gbFillZusfields := False;
	end;
   GgfLogEvntEnd ('ClearZusFields End');
end;


function Tfrm_MainForm.ClearZusFieldsNotsearched: boolean;
var
   iCount: integer;
begin
   GgfLogEvnt('ClearZusFieldsNotsearched');
   Result := False;
   if sbx_ZusFeld.ComponentCount = 0 then
      exit;

   gbFillZusfields := True;
	try
      try
         for iCount := 0 to (sbx_ZusFeld.ComponentCount - 1) do
         begin
            if sbx_ZusFeld.Components[iCount] is TEdit then

               with sbx_ZusFeld.Components[iCount] as TEdit do
               begin
                  if Color = clwhite then
                     Text := '';
               end;
            if sbx_ZusFeld.Components[iCount] is TJvDateEdit then
               with sbx_ZusFeld.Components[iCount] as TJvDateEdit do
               begin
                  if Color = clwhite then
                  begin
                     Text := '';
                  end;
               end;
            if sbx_ZusFeld.Components[iCount] is TComboBox then
            begin
               with sbx_ZusFeld.Components[iCount] as TComboBox do
               begin
                  if Color = clwhite then
                  begin
                     Text := '';
                  end;
               end;
            end;

            if sbx_ZusFeld.Components[iCount] is TjvCheckedComboBox then
            begin
               with sbx_ZusFeld.Components[iCount] as TjvCheckedComboBox do
               begin
                  if color = clwhite then
                  begin
                     Clear;
                     noFocusColor := clwhite;
                     Modified := False;
                     tag := Tag or 4;
                  end;
               end;
            end;
         end;
      except
         on e: Exception do
         begin
            ErrorMsg('ClearZusFieldsNotsearched', 'Fehler beim Entfernen der Zusatzfelder:' +
               e.Message, 2006, True);
         end;
      end;
      Result := True;
   finally
   	gbFillZusfields := False;
	end;
end;

procedure Tfrm_MainForm.ReadCbxUsrNG;
begin
   GgfLogEvnt('ReadCbxUsrNG');

   if TmpSQL(
      'Select Sql_No_cache sql_no_cache * from sys_usr where flags = 1 order by usr_name') //sys_usr.Flags
   then
   begin
      try
         cbx_SUsr.Items.Clear;
         cbx_SUsr.Items.AddObject(_('alle Benutzer'), TObject(0));
         with dm_DB.my_q_Tmp do
            while not EOF do
            begin
               if cbx_SUsr.Items.IndexOf(FieldByName('usr_name').AsString) = -1 then
                  cbx_SUsr.Items.AddObject(FieldByName('usr_name').AsString,
                     TObject(FieldByName('usr_ID').AsInteger));
               Next;
            end;
      except
         on e: Exception do
            ErrorMsg('ReadCbxUsr', _('Fehler beim Auslesen aller Benutzer:') +
               e.Message, 2015, True);
      end;
   end
   else
      ErrorMsg('ReadCbxUsr', _('Fehler bei Select Sql_No_cache Anweisung!'),
         2002,
         True);
   dm_DB.my_q_Tmp.Close;
end;

function Tfrm_MainForm.ArcSQL(SQLCMD: string): boolean;
begin
   GgfLogEvnt('ArcSQL');
   if dm_DB.my_q_Arc.Active then
	   dm_DB.my_q_Arc.Close;
   dm_DB.my_q_Arc.SQL.Text := SQLCMD;
   dm_DB.my_q_Arc.Open;
   Result := True;
end;

function Tfrm_MainForm.LgrArcSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_LgrArc,SQLCMD);
end;

function Tfrm_MainForm.LnkSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_Lnk,SQLCMD);
end;

function Tfrm_MainForm.TmpSysArcSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_sysarc,SQLCMD);
end;

function Tfrm_MainForm.TmpSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_Tmp,SQLCMD);
end;

function Tfrm_MainForm.TmpSQL_2(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_tmp_2,SQLCMD);
end;

function Tfrm_MainForm.TmpMoveSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_Move,SQLCMD);
end;

function Tfrm_MainForm.HistSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_Hst,SQLCMD);
end;

function Tfrm_MainForm.DocShowTmpSQL(SQLCMD: string): boolean;
begin
   Result:=DbDoSkySQL(dm_db.my_q_DocShowTmp,SQLCMD);
end;


procedure Tfrm_MainForm.ShowLgrArc;
var
   lileft: integer;
begin
   GgfLogEvnt('ShowLgrArc');
   lileft := TBXMultiDock1.Left;
   if dpnl_LgrArc.Visible then
   begin
      mnu_VisLgrArc.Checked := False;
      tbi_VisLgrArc.Checked := False;
      dpnl_LgrArc.Visible := False;
   end
   else
   begin
      mnu_VisLgrArc.Checked := True;
      tbi_VisLgrArc.Checked := True;
      dpnl_LgrArc.Visible := True;
   end;
   tbsi_VZoomClick(Self);
   TBXMultiDock1.left := lileft;
   TBXMultiDock1.left := 0; //3.5.0.57 [1621]
end;

procedure Tfrm_MainForm.ShowThumbs;
begin
   GgfLogEvntBeg('ShowThumbs - begin');
   if dpnl_Thumbs.Visible then
   begin
      mnu_VisThumbs.Checked := False;
      tbi_VisThumbs.Checked := False;
      dpnl_Thumbs.Visible := False;
   end
   else
   begin
      //      tmb_Voransicht.Clear;
      mnu_VisThumbs.Checked := True;
      tbi_VisThumbs.Checked := True;
      dpnl_Thumbs.Visible := True;
      LoadThumbs(0, true);
   end;
   tbsi_VZoomClick(Self);
   GgfLogEvntEnd('ShowThumbs - end');
end;

procedure Tfrm_MainForm.LoadThumbs(fipage: integer; fbreset: boolean);
begin
   GgfLogEvntBeg('LoadThumbs - begin');

   if gbSaveDoc or fra_Voransicht.fsavingobjs then
   	Exit;

   if thr_voransicht = nil then
   begin
      // create thread
      if fipage > 0 then
      begin
         thr_voransicht := TTvoransicht.Create(True);
         thr_voransicht.pipage := fipage;
         thr_voransicht.pbcontinuetoload := True;
         thr_voransicht.FreeOnTerminate := false;
         thr_voransicht.resume;
      end
      else
      begin
         //3.5.0.25
         //[ 2358 ] Nach Einblendung Miniaturansicht falsche Seite
         if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count > 0 then
         //\\3.5.0.25
         begin
            thr_voransicht := TTvoransicht.Create(False);
            thr_voransicht.pbcontinuetoload := not fbreset;
         end;
      end;
   end
   else
   begin
      // demand terminate
      try
         thr_voransicht.terminate;
         // wait for terminate, it should just take the moment of a
         try
            //    OutPutdebugstring(pchar(inttostr(thr_voransicht.handle)));
            thr_voransicht.waitfor;
         except on e: exception do
            begin
            end;
         end;
      finally
         begin
            FreeAndNil(thr_voransicht);
         end;
      end;
      if fbreset then
      begin
         setlength(GaiPagesSelectedtmb, 0);
      end;
      if fipage > 0 then
      begin
         thr_voransicht := TTvoransicht.Create(True);
         thr_voransicht.pipage := fipage;

      end
      else
      begin
         thr_voransicht := TTvoransicht.Create(true);
      end;
      thr_voransicht.pbcontinuetoload := not fbreset;
      thr_voransicht.FreeOnTerminate := false;
      thr_voransicht.resume;
   end;
   GgfLogEvntEnd('LoadThumbs - end');
end;

// Showframe
procedure Tfrm_MainForm.ShowFrame(frame: integer);
begin
   GgfLogEvnt('ShowFrame');
   if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveObjects(False,False);
   if (fiframe = 1) and (frame <> fiframe) then
   begin
      fra_Voransicht.img_DocView.CancelInteracts;
   end;

   fra_Voransicht.Visible := False;
   fra_Nix.Visible := False;
   fra_DocLink.Visible := False;
   fra_History.Visible := False;
   fra_Volltext.Visible := False;
   fiframe := frame;
   case frame of
      sfVoransicht:
      begin
         fra_Voransicht.Visible := True;
      end;
      sfVolltext:
      begin
         fra_Volltext.Visible := True;
         fra_Volltext.redt_Volltext.setfocus;
      end;
      sfDocLink:
      begin
         fra_DocLink.Visible := True;
      end;
      sfHistory:
      begin
         fra_History.Visible := True;
      end;

      sfNix:
      begin
         fra_Nix.Visible := True;
      end;
 
   end;
end;

procedure Tfrm_MainForm.HandleDoc;
//////////////////////////////////////////////////////////////////
///  Grafische Darstellung des Dokumentes                      ///
///  09.05.2005 Erstellt (SV)                                  ///
///  Imageenview mit den Parametern fhrt das anzuzeigenden Do ///
///  kument starten.
///  Diese Procedure setzt globale Variablen und startet dann  ///
///  die aktiven Anzeige-Proceduren                            ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   nFiletype: string;
   inworkbywvl: boolean;
   lidoc_state, licount, liImage: integer;
   liarcid, lidocid, liGDocId: int64;
   lsOriLoc, lsDocLoc, lsExtLoc, lsSha1Doc, lsSha1Org, lsSha1Dat: string;
   AktDocViewSave: TDocViewSave;
   procedure DoThumbs;
   begin
      GgfLogEvntBeg('DoThumbs Visible:'+IntToStr(ord(frm_mainform.dpnl_Thumbs.Visible)));
      if frm_mainform.dpnl_Thumbs.Visible then
      begin
         frm_mainform.loadthumbs(0, true);
      end;
   end;
begin
  GgfLogEvntBeg('HandleDoc begin');

  if gbBlockVoransicht then
     GgfLogEvntBeg('HandleDoc gbBlockVoransicht=true');

	try
      if dm_DB.fbtimansicht and gbansichtlesen then
      begin
         fra_voransicht.img_DocView.IO.Aborting := true;
         bGImageDisp := false;
         exit;
      end;
      inworkbywvl := False;
      gbsearched := True;
      fdocinusrwvl := False;
      if gbArcHandling = False then
      begin
         gbArcHandling := True;
         if not dm_DB.my_ConArc.Connected then
         begin
            gbArcHandling := False;
            gbwvlcellclick := False;
            exit;
         end;
         // Exit wenn keine Verbindung zum MYSQL besteht
         try
            with dm_DB.my_q_Arc do
            begin
               if RecordCount = 0 then
               begin
                  if thr_voransicht <> nil then
                     thr_voransicht.Terminate;
                  dm_MainForm2.tim_Blank.Enabled := True;
                  fra_Volltext.redt_Volltext.Clear;
                  sleep(30);
                  if thr_voransicht <> nil then
                  begin
                     try
                        thr_voransicht.WaitFor;
                     except
                        on e: Exception do
                        begin
                        end;
                     end;
                  end;
                  frm_MainForm.tmb_Voransicht.LockPaint;
                  frm_MainForm.tmb_Voransicht.Deselect;
                  frm_MainForm.tmb_Voransicht.Clear;
                  frm_MainForm.tmb_Voransicht.unLockPaint;
                  gbArcHandling := False; 
                  gbwvlcellclick := False;
                  exit;
               end;

               if ((RecNo = iGArcRecNo)) then
               begin
                  if bmultiarcquery then
                  begin
                     if (igarcid = dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger) and
                        (dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger = iGdocID) then
                     begin
                        gbArcHandling := False; 
                        gbwvlcellclick := False;
                        //        OUtputdebugstring(PChar('exiting in handledoc '));
                        exit;
                     end;
                  end
                  else
                  begin
                     if (dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger = iGdocID) then
                     begin
                        gbArcHandling := False;
                        gbwvlcellclick := False;
                        //        OUtputdebugstring(PChar('exiting in handledoc '));
                        exit;
                     end;
                  end;
               end;

               if fra_Voransicht.gbAnnoNotSaved then
                  fra_voransicht.saveobjects(False, False);

               if GHasNotBeenSavedAfterModify or ((gtmpiStatus xor gotmpistatus) > 0) then
               begin
                  if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
                     #13 + _('Mchten Sie die nderungen speichern?'),
                     True) = mrYes then
                  begin
                     gbArcHandling := False;     //Test
                     tbi_VSaveDocClick(self);
                  end;
                  GHasNotBeenSavedAfterModify := False;
                  gtmpiStatus := gotmpistatus;
                  btn_SaveDoc.Enabled := false;
                  tbi_VSaveDoc.Enabled := True;
                  fgchangedvoransicht := false;
                  fgchangedvoransichttif := False;
               end;

               dm_db.my_q_Arc.RefreshRecord;

               if BM1 = nil then
                  BM1 := dbgrd_trefferliste.DataSource.DataSet.GetBookmark;
               frm_MainForm.pnl_docTime.Color := clred;
               pnl_doctime.Caption := 'Laden';
               //only when visible cancelinteracts, else it should be caught earlier
               if fra_Voransicht.Visible then
               begin
                  fra_Voransicht.img_DocView.CancelInteracts;
               end;

               dm_MainForm2.tim_docload.Enabled := True;
               iGdocidtmp := iGdocid;
               iGarcidtmp := iGarcid;
               fsinfo := '';
               iGArcRecNo := RecNo; // Aus KeyUp Event von dbgrd_Trefferliste
               tbi_VSaveDoc.Enabled := False;
               btn_SaveDoc.Enabled := False;
               tbi_VSaveDoc.Enabled := false;

               fgchangedvoransicht := false;
               fgchangedvoransichttif := False;
               if not bGImageDisp then
               begin
                  fra_Voransicht.img_DocView.IO.Aborting := True;
                  tmb_Voransicht.MIO.Aborting := True;
                  bGImageDisp := True;
                  gbArcHandling := False; 
                  gbwvlcellclick := False;
                  exit;
               end;
               iGBorderRem := 1;
               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  gbwvlcellclick := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;
               iGDocID := FieldByName('doc_id').AsInteger;

               lsOriLoc := FieldByName('ori_loc').AsString;
               lsDocLoc := FieldByName('doc_loc').AsString;
               lsExtLoc := FieldByName('ext_loc').AsString;
               if (sGSha1ErrorMsg>'') then
               begin
                  try
                     lsSha1Org := FieldByName('SHA1').AsString;
                  except
                     on e:Exception do
                        LogEvnt('4200    ' + _('Fehler') + ' in Modul: Tfrm_MainForm.HandleDoc ' + e.Message);
                  end;
               end;

               fra_Voransicht.fphistorymessage := '';

               //  Dokument Informationen in der Status zeile ausgeben
               //  Statuszeile
               tbx_privNote.Checked := False;
               tbx_pubNote.Checked := True;

               if lsOriLoc <> '' then
                  nFiletype := ExtractFileExt(lsOriLoc)
               else
               if lsDocLoc <> '' then
               begin
                  nFiletype := ExtractFileExt(lsDocLoc);
               end;


               sgdocfilename := FieldByName('doc_loc').AsString;
               sgextfilename := FieldByName('ext_loc').AsString;
               if ((bMultiArcQuery) and (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)) then
               begin
                  iGArcID := FieldByName('Arc_ID').AsInteger;
                  sIArcName := FieldByName('TblName').AsString;
                  stb_Main.Hint :=
                     _('Archiv:') + ' ' + FieldByName('ArcName').AsString + #13 +
                     _('Dokument:') + ' ' + FieldByName('Disp_Name').AsString + #13 +
                     _('Datum:') + ' ' + FieldByName('TStamp').AsString + #13 +
                     _('Gre:') + ' ' + GetFileSizeStr(FieldByName('doc_loc').AsString) +
                     #13 + _('Dateityp:') + ' ' + nFileType;
               end
               else
               begin
                  stb_Main.Hint :=
                     _('Archiv:') + ' ' + sGArcName + #13 + _('Dokument:') + ' ' +
                     FieldByName('Disp_Name').AsString + #13 + _('Datum:') + ' ' +
                     FieldByName('TStamp').AsString + #13 + _('Gre:') + ' ' +
                     GetFileSizeStr(FieldByName('doc_loc').AsString) +
                     #13 + _('Dateityp:') + ' ' + nFileType;
               end;
               for licount := 0 to stb_main.Panels.Count - 1 do
               begin
                  SetStatusHint(licount, stb_Main.Hint);
               end;

               gi64docrev := -1;
               gshardlarcname := SIarcname;
               if gbhasgdocid and (not gbkleiner3400) then
               begin
                  ftci_InUseonceclicked := false;
                  if dm_db.my_q_Arc.FieldDefList.Find('gdoc_id') <> nil then
                  begin
                     giglobalgdocid := FieldByName('gdoc_id').AsInteger;
                  end;
               end;
               // save names for merge revisionssicher documents
               stempselecteditem := ssomeselecteditem;
               ssomeselecteditem := FieldByName('Disp_Name').AsString;

               liGDocId := GDocIdAnhandArcDocId(iGArcID,iGDocID);

               SetStatusText(cStatusPanelDoc,
                    IntToStr(iGArcID) + '.' + IntToStr(iGDocID)
                    + cStatusPanelDocIdTrennzeichen
                    + IntToStr(liGDocId));
               frm_mainform.setpanelinfo(
                  StringReplace(stb_Main.Hint, chr(13), ' - ', [rfReplaceAll]));
               dm_MainForm2.gsstatustext := GetStatusText(cStatusPanelInfo); //3.5.0.25

               dm_db.my_q_Tmp.SQL.Text :=
                  'select * from sys_timer where doc_id=' + IntToStr(igdocid) +
                  ' and arc_id=' + IntToStr(igarcid) + ' and status <> 2 ';
               dm_db.my_q_Tmp.Execute;

               if dm_db.my_q_Tmp.RecordCount > 0 then
               begin
                  dm_db.my_q_Tmp.SQL.Text :=
                     'select * from sys_timer where doc_id=' + IntToStr(igdocid) +
                     ' and arc_id=' + IntToStr(igarcid) +
                     ' and status <> 2 and usr_id_work =' + IntToStr(iGUsrID);
                  dm_db.my_q_Tmp.Execute;
                  if (frm_MainForm.reset) then
                  begin
                     gbArcHandling := False;
                     gbwvlcellclick := False;
                     frm_MainForm.reset := False;
                     resetmyqarc;
                     exit;
                  end;
                  if dm_db.my_q_Tmp.RecordCount > 0 then
                  begin
                     tbi_wvldoc.Enabled := True;
                     dm_MainForm2.mnu_gototimid.Visible := true;
                  end
                  else
                  begin
                     tbi_wvldoc.Enabled := False;
                     dm_MainForm2.mnu_gototimid.Visible := false;
                  end;
                  inworkbywvl := True;
               end;
               // todo handle doc is called from a thread
               // so give dm_db.MyQNog01 a connection or use my_q_wvl or my_q_arc for it!
               // dont go in if editdoc is open, since it could cause a timeout! (doceditor is modal)
               if gbeditdoc or frm_MainForm.reset then
               begin
                  gbArcHandling := False;
                  gbwvlcellclick := False;
                  frm_MainForm.reset := False;
                  gbeditdoc := false;
                  pnl_docTime.Caption := '';
                  dm_MainForm2.tim_docload.Enabled := False;
                  pnl_docTime.ParentBackground := True;
                  pnl_docTime.Color := pnl_SuchOpt.Color;
                  if frm_MainForm.reset then
                  begin
                     resetmyqarc;
                  end;
                  exit;
               end;

               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  gbwvlcellclick := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;
               try
                  lidoc_state := FieldByName('doc_state').AsInteger;
               except
                  on e: Exception do
                  begin
                     gbArcHandling := False;
                     gbwvlcellclick := False;
                     frm_MainForm.reset := False;
                     resetmyqarc;
                     exit;
                  end;
               end;
               dm_MainForm2.GetListOfPrivatAnnos;
               if ((lidoc_state and 1) = 1) or (inworkbywvl = True) then
               begin
                  tci_InUse.Color := clLime;   GgfLogEvnt('tci_InUse.Color := cllime [3]');
                  tci_InUse.Hint :=
                     _('Das Dokument befindet sich noch in Bearbeitung');
                  tci_InUse.Tag := 1;
                  dm_MainForm2.mnu_TEndWorkflow.Enabled := True;
               end
               else
               begin
                  if tci_InUse.Color <> clRed then
                  begin
                     tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [4]');
                  end;
                  tci_InUse.Hint := '';
                  tci_InUse.Tag := 0;
                  dm_MainForm2.mnu_TEndWorkflow.Enabled := False;
               end;

               GgfLogEvnt('Tfrm_MainForm.HandleDoc - vor if (frm_MainForm.reset) then');
               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  gbwvlcellclick := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;
               if Fields.IndexOf(fields.FindField('ori_Loc')) <> -1 then
               begin
                  if FileExists(FieldByName('ori_Loc').AsString) then
                  begin
                     tci_OriFile.Color := clAqua;
                     tci_OriFile.Hint := _('Externes Dokument ffnen.');
                     tci_OriFile.Tag := 1;
                  end
                  else
                  begin
                     tci_OriFile.Color := clTeal;
                     tci_OriFile.Hint := _('Kein Externes Dokument vorhanden.');
                     tci_OriFile.Tag := 0;
                  end;
               end
               else
               begin
                  tci_OriFile.Color := clTeal;
                  tci_OriFile.Hint :=
                     _('Dieses Archiv hat keine Informationen ber externe Dokumente.');
                  tci_OriFile.Tag := 0;
               end;

               // auf Revisionssicherheit berprfen...
               if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0 then
               begin
                  dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
               end;
               if not frm_mainform.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected then
               begin
                  if iGArcRecNo <> dm_db.my_q_arc.RecNo then
                  begin
                     dm_db.my_q_Arc.GotoBookmark(
                        Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
                  end;
               end;

               if Pos(lowercase(sGArcPath), lowercase(ExtractFilePath(dm_DB.my_q_Arc.FieldByName('doc_loc').AsString))) = 1 then
               begin
                  img_Revision.Hint :=
                     _('Das Dokument ist revisionssicher abgelegt.');
                  dm_MainForm2.il_Standard.GetIcon(83, img_Revision.Picture.Icon);
                  tbi_VMakeRev.Enabled := False;
                  tbi_CopyDocToExt.Enabled := True;
               end
               else
               begin
                  img_Revision.Hint :=
                     _('Das Dokument ist noch nicht revisionssicher abgelegt.');
                  dm_MainForm2.il_Standard.GetIcon(84, img_Revision.Picture.Icon);
                  tbi_VMakeRev.Enabled := True;
                  tbi_CopyDocToExt.Enabled := False;
               end;


               // Benutzerrechte einlesen und verarbeiten
               // Rechte des Users am Dokument ermitteln
               // LINKS ( Verknpfungen )
               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  gbwvlcellclick := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;

               GetDocUsrRights(False);

               frm_mainForm.fra_Voransicht.fRights := rGDocRight;
			      frm_MainForm.fra_Voransicht.fPrivAnnoID := iGUsrID;

               fra_DocLink.GetQuickLinks;

               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  gbwvlcellclick := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;

               //  Verknpfungen
               with dm_MainForm2 do
               begin
                  if pum_Links.Items.Count > 0 then
                  begin
                     // wenn Verknuepfungen gefunden, dann wird die Anzahl der VK im Hint angezeigt.
                     //  Farbe der Verkuepfungslampe auf gelb einstellen

                     tci_DocLink.Color := clYellow;
                     if pum_Links.Items.Count = 1 then
                        tci_DocLink.Hint :=
                           S(_('Verknpfung gefunden<nl>Zu diesem Dokument gibt es<nl>eine Verknpfung.'))
                     else
                        tci_DocLink.Hint := Format(
                           S(_('Verknpfungen gefunden.<nl>Zu diesem Dokument gibt es <nl>%d Verknpfungen.')),
                           [pum_Links.Items.Count]);
                     dm_MainForm2.mnu_DocLinks.ImageIndex := 135;
                     dm_MainForm2.mnu_DocLinks.enabled := True;
                  end
                  else
                  begin
                     dm_MainForm2.mnu_DocLinks.enabled := False;
                     tci_DocLink.Color := clOlive;
                     tci_DocLink.Hint := _('keine Verknpfung vorhanden');
                  end;
               end;
            end;

            if (sbx_ZusFeld.ComponentCount > 0) then
            begin
               if bFillZusFields then
               begin
                  try
                     FillZusFields;
                  except on e: exception do
                     begin
                        gbArcHandling := False;
                        gbwvlcellclick := False;
                        frm_MainForm.reset := False;
                        resetmyqarc;
                        frm_mainform.dbgrd_Trefferliste.visible := true;
                        btn_ResFieldsClick(btn_ResFields);
                        exit;
                     end;
                  end;
               end;
            end
            else
            begin
               DelZusFields2(true);
               iGZusFCount := 0;
            end;

            if (frm_MainForm.reset) then
            begin
               gbArcHandling := False;
               gbwvlcellclick := False;
               frm_MainForm.reset := False;
               resetmyqarc;
               exit;
            end;

            if (tlb_Status.ComponentCount > 5) and bMultiArcQuery then
               DelStatus
            else
               ReadStatus;

            dm_MainForm2.tim_Blank.Enabled := False;
            igbrieflayer := 0;
            if tbi_VShowBrief.Checked and tbi_VShowBrief.enabled and
               (fra_Voransicht.img_DocView.LayersCount > 1) then
            begin
               if iGBriefLayers[0] > -1 then
               begin
                  fra_Voransicht.img_DocView.Layers[iGBriefLayers[0]].Visible := True;
               end;
            end;

            GgfLogEvnt('Tfrm_MainForm.HandleDoc -' +
                      ' bAutoPreview='   +BS(bAutoPreview) +
                      ' rGDocRight.Read='+BS(rGDocRight.Read) +
                      ' fshowwvldoc='    +BS(fshowwvldoc));

            if (bAutoPreview and rGDocRight.Read) or fshowwvldoc then //3.5.0.61
            begin
               tbi_docVoransicht.Checked := True;

               if thr_voransicht <> nil then
               begin
                  thr_voransicht.terminate;
               end;
               tbi_DocVoransichtClick(self);
            end
            else
            begin
               ShowVoransicht(True);
               if fra_voransicht.img_DocView.proc.CalcImageNumColors > 2 then
               begin
                  tbsi_VDeSpeckle.Enabled := False;
                  dm_MainForm2.mnu_TDeSpeckle.Enabled := False;
               end
               else
               begin
                  tbsi_VDeSpeckle.Enabled := True;
                  dm_MainForm2.mnu_TDeSpeckle.Enabled := True;
               end;
               if fra_Volltext.Visible then
               begin
                  ShowVolltext;
                  DoThumbs;
               end
               else
               if fra_DocLink.Visible then
               begin
                  ShowDocLink;
                  DoThumbs;
               end
               else
               if fra_History.Visible then
               begin
                  ShowHistory;
                  DoThumbs;
               end
               else
               begin
                  if tbi_DocVoransicht.Checked then
                  begin
                     ShowVoransicht(True);
                  end
                  else
                  if tbi_DocVolltext.checked then
                  begin
                     ShowVolltext;
                     DoThumbs;
                  end
                  else
                  if tbi_DocLink.checked then
                  begin
                     ShowDocLink;
                     DoThumbs;
                  end
                  else
                  if tbi_DocHistory.checked then
                  begin
                     ShowHistory;
                     DoThumbs;
                  end;
               end;
            end;

            GgfLogEvnt('sGSha1ErrorMsg:' + sGSha1ErrorMsg+ '   lsSha1Org:' + lsSha1Org);
            if (sGSha1ErrorMsg>'') then
            begin
               //3.5.0.60
               if (lsSha1Org>'') then
               try
                  GgfLogEvnt('sGSha1ErrorMsg:'+ sGSha1ErrorMsg);

                  //Prfsumme erstellen anhand der Datei im falls vorhanden ori_loc, sonst doc_loc
                  lsSha1Doc := lsOriLoc;
                  if lsSha1Doc='' then
                     lsSha1Doc := lsDocLoc;

                  if Pos( lowercase(sGArcPath),
                          lowercase(ExtractFilePath(lsSha1Doc))) = 1 then //nur wenn revisionssicher
                  begin
                     lsSha1Dat := GetSha1FromFile(lsSha1Doc);

                     if length(lsSha1Dat)<>40 then
                        LogEvnt(Format(_('Konnte Prfsumme von %s nicht ermitteln.'), [lsSha1Doc]))
                     else
                        if not FileExists(lsSha1Doc) then
                           ErrorMsg('Tfrm_MainForm.HandleDoc',
                              Format(_('Datei %s existiert nicht.'), [lsSha1Doc]) , 4002, True)
                        else
                        if lsSha1Dat <> lsSha1Org then
                            BfMessageDlg( //'Dokument falsch',
                               _('Das Dokument entspricht nicht dem Orginalzustand.\n')+sGSha1ErrorMsg,
                               mtError, [mbOK], 0);

                     GgfLogEvnt('sGSha1ErrorMsg:'+ sGSha1ErrorMsg);
                  end;
               except
                  on e: Exception do
                     LogEvnt('Error Sha1:' + e.message);
               end;
            end;

            if (frm_MainForm.reset) then
            begin
               gbArcHandling := False;
               gbwvlcellclick := False;
               frm_MainForm.reset := False;
               resetmyqarc;
               exit;
            end;

            // Briefpapier einlesen...
            if tbi_VShowBrief.Checked then
            begin
               if fra_Voransicht.img_DocView.LayersCount = 1 then
                  tbi_VShowBrief.Click
               else
               begin
                  fra_Voransicht.img_DocView.Layers[iGBriefLayers[iGBriefLayer]].Width :=
                     fra_Voransicht.img_DocView.Layers[0].Bitmap.Width;
                  fra_Voransicht.img_DocView.Layers[iGBriefLayers[iGBriefLayer]].Height :=
                     fra_Voransicht.img_DocView.Layers[0].Bitmap.Height;
                  fra_Voransicht.img_DocView.Update;
               end;
            end;
         finally
            pnl_Trefferliste.Enabled := True;
         end;

         if (frm_MainForm.reset) then
         begin
            gbArcHandling := False;
            frm_MainForm.reset := False;
            gbwvlcellclick := False;
            resetmyqarc;
            exit;
         end;
         tbxItem2.Caption := _('bitschubserei := false');
         dbgrd_Wvl.Enabled := True;

         if rGArcRight.hstprotoread then
         begin
            if TMPSQL('select * from hst_' + sIarcname + ' where doc_id = ' +
               IntToStr(igdocid) + ' and task_info like ' + #39 +
               _('User hat das Dokument') + ' ' + IntToStr(igarcid) + '.' + IntToStr(igdocid) +
               ' ' + _('gelesen. Userid:') + IntToStr(iGUsrID) + ' ' + _('Username:') + sGUsrName + #39) then
            begin
               if dm_db.my_q_tmp.RecordCount = 0 then
               begin
                  newhistory(24, _('User hat das Dokument') + ' ' + IntToStr(igarcid) + '.' +
                     IntToStr(igdocid) + ' ' + _('gelesen. Userid:') + IntToStr(iGUsrID) + ' ' + _('Username:') + sGUsrName);
               end;
            end
            else
            begin
               newhistory(24, _('User hat das Dokument') + ' ' + IntToStr(igarcid) + '.' +
                  IntToStr(igdocid) + ' ' + _('gelesen. Userid:') + IntToStr(iGUsrID) + ' ' + _('Username:') + sGUsrName);
            end;
         end;

         gbArcHandling := False;
//         dm_MainForm2.tim_voransicht.Enabled := true;

      end
      else
      begin
         fra_voransicht.img_DocView.IO.Aborting := true;
      end;
   finally
     AktDocViewSave.Doc.ArcId := igArcId;
     AktDocViewSave.Doc.DocId := igDocId;
     AktDocViewSave.Page := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageIndex;

     if (AktDocViewSave.Doc.ArcId <> gVorigesDocViewSave.Doc.ArcId)
     or (AktDocViewSave.Doc.DocId <> gVorigesDocViewSave.Doc.DocId)
     or (AktDocViewSave.Page      <> gVorigesDocViewSave.Page     )
     then
        begin
           gDocViewSaves[0] := gVorigesDocViewSave;
           gVorigesDocViewSave := AktDocViewSave;
        end;
     dbgrd_Trefferliste.LeftCol := giLeftCol;
     //giLeftCol := 1;
     GgfLogEvntEnd('HandleDoc end');
   end;
end;


procedure Tfrm_MainForm.mnu_VisLgrArcClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisLgrArcClick');
   ShowLgrArc;
end;

procedure Tfrm_MainForm.mnu_VisThumbsClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisThumbsClick');
   ShowThumbs;
end;

procedure Tfrm_MainForm.sbtn_RemThumbClick(Sender: TObject);
begin
   GgfLogEvnt('sbtn_RemThumbClick');
   ShowThumbs;
end;

procedure Tfrm_MainForm.ButtonsRechtsClick(Sender: TObject); //m.frey
begin
   // m.frey: Trotz setzen von GroupIndex geht das nicht automatisch
   if (Sender = frm_MainForm) or (Sender = dm_MainForm2) or (Sender = nil) then
   	Exit;
   tbi_DocVoransicht.Checked := Sender = tbi_DocVoransicht;
   tbi_DocVolltext.Checked := Sender = tbi_DocVolltext;
   tbi_DocLink.Checked := Sender = tbi_DocLink;
   tbi_DocHistory.Checked := Sender = tbi_DocHistory;
end;

procedure Tfrm_MainForm.tbi_DocVoransichtClick(Sender: TObject);
begin
   GgfLogEvnt('sbtn_VoransichtClick');
   ShowFrame(sfVoransicht);
   if not GHasNotBeenSavedAfterModify then
   begin
      tbx_pubNote.checked := true;
      tbx_privNote.checked := false;
      ShowVoransicht(True);
   end;
   ButtonsRechtsClick(Sender);
end;

procedure Tfrm_MainForm.tbi_DocVolltextClick(Sender: TObject);
begin
   GgfLogEvnt('sbtn_VolltextClick');
   fra_volltext.chbx_MarkHits.Checked := true;
   ShowFrame(sfVolltext);
   ShowVolltext;
   ButtonsRechtsClick(Sender);
end;

procedure Tfrm_MainForm.tbi_DocLinkClick(Sender: TObject);
begin
   GgfLogEvnt('sbtn_DocLinkClick');
   ShowFrame(sfDocLink);
   ShowDocLink;
   ButtonsRechtsClick(Sender);
end;

procedure Tfrm_MainForm.tbi_Doc_HistoryClick(Sender: TObject);
begin
   GgfLogEvnt('sbtn_HistoryClick');
   ShowFrame(sfHistory);
   ShowHistory;
   ButtonsRechtsClick(Sender);
end;

procedure Tfrm_MainForm.mnu_InfoClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_InfoClick');
   with Tfrm_Info.Create(Self) do
   begin
      ShowModal;
      Free;
   end;
   ButtonsRechtsClick(Sender);
end;

procedure Tfrm_MainForm.chbx_SDatumClick(Sender: TObject);
begin
   GgfLogEvnt('chbx_SDatumClick');
   dtp_SVon.Enabled := chbx_SDatum.Checked;
   dtp_SBis.Enabled := chbx_SDatum.Checked;
end;

////////////////////////////////////////////////////////////////////////////////////////////////////////////
//    Form das erste mal anzeigen
procedure Tfrm_MainForm.FormShow(Sender: TObject);
var
   reg: TRegistry;
   mdresult: TModalResult;
   lbloginwindow, lbmslogon, lbCheckProgVersOk: boolean;
   //lADSystemInfo: TADSystemInfo;
   //l_aUser: IADsUser;
   lsUsername: string;
begin
   logevnt('Starting ViewerV3 version:' + GetVersionInfo);

   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            closekey;
            OpenKey('\Software\bitfarm\Archiv_V3\Viewer\FormData\MainForm', True);
            if ValueExists('ShowCmd') then
               if ReadString('ShowCmd') = '2' then
                  WriteString('ShowCmd', '3');
            CloseKey;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
            if ValueExists('nologinwindow') then
               lbloginwindow := ReadBool('nologinwindow')
            else
               lbloginwindow := False;
            if ValueExists('nologinwindow') then
               lbloginwindow := ReadBool('nologinwindow')
            else
               lbloginwindow := False;
            if ValueExists('mslogon') then
               lbmslogon := ReadBool('mslogon')
            else
               lbmslogon := false;

            CloseKey;
         end;
      except
         // Mach was...
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
   end;

   ResultlistDesignPath := BD.AppdataBitfarmPd + 'bfa_hit';
   Application.CreateForm(Tfrm_Login, frm_Login);
   frm_Login.fnoshowwindow := lbloginwindow;

   if lbmslogon and ffirststart then
   begin
      lsUsername := GetAdUsername(Self);
      GgfLogEvnt('mslogon:'+ lsUsername);
      if lsUsername>'' then
         begin
            frm_Login.InitLogin;
            frm_login.edt_User.Text := lsUsername;
            frm_Login.fnotpasswordneeded := True;
            frm_Login.btn_LoginClick(self);
         end;
   end;

   if lbloginwindow then
   begin
      if (frm_Login.ModalResult <> mrOk) and (frm_Login.ModalResult <> mrCancel) then
      begin
         frm_Login.InitLogin;
         frm_Login.btn_LoginClick(self);
      end;
   end;

   //m.frey: wenn Anmeldung noch nicht erfolgte dann Login-Fenster zeigen.
   if (frm_Login.ModalResult <> mrOk) and (frm_Login.ModalResult <> mrCancel) then
   begin
      frm_Login.ShowModal;
   end;

   // terminate properly!
   mdresult := frm_Login.ModalResult;
   floginexit := mrOk;

   if (mdresult = mrCancel)   then
   begin
      if ffirststart then
         begin
            dm_DB.my_Con.Disconnect;
 				ExitProcess(0);
         end
      else
         begin
            floginexit := mdresult;
         end;
      exit;
   end;

   frm_Login.Release;

   GgfLogEvntBeg('FormShow');
   lbloginwindow := false;
   lbmslogon := false;
   dm_MainForm2.cleanuplogs;
   gfWindowsVersion := -1;
   gbsearching := false;
   gbwvldockin := False;
   gbbegindragtrefferliste := False;
   gbRefSearchbyFavorite := False;

   fiframe := 0;
   fbturned := false;

   fgchangedvoransicht := false;
   fdatestringempty := '  .  .    ';
   if GetCurrentLanguage = 'ru_RU' then
   begin
      frm_mainform.Font.Charset := RUSSIAN_CHARSET;
   end;
   if pos('en', GetCurrentLanguage) = 1 then
   begin
   end
   else
   if pos('de', GetCurrentLanguage) = 1 then
   begin
   end;

   dm_MainForm2.updatecolumnbuttonTBX(tbi_DocVoransicht, _('Voransicht'), dm_MainForm2.img_buttonstr, 0);
   dm_MainForm2.updatecolumnbuttonTBX(tbi_DocVolltext, _('Volltext'), dm_MainForm2.img_buttonstr, 1);
   dm_MainForm2.updatecolumnbuttonTBX(tbi_DocLink, _('Verknpfungen'), dm_MainForm2.img_buttonstr, 2);
   dm_MainForm2.updatecolumnbuttonTBX(tbi_DocHistory, _('History'), dm_MainForm2.img_buttonstr, 3);
   GgfLogEvnt('Viewer: 8422 : formshow');

   bParamHandled := False;
   numfiles := 1;
   lbl_choosenLink.Caption := '';
   gbshutdownapp := False;
   // Grafische Anzeige der Gruppe als linkMaenge ausschalten
   img_link.Visible := False;
   lbl_choosenLink.Hint := _('kein Referenz ausgewhlt.');
   lbl_choosenLink.Visible := False;

   //when begindrag it calls sometimes mouse up
   // so dont allow it to end drag
   gbbegindragtrefferliste := False;
   gbsettingdone := false;
   fbsaving := false;
   gbeditdoc := false;
   gbcmdzussearch := false;
   fbopeningeditor := false;

   gbshowresults := True;
   gbsendasonepdf := false;
   fshowwvldoc := False;
   fbisktstamp := False;
   setlength(GaiPagesbytes, 0);
   iGdocidtmp := -1;
   iGarcidtmp := -1;
   iGmaxhits := 50;
   ftnlastbacknode := nil;

   // Frame Alignments einstellen
   fra_Nix .Align := alClient; //m.frey
   fra_nix.Align := alClient;
   fra_history.Align := alclient;
   fra_doclink.Align := alclient;
   fra_volltext.Align := alClient;
   fra_voransicht.Align := alClient;

   //use it so saveobjects dont call doubleclick
   fra_voransicht.fdoubleklicked := false;
   fra_voransicht.fsavingobjs := false;
   //tmb_Voransicht.SelectInclusive := true;
   tmb_Voransicht.SelectionWidthNoFocus := 4;
   // tv_lese.onedited:= tv_leseEdited;

   //  Schalter einstellen

   GgfLogEvnt('Tfrm_MainForm.FormShow - tor02open := True;');
   tor02open := True;
   LogEvnt('Showing form');
   Gsorderby := ' order by  Tstamp desc ';
   WvlCellClickopen := True;
   handleparamaktiv := False;
   ngDocClickOpen := True;
   gbdoceditformshowed := true;
   gbArcHandling := False;
   TrefferListeAlreadyLoaded := False;
   istrefferliste := False;
   dpnl_firsttime := True;
   fselectingthumb := false;
   gbchangezoomtextnotview := False;
   gbdontsetpage := false;
   loadingfromwclcellclick := 0;
   gbwvlcellclick := False;
   Gbwfcancel := False;
   givirstualfiles := 0;
   fidropnode := -1;
   gcsListAnsicht := tcriticalsection.Create;
   dm_MainForm2.fblanking := false;

   InitDocTime;

   fra_Voransicht.img_DocView.IO.AutoAdjustDPI := True;

      SetStatusText(cStatusPanelUser, //3.5.0.25
      //'angemeldet als: ' +
      frm_Login.edt_User.Text); {+ ' (' + IntToStr(iGUsrID) +
    ' / ' + IntToStr(dm_db.my_con.ThreadId) + ')';  }
   SetStatusText(cStatusPanelServer, frm_Login.cbx_Profil.Text); //3.5.0.25

   CheckScreenRes;

   dm_db.my_q_Tmp.SQL.Text := 'select * from sys_config order by con_id desc';
   dm_db.my_q_Tmp.Execute;
   gbzdvc := dm_db.my_q_Tmp.FieldByName('Version').AsString < '3.3.2.28';
   gbkleiner3400 := dm_db.my_q_Tmp.FieldByName('Version').AsString < '3.4.0.0';
   fra_voransicht.img_DocView.Blank;
   CheckReg;
   ReadReg;
   mnu_VisLoadClick(self);

   //set per default parallele workflows!

   iGBriefLayers[0] := -1;
   iGBriefLayers[1] := -1;
   // mouse dependent zoom position
   fra_voransicht.img_DocView.MouseWheelParams.ZoomPosition := iemwMouse;
   tmb_voransicht.EnableMultiSelect := True;
   loadfavwvlhints;
   ffirststart := False;
   dbtv_LgrArc.DragMode := dmmanual;
   cbx_VZoom.Text := '';
   gbhasdoclock := false;
   gbhasgdocid := false;
   fbedtingtv_levenode := false;
   gbhasctrlwvl := false;

   gbhasdoclock := DbTableExist('sys_doclock');
   gbhasgdocid := DbTableExist('sys_gdocid');
   gbhasctrlwvl := DbTableExist('sys_ctlrtimer');

   GgfLogEvnt('FormShow -H1');

   gbIsWin64 := IsWindows64;
   GgfLogEvnt('gbIsWin64='+IntToStr(ord(gbIsWin64)));

   if TmpSQL('show  COLUMNS from sys_arcxs like ' + #39 + 'rights' + #39) then
   begin
      if dm_db.my_q_tmp.recordcount > 0 then
      begin

         if pos('docdel', dm_db.my_q_tmp.FieldByName('type').asstring) > 1 then
         begin
            tbi_deldoc.Visible := true;
         end
         else
         begin
            tbi_deldoc.Visible := false;
         end;
      end;
   end;

   InitViewer; // ruft auch HandleParam auf
   bParamHandled := True;

   fra_Voransicht.fUserID:= iGUsrId;
   fra_Voransicht.fUserName := sGUsrName;
   fra_Voransicht.fArcPath := sGArcPath;
   fra_Voransicht.fCopyPath := sGCopyPath;

   if (ngDocTimer = True) and checktasks and not firsttimewvl then
   begin
      tbi_VDocTimer.Checked := True;
      dpnl_wvlg.Visible := True;
      OwnAufClick(self);
   end
   else
   begin
      if ((bAutoDispNew = True) and (not gbsearched)) then
      begin
         try
            btn_StartSrcClick(self);
         except
         	on e: exception do
            begin
               logevnt('Error by formshow on btn_StartSrcClick:' + e.message);
            end;
         end;
      end;
   end;

   tbi_history.checked := dpnl_manfav.visible;

   fbmouseinthumb := false;
   fra_voransicht.fbmouseinim := false;
   //show wvl if tbi_vdoctimer checked
   if tbi_VDocTimer.checked and (not fbAufrufUeberDocId) then
   begin
      tbi_VDocTimerClick(sender);
   end;
   ngAliveMainform := True;
   gbAppStarted := True;

   Application.CreateForm(Tfrm_MailForm, frm_MailForm);

   GgfLogEvntEnd('FormShow');
end;

function Tfrm_MainForm.OperationLock: boolean;
begin
   Result :=
     (gbSaveDoc) or
     (gbDocMove) or
     (gbViewerShutdown) or
     (gbArchivChange) or
     (gbLgrArcSet) or
     (gbwvlcellclick) or
     (gbsettingdone);
end;


procedure Tfrm_MainForm.dbtv_LgrArcClick(Sender: TObject);
begin
   if gbDocMove or
   	gbLgrArcSet or
      gbArchivChange or
      gbSaveDoc or
      gbwvlcellclick then
      Exit;


   GgfLogEvnt     ('dbtv_LgrArcClick');
   dbtv_LgrArcSet (false, true);
end;


procedure Tfrm_MainForm.dbtv_LgrArcSet (bAddSearch: Boolean;
                                        isClick   : Boolean);
var
   iLgrIDX, iArcIDX: integer;
   lbmuli: boolean;
begin
   GgfLogEvntBeg ('dbtv_LgrArcSet Begin');

   if gbLgrArcSet then
     Exit;

   gbLgrArcSet := True;
   try

      if Assigned (dbtv_LgrArc.Selected) then  //  11.06.2010  Vers. 3.5.0.81  [2611]  r.sch.
      begin
        iArcIDX := cbx_Archiv.Items.IndexOfObject(dbtv_LgrArc.Selected.Data);

        if     isClick
          and (iArcIDX >= 0                   )
          and (iArcIDX  = cbx_Archiv.ItemIndex)
        then  //  01.06.2010  Vers. 3.5.0.79  [xxxx]  r.sch.
        begin
          //  Das alte Archiv ist das neue
          //  Gar nix tun!
          //
          GgfLogEvntEnd ('dbtv_LgrArcSet End via Exit #1');
          Exit;
        end;
      end;

      if gbansichtlesen or dm_db.tim_ansicht.Enabled or dm_db.tim_searcharc.enabled then
      begin
         if gblastclickedlager then
         begin
            dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGlgrID), []);
         end
         else
         begin
            dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGarcID), []);
         end;

         GgfLogEvntEnd ('dbtv_LgrArcSet End via Exit #2');
         exit;
      end;

      if fra_Voransicht.gbAnnoNotSaved then
   		fra_Voransicht.saveobjects(False, False);

      if GHasNotBeenSavedAfterModify or ((gtmpiStatus xor gotmpistatus) > 0) then
      begin
         if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
            #13 + _('Mchten Sie die nderungen speichern?'),
            True) = mrYes then
         begin
            tbi_VSaveDocClick(self);
         end;
         GHasNotBeenSavedAfterModify := False;
         fgchangedvoransicht := False;
         fgchangedvoransichttif := False;
         gtmpiStatus := gotmpistatus;
         btn_SaveDoc.Enabled := false;
         tbi_VSaveDoc.Enabled := false;
      end;

      try
         if gbArcHandling or gbarclick then
         begin
            dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(
               integer(cbx_Archiv.Items.Objects[cbx_Archiv.ItemIndex])), []);
            gbarclick := False;
            Screen.Cursor := crDefault;
            Windows.SetCursor(Screen.Cursors[0]);

            GgfLogEvntEnd ('dbtv_LgrArcSet End via Exit #3');
            exit;
         end;
         gbarclick := True;

         Screen.Cursor := crHourGlass;
         Windows.SetCursor(Screen.Cursors[0]);
         // set focus!
         dbgrd_Trefferliste.Visible := True;
         if not wvlhasfocus then
	         dbgrd_Trefferliste.SetFocus;
         Trefferlistealreadyloaded := False;
         if not gbwvlcellclick and isClick then
         begin
            gcsListAnsicht.Acquire;
            gtsl_ansicht.Clear;
            giansichtlistcounter := -1;
            gcsListAnsicht.Leave;
         end;

         comingFromFav := 0;
         if loadingfromwclcellclick = 0 then
         begin
            // lets set to 2 so we dont need to reload next time
            // set to 1 could be ok, but we dont want to overload it, dont we?
            loadingfromwclcellclick := 2;
            wvlhasfocus := False;
            wvlshowbuttons(False);
            dbgrd_wvl.Refresh;
            dbgrd_wvl.Repaint;
         end;
         Gsorderby := '';

         if dbtv_LgrArc.Selected = nil then
         begin
            if not fshowwvldoc then
            begin
               BfShowMessage(_('Bitte prfen Sie Ihre Rechte auf das Verzeichnis.'));
               Logevnt(
                  'dbtv_LgrArc.Selected = nil, mglicherweise keine Zugriffsrechte auf das Verzeichnis.');
            end;
            gbarclick := False;
            Screen.Cursor := crDefault;
            Windows.SetCursor(Screen.Cursors[0]);

            GgfLogEvntEnd ('dbtv_LgrArcSet End via Exit #4');
            exit;
         end;
         lbmuli := bMultiArcQuery;
         case dbtv_LgrArc.Selected.ImageIndex of
            0, 2:   // Lager
            begin
               bMultiArcQuery := True;
               gblastclickedlager := true;
               iLgrIDX := cbx_Lager.Items.IndexOfObject(dbtv_LgrArc.Selected.Data);
               iGLgrID := integer(dbtv_LgrArc.Selected.Data);

               DelZusFields2(true);
               DelStatus;

               if ((cbx_Lager.ItemIndex <> iLgrIDX) or (iGarcID <> 0))
                  and (ilgridx <> iglgrid) then
               begin
                  cbx_Lager.ItemIndex := iLgrIDX;
                  cbx_LagerChange(self);
               end;

               cbx_Archiv.ItemIndex := 0;
               ResetAnzeige;
               sIArcName := '';
               sGArcName := '';

               sGArcName := GSysArc[iGLgrID].ArcName;
               sIArcName := GSysArc[iGLgrID].TblName;
               sGBriefPapier := GSysArc[iGLgrID].ArcBackpic;

               if sbx_ZusFeld.ComponentCount = 0 then
               begin
                  if sIArcName <> '' then
                  begin
                     iGZusFCount := CreZusFields(False);
                  end;
               end;

               if iGZusFCount = 0 then
                  CreateStandardColumnsTrefferliste;

               if (bAutoDispNew) and (iGArcID <> iGLgrID) and gbAppStarted then
               begin
                  btn_StartSrcClick(self);
               end;

               iGArcID := 0
            end;
            1, 3:   // Archiv
            begin
               bMultiArcQuery := false;
               gblastclickedlager := false;
               iLgrIDX :=
                  cbx_Lager.Items.IndexOfObject(dbtv_LgrArc.Selected.Parent.Data);
               if cbx_Lager.ItemIndex <> iLgrIDX  then
               begin
                  cbx_Lager.ItemIndex := iLgrIDX;
                  cbx_LagerChange(self);
               end;
               iArcIDX := cbx_Archiv.Items.IndexOfObject(dbtv_LgrArc.Selected.Data);

               if not bAddSearch then //3.5.0.58 [2328]
               if sbx_ZusFeld.ComponentCount > 0 then
                  ClearZusFields;

               if (cbx_Archiv.ItemIndex <> iArcIDX) or (igarcid = 0) or lbmuli then
               begin
                  cbx_Archiv.ItemIndex := iArcIDX;
                  cbx_ArchivChange(self);
               end;
            end;
         end;
      except
        on e: Exception do
        begin
          GgfLogEvntEnd ('dbtv_LgrArcSet End via Exception');
        end;
      end;
	finally
      gbLgrArcSet := False;
      gbarclick := False;
      Screen.Cursor := crDefault;
      Windows.SetCursor(Screen.Cursors[0]);
   end;
   GgfLogEvntEnd ('dbtv_LgrArcSet End');
end;

// DRAGOVER  Lager und Archiv
procedure Tfrm_MainForm.dbtv_LgrArcDragOver(Sender, Source: TObject;
   X, Y: integer; State: TDragState; var Accept: boolean);
var
   lttmp: TTreenode;
begin
   GgfLogEvnt('dbtv_LgrArcDragOver');
   if Source is TCRDBGrid then
   begin
      if y < 15 then
      begin
         fbscroll_down := True;
         timer_autoscroll.Enabled := True;
      end
      else
      if (dbtv_LgrArc.Height - y) < 15 then
      begin
         fbscroll_down := False;
         timer_autoscroll.Enabled := True;
      end
      else
         timer_autoscroll.Enabled := False;
   end;
   if Source is TCRDBGrid then
   begin
      Accept := True;
      lttmp := dbtv_LgrArc.GetNodeAt(x, y);
      if (lttmp <> nil) and ((lttmp.ImageIndex = 1) or (lttmp.ImageIndex = 3)) then
      begin
         fidropnode := integer(lttmp.Data);
      end
      else
      begin
         fidropnode := -1;
      end;
   end;
end;


// Drag DROP  Lager und Archiv
procedure Tfrm_MainForm.dbtv_LgrArcDragDrop(Sender, Source: TObject; X, Y: integer);
var
   iNewArcID, iNewDocID, iGCount, lidoc_id, litmparc,
   liarcma, licount, liRecno, liprefix, iRC: integer;
   lsiArcname, lssarcname, lsdocids,
   sTmpDesArcTbl, sTmpSrcArcTbl, sLimit, sTmpDesArcName : string;
   lspname, lsdname, lsstandarddir, lsmydir, lsmydirtifs,
   lsparams, listname: string;
   lbshift, lbmoveresult: boolean;
   lsilshift, lsirshift: SHORT;
   lbhaszusfield: boolean;
   slZMetaField, slZMetaName,slZMetaFieldValues, slZMetaFieldType, tlsljob: TStringList;
begin
   GgfLogEvntBeg('dbtv_LgrArcDragDrop - begin');
   fDragging := False;

  	if OperationLock then
  		Exit;

   sLimit := ' Limit 1';
   lsmydir := getenvironmentvariable('temp') + '\Viewer\';
   listname := lsmydir + 'mylist' + inttostr(Random(99999));
   dbtv_LgrArc.Enabled := False;
   try
      try
         if Source is TCRDBGrid then
      	begin
            iNewArcID := integer(fidropnode);
            if iNewArcID = -1 then   // Lager erwischt   v3.5.1.62
            begin
               GgfLogEvnt('dbtv_LgrArcDragDrop Exit via 2');
               Exit;
            end;

            iNewDocID := 0;
            lbshift := false;
            lsilshift := GetAsyncKeyState(VK_LSHIFT);
            lsirshift := GetAsyncKeyState(VK_RSHIFT);
            if (lsilshift = -32767) or
               (lsilshift = -32768) or
               (lsirshift = -32767) or
               (lsirshift = -32768) then
            begin
             	lbshift := True;
            end;

            if bMultiArcQuery then
            begin
              	liarcma := dm_db.my_q_Arc.FieldByName('arc_id').AsInteger;
            end
            else
            begin
              	liarcma := iGArcID;
            end;

            // bei einer MultiArcQuery knnen wir erst spter Dokument fr Dokument
            // prfen, ob das Dokument nicht in sein eigenes Archiv verschoben werden soll,
            // ansonsten prfen wir das hier sofort
            if not bMultiArcQuery then
            begin
              if liarcma = iNewArcID then
                   exit;
            end;

            if not assigned(gtsl_markedids) then
            begin
              gtsl_markedids := TStringList.Create;
            end;
            gtsl_markedids.Clear;
            try
               dbgrd_Trefferliste.Enabled := false;
               timer_autoscroll.Enabled := False;
               // Zielzusatzfelder ermitteln

                slZMetaField      := TStringList.Create;
                slZMetaFieldValues:= TStringList.Create;
                slZMetaName       := TStringList.Create;
                slZMetaFieldType  := TStringList.Create;
                
                GgfLogEvnt('dbtv_LgrArcDragDrop - Select Sql_No_cache * from sys_arc where arc_id = ' +
                   IntToStr(liarcma) + ' or arc_id = ' + IntToStr(iNewArcID));
                if TmpSQL('Select Sql_No_cache * from sys_arc where arc_id = ' +
                   IntToStr(liarcma) + ' or arc_id = ' + IntToStr(iNewArcID)) then
                begin
                   with dm_DB.my_q_Tmp do
                   begin
                      while not EOF do
                      begin
                         if FieldByName('arc_id').AsInteger = liarcma then
                         begin
                            sTmpSrcArcTbl := FieldByName('arc_tblname').AsString;
                         end;
                         if FieldByName('arc_id').AsInteger = iNewArcID then
                         begin
                            sTmpDesArcTbl := FieldByName('arc_tblname').AsString;
                            sTmpDesArcName := FieldByName('arc_name').AsString;
                         end;
                         Next;
                      end;
                      dm_DB.my_q_Tmp.Close;
                   end;
                end;
                GgfLogEvnt('dbtv_LgrArcDragDrop - Select Sql_No_cache * from cfg_' + sTmpDesArcTbl);
               if TmpSQL('Select Sql_No_cache * from cfg_' + sTmpDesArcTbl) then
               begin
                  with dm_DB.my_q_Tmp do
                  begin
                     slZMetaField.Clear;
                     slZMetaFieldValues.Clear;
                     slZMetaName.Clear;
                     slZMetaFieldType.Clear;
                     while not EOF do
                     begin
                        slZMetaField.Add(FieldByName('Feld_Name').AsString);
                        slZMetaName.Add(FieldByName('Disp_Name').AsString);
                        slZMetaFieldValues.Add('');
                        slZMetaFieldType.Add(FieldByName('Typ').AsString);
                        Next;
                     end;
                     dm_DB.my_q_Tmp.Close;
                  end;
               end
               else
               begin
                  Close;
                  LogEvnt('dbtv_LgrArcDragDrop - Fehler beim Verschieben eines Dokumentes: Auslesen der Ziel-MetaFelder');
                  ShowMessage(_('Fehler beim Verschieben eines Dokumentes: Auslesen der Ziel-MetaFelder'));
                  Exit;
               end;
            except
               on e: exception   do
               begin
                	LogEvnt(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                	Exit;
               end;
            end;
            Try
               GGfLogEvnt('dbtv_LgrArcDragDrop - Create Tfrm_zuspflicht begin');
               Application.CreateForm(Tfrm_zuspflicht, frm_zuspflicht);
               frm_zuspflicht.fsDestIarcname := sTmpDesArcTbl;
               frm_zuspflicht.fsSrcIarcname := sTmpSrcArcTbl;
               frm_zuspflicht.igdocid := dm_db.my_q_Arc.FieldByName('doc_id').AsInteger;
               frm_zuspflicht.iGUsrID := iGUsrID;
               frm_zuspflicht.igArcid := iGArcID;
               frm_zuspflicht.igNewArcid := iNewArcID;
               frm_zuspflicht.sNewArcName := sTmpDesArcName;

               frm_zuspflicht.bMove := True;
               frm_zuspflicht.bPflichtfelder := True;
               dm_DB.bgCancelfrmZuspflicht:= false; //06.05.1979	b.takacs 3.5.1.9

               frm_zuspflicht.lbl_doctitel.caption := dm_db.my_q_arc.fieldbyname('disp_name').asstring;
               frm_zuspflicht.lbl_docid.caption := dm_db.my_q_arc.fieldbyname('doc_id').asstring;

               frm_zuspflicht.fiZusFcount := frm_zuspflicht.CreZusFields;
               if frm_zuspflicht.fTorpflichtfeld <> 0 then
                  lbhaszusfield := true
               else
                  lbhaszusfield := false;

               GGfLogEvnt('dbtv_LgrArcDragDrop - Create Tfrm_zuspflicht end');

               if lbhaszusfield then
               begin
                  frm_zuspflicht.ShowModal;
                  if frm_zuspflicht.ModalResult <> mrOk then
                  begin
                     lbmoveresult := false;
                     exit;
                  end;

                  if not frm_zuspflicht.ChkZusfield(false) then
                  begin
                     if 0 <> (frm_zuspflicht.ftorpflichtfeld - frm_zuspflicht.fkeypflichtfeld) then
                     begin
                        LogEvnt('dbtv_LgrArcDragDrop - Fehler beim Verschieben eines Dokumentes: frm_zusplicht.ChkZusfield = FALSE');
                        showmessage(_('Fehler beim Verschieben eines Dokumentes: frm_zusplicht.ChkZusfield = FALSE'));
                        Exit;
                     end;
                  end;
               end;

               if lbhaszusfield then
                  FillMetaFieldValuesPflicht(slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType)
               else
                  FillMetaFieldValues(slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType);

               if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count > 1  then
               begin
                 if dm_DB.bgCancelfrmZuspflicht then
                 begin
                   dm_DB.bgCancelfrmZuspflicht:= false;
                   if BfMessageDlg(_('Mchten Sie alle abbrechen'),mtWarning,[MbYes,mbNo],0) = mrYes then
                   begin
                     GgfLogEvnt('dbtv_LgrArcDragDrop - frm_zusplicht Cancel');
                     exit;
                   end;
                 end;
               end;

               for iGCount := 0 to (frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1) do
               begin
                 iNewDocID := 0;
                 dm_db.my_q_Arc.GotoBookmark(
                    Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[iGCount]));

                 if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 1 then
                 begin
                      if iGarcID = iNewArcID then
                         exit;
                 end
                 else
                 begin
                   if bMultiArcQuery then
                   begin
                      //take next if the bmultiarcquery
                      if dm_db.my_q_Arc.FieldByName('arc_id').AsInteger = iNewArcID then
                         continue;
                   end
                   else
                   begin
                      //todo let it in dragdrop
                      if iGarcID = iNewArcID then
                      begin
                         exit;
                      end;
                   end;
                 end;
                 //todo let it in dragdrop
                 if fidropnode = -1 then
                 begin
                    LogEvnt('dbtv_LgrArcDragDrop - ' + _('Sie knnen ein Dokument nur in ein Archiv verschieben!'));
                    ShowMessage(_('Sie knnen ein Dokument nur in ein Archiv verschieben!'));
                    exit;
                 end;

                 if (dm_db.my_q_Arc.FieldByName('doc_state').AsInteger and 1) <> 0 then
                    continue;

                 lidoc_id := dm_db.my_q_Arc.FieldByName('doc_id').AsInteger;
                 litmparc := iGArcID;
                 lsiArcname := sIArcName;
                 lssArcname := sGarcName;
                 if bMultiArcQuery then
                 begin
                    liarcma := dm_db.my_q_Arc.FieldByName('arc_id').AsInteger;
                 end
                 else
                 begin
                    liarcma := iGArcID;
                 end;

                 if TmpSQL('Select Sql_No_cache * from sys_timer where doc_id = ' +
                    IntToStr(lidoc_id) + ' and arc_id = ' + IntToStr(liarcma) + ' and  status <> 2') then
                 begin
                    if dm_db.my_q_tmp.RecordCount > 0 then
                       continue;
                 end;

                 lbmoveresult := MoveDoc(liarcma, iNewArcID, lidoc_id, iNewDocID, slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType,lbhaszusfield);

                 GgfLogEvnt('dbtv_LgrArcDragDrop lbmoveresult:'+ BoolToStr(lbmoveresult) + ' iNewDocID:' + IntToStr(iNewDocID));
                 if lbmoveresult and (iNewDocID <> 0) then
                 begin
                    gtsl_markedids.add(IntToStr(inewdocid));
                    GGflogevnt('dbtv_LgrArcDragDrop - writing history, ' + IntToStr(iNewArcID) + '.' + IntToStr(iNewDocID));

                    NewHistoryID(9, _('Dokument verschoben nach Archiv  ArcID:') +
                       IntToStr(iNewArcID) + ' DocID:' + IntToStr(iNewDocID),iNewArcID, iNewDocID, iGUsrID);

                    if frm_zuspflicht.slHistory.Count > 0 then
                    begin
                        for licount := 0 to frm_zuspflicht.slHistory.Count -1 do
                           NewHistoryID(9, frm_zuspflicht.slHistory[licount], iNewArcID, iNewDocID, iGUsrID);
                    end;

                    if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count > 0 then
                    begin
                      if bMultiArcQuery then
                      begin
                         dm_db.my_q_Arc.Edit;
                         dm_db.my_q_Arc.FieldByName('arc_id').AsInteger := iNewArcID;
                         dm_db.my_q_Arc.FieldByName('doc_id').AsInteger := iNewDocID;
                         dm_db.my_q_Arc.FieldByName('tblname').AsString := GSysArc[iNewArcID].TblName;
                         dm_db.my_q_Arc.FieldByName('arcname').AsString := GSysArc[iNewArcID].ArcName;
                         dm_db.my_q_Arc.Post;
                      end;
                    end;

                    for licount := Low(gDocViewSaves) to High(gDocViewSaves) do
                    begin
                        if (gDocViewSaves[licount].doc.ArcId = liarcma) and
                           (gDocViewSaves[licount].doc.DocId = lidoc_id) then
                        begin
                           gDocViewSaves[licount].doc.ArcId := iNewArcID;
                           gDocViewSaves[licount].doc.DocId := iNewDocID;
                        end;
                    end;
                 end
                 else
                   BfShowMessage(_('Fehler bei Verschieben eines Dokumentes:'));

                 iGArcRecNo := -1;
                 iGarcID := litmparc;
                 if not bMultiArcQuery then
                 begin
                    sIArcName := lsiArcname;
                    sGarcName := lssArcname;
                 end;
               end;
            finally
              frm_zuspflicht.Release;
              dbgrd_Trefferliste.Enabled := true;
            end;
            if lbshift then
            begin
              //when shift is pressed get the list on the target archive
              bParamHandled := False;
              handleparamaktiv := True; GgfLogEvnt('handleparamaktiv:=true B');
              HPTorOpen := False;
              GgfLogEvnt('dbtv_LgrArcDragDrop - dbtv_LgrArc.Select');
              dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iNewArcID), []);
              GgfLogEvnt('dbtv_LgrArcDragDrop - dbtv_LgrArcSet iNewArcID=' + IntToStr(iNewArcID)
              +' iGArcID=' + IntToStr(iGArcID));
              if iNewArcID <> iGArcID  then
              begin
                  SetLength(GArcSList, 1);
                  GArcSList[0].ArcID := iNewArcID;
                  iGArcID  := iNewArcID;
                  iGdbtvIdx := -1;  // wir erzwingen ein Neuladen des Archivs bei dbtv_LgrArcSet
                  sGArcName := GSysArc[iGArcID].ArcName;
                  sIArcName := GSysArc[iGArcID].TblName;
                  GArcSList[0].ArcName := sGArcName;
                  GArcSList[0].TblName := sIArcName;
                  iGArcRecNo := -1;
                  dbtv_LgrArcSet (False, False);
              end;

              if gtsl_markedids.Count > 0 then
              begin
                 lsdocids := 'doc_id = ' + gtsl_markedids.Strings[0];
                 sLimit := ' Limit ' + IntToStr(gtsl_markedids.Count);
              end
              else
                sLimit := '';

              for licount := 1 to gtsl_markedids.Count - 1 do
              begin
                 lsdocids := lsdocids + ' or doc_id = ' + gtsl_markedids.Strings[licount];
              end;

              bMultiArcQuery := False;
              //get first the rights
              GetArcUsrRights;
              gbsearched := True;
              bGImageDisp := True;

              if rGarcright.list then
              begin
                 logevnt('select * from sys_arc where arc_id = ' + IntToStr(iNewArcID));
                 if lsdocids <> '' then
                    lsdocids := ' where ' + lsdocids;
                 if Gsorderby = '' then
                 begin
                    Gsorderby := ' order by Tstamp desc ';
                 end;

                 QueryArc('select Sql_No_cache * from arc_' + GSysArc[iNewArcID].TblName + lsdocids + sLimit);

                 iGArcID := GArcSList[0].ArcID;
                 sIarcname := GArcSList[0].TblName;

                 trefferlistealreadyloaded := True;
                 GgfLogEvnt('dbtv_LgrArcDragDrop - GetArcUsrRights');
                 GetArcUsrRights;

              end;

              bParamHandled := True;
              HPTorOpen := True;
              handleparamaktiv := False;
            end;
         end;

         if not lbshift then
         begin
           liRecno := dm_db.my_q_arc.RecNo;
           dbgrd_trefferliste.SelectedRows.Clear;
           dm_db.my_q_arc.refresh;
           dbgrd_trefferliste.SelectedRows.CurrentRowSelected := True;

           BM1:= nil;
           BM2:= nil;

           if dm_db.my_q_arc.recordcount > 0 then
           begin
              iGArcRecNo := -1;

              GSelection := nil;
              SetLength(GSelection,1);
              GSelection[0] :=  dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
           end
           else
           begin
              btn_ResFieldsClick(self);
           end;
         end;
      except
        	LogEvnt('dbtv_LgrArcDragDrop - Exception');
      end;
   finally
      GgfLogEvnt('dbtv_LgrArcDragDrop - finally begin');

      if gbDocMove then        /// 16.02.2011 b.takacs 3.5.0.161   [2488]
      begin
         HandleDoc;
         gbDocMove:= false;
      end;
      if Assigned(slZMetaName) then
        	FreeAndNil(slZMetaName);
      if Assigned(slZMetaField) then
        	FreeAndNil(slZMetaField);
      if Assigned(slZMetaFieldValues) then
        	FreeAndNil(slZMetaFieldValues);
      if Assigned(slZMetaFieldType) then
        	FreeAndNil(slZMetaFieldType);
      dbtv_LgrArc.Enabled := True;
      GgfLogEvntEnd('dbtv_LgrArcDragDrop - end');
   end;
end;


procedure Tfrm_MainForm.FillMetaFieldValues(var slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType: TStringList);
var
   iCount, liCount1 : Integer;
   sFeld, sName, sWert : string;
   jvstcomp: tjvstatictext;
   xComp, xComp01: TComponent;
begin
   for iCount := 0 to slZMetaField.Count - 1 do
   begin
      for liCount1 := 0 to iGZusFCount - 1 do
      begin
         jvstcomp := tjvstatictext(frm_MainForm.sbx_ZusFeld.FindComponent(
            'zlbl_Tmp' + IntToStr(liCount1)));

         sFeld := jvstcomp.Hint;
         sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);
         if RightStr(sName,5) = _('(von)') then
            sName := Copy(sName, 0 , Length(sName) -5);
         if sName <> slZMetaName.Strings[icount] then
            continue;

         sWert := '';
         xComp := FindComponentRekursivFrame(frm_MainForm.sbx_ZusFeld, 'zedt_Tmp' +
            IntToStr(liCount1));

         if xComp is TEdit then
         begin
            sWert := TEdit(xComp).Text;
         end;
         if xComp is TJvDateEdit then
         begin
            swert := TJvDateEdit(xComp).Text;
            if swert = cEmptyDateString then
               swert := '';
         end;
         if xComp is TComboBox then
         begin
            sWert :=TComboBox(xComp).Text;
         end;
         if xComp is TJvSpinEdit then
         begin
            sWert := StringReplace(TJvSpinEdit(xComp).Text,',','.',[rfReplaceAll]);   //15.10.2010 b.takacs [2773]
         end;
         if xComp is TSpinEdit then
         begin
            xComp01 := FindComponentRekursivFrame(frm_MainForm.sbx_ZusFeld, 'zedt_Tmp_cbx_' +
               IntToStr(liCount1));
            if xComp01 <> nil then
            begin
               sWert := TSpinEdit(xComp).Text + Tcombobox(xComp01).text;
            end;
         end;
         if xComp is TjvCheckedComboBox then
         begin
            sWert := TjvCheckedComboBox(xComp).Text;
         end;

         if swert <> '' then
         begin
            slZMetaFieldValues.Strings[icount] := swert;
         end;
      end;
   end;
end;

procedure Tfrm_MainForm.FillMetaFieldValuesPflicht(var slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType: TStringList);
var
   iCount, liCount1 : Integer;
   sFeld, sName, sWert, ls : string;
   jvstcomp: tjvstatictext;
   xComp, xComp01: TComponent;
begin
   ls := GetCurrentLanguage;
   for iCount := 0 to slZMetaField.Count - 1 do
   begin
      for liCount1 := 0 to frm_zuspflicht.fiZusFcount - 1 do
      begin
         jvstcomp := tjvstatictext(frm_zuspflicht.sbx_ZusFeld.FindComponent(
            'zlbl_Tmp' + IntToStr(liCount1)));

         sFeld := jvstcomp.Hint;
         sName := copy(jvstcomp.Caption, 1, Length(jvstcomp.Caption) - 1);

         if sFeld <> slZMetaField.Strings[icount] then
            continue;

         sWert := '';
         xComp := FindComponentRekursivFrame(frm_zuspflicht.sbx_ZusFeld, 'zedt_Tmp' +
            IntToStr(liCount1));

         if xComp is TEdit then
         begin
            if ((TEdit(xComp).Color = cColorNoRightInit) or (TEdit(xComp).Color = cColorNoRight)) then
               continue;
            if (TEdit(xComp).Tag and 4) = 4 then
               sWert := #39 + TEdit(xComp).Text + #39;
         end;
         if xComp is TJvDateEdit then
         begin
            if ((TJvDateEdit(xComp).Color = cColorNoRightInit) or (TJvDateEdit(xComp).Color = cColorNoRight)) then
               continue;
            if (TJvDateEdit(xComp).Tag and 4) = 4 then
               swert := TJvDateEdit(xComp).Text;
            if swert = cEmptyDateString then
               swert := '';
            if swert <> '' then
            begin
               if Copy(ls,0,2) ='en' then
               begin
               	sWert := 'str_to_date(' + #39 + sWert + #39 + ',' + #39 +
                     '%m/%d/%Y' + #39 + ')';
               end
               else
                  sWert := 'str_to_date(' + #39 + sWert + #39 + ',' + #39 +
                     '%d.%m.%Y' + #39 + ')';
            end;
         end;
         if xComp is TComboBox then
         begin
            if ((TComboBox(xComp).Color = cColorNoRightInit) or (TComboBox(xComp).Color = cColorNoRight)) then
               continue;
            if (TComboBox(xComp).Tag and 4) = 4 then
            begin
               sWert :=TComboBox(xComp).Text;
               if (slZMetaFieldType.Strings[iCount] = '1') and (swert <> '') then   //Datum
               begin
                  if Copy(ls,0,2) ='en' then
                  begin
                     sWert := 'str_to_date(' + #39 + sWert + #39 + ',' + #39 +
                        '%m/%d/%Y' + #39 + ')';
                  end
                  else
                     sWert := 'str_to_date(' + #39 + sWert + #39 + ',' + #39 +
                        '%d.%m.%Y' + #39 + ')';
            	end
               else
                  sWert := #39 + sWert + #39;
            end;
         end;
         if xComp is TJvSpinEdit then
         begin
            if ((TjvSpinEdit(xComp).Color = cColorNoRightInit) or (TjvSpinEdit(xComp).Color = cColorNoRight)) then
               continue;
            if (TjvSpinEdit(xComp).Tag and 4) = 4 then
                  sWert := #39 + StringReplace(TJvSpinEdit(xComp).Text,',','.',[rfReplaceAll]) + #39;   //15.10.2010 b.takacs [2773]
         end;
         if xComp is TSpinEdit then
         begin
            if ((TSpinEdit(xComp).Color = cColorNoRightInit) or (TSpinEdit(xComp).Color = cColorNoRight)) then
               continue;
            if (TSpinEdit(xComp).Tag and 4) = 4 then
            begin
               xComp01 := FindComponentRekursivFrame(frm_zuspflicht.sbx_ZusFeld, 'zedt_Tmp_cbx_' +
                  IntToStr(liCount1));
               if xComp01 <> nil then
               begin
                  sWert := #39 + TSpinEdit(xComp).Text + Tcombobox(xComp01).text + #39;
               end;
            end;
         end;
         if xComp is TjvCheckedComboBox then
         begin
            if ((TjvcheckedComboBox(xComp).Color = cColorNoRightInit) or (TjvcheckedComboBox(xComp).Color = cColorNoRight)) then
               continue;
            if (TjvcheckedComboBox(xComp).Tag and 4) = 4 then
               sWert := #39 + TjvCheckedComboBox(xComp).Text + #39;
         end;

         if swert <> '' then
         begin
            slZMetaFieldValues.Strings[icount] := swert;
         end;
      end;
   end;
end;


function Tfrm_MainForm.MoveDoc(var SrcArcID, DesArcID, SrcDocID, NewDocID: integer; slZMetaField,slZMetaName,slZMetaFieldValues,slZMetaFieldType: TStringList; lbhaszusfield: boolean ): boolean;
   //////////////////////////////////////////////////////////////////
   ///  12.05.2005 Erstellt (SV)                                  ///
   ///  13.05.2005 Try/Except pro SQL-Statement erstellt (SV)     ///
   ///             Neue Schlagworttabelle bercksichtigt (SV)     ///
   ///                                                            ///
   ///  Diese Function verschiebt ein Dokument (SrcDocID) aus     ///
   ///  dem Quellarchiv (SrcArcID) ins Zielarchiv (DesArcID)      ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////

   // lokale procedure um es bersichtlicher zu machen.
   procedure lErrorMsg(const ErrMsg: string);
   begin
      Result := False;
      logevnt('MoveDoc - ErrorCode: 2023; ' + ErrMsg);
      ErrorMsg('MoveDoc', ErrMsg, 2023, True);
   end;

var
   sTmpSrcArcTbl, sTmpDesArcTbl, sTmpSrcArcName, sTmpDesArcName, sTStamp,
   sSrcFileName, sExtFileName, sOriFileName, sQMetaField, sZMetaField,
   sFeld, sName, sWert, lsoptionen, lsoptionen1, lsFeldname, lsSql,
   lsZusatzfeldInhalt, lsSVN_Link, lsSVN_Version, lsSVN_Revision,
   tmpMetaFieldValue, sFileName, msec, msg: string;
   slMoveFile, slQMetaField, slQMetaName: TStrings;
   iDesDocID, iCount, licount1, iZIx, liopt, i : integer;
   jvstcomp: tjvstatictext;
   xComp, xComp01: TComponent;
   lbhasopt, lbused, lbhasgdocid,
   lbhasopt1, lbhasgdocid1: boolean;
   ligdocid: int64;
   liDestArcOptions, FieldOption, gdocid: integer; // Optionen mit docname und Docname = Arch
   lsDocName,
   lsDefDocName,
   lsSrcArcID,
   lsSrcDocID,
   ls, xml   : widestring;
   DestArcDocId:TArcDocId;

begin
   GgfLogEvntBeg('MoveDoc - begin');

   Result := False;
   gbDocMove:= true; //16.02.2011 b.takacs 3.5.0.161 [2488]

   GgfLogEvnt('MoveDoc - my_q_GetArcDocUsrRights');
   dm_db.my_q_GetArcDocUsrRights.sql.Text :=
     'select * from sys_doclock   where   arc_id = ' +
     IntToStr(SrcArcID) + ' and doc_id = ' + IntToStr(SrcDocID) + ';';
   dm_db.my_q_GetArcDocUsrRights.Execute;
   if dm_db.my_q_GetArcDocUsrRights.RecordCount > 0 then
   begin
    result:= false;
     logevnt('MoveDoc - Das Dokument wurde ausgecheckt');
    ShowMessage(_('Hinweis!')
      + #13 + #13 +
      _('Das Dokument wurde ausgecheckt.') + #13 + #13 +
      _('Bitte wenden Sie sich an Ihren Administrator.'));
    exit;
   end;

   // Initializations
   DestArcDocId.ArcId := DesArcID;
   DestArcDocId.DocId := NewDocID;
   lsSrcDocID := IntToStr(SrcDocID);
   lsSrcArcID := IntToStr(SrcArcID);
   lbhasgdocid1 := false;
   iDesDocID := 0;
   slMoveFile        := TStringList.Create;
   slQMetaField      := TStringList.Create;
   slQMetaName       := TStringList.Create;

   lbhasopt := false;
   lbhasgdocid := false;
   liopt := 0;
   ligdocid := 0;
   lsoptionen := '';

   try

          // get for time revelant actions the server time
         dm_db.my_q_datetime.SQL.Text := 'select date_format(now(),"%Y-%m-%d %T") as date';
         dm_db.my_q_datetime.Execute;
         sTStamp := dm_db.my_q_datetime.FieldByName('date').AsString;

         // Quell und Zielarchive ermitteln
         sTmpSrcArcTbl := GSysArc[SrcArcID].TblName;
         sTmpSrcArcName := GSysArc[SrcArcID].ArcName;
         sTmpDesArcTbl := GSysArc[DesArcID].TblName;
         sTmpDesArcName := GSysArc[DesArcID].ArcName;
         
         // check if there is the entry (doc) requested in the arc_stmpsrcarctbl
         if TmpMoveSQL('Select Sql_No_cache * from arc_' + sTmpSrcArcTbl +
            ' where doc_id = ' + lsSrcDocID) then
         begin
            with dm_DB.my_q_Move do
            begin
               if RecordCount = 0 then
               begin
                  dm_DB.my_q_Arc.Delete;
                  Close;
                  lErrorMsg(_('Hinweis!')
                     + #13 + #13 +
                     _('Das Dokument wurde zwischenzeitlich von einem anderen Anwender verschoben.')
                     + _('Die Ergebnisliste wird um das bereits verschobene Dokument bereinigt.'));
                  Exit;
               end;
               if RecordCount > 1 then    //albern
               begin
                  Close;
                  lErrorMsg(
                     _('Fehler beim Verschieben eines Dokumentes: Primr Index Fehler,') + ' ' +
                     _('es wurden mehr als eine passende DOC_ID gefunden! Die Arc_ und Doc_ID waren') + ' ' + lsSrcArcID + ' ' + lsSrcDocID,
                     );
                  Exit;
               end;
               if RecordCount = 1 then
               begin
                  sSrcFileName := FieldByName('doc_loc').AsString;
                  sExtFileName := FieldByName('ext_loc').AsString;
                  sOriFileName := FieldByName('ori_loc').AsString;
               end;
               if dm_db.my_q_Move.FieldDefList.Find('Optionen') <> nil then
               begin
                  lbhasopt := true;
                  liopt := FieldByName('Optionen').Asinteger;
               end;

               if dm_db.my_q_Move.FieldDefList.Find('gdoc_id') <> nil then
               begin
                  lbhasgdocid := true;
                  ligdocid := FieldByName('gdoc_id').Asinteger;
               end;
               Close;
            end;
         end;

         if TmpMoveSQL('show columns from arc_' + sTmpDesArcTbl) then
         begin
            lbhasopt1 := false;
            lbhasgdocid1 := false;
            while not dm_db.my_q_Move.eof do
            begin
               if dm_db.my_q_Move.FieldByName('Field').AsString = 'Optionen' then
               begin
                  lbhasopt1 := true and lbhasopt;
               end;

               if dm_db.my_q_Move.FieldByName('Field').AsString = 'gdoc_id' then
               begin
                  lbhasgdocid1 := true and lbhasgdocid;
               end;
               dm_db.my_q_Move.next
            end;
            if lbhasopt1 then
            begin
               lsoptionen := ', Optionen';
            end;
            if lbhasgdocid1 then
            begin
               lsoptionen := lsoptionen + ', gdoc_id';
            end;
         end;

         // Quellzusatzfelder ermitteln
         // Zusatzfelder definitionen stehen in der Tabelle cfg_
         if TmpMoveSQL('Select Sql_No_cache * from cfg_' + sTmpSrcArcTbl + ' where typ <> 4 order by pos') then
         begin
            with dm_DB.my_q_Move do
            begin
               slQMetaField.Clear;
               slQMetaName.Clear;
               while not EOF do
               begin
                  slQMetaField.Add(FieldByName('Feld_Name').AsString);
                  slQMetaName.Add(FieldByName('Disp_Name').AsString);
                  Next;
               end;
               dm_DB.my_q_Move.Close;
            end;
         end
         else
         begin
            Close;
            lErrorMsg('Fehler bei Verschieben eines Dokumentes: Auslesen der Quell-MetaFelder');
            Exit;
         end;

         // gleiche Feldbezeichnungen finden und Meta-Felder-Informationen zusammenstellen
         sQMetaField := '';
         sZMetaField := '';
         for iCount := 0 to slQMetaName.Count - 1 do
         begin
            iZIx := slZMetaName.IndexOf(slQMetaName.Strings[iCount]);
            if iZIx <> -1 then
            begin
               sQMetaField := sQMetaField + slQMetaField.Strings[iCount] + ', ';
               sZMetaField := sZMetaField + slZMetaField.Strings[iZIx  ] + ', ';
            end;
         end;
         //---------------------------------------------------------------------
         // m.frey: Abfrage der Optionen fr cArchivOptNameArchiv
         try
            lsDefDocName := '';
            lsDefDocName := DbTableColumnValue(
               'select DefDocName from sys_arc where arc_id='+IntToStr(DesArcID));
         except
            on e: Exception do
            begin
               lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
               Exit;
            end;
         end;

         with dm_DB.my_cmd do
         begin
            //------------------------------------------------------------------
            // Dokument aus Quelltabelle in Zieltabelle kopieren
            SQL.Text := 'Insert into arc_' + sTmpDesArcTbl + ' (' +
               sZMetaField +
               'disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf' + lsoptionen + ') ' +
               'Select Sql_No_cache ' + sQMetaField +
               'disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf' + lsoptionen +
               ' from arc_' + sTmpSrcArcTbl + ' where doc_id = ' + lsSrcDocID;
            try
               Execute;
               // get the new doc_id
               sleep(20);
               iDesDocID := InsertID;
               NewDocID := iDesDocID;
               DestArcDocId.DocId := NewDocID;
            except
               on e: Exception do
               begin
                  lErrorMsg('Fehler beim Verschieben eines Dokumentes:' + e.Message);
                  Exit;
               end;
            end;

            //------------------------------------------------------------------
            //update pflichtzusfield
            if lbhaszusfield then
            begin
               lbused := false;
               sQMetaField := '';
               for icount := 0 to slZMetaField.Count - 1 do
               begin

                  if (slZMetaFieldValues.Strings[iCount] = '') or
                     (trim(slZMetaFieldValues.Strings[iCount]) = #39 + #39) or
                     (slZMetaFieldValues.Strings[iCount] = #39 +'0'+ #39) or
                     (slZMetaFieldValues.Strings[iCount] = #39 +'0.00'+ #39) or
                     (slZMetaFieldValues.Strings[iCount] = #39 +'0.0000000000'+ #39) or
                     (slZMetaFieldValues.Strings[iCount] = #39 +cEmptyDateString+ #39)then
                  begin
                     continue;
                     //          slZMetaFieldValues.Strings[iCount] := #39+#39;
                  end;
                  if lbused then
                  begin
                     sQMetaField := sQMetaField + ', ' + slZMetaField.Strings[iCount] +
                        ' = ' + slZMetaFieldValues.Strings[iCount];
                  end
                  else
                  begin
                     sQMetaField := slZMetaField.Strings[iCount] + ' = ' +
                        slZMetaFieldValues.Strings[iCount];
                     lbused := true;
                  end;

                  tmpMetaFieldValue:= slZMetaFieldValues.Strings[iCount];
                  if leftstr(tmpMetaFieldValue,11) = 'str_to_date' then
                       tmpMetaFieldValue:= #39 + Copy(tmpMetaFieldValue,14,2) +'.' +
                                           Copy(tmpMetaFieldValue,17,2) +'.' +
                                           Copy(tmpMetaFieldValue,20,4) + #39;

                  SQL.Text := 'Insert into slw_' + sTmpDesArcTbl +
                     ' (doc_id, doc_slw) ' + ' values  (' +
                     IntToStr(iDesDocID) + ', ' + tmpMetaFieldValue + ')';
                  try
                     Execute;
                  except
                     on e: Exception do
                     begin
                        lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                        Exit;
                     end;
                  end;
               end;

               if sQMetaField <> '' then
               begin
                  SQL.Text := 'update  arc_' + sTmpDesArcTbl + ' set ' +
                     sQMetaField + ' where doc_id=  ' + IntToStr(NewDocID);
                  try
                     Execute;
                  except
                     on e: Exception do
                     begin
                        lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                        Exit;
                     end;
                  end;
               end;
            end;
            //---------------------------------------------------------------------
            // VerknuepfenAnhandZusatzfelder //3.5.0.57 [2154]
            for iCount := 0 to slZMetaField.Count - 1 do
            begin
               lsFeldname := slZMetaField.Strings[iCount];
               lsSql := 'select '+lsFeldname+' from arc_'+sTmpDesArcTbl+ ' where doc_id = ' + IntToStr(NewDocID);
               lsZusatzfeldInhalt := DbTableColumnValue(lsSql);
               if lsZusatzfeldInhalt <> '' then
               begin
                  VerknuepfenAnhandZusatzfelder(DestArcDocId, lsFeldname, '', lsZusatzfeldInhalt);
               end;
            end;
            //------------------------------------------------------------------
            // alte Verknpfungen auf neue Doc_ID updaten
            SQL.Text := 'Update sys_doclnk set arc_id = ' + IntToStr(DesArcID) +
               ', doc_id = ' + IntToStr(iDesDocID) + ' where arc_id = ' +
               lsSrcArcID + ' and doc_id = ' + lsSrcDocID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------
            // alte Wvl auf neue Doc_ID updaten
            SQL.Text := 'Update sys_timer set arc_id = ' + IntToStr(DesArcID) +
               ', doc_id = ' + IntToStr(iDesDocID) + ' where arc_id = ' +
               lsSrcArcID + ' and doc_id = ' + lsSrcDocID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes(wvl):') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------
            // sys_gdocid auf neue Doc_ID updaten
            if lbhasgdocid1 then
            begin
               SQL.Text := 'Update sys_gdocid set arc_id = ' + IntToStr(DesArcID) +
                  ', doc_id = ' + IntToStr(iDesDocID) + ' where gdoc_id = ' +
                  IntToStr(ligdocid);
               try
                  Execute;
               except
                  on e: Exception do
                  begin
                     lErrorMsg(_('Fehler bei Verschieben eines Dokumentes(wvl):') + e.Message);
                     Exit;
                  end;
               end;
            end;
            //------------------------------------------------------------------
            // Neuen Historyeintrag in Zieltabelle erzeugen, dass das Dokument
            // verschoben wurde.
            SQL.Text := 'Insert into hst_' + sTmpDesArcTbl +
               ' (doc_id, usr_id, tstamp, task, task_info) ' + 'Value (' +
               IntToStr(iDesDocID) + ', ' + IntToStr(iGUsrID) + ', ' +
               #39 + sTStamp + #39 + ', 11, ' + #39 + _('Dokument aus Archiv ') +
               sTmpSrcArcName + ' Arcid:' + lsSrcArcID + ' ' +
               ' DocID:' + lsSrcDocID + _(' verschoben') + #39 + ')';
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------
            // alte Berechtigungen auf neue DocID ndern
            SQL.Text := 'Update sys_docxs set doc_id = ' + IntToStr(iDesDocID) +
               ', arc_id = ' + IntToStr(DesArcID) + ' where doc_id = ' +
               lsSrcDocID + ' and arc_id = ' + lsSrcArcID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;

            //------------------------------------------------------------------
            // if (liDestArcOptions and cArchivOptNameArchiv) <> 0 then
            if lsDefDocName<>'' then
            begin
               try
                  lsDocName := DbTableColumnValue(
                     'select DISP_NAME from arc_'+sTmpDesArcTbl+' where doc_id='+IntToStr(iDesDocID));
               except
                  on e: Exception do
                  begin
                     lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                     Exit;
                  end;
               end;
               if lsDocName = cDocNameDefault then
               begin
                  SQL.Text := 'Update arc_' + sTmpDesArcTbl + ' ' +
                                 'set DISP_NAME = ' + #39 + lsDefDocName + #39 + ' ' +
                                 'where doc_id = ' + IntToStr(iDesDocID);
                  try
                     Execute;
                  except
                     on e: Exception do
                     begin
                        lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                        Exit;
                     end;
                  end;

               end;
            end;

            //------------------------------------------------------------------
            // Schlagworte des Dokumentes aus Quelltabelle in Zieltabelle kopieren
            SQL.Text := 'Insert into slw_' + sTmpDesArcTbl +
               ' (doc_id, doc_slw) ' + 'Select Sql_No_cache ' +
               IntToStr(iDesDocID) + ' as doc_id, doc_slw from slw_' +
               sTmpSrcArcTbl + ' where doc_id = ' + lsSrcDocID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------
            // History des Dokumentes aus Quelltabelle in Zieltabelle kopieren
            SQL.Text := 'Insert into hst_' + sTmpDesArcTbl +
               ' (doc_id, usr_id, tstamp, task, task_info) ' +
               'Select Sql_No_cache ' + IntToStr(iDesDocID) +
               ' as doc_id, usr_id, tstamp, task, task_info from hst_' +
               sTmpSrcArcTbl + ' where doc_id = ' + lsSrcDocID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------

            if bMultiArcQuery then
            begin
               SQL.Text := 'delete from arc_' + sTmpSrcArcTbl + ' where doc_id=  ' +
                  lsSrcDocID;
               try
                  Execute;
               except
                  on e: Exception do
                  begin
                     lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                     Exit;
                  end;
               end;
            end
            else
            begin
               // hier wird der eintrag aus bzw. ber die Trefferliste gelscht
               dm_DB.my_q_Arc.Delete;
            end;

            //------------------------------------------------------------------
            // Alte Schlagworte des Dokumentes aus Quelltabelle lschen
            SQL.Text := 'delete from slw_' + sTmpSrcArcTbl + ' where doc_id = ' + lsSrcDocID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------
            // alten Historyeintrag entfernen
            SQL.Text := 'delete from hst_' + sTmpSrcArcTbl + ' where doc_id = ' + lsSrcDocID;
            try
               Execute;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
            //------------------------------------------------------------------
         end;

         // alles geschafft, dann Result = True
         Result := True;

         if (liopt and cZusatzFeldOptEingabepflicht) = 0 then
         begin
            try
               with slMoveFile do
               begin
                  Clear;
                  add('[Version]');
                  add('Version=3.0');
                  add('[Archiv]');
                  add('Profil=' + ChangeFileExt(ExtractFileName(sGConnection), ''));
                  add('Name=' + sTmpDesArcName);
                  add('Tabelle=' + sTmpDesArcTbl);
                  add('[Document]');
                  add('DOCID=' + IntToStr(DesArcID) + '.' + IntToStr(iDesDocID));
                  if lbhasgdocid then
                   Add('gdoc_id=' + IntToStr(ligdocid))
                  else
                   Add('gdoc_id=');
                  add('Titel=');
                  add('Orginal=' + sSrcFileName);
                  add('Kopie=' + sExtFileName);
                  add('Benutzer=');
                  add('Volltext=');
                  add('Status=');
                  add('StatStr=');
                  add('OCR_QF=');
                  add('OCR_Typ=');
                  add('Schlagworte=');
                  add('Datum=');
                  add('Quelle=' + sOriFileName);
                  add('[SVN]');
                  Add('SVN_Link=' + lsSVN_Link) ;
                  Add('SVN_Version=' + lsSVN_Version);
                  Add('SVN_Revision=' + lsSVN_Revision);

                  add('[Referenz]');
                  add('Anzahl=0');
                  add('[Zusatzfelder]');
                  //add('Felder=0');
                  add('Felder=' + IntToStr(slZMetaField.Count));
                  if slZMetaField.Count> 0 then   //3.5.0.56
                  begin
                     for i:= 0 to  slZMetaField.Count -1 DO
                     begin
                       add('ZusTitel' + inttostr(i+1)+'='+slZMetaName.Strings[i]);
                       add('ZusFeld'+ inttostr(i+1)+'='+slZMetaField.Strings[i]);
                       tmpMetaFieldValue:= slZMetaFieldValues.Strings[i];
                       if leftstr(tmpMetaFieldValue,1) = #39 then
                          tmpMetaFieldValue:=Copy(tmpMetaFieldValue,2,Length(tmpMetaFieldValue)-1);
                       if RightStr(tmpMetaFieldValue,1) = #39 then
                          tmpMetaFieldValue:=Copy(tmpMetaFieldValue,1,Length(tmpMetaFieldValue)-1);
                       if leftstr(tmpMetaFieldValue,11) = 'str_to_date' then
                          tmpMetaFieldValue:=Copy(tmpMetaFieldValue,14,10);
                       add('ZusWert'+ inttostr(i+1)+'='+tmpMetaFieldValue);

                       if tmpMetaFieldValue <> '' then
                       begin
                         dm_DB.my_q_DocMove.SQL.Text := 'SELECT Optionen FROM cfg_' + sTmpDesArcTbl + ' Where Feld_Name=' + #39 + slZMetaField.Strings[i] + #39 + ';';
                         try
                            dm_DB.my_q_DocMove.Execute;
                            FieldOption:= dm_DB.my_q_DocMove.fieldByName('Optionen').AsInteger;
                         except
                            on e: Exception do
                            begin
                               lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                               Exit;
                            end;
                         end;

                         if ( (FieldOption=2) or (FieldOption=3) or (FieldOption=6) or (FieldOption=7) )  then
                         begin
                           with dm_DB.my_cmd do
                           begin
                              SQL.Text :=
                                 'Insert into sys_doclnk (arc_id, doc_id, usr_id, ref_name, ref_lnk) Values ('
                                 +
                                 IntToStr(DesArcID) + ', ' + IntToStr(iDesDocID) + ', ' +
                                 IntToStr(iGUsrID) + ', ' + #39 + tmpMetaFieldValue + #39 + ', 0)';
                              Execute;
                              SQL.Text := 'Update sys_doclnk Set Ref_lnk = ' + IntToStr(InsertId) +
                                 ' where ref_id = ' + IntToStr(InsertId);
                              Execute;
                              NewHistoryID(4, _('Neue Verknpfung')+' ' + tmpMetaFieldValue +
                                 ' '+_('angelegt'), DesArcID, iDesDocID, iGUsrID);
                           end;
                         end;
                       end;
                     end;
                  end;

                  sFileName := ChangeFileExt(ExtractFileName(sSrcFileName), '');
                  while FileExists( sGClntSpool + sFileName + '.MOVE') do
                  begin
                      DateTimeToString(msec, 'zzz', now);
                      sFileName := sFileName + msec;
                  end;
                  SaveToFile(sGClntSpool + sFileName + '.MOVE');
               end;
            except
               on e: Exception do
               begin
                  lErrorMsg(_('Fehler bei Verschieben eines Dokumentes:') + e.Message);
                  Exit;
               end;
            end;
         end
   finally
      if Assigned(slMoveFile) then
         FreeAndNil(slMoveFile);
      if Assigned(slQMetaName) then
         FreeAndNil(slQMetaName);
      if Assigned(slQMetaField) then
         FreeAndNil(slQMetaField);
   end;
   GgfLogEvntEnd('MoveDoc - end');
end;



procedure Tfrm_MainForm.mnu_VisTlbStdClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisTlbStdClick');
   tlb_ViewerCtrl.Visible := mnu_VisTlbStd.Checked;
end;

procedure Tfrm_MainForm.mnu_VisTlbFavClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisTlbFavClick');
   tlb_Favoriten.Visible := mnu_VisTlbFav.Checked;
end;

procedure Tfrm_MainForm.mnu_VisTlbLgrClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisTlbLgrClick');
   tlb_Lager.Visible := mnu_VisTlbLgr.Checked;
end;

procedure Tfrm_MainForm.mnu_VisTlbArcClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisTlbArcClick');
   tlb_Lager.Visible := mnu_VisTlbArc.Checked;
end;

procedure Tfrm_MainForm.mnu_VisSaveClick(Sender: TObject);
var
   reg: Tregistry;
   lsmypr, lsmyp: Tstringlist;
   lii: integer;
   lcsw: TTBCustomDockableWindow;
begin
   GgfLogEvnt('mnu_VisSaveClick');
   fms_MainForm.Active := True;
   fms_MainForm.SaveFormPlacement;
   //  save (un)docked forms state
   reg := TRegistry.Create;
   lsmyp := Tstringlist.create;
   lsmypr := Tstringlist.create;
   try
      try
         lsmyp.Add('dpnl_LgrArc_');
         lsmyp.Add('dpnl_Suchen_');
         lsmyp.Add('dpnl_Thumbs_');
         lsmyp.Add('dpnl_manfav_');
         lsmyp.Add('dpnl_Wvlg_');
         lsmypr.Add('Floating');
         lsmypr.Add('Floating_x');
         lsmypr.Add('Floating_y');
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey(fms_MainForm.IniFileName + '\' + fms_MainForm.IniSection, True);
            for  lii := 0 to lsmyp.Count - 1 do
            begin
               lcsw := TTBCustomDockableWindow(frm_mainform.FindComponent(copy(lsmyp.Strings[lii], 1,
                  length(lsmyp.Strings[lii]) - 1)));
               writebool(lsmyp.Strings[lii] + lsmypr.Strings[0], lcsw.Floating);
               writeinteger(lsmyp.Strings[lii] + lsmypr.Strings[1], lcsw.FloatingPosition.x);
               writeinteger(lsmyp.Strings[lii] + lsmypr.Strings[2], lcsw.FloatingPosition.y);
            end;
            closekey;
         end;
      except
         // Mach was...
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(lsmyp) then
         FreeAndNil(lsmyp);
      if Assigned(lsmypr) then
         FreeAndNil(lsmypr);
   end;
end;

procedure Tfrm_MainForm.mnu_VisLoadClick(Sender: TObject);
var
   reg: Tregistry;
   lsmypr, lsmyp: Tstringlist;
   lii: integer;
   lcsw: TTBCustomDockableWindow;
   lp: Tpoint;
begin
   GgfLogEvntBeg('mnu_VisLoadClick');
   dock_MainForm_Top.beginupdate;
   dock_MainForm_Left.beginupdate;
   fms_MainForm.Active := True;
   GgfLogEvnt('fms_MainForm.RestoreFormPlacement');
   fms_MainForm.RestoreFormPlacement;
   dock_MainForm_Top.endupdate;
   dock_MainForm_Left.endupdate;

   reg := TRegistry.Create;
   lsmyp := Tstringlist.create;
   lsmypr := Tstringlist.create;
   try
      try
         lsmyp.Add('dpnl_LgrArc_');
         lsmyp.Add('dpnl_Suchen_');
         lsmyp.Add('dpnl_Thumbs_');
         lsmyp.Add('dpnl_manfav_');
         lsmyp.Add('dpnl_Wvlg_');
         lsmypr.Add('Floating');
         lsmypr.Add('Floating_x');
         lsmypr.Add('Floating_y');
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey(fms_MainForm.IniFileName + '\' + fms_MainForm.IniSection, True);
            for  lii := 0 to lsmyp.Count - 1 do
            begin
               if valueexists(lsmyp.Strings[lii] + lsmypr.Strings[0]) then
               begin
                  lcsw := TTBCustomDockableWindow(frm_mainform.FindComponent(copy(lsmyp.Strings[lii], 1,
                     length(lsmyp.Strings[lii]) - 1)));
                  lcsw.Floating := bool(readinteger(lsmyp.Strings[lii] + lsmypr.Strings[0]));
                  lp.x := readinteger(lsmyp.Strings[lii] + lsmypr.Strings[1]);
                  lp.y := readinteger(lsmyp.Strings[lii] + lsmypr.Strings[2]);
                  lcsw.FloatingPosition := lp;
               end;
            end;
            closekey;
         end;
      except
         // Mach was...
      end;
   finally
      if Assigned(reg) then
         FreeAndNil(reg);
      if Assigned(lsmyp) then
         FreeAndNil(lsmyp);
      if Assigned(lsmypr) then
         FreeAndNil(lsmypr);
   end;
   GgfLogEvntEnd('mnu_VisLoadClick');
end;

procedure Tfrm_MainForm.mnu_VisReDrawClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisReDrawClick');
   tlb_Favoriten.Visible := False;
   tlb_Lager.Visible := False;
   tlb_MainMenu.Visible := False;
   tlb_ViewerCtrl.Visible := False;
   tlb_Favoriten.Visible := mnu_VisTlbFav.Checked;
   tlb_Lager.Visible := mnu_VisTlbLgr.Checked;
   tlb_MainMenu.Visible := True;
   tlb_ViewerCtrl.Visible := mnu_VisTlbStd.Checked;
end;

procedure Tfrm_MainForm.mnu_ReLoginClick(Sender: TObject);
var lbtvor, lbtstat: boolean;  hd: HWND;
begin
   GgfLogEvnt('mnu_ReLoginClick');
//   lbtvor := dm_MainForm2.tim_voransicht.enabled;
   lbtstat := dm_MainForm2.tim_statustext.enabled;
//   dm_MainForm2.tim_voransicht.enabled := false;
   dm_MainForm2.tim_statustext.enabled := false;
   dm_MainForm2.tim_ChkTasks.enabled := false;
   dm_MainForm2.tim_SelPage.Enabled := False;
   dm_MainForm2.tim_SelLgrArc.Enabled := False;
   dm_MainForm2.tim_Thumb.Enabled := False;
   dm_MainForm2.tim_Blank.Enabled := False;
   dm_MainForm2.tim_DocStat.Enabled := False;
   dm_MainForm2.tim_docload.Enabled := False;
   dm_MainForm2.tim_changedocpage.Enabled := False;
   dm_MainForm2.tim_markpages.Enabled := False;
   dm_MainForm2.tim_annosshow.Enabled := False;
   dm_MainForm2.tim_changewvl.Enabled := False;

   ShutDownApp(0);
   frm_MainForm.FormShow(self);

//   dm_MainForm2.tim_voransicht.enabled := lbtvor;
   dm_MainForm2.tim_statustext.enabled := lbtstat;
   hd := FindWindow('bitfarm.hotsearch.V3', nil);
   GgfLogEvnt('mnu_ReLoginClick vor Message WM_HOTKEY_RECONNECT');
   PostMessage(hd, WM_HOTKEY_RECONNECT, 1, 1);
   GgfLogEvnt('mnu_ReLoginClick nach Message WM_HOTKEY_RECONNECT');
end;


procedure Tfrm_MainForm.dbgrd_TrefferlisteKeyUp(Sender: TObject;
   var Key: word; Shift: TShiftState);
var
   iLastRec, i: integer;
begin
   GgfLogEvnt('dbgrd_TrefferlisteKeyUp Key='+IntToStr(Key)+ ' Ctrl='+IntToStr(ord(shift = [ssCtrl])));
   outputdebugstring(pchar('Key='+IntToStr(Key)+ ' Ctrl='+IntToStr(ord(shift = [ssCtrl])))); //3.5.0.29

   if shift = [] then
   begin
      case key of
         vk_up, vk_down, vk_prior, vk_next, vk_home, vk_end:
         begin
//            dm_MainForm2.tim_voransicht.Enabled := False;
            HandleDoc; GgfLogEvnt('HandleDoc a');
//            dm_MainForm2.tim_voransicht.Enabled := True;
         end;
         vk_Space:
         begin
//            dm_MainForm2.tim_voransicht.Enabled := False;
            tbi_VEditClick(self);
//            dm_MainForm2.tim_voransicht.Enabled := True;
         end;
      end;
   end;
   if (shift = [ssCtrl]) then  //3.5.0.22
   begin
      if  ((Key = $41) or (key = $61)) then
      begin
      	i := 0;
         GSelection := nil;
         SetLength(GSelection, dbgrd_Trefferliste.DataSource.DataSet.RecordCount);
         with dbgrd_Trefferliste.DataSource.DataSet do
         begin
            iLastRec := RecNo;
            First;
            DisableControls;
            dbgrd_Trefferliste.Enabled := False;
            while not EOF do
            begin
               dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
               GSelection[i] := dbgrd_Trefferliste.DataSource.DataSet.FieldByName('doc_id').AsInteger;
               Next;
               inc(i);
            end;
            dbgrd_Trefferliste.Enabled := True;
            EnableControls;
            RecNo := iLastRec;
         end;
         wvlhasfocus := False;
         dbgrd_Trefferliste.SetFocus;
      end;
   end;
end;

procedure Tfrm_MainForm.FormResize(Sender: TObject);
begin
   if not gbshutdownapp then
   begin
     GgfLogEvnt('FormResize');
     tbsi_VZoomClick(self);
	 end;
end;


function Tfrm_MainForm.LoadTrefferlisteFromFile(ArcName: string): Boolean;
var
	recno, iCnt: Integer;
begin
	Result:= False;

   if Trefferlistealreadyloaded then
   	Exit;

   if ArcName = '' then
   	Exit;
   if dm_DB.my_q_Arc.Active then
      dm_DB.my_q_Arc.Close;

   try
      if FileExists(ResultlistDesignPath + '\' + ArcName + '.bfa') then
      begin
         dbgrd_TrefferListe.Columns.Clear;
         dbgrd_TrefferListe.Columns.Add;
         dbgrd_TrefferListe.Columns.Add;
			dbgrd_TrefferListe.Columns.Add;
         for iCnt := 0 to iGZusFCount -1 do
         	dbgrd_TrefferListe.Columns.Add;

         dbgrd_TrefferListe.ClearSorting;
         dbgrd_Trefferliste.ClearFilters;
         try
            dbgrd_TrefferListe.Columns.LoadFromFile(ResultlistDesignPath + '\' + ArcName + '.bfa');
         except
            on e: Exception do
            begin
              LogEvnt('Fehler beim Auslesen der bfa.hit Datei: ' + ArcName + '.bfa' + #13 + e.Message);
	           Exit;
            end;
         end;
         Result := True;
         Trefferlistealreadyloaded := True;
      end
      else
      if FileExists(BD.ExeDir + 'bfa_hit' + '\' + ArcName + '.bfa') then
      begin
      	dbgrd_TrefferListe.Columns.Clear;
			dbgrd_TrefferListe.Columns.Add;
         dbgrd_TrefferListe.Columns.Add;
			dbgrd_TrefferListe.Columns.Add;
         for iCnt := 0 to iGZusFCount -1 do
         	dbgrd_TrefferListe.Columns.Add;

         dbgrd_TrefferListe.ClearSorting;
         dbgrd_Trefferliste.ClearFilters;
         try
            dbgrd_TrefferListe.Columns.LoadFromFile(BD.ExeDir + 'bfa_hit\' + ArcName + '.bfa');
         except
            on e: Exception do
            begin
              LogEvnt('Fehler beim Auslesen der bfa.hit Datei: ' + BD.ExeDir + 'bfa_hit\' + ArcName + '.bfa' + #13 + e.Message);
	           Exit;
            end;
         end;
         Result := True;
         Trefferlistealreadyloaded := True;
      end;
   finally

	end;
end;



procedure Tfrm_MainForm.btn_ResFieldsClick(Sender: TObject);
var
   lbmultiarc: boolean;
begin
   GgfLogEvntBeg ('btn_ResFieldsClick Begin');

   if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveobjects(False,False);
      
   if (GHasNotBeenSavedAfterModify or ((gtmpiStatus xor gotmpistatus) > 0) or
      btn_SaveDoc.Enabled) and (dm_db.my_q_arc.recordcount > 0) then
   begin
      if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
         #13 + _('Mchten Sie die nderungen speichern?'),
         true) = mrYes then
      begin
         tbi_VSaveDocClick(self);
      end;
      GHasNotBeenSavedAfterModify := false;
      fgchangedvoransicht := False;
      fgchangedvoransichttif := False;
      gtmpiStatus := gotmpistatus;
   end;

   ftnlastbacknode := nil;

   gbTrefferlisteFiltered:= dbgrd_Trefferliste.filtered;
   btn_SaveDoc.Enabled := false;
   tbi_VSaveDoc.Enabled := false;
   frm_MainForm.reset := True;
   fra_voransicht.img_DocView.IO.Aborting := true;
   lbl_choosenLink.Caption;
   // Grafische Anzeige der Gruppe als linkMaenge ausschalten
   img_link.Visible := False;
   lbl_choosenLink.Hint := _('Keine Referenz ausgewhlt.');
   lbl_choosenLink.Enabled := False;
   dm_db.tim_searcharc.Enabled := False;
   frm_MainForm.pnl_SrcTime.ParentBackground := True;
   frm_MainForm.pnl_docTime.ParentBackground := True;
   frm_MainForm.pnl_SrcTime.Color := frm_MainForm.pnl_SuchOpt.Color;
   frm_MainForm.pnl_docTime.Color := frm_MainForm.pnl_SuchOpt.Color;
   pnl_SrcTime.Caption := '';
   pnl_docTime.Caption := '';
   chbx_SOnlyUsed.Checked := False;
//   dm_MainForm2.tim_voransicht.Enabled := False;
   JvgCb_slw.Checked := true;
   JvgCb_user.Checked := true;
   JvgCb_date.Checked := true;

   if (Sender is TBitBtn) or (Sender is TToolButton) then
   begin
      if dm_DB.thr_Arc.OneThreadIsRunning then
      begin
         dm_DB.thr_Arc.LastThread.Terminate;
         // wait till document is loaded, else it will result in a broken connection
         while (gbArcHandling) do
         begin
            sleep(10);
         end;
         dm_DB.my_conArc.Disconnect;
      end;
   end;

   ResetAnzeige;
   dm_DB.tim_ansicht.enabled := false;
   lbmultiarc := chbx_SRefSea.Checked;
   resetSuchFelder;
   //reset statusfeld suche
   gmodiStatus := 0;
   gmodsearchiStatus := 0;
   cbx_VZoom.Text := '';
   wvlhasfocus := False;
   wvlshowbuttons(False);
   iGLastArcAnnos := 0;
   iGLastDocAnnos := 0;

   //skywalker reload the wvl if already not done!
   if loadingfromwclcellclick = 0 then
   begin
      // lets set to 2 so we dont need to reload next time
      // set to 1 could be ok, but we dont want to overload it, dont we?
      loadingfromwclcellclick := 2;
      // dont show the mark on the wvl!
      dbgrd_wvl.hide;
      dbgrd_wvl.Show;
   end;

   if bMultiArcQuery then
   begin
      iGArcID := -1;
      if dm_DB.thr_Arc.OneThreadIsRunning then
      begin
         dm_DB.thr_Arc.LastThread.Terminate;
         dm_DB.my_conArc.Disconnect;
      end;
   end;
   if not lbmultiarc then
      cbx_ArchivChange(self);
   if gbArcHandling then
   begin
      gbArcHandling := False;
   end
   else
   begin
      frm_MainForm.reset := False;
   end;

   GgfLogEvntEnd ('btn_ResFieldsClick End');
end;

procedure Tfrm_MainForm.dbnav_TrefferlisteClick(Sender: TObject; Button: TNavigateBtn);
begin
   GgfLogEvnt('dbnav_TrefferlisteClick');
   if dm_DB.my_q_Arc.RecNo = iGArcRecNo then
      exit
   else
   begin
      dbgrd_Trefferliste.SelectedRows.Clear;
      dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
      HandleDoc;
   end;
end;

procedure Tfrm_MainForm.mnu_NewPassClick(Sender: TObject);
var lsPass: string;
begin
   GgfLogEvnt('mnu_NewPassClick');

   Application.CreateForm(Tfrm_NewPass, frm_NewPass);
   try
      frm_NewPass.ShowModal;
      if frm_NewPass.ModalResult = mrOk then
         frm_mainform.setpanelinfo(_('Ihr Passwort wurde gendert!'));
   finally
      frm_NewPass.Release;
   end;
end;

// SUCHEN
// Suche starten
procedure Tfrm_MainForm.btn_StartSrcClick(Sender: TObject); //[2328]

procedure NoRight;
   begin
      frm_mainform.setpanelinfo(_('Keine Berechtigung das Archiv zu durchsuchen.'));
      dm_db.tim_searcharc.Enabled := False;
      frm_MainForm.pnl_SrcTime.ParentBackground := True;
      frm_MainForm.pnl_docTime.ParentBackground := True;
      frm_Mainform.pnl_SrcTime.Caption := '';
   end;

var
   TmpLst: TStringList;
   iCount, iTmpID: integer;
   lbHasRights: boolean;
   lsTmpArcname: string;

procedure DoOne;
   begin
      with dm_DB.my_q_LgrArc do
      begin
         First;
         while not EOF do
         begin
            if FieldByName('arc_id').AsInteger = iTmpID then
            begin
               lbHasRights := false;

               dm_db.my_q_tmp_CreStatus.sql.Text :=
                  'select * from sys_arcxs   where   arc_id = ' +
                  IntToStr(iTmpID) + ' and usr_id = ' + IntToStr(iGUsrID) +
                  ' and (' + 'FIND_IN_SET(' + #39 + 'list' + #39 + ', rights))';
               dm_db.my_q_tmp_CreStatus.Execute;
               if dm_db.my_q_tmp_CreStatus.RecordCount > 0 then
               begin
                  lbHasRights := true;
               end;

               if lbHasRights then
               begin
                  GArcSList[iCount].ArcID := iTmpID;
                  GArcSList[iCount].ArcName := lsTmpArcname;
                  GArcSList[iCount].TblName := FieldByName('arc_tblname').AsString;
               end;
               break;
            end
            else
               Next;
         end;
      end
   end;


begin
	if gbStartSrcClick then
   	Exit;
   GgfLogEvntBeg('btn_StartSrcClick beg');

   gbStartSrcClick := True;
	try
      pnl_SrcTime.Caption := _('Suche aktiv ...');
      Screen.Cursor := crHourGlass;
      dm_DB.tim_searcharc.Enabled := True;
      pnl_SrcTime.ParentBackground := False;
      pnl_SrcTime.Color := clRed;
      dm_MainForm2.tim_Blank.Enabled := True;
      gbsearched := True;
      dm_db.my_q_arc.IndexFieldNames := '';

      if chbx_SRefSea.Checked then
      begin
         // parse the .text
         if not fra_DocLink.SeaLink(ParseSemicolonWithoutBackslash(edt_SRefSea.Text)) then
         begin
            dm_db.tim_searcharc.Enabled := False;
            frm_MainForm.pnl_SrcTime.ParentBackground := True;
            frm_MainForm.pnl_docTime.ParentBackground := True;
            frm_MainForm.pnl_SrcTime.Color := frm_MainForm.pnl_SuchOpt.Color;
            frm_MainForm.pnl_docTime.Color := frm_MainForm.pnl_SuchOpt.Color;
            pnl_SrcTime.Caption := '';
            pnl_docTime.Caption := '';

            if (Sender is TBitBtn) or (Sender is TToolButton) then
            begin
               if dm_DB.thr_Arc.OneThreadIsRunning then
               begin
                  dm_DB.thr_Arc.LastThread.Terminate;
                  // wait till document is loaded, else it will result in a broken connection
                  while (gbArcHandling) do
                  begin
                     sleep(10);
                  end;
                  dm_DB.my_conArc.Disconnect;
               end;
            end;
            Resetanzeige;
         end;
         exit;
      end;
      dm_MainForm2.mnu_TGoToArc.Visible := False;
      fra_Volltext.redt_Volltext.Clear;
      iGArcRecNo := -1;
      iGBorderRem := 1;
      //while in login someone can through the hotsearch initiate a search!!!
      if dbtv_LgrArc.TopItem = nil then
         exit;

      if dbtv_LgrArc.SelectionCount = 0 then
         dbtv_LgrArc.Select(dbtv_LgrArc.TopItem, []);
      case dbtv_LgrArc.Selected.ImageIndex of
         0, 2: begin
                  if not bMultiArcQuery then
                  begin
                     bMultiArcQuery := True;
                     CreateStandardColumnsTRefferliste;
                  end
                  else
                  begin
                     bMultiArcQuery := True;
                  end;
               end;
         1, 3: begin if bMultiArcQuery then
                  begin
                     iGArcID := -1;
                     cbx_ArchivChange(self);
                  end;
                  bMultiArcQuery := False;
               end;
      end;
      //  only show hitlist if
      //  the user has rights to read the arc!
      //  this doesnt makes sense, it should read first the rights, which will come later!!!
      //  if (rGDocRight.Read or rGArcRight.list) then

      TmpLst := TStringList.Create;
      try
         TmpLst.Clear;
         SetLength(GArcSList, 0);
         if not bMultiArcQuery then
         begin
            if cbx_Archiv.ItemIndex <> -1 then
            begin
               iCount := 0;
               SetLength(GArcSList, 1);
               iTmpID := integer(cbx_Archiv.Items.Objects[cbx_Archiv.ItemIndex]);
               lsTmpArcname := dm_DB.my_q_LgrArc.FieldByName('arc_name').AsString;
               DoOne;
            end;
         end
         else
         begin
            GetChilds(dbtv_LgrArc.Selected, TmpLst);
            SetLength(GArcSList, TmpLst.Count);
            for iCount := 0 to (TmpLst.Count - 1) do
            begin
               iTmpID := integer(TmpLst.Objects[iCount]);
               lsTmpArcname := TmpLst.Strings[iCount];
               DoOne;
            end;
         end;
      finally
         FreeAndNil(TmpLst);
      end;

      if ((GArcSList = nil)) then
      begin
         NoRight; Exit;
      end;

      if ((GArcSList[0].TblName = '') and (not bMultiArcQuery)) then
      begin
         NoRight; Exit;
      end;

      // while loading dbgrd_trefferliste layout trefferlistealreadyloaded must be false!
      trefferlistealreadyloaded := False;
      GgfLogEvnt('SetControls(False)c'); //3.5.0.22
      SetControls(False); // Beim Suchen die Schaltflchen ausschalten  //3.5.0.22

      SuchArc;

      // in init when no arc and lgr is choosen it should show nothing!
      if ((iGarcID = 0) and (igLgrID = 0)) then
         ArcSQL('SELECT * from sys_arc where arc_id = 0');

   finally
      wvlhasfocus := False;
      wvlshowbuttons(False);
      dbgrd_wvl.Refresh;

      if dbgrd_Trefferliste.DataSource.DataSet.RecordCount = 0 then
      begin
         ResetStatus(True);
         ClearZusFieldsNotsearched;
      end
      else
         Trefferlistealreadyloaded := True;

      Screen.Cursor := crDefault;
      gbStartSrcClick := False;
	end;

   GgfLogEvntEnd('btn_StartSrcClick end');
end;

function Tfrm_MainForm.ShutDownApp(fic: integer): boolean;
   /////////////////////////////////////////////////////////////
   ///  03.05.2005 Erstellt (sv)                             ///
   ///                                                       ///
   ///  Diese Procedure schliet alle Datenbank Verbindungen ///
   ///  und lscht die Temporre Usertabelle.                ///
   ///                                                       ///
   ///  Ausgabe: keine   ... warum auch                      ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   reg: TRegistry;
   bSavLgrArc: boolean;
   icount: integer;
begin
   GgfLogEvnt('ShutDownApp');

   gbViewerShutDown:= true;

   try
      DocViewSavesSave(gDocViewSaves); //3.5.0.53 [2304]
      gbshutdownapp := True;
      dm_db.floadingmainview := false;
      if thr_voransicht <> nil then
      begin
        thr_voransicht.terminate;
        thr_voransicht.WaitFor;
      end;
      dm_db.tim_ansicht.Enabled := false;
      reg := TRegistry.Create;
      Result := True;
      mnu_VisSaveClick(self);
      SaveLgrArcStat;
      Savetv_leseStat;
      with reg do
      begin
        try
           try
              RootKey := HKEY_CURRENT_USER;
              // Einlesen der Options-Einstellungen
              OpenKey('Software\bitfarm\Archiv_V3\Viewer\Optionen', True);
              if ValueExists('SavLastArcLgr') then
                 bSavLgrArc := ReadBool('SavLastArcLgr')
              else
              begin
                 // the default is to save it! so if the key doesnt exist save it!
                 bSavLgrArc := True;
                 WriteBool('SavLastArcLgr', bSavLgrArc);
              end;

              if bSavLgrArc and (dbtv_LgrArc.Selected <> nil)then
                  WriteString('StdArcID',IntToStr(integer(dbtv_LgrArc.Selected.Data)));

              CloseKey;
              OpenKey('Software\bitfarm\Archiv_V3\Viewer\', True);
              deletekey('wvl');
              CloseKey;
              // save wvl
              OpenKey('Software\bitfarm\Archiv_V3\Viewer\wvl', True);
              WriteInteger('iGTaskCount', iGTaskCount);
              for icount := 0 to iGTaskCount - 1 do
              begin
                 WriteInteger('tim_id' + IntToStr(icount), iGtim_id[icount]);
              end;
              CloseKey;
           except
              on e: Exception do
              begin
                 Result := False;
                 ErrorMsg('ShutDownApp',
                    _('Fehler beim Einlesen der Registrierung:') +
                    e.Message, 2029,
                    True);
              end;
           end;
        finally
           if Assigned(reg) then
              FreeAndNil(reg);
        end;
      end;
      Savefavtree;
      gbsearched := false;

      try
         DisableAllTimer
      except
          on e:Exception do
            LogEvnt(_('Fehler bei ShutDownApp:')+e.Message);
      end;

      if fic = 1 then
      begin
         if Assigned(BM1) then   // f.schneider v3.5.1.62
             BM1 := nil;
         if Assigned(BM2) then
             BM2 := nil;

        tv_lese.Items.Clear;

         if Assigned(tsl_export) then
            FreeAndNil(tsl_export);

        dm_MainForm2.tim_ChkTasks.Enabled := False;

        try
           if (not btn_StartSrc.Enabled) and (dm_DB.my_conArc.Connected) then
              dm_DB.my_ConArc.Disconnect;
        except
        end;
        DelZusFields2(true);
        with dm_DB do
        begin
            if my_con.Connected then
            begin
               my_cmd.SQL.Text := 'Drop table if exists tmp_' + sGTmpName;
               my_cmd.Execute;

               if my_q_Tmp.Active then
						my_q_Tmp.Close;
               if my_q_Hst.Active then
                	my_q_Hst.Close;
               if my_q_Lnk.Active then
                	my_q_Lnk.Close;
               if my_q_Time.Active then
                	my_q_Time.Close;
               if my_q_LgrArc.Active then
	                my_q_LgrArc.Close;
               try
                  if my_Ctrl.Active then
							my_Ctrl.Close;
               except
               end;
               my_con.Close;
               my_con.Disconnect;
            end;

            if my_conArc.Connected then
            begin
               if my_q_Arc.Active then
               	my_q_Arc.Close;
         		if my_q_sysarc.Active then
                	dm_DB.my_q_sysarc.Close;
               if my_q_usr.Active then
	            	dm_DB.my_q_usr.Close;

               my_ConArc.Close;
               my_ConArc.Disconnect;
            end;
            if my_con_wvl_timer.Connected then
            begin
               if my_q_wvl_timer.Active then
               	my_q_wvl_timer.Close;

               my_con_wvl_timer.Close;
               my_con_wvl_timer.Disconnect;
            end;
        end;
        dm_MainForm2.XmlToDomParser_local.DOMImpl.Clear;
        dm_MainForm2.xmltodomparser_global.DOMImpl.Clear;
        dm_MainForm2.XmlToDomParser_history.DOMImpl.Clear;
        vst_favfile.Clear;
      end;
	except

  	end;
end;

procedure Tfrm_MainForm.DisableAllTimer;
begin
	try
      dm_DB.tim_searcharc.Enabled := False;
      dm_MainForm2.tim_ChkTasks.Enabled := False;
      dm_MainForm2.tim_docload.Enabled := False;
      dm_MainForm2.tim_annosshow.Enabled := False;
      dm_MainForm2.tim_changewvl.Enabled := False;
      frm_MainForm.timer_autoscroll.Enabled := False;
   except
       on e:Exception do
       	LogEvnt(_('Fehler bei DisableAllTimer:')+e.Message);
   end;
end;



procedure Tfrm_MainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
	i: integer;
begin
   if gbDocMove or
   	gbLgrArcSet or
      gbArchivChange or
      gbSaveDoc or
      gbwvlcellclick then
      Exit;

   GgfLogEvnt('FormClose');
	try
   {$ifdef DXGETTEXTDEBUG}
   DefaultInstance.DebugLogToFile(BD.LogPath+'\gnugettext.log');
   {$endif}

   fra_voransicht.img_DocView.CancelInteracts;

     for i:=0 to dm_DB.ComponentCount-1 do
     begin
	     if dm_DB.Components[i] is TTimer then
     		 TTimer(dm_DB.Components[i]).Enabled := False;
     end;
     for i:=0 to dm_MainForm2.ComponentCount-1 do
     begin
	     if dm_MainForm2.Components[i] is TTimer then
     		 TTimer(dm_MainForm2.Components[i]).Enabled := False;
     end;
     for i:=0 to frm_MainForm.ComponentCount-1 do
     begin
	     if frm_MainForm.Components[i] is TTimer then
     		 TTimer(frm_MainForm.Components[i]).Enabled := False;
     end;

   ShutDownApp(1);
   except
   end;
end;

procedure Tfrm_MainForm.ChangeDocPage(Func: integer); //fbjump:boolean);
var
   iPage, liindex: integer;
   sIEVFile, sDocFile, sTmpFile: string;
begin
   GgfLogEvntBeg('ChangeDocPage begin');
   try
//      dm_MainForm2.tim_voransicht.Enabled := False;
      try
         with fra_Voransicht.img_DocView do
         begin
            iPage := IO.Params.Tiff_ImageIndex;
            case Func of
               0:
                  IO.Params.TIFF_ImageIndex := -1;
               1:
                  Inc(iPage);
               2:
                  Dec(iPage);
            end;
            if iPage < 0 then
               iPage := IO.Params.Tiff_ImageCount - 1;
            if iPage > (IO.Params.Tiff_ImageCount - 1) then
               iPage := 0;

            if (frm_MainForm.reset) then
            begin
               gbArcHandling := False;
               frm_MainForm.reset := False;
               resetmyqarc;
               exit;
            end;
            if dm_db.my_q_Arc.FieldDefList.Find('doc_loc') <> nil then
            begin
               try
                  if not dm_db.my_q_Arc.active then
                  begin
                     gbArcHandling := False;
                     frm_MainForm.reset := False;
                     //          resetmyqarc;
                     exit;
                  end;

                  if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0 then
                  begin
                     liindex := 0;
                     frm_mainform.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := true;
                  end
                  else
                  begin
                     liindex := frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1;
                  end;

                  if iGArcRecNo <> dm_db.my_q_arc.RecNo then
                  begin
                     try
                        if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count <> 0 then
                        begin
                           dm_db.my_q_Arc.GotoBookmark(
                              Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[liindex]));
                        end;
                     except on e: exception do
                        begin
                           logevnt('error by gotobookmark in changedocpage:' + e.message);
                        end;
                     end;
                  end;

                  sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
                  sTmpFile := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
                  sGdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
                  sGextfilename := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
               except
                  on e: Exception do
                  begin
                     gbArcHandling := False;
                     frm_MainForm.reset := False;
                     resetmyqarc;
                     exit;
                  end;
               end;
               if dm_db.tannoscheck <> nil then
               begin
                  dm_db.tannoscheck.WaitFor;
               end;
               if ObjectsCount > 0 then
               begin
                  try
                     RemoveAllObjects;
                  except on e: exception do
                     begin
                     end;
                  end;
               end;
               frm_MainForm.fra_Volltext.clearobjslist;
               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;
               if (sTmpFile <> '')
               then
               begin
                  if FileExists(sTmpFile) then
                  begin
                     sDocFile := sTmpFile;
                  end
                  else
                  begin
                     sGextfilename := '';
                  end;
               end
               else
                  sGextfilename := '';

               if (frm_MainForm.reset) then
               begin
                  gbArcHandling := False;
                  frm_MainForm.reset := False;
                  resetmyqarc;
                  exit;
               end;
               if tbx_pubNote.Checked then
               begin
                  sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(iPage) + '.IEV';
               end;
               if tbx_privNote.Checked then
               begin
                  sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(iPage) +
                     'P' + IntToStr(iGPrivAnnoID) + '.IEV';
               end;

               IO.Params.Tiff_ImageIndex := iPage;
               try
                  IO.LoadFromFile(sDocFile);
               except
                  on e: Exception do
                  begin
                  end;
               end;

               if (frm_MainForm.reset) or
                  (frm_mainform.fra_voransicht.img_DocView.IO.Aborting) then
               begin
                  gbArcHandling := False;
                  frm_MainForm.reset := false;
                  if (frm_MainForm.reset) then
                  begin
                     resetmyqarc;
                  end;
                  exit;
               end;
               if IO.Params.ImagingAnnot.ObjectsCount > 0 then
                  IO.Params.ImagingAnnot.CopyToTImageEnVect(fra_Voransicht.img_DocView);

               sIEVFile := StringReplace(sIEVFile, SGArcPath, SGCopyPath, [rfReplaceAll,rfIgnoreCase]);
               if FileExists(sIEVFile) and tbi_VShowAnno.Checked then
               begin
                  LoadFromFileIEV(sIEVFile);
                  GgfLogEvnt('LoadFromFileIEV M8');
                  fra_Voransicht.updateobjects;
               end;

               tbsi_VZoomClick(self);
            end;
            if dpnl_Thumbs.Visible and (func <> 0) then
            begin
               if not fselectingthumb then
               begin
                  tmb_Voransicht.deselect;
                  tmb_Voransicht.SelectedImage := iPage;
               end;
            end;
            tbxse_page.Text := inttostr(fra_Voransicht.img_DocView.IO.Params.TIFF_ImageIndex + 1);
            lbl_VSeite.Caption := _('von') + ' ' +
               IntToStr(IO.Params.Tiff_ImageCount) + ' ';
         end;
      except on e: exception do
         begin
            logevnt(' changedocpage:' + e.message);
         end;
      end;
   finally
      begin
//         dm_MainForm2.tim_voransicht.Enabled := true;
      end;
      GgfLogEvntEnd('ChangeDocPage end');
   end;
end;

procedure Tfrm_MainForm.ActivateLinkDoc(Active: boolean);
//////////////////////////////////////////////////////////////////
///  12.05.2005 Erstellt by SV.                                ///
///                                                            ///
///  Diese Procedure schaltet die Taste [Dokument Verknpfen]  ///
///  ein oder aus.                                             ///
///                                                            ///
//////////////////////////////////////////////////////////////////
begin
   GgfLogEvntBeg('ActivateLinkDoc - begin');
   if Active and rGDocRight.link then
   begin
      TBXItem37.Enabled := True;
      TBXItem37.Hint := _('Aktuelles Dokument mit Referenz ') +
         lbl_ChoosenLink.caption + ' ' + _('verknpfen');
   end
   else
   begin
      TBXItem37.Enabled := False;
      TBXItem37.Hint := _('Zur Zeit ist keine Referenz aktiv.');
   end;
   GgfLogEvntEnd('ActivateLinkDoc - end');
end;

procedure Tfrm_MainForm.mnu_EndeClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_EndeClick');
   mnu_VisSaveClick(self);
   frm_MainForm.Close;
end;

// anzeige zurcksetzen
procedure Tfrm_MainForm.mnu_VisResetClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_VisResetClick');
   fms_MainForm.Active := False;
   fms_MainForm.IniSection := 'Default';
   fms_MainForm.RestoreFormPlacement;
   fms_MainForm.Active := True;
   fms_MainForm.Active := False;
   fms_MainForm.IniSection := 'MainForm';
end;

procedure Tfrm_MainForm.mnu_OptClick(Sender: TObject);
begin
   GgfLogEvnt('mnu_OptClick');
   Application.CreateForm(Tfrm_Optionen, frm_Optionen);
   frm_Optionen.ShowModal;
   frm_Optionen.Release;
   ReadReg; 
   Optbybut := False;
end;



//  Tastatur abfrage fuer Kurztasten    Hotkey
procedure Tfrm_MainForm.FormKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
var
   objeditmode : Integer;
begin
   //GgfLogEvnt('FormKeyUp Key='+IntToStr(Key)+ ' Ctrl='+IntToStr(ord(shift = [ssCtrl])));
   outputdebugstring(pchar('FormKeyUp Key='+IntToStr(Key)+ ' Ctrl='+IntToStr(ord(shift = [ssCtrl])))); //3.5.0.29

   if gbChangeInCombobox then
   begin
      gbChangeInCombobox := False;
      Exit;
   end;

   // hier mssen die ShortCuts als Ausnahmen definiert werden, die beim TextEdit von Annos wirksam sind
   // also Strg + U und Strg + L, auerdem ESC, um den TextEditMode verlassen zu knnen
   if (fra_Voransicht.img_DocView.ObjTextEditMode <> -1) and
	   (((Shift = [ssCtrl]) and (Key = 85)) or
      ((Shift = [ssCtrl]) and (Key = 76))  or
      (Key = vk_home) or (Key = vk_end)) then
   	Exit;

   if (fra_Voransicht.img_DocView.ObjTextEditMode <> -1) then
   	fra_Voransicht.img_DocView.SetFocus;

   if not gbAddfieldDropDown then
   begin
      case key of
         VK_F1:
            ReadFav(1, False);
         VK_F2:
            ReadFav(2, False);
         VK_F3:
            ReadFav(3, False);
         VK_F4:
            ReadFav(4, False);
         VK_F5:
            ReadFav(5, False);
         VK_F7:
            tbi_normalmouseClick(self);
         VK_F8:
            tbi_objauswahlClick(self);
         VK_TAB:
            if fra_Voransicht.fbmouseinim and (fra_Voransicht.img_DocView.SelObjectsCount > 0) then
            begin
               if (Shift = [ssShift]) then
                  fra_Voransicht.SelectPrevAnno
               else
                  fra_Voransicht.SelectNextAnno;

            end;
      end;
   end;

   if shift = [] then
   begin
     objeditmode:= -1;
     if Assigned(fra_Voransicht.img_DocView) then
     begin
       if (fra_Voransicht.fbmouseinim) then
       begin
         case key of
           vk_up, vk_prior:
           begin
             tbi_VPrevClick(Sender);
           end;
           vk_down, vk_next:
           begin
             tbi_VNextClick(Sender);
           end;
           vk_home:
           begin
             ImgHomeEndClick(0);
           end;
           vk_end:
           begin
             ImgHomeEndClick(fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1);
           end;
         end;
       end;
       
       objeditmode:= fra_Voransicht.img_DocView.ObjTextEditMode;
     end;

     if wvlhasfocus then
     begin
         case key of
            vk_up, vk_down, vk_prior, vk_next, vk_home, vk_end:
            begin
               dbgrd_WvlCellClick(nil);
            end;
         end;
     end
     else
     begin
         case key of
            vk_up, vk_down, vk_prior, vk_next, vk_home, vk_end:
            begin
               dbgrd_TrefferlisteMouseUp(dbgrd_Trefferliste, mbLeft, [], -1, -1);
            end;
         end;
     end;
   end;

   //  Hotkey zum erzeugen einer Verknpfung [SHIFT-ALT+V]
   if (Shift = [ssAlt, ssShift]) and (Key = 86) then
   begin
      if rGDocRight.link then
	      TBXItem36Click(self);
   end;
   // alt f 
   if (Shift = [ssAlt]) and (Key = 70) then
   begin
      if tbi_DocLink.Checked then
      begin
         tbi_docVoransicht.Checked := True;
         tbi_DocLink.Checked := False;
         tbi_DocVoransichtClick(self);
      end
      else
      begin
         tbi_docVoransicht.Checked := False;
         tbi_DocLink.Checked := True;
         tbi_DocLinkClick(self);
      end;
   end;
   // alt g 
   if (Shift = [ssAlt]) and (Key = 71) then
   begin
      if tbi_docVolltext.Checked then
      begin
         tbi_docVoransicht.Checked := True;
         tbi_docVolltext.Checked := False;
         tbi_DocVoransichtClick(self);
      end
      else
      begin
         tbi_docVoransicht.Checked := False;
         tbi_docVolltext.Checked := True;
         tbi_DocVolltextClick(self);
      end;
   end;
   // Alt+C 
   if (Shift = [ssAlt]) and (Key = 67) then
   begin
      dm_MainForm2.mnu_DokAlsLinkKopierenClick(Sender);
   end;

   // Hotkey zum Aufrufen der Wiedervorlage liste  [ALT+W]
   if (shift = [ssAlt]) and (Key = 87) then
   begin
   	  if not dpnl_Wvlg.Visible then //16.03.2011 b.takacs 3.5.0.167
        tbi_vdocTimer.Checked := True
      else
        tbi_vdocTimer.Checked := False;

      frm_MainForm.tbi_VDocTimerClick(self);
   end
   else
   // alt shift w
   if (shift = [ssShift, ssAlt]) and (Key = 87) then
   begin
      if (dm_DB.my_q_Arc.RecordCount > 0) and (rGArcRight.read) then
      begin
         Application.CreateForm(Tfrm_AddDocTime, frm_AddDocTime);
         frm_AddDocTime.ShowModal;
         frm_AddDocTime.Release;
      end;
   end;

      // Strg + U
   if (Shift = [ssCtrl]) and (Key = 85) then
   begin
      dm_MainForm2.mnu_TGoToArcClick(Sender);
   end;
   // STRG + S
   if (Shift = [ssCtrl]) and (Key = 83) then
   begin
      btn_SaveDocClick(Sender);
      Abort;
   end;
   // STRG + P
   if (Shift = [ssCtrl]) and (Key = 80) then
   begin
      tbsi_VPrintClick(Sender);
   end;
      // STRG + M
   if (Shift = [ssCtrl]) and (Key = 77) then
   begin
      tbsi_VMailClick(Sender);
   end;
         // STRG + L
   if (Shift = [ssCtrl]) and (Key = 76) then
   begin
      tbsi_localspeichernClick(Sender);
   end;
   if (Key = 27) then   // ESC
   begin
      if not fra_Voransicht.fTextAnnoCreated then
      begin
			HandleDoc;
      end;
   end;
end;

procedure Tfrm_MainForm.ImgHomeEndClick(ipage: integer);
begin
   GgfLogEvnt('ImgHomeEndClick');

   askforsave;

   if iPage < 0 then
      iPage := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1;
   if iPage > (fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1) then
      iPage := 0;

   tmb_Voransicht.SelectedImage:= iPage;
   tmb_Voransicht.CenterSelected;
   tmb_VoransichtImageSelect(self, iPage);
end;

procedure Tfrm_MainForm.btn_SaveDocClick(Sender: TObject);
var lidocid, liarcid: integer;
   lbtmp: boolean;
begin
   GgfLogEvnt('btn_SaveDocClick');
   liarcid := 0;  
   //save info of actual loaded document
   if bmultiarcquery then
   begin
      liarcid := iGarcid;
   end;
   lidocid := iGdocid;
   lbtmp := false;

   try
      tbi_VSaveDocClick(self);
      // check if the entry jumped (if a list is sorted then when changing it is resorted
      // so the 3. entry may become the 1. and the 2. the 3.
      if lidocid <> dm_db.my_q_arc.fieldbyname('doc_id').asinteger then
      begin
         if bmultiarcquery then
         begin
            if liarcid <> dm_db.my_q_arc.fieldbyname('arc_id').asinteger then
            begin
               lbtmp := true;
            end;
         end
         else
         begin
            lbtmp := true;
         end;
      end;
      // seems doc changed so jump to it!
      if lbtmp or (dm_DB.my_q_Arc.RecNo <> iGArcRecNo) then
      begin
         if Length(GSelection) > 0 then
         begin
               Markieren2(dbgrd_Trefferliste);
               FillZusFields;
         end;
         handledoc; GgfLogEvnt('HandleDoc d');
      end;
      // SaveZusFields ist die Procedure die modifizierte Zusatzfelder speichert
   finally
      gbSaveDoc := False;
      tbi_normalmouseClick(nil);
   end;
end;

procedure Tfrm_MainForm.FormCreate(Sender: TObject);
var
   iCount, iPos: integer;
   ls, lsPar, lsParL, lsParCom, lsParVal, lsLanguage, lsLangPath: string;
begin
   giGoToPage := -1;
   BD.LogPath := BD.EnvTemp;
   BD.LogName := 'ViewerV3<%d>.log';

   if not (directoryexists(BD.AppdataBitfarm)) then
      try
         mkDir(BD.AppdataBitfarm);
      except on e: exception do
            logevnt('formcreate ' + e.message);
      end;
   if not (directoryexists(BD.AppdataBitfarm + '\bfa_hit')) then
      try
         mkDir(BD.AppdataBitfarm + '\bfa_hit');
      except on e: exception do
            logevnt('formcreate ' + e.message);
      end;
   // Auswertung der Parameter (teilweise)
   wvldebug := False;
   gbmysqldebug := false;
   BD.LogOn := false;
   lidebuglevel := 0;

   lsLanguage := '';
   for iCount := 1 to ParamCount do
   begin
      lsPar := ParamStr(icount);
      ls := inttostr(icount);
      GgfLogEvnt('paramstr('+ls+'):' + lsPar);
      lsParL := lowercase(lsPar);
      iPos := Pos(':',lsParL);
      if iPos = 0 then
         iPos := maxint-1;
      lsParCom := Copy(lsParL,1,iPos-1); // das vor dem Doppelpunkt (oder alles wenn keiner)
      lsParVal := Copy(lsParL,iPos+1,maxint); // das vor nach Doppelpunkt (oder nix wenn keiner)
      if lsParL = '-debug' then
      begin
         lidebuglevel := 1;

         BD.LogOn := true;
         wvldebug := True;

         Continue;
      end;
      if lsPar = '-debugMySQL' then
      begin gbmysqldebug := True; Continue; end;
      if lsParCom = '-lang' then   //z.B. "-lang:en"
      begin lsLanguage := lsParVal; Continue; end;
      if lsParCom = '-langpath' then   //z.B. "-langpath:"
         begin lsLangPath := lsParVal; Continue; end;
   end;
   GnugettextTextdomain('ViewerV3', lsLangPath, lsLanguage);
   TranslateComponent(self);

   TranslateComponent(dm_MainForm2, 'Viewerv3'); //3.5.0.42


   Vst_favfile.NodeDataSize := SizeOf(TTreeData);
   GTrOldLBWindowProc := dbtv_LgrArc.WindowProc; // store default WindowProc
   dbtv_LgrArc.WindowProc := LBWindowProc;    // replace default WindowProc
   DragAcceptFiles(dbtv_LgrArc.Handle, True); // now ListBox1 accept dropped files
   GgfLogEvnt('Viewer: 8411 : oncreate');
   gbAppStarted := False;

   logevnt('Viewer startet version:' + GetVersionInfo);

   giansichtlistcounter := -1;
   SingleInst.OnProcessParam := HandleParam;
   GgfLogEvnt('Viewer: 8419 : SingleInst ok');
   TimeSQLTor := True;
   HPTorOpen := True;
   ngrstime := True;
   ngAliveMainform := False;

   // register clipboard format rtf
   CF_RTF := RegisterClipboardFormat('Rich Text Format');
   gtsl_ansicht := TStringList.Create;
   TWheelDBGrid(dbgrd_trefferliste).OnMouseWheel := dbgrd_trefferlisteMouseWheel;
   ffirststart := True;

   // Frames fr Dokument zur Laufzeit erzeugen - macht das Design bersichtlicher
   fra_Nix := Tfrm_Nix.Create(pnl_Voransicht);
   fra_Nix.Visible := false;
   fra_Nix.Parent  := pnl_Voransicht;

   fra_DocLink := Tfrm_DocLink.Create(pnl_Voransicht);
   fra_DocLink.Visible := false;
   fra_DocLink.Parent  := pnl_Voransicht;;

   fra_History := Tfrm_History.Create(pnl_Voransicht);
   fra_History.Visible := false;
   fra_History.Parent  := pnl_Voransicht;

   fra_Volltext := Tfrm_Volltext.Create(pnl_Voransicht);
   fra_Volltext.Visible := false;
   fra_Volltext.Parent  := pnl_Voransicht;

   fra_Voransicht := Tfrm_Voransicht.Create(pnl_Voransicht);
   fra_Voransicht.Visible := false;
   fra_Voransicht.Parent  := pnl_Voransicht;
   fra_Voransicht.fParentHandle := frm_MainForm.Handle;
   fra_Voransicht.img_DocView.ObjBoxInnerSelectable := True;
   fra_Voransicht.img_DocView.MaxSelectionDistance := 30;
   fra_Voransicht.img_DocView.MaxMovingDistance := 30;
   fra_Voransicht.img_DocView.AllowOutOfBitmapMoving  := False;
   fra_Voransicht.img_DocView.AllowOutOfBitmapPolylines := False;
   fra_Voransicht.img_DocView.PopupMenu := dm_MainForm2.pum_Tools;
   fra_Voransicht.fSaveBtN := frm_MainForm.btn_SaveDoc;
   fra_Voransicht.fPubAnnoBTN := frm_MainForm.tbx_pubNote;
	fra_Voransicht.fPrivAnnoBTN := frm_MainForm.tbx_privNote;
   fra_Voransicht.fCbx_Zoom := frm_MainForm.cbx_VZoom;
   if tbsi_VZoom.ImageIndex = 41 then
	   fra_Voransicht.fAutozoom := False
   else
	   fra_Voransicht.fAutozoom := True;
   fra_Voransicht.fOnObjectOver := ShowAnnoData;
   fra_Voransicht.fOnDblClick := OpenDocEditor;
   fra_Voransicht.fOnMouseLeave := ResetPanelInfo;
   fra_Voransicht.fAfterSaveObjects := AfterSaveObjects;
   fra_Voransicht.fOnNewObject := fra_Volltext.removeocrhits;
   fra_Voransicht.fOnObjectMoveResize := fra_Volltext.removeocrhits;
   dbgrd_Trefferliste.OnAfterEdit := AfterEdit;
   dbgrd_Trefferliste.AfterColResize := dbgrd_TrefferlisteAfterColResize;
   dbgrd_Wvl.AfterColResize := dbgrd_WVLAfterColResize;
end;

procedure Tfrm_MainForm.AfterSaveObjects;
begin
//   gbAnnoscheck := True;
end;

procedure Tfrm_MainForm.AfterEdit;
begin
	OutputDebugString('AfterEdit');
   if not frm_mainform.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected then
   begin
      frm_mainform.dbgrd_Trefferliste.SelectedRows.Clear;
      frm_mainform.dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
   end;
end;

procedure Tfrm_MainForm.ShowAnnoData(annodata: PAnnoData);
var
   lipos1: integer;
   lsv, lsTmp: string;
begin
   OutputDebugString('ShowAnnoData');
   try
      if annodata <> nil then
      begin
         if annodata = Pointer($FFFFFFFF) then
            exit;

         lsv := annodata.version;
         if ((lsv[1] <> '0') or (lsv[3] <> '1')) then
            exit;

         lsTmp := frm_Mainform.GetStatusText(cStatusPanelInfo);
         if pos(_('; zuletzt gendert am:'), lsTmp) = 0 then //3.5.0.25
         begin
            fsinfo := lsTmp;
         end;
         frm_MainForm.setpanelinfo(
            _('Autor:') + annodata.Ersteller + _('; zuletzt gendert am:') + annodata.Datum);
         if annodata.Veraenderer <> '' then
         begin
            if 0 = Pos(',', ReverseString(annodata.Veraenderer)) then
            begin
               lipos1 := 0;
            end
            else
            begin
               lipos1 := length(annodata.Veraenderer) - Pos(',',
                  ReverseString(annodata.Veraenderer)) + 2;
            end;
            frm_MainForm.setpanelinfo(
               frm_MAinform.GetStatusText(cStatusPanelInfo)
               + _('; zuletzt verndert von:') + //3.5.0.25
               copy(annodata.Veraenderer, lipos1, length(annodata.Veraenderer)));
            frm_MainForm.SetStatusHint(cStatusPanelInfo, //3.5.0.25
               copy(annodata.Veraenderer, 0, length(annodata.Veraenderer)) );
         end;
      end
      else
      begin
         if fsinfo <> '' then
            frm_MainForm.setpanelinfo(fsinfo);
      end;
   except
      on e: Exception do
      begin
      end;
   end;
end;

procedure Tfrm_Mainform.ResetPanelInfo;
begin
	if fsinfo <> '' then
   	frm_MainForm.setpanelinfo(fsinfo);
end;


procedure Tfrm_MainForm.cbx_VZoomKeyUp(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('cbx_VZoomKeyUp');
   if key = vk_return then
      dbgrd_Trefferliste.SetFocus;
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteDblClick(Sender: TObject);
begin
   tbi_VEditClick(self); 
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: integer);

   //  Wenn das Dokument in Bearbeitung ist, dann wird hier nix verschoben
var
   i : Integer;
begin
   if (dm_DB.my_q_Arc.RecordCount = 0)  then
      exit;
   if rGDocRight.move then
   begin
      if (tci_inuse.Color = cllime) or
         ((dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger and 1) = 1) then
         exit;
      if (dbgrd_Trefferliste.ControlState = [csLButtonDown]) and
         (x > 20) and (y > 20) and (dm_DB.my_q_Arc.RecordCount > 0) and
         (not dbgrd_Trefferliste.Dragging) and
         (not gbArcHandling)   //dont allow draggin while loading!
      then
      begin
        askforsave;
        with Sender as TCRDBGrid do
        begin
           for i := 0 to Length(GSelection) -1 do
           begin
             if GSelection[i] =  dbgrd_Trefferliste.DataSource.DataSet.FieldByName('doc_id').AsInteger then
             begin
               //OutputDebugString('!!! BeginDrag !!!');
               gbbegindragtrefferliste := True;
               BeginDrag(false, 5);
               Exit;
             end;
           end;
           OutputDebugString('gbbegindragtrefferliste := False');
           gbbegindragtrefferliste := False;
        end;
      end;
   end;
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
var
   lbsg, isSelected: boolean;
   reg: Tregistry;
   i : Integer;
   lBM : TBookmark;

begin
   //OutputDebugString('dbgrd_TrefferlisteMouseUp');
   GgfLogEvntBeg ('dbgrd_TrefferlisteMouseUp Begin');

   if gbColumnMoved then
   begin
      gbColumnMoved := False;
      Abort;
   end;

   if Button = mbRight then
   	Exit;
   try
   lbsg := Shiftgedr;
   if not dbgrd_trefferliste.DataSource.DataSet.Active then
   begin
      OutputDebugString ('dbgrd_TrefferlisteMouseUp End via Exit #0');
      Exit;
   end;

   if (gbbegindragtrefferliste) then
   begin
     OutputDebugString ('dbgrd_TrefferlisteMouseUp End via Exit #1');
     Exit;
   end
   else
   begin
     lBM := (Sender as TCRDBGrid).DataSource.DataSet.GetBookmark;
     isSelected := dbgrd_Trefferliste.SelectedRows.CurrentRowSelected;
     //OutputDebugString(PChar('isSelected:' + BoolToStr(isSelected)));
     if not (dbgrd_Trefferliste.ControlState = [csLButtonDown]) then
     begin
       //OutputDebugString('EndDrag');
       dbgrd_Trefferliste.EndDrag(False);
     end;
     bh_PrivAnnoExist.CancelHint;

     if (((not lbsg) and (dbgrd_Trefferliste.SelectedRows.Count > 1)) or (gbArcHandling) or (gbSaveDoc)) then
     begin
       //OutputDebugString ('dbgrd_TrefferlisteMouseUp End via Exit #2');
       //Exit;
     end
     else
     begin
       if not lbsg then
       begin
          BM1 := (Sender as TCRDBGrid).DataSource.DataSet.GetBookmark;
          iGRecNo := (Sender as TCRDBGrid).DataSource.DataSet.RecNo;
       end
       else
       begin
         if BM1 = nil then
         begin
            BM1 := (Sender as TCRDBGrid).DataSource.DataSet.GetBookmark;
            iGRecNo := (Sender as TCRDBGrid).DataSource.DataSet.RecNo;
         end
         else
            BM2 := (Sender as TCRDBGrid).DataSource.DataSet.GetBookmark;
       end;

       if (BM1 <> nil) and (BM2 <> nil) then
       begin
          if lbsg then
          begin
             Markieren(Sender);
          end;
       end;

       if (dbgrd_Trefferliste.SelectedRows.Count > 1) then
       begin
          // outputdebugstring(pchar('exiting count ng '+booltostr(frm_mainform.dbgrd_Trefferliste.Dragging)));
          // GgfLogEvntEnd ('dbgrd_TrefferlisteMouseUp End via Exit #3');
          // Exit;
       end
       else
       begin
         // set the focus properly
         wvlhasfocus := False;
         wvlshowbuttons(False);
         //skywalker reload the wvl if already not done!  so it doesnt show marked
         if loadingfromwclcellclick = 1 then
         begin
            loadingfromwclcellclick := 0;
            dbgrd_wvl.hide;
            dbgrd_wvl.Show;
         end;

         if privAnnoCnt > 0 then
         begin
            listofpriv.Text := IntToStr(privannoCnt);
         end;

    	 end;

	  end;

      GSelection := nil;
      SetLength(GSelection,dbgrd_Trefferliste.SelectedRows.Count);
      dbgrd_Trefferliste.DataSource.DataSet.DisableControls;
      for i := 0 to dbgrd_Trefferliste.SelectedRows.Count -1 do
      begin
         dbgrd_Trefferliste.DataSource.DataSet.GotoBookmark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[i]));
         GSelection[i] :=  dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
      end;

     if lbsg then
     begin
      dbgrd_Trefferliste.DataSource.DataSet.GotoBookmark(BM1);
      dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := isSelected;
     end;

     if Strggedr then
     begin
         if not isSelected then
         begin
            if (iGDocID <> dm_DB.my_q_Arc.fieldbyName('doc_id').AsInteger) and
            	dbgrd_Trefferliste.SelectedRows.CurrentRowSelected  {and
               (dbgrd_Trefferliste.SelectedRows.Count = 1)} then
            begin
               HandleDoc;
            end;
         end
         else
         begin
	         dbgrd_Trefferliste.DataSource.DataSet.GotoBookmark(lBM);
		      dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := isSelected;
         end;
     end;

      dbgrd_Trefferliste.DataSource.DataSet.EnableControls;
   end;

   finally

   end;

   GgfLogEvntEnd ('dbgrd_TrefferlisteMouseUp End');
end;

procedure Tfrm_MainForm.dbtv_LgrArcKeyUp(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('dbtv_LgrArcKeyUp');
   //  if dm_DB.my_q_Tmp.Active then exit;
   dm_MainForm2.tim_SelLgrArc.Enabled := False;
   case key of
      vk_up, vk_down:
         dm_MainForm2.tim_SelLgrArc.Enabled := True;
      vk_return:
         if dbtv_LgrArc.Tag = 1 then
            btn_StartSrcClick(self);
   end;
   dbtv_LgrArc.Tag := 1;
end;

procedure Tfrm_MainForm.tbtn_VOCRClick(Sender: TObject);
begin
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
end;

procedure Tfrm_MainForm.shp_DocLnkInfoMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
   GgfLogEvnt('shp_DocLnkInfoMouseUp');
   if Button = mbRight then
      dm_MainForm2.pum_Links.PopUp(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;


procedure Tfrm_MainForm.tmb_VoransichtProgress(Sender: TObject; per: integer);
begin
   if per = 100 then
   begin
      if giGoToPage < 0 then
         Exit;
      try
         tmb_VoransichtImageSelect(nil, giGoToPage);
      finally
         giGoToPage := -1;
      end;
   end;
end;

procedure Tfrm_MainForm.tmb_VoransichtImageSelect(Sender: TObject; idx: integer);
var licount, lipage, lilcont, lircont: integer;
begin
   GgfLogEvnt('tmb_VoransichtImageSelect');

   if fselectingthumb then
      exit;
   fselectingthumb := true;

   lilcont := GetAsyncKeyState(VK_LCONTROL);
   lircont := GetAsyncKeyState(VK_RCONTROL);

   if thr_voransicht <> nil then
   begin
      thr_voransicht.Terminate;
      thr_voransicht.waitfor;
   end;
   lipage := frm_MainForm.tmb_Voransicht.ImageCount;
   try
   	if fra_Voransicht.gbAnnoNotSaved then
         fra_voransicht.saveobjects(false, False);

      if frm_mainform.btn_SaveDoc.Enabled and
         (fra_Voransicht.img_DocView.IO.Params.TIFF_ImageIndex <> idx) then
      begin
         if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
            #13 + _('Mchten Sie die nderungen speichern?'),
            True) = mrYes then
         begin
            tbi_VSaveDocClick(self);
         end;
         GHasNotBeenSavedAfterModify := False;
         fgchangedvoransicht := False;
         fgchangedvoransichttif := False;
         gtmpiStatus := gotmpistatus;
         btn_SaveDoc.Enabled := false;
         if fra_Voransicht.img_DocView.ObjectsCount > 0 then
         begin
            fra_Voransicht.img_DocView.RemoveAllObjects;
         end;
      end;

      igbrieflayer := 0;
      if tbi_VShowBrief.Checked then
      begin
         fra_Voransicht.img_DocView.Layers[iGBriefLayers[0]].Visible := True;

      end;

      fra_Voransicht.img_DocView.update;
      //remove else all new pages selected pages will be deselected

      if not ((lilcont = -32767) or (lircont = -32767)) then
      begin
         frm_mainform.tmb_Voransicht.Deselect;
         setlength(GaiPagesSelectedtmb, 0);
      end
      else
      begin
         if length(GaiPagesSelectedtmb) > 0 then
         begin
            frm_mainform.tmb_Voransicht.Deselect;
            for licount := 0 to length(GaiPagesSelectedtmb) - 1 do
            begin
               if GaiPagesSelectedtmb[licount] = idx then
                  continue;
               frm_mainform.tmb_Voransicht.SelectedImage := GaiPagesSelectedtmb[licount];
            end;
         end;
      end;
      gbdontsetpage := true;
      tbxse_page.Text := inttostr(idx + 1);
      frm_mainform.tmb_Voransicht.SelectedImage := idx;
      fra_Voransicht.img_DocView.IO.Params.TIFF_ImageIndex := idx;

      frm_mainform.tmb_Voransicht.SelectionColor := clred;
      frm_mainform.tmb_Voransicht.SelectedImage := idx;
      if frm_mainform.btn_SaveDoc.Enabled
      then
      begin
         if dm_MainForm2.Frage(_('Voransicht:Sie haben nderungen am Dokument am Editor gespeichert.') +
            #13 + _('Mchten Sie die Voransichtsnderung(en) verwerfen?') + #13 +
            _('(Bei "Ja" wird das vom Editor gespeichertes Dokument geladen)'),
            false) <> mrYes then
         begin
            tbi_VSaveDocClick(self);
         end;
         GHasNotBeenSavedAfterModify := False;
         fgchangedvoransicht := False;
         fgchangedvoransichttif := False;
         gtmpiStatus := gotmpistatus;
         btn_SaveDoc.Enabled := false;
         if fra_Voransicht.img_DocView.ObjectsCount > 0 then
         begin
            fra_Voransicht.img_DocView.RemoveAllObjects;
         end;
      end;
      ChangeDocPage(3); // Erzwingt eine Aktualisierung der Voransicht
      tbsi_VZoomClick(self);
   finally
      begin
         loadthumbs(lipage, false);
         gbdontsetpage := false;
         fselectingthumb := false;
      end;
   end;
end;

procedure Tfrm_MainForm.dtp_SBisChange(Sender: TObject);
begin
   GgfLogEvnt('dtp_SBisChange');
   if dtp_SBis.Date < dtp_SVon.Date then
      dtp_SVon.Date := dtp_SBis.Date;
end;

//  Archiv exportieren
procedure Tfrm_MainForm.ExportArc;
var
   TmpLst: TStringList;
   iCount, iTmpID, iRights: integer;
   bMultiQuery: boolean;
   sPathName, sAddPath, sFromDoc, sToDoc, sFromExt, sToExt, sDocFile,
   sTmpFile, lsrw: string;
   Folder: TFolderBrowser;

begin
   GgfLogEvnt('ExportArc');
   if not rGArcRight.Write then
      exit;
   // wenn der Luser keine ausreichenden Rechte ausweisen kann wird die ExportFunktion abgebrochen
   bMultiQuery := False;
   Folder := TFolderBrowser.Create(Application.Handle,
      _('Bitte Verzeichnis auswhlen'), '', False, True);

   try
      if Folder.Execute then
         sPathName := Folder.SelectedItem
      else
         exit;
   finally
      if assigned(Folder) then
         FreeAndNil(Folder);
   end;
   if dbtv_LgrArc.SelectionCount = 0 then
      dbtv_LgrArc.Select(dbtv_LgrArc.TopItem, []);
   case dbtv_LgrArc.Selected.ImageIndex of
      0, 2:
         bMultiQuery := True;
      1, 3:
         bMultiQuery := False;
   end;
   TmpLst := TStringList.Create;
   try
      TmpLst.Clear;
      //  if dbtv_LgrArc.Selected.ImageIndex = 1 then
      lsrw := '';
      if not bMultiQuery then
      begin
         SetLength(GArcSList, 1);
         GArcSList[0].ArcID := iGArcID;
         GArcSList[0].ArcName := sGArcName;
         GArcSList[0].TblName := sIArcName;
         lsrw := ' arc_id = ' + inttostr(iGArcID);

      end
      else
      begin
         GetChilds(dbtv_LgrArc.Selected, TmpLst);
         SetLength(GArcSList, TmpLst.Count);
         for iCount := 0 to (TmpLst.Count - 1) do
         begin
            iTmpID := integer(TmpLst.Objects[iCount]);
            if lsrw = '' then
            begin
               lsrw := ' arc_id = ' + inttostr(iTmpID);
            end
            else
            begin
               lsrw := lsrw + ' or  arc_id = ' + inttostr(iTmpID);
            end;
            GArcSList[iCount].ArcID := iTmpID;
            GArcSList[iCount].ArcName := TmpLst.Strings[iCount];
            with dm_DB.my_q_LgrArc do
            begin
               First;
               while not EOF do
               begin
                  if FieldByName('arc_id').AsInteger = iTmpID then
                  begin
                     GArcSList[iCount].TblName :=
                        FieldByName('arc_tblname').AsString;
                     break;
                  end
                  else
                     Next;
               end;
            end;
         end;
      end;

      // SuchArc
      if not bMultiQuery then
      begin
         TmpSQL('Select Sql_No_cache * from arc_' + GArcSList[0].TblName +
            ' as arc');
      end
      else
      begin
         with dm_DB.my_cmd do
         begin
            SQL.Text := 'drop table if exists tmp_' + sGTmpName;
            Execute;
            SQL.Text := 'CREATE TABLE `tmp_' + sGTmpName + '` (' +
               '`ARC_ID` BIGINT UNSIGNED NOT NULL,' +
               '`ArcName` VARCHAR(32) NOT NULL,' +
               '`TblName` VARCHAR(14) NOT NULL,' +
               '`DOC_ID` BIGINT UNSIGNED NOT NULL,' +
               '`DISP_NAME` VARCHAR(32) NOT NULL,' +
               '`DOC_LOC` VARCHAR(255) NOT NULL,' +
               '`EXT_LOC` VARCHAR(255) NOT NULL,' +
               '`ORI_LOC` VARCHAR(255) NOT NULL,' +
               '`USR_NAME` VARCHAR(32) NOT NULL,' +
               '`USR_ID` BIGINT UNSIGNED NOT NULL,' + '`TStamp` DATETIME NOT NULL,' +
               '`DOC_TXT` LONGTEXT,' + '`DOC_STATE` INTEGER UNSIGNED NOT NULL,' +
               '`OCR_QF` INTEGER SIGNED NOT NULL DEFAULT 0,' +
               '`SHA1` varchar(40)' +
               ', primary key (`ARC_ID`,`DOC_ID`)' + ') COMMENT = ' +
               #39 + _('Temptabelle fr Benutzer') + ' (USR_ID): ' + sGUsrName +
               ' (' + IntToStr(iGUsrID) + ')' + #39;
            try
               Execute;
            except
               on e: Exception do
                  ErrorMsg('SuchArc', _('Fehler beim Erzeugen einer Temptabelle:') +
                     e.Message, 1003, True);
            end;
            for iCount := 0 to (Length(GArcSList) - 1) do
            begin
               SQL.Text := 'Insert into tmp_' + sGTmpName +
                  ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ori_loc,'
                  +
                  'usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf) Select Sql_No_cache '
                  + IntToStr(GArcSList[iCount].ArcID) + ' as Arc_ID,' +
                  #39 + GArcSList[iCount].ArcName + #39 + ' as ArcName,' +
                  #39 + GArcSList[iCount].TblName + #39 + ' as TblName,' +
                  'arc.doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf from arc_'
                  + GArcSList[iCount].TblName + ' as arc ' + '  on duplicate key update ' +
                  ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';
               try
                  Execute;
               except
                  on e: Exception do
                     ErrorMsg('SuchArc',
                        _('Fehler beim Fllen einer Temptabelle:') + e.Message,
                        1003, True);
               end;
            end;
         end;
         TmpSQL('Select Sql_No_cache * from tmp_' + sGTmpName);
      end;
      with dm_DB.my_q_Tmp do
      begin
         First;
         for iCount := 0 to (RecordCount - 1) do
         begin
            if bMultiQuery then
               sAddPath := '\' + FieldByName('ArcName').AsString + '\'
            else
               sAddPath := '\' + GArcSList[0].ArcName + '\';
            sDocFile := FieldByName('doc_loc').AsString;
            sTmpFile := FieldByName('ext_loc').AsString;
            if FileExists(sTmpFile) then
               sDocFile := sTmpFile;

            sFromDoc := sDocFile;
            sToDoc := sPathName + sAddPath + ExtractFileName(sDocFile);
            sFromExt := FieldByName('Ori_LOC').AsString;
            sToExt := sPathName + sAddPath + ExtractFileName(
               FieldByName('ORI_Loc').AsString);

            if not DirectoryExists(sPathName + sAddPath) then
               CreateDir(sPathName + sAddPath);
            CopyFile(PChar(sFromDoc), PChar(sToDoc), False);
            if FileExists(sFromExt) then
               CopyFile(PChar(sFromExt), PChar(sToExt), False);
            Next;
         end;
      end;

      pnl_SrcTime.ParentBackground := True;
      pnl_SrcTime.Color := pnl_SuchOpt.Color;
   finally
      if Assigned(TmpLst) then
         FreeAndNil(TmpLst);
   end;
end;

procedure Tfrm_MainForm.tbi_Fav1Click(Sender: TObject);
begin
   GgfLogEvnt('tbi_Fav1Click');
   ReadFav(1, False);
end;

procedure Tfrm_MainForm.tbi_Fav2Click(Sender: TObject);
begin
   GgfLogEvnt('tbi_Fav2Click');
   ReadFav(2, False);
end;

procedure Tfrm_MainForm.tbi_Fav3Click(Sender: TObject);
begin
   GgfLogEvnt('tbi_Fav3Click');
   ReadFav(3, False);
end;

procedure Tfrm_MainForm.tbi_Fav4Click(Sender: TObject);
begin
   GgfLogEvnt('tbi_Fav4Click');
   ReadFav(4, False);
end;

procedure Tfrm_MainForm.tbi_Fav5Click(Sender: TObject);
begin
   GgfLogEvnt('tbi_Fav5Click');
   ReadFav(5, False);
end;

procedure Tfrm_MainForm.tbi_VisLgrArcClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VisLgrArcClick');
   ShowLgrArc;
end;

procedure Tfrm_MainForm.tbi_VisThumbsClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VisThumbsClick');
   ShowThumbs;
end;

//  Aenderungen speichern
procedure Tfrm_MainForm.tbi_VSaveDocClick(Sender: TObject);
var
   sDocPath, sTmpPath, lsext, lsIArcName: string;
   iCount, iSelected, shiftamount, lipage, lirecordtmp, lirecordtmp1, lirecordtmp2,
   litmparcid, litmpdocid, lifieldschanged: integer;
   lbnhasstsrights, lbtim_ansicht, lbtim_voransicht: boolean;
   liarcid, lidocid, liglobalgdocid: int64;
begin
   GgfLogEvnt('tbi_VSaveDocClick');

   if gbSaveDoc then
   	Exit;

   gbBlockVoransicht := true; //3.5.0.41 [2398]

   try
      gbSaveDoc := true;
      litmpdocid := 0;
      lbtim_ansicht := false;
      litmparcid := 0;
      lbtim_voransicht := false;
      lirecordtmp2 := 0;
      lirecordtmp := 0;

      fbfailcauselock := false;
      if (dm_db.my_q_arc.recordcount = 0) or fbsaving then
         exit;

      try
         fbsaving := true;
         if thr_voransicht <> nil then
         begin
            thr_voransicht.Terminate;
            thr_voransicht.waitfor;
         end;
         fra_Voransicht.img_DocView.CancelInteracts;
         lipage := frm_MainForm.tmb_Voransicht.ImageCount;
         lbtim_ansicht := dm_DB.tim_ansicht.enabled;
         dm_DB.tim_ansicht.enabled := false;
//         lbtim_voransicht := dm_MainForm2.tim_voransicht.enabled;
//         dm_MainForm2.tim_voransicht.enabled := false;

         if iGArcRecNo <> dm_db.my_q_arc.RecNo then
         begin
            if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count > 0 then
            begin
               dm_db.my_q_Arc.GotoBookmark(
                  Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
            end;
         end;
         dm_DB.my_q_Arc.RefreshRecord;
         if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
         begin
            BfShowMessage(_('Dokument hat keine Voransicht oder kein Dokument in der Trefferliste! Speichern nicht mglich.'));
            exit;
         end;
         if rGDocRight.modify or rGDocRight.Write then
            // Wenn die Rechte schreiben und Aendern fuer den Datensatz existieren dann
         begin
            if dbgrd_Trefferliste.SelectedRows.Count <= 1 then
            begin
               lirecordtmp := dm_DB.my_q_Arc.RecNo;
               lirecordtmp2 := 0;
               dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := False;
               dm_DB.my_q_Arc.RecNo := iGArcRecNo;
               sDocPath := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
               lsext := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
               //check for doclock

               liarcid := iGArcID;
               lidocid := iGDocID;

               dm_db.my_q_tmp.SQL.Text := 'select * from sys_doclock where ' +
                  ' arc_id=' + IntToStr(liarcid) + ' and doc_id=' + IntToStr(lidocid);
               try
                  dm_db.my_q_tmp.Execute;
               except on e: exception do
                  begin
                     LogEvnt('9004c    ' + _('Fehler') + ' in Modul: tbi_VSaveDocClick    ' + e.Message);
                  end;
               end;
               if dm_db.my_q_tmp.RecordCount <> 0 then
               begin
                  if dm_db.my_q_tmp.fieldbyname('usr_id').asinteger <> iGusrid then
                  begin
                     BfShowMessage(_('Dokument wurde bereits vom einen anderen Benutzer ausgeckeckt.') +
                        #13 + _('Dokument wird neugeladen.'));
                     handleparam(inttostr(iGArcID) + '.' + inttostr(iGDocID));
                     exit;
                  end;
               end;
               sTmpPath := StringReplace(sDocPath, sGArcPath, sGCopyPath, []);
               try
                  try
                     if fgchangedvoransicht then
                     begin
                        if not DirectoryExists(ExtractFilePath(sTmpPath)) then
                           CreateDir(ExtractFilePath(sTmpPath));
                        if not DirectoryExists(ExtractFilePath(sTmpPath)) then
                        begin
                           BfShowMessage(_('Ausgewhlte Verzeichnis konnte nicht erstellt werden.'));
                           exit;
                        end;
                        if FileExists(sTmpPath) then	// Wenn schon eine Datei existiert bearbeite diese
                        begin
                           try
                              IoSaveGraphic(fra_Voransicht.img_DocView.IO,sTmpPath);
                           except on e: exception do
                              begin
                                 logevnt('error saving save ' + e.message);
                              end;
                           end;
                        end
                        else // Wenn Datei nicht existiert kopiere Sie zuerst und aendere Sie dann.
                        begin
                           CopyFile(PChar(sDocPath), PChar(sTmpPath), False);
                           try
                              IoSaveGraphic(fra_Voransicht.img_DocView.IO,sTmpPath);
                           except on e: exception do
                              begin
                                 logevnt('error saving save ' + e.message);
                              end;
                           end;
                        end;
                        if lsext <> sTmpPath then
                        begin
                           lirecordtmp1 := iGArcRecNo;
                           //be sure it wasnt changed while saving (could happen when mydac is calling mysql-server
                           if dm_DB.my_q_Arc.RecNo <> iGArcRecNo then
                           begin
                              lirecordtmp1 := dm_DB.my_q_Arc.RecNo;
                              dm_DB.my_q_Arc.RecNo := iGArcRecNo;
                              if lirecordtmp1 <> lirecordtmp then
                              begin
                                 lirecordtmp2 := lirecordtmp1;
                              end;
                           end;
                           dm_DB.my_q_Arc.Edit;
                           dm_DB.my_q_Arc.FieldByName('ext_loc').AsString := sTmpPath;
                           dm_DB.my_q_Arc.Post;
                           //be sure it wasnt changed while saving (could happen when mydac is calling mysql-server
                           if dm_DB.my_q_Arc.RecNo <> lirecordtmp1 then
                           begin
                              dm_DB.my_q_Arc.RecNo := lirecordtmp1;
                           end;
                           sgextfilename := sTmpPath;
                           if bMultiArcQuery then
                           begin
                              dm_db.my_cmd.SQL.Text :=
                                 'Update arc_' + sIArcName + ' set ext_loc =:extloc' +
                                 ' where doc_id =' + IntToStr(iGDocID);
                              dm_DB.my_Cmd.ParamByName('extloc').AsString := sTmpPath;
                              dm_db.my_cmd.Execute;
                           end;
                        end;
                     end;
                     if fra_Voransicht.gbAnnoNotSaved then
	                     fra_voransicht.saveobjects(false, false);
                  finally
                     fgchangedvoransicht := false;
                     fgchangedvoransichttif := False;
                  end;
                  // set things which were set in      OnStsClick and InUseClick
                  // so save status as modified by user
                  // reset color fonts for all
                  lbnhasstsrights := false;
                  for iCount := 0 to (tlb_Status.Items.Count - 6) do
                  begin
                     // dont try to change the color of separators or other things like that
                     if TTBXColorItem(tlb_Status.Items.Items[iCount + 5]).ClassName =
                        'TTBXColorItem' then
                     begin
                        // check if status changed but the person dont have permission for
                        // saving it

                        if gai_sts_rights[(TTBXColorItem(tlb_Status.Items.Items[iCount + 5]).tag shr 8) - 1] then
                        begin
                           TTBXColorItem(tlb_Status.Items.Items[iCount +
                              5]).FontSettings.Color :=
                              clnone;
                        end
                        else
                        begin
                           TTBXColorItem(tlb_Status.Items.Items[iCount +
                              5]).FontSettings.Color := gcnrs;
                        end;
                     end;
                  end;
                  if gtmpiStatus <> gotmpiStatus then
                  begin
                     lirecordtmp1 := iGArcRecNo;
                     //be sure it wasnt changed while saving (could happen when mydac is calling mysql-server
                     if dm_DB.my_q_Arc.RecNo <> iGArcRecNo then
                     begin
                        lirecordtmp1 := dm_DB.my_q_Arc.RecNo;
                        dm_DB.my_q_Arc.RecNo := iGArcRecNo;
                        if lirecordtmp1 <> lirecordtmp then
                        begin
                           lirecordtmp2 := lirecordtmp1;
                        end;
                     end;
                     dm_DB.my_q_Arc.Edit;
                     dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger := gtmpiStatus;
                     gotmpiStatus := gtmpiStatus;
                     for iCount := 0 to (tlb_Status.Items.Count - 5) do
                     begin
                        if gtmphistory[iCount] <> '' then
                        begin
                           if iCount = 0 then
                              tci_InUse.FontSettings.Color := clnone
                           else
                           begin
                              if gai_sts_rights[(TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).tag shr 8) - 1] then
                              begin
                                 TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).FontSettings.Color :=
                                    clnone;

                                 // Suchstatus des zu speichernden Status zurcksetzen
                                 gmodsearchiStatus := gmodsearchiStatus and not (1 shl iCount);
                                 // Ist die Farbe rot (Status lschen) dann setzen wir auf inaktiv
                                 // damit bei der nchsten Suche nicht versehentlich nach Status negiert gesucht wird
                                 if TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).Color = clred then
                                 begin
                                    TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).Color := clteal;
                                    gmodnegiStatus := gmodnegiStatus and not (1 shl iCount);
                                 end;
                              end
                              else
                              begin
                                 TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).FontSettings.Color := gcnrs;
                              end;
                           end;
                           NewHistory(22, gtmphistory[iCount]);
                           if (gtmphinttag[iCount] <> '')
                              and (gtmphinttag[iCount] <> '-') then
                              dm_DB.my_q_Arc.FieldByName(gtmphinttag[iCount]).AsString :=
                                 gtmphhsvalue[iCount];
                        end;
                     end;
                     dm_DB.my_q_Arc.Post;
                     //be sure it wasnt changed while saving (could happen when mydac is calling mysql-server
                     if dm_DB.my_q_Arc.RecNo <> lirecordtmp1 then
                     begin
                        dm_DB.my_q_Arc.RecNo := lirecordtmp1;
                     end;
                     if bMultiArcQuery then
                     begin
                        dm_db.my_cmd.SQL.Text :=
                           'Update arc_' + sIArcName + ' set doc_state =:docstate' +
                           ' where doc_id =' + IntToStr(iGDocID);
                        dm_DB.my_Cmd.ParamByName('docstate').AsInteger := gtmpiStatus;
                        dm_db.my_cmd.Execute;
                     end;
                  end
                  else
                  begin
                     if lbnhasstsrights then
                     begin
                        BfShowMessage(_('Nicht alle nderungen an den Statusfelder konnten  gespeichert werden.') +
                           #13 + _('Grund: Fehlende Berechtigungen. Wenden Sie sich an den Administrator.'));
                     end;
                  end;
               except
                  on e: Exception do
                  begin
                     LogEvnt('9000    Allgemeiner Anwendungsfehler:    ' + e.Message);
                     frm_mainform.setpanelinfo(
                        _('Fehler beim Speichern der Dokumentennderung. Bitte Berechtigungen prfen.'));
                  end;
               end;
               //todo prfen ob shon gelock wurde
               if ((giactivedoclock and 2) > 0) and
                  ((giactivedoclock and 1) = 0) then
               begin
                  liarcid := iGArcID;
                  lidocid := iGDocID;

                  dm_db.my_cmd.SQL.Text := 'insert into sys_doclock (arc_id,doc_id,usr_id) values ' +
                     '(' + IntToStr(liarcid) + ',' + IntToStr(lidocid) +
                     ',' + inttostr(iGusrid) + ')';
                  try
                     dm_db.my_cmd.Execute;
                  except on e: exception do
                     begin
                        LogEvnt('9004b    ' + _('Fehler') + ' in Modul: tbi_checkoutClick    ' + e.Message);
                     end;
                  end;
                  try
                     NewHistory(26, _('Dokument wurde vom Benutzer') + ' ' + sGusrName + ' ' + _('mit der Usrid') + ' ' +
                        inttostr(iGUsrid) + ' ' + _('ausgecheckt.'));
                  finally
                     begin

                     end;
                  end;
                  giactivedoclock := 1;
               end
               else
               begin
                  if (giactivedoclock and 1) > 0 then
                  begin
                     liarcid := iGArcID;
                     lidocid := iGDocID;

                     dm_db.my_q_tmp.SQL.Text := 'select * from sys_doclock where ' +
                        ' arc_id=' + IntToStr(liarcid) + ' and doc_id=' + IntToStr(lidocid) +
                        ' and usr_id=' + inttostr(iGusrid);
                     try
                        dm_db.my_q_tmp.Execute;
                     except on e: exception do
                        begin
                           LogEvnt('9004c    ' + _('Fehler') + ' in Modul: tbi_checkoutClick    ' + e.Message);
                        end;
                     end;
                     if dm_db.my_q_tmp.RecordCount <> 0 then
                     begin
                        dm_db.my_cmd.SQL.Text := 'delete from  sys_doclock where ' +
                           ' arc_id=' + IntToStr(liarcid) + ' and doc_id=' + IntToStr(lidocid) +
                           ' and usr_id=' + inttostr(iGusrid);
                        try
                           dm_db.my_cmd.Execute;
                        except on e: exception do
                           begin
                              LogEvnt('9004d    ' + _('Fehler') + ' in Modul: tbi_checkoutClick    ' + e.Message);
                           end;
                        end;
                        try
                           NewHistory(26, _('Dokument wurde vom Benutzer') + ' ' + sGusrName + ' ' + _('mit der Usrid') + ' ' +
                              inttostr(iGUsrid) + ' ' + _('eingecheckt.'));
                        finally
                           begin

                           end;
                        end;
                        giactivedoclock := 0;
                     end;
                  end;
               end;
               NewHistory(9, _('nderung am Dokument gespeichert.'));
               // Wenn fur den Datensatz Zusatzfelder existieren dann
               if sbx_ZusFeld.ComponentCount > 0 then
               begin
                  if dbgrd_Trefferliste.SelectedRows.Count = 0 then
                     dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
                  SaveZusFields;
               end;

               if (lirecordtmp2 = 0) then
               begin
                  dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := False;
                  dm_DB.my_q_Arc.RecNo := lirecordtmp;
                  dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := true;
               end;

            end
            else
            begin
               if dbgrd_Trefferliste.SelectedRows.Count > 1 then
               begin
                  try
                     litmparcid := IGarcid;
                     litmpdocid := iGdocid;
                     lirecordtmp2 := iGArcRecNo;
                     lsIArcName := sIArcName;
                     if gtmpiStatus <> gotmpiStatus then
                     begin
                        if MessageDlg(Format(_('Es sind %s Dokumente markiert. Sollen die Statusfelder dieser Dokumente auf die neuen Werte gendert werden?'),
                        [IntToStr(dbgrd_Trefferliste.SelectedRows.Count)]),
                           mtWarning, [mbYes, mbNo], 0) = mrYes then
                        begin
                           lifieldschanged := (gtmpiStatus xor gotmpiStatus);
                           // set things which were set in      OnStsClick and InUseClick
                           // so save status as modified by user
                           // reset color fonts for all
                           for iCount := 0 to (tlb_Status.Items.Count - 6) do
                           begin
                              // dont try to change the color of separators or other things like that
                              if TTBXColorItem(tlb_Status.Items.Items[iCount + 5]).ClassName =
                                 'TTBXColorItem' then
                              begin
                                 if gai_sts_rights[(TTBXColorItem(tlb_Status.Items.Items[iCount + 5]).tag shr 8) - 1] then
                                 begin
                                    TTBXColorItem(tlb_Status.Items.Items[iCount +
                                       5]).FontSettings.Color := clnone;
                                 end
                                 else
                                 begin
                                    TTBXColorItem(tlb_Status.Items.Items[iCount +
                                       5]).FontSettings.Color := gcnrs;
                                 end;
                              end;
                           end;
                           for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
                           begin
                              with dbgrd_Trefferliste.DataSource.DataSet do
                              begin
                                 GotoBookMark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iSelected]));
                                 if bmultiarcquery or
                                    (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
                                 begin
                                    IGarcid := dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
                                    sIArcName := dm_DB.my_q_Arc.FieldByName('tblname').asstring;
                                 end;
                                 iGArcRecNo := dm_DB.my_q_Arc.RecNo;
                                 iGdocid := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;
                                 liarcid := iGArcID;
                                 lidocid := iGDocID;

                                 dm_db.my_q_tmp.SQL.Text := 'select * from sys_doclock where ' +
                                    ' arc_id=' + IntToStr(liarcid) + ' and doc_id=' + IntToStr(lidocid);
                                 try
                                    dm_db.my_q_tmp.Execute;
                                 except on e: exception do
                                    begin
                                       LogEvnt('9004c    ' + _('Fehler') + ' in Modul: tbi_VSaveDocClick    ' + e.Message);
                                    end;
                                 end;
                                 if dm_db.my_q_tmp.RecordCount <> 0 then
                                 begin
                                    if dm_db.my_q_tmp.fieldbyname('usr_id').asinteger <> iGusrid then
                                    begin
                                       fbfailcauselock := true;
                                       continue;
                                    end;
                                 end;
                                 lirecordtmp1 := iGArcRecNo;
                                 if dm_DB.my_q_Arc.RecNo <> iGArcRecNo then
                                 begin
                                    lirecordtmp1 := dm_DB.my_q_Arc.RecNo;
                                    dm_DB.my_q_Arc.RecNo := iGArcRecNo;
                                 end;
                                 Edit;
                                 dm_DB.my_q_Arc.Edit;
                                 //just set the values changed
                                 // set all not changed fields of avlue to 0
                                 // and add then to  the changed values of gtmpiStatus
                                 dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger :=
                                    ((not lifieldschanged) and dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger)
                                    or (gtmpiStatus and lifieldschanged);
                                 for iCount := 0 to (tlb_Status.Items.Count - 5) do
                                 begin
                                    if gtmphistory[iCount] <> '' then
                                    begin
                                       if iCount = 0 then
                                          tci_InUse.FontSettings.Color := clnone
                                       else
                                       begin
                                       	if gai_sts_rights[(TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).tag shr 8) - 1] then
				                              begin
                                             TTBXColorItem(tlb_Status.Items.Items[iCount +4]).FontSettings.Color :=
                                                   clnone;
                                             // Suchstatus des zu speichernden Status zurcksetzen
                                             gmodsearchiStatus := gmodsearchiStatus and not (1 shl iCount);
                                             // Ist die Farbe rot (Status lschen) dann setzen wir auf inaktiv
                                             // damit bei der nchsten Suche nicht versehentlich nach Status negiert gesucht wird
                                             if TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).Color = clred then
                                             begin
                                                TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).Color := clteal;
                                                gmodnegiStatus := gmodnegiStatus and not (1 shl iCount);
                                             end;
                                          end
                                          else
                                          begin
                                       		TTBXColorItem(tlb_Status.Items.Items[iCount + 4]).FontSettings.Color := gcnrs;
                                          end;
                                       end;

                                       NewHistory(22, gtmphistory[iCount]);
                                       if (gtmphinttag[iCount] <> '')
                                          and (gtmphinttag[iCount] <> '-') then
                                          dm_DB.my_q_Arc.FieldByName(gtmphinttag[iCount]).AsString :=
                                             gtmphhsvalue[iCount];
                                    end;
                                 end;
                                 dm_DB.my_q_Arc.Post;
                                 if dm_DB.my_q_Arc.RecNo <> lirecordtmp1 then
                                 begin
                                    dm_DB.my_q_Arc.RecNo := lirecordtmp1;
                                 end;
                                 if bMultiArcQuery then
                                 begin
                                    dm_db.my_cmd.SQL.Text :=
                                       'Update arc_' + sIArcName + ' set doc_state =:docstate' +
                                       ' where doc_id =' + IntToStr(iGDocID);
                                    dm_DB.my_Cmd.ParamByName('docstate').AsInteger := gtmpiStatus;
                                    dm_db.my_cmd.Execute;
                                 end;
                                 if ((giactivedoclock and 2) > 0) and
                                    ((giactivedoclock and 1) = 0) then
                                 begin
                                    dm_db.my_cmd.SQL.Text := 'insert into sys_doclock (arc_id,doc_id,usr_id) values ' +
                                       '(' + IntToStr(liarcid) + ',' + IntToStr(lidocid) +
                                       ',' + inttostr(iGusrid) + ')';
                                    try
                                       dm_db.my_cmd.Execute;
                                    except on e: exception do
                                       begin
                                          LogEvnt('9004b    ' + _('Fehler') + ' in Modul: tbi_checkoutClick    ' + e.Message);
                                       end;
                                    end;
                                    try
                                       NewHistory(26, _('Dokument wurde vom Benutzer') + ' ' + sGusrName + ' ' + _('mit der Usrid') + ' ' +
                                          inttostr(iGUsrid) + ' ' + _('ausgecheckt.'));
                                    finally
                                       begin

                                       end;
                                    end;
                                 end
                                 else
                                 begin
                                    if (giactivedoclock and 1) > 0 then
                                    begin
                                       dm_db.my_q_tmp.SQL.Text := 'select * from sys_doclock where ' +
                                          ' arc_id=' + IntToStr(liarcid) + ' and doc_id=' + IntToStr(lidocid) +
                                          ' and usr_id=' + inttostr(iGusrid);
                                       try
                                          dm_db.my_q_tmp.Execute;
                                       except on e: exception do
                                          begin
                                             LogEvnt('9004c    ' + _('Fehler') + ' in Modul: tbi_checkoutClick    ' + e.Message);
                                          end;
                                       end;
                                       if dm_db.my_q_tmp.RecordCount <> 0 then
                                       begin
                                          dm_db.my_cmd.SQL.Text := 'delete from  sys_doclock where ' +
                                             ' arc_id=' + IntToStr(liarcid) + ' and doc_id=' + IntToStr(lidocid) +
                                             ' and usr_id=' + inttostr(iGusrid);
                                          try
                                             dm_db.my_cmd.Execute;
                                          except on e: exception do
                                             begin
                                                LogEvnt('9004d    ' + _('Fehler') + ' in Modul: tbi_checkoutClick    ' + e.Message);
                                             end;
                                          end;

                                          try
                                             NewHistory(26, _('Dokument wurde vom Benutzer') + ' ' + sGusrName + ' ' + _('mit der Usrid') + ' ' +
                                                inttostr(iGUsrid) + ' ' + _('eingecheckt.'));
                                          finally
                                             begin

                                             end;
                                          end;
                                       end;
                                    end;
                                 end;
                              end;
                           end;
                        end;
                     end;

                     if ((giactivedoclock and 2) > 0) and
                        ((giactivedoclock and 1) = 0) then
                     begin
                        giactivedoclock := 1;
                     end
                     else
                     begin
                        if (giactivedoclock and 1) > 0 then
                        begin
                           giactivedoclock := 0;
                        end;
                     end;
                     gotmpiStatus := gtmpiStatus;
                     //todo prfen ob shon gelock wurde
                     if ZusFieldsChanged then
                     begin
                        // Wenn fur den Datensatz Zusatzfelder existieren dann
                        if sbx_ZusFeld.ComponentCount > 0 then
                        begin
                           if dbgrd_Trefferliste.SelectedRows.Count > 1 then
                           begin
                              if MessageDlg(Format(_('Es sind %s Dokumente markiert. Sollen die Zusatzfelder dieser Dokumente auf die neuen Werte gendert werden?'),
                              [IntToStr(dbgrd_Trefferliste.SelectedRows.Count)]),
                                 mtWarning, [mbYes, mbNo], 0) = mrYes then
                                 SaveZusFields; // Zusatzfelder speichern
                           end
                           else
                              SaveZusFields;
                        end;
                     end;
                     if fbfailcauselock then
                     begin
                        BfShowMessage(_('Die nderungen konnten nicht fr alle Dokumente auf Grund vom Auschecken') +
                           #13 + ' ' + _('bertragen werden.'));
                     end;
                  finally
                     begin
                        IGarcid := litmparcid;
                        iGdocid := litmpdocid;
                        iGArcRecNo := lirecordtmp2;
                        sIArcName := lsIArcName;
                     end;
                  end;
               end;
            end;
            // change back if not already done
            if lirecordtmp <> dm_db.my_q_arc.RecNo then
            begin
            end;

            FillZusFields; // Zusatzfelder aktualisieren
            // be sure do disable after filling
            tbi_VSaveDoc.Enabled := False;
            btn_SaveDoc.Enabled := False;
         end
         else
            BfShowMessage(_('Hinweis!') + #13 + _('Sie drfen dieses Dokument nicht speichern'));
         GHasNotBeenSavedAfterModify := False;
         fgchangedvoransicht := False;
         fgchangedvoransichttif := False;
         gtmpiStatus := gotmpistatus;
      finally
         begin
            fbsaving := false;
//            dm_MainForm2.tim_voransicht.enabled := lbtim_voransicht;
            dm_DB.tim_ansicht.enabled := lbtim_ansicht;
         end;
      end;
      loadthumbs(lipage, false);
   finally
      gbBlockVoransicht := false; //3.5.0.41 [2398]
      gbSaveDoc := False
   end;
end;

//  Dokumente lokal speichern
procedure Tfrm_MainForm.tbi_VLokalSaveClick(Sender: TObject);
begin
  GgfLogEvntBeg('tbi_VLokalSaveClick beg');
   if gbSaveDoc then
      Exit;

   gbSaveDoc := True;
   dbgrd_Trefferliste.Enabled := False;
   try
      Do_VLokalSave;
   finally
      Screen.Cursor := crDefault;
      Windows.SetCursor(Screen.Cursors[0]);
      dbgrd_Trefferliste.Enabled := True;
      gbSaveDoc := False;
   end;
end;



procedure Tfrm_MainForm.Do_VLokalSave;
var
   iCount, iTmpDocID, iTmpArcID, iCopy, iNoOfSelect: integer;
   sTmpTblName, sPathName, sDocFile, sTmpFile, sOriFile, sNamFile,
   sTmpPath, dir, lsext, snamFile1, sMsg: string;
   Folder: TFolderBrowser;
begin
   GgfLogEvntBeg('Do_VLokalSave beg');
   sTmpPath := BD.EnvTemp + '\bfa_send';

   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   if not CheckBookmark then
      Exit;

   askforsave;
   iTmpDocID   := iGDocID;
   iTmpArcID   := iGArcID;
   iCopy       := 0;
   sTmpTblName := sIArcName;
   sMsg        := '';

   gbSaveDoc := True;
   try
      if dbgrd_Trefferliste.SelectedRows.Count = 0 then
      begin
         BfShowMessage(_('Bitte whlen Sie ein Dokument.'));
      end;

      if (trim(gsstandarddir) = '') or (not directoryexists(gsstandarddir)) then
      begin
         if not NogSelectDirectory(_('Bitte whlen Sie ein Verzeichnis'),
            '\', fstdir, False, False, True) then
         begin
            exit;
         end;
         dir := fstdir;
      end
      else
      begin
         dir := gsstandarddir;
      end;
      sPathName := dir;

      Screen.Cursor := crHourGlass;
      Windows.SetCursor(Screen.Cursors[0]);

      try
        gbBlockVoransicht := true; 

        iNoOfSelect := dbgrd_Trefferliste.SelectedRows.Count;

        for iCount := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
        begin
           with dm_DB.my_q_Arc do
           begin
              GotoBookmark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iCount]));
              iGDocID := FieldByName('doc_id').AsInteger;
              GgfLogEvnt('tbi_VLokalSaveClick Doc-Nr.'+IntToStr(iCount) + 'DocId='+IntToStr(iGDocID));
              if bMultiArcQuery and (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
              begin
                 iGArcID := FieldByName('arc_id').AsInteger;
                 sIArcName := FieldByName('TblName').AsString;
              end;

              //   Rechte des Users am Document ermitteln
              //   SCHREIBEN in lokales Verzeichnis
				  GetDocUsrRights(False);
              if rGDocRight.Write then
              begin
                 sDocFile := FieldByName('doc_loc').AsString;
                 sTmpFile := FieldByName('ext_loc').AsString;
                 sOriFile := FieldByName('ori_loc').AsString;

                 if FileExists(sTmpFile) and not oribysave then
                 begin
                    sDocFile := sTmpFile;
                 end;
                 if length(gaspreferedtifname) = 0 then
                 begin
                    sNamFile := DateinameAnhandZusatzfelder(ArcDocId(iGArcID,iGDocID),sIArcName,dm_DB.my_q_Arc);
                    if sNamFile='' then
                       sNamFile := Dm_db.my_q_Arc.FieldByName('Disp_name').AsString;
                    sNamFile := CleanFileName(sNamFile);

                    // check for existent files and do not overwrite it!
                    if (((pdfbysave) and (not tifbysave)) or
                       ((UpperCase(ExtractFileExt(sOriFile)) = '.PDF') and oribysave) or
                       (UpperCase(ExtractFileExt(sDocFile)) = '.PDF') and oribysave) then
                       lsext := '.pdf'
                    else
                    if oribysave then
                    begin
                       lsext := ExtractFileExt(sOriFile);
                    end
                    else
                       lsext := '.tif';
                    snamFile := CalcNonExistingFilename(sPathName, snamFile, lsext);
                 end
                 else
                 begin
                    snamFile := gaspreferedtifname[iCount];
                 end;
                 if (bExportPDF or pdfbysave) and not tifbysave and not oribysave then
                    // real PDF Export
                 begin
                    if UpperCase(ExtractFileExt(sOriFile)) = '.PDF' then
                    begin
                       lsext := ExtractFileExt(sOriFile);
                       snamFile := CalcNonExistingFilename(sTmpPath, sNamFile, lsext);
                       if CopyFileF(sOriFile, sTmpPath + '\' + sNamFile + lsext) then
                       begin
                          //GgfLogEvnt('Do_VLokalSave CopyFileF A');
                          snamFile := CalcNonExistingFilename(sPathName, sNamFile, '.pdf');
                          if CopyFileF( sTmpPath + '\' + sNamFile + lsext,
                                        sPathName + '\' + sNamFile + '.pdf') then
                          begin
                             //GgfLogEvnt('tbi_VLokalSaveClick CopyFileF B');
                             NewHistory(15,
                                _('Dokument wurde in lokalem Verzeichnis') + ' [' +
                                sPathName + '] ' + _('gespeichert.'));
                             Inc(iCopy);
                          end
                          else
                          begin
                            GgfLogEvnt('Do_VLokalSave Datei fehlend:' + sTmpPath + '\' + sNamFile + lsext);

                            //  19.05.2010  Vers. 3.5.0.77  [2364]  r.sch.
                            sMsg := sMsg
                              + 'Dokument mit ID '
                              + IntToStr (iGArcID) + '.'
                              + IntToStr (iGDocID) +': Datei fehlt!'+#13;
                          end;
                       end;
                    end
                    else
                    begin
                       if dm_MainForm2.ConvertTo('pdf', sDocFile, sPathName + '\') then
                       begin
                          //GgfLogEvnt('Do_VLokalSave ConvertTo');
                          NewHistory(15,
                             _('Dokument wurde in lokalem Verzeichnis') + ' [' +
                             sPathName + '] ' + _('gespeichert.'));
                          Inc(iCopy);
                       end;
                    end;
                 end
                 else
                 begin
                    // speichern der Originaldatei
                    if oribysave then
                    begin
                       if sorifile <> '' then
                       begin
                          sdocfile := sorifile;
                       end;
                    end;
                    lsext := ExtractFileExt(sDocFile);
                    snamFile := CalcNonExistingFilename(sPathName, snamFile, lsext);
                    if CopyFileF(sDocFile, sPathName + '\' + snamFile + lsext) then
                    begin
                       //GgfLogEvnt('Do_VLokalSave CopyFileF Doc');
                       NewHistory(15, _('Dokument wurde in lokalem Verzeichnis') + ' [' +
                          sPathName + '] ' + _('gespeichert.'));
                       Inc(iCopy);
                    end
                    else
                    begin
                      GgfLogEvnt('Do_VLokalSave Datei fehlend:'+sDocFile);

                      //  19.05.2010  Vers. 3.5.0.77  [2364]  r.sch.
                      sMsg := sMsg
                            + 'Dokument mit ID '
                            + IntToStr (iGArcID) + '.'
                            + IntToStr (iGDocID) +': Datei fehlt!' +#13;
                    end;
                 end;
              end
              else
              begin
                sMsg := sMsg
                      + 'Dokument mit ID '
                      + IntToStr (iGArcID) + '.'
                      + IntToStr (iGDocID)
                      + ': Schreibrecht fehlt oder das Dokument ist ausgecheckt!' +#13;

                GgfLogEvnt('Do_VLokalSave Recht fehlt');
              end;
           end;
        end;
      finally
         gbBlockVoransicht := false; 
      end;

      //  Ende der verarbeitung von TIFF und PDF
      iGDocID := iTmpDocID;
      iGArcID := iTmpArcID;
      sIArcName := sTmpTblName;
      frm_mainform.setpanelinfo(
         _('Es wurden') + ' ' + IntToStr(iCopy) + ' ' + _('Dokumente von') + ' ' +
         IntToStr(dbgrd_Trefferliste.SelectedRows.Count) + ' ' + _('gespeichert.'));

     //  19.05.2010  Vers. 3.5.0.77  [2364]  r.sch.
     if (iCopy >= iNoOfSelect) then
     begin
       sMsg := IntToStr (iCopy) + ' von ' + IntToStr (iNoOfSelect)
             + ' Dateien sind lokal gespeichert worden.';

       stb_Main.Panels [7].Caption := sMsg;
     end
     else
     begin
       sMsg := IntToStr (iCopy) + ' von ' + IntToStr (iNoOfSelect)
             + ' Dateien sind lokal gespeichert worden.' +#13+#13
             + sMsg;

       BfShowMessage (sMsg);
     end;

   finally
      if Assigned(Folder) then
         FreeAndNil(Folder);
      Screen.Cursor := crDefault;
      Windows.SetCursor(Screen.Cursors[0]);
   end;

   GgfLogEvntEnd('Do_VLokalSave end');
end;

procedure Tfrm_MainForm.tbsi_VMailClick(Sender: TObject);
//  Dokument per email versenden  durch Auswahl der Art und Weise der ZUsammenstellung der Email
//  SendMailFile    Dokument wird als Anhang versendet
//  MailLinkClick   Dokument wird als Link versendet
begin
   GgfLogEvnt('tbsi_VMailClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   case tbsi_VMail.ImageIndex of
      15:
         dm_MainForm2.SendMailFile(0, -1, tbi_VShowAnno.Checked);
      16:
         tbi_VerknuepfungVersendenClick(self);
      30:
         tbi_VorJederMailFragenClick(self);
   end;
end;

procedure Tfrm_MainForm.tbi_VerknuepfungVersendenClick(Sender: TObject);
// Nachtrgliche Dokumentation
// MailLinkClick   Dokument wird als Link versendet
begin
   GgfLogEvnt('tbi_MailLinkClick');
   dazuversenden := False;
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;

   askforsave;
   if bUseIntMail then
   begin
      Application.CreateForm(Tfrm_SendMailLnk, frm_SendMailLnk);
      frm_SendMailLnk.ShowModal;
      frm_SendMailLnk.Release;
   end
   else
   begin
      dm_MainForm2.SendLinkMapi;
   end;
end;

procedure Tfrm_MainForm.tbi_AlsTifPdfVersendenClick(Sender: TObject);
// Nachtrgliche Dokumentation
// Mail File Click   Dokument wird als Anhang versandt
begin
   GgfLogEvnt('tbi_MailFileClick');
   askforsave;
   dazuversenden := False;
   dm_MainForm2.SendMailFile(0, -1, tbi_VShowAnno.Checked);
end;

procedure Tfrm_MainForm.tbi_VorJederMailFragenClick(Sender: TObject);

// POP UP EMAIL versenden
//      Email als Anhang versenden
//      Email als Link versenden
//      Email mit einer Originaldatei im Anhang vesenden
begin
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   askforsave;
   Application.CreateForm(Tfrm_AskSendMail, frm_AskSendMail);
   if dm_MainForm2.smtp_Eng.Host = '' then
   begin
      frm_MainForm.tbi_VerknuepfungVersenden.Enabled := False;
   end;

   frm_AskSendMail.ShowModal;

   case frm_AskSendMail.ModalResult of
      mrYes:
         dm_MainForm2.SendMailFile(0, -1, tbi_VShowAnno.Checked);
      mrNo:
         tbi_VerknuepfungVersendenClick(self);
      mrOk:
      begin
         // gbsendthisemailnow will be resetted in sendorimail
         if gbsendthisemailnow then
         begin
            dm_MainForm2.SendOriMail(True);
         end
         else
         begin
            dm_MainForm2.SendOriMail(True);
            frm_MainForm.tbi_GesammelteDokumenteVersendenClick(self);
         end;
      end;
   end;
   frm_AskSendMail.Release;
end;

//  Annotation Edit fr ein angezeigtes Dokument aufrufen
//  Dokument bearbeiten
procedure Tfrm_MainForm.tbi_VEditClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VEditClick');
   OpenDocEditor;
end;

procedure Tfrm_MainForm.OpenDocEditor;
var
  i :Integer;
begin
   GgfLogEvnt('OpenDocEditor');
   if (dm_DB.my_q_Arc.RecordCount = 0) or fbopeningeditor then
      exit;
   if (igArcid = -1) or (iGDocID = -1) then
   		exit;
   for i:= 0 to length(farrayofdoceid) -1 do
   begin
      if (farrayofdoceid[i].Doc_obj.doc_id = iGDocID)
         and (farrayofdoceid[i].Doc_obj.arc_id = iGArcID) then
      begin
        flastdoc_edit :=  farrayofdoceid[i];
        flastdoc_edit.fwassettofront := False;
        farrayofdoceid[i].BringToFront;
        Application.ProcessMessages;
        Exit;
      end;
   end;

   try
      fbopeningeditor := true;
      if tbi_Vedit.Enabled then
      begin
			askforsave;

         if iGArcRecNo <> dm_db.my_q_arc.RecNo then
         begin
            dm_db.my_q_Arc.GotoBookmark(
               Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
         end;
         // actualize after saving it (maybe)
         dm_db.my_q_Arc.refreshrecord;
         gbdoceditformshowed := false;
         GgfLogEvnt(' creating editor dm_docedit edt_form');
         if not assigned(dm_docedit) then
         begin
            Application.CreateForm(Tdm_DocEdit, dm_DocEdit);
         end;

         GgfLogEvnt(' creating editor frm_docedit edt_form');
         Application.CreateForm(Tfrm_DocEdit, frm_DocEdit);

         if gbchangepagebyenter then
            frm_DocEdit.tbedt_NPage.OnChange := nil
         else
            frm_DocEdit.tbedt_NPage.OnChange := frm_DocEdit.tbedt_NPageChange;
         frm_DocEdit.Caption := _('Dokumenteneditor');
         setlength(farrayofdoceid, length(farrayofdoceid) + 1);
         farrayofdoceid[length(farrayofdoceid) - 1] := frm_DocEdit;
         flastdoc_edit := frm_DocEdit;

         frm_docedit.Doc_obj.doc_id := igdocid;
         frm_docedit.Doc_obj.arc_id := igarcid;
         frm_docedit.Doc_obj.gdocid := giglobalgdocid;
         frm_docedit.Doc_obj.disp_name := dm_db.my_q_Arc.fieldbyname('disp_name').AsString;
         frm_docedit.Doc_obj.doc_loc := dm_db.my_q_Arc.fieldbyname('doc_loc').AsString;
         frm_docedit.Doc_obj.ext_loc := dm_db.my_q_Arc.fieldbyname('ext_loc').AsString;
         frm_docedit.Doc_obj.sIArcName := sIArcName;
         frm_docedit.Doc_obj.rights := rGDocRight;
         frm_docedit.fra_DocEditor.fDocid := igdocid;
         frm_docedit.fra_DocEditor.farcid := igarcid;
         frm_docedit.fra_DocEditor.fgdocid := giglobalgdocid;
         frm_docedit.fra_DocEditor.fdispname := dm_db.my_q_Arc.fieldbyname('disp_name').AsString;
         frm_docedit.fra_DocEditor.fdocloc := dm_db.my_q_Arc.fieldbyname('doc_loc').AsString;
         frm_docedit.fra_DocEditor.fextloc := dm_db.my_q_Arc.fieldbyname('ext_loc').AsString;
         frm_docedit.fra_DocEditor.fTblName := sIArcName;
         frm_docedit.fra_DocEditor.frights := rGDocRight;

         logEvnt('  showing edt_form');
         frm_DocEdit.Show;
         logEvnt('  releasing edt_form');
         frm_DocEdit.fra_DocEditor.fRights := rGDocRight;
         frm_DocEdit.fra_DocEditor.img_DocView.MouseInteract := [miScroll];

         GgfLogEvnt('  showing frm_DocEdit');
         frm_MainForm.NewHistory(9, _('Dok-Editor: Dokument geffnet.'));

         frm_DocEdit.Show;
      end;
   finally
      fbopeningeditor := false;
	end;
end;


procedure Tfrm_MainForm.tbi_VRemBorderClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VRemBorderClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   if rGDocRight.modify and (iGBorderRem <= 3) then
   begin
	   Screen.Cursor := crHourGlass;
      Windows.SetCursor(Screen.Cursors[0]);
      //Application.ProcessMessages;
      fra_Voransicht.img_DocView.Proc.AutoCrop(10, CreateRGB(255, 255, 255));
      fra_Voransicht.img_DocView.Proc.AutoCrop(10, CreateRGB(0, 0, 0));
      Inc(iGBorderRem);
      tbsi_VZoomClick(self);
      if Assigned(frm_Wait) then
      begin
         frm_Wait.Close;
      end;
      Screen.Cursor := crDefault;
      Windows.SetCursor(Screen.Cursors[0]);
      EnableSaveBtn;
      GHasNotBeenSavedAfterModify := True;
      fgchangedvoransicht := true;
      fgchangedvoransichttif := true;
   end;
   if not rGDocRight.modify then
      ShowMessage(_('Hinweis!') + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
end;

procedure Tfrm_MainForm.tbi_VDeSkewClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VDeSkewClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;

   Screen.Cursor := crHourGlass;
   Windows.SetCursor(Screen.Cursors[0]);
   //Application.ProcessMessages;
   with fra_Voransicht.img_DocView.Proc do
      Rotate(SkewDetection(0, 45, 0.1, True), True, ierFast, -1);
   tbsi_VZoomClick(self);
   if Assigned(frm_Wait) then
   begin
      frm_Wait.Close;
   end;
   Screen.Cursor := crDefault;
   Windows.SetCursor(Screen.Cursors[0]);
   EnableSaveBtn;
   GHasNotBeenSavedAfterModify := True;
   fgchangedvoransicht := true;
end;

procedure Tfrm_MainForm.tbsi_VDeSpeckleClick(Sender: TObject);
var
   iRemPixel: integer;
begin
   GgfLogEvnt('tbsi_VDeSpeckleClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   with fra_Voransicht.img_DocView.Proc do
   begin
      case tbsi_VDeSpeckle.ImageIndex of
         36:
            RemoveIsolatedPixels(0, 1);
         37:
            RemoveIsolatedPixels(0, 2);
         38:
            RemoveIsolatedPixels(0, 3);
         39:
            RemoveIsolatedPixels(0, 4);
      end;
      if tbsi_VDeSpeckle.ImageIndex = 35 then
      begin
         Application.CreateForm(Tfrm_DeSpeckle, frm_DeSpeckle);
         frm_DeSpeckle.ShowModal;
         iRemPixel := frm_DeSpeckle.Tag;
         frm_DeSpeckle.Release;
         case iRemPixel of
            0:
               RemoveIsolatedPixels(0, 1);
            1:
               RemoveIsolatedPixels(0, 2);
            2:
               RemoveIsolatedPixels(0, 3);
            3:
               RemoveIsolatedPixels(0, 4);
         end;
      end;
   end;
   EnableSaveBtn;
   GHasNotBeenSavedAfterModify := True;
   fgchangedvoransicht := true;
   fgchangedvoransichttif := true;
end;

procedure Tfrm_MainForm.tbi_DSp1PClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_DSp1PClick');
   tbsi_VDeSpeckle.ImageIndex := tbi_DSp1P.ImageIndex;
   tbsi_VDeSpeckleClick(self);
end;

procedure Tfrm_MainForm.tbi_DSp2PClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_DSp2PClick');
   tbsi_VDeSpeckle.ImageIndex := tbi_DSp2P.ImageIndex;
   tbsi_VDeSpeckleClick(self);
end;

procedure Tfrm_MainForm.tbi_DSp3PClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_DSp3PClick');
   tbsi_VDeSpeckle.ImageIndex := tbi_DSp3P.ImageIndex;
   tbsi_VDeSpeckleClick(self);
end;

procedure Tfrm_MainForm.tbi_DSp4PClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_DSp4PClick');
   tbsi_VDeSpeckle.ImageIndex := tbi_DSp4P.ImageIndex;
   tbsi_VDeSpeckleClick(self);
end;

procedure Tfrm_MainForm.tbi_DSpAskClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VTurnLeftClick');
   tbsi_VDeSpeckle.ImageIndex := tbi_DSpAsk.ImageIndex;
   tbsi_VDeSpeckleClick(self);
end;

procedure Tfrm_MainForm.tbi_VTurnLeftClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VTurnLeftClick');
   Drehen(90);
end;

procedure Tfrm_MainForm.tbi_VTurnRightClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VTurnRightClick');
   Drehen(-90);
end;

procedure Tfrm_MainForm.tbi_VFlipClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VFlipClick');
   Drehen(180);
end;

procedure Tfrm_MainForm.Drehen(Grad:integer);
var
   iCount, iidx, licount: integer;
   lball: boolean;
   sExtFile, sDocPath, sTmpPath: string;
   lbenti: boolean;
begin
  GgfLogEvntBeg('Drehen('+IntToStr(Grad)+')');
  try
   lbenti := false;
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) or
      (not (rGDocRight.modify
      or rGDocRight.Write))  //m.frey: das ist unlogisch, deswegen raus
   then
      exit;
   lball := false;
   if (tmb_Voransicht.MultiSelectedImagesCount > 1) then
   begin
      if length(GaiPagesSelectedtmb) > 0 then
      begin
         BfShowMessage(_('Bitte lschen Sie die Suchbegriffe des Volltextes und laden') +
            #13 + _('Sie das Dokument neu.(Trefferseiten und markierte Seiten sind') +
            #13 + _('inkompatibel)'));
      end;
      if dm_MainForm2.Frage(_('Sie haben mehrere Seiten markiert.') +
         #13 + _('Mchten Sie die alle Seiten drehen?') +
         #13 + _('Dabei wird das gedrehte Dokument sofort gespeichert.'),
         True) = mrYes then
      begin
         lball := true;
      end;
   end;
   try
//      lbenti := dm_MainForm2.tim_voransicht.enabled;
//      dm_MainForm2.tim_voransicht.enabled := false;
      if lball then
      begin
         fbturned := true;

         sDocPath := sgdocfilename;

         sExtFile := sgextfilename;
         if sExtFile <> '' then
         begin
            sDocPath := sExtFile;
         end;
         sTmpPath := StringReplace(sDocPath, sGArcPath, sGCopyPath, []);
         
         if FileExists(sTmpPath) then
            // Wenn schon eine Datei existiert bearbeite diese
         else // Wenn Datei nicht existiert kopiere Sie zuerst und aendere Sie dann.
         begin
            CopyFile(PChar(sDocPath), PChar(sTmpPath), False);
         end;

         fra_Voransicht.img_DocView.CancelInteracts;
         fra_Voransicht.img_DocView.RemoveAllObjects;
         licount := fra_Voransicht.img_DocView.IO.Params.ImageIndex;
         fra_Voransicht.img_DocView.OnProgress := nil;

         for iCount := 0 to (tmb_Voransicht.MultiSelectedImagesCount - 1) do
         begin
            GgfLogEvnt('Drehen Seite '+IntToStr(iCount));
            iIdx := tmb_Voransicht.MultiSelectedImages[iCount];
            fra_Voransicht.img_DocView.IO.Params.ImageIndex := iidx;
            fra_Voransicht.img_DocView.IO.LoadFromFile(sTmpPath);
            fra_Voransicht.img_DocView.Proc.Rotate(Grad);
            //fra_Voransicht.img_DocView.IO.ReplaceFileTIFF(sTmpPath);
            IoSaveGraphic(fra_Voransicht.img_DocView.IO,sTmpPath);
            try
               if frm_mainform.tmb_Voransicht.ImageCount > 0 then
               begin
                  tmb_Voransicht.Proc.AttachedIEBitmap := tmb_Voransicht.GetTIEBitmap(iidx);
                  tmb_Voransicht.Proc.Rotate(Grad);
               end;
            except on e: exception do
               begin
                  GgfLogEvnt('Drehen exception: '+e.message);
               end;
            end;
         end;
         fra_Voransicht.img_DocView.IO.Params.ImageIndex := licount;
         fra_Voransicht.img_DocView.IO.LoadFromFile(sTmpPath);
         tmb_Voransicht.UpdateEx(True);
      end
      else
      begin
         iIdx := tmb_Voransicht.MultiSelectedImages[0];
         if iIdx = -1 then
         begin
            iIdx := fra_Voransicht.img_DocView.io.Params.ImageIndex;
         end;
        tmb_Voransicht.SelectedImage:= iIdx;     //08.09.2010 b.takacs Error by rotate, beacuse image was not selected
        fra_Voransicht.img_DocView.Proc.Rotate(Grad);
        if frm_mainform.tmb_Voransicht.ImageCount > 0 then
        begin
          tmb_Voransicht.Proc.AttachedIEBitmap := tmb_Voransicht.GetTIEBitmap(iIdx);
          tmb_Voransicht.Proc.Rotate(Grad);
          tmb_Voransicht.UpdateEx(True);
        end;
      end;

      tbsi_VZoomClick(self);
      EnableSaveBtn;
      GHasNotBeenSavedAfterModify := True;
      fgchangedvoransicht := true;
      fgchangedvoransichttif := true;
      if lball then
      begin
         //askforsave;
         tbi_VSaveDocClick(self);
         GHasNotBeenSavedAfterModify := False;
         fgchangedvoransicht := False;
         fgchangedvoransichttif := False;
         gtmpiStatus := gotmpistatus;
         btn_SaveDoc.Enabled := False;
         tbi_VSaveDoc.Enabled := True;
      end;
   finally
//      dm_MainForm2.tim_voransicht.enabled := lbenti;
      fbturned := false;
   end;
  finally
     GgfLogEvntEnd('Drehen end'); 
  end;
end;

procedure Tfrm_MainForm.tbi_VSlwEditClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VSlwEditClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   if rGDocRight.modify then
   begin
      Application.CreateForm(Tfrm_SlwEdit, frm_SlwEdit);
      frm_SlwEdit.ShowModal;
      frm_SlwEdit.Release;
   end
   else
      BfShowMessage(_('Hinweis') + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
end;

procedure Tfrm_MainForm.tbi_VNewLinkClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VNewLinkClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   ActivateLinkDoc(fra_DocLink.CreAutoLink);
   fra_DocLink.GetQuickLinks;
   tci_DocLink.Color := clYellow;
end;

procedure Tfrm_MainForm.tbi_VLinkDocClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VLinkDocClick');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   ActivateLinkDoc(fra_DocLink.AutoLinkDoc);
   fra_DocLink.GetQuickLinks;
end;

procedure Tfrm_MainForm.tbi_VPrevClick(Sender: TObject);
var ipage: integer;
begin
   GgfLogEvnt('tbi_VPrevClick');

   if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveObjects(False,False);

   iPage := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageIndex;
   Dec(iPage);
   if iPage < 0 then
      iPage := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1;
   if iPage > (fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1) then
      iPage := 0;

   tmb_VoransichtImageSelect(sender, iPage);
end;

procedure Tfrm_MainForm.tbi_VNextClick(Sender: TObject);
var ipage: integer;
begin
   GgfLogEvnt('tbi_VNextClick');

   if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveObjects(False,False);

   iPage := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageIndex;
   Inc(iPage);
   if iPage < 0 then
      iPage := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1;
   if iPage > (fra_Voransicht.img_DocView.IO.Params.Tiff_ImageCount - 1) then
      iPage := 0;

   tmb_VoransichtImageSelect(sender, iPage);
end;

procedure Tfrm_MainForm.cbx_VZoomChange(Sender: TObject; const Text: string);
var
   fpZoom: single;
   iPos: integer;
   mousePos: Tpoint;
   sZoom: string;
begin
   GgfLogEvnt('cbx_VZoomChange');
   iPos := Pos('%', cbx_VZoom.Text);
   if iPos = -1 then
   begin
      cbx_VZoom.Text := cbx_VZoom.Text + ' %';
      iPos := Pos('%', cbx_VZoom.Text);
   end;

   //dont change the view if already changed
   if gbchangezoomtextnotview then
      exit;
   getcursorpos(mousePos);
   if iPos < 2 then
      exit;

   sZoom := copy(cbx_VZoom.Text, 0, iPos - 2);
	sZoom := StringReplace(sZoom, ',', gFormatSettings.DecimalSeparator,[rfReplaceAll]);
   if TryStrToFloat(sZoom, fpZoom, gFormatSettings) then
   begin
      try
         fra_Voransicht.img_DocView.Zoom := fpZoom;
      except
         on e: Exception do
         begin
            logevnt('Fehler bei zoomen');
         end;
      end;
   end;
end;

procedure Tfrm_MainForm.tbsi_VZoomClick(Sender: TObject);
begin
   GgfLogEvnt('tbsi_VZoomClick');
   if fra_Voransicht.img_DocView.MouseInteract = [miSelectZoom] then
   begin
      uncheckallgraphictools;
      fra_Voransicht.img_DocView.MouseInteract := [];
   end;
   case tbsi_VZoom.ImageIndex of
      21:
         tbi_ZoomWidthClick(self);
      22:
         tbi_ZoomPageClick(self);
      23:
         tbi_Zoom100Click(self);
      24:
         tbi_ZoomHeightClick(self);
      25:
         tbi_ZoomSelectClick(self);
   end;
end;

procedure Tfrm_MainForm.tbi_Zoom100Click(Sender: TObject);
begin
   GgfLogEvnt('tbi_Zoom100Click');
   with fra_Voransicht.img_DocView do
      if Zoom <> 100 then
      begin
         Zoom := 100;
         uncheckallgraphictools;
         MouseInteract := [miScroll];
      end;
   tbsi_VZoom.ImageIndex := 23;
end;

procedure Tfrm_MainForm.tbi_ZoomPageClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_ZoomPageClick');
   fra_Voransicht.img_DocView.Fit;
   tbsi_VZoom.ImageIndex := 22;
end;

procedure Tfrm_MainForm.tbi_ZoomWidthClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_ZoomWidthClick');
   try
      fra_Voransicht.img_DocView.FitToWidth;
   except
      on e: Exception do
      begin
         logevnt('Error on fitwidth' + e.message);
         frm_Mainform.fra_Voransicht.img_DocView.unLockpaint;
         frm_Mainform.fra_Voransicht.img_DocView.unLockpaint;
      end;
   end;

   uncheckallgraphictools;
   fra_Voransicht.img_DocView.MouseInteract := [miScroll];
   tbsi_VZoom.ImageIndex := 21;
end;

procedure Tfrm_MainForm.tbi_ZoomHeightClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_ZoomHeightClick');
   uncheckallgraphictools;
   fra_Voransicht.img_DocView.FitToHeight;
   fra_Voransicht.img_DocView.MouseInteract := [miScroll];
   tbsi_VZoom.ImageIndex := 24;
end;

procedure Tfrm_MainForm.tbi_ZoomSelectClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_ZoomOffClick');
   uncheckallgraphictools;
   fra_Voransicht.img_DocView.MouseInteract := [miSelectZoom];
   tbsi_VZoom.ImageIndex := 25;
end;

procedure Tfrm_MainForm.tbi_ZoomOffClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VLupeClick');
   uncheckallgraphictools;
   fra_Voransicht.img_DocView.MouseInteract := [miScroll];
   tbsi_VZoom.ImageIndex := 41;
end;

procedure Tfrm_MainForm.tbi_VLupeClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VLupeClick');
   tbi_VLupe.Checked := not tbi_VLupe.Checked;
end;

procedure Tfrm_MainForm.tbi_SuchenClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_SuchenClick');
   btn_StartSrcClick(self);
end;

procedure Tfrm_MainForm.tbi_ResetClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_ResetClick');
   btn_ResFieldsClick(self);
end;

procedure Tfrm_MainForm.cbx_LagerChange(Sender: TObject);
begin
   if gbViewerShutdown then
   	 exit;

   GgfLogEvnt('cbx_LagerChange');
   fidropnode := -1;

   if cbx_Lager.ItemIndex = -1 then
   begin
      cbx_Lager.ItemIndex := cbx_Lager.Items.IndexOf(cbx_Lager.Text);
   end;

   if cbx_Lager.ItemIndex <> -1 then
   begin
      askforsave;
      GgfLogEvnt('SetControls(True)a'); //3.5.0.22
      SetControls(True); // Alle Schaltfelder der wieder einschalten //3.5.0.22
      iGLgrId := integer(cbx_Lager.Items.Objects[cbx_Lager.ItemIndex]);
      ReadCbxArc(cbx_Archiv, iGUsrID, iGLgrID);
      if Sender.ClassNameIs('TJvComboBox') then
         dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGLgrID), []);
      ResetTrefferliste;

      GetArcUsrRights;

      //disable save button
      btn_SaveDoc.Enabled := False;
      tbi_VSaveDoc.Enabled := false;
   end;
   GgfLogEvnt('cbx_LagerChange End');
end;

//  Archiv anzeigen
procedure Tfrm_MainForm.cbx_ArchivChange(Sender: TObject);
var
   iTmpID, licounter, liType: integer;
   lstemp, lstemp1: string;
begin
   if gbViewerShutdown then
   	 exit;

   If gbArchivChange then
      Exit;

   gbArchivChange := True;
   try
      GgfLogEvntBeg ('cbx_ArchivChange Begin');
      fidropnode := -1;
      gbTrefferlisteFiltered:= dbgrd_Trefferliste.filtered;
   	dbgrd_Trefferliste.filtered := False;

      if cbx_Archiv.ItemIndex = -1 then
      begin
        cbx_Archiv.ItemIndex := cbx_Archiv.Items.IndexOf(cbx_Archiv.Text);
      end;
      if (cbx_Archiv.ItemIndex = 0) or (cbx_Archiv.ItemIndex = -1) then
      begin
        bMultiArcQuery := true;
        gbcfgxs := false;
      end
      else
      begin
        bMultiArcQuery := false;
      end;
      //no rights for zusfields
      try
         if (cbx_Archiv.ItemIndex <> -1) then
	        iTmpID := integer(cbx_Archiv.Items.Objects[cbx_Archiv.ItemIndex]);
        if (iTmpID = iGArcID) and (not gbarclick) then
        begin
          GgfLogEvntEnd ('cbx_ArchivChange End via Exit #2');
          exit;
        end;

        if (cbx_Archiv.ItemIndex <> -1) and (cbx_Archiv.ItemIndex <> 0) then
        begin
        		askforsave;
        end;

        // Testhalber mal auf False gesetzt, um die Trefferliste zu beruhigen
        // f.schneider  v3.5.1.62
        DelZusFields2(False);
        DelStatus;
        ResetAnzeige;
        ResetTrefferliste;
        trefferlistealreadyloaded := False;

        if (cbx_Archiv.ItemIndex <> -1) and (cbx_Archiv.ItemIndex <> 0) then
        begin
           iGArcID := iTmpID;
           Gsorderby := '';

           dm_db.my_q_arc.IndexFieldNames := '';
           dm_DB.tim_searcharc.Enabled := False;

           Trefferlistealreadyloaded := False;
           fra_Voransicht.img_DocView.LayersClear;

           if iGArcID > -1 then
           begin
             sGArcName := GSysArc[iGArcID].ArcName;
             sIArcName := GSysArc[iGArcID].TblName;
             sGBriefPapier := GSysArc[iGArcID].ArcBackpic;
             liType := GSysArc[iGArcID].typ;
           end;

            if bAutoDispNew and not handleparamaktiv then
                resetSuchFelder;

            if FileAccessable(sGBriefPapier) then
               tbi_VShowBrief.Enabled := True
            else
            begin
               tbi_VShowBrief.Enabled := False;
               tbi_VShowBrief.Checked := False;
            end;

           GetArcUsrRights;

           tbi_VSaveDoc.Enabled := False;
           btn_SaveDoc.Enabled := False;

           if sbx_ZusFeld.ComponentCount = 0 then
           begin
              iGZusFCount := CreZusFields(False);
           end;

           dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGArcID), []);
        end
        else
        begin
           // no archiv was selected so set true
           rGArcRight.read := True;
           sIArcName := '';
           sGArcName := '';

           if iGLgrID > -1 then
           begin
             sGArcName := GSysArc[iGLgrID].ArcName;
             sIArcName := GSysArc[iGLgrID].TblName;
             sGBriefPapier := GSysArc[iGLgrID].ArcBackpic;
             liType := GSysArc[iGLgrID].typ;
           end;

           dbtv_LgrArc.Select(dbtv_LgrArc.GetNodeID(iGLgrID), []);

           if sbx_ZusFeld.ComponentCount = 0 then
           begin
              if sIArcName <> '' then
              begin
                 iGZusFCount := CreZusFields(False);
              end;
           end;
           iGArcID := 0;
           iGDocID := -2;
        end;

        if (sIArcName <> '') and (not bMultiArcQuery) then
           CreStatus;

        if bAutoDispNew and (cbx_Archiv.ItemIndex <> 0) and (iGArcID <> 0) and
           bParamHandled and rGArcRight.list then
        begin
           GgfLogEvnt('SetControls(False)b'); //3.5.0.22
           SetControls(False); //3.5.0.22
           while dm_DB.my_q_Arc.Fetching do
              Application.ProcessMessages;
           dm_MainForm2.mnu_TGoToArc.Visible := False;
           fra_Volltext.redt_Volltext.Clear;
           fra_Volltext.redt_Volltext.Font.Color:= clBlack; //22.03.2011 b.takacs 3.5.0.168

           iGArcRecNo := -1;
           iGBorderRem := 1;
           bMultiArcQuery := False;
           tGStart := GetTime;
           pnl_SrcTime.Caption := '--.--.---';
           dm_DB.tim_searcharc.Enabled := True;
           pnl_SrcTime.ParentBackground := False;
           pnl_SrcTime.Color := clRed;

           if iGmaxhits > -1 then
           begin
              sGMaxHits := 'limit ' + inttostr(iGMaxHits);
              cbx_MaxTreffer.Text := IntToStr(iGmaxhits);
           end
           else
           begin
              if iGmaxhits = -1 then
              begin
                 sGMaxHits := '';
                 cbx_MaxTreffer.Text := _('alle');
              end
              else
              begin
                 sGMaxHits := 'limit 50';
                 cbx_MaxTreffer.Text := '50';
              end;
           end;

				LoadTrefferlisteFromFile(sIArcName);

            for licounter := 0 to dbgrd_TrefferListe.columns.Count - 1 do
            begin
              if dbgrd_Trefferliste.Columns.items[licounter].sortorder <> soNone then
              begin
                 lstemp := dbgrd_Trefferliste.Columns.items[licounter].DisplayName;
                 if dbgrd_Trefferliste.Columns.items[licounter].sortorder = soAsc then
                 begin
                    lstemp1 := ' ASC';
                 end
                 else
                 begin
                    lstemp1 := ' DESC';
                 end;
              end;
            end;
            if lstemp = '' then
            begin
              lstemp := 'tstamp DESC';
            end;
            Gsorderby := ' order by ' + lstemp + lstemp1;
            // dont  check permissions

           if not gbwvlcellclick then
           begin
              if Gsorderby = '' then
                 Gsorderby := ' order by tstamp DESC ';
              QueryArc('Select Sql_No_cache * from arc_' + sIArcName +
                 ' ' + Gsorderby + ' ' + sGMaxHits);
           end;
           if lstemp <> '' then
           begin
              dm_db.my_q_arc.IndexFieldNames := lstemp + lstemp1;
           end
           else
           begin
              dm_db.my_q_arc.IndexFieldNames := 'Tstamp DESC';
           end;
           HandleDoc;
        end
        else
        begin
           if not trefferlistealreadyloaded then
           begin
              if not LoadTrefferlisteFromFile(sIArcName) then
              begin
                 CreateStandardColumnsTrefferliste;
              end;

              if bAutoDispNew then
              begin
                 btn_StartSrcClick(self);
              end;
           end;
        end;
      except
        on e: Exception do
        begin
          GgfLogEvnt('Fehler bei cbx_ArchivChange:' + e.Message);
        end;
      end;
		dbgrd_TrefferListe.Visible := True;
   finally
     if dbtv_LgrArc = nil then
     		LogEvnt('dbtv_LgrArc = nil');
     GgfLogEvnt('SelectionCount:' + IntToStr(dbtv_LgrArc.SelectionCount));
     if dbtv_LgrArc.SelectionCount > 0 then
	     iGdbtvIdx:= dbtv_LgrArc.Selected.AbsoluteIndex;
     dbgrd_Trefferliste.filtered := gbTrefferlisteFiltered;
     gbArchivChange := False;
   end;
   GgfLogEvntEnd ('cbx_ArchivChange End');
end;


procedure Tfrm_MainForm.dpnl_LgrArcCloseQuery(Sender: TObject; var CanClose: boolean);
begin
   GgfLogEvnt('dpnl_LgrArcCloseQuery');
   ShowLgrArc;
end;

procedure Tfrm_MainForm.dpnl_ThumbsCloseQuery(Sender: TObject; var CanClose: boolean);
begin
   GgfLogEvnt('dpnl_ThumbsCloseQuery');
   ShowThumbs;
end;

procedure Tfrm_MainForm.tbi_VDocLinksClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VDocLinksClick');
   dm_MainForm2.pum_Links.Popup(mouse.CursorPos.X, mouse.CursorPos.Y);
end;

// Aufruf der Form Wiedervorlage durch anklicken der Schaltflche im Menue des Viewers
//  interne Suchwoerter:
//  Wiedervorlage ein oder Ausschalten
procedure Tfrm_MainForm.tbi_VDocTimerClick(Sender: TObject);
var
   hd: HWND;
begin
   GgfLogEvnt('tbi_VDocTimerClick');
   //first update registry
   dm_MainForm2.tim_ChkTasksTimer(self);
   dm_MainForm2.refreshregwvl;
   //make hotsearch stop blinking
   hd := FindWindow('bitfarm.hotsearch.V3', nil);
   GgfLogEvnt('tbi_VDocTimerClick vor sendMessage');
   sendMessage(hd, WM_HOTKEY_WVL_MESSAGE, 1, 1);
   GgfLogEvnt('tbi_VDocTimerClick nach sendMessage');

   if tbi_VDocTimer.ImageIndex = 118 then
      tbi_VDocTimer.ImageIndex := 92;

   // Wenn der Wiedervorlagetimer nicht angewaehlt ist, dann ...
   if not tbi_vdocTimer.Checked then
   begin
      dpnl_wvlg.Visible := False;
      wvlhasfocus := False;
      wvlshowbuttons(False);
      hithasfocus := True;
      istrefferliste := True;
      dbgrd_Trefferliste.SetFocus;
   end
   else
   begin
      dpnl_wvlg.Visible := True;
      if dpnl_firsttime then
      begin
         tbi_MyTaskClick(self);
         dpnl_firstTime := False;
      end
      else
      begin
         wvlhasfocus := False;
         wvlshowbuttons(False);
         tbi_MyTaskClick(self);
      end;
   end;

end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteDrawColumnCell(Sender: TObject;
   const Rect: TRect; DataCol: integer; Column: TColumn; State: TGridDrawState);
var
   lcfree, lcdone: TColor;
begin
   // set font black for all, if different, set it later
   if ((dbgrd_Trefferliste.SelectedRows.CurrentRowSelected) and (not wvlhasfocus)) then
   begin
      lcfree := $00bdbdbd;
      lcdone := $0092bf9a;
   end
   else
   begin
      lcfree := clwhite;
      lcdone := cColorHellgruen;
   end;
   if dm_DB.my_q_Arc.FieldList.IndexOf('doc_State') <> -1 then
   begin
      if dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger and 1 = 1 then
      begin
         TDBGrid(Sender).canvas.brush.color := lcdone;
      end
      else
         TDBGrid(Sender).canvas.brush.color := lcfree;
   end;

   // set the highlight view gray
   // could be handled different, when vererbt and overrided.
   if (TDBGrid(Sender).canvas.brush.color = clHighlight) then
      TDBGrid(Sender).canvas.brush.color := clwhite;

   TDBGrid(Sender).Canvas.Font.Color := clBlack;
   TDBGrid(Sender).DefaultDrawColumnCell(rect, datacol, column, state);
end;

procedure Tfrm_MainForm.sbtn_QuickAddSlwClick(Sender: TObject);
var
	i: Integer;
  DocID, ArcID: Int64;
  TblName: String;
begin
   GgfLogEvnt('sbtn_QuickAddSlwClick');
   if (edt_SSlw.Text = '') or (dm_DB.my_q_arc.RecordCount < 1) then
      exit;
   if rGDocRight.modify then
   begin
  		with dbgrd_Trefferliste.SelectedRows do
      begin
        for i:= 0 to Count - 1 do
        begin
	        dm_db.my_q_Arc.GotoBookmark(
                    Pointer(Items[i]));

          DocID:= dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;

          if bMultiArcQuery then
          begin
	          ArcID:= dm_DB.my_q_Arc.FieldByName('arc_id').AsInteger;
	          TblName:= dm_DB.my_q_Arc.FieldByName('TblName').Asstring;
          end
          else
          begin
	          ArcID:= iGArcID;
	          TblName:= sIArcName;
          end;

          with dm_DB.my_cmd do
          begin
             SQL.Text := 'Insert into slw_' + TblName + ' (doc_id, doc_slw) Values (' +
                IntToStr(DocID) + ', ' + #39 + trim(ParseSemicolonWithoutBackslash(edt_SSlw.Text)) + #39 + ')';
             try
                Execute;
             except
                on e: Exception do
                   ErrorMsg('sbtn_QuickAddSlw',
                      _('Fehler beim Hinzufgen eines Schlagwortes:') +
                      e.Message, 2025,
                      True);
             end;
             if RowsAffected <> -1 then
             begin
                frm_MainForm.NewHistory(12,_('Neues Schlagwort') + ' [' + edt_SSlw.Text +
                   '] ' + _('hinzugefgt.'));
                frm_mainform.setPanelInfo(
                   _('Das Schlagwort') + ' [' + edt_SSlw.Text + '] ' + _('wurde hinzugefgt.'));
             end
             else
                frm_mainform.setPanelInfo(
                   _('Es konnte kein Schlagwort eingetragen werden!'));
          end;
        end;
      end;
   end
   else
      BfShowMessage(_('Hinweis') + #13 + _('Dieses Dokument drfen Sie nicht verndern.'));
end;

procedure Tfrm_MainForm.tbsi_VPrintClick(Sender: TObject);
begin
   GgfLogEvnt('tbsi_VPrintClick');
   case tbsi_VPrint.ImageIndex of
      18:
         tbi_VPrintStd.Click;
      78:
         tbi_VPrintAsk.Click;
      79:
         tbi_VPrintPre.Click;
   else
      tbi_VPrintStd.Click;
   end;
end;

//  Ausgabe auf den Standard Drucker
//  Drucken
procedure Tfrm_MainForm.tbi_VPrintStdClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VPrintStdClick');
   tbsi_VPrint.ImageIndex := 18;
   if handleparamaktiv or gbsearching then
   begin
      while (gbsearching) or dm_db.tim_ansicht.enabled do
      begin
         sleep(10);
      end;
   end;
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;

   if not CheckBookmark then
      Exit;

   askforsave;

   PrintDoc(False, False);

end;

// Ausgabe auf einen auszuwhlenden Drucker
// Der von der Windows Umgebung bereitgestellt wird
// Drucken
procedure Tfrm_MainForm.tbi_VPrintAskClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VPrintAskClick');
   tbsi_VPrint.ImageIndex := 78;
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   if not CheckBookmark then
      Exit;
   askforsave;
   PrintDoc(True, False);
end;

//  Ausgabe auf Drucker mit Voransicht
//  Drucken
//  ... etwas problematisch die eigene Vorschauroutine
procedure Tfrm_MainForm.tbi_VPrintPreClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VPrintPreClick');
   tbsi_VPrint.ImageIndex := 79;
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   if not CheckBookmark then
      Exit;
   askforsave;
   PrintDoc(False, True);
end;

// Statusbutton klick
procedure Tfrm_MainForm.OnStsClick(Sender: TObject); //[2011]
var
   iFunc: byte;
   iStatus, iOStatus, shiftamount, p: integer;
   sValue, sState, lsAdd: string;
   Item: TTBXColorItem;
begin
   GgfLogEvnt('chbx_SRefSeaClick');

   if not (Sender is TTBXColorItem) //m.Frey - zur Sicherheit
   then
      Exit;
   Item := TTBXColorItem(Sender);

   p := Pos('_add', Item.Name);
   if p > 0
   then
      lsAdd := Copy(Item.Name, p + 1, maxint);

   if dm_DB.my_q_Arc.RecordCount > 0 then
   begin
      with Item do
      begin
         //get shiftamount first
         shiftamount := (byte(tag shr 8));
         // set stati for next search
         gmodiStatus := gmodiStatus or (1 shl shiftamount);
         gmodsearchiStatus := gmodsearchiStatus or (1 shl shiftamount);
         chbx_SOnlyUsed.Checked := True;
         if Color = clRed then
         begin
            chbx_SOnlyUsed.Checked := True;
            // set old byte to original value  
            Color := clTeal;
            if gai_sts_rights[(Item.tag shr 8) - 1] then
            begin
               Item.FontSettings.Color := clnone;
               gtmpiStatus := gtmpiStatus and (not (1 shl shiftamount));
               gtmpiStatus := gtmpiStatus or (gotmpiStatus and (1 shl shiftamount));
            end
            else
            begin
               Item.FontSettings.Color := gcnrs;
            end;

            //dont search for it
            gmodsearchiStatus := gmodsearchiStatus and (not (1 shl shiftamount));
            FontSettings.Bold := tsFalse;
            if (not GHasNotBeenSavedAfterModify) and
               (gtmpiStatus = gotmpiStatus) then
               btn_SaveDoc.Enabled := False;
         end
         else
         begin
            // Hier werden die Bits geschubst, die alle Dokumentstati in einem Byte bereitstellen
            iOStatus := gtmpiStatus;
            if (color = clTeal) then
            begin
               color := clLime;
               //do search for it
               FontSettings.Bold := tsTrue;
               //change to set
               iStatus := gtmpiStatus or (1 shl shiftamount);
            end
            else
            begin
               color := clred;
               FontSettings.Bold := tsTrue;
               //change to not set
               iStatus := gtmpiStatus and (not (1 shl shiftamount));
            end;

            if gai_sts_rights[(Item.tag shr 8) - 1] then
            begin
               gtmpiStatus := iStatus;
            end;

            if ((iOStatus xor iStatus) and iStatus) = (1 shl shiftamount) then
            begin
               sState := _('gesetzt');
            end
            else
            begin
               sState := _('entfernt');
            end;
            iFunc := byte(tag);
            case iFunc of
               0:
                  sValue := TimeToStr(Time);
               1:
                  sValue := DateToStr(Date);
               2:
                  sValue := DateTimeToStr(now);
               3:
                  sValue := sGUsrName;
               4:
                  sValue := sGUsrName + #32 + DateTimeToStr(now);
            else
               sValue := '';
            end;

            // check if it was changed from original or set back!
            if ((istatus xor gotmpistatus) and (1 shl shiftamount)) <> 0 then
            begin
               if (((gtmpiStatus xor gotmpistatus) > 0)) then
               begin
                  btn_SaveDoc.Enabled := True;
                  GHasNotBeenSavedAfterModify := True;
               end
               else
               begin
                  if tbi_VSaveDoc.Enabled = false then
                  begin
                     btn_SaveDoc.Enabled := False;
                  end;
               end;
               if gai_sts_rights[(Item.tag shr 8) - 1] then
               begin
                  Item.FontSettings.Color := $000385CB;
               end;

               gtmphistory[shiftamount] :=
                  _('Dokumentenstatus gendert') + ' [' + Item.Caption +
                  #32 + sState + ']';

               gtmphinttag[shiftamount] := lsAdd;
               if (istatus and (1 shl shiftamount)) <> 0 then
               begin
                  gtmphhsvalue[shiftamount] := sValue;
               end
               else
               begin
                  gtmphhsvalue[shiftamount] := '';
               end;
            end
            else
            begin
               if (((gtmpiStatus xor gotmpistatus) > 0)) then
               begin
                  btn_SaveDoc.Enabled := True;
                  GHasNotBeenSavedAfterModify := True;
               end
               else
               begin
                  if (not GHasNotBeenSavedAfterModify) or
                     (tbi_VSaveDoc.Enabled = false) then
                  begin
                     btn_SaveDoc.Enabled := False;
                  end;
               end;
               if gai_sts_rights[(Item.tag shr 8) - 1] then
               begin
                  Item.FontSettings.Color := clnone;
               end
               else
               begin
                  Item.FontSettings.Color := gcnrs;
               end;
               gtmphistory[shiftamount] := '';
               gtmphinttag[shiftamount] := '';
               gtmphhsvalue[shiftamount] := '';
            end;
         end;
      end;
   end
   else
   begin
      with Item do
      begin
         shiftamount := (byte(tag shr 8));
         gmodiStatus := gmodiStatus or (1 shl shiftamount);
         gmodsearchiStatus := gmodsearchiStatus or (1 shl shiftamount);
         if color = clLime then
         begin
            color := clRed;
            FontSettings.Bold := tsTrue;
            chbx_SOnlyUsed.Checked := True;
         end
         else
         if (color = clTeal) then
         begin
            color := clLime;
            FontSettings.Bold := tsTrue;
            chbx_SOnlyUsed.Checked := True;
         end
         else
         begin
            if gai_sts_rights[(tag shr 8) - 1] then
            begin
               FontSettings.Color := clnone;
            end
            else
            begin
               FontSettings.Color := gcnrs;
            end;
            color := clteal;
            FontSettings.Bold := tsFalse;
            gmodsearchiStatus := gmodsearchiStatus and (not (1 shl shiftamount));
         end;
      end;
   end;
end;


procedure Tfrm_MainForm.ReadStatus;
var
   iCount, iStatus: integer;
   ColItem: TTBXColorItem;
   inworkbywvl, lbmy: boolean;
begin
   GgfLogEvntBeg('ReadStatus beg');
   try
      lbmy := false;

      if not dm_DB.my_conArc.Connected then
         exit;

      if (dbgrd_trefferliste.selectedindex > 0) then
      begin
         if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0 then
         begin
            dbgrd_Trefferliste.SelectedRows.CurrentRowSelected := True;
         end;
         if iGArcRecNo <> dm_db.my_q_arc.RecNo then
         begin
            dm_db.my_q_Arc.GotoBookmark(
               Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
         end;
         dm_DB.my_q_Arc.RefreshRecord;
      end;

      // if none selected it is the first entry!
      iStatus := dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger;
      // Set the global tmpiStatus when the status is read
      gotmpiStatus := iStatus;
      gtmpiStatus := gotmpiStatus;
      // reset the array
      SetLength(gtmphistory, 0);
      SetLength(gtmphinttag, 0);
      SetLength(gtmphhsvalue, 0);
      // set the right length
      SetLength(gtmphistory, tlb_Status.Items.Count - 4);
      SetLength(gtmphinttag, tlb_Status.Items.Count - 4);
      SetLength(gtmphhsvalue, tlb_Status.Items.Count - 4);

      if tlb_Status.Items.Count > 5 then
      begin
         // something is  wrong, 5 is too high, 4 should be the first
         // 4 is but the diving line
         //todo: statusfelder die rot sind sollten nur wenn man danach gesucht wurde nicht ausfllen
         for iCount := 5 to tlb_Status.Items.Count - 1 do
         begin
            ColItem := TTBXColorItem(tlb_Status.Items.Items[iCount]);
            if ColItem.Color = clRed then
            begin
               ColItem.FontSettings.Bold := tsTrue;
               continue;
            end;

            if (iStatus and (1 shl (byte(ColItem.tag shr 8)))) > 0 then
            begin
               ColItem.Color := cllime;
               if (gmodsearchiStatus and (1 shl (byte(ColItem.tag shr 8)))) > 0 then
               begin
                  ColItem.FontSettings.Bold := tsTrue;
               end
               else
               begin
                  ColItem.FontSettings.Bold := tsFalse;
               end;
            end
            else
            begin
               ColItem.Color := clteal;
               if gai_sts_rights[(ColItem.tag shr 8) - 1] then
               begin
                  ColItem.FontSettings.Color := clnone;
               end
               else
               begin
                  ColItem.FontSettings.Color := gcnrs;
               end;
               ColItem.FontSettings.Bold := tsFalse;
            end;
         end;
      end;
      if not dm_DB.my_conArc.Connected then
         exit;

      inworkbywvl:=dm_MainForm2.InWorkByWvl( ArcDocId(iGArcID,iGDocID) );
      GgfLogEvnt('ReadStatus inworkbywvl='+BS(inworkbywvl));

      if (nil <> dm_db.my_q_Arc.FieldDefList.Find('doc_state')) then
      begin
         lbmy := ((dm_DB.my_q_Arc.FieldByName('doc_state').AsInteger and 1) = 1);
      end
      else
      begin
         BfShowMessage('error');
      end;
      if ((lbmy) or (inworkbywvl = True)) then
      begin
         tci_InUse.Color := cllime;   GgfLogEvnt('tci_InUse.Color := cllime [5]');
         tci_InUse.Hint := _('Das Dokument befindet sich noch in Bearbeitung');
         tci_InUse.Tag := 1;
         tci_InUse.FontSettings.Color := clnone;
         dm_MainForm2.mnu_TEndWorkflow.Enabled := True;
      end
      else
      begin
         if tci_InUse.Color <> clRed then
         begin
            tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [6]');
         end;
         tci_InUse.Hint := '';
         tci_InUse.Tag := 0;
         tci_InUse.FontSettings.Color := clnone;
         dm_MainForm2.mnu_TEndWorkflow.Enabled := False;
      end;
   finally
      GgfLogEvntEnd('ReadStatus end');
   end;
end;


procedure Tfrm_MainForm.CreStatus;
var
   testitem: TTBXColorItem;
   licounter: integer;
   lbhasxs: boolean;
   lsAdd, lsName: string;
begin
   GgfLogEvnt('CreStatus');

   with dm_DB.my_q_tmpcrestatus1 do
   begin
      sql.Text := 'Select Sql_No_cache * from sts_' + sIArcName + ' order by sts_id';

      GgfLogEvnt('CreStatus1 ' + sql.Text);
      logwvl('8554, WVL proc CreStatus vor open Select Sql_No_cache * from sts_ ');
      try
         if dm_db.my_q_tmpcrestatus1.Active then
         begin
            // Just do an execute!
            Execute;
         end
         else
         begin
            // else reopen the connection
            Close;
            Open;
         end;
      except on e: exception do
         begin
            LogEvnt('1000    ' + _('Fehler') + ' in Modul: CreStatus    ' + sql.Text + ' --- ' + e.message);
         end;
      end;
      setlength(gai_sts_rights, recordcount);
      dm_db.my_q_ngtmp.SQL.Text := 'show tables like ' + #39 + 'stsxs_' + sIarcname + #39;

      GgfLogEvnt('CreStatus2 ' + dm_db.my_q_ngtmp.sql.Text);
      try
         dm_db.my_q_ngtmp.execute;
      except on e: exception do
         begin
            LogEvnt('1000    ' + _('Fehler') + ' in Modul: CreStatus    ' + dm_db.my_q_ngtmp.SQL.Text + ' --- ' + e.message);
         end;
      end;
      if dm_db.my_q_ngtmp.RecordCount > 0 then
      begin
         lbhasxs := true;
         dm_db.my_q_ngtmp.SQL.Text := 'select * from stsxs_' + sIarcname + ' where usr_id = ' + inttostr(iGusrid);
         dm_db.my_q_ngtmp.execute;
      end
      else
      begin
         lbhasxs := false;
      end;
      First;
      licounter := 0;
      logwvl('8556, WVL nach open ');
      while not EOF do
      begin
         logwvl('8559, WVL begin Datensaetz der Query bearbeiten ');
         gai_sts_rights[licounter] := true;
         lsAdd := FieldByName('sts_ZusFeld').AsString;
         lsName := 'tci_Sts' + IntToStr(RecNo); //[2011]
         if Pos('add', lsAdd) = 1
         then
            lsName := lsName + '_' + lsAdd;
         testitem := TTBXColorItem.Create(tlb_Status);
         tlb_Status.Items.Add(Testitem); //[2011]
         testitem.Name := lsName; //[2011] //m.frey: in Name statt Hint
         testitem.Caption := FieldByName('sts_name').AsString;
         testitem.Tag := FieldByName('sts_Func').AsInteger + (RecNo shl 8);
         testitem.OnClick := OnStsClick; //[2011]
         testitem.Color := clteal;

         if lbhasxs then
         begin
            gai_sts_rights[licounter] := false;
            dm_db.my_q_ngtmp.first;
            while not dm_db.my_q_ngtmp.eof do
            begin
               if FieldByName('sts_id').AsInteger = dm_db.my_q_ngtmp.FieldByName('sts_id').AsInteger then
               begin
                  gai_sts_rights[licounter] := true;
               end;
               dm_db.my_q_ngtmp.next;
            end;
         end;
         if gai_sts_rights[licounter] then
         begin
            testitem.FontSettings.Color := clnone;
         end
         else
         begin
            testitem.FontSettings.Color := gcnrs;
         end;
         licounter := licounter + 1;
         Next;
         logwvl('8570, WVL Ende Datensaetz der Query bearbeiten ');
      end;

      GgfLogEvnt('CreStatus3 ');
      logwvl('8573, WVL Query schliessen (close)');
   end;
end;

procedure Tfrm_MainForm.DelStatus;
begin
   GgfLogEvnt('DelStatus');
   tci_InUse.Color := clTeal;   GgfLogEvnt('tci_InUse.Color := clteal [7]');
   tci_InUse.FontSettings.Color := clnone;
   tci_InUse.FontSettings.Bold := tsFalse;

   setlength(gai_sts_rights, 0);
   while tlb_Status.Items.Count > 5 do
      tlb_Status.Items.Items[5].Free;
end;

// Dokument in Bearbeitung aufgrund der Schaltflaeche Status im Viewer Fenster
procedure Tfrm_MainForm.tci_InUseClick(Sender: TObject);
var
   iStatus, icount: integer;
   lbinb: boolean;
begin
   GgfLogEvnt('tci_InUseClick');
   try
      gmodiStatus := gmodiStatus or 1;
      gmodsearchiStatus := gmodsearchiStatus or 1;
      istatus := gtmpiStatus;
      chbx_SOnlyUsed.Checked := True;
      if dm_DB.my_q_Arc.RecordCount > 0 then
      begin
         // set the colors for search properly clRed is when searching negative (exclusive)
         if tci_InUse.Color = clRed then
         begin
            tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [8]');
            tci_InUse.FontSettings.Color := clnone;
            tci_InUse.FontSettings.Bold := tsFalse;
            TTBXColorItem(Sender).FontSettings.Color := clnone;
            // set the old state!
            gmodsearchiStatus := gmodsearchiStatus and (not 1);

            if ((not GHasNotBeenSavedAfterModify) and
               (gtmpiStatus = gotmpiStatus)) or
               (tbi_VSaveDoc.Enabled = false) then
               btn_SaveDoc.Enabled := False;
         end
         else
         begin
            lbinb := false;
            dm_db.my_q_Tmp.SQL.Text :=
               'SELECT usr_name FROM sys_usr as a left join sys_timer as b ' +
               ' on( b.usr_id_work= a.usr_id ) where doc_id =' + IntToStr(IGDocID) +
               ' and arc_id = ' + IntToStr(IGArcID) +
               ' and (((status & 1) = 1) or (((status & 1) = 0) and  ((status & 2) = 0))) group by usr_name';
            dm_db.my_q_Tmp.Execute;
            if dm_db.my_q_Tmp.RecordCount > 0 then
            begin
               lbinb := true;
            end;
            if not ftci_InUseonceclicked then
            begin
               ftci_InUseonceclicked := true;

               if dm_db.my_q_Tmp.RecordCount > 0 then
               begin
                  dm_MainForm2.pum_inuse.Items.Clear;
                  dm_db.my_q_Tmp.First;
                  for icount := 0 to dm_db.my_q_Tmp.RecordCount - 1 do
                  begin
                     dm_MainForm2.pum_InUSE.items.add(
                        newitem(dm_db.my_q_Tmp.FieldByName('usr_name').AsString,
                        0, False, True, nil, 0, 'pum_INUse' +
                        IntToStr(dm_db.my_q_Tmp.RecNo)));
                     dm_db.my_q_Tmp.Next;
                  end;

                  tci_InUse.Color := cllime;   GgfLogEvnt('tci_InUse.Color := cllime [9]');
                  iStatus := gtmpistatus or 1;

                  if (((istatus xor gotmpistatus) > 0)) then
                  begin
                     btn_SaveDoc.Enabled := True;
                     GHasNotBeenSavedAfterModify := True;
                     tci_InUse.FontSettings.Bold := tsTrue;
                  end
                  else
                  begin
                     if (not GHasNotBeenSavedAfterModify) or
                        (tbi_VSaveDoc.Enabled = false) then
                        btn_SaveDoc.Enabled := False;
                     tci_InUse.FontSettings.Bold := tsFalse;
                  end;

                  dm_MainForm2.pum_inuse.Popup(mouse.CursorPos.X, mouse.CursorPos.Y);
                  exit;
               end;
            end
            else
            begin
               ftci_InUseonceclicked := false;
               if (tci_InUse.Color = clRed)
                  and (not lbinb) then
               begin
                  gtmpiStatus := gtmpiStatus and (not (1));
                  gtmpiStatus := gtmpiStatus or (gotmpiStatus and (1));
               end;
            end;

            if tci_InUse.Color = clteal then
            begin
               tci_InUse.Color := cllime;   GgfLogEvnt('tci_InUse.Color := cllime [10]');
               iStatus := gtmpistatus or 1;
               tci_InUse.FontSettings.Bold := tsTrue;
            end
            else
            begin
               tci_InUse.Color := clred;
               //change to not set
               if not lbinb then
               begin
                  iStatus := gtmpistatus and (not 1);
               end;
               tci_InUse.FontSettings.Bold := tsTrue;
            end;

            if ((istatus xor gotmpistatus) and 1) <> 0 then
            begin
               if (((istatus xor gotmpistatus) > 0)) then
               begin
                  btn_SaveDoc.Enabled := True;
                  GHasNotBeenSavedAfterModify := True;
               end
               else
               begin
                  if (not GHasNotBeenSavedAfterModify) or
                     (tbi_VSaveDoc.Enabled = false) then
                     btn_SaveDoc.Enabled := False;
               end;

               TTBXColorItem(Sender).FontSettings.Color := $000385CB;
               case (iStatus and 1) of
                  0:
                     gtmphistory[0] :=
                        _('Dokumentenstatus gendert [aus Bearbeitung]');
                  1:
                     gtmphistory[0] := _('Dokumentenstatus gendert [in Bearbeitung]');
               end;
            end
            else
            begin
               if (((istatus xor gotmpistatus) > 0)) then
                  btn_SaveDoc.Enabled := True
               else
               begin
                  if (not GHasNotBeenSavedAfterModify) or
                     (tbi_VSaveDoc.Enabled = false) then
                     btn_SaveDoc.Enabled := False;
               end;
               // set the font to clnone if it is old status
               TTBXColorItem(Sender).FontSettings.Color := clnone;
               gtmphistory[0] := '';
            end;
            // save the new status in gtmpistatus
            gtmpistatus := istatus;
         end;
      end
      else
      begin
         // set the colors for search properly clRed is when searching negative (exclusive)
         if tci_InUse.Color = cllime then
         begin
            tci_InUse.Color := clRed;

            chbx_SOnlyUsed.Checked := True;
            tci_InUse.FontSettings.Bold := tsTrue;
         end
         else
         if tci_InUse.Color = clteal then
         begin
            tci_InUse.Color := cllime;   GgfLogEvnt('tci_InUse.Color := cllime [11]');
            tci_InUse.FontSettings.Bold := tsTrue;
            chbx_SOnlyUsed.Checked := True;
         end
         else
         begin
            tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [12]');
            tci_InUse.FontSettings.Bold := tsFalse;
         end;
      end;
   finally

   end;
end;

// Anzeige der Annotations  ein oder ausschalten
procedure Tfrm_MainForm.tbi_VShowAnnoClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VShowAnnoClick');
   tbi_VShowAnno.Checked := not tbi_VShowAnno.Checked;
   // wird der Annoknopf bettigt und die stellung aus angesteuert werden annos angezeigt

   fra_voransicht.img_DocView.CancelInteracts;
   if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveobjects(False, False);

   if tbi_VShowAnno.Checked then
   begin
      tbx_privNote.Visible := True;
      tbx_pubNote.Visible := True;
   end
   else
   begin
      tbx_privNote.Visible := False;
      tbx_pubNote.Visible := False;
   end;
   ZustaendeAnnotationBearbeitenSetzen; //m.frey
   ChangeDocPage(0);
end;

procedure Tfrm_MainForm.tbi_VMakeRevClick(Sender: TObject);
var
   slKomFile: TStringList;
   sFileName, lsarcid: string;
begin
   GgfLogEvnt('tbi_VMakeRevClick');
   if dm_DB.my_q_Arc.RecordCount = 0 then
      exit;
   if MessageDlg(_('Wenn sie dieses Dokument revisionssicher ablegen, knnen Sie keine') +
      #13 + _('nderungen mehr an ihm vornehmen. nderungen an einem revisions-') +
      #13 + _('sicheren Dokument werden als zweite Version im Archiv abgelegt.') +
      #13 + #13 + _('Soll das aktuelle Dokument revisionssicher abgelegt werden?'),
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      if iGArcRecNo <> dm_db.my_q_arc.RecNo then
      begin
         dm_db.my_q_Arc.GotoBookmark(
            Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
      end;
      // get for timerevelant actions the server time
      dm_db.my_q_datetime.SQL.Text :=
         'select date_format(now(),"%d%m%Y%H%i%s") as date';
      dm_db.my_q_datetime.Execute;
      sFileName := dm_db.my_q_datetime.FieldByName('date').AsString;
      if bmultiarcquery or (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
      begin
         lsarcid := dm_DB.my_q_Arc.FieldByName('arc_id').AsString;
      end
      else
      begin
         lsarcid := inttostr(iGarcid);
      end;
      //  DateTimeToString(sFileName, 'ddmmyyyyhhnnss', now);
      sFileName := sGClntSpool + sFileName + IntToStr(Random(999)) + '.KOM';
      slKomFile := TStringList.Create;
      try
         try
            with slKomFile do
            begin
               Clear;
               Add('[Version]');
               Add('Version=3.0');
               Add('[Command]');
               Add('Command=MakeRevisionSave');
               Add('doc_loc=' + dm_DB.my_q_Arc.FieldByName('doc_loc').AsString);
               Add('ext_loc=' + dm_DB.my_q_Arc.FieldByName('ext_loc').AsString);
               Add('ori_loc=' + dm_DB.my_q_Arc.FieldByName('ori_loc').AsString);
               Add('doc_id=' + lsarcid + '.' + dm_DB.my_q_Arc.FieldByName('doc_id').AsString);
               Add('Profil=' + ChangeFileExt(ExtractFileName(sGConnection), ''));
               Add('Benutzer=' + sGusrname);
               SaveToFile(sFileName);
            end;
            NewHistory(21, _('Dokument zur revisionssicheren Ablage vorgemerkt'));
            frm_mainform.setpanelinfo(
               _('Das Dokument wurde zur revisionssicheren Ablage vorgemerkt.'));
            img_Revision.Hint :=
               _('Das Dokument wurde zur revisionssicheren Ablage vorgemerkt..');
            dm_MainForm2.il_Standard.GetIcon(83, img_Revision.Picture.Icon);
            btn_ResFieldsClick(Sender);
         except
            on e: Exception do
               ErrorMsg('tbi_MakeRev', _('Fehler beim Erstellen der Kommando-Datei:')
                  + e.Message, 2000, True);
         end;
      finally
         if Assigned(slKomFile) then
            FreeAndNil(slKomFile);
      end;
   end;
end;

procedure Tfrm_MainForm.tbi_VOCRClick(Sender: TObject);
var
   slKomFile: TStringList;  lb:Boolean;
   sFileName, lsarcid, lsSvnInfo: string;
   doc:TArcDocId;
begin
   GgfLogEvnt('tbi_VOCRClick');
   if dm_DB.my_q_Arc.RecordCount = 0 then
      exit;

   if iGArcRecNo <> dm_db.my_q_arc.RecNo then
   begin
      dm_db.my_q_Arc.GotoBookmark(
         Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
   end;
   // get for timerevelant actions the server time
   dm_db.my_q_datetime.SQL.Text := 'select date_format(now(),"%d%m%Y%H%i%s") as date';
   dm_db.my_q_datetime.Execute;
   sFileName := dm_db.my_q_datetime.FieldByName('date').AsString;
   if bmultiarcquery or (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
   begin
      lsarcid := dm_DB.my_q_Arc.FieldByName('arc_id').AsString;
   end
   else
   begin
      lsarcid := inttostr(iGarcid);
   end;

   doc.ArcId := StrToInt(lsarcid);
   doc.DocId := dm_DB.my_q_Arc.FieldByName('doc_id').AsInteger;

   sFileName := sGClntSpool + sFileName + IntToStr(Random(999)) + '.KOM';
   slKomFile := TStringList.Create;
   try
      try
         with slKomFile do
         begin
            Clear;
            Add('[Version]');
            Add('Version=3.0');
            Add('[Command]');
            Add('Command=ReOCRFile');
            Add('doc_loc=' + dm_DB.my_q_Arc.FieldByName('doc_loc').AsString);
            Add('ext_loc=' + dm_DB.my_q_Arc.FieldByName('ext_loc').AsString);
            Add('ori_loc=' + dm_DB.my_q_Arc.FieldByName('ori_loc').AsString);
            Add('doc_id=' + lsarcid + '.' + dm_DB.my_q_Arc.FieldByName('doc_id').AsString);
            Add('Profil=' + ChangeFileExt(ExtractFileName(sGConnection), ''));
            Add('Benutzer=' + sGusrname);
            Add('SvnInfo=' + lsSvnInfo); //SvnInfo
            Add(GetDocIdString('=', doc.ArcId, doc.DocId) ); //3.5.0.60

            SaveToFile(sFileName);
         end;
         NewHistory(20, _('Dokument zur erneuten OCR-Erkennung vorgemerkt'));
         SetStatusText(cStatusPanelInfo, //3.5.0.25
            _('Das Dokument wurde zur erneuten OCR-Erkennung vorgemerkt.'));
      except
         on e: Exception do
            ErrorMsg('tbi_VOCR', _('Fehler beim Erstellen der Kommando-Datei:') +
               e.Message, 2000, True);
      end;
   finally
      if Assigned(slKomFile) then
         FreeAndNil(slKomFile);
   end;
end;

procedure Tfrm_MainForm.dbtv_LgrArcCollapsed(Sender: TObject; Node: TTreeNode);
begin
   GgfLogEvnt('dbtv_LgrArcCollapsed');
   if fbloadinarc then
      exit;
   node.ImageIndex := node.SelectedIndex - 2;
end;

procedure Tfrm_MainForm.dbtv_LgrArcExpanded(Sender: TObject; Node: TTreeNode);
begin
   GgfLogEvnt('dbtv_LgrArcExpanded');
   if fbloadinarc then
      exit;
   node.ImageIndex := node.SelectedIndex;
end;

procedure Tfrm_MainForm.chbx_SRefSeaClick(Sender: TObject);
begin
   GgfLogEvnt('chbx_SRefSeaClick');
   tbs_Volltext.Enabled := not chbx_SRefSea.Checked;
   tbs_ZusFeld.Enabled := not chbx_SRefSea.Checked;
   sbtn_QuickAddSlw.Enabled := not chbx_SRefSea.Checked;
   cbx_SUsr.Enabled := not chbx_SRefSea.Checked;
end;

procedure Tfrm_MainForm.sbtn_SAddRefClick(Sender: TObject);
begin
   GgfLogEvnt('sbtn_SAddRefClick');
   if dm_DB.my_q_Arc.RecordCount > 0 then
      dm_MainForm2.mnu_CreNewRef.Click
   else
      BfShowMessage(_('Bitte whlen Sie erst ein Dokument aus!'));
end;

procedure Tfrm_MainForm.edt_SRefSeaChange(Sender: TObject);
begin
   GgfLogEvnt('edt_SRefSeaChange');
   if Trim(edt_SRefSea.Text) <> '' then
      chbx_SRefSea.Checked := True
   else
      chbx_SRefSea.Checked := False;
   chbx_SRefSea.OnClick(self);
end;

procedure Tfrm_MainForm.tci_OriFileClick(Sender: TObject);

//  Original Datei
//  Die Beleuchtung zeigt das Vorhandensein einer Editierbaren Datei an
//  Mit einem Klick wird die Originaldatei zum Editieren geffnet.
var
   lireturncode: integer;
   lsprogname: string;
   lirueck, licounter: integer;
   parameter, aparameter: string;
   si: TStartupInfo;
   pi: TProcessInformation;
   lsoriloc0, lsneworiloc, lsrequest: string;
   liarcid, lidocid: int64;

begin
   GgfLogEvntBeg('tci_OriFileClick beg');
   try
   licounter := 0;
   if rGDocRight.Write and (tci_OriFile.Tag = 1) then
   begin 
      if iGArcRecNo <> dm_db.my_q_arc.RecNo then
      begin
         if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0 then
            exit;
         dm_db.my_q_Arc.GotoBookmark(
            Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
      end;

      GgfLogEvnt('tci_OriFileClick A');

      if dm_MainForm2.pum_OriFile.Items.Count > 0 then
      begin
            dm_MainForm2.pum_OriFile.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
      end
      else
      begin
         lsoriloc0 := dm_DB.my_q_Arc.FieldByName('ori_Loc').AsString;
         lsneworiloc := '';

         if GbCrproridoc then
         begin
            FillChar(si, SizeOf(si), 0);
            si.cb := SizeOf(si);
            si.dwFlags := STARTF_USESHOWWINDOW;
            si.wShowWindow := SW_hide;
            FillChar(pi, SizeOf(pi), 0);
            //    cmd:= 'shell32.dll,OpenAs_RunDLL %s';
            if (lsneworiloc <> '') and (gi64docrev > -1) then
            begin
               parameter := AddDblQuote(BD.ExeDir + 'Viewer-Files\bats\svncat.bat')+' ' + lsrequest;
               AParameter := Format('cmd /c %s', [TrimRight(parameter)]);
               GgfLogEvnt('tci_OriFileClick AParameter='+AParameter);
               {errb := }CreateProcess(nil, PChar(Aparameter), nil, nil,
                  longbool(False), CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
                  nil, PChar(BD.ExeDir), si, pi);
               lirueck := WaitForSingleObject(pi.hProcess, 10);
               while (lirueck <> Wait_Object_0) and
                  (lirueck <> WAIT_ABANDONED) do
               begin
                  //Application.ProcessMessages;
                  lirueck := WaitForSingleObject(pi.hProcess, 10);
                  licounter := licounter + 1;
                  if (licounter = 500) and (lirueck = WAIT_TIMEOUT) then
                  begin
                     break;
                  end;
               end;
               CloseHandle(pi.hProcess);
               CloseHandle(pi.hThread);
            end
            else
            if (lsneworiloc <> '') then
            begin
            end
            else
            begin
               lsneworiloc := lsoriloc0;
            end;
            parameter := lsneworiloc;
            AParameter := Format('cmd /c %s', [TrimRight(parameter)]);
            {errb := }CreateProcess(nil, PChar(Aparameter), nil, nil,
               longbool(False), CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
               nil, PChar(BD.ExeDir), si, pi);
         end
         else
         begin
            if lsneworiloc <> '' then
            begin
               FillChar(si, SizeOf(si), 0);
               si.cb := SizeOf(si);
               si.dwFlags := STARTF_USESHOWWINDOW;
               si.wShowWindow := SW_hide;
               FillChar(pi, SizeOf(pi), 0);
               parameter := AddDblQuote(BD.ExeDir + 'Viewer-Files\bats\svncat.bat')+' ' + lsrequest;
               AParameter := Format('cmd /c %s', [TrimRight(parameter)]);
               GgfLogEvnt('tci_OriFileClick AParameter='+AParameter);
               {errb := }CreateProcess(nil, PChar(Aparameter), nil, nil,
                  longbool(False), CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
                  nil, PChar(BD.ExeDir), si, pi);
               lirueck := WaitForSingleObject(pi.hProcess, 10);
               licounter := 0;
               while (lirueck <> Wait_Object_0) and (lirueck <> WAIT_ABANDONED) do
               begin
                  //Application.ProcessMessages;
                  lirueck := WaitForSingleObject(pi.hProcess, 10);
                  licounter := licounter + 1;
                  if (licounter = 500) and (lirueck = WAIT_TIMEOUT) then
                  begin
                     break;
                  end;
               end;
               CloseHandle(pi.hProcess);
               CloseHandle(pi.hThread);
            end
            else
            begin
               lsneworiloc := lsoriloc0;
            end;
            // nil
            // use nil instead of 'open' for using the default value of windows!
            lireturncode := ShellExecute(Application.Handle, nil,
               PChar(lsneworiloc), nil,
               nil, SW_NORMAL);

            if (lireturncode < 33) then
            begin
               if (lireturncode = 31) then
               begin
                  lsprogname := Format('shell32.dll,OpenAs_RunDLL %s',
                     [lsneworiloc]);
                  {lireturncode := }ShellExecute(Application.Handle, nil,
                     'rundll32.exe', PChar(lsprogname), nil, SW_SHOW);
                 
               end
               else
                  BfShowMessage(_('Fehler beim ffnen der Datei.'));
            end;
         end;
      end;
   end
   else //rGDocRight.Write and (tci_OriFile.Tag = 1)
   begin
      if gidoclock < 2 then
      begin
         if gidoclock = 1 then
         begin
            if iGArcRecNo <> dm_db.my_q_arc.RecNo then
            begin
               if frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0 then
                  exit;
               dm_db.my_q_Arc.GotoBookmark(
                  Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
            end;
            lsoriloc0 := dm_DB.my_q_Arc.FieldByName('ori_Loc').AsString;
            lsneworiloc := '';
            BfShowMessage(_('Dokument wurde von einem anderen Benutzer ausgecheckt.') +
               #13 + _('Dokument wird in temporres Verzeichnis kopiert und von dort aus geffnet.') +
               #13 + _('Zum Speichern benutzen Sie bitte "speichern unter".'));
            lsneworiloc := BD.EnvTemp + '\' + inttostr(Random(9999999)) + Extractfileext(lsoriloc0);
            CopyFile(PChar(lsoriloc0), pchar(lsneworiloc), true);
            filesetattr(lsneworiloc, faArchive or SysUtils.faReadOnly);
            if GbCrproridoc then
            begin
               FillChar(si, SizeOf(si), 0);
               si.cb := SizeOf(si);
               si.dwFlags := STARTF_USESHOWWINDOW;
               si.wShowWindow := SW_hide;
               FillChar(pi, SizeOf(pi), 0);
               parameter := lsneworiloc;
               AParameter := Format('cmd /c %s', [TrimRight(parameter)]);
               {errb := }CreateProcess(nil, PChar(Aparameter), nil, nil,
                  longbool(False), CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS,
                  nil, PChar(BD.ExeDir), si, pi);
            end
            else
            begin
               if lsneworiloc <> '' then
               begin
                  FillChar(si, SizeOf(si), 0);
                  si.cb := SizeOf(si);
                  si.dwFlags := STARTF_USESHOWWINDOW;
                  si.wShowWindow := SW_hide;
                  FillChar(pi, SizeOf(pi), 0);
                  lireturncode := ShellExecute(Application.Handle, nil,
                     PChar(lsneworiloc), nil,
                     nil, SW_NORMAL);
                  if (lireturncode < 33) then
                  begin
                     if (lireturncode = 31) then
                     begin
                        lsprogname := Format('shell32.dll,OpenAs_RunDLL %s',
                           [lsneworiloc]);
                        {lireturncode := }ShellExecute(Application.Handle, nil,
                           'rundll32.exe', PChar(lsprogname), nil, SW_SHOW);
                        
                     end
                     else
                        BfShowMessage(_('Fehler beim ffnen der Datei.'));
                  end;
               end;
            end;
         end;
      end;
   end;
   finally
       GgfLogEvntEnd('tci_OriFileClick end');
   end;
end;

procedure Tfrm_MainForm.tci_DocLinkClick(Sender: TObject);
begin
   GgfLogEvnt('tci_DocLinkClick');
   dm_MainForm2.pum_Links.PopUp(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure Tfrm_MainForm.tbi_OriginaldateiVersendenClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_MailOriClick');
   dazuversenden := False;
   //dm_MainForm2.mapi_Mail.Clear;
   dm_MainForm2.SendOriMail(True);
   frm_Mailform.SendBtnClick(self);
end;

procedure Tfrm_MainForm.tbi_VShowBriefClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VShowBriefClick');
   if tbi_VShowBrief.Checked then
      LoadBriefPapier(sGBriefPapier)
   else
   if fra_Voransicht.img_DocView.LayersCount > 0 then
   begin
      if iGBriefLayers[0] <> -1 then
      begin
         fra_Voransicht.img_DocView.LayersRemove(iGBriefLayers[0]);
         iGBriefLayers[0] := 1;
      end;
      fra_Voransicht.img_DocView.Update;
   end;
end;

function Tfrm_MainForm.GetIEV(sDoc, sCop: string): string;
var
   IO: TImageEnIO;
   Vec: TImageEnVect;
   
begin
   GgfLogEvnt('GetIEV');
   Result := '';
   if FileExists(sDoc) then
      sDoc := sCop;
   IO := TImageENIO.Create(nil);
   IO.LoadFromFile(sDoc);
   Vec := TImageEnVect.Create(nil);
   Vec.Assign(nil);
   Vec.RemoveAllObjects;
   sCop := ChangeFileExt(sDoc, '.IEV');
   vec.SaveToFileIEV(sCop);
   vec.LoadFromFileIEV(sCop);
   GgfLogEvnt('LoadFromFileIEV M7');
   Result := sCop;
end;



/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// InArbeit befindliche Save Dialog Procedure
// Die Ansteuerung im Testbetrieb erfolgt mit TBX Schaltflche
// im Viewer. Im aktuellen Produktionbetrieb ist diese funktion ausgeschaltet ( Visibility:=false)
// m.frey "TBXItem1Click" kommt in der dfm nicht vor.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

procedure Tfrm_MainForm.TBXItem1Click(Sender: TObject);
var
   iCount, iTmpDocID, iTmpArcID, iCopy: integer;
   sTmpTblName, sPathName, sDocFile, sTmpFile, sOriFile, sFilename: string;
   Folder: TFolderBrowser;
begin
   GgfLogEvnt('TBXItem1Click');
   if (fra_Voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;
   if not CheckBookmark then
      Exit;
   iTmpDocID := iGDocID;
   iTmpArcID := iGArcID;
   iCopy := 0;
   sTmpTblName := sIArcName;
   try
      for iCount := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
      begin
         with dm_DB.my_q_Arc do
         begin
            GotoBookmark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iCount]));
            iGDocID := FieldByName('doc_id').AsInteger;
            if ((bMultiArcQuery) and (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <>
               nil)) then
            begin
               iGArcID := FieldByName('arc_id').AsInteger;
               sIArcName := FieldByName('TblName').AsString;
            end;

            //  Rechte des users an Donkument ermitteln
            //  SPEICHERN lokal
            GetDocUsrRights(False);
            if rGDocRight.Write then
            begin
               sDocFile := FieldByName('doc_loc').AsString;
               sTmpFile := FieldByName('ext_loc').AsString;
               sOriFile := FieldByName('ori_loc').AsString;
               // wenn die Datei im nicht revisionsicheren Speicher existiert, dann
               // erhlt sdocfile den Zeiger auf die Datei im nicht revisionssicheren Speicher
               if FileExists(sTmpFile) then
                  sDocFile := sTmpFile;
               savedialog1.FileName := ExtractFileName(sDocFile);
               saveDialog1.Execute;
               sFilename := savedialog1.InitialDir + '\' + savedialog1.FileName;
               if CopyFile(PChar(sDocFile), PChar(sFilename), False) then
                  //          if CopyFile(PChar(sDocFile), PChar(sPathName + '\' + ExtractFileName(sDocFile)), False) then
               begin
                  NewHistory(15, _('Dokument wurde in lokalem Verzeichnis') + ' [' +
                     sPathName + '] ' + _('gespeichert.'));
                  Inc(iCopy);
               end;
            end;
         end;
      end;
      iGDocID := iTmpDocID;
      iGArcID := iTmpArcID;
      sIArcName := sTmpTblName;
      frm_mainform.setpanelinfo(
         _('Es wurden') + ' ' + IntToStr(iCopy) + ' ' + _('Dokumente von') + ' ' +
         IntToStr(dbgrd_Trefferliste.SelectedRows.Count) + ' ' + _('gespeichert.'));
   finally
      if Assigned(Folder) then
         FreeAndNil(Folder);
      if Assigned(frm_Wait) then
         frm_Wait.Close;
   end;
end;

// Voransicht mit der ersten Datei der Wiedervorlage fuellen, falls die Wiedervorlage existiert
// Ist die frm_DocTime nicht existent, da keine Wiedervorlage existiert, passiert hier auch nichts
// Ist die frm_DocTime jedoch existent, da eine Wiedervorlageliste existiert,
// erhaelt die Wiedervorlageliste den Focus
procedure Tfrm_MainForm.FormActivate(Sender: TObject);
begin
   if not gbshutdownapp then //28.09.2011 b.takacs
   begin
     GgfLogEvnt('FormActivate');

     // use anwendungsdaten to store application related data!
     bringtofront;
     hithasfocus := True;

     // uebertrage den Pfade nach bfa_hit in Interne Variable
     if ngrstime then
     begin
        ngrstime := False;
     end;
   end;
end;

procedure Tfrm_MainForm.FormPaint(Sender: TObject);
begin
   ngAliveMainform := True;
end;

procedure Tfrm_MainForm.KWClick(Sender: TObject);
var
   lmyday, lmyweek, lmyyear: word;
begin
   GgfLogEvnt('KWClick');

   DecodeDateWeek(MFDateTimeEdit1.DateTime, lmyyear, lmyweek, lmyday);
   iGYear := lmyyear;
   iGKW := lmyweek;
   iGKWYear := iGYear;

   ShowDocsKW(iGKWYear, iGKW);
end;

//  Zeige alle Aufgaben der Kalenderwoche an, die mit Jahr und KW angegeben wird
procedure Tfrm_MainForm.ShowDocsKW(Year, KW: integer); //[2327]
var
   dtFirstDayOfKW, dtStart, dtEnd: TDateTime;
   sStart, sEnd, lsNow, lsStati, lsBetween, lsSql, lsGUsrID, lsUsr: string;
   icount: integer;
begin
   GgfLogEvnt('ShowDocsKW');
   GgfLogEvnt('Tfrm_MainForm.FormShow - tor02open := False;');
   tor02open := False;
   dtFirstDayOfKW := EncodeDateWeek(Year, KW, 1);
   dtStart := StartOfTheWeek(dtFirstDayOfKW);
   dtEnd := EndOfTheWeek(dtFirstDayOfKW);
   DateTimeToString(sStart, 'yyyy-mm-dd hh:nn:ss', dtStart);
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', dtEnd);
   DateTimeToString(lsNow, 'yyyy-mm-dd hh:nn:ss', now);

   lsGUsrID := IntToStr(iGUsrID);
   lsUsr := lsGUsrID;

   if tbi_MyTask.Checked then
   begin
      lsStati := ' (status <> 2)  ';
      lsBetween := 'and ((Termin between ' + #39 + sStart + #39 + ' and ' +
         #39 + sEnd + #39 + ' ) or ' + ' (Termin < ' + #39 + sStart + #39 + ')) ';
   end;
   // Anzeige der Objekte fr die eigene Wiedervorlage
   if tbi_MATask.Checked then
   begin
      // check for parallele workflows
      lsStati := '( (((Optionen&1)= 0) and (status <> 2)) or ' +
         '(((Optionen&1)=1) and (2 <> any(select status from sys_timer as b ' +
         'where a.tim_ref=b.tim_ref))))';
      lsBetween := '';
   end;
   // damit wird die wvl list angezeigt!
   lsSql :=
      'Select'
      + ' tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_tblname, arc_name,'
      + ' doc_id, doc_titel, info, status, usr_id_work, usr_id_shed, Optionen,'
      + ' b.usr_name as usr_work_name,'
      + ' c.usr_name as usr_shed_name'
      + ' from sys_timer as a'
      + ' left join sys_arc using(arc_id)'
      + ' left join sys_usr as b on a.usr_id_work = b.usr_id '
      + ' left join sys_usr as c on a.usr_id_shed = c.usr_id '
      + ' where usr_id_work = ' + lsUsr + ' and  ' + lsStati +
      lsBetween + ' order by termin, tim_id';

   if TimeSQL(lsSql) then
   begin
      dm_DB.my_q_Time.First;
      // set the iG*IDS properly!
      FillControls(False);
   end;

   dpnl_Wvlg.Caption := _('Dokumente auf eigener Wiedervorlage/Aufgaben') + ' [' + _('KW') + ' ' +
      IntToStr(KW) + ':  ' + DateToStr(dtStart) + ' - ' + DateToStr(dtEnd) + ']';
   // load the wvl
   setlength(iGtim_id, 0);
   setlength(iGtim_id, dm_DB.my_q_Time.RecordCount);
   dm_DB.my_q_Time.First;
   for icount := 0 to dm_DB.my_q_Time.RecordCount - 1 do
   begin
      iGtim_id[icount] := dm_DB.my_q_Time.FieldByName('tim_id').AsInteger;
      dm_DB.my_q_Time.Next;
   end;
   iGTaskCount := dm_DB.my_q_Time.RecordCount;
end;

function Tfrm_MainForm.TimeSQL(SQLCMD: string): boolean;
begin
   GgfLogEvnt('TimeSQL:' + SQLCMD);
   try
      with dm_db.my_q_Time do
      begin
         SQL.Text := SQLCMD;
         if dm_db.my_q_Time.Active then
         begin
            // Just do an execute!
            Execute;
         end
         else
         begin
            Close;
            Open;
         end;
         First;
         Result := True;
      end;
   except
      on e: Exception do
      begin
         LogEvnt('1000    ' + _('Fehler') + ' in Modul: TimeSQL    ' + e.message);
         Result := False;
      end;
   end;
end;

// Fillcontrols des Wiedervorlagegrid
procedure Tfrm_MainForm.FillControls(showstati: bool);
var
   iCount, iTmpID: integer;
   liUsrID: int64;
   // zu diesem Zeitpunkt ist die Wvlliste bereits gelscht
begin
   GgfLogEvntBeg ('FillControls Begin');

   with dm_DB.my_q_Time do
   begin
      if RecordCount > 0 then
      begin
         dtp_TimerNG.Enabled := True; // Tmf_datTime Edit aktivieren ( kalender)
         memo_Info.Enabled := True;   // Memo Feld aktivieren
         dtp_TimerNG.DateTime := FieldByName('termin').AsDateTime;
         // Datum des Datensatzes aus der Datenbank in die MF Fatetime Komponente bertragen
         MFDateTimeEdit1.DateTime := FieldByName('termin').AsDateTime;
         // Datum des Datensatzes aus der Datenbank ind die variable  MF Datetime edit uebertagen
         memo_Info.Text := FieldByName('Info').AsString;
         // Infotext aus dem Datensatzin  Fieldbyname(info) die die Variable bertegen
         iGTimRef := dm_DB.my_q_Time.FieldByName('tim_ref').AsInteger;
         iGTimRec := dm_DB.my_q_Time.recno;
         iGTimID := dm_DB.my_q_Time.FieldByName('tim_id').AsInteger;
         // lade die Zeitreferenz aus der Query nach iGTimRec
         iGTimArcID := dm_DB.my_q_Time.FieldByName('arc_ID').AsInteger;
         // lade die Nummer des Archives aus der Query nach iGTimeArcID
         iGTimDocID := dm_DB.my_q_Time.FieldByName('doc_ID').AsInteger;
         // lade die DocID aus der Query nach iGTimDocID
         iTmpID := dm_DB.my_q_Time.FieldByName('grp_id').AsInteger;
         // lade group_ID nach TmpID

         if (ng_lastarc = IntToStr(igtimarcID)) and (ng_lastdoc =
            IntToStr(igtimdocID)) then
         begin
           GgfLogEvntEnd ('FillControls End via Exit');
           exit;
         end;

         cbx_Usr_WorkNG.ItemIndex := 0;
         img_wvlwork.picture.Bitmap := nil;
         dm_MainForm2.il_Standard.GetBitmap(cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].ImageIndex, img_wvlwork.picture.Bitmap);
         img_wvlwork.Picture.Bitmap.Transparent := true;
         img_wvlwork.Picture.Bitmap.PixelFormat := pf24Bit;
         img_wvlwork.refresh;

         lbl_wvl_work_name.Caption := cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].Text;

         //dont show the first item alphabetically!
         if iTmpID > 0 then
         begin
            // Liste der Benutzer
            for iCount := 0 to (cbx_Usr_WorkNG.Items.Count - 1) do
               if cbx_Usr_WorkNG.Items.Items[iCount].ImageIndex = 9 then
                  if cbx_Usr_WorkNG.Items.Items[iCount].LinkedObject =
                     TObject(iTmpID) then
                  begin
                     cbx_Usr_WorkNG.ItemIndex := iCount;
                     img_wvlwork.picture.Bitmap := nil;
                     dm_MainForm2.il_Standard.GetBitmap(cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].ImageIndex, img_wvlwork.picture.Bitmap);
                     //  img_wvlwork.picture.Bitmap:=cbx_Usr_WorkNG.Items.Items[iCount].Glyph;
                     img_wvlwork.Picture.Bitmap.Transparent := true;
                     img_wvlwork.Picture.Bitmap.PixelFormat := pf24Bit;
                     img_wvlwork.refresh;
                     lbl_wvl_work_name.Caption := cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].Text;
                     break;
                  end;
         end
         else
         begin
            iTmpID := dm_DB.my_q_Time.FieldByName('usr_id_work').AsInteger;
            for iCount := 0 to (cbx_Usr_WorkNG.Items.Count - 1) do
            begin
               if cbx_Usr_WorkNG.Items.Items[iCount].ImageIndex = 8 then
               begin
                  if cbx_Usr_WorkNG.Items.Items[iCount].LinkedObject =
                     TObject(iTmpID) then
                  begin
                     cbx_Usr_WorkNG.ItemIndex := iCount;
                     img_wvlwork.picture.Bitmap := nil;
                     dm_MainForm2.il_Standard.GetBitmap(cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].ImageIndex, img_wvlwork.picture.Bitmap);
                     //  img_wvlwork.picture.Bitmap:=cbx_Usr_WorkNG.Items.Items[iCount].Glyph;
                     img_wvlwork.Picture.Bitmap.Transparent := true;
                     img_wvlwork.Picture.Bitmap.PixelFormat := pf24Bit;
                     img_wvlwork.refresh;
                     lbl_wvl_work_name.Caption := cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].Text;
                     break;
                  end;
               end;
            end;
         end;

         // Hier werden die Bearbeitungszustaende der Dokumente gesetzt
         // lese den Status des Dokumentes aus der Datenbank
         cbx_Status.ItemIndex := FieldByName('status').AsInteger;
         // setze die Leuchtanzeigen der drei Stati open, done, work auf false (nicht bettigt)
         TBX_ciOffen   .Color := clTeal; //blaugrn
         TBX_ciInArbeit.Color := clTeal;
         TBX_ciFertig  .Color := clTeal;
         // setze die Leuchtanzeige des in der Datenbank gespeicherten Status
         case cbx_Status.ItemIndex of
            0:
               TBX_ciOffen.Color := clLime; //hellgrn
            1:
               TBX_ciInArbeit.Color := clYellow;
            2:
               TBX_ciFertig.Color := clLime;
         end;
         liUsrID := FieldByName('usr_id_work').AsInteger; //[2327]
         // es gilt nicht das Recht des angemeldeten Users (iGUsrID), sondern dessen fr den man die Vertretung hat.
         dm_db.my_q_tmp_CreStatus.SQL.Text :=
            'select rights  FROM sys_arcxs where arc_id = ' + IntToStr(iGTimArcID) +
         //   ' and usr_id = ' + IntToStr(iGUsrID) + ' and find_in_set(' +
            ' and usr_id = ' + IntToStr(liUsrID) + ' and find_in_set(' +
            #39 + 'workflowbreak' + #39 + ',rights)';
         dm_db.my_q_tmp_CreStatus.Execute;
         tbx_wfcancel.Visible := dm_db.my_q_tmp_CreStatus.RecordCount > 0;
      end
      else
      begin
         dtp_TimerNG.Enabled := False;
      end;
   end;

   // Stabilisierung des Dokumentumschaltens
   ng_lastArc := IntToStr(igTimArcID);
   ng_lastDoc := IntToStr(igTimDocID);

   GgfLogEvntEnd ('FillControls End');
end;

procedure Tfrm_MainForm.InitDocTime;
var
   dtNow: TDateTime;
   lmyday, lmyweek, lmyyear: word;
begin
   GgfLogEvnt('InitDocTime');

   dtNow := Now;
   DecodeDateWeek(dtNow, lmyyear, lmyweek, lmyday);
   iGYear := lmyyear;
   iGKW := lmyweek;
   mfdatetimeedit1.date := dtNow;
   dtp_TimerNG.Date := dtNow;
   iGKWYear := iGYear;
   if dpnl_wvlg.Visible = True then
   begin
      ShowDocsKW(iGKWYear, iGKW); 
   end;

end;


// zeigt das Dokument in der Vorlage an das im wvl grid angeklickt wurde
procedure Tfrm_MainForm.tbi_ShowDocClick(Sender: TObject);
var
   stmp_WvlID_NG: string;

begin
   GgfLogEvntBeg('tbi_ShowDocClick beg');
   logwvl('9182, WVL Show docClick einstieg in Prozedur');
 
   if ngDocClickOpen then
   begin
      ngDocClickOpen := False;


      with dm_DB.my_q_Time do
      begin
         logwvl('9190, WVL Show docClick einstig in Prozedur');
         if RecordCount > 0 then
         begin
            Self.SetStatusText(cStatusPanelDoc, //3.5.0.25
               FieldByName('arc_id').AsString + '.' + FieldByName('doc_id').AsString);
            iGarcid := FieldByName('arc_id').AsInteger;
            sIArcName := FieldByName('arc_tblname').AsString;

            //  Gehe zur global bekannten DOC ID
            GoToDocID;

            stmp_WvlID_NG := FieldByName('tim_ref').AsString;
            if stmp_WvlID_NG <> '' then
            begin
               iWvlIDNG := StrToInt(stmp_WvlID_NG);
            end
            else
            begin
               iWvlIDNG := 0;
            end;
         end
         else
         begin
            ResetAnzeige;
         end;
      end;
      ngDocClickOpen := True;
   end
   else
   begin
      frm_mainform.setpanelinfo(
         _('Klicken Sie bitte das Dokument erneut an.'));
   end;
   GgfLogEvntEnd('tbi_ShowDocClick end');
end;

procedure Tfrm_MainForm.dbgrd_TimersCellClick(Column: TColumn);
begin
   GgfLogEvnt('dbgrd_TimersCellClick');
   FillControls(False);
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.dbgrd_TimersCellClick');
   tbi_ShowDocClick(self);

end;

procedure Tfrm_MainForm.dbgrd_TimersDrawColumnCell(Sender: TObject;
   const Rect: TRect; DataCol: integer; Column: TColumn; State: TGridDrawState);
begin
   if state = [] then
   begin
      if dm_DB.my_q_Time.FieldList.IndexOf('status') <> -1 then
      begin
         // Wiedervorlage Farben der Datenreihen
         case dm_DB.my_q_Time.FieldByName('status').AsInteger of
            //  Column.Field.AsInteger of
            // Modifikation der Farben der Wiedervorlage
            // 0: TDBGrid(sender).canvas.brush.color := $00FF4040;
            // Status 0 Null  OFFEN
            //0: TDBGrid(sender).canvas.brush.color := $00D6320C;
            // Weiss-Rot       //mausgrau
            // Status 1 in Arbeit
            1:
               TDBGrid(Sender).canvas.brush.color := $00FFFF80;
            // Weiss-Gelb      //signalgelb
            // Status 2 fertig
            2:
               TDBGrid(Sender).canvas.brush.color := cColorHellgruen;
            // Weiss-Grn      //signalgruen

            0:
               TDBGrid(Sender).canvas.brush.color := $00DDDDDD;

         else
            TDBGrid(Sender).canvas.brush.color := cllime;
            // Wiedervorlage Farbe clWhite
         end;

         if dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime <=
            StartOfTheDay(Date) then
         begin
            case dm_DB.my_q_Time.FieldByName('status').AsInteger of
               //  Column.Field.AsInteger of
               0:
                  TDBGrid(Sender).canvas.brush.color := clRed;
               // Wiedervorlage Farbe Rot
               1:
                  TDBGrid(Sender).canvas.brush.color := clyellow;
               // Wiedervorlage Farbe Gelb
            end;
         end;
         if column.Index = 0 then
         begin
            if dm_DB.my_q_Time.FieldByName('grp_id').AsInteger <> 0 then
            begin
               dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, 16,
                  rect.Top, 9, True);
            end
            else
            begin
               dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, 16,
                  rect.Top, 8, True);
            end;
         end;
      end;
   end;
end;

procedure Tfrm_MainForm.ReadCbxUsr;
var
   AddItem: TJvImageItem;
   lsSql: string;
begin
   GgfLogEvnt('ReadCbxUsr');
   cbx_Usr_WorkNG.Items.Clear;
   // Liste der Benutzer denen etwas delegiert werden kann zuruecksetzen
   // Gruppen auslesen...
   if TmpSQL('Select Sql_No_cache * from sys_grp order by grp_name') then
   begin
      try
         with dm_DB.my_q_Tmp do
         begin
            while not EOF do
            begin
               AddItem := cbx_Usr_WorkNG.Items.Add;
               AddItem.Text := FieldByName('grp_name').AsString;
               AddItem.LinkedObject :=
                  TObject(FieldByName('grp_ID').AsInteger);
               AddItem.ImageIndex := 9;
               Next;
            end;
            dm_DB.my_q_Tmp.Close;
         end;
      except
         on e: Exception do
            ErrorMsg('ReadCbxUsr', _('Fehler beim Auslesen aller Benutzer:') +
               e.Message, 2015, True);
      end;
   end
   else
      ErrorMsg('ReadCbxUsr', _('Fehler bei Select Sql_No_cache Anweisung!'), 2002, True);
   lsSql := 'Select Sql_No_cache * from sys_usr where (find_in_set("enabled",Flags)>0) order by usr_name'; //

   if TmpSQL(lsSql) then
   begin
      try
         cbx_SuSr.Items.Clear;
         cbx_SUsr.Items.AddObject(_('alle Benutzer'), TObject(0));
         with dm_DB.my_q_Tmp do
         begin
            while not EOF do
            begin
               if cbx_SUsr.Items.IndexOf(FieldByName('usr_name').AsString) = -1 then
                  cbx_SUsr.Items.AddObject(FieldByName('usr_name').AsString,
                     TObject(FieldByName('usr_ID').AsInteger));

               AddItem := cbx_Usr_WorkNG.Items.Add;
               AddItem.Text := FieldByName('usr_name').AsString;
               AddItem.LinkedObject :=
                  TObject(FieldByName('usr_ID').AsInteger);
               AddItem.ImageIndex := 8;
               Next;
            end;
            dm_DB.my_q_Tmp.Close;
         end;
      except
         on e: Exception do
            ErrorMsg('ReadCbxUsr', _('Fehler beim Auslesen aller Benutzer:') +
               e.Message, 2015, True);
      end;
   end
   else
      ErrorMsg('ReadCbxUsr', _('Fehler bei Select Sql_No_cache Anweisung!'), 2002, True);
end;

procedure Tfrm_MainForm.tbi_ShowKWClick(Sender: TObject);
var
   lmyday, lmyweek, lmyyear: word;
begin
   GgfLogEvnt('tbi_ShowKWClick');
   if gbArcHandling then
      exit;
   DecodeDateWeek(MFDateTimeEdit1.DateTime, lmyyear, lmyweek, lmyday);
   iGYear := lmyyear;
   iGKW := lmyweek;
   iGKWYear := iGYear;
   ShowDocsKW(iGKWYear, iGKW);
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.tbi_ShowKWClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.dtp_TimerNGChange(Sender: TObject);
begin
   GgfLogEvnt('dtp_TimerNGChange');
   ShowDocsDate(MFDateTimeEdit1.Date); 
end;

procedure Tfrm_MainForm.ShowDocsDate(Datum: TDateTime);
var
   sStart, sEnd: string;
begin
   GgfLogEvnt('ShowDocsDate');

   DateTimeToString(sStart, 'yyyy-mm-dd', StartOfTheDay(Datum));
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss', EndOfTheDay(Datum));
   // check for parallele workflows
   if TimeSQL(
      'Select Sql_No_cache tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_name, arc_tblname, doc_id,'
      + ' doc_titel, info, status, usr_id_work, usr_id_shed, Optionen from sys_timer ' +
      'left join sys_arc using(arc_id)' + ' where usr_id_work = ' +
      IntToStr(iGUsrID) + ' and ( (((Optionen&1)= 0) and (status <> 2)) or ' +
      ' (((Optionen&1) =1) and  (2 <> any(select status from sys_timer as b where  a.tim_ref=b.tim_ref)))) '
      + ' and Termin = ' + #39 + sStart + #39 + ' order by termin, tim_id') then
   begin
      FillControls(False); 
   end;

   dpnl_Wvlg.Caption := _('Dokumente der eigenen Wiedervorlage/Aufgaben') + ' [' + _('KW') + ' ' +
      IntToStr(iGKW) + ':  ' + DateToStr(Datum) + ']';
end;


procedure Tfrm_MainForm.SwitchControls(Func: integer);
var
   colTmp: TColumn;
   iColumns, iCnt, liRecNo : Integer;
begin
   GgfLogEvnt('SwitchControls');

   //   Schalte zwischend er Anzeige der eigenen und der delegierten Wiedervorlage hin und her
   //   if func = 1 then zeige die Dokumente die der eigenen Wiedervorlage zugeordnet sind
   liRecNo := -1;
   if func = 1 then
   begin
      btn_WvlSpeichern.Enabled := True;
      tbi_MyTask.Checked := True;
      tbi_MATask.Checked := False;
      tbi_PrevKW.Enabled := True;
      tbi_NextKW.Enabled := True;
      tbi_ShowKW.Enabled := True;

      tbi_ShowOpen.Visible := False;
      tbi_ShowWork.Visible := False;
      tbi_ShowDone.Visible := False;
      tbi_DelDone.Visible := False;
      TBX_FiltOffen.Enabled := False;
      TBX_FiltArb.Enabled := False;
      TBX_FiltFertig.Enabled := False;
      MFDateTimeEdit1.Enabled := True;
      TBX_ciOffen.Visible := True;
      TBX_ciInArbeit.Visible := True;
      TBX_ciFertig.Visible := True;

      cbx_Usr_WorkNG.visible := false;
      img_wvlwork.Visible := true;
      lbl_wvl_work_name.Visible := true;

      if FileExists(ResultlistDesignPath + '\WVL.bfa') then
      begin
         if gbAppStarted then
         begin
            if dbgrd_Wvl.SelectedRows.CurrentRowSelected then
               liRecNo := dbgrd_Wvl.DataSource.DataSet.RecNo;
            dbgrd_Wvl.Columns.Clear;
            iColumns := 6;

            for iCnt := 0 to iColumns do
               dbgrd_Wvl.Columns.Add;

            try
                dbgrd_Wvl.Columns.LoadFromFile(ResultlistDesignPath + '\WVL.bfa');
            except
              on e: Exception do
               LogEvnt('Fehler beim Auslesen der Datei: \WVL.bfa' + #13 + e.Message);
            end;
         end;
      end
      else
      begin
         with dbgrd_Wvl do
         begin
            Columns.Clear;
            colTmp := Columns.Add;
            colTmp.Width := 21;
            colTmp.Title.Caption := 'Typ';
            colTmp := Columns.Add;
            colTmp.Width := 57;
            colTmp.FieldName := 'termin';
            colTmp.Title.Caption := _('Termin');
            colTmp := Columns.Add;
            colTmp.Width := 100;
            colTmp.FieldName := 'arc_name';
            colTmp.Title.Caption := _('Archiv');
            colTmp := Columns.Add;
            colTmp.FieldName := 'doc_titel';
            colTmp.Title.Caption := _('Dokument');
            colTmp := Columns.Add;
            colTmp.Width := 300;
            colTmp.FieldName := 'info';
            colTmp.Title.Caption := _('Info');
            colTmp := Columns.Add;
            colTmp.Width := 50;
            colTmp.Alignment := taleftJustify;
            colTmp.FieldName := 'usr_shed_name';
            colTmp.Title.Caption := _('Controller');
            colTmp := Columns.Add;
            colTmp.Width := 50;
            colTmp.Alignment := taleftJustify;
            colTmp.FieldName := 'usr_work_name';
            colTmp.Title.Caption := _('fr');
         end;
      end;
   end;

   //   if func = 2 then zeige die Dokumente die der Mitarbeiter  Wiedervorlage zugeordnet sind
   if func = 2 then
   begin
      btn_WvlSpeichern.Enabled := True; 
      tbi_MyTask.Checked := False;
      tbi_MATask.Checked := True;
      tbi_PrevKW.Enabled := False;
      tbi_NextKW.Enabled := False;
      tbi_ShowKW.Enabled := False;
      MFDateTimeEdit1.Enabled := False;
      tbi_ShowOpen.Enabled := True;
      tbi_ShowWork.Enabled := True;
      tbi_ShowDone.Enabled := True;
      tbi_DelDone.Enabled := True;
      TBX_FiltOffen.Enabled := True;
      TBX_FiltArb.Enabled := True;
      TBX_FiltFertig.Enabled := True;
      TBX_ciOffen.Visible := False;
      TBX_ciInArbeit.Visible := False;
      TBX_ciFertig.Visible := False;
      tbi_ShowOpen.Visible := True;
      tbi_ShowWork.Visible := True;
      tbi_ShowDone.Visible := True;
      tbi_DelDone.Visible := True;
      cbx_Usr_WorkNG.visible := true;
      lbl_wvl_work_name.Visible := false;

      if FileExists(ResultlistDesignPath + '\WVLCtrl.bfa') then
      begin
         if gbAppStarted then
         begin
            dbgrd_Wvl.Columns.Clear;
            iColumns := 7;

            for iCnt := 0 to iColumns do
               dbgrd_Wvl.Columns.Add;
            try
             dbgrd_Wvl.Columns.LoadFromFile(ResultlistDesignPath + '\WVLCtrl.bfa');
            except
              on e: Exception do
               LogEvnt('Fehler beim Auslesen der Datei: \WVLCtrl.bfa' + #13 + e.Message);
            end;
         end;
      end
      else
      begin
         with dbgrd_Wvl do
         begin
            Columns.Clear;
            colTmp := Columns.Add;
            colTmp.Width := 21;
            colTmp.Title.Caption := _('Typ');
            colTmp := Columns.Add;
            colTmp.Width := 57;
            colTmp.FieldName := 'erinnerung';
            colTmp.Title.Caption := _('Erinnerung');
            colTmp := Columns.Add;
            colTmp.Width := 57;
            colTmp.FieldName := 'termin';
            colTmp.Title.Caption := _('Termin');
            colTmp := Columns.Add;
            colTmp.Width := 300;
            colTmp.FieldName := 'info';
            colTmp.Title.Caption := _('Info');
            //colTmp := Columns.Add;
            //colTmp.FieldName := 'status';
            //colTmp.Title.Caption := 'Status';
            colTmp := Columns.Add;
            colTmp.Width := 57;
            colTmp.FieldName := 'arc_name';
            colTmp.Title.Caption := _('Archiv');
            colTmp := Columns.Add;
            colTmp.Width := 57;
            colTmp.FieldName := 'doc_titel';
            colTmp.Title.Caption := _('Dokument');
            colTmp := Columns.Add;
            colTmp.Width := 57;
            colTmp.FieldName := 'usr_name';
            colTmp.Title.Caption := _('Bearbeiter');

            colTmp := Columns.Add;
            colTmp.Width := 50;
            colTmp.Alignment := taleftJustify;
            colTmp.FieldName := 'shed_usr_name';
            colTmp.Title.Caption := _('fr');

         end;
      end;
   end;
end;

// Schaltet die eigene Wiedervorlage ein
// Dokumente fuer die eigene Wiedervorlage werden im Wiedervorlagepanel aufgelistet
// eigene Wiedervorlage
procedure Tfrm_MainForm.tbi_MyTaskClick(Sender: TObject);
var
   dtNow: TDateTime;
   lmyday, lmyweek, lmyyear: word;

begin
   GgfLogEvnt('tbi_MyTaskClick');
   if fbtimcheck then
      exit;
   if gbArcHandling then
      exit;

   // ShowdocsKW ist die zentrale Anzeige der Datenstze im MY Task.
   // Diese Anzeige muss eine aktuelle KW zur Berechnung der anzuzeigenden Datenstze erhalten.
   dtNow := Now;
   SwitchControls(1); // datagrid modifizieren

   DecodeDateWeek(dtNow, lmyyear, lmyweek, lmyday);
   iGYear := lmyyear;
   iGKW := lmyweek;
   iGKWYear := iGYear;
   ShowDocsKW(iGKWYear, iGKW);

   FillControls(True);

   dm_MainForm2.refreshregwvl;
   RefreshStatus;
   wvlhasfocus := False;
   wvlshowbuttons(False);

end;

// Schaltet die Mitarbeiter Wiedervorlage ein
// Dokumente fuer die Mitarbeiter Wiedervorlage werden im Wiedervorlagepanel aufgelistet
// delegierte Wiedervorlage
procedure Tfrm_MainForm.tbi_MATaskClick(Sender: TObject); //[2327]
begin
   GgfLogEvnt('tbi_MATaskClick');
   if fbtimcheck then
      exit;
   if gbArcHandling then
      exit;

   SwitchControls(2);
   ShowMATasks;

   wvlhasfocus := False;
   wvlshowbuttons(False);
   dbgrd_wvl.Refresh;
end;

procedure Tfrm_MainForm.fra_DocLinkbtn_LnkCreClick(Sender: TObject);
begin
   GgfLogEvnt('fra_DocLinkbtn_LnkCreClick');
   fra_DocLink.btn_LnkCreClick(Sender);
end;

// Statusanzeige aktualisieren der drei Statusschaltflaechen
procedure Tfrm_MainForm.RefreshStatus;
begin
   GgfLogEvnt('RefreshStatus');

   if dm_DB.my_q_Time.FieldByName('Status').AsInteger = 0 then
   begin
      tbx_ciOffen.color := cllime;
      tbx_ciInArbeit.color := clGray;
      tbx_cifertig.color := clGray;
   end
   else
   if dm_DB.my_q_Time.FieldByName('Status').AsInteger = 1 then
   begin
      tbx_ciOffen.color := clGray;
      tbx_ciInArbeit.color := clyellow;
      tbx_cifertig.color := clGray;
   end
   else
   if dm_DB.my_q_Time.FieldByName('Status').AsInteger = 2 then
   begin
      tbx_ciOffen.color := clGray;
      tbx_ciInArbeit.color := clGray;
      tbx_cifertig.color := cllime;
   end;
end;

//  Wiedervorlage anklicken
//  Eintrag aus dem DBGrid auswaehlen
procedure Tfrm_MainForm.dbgrd_WvlCellClick(Column: TColumn);
begin
   GgfLogEvntBeg  ('dbgrd_WvlCellClick Begin');

   if gbwvlcellclick then
      exit;

   gbwvlcellclick := True;
   bMultiArcQuery:= false;
   try
      if gbansichtlesen or dm_db.tim_ansicht.Enabled or dm_db.tim_searcharc.enabled then
      begin
         if iGTimRec <> dm_DB.my_q_Time.RecNo then
         begin
            dm_DB.my_q_Time.RecNo := iGTimRec;
            dbgrd_wvl.SelectedRows.Clear;
            dbgrd_wvl.SelectedRows.CurrentRowSelected := True;
         end;
         exit;
      end;

      wvlshowbuttons(False);
      if fra_Voransicht.gbAnnoNotSaved then
      	fra_Voransicht.saveobjects(False, False);

      if GHasNotBeenSavedAfterModify or ((gtmpiStatus xor gotmpistatus) > 0) then
      begin
         if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
            #13 + _('Mchten Sie die nderungen speichern?'),
            True) = mrYes then
         begin
            tbi_VSaveDocClick(self);
         end;
         GHasNotBeenSavedAfterModify := False;
         fgchangedvoransicht := False;
         fgchangedvoransichttif := False;
         gtmpiStatus := gotmpistatus;
         btn_SaveDoc.Enabled := false;
         tbi_VSaveDoc.Enabled := false;
      end;
      // if wvl grid clicked set      loadingfromwclcellclick:= 1;
      loadingfromwclcellclick := 1;

      lbl_choosenLink.Caption := '';
      // Grafische Anzeige der Gruppe als linkMaenge ausschalten
      img_link.Visible := False;
      lbl_choosenLink.Hint := _('kein Referenz ausgewhlt.');
      lbl_choosenLink.Enabled := False;

      // Hier beginnt das die Anzeige der Wiedervorlage durch klick
      if gbArcHandling or (not WvlCellClickopen) then
      begin
         frm_mainform.setpanelinfo(
            _('Klicken Sie bitte das Dokument erneut an.'));
         exit;
      end;

      hithasfocus := False;
      istrefferliste := False;
      dbgrd_wvl.SetFocus;

      if WvlCellClickopen then
      begin
         ShowNoAnno := False;
         ResetAnzeige;
         //   Dokument anklicken und anzeigen
         wvlhasfocus := True;
         wvlshowbuttons(True);
         gbwvlcellclick := true;
         GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.dbgrd_WvlCellClick');
         tbi_ShowDocClick(self);
         ShowVoransicht(True);
         ReadStatus;
         FillControls(True);
      end;

      // if wvl grid clicked  then at the end set loadingfromwclcellclick:= 0;
      loadingfromwclcellclick := 0;
      if not gbArcHandling then
      begin
         gbwvlcellclick := False;
      end;
   finally
      gbwvlcellclick := False;
   end;

   GgfLogEvntEnd ('dbgrd_WvlCellClick End');
end;

//     Wiedervorlagen fr die vorhergehende Kalenderwoche anzeigen
procedure Tfrm_MainForm.TBXItem4Click(Sender: TObject);
var
   lmyday, lmyweek, lmyyear: word;
begin
   GgfLogEvnt('TBXItem4Click');
   if gbArcHandling then
      exit;
   Dec(iGKW);
   // we assume here igkw=0
   if (iGKW = 0) or (iGKW < 0) then
   begin
      if (igKW < 0) then
      begin
      end
      else
      begin
         DecodeDateWeek(EncodeDateWeek(iGKWYear, iGKW + 1) - 7, lmyyear, lmyweek, lmyday);
         iGKWYear := lmyyear;
         iGKW := lmyweek;
      end;
   end;
   ShowDocsKW(iGKWYear, iGKW);
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.TBXItem4Click');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

//     Wiedervorlagen fr die nchste Kalenderwoche anzeigen
procedure Tfrm_MainForm.TBXItem5Click(Sender: TObject);
var
   lmyday, lmyweek, lmyyear: word;
begin
   GgfLogEvnt('TBXItem5Click');
   if gbArcHandling then
      exit;
   Inc(iGKW);

   if (igKW > WeeksInAYear(iGKWYear)) then
   begin
      DecodeDateWeek(EncodeDateWeek(iGKWYear, iGKW - 1) + 7, lmyyear, lmyweek, lmyday);
      iGKWYear := lmyyear;
      iGKW := lmyweek;
   end;
   ShowDocsKW(iGKWYear, iGKW);
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.TBXItem5Click');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.dtp_DocTimeNGChange(Sender: TObject);
begin
   GgfLogEvnt('dtp_DocTimeNGChange');
   ShowDocsDate(MFDateTimeEdit1.Date);
end;

procedure Tfrm_MainForm.btnOffenClick(Sender: TObject);
begin
   GgfLogEvnt('btnOffenClick');
   ShowMAOpen;
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.btnOffenClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

//  Zeige MATASK, delegierte Aufgaben an Mitarbeiter delegierte Aufgaben
procedure Tfrm_MainForm.ShowMATasks; //[2327]
var
   sqlstring, lsadd, lsGUsrID, lsSql,
   sTmpTblNameTimRef, sTmpTblNameSysTimer, sTmpTblNameSysCtlr, sTmpTblNameFilt: string;
   lbHasSupUsr:Boolean; //Vorgesetzte da?
begin
   GgfLogEvnt('ShowMATasks');

   lsGUsrID := IntToStr(iGUsrID);
   sTmpTblNameTimRef   := 'tmp_' + sGTmpName+'Ref';
   sTmpTblNameSysTimer := 'tmp_' + sGTmpName+'Tim';
   sTmpTblNameSysCtlr  := 'tmp_' + sGTmpName+'Ctrl';
   sTmpTblNameFilt     := 'tmp_' + sGTmpName+'Filt';


   //---------------------------------------------------------------------------
   // erst mal eine temporre Tabelle erzeugen damit das "schneller" geht
   //---------------------------------------------------------------------------

   (**)
   with dm_DB.my_cmdarc do
   begin
      //tmp-table mit allen tim_ref von sys_timer und sys_ctlrtimer die in Frage kommen
      DbX('drop table if exists ' + sTmpTblNameTimRef);
      DbX('create table `'+sTmpTblNameTimRef+'` (' +
         '`tim_ref` bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
         'PRIMARY KEY  (`tim_ref`)' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci');
      //Der tmp-table die Eintrge von sys_timer dazu, die in Frage kommen
      lsSql:= 'Insert '+sTmpTblNameTimRef+' select distinct tim_ref from sys_timer '+
                 'where (usr_id_shed = '+lsGUsrID+' and usr_id_work <> '+lsGUsrID+')'+
                 //neue Anweisung: grundstzlich keine eigenen wiedervorlagen in delegierten Liste anzeigen
                 //'or    (usr_id_shed = '+lsGUsrID+' and usr_id_work = '+lsGUsrID+' and status = 2)';
                 '';
      DbX(lsSql);

      //Der tmp-table die Eintrge von sys_ctlrtimer dazu, die in Frage kommen
      DbX(
         'Insert '+sTmpTblNameTimRef+' select distinct tim_ref from sys_ctlrtimer '+
            'where (usr_id_shed = '+lsGUsrID+' and usr_id_work <> '+lsGUsrID+')'+
            'ON DUPLICATE KEY UPDATE '+sTmpTblNameTimRef+'.tim_ref=sys_ctlrtimer.tim_ref'
            );
      // nun werden die sys_timer und sys_ctlrtimer anhand obiger tabelle vorgefiltert

      // - sys_timer
      DbX('drop table if exists ' + sTmpTblNameSysTimer);
      DbX('create table `'+sTmpTblNameSysTimer+'` LIKE sys_timer');
      DbX('insert '+sTmpTblNameSysTimer+' '
					+ '(tim_id, tim_ref, arc_id, doc_id, doc_titel, grp_id, usr_id_work, '
               + 'usr_id_shed, status, termin, erinnerung, Optionen, info) '
               +'select tim_id, sys_timer.tim_ref, arc_id, doc_id, doc_titel, grp_id, usr_id_work, '
               +'usr_id_shed, status, termin, erinnerung, Optionen, info from sys_timer'
               + ' inner join '+sTmpTblNameTimRef+' on sys_timer.tim_ref='+sTmpTblNameTimRef+'.tim_ref');
      // - sys_ctlrtimer
      DbX('drop table if exists ' + sTmpTblNameSysCtlr);
      DbX('create table `'+sTmpTblNameSysCtlr+'` LIKE sys_ctlrtimer');
      DbX('insert '+sTmpTblNameSysCtlr+' '
               + 'select timctrl_id, tim_id, sys_ctlrtimer.tim_ref, usr_id_work, grp_id, usr_id_shed, info from sys_ctlrtimer'
               + ' inner join '+sTmpTblNameTimRef+' on sys_ctlrtimer.tim_ref='+sTmpTblNameTimRef+'.tim_ref');
   end;
   nop;

   // dont forget optionen!
   // where condition:
   // show all my works which are ready and all work i gave (scheduled) for others
    try

      if gbhasctrlwvl then
      begin
         DbX('drop table if exists ' + sTmpTblNameFilt);
         DbX('create table '+sTmpTblNameFilt + ' (' +
            'tim_id BIGINT UNSIGNED , ' +
            'tim_ref BIGINT UNSIGNED , ' +
            'arc_id BIGINT UNSIGNED , ' +
            'doc_id BIGINT UNSIGNED , ' +
            'doc_titel varchar(32) collate latin1_german1_ci NOT NULL default ' + #39 + #39 + ',' +
            'grp_id BIGINT UNSIGNED , ' +
            'termin datetime NOT NULL default "1900-01-01 00:00:00", ' +
            'erinnerung datetime NOT NULL default "1900-01-01 00:00:00", ' +
            'info varchar(255) collate latin1_german1_ci NOT NULL default ' + #39 + #39 + ',' +
            'status int(10) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            'optionen bigint(20) unsigned NOT NULL default ' + #39 + '0' + #39 + ',' +
            'usr_id_work BIGINT UNSIGNED , ' +
            'usr_id_shed BIGINT UNSIGNED , ' +
            'ctrl_usr_id_work BIGINT UNSIGNED , ' +
            'ctrl_usr_id_shed BIGINT UNSIGNED ' +
         ') ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci');
         sqlstring :=
            'insert '+sTmpTblNameFilt + ' ' +

            'Select Sql_No_cache ' +
            sTmpTblNameSysTimer+'.tim_id as tim_id, '+sTmpTblNameSysTimer+'.tim_ref as tim_ref, ' +
            sTmpTblNameSysTimer+'.arc_id, ' +
            sTmpTblNameSysTimer+'.doc_id, ' +
            sTmpTblNameSysTimer+'.doc_titel, ' +
            ' '+sTmpTblNameSysTimer+'.grp_id, termin, ' +
            'erinnerung, '+sTmpTblNameSysTimer+'.info as info , '+sTmpTblNameSysTimer+'.status, optionen, '+sTmpTblNameSysTimer+'.usr_id_work as usr_id_work' +
            ', '+sTmpTblNameSysTimer+'.usr_id_shed as usr_id_shed,' +
            sTmpTblNameSysCtlr+'.usr_id_work as ctrl_usr_id_work, '+sTmpTblNameSysCtlr+'.usr_id_shed' +
            ' as ctrl_usr_id_shed ' +
            'from '+sTmpTblNameSysTimer+' ' +
            'left join '+sTmpTblNameSysCtlr+' on('+sTmpTblNameSysTimer+'.tim_ref='+sTmpTblNameSysCtlr+'.tim_ref) ' +
            'where (('+sTmpTblNameSysTimer+'.usr_id_shed = ' + lsGUsrID + ' and '+sTmpTblNameSysTimer+'.usr_id_work <> ' +
            lsGUsrID + '))' + 'or (('+sTmpTblNameSysCtlr+'.usr_id_shed = ' + lsGUsrID + ' and ' +
            sTmpTblNameSysCtlr+'.usr_id_work <> ' + lsGUsrID + ')) ' +
            'or (('+sTmpTblNameSysTimer+'.usr_id_shed = ' + lsGUsrID + ' and '+sTmpTblNameSysTimer+'.usr_id_work =' +
            lsGUsrID + ') and ('+sTmpTblNameSysTimer+'.status =2)) ' + lsadd +
            'group by tim_ref order by termin';
         DbX(sqlstring);
         (**)
         sqlstring :=
            'Select Sql_No_cache ' +
            sTmpTblNameFilt+'.tim_id as tim_id, '+sTmpTblNameFilt+'.tim_ref as tim_ref, ' +
            //laut deccer knnen die ersten beiden as weg
            sTmpTblNameFilt+'.grp_id, termin, ' +
            sTmpTblNameFilt+'.arc_id, arc_name, arc_tblname, doc_id, doc_titel, ' +
            'if(grp_name is not null, grp_name, sys_usr.usr_name) as usr_name, ' +
            'c.usr_name as shed_usr_name, ' + //2
            'erinnerung, ' +
            sTmpTblNameFilt+'.info as info , ' +
            sTmpTblNameFilt+'.status, optionen, ' +
            sTmpTblNameFilt+'.usr_id_work as usr_id_work, ' +
            sTmpTblNameFilt+'.usr_id_shed as usr_id_shed, ' +
            sTmpTblNameFilt+'.ctrl_usr_id_work as ctrl_usr_id_work, ' +
            sTmpTblNameFilt+'.ctrl_usr_id_shed as ctrl_usr_id_shed ' +
            'from '+sTmpTblNameFilt+' ' +
            'left join sys_arc using(arc_id) ' +
            'left join sys_usr on sys_usr.usr_id = '+sTmpTblNameFilt+'.usr_id_work ' +
            'left join sys_usr as c on c.usr_id = '+sTmpTblNameFilt+'.usr_id_shed ' + //2
            'left join sys_grp on sys_grp.grp_id = '+sTmpTblNameFilt+'.grp_id ' +
            'group by tim_ref order by termin';
            nop;
      end;

      if TimeSQL(sqlstring) then
         FillControls(False);
      dpnl_Wvlg.Caption :=
         _('Dokumente auf delegierter Wiedervorlage/Aufgaben [Liste aller vergebenen Auftrge]');
      tbx_wfcancel.visible := false;
   except
      on e: Exception do
      begin
         ErrorMsg('ShowMATasks', _('Fehler beim Erstellen einer der deligierten Wiedervorlagen:') +
            e.Message, 4001, True);
      end;
   end;
end;

procedure Tfrm_MainForm.btnBearbeitungClick(Sender: TObject);
begin
   GgfLogEvnt('btnBearbeitungClick');
   ShowMAWork;
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.btnBearbeitungClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.btnFertigClick(Sender: TObject);
begin
   GgfLogEvnt('btnFertigClick');
   ShowMADone;
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.btnFertigClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;


//-----------------------------------------------------------------------------
// Zeigt alle Auftrge mit dem Status Offen
procedure Tfrm_MainForm.ShowMAOpen; //[2327]
var lsUsr: string;
begin
   GgfLogEvnt('ShowMAOpen');

   lsUsr := IntToStr(iGUsrID);

   // dont forget optionen!
   // show all things in status open even with Optionen =1
   if TimeSQL(
      'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, ' +
      'arc_name, arc_tblname, doc_id, doc_titel, ' +
      'if(grp_name is not null, grp_name, usr_name) as usr_name,' +
      ' erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer ' +
      'left join sys_arc using(arc_id) ' +
      ' left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
      ' left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
      'where (usr_id_work in (' + lsUsr + ') or usr_id_shed in (' + lsUsr + ')) '+
      'and status = 0 ' +
      'group by tim_ref order by termin') then
      FillControls(False);
   dpnl_Wvlg.Caption :=
      _('Dokumente auf Wiedervorlage/Aufgaben [Liste aller vergebenen Auftrge]');
end;

//-----------------------------------------------------------------------------
// Zeigt alle Auftrge mit dem Status in Bearbeitung
procedure Tfrm_MainForm.ShowMAWork; //[2327]
var lsUsr: string;
begin 
   GgfLogEvnt('ShowMAWork');

   lsUsr := IntToStr(iGUsrID);

   // dont forget optionen!
   if TimeSQL(
      'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, ' +
      'arc_name, arc_tblname, doc_id, doc_titel, ' +
      'if(grp_name is not null, grp_name, usr_name) as usr_name,' +
      'erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer ' +
      'left join sys_arc using(arc_id) ' +
      'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
      'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
      'where (usr_id_work in (' + lsUsr + ') or usr_id_shed in (' + lsUsr + ')) ' +
      'and status = 1 ' +
      'group by tim_ref order by termin') then
      FillControls(False);
   dpnl_Wvlg.Caption :=
      _('Dokumente auf delegierter Wiedervorlage/Aufgaben [Liste aller vergebenen Auftrge]');
end;

//-----------------------------------------------------------------------------
// Zeigt alle Auftrge mit dem Status Fertig
procedure Tfrm_MainForm.ShowMADone; //[2327]
var lsUsr: string;
begin
   GgfLogEvnt('ShowMADone');

   lsUsr := IntToStr(iGUsrID);

   // all(select ... means that all workers which have this document assigned have to click done (status =2 )
   // select the needed columns
   // dont forget optionen!
   if TimeSQL(
      'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, ' +
      'arc_name, arc_tblname, doc_id, doc_titel, ' +
      'if(grp_name is not null, grp_name, usr_name) as usr_name,' +
      'erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer ' +
      'left join sys_arc using(arc_id) ' +
      'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
      'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
      'where (usr_id_work in (' + lsUsr + ') or usr_id_shed in (' + lsUsr + ')) '+
      ' and  ' +
      '(2 = all(select status from sys_timer as st1  where (usr_id_shed in (' +
      lsUsr + ') or usr_id_work in (' + lsUsr + ')) and  sys_timer.tim_ref=st1.tim_ref))' +
      ' group by tim_ref order by termin') then
      FillControls(False);
   dpnl_Wvlg.Caption :=
      _('Dokumente auf delegierter Wiedervorlage/Aufgaben [Liste aller vergebenen Auftrge]');
end;

//-----------------------------------------------------------------------------
procedure Tfrm_MainForm.delAufgClick(Sender: TObject);
begin
   GgfLogEvnt('delAufgClick');
   SwitchControls(2);
   ShowMATasks;
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.delAufgClick');
   tbi_ShowDocClick(self);
end;

procedure Tfrm_MainForm.ownaufClick(Sender: TObject);
begin
   GgfLogEvnt('ownaufClick');
   // deaktiviert am 061114 da der Aufruf redundant ist
   tbi_mytaskclick(self);

end;

procedure Tfrm_MainForm.dbgrd_WvlDblClick(Sender: TObject);
begin
   GgfLogEvnt('dbgrd_WvlDblClick');
   ndelay(500);

end;

procedure Tfrm_MainForm.tbi_DelTimerClick(Sender: TObject);
var
   iTmpArcID, iTmpDocID: integer;
begin
   GgfLogEvnt('tbi_DelTimerClick');
   with dm_DB.my_q_Time do
   begin
      if (RecordCount > 0) and (FieldByName('status').AsInteger = 2) then
      begin
         Sql.Text := 'delete from sys_timer where tim_ref = ' +
            IntToStr(iGTimRef) + ' or tim_id = ' + IntToStr(iGTimRef);
         try
            Execute;
         except
            on e: Exception do
               ErrorMsg('tbi_DelTimer',
                  _('Fehler beim Entfernen eines Dokumentes aus der Wiedervorlage/Aufgaben:') +
                  e.Message, 1001, True);
         end;
         iTmpArcID := iGArcID;
         iTmpDocID := iGDocID;
         iGArcID := iGTimArcID;
         iGDocID := iGTimDocID;
         frm_MainForm.NewHistory(19, _('Aus Wiedervorlage/Aufgaben entfernt. Bearbeiter:') +
            cbx_Usr_WorkNG.Text + ' Termin: ' + DateToStr(
            StartOfTheDay(dtp_TimerNG.DateTime)) + ' Status: ' + cbx_Status.Text);
         iGArcID := iTmpArcID;
         iGDocID := iTmpDocID;
         if tbi_MyTask.Checked then
            ShowDocsKW(iGKWYear, iGKW);
         if tbi_MATask.Checked then
            ShowMATasks;
      end
      else
         BfShowMessage(_('Sie knnen nur Dokumente mit dem Status [Fertig] aus der Wiedervorlage/Aufgaben entfernen.'));
   end;
end;

procedure Tfrm_MainForm.tbi_SaveEditClick(Sender: TObject);
var
   sDatum, lshortDatum, lsshortalarm, slsqlrequest, lsalarm, lsushed: string;
   iTmpArcID, iTmpDocID, iStat, liInsID, licounter, lirecordnumber,
   litimeroptionen: integer;
   bUpdate: boolean;
begin
   if fbtimcheck then
      exit;
   if gbArcHandling then
   	exit;

   if gbDocMove or
   	gbLgrArcSet or
      gbArchivChange or
      gbSaveDoc or
      gbwvlcellclick then
      Exit;

   GgfLogEvnt('tbi_SaveEditClick');
   liInsID := 0;
   // DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(dtp_TimerNG.DateTime));
   DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss',
      StartOfTheDay(MFDatetimeEdit1.DateTime));
   lshortDatum := DateToStr(StartOfTheDay(now));
   DateTimeToString(lsalarm, 'yyyy-mm-dd hh:nn:ss',
      (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
      dm_DB.my_q_Time.FieldByName('termin').AsDateTime) + MFDatetimeEdit1.DateTime);
   lsshortalarm := DateToStr((dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
      dm_DB.my_q_Time.FieldByName('termin').AsDateTime) + MFDatetimeEdit1.DateTime);
   bUpdate := False;
   lirecordnumber := dm_DB.my_q_Time.RecNo;
   litimeroptionen := 0;

   if dbgrd_wvl.selectedrows.Count = 1 then
   begin
      if cbx_rts.Checked then
      begin
         litimeroptionen := 2;
      end;
      with dm_DB.my_cmd do
      begin
         // wenn mehr als Null elemente fuer die Wiedervorlage vorgemerkt sind
         if dm_DB.my_q_Time.RecordCount > 0 then
            // Recordcount enthaelt die Anzahl der Wiedervorlagen
         begin
            iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
            // den Status der WVL aus DB lesen
            // Status 0 = offen, 1 = in Bearbeitung , 2 = fertig
            // todo test if this is really meaning fulll (if refresh does work!)
            dm_DB.my_q_Time.SQLRefresh.Clear;
            // set request so it returns just 1 entry!
            slsqlrequest :=
               'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, arc_tblname, doc_id,'
               + ' doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' +
               ' erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer ' +
               ' left join sys_arc using(arc_id) ' +
               ' left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
               ' left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
               ' where tim_id = ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
            dm_DB.my_q_Time.SQLRefresh.Add(slsqlrequest);

            dm_DB.my_q_Time.RefreshRecord;
            if iStat <> dm_DB.my_q_Time.FieldByName('status').AsInteger then
            begin
               BfShowMessage(_('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.')
                  + #13 + _('Bitte berprfen Sie den neuen Status!') +
                  #13 + #13 + _('Es erfolgte keine nderung an der Wiedervorlage/Aufgaben.'));
               FillControls(False);
               exit;
            end;
            // todo misshandling of dm_db.my_q_tmp_CreStatus!!!
            // rename it???
            slsqlrequest :=
               'Select Sql_No_cache  if(grp_name is not null, grp_name, usr_name) as usr_name' +
               ' from sys_timer left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
               ' left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
               ' where tim_id = ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
            dm_db.my_q_tmp_CreStatus.sql.Text := slsqlrequest;
            dm_db.my_q_tmp_CreStatus.Execute;

            if cbx_Usr_WorkNG.Text <> dm_DB.my_q_tmp_CreStatus.FieldByName(
               'usr_name').AsString then
            begin
               // single user
               if cbx_Usr_WorkNG.Items.Items[cbx_Usr_WorkNG.ItemIndex].ImageIndex
                  = 8 then
               begin
                  if ((cbx_rts.Checked) and
                     ((dm_DB.my_q_Time.FieldByName('optionen').AsInteger and 2) = 2)) then
                  begin
                     //save some information about this wvl
                     Sql.Text :=
                        'insert into sys_timerhist (tim_id, tim_ref,usr_id_shed, optionen) values '
                        + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('optionen').AsString + ')';
                     Execute;
                     lsushed := IntToStr(iGusrid);
                  end
                  else
                  begin
                     lsushed := dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString;
                  end;

                  if gbhasctrlwvl then
                  begin
                     Sql.Text :=
                        'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                        'usr_id_shed, info) values '
                        + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                        ',' + IntToStr(integer(cbx_Usr_WorkNG.Items.Objects[cbx_Usr_WorkNG.ItemIndex])) +
                        ',' + IntToStr(iGusrid) +
                        ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                     try
                        Execute;
                     except on e: Exception do
                        begin
                        end;
                     end;
                  end;
                  Sql.Text :=
                     'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:usr_id_work, status = :status ,'
                     + ' grp_id = :grp_id, erinnerung = :erinnerung, optionen = :optionen, '
                     + ' usr_id_shed = :usr_id_shed where tim_id=' +
                     dm_DB.my_q_Time.FieldByName('tim_id').AsString;
                  dm_DB.my_Cmd.ParamByName('grp_id').AsString := '0';
                  dm_DB.my_Cmd.ParamByName('status').AsString := '0';
                  dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                  dm_DB.my_Cmd.ParamByName('termin').AsString := sDatum;
                  dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                     (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                     dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                     MFDatetimeEdit1.DateTime;
                  dm_DB.my_Cmd.ParamByName('OPTIONEN').AsInteger := litimeroptionen;
                  dm_DB.my_Cmd.ParamByName('usr_id_shed').AsString := lsushed;
                  dm_DB.my_Cmd.ParamByName('usr_id_work').AsInteger :=
                     integer(cbx_Usr_WorkNG.Items.Objects[cbx_Usr_WorkNG.ItemIndex]);

                  Execute;
                  if
                  ((dm_DB.my_q_Time.FieldByName('optionen').AsInteger and 8) = 0)
                     and
                     ((dm_DB.my_q_Time.FieldByName('optionen').AsInteger and 1) = 0)
                  then
                  begin
                     // delete other tim ids
                     Sql.Text := ' delete from sys_timer where tim_ref = ' + dm_DB.my_q_Time.FieldByName('tim_ref').Asstring +
                        '  and tim_id <> ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
                     Execute;
                     Sql.Text := 'update sys_timer set grp_id = 0 where tim_ref = ' + dm_DB.my_q_Time.FieldByName('tim_ref').Asstring;
                     Execute;
                  end;
                  bUpdate := True;
               end
               else
               begin
                  if ((dm_DB.my_q_Time.FieldByName('optionen').AsInteger or 2) = 2) then
                  begin
                     BfShowMessage(_('Hinweis!') + #13 +
                        _('Sie knnen nicht eine Wiedervorlage/Aufgabe an eine Gruppe weiterdelegieren,') + ' ' +
                        _('wenn Sie mit der Option "Nach Erledigung zurck" erstellt wurde.') + #13 +
                        _('Bitte, erstellen Sie zu diesen Zweck eine neue Wiedervorlage/Aufgabe.'));
                     exit;
                  end;
                  if not TMPSQL(
                     'select * from sys_grpusr as a left join sys_grp as b on(b.grp_id= a.grp_id) where grp_name ='
                     + #39 + cbx_Usr_WorkNG.Text + #39) then
                  begin
                     //problem bei der gruppe abfrage
                     exit;
                  end;

                  if dm_db.my_q_Tmp.RecordCount = 0 then
                  begin
                     exit;
                  end;
                  dm_db.my_q_Tmp.First;
                  for licounter := 0 to dm_db.my_q_Tmp.RecordCount - 1 do
                  begin
                     // create an entry for each  person of the group
                     //insert infos
                     dm_DB.my_Cmd.SQL.Text :=
                        'Insert into sys_timer (grp_id, arc_id, doc_id, doc_Titel, tim_ref, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info, status) ' + 'Values (:grpid, :arcid, :docid, :doctitel, :timref, :uwork, :ushed, :termin, :alarm, :optionen, :info, :status)';
                     dm_DB.my_Cmd.ParamByName('grpid').AsString :=
                        dm_db.my_q_Tmp.FieldByName('grp_id').AsString;
                     dm_DB.my_Cmd.ParamByName('arcid').AsInteger :=
                        dm_DB.my_q_Time.FieldByName('arc_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('docid').AsInteger :=
                        dm_DB.my_q_Time.FieldByName('doc_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                        dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                     dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                        dm_db.my_q_Tmp.FieldByName('usr_id').AsInteger;
                     dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGUsrID;
                     dm_DB.my_Cmd.ParamByName('termin').AsDateTime := MFDatetimeEdit1.DateTime;

                     // alarm changes like sdatum but relatively
                     dm_DB.my_Cmd.ParamByName('alarm').AsDateTime :=
                        (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                        dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                        MFDatetimeEdit1.DateTime;
                     //single user
                     dm_DB.my_Cmd.ParamByName('optionen').AsInteger :=
                        litimeroptionen or dm_DB.my_q_Time.FieldByName('optionen').AsInteger;

                     dm_DB.my_Cmd.ParamByName('info').AsString := memo_Info.Text;
                     // status should be changed also in the database and not only in cbx_status.
                     dm_DB.my_Cmd.ParamByName('status').AsString := '0';
                     dm_DB.my_Cmd.ParamByName('timref').AsString :=
                        dm_DB.my_q_Time.FieldByName('tim_Ref').AsString;

                     dm_DB.my_Cmd.Execute;
                     if licounter = 0 then
                     begin
                        liInsID := dm_DB.my_Cmd.InsertId;
                     end;
                     dm_db.my_q_Tmp.Next;
                  end;
                  // delete time_ref for the other group
                  Sql.Text :=
                     'delete from sys_timer where grp_id <> ' +
                     dm_db.my_q_Tmp.FieldByName('grp_id').AsString +
                     ' and tim_ref = ' + IntToStr(iGTimRef) + ' and tim_id < ' +
                     IntToStr(liInsID);
                  Execute;
                  bUpdate := True;
               end;
            end
            else
               // just update dont set to others users.
            begin
               if tbi_MyTask.Checked then
               begin
                  // only for this tim_id
                  Sql.Text := 'Update sys_timer set Termin = ' + #39 +
                     sDatum + #39 + ', info = ' + #39 + memo_Info.Text +
                     #39 + ', erinnerung = ' + #39 + lsalarm + #39 +
                     ' where tim_id = ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
                  Execute;
                  bUpdate := True;
               end
               else
               begin
                  // change the tim_ref infos.
                  Sql.Text := 'Update sys_timer set Termin = ' + #39 +
                     sDatum + #39 + ', info = ' + #39 + memo_Info.Text +
                     #39 + ', erinnerung = ' + #39 + lsalarm + #39 +
                     ' where tim_ref = ' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString;
                  Execute;
                  bUpdate := True;
               end;
            end;
         end;
         // nur Updaten wenn auch wirklich ein SQL Update erfolgt ist
         if bUpdate then
         begin
            //tbi_ShowDocClick(self);
            if cbx_Status.ItemIndex = 2 then
               CancelStatus;
            iTmpArcID := iGArcID;
            iTmpDocID := iGDocID;
            iGArcID := iGTimArcID;
            iGDocID := iGTimDocID;
            frm_MainForm.NewHistory(18,
               _('Wiedervorlage/Aufgaben') + ' ' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
               ' ' + _('gendert. Bearbeiter:') + ' ' + cbx_Usr_WorkNG.Text +
               ' ' + _('Termin:') + ' ' + lshortDatum + ' ' + _('Status:') + ' ' + cbx_Status.Text);
            iGArcID := iTmpArcID;
            iGDocID := iTmpDocID;
            if tbi_MyTask.Checked then
               ShowDocsKW(iGKWYear, iGKW);
            if tbi_MATask.Checked then
               ShowMATasks;

            // reselect the old
            dm_DB.my_q_Time.RecNo := lirecordnumber;
            FillCOntrols(False);
            GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.tbi_SaveEditClick');
            tbi_ShowDocClick(self);
            wvlhasfocus := True;
            wvlshowbuttons(True);
            // make this one be selected and marked!
            dbgrd_wvl.SelectedRows.CurrentRowSelected := True;
            // commented out so wvl dont jump (loose selection and hide and show)

            RefreshStatus;
         end;
      end;
   end
   else
   begin
      BfShowMessage(_('Bitte whlen Sie eine Wiedervorlage/Aufgabe.'));
   end;
end;

// CANCEl STATUS
// Wfend Datei erzeugen
procedure Tfrm_MainForm.CancelStatus;
var
   sTblName, sFileName, sTmpField, msec: string;

   xComp: TComponent;
   icount, shiftamount: integer;

begin
   GgfLogEvnt('CancelStatus');

   if frm_MainForm.TmpSQL('Select Sql_No_cache * from sys_arc where arc_id = ' +
      IntToStr(iGTimArcID)) then
   begin
      if dm_DB.my_q_Tmp.RecordCount > 0 then
      begin
         sTblName := dm_DB.my_q_Tmp.FieldByName('arc_tblname').AsString;

         dm_DB.my_q_Tmp.Close;
      end
      else
         sTblName := '';
   end;

   if sTblName <> '' then
   begin
      with dm_DB.my_cmd do
      begin
         try
            try
               TmpSQL('select * from sys_timer where status < 2 and doc_id = ' +
                  IntToStr(iGTimDocID) + ' and arc_id =' + IntToStr(iGTimArcID));
               if dm_DB.my_q_Tmp.RecordCount = 0 then
               begin
                  SQL.Text := 'Update arc_' + sTblName +
                     ' set doc_state = (doc_state | 1) ^ 1 where doc_id = ' +
                     IntToStr(iGTimDocID);
                  Execute;
               end;
            except
               on e: Exception do
               begin
                  ErrorMsg('CancelStatus',
                     _('Fehler beim ndern des Dokumentenstatus:') +
                     e.Message, 1006,
                     True);
               end;
            end;
            try
            except
               on e: Exception do
                  ErrorMsg('CancelStatus',
                     _('Fehler beim ndern des Dokumentenstatus:') +
                     e.Message, 1006,
                     True);
            end;
         finally

         end;
      end;
   end;
end;

procedure Tfrm_MainForm.tbi_SetState_OpenClick(Sender: TObject); //[2327]
var
   iTmpDocID, iTmpArcID, iStat, iStatNew, iOpt: integer;
   sTmpTblName: string;
begin
   GgfLogEvnt('tbi_SetState_OpenClick');
   if fbtimcheck then
      exit;
   if gbArcHandling then
   	exit;

   if dm_DB.my_q_Time.RecordCount > 0 then
   begin
      dm_DB.my_q_Time.SQLRefresh.Clear;

      // set the refresh query string
      // it is too complicated    http://www.crlab.com/forums/viewtopic.php?p=28601#28601
      // for refreshrecord alone
      dm_DB.my_q_Time.SQLRefresh.Add(
         'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin,' +
         ' sys_arc.arc_id, arc_name, arc_tblname, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as '
         + 'usr_name,erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer left join sys_arc using(arc_id)'
         + ' left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work left join sys_grp on sys_grp.grp_id = '
         + 'sys_timer.grp_id where (usr_id_work = ' + IntToStr(iGUsrID) +
         ' or usr_id_shed = ' + IntToStr(iGUsrID) + ') and tim_id = ' +
         IntToStr(dm_DB.my_q_Time.FieldByName('tim_id').AsInteger) +
         ' group by tim_ref order by termin, tim_id');
      //end;

      iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      // todo this should be in!!!
      dm_DB.my_q_Time.RefreshRecord;
      iStatNew := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      if iStat <> iStatNew then
      begin
         BfShowMessage(_('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.')
            + #13 + _('Bitte berprfen Sie den neuen Status!') +
            #13 + #13 + _('Es erfolgte keine nderung an der Wiedervorlage/Aufgaben.'));
         FillControls(False);
         exit;
      end;

      tbx_ciOffen.color := cllime;
      tbx_ciInArbeit.color := clGray;
      tbx_cifertig.color := clGray;

      with dm_DB.my_cmd do
      begin
         iOpt := dm_DB.my_q_Time.FieldByName('Optionen').AsInteger;
         // check if gemein- or einsam
         // if gemeinsam every one must set the status
         // if einsam one sets for all!
         //set  the tim_ref or tim_id to status 0 depending on optionen

         if ((iOpt and 1) = 1) then
            Sql.Text :=
               'Update sys_timer set status = 0 where tim_id = ' +
               IntToStr(iGTimID)
         else
            Sql.Text :=
               'Update sys_timer set status = 0 where tim_ref = ' +
               IntToStr(iGTimRef);

         Execute;
      end;
      iTmpArcID := iGArcID;
      iTmpDocID := iGDocID;
      iGArcID := iGTimArcID;
      iGDocID := iGTimDocID;
      // what does it? comment...
      frm_MainForm.TmpSQL('Select Sql_No_cache * from sys_arc where arc_ID = ' +
         IntToStr(iGArcID));
      if dm_DB.my_q_Tmp.RecordCount <> 0 then
      begin
         sTmpTblName := sIArcName;
         sIArcName := dm_DB.my_q_Tmp.FieldByName('arc_tblName').AsString;
         frm_MainForm.NewHistory(18, _('Wiedervorlage/Aufgaben') + ' ' + dm_DB.my_q_Time.FieldByName(
            'tim_ref').AsString + ' ' + _('gendert. Status: offen'));
         dm_DB.my_q_Tmp.Close;
         sIArcName := sTmpTblName;
      end;
      iGArcID := iTmpArcID;
      iGDocID := iTmpDocID;
   end;

   try
      dm_DB.my_q_time.RefreshRecord;
   except;
   end;
   RefreshStatus;

end;

//  Wiedervorlage Bearbeitungsstatus umschalten
procedure Tfrm_MainForm.tbi_SetState_WorkClick(Sender: TObject); //[2327]
var
   iTmpDocID, iTmpArcID, iStat, iStatNew, iStatus, iOpt: integer;
   sTmpTblName: string;
begin
   GgfLogEvnt('tbi_SetState_WorkClick');
   iStatus := 0;

   if fbtimcheck then
      exit;
   if gbArcHandling then
   	exit;

   if dm_DB.my_q_Time.RecordCount > 0 then
   begin
      dm_DB.my_q_Time.SQLRefresh.Clear;
      if tbi_MATask.Checked then
      begin
         if MessageDlg(_('Mchten Sie den Status des Dokuments mit der WvlID') + ' ' +
            dm_DB.my_q_Time.FieldByName('tim_id').AsString +
            ' ' + _('des Bearbeiters') + ' ' + dm_DB.my_q_Time.FieldByName(
            'usr_name').AsString + ' ' + _('auf "in Arbeit" setzen?'), mtConfirmation,
            [mbYes, mbNo], 0) = mrNo then
            exit;
         // set the refresh query string
         // it is too complicated    http://www.crlab.com/forums/viewtopic.php?p=28601#28601
         // for refreshrecord alone
      end;
      iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      dm_DB.my_q_Time.SQLRefresh.Add(
         'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin,' +
         ' sys_arc.arc_id, arc_name, arc_tblname, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as '
         + 'usr_name,erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer left join sys_arc using(arc_id)'
         + ' left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work left join sys_grp on sys_grp.grp_id = '
         + 'sys_timer.grp_id where (usr_id_work = ' + IntToStr(iGUsrID) +
         ' or usr_id_shed = ' + IntToStr(iGUsrID) + ') and tim_id = ' +
         IntToStr(dm_DB.my_q_Time.FieldByName('tim_id').AsInteger) +
         ' group by tim_ref order by termin, tim_id');
      // todo this should be in!!!
      dm_DB.my_q_Time.RefreshRecord;

      iStatNew := dm_DB.my_q_Time.FieldByName('status').AsInteger;
      if iStat <> iStatNew then
      begin
         BfShowMessage(_('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.')
            + #13 + _('Bitte berprfen Sie den neuen Status!') +
            #13 + #13 + _('Es erfolgte keine nderung an der Wiedervorlage/Aufgaben.'));
         FillControls(False);
         exit;
      end;

      with dm_DB.my_cmd do
      begin
         iOpt := dm_DB.my_q_Time.FieldByName('Optionen').AsInteger;
         // check if gemein- or einsam
         // if gemeinsam every one must set the status
         // if einsam one sets for all!
         //set  the tim_ref or tim_id to status 0 depending on optionen

         if ((iOpt and 1) = 1) then
            Sql.Text :=
               'Update sys_timer set status = 1 where tim_id = ' +
               IntToStr(iGTimID)
         else
            Sql.Text :=
               'Update sys_timer set status = 1 where tim_ref = ' +
               IntToStr(iGTimRef);

         Execute;
      end;

      if (iStatus and 1) = 1 then
         NewHistory(22, _('Dokumentenstatus') + ' ' + IntToStr(iGTimRef) +
            ' ' + _('gendert') + ' [' + _('in Bearbeitung') + ']');

      iTmpArcID := iGArcID;
      iTmpDocID := iGDocID;
      iGArcID := iGTimArcID;
      iGDocID := iGTimDocID;

      frm_MainForm.TmpSQL('Select Sql_No_cache * from sys_arc where arc_ID = ' +
         IntToStr(iGArcID));
      if dm_DB.my_q_Tmp.RecordCount <> 0 then
      begin
         sTmpTblName := sIArcName;
         sIArcName := dm_DB.my_q_Tmp.FieldByName('arc_tblName').AsString;
         frm_MainForm.NewHistory(18,
            _('Wiedervorlage/Aufgaben') + ' ' + IntToStr(iGTimRef) + ' ' + _('gendert. Status: ') + '' + _('in Bearbeitung'));
         dm_DB.my_q_Tmp.Close;
         sIArcName := sTmpTblName;
      end;
      iGArcID := iTmpArcID;
      iGDocID := iTmpDocID;

      try
         dm_DB.my_q_time.RefreshRecord;
      except
         on e: Exception do
            logevnt(
               'Fehler beim Entfernen refresh record in  tbi_SetState_WorkClick:' +
               e.Message);
      end;
      RefreshStatus;
   end;
end;

// Wiedervorlage auf Fertig setzen
procedure Tfrm_MainForm.tbi_SetState_DoneClick(Sender: TObject); //[2327]
var
   hd: HWND;
   iTmpDocID, iTmpArcID, iStat, iStatNew, iOpt, lirecordnumber, listatus,
   licounter, lierr: integer;
   lsSql, lsTimId, lsUsr, lsWhereUsr,
   lsshedid, lsworkid, lsstatus, lsvertrshed, lsvertrwrk: string;
   lbupsta, lbrts, lbtim_voransicht: boolean;
begin
   if fbtimcheck then
      exit;
   if gbArcHandling then
   	exit;
   if gbSaveDoc then
   	Exit;

   GgfLogEvnt('tbi_SetState_DoneClick');
   lbtim_voransicht := false;
   gbSaveDoc := True;
   try
      lierr := 0;
      if gbArcHandling or gbsettingdone or gbansichtlesen or (not HPTorOpen)
         or (gbsettingdone) or (dm_DB.my_q_arc.recordcount = 0) or
         handleparamaktiv or gbsearching
      then
      begin
         GgfLogEvnt('leaving gbArcHandling tbi_SetState_DoneClick');
         exit;
      end;
      try
//         lbtim_voransicht := dm_MainForm2.tim_voransicht.enabled;
         gbsettingdone := true;
         lbupsta := True;
         // must check if a rts was sent to a not rts and back:
         // rts1 -> rts2 -> fertig => rts2
         // rts1 -> nrts1 -> fertig => rts1
         // m.frey  wer oder was ist eine "rts"? rts = "return to sender" / "Nach Erledigung zurck"
         lbrts := False;

         // loesche den inhalt des Infofeldes falls keine Wiedervorlage mehr angezeigt wird
         lirecordnumber := dm_DB.my_q_Time.RecNo;
         try
            // Wenn die Wiedervorlageliste mindestens ein Element hat, dann...
            if dm_DB.my_q_Time.RecordCount > 0 then
            begin
               if iGTimRec <> dm_DB.my_q_Time.RecNo then
               begin
                  dm_DB.my_q_Time.RecNo := iGTimRec;
                  dbgrd_wvl.SelectedRows.CurrentRowSelected := true;
               end;
               if tbi_MATask.Checked then
               begin
                  if dm_DB.my_q_Time.FieldByName('grp_id').asinteger <> 0 then
                  begin
                     BfShowMessage(_('Abbrechen der Gruppenwiedervorlage wird noch nicht untersttzt.'));
                     gbsettingdone := false;
                     GgfLogEvnt('leaving tbi_SetState_DoneClick Gruppenwiedervorlage');
                     exit;
                  end;
                  if MessageDlg(_('Mchten Sie den Status des Dokuments mit der WvlID') + ' ' +
                     dm_DB.my_q_Time.FieldByName('tim_id').AsString + ' ' + _('des Bearbeiters') + ' ' +
                     dm_DB.my_q_Time.FieldByName('usr_name').AsString +
                     ' ' + _('auf "fertig" setzen?'), mtConfirmation, [mbYes, mbNo], 0) = mrNo then
                  begin
                     gbsettingdone := false;
                     GgfLogEvnt('leaving tbi_SetState_DoneClick auf "fertig" setzen');
                     exit;
                  end;
               end;

               lierr := 1;
               lsTimId := dm_DB.my_q_Time.FieldByName('tim_id').AsString;

               lsUsr := IntToStr(iGUsrID);

               lsWhereUsr := '(usr_id_work = ' + lsUsr + ' or usr_id_shed = ' + lsUsr + ')'; //3.6.0.11 [2535]
               lsSql :=
                  'Select Sql_No_cache' +
                  ' usr_id_work, usr_id_shed, tim_id, tim_ref, sys_timer.grp_id, termin,' +
                  ' sys_arc.arc_id, arc_name, arc_tblname, doc_id, doc_titel, if(grp_name is not null, grp_name, usr_name) as '
                  + 'usr_name,erinnerung, info, status, optionen '
                  + 'from sys_timer '
                  + 'left join sys_arc using(arc_id) '
                  + 'left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work '
                  + 'left join sys_grp on sys_grp.grp_id = sys_timer.grp_id '
                  + 'where '
                  + lsWhereUsr  //3.6.0.10 [2535]
                  + ' and tim_id = ' + lsTimId
                  + ' group by tim_ref order by termin, tim_id';
               dm_DB.my_q_Time.SQLRefresh.text := lsSql;

               iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
               lierr := 2;
               // lese den Status des Datensatzes der Wiedervorlage aus.
               dm_DB.my_q_Time.RefreshRecord; // aktualisieren die Query
               iStatNew := dm_DB.my_q_Time.FieldByName('status').AsInteger;
               // lese den Status des Datensatzes erneut aus
               if iStat <> iStatNew then
               begin
                  lierr := 3;
                  BfShowMessage(_('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.')
                     + #13 + _('Bitte berprfen Sie den neuen Status!') + #13 +
                     #13 + _('Es erfolgte keine nderung an der Wiedervorlage/Aufgaben.'));
                  FillControls(False);
                  gbsettingdone := false;
                  GgfLogEvnt('leaving tbi_SetState_DoneClick wurde bereits');
                  exit;
               end;
               if tbi_MyTask.Checked then
               begin
                  if btn_SaveDoc.Enabled then
                  begin
                     if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
                        #13 + _('Mchten Sie die nderungen speichern?'),
                        true) = mrYes then
                     begin
                        lierr := 4;
                        tbi_VSaveDocClick(self);
                     end
                     else
                     begin
                        GHasNotBeenSavedAfterModify := false;
                        fgchangedvoransicht := False;
                        fgchangedvoransichttif := False;
                        gtmpiStatus := gotmpistatus;
                        btn_SaveDoc.Enabled := false;
                        tbi_VSaveDoc.Enabled := false;
                     end;
                  end;
               end;
               lierr := 5;
               if Gbwfcancel then
               begin
                  lsstatus := _('abgebrochen');
               end
               else
               begin
                  lsstatus := _('fertig');
               end;

               with dm_DB.my_cmd do
               begin
                  iOpt := 0;
                  iOpt := dm_DB.my_q_Time.FieldByName('Optionen').AsInteger;
                  // check if gemein- or einsam
                  // if gemeinsam every one must set the status
                  // if einsam one sets for all!
                  //check first for sys_timerhist to see if there is any hist_id with this tim_id
                  lierr := 6;
                  dm_DB.my_q_tmp.sql.Text :=
                     'select * from sys_timerhist where tim_ref = ' +
                     IntToStr(iGTimRef) + '  order by hist_id desc ';
                  dm_DB.my_q_tmp.Execute;
                  //is there any?
                  lierr := 7;
                  if dm_DB.my_q_tmp.RecordCount > 0 then
                  begin
                     lierr := 8;
                     lsshedid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                     while (dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString
                           = dm_DB.my_q_Time.FieldByName(
                           'usr_id_shed').AsString) and
                        ((iopt and 2) = 2) do
                     begin
                        // take the   shed_id
                        lsworkid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                        sql.Text := 'delete from sys_timerhist where hist_id = ' +
                           dm_DB.my_q_tmp.FieldByName('hist_id').AsString;
                        Execute;
                        dm_db.my_q_tmp.Refresh;
                        if dm_DB.my_q_tmp.RecordCount > 0 then
                        begin
                           iOpt := dm_DB.my_q_tmp.FieldByName('Optionen').AsInteger;
                           lsshedid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                        end;
                        lierr := 9;
                     end;
                  end;
                  if dm_DB.my_q_tmp.RecordCount > 0 then
                  begin
                     lierr := 10;
                     // this is the case if the wvl was 2 or more times sent to other ppl.
                     //get the information back from sys_timerhist and set it.
                     dm_DB.my_q_tmp.First;
                     if ((iopt and 2) = 2) then
                     begin
                        lierr := 11;

                        if lsvertrshed = '' then
                        begin
                           lsvertrshed := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                        end;
                        if lsvertrwrk = '' then
                        begin
                           lsvertrwrk := dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString;
                        end;
                        Sql.Text :=
                           'Update sys_timer set status = 0, usr_id_shed = ' +
                           lsvertrshed +
                           ', usr_id_work =' + lsvertrwrk + ',grp_id = 0, optionen = ' +
                           dm_DB.my_q_tmp.FieldByName('optionen').AsString +
                           ',  info = ' + #39 + 'Erledigt (' + lsstatus + ') von ' + sGUsrName +
                           ':' + dm_DB.my_q_Time.FieldByName('info').AsString +
                           #39 + ' where tim_id = ' + IntToStr(iGTimID);
                        Execute;
                        //   dm_DB.my_q_tmp.Delete;
                        //delete group
                        sql.Text := 'delete from sys_timer where tim_ref = ' +
                           dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and ' +
                           'tim_id <> ' + IntToStr(iGTimID);
                        Execute;
                        // delete entry if needed from sys_ctlrtimer
                        sql.Text := 'delete from sys_ctlrtimer where usr_id_shed = ' +
                           dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString + ' and ' +
                           'tim_ref = ' + IntToStr(iGTimRef);
                        Execute;
                        // delete this entry from sys_timerhist
                        sql.Text := 'delete from sys_timerhist where hist_id = ' +
                           dm_DB.my_q_tmp.FieldByName('hist_id').AsString;
                     end
                     else
                     begin
                        lierr := 12;
                        //must jump one worker in the chain
                        licounter := 0;
                        while ((dm_DB.my_q_tmp.FieldByName('optionen').AsInteger and
                              2) <> 2) and (not dm_DB.my_q_tmp.eof) do
                        begin
                           // take the   shed_id
                           lsworkid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                           dm_DB.my_q_tmp.Next;
                           lsshedid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                           licounter := licounter + 1;
                        end;
                        // didnt get in the main part of the loop!
                        if (licounter = 0) and ((dm_DB.my_q_tmp.FieldByName('optionen').AsInteger and
                           2) <> 2) then
                        begin
                           lsshedid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                        end
                        else
                        if
                        ((dm_DB.my_q_tmp.FieldByName('optionen').AsInteger and
                           2) = 2) and (not dm_DB.my_q_tmp.eof) then
                        begin
                           //probably only one entry
                           lsworkid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                           lsshedid := dm_DB.my_q_tmp.FieldByName('usr_id_shed').AsString;
                        end;
                        lierr := 13;
                        //delete group
                        sql.Text := 'delete from sys_timer where tim_ref = ' +
                           dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and ' +
                           'tim_id <> ' + IntToStr(iGTimID);
                        Execute;

                        if lsvertrshed = '' then
                        begin
                           lsvertrshed := lsshedid;
                        end;

                        if lsvertrwrk = '' then
                        begin
                           lsvertrwrk := lsworkid;
                        end;
                        Sql.Text :=
                           'Update sys_timer set status = 0, usr_id_shed = ' +
                           lsvertrshed + ', usr_id_work =' + lsvertrwrk +
                           ', optionen = ' + dm_DB.my_q_tmp.FieldByName('optionen').AsString +
                           ',  info = ' + #39 + 'Erledigt (' + lsstatus + ') von ' + sGUsrName +
                           ':' + dm_DB.my_q_Time.FieldByName('info').AsString +
                           #39 + ' where tim_id = ' + IntToStr(iGTimID);
                        iopt := dm_DB.my_q_tmp.FieldByName('optionen').AsInteger;
                        Execute;
                        sql.Text := 'delete from sys_ctlrtimer where usr_id_shed = ' +
                           lsworkid + ' and ' +
                           'tim_ref = ' + IntToStr(iGTimRef);
                        Execute;
                        // delete this entry from sys_timerhist  and all older (the list is sorted desc)
                        sql.Text := 'delete from sys_timerhist where hist_id >= ' +
                           dm_DB.my_q_tmp.FieldByName('hist_id').AsString +
                           ' and tim_ref = ' + IntToStr(iGTimRef);
                        lierr := 14;
                     end;
                     lbupsta := False;
                  end
                  else
                  begin
                     //todo: fix it there is still to much possibilities which were exclused
                     // like ipot = 3!!!
                     // could be also iOpt and 3 <> 0 ! but for better reading i let so.
                     lierr := 15;
                     if (((iOpt and 1) = 1) or ((iOpt and 2) = 2)) then
                     begin
                        if ((iOpt and 1) = 1) then
                        begin
                           Sql.Text :=
                              'Update sys_timer set status = 2 where tim_id = ' +
                              IntToStr(iGTimID);
                        end;
                        // rts
                        if ((iOpt and 2) = 2) then
                        begin
                           //last wvl? if the user click now fertig then it should be done!
                           iOpt := iopt and (not 2);
                           if ((iOpt and 1) = 0) then
                           begin
                              //delete group
                              sql.Text := 'delete from sys_timer where tim_ref = ' +
                                 dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and ' +
                                 'tim_id <> ' + IntToStr(iGTimID);
                              Execute;
                              // delete entry if needed from sys_ctlrtimer
                              sql.Text := 'delete from sys_ctlrtimer where usr_id_shed = ' +
                                 dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString + ' and ' +
                                 'tim_ref = ' + IntToStr(iGTimRef);
                              Execute;
                           end;
                           lierr := 16;
                           if dm_DB.my_q_Time.FieldByName('usr_id_work').asinteger =
                              dm_DB.my_q_Time.FieldByName('usr_id_shed').asinteger then
                           begin
                              Sql.Text :=
                                 'Update sys_timer set status = 2 where tim_id = ' +
                                 IntToStr(iGTimID);
                           end
                           else
                           begin

                              if lsvertrshed = '' then
                              begin
                                 lsvertrshed := dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString;
                              end;
                              Sql.Text :=
                                 'Update sys_timer set status = 0,  usr_id_work=' +
                                 lsvertrshed +
                                 ',  info = ' + #39 + 'Erledigt (' + lsstatus + ') von ' + sGUsrName +
                                 ':' + dm_DB.my_q_Time.FieldByName('info').AsString +
                                 #39 + ', optionen = ' + #39 + IntToStr(iopt) +
                                 #39' where  tim_id = ' + IntToStr(iGTimID);
                              lbupsta := False;
                           end;
                        end;
                        lierr := 17;
                     end
                     else
                     begin
                        if lbrts then
                        begin
                        end
                        else
                        begin
                           Sql.Text :=
                              'Update sys_timer set status = 2 where tim_ref = ' +
                              IntToStr(iGTimRef);
                        end;
                     end;
                  end;

                  Execute;
                  lierr := 18;
                  // iskywalker20070613 hope that     iGTimArcID uisnt need for anything really important...
                  //not needed since status set all, the first bit of optionen should be set
                  // in a check box (gemeinsam, einsam)
                  frm_MainForm.NewHistory(18,
                     _('Wiedervorlage/Aufgaben') + ' ' + IntToStr(iGTimRef) + ' ' + _('von Benutzer') + ' ' +
                     sGUsrName + ' ' + _('gendert. Status:') + ' ' + lsstatus);
                  // iopt was maybe reset, hope this is right.
                  if ((iOpt and 2) = 2) then
                  begin
                     // must check if yr-> nr-> o !!!
                     // this case checks for yr-> yr-> o .
                     dm_DB.my_q_tmp.Sql.Text :=
                        ' select * from sys_usr where usr_id=' + lsvertrshed;
                     dm_DB.my_q_tmp.Execute;

                     frm_MainForm.NewHistory(23,
                        _('Dokument von Benutzer') + ' ' + sGUsrName + ' ' + _('auf Wiedervorlage/Aufgaben von Benutzer') + ' ' +
                        dm_DB.my_q_tmp.FieldByName('usr_name').AsString +
                        ' ' + _('gelegt. Status: fertig'));
                  end;
               end;
               lierr := 19;
               //check if parallele workflows is active and if je (jeder einzelnen)
               if ((iOpt and 1) = 1) then
               begin
                  TmpSQL('SELECT * FROM sys_timer as a where (((Optionen &1)=1) ' +
                     ' and ( tim_id=' + IntToStr(iGTimID) +
                     ' )  and (2 = all(select status from sys_timer ' +
                     ' as b where  a.tim_ref=b.tim_ref   )))');
                  if dm_DB.my_q_Tmp.RecordCount > 0 then
                  begin
                     //all ready
                     //erzeugen der wfend datei
                     //check rts
                     //if so dont update doc_state
                     if lbupsta then
                     begin
                        CancelStatus;
                        lierr := 20;
                        TmpSQL('select * from sys_timer where status < 2 and doc_id = ' +
                           IntToStr(iGTimDocID) + ' and arc_id =' + IntToStr(iGTimArcID));
                        if dm_DB.my_q_Tmp.RecordCount = 0 then
                        begin
                           TmpSQL('select doc_state from arc_' + sIArcName +
                              ' where doc_id = ' + IntToStr(iGTimDocID));
                           listatus := dm_DB.my_q_Tmp.FieldByName('doc_state').AsInteger and (not 1);
                           dm_DB.my_cmd.sql.Text :=
                              'update arc_' + sIArcName + ' set doc_state = ' +
                              IntToStr(listatus) + ' where doc_id = ' + IntToStr(iGTimDocID);
                           dm_DB.my_cmd.Execute;
                        end;
                     end;
                     lierr := 21;
                     dm_db.my_q_arc.refreshrecord;
                     dbgrd_trefferliste.Show;
                     tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [13]');
                  end;
               end
               else
               begin
                  // one for all (efa)
                  // also single user

                  //check rts
                  //if so dont update doc_state
                  if lbupsta then
                  begin
                     CancelStatus;
                     TmpSQL('select * from sys_timer where status < 2 and doc_id = ' +
                        IntToStr(iGDocID) + ' and arc_id =' + IntToStr(iGArcID));
                     if dm_DB.my_q_Tmp.RecordCount = 0 then
                     begin
                        TmpSQL('select doc_state from arc_' + sIArcName +
                           ' where doc_id = ' + IntToStr(iGDocID));
                        listatus := dm_DB.my_q_Tmp.FieldByName('doc_state').AsInteger and (not 1);
                        dm_DB.my_cmd.sql.Text :=
                           'update arc_' + sIArcName + ' set doc_state = ' +
                           IntToStr(listatus) + '  where doc_id = ' + IntToStr(iGDocID);
                        dm_DB.my_cmd.Execute;
                     end;
                  end;

                  lierr := 22;
                  tci_InUse.Color := clteal;   GgfLogEvnt('tci_InUse.Color := clteal [14]');

                  //todo finish it!!! (returntosender) and also for  jeder einzelnen
               end;

               if tbi_MATask.Checked then
               begin
                  try
                     dm_DB.my_q_Time.RefreshRecord; // aktualisieren die Query
                  except
                     on e: Exception do
                        logevnt(
                           _('Fehler beim Entfernen refresh record in  tbi_SetState_DoneClick:') +
                           e.Message);
                  end;
               end;
               if tbi_MyTask.Checked then
               begin
                  dm_DB.my_q_Time.RecNo := lirecordnumber;

               end;
            end
            else
            begin
               memo_info.Text := '';
            end;
            if tbi_MyTask.Checked then
            begin
               dbgrd_wvl.hide;
               // refresh query
               dm_DB.my_q_Time.Refresh;
               if dm_DB.my_q_Time.recordcount < lirecordnumber then
               begin
                  dm_DB.my_q_Time.RecNo := dm_DB.my_q_Time.recordcount;
               end
               else
               begin
                  dm_DB.my_q_Time.RecNo := lirecordnumber;
               end;
               lierr := 23;
               dm_MainForm2.refreshregwvl;
               if dm_db.my_q_Arc.RecordCount = 1 then
               begin
                  wvlhasfocus := True;
                  wvlshowbuttons(True);
                  // show (e.g. draw again!)
                  if dm_DB.my_q_Time.recordcount < lirecordnumber then
                  begin
                     dbgrd_wvl.DataSource.DataSet.RecNo := dm_DB.my_q_Time.recordcount;
                  end
                  else
                  begin
                     dbgrd_wvl.DataSource.DataSet.RecNo := lirecordnumber;
                  end;
                  dbgrd_wvl.SelectedRows.Clear;
                  dbgrd_wvl.SelectedRows.CurrentRowSelected := True;
                  loadingfromwclcellclick := 1;
                  FillControls(True);
                  btn_SaveDoc.Enabled := false;
                  tbi_VSaveDoc.Enabled := false;
                  fshowwvldoc := True;
                  gbwvlcellclick := true;
   					GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.tbi_SetState_DoneClick');

                  tbi_ShowDocClick(self);

                  gbwvlcellclick := False;
                  loadingfromwclcellclick := 0;
                  dbgrd_wvl.SelectedRows.Clear;
                  dbgrd_wvl.SelectedRows.CurrentRowSelected := True;
                  wvlhasfocus := True;
                  wvlshowbuttons(True);
                  dbgrd_wvl.Show;
               end
               else
               begin
                  dm_db.my_q_Arc.refreshrecord;
                  dbgrd_wvl.SelectedRows.Clear;
                  wvlhasfocus := False;
                  wvlshowbuttons(False);
                  dbgrd_Wvl.Hide;
                  dbgrd_Wvl.Show;
               end;
               lierr := 24;
            end;
            // refreshstatus after refreshrecord
            RefreshStatus;

            // loesche den inhalt des Infofeldes falls keine Wiedervorlage mehr angezeigt wird
            if dm_DB.my_q_Time.RecordCount = 0 then
            begin
               memo_info.Text := ''; // Memo_info lschen
               tbx_ciOffen.Color := clGray;
               tbx_ciInArbeit.Color := clGray;
               tbx_cifertig.Color := clGray;
               resetanzeige;
            end;
            dm_MainForm2.fbshowhintwvl := false;
            dm_MainForm2.tim_ChkTasksTimer(self);
            dm_MainForm2.refreshregwvl;
            //make hotsearch stop blinking
            hd := FindWindow('bitfarm.hotsearch.V3', nil);
            GgfLogEvnt('tbi_SetState_DoneClick vor sendMessage');
            sendMessage(hd, WM_HOTKEY_WVL_MESSAGE, 1, 1);
            GgfLogEvnt('tbi_SetState_DoneClick nach sendMessage');
            dm_MainForm2.fbshowhintwvl := true;
            lierr := 25;

         except on e: exception do
            begin
               logevnt('Exception in tbi_SetState_DoneClick (' + inttostr(lierr) + '):' + e.message);
            end;
         end;
      finally
         gbsettingdone := false;
//         dm_MainForm2.tim_voransicht.enabled := lbtim_voransicht;
         GgfLogEvnt('leaving tbi_SetState_DoneClick end');
      end;
   finally
   	gbSaveDoc := False;
      GgfLogEvnt('tbi_SetState_DoneClick finally');
   end;
   GgfLogEvnt('tbi_SetState_DoneClick end');
end;

procedure Tfrm_MainForm.dbgrd_WvlStartDock(Sender: TObject;
   var DragObject: TDragDockObject);
begin
   GgfLogEvnt('dbgrd_WvlStartDock');

   FillControls(False);
   GgfLogEvnt('Vor tbi_ShowDocClick in dbgrd_WvlStartDock');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.dbgrd_WvlDrawColumnCell(Sender: TObject;
   const Rect: TRect; DataCol: integer; Column: TColumn; State: TGridDrawState);
var
   lcfree, lcwork, lcdone, lcurgent: TColor;
begin
   try
     // set font black for all, if different, set it later
     if ((TDBGrid(Sender).SelectedRows.CurrentRowSelected) and wvlhasfocus) then
     begin
        //  wiedervorlage
        //    TDBGrid(Sender).canvas.brush.color := clGray;
        lcfree := gclFree_Selected;
        lcwork := gclWork_Selected;
        lcdone := gclDone_Selected;
        lcurgent := gclUrgent_Selected;
        // Cursorfarbe der markierten ROW
        //        TDBGrid(sender).DefaultDrawColumnCell(rect, datacol, column, state);
        // $00ffe3e1; // Weiss-Blau
     end
     else
     begin
        lcfree := gclFree;
        lcwork := gclWork;
        lcdone := gclDone;
        lcurgent := gclUrgent;
     end;
     TDBGrid(Sender).canvas.font.Color := clblack;

     if dm_DB.my_q_Time.FieldList.IndexOf('status') <> -1 then
     begin
        // Wiedervorlage  Farben der Datenreihen
        if dm_DB.my_q_Time.RecordCount > 0 then
        begin
           case dm_DB.my_q_Time.FieldByName('status').AsInteger of
              //  Column.Field.AsInteger of
              //wei
              0:
                 TDBGrid(Sender).canvas.brush.color := lcfree;
              // Mausgrau   // Standard Farbe
              // $00E1E1FF; // Weiss-Rot
              1:
                 TDBGrid(Sender).canvas.brush.color := lcwork;
              // gelb // in arbeit
              //$00E1FCFF; // Weiss-Gelb
              // grn
              2:
                 TDBGrid(Sender).canvas.brush.color := lcdone;
              // Gruen // fertig
              //cColorHellgruen; // Weiss-Grn
           else
              TDBGrid(Sender).canvas.brush.color := clSkyblue; // mausgrau  offen
           end;
           if dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime <=
              StartOfTheDay(Date) then
           begin
              case dm_DB.my_q_Time.FieldByName('status').AsInteger of
                 //  Column.Field.AsInteger of
                 0:
                    TDBGrid(Sender).canvas.brush.color := lcurgent; // Rot
                 1:
                    TDBGrid(Sender).canvas.brush.color := lcwork; // Gelb
              end;
           end;
        end
        else
        begin
           TDBGrid(Sender).canvas.brush.color := lcfree;
        end;
     end;

     // Markierung der Reihe durch einfachen Linksklick
     // Cursor Color of WVL
     TDBGrid(Sender).DefaultDrawColumnCell(rect, datacol, column, state);
     if (Column.Title.Caption = 'Typ') (* column.Index = 0 *) and (dm_DB.my_q_Time.RecordCount > 0) then
     begin
        if dm_DB.my_q_Time.FieldByName('grp_id').AsInteger <> 0 then
           dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, Rect.Left, rect.Top, 9, True)
        else
           dm_MainForm2.il_Standard.Draw(TDBGrid(Sender).Canvas, Rect.Left, rect.Top, 8, True);
     end;
   finally

   end;
end;

procedure Tfrm_MainForm.TBX_FiltOffenClick(Sender: TObject);
begin
   GgfLogEvnt('TBX_FiltOffenClick');
   ShowMAOpen;
   GgfLogEvnt('Vor tbi_ShowDocClick in TBX_FiltOffenClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.TBX_FiltArbClick(Sender: TObject);
begin
   GgfLogEvnt('TBX_FiltArbClick');
   ShowMAWork;
   GgfLogEvnt('Vor tbi_ShowDocClick in TBX_FiltArbClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.TBX_FiltFertigClick(Sender: TObject);
begin
   GgfLogEvnt('TBX_FiltFertigClick');
   ShowMADone;
   GgfLogEvnt('Vor tbi_ShowDocClick in TBX_FiltFertigClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;

procedure Tfrm_MainForm.tbi_nuDateClick(Sender: TObject);
begin
   ShowDocsDate(MFDateTimeEdit1.Date);
end;

procedure Tfrm_MainForm.TSH_OffenMouseUp(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: integer);
begin
   GgfLogEvnt('TSH_OffenMouseUp');
   tbi_SetState_OpenClick(self);
end;

procedure Tfrm_MainForm.TSH_BearbeitungMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
   GgfLogEvnt('TSH_BearbeitungMouseUp');
   tbi_SetState_WorkClick(self);
end;

procedure Tfrm_MainForm.TSH_fertigMouseUp(Sender: TObject; Button: TMouseButton;
   Shift: TShiftState; X, Y: integer);
begin
   GgfLogEvnt('TSH_fertigMouseUp');
   tbi_SetState_DoneClick(self);
end;

//  PDF Datei local Save lokal speichern
procedure Tfrm_MainForm.tbi_VlocalSavePdfClick(Sender: TObject);
begin
   if gbSaveDoc then
      Exit;

   gbSaveDoc := True;
   try
      GgfLogEvnt('tbi_VlocalSavePdfClick');
      if dm_db.my_q_Arc.RecordCount > 0 then
      begin
         askforsave;
         tbsi_localspeichern.Images := dm_MainForm2.ilFile;
         tbsi_localspeichern.imageindex := 2;
         //  PDF Speichern
         gballasonefile := False;
         pdfbysave := True;
         oribysave := False;
         tifbysave := False;

         if frm_mainform.tbi_VShowAnno.Checked and (tbx_pubNote.Checked or
            tbx_privnote.Checked or tbi_VShowBrief.Checked) then
         begin
            mergeannotation;
         end
         else
         begin
            Do_VLokalSave;
         end;
      end;
   finally
       gbSaveDoc := False;
   end;
end;

// TIF Datei local save lokal speichern
procedure Tfrm_MainForm.tbi_VlocalSaveTifClick(Sender: TObject);
begin
	if gbSaveDoc then
      Exit;

   gbSaveDoc := True;
   try
      GgfLogEvnt('tbi_VlocalSaveTifClick');
      if dm_db.my_q_Arc.RecordCount > 0 then
      begin
         askforsave;
         tbsi_localspeichern.Images := dm_MainForm2.ilFile;
         tbsi_localspeichern.imageindex := 0;
         gballasonefile := False;
         oribysave := False;
         pdfbysave := False;
         tifbysave := True;
         if frm_mainform.tbi_VShowAnno.Checked and (tbx_pubNote.Checked or
            tbx_privnote.Checked or tbi_VShowBrief.Checked) then
            // Wenn Annotation angezeigt werden sollen dann
         begin
            mergeannotation;
         end
         else
         begin
            Do_VLokalSave;
         end;
      end;
   finally
      gbSaveDoc := False;
   end;
end;

//  Orginaldatei(?) Datei lokal speichern
procedure Tfrm_MainForm.tbi_VlocalSaveOriClick(Sender: TObject);
begin
	if gbSaveDoc then
      Exit;

   gbSaveDoc := True;
   try
      GgfLogEvnt('tbi_VlocalSaveOriClick');
      if rGDocRight.Write then
      begin
         askforsave;
         tbsi_localspeichern.Images := dm_MainForm2.ilFile;
         tbsi_localspeichern.imageindex := 1;
         gballasonefile := False;
         pdfbysave := False;
         oribysave := True;
         tifbysave := False;
         Do_VLokalSave;
      end
      else
         frm_mainform.setpanelinfo(_('Dieses Dokument drfen Sie nicht lokal Speichern.'));
   finally
       gbSaveDoc := False;
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_MainForm.tbi_DelDoneClick(Sender: TObject); //[2327]
var
   lsstring: string;
begin
   GgfLogEvnt('tbi_DelDoneClick');
   lsstring := '';
   if gbhasctrlwvl and (dm_db.my_q_Arc.FieldDefList.Find('ctrl_usr_id_work') <> nil) then
   begin
      dm_db.my_q_Time.first;
      while not dm_db.my_q_Time.Eof do
      begin
         if (not dm_db.my_q_Time.fieldbyname('ctrl_usr_id_work').IsNull)
            and (dm_db.my_q_Time.fieldbyname('usr_id_shed').asinteger = iGUsrID) then
         begin
            with dm_DB.my_cmd do
            begin
               SQL.Text := 'update sys_timer set usr_id_shed = 0 where tim_ref = ' +
                  dm_db.my_q_Time.fieldbyname('tim_ref').asstring;
               try
                  Execute;
               except
                  on e: Exception do
                     ErrorMsg('tbi_DelDone',
                        _('Fehler beim Entfernen fertiger Eintrge aus der Wiedervorlage/Aufgaben:') +
                        e.Message, 1001, True);
               end;
            end;
         end
         else
         if (not dm_db.my_q_Time.fieldbyname('ctrl_usr_id_work').IsNull) and
            (dm_db.my_q_Time.fieldbyname('ctrl_usr_id_shed').asinteger = iGUsrID) then
         begin
            with dm_DB.my_cmd do
            begin
               SQL.Text := 'delete from sys_ctlrtimer where tim_ref = ' +
                  dm_db.my_q_Time.fieldbyname('tim_ref').asstring + ' and usr_id_shed = ' +
                  inttostr(iGUsrID);
               try
                  Execute;
               except
                  on e: Exception do
                     ErrorMsg('tbi_DelDone',
                        _('Fehler beim Entfernen fertiger Eintrge aus der Wiedervorlage/Aufgaben:') +
                        e.Message, 1001, True);
               end;
            end;
         end;
         dm_db.my_q_Time.next;
      end;
      lsstring := ' and usr_id_shed <> 0';
   end;

   with dm_DB.my_cmd do
   begin
      SQL.Text :=
         'delete from sys_timer where status = 2 and (usr_id_work = :uid or usr_id_shed = :uid)' +
         lsstring;
      ParamByName('uid').AsInteger := iGUsrID;
      try
         Execute;
      except
         on e: Exception do
            ErrorMsg('tbi_DelDone',
               _('Fehler beim Entfernen fertiger Eintrge aus der Wiedervorlage/Aufgaben:') +
               e.Message, 1001, True);
      end;
      SQL.Text :=
         'delete from sys_ctlrtimer where (tim_ref in (select tim_ref from sys_timer where status = 2)) and usr_id_shed = :uid';
      ParamByName('uid').AsInteger := iGUsrID;
      try
         Execute;
      except
         on e: Exception do
            ErrorMsg('tbi_DelDone',
               _('Fehler beim Entfernen fertiger Eintrge aus der Wiedervorlage/Aufgaben:') +
               e.Message, 1001, True);
      end;
   end;
   ShowMATasks;
   refreshstatus;
end;

procedure Tfrm_MainForm.tbi_ShowOpenClick(Sender: TObject); //[2327]
begin
   GgfLogEvnt('tbi_ShowOpenClick');
   tbi_showOpen.Checked := True;
   tbi_showwork.Checked := False;
   tbi_showdone.Checked := False;

   ShowMAOpen;
   //select first row
   dbgrd_wvl.SelectedRows.CurrentRowSelected := true;
   dbgrd_WvlCellClick(nil);
   RefreshStatus;
   tbi_showOpen.Checked := False;
   tbi_showwork.Checked := False;
   tbi_showdone.Checked := False;
end;

procedure Tfrm_MainForm.tbi_ShowWorkClick(Sender: TObject); //[2327]
begin
   GgfLogEvnt('tbi_ShowWorkClick');

   tbi_showOpen.Checked := False;
   tbi_showwork.Checked := True;
   tbi_showdone.Checked := False;

   ShowMAWork;

   //select first row
   dbgrd_wvl.SelectedRows.CurrentRowSelected := true;
   dbgrd_WvlCellClick(nil);
   RefreshStatus;
   tbi_showOpen.Checked := False;
   tbi_showwork.Checked := False;
   tbi_showdone.Checked := False;
end;

procedure Tfrm_MainForm.tbi_ShowDoneClick(Sender: TObject); //[2327]
begin
   GgfLogEvnt('tbi_ShowDoneClick');

   tbi_showOpen.Checked := False;
   tbi_showwork.Checked := False;
   tbi_showdone.Checked := True;
   ShowMADone;
   //select first row
   dbgrd_wvl.SelectedRows.CurrentRowSelected := true;
   dbgrd_WvlCellClick(nil);
   RefreshStatus;

   tbi_showOpen.Checked := False;
   tbi_showwork.Checked := False;
   tbi_showdone.Checked := False;
end;

procedure Tfrm_MainForm.fra_DocLinkbtn_ShowLnkClick(Sender: TObject);
begin
   GgfLogEvnt('fra_DocLinkbtn_ShowLnkClick');
   fra_DocLink.btn_ShowLnkClick(Sender);
end;

procedure Tfrm_MainForm.fra_DocLinkbtn_LnkRenClick(Sender: TObject);
begin
   GgfLogEvnt('fra_DocLinkbtn_LnkRenClick');
   fra_DocLink.btn_LnkRenClick(Sender);
end;

procedure Tfrm_MainForm.fra_DocLinkbtn_LnkImpClick(Sender: TObject);
begin
   GgfLogEvnt('fra_DocLinkbtn_LnkImpClick');
   fra_DocLink.btn_LnkImpClick(Sender);
end;

procedure Tfrm_MainForm.fra_DocLinkbtn_LnkDelClick(Sender: TObject);
begin
   GgfLogEvnt('fra_DocLinkbtn_LnkDelClick');
   fra_DocLink.btn_LnkDelClick(Sender);
end;

procedure Tfrm_MainForm.fra_DocLinkdbgrd_LinksCellClick(Column: TColumn);
begin
   GgfLogEvnt('fra_DocLinkdbgrd_LinksCellClick');
   fra_DocLink.dbgrd_LinksCellClick(Column);
end;

procedure Tfrm_MainForm.memo_InfoDblClick(Sender: TObject);
begin
   GgfLogEvnt('memo_InfoDblClick');

   frm_editInfo.ShowModal;
end;

procedure Tfrm_MainForm.MFDateTimeEdit1Change(Sender: TObject);
begin
   GgfLogEvnt('MFDateTimeEdit1Change');
   ShowDocsDate(MFDateTimeEdit1.Date); 
end;

procedure Tfrm_MainForm.MFDateTimeEdit1Click(Sender: TObject);
var
   sStart, sEnd: string;
begin
   GgfLogEvnt('MFDateTimeEdit1Click');

   DateTimeToString(sStart, 'yyyy-mm-dd', StartOfTheDay(MFDateTimeEdit1.Date));
   DateTimeToString(sEnd, 'yyyy-mm-dd hh:nn:ss',
      EndOfTheDay(MFDateTimeEdit1.Date));
   if TimeSQL(
      'Select Sql_No_cache tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_name, arc_tblname, doc_id, doc_titel, info, status, usr_id_work, usr_id_shed from sys_timer ' +
      'left join sys_arc using(arc_id) where usr_id_work = ' +
      IntToStr(iGUsrID) + ' and status <> 2 ' + 'and Termin = ' + #39 +
      sStart + #39 + ' order by termin, tim_id') then
   begin
      FillControls(False);
   end;

   dpnl_Wvlg.Caption := _('Dokumente der eigenen Wiedervorlage/Aufgaben') + ' [' + _('KW') + ' ' +
      IntToStr(iGKW) + ':  ' + DateToStr(MFDateTimeEdit1.Date) + ']';
end;




procedure Delay(Milliseconds: integer);

// Durch die Anwendung von MsgWaitForMultpleObjects() mit dem niemals signalisierendem Event,
// wird der aktuelle Thread solange schlafen gelegt bis entweder ein Timeout eintrifft oder
// aber im Messagequeue Messages abgearbeitet werden mssen.
// Damit ist diese Delay Funktion gleichermaen sicher in beliebigen Threads ohne Messagequeues
// oder dem MainThread einer Anwendung benutztbar.
// In einem abgespalteten Thread der kein Messagequeue besitzt verhlt sich Delay() so wie Sleep().
// In einem Thread mit Messagequeue, z.b. Hauptthread, wrde die meiste Zeit der Thread schlafen
// und nur wenn tatschlich Messages vorliegen, diese per Application.ProcessMesages abgearbeitet.
// Da Application.ProcessMessages per PeekMessage() und GetMessage() ein Polling realisiert
// verbraucht ein unntiger Aufruf dieser Funktionen mehr CPU Zeit.
// Mit obiger Funktion stellen wir um vom Polling auf Ereignisorientiert.

var
   Tick: DWord;
   Event: THandle;
begin
   Event := CreateEvent(nil, False, False, nil);
   try
      Tick := GetTickCount + DWord(Milliseconds);
      while (Milliseconds > 0) and (MsgWaitForMultipleObjects(1,
            Event, False, Milliseconds, QS_ALLINPUT) <> WAIT_TIMEOUT) do
      begin
         Application.ProcessMessages;
         if Application.Terminated then
            Exit;
         Milliseconds := Tick - GetTickcount;
      end;
   finally
      CloseHandle(Event);
   end;
end;


procedure Tfrm_MainForm.MergeAnnotation;
var
   iout, ibps, ispp, icolors, linfiles: integer;
   sTmpPath, sTargetPath, sTargetFileName, snamFile, snamFile1, fn,
   currentfile, dir, lsext, lsfiledisp, Dokumentname, sIEVPath: string;
   Vec: TImageEnVect;
   ImgCon: TimageEnMView;
   Folder: TFolderBrowser;
   Palette: array[0..255] of TRGB;
   hasanno, lbhasnnonow: boolean;
   licount, iLW, iLH, iL, ilx, ily, litempdocid, litemparcid, lipagescount,
   lidocpages, liBriefLayer, iX, iY: integer;
   lianumcol: array of integer;
   lfs: TFileStream;
   lttags: TIETIFFHandler;
   tmp: TMemoryStream;
begin
   GgfLogEvnt('MergeAnnotation');
   sTmpPath := BD.EnvTemp;
   litempdocid := iGDocID;
   litemparcid := iGArcID;
   if (trim(gsstandarddir) = '') or (not directoryexists(gsstandarddir)) then
   begin
      if not NogSelectDirectory(_('Bitte whlen Sie ein Verzeichnis'), '\',
         dir, False, False, True) then
         exit;
   end
   else
   begin
      dir := gsstandarddir;
   end;

   sTargetPAth := dir;

   Screen.Cursor := crHourGlass;
   Windows.SetCursor(Screen.Cursors[0]);

   try
     gbBlockVoransicht := true;
     for liCount := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
     begin
        try
           with dm_DB.my_q_Arc do
           begin
              if ((bExportPDF or pdfbysave) and (not tifbysave) and (not oribysave)) then
              begin
                 // Hier passen die Wait forms fuer Original Datei und TIFF hinein
              end;
              GotoBookmark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[liCount]));
              iGDocID := FieldByName('doc_id').AsInteger;
              //todo check if   bMultiArcQuery wasnt be better
              if (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil) then
              begin
                 iGArcID := FieldByName('arc_id').AsInteger;
              end;
              getDocUsrRights(False);
              if not rGDocRight.Write then
              begin
                 frm_mainform.setpanelinfo(
                    'Dieses Dokument drfen Sie nicht lokal Speichern.');
                 continue;
              end;

              if dm_DB.my_q_Arc.FieldByName('ext_loc').AsString <> '' then
              begin
                 Dokumentname := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
              end
              else
              begin
                 Dokumentname := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
              end;
              if FileExists(Dokumentname) then
              begin
                 if ((not gballasonefile) or (liCount = 0)) then
                 begin
                    sNamFile := DateinameAnhandZusatzfelder(ArcDocId(iGArcID,iGDocID),sIArcName,dm_DB.my_q_Arc);
                    if sNamFile='' then
                       snamFile := dm_db.my_q_Arc.FieldByName('Disp_name').AsString;
                    sNamFile := CleanFileName(sNamFile);
                    if tifbysave then
                       lsext := '.tif'
                    else
                    if pdfbysave then
                       lsext := '.pdf';
                    linfiles := ExitentFilesInDir(sTargetPAth + '\' + snamFile + lsext);
                    if linfiles <> 0 then
                    begin
                       snamFile1 := snamFile + '_' + IntToStr(linfiles);
                       while FileExists(sTargetPAth + '\' + snamFile1 + lsext) do
                       begin
                          Inc(linfiles);
                          snamFile1 := snamFile + '_' + IntToStr(linfiles);
                       end;
                       snamFile := snamFile1;
                    end;
                 end;

                 sTargetFilename := SnamFile;
              end;

              if length(gaspreferedtifname) > 0 then
              begin
                 sTargetFilename := gaspreferedtifname[liCount];
              end;

              if not assigned(vec) then
              begin
                 Vec := TImageEnVect.Create(nil);
                 vec.IO.AutoAdjustDPI := True;
              end;
              Screen.Cursor := crHourGlass;
              Windows.SetCursor(Screen.Cursors[0]);
              if pdfbysave and ((not gballasonefile) or (liCount = 0)) then
              begin
                 vec.IO.CreatePDFFile(sTargetPath + '\' + sTargetFilename + '.pdf');
                 vec.IO.Params.PDF_Creator :=
                    'bitfarm Archiv V3 (c) 2004 - 2013 bitfarm Informationssysteme GmbH';
                 if gballasonefile then
                 begin
                    vec.IO.Params.PDF_Title := 'sTargetFilename';
                 end
                 else
                 begin
                    vec.IO.Params.PDF_Title := dm_db.my_q_Arc.FieldByName('Disp_name').AsString;
                 end;
                 vec.IO.Params.PDF_Keywords := dm_db.my_q_arc.FieldByName('doc_txt').AsString;
                 vec.IO.Params.PDF_Producer :=
                    'bitfarm Archiv Viewer V3.5 (c) 2004 - 2013 bitfarm Informationssysteme GmbH';
                 vec.IO.Params.JPEG_Quality := 80;
              end;
              if tifbysave and ((not gballasonefile) or (liCount = 0)) then
              begin
                 lttags := TIETIFFHandler.Create;
              end;

              lidocpages := IEGetFileFramesCount(Dokumentname);

              hasanno := False;
              for iout := 0 to lidocpages - 1 do
              begin
                 if frm_mainform.tbi_VShowAnno.Checked then
                 begin
                    sIEVPath := StringReplace(Dokumentname, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

                    if tbx_pubNote.Checked then
                    begin
                       if fileexists(ChangeFileExt(sIEVPath, IntToStr(iout) + '.IEV')) then
                       begin
                          hasanno := True;
                       end;
                    end;
                    if tbx_privNote.Checked then
                    begin
                       if fileexists(ChangeFileExt(sIEVPath, IntToStr(iout) +
                          'P' + IntToStr(iGPrivAnnoID) + '.IEV')) then
                       begin
                          hasanno := True;
                       end;
                    end;
                 end;
              end;

              for iout := 0 to lidocpages - 1 do
              begin
                 // load every page and copy to        imgcon
                 // converted.  maybe use this procedure for loading thumbnails!
                 vec.io.params.imageindex := iout;
                 icolors := 0;
                 vec.io.LoadFromFile(Dokumentname);
                 lbhasnnonow := False;
                 // convert to 24bit before loading!! so the annos wont be converted back!

                 vec.RemoveAllObjects;
                 if frm_mainform.tbi_VShowAnno.Checked then
                 begin
                    if tbx_pubNote.Checked then
                    begin
                       if fileexists(ChangeFileExt(sIEVPath, IntToStr(iout) + '.IEV')) then
                       begin
                          iColors := vec.Proc.CalcImageNumColors;
                          if (iColors < power(vec.io.Params.BitsPerSample,
                             vec.io.Params.SamplesPerPixel) + 30) then
                          begin
                             if (vec.io.Params.BitsPerSample <> 8) or
                                (vec.io.Params.SamplesPerPixel <> 3) then
                             begin
                                vec.io.Params.BitsPerSample := 8;
                                vec.io.Params.SamplesPerPixel := 3;
                                //                  Outputdebugstring(PChar(' converting'));
                                vec.proc.convertTo24bit;
                             end;
                          end;
                          vec.loadFromFileIEV(ChangeFileExt(sIEVPath,
                             IntToStr(iout) + '.IEV'));
                          GgfLogEvnt('LoadFromFileIEV M6');
                          vec.ObjGraphicRender := False;
                          vec.ObjAntialias := False;
                          vec.CopyObjectsToBack(False);
                          hasanno := True;
                          lbhasnnonow := True;
                       end;
                    end;
                    if tbx_privNote.Checked then
                    begin
                       if fileexists(ChangeFileExt(sIEVPath, IntToStr(iout) +
                          'P' + IntToStr(iGPrivAnnoID) + '.IEV')) then
                       begin
                          iColors := vec.Proc.CalcImageNumColors;
                          if (iColors <
                             power(vec.io.Params.BitsPerSample, vec.io.Params.SamplesPerPixel) + 30) then
                          begin
                             if (vec.io.Params.BitsPerSample <> 8) or
                                (vec.io.Params.SamplesPerPixel <> 3) then
                             begin
                                vec.io.Params.BitsPerSample := 8;
                                vec.io.Params.SamplesPerPixel := 3;
                                vec.proc.convertTo24bit;
                             end;
                          end;
                          vec.loadFromFileIEV(ChangeFileExt(sIEVPath,
                             IntToStr(iout) + 'P' + IntToStr(iGPrivAnnoID) + '.IEV'));
                          GgfLogEvnt('LoadFromFileIEV M5');
                          vec.ObjGraphicRender := False;
                          vec.ObjAntialias := False;
                          vec.CopyObjectsToBack(False);
                          hasanno := True;
                          lbhasnnonow := True;
                       end;
                    end;

                    if tbi_VShowBrief.Checked then
                    begin
                       lbhasnnonow := True;

                       hasanno := True;
                       with vec do
                       begin
                          io.params.TIFF_ImageIndex := 0;
                          liBriefLayer := vec.LayersAdd;
                          io.LoadFromFile(sGBriefPapier);
                          if ((vec.IO.Params.ImageCount > 1) and (iout > 0)) then
                          begin
                             io.params.TIFF_ImageIndex := 1;
                             io.LoadFromFile(sGBriefPapier);
                          end;
                          layers[liBriefLayer].PosX := 0;
                          layers[liBriefLayer].Posy := 0;
                          layers[liBriefLayer].Width := layers[0].Bitmap.Width;
                          layers[liBriefLayer].Height := layers[0].Bitmap.Height;
                          layers[liBriefLayer].Operation := ielAND;
                          layers[liBriefLayer].Visible := True;
                          Layerscurrent := 0;
                          if (Layers[0].Bitmap.PixelFormat <> ie1g) or
                             (Layers[liBriefLayer].Bitmap.PixelFormat <> ie1g) then
                             LayersMerge(0, liBriefLayer, True)
                          else
                          begin
                             if (Layers[liBriefLayer].Bitmap.Width <> Layers[0].Bitmap.Width) or
                                (Layers[liBriefLayer].Bitmap.Height <> Layers[0].Bitmap.Height) then
                             begin
                                vec.proc.AttachedIEBitmap := Layers[liBriefLayer].Bitmap;
                                vec.proc.Resample(Layers[0].Bitmap.Width,
                                   Layers[0].Bitmap.Height, rfNone);
                             end;
                             for iY := 0 to Layers[liBriefLayer].Bitmap.Height - 1 do
                                for iX := 0 to Layers[liBriefLayer].Bitmap.Width - 1 do
                                   Layers[0].Bitmap.Pixels_ie1g[iX, iY] :=
                                      (Layers[0].Bitmap.Pixels_ie1g[iX, iY] and
                                      Layers[liBriefLayer].Bitmap.Pixels_ie1g[iX, iY]);
                          end;
                       end;
                       vec.ObjGraphicRender := False;
                       vec.ObjAntialias := False;
                       vec.CopyObjectsToBack(False);
                    end;
                 end;

                 if lbhasnnonow then
                 begin
                    if vec.proc.calcImagenumcolors > icolors then
                       icolors := vec.proc.calcImagenumcolors;

                    vec.RemoveAllObjects;
                 end;

                 if pdfbysave = True then
                 begin
                    if ((hasanno) or (ExtractFileExt(Dokumentname) <> '.pdf')) then
                    begin
                       if icolors = 0 then
                       begin
                          iColors := vec.Proc.CalcImageNumColors;
                       end;
                       if icolors < 128 then
                       begin
                          vec.IO.Params.PDF_Compression := ioPDF_LZW;
                       end
                       else
                       begin
                          vec.IO.Params.PDF_Compression := ioPDF_jpeg;
                          vec.io.Params.BitsPerSample := 8;
                          vec.io.Params.SamplesPerPixel := 3;
                       end;
                       vec.IO.SaveToPDF;
                    end;
                 end; //pdfbysave

                // Speichern als Tiff Datei
                 if tifbysave then
                 begin
                    if not (not hasanno and (ExtractFileExt(Dokumentname) = '.tif')) then
                    begin
                       tmp := TMemoryStream.Create;
                       //did not have annos and tbx_pubNote.Checked = 0 so take the compression of the old file
                       if icolors = 0 then
                       begin
                          vec.IO.Params.TIFF_Compression := fra_voransicht.img_DocView.IO.Params.TIFF_Compression;
                       end
                       else
                       if icolors < 128 then
                       begin
                          vec.IO.Params.TIFF_Compression := ioTIFF_LZW;
                       end
                       else
                       begin
                          vec.IO.Params.TIFF_Compression := ioTIFF_JPEG;
                          vec.io.Params.BitsPerSample := 8;
                          vec.io.Params.SamplesPerPixel := 3;
                       end;

                       vec.IO.SaveToStreamTIFF(tmp);
                       tmp.Seek(0, 0);
                       lttags.ReadFile(sTargetPath + '\' + sTargetFilename + '.tif');
                       lttags.InsertTIFFStream(tmp, lttags.GetPagesCount);
                       lttags.WriteFile(sTargetPath + '\' + sTargetFilename + '.tif');

                       tmp.Free;
                    end;
                 end;
              end;

              if tifbysave then
              begin
                 if ((not hasanno) and (ExtractFileExt(Dokumentname) = '.tif') and
                    (not gballasonefile)) then
                 begin
                    CopyFile(PANSICHAR(Dokumentname),
                       PANSICHAR(sTargetPath + '\' + sTargetFilename + '.tif'), False);
                 end;
              end;
              if pdfbysave = True then
              begin
                 if ((not hasanno) and (ExtractFileExt(Dokumentname) = '.pdf') and
                    (not gballasonefile)) then
                 begin
                    CopyFile(PANSICHAR(Dokumentname), PANSICHAR(sTmpPath + '\' +
                       sTargetFilename + '.pdf'), False);

                 end
                 else
                 begin
                    if not gballasonefile then
                       vec.IO.ClosePDFFile;
                 end;
              end;
              if (not gballasonefile) then
              begin
                 vec.Proc.Undo;
                 freeandnil(vec);
              end;

              if not gballasonefile then
              begin
                 if assigned(lttags) then
                    FreeAndNil(lttags);
              end;
              NewHistory(15, 'Dokument wurde in lokalem Verzeichnis [' +
                 sTargetPath + '] gespeichert.');
           end;
        except
           on e: Exception do
           begin
              logevnt('Error mergingannos ' + e.message);
           end;
        end;
     end;
   finally
      gbBlockVoransicht := false;
   end;
   if Assigned(frm_Wait) then
      frm_Wait.Release;

   if gballasonefile then
   begin
      if pdfbysave then
      begin
         vec.IO.ClosePDFFile;
      end;
      vec.Proc.Undo;
      freeandnil(vec);
      //todo check if this is right      
      if assigned(lttags) then
         FreeAndNil(lttags);
   end;
   Screen.Cursor := crDefault;
   Windows.SetCursor(Screen.Cursors[0]);
   iGDocID := litempdocid;
   iGArcID := litemparcid;
end;

procedure Tfrm_MainForm.tbi_HinzufuegenDesDokumentesAlsAttachmentClick(Sender: TObject);
var
   lb1, lb2, lb3: boolean;
begin
   GgfLogEvnt('tbi_HinzufuegenDesDokumentesAlsAttachmentClick');
   askforsave;
   dazuversenden := True;
   //use tiff so later convert to pdf
   lb1 := pdfbysave;
   lb2 := bexportpdf;
   lb3 := tifbysave;
   pdfbysave := false;
   bexportpdf := false;
   tifbysave := true;
   dm_MainForm2.SendMailFile(0, -1, tbi_VShowAnno.Checked);
   pdfbysave := lb1;
   bexportpdf := lb2;
   tifbysave := lb3;
end;

procedure Tfrm_MainForm.tbi_HinzufuegenDerOriginaldateiClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_HinzufuegenDerOriginaldatei');
   dazuversenden := True;
   dm_MainForm2.SendOriMail(True);
end;

procedure Tfrm_MainForm.tbi_GesammelteDokumenteVersendenClick(Sender: TObject);
var li, li1, lidocpages, linfiles: integer;
   lsext, lstifname, lspdfname,
   snamFile, snamFile1: string;
   liev: timageenview;
begin
   GgfLogEvnt('tbi_GesammelteDokumenteVersendenClick');
   askforsave;
   dazuversenden := False;

   if bExportPDF then
   begin
      try
         liev := timageenview.Create(nil);
         for li := 0 to frm_Mailform.AttachmentMemo.Lines.Count - 1 do
         begin
            lstifname := frm_Mailform.AttachmentMemo.Lines.Strings[li];
            lsext := lowercase(ExtractFileExt(lstifname));

            if lsext = '.tif' then
            begin
               lidocpages := IEGetFileFramesCount(lstifname);
               snamFile := CleanFileName(changefileext(extractfilename(lstifname), ''));
               lspdfname := extractfilepath(lstifname) + '\' +
                  snamFile + '.pdf';
               if fileexists(lspdfname) then
               begin
                  linfiles := ExitentFilesInDir(extractfilepath(lstifname) + '\' +
                     snamFile + '.pdf');
                  if linfiles <> 0 then
                  begin
                     snamFile1 := snamFile + '_' + IntToStr(linfiles);
                     while FileExists(extractfilepath(lstifname) + '\' + snamFile1 + '.pdf') do
                     begin
                        Inc(linfiles);
                        snamFile1 := snamFile + '_' + IntToStr(linfiles);
                     end;
                     snamFile := snamFile1;
                  end;        
                  lspdfname := extractfilepath(lstifname) + '\' +
                     snamFile + '.pdf';
               end;
               liev.IO.CreatePDFFile(lspdfname);
               liev.IO.Params.PDF_Creator :=
                  'bitfarm Archiv V3 (c) 2004 - 2013 bitfarm Informationssysteme GmbH';
               liev.IO.Params.PDF_Title := changefileext(extractfilename(lstifname), '');

               liev.IO.Params.PDF_Producer :=
                  'bitfarm Archiv Viewer V3.5 (c) 2004 - 2013 bitfarm Informationssysteme GmbH';
               for li1 := 0 to lidocpages - 1 do
               begin
                  liev.IO.Params.ImageIndex := li1;
                  liev.IO.LoadFromFileTIFF(lstifname);
                  case liev.IO.Params.TIFF_Compression of
                     ioTIFF_UNCOMPRESSED:
                        liev.IO.Params.PDF_Compression := ioPDF_UNCOMPRESSED;
                     ioTIFF_G4FAX:
                        liev.IO.Params.PDF_Compression := ioPDF_G4FAX;
                     ioTIFF_LZW:
                        liev.IO.Params.PDF_Compression := ioPDF_LZW;
                     ioTIFF_JPEG:
                        liev.IO.Params.PDF_Compression := ioPDF_JPEG;
                  else
                     liev.IO.Params.PDF_Compression := ioPDF_UNCOMPRESSED;
                  end;

                  liev.IO.Params.JPEG_Quality := 80;
                  liev.IO.SaveToPDF;
               end;
               liev.IO.ClosePDFFile;
               frm_Mailform.AttachmentMemo.Lines.Strings[li] := lspdfname;
            end;
         end;
      finally
         begin
            freeandnil(liev);
         end;
      end;
   end;
   frm_Mailform.SendBtnClick(self);
end;

procedure Tfrm_MainForm.TBXItem34Click(Sender: TObject);
begin
   GgfLogEvnt('TBXItem34Click');
   ShellExecute(Application.Handle, nil,
      'http://sourceforge.net/projects/bitfarm-archiv/support', nil, nil,
      sw_shownormal);
end;

procedure Tfrm_MainForm.Button1Click(Sender: TObject);
begin
   GgfLogEvnt('Button1Click');
   subject := ' bitfarm Archiv';
   Mailtext := _('Hier gibts den Text zur mail');
   ToName := 'Norbert Gering';
   ToAdress := 'n.gering@bitfarm-gmbh.de';
   Attachedfilename := 'c:\test.pdf';
   Displayfilename := 'c:\test.pdf';
   ShowDialog := True;

   dm_MainForm2.SendMail(Subject,
      Mailtext,
      FromName,
      FromAdress,
      ToName, ToAdress,
      AttachedFileName,
      DisplayFileName,
      ShowDialog);
end;

procedure Tfrm_MainForm.Button2Click(Sender: TObject);
begin
   GgfLogEvnt('Button2Click');
   FillControls(False);
end;

procedure Tfrm_Mainform.nDelay(ATime: dword);
var
   Start: Dword;
begin
   Start := GetTickCount;
   repeat
      Application.ProcessMessages;
   until GetTickCount - Start > ATime;
end;

procedure Tfrm_MainForm.bitbtn1Click(Sender: TObject);
var
   iCount: integer;
   ColItem: TTBXColorItem;
begin
   GgfLogEvntBeg ('bitbtn1Click Begin (= Suchen-Button)');

   if dbtv_LgrArc.Selected = nil then
   begin
       Exit;
   end;

   debugedit := TEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp6'));

   if (dm_db.my_q_arc.RecordCount > 0) and
      (gbsearched and (sIarcName <> '') and (not bMultiArcQuery)) then
   begin
      try
         dbgrd_Trefferliste.Columns.SaveToFile(ResultlistDesignPath +
            '\' + sIArcName + '.bfa');
      except on e: exception do
         begin
            logevnt('bitbtn1Click ' + e.Message);
         end;
      end;
   end;

   if GHasNotBeenSavedAfterModify and btn_SaveDoc.Enabled then
   begin
      if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
         #13 + _('Mchten Sie die nderungen speichern?'),
         True) = mrYes then
      begin
         tbi_VSaveDocClick(self);
      end;
   end
   else if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveobjects(False, False);

   if ((gtmpiStatus xor gotmpistatus) > 0) then
   begin
      for iCount := 5 to tlb_Status.Items.Count - 1 do
      begin
         ColItem := TTBXColorItem(tlb_Status.Items.Items[iCount]);
         if gai_sts_rights[(ColItem.tag shr 8) - 1] then
         begin
            ColItem.FontSettings.Color := clnone;
         end
         else
         begin
            ColItem.FontSettings.Color := gcnrs;
         end;
      end;
   end;
   GHasNotBeenSavedAfterModify := False;
   gtmpiStatus := gotmpistatus;
   btn_SaveDoc.Enabled := false;
   tbi_VSaveDoc.Enabled := false;
   fgchangedvoransicht := False;
   fgchangedvoransichttif := False;
//   dm_MainForm2.tim_voransicht.Enabled := False;
   addToXmlFile(BD.AppdataBitfarmPd + 'History.xml', False);

   btn_StartSrcClick(self);

//   dm_MainForm2.tim_voransicht.Enabled := True;
   dbgrd_Trefferliste.filtered := gbTrefferlisteFiltered;
   GgfLogEvntEnd ('bitbtn1Click End');
end;

procedure Tfrm_MainForm.Button3Click(Sender: TObject);
begin
   GgfLogEvnt('Button3Click');
   btn_ResFieldsClick(self);
end;

procedure Tfrm_MainForm.memo_VtxKeyPress(Sender: TObject; var Key: char);
begin
   GgfLogEvnt('memo_VtxKeyPress');
   begin
      if Key = #13 then //Ist die gedrckte Taste ASCII-Return?
      begin
         bitbtn1Click(self);
      end;
   end;
end;

procedure Tfrm_MainForm.edt_SSlwKeyPress(Sender: TObject; var Key: char);
begin
   GgfLogEvnt('edt_SSlwKeyPress');

   begin
      if Key = #13 then //Ist die gedrckte Taste ASCII-Return?
      begin
         bitbtn1Click(self);
      end;
   end;
end;


procedure Tfrm_MainForm.SpeedButtonExportErstellenClick(Sender: TObject);
//////////////////////////////////////////////////////////////////////////
//   Startoption fr den Exporter V3 schaffen
begin
   GgfLogEvnt('SpeedButton2Click');
   ShellExecute(0, nil, PChar(BD.ExeDir + 'ExporterV3.exe'), nil, nil,
      SW_SHOWNORMAL);
end;

procedure Tfrm_MainForm.tbi_VInvertClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_VInvertClick');
   if rGDocRight.modify = False then
      exit;
   if (fra_voransicht.img_DocView.IsEmpty) or (dm_DB.my_q_Arc.RecordCount = 0) then
      exit;

   Screen.Cursor := crHourGlass;
   Windows.SetCursor(Screen.Cursors[0]);
   with fra_Voransicht.img_DocView.Proc do
      Negative;

   tbsi_VZoomClick(self);
   Screen.Cursor := crDefault;
   Windows.SetCursor(Screen.Cursors[0]);
   EnableSaveBtn;
   GHasNotBeenSavedAfterModify := True;
   fgchangedvoransicht := true;
   fgchangedvoransichttif := true;
end;

procedure Tfrm_MainForm.TsqlClick(Sender: TObject);
begin
   GgfLogEvnt('TsqlClick');
   timesql('Select  tim_id, tim_Ref, grp_id, erinnerung, termin, ' +
      'sys_arc.arc_id, arc_name, arc_tblname, doc_id, doc_titel, info, status, usr_id_work, usr_id_shed '
      + 'from sys_timer left join sys_arc using(arc_id) where usr_id_work = 8 and ' +
      'status <> 2 and ((Termin between ' + #39 + '( 2007-03-26 00:00:00 ' +
      #39 + ' and ' + #39 + '2007-04-01 23:59:59' + #39 + ') ' +
      'or  (Termin < ' + #39 + '2007-03-26 00:00:00' + #39 + ')) order by termin, tim_id');
end;

procedure Tfrm_MainForm.btn_SDKWClick(Sender: TObject);
begin
   GgfLogEvnt('btn_SDKWClick');
   if frm_MainForm.TmpSQL(
      'Select * from sys_timer where tim_ref = (Select Sql_No_cache tim_ref from sys_timer where arc_id = '
      + IntToStr(iGTimArcID) + ' and doc_id = ' + IntToStr(iGTimDocID) + ')') then
   begin
      DM_DB.my_q_Tmp.Close; // Tabelle schliessen
   end;
   frm_techinf.Show;
end;

procedure LogWvl(LogMsg: string);
var
   wvlLogFile: TextFile;
   sLogDate: string;
begin
   if not wvldebug then
      Exit;
   // get for timerevelant actions the server time
   dm_db.my_q_datetime.SQL.Text :=
      'select date_format(now(),"%d.%m.%Y %T") as date';
   dm_db.my_q_datetime.Execute;
   sLogDate := dm_db.my_q_datetime.FieldByName('date').AsString;
   //  DateTimeToString(sLogDate, 'dd.mm.yyyy hh:nn:ss', now);
   try
      AssignFile(wvlLogFile, BD.EnvTemp + '\wvl.log');
      if not FileExists(BD.EnvTemp + '\wvl.log') then
         ReWrite(wvlLogFile);
      Reset(wvlLogFile);
      Append(wvlLogFile);
      WriteLn(wvlLogFile, sLogDate + '    ' + LogMsg);
      Flush(wvlLogFile);
      CloseFile(wvlLogFile);
   except
      on e: Exception do
         BfShowMessage(_('Schwerer Fehler:') +
            e.Message + #13 + #13 +
            _('Rechte reichen nicht aus zum schreiben der Datei ') +
            BD.EnvTemp);
   end;
end;

procedure Tfrm_MainForm.tbx_privNoteClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_privNoteClick');

   askforsave;

   fra_Voransicht.fAnnoType := 1;
   tbx_pubNote.Checked := False;
   fra_Voransicht.fPrivAnnoID := iGUsrID;
   tbx_privNote.Checked := not tbx_privNote.Checked;
   iGPrivAnnoID := iGUsrID;
   if tbx_privNote.Checked then
      dm_MainForm2.pum_PrivAnno.Popup(mouse.CursorPos.X, mouse.CursorPos.Y);

   ZustaendeAnnotationBearbeitenSetzen; //m.frey
   ChangeDocPage(0);
end;

procedure Tfrm_MainForm.tbx_pubNoteClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_pubNoteClick');
   fra_voransicht.img_DocView.CancelInteracts;

	askforsave;

   fra_Voransicht.fAnnoType := 0;
   tbx_privNote.Checked := False;
   tbx_pubNote.Checked := not tbx_pubNote.Checked;
   if tbx_pubnote.Checked then
   begin
      tbx_pubnote.Hint := gstbxpubannotmp;
   end
   else
   begin
      gstbxpubannotmp := tbx_pubnote.Hint;
      tbx_pubnote.Hint := _('Zeige ffentlliche Anmerkungen an');
   end;
   ZustaendeAnnotationBearbeitenSetzen; //m.frey
   ChangeDocPage(0);
end;

procedure Tfrm_MainForm.doSearchOnEnter(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('doSearchOnEnter');
   if not gbAddfieldDropDown then
      if Key = vk_return then //Ist die gedrckte Taste ASCII-Return?
      begin
			if not btn_SaveDoc.Enabled then
	         bitbtn1Click(self);
	   end
      else if Sender.ClassName = 'TComboBox' then
      	gbChangeInComboBox := True;
end;


procedure Tfrm_MainForm.cbx_SUsrKeyPress(Sender: TObject; var Key: char);
begin
   GgfLogEvnt('cbx_SUsrKeyPress');

   if Key = #13 then //Ist die gedrckte Taste ASCII-Return?
   begin
      bitbtn1Click(self);
   end;
end;

procedure Tfrm_MainForm.dtp_SBisKeyDown(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('dtp_SBisKeyDown');
   if Key = VK_RETURN then //Ist die gedrckte Taste ASCII-Return?
   begin
      bitbtn1Click(self);
   end;
end;

procedure Tfrm_MainForm.dtp_SVonKeyDown(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('dtp_SVonKeyDown');
   if Key = VK_RETURN then //Ist die gedrckte Taste ASCII-Return?
   begin
      bitbtn1Click(self);
   end;
end;

procedure Tfrm_MainForm.edt_SRefSeaKeyDown(Sender: TObject; var Key: word;
   Shift: TShiftState);
begin
   GgfLogEvnt('edt_SRefSeaKeyDown');
   if Key = VK_RETURN then //Ist die gedrckte Taste ASCII-Return?
   begin
      bitbtn1Click(self);
   end;
end;

// Farbe zwischen 2 vorgegebenen Farbwerten berechnen
function Tfrm_MainForm.ColorBetween(C1, C2: TColor; blend: real): TColor;
var
   r, g, b: byte;

   y1, y2: byte;
begin
   GgfLogEvnt('ColorBetween');
   C1 := ColorToRGB(C1);
   C2 := ColorToRGB(C2);

   y1 := GetRValue(C1);
   y2 := GetRValue(C2);

   r := Round(y1 + (y2 - y1) * blend);

   y1 := GetGValue(C1);
   y2 := GetGValue(C2);

   g := Round(y1 + (y2 - y1) * blend);

   y1 := GetBValue(C1);
   y2 := GetBValue(C2);

   b := Round(y1 + (y2 - y1) * blend);
   Result := RGB(r, g, b);
end;

// Farbe zwischen beliebig vielen vorgegebenen Farbwerten berechnen
function Tfrm_MainForm.ColorsBetween(colors: array of TColor; blend: real): TColor;
var
   a: integer;
   faktor: real;
begin
   GgfLogEvnt('ColorsBetween');
   if Length(colors) < 2 then
      raise Exception.Create('ColorsBetween() at least 2 Colors required');

   if blend <= 0.0 then
      Result := colors[0]
   else
   if blend >= 1.0 then
      Result := colors[High(colors)]
   else
   begin
      a := Trunc(High(colors) * blend);
      faktor := 1.0 / High(colors);

      Result := ColorBetween(colors[a], colors[a + 1], (blend - (a * faktor)) /
         faktor);
   end;
end;

// ermittlung der Anzahl der Datein in einem Verzeichnis
function Tfrm_MainForm.ngFilesInDir(sNGPath: string): integer;
var
   sr: TSearchRec;
   RowCount: integer;

begin
   GgfLogEvnt('ngFilesInDir');
   RowCount := 0;
   ngFilesInDir := 0;
   if FindFirst(sNGPath, faAnyFile, sr) = 0 then
   begin
      repeat
         RowCount := RowCount + 1;
      until FindNext(sr) <> 0;

      FindClose(sr);
      ngFilesInDir := RowCount;
   end;
end;

// ermittlung der Mglichen dateinamen
function Tfrm_MainForm.ExitentFilesInDir(fsPath: string): integer;
var
   sr: TSearchRec;
   RowCount: integer;

begin
   GgfLogEvnt('ExitentFilesInDir');
   RowCount := 0;
   Result := 0;
   if FindFirst(fsPath, faAnyFile, sr) = 0 then
   begin
      repeat

         RowCount := RowCount + 1;
      until FindNext(sr) <> 0;

      FindClose(sr);
      Result := RowCount;
   end;
end;


procedure Tfrm_MainForm.FormDestroy(Sender: TObject);
begin
   GgfLogEvnt('FormDestroy');
   GaugePanelCanvas.Free;
   deleteDC(dc);
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteTitleClick(Column: TColumn);
begin
   GgfLogEvnt('dbgrd_TrefferlisteTitleClick');
   if iGArcRecNo <> dbgrd_Trefferliste.DataSource.DataSet.RecNo then
      iGArcRecNo := dbgrd_Trefferliste.DataSource.DataSet.RecNo;
    ColumnMoved;
    Markieren2(dbgrd_Trefferliste);
end;


function Tfrm_MainForm.DelLnk: boolean;
   /////////////////////////////////////////////////////////////
   ///  0705111546                           ///
   ///                                                       ///
   ///  Function lscht ein Verknuepfung aus der Tabelle     ///
   ///  sys_doclnk
   ///                                                       ///
   ///  Ausgabe: True bei Erfolg                             ///
   ///           False bei Fehlschlag oder Abbruch           ///
   ///                                                       ///
   /////////////////////////////////////////////////////////////
var
   sSlw: string;
begin
   GgfLogEvnt('DelLnk');
   Result := True;

   if MessageDlg(_('Mchten Sie wirklich die Verknpfung [yxz] entfernen?'),
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      with dm_DB.my_cmd do
      begin
         // SQL.Text := 'delete from sys_doclnk where  Arc_id = '+'  ' + IntToStr(iTmpID);
         try
            Execute;
         except
            on e: Exception do
            begin
               Result := False;
               ErrorMsg('frm_Mainfrm.Dellnk',
                  _('Fehler beim Entfernen eines links:') +
                  e.Message, 2027, True);
            end;
         end;
      end;
   end
   else
      Result := False;
   if Result then
      frm_MainForm.NewHistory(13, 'Link [' + sSlw + '] ' + _('entfernt.'));
end;

procedure Tfrm_MainForm.TBXItem36Click(Sender: TObject);
var
   icount, litmparcid, litmpdocid: integer;
begin
   GgfLogEvnt('TBXItem36Click');
   litmpdocid := 0;
   litmparcid := 0;

   if dm_DB.my_q_Arc.RecordCount > 0 then
   begin
      dm_MainForm2.mnu_CreNewRef.Click; // Erzeuge einen neuen Referenznamen
   end
   else
   begin
      BfShowMessage(_('Bitte whlen Sie erst ein Dokument aus!'));
      exit;
   end;

   //check if the user clicked on cancel!
   if ((fra_DocLink.edt_Link.Text = '') or (createnewlink = False)) then
      exit;
   try
      litmparcid := iGArcID;
      litmpdocid := iGDocID;
      for iCount := 0 to (frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1) do
      begin
         with dm_DB.my_q_Arc do
         begin
            GotoBookmark(Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items
               [iCount]));
            iGDocID := FieldByName('doc_id').AsInteger;
            if ((bMultiArcQuery) and (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)) then
            begin
               iGArcID := FieldByName('arc_id').AsInteger;
            end;
            iGRArcID := iGArcID;
            iGRDocID := iGDocID;
            fra_DocLink.AddDocToRef;
            tci_DocLink.Color := clYellow;
         end;
      end;
   finally
      iGArcID := litmparcid;
      iGDocID := litmpdocid;
   end;
end;

procedure Tfrm_MainForm.TBXItem37Click(Sender: TObject);
var
   icount, litmparcid, litmpdocid: integer;
begin
   GgfLogEvnt('TBXItem37Click');

   // erzeuge einen neuen Linknamen
   if (frm_mainform.dbgrd_Trefferliste.SelectedRows.Count = 0) then
   begin
      BfShowMessage(_('Kein Dokument ausgewhlt!'));
      exit;
   end;

   litmparcid := iGArcID;
   litmpdocid := iGDocID;
   for iCount := 0 to (frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1) do
      // Alle markierten Dokumente durchgehen
   begin
      if lbl_ChoosenLink.caption <> '' then
      begin
         with dm_DB.my_cmd do
         begin
            TMPSQL(' select Ref_lnk from sys_doclnk where Ref_name like ' +
               #39 + lbl_ChoosenLink.caption + #39);

            // ref was deleted maybe give a warning
            if dm_DB.my_q_tmp.RecordCount = 0 then
            begin
               BfShowMessage(_('Verknpfung') + ' ' + lbl_ChoosenLink.caption +
                  ' ' + _('existiert nicht mehr.'));
               exit;
            end;
            //todo check for existent link!!! then dont do anything!
            // go to the doc which will be insert into the link

            dm_db.my_q_arc.GotoBookmark(
               Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[iCount]));

            iGDocID := dm_db.my_q_arc.FieldByName('doc_id').AsInteger;
            if ((bMultiArcQuery) and (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <>
               nil)) then
            begin
               iGArcID := dm_db.my_q_arc.FieldByName('arc_id').AsInteger;
            end;
            iGRArcID := iGArcID;
            iGRDocID := iGDocID;
            sGRArcName := sIArcName;
            iGRefLNK := dm_DB.my_q_tmp.FieldByName('ref_lnk').AsInteger;

            if tmpsql('select * from sys_doclnk where arc_id = ' +
               IntToStr(iGRArcID) + ' and doc_id = ' + IntToStr(iGRDocID) +
               ' and ref_Name = ' + #39 + lbl_ChoosenLink.caption + #39 +
               ' order by ref_lnk desc') then
            begin
               if dm_DB.my_q_Tmp.RecordCount > 0 then
               begin
                  continue;
               end;
               SQL.Text :=
                  'insert into sys_doclnk (arc_id, doc_id, usr_id, ref_Name, Ref_lnk) ' +
                  'Values (' + IntToStr(iGRArcID) + ', ' + IntToStr(iGRDocID) +
                  ', ' + IntToStr(iGUsrID) + ', ' + #39 + lbl_ChoosenLink.caption +
                  #39 + ', ' + IntToStr(iGRefLNK) + ')';
               Execute;

               frm_mainform.setpanelinfo(
                  _('Gemerktes Dokument mit Referenz') + ' ' + lbl_ChoosenLink.caption + ' ' + _('verknpft.'));
               frm_MainForm.NewHistory(4, _('Neue Verknpfung') + ' ' +
                  lbl_ChoosenLink.caption + ' ' + _('angelegt'));
               SQL.Text := 'Insert into slw_' + sIArcName +
                  ' (doc_id, doc_slw) Values (' + IntToStr(iGRDocID) +
                  ', ' + #39 + trim(ParseSemicolonUseBackslash(lbl_ChoosenLink.caption)) + #39 + ')';
               Execute;
               frm_MainForm.tci_DocLink.color := clyellow;
               fra_docLink.GetQuickLinks;
               fra_docLink.GetLinkedDocs;
               if dm_db.my_q_Lnk.Active then
                  dm_db.my_q_Lnk.refresh;
            end;
         end;
      end
      else
      begin
         BfShowMessage(
            _('Verknpfung hat keinen Namen! Gegebenenfalls erstellen Sie bitte eine neue Verknpfung.'));
         exit;
      end;
   end;

   tci_DocLink.Color := clYellow;
   iGArcID := litmparcid;
   iGDocID := litmpdocid;
end;

procedure Tfrm_MainForm.TBXItem38Click(Sender: TObject);

begin
   GgfLogEvnt('TBXItem38Click');

   begin
      uncheckallgraphictools;
      fra_voransicht.img_DocView.MouseInteract :=
         fra_voransicht.img_DocView.MouseInteract + [miscroll];
   end;
end;


procedure Tfrm_MainForm.onExitComboBox (Sender: TObject);
begin
 	adjustText (TComboBox (Sender));
end;

procedure Tfrm_MainForm.OnAddfieldDropDown(Sender: TObject);
begin
   gbAddfieldDropDown := True;
end;

procedure Tfrm_MainForm.OnAddfieldCloseUp(Sender: TObject);
begin
   gbAddfieldDropDown := False;
end;

procedure Tfrm_MainForm.MehrfachGetScrollbar(Sender: TObject);
begin
   OutputDebugString('MehrfachGetScrollbar');
   gbAddfieldDropDown := True;
   if gbGetZusfieldPos then
   	Exit;
   gbGetZusfieldPos := True;
   igZusFieldPos := sbx_ZusFeld.VertScrollBar.Position;
end;

procedure Tfrm_MainForm.MehrfachRestoreScrollbar(Sender: TObject);
begin
   OutputDebugString('MehrfachRestoreScrollbar');
   if gbArcHandling or gbwvlcellclick then
   	Exit;
	sbx_ZusFeld.VertScrollBar.Position := igZusFieldPos;
  	EnableSaveOnChange(Sender);
end;

procedure Tfrm_MainForm.MehrfachRestoreAndUnset(Sender: TObject);
begin
   OutputDebugString('MehrfachRestoreAndUnset');
   if gbAddfieldDropDown then
   begin
      if igZusFieldPos <> sbx_ZusFeld.VertScrollBar.Position then
	      sbx_ZusFeld.VertScrollBar.Position := igZusFieldPos;
   end;
end;

procedure Tfrm_MainForm.sbx_ZusFeldCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
   if gbAddfieldDropDown then
   begin
  		sbx_ZusFeld.VertScrollBar.Position := igZusFieldPos;
	end;
end;

procedure Tfrm_MainForm.sbx_ZusFeldVerticalScroll(Sender: TObject);
begin
	igZusFieldPos := sbx_ZusFeld.VertScrollBar.Position;
end;


procedure Tfrm_MainForm.EnableSaveOnChange(Sender: TObject);
var
   ls, lstmp, lstmpindex, lsnc: string;
   li: integer;
   lbr: boolean;
   xComp,lcc  : TComponent;
   ldNow, ldVon, ldBis : TDateTime;
   bDeactivateTextEdit : Boolean;
begin
   GgfLogEvnt ('EnableSaveOnChange');
   if gbFillZusfields or gbArcHandling or frm_MainForm.reset or gbarclick or gbwvlcellclick
	   or gbSaveDoc then
   begin
   	GgfLogEvnt('Exit EnableSaveOnChange ' + BoolToStr(gbFillZusfields)
      + ' ' + BoolToStr(gbArcHandling)
      + ' ' + BoolToStr(frm_MainForm.reset)
      + ' ' + BoolToStr(gbarclick)
      + ' ' + BoolToStr(gbwvlcellclick)
      + ' ' + BoolToStr(gbSaveDoc));
	   exit;
   end;

   if fra_Voransicht.img_DocView.ObjTextEditMode <> -1 then  // Text Anno noch offen? dann schlieen...
   begin
   	tbi_normalmouseClick(nil);
      bDeactivateTextEdit := True;
   end;

   lbr := true;
   if Sender is TEdit then
   begin
      with Sender as TEdit do
      begin
         if bDeactivateTextEdit then
         begin
            SetFocus;
            SelStart := Length(Text);
         end;
         if Modified then
         begin
            if gbcfgxs then
            begin
               ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1,
                  length(TEdit(sender).name) - length('zedt_Tmp'));
               try
                  li := strtoint(ls);
               except on e: exception do
                  begin
                  end;
               end;
               lbr := gai_cfg_rights[li];
            end;

            if lbr and (dm_db.my_q_arc.recordcount > 0) then
            begin
	            Color := cColorHellgruen;
               if rGDocRight.modify then //18.04.2011 b.takacs 3.5.0.178
               begin
                 tbi_VSaveDoc.Enabled := True;
                 btn_SaveDoc.Enabled := True;
               end;
            end
            else
            begin
               if lbr then
               begin
                  Color := cColorHellgruen;
               end
               else
               begin
                  color := cColorHellgruen;
                  //color := cColorNoRight;
               end;
            end;
         end;
      end;
   end;
   if Sender is TJvDateEdit then
   begin
      with Sender as TJvDateEdit do
      begin
      	if bDeactivateTextEdit then
         begin
            SetFocus;
            SelStart := Length(Text);
         end;
         if Modified then
         begin
           ldNow := Now();

            if (Pos('_og', TJvDateEdit(sender).name) = 0) then
            begin
               ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1,
                  length(TEdit(sender).name) - length('zedt_Tmp'));
               if trystrtoint(ls, li)  then
               begin

                	if ((TJvDateEdit(sender).text = cEmptyDateString) or
                     (length(Trim(TJvDateEdit(sender).text)) = 0)) then
                  begin
                     if (TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                           IntToStr(li))).Text <> cEmptyDateString) then
                        TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                              IntToStr(li))).Text := cEmptyDateString;
                  end
                  else
                  if length(Trim(TJvDateEdit(sender).text)) = 10 then
                  if  TryStrToDateTime(TJvDateEdit(sender).text, ldVon) then
                  begin
                     TryStrToDateTime(TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                           IntToStr(li))).Text, ldBis);
                     if (ldVon <= ldNow) and (ldBis = 0) then
                        TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                           IntToStr(li))).Text := DateToStr(ldNow)
                     else
                     (*if (ldVon > ldNow) and (ldVon > ldBis) then
                     	TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
		                  	IntToStr(li))).Text := DateToStr(ldVon); *)
                     if ldVon > ldBis then
                     	TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
		                  	IntToStr(li))).Text := DateToStr(ldVon);
		            end
                  else
                     TJvDateEdit(sender).text := cEmptyDateString;
               end;
            end
            else
            begin
            	ls := copy(TEdit(sender).name, length('zedt_Tmp_og_') + 1,
                  length(TEdit(sender).name) - length('zedt_Tmp_og_'));
               if trystrtoint(ls, li)  then
               begin
                  if length(Trim(TJvDateEdit(sender).text)) = 10 then
                  if  TryStrToDateTime(TJvDateEdit(sender).text, ldBis) then
                  begin
                     TryStrToDateTime(TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' +
                           IntToStr(li))).Text, ldVon);
                     if ldVon > ldBis then
                        TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' +
                           IntToStr(li))).Text := DateToStr(ldBis);
                  end
                  else
                     TJvDateEdit(sender).text := cEmptyDateString;
               end;
            end;

            if gbcfgxs then
            begin
               ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1,
                  length(TEdit(sender).name) - length('zedt_Tmp'));
               if not trystrtoint(ls, li) then
               begin
                  ls := copy(TJvDateEdit(sender).name, length('zedt_Tmp_og_') + 1,
                     length(TJvDateEdit(sender).name) - length('zedt_Tmp_og_'));
                  trystrtoint(ls, li);
               end;
               lbr := gai_cfg_rights[li];
            end;

            if lbr and (dm_db.my_q_arc.recordcount > 0) then
            begin
               Color := cColorHellgruen;
               if (rGDocRight.modify) and (Pos('_og', TJvDateEdit(sender).name) = 0) then //18.04.2011 b.takacs 3.5.0.178
               begin
                 tbi_VSaveDoc.Enabled := True;
                 btn_SaveDoc.Enabled := True;
               end;
            end
            else
            begin
               if lbr then
               begin
                  Color := cColorHellgruen;
               end
               else
               begin
                  color := cColorHellgruen;
               end;
            end;
            Tag := (Tag or 4);

         end;
      end;
   end;
   if Sender is TComboBox then
   begin
      with Sender as TComboBox do
      begin
         //  Korrektur des ItemIndex
         if bDeactivateTextEdit then
         begin
            SetFocus;
            SelStart := Length(Text);
         end;
         if gbAddfieldDropDown then
         begin
            if (Text = _('--- nur suchen mglich ---')) then
            	ItemIndex := ItemIndex - 1;
         end
         else
         begin
				if (Text = _('--- nur suchen mglich ---')) then
					ItemIndex := ItemIndex - 1;
         end;

         if gbcfgxs then
         begin
            if pos('_cbx_', TComboBox(sender).name) > 0 then
            begin
               ls := copy(TComboBox(sender).name, length('zedt_Tmp_cbx_') + 1,
                  length(TComboBox(sender).name) - length('zedt_Tmp_cbx'));
            end
            else
            begin
               ls := copy(TComboBox(sender).name, length('zedt_Tmp') + 1,
                  length(TComboBox(sender).name) - length('zedt_Tmp'));
            end;
            try
               li := strtoint(ls);
            except on e: exception do
               begin
               end;
            end;
            lbr := gai_cfg_rights[li];
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
           Tag := (Tag or 4);
           Color := cColorHellgruen;
           if rGDocRight.modify and (pos('_cbx_', TComboBox(sender).name) = 0) then //18.04.2011 b.takacs 3.5.0.178
           begin
                tbi_VSaveDoc.Enabled := True;
                btn_SaveDoc.Enabled := True;
           end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;
            end
            else
            begin
               Color := cColorHellgruen;
            end;
         end;
      end;
   end;
   if Sender is TSpinEdit then
   begin
      with Sender as TSpinEdit do
      begin
      	if bDeactivateTextEdit then
         begin
            SetFocus;
            SelStart := Length(Text);
         end;
         TSpinEdit(sender).MinValue := 0;

         lsnc := copy(TSpinEdit(sender).name, 9, length(TSpinEdit(sender).name));
         lcc := (FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + lsnc));
         if lcc <> nil then
         begin
            if TCOMBOBOX(lcc).text = '' then
            begin
               TCOMBOBOX(lcc).itemindex := 0;
            end;
         end;

         if gbcfgxs then
         begin
            ls := copy(TSpinEdit(sender).name, length('zedt_Tmp') + 1,
               length(TSpinEdit(sender).name) - length('zedt_Tmp'));
            if trystrtoint(ls, li) then
            begin
               lbr := gai_cfg_rights[li];
            end;
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            Color := cColorHellgruen;
            if rGDocRight.modify and (Pos('_og',TSpinEdit(sender).name)=0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
            end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;
            end
            else
            begin
               Color := cColorHellgruen;
            end;
         end;
         Tag := (Tag or 4);
      end;
   end;
   if Sender is TjvSpinEdit then
   begin
      with Sender as TjvSpinEdit do
      begin
      	if bDeactivateTextEdit then
         begin
            SetFocus;
            SelStart := 1;
         end;
      	if (Pos('_og', TjvSpinEdit(sender).name) = 0) then
         begin
         	ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1,
            	length(TEdit(sender).name) - length('zedt_Tmp'));
            if trystrtoint(ls, li)  then
            begin
               if TjvSpinEdit(sender).Value > TjvSpinEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
               	IntToStr(li))).Value then
               	TjvSpinEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
               	IntToStr(li))).Value := TjvSpinEdit(sender).Value;
                  TjvSpinEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
               	IntToStr(li))).Tag := TjvSpinEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
               	IntToStr(li))).Tag or 4;
            end;
         end;

         if gbcfgxs then
         begin
            ls := copy(TjvSpinEdit(sender).name, length('zedt_Tmp') + 1,
               length(TjvSpinEdit(sender).name) - length('zedt_Tmp'));
            if not trystrtoint(ls, li) then
            begin
               ls := copy(TjvSpinEdit(sender).name, length('zedt_Tmp_og_') + 1,
                  length(TjvSpinEdit(sender).name) - length('zedt_Tmp_og_'));
               trystrtoint(ls, li);
            end;
            lbr := gai_cfg_rights[li];
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            Color := cColorHellgruen;
            if rGDocRight.modify and (Pos('_og',TjvSpinEdit(sender).name)=0) then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
            end;
         end
         else
         begin
            if lbr then
            begin
               Color := cColorHellgruen;
            end
            else
            begin
               Color := cColorHellgruen;
            end;
         end;
         Tag := (Tag or 4);
      end;
   end;
   if Sender is TjvCheckedComboBox then
   begin
      with Sender as TjvCheckedComboBox do
      begin
         if gbcfgxs then
         begin
            ls := copy(TEdit(sender).name, length('zedt_Tmp') + 1,
               length(TEdit(sender).name) - length('zedt_Tmp'));
            try
               li := strtoint(ls);
            except on e: exception do
               begin
               end;
            end;
            lbr := gai_cfg_rights[li];
         end;

         if lbr and (dm_db.my_q_arc.recordcount > 0) then
         begin
            noFocusColor := cColorHellgruen;
            if rGDocRight.modify then //18.04.2011 b.takacs 3.5.0.178
            begin
              tbi_VSaveDoc.Enabled := True;
              btn_SaveDoc.Enabled := True;
            end;
         end
         else
         begin
            if lbr then
               noFocusColor := cColorHellgruen
            else
               noFocusColor := cColorHellgruen;
         end;
         Tag := (Tag or 4);
         Modified := True;
	      outputdebugstring(PChar('modified:' + booltostr(Modified)));
      end;
   end;

   //GgfLogEvntEnd ('EnableSaveOnChange End');
end;




procedure Tfrm_MainForm.logtoMemo(msg: string);
begin
end;

procedure Tfrm_MainForm.TBXItem35Click(Sender: TObject);
begin
   GgfLogEvnt('TBXItem35Click');
   ShowFrame(sfDocLink);
   ShowDocLink;
end;

procedure Tfrm_MainForm.DeleteDocumentClick(Sender: TObject);
begin
   GgfLogEvnt('DeleteDocumentClick');
   frm_DelDoc.btn_DelDocClick(self);
   iGArcRecNo := -1;
   HandleDoc; GgfLogEvnt('HandleDoc a');
end;


procedure Tfrm_MainForm.dbtv_LgrArcAdvancedCustomDrawItem(Sender: TCustomTreeView;
   Node: TTreeNode; State: TCustomDrawState; Stage: TCustomDrawStage;
   var PaintImages, DefaultDraw: boolean);
begin
	//GgfLogEvnt(PChar('dbtv_LgrArcAdvancedCustomDrawItem '));
   //highlight with clgray!
   try
      if (Sender.canvas.brush.color = clHighlight) then
      begin
         Sender.canvas.brush.color := clgray;
         Sender.Canvas.Font.Style := [fsBold];
       end;
       If (State = [cdsHot]) and (Stage = cdPrePaint) then
       begin
         Sender.Canvas.Font.Style := [fsUnderline];
         Sender.Canvas.Font.Color := clBlue;
       end
       else If (fDragging) and (Integer(Node.Data) = fidropnode) then
       begin
         Sender.Canvas.Font.Style := [fsUnderline];
         Sender.Canvas.Font.Color := clBlue;
       end
       else if not (cdsSelected in State) then
       begin
         Sender.Canvas.Font.Style := [fsUnderline];
         Sender.Canvas.Font.Style := [];
       end;
	except
   end;
end;

procedure Tfrm_MainForm.tlb_Zoom2MouseMove(Sender: TObject; Shift: TShiftState;
   X, Y: integer);
begin
end;

// Wenn der Benutzer ber den Steuerelementen DE Annotation mit der Maus kreis werden die verfgbaren fre
// freigegebenen Annotation Absender eingeblendet.
// ... so die Idee des Erfinders

procedure Tfrm_MainForm.Button4Click(Sender: TObject);
begin
   GgfLogEvnt('Button4Click');
   dm_MainForm2.GetListOfPrivatAnnos;
   if privAnnoCnt > 0 then
   begin
      bh_privAnno.ActivateHintPos(frm_MainForm, Mouse.CursorPos,
         _('Dieses Dokument') + ' ',
         _('hat') + IntToStr(privannoCnt) + ' ' + _('freigegebene Anmerkungen'));
   end;
end;


procedure Tfrm_MainForm.CreateStandardColumnsTRefferliste;
var
   coltmpNG: Tcolumn;
begin
   GgfLogEvnt('CreateStandardColumnsTRefferliste');
   //  outputdebugstring(pchar('entegin CreateStandardColumnsTRefferliste'));
   with dbgrd_TrefferListe do
      // dynamische Tabelle der Trefferliste erzeugen
   begin
      if frm_mainform.dbgrd_TrefferListe.columns.GetUpdateCount = -1 then
      begin
         frm_mainform.dbgrd_TrefferListe.columns.BeginUpdate;
      end;
      columns.Clear;
      coltmpNG := Columns.add;
      coltmpNG.Width := 70;
      colTmpNG.Title.Caption := _('Dokument');
      colTmpNG.FieldName := 'Disp_Name';
      coltmpNG.Alignment := taLeftJustify;
      coltmpNG.ButtonStyle := cbsAuto;
      coltmpNG.Color := clWhite;
      coltmpNG.DropDownRows := 7;
      coltmpNG.Expanded := False;
      coltmpNG.ReadOnly := True;
      coltmpNG.Visible := True;
      coltmpNG := columns.add;
      coltmpNG.Width := 70;
      colTmpNG.FieldName := 'usr_Name';
      colTmpNG.Title.Caption := _('Benutzer');
      colTmpNG := Columns.Add;
      coltmpNG.Width := 140;
      colTmpNG.FieldName := 'tstamp';
      colTmpNG.Title.Caption := _('Datum');
      colTmpNG.Expanded := True;
      if bMultiArcQuery then // or (dm_db.my_q_Arc.FieldDefList.Find('arc_id')<> nil)  then
      begin
         coltmpNG := columns.add;
         coltmpNG.Width := 70;
         colTmpNG.FieldName := 'arc_id';
         colTmpNG.Title.Caption := _('Archivnummer');
      end;
   end;
   dm_db.my_q_arc.IndexFieldNames := '';
   //  outputdebugstring(pchar('leving CreateStandardColumnsTRefferliste'));
end;

procedure Tfrm_MainForm.dbgrd_WvlExit(Sender: TObject);
begin
   GgfLogEvnt('dbgrd_WvlExit');
   if ((not gbwvlcellclick) and (wvlhasfocus)) and (dpnl_Wvlg.currentdock <> nil) then
   begin
      wvlhasfocus := False;
      wvlshowbuttons(False);
      dbgrd_Wvl.Hide;
      dbgrd_Wvl.Show;
   end;
end;

procedure Tfrm_MainForm.tbi_CopyDocToExtClick(Sender: TObject);
var
   sDocPath, sTmpPath, snamFile, snamFile1: string;
   linfiles: integer;
begin
   GgfLogEvnt('tbi_CopyDocToExtClick');

   if dbgrd_Trefferliste.SelectedRows.Count = 1 then
   begin
      if rGArcRight.Write then
      begin
         if MessageDlg(
            _('Mchten Sie dieses Dokument mit dem Original ersetzen?') +
            ' ' + _('Dadurch gehen Vernderungen verloren, wie z. B. die Drehung, Farbinvertierung,') +
            ' ' + _('etc. (Hinweis: Annotationen bleiben erhalten.)'), mtConfirmation, [mbYes, mbNo], 0) = mrNo then
            exit;

         if iGArcRecNo <> dm_db.my_q_arc.RecNo then
         begin
            dm_db.my_q_Arc.GotoBookmark(
               Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
         end;
         dm_DB.my_q_Arc.RefreshRecord;

         sDocPath := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;

         snamFile := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
         sTmpPath := StringReplace(sDocPath, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);
         CopyFile(PChar(sDocPath), PChar(sTmpPath), False);
         if dm_DB.my_q_Arc.FieldByName('ext_loc').AsString <> sTmpPath then
         begin
            dm_DB.my_q_Arc.Edit;
            dm_DB.my_q_Arc.FieldByName('ext_loc').AsString := sTmpPath;

            dm_DB.my_q_Arc.Post;
         end;
      end
      else
      begin
         BfShowMessage(_('Sie haben keine Schreibrechte') + #13 + _('auf das Dokument'));
      end;
      if rGDocRight.amodify then
      begin
         if dm_MainForm2.Frage(_('Mchten Sie die ffentlichen Annotationen zustzlich lschen?'),
            true) = mrNo then
         begin
            ShowVoransicht(True);
            exit;
         end
         else
         begin
            linfiles := 0;
            snamfile := ChangeFileExt(snamFile, '');
            snamFile1 := snamfile + IntToStr(linfiles);
            while FileExists(snamFile1 + '.IEV') do
            begin
               killfile(snamFile1 + '.IEV');
               snamFile1 := snamFile + IntToStr(linfiles);

               Inc(linfiles);
            end;
         end;
      end
      else
      begin
         BfShowMessage(_('Sie haben keine Rechte') +
            #13 + _('auf das Dokument, um Annotationen zu schreiben(lschen).'));
      end;
   end;
   ShowVoransicht(True);
end;


procedure Tfrm_MainForm.cbx_MaxTrefferChange(Sender: TObject);
var
   litmp: integer;
   lipos: integer;
begin
   GgfLogEvnt('cbx_MaxTrefferChange');

   lipos := cbx_MaxTreffer.Items.IndexOf(cbx_MaxTreffer.Text);
   if lipos > 0 then
   begin
      //alle
      if (cbx_MaxTreffer.Items.Count - 1) = lipos then
      begin
         sGmaxhits := '';
      end
      else
      begin
         sGmaxhits := 'Limit ' + cbx_MaxTreffer.Text;
      end;

   end
   else
   begin
      try
         litmp := StrToInt(cbx_MaxTreffer.Text);
         sgmaxhits := 'Limit ' + IntToStr(litmp);
      except

         on e: Exception do
         begin
            sGmaxhits := 'Limit 50';
            cbx_MaxTreffer.Text := sGmaxhits;
         end;
      end;
   end;
end;

procedure Tfrm_MainForm.tbi_EStampClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_EStampClick');
   fra_Voransicht.createannodata(-1);
   CreateTfrm_Stamps(Self, fra_Voransicht);
end;

procedure Tfrm_MainForm.tbx_favClick(Sender: TObject);
var tbx_fav:TTBXItem;
begin
   GgfLogEvntBeg ('tbx_favClick Begin');

   if not (Sender is TTBXItem) then
      Exit; // nur zur Sicherheit
   tbx_fav := TTBXItem(Sender);
   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      loadfavstampvalues(tbx_fav.tag, tbx_fav.Hint);
      tbx_fav.Checked := true;
      tbi_normalmouse.checked := false;
   end;

   GgfLogEvntEnd ('tbx_favClick End');
end;

procedure Tfrm_MainForm.tbx_lineimClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_lineimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      fra_Voransicht.ReadObjVals(7, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutPolyLine];
      fra_voransicht.img_DocView.PolylineEndingMode := ieemManual;

      fra_voransicht.fphistorymessage := _('Linie');
      tbx_lineim.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbx_noteimClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_noteimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      fra_Voransicht.ReadObjVals(9, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Notiz');
      tbsi_notizen.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;


procedure Tfrm_MainForm.tbx_hiimClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_hiimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      fra_Voransicht.ReadObjVals(11, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutBox];
      fra_voransicht.fphistorymessage := _('Marker');

      tbsi_highlight.Checked := true;

      tbsi_highlight.imageindex := 7;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbx_TextimClick(Sender: TObject);
var
   liresult: integer;
begin
   GgfLogEvnt('tbx_TextimClick');

   uncheckallgraphictools;
   tbi_normalmouse.checked := false;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbxs_text.imageindex := 15;
      fra_Voransicht.ReadObjVals(15, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Textannotation');
      tbxs_text.checked := true;
   end;
end;

procedure Tfrm_MainForm.tbx_wfcancelClick(Sender: TObject); //[2327]
begin
   if fbtimcheck then
      exit;
   if gbArcHandling then
   	exit;

   GgfLogEvnt('tbx_wfcancelClick');
   // we dont need it or?
   dm_db.my_q_Tmp.SQL.Text := 'select rights  FROM sys_arcxs where arc_id = ' +
      IntToStr(iGArcID) + ' and usr_id = ' + IntToStr(iGUsrID) +
      ' and find_in_set(' + #39 + 'workflowbreak' + #39 + ',rights)';
   dm_db.my_q_Tmp.Execute;
   if dm_db.my_q_Tmp.RecordCount > 0 then
   begin
      Gbwfcancel := True;

      tbi_SetState_DoneClick(Sender);
      Gbwfcancel := False;
   end;
end;


procedure Tfrm_MainForm.wvlshowbuttons(fshow: boolean);
begin
   GgfLogEvnt('wvlshowbuttons');

   btn_WvlSpeichern.Enabled := fshow;
   TBX_ciOffen.Enabled := fshow;
   TBX_ciInArbeit.Enabled := fshow;
   TBX_ciFertig.Enabled := fshow;
   tbx_wfcancel.Enabled := fshow;
   if tbi_MyTask.Checked then
   begin
      lbl_wvl_work_name.Visible := fshow;
   end
   else
   begin
      cbx_Usr_WorkNG.Visible := fshow;
   end;

end;

procedure Tfrm_MainForm.resetmyqarc;
begin
   try
      dm_DB.my_q_Arc.Close;
   except on e: exception do
      begin
         logevnt('Error on close my_q_arc ' + e.message);
      end;
   end;
end;

procedure Tfrm_MainForm.tbi_wvldocClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_wvldocClick');
   tbi_vdocTimer.Checked := true;
   tbi_VDocTimerClick(sender);
   TIMESQL('Select  tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_tblname, arc_name,'
      + ' doc_id, doc_titel, info, status, usr_id_work, usr_id_shed, Optionen from sys_timer as a '
      + 'left join sys_arc using(arc_id) where usr_id_work = ' +
      IntToStr(iGUsrID) + ' and  ( status <> 2) and doc_id=' +
      IntToStr(igdocid) + ' and a.arc_id=' + IntToStr(igarcid));
   dbgrd_Wvl.SelectedRows.CurrentRowSelected := true;
   //application.processmessages;
   dbgrd_WvlCellClick(nil);
end;


procedure Tfrm_MainForm.tbx_srcsaveClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_srcsaveClick');

   addToXmlFile(BD.AppdataBitfarmPd + 'Lese.xml', True);
end;

procedure Tfrm_MainForm.tbx_lesemanClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_lesemanClick');
end;

procedure Tfrm_MainForm.WMDROPFILES(var Msg: TWMDropFiles);
var
   i, amount: integer;
   FileName: array[0..MAX_PATH] of char;
   FileNames: string;
begin
   inherited;

   try
      Amount := DragQueryFile(Msg.Drop, $FFFFFFFF, FileName, MAX_PATH);
      FileNames := '';
      for i := 0 to (Amount - 1) do
      begin
         DragQueryFile(Msg.Drop, i, FileName, MAX_PATH);
         FileNames := FileNames + #34 + Filename + #34 + ' ';
      end;
      //todo should get a more abstract(variable dependent) path!!!
      if not FileExists(PChar(BD.ExeDir + 'copytobitfarm.vbs')) then
      begin
      	BfShowMessage(_('Drag and Drop nicht mglich, copytobitfarm.vbs nicht erreichbar.')
         				+ #13 + PChar(BD.ExeDir + 'copytobitfarm.vbs'));
			exit;
      end;
      {err := }ShellExecute(0, 'open', PChar(BD.ExeDir + 'copytobitfarm.vbs'),
         PChar(FileNames), nil, SW_hide); //showmessage(FileName);
   finally
      DragFinish(Msg.Drop);
   end;
end;

procedure Tfrm_MainForm.LBWindowProc(var Message: TMessage);
begin
   if Message.Msg = WM_DROPFILES then
      WMDROPFILES(TWMDropFiles(Message)); // handle WM_DROPFILES message
   GTrOldLBWindowProc(Message);
   // call default ListBox1 WindowProc method to handle all other messages
end;

procedure Tfrm_MainForm.vst_favfileGetText(Sender: TBaseVirtualTree;
   Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
   var CellText: WideString);
var
   lddata: PTreeData;
begin
   lddata := Sender.GetNodeData(Node);
   if Assigned(lddata) then
      CellText := lddata.Caption;
end;


procedure Tfrm_MainForm.vst_favfileDblClick(Sender: TObject);
var
   lddata: PTreeData;
begin
   GgfLogEvnt('vst_favfileDblClick');
   vst_favfile.EndDrag(False);
   if (vst_favfile.GetNodeAt(MousePositionvts_fav.X, MousePositionvts_fav.Y) <> nil) and
      (PTreeData(vst_favfile.GetNodeData(vst_favfile.GetNodeAt(MousePositionvts_fav.x,
      MousePositionvts_fav.Y)))^.index <> 0) then
   begin
      lddata := vst_favfile.GetNodeData(vst_favfile.FocusedNode);
      searchWithNode(lddata.domnode);
   end;
end;

procedure Tfrm_MainForm.searchWithNode(fDomNode: TDomNode);
var
  lbdisp: boolean;
begin
   GgfLogEvntBeg('searchWithNode Begin');

   lbdisp := bAutoDispNew;
   try
      bAutoDispNew := False;
      resetSuchFelder;
      if not Assigned(fDomNode) then
      begin
        GgfLogEvntEnd('searchWithNode End via Exit');
        Exit;
      end;

      fillSearchWithNode(fDomNode, false);
      Self.btn_StartSrcClick(self);
   finally
   	begin
         if gbRefSearchbyFavorite then   // nach einer Verknpfungssuche ber Lesezeichen setzen wir die
         begin                           // Aufbauende Suche zurck, sonst erhalten wir immer wieder das Ergebnis der Verknpfungssuche
            gbRefSearchbyFavorite := False;
		   end;

         bAutoDispNew := lbdisp;

      end;
   end;

   GgfLogEvntEnd('searchWithNode End');
end;

//-----------------------------------------------------------------------------
(* m.frey:
Die alte procedure Tfrm_MainForm.searchWithNode hat alles gemacht. Nun habe
ich das aufgeteilt. Die fillSearchWithNode macht den Kern der Sache. Die
searchWithNode macht den Rahmen und vor allem auch das resetSuchFelder.
*)
procedure Tfrm_MainForm.fillSearchWithNode (fDomNode  : TDomNode;
                                            bAddSearch:Boolean  );
var
   limode, linumber, liCount, liarc, iStat, icount, niStat: integer;
   lsname, lsarcid, lstmp: string;
   liini: Tinifile;
   xComp, xComp01, xCompNegBtnRight: TComponent; // Dummy Komponente
   zLbl: TJvStaticText;
   jvdatetemp: TJvDateEdit;
   jvspintemp: TJvSpinEdit;
   lNode: PVirtualNode;
   DomNode, DomNode1, domnode2, domnode3: TDomNode;
   lddata: PTreeData;
   lic, lic1, lic2, liType: integer;
   Astr, lsspin, lsTextContent: string;
   lstrl: TStringList;
   ldtStart, ldtEnd: TDateTime;
   liyearmultiplier, limonthmultiplier, liweekmultiplier, lidaysmultiplier,
   lidayscounter, lidayscountertmp, limonthcounter, liyearcounter, limonthof: integer;
   lisign, lipos1, lipos2, lipos3, licasefunction1, licasefunction2: integer;
   lmf1, lmf2: Tmydatefunction;
begin
   GgfLogEvntBeg ('fillSearchWithNode Begin');

   jvdatetemp := nil;
   lstrl := TStringList.Create;
   // go through nodes
   GgfLogEvnt('searchWithNode fdomnode.ChildNodes.Length='+IntToStr(fdomnode.ChildNodes.Length));

   //  alle Komponenten leeren, bevor sie mit den XML-Daten neu gefllt werden
   ClearZusFields;

   for lic := 0 to Pred(fdomnode.ChildNodes.Length) do
   begin
      DomNode := fdomnode.ChildNodes.Item(lic);
      lsTextContent := DomNode.TextContent;
      Astr := DomNode.NodeName;

      if Pos('#', Astr) <> 1 then
      begin
         if (Pos('arcid', Astr) = 1) then
         begin
            if StrToInt(trim(lsTextContent)) = 0 then
               lsarcid := '1'
            else
               lsarcid := trim(lsTextContent);
            dm_db.my_q_tmp.sql.Text :=
               'select * from sys_arc where arc_tblname = ' + #39 + lsarcid + #39;
            dm_db.my_q_Tmp.Execute;
            frm_Mainform.dbtv_LgrArc.Select(
               frm_Mainform.dbtv_LgrArc.GetNodeID(StrToInt(lsarcid)), []);
            dbtv_LgrArcSet (True, False); //3.5.0.58 [2328]
         end;

         //  alle Komponenten leeren, bevor sie mit den XML-Daten neu gefllt werden
         DomNode1 := domnode.Attributes.GetNamedItem('text');
         if domnode1 <> nil then
         begin
            if (Pos('zusatzname', Astr) = 1) then
            begin
               //go through zusatzfields
               for liCount := 0 to iGZusFCount - 1 do
               begin
                  zLbl := TJvStaticText(frm_Mainform.sbx_ZusFeld.FindComponent(
                     'zlbl_Tmp' + IntToStr(liCount)));
                  xComp := FindComponentRekursivFrame(frm_Mainform.sbx_ZusFeld, 'zedt_Tmp' +
                     IntToStr(liCount));

                  //[2494]
                  xCompNegBtnRight := FindComponentRekursivFrame(
                                       frm_Mainform.sbx_ZusFeld,
                                       'jvcbzedt_Tmp' + IntToStr(liCount));
                  if xCompNegBtnRight is TJvgCheckBox then
                     TJvgCheckBox(xCompNegBtnRight).Enabled := False;
                  //\\[2494]

                  //found
                  if domnode1.NodeValue = zLbl.hint then
                  begin
                     liType := -1;
                     for lic1 := 0 to Pred(domnode.ChildNodes.Length) do
                     begin
                        DomNode2 := domnode.ChildNodes.Item(lic1);
                        if domnode2 = nil then
                        begin
                           continue;
                        end;
                        if ((domnode2.NodeName = 'type') and (liType = -1)) then
                        begin
                           if domnode2.TextContent = 'edit' then
                           begin
                              liType := 0;
                              break;
                           end;
                           if domnode2.TextContent = 'date' then
                           begin
                              liType := 1;
                              break;
                           end;
                           if domnode2.TextContent = 'comboChecked' then
                           begin
                              liType := 3;
                              break;
                           end;
                           if domnode2.TextContent = 'combo' then
                           begin
                              liType := 2;
                              break;
                           end;
                           if domnode2.TextContent = 'interval-spin' then
                           begin
                              liType := 5;
                              break;
                           end;
                           if domnode2.TextContent = 'zahl' then
                           begin
                              liType := 6;
                              break;
                           end;
                        end;
                     end;
                     // go through child nodes of zusfield
                     for lic1 := 0 to Pred(domnode.ChildNodes.Length) do
                     begin
                        DomNode2 := domnode.ChildNodes.Item(lic1);
                        if domnode2 = nil then
                        begin
                           continue;
                        end;
                        if liType = 0 then
                        begin
                           if (domnode2.NodeName = 'value') then
                           begin
                              TEdit(xComp).Text := domnode2.TextContent;
                              GgfLogEvnt ('Untfeld-Text: *' + TEdit(xComp).Text + '*');
                           end;
                           if (domnode2.NodeName = 'mode') then
                           begin
                              TEdit(xComp).Text := domnode2.TextContent;
                           end;
                           if (TEdit(xComp).Color = cColorNoRightInit) or
                              (TEdit(xComp).Color = cColorNoRight) then
                           begin
                              TEdit(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              TEdit(xComp).Color := cColorHellgruen;
                           end;
                           TEdit(xComp).Modified := True;
                        end;
                        if liType = 1 then
                        begin
                           trystrtoint(copy(TJvDateEdit(xComp).name,
                              length('zedt_Tmp') + 1,
                              length(TJvDateEdit(xComp).name) - length('zedt_Tmp')), linumber);
                           if (domnode2.NodeName = 'valueUG') then
                           begin
                              TJvDateEdit(xComp).Text := domnode2.TextContent;
                           end;

                           // we assume valueOG stand after  valueUG
                           if (domnode2.NodeName = 'valueOG') then
                           begin
                              jvdatetemp :=
                                 TJvDateEdit(frm_Mainform.sbx_ZusFeld.FindComponent(
                                 'zedt_Tmp_og_' + IntToStr(linumber)));
                              jvdatetemp.Text := domnode2.TextContent;

                              if (TJvDateEdit(jvdatetemp).Color = cColorNoRightInit) or
                                 (TJvDateEdit(jvdatetemp).Color = cColorNoRight) then
                              begin
                                 TJvDateEdit(jvdatetemp).Color := cColorNoRight;
                              end
                              else
                              begin
                                 TJvDateEdit(jvdatetemp).Color := cColorHellgruen;
                              end;
                              TJvDateEdit(jvdatetemp).Modified := True;
                           end;
                           // we assume abstand Translationc after   Abstand
                           // we assume ValueUG and ValueOG was set
                           if (domnode2.NodeName = 'Translationc') then
                           begin
                              jvdatetemp :=
                                 TJvDateEdit(frm_Mainform.sbx_ZusFeld.FindComponent(
                                 'zedt_Tmp' + IntToStr(linumber) + 'og'));
                              //                    jvdatetemp.Text := domnode2.TextContent;
                              try
                                 TJvDateEdit(jvdatetemp).Date := TJvDateEdit(xComp).date +
                                    strtoint(domnode2.TextContent);
                                 TJvDateEdit(xComp).date := TJvDateEdit(xComp).date - TJvDateEdit(jvdatetemp).date +
                                    strtoint(domnode2.TextContent);
                              except on e: Exception do
                                 begin
                                 end;
                              end;
                           end;
                           // we assume abstand Translationf after   Translationc
                           if (domnode2.NodeName = 'Translationf') then
                           begin
                              lidaysmultiplier := 0;
                              liweekmultiplier := 0;
                              limonthmultiplier := 0;
                              liyearmultiplier := 0;
                              lmf1 := MyDummyNow;
                              lmf2 := MyDummyNow;
                              for lic2 := 0 to Pred(domnode2.ChildNodes.Length) do
                              begin
                                 domnode3 := domnode2.ChildNodes.Item(lic2);
                                 if domnode3.NodeName = 'days' then
                                 begin
                                    lidaysmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.NodeName = 'week' then
                                 begin
                                    liweekmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.NodeName = 'month' then
                                 begin
                                    limonthmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.NodeName = 'year' then
                                 begin
                                    liyearmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.nodename = 'startend' then
                                 begin
                                    lipos3 := pos('_', domnode3.TextContent);
                                    if lipos3 = 0 then
                                    begin
                                       lipos3 := length(domnode3.TextContent) + 1;
                                    end;
                                    lstmp := copy(domnode3.TextContent, 1, lipos3 - 1);
                                    if lstmp <> '' then
                                    begin
                                       licasefunction1 := strtoint(lstmp);
                                       case licasefunction1 of
                                          1: lmf1 := StartOfTheWeek;
                                          2: lmf1 := StartOfTheMonth;
                                          3: lmf1 := StartOfTheYear;
                                       else  lmf1 := MyDummyNow;
                                       end;
                                    end;
                                    if lipos3 <> length(domnode3.TextContent) + 1 then
                                    begin
                                       lstmp := copy(domnode3.TextContent, lipos3 + 1, length(domnode3.TextContent) - lipos3);
                                       if lstmp <> '' then
                                       begin
                                          licasefunction2 := strtoint(lstmp);
                                          case licasefunction2 of
                                             1: lmf2 := EndOfTheWeek;
                                             2: lmf2 := EndOfTheMonth;
                                             3: lmf2 := EndOfTheYear;
                                          else  lmf2 := MyDummyNow;
                                          end;
                                       end;
                                    end;
                                 end;
                              end;
                              licasefunction2 := 0;
                              TJvDateEdit(xComp).date := now;
                              TJvDateEdit(jvdatetemp).Date := now;

                              lidayscounter := 0;
                              liyearcounter := 0;
                              if liyearmultiplier <> 0 then
                              begin
                                 lisign := trunc(liyearmultiplier / abs(liyearmultiplier));
                                 while liyearcounter < abs(liyearmultiplier) do
                                 begin
                                    limonthcounter := 0;
                                    while limonthcounter < 12 do
                                    begin
                                       limonthof := ((MonthOf(TJvDateEdit(xComp).Date + lidayscounter) + lisign) mod 12);
                                       if limonthof = 0 then
                                          limonthof := 12;
                                       lidayscountertmp := daysinamonth(YearOf(TJvDateEdit(xComp).Date + lidayscounter),
                                          limonthof);
                                       lidayscounter := lidayscounter + lisign * lidayscountertmp;
                                       limonthcounter := limonthcounter + 1;
                                    end;
                                    inc(liyearcounter);
                                 end;
                              end;
                              if limonthmultiplier <> 0 then
                              begin
                                 limonthcounter := 0;
                                 lisign := trunc(limonthmultiplier / abs(limonthmultiplier));
                                 while limonthcounter < abs(limonthmultiplier) do
                                 begin
                                    limonthof := (MonthOf(TJvDateEdit(xComp).Date + lidayscounter) + lisign) mod 12;
                                    if limonthof = 0 then
                                       limonthof := 12;
                                    lidayscountertmp := daysinamonth(YearOf(TJvDateEdit(xComp).Date + lidayscounter), limonthof);
                                    lidayscounter := lidayscounter + lisign * lidayscountertmp;
                                    limonthcounter := limonthcounter + 1;
                                 end;
                              end;

                              lidayscounter := lidayscounter + lidaysmultiplier;
                              lidayscounter := lidayscounter + liweekmultiplier * 7;
                              ldtStart := lmf1(TJvDateEdit(xComp).Date + lidayscounter);
                              ldtEnd := lmf2(TJvDateEdit(xComp).Date + lidayscounter);
                              TJvDateEdit(xComp).date := ldtStart;
                              //                    TJvDateEdit(xComp).date-TJvDateEdit(jvdatetemp).date+now;
                              TJvDateEdit(jvdatetemp).Date := ldtEnd;
                           end;

                           // we assume abstand stand after   valueOG
                           if (domnode2.NodeName = 'Abstand') then
                           begin
                              lidaysmultiplier := 0;
                              liweekmultiplier := 0;
                              limonthmultiplier := 0;
                              liyearmultiplier := 0;
                              lmf1 := MyDummyNow;
                              lmf2 := MyDummyNow;
                              for lic2 := 0 to Pred(domnode2.ChildNodes.Length) do
                              begin
                                 domnode3 := domnode2.ChildNodes.Item(lic2);
                                 if domnode3.NodeName = 'days' then
                                 begin
                                    lidaysmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.NodeName = 'week' then
                                 begin
                                    liweekmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.NodeName = 'month' then
                                 begin
                                    limonthmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.NodeName = 'year' then
                                 begin
                                    liyearmultiplier := strtoint(domnode3.TextContent);
                                 end;
                                 if domnode3.nodename = 'startend' then
                                 begin
                                    lipos3 := pos('_', domnode3.TextContent);
                                    if lipos3 = 0 then
                                    begin
                                       lipos3 := length(domnode3.TextContent) + 1;
                                    end;
                                    lstmp := copy(domnode3.TextContent, 1, lipos3 - 1);
                                    if lstmp <> '' then
                                    begin
                                       licasefunction1 := strtoint(lstmp);
                                       case licasefunction1 of
                                          1: lmf1 := StartOfTheWeek;
                                          2: lmf1 := StartOfTheMonth;
                                          3: lmf1 := StartOfTheYear;
                                       else  lmf1 := MyDummyNow;
                                       end;
                                    end;
                                    if lipos3 <> length(domnode3.TextContent) + 1 then
                                    begin
                                       lstmp := copy(domnode3.TextContent, lipos3 + 1, length(domnode3.TextContent) - lipos3);
                                       if lstmp <> '' then
                                       begin
                                          licasefunction2 := strtoint(lstmp);
                                          case licasefunction2 of
                                             1: lmf2 := EndOfTheWeek;
                                             2: lmf2 := EndOfTheMonth;
                                             3: lmf2 := EndOfTheYear;
                                          else  lmf2 := MyDummyNow;
                                          end;
                                       end;
                                    end;
                                 end;
                              end;
                              licasefunction2 := 0;
                              lidayscounter := 0;
                              liyearcounter := 0;
                              if liyearmultiplier <> 0 then
                              begin
                                 lisign := trunc(liyearmultiplier / abs(liyearmultiplier));
                                 while liyearcounter < abs(liyearmultiplier) do
                                 begin
                                    limonthcounter := 0;
                                    while limonthcounter < 12 do
                                    begin
                                       limonthof := ((MonthOf(TJvDateEdit(xComp).Date + lidayscounter) + lisign) mod 12);
                                       if limonthof = 0 then
                                          limonthof := 12;
                                       lidayscountertmp := daysinamonth(YearOf(TJvDateEdit(xComp).Date + lidayscounter), limonthof);
                                       lidayscounter := lidayscounter + lisign * lidayscountertmp;
                                       limonthcounter := limonthcounter + 1;
                                    end;
                                    inc(liyearcounter);
                                 end;
                              end;
                              if limonthmultiplier <> 0 then
                              begin
                                 limonthcounter := 0;
                                 lisign := trunc(limonthmultiplier / abs(limonthmultiplier));
                                 while limonthcounter < abs(limonthmultiplier) do
                                 begin
                                    limonthof := (MonthOf(TJvDateEdit(xComp).Date + lidayscounter) + lisign) mod 12;
                                    if limonthof = 0 then
                                       limonthof := 12;
                                    lidayscountertmp := daysinamonth(YearOf(TJvDateEdit(xComp).Date + lidayscounter), limonthof);
                                    lidayscounter := lidayscounter + lisign * lidayscountertmp;
                                    limonthcounter := limonthcounter + 1;
                                 end;
                              end;

                              lidayscounter := lidayscounter + lidaysmultiplier;
                              lidayscounter := lidayscounter + liweekmultiplier * 7;
                              if lidayscounter < 0 then
                              begin
                                 ldtStart := lmf1(TJvDateEdit(xComp).Date + lidayscounter);
                                 ldtEnd   := lmf2(TJvDateEdit(xComp).Date);
                              end
                              else
                              begin
                                 ldtStart := lmf1(TJvDateEdit(xComp).Date);
                                 ldtEnd   := lmf2(TJvDateEdit(xComp).Date + lidayscounter);
                              end;
                              TJvDateEdit(xComp).date := ldtStart;
                              //                    TJvDateEdit(xComp).date-TJvDateEdit(jvdatetemp).date+now;
                              TJvDateEdit(jvdatetemp).Date := ldtEnd;
                           end;
                           if (domnode2.NodeName = 'mode') then
                           begin
                              TJvDateEdit(xComp).Tag := StrToInt(domnode2.TextContent);
                           end;
                           if (TJvDateEdit(xComp).Color = cColorNoRightInit) or
                              (TJvDateEdit(xComp).Color = cColorNoRight) then
                           begin
                              TJvDateEdit(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              TJvDateEdit(xComp).Color := cColorHellgruen;
                           end;
                           TJvDateEdit(xComp).Modified := True;
                        end;
                        if liType = 2 then
                        begin
                           if (domnode2.NodeName = 'value') then
                           begin
                              TComboBox(xComp).ItemIndex := TComboBox(xComp).Items.IndexOf(domnode2.TextContent);
                           end;
                           if (domnode2.NodeName = 'mode') then
                           begin
                              TComboBox(xComp).Tag := StrToInt(domnode2.TextContent);
                           end;
                           if (TComboBox(xComp).Color = cColorNoRightInit) or
                              (TComboBox(xComp).Color = cColorNoRight) then
                           begin
                              TComboBox(xComp).Color := cColorNoRight;
                           end
                           else
                           begin
                              TComboBox(xComp).Color := cColorHellgruen;
                           end;
                        end;
                        if liType = 3 then  //  02.06.2010  Vers. 3.5.0.80  [2450]  r.sch.
                        begin
                           if (domnode2.NodeName = 'value') then
                           begin
                              TjvCheckedComboBox(xComp).Text := domnode2.TextContent;
                           end;
                           if (domnode2.NodeName = 'mode') then
                           begin
                              TjvCheckedComboBox(xComp).Tag := StrToInt(domnode2.TextContent);
                           end;
                           if (TjvCheckedComboBox(xComp).noFocusColor = cColorNoRightInit) or
                              (TjvCheckedComboBox(xComp).noFocusColor = cColorNoRight) then
                           begin
                              TjvCheckedComboBox(xComp).noFocusColor := cColorNoRight;
                           end
                           else
                           begin
                              TjvCheckedComboBox(xComp).noFocusColor := cColorHellgruen;
                           end;
                        end;
                        if liType = 5 then
                        begin
                           xComp01 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(liCount));
                           if (domnode2.NodeName = 'value') then
                           begin
                              lsspin := domnode2.TextContent;
                              if lsspin <> '' then
                              begin
                                 try
                                    Tspinedit(xComp).Value := strtoint(
                                       copy(lsspin, 0, length(lsspin) - 1));
                                    TCombobox(xComp01).Text :=
                                       copy(lsspin, length(lsspin), 1);
                                 except on e: exception do
                                    begin
                                    end;
                                 end;
                              end
                              else
                              begin
                                 Tspinedit(xComp).text := '';
                                 TCombobox(xComp01).Text := '';
                              end;
                           end;

                           if (domnode2.NodeName = 'mode') then
                           begin
                              Tspinedit(xComp).Tag := StrToInt(domnode2.TextContent);
                              TCombobox(xComp01).Tag := StrToInt(domnode2.TextContent);
                           end;
                           if (Tspinedit(xComp).Color = cColorNoRightInit) or
                              (Tspinedit(xComp).Color = cColorNoRight) then
                           begin
                              Tspinedit(xComp).Color := cColorNoRight;
                              TCombobox(xComp01).Color := cColorNoRight;
                           end
                           else
                           begin
                              Tspinedit(xComp).Color := cColorHellgruen;
                              TCombobox(xComp01).Color := cColorHellgruen;
                           end;
                        end;

                        if liType = 6 then
                        begin
                           trystrtoint(copy(TJvSpinEdit(xComp).name,
                              length('zedt_Tmp') + 1,
                              length(TJvSpinEdit(xComp).name) - length('zedt_Tmp')), linumber);
                           if (domnode2.NodeName = 'valueUG') then
                           begin
                              TJvSpinEdit(xComp).Text := domnode2.TextContent;
                              if (TJvSpinEdit(xComp).Color = cColorNoRightInit) or
                                 (TJvSpinEdit(xComp).Color = cColorNoRight) then
                              begin
                                 TJvSpinEdit(xComp).Color := cColorNoRight;
                              end
                              else
                              begin
                                 TJvSpinEdit(xComp).Color := cColorHellgruen;
                              end;
                              TJvSpinEdit(xComp).Modified := True;
                           end;

                           // we assume valueOG stand after  valueUG
                           if (domnode2.NodeName = 'valueOG') then
                           begin
                              jvspintemp :=
                                 TJvSpinEdit(frm_Mainform.sbx_ZusFeld.FindComponent(
                                 'zedt_Tmp_og_' + IntToStr(linumber)));
                              jvspintemp.Text := domnode2.TextContent;

                              if (TJvSpinEdit(jvspintemp).Color = cColorNoRightInit) or
                                 (TJvSpinEdit(jvspintemp).Color = cColorNoRight) then
                              begin
                                 TJvSpinEdit(jvspintemp).Color := cColorNoRight;
                              end
                              else
                              begin
                                 TJvSpinEdit(jvspintemp).Color := cColorHellgruen;
                              end;
                              TJvSpinEdit(jvspintemp).Modified := True;
                           end;

                           if (domnode2.NodeName = 'mode') then
                           begin
                              jvspintemp :=
                                 TJvSpinEdit(frm_Mainform.sbx_ZusFeld.FindComponent(
                                 'zedt_Tmp_og_' + IntToStr(linumber)));
                              TJvSpinEdit(xComp).Tag := StrToInt(domnode2.TextContent);
                              TJvSpinEdit(jvspintemp).Tag := StrToInt(domnode2.TextContent);
                           end;
                        end;
                     end;
                  end;
               end;
            end;
            lstrl.add(domnode.NodeName + ' ' + domnode1.NodeValue);
         end;
         if (Pos('slw', Astr) = 1) then
         begin
            Self.edt_SSLW.Text := lsTextContent;
         end;

         if (Pos('maxvalues', Astr) = 1) then
         begin
            Self.cbx_MaxTreffer.Text := trim(lsTextContent);
         end;

         if (Pos('iStat', Astr) = 1) then
         begin
            chbx_SOnlyUsed.Checked := true;

            iStat := strtoint(trim(lsTextContent));
            gmodsearchiStatus := 0;

            if (iStat and 1) = 1 then
            begin
               tci_InUse.Color := cllime;   GgfLogEvnt('tci_InUse.Color := cllime [15]');
               gmodsearchiStatus := 1;
               gmodiStatus := 1;
            end;
            for iCount := 5 to (tlb_Status.Items.Count - 1) do
            begin
               // for all items which color is lime set a search bit
               // question is why it finds also the documents whith unseted bit
               // answer: it doesnt find!!! maybe it can be changed...
               // WHY XOR!!???
               //search only modified fields
               if (iStat and (1 shl (iCount - 5))) > 0 then
               begin
                  TTBXColorItem(tlb_Status.Items.Items[iCount]).Color := clLime;
                  gmodsearchiStatus := gmodsearchiStatus or (1 shl (iCount - 5));
                  gmodiStatus := gmodiStatus or (1 shl (iCount - 5));
               end;
            end;
         end;
         if (Pos('niStat', Astr) = 1) then
         begin
            chbx_SOnlyUsed.Checked := true;
            gmodsearchiStatus := 0;
            niStat := strtoint(trim(lsTextContent));

            if (niStat and 1) = 1 then
            begin
               tci_InUse.Color := clRed;
               gmodsearchiStatus := 1;
            end;
            for iCount := 5 to (tlb_Status.Items.Count - 1) do
            begin
               // for all items which color is lime set a search bit
               // question is why it finds also the documents whith unseted bit
               // answer: it doesnt find!!! maybe it can be changed...
               // WHY XOR!!???
               if (niStat and (1 shl (iCount - 5))) > 0 then
               begin
                  TTBXColorItem(tlb_Status.Items.Items[iCount]).Color := clRed;
                  gmodsearchiStatus := gmodsearchiStatus or (1 shl (iCount - 5));
               end;
            end;
         end;

         if (Pos('benutzer', Astr) = 1) then
         begin
            Self.cbx_SUsr.Text := lsTextContent;
         end;

         if (Pos('datevom', Astr) = 1) then
         begin
            Self.chbx_SDatum.Checked := True;
            Self.dtp_SVon.DateTime := strtofloat(lsTextContent);
         end;

         if (Pos('datebis', Astr) = 1) then
         begin
            Self.dtp_SBis.DateTime := strtofloat(lsTextContent);
         end;

         if (Pos('refsearch', Astr) = 1) then
         begin
            Self.chbx_SRefSea.checked := true;
            Self.edt_SRefSea.text := lsTextContent;
            gbRefSearchbyFavorite := True;
         end;
         if (Pos('vtx', Astr) = 1) then
         begin
            Self.memo_VTX.Text := lsTextContent;
         end;
      end;
   end;

   GgfLogEvntEnd('fillSearchWithNode End');
end;


procedure Tfrm_MainForm.UpdateTreeView(const Doc          : TdomDocument;
                                             fmytviewX    : TTreeview;
                                             fbAppendfirst: boolean     );

   procedure HandleNodeList(Parent        : TTreeNode;
                            ANode         : PVirtualNode;
                            DomNodeList   : TDomNodeList;
                            ffbAppendfirst: boolean     );
   var
      I, J: integer;
      DomNode, DomNode1, Domnode2, DNUrights, DNGrights: TDomNode;
      Tn: TTreeNode;
      Pvn: PVirtualNode;
      Astr, Astr1: string;
      ltmylist: Tstringlist;
      lbfound: boolean;
      Data: PTreeData;

   begin
      TN := nil;

      for I := 0 to Pred(DomNodeList.Length) do
      begin
         try
            DomNode := DomNodeList.Item(I);

            Astr := DomNode.NodeName;

            if Pos('#', Astr) <> 1 then
            begin
               if Astr = 'fav' then
               begin
                  DomNode1 := domnode.Attributes.GetNamedItem('name_fav');
                  DomNode2 := domnode.Attributes.GetNamedItem('Suchdatum');

                  if domnode1 <> nil then
                  begin
                     Astr := domnode1.NodeValue;
                  end;
                  //should go through the items of <fav>
                  Pvn := frm_mainform.vst_favfile.AddChild(ANode);
                  Data := frm_mainform.vst_favfile.GetNodeData(Pvn);
                  Astr1 := Astr;
                  if not bgisverlauffav then
                  begin
                     givirstualfiles := givirstualfiles + 1;
                     setlength(gpvnvirstualfiles, givirstualfiles);
                     gpvnvirstualfiles[givirstualfiles - 1].PVNode := Pvn;
                     gpvnvirstualfiles[givirstualfiles - 1].domnode := DomNode;
                     gpvnvirstualfiles[givirstualfiles - 1].Name := Astr1;

                  end
                  else
                  begin
                     if domnode2 <> nil then
                     begin
                        if DomNode2.NodeValue <> '' then
                        begin
                           Astr1 := DomNode2.NodeValue;
                        end;
                     end;
                  end;
                  frm_mainform.vst_favfile.ValidateNode(Pvn, False);
                  Data.Caption := Astr1;
                  Data.domnode := DomNode;
                  Data.index := 1;
                  tn := nil;
                  if ffbAppendfirst then
                  begin
                     if Parent <> nil then
                        Tn := Parent.Owner.AddChildObjectFirst(Parent, Astr1, DomNode);
                  end
                  else
                  begin
                     Tn := Parent.Owner.AddChildObject(Parent, Astr1, DomNode);
                  end;
                  if tn <> nil then
                  begin
                     Tn.ImageIndex := 1;
                     tn.SelectedIndex := 3;
                  end;
               end
               else
               if Astr = 'folder' then
               begin
                  DomNode1 := domnode.Attributes.GetNamedItem('folder_name');
                  if domnode1 <> nil then
                  begin
                     Astr := domnode1.NodeValue;
                  end;

                  Pvn := frm_mainform.vst_favfile.AddChild(ANode);
                  Data := frm_mainform.vst_favfile.GetNodeData(Pvn);
                  frm_mainform.vst_favfile.ValidateNode(Pvn, False);
                  Data.Caption := Astr;
                  Data.domnode := DomNode;

                  Data.index := 0;
                  if ffbAppendfirst then
                  begin
                     Tn := Parent.Owner.AddChildObjectFirst(Parent, Astr, DomNode);
                  end
                  else
                  begin
                     Tn := Parent.Owner.AddChildObject(Parent, Astr, DomNode);
                  end;
                  Tn.ImageIndex := 0;
                  tn.SelectedIndex := 2;
               end
               else
               if Astr = 'Lesezeichen' then
               begin
                  DomNode1 := domnode.Attributes.GetNamedItem('name');
                  if domnode1 <> nil then
                  begin
                     Astr1 := domnode1.NodeValue;
                  end
                  else
                  begin
                     Astr1 := '';
                  end;

                  if Parent = nil then
                  begin
                     Tn := fmytviewX.Items.AddChildObject(Parent, _(Astr1) + _(Astr), DomNode);
                  end
                  else
                  begin
                     Tn := Parent.Owner.AddChildObject(Parent,  _(Astr1) + _(Astr), DomNode);
                  end;
                  Tn.ImageIndex := 0;
                  tn.SelectedIndex := 2;
                  Pvn := frm_mainform.vst_favfile.AddChild(ANode);
                  Data := frm_mainform.vst_favfile.GetNodeData(Pvn);
                  frm_mainform.vst_favfile.ValidateNode(Pvn, False);
                  Data.Caption :=  _(Astr1) + _(Astr);
                  if Astr1 = 'Lokale ' then
                  begin
                     frm_mainform.vst_favfile.FocusedNode := Pvn;
                     fpvnlokalefav := Tn;
                  end
                  else
                  if Astr1 = 'Verlauf-' then
                  begin
                     fpvnhistofav := Tn;
                     frm_mainform.vst_favfile.FocusedNode := Pvn;
                     bgisverlauffav := true;
                  end
                  else

                  Data.domnode := DomNode;
                  Data.index := 0;
               end
               else
               if Astr = 'arcid' then
               begin
                  if not bgisverlauffav then
                  begin
                     gpvnvirstualfiles[givirstualfiles - 1].ArcID :=
                        StrToInt(trim(DomNode.TextContent));
                  end;
               end;

               if TN <> nil then
               begin
                  tn.MakeVisible;
               end;
               if Assigned(DomNode.ChildNodes) then
                  HandleNodeList(Tn, Pvn, DomNode.ChildNodes, ffbAppendfirst);
            end;
         except on e: Exception do
            begin
               LogEvnt('9001    ' + _('Fehler') + ' in Modul: HandleNodeList    ' + e.Message);
            end;
         end;
      end;
   end;
begin
   if not Assigned(Doc) then //m.frey
      Exit;

   GgfLogEvnt('UpdateTreeView');

   bgisverlauffav := false;
   try
      try
         HandleNodeList(nil, nil, Doc.ChildNodes, fbAppendfirst);
      except on e: Exception do
         begin
            logevnt('Error on updatetree :' + e.message);
         end;
      end;
   finally
      bgisverlauffav := false;
   end;

   GgfLogEvnt('leaving UpdateTreeView');
end;


procedure Tfrm_MainForm.vst_favfileGetImageIndex(Sender: TBaseVirtualTree;
   Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
   var Ghosted: boolean; var ImageIndex: integer);
var
   Data: PTreeData;
begin
   GgfLogEvnt('vst_favfileGetImageIndex');

   Data := frm_mainform.vst_favfile.GetNodeData(node);
   if Data.index = 1 then
   begin
      imageindex := 1;
   end
   else
   begin
      imageindex := 0;
   end;
end;

procedure Tfrm_MainForm.vst_favfileEditing(Sender: TBaseVirtualTree;
   Node: PVirtualNode; Column: TColumnIndex; var Allowed: boolean);
begin
   allowed := True;
end;

procedure Tfrm_MainForm.vst_favfileNewText(Sender: TBaseVirtualTree;
   Node: PVirtualNode; Column: TColumnIndex; NewText: WideString);
var
   Data: PTreeData;
begin
   Data := Sender.GetNodeData(Node);
   if Assigned(Data) then
      Data.Caption := NewText;
end;

procedure Tfrm_MainForm.vst_favfileDragOver(Sender: TBaseVirtualTree;
   Source: TObject; Shift: TShiftState; State: TDragState; Pt: TPoint;
   Mode: TDropMode; var Effect: integer; var Accept: boolean);
begin
   if Source = nil then
   begin
      exit;
   end;

   if ((Source.ClassName = tvirtualstringtree.ClassName)) then
   begin
      accept := True;
      //    Outputdebugstring(PChar('dropped '));
      if (not (cslbuttondown in vst_favfile.ControlState)) then
      begin
      end;
   end;
end;

procedure Tfrm_MainForm.vst_favfileMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: integer);
var
   lpt: Pvirtualnode;
begin
   MousePositionvts_fav.x := x;
   MousePositionvts_fav.y := y;
   lpt := vst_favfile.GetNodeAt(x, Y);
   if lpt = nil then
   begin
      exit;
   end;

   if (cslbuttondown in vst_favfile.ControlState) and (not vst_favfile.Dragging) and
      (PTreeData(vst_favfile.GetNodeData(lpt))^.index <> 0) then
   begin
      vst_favfile.BeginDrag(True, 20);
   end;
end;


procedure Tfrm_MainForm.vst_favfileMouseUp(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: integer);
begin
   GgfLogEvnt('vst_favfileMouseUp');
   if not (vst_favfile.ControlState = [csLButtonDown]) then
      vst_favfile.EndDrag(False);
end;

procedure Tfrm_MainForm.pumOrdnerHinzufuegenClick(Sender: TObject);
var
   sordname: string;
   Pvnsrc, Pvndest: TTreenode;
   Data1: Tdomnode;
   Doc: TdomDocument;
   FNodeElement: TDomElement;
   DomNode0, domnode1: Tdomnode;
begin
   GgfLogEvnt('pumOrdnerHinzufuegenClick');
   if InputQuery(_('Ordner Hinzufgen'),
      _('Bitte geben Sie einen neuen Namen ein:'),
      sordname) then
   begin
      Pvnsrc := tv_lese.Selected;
      //save to dom
      Doc := (dm_MainForm2.XmlToDomParser_local.DOMImpl.Documents.Item(0) as
         TdomDocument);
      FNodeElement := TDomElement.Create(Doc, 'folder');
      fnodeelement.SetAttribute('folder_name', sordname);
      if Pvnsrc = nil then
      begin
         DomNode0 := Doc.ChildNodes.Item(0);
         domnode1 := domnode0.AppendChild(fnodeelement);
         Pvndest := tv_lese.Items.AddChildObject(nil, sordname, domnode1);
      end
      else
      begin
         Data1 := Pvnsrc.Data;
         if data1 = nil then
         begin
            DomNode0 := Doc.ChildNodes.Item(0);
            domnode1 := domnode0.AppendChild(fnodeelement);
         end
         else
         begin
            domnode1 := data1.AppendChild(fnodeelement);
         end;
         Pvndest := tv_lese.Items.AddChildObject(Pvnsrc, sordname, domnode1);
      end;
      Pvndest.SelectedIndex := 2;
      Pvndest.ImageIndex := 0;
   end;
end;

//-----------------------------------------------------------------------------
//3.5.0.45 [2271]
procedure Tfrm_MainForm.pumOrdnerLoeschenClick(Sender: TObject);
   function Loeschbar(Node: TTreenode):Boolean;
   var ls: string;
   begin
      Result:=false;
      if Node=nil
      then Exit;
      if Node.Parent=nil
      then Exit;

      while Node.Parent<>nil do
         Node:=Node.Parent;
      if Node.Text <> _('Lokale Lesezeichen') then
         Exit;
      Result:=true;
   end;
var
   lsOrdname, lsMsg: string;
   Pvnsrc, Pvndest: TTreenode;
   Data1: Tdomnode;
   Doc: TdomDocument;
   FNodeElement: TDomElement;
   DomNode0, domnode1, DomNode: TDomNode;
begin
   GgfLogEvnt('pumOrdnerHinzufuegenClick');
   Pvnsrc := tv_lese.Selected;
   if not Loeschbar(Pvnsrc) then
   begin
       BfMessageDlg(_('Diesen Ordner drfen Sie nicht lschen!') , mtError, [mbOK], 0);
       Exit;
   end;

   lsOrdname := Pvnsrc.Text;
   lsMsg := Format(_('Sind Sie sicher, dass Sie den Ordner "%s" lschen wollen? Alle ggf. enthaltenen Lesezeichen werden ebenfalls gelscht!'),
                   [lsOrdname]);
   if BfMessageDlg( lsMsg, mtConfirmation, [mbYes, mbNo], 0) = mrYes then
   begin
      Doc := (dm_MainForm2.XmlToDomParser_local.DOMImpl.Documents.Item(0) as
         TdomDocument);
      DomNode := TDomNode(Pvnsrc.Data);
      DomNode.FindParentElement.RemoveChild(DomNode);
      Pvnsrc.Delete;
   end;
end;

//-----------------------------------------------------------------------------
function Tfrm_MainForm.Savefavtree: boolean;
var
   Stream: TFileStream;
   Doc: TdomDocument;
   liint: integer;
begin
   GgfLogEvnt('Savefavtree');
   result := false;
   liint := 0;
   try
      Doc := (dm_MainForm2.XmlToDomParser_local.DOMImpl.Documents.Item(0) as TdomDocument);
      inc(liint);
      Stream := TFileStream.Create(BD.AppdataBitfarmPd + 'Lese.xml', fmCreate);
      inc(liint);
      try
         dm_MainForm2.DomToXMLParser_local.WriteToStream(Doc, 'ISO-8859-1', Stream);
         inc(liint);
      finally
         Stream.Free;
         inc(liint);
      end;
      Doc := (dm_MainForm2.XmlToDomParser_history.DOMImpl.Documents.Item(0) as TdomDocument);
      inc(liint);

      Stream := TFileStream.Create(BD.AppdataBitfarmPd + 'History.xml', fmCreate);
      inc(liint);
      try
         dm_MainForm2.DomToXMLParser_local.WriteToStream(Doc, 'ISO-8859-1', Stream);
         inc(liint);
      finally
         Stream.Free;
         inc(liint);
      end;
   except

   end;
end;

procedure Tfrm_MainForm.img_linkClick(Sender: TObject);
var
   lssearch: string;
begin
   GgfLogEvnt('i_newdoclinksuchClick');
   lssearch := '';
   if edt_SRefSea.Text <> '' then
   begin
      lssearch := edt_SRefSea.Text;
   end;
   //search for the ref in  lbl_ChoosenLink
   if lbl_ChoosenLink.Caption <> '' then
   begin
      lssearch := lbl_ChoosenLink.Caption;
   end;
   if lssearch <> '' then
   begin
      lssearch := lbl_ChoosenLink.Caption;
      chbx_SRefSea.Checked := True;
      btn_ResFieldsClick(self);
      lbl_ChoosenLink.Caption := lssearch;
      frm_mainform.lbl_choosenLink.Visible := True;
      frm_mainform.img_link.Visible := True;
      edt_SRefSea.Text := lssearch;

      bitbtn1Click(self);
   end;
end;


procedure Tfrm_MainForm.dbtv_LgrArcStartDrag(Sender: TObject;
   var DragObject: TDragObject);
begin
   //GgfLogEvnt('dbtv_LgrArcStartDrag');

   dbtv_LgrArc.EndDrag(False);
end;

procedure Tfrm_MainForm.dbtv_LgrArcEndDrag(Sender, Target: TObject; X, Y: integer);
begin
   //GgfLogEvnt('dbtv_LgrArcEndDrag');

   if Sender is TpsDBTreeView then
   begin
      dbtv_LgrArc.EndDrag(False);
   end;
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  	if OperationLock then
  		Exit;

   if Length(GSelection) > 0 then
   begin
      	fDragging := True;
         Markieren2(Sender);
         gbbegindragtrefferliste := False;
   end;
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteEndDrag(Sender, Target: TObject;
  X, Y: Integer);
begin
	//OutputDebugString('dbgrd_TrefferlisteEndDrag');
   fDragging := False;
   gbbegindragtrefferliste := False;
   frm_MainForm.dbtv_LgrArc.Repaint;
end;

procedure Tfrm_MainForm.vst_favfileKeyUp(Sender: TObject; var Key: word; Shift: TShiftState);
var
   lddata: PTreeData;
   ldompar: tdomnode;
begin
   GgfLogEvnt('vst_favfileKeyUp');
   if key = VK_DELETE then
   begin
      //Doc := (dm_MainForm2.XmlToDomParser_local.DOMImpl.Documents.Item(0) as TdomDocument);
      lddata := vst_favfile.GetNodeData(vst_favfile.FocusedNode);
      ldompar := lddata.domnode.ParentNode;
      ldompar.RemoveChild(lddata.domnode);
      vst_favfile.DeleteNode(vst_favfile.FocusedNode, True);
   end;
end;

procedure Tfrm_MainForm.dbgrd_trefferlisteMouseWheel(Sender: TObject;
   Shift: TShiftState; WheelDelta: integer; MousePos: TPoint; var Handled: boolean);
var
   Direction: shortint;
begin
   GgfLogEvnt('dbgrd_trefferlisteMouseWheel');
   Direction := 1;

   if WheelDelta = 0 then
      Exit
   else
   if WheelDelta > 0 then
      Direction := -1;

   with TDBGrid(Sender) do
   begin
      if Assigned(DataSource) and Assigned(DataSource.DataSet) then
         DataSource.DataSet.MoveBy(Direction * GetNumScrollLines);
      Invalidate;
   end;
end;

procedure Tfrm_MainForm.loadfavstampvalues(fktag: integer; favtext: string);
var
   iSHeight, iSWidth, liposzus, liposzus1, lizus: integer;
   mesTmp: TIEUnits;
   reg: TRegistry;
   lsfilename: string;
   ltim: TIEMouseInteractVt;
   sStampText, sDate, sTime, lszusname, lszusnr: string;
   fsTmp: TFontStyles;
begin
   GgfLogEvnt('loadfavstampvalues');
   iSHeight := 0;
   iSWidth := 0;
   uncheckallgraphictools;
   tbi_normalmouse.checked := false;
   fra_Voransicht.LoadStamp(gasfavstemp[fktag]);
end;

procedure Tfrm_MainForm.tbx_noteimgreenClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_noteimgreenClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_notizen.ImageIndex := 10;
      fra_Voransicht.ReadObjVals(25, -1);
      //  fra_voransicht.img_docview.ObjBrushColor[-1] := cllime;
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Grne Notiz');
      tbsi_notizen.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbx_noteimyellowClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_noteimyellowClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_notizen.ImageIndex := 5;
      fra_Voransicht.ReadObjVals(9, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Gelbe(selbstdefinierte) Notiz');
      tbx_noteimyellow.Checked := true;
      tbsi_notizen.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbx_noteimredClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_noteimredClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_notizen.ImageIndex := 11;
      fra_Voransicht.ReadObjVals(26, -1);
      //  fra_voransicht.img_docview.ObjBrushColor[-1] := clred;
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Rote Notiz');
      tbsi_notizen.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;


procedure Tfrm_MainForm.tbi_createemptypageClick(Sender: TObject);
var
   lslogdate, lsPath, lsFileNameTif, lsFileNameFullTif, lsFileNameFullTxt,
   lsTmpName, lsSql, lsDbPathTif, lsDbPathTxt, lsTmp2: string;
   li: TImageEn;
   lbit: Tiebitmap;
   liid, ligid: integer;
begin
   GgfLogEvnt('tbi_createemptypageClick');

   if bmultiarcquery then
   begin
      BfShowMessage(_('Leeres Dokument kann nur in einem Archivordner erstellt werden.'));
      exit;
   end;

   DateTimeToString(lsLogDate, 'mmyyyy', now);

   //m.frey todo: ForceDirectories
   if not (directoryexists(sGCopyPath + sGArcName + sIArcName)) then
   begin
      mkDir(sGCopyPath + '\' + sGArcName + sIArcName);
   end;
   if not (directoryexists(sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate)) then
   begin
      mkDir(sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate);
   end;
   if not (directoryexists(sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate)) then
   begin
      mkDir(sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate);
   end;
   DateTimeToString(lsLogDate, 'mmyyyy\dd', now);
   if not (directoryexists(sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate)) then
   begin
      mkDir(sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate);
   end;

   DateTimeToString(lsFileNameTif, 'ddmmyyyyhhnnss', now);
   lsFileNameTif := lsFileNameTif + IntToStr(Random(999)) + '.tif';

   btn_ResFieldsClick(self);
   dm_db.my_q_datetime.SQL.Text := 'select date_format(now(),"%Y-%m-%d %T") as date';
   dm_db.my_q_datetime.Execute;
   lsTmpName := dm_db.my_q_datetime.FieldByName('date').AsString;
   // fra_voransicht.img_DocView.IO.SaveToFile(sGCopyPath+sGArcName+sIArcName+'\'+lsLogDate+'\'+lsFileNameTif);

   lsPath := sGCopyPath + sGArcName + sIArcName + '\' + lsLogDate;
   lsFileNameFullTif := lsPath + '\' + lsFileNameTif;
   lsFileNameFullTxt := ChangeFileExt(lsFileNameFullTif,'.txt');

   lsDbPathTif := stringreplace(lsFileNameFullTif, '\', '\\', [rfReplaceAll]);
   lsDbPathTxt := stringreplace(lsFileNameFullTxt, '\', '\\', [rfReplaceAll]);

   lsSql := 'insert into arc_' + SIarcname +
      ' (disp_name,doc_loc,ori_loc,tstamp,usr_name) '+
      'values(' +
      #39 + _('leeres Dokument') + #39 + ',' + //disp_name
      #39 + lsDbPathTif          + #39 + ',' + //doc_loc
      #39 + lsDbPathTxt          + #39 + ',' + //ori_loc
      #39 + lsTmpName            + #39 + ',' + //tstamp
      #39 + sGusrName            + #39 + ')'; //usr_name

   dm_db.my_cmd.SQL.Text := lsSql;
   dm_db.my_cmd.Execute;
   liid := dm_db.my_cmd.InsertId;
   if gbhasgdocid then
   begin
      dm_db.my_cmd.SQL.Text := 'insert into sys_gdocid (arc_id,doc_id) values(' +
         inttostr(igarcid) + ',' + inttostr(liid) + ')';
      dm_db.my_cmd.Execute;
      ligid := dm_db.my_cmd.InsertId;
      dm_db.my_cmd.SQL.Text := 'update arc_' + SIarcname + ' set gdoc_id = ' + inttostr(ligid) +
         ' where doc_id = ' + inttostr(liid);
      dm_db.my_cmd.Execute;
   end;
   lbit := Tiebitmap.Create(2000, 3000, ie1g);
   lbit.Fill(clwhite);
   li := TImageEn.Create(nil);
   li.IO.AttachedIEBitmap := lbit;
   li.io.Params.TIFF_Compression := ioTIFF_G4FAX;
   li.io.Params.BitsPerSample := 1;
   li.io.Params.SamplesPerPixel := 1;
   li.Fit;
   li.Update;
   li.IO.SaveToFile(lsFileNameFullTif);
   StringInDatei(lsFileNameFullTxt, '');//3.5.0.62 []

   if assigned(li) then
      FreeAndNil(li);
   if assigned(lbit) then
      FreeAndNil(lbit);
   gtsl_ansicht.Add(IntToStr(dm_db.my_q_arc.RecNo));
   handleparam(IntToStr(iGArcID) + '.' + IntToStr(liid));
end;

procedure Tfrm_MainForm.ApplicationEvents1Message(var Msg: tagMSG;
   var Handled: boolean);
var
   i: integer;
   pt, ptSTC : TPoint;
begin
   if gbViewerShutdown then
   	exit;
   if gbAddfieldDropDown then
   	Exit;

   if Msg.message = WM_MOUSEWHEEL then
   begin
      If OperationLock then
      begin
         Handled := True;
      	Exit;
      end;

   	if GetForegroundWindow <> frm_MainForm.Handle then
      begin
         for i:= 0 to length(farrayofdoceid) -1 do
         begin
            if farrayofdoceid[i].Handle = GetForegroundWindow then
            begin
               Handled := False;
               Exit;
            end;
         end;
      end;

      pt := Mouse.CursorPos;

      if fra_Voransicht.Visible then
      begin
         ptSTC := fra_Voransicht.ScreenToClient(pt);
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= fra_Voransicht.ClientWidth) and (ptSTC.Y <= fra_Voransicht.ClientHeight) then
         begin
            if fra_Voransicht.img_DocView.Focused then
            begin
               Handled := False;
               Exit;
            end
            else
            begin
               fra_Voransicht.img_DocView.SetFocus;
               Handled := True;
               Exit;
            end;
         end;
      end;

      ptSTC := dbgrd_trefferliste.ScreenToClient(pt);
//      if dbgrd_trefferliste.Focused then
      if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
       (ptSTC.x <= dbgrd_trefferliste.ClientWidth) and (ptSTC.Y <= dbgrd_trefferliste.ClientHeight)
       and (not fra_Voransicht.fbmouseinim) then
      begin
         Msg.message := WM_KEYDOWN;
         Msg.lParam := 0;
         i := Msg.wParam;

         if i > 0 then
            Msg.wParam := SendMessage(dbgrd_trefferliste.Handle, WM_VSCROLL, SB_LINEUP, 0)
         else
            Msg.wParam := SendMessage(dbgrd_trefferliste.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

         Handled := True;
         Exit;
      end;


      if dpnl_Wvlg.Visible then
      begin
         ptSTC := dbgrd_WVL.ScreenToClient(pt);
   //      if dbgrd_WVL.Focused then
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= dbgrd_WVL.ClientWidth) and (ptSTC.Y <= dbgrd_WVL.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
               Msg.wParam := SendMessage(dbgrd_WVL.Handle, WM_VSCROLL, SB_LINEUP, 0)
            else
               Msg.wParam := SendMessage(dbgrd_WVL.Handle, WM_VSCROLL, SB_LINEDOWN, 0);

            Handled := True;
            Exit;
         end;
      end;

      if fra_Volltext.Visible then
      begin
         ptSTC := fra_Volltext.ScreenToClient(pt);
   //      if dbgrd_WVL.Focused then
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= fra_Volltext.ClientWidth) and (ptSTC.Y <= fra_Volltext.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
            begin
               Msg.wParam := SendMessage(fra_Volltext.redt_Volltext.Handle, WM_VSCROLL, SB_LINEUP, 0);
               Msg.wParam := SendMessage(fra_Volltext.redt_Volltext.Handle, WM_VSCROLL, SB_LINEUP, 0);
            end
            else
            begin
               Msg.wParam := SendMessage(fra_Volltext.redt_Volltext.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
               Msg.wParam := SendMessage(fra_Volltext.redt_Volltext.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;

            Handled := True;
            Exit;
         end;
      end;

      if fra_DocLink.Visible then
      begin
         ptSTC := fra_DocLink.dbgrd_Links.ScreenToClient(pt);
   //      if dbgrd_WVL.Focused then
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= fra_DocLink.dbgrd_Links.ClientWidth) and (ptSTC.Y <= fra_DocLink.dbgrd_Links.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
            begin
               Msg.wParam := SendMessage(fra_DocLink.dbgrd_Links.Handle, WM_VSCROLL, SB_LINEUP, 0);
            end
            else
            begin
               Msg.wParam := SendMessage(fra_DocLink.dbgrd_Links.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;

            Handled := True;
            Exit;
         end;
      end;

      if fra_History.Visible then
      begin
         ptSTC := fra_History.dbgrd_History.ScreenToClient(pt);
   //      if dbgrd_WVL.Focused then
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= fra_History.dbgrd_History.ClientWidth) and (ptSTC.Y <= fra_History.dbgrd_History.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
            begin
               Msg.wParam := SendMessage(fra_History.dbgrd_History.Handle, WM_VSCROLL, SB_LINEUP, 0);
            end
            else
            begin
               Msg.wParam := SendMessage(fra_History.dbgrd_History.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;

            Handled := True;
            Exit;
         end;
      end;

		ptSTC := sbx_ZusFeld.ScreenToClient(pt);
//   		OutputDebugString(PChar(string(Sender.ClassName)));
      if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
          (ptSTC.x <= sbx_ZusFeld.ClientWidth) and (ptSTC.Y <= sbx_ZusFeld.ClientHeight) then
		begin
         Msg.message := WM_KEYDOWN;
         Msg.lParam := 0;
         i := Msg.wParam;

         if i > 0 then
         begin
            Msg.wParam := SendMessage(sbx_ZusFeld.Handle, WM_VSCROLL, SB_LINEUP, 0);
            Msg.wParam := SendMessage(sbx_ZusFeld.Handle, WM_VSCROLL, SB_LINEUP, 0);
         end
         else
         begin
            Msg.wParam := SendMessage(sbx_ZusFeld.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            Msg.wParam := SendMessage(sbx_ZusFeld.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
         end;

         Handled := True;
         Exit;
      end;


      if dpnl_LgrArc.Visible then
      begin
         ptSTC := dbtv_LgrArc.ScreenToClient(pt);
   //   		OutputDebugString(PChar(string(Sender.ClassName)));
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= dbtv_LgrArc.ClientWidth) and (ptSTC.Y <= dbtv_LgrArc.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
            begin
               Msg.wParam := SendMessage(dbtv_LgrArc.Handle, WM_VSCROLL, SB_LINEUP, 0);
            end
            else
            begin
               Msg.wParam := SendMessage(dbtv_LgrArc.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;

            Handled := True;
            Exit;
         end;
      end;

      if dpnl_Thumbs.Visible then
      begin
         ptSTC := tmb_Voransicht.ScreenToClient(pt);
   //   		OutputDebugString(PChar(string(Sender.ClassName)));
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= tmb_Voransicht.ClientWidth) and (ptSTC.Y <= tmb_Voransicht.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
            begin
               Msg.wParam := SendMessage(tmb_Voransicht.Handle, WM_VSCROLL, SB_LINEUP, 0);
            end
            else
            begin
               Msg.wParam := SendMessage(tmb_Voransicht.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;

            Handled := True;
            Exit;
         end;
      end;

      if dpnl_manfav.Visible then
      begin
         ptSTC := tv_lese.ScreenToClient(pt);
   //   		OutputDebugString(PChar(string(Sender.ClassName)));
         if (ptSTC.x > -1) and (ptSTC.Y  > -1) and	// sind wir innerhalb der Scrollbox?
             (ptSTC.x <= tv_lese.ClientWidth) and (ptSTC.Y <= tv_lese.ClientHeight) then
         begin
            Msg.message := WM_KEYDOWN;
            Msg.lParam := 0;
            i := Msg.wParam;

            if i > 0 then
            begin
               Msg.wParam := SendMessage(tv_lese.Handle, WM_VSCROLL, SB_LINEUP, 0);
            end
            else
            begin
               Msg.wParam := SendMessage(tv_lese.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
            end;

            Handled := True;
            Exit;
         end;
      end;

      Handled := True;  // wenn bisher kein Mausrad behandelt wurde, dann muss auch keins behandelt werden.
   end;
end;

procedure Tfrm_MainForm.tbi_savepdfsasonefileClick(Sender: TObject);
var lbtim_ansicht, lbtim_voransicht: boolean;
begin
	if gbSaveDoc then
      Exit;

   gbSaveDoc := True;
   try
      GgfLogEvnt('savepdfClick');
      //  Rechte des Users an Dokument ermitteln
      if dm_db.my_q_Arc.RecordCount > 0 then
      begin
         askforsave;
         gballasonefile := true;
         lbtim_ansicht := dm_DB.tim_ansicht.enabled;
         dm_DB.tim_ansicht.enabled := false;
//         lbtim_voransicht := dm_MainForm2.tim_voransicht.enabled;
//         dm_MainForm2.tim_voransicht.enabled := false;
         thr_voransicht.Terminate;
         thr_voransicht.WaitFor;
         gbArcHandling := true;

         pdfbysave := True;
         oribysave := False;
         tifbysave := False;
         mergeannotation;
         gbArcHandling := false;
//         dm_MainForm2.tim_voransicht.enabled := lbtim_voransicht;
         dm_DB.tim_ansicht.enabled := lbtim_ansicht;
         gballasonefile := false;
	   end;
   finally
      gbSaveDoc := False;
   end;
end;

procedure Tfrm_MainForm.tbi_savetifsasonefileClick(Sender: TObject);
var lbtim_ansicht, lbtim_voransicht: boolean;
begin
	if gbSaveDoc then
      Exit;

   gbSaveDoc := True;
   try
      GgfLogEvnt('tbi_VlocalSaveTifClick');

      if dm_db.my_q_Arc.RecordCount > 0 then
      begin
         askforsave;
         gballasonefile := true;
         lbtim_ansicht := dm_DB.tim_ansicht.enabled;
         dm_DB.tim_ansicht.enabled := false;
//         lbtim_voransicht := dm_MainForm2.tim_voransicht.enabled;
//         dm_MainForm2.tim_voransicht.enabled := false;
         thr_voransicht.Terminate;
         thr_voransicht.WaitFor;
         gbArcHandling := true;
         tbsi_localspeichern.Images := dm_MainForm2.ilFile;
         tbsi_localspeichern.imageindex := 5;

         oribysave := False;

         gballasonefile := true;
         pdfbysave := False;
         tifbysave := True;
         mergeannotation;
         gbArcHandling := false;
//         dm_MainForm2.tim_voransicht.enabled := lbtim_voransicht;
         dm_DB.tim_ansicht.enabled := lbtim_ansicht;
         gballasonefile := false;
      end;
   finally
      gbSaveDoc := False
   end;
end;



procedure Tfrm_MainForm.timer_autoscrollTimer(Sender: TObject);
begin
   if fbscroll_down then
      SendMessage(dbtv_LgrArc.Handle, WM_VSCROLL, SB_LINEUP, 0)
   else
      SendMessage(dbtv_LgrArc.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
end;

procedure Tfrm_MainForm.tmb_VoransichtKeyDown(Sender: TObject;
   var Key: word; Shift: TShiftState);
begin
   if ssCtrl in Shift then
   begin
      case Key of
         Ord('A'):
         begin
            if thr_voransicht <> nil then
            begin
               //ietextc modified for it!!!
               if thr_voransicht.pitotalpages > thr_voransicht.piloadedpages then
               begin
                  BfShowMessage(_('Dokument wurde nicht komplett geladen.') +
                     #13 + _('Letzte geladene Seite ist:') +
                     IntToStr(thr_voransicht.piloadedpages));
               end
               else
               begin
                  tmb_Voransicht.SelectAll;
               end;
            end
            else
            begin
               BfShowMessage(_('Auswhlen nicht mglich!'));
            end;
         end;
      end;
   end;
end;


procedure Tfrm_MainForm.addToXmlFile(filename: string; fbaskforname: boolean);
var
   liini: Tinifile;
   lilesecount, limode, liCount, lifavid, litmp, liArcIDX, lipos,
   istat, nistat, icount, liArcID: integer;
   lbCompModified, lbcreatedfile, lbalreadyexists: boolean;
   lsSQLCMD, sZusCMD, sZusOp, sZusText, sZusTextOG, sZusTextUG, sSlwCMD,
   sBenCMD, sDatVon, sDatBis, sDatCMD, sVtxCMD, //obere Grenze fuer die Suche im Datumsrange
   sLnkName, lsfavname, lssuchdatum, lsTmp, lsVolltext: string;
   lslFelder: TStringList;
   xComp, xComp01: TComponent; // Dummy Komponente
   zLbl: TJvStaticText;
   ltbxnew: ttbxitem;
   Doc: TdomDocument;
   Root: TTreeNode;
   DomNode0, DomNode1, DomNode2, Domlese, domfav: TDomNode;
   Astr, lsTmpA, lsTmpV, lsTextContentAct, lsTextContentPrev: string;
   Stream: TFileStream;
   domlistfav: tdomnodelist;
   FNodeElement, FNodeElement1, FNodeElement2, FNodeElementVorher: TDomElement;
   FNodeElement3: TDomText;
   Pvnsrc, Pvndest, PvnVorig, lPvndummy: TTreenode;
   Data: PTreeData;
   lmyd2xparser: TDomToXmlParser;
   lmyx2dparser: TXmlToDomParser;
   lmytreeview: TTreeview;
   lbhistory: boolean;
begin
   GgfLogEvnt('addToXmlFile');
   domnode1 := nil;
   iStat := 0;
   lPvndummy := nil;

   lsVolltext := GetVolltext; //[2487]

   lipos := pos('History.xml', filename);
   // is it history.xml or lese.xml?
   if lipos > 0 then
   begin
      lmyd2xparser := dm_MainForm2.DomToXMLParser_history;
      lmyx2dparser := dm_MainForm2.XmlToDomParser_history;
      lsfavname := 'Verlauf-';
      lmytreeview := tv_lese;
      lbhistory := true;
      GgfLogEvnt('addToXmlFile- Verlauf');
   end
   else
   begin
      lmyd2xparser := dm_MainForm2.DomToXMLParser_local;
      lmyx2dparser := dm_MainForm2.XmlToDomParser_local;
      lsfavname := 'Lokale ';
      lmytreeview := tv_lese;
      lbhistory := false;
   end;
   GgfLogEvnt('addToXmlFile- ' + filename);
   lbcreatedfile := False;
   if not Fileexists(filename) then
   begin
      lbcreatedfile := True;
      doc := TdomDocument.Create(dm_MainForm2.DomImplementation1);
      FNodeElement := TDomElement.Create(Doc, 'Lesezeichen');
      FNodeElement.SetAttribute('name', lsfavname);
      doc.AppendChild(FNodeElement);
      try
         Stream := TFileStream.Create(filename, fmCreate);
         try
            lmyd2xparser.WriteToStream(Doc, 'ISO-8859-1', Stream);
         finally
            Stream.Free;
         end;
      except on e: exception do
            logevnt('addToXmlFile ' + e.message);
      end;
      //  := FNodeElement;
   end;
   GgfLogEvnt('addToXmlFile- parsing');
   lmyx2dparser.ParseFile(filename, True);
   Doc := (lmyx2dparser.DOMImpl.Documents.Item(0) as TdomDocument);

   if lbcreatedfile then
   begin
      if lbhistory then
      begin
         updatetreeview(doc, lmytreeview, true);
      end
      else
      begin
         updatetreeview(doc, lmytreeview, false);
      end;
   end;

   try
      DomNode0 := Doc.ChildNodes.Item(0);
      FNodeElement := (domnode0 as TDomElement);
      domlistfav := fnodeelement.GetElementsByTagName('fav');
      lifavid := 0;
      for licount := 0 to domlistfav.length - 1 do
      begin
         DomNode1 := domlistfav.Item(licount);
         DomNode2 := domnode1.Attributes.GetNamedItem('id');
         litmp := StrToInt(DomNode2.NodeValue);
         if litmp > lifavid then
         begin
            lifavid := litmp;
         end;
      end;
      lifavid := lifavid + 1;
      if fbaskforname then
      begin
         InputQuery(_('Neue Favoritensuche anlegen'),
            _('Bitte geben Sie eine Bezeichnung fr die ') +
            #13 + _('neue Suche ein:'),
            sLnkName);
      end
      else
      begin
         sLnkName := IntToStr(lifavid);
      end;
      if sLnkName = '' then
         exit;

      FNodeElement := TDomElement.Create(Doc, 'fav');
      fnodeelement.SetAttribute('name_fav', sLnkName);
      fnodeelement.SetAttribute('id', IntToStr(lifavid));
      DateTimeToString(lssuchdatum, 'dd.mm.yyyy hh:nn:ss', now);
      fnodeelement.SetAttribute('Suchdatum', lssuchdatum);

      lbCompModified := False;
      lsSQLCMD := ''; // Initalisieren des SQL Komandos;
      lslFelder := TStringList.Create; // Initalisieren der Felder-Liste
      FNodeElement1 := TDomElement.Create(Doc, 'arcid');
      if dbtv_LgrArc.Selected <> nil then
      begin
         liArcID := integer(dbtv_LgrArc.Selected.data);
         FNodeElement3 := TDomText.Create(Doc);
         FNodeElement3.NodeValue := inttostr(integer(dbtv_LgrArc.Selected.data));
         FNodeElement1.AppendChild(FNodeElement3);
      end;
      fnodeelement.AppendChild(FNodeElement1);
      FNodeElement1 := TDomElement.Create(Doc, 'maxvalues');
      FNodeElement3 := TDomText.Create(Doc);
      FNodeElement3.NodeValue := cbx_MaxTreffer.Text;
      FNodeElement1.AppendChild(FNodeElement3);
      fnodeelement.AppendChild(FNodeElement1);

      //save status
      if chbx_SOnlyUsed.Checked then
      begin
         ////////////////////////////////////////////////////////////////////////////////////////////////////////
         // wenn die Farbe des leuchtmelders clLime entspricht ist die Bearbeitung aktiv
         // if tci_InUse.Color = clLime then iStat := 1 else iStat := 0;
         // skywalker20070612 changed status to use red as negative (exclusive search)
         // So it checks which are green and which are red and search properly after it
         if tci_InUse.Color = clLime then
         begin
            if ((gmodiStatus and 1) = 1) then
            begin
               iStat := 1;
            end;
         end;

         for iCount := 5 to (tlb_Status.Items.Count - 1) do
         begin
            if TTBXColorItem(tlb_Status.Items.Items[iCount]).Color = clRed then
            begin
               break;
            end;
         end;

         if tci_InUse.Color = clRed then
            niStat := 1

         else
            niStat := 0;
         for iCount := 5 to (tlb_Status.Items.Count - 1) do
         begin
            // for all items which color is lime set a search bit
            // question is why it finds also the documents whith unseted bit
            // answer: it doesnt find!!! maybe it can be changed...
            // WHY XOR!!???
            if TTBXColorItem(tlb_Status.Items.Items[iCount]).Color = clRed then
            begin
               niStat := niStat xor (1 shl (iCount - 5));
            end;
         end;
         gmodnegiStatus := gmodnegiStatus or niStat;

         for iCount := 5 to (tlb_Status.Items.Count - 1) do
         begin
            // for all items which color is lime set a search bit
            // question is why it finds also the documents whith unseted bit
            // answer: it doesnt find!!! maybe it can be changed...
            // WHY XOR!!???
            //search only modified fields
            if (((gmodsearchiStatus and (1 shl (iCount - 5))) =
               (1 shl (iCount - 5))) or (dm_db.my_q_arc.RecordCount = 0)) then
            begin
               if TTBXColorItem(tlb_Status.Items.Items[iCount]).Color = clLime then
                  iStat := iStat xor (1 shl (iCount - 5));
            end
            else
            begin
               iStat := iStat and (not (1 shl (iCount - 5)));
            end;
         end;
         //exact search

         // imply, include search
         if iStat <> 0 then
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'iStat');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := inttostr(istat);
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
         end;

         if niStat <> 0 then
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'niStat');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := inttostr(niStat);
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
         end;
      end;

      datezusfield := False;

      // Zusatz felder auswerten und dem SQL String zufgen
      try
         if sbx_ZusFeld.ComponentCount > 0 then
         begin
            for liCount := 0 to iGZusFCount - 1 do
            begin
               zLbl := TJvStaticText(sbx_ZusFeld.FindComponent('zlbl_Tmp' +
                  IntToStr(liCount)));
               // Weise Dummy Komponente den Pointer auf Dynamisch erzeugtes Label zu!

               xComp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(liCount));
               // Weise Dummy Komponente den Pointer auf Dynamisch erzeugtes Editfeld zu!
               if xComp is TEdit then
               begin
                  if (tedit(xComp).Color = cColorHellgruen) or
                     (tedit(xComp).Color = cColorNoRight) then
                  begin
                     sZusText := TEdit(xComp).Text;

                     FNodeElement1 := TDomElement.Create(Doc, 'zusatzname');
                     fnodeelement1.SetAttribute('text', zLbl.hint);

                     FNodeElement2 := TDomElement.Create(Doc, 'type');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := 'edit';
                     FNodeElement2.AppendChild(FNodeElement3);

                     fnodeelement1.AppendChild(fnodeelement2);

                     FNodeElement2 := TDomElement.Create(Doc, 'mode');

                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := IntToStr(TEdit(xComp).Tag);
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);

                     FNodeElement2 := TDomElement.Create(Doc, 'value');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := TEdit(xComp).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                  end;
                  // set modified := false so it wont save next save action
                  TEdit(xComp).Modified := False;
               end
               else
               if xComp is TSpinEdit then
               begin
                  xComp01 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(liCount));
                  if (xComp01 <> nil) then
                  begin
                     if
                     ((TSpinEdit(xComp).Color = cColorHellgruen) or
                        (TSpinEdit(xComp).Color = cColorNoRight)) or
                        ((
                        ((Tcombobox(xComp01).Color = cColorHellgruen) or
                        (Tcombobox(xComp01).Color = cColorNoRight))))
                     then
                     begin
                        sZusText := TSpinEdit(xComp).Text + Tcombobox(xComp01).text;

                        FNodeElement1 := TDomElement.Create(Doc, 'zusatzname');
                        fnodeelement1.SetAttribute('text', zLbl.hint);

                        FNodeElement2 := TDomElement.Create(Doc, 'type');
                        FNodeElement3 := TDomText.Create(Doc);
                        FNodeElement3.NodeValue := 'interval-spin';
                        FNodeElement2.AppendChild(FNodeElement3);

                        fnodeelement1.AppendChild(fnodeelement2);

                        FNodeElement2 := TDomElement.Create(Doc, 'mode');

                        FNodeElement3 := TDomText.Create(Doc);
                        FNodeElement3.NodeValue := IntToStr(TSpinEdit(xComp).Tag);
                        FNodeElement2.AppendChild(FNodeElement3);
                        fnodeelement1.AppendChild(fnodeelement2);

                        FNodeElement2 := TDomElement.Create(Doc, 'value');
                        FNodeElement3 := TDomText.Create(Doc);
                        FNodeElement3.NodeValue := sZusText;
                        FNodeElement2.AppendChild(FNodeElement3);
                        fnodeelement1.AppendChild(fnodeelement2);
                     end;
                  end;

               end
               else
               if xComp is TJvDateEdit then
               begin
                  // zusatz felder Datum Datumsfeld auswerten und der Abfrage hinzufgen

                  sZusText := '"' + TJvDateEdit(xComp).Text + '"';
                  // zweites Datumsfeld, das die obere Grenze beschreibt lesen
                  datezusfield := True;
                  sZustextOG := '"' + TJvDateEdit(
                     FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(liCount))).Text + '"';

                  if sZusText = '"  .  .    "' then
                  begin
                     sZusText := '';
                     sZusTextUG := '';
                  end
                  else
                  begin
                     sZusTextUG := sZusText;
                  end;
                  // Wenn sZusText nur die Datumsmaske enthaelt, dann wird der Inhalt der Variablen zu 'leer' deklariert

                  if sZusTextOG = '"  .  .    "' then
                     sZusTextOG := szustext;
                  sZustextOG1 := sZustextOG;
                  sZustextUG1 := sZustextUG;
                  if (((TJvDateEdit(xComp).color = cColorHellgruen) or
                     (TJvDateEdit(xComp).Color = cColorNoRight))) then
                  begin
                     FNodeElement1 := TDomElement.Create(Doc, 'zusatzname');
                     fnodeelement1.SetAttribute('text', zLbl.hint);

                     FNodeElement2 := TDomElement.Create(Doc, 'type');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := 'date';
                     FNodeElement2.AppendChild(FNodeElement3);

                     fnodeelement1.AppendChild(fnodeelement2);

                     FNodeElement2 := TDomElement.Create(Doc, 'mode');

                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := IntToStr(TComboBox(xComp).Tag);
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);

                     FNodeElement2 := TDomElement.Create(Doc, 'valueUG');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := TJvDateEdit(xComp).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                     FNodeElement2 := TDomElement.Create(Doc, 'valueOG');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue :=
                        TJvDateEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                        IntToStr(liCount))).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                  end;

               end
               else
               if xComp is TJvSpinEdit then
               begin
                  /////////////////////////////////////////////////////////////////////////////////////////////////////
                  // zusatz felder Datum Datumsfeld auswerten und der Abfrage hinzufgen

                  sZusText := TJvSpinEdit(xComp).Text;
                  // zweites Datumsfeld, das die obere Grenze beschreibt lesen
                  datezusfield := false;
                  sZustextOG := TJvSpinEdit(
                     FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(liCount))).Text;

                  sZusTextUG := sZusText;
                  if sZusTextOG = '"  .  .    "' then
                     sZusTextOG := szustext;
                  sZustextOG1 := sZustextOG;
                  sZustextUG1 := sZustextUG;

                  if (
                     ((TJvSpinEdit(xComp).color = cColorHellgruen) or
                     (TJvSpinEdit(xComp).Color = cColorNoRight))) then
                  begin
                     FNodeElement1 := TDomElement.Create(Doc, 'zusatzname');
                     fnodeelement1.SetAttribute('text', zLbl.hint);

                     FNodeElement2 := TDomElement.Create(Doc, 'type');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := 'zahl';
                     FNodeElement2.AppendChild(FNodeElement3);

                     fnodeelement1.AppendChild(fnodeelement2);

                     FNodeElement2 := TDomElement.Create(Doc, 'mode');

                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := IntToStr(TJvSpinEdit(xComp).Tag);
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);

                     FNodeElement2 := TDomElement.Create(Doc, 'valueUG');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := TJvSpinEdit(xComp).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                     FNodeElement2 := TDomElement.Create(Doc, 'valueOG');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue :=
                        TJvSpinEdit(FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' +
                        IntToStr(liCount))).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                  end;
               end
               else
               if xComp is TComboBox then
               begin
                  sZusText := TComboBox(xComp).Text;

                  if   (TComboBox(xComp).color = cColorHellgruen)
                    or (TComboBox(xComp).color = cColorHellblau )
                    or (Tcombobox(xComp).Color = cColorNoRight         )
                  then begin
                     FNodeElement1 := TDomElement.Create(Doc, 'zusatzname');
                     fnodeelement1.SetAttribute('text', zLbl.hint);
                     FNodeElement2 := TDomElement.Create(Doc, 'type');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := 'combo';
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                     FNodeElement2 := TDomElement.Create(Doc, 'mode');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := IntToStr(TComboBox(xComp).Tag);
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                     FNodeElement2 := TDomElement.Create(Doc, 'value');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := TComboBox(xComp).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                  end;
               end
               else
               if xComp is TjvCheckedComboBox then  //  02.06.2010  Vers. 3.5.0.80  [2450]  r.sch.
               begin
                  sZusText := TjvCheckedComboBox(xComp).Text;

                  if    (TjvCheckedComboBox(xComp).noFocusColor = cColorHellgruen)
                     or (TjvCheckedComboBox(xComp).noFocusColor = cColorNoRight   )
                  then
                  begin
                     FNodeElement1 := TDomElement.Create(Doc, 'zusatzname');
                     fnodeelement1.SetAttribute('text', zLbl.hint);
                     FNodeElement2 := TDomElement.Create(Doc, 'type');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := 'comboChecked';
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                     FNodeElement2 := TDomElement.Create(Doc, 'mode');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := IntToStr(TjvCheckedComboBox(xComp).Tag);
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                     FNodeElement2 := TDomElement.Create(Doc, 'value');
                     FNodeElement3 := TDomText.Create(Doc);
                     FNodeElement3.NodeValue := TjvCheckedComboBox(xComp).Text;
                     FNodeElement2.AppendChild(FNodeElement3);
                     fnodeelement1.AppendChild(fnodeelement2);
                  end;
               end;
               fnodeelement.AppendChild(fnodeelement1);
            end;
         end;
         if edt_SSLW.Text = '' then
            lsSQLCMD := lsSQLCMD + ''
         else
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'slw');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := edt_SSLW.Text;
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);

            sSlwCMD := '(' + MakeRefQuery(ParseSemicolonWithoutBackslash(edt_SSLW.Text),
               'doc_slw', False, True) + ')';
            if lsSQLCMD = '' then
               lsSQLCMD := lsSQLCMD + sSlwCMD
            else
               lsSQLCMD := lsSQLCMD + ' and ' + sSlwCMD;
         end;

         if cbx_SUsr.Text = _('alle Benutzer') then
            lsSQLCMD := lsSQLCMD + ''
         else
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'benutzer');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := cbx_SUsr.Text;
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
            sBenCMD := 'usr_name = ' + #39 + ParseSemicolonWithoutBackslash(cbx_SUsr.Text) + #39;
            if lsSQLCMD = '' then
               lsSQLCMD := lsSQLCMD + sBenCMD
            else
               lsSQLCMD := lsSQLCMD + ' and ' + sBenCMD;
         end;

         if not chbx_SRefSea.Checked then
            lsSQLCMD := lsSQLCMD + ''
         else
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'refsearch');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := edt_SRefSea.Text;
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
         end;

         if not chbx_SDatum.Checked then
            lsSQLCMD := lsSQLCMD + ''
         else
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'datevom');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := floattostr(dtp_SVon.DateTime);
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
            FNodeElement1 := TDomElement.Create(Doc, 'datebis');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := floattostr(dtp_SBis.DateTime);
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
            DateTimeToString(sDatVon, 'yyyy-mm-dd hh:nn:ss', dtp_SVon.DateTime);
            DateTimeToString(sDatBis, 'yyyy-mm-dd hh:nn:ss', dtp_SBis.DateTime);
            sDatCMD := 'tstamp between ' + #39 + sDatVon + #39 + ' and ' +
               #39 + sDatBis + #39;
            if lsSQLCMD = '' then
               lsSQLCMD := lsSQLCMD + sDatCMD
            else
               lsSQLCMD := lsSQLCMD + ' and ' + sDatCMD;
         end;

		    // Volltext auswerten und dem SQL String zufgen
         if memo_VTX.Text = '' then
            lsSQLCMD := lsSQLCMD + ''
         else
         begin
            FNodeElement1 := TDomElement.Create(Doc, 'vtx');
            FNodeElement3 := TDomText.Create(Doc);
            FNodeElement3.NodeValue := lsVolltext; //[2487]
            FNodeElement1.AppendChild(FNodeElement3);
            fnodeelement.AppendChild(FNodeElement1);
            lslFelder.Clear;
            lsTmp := Trim(ParseSemicolonWithoutBackslash(lsVolltext));
            if chbx_VTXSLW.Checked then
               sVtxCMD := MakeKomplexVTXQuery(lsVolltext,
                  False, bGAddAsterix, bGAppAsterix, GSysArc[liArcID].TblName)
            else
            begin
               lslFelder.AddObject('doc_txt', TObject(0));

               sVtxCMD := MakeKomplexQuery (lsVolltext, 
                                            lslFelder,
                                            zfld04_NichtDefiniert,
                                            bGAddAsterix,
                                            bGAppAsterix,
                                            False);
            end;
            if (lsSQLCMD = '') and (sSLWCMD = '') then
               lsSQLCMD := lsSQLCMD + sVtxCMD
            else
            begin
               if (sVtxCMD <> '') then
                  lsSQLCMD := lsSQLCMD + ' and ' + sVtxCMD;
            end;
         end;

         if lipos < 1 then
         begin
            //should check if  vst_favfile.FocusedNode is decendant from fpvnlokalefav!
            Pvnsrc := tv_lese.Selected;
            if (pvnsrc <> nil) then
            begin
               lPvndummy := Pvnsrc.Parent;
               while ((lPvndummy <> fpvnlokalefav) or
                     (lPvndummy <> tv_lese.TopItem)) and (lPvndummy <> nil) do
               begin
                  lPvndummy := lpvndummy.Parent;
               end;
            end;

            if (pvnsrc = nil) or ((tv_lese.Items.count > 0) and (lPvndummy = tv_lese.TopItem)) or
               (lPvndummy = nil) then
            begin
               //pvnsrc:= vst_favfile.GetFirstChild(nil);
               pvnsrc := fpvnlokalefav;
            end;
            Pvndest := dm_MainForm2.GetNodeByText(tv_lese, pvnsrc, sLnkName, true);
            if Pvndest = nil then
            begin
               if lbhistory then
               begin
                  Pvndest := tv_lese.Items.AddChildObjectFirst(Pvnsrc, lssuchdatum, fnodeelement);
                  tv_lese.Selected := Pvndest;
               end
               else
               begin
                  Pvndest := tv_lese.Items.AddChildObject(Pvnsrc, sLnkName, fnodeelement);
               end;
            end
            else
            begin
               Pvndest.Data := fnodeelement;
            end;

            Pvndest.ImageIndex := 1;
            Pvndest.SelectedIndex := 3;
         end
         else
         begin
            Pvnsrc := tv_lese.Selected;
            if (pvnsrc <> nil) then
            begin
               lPvndummy := Pvnsrc.Parent;
               while ((lPvndummy <> fpvnhistofav) or
                     (lPvndummy <> tv_lese.TopItem)) and (lPvndummy <> nil) do
               begin
                  lPvndummy := lpvndummy.Parent;
               end;
            end;
            if (pvnsrc = nil) or (lPvndummy = tv_lese.TopItem) or
               (lPvndummy = nil) then
            begin
               //pvnsrc:= vst_favfile.GetFirstChild(nil);
               pvnsrc := fpvnhistofav;
            end;
            if pvnsrc <> nil then
            begin
               Pvndest := dm_MainForm2.GetNodeByText(tv_lese, pvnsrc, sLnkName, true);
               if Pvndest = nil then
               begin
                  if lbhistory then
                  begin
                     Pvndest := tv_lese.Items.AddChildObjectFirst(Pvnsrc, lssuchdatum, fnodeelement);
                  end
                  else
                  begin
                     Pvndest := tv_lese.Items.AddChildObject(Pvnsrc, sLnkName, fnodeelement);
                  end;
               end
               else
               begin
                  Pvndest.Data := fnodeelement;
               end;
               Pvndest.ImageIndex := 1;
               Pvndest.SelectedIndex := 3;
               tv_lese.Selected := Pvndest;
               ftnlastbacknode := Pvndest;
               //3.5.0.46 [2271]
               // Jetzt wird der vorletzte Eintrag ggf. gelscht.
               PvnVorig := Pvndest.getNextSibling;
               //lsTmp := PvnVorig.Text;
               //FNodeElementVorher := TDomElement(FNodeElement.PreviousSibling);
               //FNodeElementVorher := TDomElement(FNodeElement.NextSibling);
               if Assigned(PvnVorig) then
               FNodeElementVorher := TDomElement(PvnVorig.Data);

               if Assigned(PvnVorig) and Assigned(FNodeElementVorher) then
               begin
                  lsTextContentAct  := FNodeElement.TextContent;
                  lsTextContentPrev := FNodeElementVorher.TextContent;
                  if lsTextContentAct = lsTextContentPrev
                  then // der letzte (aktuelle) und vorletzte sind inhaltlich gleich.
                  begin // dann lschen wir den vorletzen
                     FNodeElementVorher.FindParentElement.RemoveChild(FNodeElementVorher);
                     PvnVorig.Delete;
                  end;
               end;
            end;
         end;
      finally
         if Assigned(lslFelder) then
            FreeAndNil(lslFelder);
      end;
      lbalreadyexists := false;
      if doc.GetElementsByTagName('fav') <> nil then
      begin
         licount := 0;
         while licount < doc.GetElementsByTagName('fav').Length do
         begin
            if doc.GetElementsByTagName('fav').Item(licount).attributes.GetNamedItem('name_fav').nodevalue = sLnkName then
            begin
               lbalreadyexists := true;
               domnode1 := domnode0.ReplaceChild(fnodeelement, doc.GetElementsByTagName('fav').Item(licount));
               break;
            end;
            inc(licount);
         end;
      end;
      if not lbalreadyexists then
      begin
         domnode1 := domnode0.AppendChild(fnodeelement);
      end;
      //dont show history in menu
      if lipos = 0 then
      begin
         givirstualfiles := givirstualfiles + 1;
         setlength(gpvnvirstualfiles, givirstualfiles);
         gpvnvirstualfiles[givirstualfiles - 1].domnode := domnode1;
         gpvnvirstualfiles[givirstualfiles - 1].Name := sLnkName;
         gpvnvirstualfiles[givirstualfiles - 1].arcid := integer(dbtv_LgrArc.Selected.data);
      end;
   except
      on e: Exception do
      begin
         BfShowMessage(e.Message);
      end;
   end;

   Stream := TFileStream.Create(filename, fmCreate);
   try
      lmyd2xparser.WriteToStream(Doc, 'ISO-8859-1', Stream);
   finally
      Stream.Free;
   end;
end;

procedure Tfrm_MainForm.tbx_wvlfavbear0Click(Sender: TObject);
var
   lini: Tinifile;
   ls, lstaskfavnr: string;
   litimeroptionen, licounter, licounter1, liindex, licounterSave,
   liabstand: integer;
   lstrl: TStringList;
   lb: Boolean;
begin
   GgfLogEvnt('tbx_wvldelfavbearClick');
   if dm_DB.my_q_Arc.RecordCount > 0 then
   begin
      Application.CreateForm(Tfrm_AddDocTime, frm_AddDocTime);
      frm_AddDocTime.InitAddDocTimer;
      try
         try
            lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlfav.ini');
            licounter1 := ttbxitem(Sender).Tag;
            lstaskfavnr := 'Task' + IntToStr(licounter1);

            with lini do
            begin
               litimeroptionen := 0;
               if Valueexists(lstaskfavnr, 'Optionen') then // braucht man das?
               begin
                  litimeroptionen := ReadInteger(lstaskfavnr, 'Optionen', litimeroptionen);
               end;
               for licounter := 0 to frm_AddDocTime.jchb_opttim.Items.Count - 1 do
               begin
                  // Nach Erledigung zurck 2
                  // Erinnerungsmail senden 4
                  // nicht Einzelmodusinbearbeitung 8

                  lb := ((litimeroptionen and (1 shl (licounter + 1))) =
                        (1 shl (licounter + 1)));
                  frm_AddDocTime.jchb_opttim.Checked[licounter] := lb;
               end;

               ls := ReadString(lstaskfavnr, 'Workersje', '');
               ls := stringreplace( ls , ',', ' ', [rfReplaceAll]);
               lstrl := StrToWords7(ls); // StrToWords(ls);
               frm_AddDocTime.jvccb_je.SetUnCheckedAll(nil);
               for licounter := 0 to lstrl.Count - 1 do
               begin
                  liindex := frm_AddDocTime.jvccb_je.Items.IndexOf(lstrl.Strings[licounter]);
                  lb :=  liindex > -1;
                  if lb then
                     frm_AddDocTime.jvccb_je.Checked[liindex] := lb;
               end;
               lstrl.Free;

               ls := ReadString(lstaskfavnr, 'Workersefa', '');
               ls := stringreplace(ls,',', ' ', [rfReplaceAll]);
               lstrl := StrToWords7(ls); // StrToWords(ls);
               frm_AddDocTime.jvccb_efa.SetUnCheckedAll(nil);
               for licounter := 0 to lstrl.Count - 1 do
               begin
                  liindex := frm_AddDocTime.jvccb_efa.Items.IndexOf(lstrl.Strings[licounter]);
                  lb :=  liindex > -1;
                  if lb then
                     frm_AddDocTime.jvccb_efa.Checked[liindex] := lb;
               end;
               lstrl.Free;

               ls := ReadString(lstaskfavnr, 'Workerseb', '');
               ls := stringreplace(ls,',', ' ', [rfReplaceAll]); //neu
               lstrl := StrToWords7(ls); //StrToWordswvl2(ls);
               frm_AddDocTime.jvccb_eb.SetUnCheckedAll(nil);
               licounterSave := 0;
               for licounter := 0 to lstrl.Count - 1 do
               begin
                  licounterSave := licounter;
                  liindex := frm_AddDocTime.jvccb_eb.Items.IndexOf(lstrl.Strings[licounter]);
                  lb :=  liindex > -1;
                  if lb then
                     frm_AddDocTime.jvccb_eb.Checked[liindex] := lb;
               end;
               lstrl.Free;
               liabstand := ReadInteger(lstaskfavnr, 'Abstand', 7);
               frm_AddDocTime.dtp_DocTime.datetime := now;
               frm_AddDocTime.dtp_Alarm.datetime := now + liabstand;
               frm_AddDocTime.memo_Info.Text := ReadString(lstaskfavnr, 'Info', '');
            end;
         except
            on e: Exception do
            begin
            end;
         end;
      finally
         begin
            if Assigned(lini) then
            begin
               lini.UpdateFile;
               FreeAndNil(lini);
            end;
         end;
      end;
      frm_AddDocTime.sbtn_OKClick(self);
      frm_AddDocTime.Release;
   end;
end;


procedure Tfrm_MainForm.loadfavdelwvlhints;
var
   lini: Tinifile;
   lstrl, lsgrpe, lsgrpf: TStringList;
   licounter, licounter1, litimeropt: integer;
   lsmemotext, lsadd, lsjunk: string;
   lttbitem: ttbxitem;
   lbfoundonce, lbfounduser: boolean;
begin
   lbfounduser := false;
   try
      try
         if not fileexists(BD.AppdataBitfarmPd + 'wvlwlt.ini') then
         begin
            if fileexists(BD.AppdataBitfarmPd + 'wvldelfav.ini') then
            begin
               convertdelv2wlt;
               if fileexists(BD.AppdataBitfarmPd + 'wvlwlt.ini') then
               begin
                  //we dont need it anymore
                  killfile(BD.AppdataBitfarmPd + 'wvldelfav.ini');
               end;
            end
            else
            begin
               for licounter := 0 to 9 do
               begin
                  lttbitem := ttbxitem(FindComponent('tbx_wvlfavdelbear' + IntToStr(liCounter)));
                  lttbitem.Visible := false;
                  lttbitem.Hint := '';
               end;
               TBX_DelWvl.Visible := false;
               exit
            end;
         end;
         lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
         with lini do
         begin
            lbfoundonce := false;
            for licounter := 0 to 9 do
            begin
               if assigned(lstrl) then
                  FreeAndNil(lstrl);
               lttbitem := ttbxitem(FindComponent('tbx_wvlfavdelbear' + IntToStr(liCounter)));

               if lini.SectionExists('Task' + inttostr(licounter)) then
               begin
                  lstrl  := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workerseb', ''));
                  lsgrpf := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workersefa', ''));
                  lsgrpe := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workersje', ''));
                  lsmemotext := ReadString('Task' + IntToStr(licounter), 'Info', '');
                  litimeropt := ReadInteger('Task' + IntToStr(licounter), 'Optionen', 0);
                  lsadd := '';
                  lsjunk := '';

                  for licounter1 := 0 to 3 do
                  begin
                     // Nach Erledigung zurck 2
                     // Erinnerungsmail senden 4
                     // nicht Einzelmodusinbearbeitung 8
                     case (1 shl (licounter1 + 1)) and litimeropt of
                        1:
                        begin
                        end;
                        2:
                        begin
                           if lsadd = '' then
                           begin
                              lsadd := _('Optionen:Nach Erledigung zurck');
                           end
                           else
                           begin
                              lsadd := lsadd + _(',nach Erledigung zurck');
                           end;
                        end;
                        4:
                        begin
                           if lsadd = '' then
                           begin
                              lsadd := _('Optionen:Erinnerungsmail');
                           end
                           else
                           begin
                              lsadd := lsadd + _(',erinnerungsmail')
                           end;
                        end;
                        8:
                        begin
                           if lsadd = '' then
                           begin
                              lsadd := _('Optionen:Nicht Einzelmodusinbearbeitung');
                           end
                           else
                           begin
                              lsadd := lsadd + _(',nicht Einzelmodusinbearbeitung')
                           end;
                        end;
                     end;
                  end;

                  if lsadd <> '' then
                  begin
                     lsadd := lsadd + #13;
                  end;
                  if trim(lstrl.text) <> '' then
                  begin
                     lsadd := lsadd + _('Bearbeiter:') + lstrl.text;
                     lbfounduser := true;
                  end;
                  if trim(lsgrpf.text) <> '' then
                  begin
                     lsadd := lsadd + _('Gruppen:') + lsgrpf.text;
                     lbfounduser := true;
                  end;
                  if (trim(lsgrpf.text) <> '') and (trim(lsgrpe.text) <> '') then
                  begin
                     lsadd := lsadd + ';' + lsgrpe.text;
                     lsjunk := ';';
                  end
                  else
                  if (trim(lsgrpe.text) <> '') then
                  begin
                     lsadd := lsadd + _('Gruppen:') + lsgrpe.text;
                     lsjunk := ';';
                     lbfounduser := true; //3.5.0.18
                  end;
                  if trim(lsmemotext) <> '' then
                  begin
                     lsadd := lsadd + lsjunk + ' ' + _('Info:') + lsmemotext;
                     lsjunk := ';';
                  end;

                  if lbfounduser then
                  begin
                     lttbitem.Hint := lsadd;
                     lttbitem.Visible := true;
                     lbfoundonce := true;
                  end
                  else
                  begin
                     lttbitem.Visible := false;
                     lttbitem.Hint := '';
                  end;
               end
               else
               begin
                  lttbitem.Visible := false;
                  lttbitem.Hint := '';
               end;
            end;

            if not lbfoundonce then
            begin
               TBX_DelWvl.Visible := false;
            end;
         end;
      except
         on e: Exception do
         begin
            logevnt('loadfavdelwvlhints ' + e.message);
         end;
      end;
   finally
      if assigned(lini) then
         FreeAndNil(lini);
      if assigned(lstrl) then
         FreeAndNil(lstrl);
   end;
end;


procedure Tfrm_MainForm.loadfavwvlhints;
var
   lini: Tinifile;
   lstrl, lsgrpe, lsgrpf: TStringList;
   licounter, licounter1, liabstand, litimeropt: integer;
   lsmemotext, lsadd, lsjunk: string;
   lttbitem: ttbxitem;
   lbfoundonce, lbfounduser: boolean;
begin
   try
      try
         if not fileexists(BD.AppdataBitfarmPd +
            'wvlfav.ini') then
         begin
            for licounter := 0 to 9 do
            begin
               lttbitem := ttbxitem(FindComponent('tbx_wvlfavbear' + IntToStr(liCounter)));
               lttbitem.Visible := false;
               lttbitem.Hint := '';
            end;
            tbx_favwvl.Visible := false;
            exit;
         end;
         lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlfav.ini');
         with lini do
         begin
            lbfoundonce := false;
            for licounter := 0 to 9 do
            begin
               lbfounduser := false;
               if assigned(lstrl) then
                  FreeAndNil(lstrl);
               lttbitem := ttbxitem(FindComponent('tbx_wvlfavbear' + IntToStr(liCounter)));

               if lini.SectionExists('Task' + inttostr(licounter)) then
               begin
               
                  lstrl  := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workerseb', ''));
                  lsgrpf := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workersefa', ''));
                  lsgrpe := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workersje', ''));

                  lsmemotext := ReadString('Task' + IntToStr(licounter), 'Info', '');
                  liabstand := ReadInteger('Task' + IntToStr(licounter), 'Abstand', 7);
                  litimeropt := ReadInteger('Task' + IntToStr(licounter), 'Optionen', 0);
                  lsadd := '';
                  lsjunk := '';

                  for licounter1 := 0 to 3 do
                  begin
                     // Nach Erledigung zurck 2
                     // Erinnerungsmail senden 4
                     // nicht Einzelmodusinbearbeitung 8
                     case (1 shl (licounter1 + 1)) and litimeropt of
                        1:
                        begin
                        end;
                        2:
                        begin
                           if lsadd = '' then
                           begin
                              lsadd := _('Optionen:Nach Erledigung zurck');
                           end
                           else
                           begin
                              lsadd := lsadd + _(',nach Erledigung zurck');
                           end;
                        end;
                        4:
                        begin
                           if lsadd = '' then
                           begin
                              lsadd := _('Optionen:Erinnerungsmail');
                           end
                           else
                           begin
                              lsadd := lsadd + _(',erinnerungsmail')
                           end;
                        end;
                        8:
                        begin
                           if lsadd = '' then
                           begin
                              lsadd := _('Optionen:Nicht Einzelmodusinbearbeitung');
                           end
                           else
                           begin
                              lsadd := lsadd + _(',nicht Einzelmodusinbearbeitung')
                           end;
                        end;
                     end;
                  end;

                  if lsadd <> '' then
                  begin
                     lsadd := lsadd + #13;
                  end;
                  if trim(lstrl.text) <> '' then
                  begin
                     lsadd := _('Bearbeiter:') + lstrl.text;
                     lbfounduser := true;
                  end;
                  if trim(lsgrpf.text) <> '' then
                  begin
                     lsadd := lsadd + _('Gruppen:') + lsgrpf.text;
                     lbfounduser := true;
                  end;
                  if (trim(lsgrpf.text) <> '') and (trim(lsgrpe.text) <> '') then
                  begin
                     lsadd := lsadd + ';' + lsgrpe.text;
                     lsjunk := ';';
                  end
                  else
                  if (trim(lsgrpe.text) <> '') then
                  begin
                     lsadd := lsadd + _('Gruppen:') + lsgrpe.text;
                     lsjunk := ';';
                     lbfounduser := true; //3.5.0.18
                  end;
                  if trim(lsmemotext) <> '' then
                  begin
                     lsadd := lsadd + lsjunk + ' ' + _('Info:') + lsmemotext;
                     lsjunk := ';';
                  end;
                  if lbfounduser then
                  begin
                     lttbitem.Hint := lsadd
                        + lsjunk + ' ' + _('Frist:') + inttostr(liabstand) + ' ' + _('Tage');
                     lttbitem.Visible := true;
                     lbfoundonce := true;
                  end
                  else
                  begin
                     lttbitem.Visible := false;
                     lttbitem.Hint := '';
                  end;
               end
               else
               begin
                  lttbitem.Visible := false;
                  lttbitem.Hint := '';
               end;
            end;

            if not lbfoundonce then
            begin
               tbx_favwvl.Visible := false;
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      if assigned(lini) then
         FreeAndNil(lini);
      if assigned(lstrl) then
         FreeAndNil(lstrl);
   end;
end;

procedure Tfrm_MainForm.tbx_wvlfavdelbearClick(Sender: TObject);
var
   sDatum, slsqlrequest, lsalarm, lsushed: string;
   iTmpArcID, iTmpDocID, iStat, liInsID, licounter, lirecordnumber,
   litimeroptionen: integer;
   bUpdate, lbfound, lbfound1, lbupdated: boolean;
   lini: Tinifile;
   lstaskfavnr, lsmemotext, lsStart, lsworkersid, lstmp, lsIniAbschnitt,
   lstmp1, lstmp2: string;
   liindex, liabstand: integer;
   lstrl, lsgrpe, lsgrpf: TStringList;
   iActArcID, iActDocID: integer;
   sActDocTitle: string;
begin
   GgfLogEvnt('tbx_wvldelfavbearClick');
   lsgrpf := nil;
   lsgrpe := nil;
   lstrl := nil;
   litimeroptionen := 0;

   if gbDocMove or
   	gbLgrArcSet or
      gbArchivChange or
      gbSaveDoc or
      gbwvlcellclick then
      Exit;

   if (dm_DB.my_q_Time.FieldByName('Optionen').asinteger and 1) = 1 then
   begin
      BfShowMessage(_('Weiterleiten nicht fr eine Wiedervorlage/Aufgabe<nl>mit der Option "Jeder einzelne" erlaubt.'));
      exit;
   end;

   gbSaveDoc := True;
   try
      //onyl when one entry is selected
      if dbgrd_wvl.selectedrows.Count = 1 then
      begin
         //Aus der ini-Datei lesen, was bei dieser Aktion passieren soll
         try
            try
               lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
               licounter := ttbxitem(Sender).Tag;
               if lini.SectionExists('Task' + inttostr(licounter)) then
               begin
                  lsIniAbschnitt := 'Task' + IntToStr(licounter);
                  lstrl := StrToWordswvl2(lini.ReadString(lsIniAbschnitt, 'Workerseb', ''));
                  lsgrpf := StrToWordswvl2(lini.ReadString(lsIniAbschnitt, 'Workersefa', ''));
                  lsgrpe := StrToWordswvl2(lini.ReadString(lsIniAbschnitt, 'Workersje', ''));
                  lsmemotext := lini.ReadString(lsIniAbschnitt, 'Info', '');
                  litimeroptionen := lini.ReadInteger(lsIniAbschnitt, 'Optionen', 0);
               end;
            except
               on e: Exception do
               begin
                  logevnt('tbx_wvlfavdelbearClick ' + e.message);
               end;
            end;
         finally
            begin
               if Assigned(lini) then
               begin
                  lini.UpdateFile;
                  FreeAndNil(lini);
               end;
            end;
         end;
         //no receiver or more than one receiver found
         if (lsgrpf.Count + lsgrpe.Count > 1)
         then
         begin
            if (lsgrpf.Count + lsgrpe.Count > 1) then
            begin
               BfShowMessage(_('Nur ein Adressat(Gruppe oder Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung mglich.'));
            end;
            exit;
         end;
         if (lstrl.Count > 0) and ((lsgrpf.Count + lsgrpe.Count) > 0) then
         begin
            BfShowMessage(_('Erlaubt werden entweder nur einzelne Bearbeiter oder eine Gruppe.'));
            exit;
         end;

         if (lstrl.Count > 1) and ((litimeroptionen and 2) = 2) then
         begin
            BfShowMessage(_('Nur ein Adressat(Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung') +
               #13 + _('mit "Nach Erledigung zurck" mglich.'));
            exit;
         end;
         if (litimeroptionen and 1) = 1 then
         begin
            BfShowMessage(_('Weiterleitung von Wiedervorlagen fr Gruppen') + ' ' +
               _('in Modus "Jeder einzelnen" nicht untersttzt.'));
            exit;
         end;

         // DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(dtp_TimerNG.DateTime));
         DateTimeToString(sDatum, 'yyyy-mm-dd hh:nn:ss', StartOfTheDay(MFDatetimeEdit1.DateTime));
         DateTimeToString(lsalarm, 'yyyy-mm-dd hh:nn:ss',
            (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
            dm_DB.my_q_Time.FieldByName('termin').AsDateTime) + MFDatetimeEdit1.DateTime);
         bUpdate := False;
         lirecordnumber := dm_DB.my_q_Time.RecNo;

         with dm_DB.my_cmd do
         begin
            // wenn mehr als Null Elemente fuer die Wiedervorlage vorgemerkt sind
            if dm_DB.my_q_Time.RecordCount > 0 then
               // Recordcount enthaelt die Anzahl der Wiedervorlagen
            begin
               iStat := dm_DB.my_q_Time.FieldByName('status').AsInteger;
               // den Status der WVL aus DB lesen
               // Status 0 = offen, 1 = in Bearbeitung , 2 = fertig
               // todo test if this is really meaning fulll (if refresh does work!)
               dm_DB.my_q_Time.SQLRefresh.Clear;
               // set request so it returns just 1 entry!
               slsqlrequest :=
                  'Select Sql_No_cache tim_id, tim_ref, sys_timer.grp_id, termin, sys_arc.arc_id, arc_name, arc_tblname, doc_id,'
                  + ' doc_titel, if(grp_name is not null, grp_name, usr_name) as usr_name,' +
                  ' erinnerung, info, status, optionen, usr_id_work, usr_id_shed from sys_timer '
                  +
                  'left join sys_arc using(arc_id) ' +
                  ' left join sys_usr on sys_usr.usr_id = sys_timer.usr_id_work ' +
                  ' left join sys_grp on sys_grp.grp_id = sys_timer.grp_id ' +
                  ' where tim_id = ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;

               dm_DB.my_q_Time.SQLRefresh.Add(slsqlrequest);

               dm_DB.my_q_Time.RefreshRecord;
               if iStat <> dm_DB.my_q_Time.FieldByName('status').AsInteger then
               begin
                  BfShowMessage(_('Der Status des Dokumentes wurde bereits von einem anderen Benutzer gendert.')
                     + #13 + _('Bitte berprfen Sie den neuen Status!') +
                     #13 + #13 + _('Es erfolgte keine nderung an der Wiedervorlage/Aufgaben.'));
                  FillControls(False);
                  exit;
               end;
               iActArcID := dm_DB.my_q_Time.FieldByName('arc_id').AsInteger;
               iActDocID := dm_DB.my_q_Time.FieldByName('doc_id').AsInteger;
               sActDocTitle := dm_DB.my_q_Time.FieldByName('doc_titel').AsString;
               if (lstrl.Count > 1) then
               begin
                  frm_MainForm.TmpSQL('Select * from sys_timerhist where tim_ref=' +
                     dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and usr_id_shed =' +
                     dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString + ' and ((optionen & 2)=2)');
                  if
                  dm_DB.my_q_Tmp.RecordCount = 0 then
                  begin
                     BfShowMessage(_('Nur ein Adressat(Benutzer) fr Wiedervorlage/Aufgaben-Weiterleitung') +
                        #13 +
                        _('mit "Nach Erledigung zurck" mglich') +
                        #13 +
                        _('(auch in der Weiterleitung-Kette).'));
                     exit;
                  end;
               end;
               if ((dm_DB.my_q_Time.FieldByName('optionen').asinteger and 1) = 1) then
               begin
                  BfShowMessage(_('Wiedervorlage/Aufgaben-Weiterleitung beim Modus "Jeder einzeln" wird') +
                     _('noch nicht unterstzt.'));
                  exit;
               end;
               //Gruppe auflsen: alle Eintrge auer dem ersten werden gelscht.
               if dm_DB.my_q_Time.FieldByName('grp_id').asinteger <> 0 then
               begin
                  Sql.Text := 'delete from sys_timer where tim_ref = ' + dm_DB.my_q_Time.FieldByName('tim_ref').Asstring +
                     ' and tim_id <> ' + dm_DB.my_q_Time.FieldByName('tim_id').AsString;
                  // tim_id ist hier der ???
                  Execute;
               end;
               //wvl erzeugen
               lstmp := '';
               //einzelner benutzer
               lbfound1 := false;

               //check if return to sender
               // if there is an entry for the actual wvl
               //since for the 1. time wlt it is set but for setting a wvl there
               // is no entry
               // u0 -> u1,rts ;  there is no sys_timerhist there
               // u0 -> u1,rts -> u2,rts there should be 2 (maybe one, but saver is 2) entries in sys_timerhist
               if ((dm_DB.my_q_Time.FieldByName('optionen').asinteger and 2) = 2)
               //and ((litimeroptionen and 2) = 0 )
               then
               begin
                  frm_MainForm.TmpSQL('Select * from sys_timerhist where tim_ref=' +
                     dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and usr_id_shed =' +
                     dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString);
                  if
                  dm_DB.my_q_Tmp.RecordCount = 0 then
                  begin
                     Sql.Text :=
                        'insert into sys_timerhist (tim_id, tim_ref,usr_id_shed, optionen) values '
                        + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('optionen').AsString + ')';
                     Execute;
                     lsushed := IntToStr(iGusrid);
                  end;
               end;
               if ((litimeroptionen and 2) = 2) then // 2 = Nach Erledigung zurck
               begin
                  //save some information about this wvl
                  Sql.Text :=
                     'insert into sys_timerhist (tim_id, tim_ref,usr_id_shed, optionen) values '
                     + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                     ',' + dm_DB.my_q_Time.FieldByName('optionen').AsString + ')';
                  Execute;
                  lsushed := IntToStr(iGusrid);
               end
               else
               begin
                  lsushed := dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString;
               end;

               //be sure last user was in (maybe came through dbimp
               //set right the list for delegierte
               if gbhasctrlwvl then
               begin
                  //todo: gruppe erlauben
                  frm_MainForm.TmpSQL('Select * from sys_ctlrtimer where tim_ref=' +
                     dm_DB.my_q_Time.FieldByName('tim_ref').AsString + ' and usr_id_shed =' +
                     dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString);
                  if dm_DB.my_q_Tmp.RecordCount = 0 then
                  begin
                     Sql.Text :=
                        'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                        'usr_id_shed, info) values '
                        + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                        ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                        ',' + IntToStr(iGusrid) +
                        ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                        ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                     try
                        Execute;
                     except on e: Exception do
                        begin
                        end;
                     end;
                  end;
               end;
               //todo: what happens if user was deleted? (very unlikely)
               //go thorugh all selected users and create a new tim_ref for each
               //new entry
               for licounter := 0 to lstrl.Count - 1 do
               begin
                  lbfound := false;
                  //check if user exists
                  frm_MainForm.TmpSQL('Select * from sys_usr');
                  // m.frey: geht da ein [Select * from sys_usr where usr_name = "t.cat"] nicht einfacher?
                  dm_DB.my_q_Tmp.first;
                  while not dm_DB.my_q_Tmp.Eof do
                  begin
                     if dm_DB.my_q_Tmp.fieldbyname('usr_name').asstring =
                        lstrl.Strings[licounter] then
                     begin
                        lbfound := true;
                        break;
                     end;
                     dm_DB.my_q_Tmp.next;
                  end;

                  if not lbfound then
                  begin
                     continue;
                  end;

                  // first user
                  if (not lbfound1) then
                  begin
                     //first user dont change tim_ref
                     lbfound1 := true;
                     if gbhasctrlwvl then
                     begin
                        //todo: gruppe erlauben
                        Sql.Text :=
                           'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                           'usr_id_shed, info) values '
                           + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                           ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                           ',' + dm_DB.my_q_Tmp.fieldbyname('usr_id').AsString +
                           ',' + IntToStr(iGusrid) +
                           ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                        try
                           Execute;
                        except on e: Exception do
                           begin
                           end;
                        end;
                     end;
                     try
                        Sql.Text :=
                           'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:uwork, ' +
                           'usr_id_shed = :ushed, status = :status, ' +
                           'grp_id = :grp_id, erinnerung = :erinnerung, optionen = :optionen ' +
                           'where tim_id=' + dm_DB.my_q_Time.FieldByName(
                           'tim_id').AsString;
                        dm_DB.my_Cmd.ParamByName('grp_id').AsString := '0';
                        dm_DB.my_Cmd.ParamByName('status').AsString := '0';
                        dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                        dm_DB.my_Cmd.ParamByName('termin').AsDateTime := StartOfTheDay(MFDatetimeEdit1.DateTime);
                        dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                           (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                           dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                           StartOfTheDay(MFDatetimeEdit1.DateTime);
                        dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;
                        dm_DB.my_Cmd.ParamByName('uwork').Asinteger := dm_DB.my_q_Tmp.fieldbyname('usr_id').Asinteger;
                        dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGusrid; //iGUsrID;
                        Execute;
                        lstmp := lstrl.Strings[licounter];
                     except
                        on e: Exception do
                        begin
                           ErrorMsg('frm_MainForm.tbx_wvlfavdelbearClick',
                              _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben:') +
                              e.Message, 2023, True);
                        end;
                     end;
                  end
                  else
                  begin
                     try
                        dm_DB.my_Cmd.SQL.Text :=
                           'Insert into sys_timer (grp_id, arc_id, doc_id, doc_Titel, usr_id_work,'
                           + ' usr_id_shed, termin, erinnerung, optionen, info, status) '
                           + 'Values (:grpid, :arcid, :docid, :doctitel,  :uwork, :ushed, :termin,'
                           + ' :erinnerung, :optionen, :info, :status)';
                        dm_DB.my_Cmd.ParamByName('grpid').AsString := '0';
                        dm_DB.my_Cmd.ParamByName('arcid').AsInteger :=
                           dm_DB.my_q_Time.FieldByName('arc_id').AsInteger;
                        dm_DB.my_Cmd.ParamByName('docid').AsInteger :=
                           dm_DB.my_q_Time.FieldByName('doc_id').AsInteger;
                        dm_DB.my_Cmd.ParamByName('doctitel').AsString :=
                           dm_DB.my_q_Arc.FieldByName('disp_name').AsString;
                        dm_DB.my_Cmd.ParamByName('uwork').Asinteger :=
                           dm_DB.my_q_Tmp.fieldbyname('usr_id').Asinteger;
                        dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                           iGusrid; //iGUsrID;
                        dm_DB.my_Cmd.ParamByName('termin').AsDateTime := StartOfTheDay(MFDatetimeEdit1.DateTime);
                        // alarm changes like sdatum but relatively
                        dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                           (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                           dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                           StartOfTheDay(MFDatetimeEdit1.DateTime);;
                        dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;
                        dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                        // status should be changed also in the database and not only in cbx_status.
                        dm_DB.my_Cmd.ParamByName('status').AsString := '0';
                        dm_DB.my_Cmd.Execute;
                        liInsID := dm_DB.my_Cmd.InsertId;
                        dm_DB.my_Cmd.SQL.Text :=
                           'Update sys_timer set tim_ref = ' + IntToStr(liInsID) +
                           ' where tim_id = ' + IntToStr(liInsID);
                        dm_DB.my_Cmd.Execute;
                        if ((litimeroptionen and 2) = 2) then
                        begin
                           //save some information about this wvl
                           Sql.Text :=
                              'insert into sys_timerhist (tim_id, tim_ref,usr_id_shed, optionen) values '
                              + '(' + IntToStr(liInsID) +
                              ',' + IntToStr(liInsID) +
                              ',' + dm_DB.my_q_Time.FieldByName('usr_id_shed').AsString +
                              ',' + dm_DB.my_q_Time.FieldByName('optionen').AsString + ')';
                           Execute;
                        end;
                        if gbhasctrlwvl then
                        begin
                           //reproduce the same "history of the first" for all sequence
                           //todo: gruppe erlauben
                           Sql.Text :=
                              'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                              'usr_id_shed, info) select ' +
                              IntToStr(liInsID) +
                              ',' + IntToStr(liInsID) +
                              ',usr_id_work' +
                              ',usr_id_shed' +
                              ',info  from sys_ctlrtimer where tim_ref =' +
                              dm_DB.my_q_Time.FieldByName('tim_Ref').AsString;
                           try
                              Execute;
                           except on e: Exception do
                              begin
                              end;
                           end;
                        end;
                        lstmp := lstmp + ',' + lstrl.Strings[licounter];
                     except
                        on e: Exception do
                        begin
                           ErrorMsg('frm_MainForm.tbx_wvlfavdelbearClick',
                              _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben:') +
                              e.Message, 2023, True);
                        end;
                     end;
                  end;
               end;

               //gruppe jeder einzelne nur ein mglich bis jetzt
               for licounter := 0 to lsgrpe.Count - 1 do
               begin
                  frm_MainForm.TmpSQL(
                     'Select * from sys_grpusr left join sys_usr using (usr_id) left join sys_grp ' +
                     'on (sys_grpusr.grp_id=sys_grp.grp_id) where grp_name = ' + #39 +
                     lsgrpe.Strings[licounter] + #39 + ' and usr_name not like ' +
                     #39 + 'DEL\_%' + #39);
                  try
                     if dm_DB.my_q_Tmp.RecordCount > 0 then
                     begin
                        if gbhasctrlwvl then
                        begin
                           //todo: gruppe erlauben
                           Sql.Text :=
                              'insert into sys_ctlrtimer (tim_id, tim_ref,usr_id_work,' +
                              'grp_id,usr_id_shed, info) values '
                              + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                              ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                              ',' + dm_DB.my_q_Tmp.fieldbyname('usr_id').AsString +
                              ',' + dm_DB.my_q_Tmp.fieldbyname('grp_id').AsString +
                              ',' + IntToStr(iGusrid) +
                              ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                           try
                              Execute;
                           except on e: Exception do
                              begin
                              end;
                           end;
                        end;
                        Sql.Text :=
                           'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:uwork, ' +
                           'usr_id_shed = :ushed, status = :status ,'
                           + ' grp_id = :grpid, erinnerung = :erinnerung, optionen = :optionen '
                           + ' where tim_id=' + dm_DB.my_q_Time.FieldByName(
                           'tim_id').AsString;
                        dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                           dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;
                        dm_DB.my_Cmd.ParamByName('status').asinteger := 0;
                        dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                           dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                        dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                           iGusrid; //iGUsrID;
                        dm_DB.my_Cmd.ParamByName('termin').AsDateTime := StartOfTheDay(MFDatetimeEdit1.DateTime);
                        dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                           (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                           dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                           StartOfTheDay(MFDatetimeEdit1.DateTime);;
                        dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen or 1;
                        dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                        dm_DB.my_Cmd.Execute;

                        dm_DB.my_q_Tmp.Next;
                        while not dm_DB.my_q_Tmp.EOF do
                        begin
                           dm_DB.my_Cmd.SQL.Text :=
                              'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) '
                              +
                              'Values (:timref, :grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :erinnerung, :optionen, :info)';
                           dm_DB.my_Cmd.ParamByName('timref').AsInteger := dm_DB.my_q_Time.FieldByName(
                              'tim_ref').AsInteger;
                           dm_DB.my_Cmd.ParamByName('grpid').AsInteger :=
                              dm_DB.my_q_Tmp.FieldByName('grp_id').AsInteger;

                           dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iActArcID; //so aber
                           dm_DB.my_Cmd.ParamByName('docid').AsInteger := iActDocID;
                           dm_DB.my_Cmd.ParamByName('doctitel').AsString := sActDocTitle;
                           dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                              dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                           dm_DB.my_Cmd.ParamByName('ushed').AsInteger := iGusrid;
                           dm_DB.my_Cmd.ParamByName('termin').AsDateTime := StartOfTheDay(MFDatetimeEdit1.DateTime);
                           dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                              (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                              dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                              StartOfTheDay(MFDatetimeEdit1.DateTime);
                           dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen or 1;

                           dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                           dm_DB.my_Cmd.Execute;

                           dm_DB.my_q_Tmp.Next;
                        end;
                     end;
                  except
                     on e: Exception do
                     begin
                        ErrorMsg('frm_MainForm.tbx_wvlfavdelbearClick',
                           _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben:') +
                           e.Message, 2023, True);
                     end;
                  end;
               end;

               //gruppe einer fr alle nur ein mglich bis jetzt
               for licounter := 0 to lsgrpf.Count - 1 do
               begin
                  //               susr:= sUsr+'#'+jvccb_efa.items.Strings[i] +' ';
                  frm_MainForm.TmpSQL(
                     'Select * from sys_grpusr left join sys_usr using (usr_id)  left join sys_grp ' +
                     'on (sys_grpusr.grp_id=sys_grp.grp_id) where grp_name = ' + #39 +
                     lsgrpf.Strings[licounter] + #39 + ' and usr_name not like  ' +
                     #39 + 'DEL\_%' + #39);
                  try
                     if dm_DB.my_q_Tmp.RecordCount > 0 then
                     begin
                        if gbhasctrlwvl then
                        begin
                           //todo: gruppe erlauben    //m.frey: und was soll das Ganze?
                           Sql.Text :=
                              'insert into sys_ctlrtimer (tim_id, tim_ref, usr_id_work,' +
                              ' grp_id, usr_id_shed, info) values '
                              + '(' + dm_DB.my_q_Time.FieldByName('tim_id').AsString +
                              ',' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                              ',' + dm_DB.my_q_Tmp.fieldbyname('usr_id').AsString +
                              ',' + dm_DB.my_q_Tmp.fieldbyname('grp_id').AsString +
                              ',' + IntToStr(iGusrid) +
                              ',' + #39 + dm_DB.my_q_Time.FieldByName('info').AsString + #39 + ')';
                           try
                              Execute;
                           except on e: Exception do
                              begin
                              end;
                           end;
                        end;
                        Sql.Text :=
                           'Update sys_timer set Termin  = :termin, info = :info,  usr_id_work =:uwork, ' +
                           'usr_id_shed = :ushed, status = :status ,'
                           + ' grp_id = :grpid, erinnerung = :erinnerung, optionen = :optionen '
                           + ' where tim_id=' + dm_DB.my_q_Time.FieldByName(
                           'tim_id').AsString;
                        dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                           dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;
                        dm_DB.my_Cmd.ParamByName('status').asinteger := 0;
                        dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                           dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                        dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                           iGusrid; //iGUsrID;
                        dm_DB.my_Cmd.ParamByName('termin').AsDateTime := StartOfTheDay(MFDatetimeEdit1.DateTime);

                        dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                           (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                           dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                           StartOfTheDay(MFDatetimeEdit1.DateTime);
                        dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;

                        dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                        dm_DB.my_Cmd.Execute;

                        dm_DB.my_q_Tmp.Next;
                        while not dm_DB.my_q_Tmp.EOF do
                        begin
                           dm_DB.my_Cmd.SQL.Text :=
                              'Insert into sys_timer (tim_ref, grp_id, arc_id, doc_id, doc_Titel, usr_id_work, usr_id_shed, termin, erinnerung, optionen, info) ' +
                              'Values (:timref, :grpid, :arcid, :docid, :doctitel, :uwork, :ushed, :termin, :erinnerung, :optionen, :info)';
                           dm_DB.my_Cmd.ParamByName('timref').AsInteger := dm_DB.my_q_Time.FieldByName(
                              'tim_ref').asinteger;
                           dm_DB.my_Cmd.ParamByName('grpid').asinteger :=
                              dm_DB.my_q_Tmp.FieldByName('grp_id').asinteger;

                           dm_DB.my_Cmd.ParamByName('arcid').AsInteger := iActArcID; //so aber
                           dm_DB.my_Cmd.ParamByName('docid').AsInteger := iActDocID;
                           dm_DB.my_Cmd.ParamByName('doctitel').AsString := sActDocTitle;
                           dm_DB.my_Cmd.ParamByName('uwork').AsInteger :=
                              dm_DB.my_q_Tmp.FieldByName('usr_id').AsInteger;
                           dm_DB.my_Cmd.ParamByName('ushed').AsInteger :=
                              iGusrid;
                           dm_DB.my_Cmd.ParamByName('termin').AsDateTime := StartOfTheDay(MFDatetimeEdit1.DateTime);

                           dm_DB.my_Cmd.ParamByName('erinnerung').AsDateTime :=
                              (dm_DB.my_q_Time.FieldByName('erinnerung').AsDateTime -
                              dm_DB.my_q_Time.FieldByName('termin').AsDateTime) +
                              StartOfTheDay(MFDatetimeEdit1.DateTime);
                           dm_DB.my_Cmd.ParamByName('optionen').AsInteger := litimeroptionen;
                           dm_DB.my_Cmd.ParamByName('info').AsString := lsmemotext;
                           dm_DB.my_Cmd.Execute;
                           dm_DB.my_q_Tmp.Next;
                        end;
                     end;
                  except
                     on e: Exception do
                     begin
                        ErrorMsg('frm_MainForm.tbx_wvlfavdelbearClick',
                           _('Fehler beim Hinzufgen eines Dokumentes zur Wiedervorlage/Aufgaben:') +
                           e.Message, 2023, True);
                     end;
                  end;
               end;
               bUpdate := True;
            end;

            // nur Updaten wenn auch wirklich ein SQL Update erfolgt ist
            if bUpdate then
            begin
               if cbx_Status.ItemIndex = 2 then
                  CancelStatus;
               iTmpArcID := iGArcID; // m.frey: ist das nicht berflssig?
               iTmpDocID := iGDocID; // m.frey: ist das nicht berflssig?
               iGArcID := iGTimArcID; // m.frey: ist das nicht berflssig?
               iGDocID := iGTimDocID; // m.frey: ist das nicht berflssig?
               frm_MainForm.NewHistory(18,
                  _('Wiedervorlage/Aufgaben') + ' ' + dm_DB.my_q_Time.FieldByName('tim_ref').AsString +
                  ' ' + _('gendert. Berarbeiternamen:') + lstmp + _(';Bearbeiter:') + ' ' +
                  Trim(lstrl.text + lsgrpf.text + lsgrpe.text) + '; ' + _('Termin:') + ' ' + sDatum + ' ' + _('Status:') + ' ' + cbx_Status.Text);
               iGArcID := iTmpArcID; // m.frey: ist das nicht berflssig?
               iGDocID := iTmpDocID; // m.frey: ist das nicht berflssig?
               if tbi_MyTask.Checked then
                  ShowDocsKW(iGKWYear, iGKW);
               if tbi_MATask.Checked then
                  ShowMATasks;

               // reselect the old
               dm_DB.my_q_Time.RecNo := lirecordnumber;
               FillCOntrols(False);
   				GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.tbx_wvlfavdelbearClick');
               tbi_ShowDocClick(self);
               wvlhasfocus := True;

               wvlshowbuttons(True);
               // make this one be selected and marked!
               dbgrd_wvl.SelectedRows.CurrentRowSelected := True;
               // commented out so wvl dont jump (loose selection and hide and show)

               RefreshStatus;
            end;
         end;
      end
      else
      begin
         BfShowMessage(_('Bitte whlen Sie eine Wiedervorlage/Aufgabe.'));
      end;
   finally
   	gbSaveDoc := False;
      GgfLogEvnt('tbx_wvldelfavbearClick - finally');
   end;
   GgfLogEvnt('tbx_wvldelfavbearClick - end');
end;

procedure Tfrm_MainForm.tbi_docdupClick(Sender: TObject);
var
   lssarcname, lsselval, sFileName, sCDocFile, sDocFile, sCExtFile,
   sCOriFile, sTmpPath: string;
   linewdocid, liGblDocID: int64;
   linijob: Tinifile;
begin
   GgfLogEvnt('tbi_docdupClick');
   linewdocid := 0; 

   if dm_db.my_q_Arc.RecordCount = 0 then
      exit;

   if bmultiarcquery then
   begin
      BfShowMessage(_('Dokument duplizieren geht nur auf Archiv-Ebene.'));
      Exit;
   end;

   if dbgrd_Trefferliste.SelectedRows.Count > 1 then
   begin
     	BfShowMessage(_('Sie knnen nur ein einzelnes Dokument duplizieren.'));
     	Exit;
   end;

   if iGArcRecNo <> dm_db.my_q_arc.RecNo then
   begin
      dm_db.my_q_Arc.GotoBookmark(
         Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));
   end;

   //todo multiarcquery
   if not bmultiarcquery then
   begin
      lssarcname := sIarcname;
      dm_db.my_q_Tmp.SQL.Text := 'show columns from arc_' + lssarcname;
      dm_db.my_q_Tmp.Execute;
      dm_db.my_q_Tmp.First;
      lsselval := '';
      while not dm_db.my_q_Tmp.EOF do
      begin
         if (lowercase(dm_db.my_q_Tmp.FieldByName('Field').AsString) <> 'doc_id') then
         begin
            if lsselval = '' then
            begin
               lsselval := dm_db.my_q_Tmp.FieldByName('Field').AsString;
            end
            else
            begin
               lsselval := lsselval + ',' + dm_db.my_q_Tmp.FieldByName('Field').AsString;
            end;
         end;
         dm_db.my_q_Tmp.Next;
      end;
      //entry in arc
      dm_db.my_cmd.SQL.Text := 'insert into arc_' + lssarcname + '(' +
         lsselval + ')' + ' select ' + lsselval + ' from arc_' +
         lssarcname + ' where doc_id=' + dm_db.my_q_Arc.FieldByName('doc_id').AsString;
      dm_db.my_cmd.Execute;
      linewdocid := dm_db.my_cmd.InsertId;
      sDocFile := dm_db.my_q_Arc.FieldByName('doc_loc').AsString;
      sCDocFile := sDocFile;
      sCExtFile := dm_db.my_q_Arc.FieldByName('ext_loc').AsString;
      sCOriFile := dm_db.my_q_Arc.FieldByName('ori_loc').AsString;

      if (sCExtFile <> '') and fileexists(sCExtFile) then
      begin
         sCDocFile := sCExtFile;
      end;
      // entry in slw
      dm_db.my_cmd.sql.Text := 'insert into slw_' + lssarcname +
         '(doc_id,doc_slw)' + ' select ' + IntToStr(linewdocid) +
         ', doc_slw from   slw_' + lssarcname + ' where doc_id=' +
         dm_db.my_q_Arc.FieldByName('doc_id').AsString;
      dm_db.my_cmd.Execute;
      // copy file and job
      DateTimeToString(sFileName, 'ddmmyyyyhhnnss', now);
      sTmpPath := StringReplace(sCDocFile, sGArcPath, sGCopyPath, []);
      sFileName := extractfilepath(sTmpPath) + ChangeFileExt(
         extractfilename(sCDocFile), '') + IntToStr(Random(999)) +
         ExtractFileExt(sCDocFile);

      while fileexists(sFileName) do
      begin
         sFileName := extractfilepath(sTmpPath) + ChangeFileExt(
            extractfilename(sCDocFile), '') + IntToStr(Random(999)) +
            ExtractFileExt(sCDocFile);
      end;
      CopyFile(PChar(sCDocFile), PChar(sFileName), False);

      dm_db.my_cmd.SQL.Text := 'Update arc_' + lssarcname + ' set doc_loc =:docloc' +
         ' where doc_id =' + IntToStr(linewdocid);
      dm_DB.my_Cmd.ParamByName('docloc').AsString := sFileName;
      dm_db.my_cmd.Execute;
      dm_db.my_cmd.SQL.Text := 'Update arc_' + lssarcname + ' set ext_loc = ' +
         #39 + #39 + ' where doc_id =' + IntToStr(linewdocid);
      dm_db.my_cmd.Execute;

      if sCOriFile <> '' then
      begin
         sFileName := ChangeFileExt(sFileName, '') + ExtractFileExt(sCOriFile);
         CopyFile(PChar(sCOriFile), PChar(sFileName), False);
         dm_db.my_cmd.SQL.Text := 'Update arc_' + lssarcname + ' set ori_loc =:oriloc' +
         ' where doc_id =' + IntToStr(linewdocid);
         dm_DB.my_Cmd.ParamByName('oriloc').AsString := sFileName;
         dm_db.my_cmd.Execute;
      end;

      dm_db.my_q_Tmp.SQL.Text := 'show tables like ' + #39 + 'sys_gdocid' + #39;
      dm_db.my_q_Tmp.Execute;
      if dm_db.my_q_Tmp.RecordCount > 0 then
      begin
         dm_db.my_Cmd.SQL.Text :=
            'insert into sys_gdocid (arc_id, doc_id) values ' + '(' +
            #39 + IntToStr(iGArcID) + #39',' + #39 + IntToStr(linewdocid) + #39')';
         dm_db.my_Cmd.Execute;
         liGblDocID := dm_db.my_Cmd.InsertId;
         dm_db.my_Cmd.SQL.Text :=
            'update arc_' + lssarcname + ' set gdoc_id = ' + IntToStr(liGblDocID) +
            ' where doc_id =' + IntToStr(linewdocid);
         dm_db.my_Cmd.Execute;
      end;
      if fileexists(ChangeFileExt(sDocFile, '.job')) then
      begin
         sFileName := ChangeFileExt(sFileName, '.job');
         CopyFile(PChar(ChangeFileExt(sDocFile, '.job')), PChar(sFileName), False);
         linijob := Tinifile.Create(ChangeFileExt(sFileName, '.job'));
         linijob.WriteInteger('Document', 'DOCID', linewdocid);
         linijob.Free;
      end;
      NewHistory(15, _('Dokument kopiert-> jetzige docid :') +
      IntToStr(iGarcid) + '.' + IntToStr(iGdocid) + ' ' + _('Kopie:') + IntToStr(igarcid) + '.' +
      IntToStr(linewdocid));
      NewHistoryID(16, _('Dokument wurde kopiert von Dokument ') + IntToStr(iGarcid) + '.' + IntToStr(iGdocid),iGArcid, linewdocid, iGUsrID);
	   handleparam(IntToStr(igarcid) + '.' + IntToStr(linewdocid));
   end;

end;

procedure Tfrm_MainForm.tbx_zuspflichtdebugClick(Sender: TObject);
begin
   Application.CreateForm(Tfrm_zuspflicht, frm_zuspflicht);
   frm_zuspflicht.fsSrcIarcname := sIarcname;
   frm_zuspflicht.fsDestIarcname := sIarcname;
   frm_zuspflicht.fiZusFcount := frm_zuspflicht.CreZusFields;
   frm_zuspflicht.ShowModal;
   frm_zuspflicht.Release;
end;

procedure Tfrm_MainForm.tbxi_symlinkClick(Sender: TObject);
var
   lssarcname, lsselval: string;
   linewdocid, liGblDocID, lidocid, ligdocid, lioptionen: int64;
begin
   GgfLogEvnt('tbi_docdupClick');

   if dm_db.my_q_Arc.RecordCount = 0 then
      exit;
   lidocid := dm_db.my_q_Arc.FieldByName('doc_id').Asinteger;
   lioptionen := dm_db.my_q_Arc.FieldByName('Optionen').Asinteger;
   dm_db.my_q_Tmp.SQL.Text := 'show tables like ' + #39 + 'sys_gdocid' + #39;
   dm_db.my_q_Tmp.Execute;
   if dm_db.my_q_Tmp.RecordCount > 0 then
   begin
      ligdocid := dm_db.my_q_Arc.FieldByName('gdoc_id').Asinteger;

      if iGArcRecNo <> dm_db.my_q_arc.RecNo then
      begin
         dm_db.my_q_Arc.GotoBookmark(
            Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[frm_mainform.dbgrd_Trefferliste.SelectedRows.Count - 1]));

         lidocid := dm_db.my_q_Arc.FieldByName('doc_id').Asinteger;
         lioptionen := dm_db.my_q_Arc.FieldByName('Optionen').Asinteger;
      end;
      //todo multiarcquery
      if (lioptionen and 1) = 1 then
      begin
         BfShowmessage(_('Erstellung von symbolischer Verknpfung noch nicht untersttzt.'));
         exit;
      end;
      if bmultiarcquery then
      begin
      end
      else
      begin
         lssarcname := sIarcname;
         dm_db.my_q_Tmp.SQL.Text := 'show columns from arc_' + lssarcname;
         dm_db.my_q_Tmp.Execute;
         dm_db.my_q_Tmp.First;
         lsselval := '';
         while not dm_db.my_q_Tmp.EOF do
         begin
            if (lowercase(dm_db.my_q_Tmp.FieldByName('Field').AsString) <> 'doc_id') then
            begin
               if lsselval = '' then
               begin
                  lsselval := dm_db.my_q_Tmp.FieldByName('Field').AsString;
               end
               else
               begin
                  lsselval := lsselval + ',' + dm_db.my_q_Tmp.FieldByName('Field').AsString;
               end;
            end;
            dm_db.my_q_Tmp.Next;
         end;
         //entry in arc
         dm_db.my_cmd.SQL.Text :=
            'insert into arc_' + lssarcname + '(' + lsselval + ')' +
            ' select ' + lsselval + ' from arc_' + lssarcname + ' where doc_id=' +
            inttostr(lidocid);
         dm_db.my_cmd.Execute;
         linewdocid := dm_db.my_cmd.InsertId;

         dm_db.my_cmd.SQL.Text :=
            'insert into slw_' + lssarcname + '(doc_id,doc_slw)' +
            ' select ' + inttostr(linewdocid) + ', doc_slw from slw_' + lssarcname + ' where doc_id=' +
            inttostr(lidocid);
         dm_db.my_cmd.Execute;

         dm_db.my_cmd.SQL.Text :=
            'Update arc_' + lssarcname + ' set optionen = ' + #39 + '1' +
            #39 + ' where doc_id =' + IntToStr(linewdocid);
         dm_db.my_cmd.Execute;
 
         liGblDocID := dm_db.my_Cmd.InsertId;
         dm_db.my_Cmd.SQL.Text :=
            'update arc_' + lssarcname + ' set gdoc_id = ' + IntToStr(liGblDocID) +
            ' where doc_id =' + IntToStr(linewdocid);
         dm_db.my_Cmd.Execute;
         newhistory(15, _('Symbolischer Link erzeugt:') +
            IntToStr(iGarcid) +
            '.' + IntToStr(linewdocid) + ' gsdoc_id :' + inttostr(liGblDocID));
         handleparam(inttostr(iGarcid) + '.' + IntToStr(linewdocid));
      end;
   end;
end;


procedure Tfrm_MainForm.tbi_expcsvClick(Sender: TObject);
var
   lsfname, lstmp: string;
   iSelected, licounter1, licounter2, liactiverecord: integer;
   lsst: Tstringlist;
   lbcfg, lbfound: boolean;
begin
   GgfLogEvnt('tbi_expcsvClick');

//   lbfound := dm_MainForm2.tim_voransicht.Enabled;

//   dm_MainForm2.tim_voransicht.Enabled := false;
   liactiverecord := dm_MainForm2.getactiverecordfromdbgrid(TDBGrid(dbgrd_Trefferliste));

   if not PromptForFileName(lsfname, 'CSV|*.CSV', 'csv',
      'Wie soll die Offline-Datei heien?', '', True) then
      exit;
   lsst := Tstringlist.create;
   dm_db.my_q_tmp.sql.text := 'select * from sts_' + sIarcname + ' order by sts_id';
   dm_db.my_q_tmp.execute;
   dm_db.MyQNog01.sql.text := 'select * from cfg_' + sIarcname;
   dm_db.MyQNog01.execute;
   //erste Spalte
   lstmp := '';
   for licounter1 := 0 to dm_db.my_q_Arc.FieldDefList.Count - 1 do  //dm_db.my_q_Arc.FieldDefList
   begin
      if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_loc') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ext_loc') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ori_loc') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_id') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'usr_id') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ocr_qf') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_state') and
         (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'gdoc_id') then
      begin
         dm_db.MyQNog01.first;
         lbcfg := false;
         while not dm_db.MyQNog01.eof do
         begin
            if lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = dm_db.MyQNog01.fieldbyname('Feld_Name').asstring then
            begin
               lstmp := lstmp + #34 + dm_db.MyQNog01.fieldbyname('Disp_Name').asstring + #34 + ';';
               lbcfg := true;
               break;
            end;
            dm_db.MyQNog01.next;
         end;
         if lbcfg then
         begin
            continue;
         end;
         lstmp := lstmp + #34 + dm_db.my_q_Arc.FieldDefList.Strings[licounter1] + #34 + ';';
      end;
      if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_state') then
      begin
         lstmp := lstmp + #34 + _('In Bearbeitung') + #34 + ';';
         dm_db.my_q_tmp.first;
         while not dm_db.my_q_tmp.eof do
         begin
            lstmp := lstmp + #34 + dm_db.my_q_tmp.fieldbyname('sts_Name').asstring + #34 + ';';
            dm_db.my_q_tmp.next;
         end;
      end;
   end;
   lsst.Add(lstmp);
   //der rest
   for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
   begin
      with dbgrd_Trefferliste.DataSource.DataSet do
      begin
         GotoBookMark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iSelected]));
         lstmp := '';
         for licounter1 := 0 to dm_db.my_q_Arc.FieldDefList.Count - 1 do  //dm_db.my_q_Arc.FieldDefList
         begin
            if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ext_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ori_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_id') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'usr_id') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ocr_qf') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_state') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'gdoc_id') then
            begin
               lstmp := lstmp + #34 + dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString + #34 + ';';
            end;
            if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_state') then
            begin
               if (dm_db.my_q_Arc.fieldbyname('doc_state').asinteger and 1) > 0 then
               begin
                  lstmp := lstmp + #34 + _('ja') + #34 + ';';
               end
               else
               begin
                  lstmp := lstmp + #34 + _('nein') + #34 + ';';
               end;
               dm_db.my_q_tmp.first;
               licounter2 := 1;
               while not dm_db.my_q_tmp.eof do
               begin
                  if (dm_db.my_q_Arc.fieldbyname('doc_state').asinteger and (1 shl licounter2)) > 0 then
                  begin
                     lstmp := lstmp + #34 + _('ja') + #34 + ';';
                  end
                  else
                  begin
                     lstmp := lstmp + #34 + _('nein') + #34 + ';';
                  end;
                  dm_db.my_q_tmp.next;
                  licounter2 := licounter2 + 1;
               end;
            end;
         end;
      end;
      lsst.Add(lstmp);
   end;
   try
      lsst.SaveToFile(lsfname);
   except on e: Exception do
      begin
         logevnt('Problem with Saving file csv ' + lsfname + ' Fehler:' + e.message);
      end;
   end;

   dm_db.my_q_Arc.RecNo := liactiverecord;
//   dm_MainForm2.tim_voransicht.Enabled := lbfound;
end;

procedure Tfrm_MainForm.tbi_expxlsClick(Sender: TObject);
const
   xlVAlignCenter = -4108;
   xlThin = 2;
   xlEdgeBottom = 9;
   xlDouble = -4119;
   xlThick = 4;
   xl3DColumn = -4100;
   xlColumns = 2;
   xlLocationAsObject = 2;
var
   oXL, oWB, oSheet: Variant;
   lstmp, lsnf: string;
   iSelected, licounter1, licounter2, licounter3, licounter4: integer;
   lbcfg, lbfound: boolean;
begin
//   lbfound := dm_MainForm2.tim_voransicht.Enabled;
//   dm_MainForm2.tim_voransicht.Enabled := false;
   try
	   // Start von Excel und Aufrufen eines Anwendungsobjektes
      try
         oXL := CreateOleObject('Excel.Application');
      except
         on e: exception do
         begin
            BfShowMessage(_('Export nach Excel nicht mglich. (Ggf. nicht installiert)'));
            Exit;
         end;
      end;
      try
         oXL.Visible := True;
         oWB := oXL.Workbooks.Add;
         oSheet := oWB.ActiveSheet;
         GgfLogEvnt('tbi_expcsvClick');
         dm_db.my_q_tmp.sql.text := 'select * from sts_' + sIarcname + ' order by sts_id';
         dm_db.my_q_tmp.execute;
         dm_db.MyQNog01.sql.text := 'select * from cfg_' + sIarcname;
         dm_db.MyQNog01.execute;
         //erste Spalte
         lstmp := '';
         licounter2 := 1;
         for licounter1 := 0 to dm_db.my_q_Arc.FieldDefList.Count - 1 do  //dm_db.my_q_Arc.FieldDefList
         begin
            if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ext_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ori_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'usr_id') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ocr_qf') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_state') then
            begin
               dm_db.MyQNog01.first;
               lbcfg := false;
               while not dm_db.MyQNog01.eof do
               begin
                  if lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = dm_db.MyQNog01.fieldbyname('Feld_Name').asstring then
                  begin
                     oSheet.Cells[1, licounter2] := dm_db.MyQNog01.fieldbyname('Disp_Name').asstring;
                     licounter2 := licounter2 + 1;
                     lbcfg := true;
                     break;
                  end;
                  dm_db.MyQNog01.next;
               end;
               if lbcfg then
               begin
                  continue;
               end;
               oSheet.Cells[1, licounter2] := dm_db.my_q_Arc.FieldDefList.Strings[licounter1];
               licounter2 := licounter2 + 1;
            end;
            if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_state') then
            begin
               oSheet.Cells[1, licounter2] := _('In Bearbeitung');
               licounter2 := licounter2 + 1;
               dm_db.my_q_tmp.first;
               while not dm_db.my_q_tmp.eof do
               begin
                  oSheet.Cells[1, licounter2] := dm_db.my_q_tmp.fieldbyname('sts_Name').asstring;
                  licounter2 := licounter2 + 1;
                  dm_db.my_q_tmp.next;
               end;
            end;
         end;
         dm_db.my_q_tmp_CreStatus.SQL.text := 'select * from sys_timer as a left join sys_usr as b on ' +
            '(a.usr_id_work =b.usr_id) limit 1';
         dm_db.my_q_tmp_CreStatus.execute;
         licounter3 := 0;
         for licounter1 := licounter2 to dm_db.my_q_tmp_CreStatus.FieldDefList.Count + licounter2 - 1 do  //dm_db.my_q_Arc.FieldDefList
         begin
            if (lowercase(dm_db.my_q_tmp_CreStatus.FieldDefList.Strings[licounter1 - licounter2]) = 'usr_pass') then
            begin
               inc(licounter3);
               continue;
            end;
            oSheet.Cells[1, licounter1 - licounter3] := dm_db.my_q_tmp_CreStatus.FieldDefList.Strings[licounter1 - licounter2];
         end;

         // save default value for gdocid (else it will be by ocr_rf overwritten
         iSelected := 0;
         licounter4 := 0;
         licounter2 := 1;
         oSheet.Range[RefToCell(iSelected + 2 + licounter4, licounter2),
            RefToCell(iSelected + 2 + licounter4, licounter2)].Select;
         lsnf := oXL.Selection.NumberFormat;
         //der rest
         for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
         begin
            with dbgrd_Trefferliste.DataSource.DataSet do
            begin
               GotoBookMark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iSelected]));

               licounter2 := 1;
               for licounter1 := 0 to dm_db.my_q_Arc.FieldDefList.Count - 1 do  //dm_db.my_q_Arc.FieldDefList
               begin
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_id') then
                  begin
                     if bmultiarcquery then
                     begin
                        oSheet.Cells[iSelected + 2 + licounter4, licounter2] :=
                           '=HYPERLINK("docid:' + dm_db.my_q_Arc.fieldbyname('arc_id').asstring + '.' +
                           dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString
                           + '")';
                     end
                     else
                     begin
                        oSheet.Cells[licounter4 + iSelected + 2, licounter2] :=
                           '=HYPERLINK("docid:' + inttostr(iGarcid) + '.' + dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString
                           + '")';
                     end;
                     licounter2 := licounter2 + 1;
                  end
                  else
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'gdoc_id') then
                  begin
                     oSheet.Range[RefToCell(iSelected + 2 + licounter4, licounter2),
                        RefToCell(iSelected + 2 + licounter4, licounter2)].Select;
                     oXL.Selection.NumberFormat := lsnf;
                     oSheet.Cells[licounter4 + iSelected + 2, licounter2] :=
                        '=HYPERLINK("gdocid:' + dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString
                        + '")';
                     licounter2 := licounter2 + 1;
                  end
                  else
                  begin
                     oSheet.Range[RefToCell(iSelected + 2 + licounter4, licounter2),
                        RefToCell(iSelected + 2 + licounter4, licounter2)].Select;
                     oXL.Selection.NumberFormat := '@';
                  end;

                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_loc') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ext_loc') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ori_loc') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_id') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'usr_id') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ocr_qf') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_state') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'gdoc_id') then
                  begin
                     if (pos('add_', lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1])) = 1) then
                     begin
                        if dm_db.my_q_Arc.FieldDefList.FieldDefs[licounter1].DataType = ftFloat then
                        begin
                           dm_db.MyQNog01.first;
                           while not dm_db.MyQNog01.eof do
                           begin
                              if lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = dm_db.MyQNog01.fieldbyname('Feld_Name').asstring then
                              begin
                                 oSheet.Range[RefToCell(licounter4 + iSelected + 2, licounter2),
                                    RefToCell(licounter4 + iSelected + 2, licounter2)].Select;
                                 if dm_db.MyQNog01.fieldbyname('Typ').asinteger = 8 then
                                 begin
                                    oXL.Selection.NumberFormat := '0,00';
                                 end
                                 else
                                 begin
                                    oXL.Selection.NumberFormat := lsnf;
                                 end;
                                 break;
                              end;
                              dm_db.MyQNog01.next;
                           end;
                           oSheet.Cells.item[licounter4 + iSelected + 2, licounter2].value := dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).asfloat;

                        end
                        else
                        if dm_db.my_q_Arc.FieldDefList.FieldDefs[licounter1].DataType = ftInteger then
                        begin
                           oSheet.Cells.item[licounter4 + iSelected + 2, licounter2].value := dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).asinteger;
                        end
                        else
                        begin
                           oSheet.Cells.item[licounter4 + iSelected + 2, licounter2].value := dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).asstring;
                        end;
                     end
                     else
                     begin
                        oSheet.Cells[licounter4 + iSelected + 2, licounter2] := dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString;
                     end;
                     licounter2 := licounter2 + 1;
                  end;
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_state') then
                  begin
                     if (dm_db.my_q_Arc.fieldbyname('doc_state').asinteger and 1) > 0 then
                     begin
                        oSheet.Cells[licounter4 + iSelected + 2, licounter2] := _('ja');
                        licounter2 := licounter2 + 1;

                     end
                     else
                     begin
                        oSheet.Cells[licounter4 + iSelected + 2, licounter2] := _('nein');
                        licounter2 := licounter2 + 1;
                     end;
                     dm_db.my_q_tmp.first;
                     licounter3 := 1;
                     while not dm_db.my_q_tmp.eof do
                     begin
                        if (dm_db.my_q_Arc.fieldbyname('doc_state').asinteger and (1 shl licounter3)) > 0 then
                        begin
                           oSheet.Cells[licounter4 + iSelected + 2, licounter2] := _('ja');
                           licounter2 := licounter2 + 1;
                        end
                        else
                        begin
                           oSheet.Cells[licounter4 + iSelected + 2, licounter2] := _('nein');
                           licounter2 := licounter2 + 1;
                        end;
                        dm_db.my_q_tmp.next;
                        licounter3 := licounter3 + 1;
                     end;
                  end;
               end;

               //get wvl
               if bmultiarcquery then
               begin
                  lstmp := dm_db.my_q_Arc.fieldbyname('arc_id').asstring;
               end
               else
               begin
                  lstmp := inttostr(iGarcid);
               end;
               dm_db.my_q_tmp_CreStatus.SQL.text := 'select * from sys_timer as a left join sys_usr as b on ' +
                  '(a.usr_id_work =b.usr_id) where ((arc_id = ' + lstmp + ')' +
                  ' and (doc_id = ' + dm_db.my_q_Arc.fieldbyname('doc_id').asstring + ')' +
                  ' and (status <> 2))';
               dm_db.my_q_tmp_CreStatus.execute;

               dm_db.my_q_tmp_CreStatus.first;

               while not dm_db.my_q_tmp_CreStatus.eof do
               begin
                  licounter3 := 0;
                  for licounter1 := licounter2 to dm_db.my_q_tmp_CreStatus.FieldDefList.Count + licounter2 - 1 do  //dm_db.my_q_Arc.FieldDefList
                  begin
                     if (lowercase(dm_db.my_q_tmp_CreStatus.FieldDefList.Strings[licounter1 - licounter2]) = 'usr_pass') then
                     begin
                        inc(licounter3);
                        continue;
                     end;
                     oSheet.Cells[licounter4 + iSelected + 2, licounter1 + licounter3] := dm_db.my_q_tmp_CreStatus.fieldbyname(dm_db.my_q_tmp_CreStatus.FieldDefList.Strings[licounter1 - licounter2]).AsString;
                  end;
                  licounter4 := licounter4 + 1;

                  dm_db.my_q_tmp_CreStatus.next;
               end;
               if dm_db.my_q_tmp_Crestatus.recordcount > 0 then
               begin
                  dec(licounter4);
               end;
            end;
         end;
         // Sicherstellen, dass Excel sichtbar ist und bergabe der Kontrolle ber
         // die Gltigkeitsdauer von Microsoft Excel an den Benutzer
         oXL.Visible := True;
         oXL.UserControl := True;
      except
         on e: Exception do
         begin
            BfShowMessage(_('Fehler beim Excel Export'));
            Exit;
         end;
      end;
   finally
      dm_db.my_q_Arc.RecNo := iGArcRecNo;
//      dm_MainForm2.tim_voransicht.Enabled := lbfound;
   end;
end;

procedure Tfrm_MainForm.tbi_expodsClick(Sender: TObject);
var
   iSelected, licounter1, licounter2, licounter3,
   liactiverecord: integer;
   lbcfg, lbfound: boolean;
   HCalc: THojaCalc;
begin
   GgfLogEvnt('tbi_expodsClick');
//   lbfound := dm_MainForm2.tim_voransicht.Enabled;
   liactiverecord := dm_MainForm2.getactiverecordfromdbgrid(TDBGrid(dbgrd_Trefferliste));

   try
	   HCalc := THojaCalc.create(thcOpenOffice, true); //OpenOffice doc if possible, please
   except
      on e: exception do
      begin
      	BfShowMessage(_('Export nach OpenOffice nicht mglich. (Ggf. nicht installiert)'));
         Exit;
      end;
   end;

   try
   	try
         HCalc.FileName := 'F:\MyNewDoc'; //Needs a file name before you SaveDoc!
         HCalc.ActiveSheetName := 'Bitfarm Export';
         if HCalc.IsActiveSheetProtected then
            ShowMessage('2nd sheet of name "' + HCalc.ActiveSheetName + '" IS protected');
         //Change a cell value (well, change formula, not the double float value)
         if HCalc.CellText[1, 2] = '' then
            HCalc.CellText[1, 2] := 'Hello world!';

         if not (directoryexists(BD.AppdataBitfarm)) then
         begin
            try
               mkDir(BD.AppdataBitfarm);
            except on e: exception do
               begin
                  logevnt('tbi_expodsClick ' + e.message);
               end;
            end;
         end;

         if not (directoryexists(BD.AppdataBitfarmPd + 'Export-Suche')) then
         begin
            try
               mkDir(BD.AppdataBitfarmPd + 'Export-Suche');
            except on e: exception do
               begin
                  logevnt('tbi_expodsClick ' + e.message);
               end;
            end;
         end;

         dm_db.my_q_tmp.sql.text := 'select * from sts_' + sIarcname + ' order by sts_id';
         dm_db.my_q_tmp.execute;
         dm_db.MyQNog01.sql.text := 'select * from cfg_' + sIarcname;
         dm_db.MyQNog01.execute;
         //erste Spalte
         //lstmp:='';
         licounter2 := 1;
         for licounter1 := 0 to dm_db.my_q_Arc.FieldDefList.Count - 1 do  //dm_db.my_q_Arc.FieldDefList
         begin
            if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ext_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ori_loc') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'usr_id') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ocr_qf') and
               (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_state') then
            begin
               dm_db.MyQNog01.first;
               lbcfg := false;
               while not dm_db.MyQNog01.eof do
               begin
                  if lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = dm_db.MyQNog01.fieldbyname('Feld_Name').asstring then
                  begin
                     HCalc.CellText[1, licounter2] := dm_db.MyQNog01.fieldbyname('Disp_Name').asstring;
                     licounter2 := licounter2 + 1;
                     lbcfg := true;
                     break;
                  end;
                  dm_db.MyQNog01.next;
               end;
               if lbcfg then
               begin
                  continue;
               end;
               HCalc.CellText[1, licounter2] := dm_db.my_q_Arc.FieldDefList.Strings[licounter1];
               licounter2 := licounter2 + 1;
            end;
            if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_state') then
            begin
               HCalc.CellText[1, licounter2] := _('In Bearbeitung');
               licounter2 := licounter2 + 1;
               dm_db.my_q_tmp.first;
               while not dm_db.my_q_tmp.eof do
               begin
                  HCalc.CellText[1, licounter2] := dm_db.my_q_tmp.fieldbyname('sts_Name').asstring;
                  licounter2 := licounter2 + 1;
                  dm_db.my_q_tmp.next;
               end;
            end;
         end;
         //der rest
         for iSelected := 0 to (dbgrd_Trefferliste.SelectedRows.Count - 1) do
         begin
            with dbgrd_Trefferliste.DataSource.DataSet do
            begin
               GotoBookMark(Pointer(dbgrd_Trefferliste.SelectedRows.Items[iSelected]));

               licounter2 := 1;
               for licounter1 := 0 to dm_db.my_q_Arc.FieldDefList.Count - 1 do  //dm_db.my_q_Arc.FieldDefList
               begin
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_loc') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ext_loc') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ori_loc') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_id') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'usr_id') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_txt') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'ocr_qf') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'doc_state') and
                     (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) <> 'gdoc_id') then
                  begin
                     HCalc.fbformula := true;
                     if (
                        dm_db.my_q_Arc.FieldDefList.FieldDefs[licounter1].DataType
                        = ftDateTime) then
                     begin
                        HCalc.fbformula := false;
                     end;
                     HCalc.CellText[iSelected + 2, licounter2] := dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString;
                     licounter2 := licounter2 + 1;
                  end;
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_id') then
                  begin
                     if bmultiarcquery then
                     begin
                        HCalc.CellText[iSelected + 2, licounter2] := '=HYPERLINK("docid:' +
                           dm_db.my_q_Arc.fieldbyname('arc_id').asstring +
                           '.' + dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString
                           + '")';
                     end
                     else
                     begin
                        HCalc.CellText[iSelected + 2, licounter2] := '=HYPERLINK("docid:' + inttostr(iGarcid) + '.' + dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString
                           + '")';
                     end;
                     licounter2 := licounter2 + 1;
                  end;
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'gdoc_id') then
                  begin
                     HCalc.CellText[iSelected + 2, licounter2] := '=HYPERLINK("gdocid:' + dm_db.my_q_Arc.fieldbyname(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]).AsString
                        + '")';
                     licounter2 := licounter2 + 1;
                  end;
                  if (lowercase(dm_db.my_q_Arc.FieldDefList.Strings[licounter1]) = 'doc_state') then
                  begin
                     if (dm_db.my_q_Arc.fieldbyname('doc_state').asinteger and 1) > 0 then
                     begin
                        HCalc.CellText[iSelected + 2, licounter2] := _('ja');
                        licounter2 := licounter2 + 1;
                     end
                     else
                     begin
                        HCalc.CellText[iSelected + 2, licounter2] := _('nein');
                        licounter2 := licounter2 + 1;
                     end;
                     dm_db.my_q_tmp.first;
                     licounter3 := 1;
                     while not dm_db.my_q_tmp.eof do
                     begin
                        if (dm_db.my_q_Arc.fieldbyname('doc_state').asinteger and (1 shl licounter3)) > 0 then
                        begin
                           HCalc.CellText[iSelected + 2, licounter2] := _('ja');
                           licounter2 := licounter2 + 1;
                        end
                        else
                        begin
                           HCalc.CellText[iSelected + 2, licounter2] := _('nein');
                           licounter2 := licounter2 + 1;
                        end;
                        dm_db.my_q_tmp.next;
                        licounter3 := licounter3 + 1;
                     end;
                  end;
               end;
            end;
         end;
      except
         on e: Exception do
         begin
            BfShowMessage(_('Fehler beim OpenOffice Export'));
            Exit;
         end;
	   end;

   finally
      dm_db.my_q_Arc.RecNo := liactiverecord;
//      dm_MainForm2.tim_voransicht.Enabled := lbfound;
   end;


end;


procedure Tfrm_MainForm.ShowVoransichtNorefresh;
//////////////////////////////////////////////////////////////////
///
///  Voransicht
///  28.04.2005 Erstellt (SV)                                  ///
///  09.05.2005 Erweitert um Hintanzeige (SV)                  ///
///                                                            ///
///  Diese Procedure liest die Tiffdatei des Dokumentes ein    ///
///  und Zeigt diese an                                        ///
///                                                            ///
//////////////////////////////////////////////////////////////////
var
   sIEVFile, sIEVFiletmp, sDocFile, sExtFile, sChk4pIev, lsUsers, lspubannopages, lstmp, lsprivtmp, lspubtmp: string;
   iXTbi, iYTbi, iXTlb, iYTlb, licounter, licounter2, licounter2Save, liobjcount: integer;
   iPos: tPoint;
   lblesbar, lblesbaranno, lblesbarpubanno: bool;
begin
   GgfLogEvntBeg ('ShowVoransichtNorefresh Begin');

   liobjcount := 0;
   licounter2save := 0; 
   lblesbar := False;
   lblesbaranno := False;
   lblesbarpubanno := False;
   //  outputdebugstring(PChar('Voransicht'));
   with fra_Voransicht.img_DocView do
   begin
      if fra_Nix.Visible then
         fra_Nix.Visible := False;

      if dm_DB.my_q_Arc.RecordCount = 0 then
      begin
        GgfLogEvntEnd ('ShowVoransichtNorefresh End via Exit #1');
        exit;
      end;

      bGImageDisp := False; // Neues Bild wurde noch nicht geladen
      Clear;
      Blank;
      if ObjectsCount > 0 then
         RemoveAllObjects;
      frm_MainForm.fra_Volltext.clearobjslist;

      if not FileAccessable(sDocFile) then
         // Wenn Datei nicht existiert, Datensatz aktualisieren und 100ms warten
      begin
         dm_DB.my_q_Arc.RefreshRecord;
         sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         sgextfilename := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
         sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
         sleep(50);
      end
      else
      begin
         lblesbar := True;
         if FileExists(sExtFile) then
         begin
            sDocFile := sExtFile;
         end;
      end;
      if ((not FileAccessable(sDocFile)) and (not lblesbar)) then

      begin
         dm_DB.my_q_Arc.RefreshRecord;
         sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
         sgextfilename := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
         sExtFile := dm_DB.my_q_Arc.FieldByName('Ext_loc').AsString;
         sleep(50);
      end
      else
      begin
         lblesbar := True;
         if FileExists(sExtFile) then
         begin
            sDocFile := sExtFile;
         end;
      end;
      dm_MainForm2.pum_PrivAnno.Items.Clear;

      //too many threads make the fileaccess failt for some reason
      if (not lblesbar) then
      begin
         for licounter := 0 to 2 do
         begin
            if FileExists(sExtFile) then
            begin
               sDocFile := sExtFile;
            end;
            if not FileAccessable(sDocFile) then
            begin
               // wait for caching?
               sleep(70);
            end
            else
            begin
               lblesbar := True;
               break;
            end;
         end;

         if licounter = 2 then
         begin
            if sExtFile = sDocFile then
            begin
               sgdocfilename := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
               sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            end;
         end;
      end;

      if ((not FileAccessable(sDocFile)) and (not lblesbar)) then
      begin
         frm_mainform.setpanelinfo(
            _('Die Datei kann nicht gelesen werden, bitte versuchen sie es erneut.'));
         Clear;
         Blank;
         if ObjectsCount > 0 then
            RemoveAllObjects;
         frm_MainForm.fra_Volltext.clearobjslist;
         bGImageDisp := True;
         //      outputdebugstring(PChar('Could not open file ' + sDocFile));
         LogEvnt('Could not open file ' + sDocFile);
         GgfLogEvntEnd ('ShowVoransichtNorefresh End via Exit #2');
         exit;
      end;
      sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(IO.Params.TIFF_ImageIndex) + '.IEV';
      sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

      // Erzeuge den Privat Annotation namen des angemeldeten Users
      // should check for priv anno from others which give the right to read
      sChk4pIev := ChangeFileExt(sDocFile, '') + IntToStr(IO.Params.TIFF_ImageIndex) +
         'P' + IntToStr(igUsrId) + '.IEV';
      fra_Voransicht.img_DocView.RemoveAllObjects;
      frm_MainForm.fra_Volltext.clearobjslist;

      fra_Voransicht.img_DocView.Visible := false;
      IO.LoadFromFile(sDocFile);

      for licounter := 0 to 2 do
      begin
         if (Fileexists(sChk4pIev)) then
         begin
            lblesbaranno := True;
            break;
         end;
         sleep(20);
      end;

      if lblesbaranno then
      begin
         fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
                     GgfLogEvnt('LoadFromFileIEV M4');
         if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
         begin
            lsUsers := sGUsrName;
            liobjcount := fra_Voransicht.img_DocView.ObjectsCount;

            dm_MainForm2.pum_PrivAnno.Items.Add(
               newItem(sGUsrName, //name
               0,    //shortcut
               False,//checked
               True, // enabled
               dm_MainForm2.pum_PrivAnnoClick, //onclick
               0,    //heplcontext
               'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
               ));
            dm_MainForm2.pum_PrivAnno.Items[
               dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
               iGUSRID;
         end;
      end;
      if TMPSQL(' select b.usr_id, src_usr_id, usr_name from sys_docxs   as b left join' +
         ' sys_usr as a on(a.usr_id=b.src_usr_id) where b.usr_id = ' +
         IntToStr(igUsrId) + ' and  doc_id= ' + IntToStr(igdocid) +
         ' and arc_id=' + IntToStr(igarcid) + ' and  (find_in_set(' +
         #39 + 'apread' + #39 + ',rights))') then
      begin
         for licounter := 0 to dm_db.my_q_Tmp.RecordCount - 1 do
         begin
            for licounter2 := 0 to fra_Voransicht.img_DocView.io.params.ImageCount - 1 do
            begin
               licounter2Save := licounter2;
               sChk4pIev := ChangeFileExt(sDocFile, '') + inttostr(licounter2) + 'P' +
                  dm_db.my_q_Tmp.FieldByName('src_usr_id').AsString + '.IEV';
               if Fileexists(sChk4pIev) then
               begin
                  // Icon 119
                  fra_Voransicht.img_DocView.LoadFromFileIEV(sChk4pIev);
                     GgfLogEvnt('LoadFromFileIEV M3');
                  if fra_Voransicht.img_DocView.ObjectsCount <> 0 then
                  begin
                     liobjcount := fra_Voransicht.img_DocView.ObjectsCount + liobjcount;
                     if lsUsers = '' then
                        lsUsers := dm_db.my_q_Tmp.FieldByName('usr_name').AsString
                     else
                        lsUsers := lsusers + ', ' +
                           dm_db.my_q_Tmp.FieldByName('usr_name').AsString;
                     dm_MainForm2.pum_PrivAnno.Items.Add(
                        newItem(dm_db.my_q_Tmp.FieldByName('usr_name').AsString, //name
                        0,    //shortcut
                        False,//checked
                        True, // enabled
                        dm_MainForm2.pum_PrivAnnoClick, //onclick
                        0,    //heplcontext
                        'Privan_' + IntToStr(dm_MainForm2.pum_PrivAnno.Items.Count)//Name
                        ));
                     dm_MainForm2.pum_PrivAnno.Items[
                        dm_MainForm2.pum_PrivAnno.Items.Count - 1].Tag :=
                        dm_db.my_q_Tmp.FieldByName('src_usr_id').AsInteger;
                  end;
               end;
            end;
         end;

         if lsusers = '' then
         begin
            tbx_privNote.ImageIndex := 109;
            // Icon 109
         end
         else
         begin
            tbx_privNote.ImageIndex := 119;
            tbx_privNote.Hint :=
               _('Zu diesem Dokument existiert eine persnliche Notiz von') + ' ' + lsusers;
         end;
         fra_Voransicht.img_DocView.RemoveAllObjects;
         frm_MainForm.fra_Volltext.clearobjslist;
      end
      else
      begin
         LogEvnt('error with TMPSQL in   ShowVoransicht, searching for priv anno');
      end;

      if lblesbar then
      begin
         // Wenn eine IEV Datei mit Annotation existiert wird die Schaltflaeche Annotation automatisch aktiviert
         // und ebenfalls die Annotation automatisch angezeigt
         // if FileExists(sIEVFile) then tbi_VShowAnno.Checked := true;

         userights(rgDocRight);
         lspubannopages := '';
         for licounter := 0 to 2 do
         begin
            if (Fileexists(sIEVFile)) then
            begin
               if lspubannopages = '' then
               begin
                  lspubannopages := IntToStr(licounter2save + 1);
               end
               else
               begin
                  lspubannopages := lspubannopages + ',' + IntToStr(licounter2save + 1);
               end;
               if licounter2save = 0 then
               begin
                  lblesbarpubanno := True;
               end;
               break;
            end;
         end;

         if (lspubannopages <> '') or (lsusers <> '') then
         begin
            if tbx_privNote.Visible and (lspubannopages <> '') and (lsusers <> '') and tbx_pubNote.Visible then
            begin
               iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbi_vshowanno).BoundsRect.Left;
               iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbi_vshowanno).BoundsRect.Top;
            end
            else
            if tbx_privNote.Visible and (lsusers <> '') then
            begin
               iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbx_privNote).BoundsRect.Left;
               iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbx_privNote).BoundsRect.Top;
            end
            else
            if tbx_pubNote.Visible then
            begin
               iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbx_pubNote).BoundsRect.Left;
               iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbx_pubNote).BoundsRect.Top;
            end
            else
            begin
               iXTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbi_vshowanno).BoundsRect.Left;
               iYTbi := frm_MainForm.tlb_Zoom2.View.Find(
                  frm_MainForm.tbi_vshowanno).BoundsRect.Top;
            end;
            if lsusers <> '' then
            begin
               if liobjcount = 1 then
               begin
                   lsprivtmp := Format(
                      _('Zu diesem Dokument existiert eine persnliche Notiz von %s'),
                      [lsusers]);
               end
               else
               begin
                  lsprivtmp := Format(
                     _('Zu diesem Dokument existieren %d persnliche Notizen von %s'),
                     [liobjcount,lsusers]);
               end;
               lstmp := lsprivtmp;
            end;
            if lspubannopages <> '' then
            begin
               tbx_pubNote.ImageIndex := 150;
               lspubtmp := 
                  _('Zu diesem Dokument existieren ffentliche Notizen auf Seite(n)')
                  + ' ' + lspubannopages;
               lstmp := lspubtmp;
               tbx_pubNote.Hint := lspubtmp;
            end;
            if (lspubannopages <> '') and (lsusers <> '') then
            begin
               lstmp := lspubtmp + #13 + lsprivtmp;
            end;
            iXTlb := frm_MainForm.tlb_Zoom2.Left;
            iYTlb := frm_MainForm.tlb_Zoom2.Top;

            iPos.X := frm_MainForm.tlb_Zoom2.CurrentDock.Left + iXTlb + iXTbi + 15;
            iPos.Y := frm_MainForm.tlb_Zoom2.CurrentDock.Top + iYTlb + iYTbi + 15;

            bh_PrivAnnoExist.ActivateHintPos(frm_MainForm, iPos,
               _('Notiz'),
               lstmp);
         end;
         if lspubannopages = '' then
         begin
            tbx_pubnote.Hint := _('Zeige ffentlliche Anmerkungen an');
            tbx_pubNote.ImageIndex := 110;
         end;


         if lblesbarpubanno and not ShowNoAnno then
            tbi_VShowAnno.Checked := True;
         if tbi_VShowAnno.Checked then
         begin
            tbx_privNote.Visible := True;
            tbx_pubNote.Visible := True;
            // tbx_UserNote.Visible:=false;
         end
         else
         begin
            tbx_privNote.Visible := False;
            tbx_pubNote.Visible := False;
            //tbx_UserNote.Visible:=true;
         end;
         IO.LoadFromFile(sDocFile);
         if tbi_VShowAnno.Checked then
         begin
            if lblesbarpubanno and lblesbar then
            begin
               try
                  if Fileexists(sIEVFile) then
                  begin
                     LoadFromFileIEV(sIEVFile);
                     GgfLogEvnt('LoadFromFileIEV M2');
                  end;
               except on e: exception do
                  begin
                     logevnt('Error ' + e.message + ' on showvoransichtnorefrehs by loading file ' + sIEVFiletmp);
                  end;
               end;
            end
            else
            if ObjectsCount > 0 then
            begin
               RemoveAllObjects;


               fra_Voransicht.updateobjects;
            end;
            frm_MainForm.fra_Volltext.clearobjslist;
            if IO.Params.ImagingAnnot.ObjectsCount > 0 then
               IO.Params.ImagingAnnot.CopyToTImageEnVect(fra_Voransicht.img_DocView);
         end;

         ChangeDocPagenorefresh(3);    // Erneuert nur die Seitenanzeige
         bGImageDisp := True; // Neues Bild wurde geladen
      end
      else
      begin
         frm_mainform.setpanelinfo(_('Die Datei kann nicht gelesen werden.'));
         Clear;
         Blank;
         if ObjectsCount > 0 then
            RemoveAllObjects;
         frm_MainForm.fra_Volltext.clearobjslist;
         bGImageDisp := True;
      end;
   end;
   fra_Voransicht.img_DocView.Visible := true;
   dm_MainForm2.tim_docload.enabled := false;
   frm_MainForm.pnl_docTime.ParentBackground := True;
   frm_MainForm.pnl_docTime.Color := frm_MainForm.pnl_SuchOpt.Color;
   frm_MainForm.pnl_docTime.Caption := '';

   GgfLogEvntEnd ('ShowVoransichtNorefresh End');
end;


procedure Tfrm_MainForm.ChangeDocPagenorefresh(Func: integer);
var
   iPage: integer;
   sIEVFile, sDocFile, sTmpFile: string;
begin
   GgfLogEvnt('ChangeDocPage');

   with fra_Voransicht.img_DocView do
   begin
      iPage := IO.Params.Tiff_ImageIndex;
      case Func of
         0:
            IO.Params.TIFF_ImageIndex := -1;
         1:
            Inc(iPage);
         2:
            Dec(iPage);
      end;
      if iPage < 0 then
         iPage := IO.Params.Tiff_ImageCount - 1;
      if iPage > (IO.Params.Tiff_ImageCount - 1) then
         iPage := 0;

      if (frm_MainForm.reset) then
      begin
         gbArcHandling := False;
         frm_MainForm.reset := false;
         resetmyqarc;
         exit;
      end;
      if dm_db.my_q_Arc.FieldDefList.Find('doc_loc') <> nil then
      begin
         try
            sDocFile := dm_DB.my_q_Arc.FieldByName('doc_loc').AsString;
            sTmpFile := dm_DB.my_q_Arc.FieldByName('ext_loc').AsString;
         except on e: Exception do
            begin
               gbArcHandling := False;
               frm_MainForm.reset := false;
               resetmyqarc;
               exit;
            end;
         end;
         if ObjectsCount > 0 then
            RemoveAllObjects;
         frm_MainForm.fra_Volltext.clearobjslist;
         if (frm_MainForm.reset) then
         begin
            gbArcHandling := False;
            frm_MainForm.reset := false;
            resetmyqarc;
            exit;
         end;
         if FileExists(sTmpFile) then
            sDocFile := sTmpFile;
         if (frm_MainForm.reset) then
         begin
            gbArcHandling := False;
            frm_MainForm.reset := false;
            resetmyqarc;
            exit;
         end;
         if tbx_pubNote.Checked = True then
         begin
            sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(iPage) + '.IEV';
         end;

         sIEVFile := StringReplace(sIEVFile, sGArcPath, sGCopyPath, [rfReplaceAll,rfIgnoreCase]);

         if tbx_privNote.Checked = True then
         begin
            sIEVFile := ChangeFileExt(sDocFile, '') + IntToStr(iPage) +
               'P' + IntToStr(iGPrivAnnoID) + '.IEV';
         end;
         //todo loading doc 2 times??? one from showvoransicht and now? and
         // showvoransicht calls that procedure

         IO.Params.Tiff_ImageIndex := iPage;
         IO.LoadFromFile(sDocFile);
         if IO.Params.ImagingAnnot.ObjectsCount > 0 then
            IO.Params.ImagingAnnot.CopyToTImageEnVect(fra_Voransicht.img_DocView);
         if (frm_MainForm.reset) then
         begin
            gbArcHandling := False;
            frm_MainForm.reset := false;
            resetmyqarc;
            exit;
         end;
         if FileExists(sIEVFile) and tbi_VShowAnno.Checked then
            begin
               LoadFromFileIEV(sIEVFile);
               GgfLogEvnt('LoadFromFileIEV M1');
            end;

         fra_Voransicht.updateobjects;

         tbsi_VZoomClick(self);
      end;
      if dpnl_Thumbs.Visible and (func <> 0) then
      begin
         tmb_Voransicht.deselect;
         tmb_Voransicht.SelectedImage := iPage;
      end;
      tbxse_page.Text := IntToStr(iPage + 1);
      lbl_VSeite.Caption := _('von') + ' ' +
         IntToStr(IO.Params.Tiff_ImageCount) + ' ';
   end;
end;


procedure Tfrm_MainForm.tbi_manuscanClick(Sender: TObject);
var lsExe, lsPar: string;
begin
   lsExe := BD.ExeDir + 'manuscan.vbs';

   lsPar := ChangeFileExt(ExtractFileName(sGConnection),'');
   if iGArcID>=0 then
   lsPar := lsPar + ' -ArcId:' + IntToStr(iGArcID);

   GgfLogEvnt('tbi_manuscanClick: '+lsExe+' '+lsPar);

   ShellExecute(0, 'open', PChar(lsExe), PChar(lsPar), nil, SW_hide);
end;

procedure Tfrm_MainForm.tbi_historyClick(Sender: TObject);
begin
   tbi_history.checked := not tbi_history.checked;
   dpnl_manfav.visible := tbi_history.checked;
end;

procedure Tfrm_MainForm.tbi_hideposvtxClick(Sender: TObject);
begin
   fra_Volltext.removeocrhits;
end;


procedure Tfrm_MainForm.tbxse_pageChange(Sender: TObject; const Text: String);
var iPAge: integer;
begin
   if gbdontsetpage then
   begin
      exit;
   end;
   try
      iPage := strtoint(Text) - 1;
   except on e: Exception do
      begin
         exit;
      end;
   end;
   with fra_Voransicht.img_DocView do
   begin
      if iPage < 0 then
      begin
         iPage := IO.Params.Tiff_ImageCount - 1;
      end;
      if iPage > (IO.Params.Tiff_ImageCount - 1) then
      begin
         iPage := 0;
      end;
      tmb_VoransichtImageSelect(sender, iPage);
      lbl_VSeite.Caption := _('von') + ' ' + IntToStr(IO.Params.Tiff_ImageCount) + ' ';
   end;
   gbchangevaluespinpage := false;
end;

procedure Tfrm_MainForm.tv_leseDblClick (Sender: TObject);

var
   lPvntopsrc: TTreenode;

begin
   GgfLogEvntBeg ('tv_leseDblClick Begin');

   if   gbansichtlesen
     or dm_db.tim_ansicht  .Enabled
     or dm_db.tim_searcharc.Enabled
   then begin
      GgfLogEvntEnd ('tv_leseDblClick End via Exit');
      exit;
   end;

   if tv_lese.Selected.imageindex = 1 then
   begin
      lPvntopsrc := TTreenode(tv_lese.Selected);

      while (lPvntopsrc <> nil            )
        and (lPvntopsrc <> tv_lese.TopItem)
      do begin
         lPvntopsrc := lPvntopsrc.Parent;
      end;

      ftnlastbacknode := TTreenode(tv_lese.Selected);
      searchWithNode(TDOMnode(tv_lese.Selected.Data));
   end;

  GgfLogEvntEnd ('tv_leseDblClick End');
end;

procedure Tfrm_MainForm.tv_leseDragOver(Sender, Source: TObject; X,
   Y: Integer; State: TDragState; var Accept: Boolean);
begin
   if Source = nil then
   begin
      exit;
   end;

   if ((Source.ClassName = TTreeView.ClassName)) then
   begin
      accept := True;
      //    Outputdebugstring(PChar('dropped '));
      if (not (cslbuttondown in tv_lese.ControlState)) then
      begin
      end;
   end;
end;

procedure Tfrm_MainForm.tv_leseEditing(Sender: TObject; Node: TTreeNode;
   var AllowEdit: Boolean);
begin
   fbedtingtv_levenode := true;
   // AllowEdit := True;
end;

procedure Tfrm_MainForm.tv_leseMouseMove(Sender: TObject;
   Shift: TShiftState; X, Y: Integer);
var lpt: TTreenode;
begin
   MousePositiontv_lese.x := x;
   MousePositiontv_lese.y := y;
   lpt := tv_lese.GetNodeAt(x, Y);
   if lpt = nil then
   begin
      exit;
   end;

   if (cslbuttondown in tv_lese.ControlState) and (not tv_lese.Dragging) and
      (lpt.ImageIndex <> 0) then
   begin
      tv_lese.BeginDrag(false, 20);
   end;
end;

procedure Tfrm_MainForm.tv_leseDragDrop(Sender, Source: TObject; X, Y: Integer);
var
   Data0, data1, data2: Tdomnode;
   Pvnsrc, Pvndest, lPvntopsrc, lPvntopdest,
   ToDeleteItem, ltnextitem: TTreenode;
   Doc: TdomDocument;
   DomNode1, DomNode2: TDomNode;
   childcount, childrun: integer;
begin
   GgfLogEvnt('vst_favfileEndDrag');

   //is editing? (this doesnt work...
   if tv_lese.IsEditing or fbedtingtv_levenode then
   begin
      exit;
   end;
   // src is selected
   Pvnsrc := tv_lese.Selected;
   data2 := nil;
   // no srouce no moving
   if pvnsrc = nil then
      exit;
   // check if srouce has parent and if the parent history is
   lPvntopsrc := Pvnsrc.Parent;
   while ((lPvntopsrc <> fpvnhistofav)) and (lPvntopsrc <> nil) and
      (lPvntopsrc <> tv_lese.TopItem) do
   begin
      lPvntopsrc := lPvntopsrc.Parent;
   end;
   if (pvnsrc = nil) //or (lPvntopsrc = fpvnhistofav)
   then
   begin
      exit;
   end;
   //  Outputdebugstring(PChar('dropped vtfs'));
   //get the destination and see if it has the same parent
   Pvndest := tv_lese.GetNodeAt(x, Y);
   if (Pvndest = pvnsrc) or (pvnsrc = Pvndest.parent) then
      exit;

   if pvndest <> nil then
   begin
      if pvndest.Parent <> nil then
      begin
         lPvntopdest := pvndest.Parent;
         while ((lPvntopdest <> fpvnhistofav)) and (lPvntopdest <> nil) and
            (lPvntopdest <> tv_lese.TopItem) do
         begin
            lPvntopdest := lPvntopdest.Parent;
         end;
      end
      else
      begin
         lPvntopdest := pvndest;
      end;
      Data0 := Pvnsrc.Data;
      Data1 := Pvndest.Data;

      if data1 <> nil then
      begin
         try
            if lPvntopsrc = fpvnhistofav then
            begin
               //            doc.ChildNodes.Item().
               if lPvntopdest <> lPvntopsrc then
               begin
                  data2 := data1.OwnerDocument.ImportNode(data0, true);
                  DomNode1 := data2.Attributes.GetNamedItem('name_fav');
                  DomNode2 := data2.Attributes.GetNamedItem('Suchdatum');
                  DomNode1.NodeValue := DomNode2.NodeValue;

                  givirstualfiles := givirstualfiles + 1;
                  setlength(gpvnvirstualfiles, givirstualfiles);
                  gpvnvirstualfiles[givirstualfiles - 1].domnode := data2;
                  gpvnvirstualfiles[givirstualfiles - 1].Name := DomNode1.NodeValue;

                  trystrtoint(data2.GetFirstChildElement('arcid').TextContent,
                     gpvnvirstualfiles[givirstualfiles - 1].arcid);
               end
               else
               begin
                  data2 := data0;
               end;
               data1.AppendChild(data2);
               Doc := (dm_MainForm2.XmlToDomParser_history.DOMImpl.Documents.Item(0) as TdomDocument);
               doc.ChildNodes.Item(0).RemoveChild(data0);
            end
            else
            begin
               //dont allow to copy to history
               if (lPvntopdest <> fpvnhistofav) then
               begin
                  data2 := data0;
                  data1.AppendChild(data2);
               end
               else
               begin
                  exit;
               end;
            end;
         except
            on e: Exception do
               exit;
         end;
      end
      else
      begin
         try
            Doc := (dm_MainForm2.XmlToDomParser_local.DOMImpl.Documents.Item(0) as
               TdomDocument);

            if lPvntopsrc = fpvnhistofav then
            begin
               doc.AppendChild(data0.CloneNode(false));
            end
            else
            begin
               doc.AppendChild(data0);
            end;
         except
            on e: Exception do
               exit;
         end;
      end;
      //move       recursively
      ToDeleteItem := Pvnsrc;
      ltnextitem := tv_lese.Items.addchildObject(pvndest, pvnsrc.Text, data2);
      ltnextitem.ImageIndex := pvnsrc.ImageIndex;
      ltnextitem.SelectedIndex := pvnsrc.SelectedIndex;
      ChildCount := tv_lese.Selected.Count;
      for Childrun := 1 to ChildCount do
      begin
         pvnsrc := tv_lese.Selected.GetFirstChild;
         ltnextitem := tv_lese.Items.AddChildObject(pvndest, pvnsrc.Text, Pvnsrc.Data);
         ltnextitem.ImageIndex := pvnsrc.ImageIndex;
         ltnextitem.SelectedIndex := pvnsrc.SelectedIndex;
         tv_lese.Items.Delete(pvnsrc);
      end;
      ToDeleteItem.Delete;
      tv_lese.Update;
   end;
   //  Outputdebugstring(PChar('end drag '));
end;


procedure Tfrm_MainForm.tbi_normalmouseClick(Sender: TObject);
begin
	if not tbi_DocVoransicht.Checked then
    	Exit;

   uncheckallgraphictools;
   tbi_normalmouse.checked := true;
   fra_voransicht.img_DocView.DeSelect;
   fra_voransicht.img_DocView.MouseInteractVt := [];
   fra_voransicht.img_DocView.MouseInteract := [miscroll];
   fra_voransicht.img_DocView.Cursor := 0;
end;

procedure Tfrm_MainForm.tbi_objauswahlClick(Sender: TObject);
begin
	if not tbi_DocVoransicht.Checked then
    	Exit;
   GgfLogEvnt('tbi_objauswahlClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbi_objauswahl.checked := true;
      fra_voransicht.img_DocView.MouseInteractVt := [miObjectSelect];
      tbi_normalmouse.checked := false;
      fra_voransicht.img_DocView.Cursor := 1780;
   end;
end;

procedure Tfrm_MainForm.uncheckallgraphictools;
begin
   tbi_normalmouse.checked := false;
   tbx_fav1.checked := false;
   tbx_fav2.checked := false;
   tbx_fav3.checked := false;
   tbx_fav4.checked := false;
   tbx_fav5.checked := false;
   tbx_hiim.checked := false;
   tbx_noteim.checked := false;
   tbx_noteimgreen.checked := false;
   tbx_noteimyellow.checked := false;
   tbx_noteimred.checked := false;
   tbx_lineim.checked := false;
   tbx_Textim.checked := false;
   tbi_freihand.checked := false;
   tbi_objauswahl.checked := false;

   tbsi_highlight.checked := false;
   tbsi_notizen.checked := false;
   tbsi_stifte.checked := false;
   tbxs_text.checked := false;

   if fra_Voransicht.img_docview.MouseInteractVt = [miPutPolyLine] then
   begin
      fra_Voransicht.img_DocView.CancelInteracts;
      fra_Voransicht.img_DocView.DeSelect;
      fra_Voransicht.img_DocView.UnSelAllObjects;
      fra_Voransicht.img_docview.MouseInteractVt := [];
      fra_Voransicht.img_docview.BitmapResampleFilter := rfLinear;
      fra_Voransicht.createannodata(fra_Voransicht.img_DocView.ObjHeapCount -1);
      fra_Voransicht.gbAnnoNotSaved := True;
   end;

   tbi_normalmouse.Checked := true;
   fra_voransicht.img_DocView.CancelInteracts;
   fra_voransicht.img_DocView.UnSelAllObjects;
   fra_voransicht.img_DocView.MouseInteract := [miscroll];
   fbisktstamp := false;
   fra_Voransicht.fEndPolyLineOnMouseUp := False;
end;

procedure Tfrm_MainForm.tbi_freihandClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_freihandClick');
   uncheckallgraphictools;

   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_stifte.ImageIndex := 13;
      fra_Voransicht.ReadObjVals(16, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutPolyLine];
      fra_voransicht.fphistorymessage := _('Linie');
      tbsi_stifte.Checked := true;
      tbi_normalmouse.checked := false;
      fra_voransicht.img_Docview.BitmapResampleFilter := rfNone;
      fra_Voransicht.fEndPolylineOnMouseUp := True;
   end;
end;

procedure Tfrm_MainForm.tv_leseKeyUp(Sender: TObject; var Key: Word;
   Shift: TShiftState);
var
   licount, licount2: integer;
begin
   if key = VK_DELETE then
   begin
      if TDOMNODE(tv_lese.Selected.Data).Attributes.GetNamedItem('name_fav') = nil then
         exit;
      for licount := 0 to givirstualfiles - 1 do
      begin
         if gpvnvirstualfiles[licount].Name
            = TDOMNODE(tv_lese.Selected.Data).Attributes.GetNamedItem('name_fav').NodeValue then
         begin
            if licount <> givirstualfiles - 1 then
            begin
               for licount2 := licount to givirstualfiles - 2 do
               begin
                  gpvnvirstualfiles[licount2] := gpvnvirstualfiles[licount2 + 1]
               end;
            end;
            givirstualfiles := givirstualfiles - 1;
            setlength(gpvnvirstualfiles, givirstualfiles);
         end;
      end;
      TDOMNODE(tv_lese.Selected.Data).ParentNode.RemoveChild(TDOMNODE(tv_lese.Selected.Data));
      TDOMNODE(tv_lese.Selected.Data).destroy;
      tv_lese.Selected.Delete;
   end;
end;


function Tfrm_MainForm.ZusFieldsChanged: Boolean;
var
   iCount: integer;
   xComp, xComp01, xComp02: Tcomponent;
   stmpfield1, sTmpField: string;
begin
   Result := false;
   for iCount := 0 to (iGZusFCount - 1) do
   begin
      // save the name of the component!
      xComp01 := sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount));
      stmpfield1 := Copy(TJvStaticText(xComp01).Caption, 1,
         length(TJvStaticText(xComp01).Caption) - 1);
      with sbx_ZusFeld.FindComponent('zlbl_Tmp' + IntToStr(iCount)) as

         // TLabel do
         TJvStaticText do
      begin
         sTmpField := Hint;
         xComp := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp' + IntToStr(iCount));
      end;
      if xComp is TEdit then
      begin
         if (TEdit(xComp).Modified = True) then
         begin
            Result := true;
            break;
         end;
      end;

      if xComp is TJvDateEdit then
      begin
         // and 4 means it was modified
         if (TJvDateEdit(xComp).Tag and 4) = 4 then
         begin
            Result := true;
            break;
         end;
      end;

      if xComp is TComboBox then
      begin
         //??? save when
         if (TComboBox(xComp).Tag and 4) = 4 then
         begin
            Result := true;
            break;
         end;
      end;

      if xComp is TjvCheckedComboBox then  //  28.05.2010  Vers. 3.5.0.79  [2590]  r.sch.
      begin
         // and 4 means it was modified
         if (TjvCheckedComboBox(xComp).Tag and 4) = 4 then
         begin
            Result := true;
            break;
         end;
      end;

      if xComp is TSpinEdit then
      begin
         //??? save when
         xComp02 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_cbx_' + IntToStr(iCount));
         if xComp02 <> nil then
         begin
            if ((TSpinEdit(xComp).Tag and 4) = 4) or
               ((TComboBox(xComp02).Tag and 4) = 4) then
            begin
               Result := true;
               break;
            end;
         end;
      end;
      if xComp is TjvSpinEdit then
      begin
         //??? save when
         xComp02 := FindComponentRekursivFrame(sbx_ZusFeld, 'zedt_Tmp_og_' + IntToStr(iCount));
         if ((TjvSpinEdit(xComp).Tag and 4) = 4) or
            ((TjvSpinEdit(xComp02).Tag and 4) = 4) then
         begin
            Result := true;
            break;
         end;
      end;
   end;
end;


procedure Tfrm_MainForm.tbi_textfirstClick(Sender: TObject);
begin
   tbxs_text.ImageIndex := 15;
end;

procedure Tfrm_MainForm.tbi_textsecondClick(Sender: TObject);
var
   liresult: integer;
begin
   GgfLogEvnt('tbx_TextimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbxs_text.ImageIndex := 16;
      fra_Voransicht.ReadObjVals(21, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Textannotation');
      tbxs_text.checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_grphikoptionenClick(Sender: TObject);
begin
   Application.CreateForm(Tfrm_DocEditOpt, frm_DocEditOpt);
   frm_DocEditOpt.ShowModal;
   frm_DocEditOpt.Release;
end;


function Tfrm_MainForm.Savetv_leseStat: boolean;
   //////////////////////////////////////////////////////////////////
   ///  06.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion sichert den optischen Aufbau des Lager    ///
   ///  und Archiv Baumes in der Registrierung.                   ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount, iID: integer;
   reg: TRegistry;
begin
   GgfLogEvnt('Savetv_leseStat');
   Result := True;
   reg := TRegistry.Create;
   try
      try
         reg.RootKey := HKEY_CURRENT_USER;
         reg.OpenKey('Software\bitfarm\Archiv_V3\Viewer\Tv_leseTree', True);
         for iCount := 0 to tv_lese.Items.Count - 1 do
         begin
            iID := integer(tv_lese.Items.Item[iCount].AbsoluteIndex);
            reg.WriteBool(IntToStr(iID), tv_lese.Items.Item[iCount].Expanded);
         end;
         reg.CloseKey;
      except
         on e: Exception do
         begin
            Result := False;
            ErrorMsg('Savetv_leseStat', _('Fehler beim Speichern des Treestatus:') +
               e.Message, 2038, True);
         end;
      end;
   finally
      FreeAndNil(reg);
   end;
end;


function Tfrm_MainForm.Loadtv_leseStat: boolean;
   //////////////////////////////////////////////////////////////////
   ///  06.07.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Diese Funktion liest den optischen Aufbau des Lager und   ///
   ///  Archiv Baumes aus der Registrierung.                      ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschlag                             ///
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
   //  Einlesen der Tree Knoten aus den Lager und aRCHiVEN

var
   iCount, iID: integer;
   reg: TRegistry;
begin
   GgfLogEvnt('Loadtv_leseStat');
   Result := True;
   reg := TRegistry.Create;
   try
      try
         with reg do
         begin
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\tv_leseTree', True);
            for iCount := 0 to tv_lese.Items.Count - 1 do
            begin
               iID := integer(tv_lese.Items.Item[iCount].AbsoluteIndex);
               // check first if value exists
               if ValueExists(IntToStr(iID)) then
               begin
                  if ReadBool(IntToStr(iID)) then
                     tv_lese.Items.Item[iCount].Expand(False)
                  else
                     tv_lese.Items.Item[iCount].Collapse(False);
               end;
            end;
            tv_lese.Enabled := True;

            CloseKey;

         end;
      except
         on e: Exception do
         begin
            Result := False;
            tv_lese.FullCollapse;
            //ErrorMsg('SaveLgrArcStat', 'Fehler beim Laden des Treestatus:' + e.Message, 2038, True);
         end;
      end;
   finally
      FreeAndNil(reg);
   end;
end;

procedure Tfrm_MainForm.btn_backClick(Sender: TObject);
var
   lnode: TTreenode;
begin
   if gbansichtlesen or dm_db.tim_ansicht.Enabled or dm_db.tim_searcharc.enabled then
   begin
      exit;
   end;
   if ftnlastbacknode = nil then
   begin
      lnode := fpvnhistofav.getFirstChild;
   end
   else
   begin
      lnode := fpvnhistofav.GetNextChild(ftnlastbacknode);
   end;
   ftnlastbacknode := lnode;
   lnode.Selected := true;
   searchWithNode(TDOMnode(lnode.Data));
end;

procedure Tfrm_MainForm.btn_forwardClick(Sender: TObject);
var
   lnode: TTreenode;
begin
   if gbansichtlesen or dm_db.tim_ansicht.Enabled or dm_db.tim_searcharc.enabled then
   begin
      exit;
   end;
   if ftnlastbacknode = nil then
   begin
      lnode := fpvnhistofav.getFirstChild;
   end
   else
   begin
      lnode := fpvnhistofav.GetPrevChild(ftnlastbacknode);
   end;
   if lnode = nil then
   begin
      lnode := fpvnhistofav.getFirstChild;
   end;
   ftnlastbacknode := lnode;
   lnode.Selected := true;
   searchWithNode(TDOMnode(lnode.Data));
end;

procedure Tfrm_MainForm.tbi_stiftsecondClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_freihandClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_stifte.ImageIndex := 19;
      fra_Voransicht.ReadObjVals(17, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutPolyLine];
      fra_voransicht.fphistorymessage := _('Linie');
      tbsi_stifte.Checked := true;
      fra_Voransicht.fEndPolylineOnMouseUp := True;
      tbi_normalmouse.checked := false;
      fra_voransicht.img_docview.BitmapResampleFilter := rfNone;
   end;
end;

procedure Tfrm_MainForm.tbi_stiftthirdClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_freihandClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_stifte.ImageIndex := 17;
      fra_Voransicht.ReadObjVals(18, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutPolyLine];
      fra_voransicht.fphistorymessage := _('Linie');
      tbsi_stifte.Checked := true;
      fra_Voransicht.fEndPolylineOnMouseUp := True;
      tbi_normalmouse.checked := false;
      fra_voransicht.img_docview.BitmapResampleFilter := rfNone;
   end;
end;

procedure Tfrm_MainForm.tbi_stiftfourthClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_freihandClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_stifte.ImageIndex := 18;
      fra_Voransicht.ReadObjVals(19, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutPolyLine];
      fra_voransicht.fphistorymessage := _('Linie');
      tbsi_stifte.Checked := true;
      fra_Voransicht.fEndPolylineOnMouseUp := True;
      tbi_normalmouse.checked := false;
      fra_voransicht.img_docview.BitmapResampleFilter := rfNone;
   end;
end;

procedure Tfrm_MainForm.tbi_stiftfifthClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_freihandClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_stifte.ImageIndex := 21;
      fra_Voransicht.ReadObjVals(20, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutPolyLine];
      fra_voransicht.fphistorymessage := _('Linie');
      tbsi_stifte.Checked := true;
      fra_Voransicht.fEndPolylineOnMouseUp := True;
      tbi_normalmouse.checked := false;
      fra_voransicht.img_docview.BitmapResampleFilter := rfNone;
   end;
end;


procedure Tfrm_MainForm.tbi_highlightsecondClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_highlightsecondClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_highlight.imageindex := 28;
      fra_Voransicht.ReadObjVals(29, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutBox];
      fra_voransicht.fphistorymessage := _('Marker');
      tbsi_highlight.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_highlightthirdClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_highlightthirdClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_highlight.imageindex := 30;
      fra_Voransicht.ReadObjVals(30, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutBox];
      fra_voransicht.fphistorymessage := _('Marker');
      tbsi_highlight.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_highlightfourthClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_highlightfourthClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_highlight.imageindex := 27;
      fra_Voransicht.ReadObjVals(31, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutBox];
      fra_voransicht.fphistorymessage := _('Marker');
      tbsi_highlight.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_highlightfifthClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_highlightfifthClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_highlight.imageindex := 29;
      fra_Voransicht.ReadObjVals(32, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutBox];
      fra_voransicht.fphistorymessage := _('Marker');
      tbsi_highlight.Checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_textthirdClick(Sender: TObject);
var
   liresult: integer;
begin
   GgfLogEvnt('tbx_TextimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbxs_text.ImageIndex := 22;
      fra_Voransicht.ReadObjVals(22, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Textannotation');
      tbxs_text.checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_textfourthClick(Sender: TObject);
var
   liresult: integer;
begin
   GgfLogEvnt('tbx_TextimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbxs_text.ImageIndex := 23;
      fra_Voransicht.ReadObjVals(23, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Textannotation');
      tbxs_text.checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbi_textfithClick(Sender: TObject);
var
   liresult: integer;
begin
   GgfLogEvnt('tbx_TextimClick');

   uncheckallgraphictools;
   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbxs_text.ImageIndex := 24;
      fra_Voransicht.ReadObjVals(24, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Textannotation');
      tbxs_text.checked := true;
      tbi_normalmouse.checked := false;
   end;
end;

procedure Tfrm_MainForm.tbx_noteimblueClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_noteimblueClick');

   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_notizen.ImageIndex := 9;
      fra_Voransicht.ReadObjVals(27, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Blaue Notiz');
      tbsi_notizen.Checked := true;
   end;
end;

procedure Tfrm_MainForm.tbx_noteimorangeClick(Sender: TObject);
begin
   GgfLogEvnt('tbx_noteimorangeClick');

   if rGDocRight.awrite and (tbx_pubNote.checked or tbx_privNote.Checked) then
   begin
      tbsi_notizen.ImageIndex := 20;
      fra_Voransicht.ReadObjVals(28, -1);
      fra_Voransicht.createannodata(-1);
      fra_voransicht.img_docview.MouseInteractVt := [miPutMemo];
      fra_voransicht.fphistorymessage := _('Orange Notiz');
      tbsi_notizen.Checked := true;
   end;
end;

procedure Tfrm_MainForm.tbsi_localspeichernClick(Sender: TObject);
begin
   case tbsi_localspeichern.imageindex of
      // selected
      0: tbi_VlocalSaveTifClick(sender);
      1: tbi_VlocalSaveOriClick(sender);
      2: tbi_VlocalSavePdfClick(sender);
      4: tbi_savepdfsasonefileClick(sender);
      5: tbi_savetifsasonefileClick(sender);
      // default image
      19: tbi_VlocalSaveOriClick(sender);
   end;
end;

//  12.05.2010  r.sch.  3.5.0.76  [2197]
procedure Tfrm_MainForm.tbi_configurationClick(Sender: TObject);
begin

   frm_DocEditOpt :=  Tfrm_DocEditOpt.Create(Self);
   frm_DocEditOpt.ShowModal;
   frm_DocEditOpt.Release;
   // Favoritenstempel aktualisieren
   LoadFavStampbuttons( frm_mainform.tbx_fav1, frm_mainform.tbx_fav2,
         frm_mainform.tbx_fav3, frm_mainform.tbx_fav4, frm_mainform.tbx_fav5);
end;

procedure Tfrm_MainForm.tbsi_stifteClick(Sender: TObject);
begin
   GgfLogEvnt('tbsi_stifteClick');
   case tbsi_stifte.ImageIndex of
      13:
      begin
         tbi_freihandClick(sender);
      end;
      19:
      begin
         tbi_stiftsecondClick(sender);
      end;
      17:
      begin
         tbi_stiftthirdClick(sender);
      end;
      18:
      begin
         tbi_stiftfourthClick(sender);
      end;
      21:
      begin
         tbi_stiftfifthClick(sender);
      end;
   else
   begin
      tbi_freihandClick(sender);
   end;
   end;
end;

procedure Tfrm_MainForm.tbxs_textClick(Sender: TObject);
begin
   GgfLogEvnt('tbxs_textClick');

   case tbxs_text.ImageIndex of
      15:
      begin
         tbx_TextimClick(sender);
      end;
      16:
      begin
         tbi_TextsecondClick(sender);
      end;
      22:
      begin
         tbi_TextthirdClick(sender);
      end;
      23:
      begin
         tbi_TextfourthClick(sender);
      end;
      24:
      begin
         tbi_textfithClick(sender);
      end;
   else
   begin
      tbx_TextimClick(sender);
   end;
   end;
end;

procedure Tfrm_MainForm.tbsi_notizenClick(Sender: TObject);
begin
   GgfLogEvnt('tbxs_textClick');

   case tbsi_notizen.ImageIndex of
      5:
      begin
         tbx_noteimyellowClick(sender);
      end;
      10:
      begin
         tbx_noteimgreenClick(sender);
      end;
      11:
      begin
         tbx_noteimredClick(sender);
      end;
      9:
      begin
         tbx_noteimblueClick(sender);
      end;
      20:
      begin
         tbx_noteimorangeClick(sender);
      end;
   else
   begin
      tbx_noteimyellowClick(sender);
   end;
   end;
end;

procedure Tfrm_MainForm.dpnl_manfavClose(Sender: TObject);
begin
   tbi_history.Checked := false;
end;

procedure Tfrm_MainForm.tv_leseMouseDown(Sender: TObject;
   Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   //
end;

procedure Tfrm_MainForm.tv_leseEdited(Sender: TObject; Node: TTreeNode;
   var S: String);
var
   licount: integer;
   lmydnode: Tdomnode;
begin
   lmydnode := TDOMNODE(node.data).Attributes.GetNamedItem('name_fav');
   for licount := 0 to givirstualfiles - 1 do
   begin
      if gpvnvirstualfiles[licount].Name = lmydnode.nodevalue then
      begin
         gpvnvirstualfiles[licount].Name := s;
         break;
      end;
   end;
   lmydnode.nodevalue := s;
   TDOMNODE(node.data).Attributes.SetNamedItem(lmydnode);
   fbedtingtv_levenode := false;
end;



function Tfrm_Mainform.CreZusPum(ParentMenu: TMenuItem; OnClickFunction: TNotifyEvent;
   BaseName: string; fsavezus: boolean): boolean;
   //////////////////////////////////////////////////////////////////
   ///  12.08.2005 Erstellt by SV.                                ///
   ///                                                            ///
   ///  Erzeugt fr ParentMenu ein neues Untermen                ///
   ///                                                            ///
   ///  Ausgabe: True bei Erfolg                                  ///
   ///           False bei Fehlschl                               ///
   ///  Create Zusatzfelder
   ///                                                            ///
   //////////////////////////////////////////////////////////////////
var
   iCount: integer;
   TmpLbl: TJvStaticText;
   TmpMnu: TMenuItem;
begin
  GgfLogEvntBeg ('CreZusPum Begin');

   frm_Mainform.sbx_ZusFeld.Autoscroll := False;
   Result := True;
   ParentMenu.Clear;
   for iCount := 0 to (frm_Mainform.sbx_ZusFeld.ComponentCount - 1) do
   begin
      if frm_Mainform.sbx_ZusFeld.Components[iCount] is TJvStaticText then
      begin
         try
            TmpLbl := TJvStaticText(frm_Mainform.sbx_ZusFeld.Components[iCount]);

            TmpMnu := newItem(copy(TmpLbl.caption, 1,
               length(TmpLbl.caption) - 1),
               0, False, True, OnClickFunction, 0, 'mnu_' + TmpLbl.Name);
            TmpMnu.Hint := TmpLbl.Name;
            ParentMenu.Add(TmpMnu);
         except
            on e: Exception do
            begin
               ErrorMsg('CreZusPum', _('Fehler beim Erstellen eines Untermens:') +
                  e.Message, 2000, True);
               Result := False;
               if Assigned(TmpLbl) then
                  FreeAndNil(TmpLbl);
               if Assigned(TmpMnu) then
                  FreeAndNil(TmpMnu);
            end;
         end;
      end;
   end;

   frm_Mainform.sbx_ZusFeld.Autoscroll := True;

  GgfLogEvntEnd ('CreZusPum End');
end;


procedure Tfrm_MainForm.tbsi_highlightClick(Sender: TObject);
begin
   GgfLogEvnt('tbxs_textClick');

   case tbsi_highlight.ImageIndex of
      7:
      begin
         tbx_hiimClick(sender);
      end;
      28:
      begin
         tbi_highlightsecondClick(sender);
      end;
      30:
      begin
         tbi_highlightthirdClick(sender);
      end;
      27:
      begin
         tbi_highlightfourthClick(sender);
      end;
      29:
      begin
         tbi_highlightfifthClick(sender);
      end;
   else
   begin
      tbx_hiimClick(sender);
   end;
   end;
end;

procedure Tfrm_MainForm.tbi_GesammelteDokumenteAlsEinPdfVersendenClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_MailsendasonepdfClick');
   askforsave;
   dm_MainForm2.mnu_GesammelteDokumentealseinPDFversenden1Click(sender);
end;

procedure Tfrm_Mainform.askforsave;
begin
   GgfLogEvnt('askforsave');

   if GHasNotBeenSavedAfterModify or ((gtmpiStatus xor gotmpistatus) > 0)
      or btn_SaveDoc.Enabled then
   begin
      if dm_MainForm2.Frage(_('Sie haben nderungen am Dokument vorgenommen.') +
         #13 + _('Mchten Sie die nderungen speichern?'),
         True) = mrYes then
      begin
         tbi_VSaveDocClick(self);
      end;
      GHasNotBeenSavedAfterModify := False;

      fgchangedvoransicht := False;
      fgchangedvoransichttif := false;
      gtmpiStatus := gotmpistatus;
      btn_SaveDoc.Enabled := false;
      tbi_VSaveDoc.Enabled := True;
   end
   else if fra_Voransicht.gbAnnoNotSaved then
   	fra_Voransicht.saveobjects(False, True);
end;


procedure Tfrm_MainForm.tmb_VoransichtMouseEnter(Sender: TObject);
begin
	fbmouseinthumb := true;
end;

procedure Tfrm_MainForm.tmb_VoransichtMouseLeave(Sender: TObject);
begin
	fbmouseinthumb := false;
end;

procedure Tfrm_MainForm.setpanelinfo(fmyinfo: String);
begin
  if gLocalLog then
    GgfLogEvnt('setpanelinfo');

   frm_MAinform.SetStatusText(cStatusPanelInfo,fmyinfo); //3.5.0.25
   dm_MainForm2.tim_statustext.enabled := false;
   dm_MainForm2.tim_statustext.enabled := true;
end;

procedure Tfrm_MainForm.SetStatusText(Panel:integer; AText: String);
begin
  if gLocalLog then
    GgfLogEvnt('SetStatusText Panel:'+IntTostr(Panel)+'; AText:'+AText);

   Self.stb_MAin.Panels[Panel].Caption := AText;
   if Panel < cStatusPanelInfo then
   begin
      stb_MAin.Panels[Panel].Size := Canvas.Textwidth(AText) + 10; //3.5.0.25
   end;
end;

function Tfrm_MainForm.GetStatusText(Panel:integer): String;
begin
   Result := Self.stb_MAin.Panels[Panel].Caption;
end;

procedure Tfrm_MainForm.SetStatusHint(Panel:integer; AText: String);
begin
   Self.stb_MAin.Panels[Panel].Hint := AText;
end;

procedure Tfrm_MainForm.searchforzusfields;
var
   TmpLst, lfTmpzusLst: TStringList;
   iCount, iTmpID: integer;
   coltmpNG: tColumn;
begin
   GgfLogEvnt('searchforzusfields');

   try
      gbcmdzussearch := true;
//      dm_MainForm2.tim_voransicht.enabled := false;
      gbsearched := True;
      dm_db.my_q_arc.IndexFieldNames := '';
      dm_MainForm2.mnu_TGoToArc.Visible := False;
      fra_Volltext.redt_Volltext.Clear;

      iGArcRecNo := -1;
      iGBorderRem := 1;
      //while in login someone can through the hotsearch initiate a search!!!
      if dbtv_LgrArc.TopItem = nil then
         exit;
      bMultiArcQuery := True;
      CreateStandardColumnsTRefferliste;

      with  dbgrd_TrefferListe do     // dynamische Tabelle der Trefferliste erzeugen
      begin
         coltmpNG := columns.add;
         coltmpNG.Width := 70;
         colTmpNG.FieldName := 'add_0000000';
         colTmpNG.Title.Caption := fcmdzusfieldsearch;
      end;

      TmpLst := TStringList.Create;
      lfTmpzusLst := TStringList.Create;
      try
         TmpLst.Clear;
         SetLength(GArcSList, 0);
         // Speicher wieder freigeben!
         getzusfieldsarc(fcmdzusfieldsearch, TmpLst, lfTmpzusLst);
         SetLength(GZusSList, TmpLst.Count);
         for iCount := 0 to (TmpLst.Count - 1) do
         begin
            iTmpID := integer(TmpLst.Objects[iCount]);
            with dm_DB.my_q_LgrArc do
            begin
               First;
               while not EOF do
               begin
                  if FieldByName('arc_id').AsInteger = iTmpID then
                  begin
                     // list only things the user have right at least to read or list!
                     // todo misshandling of dm_db.my_q_tmp_CreStatus!!!
                     dm_db.my_q_tmp_CreStatus.sql.Text :=
                        'select * from sys_arcxs   where   arc_id = ' +
                        IntToStr(iTmpID) + ' and usr_id = ' + IntToStr(iGUsrID) +
                        ' and (FIND_IN_SET(' + #39 + 'read' + #39 +
                        ', rights) or FIND_IN_SET(' + #39 + 'list' + #39 + ', rights))';
                     dm_db.my_q_tmp_CreStatus.Execute;
                     if dm_db.my_q_tmp_CreStatus.RecordCount > 0 then
                     begin
                        GZusSList[iCount].ArcID := iTmpID;
                        GZusSList[iCount].ArcName :=
                           TmpLst.Strings[iCount];
                        GZusSList[iCount].TblName :=
                           FieldByName('arc_tblname').AsString;
                        GZusSList[iCount].Feldname := copy(lfTmpzusLst.Strings[iCount], 1,
                           pos(':', lfTmpzusLst.Strings[iCount]) - 1);
                        GZusSList[iCount].dispname := copy(lfTmpzusLst.Strings[iCount],
                           pos(':', lfTmpzusLst.Strings[iCount]), length(lfTmpzusLst.Strings[iCount]));
                     end;
                     break;
                  end
                  else
                     Next;
               end;
            end;
         end;
      finally
         if Assigned(TmpLst) then
            FreeAndNil(TmpLst);
      end;

      if ((GZusSList = nil)) then
      begin
         frm_mainform.setpanelinfo(_('Keine Berechtigung das Archiv zu durchsuchen.')); //NoRight;
         Exit;
      end;

      pnl_SrcTime.Caption := _('Suche aktiv ...');
      dm_DB.tim_searcharc.Enabled := True;
      pnl_SrcTime.ParentBackground := False;
      pnl_SrcTime.Color := clRed;
      dm_MainForm2.tim_Blank.Enabled := True;

      // while loading dbgrd_trefferliste layout trefferlistealreadyloaded mus be false!
      trefferlistealreadyloaded := False;
      frm_MainForm.DelZusFields2(true);
      GgfLogEvnt('SetControls(False)a'); //3.5.0.22
      SetControls(False); // Beim Suchen die Schaltflchen ausschalten //3.5.0.22

      // Archiv durchsuchen
      SuchZus;

      // in init when no arc and lgr is choosen it should show nothing!
      if ((iGarcID = 0) and (igLgrID = 0)) then
      begin
         ArcSQL(' SELECT * from sys_arc where arc_id = 0');
      end;

      wvlhasfocus := False;
      wvlshowbuttons(False);
      dbgrd_wvl.Refresh;
      dbgrd_wvl.Repaint;
   finally
      begin
         gbcmdzussearch := false;
      end;
   end;

end;

procedure Tfrm_MainForm.getzusfieldsarc(fname: string; ChildList, ChildzusList: TStringList);
begin
   GgfLogEvnt('getzusfieldsarc');
   dm_db.my_q_LgrArc.First;
   while not dm_db.my_q_LgrArc.eof do
   begin
      if dm_db.my_q_LgrArc.fieldbyname('type').asinteger = 1 then
      begin
         dm_db.my_q_Tmp.sql.Text := 'select * from cfg_' + dm_db.my_q_LgrArc.fieldbyname('arc_tblname').asstring;
         dm_db.my_q_Tmp.execute;
         while not dm_db.my_q_Tmp.eof do
         begin
            if dm_db.my_q_Tmp.fieldbyname('disp_name').asstring = fname then
            begin
               ChildList.Addobject(dm_db.my_q_LgrArc.fieldbyname('arc_tblname').asstring,
                  TObject(dm_db.my_q_LgrArc.fieldbyname('arc_id').asinteger));
               ChildzusList.add(dm_db.my_q_Tmp.fieldbyname('feld_name').asstring + ':' +
                  dm_db.my_q_Tmp.fieldbyname('disp_name').asstring);
               break;
            end;
            dm_db.my_q_Tmp.next;
         end;
      end;
      dm_db.my_q_LgrArc.next;
   end;
end;

function Tfrm_MainForm.SuchZus: boolean;
var
   sSQLCMD, lsadd, lsadd2: string;
   iCount: integer;
begin
   GgfLogEvnt('SuchZus');
   tGStart := GetTime;
   Result := False;

   with dm_DB.my_conArc do
   begin
      Disconnect;
      Port := dm_DB.my_Con.Port;
      Server := dm_DB.my_Con.Server;
      Username := dm_DB.my_Con.Username;
      Password := dm_DB.my_Con.Password;
      DataBase := dm_DB.my_Con.Database;
      LoginPrompt := False;
      Options.Compress := True;
      Connect;
   end;

   with dm_DB.my_cmdarc do
   begin
      SQL.Text := 'drop table if exists tmp_' + sGTmpName;
      Execute;
      if
      gbhasgdocid and (not gbkleiner3400) then
      begin
         lsadd := ', `gdoc_id` BIGINT UNSIGNED';
         lsadd2 := ', INDEX `idx_gdoc_id` (`gdoc_id`) ';
      end;

      lsadd := lsadd + ',`add_0000000` VARCHAR(255) NOT NULL default ' + #39 + #39;
      // temporary:
      // http://dev.mysql.com/doc/refman/5.1/de/temporary-table-problems.html
      SQL.Text := 'CREATE   TABLE `tmp_' + sGTmpName + '` (' +
         '`ARC_ID` BIGINT UNSIGNED NOT NULL,' + '`ArcName` VARCHAR(32) NOT NULL,' +
         '`TblName` VARCHAR(14) NOT NULL,' + '`DOC_ID` BIGINT UNSIGNED NOT NULL,' +
         '`DISP_NAME` VARCHAR(32) NOT NULL,' + '`DOC_LOC` VARCHAR(255) NOT NULL,' +
         '`EXT_LOC` VARCHAR(255) NOT NULL,' + '`ORI_LOC` VARCHAR(255) NOT NULL,' +
         '`USR_NAME` VARCHAR(32) NOT NULL,' + 
         '`USR_ID` BIGINT UNSIGNED NOT NULL,' + '`TStamp` DATETIME NOT NULL,' +
         '`DOC_TXT` LONGTEXT,' + '`DOC_STATE` INTEGER UNSIGNED NOT NULL,' +
         '`OCR_QF` INTEGER SIGNED NOT NULL DEFAULT 0,' +
         '`SHA1` varchar(40)' +
         lsadd + lsadd2 +
         ', primary key (`ARC_ID`,`DOC_ID`)' + ') COMMENT = ' +
         #39 + _('Temptabelle fr Benutzer') + ' (USR_ID): ' + sGUsrName +
         ' (' + IntToStr(iGUsrID) + ')' + #39;
      try
         Execute;
      except
         on e: Exception do
            ErrorMsg('SuchArc', _('Fehler beim Erzeugen einer Temptabelle: ') +
               e.Message, 1003, True);
      end;
      for iCount := 0 to (Length(GZusSList) - 1) do
      begin
         sSQLCMD := ' where ' + GZusSList[iCount].feldname + ' like ' + #39 + '%' + fcmdzusvaluesearch + '%' + #39;
         // if there is no name in this arc, we have an empty thing dont show nothing then!
         if GZusSList[iCount].ArcName <> '' then
         begin
            lsadd := '';
            lsadd2 := '';
            if
            gbhasgdocid and (not gbkleiner3400) then
            begin
               lsadd := ', `gdoc_id`';
               lsadd2 := 'gdoc_id, ';
            end;

            lsadd := lsadd + ',add_0000000';
            SQL.Text := 'Insert into tmp_' + sGTmpName +
               ' (arc_id, ArcName, TblName, doc_id, disp_name, doc_loc, ext_loc, ' +
               'ori_loc, usr_name, usr_id, tstamp, doc_txt, doc_state, ocr_qf' + lsadd +
               ') Select Sql_No_cache '
               + IntToStr(GZusSList[iCount].ArcID) + ' as Arc_ID,' +
               #39 + GZusSList[iCount].ArcName + #39 + ' as ArcName,' +
               #39 + GZusSList[iCount].TblName + #39 + ' as TblName,' +
               ' arc.doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, arc.usr_id, tstamp, doc_txt, doc_state, ocr_qf,' +
               lsadd2 + GZusSList[iCount].feldname + ' from arc_'
               + GZusSList[iCount].TblName + ' as arc ' {+ sSLWCMD} +
               sSQLCMD {+ sGroupBy} + ' order by tstamp desc ' + sGMaxHits + '  on duplicate key update ' +
               ' tmp_' + sGTmpName + '.doc_id = arc.doc_id ';
            SQL.Text := StringReplace(SQL.Text, ':bitfarmslwtbl',
               'slw_' + GZusSList[iCount].TblName, [rfReplaceAll]);
            try
               // ShowMessage(sql.Text);
               Execute;
            except
               on e: Exception do
               begin
                  LogEvnt(
                     '1003    ' + _('Fehler') + ' in Modul: SuchZus ' + _('Wurde der Suchjob abgebrochen?'));
                  LogEvnt(
                     '1003    ' + _('Fehler') + ' in Modul: SuchZus ' + _('Fehler beim Fllen einer Temptabelle:')
                     + e.Message);
                  Break;
               end;
            end;
         end;
      end;
   end;
   if Gsorderby = '' then
   begin
      Gsorderby := ' order by tstamp desc ';
   end;
   QueryArc('Select Sql_No_cache * from tmp_' + sGTmpName + Gsorderby +
      ' ' + sGMaxHits);

   bMultiArcQuery := True;
   //  OutPutdebugstring(PChar('searched'));
   if bMultiArcQuery then
      dm_MainForm2.mnu_TGoToArc.Visible := True;
end;

procedure Tfrm_MainForm.tbi_filterwvlClick(Sender: TObject);
begin
   GgfLogEvnt('tbi_filterwvlClick');
   if tbi_filterwvl.ImageIndex = 139 then
   begin
      dbgrd_Wvl.OptionsEx := dbgrd_Wvl.OptionsEx + [dgeFilterBar];
      dbgrd_Wvl.Filtered := true;
      tbi_filterwvl.ImageIndex := 140;
   end
   else
   begin
      dbgrd_Wvl.OptionsEx := dbgrd_Wvl.OptionsEx - [dgeFilterBar];
      dbgrd_Wvl.Filtered := false;
      tbi_filterwvl.ImageIndex := 139;
   end;
end;

function Tfrm_MainForm.activateimg_docview: boolean;
begin
   result := false;
   if fra_voransicht.fbmouseinim then
   begin
      fra_voransicht.img_DocView.SetFocus;
      result := true;
   end;
end;

function Tfrm_MainForm.activatethumbs: boolean;
begin
   if fbmouseinthumb then
   begin
      if  GetForegroundWindow = frm_MainForm.Handle then
			tmb_Voransicht.setfocus;
   end;
end;

procedure Tfrm_MainForm.dbgrd_WvlKeyDown(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
   if
   (dm_db.my_q_time.recno <> iGTimRec) or
      (dm_db.my_q_time.fieldbyname('tim_id').asinteger <> iGTimID) then
   begin
      dm_db.my_q_time.recno := iGTimRec;
      if (dm_db.my_q_time.fieldbyname('tim_id').asinteger <> iGTimID) then
      begin
         dm_db.my_q_time.first;
         while not dm_db.my_q_time.eof do
         begin
            if dm_db.my_q_time.fieldbyname('tim_id').asinteger = iGTimID then
            begin
               break;
            end;
            dm_db.my_q_time.next;
         end;
      end;
   end;
   dbgrd_wvl.SelectedRows.CurrentRowSelected := true;

end;


procedure Tfrm_MainForm.btn_WvlWeiterleitenClick(Sender: TObject);
begin
	if fbtimcheck then
      exit;
   if gbArcHandling then
   	exit;

   GgfLogEvnt('btn_wvlwltClick');
   if dm_DB.my_q_Time.RecordCount=0 then
   begin
      BfMessageDlg( _('Es ist kein Dokument ausgewhlt.'), mtError, [mbOK], 0);
      Exit;
   end;

   Application.CreateForm(Tfrm_wvlwlt, frm_wvlwlt);
   if frm_wvlwlt.showmodal = mrOk then
   begin
   end;

   if Assigned(frm_wvlwlt) then
      frm_wvlwlt.Release;
end;

procedure Tfrm_MainForm.tbxse_pageAcceptText(Sender: TObject;
   var NewText: String; var Accept: Boolean);
var iPAge: integer;
begin
   GgfLogEvnt('tbxse_pageAcceptText');
   if gbdontsetpage then
   begin
      exit;
   end;
   try
      iPage := strtoint(NewText) - 1;
   except on e: Exception do
      begin
         exit;
      end;
   end;
   with fra_Voransicht.img_DocView do
   begin
      if iPage < 0 then
      begin
         iPage := IO.Params.Tiff_ImageCount - 1;
      end;
      if iPage > (IO.Params.Tiff_ImageCount - 1) then
      begin
         iPage := 0;
      end;
      tmb_VoransichtImageSelect(sender, iPage);

      lbl_VSeite.Caption := _('von') + ' ' + IntToStr(IO.Params.Tiff_ImageCount) + ' ';
   end;
   gbchangevaluespinpage := false;
end;


function Tfrm_MainForm.Shiftgedr: Boolean;
var
   State: TKeyboardState;
begin
   GetKeyboardState(State);
   Result := ((State[VK_SHIFT] and 128) <> 0);
end;

function Tfrm_MainForm.Strggedr: Boolean;
var
   State: TKeyboardState;
begin
   GetKeyboardState(State);
   Result := ((State[VK_CONTROL] and 128) <> 0);
end;

procedure Tfrm_MainForm.Markieren(Sender: TObject);
var
   Richtung: string;
   TempBM: TBookmark;
begin
   with (Sender as TCRDBGrid).DataSource.Dataset do
   begin
      if (BOF and EOF) then
         Exit;
      DisableControls;
      try
         try
            GotoBookmark(BM1);
            case (Sender as TCRDBGrid).DataSource.DataSet.CompareBookmarks(BM1, BM2) of
               -1:
                  Richtung := 'Unten';
               1:
                  Richtung := 'Oben';
               0:
                  Richtung := 'Gleich';
            end;
            TempBM := (Sender as TCRDBGrid).DataSource.DataSet.GetBookmark;
            while (Sender as TCRDBGrid).DataSource.DataSet.CompareBookmarks(BM2, TempBM) <> 0 do
            begin
               (Sender as TCRDBGrid).SelectedRows.CurrentRowSelected := True;
               if Richtung = 'Unten' then
                  Next
               else
                  Prior;
               TempBM := (Sender as TCRDBGrid).DataSource.DataSet.GetBookmark;
            end;
            (Sender as TCRDBGrid).SelectedRows.CurrentRowSelected := True;
         finally
            FreeBookmark(TempBM);
         end;
      finally
         GotoBookmark(BM1);
         EnableControls;
      end;
   end;
end;

procedure Tfrm_MainForm.Markieren2(Sender: TObject);
var
   Richtung: string;
   TempBM: TBookmark;
   i : Integer;
begin
   with (Sender as TCRDBGrid).DataSource.Dataset do
   begin
      if (BOF and EOF) then
         Exit;
      DisableControls;
      try
         OutputDebugString( PChar('GSelection markieren2: ' +inttostr (Length(GSelection))));
         (Sender as TCRDBGrid).SelectedRows.Clear;
         for i := 0 to Length(GSelection) -1 do
         begin
           (Sender as TCRDBGrid).DataSource.DataSet.Locate('doc_id',GSelection[i],[]);
           (Sender as TCRDBGrid).SelectedRows.CurrentRowSelected := True;
         end;
         if BM1 <> nil then
         begin
           dbgrd_Trefferliste.DataSource.DataSet.GotoBookmark(BM1);
           (Sender as TCRDBGrid).SelectedRows.CurrentRowSelected := True;

         end;
      finally
         EnableControls;
      end;
   end;
end;


procedure Tfrm_MainForm.tbx_delcolltedClick(Sender: TObject);
begin
   frm_Mailform.mm_attachmenttiffs.clear;
   frm_Mailform.AttachmentMemo.clear;
end;

procedure Tfrm_mainform.convertdelv2wlt;
var lbfound: boolean;
   lini, lini1: tinifile;
   licounter, licounter1, litimeroptionen: integer;
   lseb, lsmemo, lstaskfavnr: string;
   lstrl: Tstringlist;
begin
   GgfLogEvnt('convertdelv2wlt');
   try
      try
         lini1 := tinifile.Create(BD.AppdataBitfarmPd + 'wvlwlt.ini');
         lini := tinifile.Create(BD.AppdataBitfarmPd + 'wvldelfav.ini');

         lini1.WriteString('Version', 'Version', '3.0');
         frm_MainForm.TmpSQL('Select * from sys_usr');
         with lini do
         begin
            for  licounter := 0 to 9 do
            begin
               lstaskfavnr := 'Task' + IntToStr(licounter);
               //  liindex:= Readinteger('Task'+inttostr(licounter), 'Workerid',-1);
               lstrl := StrToWordswvl2(ReadString('Task' + IntToStr(licounter), 'Workerid', ''));
               lseb := '';
               lsmemo := '';
               for licounter1 := 0 to lstrl.Count - 1 do
               begin
                  // Nach Erledigung zurck 2
                  // Erinnerungsmail senden 4
                  // nicht Einzelmodusinbearbeitung 8
                  lbfound := false;
                  dm_DB.my_q_Tmp.first;
                  while not dm_DB.my_q_Tmp.Eof do
                  begin
                     if lstrl.strings[licounter1] = dm_DB.my_q_Tmp.fieldbyname('usr_id').asstring then
                     begin
                        lbfound := true;
                        break;
                     end;
                     dm_DB.my_q_Tmp.next;
                  end;
                  if lbfound then
                  begin
                     if lseb = '' then
                     begin
                        lseb := dm_DB.my_q_Tmp.fieldbyname('usr_name').asstring;
                     end
                     else
                     begin
                        lseb := lseb + ',' + dm_DB.my_q_Tmp.fieldbyname('usr_name').asstring;
                     end;
                  end;
               end;

               lsmemo := ReadString(lstaskfavnr, 'Info', '');
               if trim(lseb) <> '' then
               begin
                  with lini1 do
                  begin
                     litimeroptionen := 0;
                     WriteInteger(lstaskfavnr, 'Optionen', litimeroptionen);
                     WriteString(lstaskfavnr, 'Workersje', '');
                     WriteString(lstaskfavnr, 'Workersefa', '');
                     WriteString(lstaskfavnr, 'Workerseb', lseb);
                     WriteInteger(lstaskfavnr, 'Abstand', 7);
                     WriteString(lstaskfavnr, 'Info', lsmemo);
                  end;
               end;
            end;
         end;
      except
         on e: Exception do
         begin
         end;
      end;
   finally
      begin
         if Assigned(lini) then
         begin
            FreeAndNil(lini);
            if assigned(lstrl) then
               FreeAndNil(lstrl);
         end;
         if Assigned(lini1) then
         begin
            FreeAndNil(lini1);
         end;
      end;
   end;
end;


procedure Tfrm_MainForm.tbx_stempeldiagClick(Sender: TObject);
begin
   GgfLogEvntBeg('tbx_stempeldiagClick begin');

   fra_Voransicht.createannodata(-1);
   CreateTfrm_Stamps(Self, fra_Voransicht);
end;


procedure Tfrm_MainForm.tbbt_searchClick(Sender: TObject);
begin
  GgfLogEvntBeg ('tbbt_searchClick Begin');
  dm_MainForm2.tbbt_searchDblClick(Sender);
  GgfLogEvntEnd ('tbbt_searchClick End');
end;

procedure Tfrm_MainForm.tbxb_resetClick(Sender: TObject);
begin
   GgfLogEvntBeg ('tbxb_resetClick Begin');

   Trefferlistealreadyloaded := false;
   cbx_Archiv.ItemIndex :=
      cbx_Archiv.Items.IndexOfObject(TObject(igarcid));
   iGArcID := -1;
   cbx_Archiv.OnChange(cbx_Archiv);

   GgfLogEvntEnd ('tbxb_resetClick End');
end;

procedure Tfrm_MainForm.tbi_deldocClick(Sender: TObject);
var
   lsadd, lsarcname: string;
   iCount, liarcma, lidocma: integer;
begin
   GgfLogEvnt('tbi_deldocClick');

   if dm_MainForm2.Frage(_('Sie haben') + ' ' + inttostr(frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count)
      + ' ' + _('am Dokument vorgenommen.') + _('Dokument(e) zum Lschen markiert. Sind Sie sicher,') + #13 +
      _('dass der Vorgang durchgefhrt werden soll? (Achtung: Das Lschen funktioniert nur bei') + #13 +
      _('nicht revisionssicheren Dokumenten. Der Lschvorgang kann nicht rckgngig gemacht werden!)'),
      True) <> mrYes then
   begin
      exit;
   end;

   for iCount := 0 to (frm_MainForm.dbgrd_Trefferliste.SelectedRows.Count - 1) do
   begin
      dm_db.my_q_Arc.GotoBookmark(
         Pointer(frm_mainform.dbgrd_Trefferliste.SelectedRows.Items[iCount]));

      dm_db.my_q_Arc.RefreshRecord;

      if (dm_db.my_q_arc.FieldByName('doc_state').asinteger and 1) = 1 then
      begin
         exit;
      end;
      if Pos(LowerCase(sGArcPath), LowerCase(ExtractFilePath(dm_DB.my_q_Arc.FieldByName(
        'doc_loc').AsString))) = 1 then
      begin
        exit;
      end;

      if bMultiArcQuery then
      begin
         liarcma := dm_db.my_q_Arc.FieldByName('arc_id').AsInteger;
         lsarcname := dm_db.my_q_Arc.FieldByName('TblName').AsString;
      end
      else
      begin
         liarcma := IGArcID;
         lsarcname := sIArcName;
      end;

      lidocma := dm_db.my_q_Arc.FieldByName('doc_id').AsInteger;
      dm_db.my_q_Tmp.SQL.Text :=
         'SELECT * FROM  sys_doclock  ' +
         '  where doc_id =' + IntToStr(lidocma) +
         ' and arc_id = ' + IntToStr(liarcma);
      dm_db.my_q_Tmp.Execute;
      if dm_db.my_q_Tmp.recordcount > 0 then
      begin
         showmessage(_('Dokument wurde von einem anderen Benutzer ausgecheckt.'));
         exit;
      end;

      lsadd := '';
      if gbhasgdocid then
      begin
         lsadd := ', gdoc_id';
      end;
      dm_db.my_cmd.SQL.Text := 'insert into sys_delhistory (' +
         'arc_id, doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id,' +
         ' tstamp, doc_txt, doc_state, ocr_qf' + lsadd + ') '
         + 'Select Sql_No_cache ' + inttostr(liarcma) +
         ', doc_id, disp_name, doc_loc, ext_loc, ori_loc, usr_name, usr_id, tstamp,' +
         ' doc_txt, doc_state, ocr_qf' + lsadd + ' from arc_'
         + lsarcname + ' where doc_id = ' + IntToStr(lidocma);
      dm_db.my_cmd.execute;
      dm_db.my_cmd.SQL.Text := 'delete from hst_' + lsarcname + ' where doc_id = ' + IntToStr(lidocma);
      dm_db.my_cmd.execute;
      dm_db.my_cmd.SQL.Text := 'delete from slw_' + lsarcname + ' where doc_id = ' + IntToStr(lidocma);
      dm_db.my_cmd.execute;

      dm_DB.my_q_Arc.Delete;
      if bMultiArcQuery then
      begin
         dm_db.my_cmd.SQL.Text := 'delete from arc_' + lsarcname + ' where doc_id=  ' +
            IntToStr(lidocma);
         try
            dm_db.my_cmd.Execute;
         except
            on e: Exception do
            begin
               ErrorMsg('tbi_deldocClick',
                  _('Fehler beim Lschen des Dokumentes:') +
                  e.Message,
                  2023, True);
            end;
         end;
      end
      else
      begin

      end;
   end;
   dbgrd_trefferliste.SelectedRows.Clear;
   dm_db.my_q_arc.refresh;
   dbgrd_trefferliste.SelectedRows.CurrentRowSelected := True;

   if dm_db.my_q_arc.recordcount > 0 then
   begin
      iGArcRecNo := -1;
      handledoc; GgfLogEvnt('HandleDoc b');
   end
   else
   begin
      btn_ResFieldsClick(self);
   end;
end;

procedure Tfrm_MainForm.dpnl_WvlgResize(Sender: TObject);
begin
   if dpnl_Wvlg.Docked then
   begin
      dpnl_Wvlg.MaxClientHeight := pnl_Voransicht.Height - 100;
   end
   else
   begin
      dpnl_Wvlg.MaxClientHeight := 0;
   end;
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteAfterColResize(Sender: TObject);
begin
   OutputDebugString('dbgrd_TrefferlisteAfterColResize');
   ColumnMoved;
end;

procedure Tfrm_MainForm.dbgrd_WVLAfterColResize(Sender: TObject);
begin
   OutputDebugString('dbgrd_WVLAfterColResize');
   WVLColumnMoved;
end;


procedure Tfrm_MainForm.tbix_showallwvlClick(Sender: TObject);
var
   lsStati, between: string;
   icount: integer;
begin
   if tbi_MyTask.Checked then
   begin
      lsStati := ' ( status <> 2)  ';
      between := ' ';
   end;
   // Anzeige der Objekte fr die eigene Wiedervorlage
   if tbi_MATask.Checked then
   begin
      // check for parallele workflows
      lsStati := '( (((Optionen&1)= 0) and (status <> 2)) or ' +
         ' (((Optionen&1) =1) and  (2 <> any(select status from sys_timer as b where  a.tim_ref=b.tim_ref))))';
      between := '';
   end;
   // not supported till  param(1) = 0704161322 -> or (Optionen = 1)) ';
   // damit wird die wvl list angezeigt!
   if TimeSQL(
      'Select  tim_id, tim_Ref, grp_id, erinnerung, termin, sys_arc.arc_id, arc_tblname, arc_name,'
      + ' doc_id, doc_titel, info, status, usr_id_work, usr_id_shed, Optionen,  usr_name as usr_shed_name from sys_timer as a '
      + 'left join sys_arc using(arc_id) left join sys_usr as b on a.usr_id_shed = b.usr_id '
      + ' where usr_id_work = ' + IntToStr(iGUsrID) + ' and  ' + lsStati +
      //      ' and status <> 2  or' +
      //      ' optionen = 1  and' +
      between + ' order by termin, tim_id') then
   begin
      dm_DB.my_q_Time.First;
      // set the iG*IDS properly!
      FillControls(False);
   end;

   dpnl_Wvlg.Caption := _('Dokumente auf eigener Wiedervorlage/Aufgaben');
   // load the wvl
   setlength(iGtim_id, 0);
   setlength(iGtim_id, dm_DB.my_q_Time.RecordCount);
   dm_DB.my_q_Time.First;
   for icount := 0 to dm_DB.my_q_Time.RecordCount - 1 do
   begin
      iGtim_id[icount] := dm_DB.my_q_Time.FieldByName('tim_id').AsInteger;
      dm_DB.my_q_Time.Next;
   end;
   iGTaskCount := dm_DB.my_q_Time.RecordCount;
   GgfLogEvnt('Vor tbi_ShowDocClick in Tfrm_MainForm.tbix_showallwvlClick');
   tbi_ShowDocClick(self);
   RefreshStatus;
end;


//-----------------------------------------------------------------------------
//3.5.0.53 [2304]
procedure Tfrm_MainForm.tbi_GemerktesDokumentClick(Sender: TObject);
var liNr:integer;  State: TDocViewSave;  ls: string;
begin
   GgfLogEvntBeg('tbi_GemerktesDokumentClick beg giGoToPage:'+IntToStr(giGoToPage));
   liNr := TComponent(Sender).Tag - 20000;
   // Zustand holen
   State := gDocViewSaves[liNr];
   if State.Doc.ArcId = 0 then
      Exit;
   ls := 'docid:'+IntToStr(State.Doc.ArcId)+'.'+IntToStr(State.Doc.docId);

   giGoToPage := State.Page;
   GgfLogEvnt('tbi_GemerktesDokumentClick giGoToPage:'+IntToStr(giGoToPage));
   HandleParam(ls);
   //tmb_VoransichtImageSelect(sender, State.Page );
   GgfLogEvntEnd('tbi_GemerktesDokumentClick beg giGoToPage:'+IntToStr(giGoToPage));
end;

//-----------------------------------------------------------------------------
//3.5.0.53 [2304]
procedure Tfrm_MainForm.tbi_DokumentMerkenClick(Sender: TObject);
var liNr:integer;  State: TDocViewSave;
begin
   liNr := TComponent(Sender).Tag;
   State.Doc.ArcId := iGArcID;
   State.Doc.DocId := iGDocID;
   State.Page := fra_Voransicht.img_DocView.IO.Params.Tiff_ImageIndex;

   // Speichern
   gDocViewSaves[liNr] := State;
end;

//-----------------------------------------------------------------------------
//3.5.0.53 [2304]
procedure Tfrm_MainForm.tbxs_lesezeichenPopup(Sender: TTBCustomItem;
  FromLink: Boolean);
var State: TDocViewSave;  lbEnabled:Boolean; i, k, liCount: integer;
  Item:TTBCustomItem;
begin
   for i := Low(gDocViewSaves) to High(gDocViewSaves) do
   begin
      State := gDocViewSaves[i];
      lbEnabled := State.Doc.ArcId > 0;
      
      liCount := tbxs_lesezeichen.Count;
      for k := 0 to liCount-1 do
      begin
         Item := tbxs_lesezeichen.Items[k];
         if Item.Tag = 20000+i then
            Item.Enabled := lbEnabled;  
      end;
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_MainForm.SeiteSetzen;
begin
   GgfLogEvntBeg('SeiteSetzen beg giGoToPage:'+IntToStr(giGoToPage));
   try
      if giGoToPage < 0 then
         Exit;
      try
         //### tmb_VoransichtImageSelect(nil, giGoToPage);
      finally
         giGoToPage := -1;
      end;
   finally
      GgfLogEvntEnd('SeiteSetzen end');
   end;
end;

//-----------------------------------------------------------------------------
procedure Tfrm_MainForm.tmb_VoransichtDrawProgress(Sender: TObject; per,
  idx: Integer);
var per2: integer;
begin
   if per <100 then
      Exit;
   GgfLogEvntBeg('tmb_VoransichtDrawProgress beg');
   try
      if giGoToPage < 0 then
         Exit;

      try
         tmb_VoransichtImageSelect(nil, giGoToPage);
      finally
         giGoToPage := -1;
      end;
   finally
      GgfLogEvntEnd('tmb_VoransichtDrawProgress end');
   end;
end;


function Tfrm_MainForm.GetVolltext:string;
begin
   Result := memo_vtx.Text; //[2487]

end;
//-----------------------------------------------------------------------------
procedure LoadFavStampbuttons(tbx_fav1, tbx_fav2, tbx_fav3, tbx_fav4, tbx_fav5: TTBXItem);
var
   reg: TRegistry;  lsStampName: string;
   slStampKeys: TStringList;
   iCount, lifav: integer;
begin
   reg := TRegistry.Create;
   try
      with reg do
      begin
         slStampKeys := TStringList.Create;
         try
            RootKey := HKEY_CURRENT_USER;
            OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps', True);
            GetKeyNames(slStampKeys);
            CloseKey;
            setlength(gasfavstemp, slStampKeys.Count);
            //Items im Hauptformular
            tbx_fav1.Enabled := False;
            tbx_fav1.visible := False;
            tbx_fav1.Tag := 0;
            tbx_fav2.Enabled := False;
            tbx_fav2.visible := False;
            tbx_fav2.Tag := 0;
            tbx_fav3.Enabled := False;
            tbx_fav3.visible := False;
            tbx_fav3.Tag := 0;
            tbx_fav4.Enabled := False;
            tbx_fav4.visible := False;
            tbx_fav4.Tag := 0;
            tbx_fav5.Enabled := False;
            tbx_fav5.visible := False;
            tbx_fav5.Tag := 0;

            for iCount := 0 to (slStampKeys.Count - 1) do
            begin
               OpenKey('Software\bitfarm\Archiv_V3\Viewer\Stamps\' +
                  slStampKeys.Strings[iCount], True);

               if ValueExists('favnr') then
               begin
                  lifav := readinteger('favnr');
                  lsStampName := readstring('StampName');
                  case lifav of
                     1:
                     begin
                        tbx_fav1.Enabled := True;
                        tbx_fav1.visible := True;
                        tbx_fav1.hint := lsStampName;
                        tbx_fav1.Tag := icount;
                     end;
                     2:
                     begin
                        tbx_fav2.Enabled := True;
                        tbx_fav2.visible := True;
                        tbx_fav2.hint := lsStampName;
                        tbx_fav2.Tag := icount;
                     end;
                     3:
                     begin
                        tbx_fav3.Enabled := True;
                        tbx_fav3.visible := True;
                        tbx_fav3.hint := lsStampName;
                        tbx_fav3.Tag := icount;
                     end;
                     4:
                     begin
                        tbx_fav4.Enabled := True;
                        tbx_fav4.visible := True;
                        tbx_fav4.hint := lsStampName;
                        tbx_fav4.Tag := icount;
                     end;
                     5:
                     begin
                        tbx_fav5.Enabled := True;
                        tbx_fav5.visible := True;
                        tbx_fav5.hint := lsStampName;
                        tbx_fav5.Tag := icount;
                     end;
                  end;
                  gasfavstemp[icount] := slStampKeys.Strings[iCount];
               end;
               CloseKey;
            end;
         finally
            slStampKeys.Free;
         end;
      end;
   except
      on e: Exception do
      begin
         ErrorMsg('LoadFavStampbuttons', _('Fehler beim Lesen des Registrierung:') +
            e.Message, 2200, True);
      end;
   end;
end;

procedure Tfrm_MainForm.Ed_advuser_edtKeyPress (Sender: TObject; var Key : Char);
begin
 if Key = ';' then
   Key := chr (0);
end;

procedure Tfrm_MainForm.pum_favtreePopup(Sender: TObject);
var
	Pvnsrc: TTreenode;
   bNotAllowed : Boolean;
begin
	OutputDebugString('pum_favtreePopup');
   bNotAllowed := False;
   Pvnsrc := tv_lese.Selected;
   if Pvnsrc.ImageIndex = 0 then
     frm_MainForm.pum_favtree.Items[1].Caption := _('Ordner lschen')
   else
     frm_MainForm.pum_favtree.Items[1].Caption := _('Lesezeichen lschen');
     
   if Pvnsrc.Parent = nil then
   begin
      bNotAllowed := bNotAllowed or (LowerCase(Pvnsrc.Text) = LowerCase(_('Verlauf-Lesezeichen')));
   end
   else
   begin
      bNotAllowed := bNotAllowed or (LowerCase(Pvnsrc.Parent.Text) = LowerCase(_('Verlauf-Lesezeichen')));
   end;

   if bNotAllowed then
   begin
      tv_lese.ClearSelection(True);
      tv_lese.Select(Pvnsrc);
      Abort;
   end;
end;


procedure Tfrm_MainForm.tbxtm_delbfahitClick(Sender: TObject);
begin
	if wvlhasfocus then
   begin
      if tbi_MyTask.Checked then
      begin
         if FileExists(BD.AppdataBitfarmPd + 'bfa_hit\WVL.bfa') then
         begin
            dbgrd_WVL.columns.Clear;
            KillFile(BD.AppdataBitfarmPd + 'bfa_hit\WVL.bfa');
            SwitchControls(1);
         end;
      end;
      if tbi_MATask.Checked then
      begin
         if FileExists(BD.AppdataBitfarmPd + 'bfa_hit\WVLCtrl.bfa') then
         begin
            dbgrd_WVL.columns.Clear;
            KillFile(BD.AppdataBitfarmPd + 'bfa_hit\WVLCtrl.bfa');
            SwitchControls(2);
         end;
      end;
   end
   else
   begin
      if FileExists(BD.AppdataBitfarmPd + 'bfa_hit\' + GSysArc[iGArcid].TblName + '.bfa') then
      begin
         dbgrd_TrefferListe.columns.Clear;
         KillFile(BD.AppdataBitfarmPd + 'bfa_hit\' + GSysArc[iGArcid].TblName + '.bfa');
         CreateStandardColumnsTrefferliste;
         btn_ResFieldsClick(Self);
      end;
   end;
end;

procedure Tfrm_MainForm.tbxtm_AnnoDeleteClick(Sender: TObject);
begin
	fra_Voransicht.AnnoDelete(Self);
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteCellClick(Column: TColumn);
var
   arcid : Integer;
begin
   //OutputDebugString('dbgrd_TrefferlisteCellClick');
   dbgrd_Trefferliste.LeftCol := giLeftCol;
   //giLeftCol := 1;
      if ((bMultiArcQuery) or (dm_db.my_q_Arc.FieldDefList.Find('arc_id') <> nil)) then
   begin
      arcid := dm_db.my_q_Arc.FieldByName('arc_id').AsInteger;
   end
   else
   	arcid := iGArcID;

   if (iGDocID <> dm_DB.my_q_Arc.fieldbyName('doc_id').AsInteger) or
   	(arcid <> iGArcID) then
   begin
      HandleDoc;
   end;
end;

procedure Tfrm_MainForm.dbgrd_TrefferlisteColExit(Sender: TObject);
begin
   OutputDebugString('dbgrd_TrefferlisteColExit');
   giLeftCol := dbgrd_Trefferliste.LeftCol;

end;

initialization
   //InitializeCriticalSection(csLog); //09-09-07 m.frey

finalization
   //DeleteCriticalSection(csLog); //09-09-07 m.frey

end.











